%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Jennifer Jackson 2017                                                        %
% A Biodiversity Approach to Cyber Security                                    %
% PhD Complexity Science                                                       %
% University of Warwick                                                        %
% http://wrap.warwick.ac.uk/98458                                              %
% This software is distributed under the  Creative Commons Attribution License %
% https://creativecommons.org/licenses/by/4.0/                                 %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function  AlgModelFavScoreTloop(t,lengthCounter,handles,ihandles,rhandles,ohandles,psim)
       %run function if enabled
     if strcmp(ihandles.algModelS,'Favourability Score')
     %*********************************************************************
     %change weights and desirabilities 
     %*********************************************************************
     DynAlgClass.ChangeWeightsAndDesirabilities(t,ihandles,rhandles); %OLD METHOD, will still work
     DynAlgClass.ChangeWeightsAndDesirabilitiesNEW(t,ihandles,rhandles); %NEW METHOD
    % %*********************************************************************
    % %Node encounter
    % %*********************************************************************
    % %choose a uniform random number to decide whether to meet another node
    % randomNumber = rand(ihandles.numNodes,1);
    % %encounter a node if less than probability number
    % %(randomNumber < ihandles.probabilityDistr) equals 1 if true
    % rhandles.encounterYes = (randomNumber < ihandles.probabilityDistr);
    % %generate a random node to encounter , but must not encounter itself
    % rhandles.randomEncounter = randi([1 ihandles.numNodes],ihandles.numNodes,1);
    % for i = 1:ihandles.numNodes
    %     while rhandles.randomEncounter(i) == i
    %         rhandles.randomEncounter(i) = randi(ihandles.numNodes,1);
    %     end;
    % end;
     %*********************************************************************
     % Run attack Model if enabled
     %*********************************************************************
   %  StateMachineClass.attackModelRunTloop(t,ihandles,rhandles)
     %*********************************************************************
     % Tally software encountered
     %*********************************************************************
     %only tally those that have had an encounter
     encounterYesRep = repmat(rhandles.encounterYes,1,ihandles.tallyLength);
     if ihandles.turnOnSol1 == 1; rhandles.tallySol1 = (rhandles.GenotypeSol1(rhandles.randomEncounter,:)).*encounterYesRep + rhandles.tallySol1; end
     if ihandles.turnOnSol2 == 1; rhandles.tallySol2 = (rhandles.GenotypeSol2(rhandles.randomEncounter,:)).*encounterYesRep + rhandles.tallySol2; end
     if ihandles.turnOnSol3 == 1; rhandles.tallySol3 = (rhandles.GenotypeSol3(rhandles.randomEncounter,:)).*encounterYesRep + rhandles.tallySol3; end
     rhandles.tallySol4 = (rhandles.GenotypeSol4(rhandles.randomEncounter,:)).*encounterYesRep + rhandles.tallySol4;
     rhandles.tallySol5 = (rhandles.GenotypeSol5(rhandles.randomEncounter,:)).*encounterYesRep + rhandles.tallySol5;
     %**********************************************************************
     % Check when to update the genotype
     %***********************************************************************
     %increment counters - only increment if encountered another node
     rhandles.counterEncounters = rhandles.counterEncounters + (1.*rhandles.encounterYes);
     %check counters for update (if true will set to 1)
     updateYes = (rhandles.counterEncounters == rhandles.numEncounters);
     rhandles.updateGenotypeYes = updateYes;
     %**********************************************************************
     % Stop-start the update process (sol 4 and 5 only)
     %**********************************************************************
     DynAlgClass.StopUpdateProcess(t,lengthCounter,updateYes,ihandles,rhandles) %updated 21st April 2016
     %*********************************************************************
     % keep a running total of the number of updates performed
     %**********************************************************************
     rhandles.tallyUpdates = rhandles.tallyUpdates + updateYes;
     %**********************************************************************
     % Update Genotypes for all solutions
     %**********************************************************************
     DynAlgClass.updateGenotypesAllSols(t,updateYes,ihandles,rhandles)% t used for starting blacklisting time
     %*********************************************************************
     % Reset counters and tallys
     %*********************************************************************
     %reset counters if needed, if reset resetCounters will be set to zero
     resetCounters = 1 - updateYes;
     rhandles.counterEncounters = rhandles.counterEncounters .* resetCounters;
     %reset the tallySol if needed
     resetCountersRep = repmat(resetCounters,1,ihandles.tallyLength);
     rhandles.tallySol1 = rhandles.tallySol1 .*resetCountersRep;
     rhandles.tallySol2 = rhandles.tallySol2 .*resetCountersRep;
     rhandles.tallySol3 = rhandles.tallySol3 .*resetCountersRep;
     rhandles.tallySol4 = rhandles.tallySol4 .*resetCountersRep;
     rhandles.tallySol5 = rhandles.tallySol5 .*resetCountersRep;
     %******************************************************************
     % reasign new output for all solutions
     %********************************************************************
     %DynAlgClass.reasignNewOutputs(t,psim,ihandles,rhandles,ohandles)
     DynAlgClass.reasignNewOutputs(lengthCounter,psim,ihandles,rhandles,ohandles)%updated 21st April 2016
     end %strcmp
end

