%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Jennifer Jackson 2017                                                        %
% A Biodiversity Approach to Cyber Security                                    %
% PhD Complexity Science                                                       %
% University of Warwick                                                        %
% http://wrap.warwick.ac.uk/98458                                              %
% This software is distributed under the  Creative Commons Attribution License %
% https://creativecommons.org/licenses/by/4.0/                                 %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function varargout = DynAlgGUI(varargin)
% DYNALGGUI MATLAB code for DynAlgGUI.fig
%      DYNALGGUI, by itself, creates a new DYNALGGUI or raises the existing
%      singleton*.
%
%      H = DYNALGGUI returns the handle to a new DYNALGGUI or the handle to
%      the existing singleton*.
%
%      DYNALGGUI('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in DYNALGGUI.M with the given input arguments.
%
%      DYNALGGUI('Property','Value',...) creates a new DYNALGGUI or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before DynAlgGUI_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to DynAlgGUI_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help DynAlgGUI

% Last Modified by GUIDE v2.5 22-Apr-2015 15:32:48

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @DynAlgGUI_OpeningFcn, ...
                   'gui_OutputFcn',  @DynAlgGUI_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before DynAlgGUI is made visible.
function DynAlgGUI_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to DynAlgGUI (see VARARGIN)

% Choose default command line output for DynAlgGUI
handles.output = hObject;
%set initialisation values
GUIClass.defaultHandles(handles);
% Update handles structure
guidata(hObject, handles);
% UIWAIT makes DynAlgGUI wait for user response (see UIRESUME)
% uiwait(handles.figureDynAlgGUI);


% --- Outputs from this function are returned to the command line.
function varargout = DynAlgGUI_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --------------------------------------------------------------------
function File_Callback(~, eventdata, handles)
% hObject    handle to File (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function LoadSettings_Callback(hObject, eventdata, handles)
% hObject    handle to LoadSettings (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
loadSettingsFig = loadSettings(handles);%open figure, pass main gui handles
handles.loadSettingsFig = loadSettingsFig; %save handle ref
set(handles.loadSettingsFig,'Visible','on');%make visible
%Update handles structure
guidata(hObject, handles);

% --------------------------------------------------------------------
function SaveSettings_Callback(hObject, eventdata, handles)
% hObject    handle to SaveSettings (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
%saveSettingsFig = saveSettings('saveSettings', hObject);%open figure
saveSettingsFig = saveSettings(handles);%open figure
handles.saveSettingsFig = saveSettingsFig; %save handle ref
set(handles.saveSettingsFig,'Visible','on');%make visible
%Update handles structure
guidata(hObject, handles);

% --------------------------------------------------------------------
function LoadTestData_Callback(hObject, eventdata, handles)
% hObject    handle to LoadTestData (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function CreateNewTestData_Callback(hObject, eventdata, handles)
% hObject    handle to CreateNewTestData (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function OpenOutputSimulationData_Callback(hObject, eventdata, handles)
% hObject    handle to OpenOutputSimulationData (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)



function editNumRuns_Callback(hObject, eventdata, handles)
% hObject    handle to editNumRuns (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of editNumRuns as text
%        str2double(get(hObject,'String')) returns contents of editNumRuns as a double

editNumRunsV = str2double(get(hObject,'String'))
editNumRunsS = get(hObject,'String');
%save to structure
set(handles.editNumRuns,'Value',editNumRunsV);
set(handles.editNumRuns,'String',editNumRunsS);
% save the changes to the structure
guidata(gcbo,handles);

% --- Executes during object creation, after setting all properties.
function editNumRuns_CreateFcn(hObject, eventdata, handles)
% hObject    handle to editNumRuns (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function editNumTimeSteps_Callback(hObject, eventdata, handles)
% hObject    handle to editNumTimeSteps (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of editNumTimeSteps as text
%        str2double(get(hObject,'String')) returns contents of editNumTimeSteps as a double
editNumTimeStepsV = str2double(get(hObject,'String'))
editNumTimeStepsS = get(hObject,'String');
%save to structure
set(handles.editNumTimeSteps,'Value',editNumTimeStepsV);
set(handles.editNumTimeSteps,'String',editNumTimeStepsS);
% save the changes to the structure
guidata(gcbo,handles);

% --- Executes during object creation, after setting all properties.
function editNumTimeSteps_CreateFcn(hObject, eventdata, handles)
% hObject    handle to editNumTimeSteps (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in checkboxSaveGraphs.
function checkboxSaveGraphs_Callback(hObject, eventdata, handles)
% hObject    handle to checkboxSaveGraphs (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkboxSaveGraphs
checkboxSaveGraphsV = get(hObject,'Value')
checkboxSaveGraphsS = get(hObject,'String');
%save to structure
set(handles.checkboxSaveGraphs,'Value',checkboxSaveGraphsV);
set(handles.checkboxSaveGraphs,'String',checkboxSaveGraphsS);
% save the changes to the structure
guidata(gcbo,handles);

% --- Executes on button press in checkboxSaveOutput.
function checkboxSaveOutput_Callback(hObject, eventdata, handles)
% hObject    handle to checkboxSaveOutput (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkboxSaveOutput
checkboxSaveOutputV = get(hObject,'Value')
checkboxSaveOutputS = get(hObject,'String');
%save to structure
set(handles.checkboxSaveOutput,'Value',checkboxSaveOutputV);
set(handles.checkboxSaveOutput,'String',checkboxSaveOutputS);
% save the changes to the structure
guidata(gcbo,handles);

% --- Executes on selection change in listbox1.
function listbox1_Callback(hObject, eventdata, handles)
% hObject    handle to listbox1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns listbox1 contents as cell array
%        contents{get(hObject,'Value')} returns selected item from listbox1


% --- Executes during object creation, after setting all properties.
function listbox1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to listbox1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in popupmenuNumSims.
function popupmenuNumSims_Callback(hObject, eventdata, handles)
% hObject    handle to popupmenuNumSims (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns popupmenuNumSims contents as cell array
%        contents{get(hObject,'Value')} returns selected item from
%        popupmenuNumSims

%new stuff
%*************************
%get names of temp files
directorynameSettings = GUIClass.getDirectoryNameSettings();
settingsTempFileNames = GUIClass.genSettingsTempFileNames(directorynameSettings,GUIClass.getMaxNumSims());
%find currently selected simulation and make sure settings saved first in temp file
settingsSimNumber = get(handles.popupmenuSettings, 'Value');
GUIClass.saveSettingsTempFile(settingsTempFileNames,settingsSimNumber,handles)
%Get the number of simulations selected
numSims = get(hObject,'Value');
%set list of available simulations
popupmenuList = GUIClass.genSimList(numSims);
set(handles.popupmenuSettings, 'String', popupmenuList);
set(handles.popupmenuGraphicalOutput, 'String', popupmenuList);
%set back to simulation 1 otherwise might select something not available
set(handles.popupmenuSettings, 'Value', 1);
set(handles.popupmenuGraphicalOutput, 'Value', 1);
%load settings temp file for sim 1
GUIClass.loadSettingsTempFile(settingsTempFileNames,1,handles)

%Update handles structure
guidata(hObject, handles);
%**************************


% --- Executes during object creation, after setting all properties.
function popupmenuNumSims_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenuNumSims (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in pushbuttonRunSimulations.
function pushbuttonRunSimulations_Callback(hObject, eventdata, handles)
% hObject    handle to pushbuttonRunSimulations (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
%************************************
%set the start time of the simulation
startTime = fix(clock);
startTimeStr = [num2str(startTime(4)) ':' num2str(startTime(5)) ':' num2str(startTime(6))];
set(handles.editSimStartTime, 'String' ,startTimeStr);
endTimeStr = ['00' ':' '00' ':' '00'];
set(handles.editSimEndTime, 'String' ,endTimeStr);
numFiles = get(handles.popupmenuNumSims, 'Value')
numSims = num2str(numFiles)
progressStr = ['0%  0 of ' numSims]
set(handles.editSimProgress, 'String' ,progressStr);
%Update handles structure
guidata(hObject, handles);
pause(0.001)%time to update screen
%**************************************
%check file extensions to use for output data
binmode=get(handles.checkboxbinmode,'Value'); %this is set for each setting but should be applied to all sims really
fileExtension = GUIClass.getFileExtension(binmode);
%*****************************
%names of settings temp files
directorynameSettings = GUIClass.getDirectoryNameSettings();
settingsTempFileNames = GUIClass.genSettingsTempFileNames(directorynameSettings,numFiles);
%names of outputs temp files
directorynameOut = GUIClass.getDirectoryNameOut();
outputsTempFileNames = GUIClass.genOutputsTempFileNames(directorynameOut,numFiles,fileExtension);
%names of automated outputs
folderName=[num2str(startTime(1)) '-' num2str(startTime(2)) '-' num2str(startTime(3)) '-' num2str(startTime(4)) '-' num2str(startTime(5)) '-' num2str(startTime(6)) '\'];
directoryName = [directorynameOut folderName];
outputsSimFileNames = GUIClass.genOutputsSimFileNames(directoryName,numFiles,fileExtension);
settingsSimFileNames = GUIClass.genSettingsSimFileNames(directoryName,numFiles);
%*************************
%find currently selected simulation and make sure settings saved first in temp file
settingsSimNumber = get(handles.popupmenuSettings, 'Value')
GUIClass.saveSettingsTempFile(settingsTempFileNames,settingsSimNumber,handles)
%****************************
%RUN THE SIMULATIONS
        for simNumber = 1 : numFiles
        currentSimNumber = simNumber-1;
        %****************************
        %load temp settings for sim
        GUIClass.loadSettingsTempFile(settingsTempFileNames,simNumber,handles)
        %select sim settings on display
        set(handles.popupmenuSettings,'Value', simNumber);
        set(handles.editOldSimSetting,'String', num2str(simNumber));
        %**************************************************
        % save the changes to the structure
        guidata(gcbo,handles); 
        %******************************
        %run A SINGLE simulation
        outputs = DynAlgStochastic(handles,currentSimNumber)
        %**********************
        %save temp output data from simulation
        GUIClass.saveOutputsTempFile(outputsTempFileNames,simNumber,outputs,binmode);
        %check for autosave outputs  - save data and settings in seperate files
        GUIClass.autoSaveOutputs(directorynameOut,folderName,simNumber,outputsTempFileNames,settingsTempFileNames,outputsSimFileNames,settingsSimFileNames,directoryName,outputs,handles);
        %***********************
        end        
        %display the graph of the last output generated
        displayGUIGraph(outputs,handles)
        set(handles.popupmenuGraphicalOutput,'Value', simNumber);
%*************************
%******************************************
%record the end time of the simulation
endTime = fix(clock);
endTimeStr = [num2str(endTime(4)) ':' num2str(endTime(5)) ':' num2str(endTime(6))];
set(handles.editSimEndTime, 'String' ,endTimeStr);
numSims = num2str(get(handles.popupmenuNumSims, 'Value'))
progressStr = ['100%  ' numSims ' of ' numSims]
set(handles.editSimProgress, 'String' ,progressStr);
%Update handles structure
guidata(hObject, handles);


% --- Executes on button press in pushbuttonAlgInfo.
function pushbuttonAlgInfo_Callback(hObject, eventdata, handles)
% hObject    handle to pushbuttonAlgInfo (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
algInfoFig = algInfo('algInfo', hObject);%open figure
handles.algInfoFig = algInfoFig; %save handle ref
set(handles.algInfoFig,'Visible','on');%make visible
%Update handles structure
guidata(hObject, handles);


function editDiversityWeight_Callback(hObject, eventdata, handles)
% hObject    handle to editDiversityWeight (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of editDiversityWeight as text
%        str2double(get(hObject,'String')) returns contents of editDiversityWeight as a double
editDiversityWeightV = str2double(get(hObject,'String'))
editDiversityWeightS = get(hObject,'String');
%save to structure
set(handles.editDiversityWeight,'Value',editDiversityWeightV);
set(handles.editDiversityWeight,'String',editDiversityWeightS);
% save the changes to the structure
guidata(gcbo,handles);

% --- Executes during object creation, after setting all properties.
function editDiversityWeight_CreateFcn(hObject, eventdata, handles)
% hObject    handle to editDiversityWeight (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function editCommWeight_Callback(hObject, eventdata, handles)
% hObject    handle to editCommWeight (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of editCommWeight as text
%        str2double(get(hObject,'String')) returns contents of editCommWeight as a double
editCommWeightV = str2double(get(hObject,'String'))
editCommWeightS = get(hObject,'String');
%save to structure
set(handles.editCommWeight,'Value',editCommWeightV);
set(handles.editCommWeight,'String',editCommWeightS);
% save the changes to the structure
guidata(gcbo,handles);

% --- Executes during object creation, after setting all properties.
function editCommWeight_CreateFcn(hObject, eventdata, handles)
% hObject    handle to editCommWeight (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function editIndWeight_Callback(hObject, eventdata, handles)
% hObject    handle to editIndWeight (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of editIndWeight as text
%        str2double(get(hObject,'String')) returns contents of editIndWeight as a double
editIndWeightV = str2double(get(hObject,'String'))
editIndWeightS = get(hObject,'String');
%save to structure
set(handles.editIndWeight,'Value',editIndWeightV);
set(handles.editIndWeight,'String',editIndWeightS);
% save the changes to the structure
guidata(gcbo,handles);

% --- Executes during object creation, after setting all properties.
function editIndWeight_CreateFcn(hObject, eventdata, handles)
% hObject    handle to editIndWeight (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function editEffWeight_Callback(hObject, eventdata, handles)
% hObject    handle to editEffWeight (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of editEffWeight as text
%        str2double(get(hObject,'String')) returns contents of editEffWeight as a double
editEffWeightV = str2double(get(hObject,'String'))
editEffWeightS = get(hObject,'String');
%save to structure
set(handles.editEffWeight,'Value',editEffWeightV);
set(handles.editEffWeight,'String',editEffWeightS);
% save the changes to the structure
guidata(gcbo,handles);

% --- Executes during object creation, after setting all properties.
function editEffWeight_CreateFcn(hObject, eventdata, handles)
% hObject    handle to editEffWeight (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in popupmenuGraphType.
function popupmenuGraphType_Callback(hObject, eventdata, handles)
% hObject    handle to popupmenuGraphType (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns popupmenuGraphType contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenuGraphType

popupmenuGraphTypeS = cellstr(get(hObject,'String'))
popupmenuGraphTypeV = popupmenuGraphTypeS{get(hObject,'Value')}
switch (popupmenuGraphTypeV)
    case 'Diversity Index'
        popupmenuGraphTypeV2 = 1
        %if output file exists display data on graph
    case 'Diversity Index Log'
        popupmenuGraphTypeV2 = 2
    case 'Individual Diversities'
        popupmenuGraphTypeV2 = 3
    case 'Individual Diversities Log'
        popupmenuGraphTypeV2 = 4
    case 'Node 1 mean Alg 4'
        popupmenuGraphTypeV2 = 5
    case 'Node 1 standard deviation Alg 4'
        popupmenuGraphTypeV2 = 6  
    case 'Node 1 stop/start update Alg 4'
        popupmenuGraphTypeV2 = 7
    case 'Node 1 stop/start update Alg 5'
        popupmenuGraphTypeV2 = 8
    otherwise
        popupmenuGraphTypeV2 = 1
end
%save to structure
set(handles.popupmenuGraphType,'Value',popupmenuGraphTypeV2);
set(handles.popupmenuGraphType,'String',popupmenuGraphTypeS);
% save the changes to the structure
guidata(gcbo,handles);

numFiles = get(handles.popupmenuNumSims, 'Value')
%names of settings temp files
directorynameSettings = GUIClass.getDirectoryNameSettings();
settingsTempFileNames = GUIClass.genSettingsTempFileNames(directorynameSettings,numFiles);
%find currently selected view simulation button to load graph
simNumber=get(handles.popupmenuGraphicalOutput,'Value')
%load settings file to determine binmode value
GUIClass.loadSettingsTempFile(settingsTempFileNames,simNumber,handles);
binmode=get(handles.checkboxbinmode,'Value')
fileExtension = GUIClass.getFileExtension(binmode)
%reset these handles as overwritten by settings file
set(handles.popupmenuGraphicalOutput,'Value',simNumber)
set(handles.popupmenuSettings,'Value',simNumber)
set(handles.popupmenuGraphType,'Value',popupmenuGraphTypeV2);
set(handles.popupmenuGraphType,'String',popupmenuGraphTypeS);

%names of outputs temp files
directorynameOut = GUIClass.getDirectoryNameOut();
outputsTempFileNames = GUIClass.genOutputsTempFileNames(directorynameOut,numFiles,fileExtension);
%make sure correct file is loaded - load temp output file
outputs = GUIClass.loadOutputsTempFile(outputsTempFileNames,simNumber,binmode)

displayGUIGraph(outputs,handles)

% --- Executes during object creation, after setting all properties.
function popupmenuGraphType_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenuGraphType (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in popupmenuEncounterType.
function popupmenuEncounterType_Callback(hObject, eventdata, handles)
% hObject    handle to popupmenuEncounterType (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns popupmenuEncounterType contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenuEncounterType
popupmenuEncounterTypeS = cellstr(get(hObject,'String')) %all string as list
popupmenuEncounterTypeV = popupmenuEncounterTypeS{get(hObject,'Value')} %selected string
switch (popupmenuEncounterTypeV)
    case 'Fixed number of encounters'
        popupmenuEncounterTypeV2 = 1
    case 'Stochastic Normal distribution'
        popupmenuEncounterTypeV2 = 2
    case 'Stochastic Uniform distribution'
        popupmenuEncounterTypeV2 = 3
    otherwise
        popupmenuEncounterTypeV2 = 1
end
%save to structure
set(handles.popupmenuEncounterType,'Value',popupmenuEncounterTypeV2);
set(handles.popupmenuEncounterType,'String',popupmenuEncounterTypeS);
% save the changes to the structure
guidata(gcbo,handles);

% --- Executes during object creation, after setting all properties.
function popupmenuEncounterType_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenuEncounterType (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function editMinEncounters_Callback(hObject, eventdata, handles)
% hObject    handle to editMinEncounters (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of editMinEncounters as text
%        str2double(get(hObject,'String')) returns contents of editMinEncounters as a double
editMinEncountersS = get(hObject,'String') 
editMinEncountersV = str2double(get(hObject,'String'))
%save to structure
set(handles.editMinEncounters,'Value',editMinEncountersV);
set(handles.editMinEncounters,'String',editMinEncountersS);
% save the changes to the structure
guidata(gcbo,handles);

% --- Executes during object creation, after setting all properties.
function editMinEncounters_CreateFcn(hObject, eventdata, handles)
% hObject    handle to editMinEncounters (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function editMaxEncounters_Callback(hObject, eventdata, handles)
% hObject    handle to editMaxEncounters (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of editMaxEncounters as text
%        str2double(get(hObject,'String')) returns contents of editMaxEncounters as a double
editMaxEncountersS = get(hObject,'String') 
editMaxEncountersV = str2double(get(hObject,'String'))
%save to structure
set(handles.editMaxEncounters,'Value',editMaxEncountersV);
set(handles.editMaxEncounters,'String',editMaxEncountersS);
% save the changes to the structure
guidata(gcbo,handles);

% --- Executes during object creation, after setting all properties.
function editMaxEncounters_CreateFcn(hObject, eventdata, handles)
% hObject    handle to editMaxEncounters (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function editUpdateSampleSize_Callback(hObject, eventdata, handles)
% hObject    handle to editUpdateSampleSize (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of editUpdateSampleSize as text
%        str2double(get(hObject,'String')) returns contents of editUpdateSampleSize as a double
editUpdateSampleSizeS = get(hObject,'String') 
editUpdateSampleSizeV = str2double(get(hObject,'String'))
%save to structure
set(handles.editUpdateSampleSize,'Value',editUpdateSampleSizeV);
set(handles.editUpdateSampleSize,'String',editUpdateSampleSizeS);
% save the changes to the structure
guidata(gcbo,handles);

% --- Executes during object creation, after setting all properties.
function editUpdateSampleSize_CreateFcn(hObject, eventdata, handles)
% hObject    handle to editUpdateSampleSize (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in popupmenuAlg5UpdateType.
function popupmenuAlg5UpdateType_Callback(hObject, eventdata, handles)
% hObject    handle to popupmenuAlg5UpdateType (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns popupmenuAlg5UpdateType contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenuAlg5UpdateType
popupmenuAlg5UpdateTypeS = cellstr(get(hObject,'String'))
popupmenuAlg5UpdateTypeV = popupmenuAlg5UpdateTypeS{get(hObject,'Value')}
switch (popupmenuAlg5UpdateTypeV)
    case 'Continuous update'
        popupmenuAlg5UpdateTypeV2=1
        set(handles.editAlg5MinStd, 'Enable', 'off');
        set(handles.editAlg5MaxStd, 'Enable', 'off');
    case 'Single stop'
        popupmenuAlg5UpdateTypeV2=2
        set(handles.editAlg5MinStd, 'Enable', 'on');
        set(handles.editAlg5MaxStd, 'Enable', 'off');
    case 'Multiple stop and restart'
        popupmenuAlg5UpdateTypeV2=3
        set(handles.editAlg5MinStd, 'Enable', 'on');
        set(handles.editAlg5MaxStd, 'Enable', 'on');
    otherwise
        popupmenuAlg5UpdateTypeV2=1
        set(handles.editAlg5MinStd, 'Enable', 'off');
        set(handles.editAlg5MaxStd, 'Enable', 'off');
end;
%save to structure
set(handles.popupmenuAlg5UpdateType,'Value',popupmenuAlg5UpdateTypeV2);
set(handles.popupmenuAlg5UpdateType,'String',popupmenuAlg5UpdateTypeS);
% save the changes to the structure
guidata(gcbo,handles);

% --- Executes during object creation, after setting all properties.
function popupmenuAlg5UpdateType_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenuAlg5UpdateType (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function editAlg5MinStd_Callback(hObject, eventdata, handles)
% hObject    handle to editAlg5MinStd (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of editAlg5MinStd as text
%        str2double(get(hObject,'String')) returns contents of editAlg5MinStd as a double
editAlg5MinStdS = get(hObject,'String') 
editAlg5MinStdV = str2double(get(hObject,'String'))
%save to structure
set(handles.editAlg5MinStd,'Value',editAlg5MinStdV);
set(handles.editAlg5MinStd,'String',editAlg5MinStdS);
% save the changes to the structure
guidata(gcbo,handles);

% --- Executes during object creation, after setting all properties.
function editAlg5MinStd_CreateFcn(hObject, eventdata, handles)
% hObject    handle to editAlg5MinStd (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function editAlg5MaxStd_Callback(hObject, eventdata, handles)
% hObject    handle to editAlg5MaxStd (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of editAlg5MaxStd as text
%        str2double(get(hObject,'String')) returns contents of editAlg5MaxStd as a double
editAlg5MaxStdS = get(hObject,'String') 
editAlg5MaxStdV = str2double(get(hObject,'String'))
%save to structure
set(handles.editAlg5MaxStd,'Value',editAlg5MaxStdV);
set(handles.editAlg5MaxStd,'String',editAlg5MaxStdS);
% save the changes to the structure
guidata(gcbo,handles);

% --- Executes during object creation, after setting all properties.
function editAlg5MaxStd_CreateFcn(hObject, eventdata, handles)
% hObject    handle to editAlg5MaxStd (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in popupmenuAlg4UpdateType.
function popupmenuAlg4UpdateType_Callback(hObject, eventdata, handles)
% hObject    handle to popupmenuAlg4UpdateType (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns popupmenuAlg4UpdateType contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenuAlg4UpdateType
popupmenuAlg4UpdateTypeS = cellstr(get(hObject,'String'))
popupmenuAlg4UpdateTypeV = popupmenuAlg4UpdateTypeS{get(hObject,'Value')}
switch (popupmenuAlg4UpdateTypeV)
    case 'Continuous update'
        popupmenuAlg4UpdateTypeV2=1
        %disable max and min std
        set(handles.editAlg4Minstd, 'Enable', 'off');
        set(handles.editAlg4MaxStd, 'Enable', 'off');
    case 'Single stop'
        popupmenuAlg4UpdateTypeV2=2
        set(handles.editAlg4Minstd, 'Enable', 'on');
        set(handles.editAlg4MaxStd, 'Enable', 'off');
    case 'Multiple stop and restart'
        popupmenuAlg4UpdateTypeV2=3
       set(handles.editAlg4Minstd, 'Enable', 'on');
        set(handles.editAlg4MaxStd, 'Enable', 'on');
    otherwise
        popupmenuAlg4UpdateTypeV2=1
        set(handles.editAlg4Minstd, 'Enable', 'off');
        set(handles.editAlg4MaxStd, 'Enable', 'off');
end;
%save to structure
set(handles.popupmenuAlg4UpdateType,'Value',popupmenuAlg4UpdateTypeV2);
set(handles.popupmenuAlg4UpdateType,'String',popupmenuAlg4UpdateTypeS);
% save the changes to the structure
guidata(gcbo,handles);

% --- Executes during object creation, after setting all properties.
function popupmenuAlg4UpdateType_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenuAlg4UpdateType (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function editAlg4Minstd_Callback(hObject, eventdata, handles)
% hObject    handle to editAlg4Minstd (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of editAlg4Minstd as text
%        str2double(get(hObject,'String')) returns contents of editAlg4Minstd as a double
editAlg4MinstdS = get(hObject,'String') 
editAlg4MinstdV = str2double(get(hObject,'String'))
%save to structure
set(handles.editAlg4Minstd,'Value',editAlg4MinstdV);
set(handles.editAlg4Minstd,'String',editAlg4MinstdS);
% save the changes to the structure
guidata(gcbo,handles);

% --- Executes during object creation, after setting all properties.
function editAlg4Minstd_CreateFcn(hObject, eventdata, handles)
% hObject    handle to editAlg4Minstd (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function editAlg4MaxStd_Callback(hObject, eventdata, handles)
% hObject    handle to editAlg4MaxStd (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of editAlg4MaxStd as text
%        str2double(get(hObject,'String')) returns contents of editAlg4MaxStd as a double
editAlg4MaxStdS = get(hObject,'String') 
editAlg4MaxStdV = str2double(get(hObject,'String'))
%save to structure
set(handles.editAlg4MaxStd,'Value',editAlg4MaxStdV);
set(handles.editAlg4MaxStd,'String',editAlg4MaxStdS);
% save the changes to the structure
guidata(gcbo,handles);

% --- Executes during object creation, after setting all properties.
function editAlg4MaxStd_CreateFcn(hObject, eventdata, handles)
% hObject    handle to editAlg4MaxStd (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in checkboxChangeCommDes.
function checkboxChangeCommDes_Callback(hObject, eventdata, handles)
% hObject    handle to checkboxChangeCommDes (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkboxChangeCommDes
checkboxChangeCommDesV = get(hObject,'Value')
checkboxChangeCommDesS = get(hObject,'String');
%save to structure
set(handles.checkboxChangeCommDes,'Value',checkboxChangeCommDesV);
set(handles.checkboxChangeCommDes,'String',checkboxChangeCommDesS);
% save the changes to the structure
guidata(gcbo,handles);

% --- Executes on button press in checkboxChangeIndDes.
function checkboxChangeIndDes_Callback(hObject, eventdata, handles)
% hObject    handle to checkboxChangeIndDes (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkboxChangeIndDes
checkboxChangeIndDesV = get(hObject,'Value')
checkboxChangeIndDesS = get(hObject,'String');
%save to structure
set(handles.checkboxChangeIndDes,'Value',checkboxChangeIndDesV);
set(handles.checkboxChangeIndDes,'String',checkboxChangeIndDesS);
% save the changes to the structure
guidata(gcbo,handles);


% --- Executes on button press in checkboxChangeEff.
function checkboxChangeEff_Callback(hObject, eventdata, handles)
% hObject    handle to checkboxChangeEff (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkboxChangeEff
checkboxChangeEffV = get(hObject,'Value')
checkboxChangeEffS = get(hObject,'String');
%save to structure
set(handles.checkboxChangeEff,'Value',checkboxChangeEffV);
set(handles.checkboxChangeEff,'String',checkboxChangeEffS);
% save the changes to the structure
guidata(gcbo,handles);


function editCommTime1_Callback(hObject, eventdata, handles)
% hObject    handle to editCommTime1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of editCommTime1 as text
%        str2double(get(hObject,'String')) returns contents of editCommTime1 as a double
editCommTime1S = get(hObject,'String') 
editCommTime1V = str2double(get(hObject,'String'))
%save to structure
set(handles.editCommTime1,'Value',editCommTime1V);
set(handles.editCommTime1,'String',editCommTime1S);
% save the changes to the structure
guidata(gcbo,handles);

% --- Executes during object creation, after setting all properties.
function editCommTime1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to editCommTime1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function editIndTime1_Callback(hObject, eventdata, handles)
% hObject    handle to editIndTime1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of editIndTime1 as text
%        str2double(get(hObject,'String')) returns contents of editIndTime1 as a double
editIndTime1S = get(hObject,'String') 
editIndTime1V = str2double(get(hObject,'String'))
%save to structure
set(handles.editIndTime1,'Value',editIndTime1V);
set(handles.editIndTime1,'String',editIndTime1S);
% save the changes to the structure
guidata(gcbo,handles);

% --- Executes during object creation, after setting all properties.
function editIndTime1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to editIndTime1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function editEffTime1_Callback(hObject, eventdata, handles)
% hObject    handle to editEffTime1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of editEffTime1 as text
%        str2double(get(hObject,'String')) returns contents of editEffTime1 as a double
editEffTime1S = get(hObject,'String') 
editEffTime1V = str2double(get(hObject,'String'))
%save to structure
set(handles.editEffTime1,'Value',editEffTime1V);
set(handles.editEffTime1,'String',editEffTime1S);
% save the changes to the structure
guidata(gcbo,handles);

% --- Executes during object creation, after setting all properties.
function editEffTime1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to editEffTime1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in checkboxCommTime1.
function checkboxCommTime1_Callback(hObject, eventdata, handles)
% hObject    handle to checkboxCommTime1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkboxCommTime1
checkboxCommTime1V = get(hObject,'Value')
checkboxCommTime1S = get(hObject,'String');
%save to structure
set(handles.checkboxCommTime1,'Value',checkboxCommTime1V);
set(handles.checkboxCommTime1,'String',checkboxCommTime1S);
% save the changes to the structure
guidata(gcbo,handles);

% --- Executes on button press in checkboxIndTime1.
function checkboxIndTime1_Callback(hObject, eventdata, handles)
% hObject    handle to checkboxIndTime1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkboxIndTime1
checkboxIndTime1V = get(hObject,'Value')
checkboxIndTime1S = get(hObject,'String');
%save to structure
set(handles.checkboxIndTime1,'Value',checkboxIndTime1V);
set(handles.checkboxIndTime1,'String',checkboxIndTime1S);
% save the changes to the structure
guidata(gcbo,handles);

% --- Executes on button press in checkboxEffTime1.
function checkboxEffTime1_Callback(hObject, eventdata, handles)
% hObject    handle to checkboxEffTime1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkboxEffTime1
checkboxEffTime1V = get(hObject,'Value')
checkboxEffTime1S = get(hObject,'String');
%save to structure
set(handles.checkboxEffTime1,'Value',checkboxEffTime1V);
set(handles.checkboxEffTime1,'String',checkboxEffTime1S);
% save the changes to the structure
guidata(gcbo,handles);


function editCommTime2_Callback(hObject, eventdata, handles)
% hObject    handle to editCommTime2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of editCommTime2 as text
%        str2double(get(hObject,'String')) returns contents of editCommTime2 as a double
editCommTime2S = get(hObject,'String') 
editCommTime2V = str2double(get(hObject,'String'))
%save to structure
set(handles.editCommTime2,'Value',editCommTime2V);
set(handles.editCommTime2,'String',editCommTime2S);
% save the changes to the structure
guidata(gcbo,handles);

% --- Executes during object creation, after setting all properties.
function editCommTime2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to editCommTime2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function editIndTime2_Callback(hObject, eventdata, handles)
% hObject    handle to editIndTime2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of editIndTime2 as text
%        str2double(get(hObject,'String')) returns contents of editIndTime2 as a double
editIndTime2S = get(hObject,'String') 
editIndTime2V = str2double(get(hObject,'String'))
%save to structure
set(handles.editIndTime2,'Value',editIndTime2V);
set(handles.editIndTime2,'String',editIndTime2S);
% save the changes to the structure
guidata(gcbo,handles);

% --- Executes during object creation, after setting all properties.
function editIndTime2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to editIndTime2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function editEffTime2_Callback(hObject, eventdata, handles)
% hObject    handle to editEffTime2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of editEffTime2 as text
%        str2double(get(hObject,'String')) returns contents of editEffTime2 as a double
editEffTime2S = get(hObject,'String') 
editEffTime2V = str2double(get(hObject,'String'))
%save to structure
set(handles.editEffTime2,'Value',editEffTime2V);
set(handles.editEffTime2,'String',editEffTime2S);
% save the changes to the structure
guidata(gcbo,handles);

% --- Executes during object creation, after setting all properties.
function editEffTime2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to editEffTime2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in checkboxCommTime2.
function checkboxCommTime2_Callback(hObject, eventdata, handles)
% hObject    handle to checkboxCommTime2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkboxCommTime2
checkboxCommTime2V = get(hObject,'Value')
checkboxCommTime2S = get(hObject,'String');
%save to structure
set(handles.checkboxCommTime2,'Value',checkboxCommTime2V);
set(handles.checkboxCommTime2,'String',checkboxCommTime2S);
% save the changes to the structure
guidata(gcbo,handles);

% --- Executes on button press in checkboxIndTime2.
function checkboxIndTime2_Callback(hObject, eventdata, handles)
% hObject    handle to checkboxIndTime2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkboxIndTime2
checkboxIndTime2V = get(hObject,'Value')
checkboxIndTime2S = get(hObject,'String');
%save to structure
set(handles.checkboxIndTime2,'Value',checkboxIndTime2V);
set(handles.checkboxIndTime2,'String',checkboxIndTime2S);
% save the changes to the structure
guidata(gcbo,handles);

% --- Executes on button press in checkboxEffTime2.
function checkboxEffTime2_Callback(hObject, eventdata, handles)
% hObject    handle to checkboxEffTime2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkboxEffTime2
checkboxEffTime2V = get(hObject,'Value')
checkboxEffTime2S = get(hObject,'String');
%save to structure
set(handles.checkboxEffTime2,'Value',checkboxEffTime2V);
set(handles.checkboxEffTime2,'String',checkboxEffTime2S);
% save the changes to the structure
guidata(gcbo,handles);


function edit20_Callback(hObject, eventdata, handles)
% hObject    handle to editSimProgress (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of editSimProgress as text
%        str2double(get(hObject,'String')) returns contents of editSimProgress as a double


% --- Executes during object creation, after setting all properties.
function editSimProgress_CreateFcn(hObject, eventdata, handles)
% hObject    handle to editSimProgress (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit21_Callback(hObject, eventdata, handles)
% hObject    handle to editSimStartTime (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of editSimStartTime as text
%        str2double(get(hObject,'String')) returns contents of editSimStartTime as a double


% --- Executes during object creation, after setting all properties.
function editSimStartTime_CreateFcn(hObject, eventdata, handles)
% hObject    handle to editSimStartTime (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit22_Callback(hObject, eventdata, handles)
% hObject    handle to editSimEndTime (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of editSimEndTime as text
%        str2double(get(hObject,'String')) returns contents of editSimEndTime as a double


% --- Executes during object creation, after setting all properties.
function editSimEndTime_CreateFcn(hObject, eventdata, handles)
% hObject    handle to editSimEndTime (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in popupmenuInputDataset.
function popupmenuInputDataset_Callback(hObject, eventdata, handles)
% hObject    handle to popupmenuInputDataset (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns popupmenuInputDataset contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenuInputDataset
popupmenuInputDatasetS = cellstr(get(hObject,'String'))
popupmenuInputDatasetV = popupmenuInputDatasetS{get(hObject,'Value')}
popupmenuInputDatasetV2 = str2double(popupmenuInputDatasetV)

%save to structure
set(handles.popupmenuInputDataset,'Value',popupmenuInputDatasetV2);
set(handles.popupmenuInputDataset,'String',popupmenuInputDatasetS);
% save the changes to the structure
guidata(gcbo,handles);

% --- Executes during object creation, after setting all properties.
function popupmenuInputDataset_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenuInputDataset (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in pushbuttonDatasetInfo.
function pushbuttonDatasetInfo_Callback(hObject, eventdata, handles)
% hObject    handle to pushbuttonDatasetInfo (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
summaryDatasetsFig = summaryDatasets('summaryDatasets', hObject);%open figure
handles.summaryDatasetsFig = summaryDatasetsFig; %save handle ref
set(handles.summaryDatasetsFig,'Visible','on');%make invisible
%Update handles structure
guidata(hObject, handles);

% --- Executes when selected object is changed in uipanelViewSimulationSettings.
function uipanelViewSimulationSettings_SelectionChangeFcn(hObject, eventdata, handles)
% hObject    handle to the selected object in uipanelViewSimulationSettings 
% eventdata  structure with the following fields (see UIBUTTONGROUP)
%	EventName: string 'SelectionChanged' (read only)
%	OldValue: handle of the previously selected object or empty if none was selected
%	NewValue: handle of the currently selected object
% handles    structure with handles and user data (see GUIDATA)



% --- Executes when selected object is changed in uipanelSelectAlgorithms.
function uipanelSelectAlgorithms_SelectionChangeFcn(hObject, eventdata, handles)
% hObject    handle to the selected object in uipanelSelectAlgorithms 
% eventdata  structure with the following fields (see UIBUTTONGROUP)
%	EventName: string 'SelectionChanged' (read only)
%	OldValue: handle of the previously selected object or empty if none was selected
%	NewValue: handle of the currently selected object
% handles    structure with handles and user data (see GUIDATA)
%get new value of selected button
newSelectionV=get(eventdata.NewValue,'Value')
newSelectionS=get(eventdata.NewValue,'String')
%save to structure
%set(handles.uipanelSelectAlgorithms,'Value',newSelectionV);
%set(handles.uipanelSelectAlgorithms,'String',newSelectionS);
% save the changes to the structure
guidata(gcbo,handles);

% --- Executes on key press with focus on editNumTimeSteps and none of its controls.
function editNumTimeSteps_KeyPressFcn(hObject, eventdata, handles)
% hObject    handle to editNumTimeSteps (see GCBO)
% eventdata  structure with the following fields (see UICONTROL)
%	Key: name of the key that was pressed, in lower case
%	Character: character interpretation of the key(s) that was pressed
%	Modifier: name(s) of the modifier key(s) (i.e., control, shift) pressed
% handles    structure with handles and user data (see GUIDATA)


% --- Executes during object creation, after setting all properties.
function uipanelSelectAlgorithms_CreateFcn(hObject, eventdata, handles)
% hObject    handle to uipanelSelectAlgorithms (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called


% --- Executes when selected object is changed in uipanelViewGraphicalOutput.
function uipanelViewGraphicalOutput_SelectionChangeFcn(hObject, eventdata, handles)
% hObject    handle to the selected object in uipanelViewGraphicalOutput 
% eventdata  structure with the following fields (see UIBUTTONGROUP)
%	EventName: string 'SelectionChanged' (read only)
%	OldValue: handle of the previously selected object or empty if none was selected
%	NewValue: handle of the currently selected object
% handles    structure with handles and user data (see GUIDATA)
%get new value of selected button



% --- Executes when user attempts to close figureDynAlgGUI.
function figureDynAlgGUI_CloseRequestFcn(hObject, eventdata, handles)
% hObject    handle to figureDynAlgGUI (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: delete(hObject) closes the figure
%delete temporary files
GUIClass.deleteAllSettingsTempFiles();
GUIClass.deleteAllOutputsTempFiles();
delete(hObject);


% --- Executes during object deletion, before destroying properties.
function popupmenuGraphType_DeleteFcn(hObject, eventdata, handles)
% hObject    handle to popupmenuGraphType (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function saveSimulationOutput_Callback(hObject, eventdata, handles)
% hObject    handle to saveSimulationOutput (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
saveSimulationOutputFig = saveSimulationOutput(handles);%open figure
handles.saveSimulationOutputFig = saveSimulationOutputFig; %save handle ref
set(handles.saveSimulationOutputFig,'Visible','on');%make visible
%Update handles structure
guidata(hObject, handles);


% --------------------------------------------------------------------
function LoadSimulationOutput_Callback(hObject, eventdata, handles)
% hObject    handle to LoadSimulationOutput (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

loadSimulationOutputFig = loadSimulationOutput(handles);%open figure
handles.loadSimulationOutputFig = loadSimulationOutputFig; %save handle ref
set(handles.loadSimulationOutputFig,'Visible','on');%make visible
%Update handles structure
guidata(hObject, handles);


% --------------------------------------------------------------------
function ProgramSettings_Callback(hObject, eventdata, handles)
% hObject    handle to ProgramSettings (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

%include settings here such as being able to change the input and output
%directories for saving data


% --- Executes on button press in checkboxbinmode.
function checkboxbinmode_Callback(hObject, eventdata, handles)
% hObject    handle to checkboxbinmode (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkboxbinmode
checkboxbinmodeV = get(hObject,'Value')
checkboxbinmodeS = get(hObject,'String');
%save to structure
set(handles.checkboxbinmode,'Value',checkboxbinmodeV);
set(handles.checkboxbinmode,'String',checkboxbinmodeS);
% save the changes to the structure
guidata(gcbo,handles);


% --------------------------------------------------------------------
function Scripts_Callback(hObject, eventdata, handles)
% hObject    handle to Scripts (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function ScriptsInfo_Callback(hObject, eventdata, handles)
% hObject    handle to ScriptsInfo (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
scriptsInfoFig = scriptsInfo(handles);%open figure, pass main gui handles
handles.scriptsInfoFig = scriptsInfoFig; %save handle ref
set(handles.scriptsInfoFig,'Visible','on');%make visible
%Update handles structure
guidata(hObject, handles);

% --------------------------------------------------------------------
function EditScripts_Callback(hObject, eventdata, handles)
% hObject    handle to EditScripts (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function RunScripts_Callback(hObject, eventdata, handles)
% hObject    handle to RunScripts (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function script_maximiseDiversity_Callback(hObject, eventdata, handles)
% hObject    handle to script_maximiseDiversity (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

%change directory
cd scripts
%run script
maximiseDiversity
%go back to this directory
cd ..


% --------------------------------------------------------------------
function editMaximiseDiversity_Callback(hObject, eventdata, handles)
% hObject    handle to editMaximiseDiversity (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
output = open('scripts\maximiseDiversity.m')


% --- Executes during object creation, after setting all properties.
function figureDynAlgGUI_CreateFcn(hObject, eventdata, handles)
% hObject    handle to figureDynAlgGUI (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called


% --------------------------------------------------------------------
function script_maximiseCommunity_Callback(hObject, eventdata, handles)
% hObject    handle to script_maximiseCommunity (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

%change directory
cd scripts
%run script
maximiseCommunity
%go back to this directory
cd ..


% --------------------------------------------------------------------
function editMaximiseCommunity_Callback(hObject, eventdata, handles)
% hObject    handle to editMaximiseCommunity (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
output = open('scripts\maximiseCommunity.m')


% --------------------------------------------------------------------
function script_maximiseDivCom_Callback(hObject, eventdata, handles)
% hObject    handle to script_maximiseDivCom (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
maximiseDivCom


% --------------------------------------------------------------------
function script_meanDiversityVsNumNodes_Callback(hObject, eventdata, handles)
% hObject    handle to script_meanDiversityVsNumNodes (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
meanDiversityVsNumNodes

% --- Executes on button press in checkboxAlignData.
function checkboxAlignData_Callback(hObject, eventdata, handles)
% hObject    handle to checkboxAlignData (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkboxAlignData
checkboxAlignDataV = get(hObject,'Value')
checkboxAlignDataS = get(hObject,'String');
%save to structure
set(handles.checkboxAlignData,'Value',checkboxAlignDataV);
set(handles.checkboxAlignData,'String',checkboxAlignDataS);
% save the changes to the structure
guidata(gcbo,handles);


% --------------------------------------------------------------------
function script_alignmentExample_Callback(hObject, eventdata, handles)
% hObject    handle to script_alignmentExample (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
%change directory
alignmentExample


% --------------------------------------------------------------------
function stoppingTolerance_Callback(hObject, eventdata, handles)
% hObject    handle to stoppingTolerance (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
output = open('scripts\stoppingTolerance.m')


% --------------------------------------------------------------------
function maxDiv_Callback(hObject, eventdata, handles)
% hObject    handle to maxDiv (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
output = open('scripts\maxDiv.m')


% --------------------------------------------------------------------
function maxDivRelationship2_Callback(hObject, eventdata, handles)
% hObject    handle to maxDivRelationship2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
output = open('scripts\maxDivRelationship2.m')


% --------------------------------------------------------------------
function maxDivRelationship_Callback(hObject, eventdata, handles)
% hObject    handle to maxDivRelationship (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
output = open('scripts\maxDivRelationship.m')


% --------------------------------------------------------------------
function adaptiveExample_Callback(hObject, eventdata, handles)
% hObject    handle to adaptiveExample (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
output = open('scripts\adaptiveExample.m')


% --------------------------------------------------------------------
function script_stoppingTolerance_Callback(hObject, eventdata, handles)
% hObject    handle to script_stoppingTolerance (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
stoppingTolerance


% --------------------------------------------------------------------
function script_maxDiv_Callback(hObject, eventdata, handles)
% hObject    handle to script_maxDiv (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
maxDiv


% --------------------------------------------------------------------
function script_maxDivRelationship2_Callback(hObject, eventdata, handles)
% hObject    handle to script_maxDivRelationship2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
maxDivRelationship2


% --------------------------------------------------------------------
function alignmentExample_Callback(hObject, eventdata, handles)
% hObject    handle to alignmentExample (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
output = open('scripts\alignmentExample.m')


% --------------------------------------------------------------------
function maximiseDivCom_Callback(hObject, eventdata, handles)
% hObject    handle to maximiseDivCom (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
output = open('scripts\maximiseDivCom.m')


% --------------------------------------------------------------------
function meanDiversityVsNumNodes_Callback(hObject, eventdata, handles)
% hObject    handle to meanDiversityVsNumNodes (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
output = open('scripts\meanDiversityVsNumNodes.m')


% --------------------------------------------------------------------
function script_maxDivRelationship_Callback(hObject, eventdata, handles)
% hObject    handle to script_maxDivRelationship (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
maxDivRelationship

% --------------------------------------------------------------------
function script_adaptiveExample_Callback(hObject, eventdata, handles)
% hObject    handle to script_adaptiveExample (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
adaptiveExample


% --- Executes on selection change in popupmenuSettings.
function popupmenuSettings_Callback(hObject, eventdata, handles)
% hObject    handle to popupmenuSettings (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns popupmenuSettings contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenuSettings
%get old value of selected button
oldSelectionS=get(handles.editOldSimSetting,'String')
settingsSimNumber = str2num(oldSelectionS);
maxNumSims = GUIClass.getMaxNumSims();
%save settings data
%DO STUIFF HERE
directorynameSettings = GUIClass.getDirectoryNameSettings();
settingsTempFileNames = GUIClass.genSettingsTempFileNames(directorynameSettings,maxNumSims);
GUIClass.saveSettingsTempFile(settingsTempFileNames,settingsSimNumber,handles);
%get new value of selected button
newSelectionV = get(hObject,'Value')
%save new value
set(handles.popupmenuSettings,'Value',newSelectionV)
%load any previous settings recorded
GUIClass.loadSettingsTempFile(settingsTempFileNames,newSelectionV,handles)
% do last - set text to current sim setting value
set(handles.editOldSimSetting,'String',num2str(newSelectionV))
% save the changes to the structure
guidata(gcbo,handles);

% --- Executes during object creation, after setting all properties.
function popupmenuSettings_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenuSettings (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in popupmenuGraphicalOutput.
function popupmenuGraphicalOutput_Callback(hObject, eventdata, handles)
% hObject    handle to popupmenuGraphicalOutput (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns popupmenuGraphicalOutput contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenuGraphicalOutput
%get new value of selected button
simNumber=get(hObject,'Value')
set(handles.popupmenuGraphicalOutput,'Value', simNumber)
% save the changes to the structure
guidata(gcbo,handles);
%**************************************
%check file extensions to use for output data
binmode=get(handles.checkboxbinmode,'Value'); %this is set for each setting but should be applied to all sims really
fileExtension = GUIClass.getFileExtension(binmode);
%*****************************
%names of settings temp files
directorynameSettings = GUIClass.getDirectoryNameSettings();
settingsTempFileNames = GUIClass.genSettingsTempFileNames(directorynameSettings,simNumber);
%names of outputs temp files
directorynameOut = GUIClass.getDirectoryNameOut();
outputsTempFileNames = GUIClass.genOutputsTempFileNames(directorynameOut,simNumber,fileExtension);
%*************************************
%make sure correct file is loaded
outputs = GUIClass.loadOutputsTempFile(outputsTempFileNames,simNumber,binmode)
%**************************
%Display data on graph
displayGUIGraph(outputs,handles)


% --- Executes during object creation, after setting all properties.
function popupmenuGraphicalOutput_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenuGraphicalOutput (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- If Enable == 'on', executes on mouse press in 5 pixel border.
% --- Otherwise, executes on mouse press in 5 pixel border or over popupmenuSettings.
function popupmenuSettings_ButtonDownFcn(hObject, eventdata, handles)
% hObject    handle to popupmenuSettings (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes on key press with focus on popupmenuSettings and none of its controls.
function popupmenuSettings_KeyPressFcn(hObject, eventdata, handles)
% hObject    handle to popupmenuSettings (see GCBO)
% eventdata  structure with the following fields (see UICONTROL)
%	Key: name of the key that was pressed, in lower case
%	Character: character interpretation of the key(s) that was pressed
%	Modifier: name(s) of the modifier key(s) (i.e., control, shift) pressed
% handles    structure with handles and user data (see GUIDATA)



function editOldSimSetting_Callback(hObject, eventdata, handles)
% hObject    handle to editOldSimSetting (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of editOldSimSetting as text
%        str2double(get(hObject,'String')) returns contents of editOldSimSetting as a double


% --- Executes during object creation, after setting all properties.
function editOldSimSetting_CreateFcn(hObject, eventdata, handles)
% hObject    handle to editOldSimSetting (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in checkboxFixedDiv.
function checkboxFixedDiv_Callback(hObject, eventdata, handles)
% hObject    handle to checkboxFixedDiv (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkboxFixedDiv


% --- Executes on button press in checkboxFixedCom.
function checkboxFixedCom_Callback(hObject, eventdata, handles)
% hObject    handle to checkboxFixedCom (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkboxFixedCom


% --- Executes on button press in checkboxFixedInd.
function checkboxFixedInd_Callback(hObject, eventdata, handles)
% hObject    handle to checkboxFixedInd (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkboxFixedInd


% --- Executes on button press in checkboxFixedQual.
function checkboxFixedQual_Callback(hObject, eventdata, handles)
% hObject    handle to checkboxFixedQual (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkboxFixedQual


% --- Executes on button press in checkboxDynDiv.
function checkboxDynDiv_Callback(hObject, eventdata, handles)
% hObject    handle to checkboxDynDiv (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkboxDynDiv
checkboxDynDivV = get(hObject,'Value')
%save to structure
set(handles.checkboxDynDiv,'Value',checkboxDynDivV);
% save the changes to the structure
guidata(gcbo,handles);

% --- Executes on button press in checkboxDynCom.
function checkboxDynCom_Callback(hObject, eventdata, handles)
% hObject    handle to checkboxDynCom (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkboxDynCom
checkboxDynComV = get(hObject,'Value')
%save to structure
set(handles.checkboxDynCom,'Value',checkboxDynComV);
% save the changes to the structure
guidata(gcbo,handles);


% --- Executes on button press in checkboxDynInd.
function checkboxDynInd_Callback(hObject, eventdata, handles)
% hObject    handle to checkboxDynInd (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkboxDynInd
checkboxDynIndV = get(hObject,'Value')
%save to structure
set(handles.checkboxDynInd,'Value',checkboxDynIndV);
% save the changes to the structure
guidata(gcbo,handles);

% --- Executes on button press in checkboxDynQual.
function checkboxDynQual_Callback(hObject, eventdata, handles)
% hObject    handle to checkboxDynQual (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkboxDynQual
checkboxDynQualV = get(hObject,'Value')
%save to structure
set(handles.checkboxDynQual,'Value',checkboxDynQualV);
% save the changes to the structure
guidata(gcbo,handles);


function editWeightFileDiv_Callback(hObject, eventdata, handles)
% hObject    handle to editWeightFileDiv (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of editWeightFileDiv as text
%        str2double(get(hObject,'String')) returns contents of editWeightFileDiv as a double
editWeightFileDivV = str2double(get(hObject,'String'));
editWeightFileDivS = get(hObject,'String');
%save to structure
set(handles.editWeightFileDiv,'Value',editWeightFileDivV);
set(handles.editWeightFileDiv,'String',editWeightFileDivS);
% save the changes to the structure
guidata(gcbo,handles);


% --- Executes during object creation, after setting all properties.
function editWeightFileDiv_CreateFcn(hObject, eventdata, handles)
% hObject    handle to editWeightFileDiv (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function editWeightFileCom_Callback(hObject, eventdata, handles)
% hObject    handle to editWeightFileCom (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of editWeightFileCom as text
%        str2double(get(hObject,'String')) returns contents of editWeightFileCom as a double
editWeightFileComV = str2double(get(hObject,'String'))
editWeightFileComS = get(hObject,'String');
%save to structure
set(handles.editWeightFileCom,'Value',editWeightFileComV);
set(handles.editWeightFileCom,'String',editWeightFileComS);
% save the changes to the structure
guidata(gcbo,handles);

% --- Executes during object creation, after setting all properties.
function editWeightFileCom_CreateFcn(hObject, eventdata, handles)
% hObject    handle to editWeightFileCom (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function editWeightFileInd_Callback(hObject, eventdata, handles)
% hObject    handle to editWeightFileInd (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of editWeightFileInd as text
%        str2double(get(hObject,'String')) returns contents of editWeightFileInd as a double
editWeightFileIndV = str2double(get(hObject,'String'))
editWeightFileIndS = get(hObject,'String');
%save to structure
set(handles.editWeightFileInd,'Value',editWeightFileIndV);
set(handles.editWeightFileInd,'String',editWeightFileIndS);
% save the changes to the structure
guidata(gcbo,handles);

% --- Executes during object creation, after setting all properties.
function editWeightFileInd_CreateFcn(hObject, eventdata, handles)
% hObject    handle to editWeightFileInd (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function editWeightFileQual_Callback(hObject, eventdata, handles)
% hObject    handle to editWeightFileQual (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of editWeightFileQual as text
%        str2double(get(hObject,'String')) returns contents of editWeightFileQual as a double
editWeightFileQualV = str2double(get(hObject,'String'))
editWeightFileQualS = get(hObject,'String');
%save to structure
set(handles.editWeightFileQual,'Value',editWeightFileQualV);
set(handles.editWeightFileQual,'String',editWeightFileQualS);
% save the changes to the structure
guidata(gcbo,handles);

% --- Executes during object creation, after setting all properties.
function editWeightFileQual_CreateFcn(hObject, eventdata, handles)
% hObject    handle to editWeightFileQual (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in checkComDes.
function checkComDes_Callback(hObject, eventdata, handles)
% hObject    handle to checkComDes (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkComDes
checkComDesV = get(hObject,'Value')
%save to structure
set(handles.checkComDes,'Value',checkComDesV);
% save the changes to the structure
guidata(gcbo,handles);

% --- Executes on button press in checkIndDes.
function checkIndDes_Callback(hObject, eventdata, handles)
% hObject    handle to checkIndDes (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkIndDes
checkIndDesV = get(hObject,'Value')
%save to structure
set(handles.checkIndDes,'Value',checkIndDesV);
% save the changes to the structure
guidata(gcbo,handles);

% --- Executes on button press in checkQualDes.
function checkQualDes_Callback(hObject, eventdata, handles)
% hObject    handle to checkQualDes (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkQualDes
checkQualDesV = get(hObject,'Value')
%save to structure
set(handles.checkQualDes,'Value',checkQualDesV);
% save the changes to the structure
guidata(gcbo,handles);


function editDesComFilename_Callback(hObject, eventdata, handles)
% hObject    handle to editDesComFilename (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of editDesComFilename as text
%        str2double(get(hObject,'String')) returns contents of editDesComFilename as a double
editDesComFilenameV = str2double(get(hObject,'String'));
editDesComFilenameS = get(hObject,'String');
%save to structure
set(handles.editDesComFilename,'Value',editDesComFilenameV);
set(handles.editDesComFilename,'String',editDesComFilenameS);
% save the changes to the structure
guidata(gcbo,handles);

% --- Executes during object creation, after setting all properties.
function editDesComFilename_CreateFcn(hObject, eventdata, handles)
% hObject    handle to editDesComFilename (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function editDesIndFilename_Callback(hObject, eventdata, handles)
% hObject    handle to editDesIndFilename (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of editDesIndFilename as text
%        str2double(get(hObject,'String')) returns contents of editDesIndFilename as a double
editDesIndFilenameV = str2double(get(hObject,'String'));
editDesIndFilenameS = get(hObject,'String');
%save to structure
set(handles.editDesIndFilename,'Value',editDesIndFilenameV);
set(handles.editDesIndFilename,'String',editDesIndFilenameS);
% save the changes to the structure
guidata(gcbo,handles);

% --- Executes during object creation, after setting all properties.
function editDesIndFilename_CreateFcn(hObject, eventdata, handles)
% hObject    handle to editDesIndFilename (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function editDesQualFilename_Callback(hObject, eventdata, handles)
% hObject    handle to editDesQualFilename (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of editDesQualFilename as text
%        str2double(get(hObject,'String')) returns contents of editDesQualFilename as a double
editDesQualFilenameV = str2double(get(hObject,'String'));
editDesQualFilenameS = get(hObject,'String');
%save to structure
set(handles.editDesQualFilename,'Value',editDesQualFilenameV);
set(handles.editDesQualFilename,'String',editDesQualFilenameS);
% save the changes to the structure
guidata(gcbo,handles);

% --- Executes during object creation, after setting all properties.
function editDesQualFilename_CreateFcn(hObject, eventdata, handles)
% hObject    handle to editDesQualFilename (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
