%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Jennifer Jackson 2017                                                        %
% A Biodiversity Approach to Cyber Security                                    %
% PhD Complexity Science                                                       %
% University of Warwick                                                        %
% http://wrap.warwick.ac.uk/98458                                              %
% This software is distributed under the  Creative Commons Attribution License %
% https://creativecommons.org/licenses/by/4.0/                                 %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%function outputs = DynAlgStochastic(handles,currentSimNumber,networkModelEnable,probOfEncounter)
function outputs = SingleSim(handles,ihandles,ohandles,currentSimNumber,directorynameOut,folderName,settingsTempFileNames,settingsSimFileNames)
        %run A SINGLE simulation - CHECK WHAT TO INCLUDE and initialise
        fileSaveOption = get(handles.popupmenuFileSaveOption, 'Value'); %1 save sims, 2 save run at end, 3 save run in blocks
        fileSavePrecision = get(handles.popupmenuFileSavePrecision, 'Value');
        GUIClass.checkMainIncludes(handles,ihandles)
        %blocklength = 60 %when save run output in blocks
        [trueNumRuns trueNumTimesteps] = GUIClass.getSimInfo(handles,ihandles) %set numRuns and numTimeSteps here
        ihandlesnumRunsPerSimD=ihandles.numRunsPerSim
        ihandlesnumTimeStepsD=ihandles.numTimeSteps
        DataClass.DataSimInit(handles,ihandles)%****o.k enabled %for dynamic diversity only
        StaticDiversityClass.StaticDataSimInit(handles,ihandles,ohandles)%*****O.K enabled %for static diversity only
        %network
        NodeEncounterClass.nodeEncounterSimInit(handles,ihandles)
        WirelessClass.WBSimInit(handles,ihandles)
        NodeEncounterClass.RWPSimInit(handles, ihandles)
        %attack
        DynAlgClass.AlgModelFavScoreSimInit(handles,ihandles,ohandles)%*****o.k enabled
        StaticDiversityClass.StaticDiversitySimInit(handles,ihandles,ohandles)%*****O.K enabled
        MeasureDiversityClass.MeasDivSimInit(handles,ihandles,ohandles)%*****o.k all time
        StateMachineClass.attackModelSimInit(handles,ihandles,ohandles) %malware type set here
        ihandlesprobabilityDistr=ihandles.probabilityDistr;
        %Check if save out simulation header file
        if fileSaveOption > 1 
            GUIClass.saveOutputsTempFile_simHeader(directorynameOut,currentSimNumber+1,ihandles,trueNumRuns,trueNumTimesteps)
        end %if
        
         disp('now in single sim func')   
%Do for all individual simulation runs
 for runNumber = 1: trueNumRuns %ihandles.numRunsPerSim 

  rhandles = runHandles();
  
  %do a single run
 % profile clear % clears the viewer contents
%profile on % turns profiler on

  SingleRun(handles,ihandles,rhandles,ohandles,currentSimNumber,runNumber,trueNumTimesteps,trueNumRuns,directorynameOut)
   
  %*************save one run as temp data
     if fileSaveOption ==2
         %save whole run
         lengthCounter=trueNumTimesteps; %length of data to save
         filenames = GUIClass.getTempRunFileNames(directorynameOut,currentSimNumber+1,runNumber);
         runFileHandles = GUIClass.saveOutputsTempFile_OpenRunFiles(filenames,currentSimNumber+1,runNumber);
         GUIClass.saveOutputsTempFile_SaveOutputs1RunBinaryData(runFileHandles,rhandles,ohandles,ihandles,handles,lengthCounter,fileSavePrecision);
         GUIClass.saveOutputsTempFile_SaveOutputs1RunBinaryDataSingleValues(runFileHandles,rhandles,ohandles,ihandles,handles);
         GUIClass.saveOutputsTempFile_CloseRunFiles(runFileHandles);
     end
    %copy and compress files at end instead 
    % if fileSaveOption > 1 
    %        %GUIClass.saveOutputsTempFile_simHeader(directorynameOut,currentSimNumber+1,ihandles,trueNumRuns,trueNumTimesteps)
    %        %copy run files into correct directory if autosave
    %        GUIClass.saveOutputsTempFile_simHeader(directorynameOut,currentSimNumber+1,ihandles,trueNumRuns,trueNumTimesteps)
    %        Tempfilenames_runFiles = GUIClass.getTempRunFileNames(directorynameOut,currentSimNumber+1,runNumber)             
    %        simfilenames_runFiles = GUIClass.getOutputRunFileNames(directorynameOut,folderName,currentSimNumber+1,runNumber)  
    %        GUIClass.autoSaveOutputs_sepRunFiles(directorynameOut,folderName,Tempfilenames_runFiles,simfilenames_runFiles,handles);
    %        %need to add saving graphs
    % end
  
  %profile off % turn it off
%profile viewer % view results
  %TEST ONLY
 % displayRWPsum = rhandles.RWPSumEncounterYes 
  %displaysum = rhandles.sumEncounterYes
  %displayrhandlesnodeStateAtTime = rhandles.nodeStateAtTimeStr
  % displayrhandlesnodeStateAtTimeN = rhandles.nodeStateAtTimeNumber
   
 end; %end psim
 

 %return output data - temporarily as can get rid of this really
outputs.datasetEnable =ohandles.datasetEnable;
outputs.datasetNumber =ohandles.datasetNumber;
outputs.networkModelEnable =ohandles.networkModelEnable; 
outputs.networkModelS =ohandles.networkModelS;
outputs.networkModelV =ohandles.networkModelV;
outputs.attackModelEnable =ohandles.attackModelEnable;
outputs.attackModelS =ohandles.attackModelS;
outputs.attackModelV =ohandles.attackModelV;
outputs.exploitEnable=ohandles.exploitEnable;
outputs.exploitTypeS=ohandles.exploitTypeS;
outputs.exploitTypeV=ohandles.exploitTypeV;
outputs.algModelEnable =ohandles.algModelEnable;
outputs.algModelS =ohandles.algModelS;
outputs.algModelV =ohandles.algModelV;
outputs.networkPerfEnable =ohandles.networkPerfEnable;
outputs.perfModelS =ohandles.perfModelS;
outputs.perfModelV =ohandles.perfModelV;
 outputs.numNodes=ohandles.numNodes;
 %outputs.numSims=ohandles.numSims;
 outputs.numRuns=ohandles.numRunsPerSim;
 outputs.numTimeSteps=ohandles.numTimeSteps;
 outputs.len_apps=ohandles.len_apps;
 outputs.len_serv=ohandles.len_serv;
 outputs.len_os=ohandles.len_os;
 outputs.len_dr=ohandles.len_dr;
 outputs.CD_apps=ohandles.CD_apps;
 outputs.CD_serv=ohandles.CD_serv;
 outputs.CD_os=ohandles.CD_os;
 outputs.CD_dr=ohandles.CD_dr;
 outputs.ChangeDesirabilitiesFlag=ohandles.ChangeDesirabilitiesFlag;
 outputs.tChange1=ohandles.tChange1;
 outputs.tChange2=ohandles.tChange2;
 outputs.CD_apps2=ohandles.CD_apps2;
 outputs.CD_serv2=ohandles.CD_serv2;
 outputs.CD_os2=ohandles.CD_os2;
 outputs.CD_dr2=ohandles.CD_dr2;
 outputs.ChangeIndDesirabilitiesFlag=ohandles.ChangeIndDesirabilitiesFlag;
 outputs.tChangeInd1=ohandles.tChangeInd1;
 outputs.tChangeInd2=ohandles.tChangeInd2;
 outputs.ID2=ohandles.ID2;
 outputs.ID_apps2=ohandles.ID_apps2;
 outputs.ID_serv2=ohandles.ID_serv2;
 outputs.ID_os2=ohandles.ID_os2;
 outputs.ID_dr2=ohandles.ID_dr2;
 outputs.E_apps=ohandles.E_apps;
 outputs.E_serv=ohandles.E_serv;
 outputs.E_os=ohandles.E_os;
 outputs.E_dr=ohandles.E_dr;
 outputs.ChangeEffFlag=ohandles.ChangeEffFlag;
 outputs.tChangeEff1=ohandles.tChangeEff1;
 outputs.tChangeEff2=ohandles.tChangeEff2;
 outputs.E_apps2=ohandles.E_apps2;
 outputs.E_serv2=ohandles.E_serv2;
 outputs.E_os2=ohandles.E_os2;
 outputs.E_dr2=ohandles.E_dr2;
 outputs.Genotype=ohandles.Genotype;
 outputs.Genotype_apps=ohandles.Genotype_apps;
 outputs.Genotype_serv=ohandles.Genotype_serv;
 outputs.Genotype_os=ohandles.Genotype_os;
 outputs.Genotype_dr=ohandles.Genotype_dr; 
 outputs.textdata=ohandles.textdata;
 outputs.ID=ohandles.ID;
 outputs.ID_apps=ohandles.ID_apps;
 outputs.ID_serv=ohandles.ID_serv;
 outputs.ID_os=ohandles.ID_os;
 outputs.ID_dr=ohandles.ID_dr;
 outputs.Nei_sol1=ohandles.Nei_sol1;
 outputs.Nei_sol2=ohandles.Nei_sol2;
 outputs.Nei_sol3=ohandles.Nei_sol3;
 outputs.Nei_sol4=ohandles.Nei_sol4;
 outputs.Nei_sol5=ohandles.Nei_sol5;
 outputs.nodesDiversity4=ohandles.nodesDiversity4;
 outputs.nodesMean4=ohandles.nodesMean4;
 outputs.nodesStd4=ohandles.nodesStd4;
 outputs.updateStopDisplay4=ohandles.updateStopDisplay4;
 outputs.nodesStd4=ohandles.nodesStd4;
 outputs.minstd4Tolerance=ohandles.minstd4Tolerance;
 outputs.maxstd4Tolerance=ohandles.maxstd4Tolerance;
 outputs.minStd4Curve=ohandles.minStd4Curve;
 outputs.updateStopDisplay5=ohandles.updateStopDisplay5;
 outputs.nodesStd5=ohandles.nodesStd5;
 outputs.minstd5Tolerance=ohandles.minstd5Tolerance;
 outputs.maxstd5Tolerance=ohandles.maxstd5Tolerance;
 outputs.minStd5Curve=ohandles.minStd5Curve;
 outputs.turnOnSol1=ohandles.turnOnSol1;
 outputs.turnOnSol2=ohandles.turnOnSol2;
 outputs.turnOnSol3=ohandles.turnOnSol3;
 outputs.turnOnSol4=ohandles.turnOnSol4;
 outputs.turnOnSol5=ohandles.turnOnSol5;
 
 %NEW OUTPUTS 
 outputs.lastStoppedStdMatrix=ohandles.lastStoppedStdMatrix;
 outputs.lastStoppedStdMatrix2=ohandles.lastStoppedStdMatrix2;
 outputs.stdMargin=ohandles.stdMargin;
 outputs.Nei_indDynamic=ohandles.Nei_indDynamic;
 outputs.singleStopMode = ohandles.singleStopMode;
 outputs.restartMode = ohandles.restartMode;
 outputs.ChangeOwnIndDesirabilitiesFlag = ohandles.ChangeOwnIndDesirabilitiesFlag;
 %Attack outputs
 outputs.numStates = ohandles.numStates;
 outputs.sumOfStates = ohandles.sumOfStates;
 outputs.vs_node = ohandles.vs_node;
 outputs.allRunsNodeStateAtTime = ohandles.allRunsNodeStateAtTime;
outputs.beta = ohandles.beta;
outputs.gammaSIR = ohandles.gammaSIR;
%added 31st March 2016
outputs.datasetStaticEnable =ohandles.datasetStaticEnable;
outputs.datasetStaticNumber =ohandles.datasetStaticNumber;

outputs.neiIndexSingleLocus_sol4 = ohandles.neiIndexSingleLocus_sol4;
outputs.neiIndexSingleLocus_sol5 = ohandles.neiIndexSingleLocus_sol5;
    
outputs.GenoSim_sol4 = ohandles.GenoSim_sol4;
outputs.GenoSim_sol5 = ohandles.GenoSim_sol5;
 % GenoSim_sol4 = zeros(numRunsPerSim,numTimeSteps,numNodes,numVariants); 
% disp('genotypeouts1node')
%outputsGenoSim_sol41(:,1:8) =outputs.GenoSim_sol4(1,1:400,1,1:8)
%outputsGenoSim_sol41(:,1:8) =outputs.GenoSim_sol4(1,1,1:10,1:8)
%outputsGenoSim_sol42(:,1:8) =outputs.GenoSim_sol4(1,1,1:10,1:8)
%outputsGenoSim_sol43(:,1:8) =outputs.GenoSim_sol4(1,2,1:10,1:8)
%outputsGenoSim_sol44(:,1:8) =outputs.GenoSim_sol4(1,3,1:10,1:8)
%outputsGenoSim_sol45(:,1:8) =outputs.GenoSim_sol4(1,4,1:10,1:8)
%outputsGenoSim_sol46(:,1:8) =outputs.GenoSim_sol4(1,5,1:10,1:8)
          