%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Jennifer Jackson 2017                                                        %
% A Biodiversity Approach to Cyber Security                                    %
% PhD Complexity Science                                                       %
% University of Warwick                                                        %
% http://wrap.warwick.ac.uk/98458                                              %
% This software is distributed under the  Creative Commons Attribution License %
% https://creativecommons.org/licenses/by/4.0/                                 %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function StaticDiversityBatchMode()
close all;
clear all;
runTests = ones(1,4) %(1,numTests total)
%runTests(1) = 1 % 0 means don't run that test
%runTests(2) = 0 % 0 means don't run that test
%directory = 'settings\staticDiversity\'
directory = 'settings\staticDiversity\' %PC directory

figh = DiversityModelGUI; %load program

%test settings files to run
%**************************
%Test 1
%**************************
if runTests(1) == 1
testFile(1).Filename = [directory 'Test1_0_02\settings'];
testFile(2).Filename = [directory 'Test1_0_04\settings'];
testFile(3).Filename= [directory 'Test1_0_06\settings'];
testFile(4).Filename = [directory 'Test1_0_08\settings'];
testFile(5).Filename = [directory 'Test1_0_1\settings'];

numTests = size(testFile,2)
%numTests = 2 %for overide

for testNumber = 1:numTests
    run1Instance(figh,testFile(testNumber).Filename)
end
end
%**************************
%Test 2
%**************************
if runTests(2) == 1
clear testFile
testFile(1).Filename = [directory 'Test2_\settings'];

numTests = size(testFile,2)
%numTests = 2 %for overide

for testNumber = 1:numTests
    run1Instance(figh,testFile(testNumber).Filename)
end
end

%**************************
%Test 3
%**************************
if runTests(3) == 1
clear testFile
testFile(1).Filename = [directory 'Test3_WBT_10\settings'];

numTests = size(testFile,2)
%numTests = 2 %for overide

for testNumber = 1:numTests
    run1Instance(figh,testFile(testNumber).Filename)
end
end


%**************************
%Test 4
%**************************
if runTests(4) == 1
clear testFile
testFile(1).Filename = [directory 'Test4_RWP_rr\settings'];

numTests = size(testFile,2)
%numTests = 2 %for overide

for testNumber = 1:numTests
    run1Instance(figh,testFile(testNumber).Filename)
end
end




%close program

end







%***************
%sub functions
%***************
function run1Instance(figh,testFile)
%***********************************
%Run 1 program simulation
%***********************************
DiversityModelGUI('LoadSettings_Callback',figh,[],guidata(figh))
%DiversityModelGUI('LoadSettings_Callback',fighdata.LoadSettings,[],guidata(figh))
fighdata = guidata(figh); %load main gui data
loadSettingsData = guidata(fighdata.loadSettingsFig); %load settings data
editLoadSettings=get(loadSettingsData.editLoadSettings,'String');
%set new settings file
editLoadSettings = testFile;
set(loadSettingsData.editLoadSettings,'String',editLoadSettings);
editLoadSettings=get(loadSettingsData.editLoadSettings,'String')%check
%OPEN SETTINGS FILE
%loadSettings('pushbuttonOpen_Callback',fighdata.loadSettingsFig,[],guidata(fighdata.loadSettingsFig))
loadSettings('pushbuttonOpen_Callback',loadSettingsData.pushbuttonOpen,[],guidata(fighdata.loadSettingsFig))
%RUN SIMULATION
numSimsHandles = fighdata.popupmenuNumSims;
%pushbuttonRunSimulations_Callback(hObject, eventdata, handles)
%hobject = pushbuttonRunSimulations: 332.0018
disp('batchmode pushbuttonrunSims')
fighdata.pushbuttonRunSimulations;
DiversityModelGUI('pushbuttonRunSimulations_Callback',fighdata.pushbuttonRunSimulations,[],fighdata)
end