%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Jennifer Jackson 2017                                                        %
% A Biodiversity Approach to Cyber Security                                    %
% PhD Complexity Science                                                       %
% University of Warwick                                                        %
% http://wrap.warwick.ac.uk/98458                                              %
% This software is distributed under the  Creative Commons Attribution License %
% https://creativecommons.org/licenses/by/4.0/                                 %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function  autosaveGraphs(directoryName, simName, outputs, fileSaveOption)          
%create and save seperate graphs
saveGraphs = 1;
closeAllGraphs = 1; % close graphs after saving
saveGraphsDirectoryName = directoryName;
numNodes=outputs.numNodes;
numSims=outputs.numRuns;
numRuns=outputs.numTimeSteps;
len_apps = outputs.len_apps;
len_serv = outputs.len_serv;
len_os = outputs.len_os;
len_dr = outputs.len_dr;
CD_apps = outputs.CD_apps;
CD_serv = outputs.CD_serv;
CD_os = outputs.CD_os;
CD_dr = outputs.CD_dr;
ChangeDesirabilitiesFlag = outputs.ChangeDesirabilitiesFlag;
tChange1 = outputs.tChange1;
tChange2 = outputs.tChange2;
CD_apps2 = outputs.CD_apps2;
CD_serv2 = outputs.CD_serv2;
CD_os2 = outputs.CD_os2;
CD_dr2 = outputs.CD_dr2;
E_apps = outputs.E_apps;
E_serv = outputs.E_serv;
E_os = outputs.E_os;
E_dr = outputs.E_dr;
ChangeEffFlag = outputs.ChangeEffFlag;
tChangeEff1 = outputs.tChangeEff1;
tChangeEff2 = outputs.tChangeEff2;
E_apps2 = outputs.E_apps2;
E_serv2 = outputs.E_serv2;
E_os2 = outputs.E_os2;
E_dr2 = outputs.E_dr2;
origGenotype = outputs.Genotype; 
textData = outputs.textdata; 
ID = outputs.ID; 
ID2 = outputs.ID2; 
ChangeIndDesirabilitiesFlag = outputs.ChangeIndDesirabilitiesFlag;
tChangeInd1 = outputs.tChangeInd1;
tChangeInd2 = outputs.tChangeInd2;
Nei_sol1 = outputs.Nei_sol1; 
Nei_sol2 = outputs.Nei_sol2; 
Nei_sol3 = outputs.Nei_sol3; 
Nei_sol4 = outputs.Nei_sol4; 
Nei_sol5 = outputs.Nei_sol5;
minstd4Tolerance = outputs.minstd4Tolerance; 
maxstd4Tolerance = outputs.maxstd4Tolerance;
minstd5Tolerance = outputs.minstd5Tolerance; 
maxstd5Tolerance = outputs.maxstd5Tolerance; 
turnOnSol1 = outputs.turnOnSol1; 
turnOnSol2 = outputs.turnOnSol2; 
turnOnSol3 = outputs.turnOnSol3; 
turnOnSol4 = outputs.turnOnSol4; 
turnOnSol5 = outputs.turnOnSol5;
stdMargin = outputs.stdMargin;

%seperate out multiple runs
nodesDiversity = outputs.nodesDiversity4;
nodesMean = outputs.nodesMean4; 
nodesStd = outputs.nodesStd4;
updateStopDisplay4 = outputs.updateStopDisplay4;
nodesStd4 = outputs.nodesStd4; 
minStd4Curve = outputs.minStd4Curve;               
updateStopDisplay5 = outputs.updateStopDisplay5; 
nodesStd5 = outputs.nodesStd5; 
minStd5Curve = outputs.minStd5Curve;
lastStoppedStdMatrix = outputs.lastStoppedStdMatrix;
lastStoppedStdMatrix2 = outputs.lastStoppedStdMatrix2;
Nei_indDynamic = outputs.Nei_indDynamic;
numStates = outputs.numStates;
sumOfStates = outputs.sumOfStates;
beta = outputs.beta;


%**************************
%added 31st March 2016
%check if plot for static diversity or the full set of graphs
%******************************
datasetStaticEnable = outputs.datasetStaticEnable
datasetStaticNumber = outputs.datasetStaticNumber

if or(datasetStaticEnable,fileSaveOption > 1)
    %only plot a few graphs
StaticDiversityClass.plotStatic(saveGraphs, closeAllGraphs, saveGraphsDirectoryName, simName, numNodes, numSims, numRuns, ...
               len_apps, len_serv, len_os, len_dr, ...
               Nei_sol1, Nei_sol2, Nei_sol3, Nei_sol4, Nei_sol5, ...
               turnOnSol1, turnOnSol2, turnOnSol3, turnOnSol4, turnOnSol5,...
               sumOfStates,beta)   
     
else
%plot all graphs as normal
[NeiAbsMax Nei_orig Nei_ind Nei_comm Nei_eff ] = ...
    plotOutput(saveGraphs, closeAllGraphs, saveGraphsDirectoryName, simName, numNodes, numSims, numRuns, ...
               len_apps, len_serv, len_os, len_dr, ...
               CD_apps,CD_serv,CD_os,CD_dr, ...
               ChangeDesirabilitiesFlag, tChange1, tChange2,CD_apps2,CD_serv2,CD_os2,CD_dr2, ...
               E_apps,E_serv,E_os,E_dr, ...
               ChangeEffFlag, tChangeEff1, tChangeEff2,E_apps2,E_serv2,E_os2,E_dr2, ...
               origGenotype, textData, ID, ...
               ChangeIndDesirabilitiesFlag, ID2, tChangeInd1, tChangeInd2, ...
               Nei_sol1, Nei_sol2, Nei_sol3, Nei_sol4, Nei_sol5, ...
               nodesDiversity,nodesMean, nodesStd, ...
               updateStopDisplay4, nodesStd4, minstd4Tolerance, maxstd4Tolerance, minStd4Curve, ...
               updateStopDisplay5, nodesStd5, minstd5Tolerance, maxstd5Tolerance, minStd5Curve, ...
               turnOnSol1, turnOnSol2, turnOnSol3, turnOnSol4, turnOnSol5,...
               lastStoppedStdMatrix,lastStoppedStdMatrix2,stdMargin,Nei_indDynamic,...
               numStates,sumOfStates)
end
           