%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Jennifer Jackson 2017                                                        %
% A Biodiversity Approach to Cyber Security                                    %
% PhD Complexity Science                                                       %
% University of Warwick                                                        %
% http://wrap.warwick.ac.uk/98458                                              %
% This software is distributed under the  Creative Commons Attribution License %
% https://creativecommons.org/licenses/by/4.0/                                 %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function batchMode()
close all;
clear all;
%test settings files to run
%**************************
%Test 1
%**************************
directory = 'settings\'
testFile(1,:) = [directory 'staticTest1'];
testFile(2,:) = [directory 'staticTest1'];

numTests = 2

figh = DiversityModelGUI; %load program

for testNumber = 1:numTests
    run1Instance(figh,testFile(testNumber,:))
end
%close program

end


%***************
%sub functions
%***************
function run1Instance(figh,testFile)
%***********************************
%Run 1 program simulation
%***********************************
DiversityModelGUI('LoadSettings_Callback',figh,[],guidata(figh))
%DiversityModelGUI('LoadSettings_Callback',fighdata.LoadSettings,[],guidata(figh))
fighdata = guidata(figh); %load main gui data
loadSettingsData = guidata(fighdata.loadSettingsFig); %load settings data
editLoadSettings=get(loadSettingsData.editLoadSettings,'String');
%set new settings file
editLoadSettings = testFile;
set(loadSettingsData.editLoadSettings,'String',editLoadSettings);
editLoadSettings=get(loadSettingsData.editLoadSettings,'String')%check
%OPEN SETTINGS FILE
%loadSettings('pushbuttonOpen_Callback',fighdata.loadSettingsFig,[],guidata(fighdata.loadSettingsFig))
loadSettings('pushbuttonOpen_Callback',loadSettingsData.pushbuttonOpen,[],guidata(fighdata.loadSettingsFig))
%RUN SIMULATION
numSimsHandles = fighdata.popupmenuNumSims;
%pushbuttonRunSimulations_Callback(hObject, eventdata, handles)
%hobject = pushbuttonRunSimulations: 332.0018
disp('batchmode pushbuttonrunSims')
fighdata.pushbuttonRunSimulations;
DiversityModelGUI('pushbuttonRunSimulations_Callback',fighdata.pushbuttonRunSimulations,[],fighdata)
end