%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Jennifer Jackson 2017                                                        %
% A Biodiversity Approach to Cyber Security                                    %
% PhD Complexity Science                                                       %
% University of Warwick                                                        %
% http://wrap.warwick.ac.uk/98458                                              %
% This software is distributed under the  Creative Commons Attribution License %
% https://creativecommons.org/licenses/by/4.0/                                 %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function Nei = communityDiversity(CD_apps,CD_serv,CD_os,CD_dr)
%This function measures the diversity of the community scale
%desirabilities

%TEST INPUTS
%community desirability ratings (1 to 100) (1)least desirable (100)most
%desirable
%CD_apps = [25 40 10 5 10 5 3 2];
%CD_serv = [70 5 3 2 5 5 5 5];
%CD_os = [80 20];
%CD_dr = [50 20 5 5 10 5 3 2];
%CD_apps = [90 2 1 1 1 1 1 3];
%CD_serv = [90 2 1 1 1 1 1 3];
%CD_os = [94 6];
%CD_dr = [90 2 1 1 1 1 1 3];
%CD_apps = [100 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0];
%CD_serv = [100 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0];
%CD_os = [100 0 0 0 0 0 0 0 0 0];
%CD_dr = [100 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0];

%MAIN CODE

%algorithm
%work out the frequencies of each
freqvarApps = CD_apps./100;
freqvarServ = CD_serv./100;
freqvarOS = CD_os./100;
freqvarDr = CD_dr./100;

%determine (h) heterozygosity = 1-sum(freq.^2)
hApps = 1 - sum(freqvarApps.^2);
hServ = 1 - sum(freqvarServ.^2);
hOS = 1 - sum(freqvarOS.^2);
hDr = 1 - sum(freqvarDr.^2);

%determine Nei genetic diversity index sum(h)/number of loci
Nei = (hApps + hServ + hOS + hDr)/4;
