%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Jennifer Jackson 2017                                                        %
% A Biodiversity Approach to Cyber Security                                    %
% PhD Complexity Science                                                       %
% University of Warwick                                                        %
% http://wrap.warwick.ac.uk/98458                                              %
% This software is distributed under the  Creative Commons Attribution License %
% https://creativecommons.org/licenses/by/4.0/                                 %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function displayAttackGraph(outputs,handles)

graphType = get(handles.popupmenuAttackGraphType,'Value');

dataSize = size(outputs.sumOfStates) %size of data

colourPlot = {'b' 'r' 'g' 'c' 'r--' 'm' 'k' 'y'}

numRuns = dataSize(1)
numStates = dataSize(2)
numTimeSteps = dataSize(3)

%release graph from previous data to refresh plot
hold(handles.axesAttackGraph,'off') 
%graphs
switch (graphType)
    case 1 %Number per state
        for psim = 1:numRuns %for each run
            for stateNumber = 1:numStates %for each state
            %plot solution 4 only
             %b(1,:) = a(1,1,:)this code works
            plotStates(1,:) = outputs.sumOfStates(psim,stateNumber,:);
            plot(handles.axesAttackGraph,plotStates,char(colourPlot(stateNumber)))
            hold(handles.axesAttackGraph,'on'); 
            end
        end
end

        xlabel(handles.axesAttackGraph,'Number of Time Steps')
        ylabel(handles.axesAttackGraph,'Number of Nodes')
        hold(handles.axesAttackGraph,'on'); 
        %legend
            if numStates == 2
                legend(handles.axesAttackGraph,'Susceptibles','Infected')
            elseif numStates ==3
                legend(handles.axesAttackGraph,'Susceptibles','Infected','Recovered')
            elseif numStates == 4
                legend(handles.axesAttackGraph,'Susceptibles','Exposed','Infected','Recovered')
            else
                legend(handles.axesAttackGraph,'Susceptibles','Exposed','Prevented','Treated','Infected','Contained','Offline','eXposed off-line')
            end
            hold(handles.axesAttackGraph,'on'); 


end %end func

