%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Jennifer Jackson 2017                                                        %
% A Biodiversity Approach to Cyber Security                                    %
% PhD Complexity Science                                                       %
% University of Warwick                                                        %
% http://wrap.warwick.ac.uk/98458                                              %
% This software is distributed under the  Creative Commons Attribution License %
% https://creativecommons.org/licenses/by/4.0/                                 %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function [encounterYes,nodesEncountered] = getNearestNode(nodes,range,mode)
%UNTITLED Summary of this function goes here
%   Detailed explanation goes here
%nodes.x = [4 6 2 1 8];
%nodes.y = [1 2 3 4 5]
%range = 4 % in metres
[nodesInRange,numNodesInRange,nodesInRangeFlag,nearestNodes,randomNodes] = getNodesInRange(nodes,range)

%At the moment just encounter a node if meets range criteria
%In the future need to check to see how long has been in range for 
%because will also nee to meet time criteria
mode =2;
[encounterYes,nodesEncountered] = getNodesEncounter(mode,nodesInRange,numNodesInRange,nodesInRangeFlag,nearestNodes,randomNodes);

end


function [encounterYes,nodesEncountered] = getNodesEncounter(mode,nodesInRange,numNodesInRange,nodesInRangeFlag,nearestNodes,randomNodes)
%choose selection process
if mode == 1
    %choose nearest node if in range
    encounterYes = nodesInRangeFlag;
    nodesEncountered = nearestNodes.*nodesInRangeFlag;
else
    %choose random nearest node if more than 1 in range
    encounterYes = nodesInRangeFlag;
    nodesEncountered = randomNodes.*nodesInRangeFlag;
end
end

function [nodesInRange,numNodesInRange,nodesInRangeFlag,nearestNodes,randomNodes] = getNodesInRange(nodes, range)
% square of distance
% xdiff=|x2-x1|
% ydiff=|y2-y1|
% (xdiff)^2 + (ydiff)^2

lenx = size(nodes.x,2);
sqrDistance = zeros(lenx,lenx);
for a = 1:lenx
b=a+1;
c=a-1;
%x
xShifted(1:lenx-a) = nodes.x(b:end);
xShifted(lenx-c:lenx) = nodes.x(1:a);
xdiff = xShifted-nodes.x;
xsq = xdiff.^2;
%y
yShifted(1:lenx-a) = nodes.y(b:end);
yShifted(lenx-c:lenx) = nodes.y(1:a);
ydiff = yShifted-nodes.y;
ysq = ydiff.^2;
%square of distance
sqrDistance(a,:) = xsq+ysq;
end
sqrDistanceD=sqrDistance %Test Display
%All nodes in range
nodesInRange = sqrDistance(:,:)<=range; %before self
nodesInRange(end,:) = 0; %exclude self
numNodesInRange = sum(nodesInRange);
nodesInRangeFlag = numNodesInRange>=1;
%Get nearest node
[nearestNodesValue, nearestNodesIndex] = min(sqrDistance(1:end-1,:));
%need to get in correct format
nearestNodes = formatNodesIndex(nearestNodesIndex,lenx);

%for a= 1:lenx
%    index(a) = nearestNodesIndex(a)+a;
%    if index(a) > lenx
%        index(a) = rem(index(a),lenx);
%    end
%end
% nearestNodes = index

%Choose a random node in range
randomNumberMatrix = rand(lenx,lenx);
MaskedRandomNumberMatrix = randomNumberMatrix.*nodesInRange;
[randomNodesValue,randomNodesIndex] = max(MaskedRandomNumberMatrix);
%need to get in correct format
randomNodes = formatNodesIndex(randomNodesIndex,lenx);

end

function nearestNodes = formatNodesIndex(nearestNodesIndex,lenx)
for a= 1:lenx
    index(a) = nearestNodesIndex(a)+a;
    if index(a) > lenx
        index(a) = rem(index(a),lenx);
    end
end
 nearestNodes = index;
end

