%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Jennifer Jackson 2017                                                        %
% A Biodiversity Approach to Cyber Security                                    %
% PhD Complexity Science                                                       %
% University of Warwick                                                        %
% http://wrap.warwick.ac.uk/98458                                              %
% This software is distributed under the  Creative Commons Attribution License %
% https://creativecommons.org/licenses/by/4.0/                                 %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%********************************************************************
%Dynamic Desirabilities File
%desirabilities for the community level
%********************************************************************
%1. FORMAT
%set matrix size: weights = zeros(numNodes,numChanges,numValues + 1)
%                           
%*********************************************************************
%2. SET VALUES:

%example to set individual node:
%weights(2,:,:) = [10 0.2 0.25; 20 0.25 0.32]
%node 2 set for time1 = 10, value1 = 0.2, value2 = 0.25

%example to copy node values:
% divWeights(3:4,:,:) = divWeights(1:2,:,:)

%example to set multiple nodes the same value using repmat:
%B = repmat(A,[m n p...]) produces a multidimensional array B composed of 
%copies of A. The size of B is [size(A,1)*m, size(A,2)*n, size(A,3)*p, ...].
% c = zeros(1,2,2) - set up 1 node
% c(1,:,:) = [10 0.2; 20 0.25] - set value
% d = repmat(c,[5,1,1]) - extend to all 5 nodes
%************************************************************************

function qualDes = getQualDes(numNodes,caseNo,desFile)
switch caseNo
    case 1
        %get values from file
        directorynameDesirabilities = GUIClass.getDirectoryNameDesirabilities();
        fileName = [directorynameDesirabilities desFile];
        qualDes = DynAlgClass.getWeightsFromFile(fileName,numNodes);
    otherwise
        %get values from function
        numChanges = 2;
        len_sw = 26;
        qualDes = zeros(numNodes,numChanges,len_sw+1);

end
end

