%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Jennifer Jackson 2017                                                        %
% A Biodiversity Approach to Cyber Security                                    %
% PhD Complexity Science                                                       %
% University of Warwick                                                        %
% http://wrap.warwick.ac.uk/98458                                              %
% This software is distributed under the  Creative Commons Attribution License %
% https://creativecommons.org/licenses/by/4.0/                                 %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function outputs = loadOutputs1SimBinary(fid)

outputs.numNodes = fread(fid,1,'double');
outputs.numRuns = fread(fid,1,'double');
outputs.numTimeSteps = fread(fid,1,'double');
outputs.len_apps = fread(fid,1,'double');
outputs.len_serv = fread(fid,1,'double');
outputs.len_os = fread(fid,1,'double');
outputs.len_dr = fread(fid,1,'double');
outputs.CD_apps = fread(fid,[1,outputs.len_apps],'double');
outputs.CD_serv = fread(fid,[1,outputs.len_serv],'double');
outputs.CD_os = fread(fid,[1,outputs.len_os],'double');
outputs.CD_dr = fread(fid,[1,outputs.len_dr],'double');
outputs.ChangeDesirabilitiesFlag = fread(fid,1,'double');
outputs.tChange1 = fread(fid,1,'double');
outputs.tChange2 = fread(fid,1,'double');
outputs.CD_apps2 = fread(fid,[1,outputs.len_apps],'double');
outputs.CD_serv2 = fread(fid,[1,outputs.len_serv],'double');
outputs.CD_os2 = fread(fid,[1,outputs.len_os],'double');
outputs.CD_dr2 = fread(fid,[1,outputs.len_dr],'double');
outputs.E_apps = fread(fid,[1,outputs.len_apps],'double');
outputs.E_serv = fread(fid,[1,outputs.len_serv],'double');
outputs.E_os = fread(fid,[1,outputs.len_os],'double');
outputs.E_dr = fread(fid,[1,outputs.len_dr],'double');
%new code added 27th Nov 2014
outputs.ChangeEffFlag = fread(fid,1,'double');
outputs.tChangeEff1 = fread(fid,1,'double');
outputs.tChangeEff2 = fread(fid,1,'double');
outputs.E_apps2 = fread(fid,[1,outputs.len_apps],'double');
outputs.E_serv2 = fread(fid,[1,outputs.len_serv],'double');
outputs.E_os2 = fread(fid,[1,outputs.len_os],'double');
outputs.E_dr2 = fread(fid,[1,outputs.len_dr],'double');
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
outputs.Genotype_apps = fread(fid,[outputs.numNodes,outputs.len_apps],'double');
outputs.Genotype_serv = fread(fid,[outputs.numNodes,outputs.len_serv],'double');
outputs.Genotype_os = fread(fid,[outputs.numNodes,outputs.len_os],'double');
outputs.Genotype_dr = fread(fid,[outputs.numNodes,outputs.len_dr],'double');
rowstextdata = outputs.len_apps + outputs.len_serv + outputs.len_os + outputs.len_dr;
outputs.textdata = fread(fid,[rowstextdata,2],'*char');
outputs.ID_apps = fread(fid,[outputs.numNodes,outputs.len_apps],'double');
outputs.ID_serv = fread(fid,[outputs.numNodes,outputs.len_serv],'double');
outputs.ID_os = fread(fid,[outputs.numNodes,outputs.len_os],'double');
outputs.ID_dr = fread(fid,[outputs.numNodes,outputs.len_dr],'double');
outputs.ID = [outputs.ID_apps outputs.ID_serv outputs.ID_os outputs.ID_dr]';
%new code added 27th Nov 2014
outputs.ChangeIndDesirabilitiesFlag = fread(fid,1,'double');
outputs.tChangeInd1 = fread(fid,1,'double');
outputs.tChangeInd2 = fread(fid,1,'double');
outputs.ID_apps2 = fread(fid,[outputs.numNodes,outputs.len_apps],'double');
outputs.ID_serv2 = fread(fid,[outputs.numNodes,outputs.len_serv],'double');
outputs.ID_os2 = fread(fid,[outputs.numNodes,outputs.len_os],'double');
outputs.ID_dr2 = fread(fid,[outputs.numNodes,outputs.len_dr],'double');
outputs.ID2 = [outputs.ID_apps2 outputs.ID_serv2 outputs.ID_os2 outputs.ID_dr2]';
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%outputs.Nei_sol1 = fread(fid,[outputs.numRuns,outputs.numTimeSteps],'double');
%outputs.Nei_sol2 = fread(fid,[outputs.numRuns,outputs.numTimeSteps],'double');
%outputs.Nei_sol3 = fread(fid,[outputs.numRuns,outputs.numTimeSteps],'double');
outputs.Nei_sol4 = fread(fid,[outputs.numRuns,outputs.numTimeSteps],'double');
outputs.Nei_sol5 = fread(fid,[outputs.numRuns,outputs.numTimeSteps],'double');
%outputs.nodesDiversity4 = fread(fid,[outputs.numNodes,outputs.numTimeSteps+1],'double');
%outputs.nodesMean4 = fread(fid,[outputs.numNodes,outputs.numTimeSteps+1],'double');
%outputs.nodesStd4 = fread(fid,[outputs.numNodes,outputs.numTimeSteps+1],'double');
%outputs.updateStopDisplay4 = fread(fid,[outputs.numTimeSteps,outputs.numNodes],'double');

%fread only works on a 2 dimensional array so have to read as a single and then reshape
a = fread(fid,outputs.numRuns*outputs.numNodes*(outputs.numTimeSteps+1), '*double');
outputs.nodesDiversity4 = reshape(a,[outputs.numRuns,outputs.numNodes,outputs.numTimeSteps+1]);
a = fread(fid,outputs.numRuns*outputs.numNodes*(outputs.numTimeSteps+1), '*double');
outputs.nodesMean4 = reshape(a,[outputs.numRuns,outputs.numNodes,outputs.numTimeSteps+1]);
a = fread(fid,outputs.numRuns*outputs.numNodes*(outputs.numTimeSteps+1), '*double');
outputs.nodesStd4 = reshape(a,[outputs.numRuns,outputs.numNodes,outputs.numTimeSteps+1]);
a = fread(fid,outputs.numRuns*outputs.numTimeSteps*outputs.numNodes, '*double');
outputs.updateStopDisplay4 = reshape(a,[outputs.numRuns,outputs.numTimeSteps,outputs.numNodes]);

outputs.minstd4Tolerance = fread(fid,1,'double');
outputs.maxstd4Tolerance = fread(fid,1,'double');
%outputs.minStd4Curve = fread(fid,[outputs.numNodes,1],'double');
%outputs.updateStopDisplay5 = fread(fid,[outputs.numTimeSteps,outputs.numNodes],'double');
%outputs.nodesStd5 = fread(fid,[outputs.numNodes,outputs.numTimeSteps+1],'double');

a = fread(fid,outputs.numRuns*outputs.numNodes*1, '*double');
outputs.minStd4Curve = reshape(a,[outputs.numRuns,outputs.numNodes,1]);
a = fread(fid,outputs.numRuns*outputs.numTimeSteps*outputs.numNodes, '*double');
outputs.updateStopDisplay5 = reshape(a,[outputs.numRuns,outputs.numTimeSteps,outputs.numNodes]);
a = fread(fid,outputs.numRuns*outputs.numNodes*(outputs.numTimeSteps+1), '*double');
outputs.nodesStd5 = reshape(a,[outputs.numRuns,outputs.numNodes,outputs.numTimeSteps+1]);

outputs.minstd5Tolerance = fread(fid,1,'double');
outputs.maxstd5Tolerance = fread(fid,1,'double');

%outputs.minStd5Curve = fread(fid,[outputs.numNodes,1],'double');
a = fread(fid,outputs.numRuns*outputs.numNodes*1, '*double');
outputs.minStd5Curve = reshape(a,[outputs.numRuns,outputs.numNodes,1]);

outputs.turnOnSol1 = fread(fid,1,'double');
outputs.turnOnSol2 = fread(fid,1,'double');
outputs.turnOnSol3 = fread(fid,1,'double');
outputs.turnOnSol4 = fread(fid,1,'double');
outputs.turnOnSol5 = fread(fid,1,'double');
%New code added 4th Dec
outputs.stdMargin = fread(fid,1,'double');
%outputs.lastStoppedStdMatrix = fread(fid,[outputs.numTimeSteps,outputs.numNodes],'double');
%outputs.lastStoppedStdMatrix2 = fread(fid,[outputs.numTimeSteps,outputs.numNodes],'double');
%outputs.Nei_indDynamic = fread(fid,[1,outputs.numTimeSteps],'double');
a = fread(fid,outputs.numRuns*outputs.numTimeSteps*outputs.numNodes, '*double');
outputs.lastStoppedStdMatrix = reshape(a,[outputs.numRuns,outputs.numTimeSteps,outputs.numNodes]);
a = fread(fid,outputs.numRuns*outputs.numTimeSteps*outputs.numNodes, '*double');
outputs.lastStoppedStdMatrix2 = reshape(a,[outputs.numRuns,outputs.numTimeSteps,outputs.numNodes]);
a = fread(fid,outputs.numRuns*1*outputs.numTimeSteps, '*double');
outputs.Nei_indDynamic = reshape(a,[outputs.numRuns,1,outputs.numTimeSteps]);
outputs.singleStopMode = fread(fid,1,'double');
outputs.restartMode = fread(fid,1,'double');
outputs.ChangeOwnIndDesirabilitiesFlag = fread(fid,1,'double');
%added sept 2015
outputs.datasetEnable = fread(fid,1,'double');
outputs.datasetNumber = fread(fid,1,'double');
outputs.datasetStaticEnable = fread(fid,1,'double');
outputs.datasetStaticNumber = fread(fid,1,'double');
outputs.networkModelEnable = fread(fid,1,'double');
outputs.networkModelV = fread(fid,1,'double');

outputsnumNodes =outputs.numNodes
outputsnumRuns =outputs.numRuns
outputsnumTimeSteps = outputs.numTimeSteps
outputslen_apps = outputs.len_apps
outputslen_serv = outputs.len_serv
outputslen_os = outputs.len_os
outputslen_dr = outputs.len_dr
outputsCD_apps = outputs.CD_apps
outputsCD_serv = outputs.CD_serv
outputsCD_os = outputs.CD_os
outputsCD_dr = outputs.CD_dr
outputsChangeDesirabilitiesFlag = outputs.ChangeDesirabilitiesFlag
outputstChange1 = outputs.tChange1
outputsE_os2 = outputs.E_os2
outputsE_dr2 = outputs.E_dr2
outputsGenotype_apps = outputs.Genotype_apps
outputstextdata = outputs.textdata
outputsID_apps = outputs.ID_apps
%outputsNei_sol4 = outputs.Nei_sol4
outputsnodesDiversity4size = size(outputs.nodesDiversity4)
outputs
%outputsminStd5Curve = outputs.minStd5Curve
%outputsturnOnSol1 = outputs.turnOnSol1
%outputsturnOnSol2 = outputs.turnOnSol2
%outputsturnOnSol3 = outputs.turnOnSol3
%outputsturnOnSol4 = outputs.turnOnSol4
%outputsturnOnSol5 = outputs.turnOnSol5
%outputsstdMargin=outputs.stdMargin
%sizelaststopped = size(outputs.lastStoppedStdMatrix)
%sizelaststopped2 = size(outputs.lastStoppedStdMatrix2)
%outputslastStoppedStdMatrix=outputs.lastStoppedStdMatrix
%outputslastStoppedStdMatrix2 =outputs.lastStoppedStdMatrix2 
%outputsNei_indDynamic=outputs.Nei_indDynamic %THIS NOT SAVED PROPERLY FOR STATIC DIVERSITY

%outputssingleStopMode=outputs.singleStopMode
%outputsChangeOwnIndDesirabilitiesFlag =outputs.ChangeOwnIndDesirabilitiesFlag
%outputsdatasetEnable=outputs.datasetEnable
%outputsdatasetNumber = outputs.datasetNumber
%outputsdatasetStaticEnable = outputs.datasetStaticEnable
%outputsdatasetStaticNumber = outputs.datasetStaticNumber
%outputsnetworkModelEnable = outputs.networkModelEnable
%outputsnetworkModelV = outputs.networkModelV

outputs.networkModelS = GUIClass.getNetworkModelString(outputs.networkModelV);

%Testing
%outputsnumNodes =outputs.numNodes
%outputsnumRuns =outputs.numRuns
%outputsnumTimeSteps = outputs.numTimeSteps
%outputslen_apps = outputs.len_apps
%outputslen_serv = outputs.len_serv
%outputslen_os = outputs.len_os
%outputslen_dr = outputs.len_dr
%outputsCD_apps = outputs.CD_apps
%outputsCD_serv = outputs.CD_serv
%outputsCD_os = outputs.CD_os
%outputsCD_dr = outputs.CD_dr
%outputsChangeDesirabilitiesFlag = outputs.ChangeDesirabilitiesFlag
%outputstChange1 = outputs.tChange1
%outputsE_os2 = outputs.E_os2
%outputsE_dr2 = outputs.E_dr2
%outputsGenotype_apps = outputs.Genotype_apps
%outputstextdata = outputs.textdata
%outputsID_apps = outputs.ID_apps
%outputsNei_sol4 = outputs.Nei_sol4
%outputsnodesDiversity4 = outputs.nodesDiversity4
%outputsminStd5Curve = outputs.minStd5Curve
%outputsturnOnSol1 = outputs.turnOnSol1
%outputsturnOnSol2 = outputs.turnOnSol2
%outputsturnOnSol3 = outputs.turnOnSol3
%outputsturnOnSol4 = outputs.turnOnSol4
%outputsturnOnSol5 = outputs.turnOnSol5
%outputsstdMargin=outputs.stdMargin
%sizelaststopped = size(outputs.lastStoppedStdMatrix)
%sizelaststopped2 = size(outputs.lastStoppedStdMatrix2)
%outputslastStoppedStdMatrix=outputs.lastStoppedStdMatrix
%outputslastStoppedStdMatrix2 =outputs.lastStoppedStdMatrix2 
%outputsNei_indDynamic=outputs.Nei_indDynamic %THIS NOT SAVED PROPERLY FOR STATIC DIVERSITY
%outputssingleStopMode=outputs.singleStopMode
%outputsChangeOwnIndDesirabilitiesFlag =outputs.ChangeOwnIndDesirabilitiesFlag
%outputsdatasetEnable=outputs.datasetEnable
%outputsdatasetNumber = outputs.datasetNumber
%outputsdatasetStaticEnable = outputs.datasetStaticEnable
%outputsdatasetStaticNumber = outputs.datasetStaticNumber
%outputsnetworkModelEnable = outputs.networkModelEnable
%outputsnetworkModelV = outputs.networkModelV

outputs.attackModelEnable = fread(fid,1,'double');
outputs.attackModelV = fread(fid,1,'double');
outputs.attackModelS = GUIClass.getAttackModelString(outputs.attackModelV);
outputs.exploitEnable= fread(fid,1,'double');
outputs.exploitTypeV= fread(fid,1,'double');
outputs.exploitTypeS = GUIClass.getExploitModelString(outputs.exploitTypeV);
outputs.algModelEnable = fread(fid,1,'double');
outputs.algModelV = fread(fid,1,'double');
outputs.algModelS = GUIClass.getAlgModelString(outputs.algModelV);
outputs.networkPerfEnable = fread(fid,1,'double');
outputs.perfModelV = fread(fid,1,'double');
outputs.perfModelS = GUIClass.getPerfModelString(outputs.perfModelV);

%random waypoint animation
if and(outputs.networkModelEnable,strcmp(outputs.networkModelS,'Random Waypoint'))
  %x and y waypoints
for nodeIndex = 1:outputs.numNodes  
   temp1.vs_node(nodeIndex).v_x = fread(fid,[outputs.numTimeSteps],'double');
   temp1.vs_node(nodeIndex).v_y = fread(fid,[outputs.numTimeSteps],'double');
   %get in correct orientation
   outputs.vs_node(nodeIndex).v_x = temp1.vs_node(nodeIndex).v_x';
   outputs.vs_node(nodeIndex).v_y = temp1.vs_node(nodeIndex).v_y'; 
end  
end %if enable

%attack model
if outputs.attackModelEnable == 1
%numStates first
outputs.numStates = fread(fid,1,'double');
%disp('load outputs file')
%datasetEnable=    outputs.datasetEnable
%datasetNumber=outputs.datasetNumber
%networkModelEnable=outputs.networkModelEnable
%networkModelV=outputs.networkModelV
%attackModelEnable=outputs.attackModelEnable
%attackModelV=outputs.attackModelV
%exploitEnable=outputs.exploitEnable
%exploitTypeV=outputs.exploitTypeV
%algModelEnable=outputs.algModelEnable
%algModelV=outputs.algModelV
%networkPerfEnable=outputs.networkPerfEnable
%perfModelV=outputs.perfModelV
%numStates = outputs.numStates
%sumOfStates rhandles.sumOfStates =  zeros(rhandles.numStates,ihandles.numTimeSteps);
a = fread(fid,outputs.numRuns*outputs.numStates*outputs.numTimeSteps, '*double');
outputs.sumOfStates = reshape(a,[outputs.numRuns,outputs.numStates,outputs.numTimeSteps]);
%outputs.allRunsNodeStateAtTime
for runNumber = 1:outputs.numRuns
    for t = 1:outputs.numTimeSteps
      temp5 = fread(fid,[outputs.numNodes,1],'*char'); %structure;
      temp3.nodeStateAtTimeStr(t,:) = cellstr(temp5);
    end
    outputs.allRunsNodeStateAtTime(runNumber).nodeStateAtTimeStr =temp3.nodeStateAtTimeStr;
end
for runNumber = 1:outputs.numRuns
    temp6.nodeStateAtTimeNumber = fread(fid,[outputs.numTimeSteps,outputs.numNodes],'double') ;
    outputs.allRunsNodeStateAtTime(runNumber).nodeStateAtTimeNumber =temp6.nodeStateAtTimeNumber;
end
end %if enable

%added 31st March 2016
%SingleLocus_sol4 = zeros(numRunsPerSim,numTimeSteps,numLoci);
%SingleLocus_sol5 = zeros(numRunsPerSim,numTimeSteps,numLoci);
disp('load outputs file num loci set')
numLoci = 4
for runNumber = 1:outputs.numRuns
    SingleLocus_sol4Temp = fread(fid,[outputs.numTimeSteps,numLoci],'double');
    outputs.neiIndexSingleLocus_sol4(runNumber,:,:) = SingleLocus_sol4Temp;
end
for runNumber = 1:outputs.numRuns
    SingleLocus_sol5Temp = fread(fid,[outputs.numTimeSteps,numLoci],'double');
    outputs.neiIndexSingleLocus_sol5(runNumber,:,:) = SingleLocus_sol5Temp;
end
%GenoSim_sol4 = zeros(numRunsPerSim,numTimeSteps,numNodes,numVariants); 
%GenoSim_sol5 = zeros(numRunsPerSim,numTimeSteps,numNodes,numVariants);
numVariants = outputs.len_apps + outputs.len_serv + outputs.len_os + outputs.len_dr ;
for runNumber = 1:outputs.numRuns
    for nodeNumber = 1:outputs.numNodes
       genoTemp4 = fread(fid,[outputs.numTimeSteps,numVariants],'double');
        outputs.GenoSim_sol4(runNumber,:,nodeNumber,:) = genoTemp4;
    end
end
for runNumber = 1:outputs.numRuns
    for nodeNumber = 1:outputs.numNodes
       genoTemp5 = fread(fid,[outputs.numTimeSteps,numVariants],'double');
        outputs.GenoSim_sol5(runNumber,:,nodeNumber,:) = genoTemp5;
    end
end

%ohandles.beta = zeros(ihandles.numRunsPerSim,ihandles.numTimeSteps);
outputs.beta = fread(fid,[outputs.numRuns,outputs.numTimeSteps],'double');
%outputsbeta = outputs.beta
return
