%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Jennifer Jackson 2017                                                        %
% A Biodiversity Approach to Cyber Security                                    %
% PhD Complexity Science                                                       %
% University of Warwick                                                        %
% http://wrap.warwick.ac.uk/98458                                              %
% This software is distributed under the  Creative Commons Attribution License %
% https://creativecommons.org/licenses/by/4.0/                                 %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function varargout = loadSettings(varargin)
% LOADSETTINGS MATLAB code for loadSettings.fig
%      LOADSETTINGS, by itself, creates a new LOADSETTINGS or raises the existing
%      singleton*.
%
%      H = LOADSETTINGS returns the handle to a new LOADSETTINGS or the handle to
%      the existing singleton*.
%
%      LOADSETTINGS('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in LOADSETTINGS.M with the given input arguments.
%
%      LOADSETTINGS('Property','Value',...) creates a new LOADSETTINGS or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before loadSettings_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to loadSettings_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help loadSettings

% Last Modified by GUIDE v2.5 23-Mar-2015 10:36:40

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @loadSettings_OpeningFcn, ...
                   'gui_OutputFcn',  @loadSettings_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before loadSettings is made visible.
function loadSettings_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to loadSettings (see VARARGIN)

% Choose default command line output for loadSettings
handles.output = hObject;
%varargin
handles.main = varargin{1} %save handles from main figure

%set open file type default as multiple files
set(handles.radiobuttonOpenSet1File, 'Value', 0)
set(handles.radiobuttonOpenSetMultipleFiles, 'Value', 1)

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes loadSettings wait for user response (see UIRESUME)
% uiwait(handles.figureLoadSettings);


% --- Outputs from this function are returned to the command line.
function varargout = loadSettings_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;



function editLoadSettings_Callback(hObject, eventdata, handles)
% hObject    handle to editLoadSettings (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of editLoadSettings as text
%        str2double(get(hObject,'String')) returns contents of editLoadSettings as a double
editLoadSettings=get(hObject,'String');
%save to structure
set(handles.editLoadSettings,'String',editLoadSettings);
% save the changes to the structure
guidata(gcbo,handles);

% --- Executes during object creation, after setting all properties.
function editLoadSettings_CreateFcn(hObject, eventdata, handles)
% hObject    handle to editLoadSettings (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in pushbuttonOpen.
function pushbuttonOpen_Callback(hObject, eventdata, handles)
% hObject    handle to pushbuttonOpen (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

%names of settings temp files
directorynameSettings = GUIClass.getDirectoryNameSettings();
settingsTempFileNames = GUIClass.genSettingsTempFileNames(directorynameSettings,GUIClass.getMaxNumSims());

%*************************
%find currently selected button 
rb1=get(handles.radiobuttonOpenSet1File,'Value');
rb2=get(handles.radiobuttonOpenSetMultipleFiles,'Value');
%get filename of settings file
editLoadSettings=get(handles.editLoadSettings,'String');


if rb1 == 1
    %open as single file
    disp('single files no longer supported')
elseif rb2==1
    %open as multiple files
    %count files
    numFiles = GUIClass.countSettingsFiles(editLoadSettings)
    %gen file names
    settingsLoadFileNames = GUIClass.genSettingsSaveAsFileNames(editLoadSettings,numFiles);
    %copy settings files to temp directory location
    for simNumber = 1:numFiles
        copyfile(char(settingsLoadFileNames(simNumber)),char(settingsTempFileNames(simNumber)));  
    end
    %set list of available simulations
    set(handles.main.popupmenuNumSims, 'Value', numFiles);
    popupmenuList = GUIClass.genSimList(numFiles);
    set(handles.main.popupmenuSettings, 'String', popupmenuList);
    set(handles.main.popupmenuGraphicalOutput, 'String', popupmenuList);
    %set back to simulation 1 otherwise might select something not available
    set(handles.main.popupmenuSettings, 'Value', 1);
    set(handles.main.popupmenuGraphicalOutput, 'Value', 1);
    %load settings temp file for sim 1
    %GUIClass.loadSettingsTempFile(settingsTempFileNames,1,handles.main);
    GUIClass.loadSettingsTempFileMultipleGUIs(settingsTempFileNames,1,handles.main)
end

delete(handles.figureLoadSettings)


% --- Executes during object creation, after setting all properties.
function figureLoadSettings_CreateFcn(hObject, eventdata, handles)
% hObject    handle to figureLoadSettings (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called


% --- Executes when selected object is changed in uipanel2.
function uipanel2_SelectionChangeFcn(hObject, eventdata, handles)
% hObject    handle to the selected object in uipanel2 
% eventdata  structure with the following fields (see UIBUTTONGROUP)
%	EventName: string 'SelectionChanged' (read only)
%	OldValue: handle of the previously selected object or empty if none was selected
%	NewValue: handle of the currently selected object
% handles    structure with handles and user data (see GUIDATA)


% --- Executes during object creation, after setting all properties.
function uipanel2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to uipanel2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called
