%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Jennifer Jackson 2017                                                        %
% A Biodiversity Approach to Cyber Security                                    %
% PhD Complexity Science                                                       %
% University of Warwick                                                        %
% http://wrap.warwick.ac.uk/98458                                              %
% This software is distributed under the  Creative Commons Attribution License %
% https://creativecommons.org/licenses/by/4.0/                                 %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function varargout = loadSimulationOutput(varargin)
% LOADSIMULATIONOUTPUT MATLAB code for loadSimulationOutput.fig
%      LOADSIMULATIONOUTPUT, by itself, creates a new LOADSIMULATIONOUTPUT or raises the existing
%      singleton*.
%
%      H = LOADSIMULATIONOUTPUT returns the handle to a new LOADSIMULATIONOUTPUT or the handle to
%      the existing singleton*.
%
%      LOADSIMULATIONOUTPUT('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in LOADSIMULATIONOUTPUT.M with the given input arguments.
%
%      LOADSIMULATIONOUTPUT('Property','Value',...) creates a new LOADSIMULATIONOUTPUT or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before loadSimulationOutput_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to loadSimulationOutput_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help loadSimulationOutput

% Last Modified by GUIDE v2.5 01-Apr-2015 14:34:39

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @loadSimulationOutput_OpeningFcn, ...
                   'gui_OutputFcn',  @loadSimulationOutput_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before loadSimulationOutput is made visible.
function loadSimulationOutput_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to loadSimulationOutput (see VARARGIN)

% Choose default command line output for loadSimulationOutput
handles.output = hObject;

%varargin
handles.main = varargin{1} %save handles from main figure

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes loadSimulationOutput wait for user response (see UIRESUME)
% uiwait(handles.figureLoadOutput);


% --- Outputs from this function are returned to the command line.
function varargout = loadSimulationOutput_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes when user attempts to close figureLoadOutput.
function figureLoadOutput_CloseRequestFcn(hObject, eventdata, handles)
% hObject    handle to figureLoadOutput (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: delete(hObject) closes the figure
delete(hObject);



function editOpenSimAs_Callback(hObject, eventdata, handles)
% hObject    handle to editOpenSimAs (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of editOpenSimAs as text
%        str2double(get(hObject,'String')) returns contents of editOpenSimAs as a double

editSaveAs=get(hObject,'String');
%save to structure
set(handles.editOpenSimAs,'String',editSaveAs);
% save the changes to the structure
guidata(gcbo,handles);

% --- Executes during object creation, after setting all properties.
function editOpenSimAs_CreateFcn(hObject, eventdata, handles)
% hObject    handle to editOpenSimAs (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in pushbuttonOpen.
function pushbuttonOpen_Callback(hObject, eventdata, handles)
% hObject    handle to pushbuttonOpen (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
%*************************
%find currently selected button 
rb1=get(handles.radiobuttonOpenOut1File,'Value');
rb2=get(handles.radiobuttonOpenOutMultipleFiles,'Value');
%retreive the simulations
if rb2 == 1
    GUIClass.openAllOutputs(handles)
end
%close window
delete(handles.figureLoadOutput)

%**************************


% --- Executes during object creation, after setting all properties.
function figureLoadOutput_CreateFcn(hObject, eventdata, handles)
% hObject    handle to figureLoadOutput (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

set(handles.radiobuttonOpenOut1File,'Enable', 'off')
set(handles.radiobuttonOpenOutMultipleFiles,'Enable', 'on')
