%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Jennifer Jackson 2017                                                        %
% A Biodiversity Approach to Cyber Security                                    %
% PhD Complexity Science                                                       %
% University of Warwick                                                        %
% http://wrap.warwick.ac.uk/98458                                              %
% This software is distributed under the  Creative Commons Attribution License %
% https://creativecommons.org/licenses/by/4.0/                                 %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function [nodesStd4 nodesMean4 nodesDiversity4 ] = localDiversity(t,sampleSize,nodesDiversityOld4,...
                                                   tallySol4,numEncounters,len_apps,len_serv,len_os,len_dr,updateYes)

     if t >sampleSize 
     start = t-(sampleSize);
     else
         start = 1;
     end;
     stop = t+1;
     
     %record the diversity each node sees
     %nodesDiversityOld4 = nodesDiversity4(:,t);
     nodesDiversity4(:,t+1) = nodesNei(tallySol4, numEncounters, len_apps, len_serv, len_os, len_dr, updateYes, nodesDiversityOld4);
     %record the running mean of the diversity each node sees for sol 4
     %record the running standard deviation each node sees for solution 4
     %(dim 1 does the columns, dim 2 does the rows)
     nodesMean4(:,t+1) = mean(nodesDiversity4(:,start:stop),2); 
     nodesStd4(:,t+1) = std(nodesDiversity4(:,start:stop),0,2);




