%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Jennifer Jackson 2017                                                        %
% A Biodiversity Approach to Cyber Security                                    %
% PhD Complexity Science                                                       %
% University of Warwick                                                        %
% http://wrap.warwick.ac.uk/98458                                              %
% This software is distributed under the  Creative Commons Attribution License %
% https://creativecommons.org/licenses/by/4.0/                                 %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function [maxMatrixVal maxMatrixI] = maxRand(dataMatrix,dimension, tolerance)
%Description:
%The matlab max function only returns the first maximum number that it sees
%This max function will get all of the maximum numbers and then choose 1 at
%random 
%Inputs:
%(1)dataMatrix:input matrix to find the maximum values
%(2)dimension: dimension of matrix to find max numbers
%(3)tolerance: tolerance of finding similar maximum numbers, i.e if the
%tolerance is zero all the maximum numbers found must be exactly the same
%number. If the tolerance is 0.1, then the maximum numbers can be 0.1
%apart
%tolerance = 0.2;
%dimension = 2;
%dataMatrix = [0.1 0.8 1 1 0.5 0.3 0.2; 0.3 1 1 0.6 0.1 0.8 1]
%dataMatrix = [0.1 0.2; 1 1]
%reset variables
temp = dataMatrix;
[r, c] = size(temp);

%max poss numbers
[maxVal maxI] = max(temp,[],dimension);
for s = 1:r
 flag = 0;
 i = 1;
while (flag == 0) && (i < c+1)
[val maxI] = max(temp(s,:));
    if val >= maxVal(s) - tolerance
    maxMatrix1(s,i,1)= val;
    maxMatrix1(s,i,2)= maxI;
    maxIndex(s,i)=maxI;
    temp(s,maxI) = 0; %set max number to zero
    %record the number of maximum numbers
    numberofMaxValues(s) = i;
    i = i + 1;
    else
        flag = 1;
    end %end if
    s;
end; %end while
end; %end for s
temp;


%choose random max index from each row
%number of maximum numbers in each row
numberofMaxValues ;
%for each row choose a random number between 1 and numberMax
numNodes = r;
for g = 1: numNodes
 randIndex(g) = round(rand(1)*(numberofMaxValues(g)-1))+1;
end;
for s = 1: numNodes
tempIndex(s) = maxIndex(s,(randIndex(s))); %index for temp
maxMatrixVal(s) = dataMatrix(s,tempIndex(s));%value of dataMatrix randomly chosen
maxMatrixI(s) = tempIndex(s);%index of dataMatrix randomly chosen
end
tempIndex;
maxMatrixVal=maxMatrixVal';
maxMatrixI=maxMatrixI';

