%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Jennifer Jackson 2017                                                        %
% A Biodiversity Approach to Cyber Security                                    %
% PhD Complexity Science                                                       %
% University of Warwick                                                        %
% http://wrap.warwick.ac.uk/98458                                              %
% This software is distributed under the  Creative Commons Attribution License %
% https://creativecommons.org/licenses/by/4.0/                                 %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function [nodesMean nodesStd updateStop updateStopDisplay minStdCurve,minStd,reachTolFlag, nodesDiversity] = multipleStopUpdating(t, sampleSize, ...
                      numNodes, nodesDiversityOld, ...
                      tallySol, numEncounters, len_apps, len_serv, len_os, len_dr, updateYes, ...
                      minstdTolerance, minStdOld, maxStd, reachTolFlagOld, updateStopOld, updateStopDisplayOld, minStdCurveOld)

%*******************************************
     %STOPPING THE UPDATE PROCESS
     %Code for solution 4 and 5 only
     %*******************************************
     if t > sampleSize 
     start = t-(sampleSize);
     else
         start = 1;
     end;
     stop = t+1;
        
     
    %****************Multiple stop update 
    % if restartUpdate == 1
     %record the diversity each node sees for solution 4 only
     nodesDiversitySingle = nodesDiversityOld(:,t);
     nodesDiversity(:,t+1) = nodesNei(tallySol, numEncounters, len_apps, len_serv, len_os, len_dr, updateYes, nodesDiversitySingle);
     %record the running standard deviation each node sees for solution 
     nodesMean(:,t+1) = mean(nodesDiversity(:,start:stop),2); 
     nodesStd(:,t+1) = std(nodesDiversity(:,start:stop),0,2);
     for i = 1: numNodes
     % check to see if surpassed sample size
     if (t >sampleSize)
      %***minimum update
      if reachTolFlagOld(i) == 0 && (nodesStd(i,t+1) <= minStdOld(i)) && (nodesStd(i,t+1) < maxStd(i))  
          minStd(i) = nodesStd(i,t+1); %set new minimum
          minStdCurve(i,t) = nodesStd(i,t+1);
          reachTolFlag(i) = 1; %surpassed tolerance
          updateStop(i) = updateStopOld(i);
          updateStopDisplay(t,i)= updateStopDisplayOld(t,i);
      elseif reachTolFlagOld(i) == 1 && (nodesStd(i,t+1) <= minStdOld(i)) && (nodesStd(i,t+1) < maxStd(i))  
          minStd(i) = nodesStd(i,t+1); %set new minimum
           minStdCurve(i,t) = nodesStd(i,t+1);
          updateStop(i) = 1; %continue updating
          updateStopDisplay(t,i)= 1; %continue updating
          reachTolFlag(i) = reachTolFlagOld(i);
      elseif reachTolFlagOld(i) == 1 && (nodesStd(i,t+1) > minStdOld(i)) && (nodesStd(i,t+1) < maxStd(i)) 
         updateStop(i) = 0; %stop updating
         updateStopDisplay(t,i)= 0; %stop updating
         minStdCurve(i,t) = minStdCurveOld(i,t);
         reachTolFlag(i) = reachTolFlagOld(i);
         minStd(i) = minStdOld(i);
      %***maximum update - update again and reset if std goes back up again
      elseif reachTolFlagOld(i) == 1 && (nodesStd(i,t+1) > minStd(i)) && (nodesStd(i,t+1) > maxStd(i))  
          updateStop(i) = 1; %start updating again
          updateStopDisplay(t,i)= 1; %start updating again
          %reset min tolerance and tolFlag
          minStd(i) = minstdTolerance;
           minStdCurve(i,t) = minstdTolerance;
          reachTolFlag(i) = 0;
      else
          minStdCurve(i,t) = minStdCurveOld(i,t);
          minStd(i) = minStdOld(i);
          updateStop(i) = updateStopOld(i);
          updateStopDisplay(t,i)= updateStopDisplayOld(t,i);
          reachTolFlag(i) = reachTolFlagOld(i);
      end; %end stop update logic
     else
         minStdCurve(i,t) = minstdTolerance; %else sample size
         updateStop(i) = 1; %keep updating if less than the sample size
         updateStopDisplay(t,i)= 1;
         reachTolFlag(i) = 0;
         minStd(i) = minStdOld(i);
     end; %end sample size
     end; %end i loop
  %   end; % end restartUpdate