%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Jennifer Jackson 2017                                                        %
% A Biodiversity Approach to Cyber Security                                    %
% PhD Complexity Science                                                       %
% University of Warwick                                                        %
% http://wrap.warwick.ac.uk/98458                                              %
% This software is distributed under the  Creative Commons Attribution License %
% https://creativecommons.org/licenses/by/4.0/                                 %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function varargout = networkModelParameters_randomEncounter(varargin)
% NETWORKMODELPARAMETERS_RANDOMENCOUNTER MATLAB code for networkModelParameters_randomEncounter.fig
%      NETWORKMODELPARAMETERS_RANDOMENCOUNTER, by itself, creates a new NETWORKMODELPARAMETERS_RANDOMENCOUNTER or raises the existing
%      singleton*.
%
%      H = NETWORKMODELPARAMETERS_RANDOMENCOUNTER returns the handle to a new NETWORKMODELPARAMETERS_RANDOMENCOUNTER or the handle to
%      the existing singleton*.
%
%      NETWORKMODELPARAMETERS_RANDOMENCOUNTER('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in NETWORKMODELPARAMETERS_RANDOMENCOUNTER.M with the given input arguments.
%
%      NETWORKMODELPARAMETERS_RANDOMENCOUNTER('Property','Value',...) creates a new NETWORKMODELPARAMETERS_RANDOMENCOUNTER or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before networkModelParameters_randomEncounter_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to networkModelParameters_randomEncounter_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help networkModelParameters_randomEncounter

% Last Modified by GUIDE v2.5 17-Sep-2015 10:15:13

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @networkModelParameters_randomEncounter_OpeningFcn, ...
                   'gui_OutputFcn',  @networkModelParameters_randomEncounter_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before networkModelParameters_randomEncounter is made visible.
function networkModelParameters_randomEncounter_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to networkModelParameters_randomEncounter (see VARARGIN)

% Choose default command line output for networkModelParameters_randomEncounter
% Choose default command line output for networkModelParameters_randomWaypoint
handles.output = hObject;
handles.main = varargin{1} %save handles from main figure
% Update handles structure
guidata(hObject, handles);

%Get the number of simulations selected in main gui
numSims = get(handles.main.popupmenuNumSims,'Value')
%set list of available simulations in sub gui
popupmenuList = GUIClass.genSimList(numSims);
set(handles.popupmenuSettings, 'String', popupmenuList);

%set back to simulation 1 otherwise might select something not available
%set(handles.popupmenuSettings, 'Value', 1);
%set simulation number to match main GUI
currentSimSetting = get(handles.main.popupmenuSettings,'Value')
set(handles.popupmenuSettings, 'Value', currentSimSetting);


% Update handles structure
guidata(hObject, handles);

% UIWAIT makes networkModelParameters_randomEncounter wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = networkModelParameters_randomEncounter_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;



function editRandomEncounterProb_Callback(hObject, eventdata, handles)
% hObject    handle to editRandomEncounterProb (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of editRandomEncounterProb as text
%        str2double(get(hObject,'String')) returns contents of editRandomEncounterProb as a double
editRandomEncounterProbV = str2double(get(hObject,'String'))
editRandomEncounterProbS = get(hObject,'String');
%save to structure
set(handles.editRandomEncounterProb,'Value',editRandomEncounterProbV);
set(handles.editRandomEncounterProb,'String',editRandomEncounterProbS);
% save the changes to the structure
guidata(gcbo,handles);

% --- Executes during object creation, after setting all properties.
function editRandomEncounterProb_CreateFcn(hObject, eventdata, handles)
% hObject    handle to editRandomEncounterProb (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in popupmenuSettings.
function popupmenuSettings_Callback(hObject, eventdata, handles)
% hObject    handle to popupmenuSettings (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns popupmenuSettings contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenuSettings


% --- Executes during object creation, after setting all properties.
function popupmenuSettings_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenuSettings (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function editOldSimSetting_Callback(hObject, eventdata, handles)
% hObject    handle to editOldSimSetting (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of editOldSimSetting as text
%        str2double(get(hObject,'String')) returns contents of editOldSimSetting as a double


% --- Executes during object creation, after setting all properties.
function editOldSimSetting_CreateFcn(hObject, eventdata, handles)
% hObject    handle to editOldSimSetting (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in pushbuttonAllSimsSame.
function pushbuttonAllSimsSame_Callback(hObject, eventdata, handles)
% hObject    handle to pushbuttonAllSimsSame (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes on button press in pushbuttonResetToDefaults.
function pushbuttonResetToDefaults_Callback(hObject, eventdata, handles)
% hObject    handle to pushbuttonResetToDefaults (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes during object creation, after setting all properties.
function figure1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to figure1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called
