%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Jennifer Jackson 2017                                                        %
% A Biodiversity Approach to Cyber Security                                    %
% PhD Complexity Science                                                       %
% University of Warwick                                                        %
% http://wrap.warwick.ac.uk/98458                                              %
% This software is distributed under the  Creative Commons Attribution License %
% https://creativecommons.org/licenses/by/4.0/                                 %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function varargout = networkModelParameters_randomWaypoint(varargin)
% NETWORKMODELPARAMETERS_RANDOMWAYPOINT MATLAB code for networkModelParameters_randomWaypoint.fig
%      NETWORKMODELPARAMETERS_RANDOMWAYPOINT, by itself, creates a new NETWORKMODELPARAMETERS_RANDOMWAYPOINT or raises the existing
%      singleton*.
%
%      H = NETWORKMODELPARAMETERS_RANDOMWAYPOINT returns the handle to a new NETWORKMODELPARAMETERS_RANDOMWAYPOINT or the handle to
%      the existing singleton*.
%
%      NETWORKMODELPARAMETERS_RANDOMWAYPOINT('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in NETWORKMODELPARAMETERS_RANDOMWAYPOINT.M with the given input arguments.
%
%      NETWORKMODELPARAMETERS_RANDOMWAYPOINT('Property','Value',...) creates a new NETWORKMODELPARAMETERS_RANDOMWAYPOINT or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before networkModelParameters_randomWaypoint_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to networkModelParameters_randomWaypoint_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help networkModelParameters_randomWaypoint

% Last Modified by GUIDE v2.5 23-Sep-2015 17:48:04

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @networkModelParameters_randomWaypoint_OpeningFcn, ...
                   'gui_OutputFcn',  @networkModelParameters_randomWaypoint_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before networkModelParameters_randomWaypoint is made visible.
function networkModelParameters_randomWaypoint_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to networkModelParameters_randomWaypoint (see VARARGIN)

% Choose default command line output for networkModelParameters_randomWaypoint
handles.output = hObject;
handles.main = varargin{1} %save handles from main figure
% Update handles structure
guidata(hObject, handles);

%Get the number of simulations selected in main gui
numSims = get(handles.main.popupmenuNumSims,'Value')
%set list of available simulations in sub gui
popupmenuList = GUIClass.genSimList(numSims);
set(handles.popupmenuSettings, 'String', popupmenuList);

%set back to simulation 1 otherwise might select something not available
%set(handles.popupmenuSettings, 'Value', 1);
%set simulation number to match main GUI
currentSimSetting = get(handles.main.popupmenuSettings,'Value')
set(handles.popupmenuSettings, 'Value', currentSimSetting);


% Update handles structure
guidata(hObject, handles);

% UIWAIT makes networkModelParameters_randomWaypoint wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = networkModelParameters_randomWaypoint_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on selection change in popupmenuSettings.
function popupmenuSettings_Callback(hObject, eventdata, handles)
% hObject    handle to popupmenuSettings (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns popupmenuSettings contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenuSettings
GUIClass.changePopupMenuSettings(hObject,handles.main)

% --- Executes during object creation, after setting all properties.
function popupmenuSettings_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenuSettings (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function editOldSimSetting_Callback(hObject, eventdata, handles)
% hObject    handle to editOldSimSetting (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of editOldSimSetting as text
%        str2double(get(hObject,'String')) returns contents of editOldSimSetting as a double


% --- Executes during object creation, after setting all properties.
function editOldSimSetting_CreateFcn(hObject, eventdata, handles)
% hObject    handle to editOldSimSetting (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in pushbuttonAllSimsSame.
function pushbuttonAllSimsSame_Callback(hObject, eventdata, handles)
% hObject    handle to pushbuttonAllSimsSame (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes on button press in pushbuttonResetToDefaults.
function pushbuttonResetToDefaults_Callback(hObject, eventdata, handles)
% hObject    handle to pushbuttonResetToDefaults (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes when user attempts to close figure1.
function figure1_CloseRequestFcn(hObject, eventdata, handles)
% hObject    handle to figure1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: delete(hObject) closes the figure
set(hObject,'Visible','off');%make invisible;
guidata(gcbo,handles);


% --- Executes on button press in pushbuttonComputeWayPoints.
function pushbuttonComputeWayPoints_Callback(hObject, eventdata, handles)
% hObject    handle to pushbuttonComputeWayPoints (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)



% --- Executes on button press in checkboxPlotWayPoints.
function checkboxPlotWayPoints_Callback(hObject, eventdata, handles)
% hObject    handle to checkboxPlotWayPoints (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% Hint: get(hObject,'Value') returns toggle state of checkboxPlotWayPoints
checkboxPlotWayPointsV = get(hObject,'Value');
%save to structure
set(handles.checkboxPlotWayPoints,'Value',checkboxPlotWayPointsV);
guidata(gcbo,handles);


% --- Executes on selection change in popupmenuRWPTxRadius.
function popupmenuRWPTxRadius_Callback(hObject, eventdata, handles)
% hObject    handle to popupmenuRWPTxRadius (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns popupmenuRWPTxRadius contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenuRWPTxRadius


% --- Executes during object creation, after setting all properties.
function popupmenuRWPTxRadius_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenuRWPTxRadius (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in popupmenuRWPEncounterChoice.
function popupmenuRWPEncounterChoice_Callback(hObject, eventdata, handles)
% hObject    handle to popupmenuRWPEncounterChoice (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns popupmenuRWPEncounterChoice contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenuRWPEncounterChoice


% --- Executes during object creation, after setting all properties.
function popupmenuRWPEncounterChoice_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenuRWPEncounterChoice (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function editRWPPosXmin_Callback(hObject, eventdata, handles)
% hObject    handle to editRWPPosXmin (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of editRWPPosXmin as text
%        str2double(get(hObject,'String')) returns contents of editRWPPosXmin as a double
editRWPPosXminV = str2double(get(hObject,'String'))
editRWPPosXminS = get(hObject,'String');
%save to structure
set(handles.editRWPPosXmin,'Value',editRWPPosXminV);
set(handles.editRWPPosXmin,'String',editRWPPosXminS);
% save the changes to the structure
guidata(gcbo,handles);

% --- Executes during object creation, after setting all properties.
function editRWPPosXmin_CreateFcn(hObject, eventdata, handles)
% hObject    handle to editRWPPosXmin (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function editRWPPosYmin_Callback(hObject, eventdata, handles)
% hObject    handle to editRWPPosYmin (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of editRWPPosYmin as text
%        str2double(get(hObject,'String')) returns contents of editRWPPosYmin as a double
editRWPPosYminV = str2double(get(hObject,'String'))
editRWPPosYminS = get(hObject,'String');
%save to structure
set(handles.editRWPPosYmin,'Value',editRWPPosYminV);
set(handles.editRWPPosYmin,'String',editRWPPosYminS);
% save the changes to the structure
guidata(gcbo,handles);

% --- Executes during object creation, after setting all properties.
function editRWPPosYmin_CreateFcn(hObject, eventdata, handles)
% hObject    handle to editRWPPosYmin (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function editRWPSpeedmin_Callback(hObject, eventdata, handles)
% hObject    handle to editRWPSpeedmin (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of editRWPSpeedmin as text
%        str2double(get(hObject,'String')) returns contents of editRWPSpeedmin as a double
editRWPSpeedminV = str2double(get(hObject,'String'))
editRWPSpeedminS = get(hObject,'String');
%save to structure
set(handles.editRWPSpeedmin,'Value',editRWPSpeedminV);
set(handles.editRWPSpeedmin,'String',editRWPSpeedminS);
% save the changes to the structure
guidata(gcbo,handles);

% --- Executes during object creation, after setting all properties.
function editRWPSpeedmin_CreateFcn(hObject, eventdata, handles)
% hObject    handle to editRWPSpeedmin (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function editRWPPausemin_Callback(hObject, eventdata, handles)
% hObject    handle to editRWPPausemin (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of editRWPPausemin as text
%        str2double(get(hObject,'String')) returns contents of editRWPPausemin as a double
editRWPPauseminV = str2double(get(hObject,'String'))
editRWPPauseminS = get(hObject,'String');
%save to structure
set(handles.editRWPPausemin,'Value',editRWPPauseminV);
set(handles.editRWPPausemin,'String',editRWPPauseminS);
% save the changes to the structure
guidata(gcbo,handles);

% --- Executes during object creation, after setting all properties.
function editRWPPausemin_CreateFcn(hObject, eventdata, handles)
% hObject    handle to editRWPPausemin (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function editRWPWalkTimemin_Callback(hObject, eventdata, handles)
% hObject    handle to editRWPWalkTimemin (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of editRWPWalkTimemin as text
%        str2double(get(hObject,'String')) returns contents of editRWPWalkTimemin as a double
editRWPWalkTimeminV = str2double(get(hObject,'String'))
editRWPWalkTimeminS = get(hObject,'String');
%save to structure
set(handles.editRWPWalkTimemin,'Value',editRWPWalkTimeminV);
set(handles.editRWPWalkTimemin,'String',editRWPWalkTimeminS);
% save the changes to the structure
guidata(gcbo,handles);

% --- Executes during object creation, after setting all properties.
function editRWPWalkTimemin_CreateFcn(hObject, eventdata, handles)
% hObject    handle to editRWPWalkTimemin (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function editRWPDirectionmin_Callback(hObject, eventdata, handles)
% hObject    handle to editRWPDirectionmin (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of editRWPDirectionmin as text
%        str2double(get(hObject,'String')) returns contents of editRWPDirectionmin as a double
editRWPDirectionminV = str2double(get(hObject,'String'))
editRWPDirectionminS = get(hObject,'String');
%save to structure
set(handles.editRWPDirectionmin,'Value',editRWPDirectionminV);
set(handles.editRWPDirectionmin,'String',editRWPDirectionminS);
% save the changes to the structure
guidata(gcbo,handles);

% --- Executes during object creation, after setting all properties.
function editRWPDirectionmin_CreateFcn(hObject, eventdata, handles)
% hObject    handle to editRWPDirectionmin (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function editRWPPosXmax_Callback(hObject, eventdata, handles)
% hObject    handle to editRWPPosXmax (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of editRWPPosXmax as text
%        str2double(get(hObject,'String')) returns contents of editRWPPosXmax as a double
editRWPPosXmaxV = str2double(get(hObject,'String'))
editRWPPosXmaxS = get(hObject,'String');
%save to structure
set(handles.editRWPPosXmax,'Value',editRWPPosXmaxV);
set(handles.editRWPPosXmax,'String',editRWPPosXmaxS);
% save the changes to the structure
guidata(gcbo,handles);

% --- Executes during object creation, after setting all properties.
function editRWPPosXmax_CreateFcn(hObject, eventdata, handles)
% hObject    handle to editRWPPosXmax (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function editRWPPosYmax_Callback(hObject, eventdata, handles)
% hObject    handle to editRWPPosYmax (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of editRWPPosYmax as text
%        str2double(get(hObject,'String')) returns contents of editRWPPosYmax as a double
editRWPPosYmaxV = str2double(get(hObject,'String'))
editRWPPosYmaxS = get(hObject,'String');
%save to structure
set(handles.editRWPPosYmax,'Value',editRWPPosYmaxV);
set(handles.editRWPPosYmax,'String',editRWPPosYmaxS);
% save the changes to the structure
guidata(gcbo,handles);

% --- Executes during object creation, after setting all properties.
function editRWPPosYmax_CreateFcn(hObject, eventdata, handles)
% hObject    handle to editRWPPosYmax (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function editRWPSpeedmax_Callback(hObject, eventdata, handles)
% hObject    handle to editRWPSpeedmax (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of editRWPSpeedmax as text
%        str2double(get(hObject,'String')) returns contents of editRWPSpeedmax as a double
editRWPSpeedmaxV = str2double(get(hObject,'String'))
editRWPSpeedmaxS = get(hObject,'String');
%save to structure
set(handles.editRWPSpeedmax,'Value',editRWPSpeedmaxV);
set(handles.editRWPSpeedmax,'String',editRWPSpeedmaxS);
% save the changes to the structure
guidata(gcbo,handles);

% --- Executes during object creation, after setting all properties.
function editRWPSpeedmax_CreateFcn(hObject, eventdata, handles)
% hObject    handle to editRWPSpeedmax (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function editRWPPausemax_Callback(hObject, eventdata, handles)
% hObject    handle to editRWPPausemax (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of editRWPPausemax as text
%        str2double(get(hObject,'String')) returns contents of editRWPPausemax as a double
editRWPPausemaxV = str2double(get(hObject,'String'))
editRWPPausemaxS = get(hObject,'String');
%save to structure
set(handles.editRWPPausemax,'Value',editRWPPausemaxV);
set(handles.editRWPPausemax,'String',editRWPPausemaxS);
% save the changes to the structure
guidata(gcbo,handles);

% --- Executes during object creation, after setting all properties.
function editRWPPausemax_CreateFcn(hObject, eventdata, handles)
% hObject    handle to editRWPPausemax (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function editRWPWalkTimemax_Callback(hObject, eventdata, handles)
% hObject    handle to editRWPWalkTimemax (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of editRWPWalkTimemax as text
%        str2double(get(hObject,'String')) returns contents of editRWPWalkTimemax as a double
editRWPWalkTimemaxV = str2double(get(hObject,'String'))
editRWPWalkTimemaxS = get(hObject,'String');
%save to structure
set(handles.editRWPWalkTimemax,'Value',editRWPWalkTimemaxV);
set(handles.editRWPWalkTimemax,'String',editRWPWalkTimemaxS);
% save the changes to the structure
guidata(gcbo,handles);

% --- Executes during object creation, after setting all properties.
function editRWPWalkTimemax_CreateFcn(hObject, eventdata, handles)
% hObject    handle to editRWPWalkTimemax (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function editRWPDirectionmax_Callback(hObject, eventdata, handles)
% hObject    handle to editRWPDirectionmax (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of editRWPDirectionmax as text
%        str2double(get(hObject,'String')) returns contents of editRWPDirectionmax as a double
editRWPDirectionmaxV = str2double(get(hObject,'String'))
editRWPDirectionmaxS = get(hObject,'String');
%save to structure
set(handles.editRWPDirectionmax,'Value',editRWPDirectionmaxV);
set(handles.editRWPDirectionmax,'String',editRWPDirectionmaxS);
% save the changes to the structure
guidata(gcbo,handles);

% --- Executes during object creation, after setting all properties.
function editRWPDirectionmax_CreateFcn(hObject, eventdata, handles)
% hObject    handle to editRWPDirectionmax (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes during object creation, after setting all properties.
function figure1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to figure1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called


% --- Executes on button press in pushbuttonRWPInfo.
function pushbuttonRWPInfo_Callback(hObject, eventdata, handles)
% hObject    handle to pushbuttonRWPInfo (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
encounterChoiceInfoFig = encounterChoiceInfo(handles);%open figure
handles.encounterChoiceInfoFig = encounterChoiceInfoFig; %save handle ref
set(handles.encounterChoiceInfoFig,'Visible','on');%make visible         
