%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Jennifer Jackson 2017                                                        %
% A Biodiversity Approach to Cyber Security                                    %
% PhD Complexity Science                                                       %
% University of Warwick                                                        %
% http://wrap.warwick.ac.uk/98458                                              %
% This software is distributed under the  Creative Commons Attribution License %
% https://creativecommons.org/licenses/by/4.0/                                 %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function nodesDiversity = nodesNei(tallySol, numEncounters, len_apps, len_serv, len_os, len_dr, updateYes, nodesDiversityOld)
%works out the diversity index each node thinks it is seeing
%nodesDiversity = zeros(numNodes,numRuns,tallyLength);

tallySol;
numEncounters;
updateYes;
%find frequency
numEncountersRep = repmat(numEncounters,1,size(tallySol,2));
freq = tallySol./numEncountersRep;
%square of freq
freqSq = freq.^2;
%split into seperate matrix sum
freqSq_apps = freqSq(:,1:len_apps);
freqSq_serv = freqSq(:,len_apps+1:len_apps+len_serv);
freqSq_os = freqSq(:,len_apps+1+len_serv:len_apps+len_serv+len_os);
freqSq_dr = freqSq(:,len_apps+1+len_serv+len_os:len_apps+len_serv+len_os+len_dr);
%sum per locus
freqSq_appsSum = sum(freqSq_apps,2);
freqSq_servSum = sum(freqSq_serv,2);
freqSq_osSum = sum(freqSq_os,2);
freqSq_drSum = sum(freqSq_dr,2);
%find h
h_apps = 1-freqSq_appsSum;
h_serv = 1-freqSq_servSum;
h_os = 1-freqSq_osSum;
h_dr = 1-freqSq_drSum;
%average to find nei
nei = (h_apps+h_serv+h_os+h_dr)./4;
%keep new ones are going to update
keepNew = nei.*updateYes;
%keep old ones not going to update
keepOld = (1-updateYes).*nodesDiversityOld;
%combine new and old to get correct output
nodesDiversity = keepNew(:,1) + keepOld(:,1);
