%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Jennifer Jackson 2017                                                        %
% A Biodiversity Approach to Cyber Security                                    %
% PhD Complexity Science                                                       %
% University of Warwick                                                        %
% http://wrap.warwick.ac.uk/98458                                              %
% This software is distributed under the  Creative Commons Attribution License %
% https://creativecommons.org/licenses/by/4.0/                                 %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function [ outputArray ] = normArray2( inputArray, normVal )
%inputArray - input array data to normalise
%normVal - can be 1(normalise to 1) or 100 (normalise to 100)
% if it is set incorrectly it will automatically normalise to 1
%normalises an array to sum to 1 or 100
%assumes all +ve values

%TESTING
%%%%%%%%%%%%%
%inputArray = [4 5 6 7; 1 2 6 9; 2 5 7 8]
%normVal = 100
%%%%%%%%%%%%%%%%%


S = sum(inputArray,2); %sum along rows
%extend to all columns
sumX = repmat(S,1,size(inputArray,2)) ;
outputArray = inputArray./sumX;
%normalise to 100
if normVal == 100
    outputArray = outputArray.*100;
    %outputArraySumCheck = sum(outputArray,2) %sum along rows
end
end
