%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Jennifer Jackson 2017                                                        %
% A Biodiversity Approach to Cyber Security                                    %
% PhD Complexity Science                                                       %
% University of Warwick                                                        %
% http://wrap.warwick.ac.uk/98458                                              %
% This software is distributed under the  Creative Commons Attribution License %
% https://creativecommons.org/licenses/by/4.0/                                 %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function [chosenVal chosenIndex] = probSol(dataMatrix)

%This function will choose a solution based on probability
%The higher the score, the higher the probability it will be chosen
%This will hopefully stop all nodes choosing the same solution when it
%comes to community desirabilities in particular
%(1) dataMatrix: rows are the nodes, columns are the values

%split values into bins, the range based on the value
%generate a random number and see which bin it ends up in
%the chosen bin will be the chosen solution

%get size of dataMatrix
[numNodes, numValues] = size(dataMatrix);
%sum each row of the data matrix to get the sumValues
sumValues = sum(dataMatrix,2);
%work out the number of bin edges needed
numEdges = numValues+1;
%create matrix of bin edges
edgesMatrix = zeros(numNodes,numEdges);
for i = 1:numNodes
    for j = 2:numEdges
    edgesMatrix(i,j) = edgesMatrix(i,j-1) + (dataMatrix(i,j-1)/sumValues(i));
    end; %j
end; %i

%generate a random number between 0 and 1 for each row
randMatrix = rand([numNodes,1]);
chosenIndex = ones(numNodes,1); %changed from zeros to ones 15th October 2014 as was getting left with some zero values when only 1 os was used
chosenVal = zeros(numNodes,1);

%use random number to choose a bin
for i = 1:numNodes
    for j = 1:numEdges-1
    if (randMatrix(i) >= edgesMatrix(i,j)) && (randMatrix(i) < edgesMatrix(i,j+1));
        chosenIndex(i,1)= j;
        chosenVal(i,1) = dataMatrix(i,j);
    end; %if
    end; %j
        %dont want to choose first zero value when blacklisting else will
        %choose the blacklisted variant
        %TEMP FIX AS ONLY WORKS FOR ONE VARIANT BLACKLISTED
        if numValues > 1 %if number of variants is more than 1 do this, else do nothing- can't blacklist if only have 1 variant
        if  chosenVal(i,1) == 0
            chosenIndex(i,1)= chosenIndex(i,1)+1;%choose next in list
            chosenVal(i,1) = dataMatrix(i,chosenIndex(i,1));
        end
        end
end; %i
chosenIndex;
chosenVal;
