%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Jennifer Jackson 2017                                                        %
% A Biodiversity Approach to Cyber Security                                    %
% PhD Complexity Science                                                       %
% University of Warwick                                                        %
% http://wrap.warwick.ac.uk/98458                                              %
% This software is distributed under the  Creative Commons Attribution License %
% https://creativecommons.org/licenses/by/4.0/                                 %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function randomWayPointEncounter( )

%do mobility model for all time
s_input = struct('V_POSITION_X_INTERVAL',[10 30],...%(m)
                 'V_POSITION_Y_INTERVAL',[10 30],...%(m)
                 'V_SPEED_INTERVAL',[0.2 2.2],...%(m/s)
                 'V_PAUSE_INTERVAL',[0 1],...%pause time (s)
                 'V_WALK_INTERVAL',[2.00 6.00],...%walk time (s)
                 'V_DIRECTION_INTERVAL',[-180 180],...%(degrees)
                 'SIMULATION_TIME',500,...%(s)
                 'NB_NODES',20);
s_mobility = Generate_Mobility(s_input);

timeStep = 1 ; %0.1;%(s) %time interval originally set at 0.1
[vs_node] = test_Animate(s_mobility,s_input,timeStep);

%xpos = vs_node(1).v_x
%ypos = vs_node(1).v_y

%get the positions for the first time step
 for nodeIndex = 1:s_mobility.NB_NODES
xpos(nodeIndex) = vs_node(nodeIndex).v_x(1);
ypos(nodeIndex) = vs_node(nodeIndex).v_y(1);
 end
 
%put in correct format for nodes 
nodes.x = xpos; %[4 6 2 1 8];
nodes.y = ypos; %[1 2 3 4 5]
range = 4 % in metres
mode = 2
[encounterYes,nodesEncountered] = getNearestNode(nodes,range,mode)







end

