%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Jennifer Jackson 2017                                                        %
% A Biodiversity Approach to Cyber Security                                    %
% PhD Complexity Science                                                       %
% University of Warwick                                                        %
% http://wrap.warwick.ac.uk/98458                                              %
% This software is distributed under the  Creative Commons Attribution License %
% https://creativecommons.org/licenses/by/4.0/                                 %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function [updateStopDisplayFlag updateStop] = restart(mode,restartUpdateEnable,numNodes,sampleSize,t,lengthCounter,tChange1Enable,tChange1,tChange2Enable,tChange2,updateStopDisplayFlagCurrent,updateStopCurrent,displayStopVal,displayStartVal, ...
                                                        currentStd, maxStdTolerance,lastStoppedStd,stdMargin, ...
                                                        ChangeDesirabilitiesFlag,ChangeEffFlag,ChangeIndDesirabilitiesFlag,ChangeOwnIndDesirabilitiesFlag, ...
                                                        tChangeEff1Enable, tChangeEff2Enable, tChangeEff1, tChangeEff2, ...
                                                        tChangeInd1Enable, tChangeInd2Enable, tChangeInd1,tChangeInd2, ...
                                                        IDtimeArray1, IDtimeArray2,wdivUpdateTime1,wdivUpdateTime2,wdivUpdateTime3,WidUpdateTime1,WidUpdateTime2)
%mode 1-4 for single stop
%mode 5-6 for multiple restart

%%%%%%%%%%%%%%
%MODE < 5
%%%%%%%%%%%%%%
if mode < 5
%Restart update procedure
if restartUpdateEnable ==1 %singlestop update enabled
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %For Comm desirabilities
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    if ChangeDesirabilitiesFlag == 1
    %for all nodes
    if (t>=wdivUpdateTime1) && (t < wdivUpdateTime1+sampleSize) %weight update time
            updateStopDisplayFlag(lengthCounter,1:numNodes)= displayStartVal;%restart;
            updateStop(1:numNodes,1) = 1; 
    elseif (t>=wdivUpdateTime2) && (t < wdivUpdateTime2+sampleSize) %weight update time
            updateStopDisplayFlag(lengthCounter,1:numNodes)= displayStartVal;%restart;
            updateStop(1:numNodes,1) = 1;  
    elseif (t>=wdivUpdateTime3) && (t < wdivUpdateTime3+sampleSize) %weight update time
            updateStopDisplayFlag(lengthCounter,1:numNodes)= displayStartVal;%restart;
            updateStop(1:numNodes,1) = 1;         
    elseif (tChange1Enable ==1) && (t >= tChange1) && (t < tChange1+sampleSize) 
        updateStopDisplayFlag(lengthCounter,1:numNodes)= displayStartVal;%restart;
        updateStop(1:numNodes,1) = 1;              
    % elseif (tChange2Enable ==1) && (t == tChange2)
    elseif (tChange2Enable ==1) && (t >= tChange2) && (t < tChange2+sampleSize) 
        updateStopDisplayFlag(lengthCounter,1:numNodes)= displayStartVal;%restart
        updateStop(1:numNodes,1) = 1;
    else 
        updateStopDisplayFlag(lengthCounter,1:numNodes)= updateStopDisplayFlagCurrent(lengthCounter,1:numNodes);%no change
        updateStop(1:numNodes,1) = updateStopCurrent(1:numNodes,1);
     end;
    end;
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %For Eff desirabilities
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    if ChangeEffFlag == 1
    if (tChangeEff1Enable ==1) && (t >= tChangeEff1) && (t < tChangeEff1+sampleSize) 
        updateStopDisplayFlag(lengthCounter,1:numNodes)= displayStartVal;%restart;
        updateStop(1:numNodes,1) = 1;              
    elseif (tChangeEff2Enable ==1) && (t >= tChangeEff2) && (t < tChangeEff2+sampleSize) 
        updateStopDisplayFlag(lengthCounter,1:numNodes)= displayStartVal;%restart
        updateStop(1:numNodes,1) = 1;
    else 
        updateStopDisplayFlag(lengthCounter,1:numNodes)= updateStopDisplayFlagCurrent(lengthCounter,1:numNodes);%no change
        updateStop(1:numNodes,1) = updateStopCurrent(1:numNodes,1);
     end;
     end;
     %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
     %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %For ALL IND desirabilities
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    if ChangeIndDesirabilitiesFlag == 1
    if (tChangeInd1Enable ==1) && (t >= tChangeInd1) && (t < tChangeInd1+sampleSize) 
        updateStopDisplayFlag(lengthCounter,1:numNodes)= displayStartVal;%restart;
        updateStop(1:numNodes,1) = 1;              
    elseif (tChangeInd2Enable ==1) && (t >= tChangeInd2) && (t < tChangeInd2+sampleSize) 
        updateStopDisplayFlag(lengthCounter,1:numNodes)= displayStartVal;%restart
        updateStop(1:numNodes,1) = 1;
    else 
        updateStopDisplayFlag(lengthCounter,1:numNodes)= updateStopDisplayFlagCurrent(lengthCounter,1:numNodes);%no change
        updateStop(1:numNodes,1) = updateStopCurrent(1:numNodes,1);
     end;
     end;
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %For OWN IND desirabilities
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    if ChangeOwnIndDesirabilitiesFlag == 1
        for i = 1: numNodes
            if (t>=IDtimeArray1(i)) && (t < IDtimeArray1(i)+sampleSize) 
            updateStopDisplayFlag(lengthCounter,i)= displayStartVal;%restart;
            updateStop(i,1) = 1;              
            elseif (t>=IDtimeArray2(i)) && (t < IDtimeArray2(i)+sampleSize)  
            updateStopDisplayFlag(lengthCounter,i)= displayStartVal;%restart
            updateStop(i,1) = 1;
            else 
            updateStopDisplayFlag(lengthCounter,i)= updateStopDisplayFlagCurrent(lengthCounter,i);%no change
            updateStop(i,1) = updateStopCurrent(i,1);
            end; %if time check
        end; %i loop
     end; %flag
     %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %Need to account for the case when no desirabilities are changing
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %under no conditions does it restart after having stopped
    if ChangeDesirabilitiesFlag == 0 && ChangeEffFlag == 0 && ChangeIndDesirabilitiesFlag == 0 && ChangeOwnIndDesirabilitiesFlag == 0
    for i = 1: numNodes
    updateStopDisplayFlag(lengthCounter,i)= updateStopDisplayFlagCurrent(lengthCounter,i);%no change
    updateStop(i,1) = updateStopCurrent(i,1);
    end
    end
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%  
end%restartUpdateEnable

%%%%%%%%%%%%%%%%%
%MODE 5
%%%%%%%%%%%%%%%%%%
%NEED TO INCLUDE COM, EFF, IND ENABLING AS ABOVE
%
elseif mode == 5
if restartUpdateEnable ==1 %stop start update enabled
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %For Comm desirabilities
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    if ChangeDesirabilitiesFlag == 1       
        %for each node
        if (t>=wdivUpdateTime1) && (t < wdivUpdateTime1+sampleSize) %weight update time
            updateStopDisplayFlag(lengthCounter,1:numNodes)= displayStartVal;%restart;
            updateStop(1:numNodes,1) = 1; 
        elseif (t>=wdivUpdateTime2) && (t < wdivUpdateTime2+sampleSize) %weight update time
            updateStopDisplayFlag(lengthCounter,1:numNodes)= displayStartVal;%restart;
            updateStop(1:numNodes,1) = 1; 
        elseif (t>=wdivUpdateTime3) && (t < wdivUpdateTime3+sampleSize) %weight update time
            updateStopDisplayFlag(lengthCounter,1:numNodes)= displayStartVal;%restart;
            updateStop(1:numNodes,1) = 1;
        elseif (tChange1Enable ==1) && (t >= tChange1) && (t < tChange1+sampleSize) 
            updateStopDisplayFlag(lengthCounter,1:numNodes)= displayStartVal;%restart;
            updateStop(1:numNodes,1) = 1;              
            % elseif (tChange2Enable ==1) && (t == tChange2)
        elseif (tChange2Enable ==1) && (t >= tChange2) && (t < tChange2+sampleSize) 
            updateStopDisplayFlag(lengthCounter,1:numNodes)= displayStartVal;%restart
            updateStop(1:numNodes,1) = 1;
        else 
            updateStopDisplayFlag(lengthCounter,1:numNodes)= updateStopDisplayFlagCurrent(lengthCounter,1:numNodes);%no change
            updateStop(1:numNodes,1) = updateStopCurrent(1:numNodes,1);
        end;
        %check to restart at maximum Tolerance
        for i = 1:numNodes
            %if currentStd(i,lengthCounter+1) > maxStdTolerance
            if currentStd(i,lengthCounter) > maxStdTolerance
            updateStopDisplayFlag(lengthCounter,i)= displayStartVal;%restart
            updateStop(i,1) = 1;
            end
        end
    end; %end com flag
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %For Eff desirabilities
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    if ChangeEffFlag == 1
        %for each node
        if (tChangeEff1Enable ==1) && (t >= tChangeEff1) && (t < tChangeEff1+sampleSize) 
            updateStopDisplayFlag(lengthCounter,1:numNodes)= displayStartVal;%restart;
            updateStop(1:numNodes,1) = 1;              
        elseif (tChangeEff2Enable ==1) && (t >= tChangeEff2) && (t < tChangeEff2+sampleSize) 
            updateStopDisplayFlag(lengthCounter,1:numNodes)= displayStartVal;%restart
            updateStop(1:numNodes,1) = 1;
        else 
            updateStopDisplayFlag(lengthCounter,1:numNodes)= updateStopDisplayFlagCurrent(lengthCounter,1:numNodes);%no change
            updateStop(1:numNodes,1) = updateStopCurrent(1:numNodes,1);
        end;
        %check to restart at maximum Tolerance
        for i = 1:numNodes
            %if currentStd(i,lengthCounter+1) > maxStdTolerance
            if currentStd(i,lengthCounter) > maxStdTolerance
            updateStopDisplayFlag(lengthCounter,i)= displayStartVal;%restart
            updateStop(i,1) = 1;
            end
        end       
    end; %end eff flag
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %For ALL IND desirabilities
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    if ChangeIndDesirabilitiesFlag == 1
        %for each node
        if (tChangeInd1Enable ==1) && (t >= tChangeInd1) && (t < tChangeInd1+sampleSize) 
            updateStopDisplayFlag(lengthCounter,1:numNodes)= displayStartVal;%restart;
            updateStop(1:numNodes,1) = 1;              
        elseif (tChangeInd2Enable ==1) && (t >= tChangeInd2) && (t < tChangeInd2+sampleSize) 
            updateStopDisplayFlag(lengthCounter,1:numNodes)= displayStartVal;%restart
            updateStop(1:numNodes,1) = 1;
        else 
            updateStopDisplayFlag(lengthCounter,1:numNodes)= updateStopDisplayFlagCurrent(lengthCounter,1:numNodes);%no change
            updateStop(1:numNodes,1) = updateStopCurrent(1:numNodes,1);
        end;
        %check to restart at maximum Tolerance
        for i = 1:numNodes
            %if currentStd(i,lengthCounter+1) > maxStdTolerance
            if currentStd(i,lengthCounter) > maxStdTolerance
            updateStopDisplayFlag(lengthCounter,i)= displayStartVal;%restart
            updateStop(i,1) = 1;
            end
        end       
    end;%end flag
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%5
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %For OWN IND desirabilities
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    if ChangeOwnIndDesirabilitiesFlag == 1
        for i = 1: numNodes
            if (t>=wdivUpdateTime1) && (t < wdivUpdateTime1+sampleSize) %weight update time
            updateStopDisplayFlag(lengthCounter,i)= displayStartVal;%restart;
            updateStop(i,1) = 1; 
            elseif (t>=wdivUpdateTime2) && (t < wdivUpdateTime2+sampleSize) %weight update time
            updateStopDisplayFlag(lengthCounter,i)= displayStartVal;%restart;
            updateStop(i,1) = 1; 
            elseif (t>=wdivUpdateTime3) && (t < wdivUpdateTime3+sampleSize) %weight update time
            updateStopDisplayFlag(lengthCounter,i)= displayStartVal;%restart;
            updateStop(i,1) = 1; 
            elseif (t>=WidUpdateTime1) && (t < WidUpdateTime1+sampleSize) %weight update time
            updateStopDisplayFlag(lengthCounter,i)= displayStartVal;%restart;
            updateStop(i,1) = 1; 
            elseif (t>=WidUpdateTime2) && (t < WidUpdateTime2+sampleSize) %weight update time
            updateStopDisplayFlag(lengthCounter,i)= displayStartVal;%restart;
            updateStop(i,1) = 1; 
            elseif (t>=IDtimeArray1(i)) && (t < IDtimeArray1(i)+sampleSize) 
            updateStopDisplayFlag(lengthCounter,i)= displayStartVal;%restart;
            updateStop(i,1) = 1;              
            elseif (t>=IDtimeArray2(i)) && (t < IDtimeArray2(i)+sampleSize)  
            updateStopDisplayFlag(lengthCounter,i)= displayStartVal;%restart
            updateStop(i,1) = 1;
            else 
            updateStopDisplayFlag(lengthCounter,i)= updateStopDisplayFlagCurrent(lengthCounter,i);%no change
            updateStop(i,1) = updateStopCurrent(i,1);
            end; %if time check
        end; %i loop
        %check to restart at maximum Tolerance
        for i = 1:numNodes
            %if currentStd(i,lengthCounter+1) > maxStdTolerance
            if currentStd(i,lengthCounter) > maxStdTolerance
            updateStopDisplayFlag(lengthCounter,i)= displayStartVal;%restart
            updateStop(i,1) = 1;
            end
        end           
    end;%end flag
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %Need to account for the case when no desirabilities are changing
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    if ChangeDesirabilitiesFlag == 0 && ChangeEffFlag == 0 && ChangeIndDesirabilitiesFlag == 0 && ChangeOwnIndDesirabilitiesFlag == 0
    for i = 1: numNodes
            %if currentStd(i,lengthCounter+1) > maxStdTolerance
            if currentStd(i,lengthCounter) > maxStdTolerance
            updateStopDisplayFlag(lengthCounter,i)= displayStartVal;%restart
            updateStop(i,1) = 1;
            else
            updateStopDisplayFlag(lengthCounter,i)= updateStopDisplayFlagCurrent(lengthCounter,i);%no change
            updateStop(i,1) = updateStopCurrent(i,1);
            end
    end
    end
    
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 end%restartUpdateEnable    
    
    
%%%%%%%%%%%%%%%%
%MODE 6 - DOESN'T WORK - ONLY STAYS ON FOR 1 CYCLE THEN TURNS ITSELF OFF
%BECAUSE BELOW THE MINIMUM THRESHOLD
%%%%%%%%%%%%%%%
elseif mode == 6
    %Restart update procedure
if restartUpdateEnable ==1
    %for each node
    % if (tChange1Enable ==1) && (t == tChange1) 
    if (tChange1Enable ==1) && (t >= tChange1) && (t < tChange1+sampleSize) 
        updateStopDisplayFlag(lengthCounter,1:numNodes)= displayStartVal;%restart;
        updateStop(1:numNodes,1) = 1;              
    % elseif (tChange2Enable ==1) && (t == tChange2)
    elseif (tChange2Enable ==1) && (t >= tChange2) && (t < tChange2+sampleSize) 
        updateStopDisplayFlag(lengthCounter,1:numNodes)= displayStartVal;%restart
        updateStop(1:numNodes,1) = 1;
    else 
        updateStopDisplayFlag(lengthCounter,1:numNodes)= updateStopDisplayFlagCurrent(lengthCounter,1:numNodes);%no change
        updateStop(1:numNodes,1) = updateStopCurrent(1:numNodes,1);
    end;
     %check to restart
     for i = 1:numNodes
        %if currentStd(i,lengthCounter+1) > (lastStoppedStd(i) + stdMargin)
        if currentStd(i,lengthCounter) > (lastStoppedStd(i) + stdMargin)
        updateStopDisplayFlag(lengthCounter,i)= displayStartVal;%restart
        updateStop(i,1) = 1;
        end
     end
    
end%restartUpdateEnable
end %end mode



end

