%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Jennifer Jackson 2017                                                        %
% A Biodiversity Approach to Cyber Security                                    %
% PhD Complexity Science                                                       %
% University of Warwick                                                        %
% http://wrap.warwick.ac.uk/98458                                              %
% This software is distributed under the  Creative Commons Attribution License %
% https://creativecommons.org/licenses/by/4.0/                                 %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function saveAsBinary
%testing saving output data as binary file
clear('all');
close('all');


fileDirectory = 'unused\';
fileName = 'complex_adj.bin';
fileLocation = [fileDirectory fileName];

%test data
outputs.numNodes = 10;
outputs.numRuns = 1;
outputs.numTimeSteps = 1000;
outputs.len_apps = 8;
outputs.len_serv = 8;
outputs.len_os = 2;
outputs.len_dr = 8;
outputs.CD_apps = [25 40 10 5 10 5 3 2];
outputs.CD_serv = [70 5 3 2 5 5 5 5];
outputs.CD_os = [80 20];
outputs.CD_dr = [50 20 5 5 10 5 3 2];
outputs.ChangeDesirabilitiesFlag=1;
outputs.tChange1=300;
outputs.tChange2=600;
outputs.CD_apps2 = [25 40 10 5 10 5 3 2];
outputs.CD_serv2 = [70 5 3 2 5 5 5 5];
outputs.CD_os2 = [80 20];
outputs.CD_dr2 = [50 20 5 5 10 5 3 2];
outputs.E_apps = [65 75 55 50 60 60 60 80];
outputs.E_serv = [65 66 67 63 59 62 72 77];
outputs.E_os = [70 80];
outputs.E_dr = [70 80 60 75 69 68 63 58];
outputs.Genotype_apps = [0 1 0 0 0 0 0 0,
                 0 1 0 0 0 0 0 0,
                 1 0 0 0 0 0 0 0,
                 0 1 0 0 0 0 0 0,
                 0 0 0 0 1 0 0 0,
                 0 0 0 0 1 0 0 0,
                 0 0 0 0 0 0 0 1,
                 0 1 0 0 0 0 0 0,
                 1 0 0 0 0 0 0 0,
                 0 0 0 0 0 0 0 1];           
outputs.Genotype_serv = [1 0 0 0 0 0 0 0,
                 1 0 0 0 0 0 0 0,
                 1 0 0 0 0 0 0 0,
                 1 0 0 0 0 0 0 0,
                 0 0 0 0 0 0 0 1,
                 0 0 0 0 0 0 0 1,
                 0 0 0 0 0 0 0 1,
                 0 1 0 0 0 0 0 0,
                 0 1 0 0 0 0 0 0,
                 0 0 0 0 0 0 0 1];             
outputs.Genotype_os = [1 0,
               1 0,
               1 0,
               1 0,
               0 1,
               0 1,
               1 0,
               1 0,
               1 0,
               0 1];           
 outputs.Genotype_dr = [1 0 0 0 0 0 0 0,
                0 1 0 0 0 0 0 0,
                0 1 0 0 0 0 0 0,
                0 1 0 0 0 0 0 0,
                0 0 0 0 0 0 1 0,
                0 0 0 0 0 0 0 1,
                0 0 0 1 0 0 0 0,
                0 1 0 0 0 0 0 0,
                0 1 0 0 0 0 0 0,
                0 0 0 1 0 0 0 0];           
SW_freq_apps = ['a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'];
SW_freq_serv = ['s', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'];
SW_freq_os = ['o', 'V'; 'o', 'V'];
SW_freq_dr = ['d', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'];
outputs.textdata = [SW_freq_apps; SW_freq_serv; SW_freq_os; SW_freq_dr];
outputs.ID_apps = [25 40 10 5 10 5 3 2,
           20 70 1 1  5 1 1 1,
           70 20 1 1 5 1 1 1,
           39 48 5 3 2 1 1 1,
           5 10 3 2 60 15 13 2,
           1 1 5 5 48 19 20 1,
           10 15 10 15 10 10 10 20,
           20 35 3 2 10 10 5 15,
           57 10 1 1 5 5 1 20,
           10 15 10 15 10 10 10 20]             
outputs.ID_serv = [70 5 3 2 5 5 5 5,
           70 5 3 2 5 5 5 5,
           60 15 3 2 5 5 5 5,
           67 7 3 2 5 1 5 10,
           5 8 7 5 13 17 20 30,
           5 8 7 5 13 17 20 30,
           12 13 12 13 12 12 12 14,
           12 23 12 13 12 12 2 14,
           12 33 12 13 12 12 2 14,
           12 13 12 13 12 12 12 14] ;                               
outputs.ID_os = [80 20,
         90 10,
         90 10,
         97 3,
         20 80,
         10 90,
         50 50,
         60 40,
         70 30,
         50 50] ;       
outputs.ID_dr = [50 20 5 5 10 5 3 2,
         20 50 10 10 4 3 1 2,
         20 50 10 10 4 3 1 2,
         1 86 5 2 1 1 1 3,
         1 2 1 18 18 20 20 20,
         1 2 1 8 18 20 20 30 ,
         10 15 5 20 10 15 10 15,
         10 25 15 10 10 10 10 10,           
         10 35 15 10 5 10 5 10,
         10 15 5 20 13 13 12 12];     
outputs.Nei_sol1 = ones(outputs.numRuns,outputs.numTimeSteps); 
outputs.Nei_sol2 = zeros(outputs.numRuns,outputs.numTimeSteps);
outputs.Nei_sol3 = ones(outputs.numRuns,outputs.numTimeSteps);
outputs.Nei_sol4 = zeros(outputs.numRuns,outputs.numTimeSteps);
outputs.Nei_sol5 = ones(outputs.numRuns,outputs.numTimeSteps);
outputs.nodesDiversity4 = zeros(outputs.numNodes,outputs.numTimeSteps+1);
outputs.nodesMean4= ones(outputs.numNodes,outputs.numTimeSteps+1);
outputs.nodesStd4 = zeros(outputs.numNodes,outputs.numTimeSteps+1);
outputs.updateStopDisplay4 = ones(outputs.numNodes,outputs.numTimeSteps);
outputs.minstd4Tolerance = 0.3;
outputs.maxstd4Tolerance = 0.17;
outputs.minStd4Curve= ones(outputs.numNodes,1);
outputs.updateStopDisplay5 = zeros(outputs.numNodes,outputs.numTimeSteps);            
outputs.nodesStd5 = ones(outputs.numNodes,outputs.numTimeSteps+1);
outputs.minstd5Tolerance = 0.5;
outputs.maxstd5Tolerance = 0.19;
outputs.minStd5Curve= ones(outputs.numNodes,1);
outputs.turnOnSol1 = 0;
outputs.turnOnSol2 = 1;
outputs.turnOnSol3 = 0;
outputs.turnOnSol4 = 1;
outputs.turnOnSol5 = 0;

%test save binary file
fid=fopen(fileLocation, 'w');
saveOutputs1SimBinary(fid, outputs)
fclose(fid);

%test read binary file
fid=fopen(fileLocation, 'r');
outputs2 = loadOutputs1SimBinary(fid)
fclose(fid);
textDatachar=outputs2.textdata 




