%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Jennifer Jackson 2017                                                        %
% A Biodiversity Approach to Cyber Security                                    %
% PhD Complexity Science                                                       %
% University of Warwick                                                        %
% http://wrap.warwick.ac.uk/98458                                              %
% This software is distributed under the  Creative Commons Attribution License %
% https://creativecommons.org/licenses/by/4.0/                                 %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%        %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function saveOutputs1Sim(fid, outputs)

%save output data from 1 simulation

%save to file
fprintf(fid, '%s\n', 'numNodes');
fprintf(fid, '%d\n', outputs.numNodes);
fprintf(fid, '%s\n', 'numRuns');
fprintf(fid, '%d\n', outputs.numRuns);
fprintf(fid, '%s\n', 'numTimeSteps');
fprintf(fid, '%d\n', outputs.numTimeSteps);
fprintf(fid, '%s\n', 'len_apps');
fprintf(fid, '%d\n', outputs.len_apps);
fprintf(fid, '%s\n', 'len_serv');
fprintf(fid, '%d\n',  outputs.len_serv);
fprintf(fid, '%s\n', 'len_os');
fprintf(fid, '%d\n', outputs.len_os);
fprintf(fid, '%s\n', 'len_dr');
fprintf(fid, '%d\n', outputs.len_dr);
fprintf(fid, '%s\n', 'CD_apps');
fprintf(fid, '%d ', outputs.CD_apps);
fprintf(fid, '\n%s\n', 'CD_serv');
fprintf(fid, '%d ', outputs.CD_serv);
fprintf(fid, '\n%s\n', 'CD_os');
fprintf(fid, '%d ', outputs.CD_os);
fprintf(fid, '\n%s\n', 'CD_dr');
fprintf(fid, '%d ', outputs.CD_dr);
fprintf(fid, '\n%s\n', 'ChangeDesirabilitiesFlag');
fprintf(fid, '%d\n', outputs.ChangeDesirabilitiesFlag);
fprintf(fid, '%s\n', 'tChange1');
fprintf(fid, '%d\n', outputs.tChange1);
fprintf(fid, '%s\n', 'tChange2');
fprintf(fid, '%d\n', outputs.tChange2);
fprintf(fid, '%s\n', 'CD_apps2');
fprintf(fid, '%d ', outputs.CD_apps2);
fprintf(fid, '\n%s\n', 'CD_serv2');
fprintf(fid, '%d ', outputs.CD_serv2);
fprintf(fid, '\n%s\n', 'CD_os2');
fprintf(fid, '%d ', outputs.CD_os2);
fprintf(fid, '\n%s\n', 'CD_dr2');
fprintf(fid, '%d ', outputs.CD_dr2);
fprintf(fid, '\n%s\n', 'E_apps');
fprintf(fid, '%d ', outputs.E_apps);
fprintf(fid, '\n%s\n', 'E_serv');
fprintf(fid, '%d ', outputs.E_serv);
fprintf(fid, '\n%s\n', 'E_os');
fprintf(fid, '%d ', outputs.E_os);
fprintf(fid, '\n%s\n', 'E_dr');
fprintf(fid, '%d ', outputs.E_dr);
%%%%New code inserted 27th November
fprintf(fid, '\n%s\n', 'ChangeEffFlag');
fprintf(fid, '%d\n', outputs.ChangeEffFlag);
fprintf(fid, '%s\n', 'tChangeEff1');
fprintf(fid, '%d\n', outputs.tChangeEff1);
fprintf(fid, '%s\n', 'tChangeEff2');
fprintf(fid, '%d\n', outputs.tChangeEff2);
fprintf(fid, '%s\n', 'E_apps2');
fprintf(fid, '%d ', outputs.E_apps2);
fprintf(fid, '\n%s\n', 'E_serv2');
fprintf(fid, '%d ', outputs.E_serv2);
fprintf(fid, '\n%s\n', 'E_os2');
fprintf(fid, '%d ', outputs.E_os2);
fprintf(fid, '\n%s\n', 'E_dr2');
fprintf(fid, '%d ', outputs.E_dr2);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
fprintf(fid, '\n%s\n', 'Genotype_apps');
genosize_apps = size(outputs.Genotype_apps);
for j = 1:genosize_apps(1)
 for i = 1:genosize_apps(2)
 fprintf(fid,'%d ', outputs.Genotype_apps(j,i));
 end
fprintf(fid,'\n');
end
fprintf(fid, '%s\n', 'Genotype_serv');
genosize_serv = size(outputs.Genotype_serv);
for j = 1:genosize_serv(1)
 for i = 1:genosize_serv(2)
 fprintf(fid,'%d ', outputs.Genotype_serv(j,i));
 end
fprintf(fid,'\n');
end
fprintf(fid, '%s\n', 'Genotype_os');
genosize_os = size(outputs.Genotype_os);
for j = 1:genosize_os(1)
 for i = 1:genosize_os(2)
 fprintf(fid,'%d ', outputs.Genotype_os(j,i));
 end
fprintf(fid,'\n');
end
fprintf(fid, '%s\n', 'Genotype_dr');
genosize_dr = size(outputs.Genotype_dr);
for j = 1:genosize_dr(1)
 for i = 1:genosize_dr(2)
 fprintf(fid,'%d ', outputs.Genotype_dr(j,i));
 end
fprintf(fid,'\n');
end
fprintf(fid, '%s\n', 'textdata');
size_textdata = size(outputs.textdata);
for j = 1:size_textdata(1)
 for i = 1:size_textdata(2)
 fprintf(fid,'%s', outputs.textdata(j,i));
 end
fprintf(fid,'\n');
end
fprintf(fid, '%s\n', 'ID_apps');
size_ID_apps = size(outputs.ID_apps);
for j = 1: size_ID_apps(1)
 for i = 1:size_ID_apps(2)
 fprintf(fid,'%d ', outputs.ID_apps(j,i));
 end
fprintf(fid,'\n');
end
fprintf(fid, '%s\n', 'ID_serv');
size_ID_serv = size(outputs.ID_serv);
for j = 1: size_ID_serv(1)
 for i = 1:size_ID_serv(2)
 fprintf(fid,'%d ', outputs.ID_serv(j,i));
 end
fprintf(fid,'\n');
end
fprintf(fid, '%s\n', 'ID_os');
size_ID_os = size(outputs.ID_os);
for j = 1: size_ID_os(1)
 for i = 1:size_ID_os(2)
 fprintf(fid,'%d ', outputs.ID_os(j,i));
 end
fprintf(fid,'\n');
end
fprintf(fid, '%s\n', 'ID_dr');
size_ID_dr = size(outputs.ID_dr);
for j = 1: size_ID_dr(1)
 for i = 1:size_ID_dr(2)
 fprintf(fid,'%d ', outputs.ID_dr(j,i));
 end
fprintf(fid,'\n');
end
%%%%%%%%%%%%%%%%%new code inserted - 27th November
fprintf(fid, '%s\n', 'ChangeIndDesirabilitiesFlag');
fprintf(fid, '%d\n', outputs.ChangeIndDesirabilitiesFlag);
fprintf(fid, '%s\n', 'tChangeInd1');
fprintf(fid, '%d\n', outputs.tChangeInd1);
fprintf(fid, '%s\n', 'tChangeInd2');
fprintf(fid, '%d\n', outputs.tChangeInd2);
fprintf(fid, '%s\n', 'ID_apps2');
size_ID_apps2 = size(outputs.ID_apps2);
for j = 1: size_ID_apps2(1)
 for i = 1:size_ID_apps2(2)
 fprintf(fid,'%d ', outputs.ID_apps2(j,i));
 end
fprintf(fid,'\n');
end
fprintf(fid, '%s\n', 'ID_serv2');
size_ID_serv2 = size(outputs.ID_serv2);
for j = 1: size_ID_serv2(1)
 for i = 1:size_ID_serv2(2)
 fprintf(fid,'%d ', outputs.ID_serv2(j,i));
 end
fprintf(fid,'\n');
end
fprintf(fid, '%s\n', 'ID_os2');
size_ID_os2 = size(outputs.ID_os2);
for j = 1: size_ID_os2(1)
 for i = 1:size_ID_os2(2)
 fprintf(fid,'%d ', outputs.ID_os2(j,i));
 end
fprintf(fid,'\n');
end
fprintf(fid, '%s\n', 'ID_dr2');
size_ID_dr2 = size(outputs.ID_dr2);
for j = 1: size_ID_dr2(1)
 for i = 1:size_ID_dr2(2)
 fprintf(fid,'%d ', outputs.ID_dr2(j,i));
 end
fprintf(fid,'\n');
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
fprintf(fid, '%s\n', 'Nei_sol1');
Nei_sol1=outputs.Nei_sol1'; %change due to size writing to file
size_Nei_sol1 = size(Nei_sol1);
for j = 1: size_Nei_sol1(1)
 for i = 1:size_Nei_sol1(2)
 fprintf(fid,'%d ', Nei_sol1(j,i));
 end
fprintf(fid,'\n');
end
fprintf(fid, '%s\n', 'Nei_sol2');
Nei_sol2=outputs.Nei_sol2'; %change due to size writing to file
size_Nei_sol2 = size(Nei_sol2);
for j = 1: size_Nei_sol2(1)
 for i = 1:size_Nei_sol2(2)
 fprintf(fid,'%d ', Nei_sol2(j,i));
 end
fprintf(fid,'\n');
end
fprintf(fid, '%s\n', 'Nei_sol3');
Nei_sol3=outputs.Nei_sol3'; %change due to size writing to file
size_Nei_sol3 = size(Nei_sol3);
for j = 1: size_Nei_sol3(1)
 for i = 1:size_Nei_sol3(2)
 fprintf(fid,'%d ', Nei_sol3(j,i));
 end
fprintf(fid,'\n');
end
fprintf(fid, '%s\n', 'Nei_sol4');
Nei_sol4=outputs.Nei_sol4'; %change due to size writing to file
size_Nei_sol4 = size(Nei_sol4);
for j = 1: size_Nei_sol4(1)
 for i = 1:size_Nei_sol4(2)
 fprintf(fid,'%d ', Nei_sol4(j,i));
 end
fprintf(fid,'\n');
end
fprintf(fid, '%s\n', 'Nei_sol5');
Nei_sol5=outputs.Nei_sol5'; %change due to size writing to file
size_Nei_sol5 = size(Nei_sol5);
for j = 1: size_Nei_sol5(1)
 for i = 1:size_Nei_sol5(2)
 fprintf(fid,'%d ', Nei_sol5(j,i));
 end
fprintf(fid,'\n');
end
fprintf(fid, '%s\n', 'nodesDiversity4');
nodesDiversity4=outputs.nodesDiversity4'; %change due to size writing to file
size_nodesDiversity4 = size(nodesDiversity4);
for j = 1: size_nodesDiversity4(1)
 for i = 1:size_nodesDiversity4(2)
 fprintf(fid,'%d ', nodesDiversity4(j,i));
 end
fprintf(fid,'\n');
end
fprintf(fid, '%s\n', 'nodesMean4');
nodesMean4=outputs.nodesMean4'; %change due to size writing to file
size_nodesMean4 = size(nodesMean4);
for j = 1: size_nodesMean4(1)
 for i = 1:size_nodesMean4(2)
 fprintf(fid,'%d ', nodesMean4(j,i));
 end
fprintf(fid,'\n');
end
fprintf(fid, '%s\n', 'nodesStd4');
nodesStd4=outputs.nodesStd4'; %change due to size writing to file
size_nodesStd4 = size(nodesStd4);
for j = 1: size_nodesStd4(1)
 for i = 1:size_nodesStd4(2)
 fprintf(fid,'%d ', nodesStd4(j,i));
 end
fprintf(fid,'\n');
end
fprintf(fid, '%s\n', 'updateStopDisplay4');
size_updateStopDisplay4 = size(outputs.updateStopDisplay4);
for j = 1: size_updateStopDisplay4(1)
 for i = 1:size_updateStopDisplay4(2)
 fprintf(fid,'%d ', outputs.updateStopDisplay4(j,i));
 end
fprintf(fid,'\n');
end
fprintf(fid, '%s\n', 'minstd4Tolerance');
fprintf(fid, '%d\n', outputs.minstd4Tolerance);
fprintf(fid, '%s\n', 'maxstd4Tolerance');
fprintf(fid, '%d\n', outputs.maxstd4Tolerance);
fprintf(fid, '%s\n', 'minStd4Curve');
fprintf(fid, '%d ', outputs.minStd4Curve);
fprintf(fid, '\n%s\n', 'updateStopDisplay5');
size_updateStopDisplay5 = size(outputs.updateStopDisplay5);
for j = 1: size_updateStopDisplay5(1)
 for i = 1:size_updateStopDisplay5(2)
 fprintf(fid,'%d ', outputs.updateStopDisplay5(j,i));
 end
fprintf(fid,'\n');
end
fprintf(fid, '%s\n', 'nodesStd5');
nodesStd5=outputs.nodesStd5'; %change due to size writing to file
size_nodesStd5 = size(nodesStd5);
for j = 1: size_nodesStd5(1)
 for i = 1:size_nodesStd5(2)
 fprintf(fid,'%d ', nodesStd5(j,i));
 end
fprintf(fid,'\n');
end
fprintf(fid, '%s\n', 'minstd5Tolerance');
fprintf(fid, '%d\n', outputs.minstd5Tolerance);
fprintf(fid, '%s\n', 'maxstd5Tolerance');
fprintf(fid, '%d\n', outputs.maxstd5Tolerance);
fprintf(fid, '%s\n', 'minStd5Curve');
fprintf(fid, '%d ', outputs.minStd5Curve);
fprintf(fid, '\n%s\n', 'turnOnSol1');
fprintf(fid, '%d\n', outputs.turnOnSol1);
fprintf(fid, '%s\n', 'turnOnSol2');
fprintf(fid, '%d\n', outputs.turnOnSol2);
fprintf(fid, '%s\n', 'turnOnSol3');
fprintf(fid, '%d\n', outputs.turnOnSol3);
fprintf(fid, '%s\n', 'turnOnSol4');
fprintf(fid, '%d\n', outputs.turnOnSol4);
fprintf(fid, '%s\n', 'turnOnSol5');
fprintf(fid, '%d\n', outputs.turnOnSol5);
%new code added 4th December 2014
fprintf(fid, '%s\n', 'lastStoppedStdMatrix');
lastStoppedStdMatrix=outputs.lastStoppedStdMatrix'; %change due to size writing to file
size_lastStoppedStdMatrix = size(lastStoppedStdMatrix);
for j = 1: size_lastStoppedStdMatrix(1)
 for i = 1:size_lastStoppedStdMatrix(2)
 fprintf(fid,'%d ', lastStoppedStdMatrix(j,i));
 end
fprintf(fid,'\n');
end
fprintf(fid, '%s\n', 'lastStoppedStdMatrix2');
lastStoppedStdMatrix2=outputs.lastStoppedStdMatrix2'; %change due to size writing to file
size_lastStoppedStdMatrix2 = size(lastStoppedStdMatrix2);
for j = 1: size_lastStoppedStdMatrix2(1)
 for i = 1:size_lastStoppedStdMatrix2(2)
 fprintf(fid,'%d ', lastStoppedStdMatrix2(j,i));
 end
fprintf(fid,'\n');
end
fprintf(fid, '%s\n', 'stdMargin');
fprintf(fid, '%d\n', outputs.stdMargin);
fwrite(fid,outputs.Nei_indDynamic,'double');
fprintf(fid, '%s\n', 'Nei_indDynamic');
Nei_indDynamic=outputs.Nei_indDynamic';
size_Nei_indDynamic = size(Nei_indDynamic);
for j = 1: size_Nei_indDynamic(1)
 for i = 1:size_Nei_indDynamic(2)
 fprintf(fid,'%d ', Nei_indDynamic(j,i));
 end
fprintf(fid,'\n');
end
fprintf(fid, '%s\n', 'singleStopMode');
fprintf(fid, '%d\n', outputs.singleStopMode);
fprintf(fid, '%s\n', 'restartMode');
fprintf(fid, '%d\n', outputs.restartMode);
fprintf(fid, '%s\n', 'ChangeOwnIndDesirabilitiesFlag');
fprintf(fid, '%d\n', outputs.ChangeOwnIndDesirabilitiesFlag)
 
 