%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Jennifer Jackson 2017                                                        %
% A Biodiversity Approach to Cyber Security                                    %
% PhD Complexity Science                                                       %
% University of Warwick                                                        %
% http://wrap.warwick.ac.uk/98458                                              %
% This software is distributed under the  Creative Commons Attribution License %
% https://creativecommons.org/licenses/by/4.0/                                 %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function saveOutputs1SimBinary(fid, outputs)
%write data as binary format
fwrite(fid,outputs.numNodes,'double');
fwrite(fid,outputs.numRuns,'double');
fwrite(fid,outputs.numTimeSteps,'double');
fwrite(fid,outputs.len_apps,'double');
fwrite(fid,outputs.len_serv,'double');
fwrite(fid,outputs.len_os,'double');
fwrite(fid,outputs.len_dr,'double');
fwrite(fid,outputs.CD_apps,'double');
fwrite(fid,outputs.CD_serv,'double');
fwrite(fid,outputs.CD_os,'double');
fwrite(fid,outputs.CD_dr,'double');
fwrite(fid,outputs.ChangeDesirabilitiesFlag,'double');
fwrite(fid,outputs.tChange1,'double');
fwrite(fid,outputs.tChange2,'double');
fwrite(fid,outputs.CD_apps2,'double');
fwrite(fid,outputs.CD_serv2,'double');
fwrite(fid,outputs.CD_os2,'double');
fwrite(fid,outputs.CD_dr2,'double');
fwrite(fid,outputs.E_apps,'double');
fwrite(fid,outputs.E_serv,'double');
fwrite(fid,outputs.E_os,'double');
fwrite(fid,outputs.E_dr,'double');
%new code added 27th Nov 2014
fwrite(fid,outputs.ChangeEffFlag,'double');
fwrite(fid,outputs.tChangeEff1,'double');
fwrite(fid,outputs.tChangeEff2,'double');
fwrite(fid,outputs.E_apps2,'double');
fwrite(fid,outputs.E_serv2,'double');
fwrite(fid,outputs.E_os2,'double');
fwrite(fid,outputs.E_dr2,'double');
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
fwrite(fid,outputs.Genotype_apps,'double');
fwrite(fid,outputs.Genotype_serv,'double');
fwrite(fid,outputs.Genotype_os,'double');
fwrite(fid,outputs.Genotype_dr,'double');
fwrite(fid,outputs.textdata,'uchar');
fwrite(fid,outputs.ID_apps,'double');
fwrite(fid,outputs.ID_serv,'double');
fwrite(fid,outputs.ID_os,'double');
fwrite(fid,outputs.ID_dr,'double');
%new code added 27th Nov 2014
fwrite(fid,outputs.ChangeIndDesirabilitiesFlag,'double');
fwrite(fid,outputs.tChangeInd1,'double');
fwrite(fid,outputs.tChangeInd2,'double');
fwrite(fid,outputs.ID_apps2,'double');
fwrite(fid,outputs.ID_serv2,'double');
fwrite(fid,outputs.ID_os2,'double');
fwrite(fid,outputs.ID_dr2,'double');
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%fwrite(fid,outputs.Nei_sol1,'double');
%fwrite(fid,outputs.Nei_sol2,'double');
%fwrite(fid,outputs.Nei_sol3,'double');
fwrite(fid,outputs.Nei_sol4,'double');
fwrite(fid,outputs.Nei_sol5,'double');
disp('saveOutputs1simBinary')
outputsnodesDiversity4size = size(outputs.nodesDiversity4)
fwrite(fid,outputs.nodesDiversity4,'double');
fwrite(fid,outputs.nodesMean4,'double');
fwrite(fid,outputs.nodesStd4,'double');
fwrite(fid,outputs.updateStopDisplay4,'double');
fwrite(fid,outputs.minstd4Tolerance,'double');
fwrite(fid,outputs.maxstd4Tolerance,'double');
fwrite(fid,outputs.minStd4Curve,'double');
fwrite(fid,outputs.updateStopDisplay5,'double');
fwrite(fid,outputs.nodesStd5,'double');
fwrite(fid,outputs.minstd5Tolerance,'double');
fwrite(fid,outputs.maxstd5Tolerance,'double');
fwrite(fid,outputs.minStd5Curve,'double');
fwrite(fid,outputs.turnOnSol1,'double');
fwrite(fid,outputs.turnOnSol2,'double');
fwrite(fid,outputs.turnOnSol3,'double');
fwrite(fid,outputs.turnOnSol4,'double');
fwrite(fid,outputs.turnOnSol5,'double');
%New code added 4th Dec
fwrite(fid,outputs.lastStoppedStdMatrix,'double');
fwrite(fid,outputs.lastStoppedStdMatrix2,'double');
fwrite(fid,outputs.stdMargin,'double');
fwrite(fid,outputs.Nei_indDynamic,'double');
fwrite(fid,outputs.singleStopMode,'double');
fwrite(fid,outputs.restartMode,'double');
fwrite(fid,outputs.ChangeOwnIndDesirabilitiesFlag,'double');
%enable properties added - sept 2015
fwrite(fid,outputs.datasetEnable,'double');
fwrite(fid,outputs.datasetNumber,'double');
fwrite(fid,outputs.datasetStaticEnable,'double'); %added 31st March 2016
fwrite(fid,outputs.datasetStaticNumber,'double'); %added 31st March 2016

fwrite(fid,outputs.networkModelEnable,'double');
fwrite(fid,outputs.networkModelV,'double');
fwrite(fid,outputs.attackModelEnable,'double');
fwrite(fid,outputs.attackModelV,'double');
fwrite(fid,outputs.exploitEnable,'double');
fwrite(fid,outputs.exploitTypeV,'double');
fwrite(fid,outputs.algModelEnable,'double');
fwrite(fid,outputs.algModelV,'double');
fwrite(fid,outputs.networkPerfEnable,'double');
fwrite(fid,outputs.perfModelV,'double');

%For testing
%sizeoutputsIDapps=size(outputs.ID_apps)
%outputsID_apps=outputs.ID_apps
%outputsturnOnSol1=outputs.turnOnSol1
%outputsturnOnSol2=outputs.turnOnSol2
%outputsturnOnSol3=outputs.turnOnSol3
%outputsturnOnSol4=outputs.turnOnSol4
%outputsturnOnSol5=outputs.turnOnSol5
%sizelaststopped = size(outputs.lastStoppedStdMatrix)
%sizelaststopped2 = size(outputs.lastStoppedStdMatrix2)
%outputsstdMargin = outputs.stdMargin
%outputsNei_indDynamic=outputs.Nei_indDynamic
%outputssingleStopMode=outputs.singleStopMode
%outputsrestartMode=outputs.restartMode
%outputsChangeOwnIndDesirabilitiesFlag=outputs.ChangeOwnIndDesirabilitiesFlag
%outputsdatasetEnable=outputs.datasetEnable
%outputsdatasetNumber=outputs.datasetNumber
%outputsdatasetStaticEnable=outputs.datasetStaticEnable
%outputsdatasetStaticNumber=outputs.datasetStaticNumber
%outputsnetworkModelEnable = outputs.networkModelEnable
%outputsnetworkModelV = outputs.networkModelV
%outputsattackModelEnable = outputs.attackModelEnable
%outputsattackModelV = outputs.attackModelV
%outputsexploitEnable = outputs.exploitEnable
%outputsexploitTypeV = outputs.exploitTypeV
%outputsalgModelEnable = outputs.algModelEnable
%outputsalgModelV = outputs.algModelV
%outputsnetworkPerfEnable = outputs.networkPerfEnable
%outputsperfModelV = outputs.perfModelV



%random waypoint animation
if and(outputs.networkModelEnable,strcmp(outputs.networkModelS,'Random Waypoint'))
%x and y waypoints
for nodeIndex = 1:outputs.numNodes
   fwrite(fid,outputs.vs_node(nodeIndex).v_x(1:outputs.numTimeSteps), 'double'); %structure
   fwrite(fid,outputs.vs_node(nodeIndex).v_y(1:outputs.numTimeSteps), 'double'); %structure
end
end
%attack model outputs
if outputs.attackModelEnable == 1
  %  disp('save outputs file')
    
%datasetEnable=    outputs.datasetEnable
%datasetNumber=outputs.datasetNumber
%networkModelEnable=outputs.networkModelEnable
%networkModelV=outputs.networkModelV
%attackModelEnable=outputs.attackModelEnable
%attackModelV=outputs.attackModelV
%exploitEnable=outputs.exploitEnable
%exploitTypeV=outputs.exploitTypeV
%algModelEnable=outputs.algModelEnable
%algModelV=outputs.algModelV
%networkPerfEnable=outputs.networkPerfEnable
%perfModelV=outputs.perfModelV
    
    
    
    
    %numStates = outputs.numStates
fwrite(fid,outputs.numStates,'double');
fwrite(fid,outputs.sumOfStates,'double');
%outputs.allRunsNodeStateAtTime
for runNumber = 1:outputs.numRuns
    temp1.nodeStateAtTimeStr = outputs.allRunsNodeStateAtTime(runNumber).nodeStateAtTimeStr;
    for t = 1:outputs.numTimeSteps
      temp2 = char(temp1.nodeStateAtTimeStr(t,:)); %convert from cellstr to char for fwrite
      fwrite(fid,temp2, 'char');%structure
    end
end
for runNumber = 1:outputs.numRuns
  temp1.nodeStateAtTimeNumber = outputs.allRunsNodeStateAtTime(runNumber).nodeStateAtTimeNumber;
  fwrite(fid,temp1.nodeStateAtTimeNumber,'double');%structure
end
end

%added 31st March 2016
%SingleLocus_sol4 = zeros(numRunsPerSim,numTimeSteps,numLoci);
%SingleLocus_sol5 = zeros(numRunsPerSim,numTimeSteps,numLoci);
for runNumber = 1:outputs.numRuns
    SingleLocus_sol4Temp(:,:) = outputs.neiIndexSingleLocus_sol4(runNumber,:,:);
    fwrite(fid,SingleLocus_sol4Temp,'double');
end
for runNumber = 1:outputs.numRuns
    SingleLocus_sol5Temp(:,:) = outputs.neiIndexSingleLocus_sol5(runNumber,:,:);
    fwrite(fid,SingleLocus_sol5Temp,'double');
end
%GenoSim_sol4 = zeros(numRunsPerSim,numTimeSteps,numNodes,numVariants); 
%GenoSim_sol5 = zeros(numRunsPerSim,numTimeSteps,numNodes,numVariants);
for runNumber = 1:outputs.numRuns
    for nodeNumber = 1:outputs.numNodes
        genoTemp4(:,:) = outputs.GenoSim_sol4(runNumber,:,nodeNumber,:);
        fwrite(fid,genoTemp4,'double');
    end
end
for runNumber = 1:outputs.numRuns
    for nodeNumber = 1:outputs.numNodes
        genoTemp5(:,:) = outputs.GenoSim_sol5(runNumber,:,nodeNumber,:);
        fwrite(fid,genoTemp5,'double');
    end
end
%ohandles.beta = zeros(ihandles.numRunsPerSim,ihandles.numTimeSteps);
fwrite(fid,outputs.beta,'double');
savebeta = outputs.beta;
return;


