%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Jennifer Jackson 2017                                                        %
% A Biodiversity Approach to Cyber Security                                    %
% PhD Complexity Science                                                       %
% University of Warwick                                                        %
% http://wrap.warwick.ac.uk/98458                                              %
% This software is distributed under the  Creative Commons Attribution License %
% https://creativecommons.org/licenses/by/4.0/                                 %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function varargout = saveSettings(varargin)
% SAVESETTINGS MATLAB code for saveSettings.fig
%      SAVESETTINGS, by itself, creates a new SAVESETTINGS or raises the existing
%      singleton*.
%
%      H = SAVESETTINGS returns the handle to a new SAVESETTINGS or the handle to
%      the existing singleton*.
%
%      SAVESETTINGS('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in SAVESETTINGS.M with the given input arguments.
%
%      SAVESETTINGS('Property','Value',...) creates a new SAVESETTINGS or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before saveSettings_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to saveSettings_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help saveSettings

% Last Modified by GUIDE v2.5 23-Mar-2015 10:50:04

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @saveSettings_OpeningFcn, ...
                   'gui_OutputFcn',  @saveSettings_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before saveSettings is made visible.
function saveSettings_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to saveSettings (see VARARGIN)

% Choose default command line output for saveSettings
handles.output = hObject;

%varargin
handles.main = varargin{1}; %save handles from main figure

%set save file type default as multiple files
set(handles.radiobuttonSaveSettings1File, 'Value', 0)
set(handles.radiobuttonSaveSettingsMultipleFiles, 'Value', 1)

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes saveSettings wait for user response (see UIRESUME)
% uiwait(handles.figureSaveSettings);


% --- Outputs from this function are returned to the command line.
function varargout = saveSettings_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes when user attempts to close figureSaveSettings.
function figureSaveSettings_CloseRequestFcn(hObject, eventdata, handles)
% hObject    handle to figureSaveSettings (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: delete(hObject) closes the figure
delete(hObject);



function editSaveAs_Callback(hObject, eventdata, handles)
% hObject    handle to editSaveAs (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of editSaveAs as text
%        str2double(get(hObject,'String')) returns contents of editSaveAs as a double

editSaveAs=get(hObject,'String');
%save to structure
set(handles.editSaveAs,'String',editSaveAs);
% save the changes to the structure
guidata(gcbo,handles);

% --- Executes during object creation, after setting all properties.
function editSaveAs_CreateFcn(hObject, eventdata, handles)
% hObject    handle to editSaveAs (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in pushbuttonSave.
function pushbuttonSave_Callback(hObject, eventdata, handles)
% hObject    handle to pushbuttonSave (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
%popupmenuNumSims
%retreive the number of simulations
numSimsS = cellstr(get(handles.main.popupmenuNumSims,'String'));
numSims = get(handles.main.popupmenuNumSims,'Value');

%names of temp files
%names of settings temp files
directorynameSettings = GUIClass.getDirectoryNameSettings();
settingsTempFileNames = GUIClass.genSettingsTempFileNames(directorynameSettings,numSims);
%*************************
%find currently selected simulation and make sure settings saved first in temp file
settingsSimNumber = get(handles.main.popupmenuSettings, 'Value')
%GUIClass.saveSettingsTempFile(settingsTempFileNames,settingsSimNumber,handles.main);
GUIClass.saveSettingsTempFileMultipleGUIs(settingsTempFileNames,settingsSimNumber,handles.main)
%****************************
%*************************
%find currently selected button to see format of saving settings 
fb1=get(handles.radiobuttonSaveSettings1File,'Value');
fb2=get(handles.radiobuttonSaveSettingsMultipleFiles,'Value');
%get file name for saving
editSaveAs = get(handles.editSaveAs,'String');
if fb1==1
    %save as single file
    disp('function no longer supported')
elseif fb2 ==1
    %save as multiple files
    settingsSaveAsFileNames = GUIClass.genSettingsSaveAsFileNames(editSaveAs,numSims);
    %save copy of temp settings files
    for simNumber = 1:numSims
        copyfile(char(settingsTempFileNames(simNumber)),char(settingsSaveAsFileNames(simNumber)));  
    end
end
%close window
delete(handles.figureSaveSettings)


% --- Executes when selected object is changed in uipanel2.
function uipanel2_SelectionChangeFcn(hObject, eventdata, handles)
% hObject    handle to the selected object in uipanel2 
% eventdata  structure with the following fields (see UIBUTTONGROUP)
%	EventName: string 'SelectionChanged' (read only)
%	OldValue: handle of the previously selected object or empty if none was selected
%	NewValue: handle of the currently selected object
% handles    structure with handles and user data (see GUIDATA)


% --- Executes during object creation, after setting all properties.
function figureSaveSettings_CreateFcn(hObject, eventdata, handles)
% hObject    handle to figureSaveSettings (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called
