%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Jennifer Jackson 2017                                                        %
% A Biodiversity Approach to Cyber Security                                    %
% PhD Complexity Science                                                       %
% University of Warwick                                                        %
% http://wrap.warwick.ac.uk/98458                                              %
% This software is distributed under the  Creative Commons Attribution License %
% https://creativecommons.org/licenses/by/4.0/                                 %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function varargout = saveSimulationOutput(varargin)
% SAVESIMULATIONOUTPUT MATLAB code for saveSimulationOutput.fig
%      SAVESIMULATIONOUTPUT, by itself, creates a new SAVESIMULATIONOUTPUT or raises the existing
%      singleton*.
%
%      H = SAVESIMULATIONOUTPUT returns the handle to a new SAVESIMULATIONOUTPUT or the handle to
%      the existing singleton*.
%
%      SAVESIMULATIONOUTPUT('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in SAVESIMULATIONOUTPUT.M with the given input arguments.
%
%      SAVESIMULATIONOUTPUT('Property','Value',...) creates a new SAVESIMULATIONOUTPUT or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before saveSimulationOutput_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to saveSimulationOutput_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help saveSimulationOutput

% Last Modified by GUIDE v2.5 01-Apr-2015 13:39:35

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @saveSimulationOutput_OpeningFcn, ...
                   'gui_OutputFcn',  @saveSimulationOutput_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before saveSimulationOutput is made visible.
function saveSimulationOutput_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to saveSimulationOutput (see VARARGIN)

% Choose default command line output for saveSimulationOutput
handles.output = hObject;

%varargin
handles.main = varargin{1} %save handles from main figure

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes saveSimulationOutput wait for user response (see UIRESUME)
% uiwait(handles.figureSaveOutput);


% --- Outputs from this function are returned to the command line.
function varargout = saveSimulationOutput_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes when user attempts to close figureSaveOutput.
function figureSaveOutput_CloseRequestFcn(hObject, eventdata, handles)
% hObject    handle to figureSaveOutput (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: delete(hObject) closes the figure
delete(hObject);



function editSaveSimAs_Callback(hObject, eventdata, handles)
% hObject    handle to editSaveSimAs (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of editSaveSimAs as text
%        str2double(get(hObject,'String')) returns contents of editSaveSimAs as a double

editSaveAs=get(hObject,'String');
%save to structure
set(handles.editSaveSimAs,'String',editSaveAs);
% save the changes to the structure
guidata(gcbo,handles);

% --- Executes during object creation, after setting all properties.
function editSaveSimAs_CreateFcn(hObject, eventdata, handles)
% hObject    handle to editSaveSimAs (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in pushbuttonSave.
function pushbuttonSave_Callback(hObject, eventdata, handles)
% hObject    handle to pushbuttonSave (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
%popupmenuNumSims
%names of temp files
%retreive the number of simulations
%numSimsS = cellstr(get(handles.main.popupmenuNumSims,'String'))
%numSims = numSimsS{get(handles.main.popupmenuNumSims,'Value')}

%*************************
%find currently selected button 
rb1=get(handles.radiobuttonSaveOut1File,'Value');
rb2=get(handles.radiobuttonSaveOutMultipleFiles,'Value');
if rb2 == 1
    GUIClass.copyAllOutputs(handles)
else
    disp('save as multiple files only')
end
%close window
delete(handles.figureSaveOutput)

%**************************


% --- Executes when selected object is changed in uipanelFileType.
function uipanelFileType_SelectionChangeFcn(hObject, eventdata, handles)
% hObject    handle to the selected object in uipanelFileType 
% eventdata  structure with the following fields (see UIBUTTONGROUP)
%	EventName: string 'SelectionChanged' (read only)
%	OldValue: handle of the previously selected object or empty if none was selected
%	NewValue: handle of the currently selected object
% handles    structure with handles and user data (see GUIDATA)


% --- Executes during object creation, after setting all properties.
function figureSaveOutput_CreateFcn(hObject, eventdata, handles)
% hObject    handle to figureSaveOutput (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called
set(handles.radiobuttonSaveOut1File,'Enable', 'off')
set(handles.radiobuttonSaveOutMultipleFiles,'Enable', 'on')
