%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Jennifer Jackson 2017                                                        %
% A Biodiversity Approach to Cyber Security                                    %
% PhD Complexity Science                                                       %
% University of Warwick                                                        %
% http://wrap.warwick.ac.uk/98458                                              %
% This software is distributed under the  Creative Commons Attribution License %
% https://creativecommons.org/licenses/by/4.0/                                 %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function [updateStop updateStopDisplayFlag lastStoppedStdNew] = singleStopUpdating(singleStopMode,t,lengthCounter, sampleSize, nodesStd,...
                      numNodes, updateStopDisplayFlagOld,displayStopVal, displayStartVal,minstdTolerance,lastStoppedStdOld)
                                 
%displayStopVal - when the nodes have stopped updating this is the number displayed on the graph
%displayStartVal - when the nodes are updating this is the number displayed on the graph

 
      %STOPPING THE UPDATE PROCESS
     %Code for solution 4 and 5 only
     %*******************************************
if singleStopMode==1 ||singleStopMode==3

  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  %Keep updating until reach minimum threshold
  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  %for each node
 for i = 1:numNodes
 if t < sampleSize
     %keep updating
     updateStopDisplayFlag(lengthCounter,i)= displayStartVal;%keep going
     updateStop(i,1) = 1;
     lastStoppedStdNew(i)= lastStoppedStdOld(i);
 else
     if nodesStd(i,lengthCounter) < minstdTolerance
     %if nodesStd(i,lengthCounter+1) < minstdTolerance
         %stop updating if less than min tolerance and reached minimum
         updateStopDisplayFlag(lengthCounter,i)= displayStopVal;%stop
         updateStop(i,1) = 0;
         %lastStoppedStdNew(i)= nodesStd(i,lengthCounter+1);
         lastStoppedStdNew(i)= nodesStd(i,lengthCounter);
     else
         if updateStopDisplayFlagOld(lengthCounter-1,i)== displayStartVal
             updateStopDisplayFlag(lengthCounter,i)= displayStartVal; %keep going
             updateStop(i,1) = 1;
             lastStoppedStdNew(i)= lastStoppedStdOld(i);
         else
             updateStopDisplayFlag(lengthCounter,i)= displayStopVal; %stop
             updateStop(i,1) = 0;
             %lastStoppedStdNew(i)= nodesStd(i,lengthCounter+1);
             lastStoppedStdNew(i)= nodesStd(i,lengthCounter);
         end; 
     end
 end
 end; %numNodes
elseif singleStopMode == 2 || singleStopMode==4 || singleStopMode==5 || singleStopMode==6
  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  %Keep updating until surpass minimum threshold and reach a minimum
  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%   
     %for each node
 for i = 1:numNodes
 if t < sampleSize
     %keep updating
     updateStopDisplayFlag(lengthCounter,i)= displayStartVal;%keep going
     updateStop(i,1) = 1;
     lastStoppedStdNew(i)= lastStoppedStdOld(i);
 else
     %if (nodesStd(i,lengthCounter+1) < minstdTolerance) && (nodesStd(i,lengthCounter+1) > nodesStd(i,lengthCounter))
     if (nodesStd(i,lengthCounter) < minstdTolerance) && (nodesStd(i,lengthCounter) > nodesStd(i,lengthCounter))
         %stop updating if less than min tolerance and reach minimum
         %check if not yet stopped
         if  updateStopDisplayFlagOld(lengthCounter-1,i)== displayStartVal; %not yet stopped
             %set stop std, as now stopped
             %lastStoppedStdNew(i)= nodesStd(i,lengthCounter+1);
             lastStoppedStdNew(i)= nodesStd(i,lengthCounter);
         else
             %stopped already so keep the old value
             lastStoppedStdNew(i)= lastStoppedStdOld(i);
         end
         %if already stopped continue to stop but dont set a new stopped
         %std value
         updateStopDisplayFlag(lengthCounter,i)= displayStopVal;%stop
         updateStop(i,1) = 0;        
     else
         if updateStopDisplayFlagOld(lengthCounter-1,i)== displayStartVal
             updateStopDisplayFlag(lengthCounter,i)= displayStartVal; %keep going
             updateStop(i,1) = 1;
             lastStoppedStdNew(i)= lastStoppedStdOld(i);
         else
             updateStopDisplayFlag(lengthCounter,i)= displayStopVal; %stop
             updateStop(i,1) = 0;
             %lastStoppedStdNew(i)= nodesStd(i,t+1);
             lastStoppedStdNew(i)= lastStoppedStdOld(i);
             
         end; 
     end
 end
 end; %numNodes      
 end %singleStopMode
end%function
