%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Jennifer Jackson 2017                                                        %
% A Biodiversity Approach to Cyber Security                                    %
% PhD Complexity Science                                                       %
% University of Warwick                                                        %
% http://wrap.warwick.ac.uk/98458                                              %
% This software is distributed under the  Creative Commons Attribution License %
% https://creativecommons.org/licenses/by/4.0/                                 %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function [ minorCalc majorCalc ] = propCalcOutbreaks( Sprop, Bn, gamma )
%calculate proportion of minor and major outbreaks
R0 = Sprop.*Bn./gamma;
for i = 1:size(R0,2)
if R0(i) >= 1
minorCalc(i) = 1./R0(i);
majorCalc(i) = 1-minorCalc(i);
else
minorCalc(i) = 1;
majorCalc(i) = 0;
end
end


end

