%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Jennifer Jackson 2017                                                        %
% A Biodiversity Approach to Cyber Security                                    %
% PhD Complexity Science                                                       %
% University of Warwick                                                        %
% http://wrap.warwick.ac.uk/98458                                              %
% This software is distributed under the  Creative Commons Attribution License %
% https://creativecommons.org/licenses/by/4.0/                                 %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function [ nearestNodeToZero nodeMaskConstrainrwp nodeMaskConstrainrwp_not] = rwpConstrain(t, rwph, xboxc, yboxc, plotGraph)

%If running in geographical constraints mode
%get node nearest origin
%get all nodes in confined box

%get distance from current x and y coordinate
distance = rwph.cx.^2 + rwph.cy.^2; 
%get node nearest origin
[val nearestNodeToZero] = min(distance);

nodeMaskConstrainrwp=zeros(1,rwph.nodes);
nodeMaskConstrainrwp(1:rwph.nodesln)=1; %NODES constrained
nodeMaskConstrainrwp_not = not(nodeMaskConstrainrwp);
%*******************
%NO LONGER USED
%set constrained box area
%xbox=xboxc*rwph.xmax;
%ybox=yboxc*rwph.ymax;
%get nodes within box
%nodeMaskConstrainrwp= and(rwph.cx<=xbox,rwph.cy<=ybox);
%nodes outside box
%nodeMaskConstrainrwp_not = not(nodeMaskConstrainrwp);
%end no longer used
%*********************
if plotGraph == 1
figure
hold on
%plot(rwph.cx(nodeMaskConstrainrwp), rwph.cy(nodeMaskConstrainrwp), 'b+') %constrained
%plot(rwph.cx(nodeMaskConstrainrwp_not), rwph.cy(nodeMaskConstrainrwp_not), 'k+') %not constrained
plot(rwph.cx(1:rwph.nodesln), rwph.cy(1:rwph.nodesln), 'b+') %constrained
plot(rwph.cx(rwph.nodesln+1:end), rwph.cy(rwph.nodesln+1:end), 'k+') %not constrained
plot(rwph.cx(nearestNodeToZero), rwph.cy(nearestNodeToZero), 'r+') %nearest to zero
legend('Constrained','Not constrained', 'Malware source (nearest origin)' )
 axis([rwph.xmin rwph.xmax rwph.ymin rwph.ymax]);
             xlabel('Distance (metres)')
            ylabel('Distance (metres)')
end


end

