%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Jennifer Jackson 2017                                                        %
% A Biodiversity Approach to Cyber Security                                    %
% PhD Complexity Science                                                       %
% University of Warwick                                                        %
% http://wrap.warwick.ac.uk/98458                                              %
% This software is distributed under the  Creative Commons Attribution License %
% https://creativecommons.org/licenses/by/4.0/                                 %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function [SW_str_apps SW_str_serv SW_str_os SW_str_dr ...
          SW_freq_apps SW_freq_serv SW_freq_os SW_freq_dr ...
          CSW1 CSW2 CSW3 CSW4 CSW5 CSW6 CSW7 CSW8 CSW9 CSW10 CSWGroup ...
          Genotype_apps Genotype_serv Genotype_os Genotype_dr ...
          E_apps E_serv E_os E_dr ...
          E_apps2 E_serv2 E_os2 E_dr2 ...
          CD_apps CD_serv CD_os CD_dr ...
          CD_apps2 CD_serv2 CD_os2 CD_dr2 ...
          ID_apps ID_serv ID_os ID_dr ...
          ID_apps2 ID_serv2 ID_os2 ID_dr2 ...
          IDtimeArray1 IDtimeArray2 ...
        ] = getData(dataSetNumber,alignData)

    %set normalisation of data 1->normalise to 1, 100->normalise to 100
    %calcS.m divides CD and ID by 100 so assumes normalisation to 100
    normValE = 100;
    normValCD = 100;
    normValID = 100;
    %alignData is used to align the data to the operating system

   
switch dataSetNumber
    case 1
        %%%%%%%%%%%%%
% set up data - Dataset 1
%%%%%%%%%%%%%
%software strings
%WebBrowser1,6 - commercial products, WebBrowser2,3,4,5 third party
SW_str_apps = ['WebBrowser1v1 ' 'WebBrowser1v2 ' 'WebBrowser2v1 ' 'WebBrowser3v1 ' 'WebBrowser4v1 ' 'WebBrowser5v1 ' 'WebBrowser6v1 ' 'WebBrowser6v4 '];
%All photo viewers about same standard with number 7 slightly better
SW_str_serv = ['PhotoViewer1 ' 'PhotoViewer2 ' 'PhotoViewer3 ' 'PhotoViewer4 ' 'PhotoViewer5 ' 'PhotoViewer6 ' 'PhotoViewer7v1 ' 'PhotoViewer7v2 '];
%OS2 slightly more efficient overall than OS1
SW_str_os = ['OS1 ' 'OS2 '];
%higher versions are better than lower number versions, the commercial
%products are more efficient than the freebies 3rd party
SW_str_dr = ['DataDr1v1 ' 'DataDr1v2 ' 'DataDr2v1 ' 'DataDr3v3 ' 'DataDr4 ' 'DataDr5 ' 'DataDr6 ' 'DataDr7 '];

%software frequency info for running the frequency and nei diversity index
%algorithm
%locusApps - 'a' represents major variants, 'V' represents a minor version
%locusServ - 's' represents major variants, 'V' represents a minor version
%locusOS  - 'o' represents major variants, 'V' represents a minor version
SW_freq_apps = ['a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'];
SW_freq_serv = ['s', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'];
SW_freq_os = ['o', 'V'; 'o', 'V'];
SW_freq_dr = ['d', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'];

%compatability of software
CSW_str_apps = ['a'; 'a'; 'a' ;'a'; 'b'; 'b'; 'b'; 'b'];
CSW_str_serv = ['a'; 'a'; 'a'; 'a'; 'b'; 'b'; 'b'; 'b'];
CSW_str_os = ['a'; 'b'];
CSW_str_dr = ['a'; 'a'; 'a'; 'a'; 'b' ;'b'; 'b'; 'b'];
CSW = [CSW_str_apps; CSW_str_serv; CSW_str_os; CSW_str_dr];
%create two filters
CSW1 = zeros(size(CSW));
CSW2 = zeros(size(CSW));
CSW3 = zeros(size(CSW));
CSW4 = zeros(size(CSW));
CSW5 = zeros(size(CSW));
CSW6 = zeros(size(CSW));
CSW7 = zeros(size(CSW));
CSW8 = zeros(size(CSW));
CSW9 = zeros(size(CSW));
CSW10 = zeros(size(CSW));
for z = 1:size(CSW)
  if CSW(z) ==  'a'
      CSW1(z) = 1;
  end;
  if CSW(z) ==  'b'
      CSW2(z) = 1;
  end;
end; %end for z
CSW1 = CSW1';
CSW2 = CSW2';
CSW3 = CSW3';
CSW4 = CSW4';
CSW5 = CSW5';
CSW6 = CSW6';
CSW7 = CSW7';
CSW8 = CSW8';
CSW9 = CSW9';
CSW10 = CSW10';
CSWGroup(1,:) = CSW1;
CSWGroup(2,:) = CSW2;


% set up genotypes for each of the 10 nodes
%They should correspond roughly to the individuals desirabilities
Genotype_apps = [0 1 0 0 0 0 0 0,
                 0 1 0 0 0 0 0 0,
                 1 0 0 0 0 0 0 0,
                 0 1 0 0 0 0 0 0,
                 0 0 0 0 1 0 0 0,
                 0 0 0 0 1 0 0 0,
                 0 0 0 0 0 0 0 1,
                 0 1 0 0 0 0 0 0,
                 1 0 0 0 0 0 0 0,
                 0 0 0 0 0 0 0 1];
             
Genotype_serv = [1 0 0 0 0 0 0 0,
                 1 0 0 0 0 0 0 0,
                 1 0 0 0 0 0 0 0,
                 1 0 0 0 0 0 0 0,
                 0 0 0 0 0 0 0 1,
                 0 0 0 0 0 0 0 1,
                 0 0 0 0 0 0 0 1,
                 0 1 0 0 0 0 0 0,
                 0 1 0 0 0 0 0 0,
                 0 0 0 0 0 0 0 1];
             
Genotype_os = [1 0,
               1 0,
               1 0,
               1 0,
               0 1,
               0 1,
               1 0,
               1 0,
               1 0,
               0 1];
           
 Genotype_dr = [1 0 0 0 0 0 0 0,
                0 1 0 0 0 0 0 0,
                0 1 0 0 0 0 0 0,
                0 1 0 0 0 0 0 0,
                0 0 0 0 0 0 1 0,
                0 0 0 0 0 0 0 1,
                0 0 0 1 0 0 0 0,
                0 1 0 0 0 0 0 0,
                0 1 0 0 0 0 0 0,
                0 0 0 1 0 0 0 0];

%efficiency/quality ratings of software (1 to 100) 
%(1)inefficient (100)maximum efficiency
E_apps = [65 75 55 50 60 60 60 80];
E_serv = [65 66 67 63 59 62 72 77];
E_os = [70 80];
E_dr = [70 80 60 75 69 68 63 58];

%community desirability ratings (1 to 100) (1)least desirable (100)most
%desirable
CD_apps = [25 40 10 5 10 5 3 2];
sum(CD_apps);
CD_serv = [70 5 3 2 5 5 5 5];
sum(CD_serv);
CD_os = [80 20];
sum(CD_os);
CD_dr = [50 20 5 5 10 5 3 2];
sum(CD_dr);
%for change over
CD_apps2 = [25 10 10 5 10 5 30 5];
sum(CD_apps2);
CD_serv2 = [40 5 3 2 15 15 10 10];
sum(CD_serv2);
CD_os2 = [50 50];
sum(CD_os2);
CD_dr2 = [40 1 4 5 10 25 3 12];
sum(CD_dr2);

%individual desirability ratings (1 to 100) (1)least desirable (100)most
%desirable
%MUST NOT HAVE ANY ZERO VALUES!
%do for 10 individuals
ID_apps = [25 40 10 5 10 5 3 2,
           20 68 1 1  5 2 2 1,
           68 20 1 1 5 2 2 1,
           39 48 5 4 1 1 1 1,
           5 10 3 2 50 15 13 2,
           1 1 4 4 48 19 22 1,
           10 15 10 15 10 10 10 20,
           20 35 3 2 10 10 5 15,
           58 10 1 1 5 4 1 20,
           10 15 10 15 10 10 10 20];  
            
ID_serv = [70 5 3 2 5 5 5 5,
           80 5 3 2 2 3 2 3,
           70 15 3 2 2 3 3 2,
           68 17 3 8 1 1 1 1,
           5 8 2 5 13 17 20 30,
           1 2 2 5 13 27 20 30,
           12 13 12 13 12 12 12 14,
           12 23 12 13 12 12 2 14,
           12 33 12 13 12 2 2 14,
           12 13 12 13 12 12 12 14] ;      
                          
ID_os = [80 20,
         90 10,
         90 10,
         96 4,
         20 80,
         10 90,
         50 50,
         60 40,
         70 30,
         50 50] ;   
     
ID_dr = [50 20 5 5 10 5 3 2,
         20 50 10 10 4 3 1 2,
         20 50 10 10 4 3 1 2,
         1 86 5 4 1 1 1 1,
         1 2 1 16 20 20 20 20,
         1 2 1 6 20 20 20 30 ,
         10 15 5 20 10 15 10 15,
         10 25 15 10 10 10 10 10,           
         10 35 15 10 5 10 5 10,
         10 15 5 20 13 13 12 12];
E_apps2 = E_apps;
E_serv2 = E_serv;
E_os2 = E_os;
E_dr2 = E_dr;     
ID_apps2 = ID_apps;
ID_serv2 = ID_serv;
ID_os2 = ID_os;
ID_dr2 = ID_dr;  

%INDIVIDUAL TIME ARRAY OF CHANGES TO PERSONAL INDIVIDUAL DESIRABILITIES
%needs to be set here because numNodes is different for each case
numNodes = 10;
IDtimeArray1 = zeros(1,numNodes);
IDtimeArray2 = zeros(1,numNodes);
     
    case 2
%%%%%%%%%%%%%
% set up data - Dataset 2
%%%%%%%%%%%%%
%software strings
%WebBrowser1,6 - commercial products, WebBrowser2,3,4,5 third party
SW_str_apps = ['WebBrowser1v1 ' 'WebBrowser1v2 ' 'WebBrowser2v1 ' 'WebBrowser3v1 ' 'WebBrowser4v1 ' 'WebBrowser5v1 ' 'WebBrowser6v1 ' 'WebBrowser6v4 '];
%All photo viewers about same standard with number 7 slightly better
SW_str_serv = ['PhotoViewer1 ' 'PhotoViewer2 ' 'PhotoViewer3 ' 'PhotoViewer4 ' 'PhotoViewer5 ' 'PhotoViewer6 ' 'PhotoViewer7v1 ' 'PhotoViewer7v2 '];
%OS2 slightly more efficient overall than OS1
SW_str_os = ['OS1 ' 'OS2 '];
%higher versions are better than lower number versions, the commercial
%products are more efficient than the freebies 3rd party
SW_str_dr = ['DataDr1v1 ' 'DataDr1v2 ' 'DataDr2v1 ' 'DataDr3v3 ' 'DataDr4 ' 'DataDr5 ' 'DataDr6 ' 'DataDr7 '];

%software frequency info for running the frequency and nei diversity index
%algorithm
%locusApps - 'a' represents major variants, 'V' represents a minor version
%locusServ - 's' represents major variants, 'V' represents a minor version
%locusOS  - 'o' represents major variants, 'V' represents a minor version
SW_freq_apps = ['a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'];
SW_freq_serv = ['s', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'];
SW_freq_os = ['o', 'V'; 'o', 'V'];
SW_freq_dr = ['d', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'];

%compatability of software
CSW_str_apps = ['a'; 'a'; 'a' ;'a'; 'b'; 'b'; 'b'; 'b'];
CSW_str_serv = ['a'; 'a'; 'a'; 'a'; 'b'; 'b'; 'b'; 'b'];
CSW_str_os = ['a'; 'b'];
CSW_str_dr = ['a'; 'a'; 'a'; 'a'; 'b' ;'b'; 'b'; 'b'];
CSW = [CSW_str_apps; CSW_str_serv; CSW_str_os; CSW_str_dr];
%create two filters
CSW1 = zeros(size(CSW));
CSW2 = zeros(size(CSW));
CSW3 = zeros(size(CSW));
CSW4 = zeros(size(CSW));
CSW5 = zeros(size(CSW));
CSW6 = zeros(size(CSW));
CSW7 = zeros(size(CSW));
CSW8 = zeros(size(CSW));
CSW9 = zeros(size(CSW));
CSW10 = zeros(size(CSW));
for z = 1:size(CSW)
  if CSW(z) ==  'a'
      CSW1(z) = 1;
  end;
  if CSW(z) ==  'b'
      CSW2(z) = 1;
  end;
end; %end for z
CSW1 = CSW1';
CSW2 = CSW2';
CSW3 = CSW3';
CSW4 = CSW4';
CSW5 = CSW5';
CSW6 = CSW6';
CSW7 = CSW7';
CSW8 = CSW8';
CSW9 = CSW9';
CSW10 = CSW10';
CSWGroup(1,:) = CSW1;
CSWGroup(2,:) = CSW2;


%A possible max diversity solution
Genotype_apps = [1 0 0 0 0 0 0 0,
                 0 1 0 0 0 0 0 0,
                 0 0 1 0 0 0 0 0,
                 0 0 0 1 0 0 0 0,
                 1 0 0 0 0 0 0 0,
                 0 0 0 0 1 0 0 0,
                 0 0 0 0 0 1 0 0,
                 0 0 0 0 0 0 1 0,
                 0 0 0 0 0 0 0 1,
                 0 0 0 0 1 0 0 0];
             
Genotype_serv = [1 0 0 0 0 0 0 0,
                 0 1 0 0 0 0 0 0,
                 0 0 1 0 0 0 0 0,
                 0 0 0 1 0 0 0 0,
                 0 0 0 1 0 0 0 0,
                 0 0 0 0 1 0 0 0,
                 0 0 0 0 0 1 0 0,
                 0 0 0 0 0 0 1 0,
                 0 0 0 0 0 0 0 1,
                 0 0 0 0 0 0 0 1];
             
Genotype_os = [1 0,
               1 0,
               1 0,
               1 0,
               1 0,
               0 1,
               0 1,
               0 1,
               0 1,
               0 1];
           
 Genotype_dr = [1 0 0 0 0 0 0 0,
                0 1 0 0 0 0 0 0,
                0 0 1 0 0 0 0 0,
                0 0 0 1 0 0 0 0,
                0 1 0 0 0 0 0 0,
                0 0 0 0 1 0 0 0,
                0 0 0 0 0 1 0 0,
                0 0 0 0 0 0 1 0,
                0 0 0 0 0 0 0 1,
                0 0 0 0 0 1 0 0];
            
%efficiency/quality ratings of software (1 to 100) 
%(1)inefficient (100)maximum efficiency
E_apps = [65 75 55 50 60 60 60 80];
E_serv = [65 66 67 63 59 62 72 77];
E_os = [70 80];
E_dr = [70 80 60 75 69 68 63 58];

%community desirability ratings (1 to 100) (1)least desirable (100)most
%desirable
CD_apps = [25 40 10 5 10 5 3 2];
%CD_apps = [12.5 12.5 12.5 12.5 12.5 12.5 12.5 12.5];
sum(CD_apps);
CD_serv = [70 5 3 2 5 5 5 5];
%CD_serv = [12.5 12.5 12.5 12.5 12.5 12.5 12.5 12.5];
sum(CD_serv);
CD_os = [80 20];
%CD_os = [12.5 12.5];
sum(CD_os);
CD_dr = [50 20 5 5 10 5 3 2];
%CD_dr = [12.5 12.5 12.5 12.5 12.5 12.5 12.5 12.5];
sum(CD_dr);
%for change over
%for change over
CD_apps2 = [25 10 10 5 10 5 30 5];
sum(CD_apps2);
CD_serv2 = [40 5 3 2 15 15 10 10];
sum(CD_serv2);
CD_os2 = [50 50];
sum(CD_os2);
CD_dr2 = [40 1 4 5 10 25 3 12];
sum(CD_dr2);
            
%individual desirability ratings (1 to 100) (1)least desirable (100)most
%desirable
%MUST NOT HAVE ANY ZERO VALUES!
%do for 10 individuals
ID_apps = [25 40 10 5 10 5 3 2,
           20 68 1 1  5 2 2 1,
           68 20 1 1 5 2 2 1,
           39 48 5 4 1 1 1 1,
           5 10 3 2 50 15 13 2,
           1 1 4 4 48 19 22 1,
           10 15 10 15 10 10 10 20,
           20 35 3 2 10 10 5 15,
           58 10 1 1 5 4 1 20,
           10 15 10 15 10 10 10 20];  
            
ID_serv = [70 5 3 2 5 5 5 5,
           80 5 3 2 2 3 2 3,
           70 15 3 2 2 3 3 2,
           68 17 3 8 1 1 1 1,
           5 8 2 5 13 17 20 30,
           1 2 2 5 13 27 20 30,
           12 13 12 13 12 12 12 14,
           12 23 12 13 12 12 2 14,
           12 33 12 13 12 2 2 14,
           12 13 12 13 12 12 12 14] ;      
                          
ID_os = [80 20,
         90 10,
         90 10,
         96 4,
         20 80,
         10 90,
         50 50,
         60 40,
         70 30,
         50 50] ;   
     
ID_dr = [50 20 5 5 10 5 3 2,
         20 50 10 10 4 3 1 2,
         20 50 10 10 4 3 1 2,
         1 86 5 4 1 1 1 1,
         1 2 1 16 20 20 20 20,
         1 2 1 6 20 20 20 30 ,
         10 15 5 20 10 15 10 15,
         10 25 15 10 10 10 10 10,           
         10 35 15 10 5 10 5 10,
         10 15 5 20 13 13 12 12];
    
E_apps2 = E_apps;
E_serv2 = E_serv;
E_os2 = E_os;
E_dr2 = E_dr;     
ID_apps2 = ID_apps;
ID_serv2 = ID_serv;
ID_os2 = ID_os;
ID_dr2 = ID_dr;
%INDIVIDUAL TIME ARRAY OF CHANGES TO PERSONAL INDIVIDUAL DESIRABILITIES
%needs to be set here because numNodes is different for each case
numNodes = 10;
IDtimeArray1 = zeros(1,numNodes);
IDtimeArray2 = zeros(1,numNodes);
     
      case 3
%%%%%%%%%%%%%
% set up data - Dataset 3
%%%%%%%%%%%%%
%software strings
%WebBrowser1,6 - commercial products, WebBrowser2,3,4,5 third party
SW_str_apps = ['WebBrowser1v1 ' 'WebBrowser1v2 ' 'WebBrowser2v1 ' 'WebBrowser3v1 ' 'WebBrowser4v1 ' 'WebBrowser5v1 ' 'WebBrowser6v1 ' 'WebBrowser6v4 '];
%All photo viewers about same standard with number 7 slightly better
SW_str_serv = ['PhotoViewer1 ' 'PhotoViewer2 ' 'PhotoViewer3 ' 'PhotoViewer4 ' 'PhotoViewer5 ' 'PhotoViewer6 ' 'PhotoViewer7v1 ' 'PhotoViewer7v2 '];
%OS2 slightly more efficient overall than OS1
SW_str_os = ['OS1 ' 'OS2 ' 'OS3 '];
%higher versions are better than lower number versions, the commercial
%products are more efficient than the freebies 3rd party
SW_str_dr = ['DataDr1v1 ' 'DataDr1v2 ' 'DataDr2v1 ' 'DataDr3v3 ' 'DataDr4 ' 'DataDr5 ' 'DataDr6 ' 'DataDr7 '];

%software frequency info for running the frequency and nei diversity index
%algorithm
%locusApps - 'a' represents major variants, 'V' represents a minor version
%locusServ - 's' represents major variants, 'V' represents a minor version
%locusOS  - 'o' represents major variants, 'V' represents a minor version
SW_freq_apps = ['a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'];
SW_freq_serv = ['s', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'];
SW_freq_os = ['o', 'V'; 'o', 'V'; 'o', 'V'];
SW_freq_dr = ['d', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'];

%compatability of software
CSW_str_apps = ['a'; 'a'; 'a' ;'b'; 'b'; 'c'; 'c'; 'c'];
CSW_str_serv = ['a'; 'a'; 'a'; 'b'; 'b'; 'c'; 'c'; 'c'];
CSW_str_os = ['a'; 'b'; 'c'];
CSW_str_dr = ['a'; 'a'; 'b'; 'b'; 'c' ;'c'; 'c'; 'c'];
CSW = [CSW_str_apps; CSW_str_serv; CSW_str_os; CSW_str_dr];
%create two filters
CSW1 = zeros(size(CSW));
CSW2 = zeros(size(CSW));
CSW3 = zeros(size(CSW));
CSW4 = zeros(size(CSW));
CSW5 = zeros(size(CSW));
CSW6 = zeros(size(CSW));
CSW7 = zeros(size(CSW));
CSW8 = zeros(size(CSW));
CSW9 = zeros(size(CSW));
CSW10 = zeros(size(CSW));
for z = 1:size(CSW)
  if CSW(z) ==  'a'
      CSW1(z) = 1;
  end;
  if CSW(z) ==  'b'
      CSW2(z) = 1;
  end;
  if CSW(z) ==  'c'
      CSW3(z) = 1;
  end;
end; %end for z
CSW1 = CSW1';
CSW2 = CSW2';
CSW3 = CSW3';
CSW4 = CSW4';
CSW5 = CSW5';
CSW6 = CSW6';
CSW7 = CSW7';
CSW8 = CSW8';
CSW9 = CSW9';
CSW10 = CSW10';
CSWGroup(1,:) = CSW1;
CSWGroup(2,:) = CSW2;
CSWGroup(3,:) = CSW3;


%A possible max diversity solution
Genotype_apps = [1 0 0 0 0 0 0 0,
                 0 1 0 0 0 0 0 0,
                 0 0 1 0 0 0 0 0,
                 0 0 0 1 0 0 0 0,
                 1 0 0 0 0 0 0 0,
                 0 0 0 0 1 0 0 0,
                 0 0 0 0 0 1 0 0,
                 0 0 0 0 0 0 1 0,
                 0 0 0 0 0 0 0 1,
                 0 0 0 0 1 0 0 0];
             
Genotype_serv = [1 0 0 0 0 0 0 0,
                 0 1 0 0 0 0 0 0,
                 0 0 1 0 0 0 0 0,
                 0 0 0 1 0 0 0 0,
                 0 0 0 1 0 0 0 0,
                 0 0 0 0 1 0 0 0,
                 0 0 0 0 0 1 0 0,
                 0 0 0 0 0 0 1 0,
                 0 0 0 0 0 0 0 1,
                 0 0 0 0 0 0 0 1];
             
Genotype_os = [1 0 0,
               1 0 0,
               0 0 1,
               0 1 0,
               1 0 0,
               0 1 0,
               0 0 1,
               0 0 1,
               0 1 0,
               1 0 0];
           
 Genotype_dr = [1 0 0 0 0 0 0 0,
                0 1 0 0 0 0 0 0,
                0 0 1 0 0 0 0 0,
                0 0 0 1 0 0 0 0,
                0 1 0 0 0 0 0 0,
                0 0 0 0 1 0 0 0,
                0 0 0 0 0 1 0 0,
                0 0 0 0 0 0 1 0,
                0 0 0 0 0 0 0 1,
                0 0 0 0 0 1 0 0];
            
%efficiency/quality ratings of software (1 to 100) 
%(1)inefficient (100)maximum efficiency
E_apps = [65 75 55 50 60 60 60 80];
E_serv = [65 66 67 63 59 62 72 77];
E_os = [70 80 20];
E_dr = [70 80 60 75 69 68 63 58];

%community desirability ratings (1 to 100) (1)least desirable (100)most
%desirable
CD_apps = [25 40 15 1 9 1 1 8];
%CD_apps = [12.5 12.5 12.5 12.5 12.5 12.5 12.5 12.5];
sum(CD_apps);
CD_serv = [70 5 5 3 7 6 2 2];
%CD_serv = [12.5 12.5 12.5 12.5 12.5 12.5 12.5 12.5];
sum(CD_serv);
CD_os = [80 10 10];
%CD_os = [12.5 12.5];
sum(CD_os);
CD_dr = [50 30 5 5 1 2 4 3];
%CD_dr = [12.5 12.5 12.5 12.5 12.5 12.5 12.5 12.5];
sum(CD_dr);
%for change over
CD_apps2 = [10 40 10 20 10 5 3 2];
%CD_apps2 = [12.5 12.5 12.5 12.5 12.5 12.5 12.5 12.5];
sum(CD_apps2);
CD_serv2 = [52 5 3 5 25 3 2 5];
%CD_serv2 = [12.5 12.5 12.5 12.5 12.5 12.5 12.5 12.5];
sum(CD_serv2);
CD_os2 = [60 30 10];
%CD_os2 = [12.5 12.5];
sum(CD_os2);
CD_dr2 = [50 10 15 15 1 5 3 1];
%CD_dr2 = [12.5 12.5 12.5 12.5 12.5 12.5 12.5 12.5];
sum(CD_dr2);
            
%individual desirability ratings (1 to 100) (1)least desirable (100)most
%desirable
%MUST NOT HAVE ANY ZERO VALUES!
%do for 10 individuals
ID_apps = [25 25 10 5 15 15 3 2,
           20 59 1 5 5 8 1 1,
           59 20 1 5 5 8 1 1,
           39 48 6 1 2 2 1 1,
           2 10 3 20 60 1 2 2,
           1 1 3 3 2 69 20 1,
           10 14 10 23 10 10 10 13,
           23 25 3 20 10 10 5 5,
           19 10 1 1 1 45 5 18,
           10 13 10 10 23 10 10 14];  
            
ID_serv = [52 5 3 12 8 5 5 10,
           70 5 5 5 5 5 3 2,
           60 17 3 2 8 5 3 2,
           67 23 3 2 1 1 1 2,
           1 7 7 5 75 2 1 2,
           1 2 2 4 1 40 20 30,
           11 11 12 11 22 11 11 11,
           12 23 15 13 17 12 4 4,
           10 10 10 1 1 11 23 34,
           10 13 10 13 20 10 10 14] ;      
                          
ID_os = [60 20 20,
         80 10 10,
         80 10 10,
         93 3 4,
         15 80 5,
         5 5 90,
         34 33 33,
         50 30 20,
         30 2 68,
         33 33 34] ;   
     
ID_dr = [50 10 15 5 10 5 3 2,
         20 60 9 1 5 3 1 1,
         20 60 1 9 5 3 1 1,
         7 86 1 2 1 1 1 1,
         13 2 72 8 2 1 1 1,
         3 2 1 4 20 20 20 30,
         20 14 13 20 10 3 10 10,
         25 25 15 15 5 3 2 10,           
         25 5 1 1 30 10 18 10,
         18 15 5 28 10 10 10 4];
     
     E_apps2 = E_apps;
E_serv2 = E_serv;
E_os2 = E_os;
E_dr2 = E_dr;     
ID_apps2 = ID_apps;
ID_serv2 = ID_serv;
ID_os2 = ID_os;
ID_dr2 = ID_dr;
%INDIVIDUAL TIME ARRAY OF CHANGES TO PERSONAL INDIVIDUAL DESIRABILITIES
%needs to be set here because numNodes is different for each case
numNodes = 10;
IDtimeArray1 = zeros(1,numNodes);
IDtimeArray2 = zeros(1,numNodes);
    case 4
%%%%%%%%%%%%%
% set up data - Dataset 4
%%%%%%%%%%%%%
%software strings
%WebBrowser1,6 - commercial products, WebBrowser2,3,4,5 third party
SW_str_apps = ['WebBrowser1v1 ' 'WebBrowser1v2 ' 'WebBrowser2v1 ' 'WebBrowser3v1 ' 'WebBrowser4v1 ' 'WebBrowser5v1 ' 'WebBrowser6v1 ' 'WebBrowser6v4 '];
%All photo viewers about same standard with number 7 slightly better
SW_str_serv = ['PhotoViewer1 ' 'PhotoViewer2 ' 'PhotoViewer3 ' 'PhotoViewer4 ' 'PhotoViewer5 ' 'PhotoViewer6 ' 'PhotoViewer7v1 ' 'PhotoViewer7v2 '];
%OS2 slightly more efficient overall than OS1
SW_str_os = ['OS1 ' 'OS2 ' 'OS3 ' 'OS4 '];
%higher versions are better than lower number versions, the commercial
%products are more efficient than the freebies 3rd party
SW_str_dr = ['DataDr1v1 ' 'DataDr1v2 ' 'DataDr2v1 ' 'DataDr3v3 ' 'DataDr4 ' 'DataDr5 ' 'DataDr6 ' 'DataDr7 '];

%software frequency info for running the frequency and nei diversity index
%algorithm
%locusApps - 'a' represents major variants, 'V' represents a minor version
%locusServ - 's' represents major variants, 'V' represents a minor version
%locusOS  - 'o' represents major variants, 'V' represents a minor version
SW_freq_apps = ['a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'];
SW_freq_serv = ['s', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'];
SW_freq_os = ['o', 'V'; 'o', 'V'; 'o', 'V'; 'o', 'V'];
SW_freq_dr = ['d', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'];

%compatability of software
CSW_str_apps = ['a'; 'a'; 'b' ;'b'; 'c'; 'c'; 'd'; 'd'];
CSW_str_serv = ['a'; 'a'; 'b'; 'b'; 'c'; 'c'; 'd'; 'd'];
CSW_str_os = ['a'; 'b'; 'c'; 'd'];
CSW_str_dr = ['a'; 'a'; 'b'; 'b'; 'c' ;'c'; 'd'; 'd'];
CSW = [CSW_str_apps; CSW_str_serv; CSW_str_os; CSW_str_dr];
%create filters
CSW1 = zeros(size(CSW));
CSW2 = zeros(size(CSW));
CSW3 = zeros(size(CSW));
CSW4 = zeros(size(CSW));
CSW5 = zeros(size(CSW));
CSW6 = zeros(size(CSW));
CSW7 = zeros(size(CSW));
CSW8 = zeros(size(CSW));
CSW9 = zeros(size(CSW));
CSW10 = zeros(size(CSW));
for z = 1:size(CSW)
  if CSW(z) ==  'a'
      CSW1(z) = 1;
  end;
  if CSW(z) ==  'b'
      CSW2(z) = 1;
  end;
 if CSW(z) ==  'c'
      CSW3(z) = 1;
  end;
 if CSW(z) ==  'd'
      CSW4(z) = 1;
  end;
end; %end for z
CSW1 = CSW1';
CSW2 = CSW2';
CSW3 = CSW3';
CSW4 = CSW4';
CSW5 = CSW5';
CSW6 = CSW6';
CSW7 = CSW7';
CSW8 = CSW8';
CSW9 = CSW9';
CSW10 = CSW10';
CSWGroup(1,:) = CSW1;
CSWGroup(2,:) = CSW2;
CSWGroup(3,:) = CSW3;
CSWGroup(4,:) = CSW4;


%A possible max diversity solution
Genotype_apps = [1 0 0 0 0 0 0 0,
                 0 1 0 0 0 0 0 0,
                 0 0 1 0 0 0 0 0,
                 0 0 0 1 0 0 0 0,
                 1 0 0 0 0 0 0 0,
                 0 0 0 0 1 0 0 0,
                 0 0 0 0 0 1 0 0,
                 0 0 0 0 0 0 1 0,
                 0 0 0 0 0 0 0 1,
                 0 0 0 0 1 0 0 0];
             
Genotype_serv = [1 0 0 0 0 0 0 0,
                 0 1 0 0 0 0 0 0,
                 0 0 1 0 0 0 0 0,
                 0 0 0 1 0 0 0 0,
                 0 0 0 1 0 0 0 0,
                 0 0 0 0 1 0 0 0,
                 0 0 0 0 0 1 0 0,
                 0 0 0 0 0 0 1 0,
                 0 0 0 0 0 0 0 1,
                 0 0 0 0 0 0 0 1];
             
Genotype_os = [1 0 0 0,
               1 0 0 0,
               0 0 1 0,
               0 1 0 0,
               0 0 0 1,
               0 1 0 0,
               0 0 0 1,
               0 0 1 0,
               0 1 0 0,
               1 0 0 0];
           
 Genotype_dr = [1 0 0 0 0 0 0 0,
                0 1 0 0 0 0 0 0,
                0 0 1 0 0 0 0 0,
                0 0 0 1 0 0 0 0,
                0 1 0 0 0 0 0 0,
                0 0 0 0 1 0 0 0,
                0 0 0 0 0 1 0 0,
                0 0 0 0 0 0 1 0,
                0 0 0 0 0 0 0 1,
                0 0 0 0 0 1 0 0];
            
%efficiency/quality ratings of software (1 to 100) 
%(1)inefficient (100)maximum efficiency
E_apps = [65 75 55 50 60 60 60 80];
E_serv = [65 66 67 63 59 62 72 77];
E_os = [70 80 20 10];
E_dr = [70 80 60 75 69 68 63 58];

%community desirability ratings (1 to 100) (1)least desirable (100)most
%desirable
CD_apps = [25 55 5 5 1 4 3 2];
%CD_apps = [12.5 12.5 12.5 12.5 12.5 12.5 12.5 12.5];
sum(CD_apps);
CD_serv = [70 10 3 7 3 2 1 4];
%CD_serv = [12.5 12.5 12.5 12.5 12.5 12.5 12.5 12.5];
sum(CD_serv);
CD_os = [80 10 5 5];
%CD_os = [12.5 12.5];
sum(CD_os);
CD_dr = [50 30 5 5 1 4 3 2];
%CD_dr = [12.5 12.5 12.5 12.5 12.5 12.5 12.5 12.5];
sum(CD_dr);
%for change over
CD_apps2 = [40 50 2 3 1 2 1 1];
%CD_apps2 = [12.5 12.5 12.5 12.5 12.5 12.5 12.5 12.5];
sum(CD_apps2);
CD_serv2 = [70 20 3 2 1 2 1 1];
%CD_serv2 = [12.5 12.5 12.5 12.5 12.5 12.5 12.5 12.5];
sum(CD_serv2);
CD_os2 = [90 5 3 2];
%CD_os2 = [12.5 12.5];
sum(CD_os2);
CD_dr2 = [50 40 1 4 1 2 1 1];
%CD_dr2 = [12.5 12.5 12.5 12.5 12.5 12.5 12.5 12.5];
sum(CD_dr2);
            
%individual desirability ratings (1 to 100) (1)least desirable (100)most
%desirable
%MUST NOT HAVE ANY ZERO VALUES!
%do for 10 individuals
ID_apps = [20 40 10 10 9 1 7 3,
           10 70 9 1  4 1 3 2,
           70 10 9 1 4 1 4 1,
           40 54 1 1 1 1 1 1,
           5 10 30 40 4 1 8 2,
           1 4 1 4 47 13 20 10,
           10 15 10 15 10 15 10 15,
           20 29 10 20 10 9 1 1,
           8 20 1 1 60 8 1 1,
           10 15 10 15 10 15 10 15];  
            
ID_serv = [55 5 12 8 5 5 5 5,
           75 5 8 2 1 4 1 4,
           60 20 8 2 1 4 4 1,
           90 4 1 1 1 1 1 1,
           7 8 65 5 3 2 5 5,
           2 3 1 4 50 10 2 28,
           12 13 12 13 12 13 12 13,
           26 23 17 13 12 7 1 1,
           12 16 1 1 52 16 1 1,
           12 13 12 13 12 13 12 13] ;      
                          
ID_os = [60 20 10 10,
         80 10 5 5,
         80 10 5 5,
         94 2 2 2,
         15 70 5 10,
         5 5 60 30,
         25 25 25 25,
         49 30 19 2,
         28 2 68 2,
         25 25 25 25] ;   
     
ID_dr = [50 10 15 5 1 9 3 7,
         20 60 1 9 2 3 3 2,
         20 60 1 9 2 3 3 2,
         8 86 1 1 1 1 1 1,
         11 4 50 20 3 2 5 5,
         1 4 1 4 20 40 20 10,
         10 15 5 20 10 15 10 15,
         10 39 15 15 10 9 1 1,           
         10 18 1 1 5 63 1 1,
         10 15 5 20 13 12 12 13];
     
     E_apps2 = E_apps;
E_serv2 = E_serv;
E_os2 = E_os;
E_dr2 = E_dr;     
ID_apps2 = ID_apps;
ID_serv2 = ID_serv;
ID_os2 = ID_os;
ID_dr2 = ID_dr;
%INDIVIDUAL TIME ARRAY OF CHANGES TO PERSONAL INDIVIDUAL DESIRABILITIES
%needs to be set here because numNodes is different for each case
numNodes = 10;
IDtimeArray1 = zeros(1,numNodes);
IDtimeArray2 = zeros(1,numNodes);
         case 5
%%%%%%%%%%%%%
% set up data - Dataset 5
%%%%%%%%%%%%%
%software strings
%WebBrowser1,6 - commercial products, WebBrowser2,3,4,5 third party
SW_str_apps = ['WebBrowser1v1 ' 'WebBrowser1v2 ' 'WebBrowser2v1 ' 'WebBrowser3v1 ' 'WebBrowser4v1 ' 'WebBrowser5v1 ' 'WebBrowser6v1 ' 'WebBrowser6v4 ' 'WebBrowser7v1 ' 'WebBrowser7v3 '];
%All photo viewers about same standard with number 7 slightly better
SW_str_serv = ['PhotoViewer1 ' 'PhotoViewer2 ' 'PhotoViewer3 ' 'PhotoViewer4 ' 'PhotoViewer5 ' 'PhotoViewer6 ' 'PhotoViewer7v1 ' 'PhotoViewer7v2 ' 'PhotoViewer8 ' 'Photoviewer9 '];
%OS2 slightly more efficient overall than OS1
SW_str_os = ['OS1 ' 'OS2 ' 'OS3 ' 'OS4 '];
%higher versions are better than lower number versions, the commercial
%products are more efficient than the freebies 3rd party
SW_str_dr = ['DataDr1v1 ' 'DataDr1v2 ' 'DataDr2v1 ' 'DataDr3v3 ' 'DataDr4 ' 'DataDr5 ' 'DataDr6 ' 'DataDr7 ' 'DataDr9 ' 'DataDr8 '];

%software frequency info for running the frequency and nei diversity index
%algorithm
%locusApps - 'a' represents major variants, 'V' represents a minor version
%locusServ - 's' represents major variants, 'V' represents a minor version
%locusOS  - 'o' represents major variants, 'V' represents a minor version
SW_freq_apps = ['a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'];
SW_freq_serv = ['s', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'];
SW_freq_os = ['o', 'V'; 'o', 'V'; 'o', 'V'; 'o', 'V'];
SW_freq_dr = ['d', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'];

%compatability of software
CSW_str_apps = ['a'; 'a'; 'a' ;'b'; 'b'; 'c'; 'c'; 'd'; 'd'; 'd'];
CSW_str_serv = ['a'; 'a'; 'b'; 'b'; 'c'; 'c'; 'd'; 'd'; 'a'; 'a'];
CSW_str_os = ['a'; 'b'; 'c'; 'd'];
CSW_str_dr = ['a'; 'a'; 'b'; 'b'; 'c' ;'c'; 'd'; 'd'; 'b'; 'c'];
CSW = [CSW_str_apps; CSW_str_serv; CSW_str_os; CSW_str_dr];
%create filters
CSW1 = zeros(size(CSW));
CSW2 = zeros(size(CSW));
CSW3 = zeros(size(CSW));
CSW4 = zeros(size(CSW));
CSW5 = zeros(size(CSW));
CSW6 = zeros(size(CSW));
CSW7 = zeros(size(CSW));
CSW8 = zeros(size(CSW));
CSW9 = zeros(size(CSW));
CSW10 = zeros(size(CSW));
for z = 1:size(CSW)
  if CSW(z) ==  'a'
      CSW1(z) = 1;
  end;
  if CSW(z) ==  'b'
      CSW2(z) = 1;
  end;
 if CSW(z) ==  'c'
      CSW3(z) = 1;
  end;
 if CSW(z) ==  'd'
      CSW4(z) = 1;
  end;
end; %end for z
CSW1 = CSW1';
CSW2 = CSW2';
CSW3 = CSW3';
CSW4 = CSW4';
CSW5 = CSW5';
CSW6 = CSW6';
CSW7 = CSW7';
CSW8 = CSW8';
CSW9 = CSW9';
CSW10 = CSW10';
CSWGroup(1,:) = CSW1;
CSWGroup(2,:) = CSW2;
CSWGroup(3,:) = CSW3;
CSWGroup(4,:) = CSW4;

%A possible max diversity solution
Genotype_apps = [1 0 0 0 0 0 0 0 0 0,
                 0 1 0 0 0 0 0 0 0 0,
                 0 0 1 0 0 0 0 0 0 0,
                 0 0 0 1 0 0 0 0 0 0,
                 1 0 0 0 0 0 0 0 0 0,
                 0 0 0 0 1 0 0 0 0 0,
                 0 0 0 0 0 1 0 0 0 0,
                 0 0 0 0 0 0 1 0 0 0,
                 0 0 0 0 0 0 0 1 0 0,
                 0 0 0 0 1 0 0 0 0 0];
             
Genotype_serv = [1 0 0 0 0 0 0 0 0 0,
                 0 1 0 0 0 0 0 0 0 0,
                 0 0 1 0 0 0 0 0 0 0,
                 0 0 0 1 0 0 0 0 0 0,
                 0 0 0 1 0 0 0 0 0 0,
                 0 0 0 0 1 0 0 0 0 0,
                 0 0 0 0 0 1 0 0 0 0,
                 0 0 0 0 0 0 1 0 0 0,
                 0 0 0 0 0 0 0 1 0 0,
                 0 0 0 0 0 0 0 1 0 0];
             
Genotype_os = [1 0 0 0,
               1 0 0 0,
               0 0 1 0,
               0 1 0 0,
               0 0 0 1,
               0 1 0 0,
               0 0 0 1,
               0 0 1 0,
               0 1 0 0,
               1 0 0 0];
           
 Genotype_dr = [1 0 0 0 0 0 0 0 0 0,
                0 1 0 0 0 0 0 0 0 0,
                0 0 1 0 0 0 0 0 0 0,
                0 0 0 1 0 0 0 0 0 0,
                0 1 0 0 0 0 0 0 0 0,
                0 0 0 0 1 0 0 0 0 0,
                0 0 0 0 0 1 0 0 0 0,
                0 0 0 0 0 0 1 0 0 0,
                0 0 0 0 0 0 0 1 0 0,
                0 0 0 0 0 1 0 0 0 0];
            
%efficiency/quality ratings of software (1 to 100) 
%(1)inefficient (100)maximum efficiency
E_apps = [65 75 55 50 60 60 60 80 20 20];
E_serv = [65 66 67 63 59 62 72 77 50 50];
E_os = [70 80 20 10];
E_dr = [70 80 60 75 69 68 63 58 65 65];

%community desirability ratings (1 to 100) (1)least desirable (100)most
%desirable
CD_apps = [25 40 15 5 5 2 3 2 1 2];
%CD_apps = [12.5 12.5 12.5 12.5 12.5 12.5 12.5 12.5];
sum(CD_apps);
CD_serv = [60 10 7 3 4 1 2 3 5 5];
%CD_serv = [12.5 12.5 12.5 12.5 12.5 12.5 12.5 12.5];
sum(CD_serv);
CD_os = [80 10 5 5];
%CD_os = [12.5 12.5];
sum(CD_os);
CD_dr = [55 25 5 3 3 1 3 2 2 1];
%CD_dr = [12.5 12.5 12.5 12.5 12.5 12.5 12.5 12.5];
sum(CD_dr);
%for change over
CD_apps2 = [15 15 10 5 45 1 4 1 3 1];
%CD_apps2 = [12.5 12.5 12.5 12.5 12.5 12.5 12.5 12.5];
sum(CD_apps2);
CD_serv2 = [30 5 25 20 1 4 4 1 5 5];
%CD_serv2 = [12.5 12.5 12.5 12.5 12.5 12.5 12.5 12.5];
sum(CD_serv2);
CD_os2 = [40 50 5 5];
%CD_os2 = [12.5 12.5];
sum(CD_os2);
CD_dr2 = [20 20 5 5 1 1 3 2 40 3];
%CD_dr2 = [12.5 12.5 12.5 12.5 12.5 12.5 12.5 12.5];
sum(CD_dr2);
            
%individual desirability ratings (1 to 100) (1)least desirable (100)most
%desirable
%MUST NOT HAVE ANY ZERO VALUES!
%do for 10 individuals
     ID_apps = [11 39 10 10 10 5 5 2 3 5,
           10 69 1 5 5 1 4 1 1 3,
           69 19 3 1 2 1 2 1 1 1,
           5 5 5 30 40 1 4 1 9 1,
           1 2 2 2 3 14 46 20 5 5,
           10 10 5 5 20 20 5 10 10 5,
           10 29 10 15 15 10 8 1 1 1,
           20 6 1 2 1 60 7 1 1 1,
           57 9 1 1 5 5 1 19 1 1,
           10 5 10 15 10 15 10 23 1 1];
       
ID_serv = [50 5 3 17 5 5 5 5 4 1,
           68 2 3 7 1 4 2 3 1 9,
           60 13 1 2 2 1 1 2 17 1,
           10 3 30 40 1 4 5 5 1 1,
           1 2 2 3 13 47 19 11 1 1,
           15 8 17 8 13 12 10 25 1 1,
           37 10 12 18 10 8 2 1 1 1,
           10 15 2 1 60 7 2 1 1 1,
           12 33 12 13 12 11 2 13 1 1,
           20 3 12 13 12 13 12 13 1 1] ; 
                                  
ID_os = [60 20 10 10,
         80 10 5 5,
         80 10 5 5,
         91 3 3 3,
         15 70 5 10,
         5 5 60 30,
         25 25 25 25,
         49 30 18 3,
         27 3 67 3,
         25 25 25 25] ; 
     
ID_dr = [50 10 5 5 5 4 3 7 10 1,
         30 50 1 8 1 3 3 2 1 1,
         21 70 1 1 2 1 1 2 1 1,
         1 14 50 19 1 3 1 9 1 1,
         1 4 1 3 20 39 20 10 1 1,
         5 20 4 20 20 4 20 5 1 1,
         40 9 20 9 10 7 1 2 1 1,
         10 17 1 1 60 6 2 1 1 1,           
         10 35 15 10 5 10 5 8 1 1,
         10 15 4 20 20 4 12 13 1 1];
     
     E_apps2 = E_apps;
E_serv2 = E_serv;
E_os2 = E_os;
E_dr2 = E_dr;     
ID_apps2 = ID_apps;
ID_serv2 = ID_serv;
ID_os2 = ID_os;
ID_dr2 = ID_dr;
%INDIVIDUAL TIME ARRAY OF CHANGES TO PERSONAL INDIVIDUAL DESIRABILITIES
%needs to be set here because numNodes is different for each case
numNodes = 10;
IDtimeArray1 = zeros(1,numNodes);
IDtimeArray2 = zeros(1,numNodes);     
     
    case 6
     %%%%%%%%%%%%%
% set up data - Dataset 6
%%%%%%%%%%%%%
%software strings
%WebBrowser1,6 - commercial products, WebBrowser2,3,4,5 third party
SW_str_apps = ['WebBrowser1v1 ' 'WebBrowser1v2 ' 'WebBrowser2v1 ' 'WebBrowser3v1 ' 'WebBrowser4v1 ' 'WebBrowser5v1 ' 'WebBrowser6v1 ' 'WebBrowser6v4 ' 'WebBrowser7v1 ' 'WebBrowser7v3 '];
%All photo viewers about same standard with number 7 slightly better
SW_str_serv = ['PhotoViewer1 ' 'PhotoViewer2 ' 'PhotoViewer3 ' 'PhotoViewer4 ' 'PhotoViewer5 ' 'PhotoViewer6 ' 'PhotoViewer7v1 ' 'PhotoViewer7v2 ' 'PhotoViewer8 ' 'Photoviewer9 '];
%OS2 slightly more efficient overall than OS1
SW_str_os = ['OS1 ' 'OS2 ' 'OS3 ' 'OS4 '];
%higher versions are better than lower number versions, the commercial
%products are more efficient than the freebies 3rd party
SW_str_dr = ['DataDr1v1 ' 'DataDr1v2 ' 'DataDr2v1 ' 'DataDr3v3 ' 'DataDr4 ' 'DataDr5 ' 'DataDr6 ' 'DataDr7 ' 'DataDr9 ' 'DataDr8 '];

%software frequency info for running the frequency and nei diversity index
%algorithm
%locusApps - 'a' represents major variants, 'V' represents a minor version
%locusServ - 's' represents major variants, 'V' represents a minor version
%locusOS  - 'o' represents major variants, 'V' represents a minor version
SW_freq_apps = ['a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'];
SW_freq_serv = ['s', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'];
SW_freq_os = ['o', 'V'; 'o', 'V'; 'o', 'V'; 'o', 'V'];
SW_freq_dr = ['d', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'];

%compatability of software
CSW_str_apps = ['a'; 'a'; 'a' ;'b'; 'b'; 'c'; 'c'; 'd'; 'd'; 'd'];
CSW_str_serv = ['a'; 'a'; 'a'; 'b'; 'b'; 'c'; 'c'; 'd'; 'd'; 'd'];
CSW_str_os = ['a'; 'b'; 'c'; 'd'];
CSW_str_dr = ['a'; 'a'; 'a'; 'b'; 'b' ;'b'; 'c'; 'd'; 'd'; 'd'];
CSW = [CSW_str_apps; CSW_str_serv; CSW_str_os; CSW_str_dr];
%create filters
CSW1 = zeros(size(CSW));
CSW2 = zeros(size(CSW));
CSW3 = zeros(size(CSW));
CSW4 = zeros(size(CSW));
CSW5 = zeros(size(CSW));
CSW6 = zeros(size(CSW));
CSW7 = zeros(size(CSW));
CSW8 = zeros(size(CSW));
CSW9 = zeros(size(CSW));
CSW10 = zeros(size(CSW));
for z = 1:size(CSW)
  if CSW(z) ==  'a'
      CSW1(z) = 1;
  end;
  if CSW(z) ==  'b'
      CSW2(z) = 1;
  end;
 if CSW(z) ==  'c'
      CSW3(z) = 1;
  end;
 if CSW(z) ==  'd'
      CSW4(z) = 1;
  end;
end; %end for z
CSW1 = CSW1';
CSW2 = CSW2';
CSW3 = CSW3';
CSW4 = CSW4';
CSW5 = CSW5';
CSW6 = CSW6';
CSW7 = CSW7';
CSW8 = CSW8';
CSW9 = CSW9';
CSW10 = CSW10';
CSWGroup(1,:) = CSW1;
CSWGroup(2,:) = CSW2;
CSWGroup(3,:) = CSW3;
CSWGroup(4,:) = CSW4;


%A possible max diversity solution
Genotype_apps = [1 0 0 0 0 0 0 0 0 0,
                 1 0 0 0 0 0 0 0 0 0,
                 1 0 0 0 0 0 0 0 0 0,
                 1 0 0 0 0 0 0 0 0 0,
                 1 0 0 0 0 0 0 0 0 0,
                 0 0 0 0 1 0 0 0 0 0,
                 0 0 0 0 1 0 0 0 0 0,
                 0 0 0 0 1 0 0 0 0 0,
                 0 0 0 0 1 0 0 0 0 0,
                 0 0 0 0 1 0 0 0 0 0];
             
Genotype_serv = [1 0 0 0 0 0 0 0 0 0,
                 1 0 0 0 0 0 0 0 0 0,
                 1 0 0 0 0 0 0 0 0 0,
                 1 0 0 0 0 0 0 0 0 0,
                 1 0 0 0 0 0 0 0 0 0,
                 0 0 0 1 0 0 0 0 0 0,
                 0 0 0 1 0 0 0 0 0 0,
                 0 0 0 1 0 0 0 0 0 0,
                 0 0 0 1 0 0 0 0 0 0,
                 0 0 0 1 0 0 0 0 0 0];
             
Genotype_os = [1 0 0 0,
               1 0 0 0,
               1 0 0 0,
               1 0 0 0,
               1 0 0 0,
               0 1 0 0,
               0 1 0 0,
               0 1 0 0,
               0 1 0 0,
               0 1 0 0];
           
 Genotype_dr = [1 0 0 0 0 0 0 0 0 0,
                0 1 0 0 0 0 0 0 0 0,
                0 1 0 0 0 0 0 0 0 0,
                0 1 0 0 0 0 0 0 0 0,
                0 1 0 0 0 0 0 0 0 0,
                0 0 1 0 0 0 0 0 0 0,
                0 0 1 0 0 0 0 0 0 0,
                0 0 1 0 0 0 0 0 0 0,
                0 0 1 0 0 0 0 0 0 0,
                0 0 1 0 0 1 0 0 0 0];
            
%efficiency/quality ratings of software (1 to 100) 
%(1)inefficient (100)maximum efficiency
E_apps = [65 75 55 50 60 60 60 80 20 20];
E_serv = [65 66 67 63 59 62 72 77 50 50];
E_os = [70 80 20 10];
E_dr = [70 80 60 75 69 68 63 58 65 65];

%community desirability ratings (1 to 100) (1)least desirable (100)most
%desirable
CD_apps = [35 40 5 5 5 2 3 2 1 2];
%CD_apps = [12.5 12.5 12.5 12.5 12.5 12.5 12.5 12.5];
sum(CD_apps);
CD_serv = [60 13 7 3 7 4 1 1 1 3];
%CD_serv = [12.5 12.5 12.5 12.5 12.5 12.5 12.5 12.5];
sum(CD_serv);
CD_os = [80 10 5 5];
%CD_os = [12.5 12.5];
sum(CD_os);
CD_dr = [50 20 10 5 1 4 5 2 1 2];
%CD_dr = [12.5 12.5 12.5 12.5 12.5 12.5 12.5 12.5];
sum(CD_dr);
%for change over
CD_apps2 = [25 35 20 5 5 2 3 1 2 2];
%CD_apps2 = [12.5 12.5 12.5 12.5 12.5 12.5 12.5 12.5];
sum(CD_apps2);
CD_serv2 = [60 13 7 3 7 4 1 1 1 3];
%CD_serv2 = [12.5 12.5 12.5 12.5 12.5 12.5 12.5 12.5];
sum(CD_serv2);
CD_os2 = [80 10 5 5];
%CD_os2 = [12.5 12.5];
sum(CD_os2);
CD_dr2 = [50 20 10 5 1 4 5 2 1 2];
%CD_dr2 = [12.5 12.5 12.5 12.5 12.5 12.5 12.5 12.5];
sum(CD_dr2);
            
%individual desirability ratings (1 to 100) (1)least desirable (100)most
%desirable
%MUST NOT HAVE ANY ZERO VALUES!
%do for 10 individuals
ID_apps = [22 28 10 10 10 5 5 2 3 5,
           10 68 2 5 5 1 4 1 1 3,
           68 10 2 5 5 1 4 1 1 3,
           40 50 2 1 1 1 1 1 1 1,
           5 10 3 2 58 15 13 2 1 1,
           5 5 5 20 50 1 4 8 1 1,
           1 3 1 1 4 50 10 20 5 5,
           20 20 9 15 13 19 1 1 1 1,
           19 10 1 1 2 60 4 1 1 1,
           10 5 10 15 10 10 15 20 1 4];  
            
ID_serv = [52 5 3 2 18 5 5 5 4 1,
           68 2 10 2 8 3 2 3 1 1,
           68 2 10 2 8 3 2 3 1 1,
           65 7 20 2 1 1 1 1 1 1,
           5 4 6 50 20 1 4 8 1 1,
           1 1 3 4 1 15 45 28 1 1,
           12 3 10 13 12 12 13 14 1 10,
           19 20 10 13 15 10 10 1 1 1,
           2 10 18 2 1 10 54 1 1 1,
           12 3 10 13 12 12 13 14 1 10] ;      
                          
ID_os = [60 20 10 10,
         80 10 5 5,
         80 10 5 5,
         92 3 2 3,
         15 70 5 10,
         5 5 60 30,
         25 25 25 25,
         49 28 20 3,
         30 3 64 3,
         25 25 25 25] ;   
     
ID_dr = [35 20 5 5 10 5 10 2 7 1,
         20 50 10 2 5 3 5 2 1 2,
         20 50 10 2 5 3 5 2 1 2,
         1 84 7 1 1 1 2 1 1 1,
         3 2 10 30 20 20 5 8 1 1,
         2 2 1 2 1 2 60 28 1 1,
         10 10 5 15 5 5 25 13 10 2,
         10 25 14 8 10 10 20 1 1 1,           
         10 5 15 1 1 1 64 1 1 1,
         10 10 5 15 5 5 25 13 10 2];
     
     E_apps2 = E_apps;
E_serv2 = E_serv;
E_os2 = E_os;
E_dr2 = E_dr;     
ID_apps2 = ID_apps;
ID_serv2 = ID_serv;
ID_os2 = ID_os;
ID_dr2 = ID_dr;
%INDIVIDUAL TIME ARRAY OF CHANGES TO PERSONAL INDIVIDUAL DESIRABILITIES
%needs to be set here because numNodes is different for each case
numNodes = 10;
IDtimeArray1 = zeros(1,numNodes);
IDtimeArray2 = zeros(1,numNodes);
case 7
%%%%%%%%%%%%%
% set up data - Dataset 7
%%%%%%%%%%%%%
%software strings
%WebBrowser1,6 - commercial products, WebBrowser2,3,4,5 third party
SW_str_apps = ['WebBrowser1v1 ' 'WebBrowser1v2 ' 'WebBrowser2v1 ' 'WebBrowser3v1 ' 'WebBrowser4v1 ' 'WebBrowser5v1 ' 'WebBrowser6v1 ' 'WebBrowser6v4 ' 'WebBrowser7v1 ' 'WebBrowser7v3 '];
%All photo viewers about same standard with number 7 slightly better
SW_str_serv = ['PhotoViewer1 ' 'PhotoViewer2 ' 'PhotoViewer3 ' 'PhotoViewer4 ' 'PhotoViewer5 ' 'PhotoViewer6 ' 'PhotoViewer7v1 ' 'PhotoViewer7v2 ' 'PhotoViewer8 ' 'Photoviewer9 '];
%OS2 slightly more efficient overall than OS1
SW_str_os = ['OS1 ' 'OS2 ' 'OS3 ' 'OS4 ' 'OS5' 'OS6' 'OS7' 'OS8' 'OS9' 'OS10'];
%higher versions are better than lower number versions, the commercial
%products are more efficient than the freebies 3rd party
SW_str_dr = ['DataDr1v1 ' 'DataDr1v2 ' 'DataDr2v1 ' 'DataDr3v3 ' 'DataDr4 ' 'DataDr5 ' 'DataDr6 ' 'DataDr7 ' 'DataDr9 ' 'DataDr8 '];

%software frequency info for running the frequency and nei diversity index
%algorithm
%locusApps - 'a' represents major variants, 'V' represents a minor version
%locusServ - 's' represents major variants, 'V' represents a minor version
%locusOS  - 'o' represents major variants, 'V' represents a minor version
SW_freq_apps = ['a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'];
SW_freq_serv = ['s', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'];
SW_freq_os = ['o', 'V'; 'o', 'V'; 'o', 'V'; 'o', 'V';'o', 'V'; 'o', 'V'; 'o', 'V'; 'o', 'V';'o', 'V'; 'o', 'V'];
SW_freq_dr = ['d', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'];

%compatability of software
CSW_str_apps = ['a'; 'b'; 'c' ;'d'; 'e'; 'f'; 'g'; 'h'; 'i'; 'j'];
CSW_str_serv = ['a'; 'b'; 'c'; 'd'; 'e'; 'f'; 'g'; 'h'; 'i'; 'j'];
CSW_str_os = ['a'; 'b'; 'c'; 'd'; 'e'; 'f'; 'g'; 'h'; 'i'; 'j'];
CSW_str_dr = ['a'; 'b'; 'c'; 'd'; 'e' ;'f'; 'g'; 'h'; 'i'; 'j'];
CSW = [CSW_str_apps; CSW_str_serv; CSW_str_os; CSW_str_dr];
%create filters
CSW1 = zeros(size(CSW));
CSW2 = zeros(size(CSW));
CSW3 = zeros(size(CSW));
CSW4 = zeros(size(CSW));
CSW5 = zeros(size(CSW));
CSW6 = zeros(size(CSW));
CSW7 = zeros(size(CSW));
CSW8 = zeros(size(CSW));
CSW9 = zeros(size(CSW));
CSW10 = zeros(size(CSW));
for z = 1:size(CSW)
  if CSW(z) ==  'a'
      CSW1(z) = 1;
  end;
  if CSW(z) ==  'b'
      CSW2(z) = 1;
  end;
 if CSW(z) ==  'c'
      CSW3(z) = 1;
  end;
 if CSW(z) ==  'd'
      CSW4(z) = 1;
  end;
    if CSW(z) ==  'e'
      CSW5(z) = 1;
  end;
  if CSW(z) ==  'f'
      CSW6(z) = 1;
  end;
 if CSW(z) ==  'g'
      CSW7(z) = 1;
  end;
 if CSW(z) ==  'h'
      CSW8(z) = 1;
  end;  if CSW(z) ==  'i'
      CSW9(z) = 1;
  end;
  if CSW(z) ==  'j'
      CSW10(z) = 1;
  end;

end; %end for z
CSW1 = CSW1';
CSW2 = CSW2';
CSW3 = CSW3';
CSW4 = CSW4';
CSW5 = CSW5';
CSW6 = CSW6';
CSW7 = CSW7';
CSW8 = CSW8';
CSW9 = CSW9';
CSW10 = CSW10';
CSWGroup(1,:) = CSW1;
CSWGroup(2,:) = CSW2;
CSWGroup(3,:) = CSW3;
CSWGroup(4,:) = CSW4;
CSWGroup(5,:) = CSW5;
CSWGroup(6,:) = CSW6;
CSWGroup(7,:) = CSW7;
CSWGroup(8,:) = CSW8;
CSWGroup(9,:) = CSW9;
CSWGroup(10,:) = CSW10;

%A possible max diversity solution
Genotype_apps = [1 0 0 0 0 0 0 0 0 0,
                 1 0 0 0 0 0 0 0 0 0,
                 1 0 0 0 0 0 0 0 0 0,
                 1 0 0 0 0 0 0 0 0 0,
                 1 0 0 0 0 0 0 0 0 0,
                 0 0 0 0 1 0 0 0 0 0,
                 0 0 0 0 1 0 0 0 0 0,
                 0 0 0 0 1 0 0 0 0 0,
                 0 0 0 0 1 0 0 0 0 0,
                 0 0 0 0 1 0 0 0 0 0];
             
Genotype_serv = [1 0 0 0 0 0 0 0 0 0,
                 1 0 0 0 0 0 0 0 0 0,
                 1 0 0 0 0 0 0 0 0 0,
                 1 0 0 0 0 0 0 0 0 0,
                 1 0 0 0 0 0 0 0 0 0,
                 0 0 0 0 1 0 0 0 0 0,
                 0 0 0 0 1 0 0 0 0 0,
                 0 0 0 0 1 0 0 0 0 0,
                 0 0 0 0 1 0 0 0 0 0,
                 0 0 0 0 1 0 0 0 0 0];
             
Genotype_os = [1 0 0 0 0 0 0 0 0 0,
               1 0 0 0 0 0 0 0 0 0, 
               1 0 0 0 0 0 0 0 0 0,
               1 0 0 0 0 0 0 0 0 0,
               1 0 0 0 0 0 0 0 0 0,
               0 0 0 0 1 0 0 0 0 0,
               0 0 0 0 1 0 0 0 0 0,
               0 0 0 0 1 0 0 0 0 0,
               0 0 0 0 1 0 0 0 0 0,
               0 0 0 0 1 0 0 0 0 0];
           
 Genotype_dr = [1 0 0 0 0 0 0 0 0 0,
                1 0 0 0 0 0 0 0 0 0,
                1 0 0 0 0 0 0 0 0 0,
                1 0 0 0 0 0 0 0 0 0,
                1 0 0 0 0 0 0 0 0 0,
                0 0 0 0 1 0 0 0 0 0,
                0 0 0 0 1 0 0 0 0 0,
                0 0 0 0 1 0 0 0 0 0,
                0 0 0 0 1 0 0 0 0 0,
                0 0 0 0 1 0 0 0 0 0];
            
%efficiency/quality ratings of software (1 to 100) 
%(1)inefficient (100)maximum efficiency
E_apps = [65 75 55 50 60 60 60 80 20 20];
E_serv = [65 66 67 63 59 62 72 77 50 50];
E_os = [50 50 50 50 50 50 50 50 50 50];
E_dr = [70 80 60 75 69 68 63 58 65 65];

%community desirability ratings (1 to 100) (1)least desirable (100)most
%desirable
CD_apps = [74 10 5 5 1 1 1 1 1 1];
%CD_apps = [12.5 12.5 12.5 12.5 12.5 12.5 12.5 12.5];
sum(CD_apps);
CD_serv = [74 10 5 5 1 1 1 1 1 1];
%CD_serv = [12.5 12.5 12.5 12.5 12.5 12.5 12.5 12.5];
sum(CD_serv);
CD_os = [74 10 5 5 1 1 1 1 1 1];
%CD_os = [12.5 12.5];
sum(CD_os);
CD_dr = [74 10 5 5 1 1 1 1 1 1];
%CD_dr = [12.5 12.5 12.5 12.5 12.5 12.5 12.5 12.5];
sum(CD_dr);
%for change over
CD_apps2 = [64 10 5 5 1 1 1 1 1 10];
%CD_apps2 = [12.5 12.5 12.5 12.5 12.5 12.5 12.5 12.5];
sum(CD_apps2);
CD_serv2 = [64 10 5 5 1 1 1 1 1 10];
%CD_serv2 = [12.5 12.5 12.5 12.5 12.5 12.5 12.5 12.5];
sum(CD_serv2);
CD_os2 = [64 10 5 5 1 1 1 1 1 10];
%CD_os2 = [12.5 12.5];
sum(CD_os2);
CD_dr2 = [64 10 5 5 1 1 1 1 1 10];
%CD_dr2 = [12.5 12.5 12.5 12.5 12.5 12.5 12.5 12.5];
sum(CD_dr2);
            
%individual desirability ratings (1 to 100) (1)least desirable (100)most
%desirable
%MUST NOT HAVE ANY ZERO VALUES!
%do for 10 individuals
ID_apps = [58 18 9 9 1 1 1 1 1 1,
         78 8 5 3 1 1 1 1 1 1,
         78 8 5 3 1 1 1 1 1 1,
         90 2 1 1 1 1 1 1 1 1,
         15 65 5 9 1 1 1 1 1 1,
         5 5 59 25 1 1 1 1 1 1,
         23 23 24 24 1 1 1 1 1 1,
         49 27 17 1 1 1 1 1 1 1,
         27 1 65 1 1 1 1 1 1 1,
         24 24 23 23 1 1 1 1 1 1] ;   
            
ID_serv = [58 18 9 9 1 1 1 1 1 1,
         78 8 5 3 1 1 1 1 1 1,
         78 8 5 3 1 1 1 1 1 1,
         90 2 1 1 1 1 1 1 1 1,
         15 65 5 9 1 1 1 1 1 1,
         5 5 59 25 1 1 1 1 1 1,
         23 23 24 24 1 1 1 1 1 1,
         49 27 17 1 1 1 1 1 1 1,
         27 1 65 1 1 1 1 1 1 1,
         24 24 23 23 1 1 1 1 1 1] ;        
                          
ID_os = [58 18 9 9 1 1 1 1 1 1,
         78 8 5 3 1 1 1 1 1 1,
         78 8 5 3 1 1 1 1 1 1,
         90 2 1 1 1 1 1 1 1 1,
         15 65 5 9 1 1 1 1 1 1,
         5 5 59 25 1 1 1 1 1 1,
         23 23 24 24 1 1 1 1 1 1,
         49 27 17 1 1 1 1 1 1 1,
         27 1 65 1 1 1 1 1 1 1,
         24 24 23 23 1 1 1 1 1 1] ;   
     
ID_dr = [58 18 9 9 1 1 1 1 1 1,
         78 8 5 3 1 1 1 1 1 1,
         78 8 5 3 1 1 1 1 1 1,
         90 2 1 1 1 1 1 1 1 1,
         15 65 5 9 1 1 1 1 1 1,
         5 5 59 25 1 1 1 1 1 1,
         23 23 24 24 1 1 1 1 1 1,
         49 27 17 1 1 1 1 1 1 1,
         27 1 65 1 1 1 1 1 1 1,
         24 24 23 23 1 1 1 1 1 1] ;  
     
     E_apps2 = E_apps;
E_serv2 = E_serv;
E_os2 = E_os;
E_dr2 = E_dr;     
ID_apps2 = ID_apps;
ID_serv2 = ID_serv;
ID_os2 = ID_os;
ID_dr2 = ID_dr;
%INDIVIDUAL TIME ARRAY OF CHANGES TO PERSONAL INDIVIDUAL DESIRABILITIES
%needs to be set here because numNodes is different for each case
numNodes = 10;
IDtimeArray1 = zeros(1,numNodes);
IDtimeArray2 = zeros(1,numNodes);

case 8
%%%%%%%%%%%%%
% set up data - Dataset 8
%%%%%%%%%%%%%
%software strings
%WebBrowser1,6 - commercial products, WebBrowser2,3,4,5 third party
SW_str_apps = ['WebBrowser1v1 ' 'WebBrowser1v2 ' 'WebBrowser2v1 ' 'WebBrowser3v1 ' 'WebBrowser4v1 ' 'WebBrowser5v1 ' 'WebBrowser6v1 ' 'WebBrowser6v4 ' 'WebBrowser7v1 ' 'WebBrowser7v3 ''WebBrowser8v1 ' 'WebBrowser8v2 ' 'WebBrowser8v3 ' 'WebBrowser9v1 ' 'WebBrowser10v1 ' 'WebBrowser11v1 ' 'WebBrowser12v1 ' 'WebBrowser13v4 ' 'WebBrowser14v1 ' 'WebBrowser15v3 '];
%All photo viewers about same standard with number 7 slightly better
SW_str_serv = ['PhotoViewer1 ' 'PhotoViewer2 ' 'PhotoViewer3 ' 'PhotoViewer4 ' 'PhotoViewer5 ' 'PhotoViewer6 ' 'PhotoViewer7v1 ' 'PhotoViewer7v2 ' 'PhotoViewer8 ' 'Photoviewer9 ' 'PhotoViewer1 ' 'PhotoViewer2 ' 'PhotoViewer3 ' 'PhotoViewer4 ' 'PhotoViewer5 ' 'PhotoViewer6 ' 'PhotoViewer7v1 ' 'PhotoViewer7v2 ' 'PhotoViewer8 ' 'Photoviewer9 '];
%OS2 slightly more efficient overall than OS1
SW_str_os = ['OS1 ' 'OS2 ' 'OS3 ' 'OS4 ' 'OS5' 'OS6' 'OS7' 'OS8' 'OS9' 'OS10'];
%higher versions are better than lower number versions, the commercial
%products are more efficient than the freebies 3rd party
SW_str_dr = ['DataDr1v1 ' 'DataDr1v2 ' 'DataDr2v1 ' 'DataDr3v3 ' 'DataDr4 ' 'DataDr5 ' 'DataDr6 ' 'DataDr7 ' 'DataDr9 ' 'DataDr8 ' 'DataDr1v1 ' 'DataDr1v2 ' 'DataDr2v1 ' 'DataDr3v3 ' 'DataDr4 ' 'DataDr5 ' 'DataDr6 ' 'DataDr7 ' 'DataDr9 ' 'DataDr8 '];

%software frequency info for running the frequency and nei diversity index
%algorithm
%locusApps - 'a' represents major variants, 'V' represents a minor version
%locusServ - 's' represents major variants, 'V' represents a minor version
%locusOS  - 'o' represents major variants, 'V' represents a minor version
SW_freq_apps = ['a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V';'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'];
SW_freq_serv = ['s', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'];
SW_freq_os = ['o', 'V'; 'o', 'V'; 'o', 'V'; 'o', 'V';'o', 'V'; 'o', 'V'; 'o', 'V'; 'o', 'V';'o', 'V'; 'o', 'V'];
SW_freq_dr = ['d', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'];

%compatability of software
CSW_str_apps = ['a'; 'b'; 'c' ;'d'; 'e'; 'f'; 'g'; 'h'; 'i'; 'j'; 'a'; 'b'; 'c' ;'d'; 'e'; 'f'; 'g'; 'h'; 'i'; 'j'];
CSW_str_serv = ['a'; 'b'; 'c'; 'd'; 'e'; 'f'; 'g'; 'h'; 'i'; 'j'; 'a'; 'b'; 'c'; 'd'; 'e'; 'f'; 'g'; 'h'; 'i'; 'j'];
CSW_str_os = ['a'; 'b'; 'c'; 'd'; 'e'; 'f'; 'g'; 'h'; 'i'; 'j'];
CSW_str_dr = ['a'; 'b'; 'c'; 'd'; 'e' ;'f'; 'g'; 'h'; 'i'; 'j'; 'a'; 'b'; 'c'; 'd'; 'e'; 'f'; 'g'; 'h'; 'i'; 'j'];
CSW = [CSW_str_apps; CSW_str_serv; CSW_str_os; CSW_str_dr];
%create filters
CSW1 = zeros(size(CSW));
CSW2 = zeros(size(CSW));
CSW3 = zeros(size(CSW));
CSW4 = zeros(size(CSW));
CSW5 = zeros(size(CSW));
CSW6 = zeros(size(CSW));
CSW7 = zeros(size(CSW));
CSW8 = zeros(size(CSW));
CSW9 = zeros(size(CSW));
CSW10 = zeros(size(CSW));
for z = 1:size(CSW)
  if CSW(z) ==  'a'
      CSW1(z) = 1;
  end;
  if CSW(z) ==  'b'
      CSW2(z) = 1;
  end;
 if CSW(z) ==  'c'
      CSW3(z) = 1;
  end;
 if CSW(z) ==  'd'
      CSW4(z) = 1;
  end;
  if CSW(z) ==  'e'
      CSW5(z) = 1;
  end;
  if CSW(z) ==  'f'
      CSW6(z) = 1;
  end;
 if CSW(z) ==  'g'
      CSW7(z) = 1;
  end;
 if CSW(z) ==  'h'
      CSW8(z) = 1;
  end;  
  if CSW(z) ==  'i'
      CSW9(z) = 1;
  end;
  if CSW(z) ==  'j'
      CSW10(z) = 1;
  end;

end; %end for z
CSW1 = CSW1';
CSW2 = CSW2';
CSW3 = CSW3';
CSW4 = CSW4';
CSW5 = CSW5';
CSW6 = CSW6';
CSW7 = CSW7';
CSW8 = CSW8';
CSW9 = CSW9';
CSW10 = CSW10';
CSWGroup(1,:) = CSW1;
CSWGroup(2,:) = CSW2;
CSWGroup(3,:) = CSW3;
CSWGroup(4,:) = CSW4;
CSWGroup(5,:) = CSW5;
CSWGroup(6,:) = CSW6;
CSWGroup(7,:) = CSW7;
CSWGroup(8,:) = CSW8;
CSWGroup(9,:) = CSW9;
CSWGroup(10,:) = CSW10;

%A possible max diversity solution
Genotype_apps = [1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0,
                 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0,
                 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0,
                 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0,
                 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0,
                 0 0 0 0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0,
                 0 0 0 0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0,
                 0 0 0 0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0,
                 0 0 0 0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0,
                 0 0 0 0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0];
             
Genotype_serv = [1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0,
                 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0,
                 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0,
                 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0,
                 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0,
                 0 0 0 0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0,
                 0 0 0 0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0,
                 0 0 0 0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0,
                 0 0 0 0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0,
                 0 0 0 0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0];
             
Genotype_os = [1 0 0 0 0 0 0 0 0 0,
               1 0 0 0 0 0 0 0 0 0, 
               1 0 0 0 0 0 0 0 0 0,
               1 0 0 0 0 0 0 0 0 0,
               1 0 0 0 0 0 0 0 0 0,
               0 0 0 0 1 0 0 0 0 0,
               0 0 0 0 1 0 0 0 0 0,
               0 0 0 0 1 0 0 0 0 0,
               0 0 0 0 1 0 0 0 0 0,
               0 0 0 0 1 0 0 0 0 0];
           
 Genotype_dr = [1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0,
                1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0,
                1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0,
                1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0,
                1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0,
                0 0 0 0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0,
                0 0 0 0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0,
                0 0 0 0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0,
                0 0 0 0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0,
                0 0 0 0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0];
            
%efficiency/quality ratings of software (1 to 100) 
%(1)inefficient (100)maximum efficiency
E_apps = [65 75 55 50 60 60 60 80 20 20 65 75 55 50 60 60 60 80 20 20];
E_serv = [65 66 67 63 59 62 72 77 50 50 65 75 55 50 60 60 60 80 20 20];
E_os = [50 50 50 50 50 50 50 50 50 50];
E_dr = [70 80 60 75 69 68 63 58 65 65 65 75 55 50 60 60 60 80 20 20];

%community desirability ratings (1 to 100) (1)least desirable (100)most
%desirable
%MUST NOT HAVE ANY ZERO VALUES!
%CD_apps = [15 35 10 5 10 5 3 2 10 5 0 0 0 0 0 0 0 0 0 0];
%CD_apps = [85 5 5 5 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0];
CD_apps = [81 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1];
%CD_apps = [12.5 12.5 12.5 12.5 12.5 12.5 12.5 12.5];
sum(CD_apps);
%CD_serv = [60 5 3 2 5 5 5 5 5 5 0 0 0 0 0 0 0 0 0 0];
%CD_serv = [85 5 5 5 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0];
CD_serv = [81 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1];
%CD_serv = [12.5 12.5 12.5 12.5 12.5 12.5 12.5 12.5];
sum(CD_serv);
%CD_os = [80 10 5 5 0 0 0 0 0 0];
%CD_os = [85 5 5 5 0 0 0 0 0 0];
CD_os = [82 2 2 2 2 2 2 2 2 2];
%CD_os = [12.5 12.5];
sum(CD_os);
%CD_dr = [50 20 5 5 10 5 3 2 0 0 0 0 0 0 0 0 0 0 0 0];
%CD_dr = [85 5 5 5 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0];
CD_dr = [81 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1];
%CD_dr = [12.5 12.5 12.5 12.5 12.5 12.5 12.5 12.5];
sum(CD_dr);
%for change over
CD_apps2 = [15 5 2 4 1 1 1 1 1 1 53 5 3 1 1 1 1 1 1 1];
%CD_apps2 = [12.5 12.5 12.5 12.5 12.5 12.5 12.5 12.5];
sum(CD_apps2);
CD_serv2 = [56 5 3 2 1 1 1 1 1 1 12 5 2 3 1 1 1 1 1 1];
%CD_serv2 = [12.5 12.5 12.5 12.5 12.5 12.5 12.5 12.5];
sum(CD_serv2);
CD_os2 = [68 10 5 5 2 2 2 2 2 2];
%CD_os2 = [12.5 12.5];
sum(CD_os2);
CD_dr2 = [48 5 4 4 1 1 1 1 1 1 20 5 1 1 1 1 1 1 1 1];
%CD_dr2 = [12.5 12.5 12.5 12.5 12.5 12.5 12.5 12.5];
sum(CD_dr2);
            
%individual desirability ratings (1 to 100) (1)least desirable (100)most
%desirable
%MUST NOT HAVE ANY ZERO VALUES!
%do for 10 individuals
ID_apps = [22 12 4 5 1 1 1 1 1 1 28 10 4 3 1 1 1 1 1 1,
           18 6 2 2 1 1 1 1 1 1 52 2 3 3 1 1 1 1 1 1,
           18 6 2 2 1 1 1 1 1 1 52 2 3 3 1 1 1 1 1 1,
           40 1 1 1 1 1 1 1 1 1 42 1 1 1 1 1 1 1 1 1,
           5 50 3 2 1 1 1 1 1 1 10 8 2 8 1 1 1 1 1 1,
           1 1 5 5 1 1 1 1 1 1 1 4 4 43 25 1 1 1 1 1,
           10 15 10 11 1 1 1 1 1 1 14 9 10 9 1 1 1 1 1 1,
           15 20 3 1 1 1 1 1 1 1 25 6 17 1 1 1 1 1 1 1,
           14 1 54 1 1 1 1 1 1 1 10 1 6 1 1 1 1 1 1 1,
           10 10 10 10 1 1 1 1 1 1 14 14 10 10 1 1 1 1 1 1];  
            
ID_serv = [22 12 4 5 1 1 1 1 1 1 28 10 4 3 1 1 1 1 1 1,
           18 6 2 2 1 1 1 1 1 1 52 2 3 3 1 1 1 1 1 1,
           18 6 2 2 1 1 1 1 1 1 52 2 3 3 1 1 1 1 1 1,
           40 1 1 1 1 1 1 1 1 1 42 1 1 1 1 1 1 1 1 1,
           5 50 3 2 1 1 1 1 1 1 10 8 2 8 1 1 1 1 1 1,
           1 1 5 5 1 1 1 1 1 1 1 4 4 43 25 1 1 1 1 1,
           10 15 10 11 1 1 1 1 1 1 14 9 10 9 1 1 1 1 1 1,
           15 20 3 1 1 1 1 1 1 1 25 6 17 1 1 1 1 1 1 1,
           14 1 54 1 1 1 1 1 1 1 10 1 6 1 1 1 1 1 1 1,
           10 10 10 10 1 1 1 1 1 1 14 14 10 10 1 1 1 1 1 1];       
                          
ID_os = [50 22 8 8 2 2 2 2 2 2,
         70 8 5 5 2 2 2 2 2 2,
         70 8 5 5 2 2 2 2 2 2,
         82 2 2 2 2 2 2 2 2 2,
         15 58 5 10 2 2 2 2 2 2,
         5 5 48 30 2 2 2 2 2 2,
         24 24 20 20 2 2 2 2 2 2,
         40 26 20 2 2 2 2 2 2 2,
         24 2 60 2 2 2 2 2 2 2,
         24 24 20 20 2 2 2 2 2 2] ;   
     
ID_dr = [22 12 4 5 1 1 1 1 1 1 28 10 4 3 1 1 1 1 1 1,
           18 6 2 2 1 1 1 1 1 1 52 2 3 3 1 1 1 1 1 1,
           18 6 2 2 1 1 1 1 1 1 52 2 3 3 1 1 1 1 1 1,
           40 1 1 1 1 1 1 1 1 1 42 1 1 1 1 1 1 1 1 1,
           5 50 3 2 1 1 1 1 1 1 10 8 2 8 1 1 1 1 1 1,
           1 1 5 5 1 1 1 1 1 1 1 4 4 43 25 1 1 1 1 1,
           10 15 10 11 1 1 1 1 1 1 14 9 10 9 1 1 1 1 1 1,
           15 20 3 1 1 1 1 1 1 1 25 6 17 1 1 1 1 1 1 1,
           14 1 54 1 1 1 1 1 1 1 10 1 6 1 1 1 1 1 1 1,
           10 10 10 10 1 1 1 1 1 1 14 14 10 10 1 1 1 1 1 1];  
       
       E_apps2 = E_apps;
E_serv2 = E_serv;
E_os2 = E_os;
E_dr2 = E_dr;     
ID_apps2 = ID_apps;
ID_serv2 = ID_serv;
ID_os2 = ID_os;
ID_dr2 = ID_dr;
%INDIVIDUAL TIME ARRAY OF CHANGES TO PERSONAL INDIVIDUAL DESIRABILITIES
%needs to be set here because numNodes is different for each case
numNodes = 10;
IDtimeArray1 = zeros(1,numNodes);
IDtimeArray2 = zeros(1,numNodes);

case 9
%%%%%%%%%%%%%
% set up data - Dataset 9
%%%%%%%%%%%%%
numNodes = 20
%software strings
%WebBrowser1,6 - commercial products, WebBrowser2,3,4,5 third party
SW_str_apps = ['WebBrowser1v1 ' 'WebBrowser1v2 ' 'WebBrowser2v1 ' 'WebBrowser3v1 ' 'WebBrowser4v1 ' 'WebBrowser5v1 ' 'WebBrowser6v1 ' 'WebBrowser6v4 ' 'WebBrowser7v1 ' 'WebBrowser7v3 ''WebBrowser8v1 ' 'WebBrowser8v2 ' 'WebBrowser8v3 ' 'WebBrowser9v1 ' 'WebBrowser10v1 ' 'WebBrowser11v1 ' 'WebBrowser12v1 ' 'WebBrowser13v4 ' 'WebBrowser14v1 ' 'WebBrowser15v3 '];
%All photo viewers about same standard with number 7 slightly better
SW_str_serv = ['PhotoViewer1 ' 'PhotoViewer2 ' 'PhotoViewer3 ' 'PhotoViewer4 ' 'PhotoViewer5 ' 'PhotoViewer6 ' 'PhotoViewer7v1 ' 'PhotoViewer7v2 ' 'PhotoViewer8 ' 'Photoviewer9 ' 'PhotoViewer1 ' 'PhotoViewer2 ' 'PhotoViewer3 ' 'PhotoViewer4 ' 'PhotoViewer5 ' 'PhotoViewer6 ' 'PhotoViewer7v1 ' 'PhotoViewer7v2 ' 'PhotoViewer8 ' 'Photoviewer9 '];
%OS2 slightly more efficient overall than OS1
SW_str_os = ['OS1 ' 'OS2 ' 'OS3 ' 'OS4 ' 'OS5' 'OS6' 'OS7' 'OS8' 'OS9' 'OS10'];
%higher versions are better than lower number versions, the commercial
%products are more efficient than the freebies 3rd party
SW_str_dr = ['DataDr1v1 ' 'DataDr1v2 ' 'DataDr2v1 ' 'DataDr3v3 ' 'DataDr4 ' 'DataDr5 ' 'DataDr6 ' 'DataDr7 ' 'DataDr9 ' 'DataDr8 ' 'DataDr1v1 ' 'DataDr1v2 ' 'DataDr2v1 ' 'DataDr3v3 ' 'DataDr4 ' 'DataDr5 ' 'DataDr6 ' 'DataDr7 ' 'DataDr9 ' 'DataDr8 '];

%software frequency info for running the frequency and nei diversity index
%algorithm
%locusApps - 'a' represents major variants, 'V' represents a minor version
%locusServ - 's' represents major variants, 'V' represents a minor version
%locusOS  - 'o' represents major variants, 'V' represents a minor version
SW_freq_apps = ['a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V';'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'];
SW_freq_serv = ['s', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'];
SW_freq_os = ['o', 'V'; 'o', 'V'; 'o', 'V'; 'o', 'V';'o', 'V'; 'o', 'V'; 'o', 'V'; 'o', 'V';'o', 'V'; 'o', 'V'];
SW_freq_dr = ['d', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'];

%compatability of software
CSW_str_apps = ['a'; 'b'; 'c' ;'d'; 'e'; 'f'; 'g'; 'h'; 'i'; 'j'; 'a'; 'b'; 'c' ;'d'; 'e'; 'f'; 'g'; 'h'; 'i'; 'j'];
CSW_str_serv = ['a'; 'b'; 'c'; 'd'; 'e'; 'f'; 'g'; 'h'; 'i'; 'j'; 'a'; 'b'; 'c'; 'd'; 'e'; 'f'; 'g'; 'h'; 'i'; 'j'];
CSW_str_os = ['a'; 'b'; 'c'; 'd'; 'e'; 'f'; 'g'; 'h'; 'i'; 'j'];
CSW_str_dr = ['a'; 'b'; 'c'; 'd'; 'e' ;'f'; 'g'; 'h'; 'i'; 'j'; 'a'; 'b'; 'c'; 'd'; 'e'; 'f'; 'g'; 'h'; 'i'; 'j'];
CSW = [CSW_str_apps; CSW_str_serv; CSW_str_os; CSW_str_dr];
%create filters
CSW1 = zeros(size(CSW));
CSW2 = zeros(size(CSW));
CSW3 = zeros(size(CSW));
CSW4 = zeros(size(CSW));
CSW5 = zeros(size(CSW));
CSW6 = zeros(size(CSW));
CSW7 = zeros(size(CSW));
CSW8 = zeros(size(CSW));
CSW9 = zeros(size(CSW));
CSW10 = zeros(size(CSW));
for z = 1:size(CSW)
  if CSW(z) ==  'a'
      CSW1(z) = 1;
  end;
  if CSW(z) ==  'b'
      CSW2(z) = 1;
  end;
 if CSW(z) ==  'c'
      CSW3(z) = 1;
  end;
 if CSW(z) ==  'd'
      CSW4(z) = 1;
  end;
  if CSW(z) ==  'e'
      CSW5(z) = 1;
  end;
  if CSW(z) ==  'f'
      CSW6(z) = 1;
  end;
 if CSW(z) ==  'g'
      CSW7(z) = 1;
  end;
 if CSW(z) ==  'h'
      CSW8(z) = 1;
  end;  
  if CSW(z) ==  'i'
      CSW9(z) = 1;
  end;
  if CSW(z) ==  'j'
      CSW10(z) = 1;
  end;

end; %end for z
CSW1 = CSW1';
CSW2 = CSW2';
CSW3 = CSW3';
CSW4 = CSW4';
CSW5 = CSW5';
CSW6 = CSW6';
CSW7 = CSW7';
CSW8 = CSW8';
CSW9 = CSW9';
CSW10 = CSW10';
CSWGroup(1,:) = CSW1;
CSWGroup(2,:) = CSW2;
CSWGroup(3,:) = CSW3;
CSWGroup(4,:) = CSW4;
CSWGroup(5,:) = CSW5;
CSWGroup(6,:) = CSW6;
CSWGroup(7,:) = CSW7;
CSWGroup(8,:) = CSW8;
CSWGroup(9,:) = CSW9;
CSWGroup(10,:) = CSW10;

%A possible max diversity solution
Genotype_apps = [1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0,
                 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0,
                 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0,
                 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0,
                 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0,
                 0 0 0 0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0,
                 0 0 0 0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0,
                 0 0 0 0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0,
                 0 0 0 0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0,
                 0 0 0 0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0,
                 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0,
                 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0,
                 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0,
                 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0,
                 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0,
                 0 0 0 0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0,
                 0 0 0 0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0,
                 0 0 0 0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0,
                 0 0 0 0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0,
                 0 0 0 0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0];
             
Genotype_serv = [1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0,
                 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0,
                 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0,
                 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0,
                 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0,
                 0 0 0 0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0,
                 0 0 0 0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0,
                 0 0 0 0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0,
                 0 0 0 0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0,
                 0 0 0 0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0,
                 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0,
                 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0,
                 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0,
                 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0,
                 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0,
                 0 0 0 0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0,
                 0 0 0 0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0,
                 0 0 0 0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0,
                 0 0 0 0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0,
                 0 0 0 0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0];
             
Genotype_os = [1 0 0 0 0 0 0 0 0 0,
               1 0 0 0 0 0 0 0 0 0, 
               1 0 0 0 0 0 0 0 0 0,
               1 0 0 0 0 0 0 0 0 0,
               1 0 0 0 0 0 0 0 0 0,
               0 0 0 0 1 0 0 0 0 0,
               0 0 0 0 1 0 0 0 0 0,
               0 0 0 0 1 0 0 0 0 0,
               0 0 0 0 1 0 0 0 0 0,
               0 0 0 0 1 0 0 0 0 0,
               1 0 0 0 0 0 0 0 0 0,
               1 0 0 0 0 0 0 0 0 0, 
               1 0 0 0 0 0 0 0 0 0,
               1 0 0 0 0 0 0 0 0 0,
               1 0 0 0 0 0 0 0 0 0,
               0 0 0 0 1 0 0 0 0 0,
               0 0 0 0 1 0 0 0 0 0,
               0 0 0 0 1 0 0 0 0 0,
               0 0 0 0 1 0 0 0 0 0,
               0 0 0 0 1 0 0 0 0 0];
           
 Genotype_dr = [1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0,
                1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0,
                1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0,
                1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0,
                1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0,
                0 0 0 0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0,
                0 0 0 0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0,
                0 0 0 0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0,
                0 0 0 0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0,
                0 0 0 0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0,
                1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0,
                1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0,
                1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0,
                1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0,
                1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0,
                0 0 0 0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0,
                0 0 0 0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0,
                0 0 0 0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0,
                0 0 0 0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0,
                0 0 0 0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0];
            
%efficiency/quality ratings of software (1 to 100) 
%(1)inefficient (100)maximum efficiency
E_apps = [65 75 55 50 60 60 60 80 20 20 65 75 55 50 60 60 60 80 20 20];
E_serv = [65 66 67 63 59 62 72 77 50 50 65 75 55 50 60 60 60 80 20 20];
E_os = [50 50 50 50 50 50 50 50 50 50];
E_dr = [70 80 60 75 69 68 63 58 65 65 65 75 55 50 60 60 60 80 20 20];

E_apps2 = [1 1 1 50 60 60 60 80 60 80 1 1 1 50 60 60 60 80 60 80];
E_serv2 = [1 1 1 63 59 62 72 77 77 77 1 1 1 50 60 60 60 80 60 80];
E_os2 = [1 85 1 1 1 1 1 1 1 1];
E_dr2 = [1 1 1 75 69 68 63 58 77 77 1 1 1 50 60 60 60 80 60 80];

%community desirability ratings (1 to 100) (1)least desirable (100)most
%desirable
%CD_apps = [15 35 10 5 10 5 3 2 10 5 0 0 0 0 0 0 0 0 0 0];
%CD_apps = [85 5 5 5 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0];
CD_apps = [81 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1];
%CD_apps = [12.5 12.5 12.5 12.5 12.5 12.5 12.5 12.5];
sum(CD_apps);
%CD_serv = [60 5 3 2 5 5 5 5 5 5 0 0 0 0 0 0 0 0 0 0];
%CD_serv = [85 5 5 5 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0];
CD_serv = [81 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1];
%CD_serv = [12.5 12.5 12.5 12.5 12.5 12.5 12.5 12.5];
sum(CD_serv);
%CD_os = [80 10 5 5 0 0 0 0 0 0];
%CD_os = [85 5 5 5 0 0 0 0 0 0];
CD_os = [82 2 2 2 2 2 2 2 2 2];
%CD_os = [12.5 12.5];
sum(CD_os);
%CD_dr = [50 20 5 5 10 5 3 2 0 0 0 0 0 0 0 0 0 0 0 0];
%CD_dr = [85 5 5 5 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0];
CD_dr = [81 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1];
%CD_dr = [12.5 12.5 12.5 12.5 12.5 12.5 12.5 12.5];
sum(CD_dr);
%for change over
%for change over
CD_apps2 = [15 5 2 4 1 1 1 1 1 1 53 5 3 1 1 1 1 1 1 1];
%CD_apps2 = [12.5 12.5 12.5 12.5 12.5 12.5 12.5 12.5];
sum(CD_apps2);
CD_serv2 = [56 5 3 2 1 1 1 1 1 1 12 5 2 3 1 1 1 1 1 1];
%CD_serv2 = [12.5 12.5 12.5 12.5 12.5 12.5 12.5 12.5];
sum(CD_serv2);
CD_os2 = [68 10 5 5 2 2 2 2 2 2];
%CD_os2 = [12.5 12.5];
sum(CD_os2);
CD_dr2 = [48 5 4 4 1 1 1 1 1 1 20 5 1 1 1 1 1 1 1 1];
%CD_dr2 = [12.5 12.5 12.5 12.5 12.5 12.5 12.5 12.5];
sum(CD_dr2);
            
%individual desirability ratings (1 to 100) (1)least desirable (100)most
%desirable
%MUST NOT HAVE ANY ZERO VALUES!
%do for 10 individuals
ID_apps = [22 12 4 5 1 1 1 1 1 1 28 10 4 3 1 1 1 1 1 1,
           18 6 2 2 1 1 1 1 1 1 52 2 3 3 1 1 1 1 1 1,
           18 6 2 2 1 1 1 1 1 1 52 2 3 3 1 1 1 1 1 1,
           40 1 1 1 1 1 1 1 1 1 42 1 1 1 1 1 1 1 1 1,
           5 50 3 2 1 1 1 1 1 1 10 8 2 8 1 1 1 1 1 1,
           1 1 5 5 1 1 1 1 1 1 1 4 4 43 25 1 1 1 1 1,
           10 15 10 11 1 1 1 1 1 1 14 9 10 9 1 1 1 1 1 1,
           15 20 3 1 1 1 1 1 1 1 25 6 17 1 1 1 1 1 1 1,
           14 1 54 1 1 1 1 1 1 1 10 1 6 1 1 1 1 1 1 1,
           10 10 10 10 1 1 1 1 1 1 14 14 10 10 1 1 1 1 1 1,
           22 12 4 5 1 1 1 1 1 1 28 10 4 3 1 1 1 1 1 1,
           18 6 2 2 1 1 1 1 1 1 52 2 3 3 1 1 1 1 1 1,
           18 6 2 2 1 1 1 1 1 1 52 2 3 3 1 1 1 1 1 1,
           40 1 1 1 1 1 1 1 1 1 42 1 1 1 1 1 1 1 1 1,
           5 50 3 2 1 1 1 1 1 1 10 8 2 8 1 1 1 1 1 1,
           1 1 5 5 1 1 1 1 1 1 1 4 4 43 25 1 1 1 1 1,
           10 15 10 11 1 1 1 1 1 1 14 9 10 9 1 1 1 1 1 1,
           15 20 3 1 1 1 1 1 1 1 25 6 17 1 1 1 1 1 1 1,
           14 1 54 1 1 1 1 1 1 1 10 1 6 1 1 1 1 1 1 1,
           10 10 10 10 1 1 1 1 1 1 14 14 10 10 1 1 1 1 1 1];  
            
ID_serv = [22 12 4 5 1 1 1 1 1 1 28 10 4 3 1 1 1 1 1 1,
           18 6 2 2 1 1 1 1 1 1 52 2 3 3 1 1 1 1 1 1,
           18 6 2 2 1 1 1 1 1 1 52 2 3 3 1 1 1 1 1 1,
           40 1 1 1 1 1 1 1 1 1 42 1 1 1 1 1 1 1 1 1,
           5 50 3 2 1 1 1 1 1 1 10 8 2 8 1 1 1 1 1 1,
           1 1 5 5 1 1 1 1 1 1 1 4 4 43 25 1 1 1 1 1,
           10 15 10 11 1 1 1 1 1 1 14 9 10 9 1 1 1 1 1 1,
           15 20 3 1 1 1 1 1 1 1 25 6 17 1 1 1 1 1 1 1,
           14 1 54 1 1 1 1 1 1 1 10 1 6 1 1 1 1 1 1 1,
           10 10 10 10 1 1 1 1 1 1 14 14 10 10 1 1 1 1 1 1,
           22 12 4 5 1 1 1 1 1 1 28 10 4 3 1 1 1 1 1 1,
           18 6 2 2 1 1 1 1 1 1 52 2 3 3 1 1 1 1 1 1,
           18 6 2 2 1 1 1 1 1 1 52 2 3 3 1 1 1 1 1 1,
           40 1 1 1 1 1 1 1 1 1 42 1 1 1 1 1 1 1 1 1,
           5 50 3 2 1 1 1 1 1 1 10 8 2 8 1 1 1 1 1 1,
           1 1 5 5 1 1 1 1 1 1 1 4 4 43 25 1 1 1 1 1,
           10 15 10 11 1 1 1 1 1 1 14 9 10 9 1 1 1 1 1 1,
           15 20 3 1 1 1 1 1 1 1 25 6 17 1 1 1 1 1 1 1,
           14 1 54 1 1 1 1 1 1 1 10 1 6 1 1 1 1 1 1 1,
           10 10 10 10 1 1 1 1 1 1 14 14 10 10 1 1 1 1 1 1];       
                          
ID_os = [50 22 8 8 2 2 2 2 2 2,
         70 8 5 5 2 2 2 2 2 2,
         70 8 5 5 2 2 2 2 2 2,
         82 2 2 2 2 2 2 2 2 2,
         15 58 5 10 2 2 2 2 2 2,
         5 5 48 30 2 2 2 2 2 2,
         24 24 20 20 2 2 2 2 2 2,
         40 26 20 2 2 2 2 2 2 2,
         24 2 60 2 2 2 2 2 2 2,
         24 24 20 20 2 2 2 2 2 2,
         50 22 8 8 2 2 2 2 2 2,
         70 8 5 5 2 2 2 2 2 2,
         70 8 5 5 2 2 2 2 2 2,
         82 2 2 2 2 2 2 2 2 2,
         15 58 5 10 2 2 2 2 2 2,
         5 5 48 30 2 2 2 2 2 2,
         24 24 20 20 2 2 2 2 2 2,
         40 26 20 2 2 2 2 2 2 2,
         24 2 60 2 2 2 2 2 2 2,
         24 24 20 20 2 2 2 2 2 2] ;   
     
ID_dr = [22 12 4 5 1 1 1 1 1 1 28 10 4 3 1 1 1 1 1 1,
           18 6 2 2 1 1 1 1 1 1 52 2 3 3 1 1 1 1 1 1,
           18 6 2 2 1 1 1 1 1 1 52 2 3 3 1 1 1 1 1 1,
           40 1 1 1 1 1 1 1 1 1 42 1 1 1 1 1 1 1 1 1,
           5 50 3 2 1 1 1 1 1 1 10 8 2 8 1 1 1 1 1 1,
           1 1 5 5 1 1 1 1 1 1 1 4 4 43 25 1 1 1 1 1,
           10 15 10 11 1 1 1 1 1 1 14 9 10 9 1 1 1 1 1 1,
           15 20 3 1 1 1 1 1 1 1 25 6 17 1 1 1 1 1 1 1,
           14 1 54 1 1 1 1 1 1 1 10 1 6 1 1 1 1 1 1 1,
           10 10 10 10 1 1 1 1 1 1 14 14 10 10 1 1 1 1 1 1,
           22 12 4 5 1 1 1 1 1 1 28 10 4 3 1 1 1 1 1 1,
           18 6 2 2 1 1 1 1 1 1 52 2 3 3 1 1 1 1 1 1,
           18 6 2 2 1 1 1 1 1 1 52 2 3 3 1 1 1 1 1 1,
           40 1 1 1 1 1 1 1 1 1 42 1 1 1 1 1 1 1 1 1,
           5 50 3 2 1 1 1 1 1 1 10 8 2 8 1 1 1 1 1 1,
           1 1 5 5 1 1 1 1 1 1 1 4 4 43 25 1 1 1 1 1,
           10 15 10 11 1 1 1 1 1 1 14 9 10 9 1 1 1 1 1 1,
           15 20 3 1 1 1 1 1 1 1 25 6 17 1 1 1 1 1 1 1,
           14 1 54 1 1 1 1 1 1 1 10 1 6 1 1 1 1 1 1 1,
           10 10 10 10 1 1 1 1 1 1 14 14 10 10 1 1 1 1 1 1];
       
            ID_apps2 = ID_apps;
     ID_os2 = ID_os;
     ID_dr2 = ID_dr;
ID_serv2 = ID_serv;
       
           %INDIVIDUAL TIME ARRAY OF CHANGES TO PERSONAL INDIVIDUAL DESIRABILITIES
           %needs to be set here because numNodes is different for each
           %case
IDtimeArray1 = zeros(1,numNodes);
IDtimeArray2 = zeros(1,numNodes);
       
    case 10

%%%%%%%%%%%%%
% set up data - Dataset 10 - 100 nodes
%%%%%%%%%%%%%
numNodes = 100
%software strings
%WebBrowser1,6 - commercial products, WebBrowser2,3,4,5 third party
SW_str_apps = ['WebBrowser1v1 ' 'WebBrowser1v2 ' 'WebBrowser2v1 ' 'WebBrowser3v1 ' 'WebBrowser4v1 ' 'WebBrowser5v1 ' 'WebBrowser6v1 ' 'WebBrowser6v4 ' 'WebBrowser7v1 ' 'WebBrowser7v3 ''WebBrowser8v1 ' 'WebBrowser8v2 ' 'WebBrowser8v3 ' 'WebBrowser9v1 ' 'WebBrowser10v1 ' 'WebBrowser11v1 ' 'WebBrowser12v1 ' 'WebBrowser13v4 ' 'WebBrowser14v1 ' 'WebBrowser15v3 '];
%All photo viewers about same standard with number 7 slightly better
SW_str_serv = ['PhotoViewer1 ' 'PhotoViewer2 ' 'PhotoViewer3 ' 'PhotoViewer4 ' 'PhotoViewer5 ' 'PhotoViewer6 ' 'PhotoViewer7v1 ' 'PhotoViewer7v2 ' 'PhotoViewer8 ' 'Photoviewer9 ' 'PhotoViewer1 ' 'PhotoViewer2 ' 'PhotoViewer3 ' 'PhotoViewer4 ' 'PhotoViewer5 ' 'PhotoViewer6 ' 'PhotoViewer7v1 ' 'PhotoViewer7v2 ' 'PhotoViewer8 ' 'Photoviewer9 '];
%OS2 slightly more efficient overall than OS1
SW_str_os = ['OS1 ' 'OS2 ' 'OS3 ' 'OS4 ' 'OS5' 'OS6' 'OS7' 'OS8' 'OS9' 'OS10'];
%higher versions are better than lower number versions, the commercial
%products are more efficient than the freebies 3rd party
SW_str_dr = ['DataDr1v1 ' 'DataDr1v2 ' 'DataDr2v1 ' 'DataDr3v3 ' 'DataDr4 ' 'DataDr5 ' 'DataDr6 ' 'DataDr7 ' 'DataDr9 ' 'DataDr8 ' 'DataDr1v1 ' 'DataDr1v2 ' 'DataDr2v1 ' 'DataDr3v3 ' 'DataDr4 ' 'DataDr5 ' 'DataDr6 ' 'DataDr7 ' 'DataDr9 ' 'DataDr8 '];

%software frequency info for running the frequency and nei diversity index
%algorithm
%locusApps - 'a' represents major variants, 'V' represents a minor version
%locusServ - 's' represents major variants, 'V' represents a minor version
%locusOS  - 'o' represents major variants, 'V' represents a minor version
SW_freq_apps = ['a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V';'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'];
SW_freq_serv = ['s', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'];
SW_freq_os = ['o', 'V'; 'o', 'V'; 'o', 'V'; 'o', 'V';'o', 'V'; 'o', 'V'; 'o', 'V'; 'o', 'V';'o', 'V'; 'o', 'V'];
SW_freq_dr = ['d', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'];

%compatability of software
CSW_str_apps = ['a'; 'b'; 'c' ;'d'; 'e'; 'f'; 'g'; 'h'; 'i'; 'j'; 'a'; 'b'; 'c' ;'d'; 'e'; 'f'; 'g'; 'h'; 'i'; 'j'];
CSW_str_serv = ['a'; 'b'; 'c'; 'd'; 'e'; 'f'; 'g'; 'h'; 'i'; 'j'; 'a'; 'b'; 'c'; 'd'; 'e'; 'f'; 'g'; 'h'; 'i'; 'j'];
CSW_str_os = ['a'; 'b'; 'c'; 'd'; 'e'; 'f'; 'g'; 'h'; 'i'; 'j'];
CSW_str_dr = ['a'; 'b'; 'c'; 'd'; 'e' ;'f'; 'g'; 'h'; 'i'; 'j'; 'a'; 'b'; 'c'; 'd'; 'e'; 'f'; 'g'; 'h'; 'i'; 'j'];
CSW = [CSW_str_apps; CSW_str_serv; CSW_str_os; CSW_str_dr];
%create filters
CSW1 = zeros(size(CSW));
CSW2 = zeros(size(CSW));
CSW3 = zeros(size(CSW));
CSW4 = zeros(size(CSW));
CSW5 = zeros(size(CSW));
CSW6 = zeros(size(CSW));
CSW7 = zeros(size(CSW));
CSW8 = zeros(size(CSW));
CSW9 = zeros(size(CSW));
CSW10 = zeros(size(CSW));
for z = 1:size(CSW)
  if CSW(z) ==  'a'
      CSW1(z) = 1;
  end;
  if CSW(z) ==  'b'
      CSW2(z) = 1;
  end;
 if CSW(z) ==  'c'
      CSW3(z) = 1;
  end;
 if CSW(z) ==  'd'
      CSW4(z) = 1;
  end;
  if CSW(z) ==  'e'
      CSW5(z) = 1;
  end;
  if CSW(z) ==  'f'
      CSW6(z) = 1;
  end;
 if CSW(z) ==  'g'
      CSW7(z) = 1;
  end;
 if CSW(z) ==  'h'
      CSW8(z) = 1;
  end;  
  if CSW(z) ==  'i'
      CSW9(z) = 1;
  end;
  if CSW(z) ==  'j'
      CSW10(z) = 1;
  end;

end; %end for z
CSW1 = CSW1';
CSW2 = CSW2';
CSW3 = CSW3';
CSW4 = CSW4';
CSW5 = CSW5';
CSW6 = CSW6';
CSW7 = CSW7';
CSW8 = CSW8';
CSW9 = CSW9';
CSW10 = CSW10';
CSWGroup(1,:) = CSW1;
CSWGroup(2,:) = CSW2;
CSWGroup(3,:) = CSW3;
CSWGroup(4,:) = CSW4;
CSWGroup(5,:) = CSW5;
CSWGroup(6,:) = CSW6;
CSWGroup(7,:) = CSW7;
CSWGroup(8,:) = CSW8;
CSWGroup(9,:) = CSW9;
CSWGroup(10,:) = CSW10;

Genotype_apps = zeros(100,20);
Genotype_apps(1:50,1)=1;
Genotype_apps(51:100,5)=1;

Genotype_serv = zeros(100,20);
Genotype_serv(1:50,1)=1;
Genotype_serv(51:100,5)=1;
             
Genotype_os = zeros(100,10);
Genotype_os(1:50,1)=1;
Genotype_os(51:100,5)=1;

Genotype_dr = zeros(100,20);
Genotype_dr(1:50,1)=1;
Genotype_dr(51:100,5)=1;
            
%efficiency/quality ratings of software (1 to 100) 
%(1)inefficient (100)maximum efficiency
E_apps = [30 75 55 50 60 60 60 80 20 20 65 75 55 50 60 60 60 80 20 20];
E_serv = [45 66 67 63 59 62 72 77 50 50 65 75 55 50 60 60 60 80 20 20];
E_os = [80 50 10 10 5 5 5 5 5 5];
E_dr = [20 10 60 75 69 68 63 58 65 65 65 75 55 50 60 60 60 80 20 20];

E_apps2 = [1 1 1 50 60 60 60 80 60 80 1 1 1 50 60 60 60 80 60 80];
E_serv2 = [1 1 1 63 59 62 72 77 77 77 1 1 1 50 60 60 60 80 60 80];
E_os2 = [1 85 1 1 1 1 1 1 1 1];
E_dr2 = [1 1 1 75 69 68 63 58 77 77 1 1 1 50 60 60 60 80 60 80];

%community desirability ratings (1 to 100) (1)least desirable (100)most
%desirable
%CD_apps = [15 35 10 5 10 5 3 2 10 5 0 0 0 0 0 0 0 0 0 0];
%CD_apps = [85 5 5 5 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0];
CD_apps = [81 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1];
%CD_apps = [12.5 12.5 12.5 12.5 12.5 12.5 12.5 12.5];
sum(CD_apps);
%CD_serv = [60 5 3 2 5 5 5 5 5 5 0 0 0 0 0 0 0 0 0 0];
%CD_serv = [85 5 5 5 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0];
CD_serv = [81 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1];
%CD_serv = [12.5 12.5 12.5 12.5 12.5 12.5 12.5 12.5];
sum(CD_serv);
%CD_os = [80 10 5 5 0 0 0 0 0 0];
%CD_os = [85 5 5 5 0 0 0 0 0 0];
CD_os = [82 2 2 2 2 2 2 2 2 2];
%CD_os = [12.5 12.5];
sum(CD_os);
%CD_dr = [50 20 5 5 10 5 3 2 0 0 0 0 0 0 0 0 0 0 0 0];
%CD_dr = [85 5 5 5 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0];
CD_dr = [81 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1];
%CD_dr = [12.5 12.5 12.5 12.5 12.5 12.5 12.5 12.5];
sum(CD_dr);
%for change over
CD_apps2 = [15 5 2 4 1 1 1 1 1 1 53 5 3 1 1 1 1 1 1 1];
%CD_apps2 = [12.5 12.5 12.5 12.5 12.5 12.5 12.5 12.5];
sum(CD_apps2);
CD_serv2 = [56 5 3 2 1 1 1 1 1 1 12 5 2 3 1 1 1 1 1 1];
%CD_serv2 = [12.5 12.5 12.5 12.5 12.5 12.5 12.5 12.5];
sum(CD_serv2);
CD_os2 = [68 10 5 5 2 2 2 2 2 2];
%CD_os2 = [12.5 12.5];
sum(CD_os2);
CD_dr2 = [48 5 4 4 1 1 1 1 1 1 20 5 1 1 1 1 1 1 1 1];
%CD_dr2 = [12.5 12.5 12.5 12.5 12.5 12.5 12.5 12.5];
sum(CD_dr2);
            
%individual desirability ratings (1 to 100) (1)least desirable (100)most
%desirable
%do for 10 individuals
ID_apps20 = [22 12 4 5 1 1 1 1 1 1 28 10 4 3 1 1 1 1 1 1,
           18 6 2 2 1 1 1 1 1 1 52 2 3 3 1 1 1 1 1 1,
           18 6 2 2 1 1 1 1 1 1 52 2 3 3 1 1 1 1 1 1,
           40 1 1 1 1 1 1 1 1 1 42 1 1 1 1 1 1 1 1 1,
           5 50 3 2 1 1 1 1 1 1 10 8 2 8 1 1 1 1 1 1,
           1 1 5 5 1 1 1 1 1 1 1 4 4 43 25 1 1 1 1 1,
           10 15 10 11 1 1 1 1 1 1 14 9 10 9 1 1 1 1 1 1,
           15 20 3 1 1 1 1 1 1 1 25 6 17 1 1 1 1 1 1 1,
           14 1 54 1 1 1 1 1 1 1 10 1 6 1 1 1 1 1 1 1,
           10 10 10 10 1 1 1 1 1 1 14 14 10 10 1 1 1 1 1 1,
           22 12 4 5 1 1 1 1 1 1 28 10 4 3 1 1 1 1 1 1,
           18 6 2 2 1 1 1 1 1 1 52 2 3 3 1 1 1 1 1 1,
           18 6 2 2 1 1 1 1 1 1 52 2 3 3 1 1 1 1 1 1,
           40 1 1 1 1 1 1 1 1 1 42 1 1 1 1 1 1 1 1 1,
           5 50 3 2 1 1 1 1 1 1 10 8 2 8 1 1 1 1 1 1,
           1 1 5 5 1 1 1 1 1 1 1 4 4 43 25 1 1 1 1 1,
           10 15 10 11 1 1 1 1 1 1 14 9 10 9 1 1 1 1 1 1,
           15 20 3 1 1 1 1 1 1 1 25 6 17 1 1 1 1 1 1 1,
           14 1 54 1 1 1 1 1 1 1 10 1 6 1 1 1 1 1 1 1,
           10 10 10 10 1 1 1 1 1 1 14 14 10 10 1 1 1 1 1 1];  
            
ID_serv20 = [22 12 4 5 1 1 1 1 1 1 28 10 4 3 1 1 1 1 1 1,
           18 6 2 2 1 1 1 1 1 1 52 2 3 3 1 1 1 1 1 1,
           18 6 2 2 1 1 1 1 1 1 52 2 3 3 1 1 1 1 1 1,
           40 1 1 1 1 1 1 1 1 1 42 1 1 1 1 1 1 1 1 1,
           5 50 3 2 1 1 1 1 1 1 10 8 2 8 1 1 1 1 1 1,
           1 1 5 5 1 1 1 1 1 1 1 4 4 43 25 1 1 1 1 1,
           10 15 10 11 1 1 1 1 1 1 14 9 10 9 1 1 1 1 1 1,
           15 20 3 1 1 1 1 1 1 1 25 6 17 1 1 1 1 1 1 1,
           14 1 54 1 1 1 1 1 1 1 10 1 6 1 1 1 1 1 1 1,
           10 10 10 10 1 1 1 1 1 1 14 14 10 10 1 1 1 1 1 1,
           22 12 4 5 1 1 1 1 1 1 28 10 4 3 1 1 1 1 1 1,
           18 6 2 2 1 1 1 1 1 1 52 2 3 3 1 1 1 1 1 1,
           18 6 2 2 1 1 1 1 1 1 52 2 3 3 1 1 1 1 1 1,
           40 1 1 1 1 1 1 1 1 1 42 1 1 1 1 1 1 1 1 1,
           5 50 3 2 1 1 1 1 1 1 10 8 2 8 1 1 1 1 1 1,
           1 1 5 5 1 1 1 1 1 1 1 4 4 43 25 1 1 1 1 1,
           10 15 10 11 1 1 1 1 1 1 14 9 10 9 1 1 1 1 1 1,
           15 20 3 1 1 1 1 1 1 1 25 6 17 1 1 1 1 1 1 1,
           14 1 54 1 1 1 1 1 1 1 10 1 6 1 1 1 1 1 1 1,
           10 10 10 10 1 1 1 1 1 1 14 14 10 10 1 1 1 1 1 1];       
                          
ID_os20 = [50 22 8 8 2 2 2 2 2 2,
         70 8 5 5 2 2 2 2 2 2,
         70 8 5 5 2 2 2 2 2 2,
         82 2 2 2 2 2 2 2 2 2,
         15 58 5 10 2 2 2 2 2 2,
         5 5 48 30 2 2 2 2 2 2,
         24 24 20 20 2 2 2 2 2 2,
         40 26 20 2 2 2 2 2 2 2,
         24 2 60 2 2 2 2 2 2 2,
         24 24 20 20 2 2 2 2 2 2,
         50 22 8 8 2 2 2 2 2 2,
         70 8 5 5 2 2 2 2 2 2,
         70 8 5 5 2 2 2 2 2 2,
         82 2 2 2 2 2 2 2 2 2,
         15 58 5 10 2 2 2 2 2 2,
         5 5 48 30 2 2 2 2 2 2,
         24 24 20 20 2 2 2 2 2 2,
         40 26 20 2 2 2 2 2 2 2,
         24 2 60 2 2 2 2 2 2 2,
         24 24 20 20 2 2 2 2 2 2] ;   
     
ID_dr20 = [22 12 4 5 1 1 1 1 1 1 28 10 4 3 1 1 1 1 1 1,
           18 6 2 2 1 1 1 1 1 1 52 2 3 3 1 1 1 1 1 1,
           18 6 2 2 1 1 1 1 1 1 52 2 3 3 1 1 1 1 1 1,
           40 1 1 1 1 1 1 1 1 1 42 1 1 1 1 1 1 1 1 1,
           5 50 3 2 1 1 1 1 1 1 10 8 2 8 1 1 1 1 1 1,
           1 1 5 5 1 1 1 1 1 1 1 4 4 43 25 1 1 1 1 1,
           10 15 10 11 1 1 1 1 1 1 14 9 10 9 1 1 1 1 1 1,
           15 20 3 1 1 1 1 1 1 1 25 6 17 1 1 1 1 1 1 1,
           14 1 54 1 1 1 1 1 1 1 10 1 6 1 1 1 1 1 1 1,
           10 10 10 10 1 1 1 1 1 1 14 14 10 10 1 1 1 1 1 1,
           22 12 4 5 1 1 1 1 1 1 28 10 4 3 1 1 1 1 1 1,
           18 6 2 2 1 1 1 1 1 1 52 2 3 3 1 1 1 1 1 1,
           18 6 2 2 1 1 1 1 1 1 52 2 3 3 1 1 1 1 1 1,
           40 1 1 1 1 1 1 1 1 1 42 1 1 1 1 1 1 1 1 1,
           5 50 3 2 1 1 1 1 1 1 10 8 2 8 1 1 1 1 1 1,
           1 1 5 5 1 1 1 1 1 1 1 4 4 43 25 1 1 1 1 1,
           10 15 10 11 1 1 1 1 1 1 14 9 10 9 1 1 1 1 1 1,
           15 20 3 1 1 1 1 1 1 1 25 6 17 1 1 1 1 1 1 1,
           14 1 54 1 1 1 1 1 1 1 10 1 6 1 1 1 1 1 1 1,
           10 10 10 10 1 1 1 1 1 1 14 14 10 10 1 1 1 1 1 1];

   
ID_apps = zeros(100,20);
ID_apps(1:20,:) = ID_apps20;
ID_apps(21:40,:) = ID_apps20;
ID_apps(41:60,:) = ID_apps20;
ID_apps(61:80,:) = ID_apps20;
ID_apps(81:100,:) = ID_apps20;

ID_serv = zeros(100,20);
ID_serv(1:20,:) = ID_serv20;
ID_serv(21:40,:) = ID_serv20;
ID_serv(41:60,:) = ID_serv20;
ID_serv(61:80,:) = ID_serv20;
ID_serv(81:100,:) = ID_serv20;

ID_os = zeros(100,10);
ID_os(1:20,:) = ID_os20;
ID_os(21:40,:) = ID_os20;
ID_os(41:60,:) = ID_os20;
ID_os(61:80,:) = ID_os20;
ID_os(81:100,:) = ID_os20;

ID_dr = zeros(100,20);
ID_dr(1:20,:) = ID_dr20;
ID_dr(21:40,:) = ID_dr20;
ID_dr(41:60,:) = ID_dr20;
ID_dr(61:80,:) = ID_dr20;
ID_dr(81:100,:) = ID_dr20;

     ID_apps2 = ID_apps;
     ID_os2 = ID_os;
     ID_dr2 = ID_dr;
ID_serv2 = ID_serv;
    %INDIVIDUAL TIME ARRAY OF CHANGES TO PERSONAL INDIVIDUAL DESIRABILITIES
IDtimeArray1 = zeros(1,numNodes);
IDtimeArray2 = zeros(1,numNodes);

    case 11
numNodes = 200;
%%%%%%%%%%%%%
% set up data - Dataset 11 - 200 nodes
%%%%%%%%%%%%%
%software strings
%WebBrowser1,6 - commercial products, WebBrowser2,3,4,5 third party
SW_str_apps = ['WebBrowser1v1 ' 'WebBrowser1v2 ' 'WebBrowser2v1 ' 'WebBrowser3v1 ' 'WebBrowser4v1 ' 'WebBrowser5v1 ' 'WebBrowser6v1 ' 'WebBrowser6v4 ' 'WebBrowser7v1 ' 'WebBrowser7v3 ''WebBrowser8v1 ' 'WebBrowser8v2 ' 'WebBrowser8v3 ' 'WebBrowser9v1 ' 'WebBrowser10v1 ' 'WebBrowser11v1 ' 'WebBrowser12v1 ' 'WebBrowser13v4 ' 'WebBrowser14v1 ' 'WebBrowser15v3 '];
%All photo viewers about same standard with number 7 slightly better
SW_str_serv = ['PhotoViewer1 ' 'PhotoViewer2 ' 'PhotoViewer3 ' 'PhotoViewer4 ' 'PhotoViewer5 ' 'PhotoViewer6 ' 'PhotoViewer7v1 ' 'PhotoViewer7v2 ' 'PhotoViewer8 ' 'Photoviewer9 ' 'PhotoViewer1 ' 'PhotoViewer2 ' 'PhotoViewer3 ' 'PhotoViewer4 ' 'PhotoViewer5 ' 'PhotoViewer6 ' 'PhotoViewer7v1 ' 'PhotoViewer7v2 ' 'PhotoViewer8 ' 'Photoviewer9 '];
%OS2 slightly more efficient overall than OS1
SW_str_os = ['OS1 ' 'OS2 ' 'OS3 ' 'OS4 ' 'OS5' 'OS6' 'OS7' 'OS8' 'OS9' 'OS10'];
%higher versions are better than lower number versions, the commercial
%products are more efficient than the freebies 3rd party
SW_str_dr = ['DataDr1v1 ' 'DataDr1v2 ' 'DataDr2v1 ' 'DataDr3v3 ' 'DataDr4 ' 'DataDr5 ' 'DataDr6 ' 'DataDr7 ' 'DataDr9 ' 'DataDr8 ' 'DataDr1v1 ' 'DataDr1v2 ' 'DataDr2v1 ' 'DataDr3v3 ' 'DataDr4 ' 'DataDr5 ' 'DataDr6 ' 'DataDr7 ' 'DataDr9 ' 'DataDr8 '];

%software frequency info for running the frequency and nei diversity index
%algorithm
%locusApps - 'a' represents major variants, 'V' represents a minor version
%locusServ - 's' represents major variants, 'V' represents a minor version
%locusOS  - 'o' represents major variants, 'V' represents a minor version
SW_freq_apps = ['a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V';'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'];
SW_freq_serv = ['s', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'];
SW_freq_os = ['o', 'V'; 'o', 'V'; 'o', 'V'; 'o', 'V';'o', 'V'; 'o', 'V'; 'o', 'V'; 'o', 'V';'o', 'V'; 'o', 'V'];
SW_freq_dr = ['d', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'];

%compatability of software
CSW_str_apps = ['a'; 'b'; 'c' ;'d'; 'e'; 'f'; 'g'; 'h'; 'i'; 'j'; 'a'; 'b'; 'c' ;'d'; 'e'; 'f'; 'g'; 'h'; 'i'; 'j'];
CSW_str_serv = ['a'; 'b'; 'c'; 'd'; 'e'; 'f'; 'g'; 'h'; 'i'; 'j'; 'a'; 'b'; 'c'; 'd'; 'e'; 'f'; 'g'; 'h'; 'i'; 'j'];
CSW_str_os = ['a'; 'b'; 'c'; 'd'; 'e'; 'f'; 'g'; 'h'; 'i'; 'j'];
CSW_str_dr = ['a'; 'b'; 'c'; 'd'; 'e' ;'f'; 'g'; 'h'; 'i'; 'j'; 'a'; 'b'; 'c'; 'd'; 'e'; 'f'; 'g'; 'h'; 'i'; 'j'];
CSW = [CSW_str_apps; CSW_str_serv; CSW_str_os; CSW_str_dr];
%create filters
CSW1 = zeros(size(CSW));
CSW2 = zeros(size(CSW));
CSW3 = zeros(size(CSW));
CSW4 = zeros(size(CSW));
CSW5 = zeros(size(CSW));
CSW6 = zeros(size(CSW));
CSW7 = zeros(size(CSW));
CSW8 = zeros(size(CSW));
CSW9 = zeros(size(CSW));
CSW10 = zeros(size(CSW));
for z = 1:size(CSW)
  if CSW(z) ==  'a'
      CSW1(z) = 1;
  end;
  if CSW(z) ==  'b'
      CSW2(z) = 1;
  end;
 if CSW(z) ==  'c'
      CSW3(z) = 1;
  end;
 if CSW(z) ==  'd'
      CSW4(z) = 1;
  end;
  if CSW(z) ==  'e'
      CSW5(z) = 1;
  end;
  if CSW(z) ==  'f'
      CSW6(z) = 1;
  end;
 if CSW(z) ==  'g'
      CSW7(z) = 1;
  end;
 if CSW(z) ==  'h'
      CSW8(z) = 1;
  end;  
  if CSW(z) ==  'i'
      CSW9(z) = 1;
  end;
  if CSW(z) ==  'j'
      CSW10(z) = 1;
  end;

end; %end for z
CSW1 = CSW1';
CSW2 = CSW2';
CSW3 = CSW3';
CSW4 = CSW4';
CSW5 = CSW5';
CSW6 = CSW6';
CSW7 = CSW7';
CSW8 = CSW8';
CSW9 = CSW9';
CSW10 = CSW10';
CSWGroup(1,:) = CSW1;
CSWGroup(2,:) = CSW2;
CSWGroup(3,:) = CSW3;
CSWGroup(4,:) = CSW4;
CSWGroup(5,:) = CSW5;
CSWGroup(6,:) = CSW6;
CSWGroup(7,:) = CSW7;
CSWGroup(8,:) = CSW8;
CSWGroup(9,:) = CSW9;
CSWGroup(10,:) = CSW10;

Genotype_apps = zeros(200,20);
Genotype_apps(1:100,1)=1;
Genotype_apps(101:200,5)=1;

Genotype_serv = zeros(200,20);
Genotype_serv(1:100,1)=1;
Genotype_serv(101:200,5)=1;
             
Genotype_os = zeros(200,10);
Genotype_os(1:100,1)=1;
Genotype_os(101:200,5)=1;

Genotype_dr = zeros(200,20);
Genotype_dr(1:100,1)=1;
Genotype_dr(101:200,5)=1; 
            
%efficiency/quality ratings of software (1 to 100) 
%(1)inefficient (100)maximum efficiency
E_apps = [30 75 55 50 60 60 60 80 20 20 65 75 55 50 60 60 60 80 20 20];
E_serv = [45 66 67 63 59 62 72 77 50 50 65 75 55 50 60 60 60 80 20 20];
E_os = [80 50 10 10 5 5 5 5 5 5];
E_dr = [20 10 60 75 69 68 63 58 65 65 65 75 55 50 60 60 60 80 20 20];

%community desirability ratings (1 to 100) (1)least desirable (100)most
%desirable
%CD_apps = [15 35 10 5 10 5 3 2 10 5 0 0 0 0 0 0 0 0 0 0];
%CD_apps = [85 5 5 5 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0];
CD_apps = [81 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1];
%CD_apps = [12.5 12.5 12.5 12.5 12.5 12.5 12.5 12.5];
sum(CD_apps);
%CD_serv = [60 5 3 2 5 5 5 5 5 5 0 0 0 0 0 0 0 0 0 0];
%CD_serv = [85 5 5 5 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0];
CD_serv = [81 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1];
%CD_serv = [12.5 12.5 12.5 12.5 12.5 12.5 12.5 12.5];
sum(CD_serv);
%CD_os = [80 10 5 5 0 0 0 0 0 0];
%CD_os = [85 5 5 5 0 0 0 0 0 0];
CD_os = [82 2 2 2 2 2 2 2 2 2];
%CD_os = [12.5 12.5];
sum(CD_os);
%CD_dr = [50 20 5 5 10 5 3 2 0 0 0 0 0 0 0 0 0 0 0 0];
%CD_dr = [85 5 5 5 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0];
CD_dr = [81 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1];
%CD_dr = [12.5 12.5 12.5 12.5 12.5 12.5 12.5 12.5];
sum(CD_dr);
%for change over
CD_apps2 = [15 5 2 4 1 1 1 1 1 1 53 5 3 1 1 1 1 1 1 1];
%CD_apps2 = [12.5 12.5 12.5 12.5 12.5 12.5 12.5 12.5];
sum(CD_apps2);
CD_serv2 = [56 5 3 2 1 1 1 1 1 1 12 5 2 3 1 1 1 1 1 1];
%CD_serv2 = [12.5 12.5 12.5 12.5 12.5 12.5 12.5 12.5];
sum(CD_serv2);
CD_os2 = [68 10 5 5 2 2 2 2 2 2];
%CD_os2 = [12.5 12.5];
sum(CD_os2);
CD_dr2 = [48 5 4 4 1 1 1 1 1 1 20 5 1 1 1 1 1 1 1 1];
%CD_dr2 = [12.5 12.5 12.5 12.5 12.5 12.5 12.5 12.5];
sum(CD_dr2);
            
%individual desirability ratings (1 to 100) (1)least desirable (100)most
%desirable
ID_apps20 = [22 12 4 5 1 1 1 1 1 1 28 10 4 3 1 1 1 1 1 1,
           18 6 2 2 1 1 1 1 1 1 52 2 3 3 1 1 1 1 1 1,
           18 6 2 2 1 1 1 1 1 1 52 2 3 3 1 1 1 1 1 1,
           40 1 1 1 1 1 1 1 1 1 42 1 1 1 1 1 1 1 1 1,
           5 50 3 2 1 1 1 1 1 1 10 8 2 8 1 1 1 1 1 1,
           1 1 5 5 1 1 1 1 1 1 1 4 4 43 25 1 1 1 1 1,
           10 15 10 11 1 1 1 1 1 1 14 9 10 9 1 1 1 1 1 1,
           15 20 3 1 1 1 1 1 1 1 25 6 17 1 1 1 1 1 1 1,
           14 1 54 1 1 1 1 1 1 1 10 1 6 1 1 1 1 1 1 1,
           10 10 10 10 1 1 1 1 1 1 14 14 10 10 1 1 1 1 1 1,
           22 12 4 5 1 1 1 1 1 1 28 10 4 3 1 1 1 1 1 1,
           18 6 2 2 1 1 1 1 1 1 52 2 3 3 1 1 1 1 1 1,
           18 6 2 2 1 1 1 1 1 1 52 2 3 3 1 1 1 1 1 1,
           40 1 1 1 1 1 1 1 1 1 42 1 1 1 1 1 1 1 1 1,
           5 50 3 2 1 1 1 1 1 1 10 8 2 8 1 1 1 1 1 1,
           1 1 5 5 1 1 1 1 1 1 1 4 4 43 25 1 1 1 1 1,
           10 15 10 11 1 1 1 1 1 1 14 9 10 9 1 1 1 1 1 1,
           15 20 3 1 1 1 1 1 1 1 25 6 17 1 1 1 1 1 1 1,
           14 1 54 1 1 1 1 1 1 1 10 1 6 1 1 1 1 1 1 1,
           10 10 10 10 1 1 1 1 1 1 14 14 10 10 1 1 1 1 1 1];  
            
ID_serv20 = [22 12 4 5 1 1 1 1 1 1 28 10 4 3 1 1 1 1 1 1,
           18 6 2 2 1 1 1 1 1 1 52 2 3 3 1 1 1 1 1 1,
           18 6 2 2 1 1 1 1 1 1 52 2 3 3 1 1 1 1 1 1,
           40 1 1 1 1 1 1 1 1 1 42 1 1 1 1 1 1 1 1 1,
           5 50 3 2 1 1 1 1 1 1 10 8 2 8 1 1 1 1 1 1,
           1 1 5 5 1 1 1 1 1 1 1 4 4 43 25 1 1 1 1 1,
           10 15 10 11 1 1 1 1 1 1 14 9 10 9 1 1 1 1 1 1,
           15 20 3 1 1 1 1 1 1 1 25 6 17 1 1 1 1 1 1 1,
           14 1 54 1 1 1 1 1 1 1 10 1 6 1 1 1 1 1 1 1,
           10 10 10 10 1 1 1 1 1 1 14 14 10 10 1 1 1 1 1 1,
           22 12 4 5 1 1 1 1 1 1 28 10 4 3 1 1 1 1 1 1,
           18 6 2 2 1 1 1 1 1 1 52 2 3 3 1 1 1 1 1 1,
           18 6 2 2 1 1 1 1 1 1 52 2 3 3 1 1 1 1 1 1,
           40 1 1 1 1 1 1 1 1 1 42 1 1 1 1 1 1 1 1 1,
           5 50 3 2 1 1 1 1 1 1 10 8 2 8 1 1 1 1 1 1,
           1 1 5 5 1 1 1 1 1 1 1 4 4 43 25 1 1 1 1 1,
           10 15 10 11 1 1 1 1 1 1 14 9 10 9 1 1 1 1 1 1,
           15 20 3 1 1 1 1 1 1 1 25 6 17 1 1 1 1 1 1 1,
           14 1 54 1 1 1 1 1 1 1 10 1 6 1 1 1 1 1 1 1,
           10 10 10 10 1 1 1 1 1 1 14 14 10 10 1 1 1 1 1 1];       
                          
ID_os20 = [50 22 8 8 2 2 2 2 2 2,
         70 8 5 5 2 2 2 2 2 2,
         70 8 5 5 2 2 2 2 2 2,
         82 2 2 2 2 2 2 2 2 2,
         15 58 5 10 2 2 2 2 2 2,
         5 5 48 30 2 2 2 2 2 2,
         24 24 20 20 2 2 2 2 2 2,
         40 26 20 2 2 2 2 2 2 2,
         24 2 60 2 2 2 2 2 2 2,
         24 24 20 20 2 2 2 2 2 2,
         50 22 8 8 2 2 2 2 2 2,
         70 8 5 5 2 2 2 2 2 2,
         70 8 5 5 2 2 2 2 2 2,
         82 2 2 2 2 2 2 2 2 2,
         15 58 5 10 2 2 2 2 2 2,
         5 5 48 30 2 2 2 2 2 2,
         24 24 20 20 2 2 2 2 2 2,
         40 26 20 2 2 2 2 2 2 2,
         24 2 60 2 2 2 2 2 2 2,
         24 24 20 20 2 2 2 2 2 2] ;   
     
ID_dr20 = [22 12 4 5 1 1 1 1 1 1 28 10 4 3 1 1 1 1 1 1,
           18 6 2 2 1 1 1 1 1 1 52 2 3 3 1 1 1 1 1 1,
           18 6 2 2 1 1 1 1 1 1 52 2 3 3 1 1 1 1 1 1,
           40 1 1 1 1 1 1 1 1 1 42 1 1 1 1 1 1 1 1 1,
           5 50 3 2 1 1 1 1 1 1 10 8 2 8 1 1 1 1 1 1,
           1 1 5 5 1 1 1 1 1 1 1 4 4 43 25 1 1 1 1 1,
           10 15 10 11 1 1 1 1 1 1 14 9 10 9 1 1 1 1 1 1,
           15 20 3 1 1 1 1 1 1 1 25 6 17 1 1 1 1 1 1 1,
           14 1 54 1 1 1 1 1 1 1 10 1 6 1 1 1 1 1 1 1,
           10 10 10 10 1 1 1 1 1 1 14 14 10 10 1 1 1 1 1 1,
           22 12 4 5 1 1 1 1 1 1 28 10 4 3 1 1 1 1 1 1,
           18 6 2 2 1 1 1 1 1 1 52 2 3 3 1 1 1 1 1 1,
           18 6 2 2 1 1 1 1 1 1 52 2 3 3 1 1 1 1 1 1,
           40 1 1 1 1 1 1 1 1 1 42 1 1 1 1 1 1 1 1 1,
           5 50 3 2 1 1 1 1 1 1 10 8 2 8 1 1 1 1 1 1,
           1 1 5 5 1 1 1 1 1 1 1 4 4 43 25 1 1 1 1 1,
           10 15 10 11 1 1 1 1 1 1 14 9 10 9 1 1 1 1 1 1,
           15 20 3 1 1 1 1 1 1 1 25 6 17 1 1 1 1 1 1 1,
           14 1 54 1 1 1 1 1 1 1 10 1 6 1 1 1 1 1 1 1,
           10 10 10 10 1 1 1 1 1 1 14 14 10 10 1 1 1 1 1 1];
       
ID_apps = zeros(200,20);
ID_apps(1:20,:) = ID_apps20;
ID_apps(21:40,:) = ID_apps20;
ID_apps(41:60,:) = ID_apps20;
ID_apps(61:80,:) = ID_apps20;
ID_apps(81:100,:) = ID_apps20;
ID_apps(101:200,:) = ID_apps(1:100,:);

ID_serv = zeros(200,20);
ID_serv(1:20,:) = ID_serv20;
ID_serv(21:40,:) = ID_serv20;
ID_serv(41:60,:) = ID_serv20;
ID_serv(61:80,:) = ID_serv20;
ID_serv(81:100,:) = ID_serv20;
ID_serv(101:200,:) = ID_serv(1:100,:);

ID_os = zeros(200,10);
ID_os(1:20,:) = ID_os20;
ID_os(21:40,:) = ID_os20;
ID_os(41:60,:) = ID_os20;
ID_os(61:80,:) = ID_os20;
ID_os(81:100,:) = ID_os20;
ID_os(101:200,:) = ID_os(1:100,:);

ID_dr = zeros(200,20);
ID_dr(1:20,:) = ID_dr20;
ID_dr(21:40,:) = ID_dr20;
ID_dr(41:60,:) = ID_dr20;
ID_dr(61:80,:) = ID_dr20;
ID_dr(81:100,:) = ID_dr20;
ID_dr(101:200,:) = ID_dr(1:100,:);

     E_apps2 = E_apps;
E_serv2 = E_serv;
E_os2 = E_os;
E_dr2 = E_dr;     
ID_apps2 = ID_apps;
ID_serv2 = ID_serv;
ID_os2 = ID_os;
ID_dr2 = ID_dr;

    %INDIVIDUAL TIME ARRAY OF CHANGES TO PERSONAL INDIVIDUAL DESIRABILITIES
IDtimeArray1 = zeros(1,numNodes);
IDtimeArray2 = zeros(1,numNodes);

    case 12
%%%%%%%%%%%%%
% set up data - Dataset 12 - 400 nodes
%%%%%%%%%%%%%
%software strings
%WebBrowser1,6 - commercial products, WebBrowser2,3,4,5 third party
SW_str_apps = ['WebBrowser1v1 ' 'WebBrowser1v2 ' 'WebBrowser2v1 ' 'WebBrowser3v1 ' 'WebBrowser4v1 ' 'WebBrowser5v1 ' 'WebBrowser6v1 ' 'WebBrowser6v4 ' 'WebBrowser7v1 ' 'WebBrowser7v3 ''WebBrowser8v1 ' 'WebBrowser8v2 ' 'WebBrowser8v3 ' 'WebBrowser9v1 ' 'WebBrowser10v1 ' 'WebBrowser11v1 ' 'WebBrowser12v1 ' 'WebBrowser13v4 ' 'WebBrowser14v1 ' 'WebBrowser15v3 '];
%All photo viewers about same standard with number 7 slightly better
SW_str_serv = ['PhotoViewer1 ' 'PhotoViewer2 ' 'PhotoViewer3 ' 'PhotoViewer4 ' 'PhotoViewer5 ' 'PhotoViewer6 ' 'PhotoViewer7v1 ' 'PhotoViewer7v2 ' 'PhotoViewer8 ' 'Photoviewer9 ' 'PhotoViewer1 ' 'PhotoViewer2 ' 'PhotoViewer3 ' 'PhotoViewer4 ' 'PhotoViewer5 ' 'PhotoViewer6 ' 'PhotoViewer7v1 ' 'PhotoViewer7v2 ' 'PhotoViewer8 ' 'Photoviewer9 '];
%OS2 slightly more efficient overall than OS1
SW_str_os = ['OS1 ' 'OS2 ' 'OS3 ' 'OS4 ' 'OS5' 'OS6' 'OS7' 'OS8' 'OS9' 'OS10'];
%higher versions are better than lower number versions, the commercial
%products are more efficient than the freebies 3rd party
SW_str_dr = ['DataDr1v1 ' 'DataDr1v2 ' 'DataDr2v1 ' 'DataDr3v3 ' 'DataDr4 ' 'DataDr5 ' 'DataDr6 ' 'DataDr7 ' 'DataDr9 ' 'DataDr8 ' 'DataDr1v1 ' 'DataDr1v2 ' 'DataDr2v1 ' 'DataDr3v3 ' 'DataDr4 ' 'DataDr5 ' 'DataDr6 ' 'DataDr7 ' 'DataDr9 ' 'DataDr8 '];

%software frequency info for running the frequency and nei diversity index
%algorithm
%locusApps - 'a' represents major variants, 'V' represents a minor version
%locusServ - 's' represents major variants, 'V' represents a minor version
%locusOS  - 'o' represents major variants, 'V' represents a minor version
SW_freq_apps = ['a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V';'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'];
SW_freq_serv = ['s', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'];
SW_freq_os = ['o', 'V'; 'o', 'V'; 'o', 'V'; 'o', 'V';'o', 'V'; 'o', 'V'; 'o', 'V'; 'o', 'V';'o', 'V'; 'o', 'V'];
SW_freq_dr = ['d', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'];

%compatability of software
CSW_str_apps = ['a'; 'b'; 'c' ;'d'; 'e'; 'f'; 'g'; 'h'; 'i'; 'j'; 'a'; 'b'; 'c' ;'d'; 'e'; 'f'; 'g'; 'h'; 'i'; 'j'];
CSW_str_serv = ['a'; 'b'; 'c'; 'd'; 'e'; 'f'; 'g'; 'h'; 'i'; 'j'; 'a'; 'b'; 'c'; 'd'; 'e'; 'f'; 'g'; 'h'; 'i'; 'j'];
CSW_str_os = ['a'; 'b'; 'c'; 'd'; 'e'; 'f'; 'g'; 'h'; 'i'; 'j'];
CSW_str_dr = ['a'; 'b'; 'c'; 'd'; 'e' ;'f'; 'g'; 'h'; 'i'; 'j'; 'a'; 'b'; 'c'; 'd'; 'e'; 'f'; 'g'; 'h'; 'i'; 'j'];
CSW = [CSW_str_apps; CSW_str_serv; CSW_str_os; CSW_str_dr];
%create filters
CSW1 = zeros(size(CSW));
CSW2 = zeros(size(CSW));
CSW3 = zeros(size(CSW));
CSW4 = zeros(size(CSW));
CSW5 = zeros(size(CSW));
CSW6 = zeros(size(CSW));
CSW7 = zeros(size(CSW));
CSW8 = zeros(size(CSW));
CSW9 = zeros(size(CSW));
CSW10 = zeros(size(CSW));
for z = 1:size(CSW)
  if CSW(z) ==  'a'
      CSW1(z) = 1;
  end;
  if CSW(z) ==  'b'
      CSW2(z) = 1;
  end;
 if CSW(z) ==  'c'
      CSW3(z) = 1;
  end;
 if CSW(z) ==  'd'
      CSW4(z) = 1;
  end;
  if CSW(z) ==  'e'
      CSW5(z) = 1;
  end;
  if CSW(z) ==  'f'
      CSW6(z) = 1;
  end;
 if CSW(z) ==  'g'
      CSW7(z) = 1;
  end;
 if CSW(z) ==  'h'
      CSW8(z) = 1;
  end;  
  if CSW(z) ==  'i'
      CSW9(z) = 1;
  end;
  if CSW(z) ==  'j'
      CSW10(z) = 1;
  end;

end; %end for z
CSW1 = CSW1';
CSW2 = CSW2';
CSW3 = CSW3';
CSW4 = CSW4';
CSW5 = CSW5';
CSW6 = CSW6';
CSW7 = CSW7';
CSW8 = CSW8';
CSW9 = CSW9';
CSW10 = CSW10';
CSWGroup(1,:) = CSW1;
CSWGroup(2,:) = CSW2;
CSWGroup(3,:) = CSW3;
CSWGroup(4,:) = CSW4;
CSWGroup(5,:) = CSW5;
CSWGroup(6,:) = CSW6;
CSWGroup(7,:) = CSW7;
CSWGroup(8,:) = CSW8;
CSWGroup(9,:) = CSW9;
CSWGroup(10,:) = CSW10;

Genotype_apps = zeros(400,20);
Genotype_apps(1:200,1)=1;
Genotype_apps(201:400,5)=1;

Genotype_serv = zeros(400,20);
Genotype_serv(1:200,1)=1;
Genotype_serv(201:400,5)=1;
             
Genotype_os = zeros(400,10);
Genotype_os(1:200,1)=1;
Genotype_os(201:400,5)=1;

Genotype_dr = zeros(400,20);
Genotype_dr(1:200,1)=1;
Genotype_dr(201:400,5)=1;          
            
%efficiency/quality ratings of software (1 to 100) 
%(1)inefficient (100)maximum efficiency
%E_apps = [65 75 55 50 60 60 60 80 20 20 65 75 55 50 60 60 60 80 20 20];
%E_serv = [65 66 67 63 59 62 72 77 50 50 65 75 55 50 60 60 60 80 20 20];
%E_os = [50 50 50 50 50 50 50 50 50 50];
%E_dr = [70 80 60 75 69 68 63 58 65 65 65 75 55 50 60 60 60 80 20 20];

E_apps = [1 75 55 5 1 1 5 80 20 20 10 75 10 5 5 5 60 80 5 5];
E_serv = [65 1 67 5 1 62 72 77 50 50 65 75 5 5 5 5 5 80 20 20];
E_os = [70 30 1 10 1 50 2 5 5 5];
E_dr = [70 80 1 75 15 68 20 58 1 1 1 5 5 8 5 1 60 2 20 20];

%community desirability ratings (1 to 100) (1)least desirable (100)most
%desirable
%desirability 1
CD_apps = [81 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1];
sum(CD_apps);
CD_serv = [81 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1];
sum(CD_serv);
CD_os = [82 2 2 2 2 2 2 2 2 2];
sum(CD_os);
CD_dr = [81 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1];
sum(CD_dr);
%desirability 2 when wish to change
%for change over
CD_apps2 = [15 5 2 4 1 1 1 1 1 1 53 5 3 1 1 1 1 1 1 1];
%CD_apps2 = [12.5 12.5 12.5 12.5 12.5 12.5 12.5 12.5];
sum(CD_apps2);
CD_serv2 = [56 5 3 2 1 1 1 1 1 1 12 5 2 3 1 1 1 1 1 1];
%CD_serv2 = [12.5 12.5 12.5 12.5 12.5 12.5 12.5 12.5];
sum(CD_serv2);
CD_os2 = [68 10 5 5 2 2 2 2 2 2];
%CD_os2 = [12.5 12.5];
sum(CD_os2);
CD_dr2 = [48 5 4 4 1 1 1 1 1 1 20 5 1 1 1 1 1 1 1 1];
%CD_dr2 = [12.5 12.5 12.5 12.5 12.5 12.5 12.5 12.5];
sum(CD_dr2);
            
%individual desirability ratings (1 to 100) (1)least desirable (100)most
%desirable
%do for 10 individuals

ID_apps20 = [22 12 4 5 1 1 1 1 1 1 28 10 4 3 1 1 1 1 1 1,
           18 6 2 2 1 1 1 1 1 1 52 2 3 3 1 1 1 1 1 1,
           18 6 2 2 1 1 1 1 1 1 52 2 3 3 1 1 1 1 1 1,
           40 1 1 1 1 1 1 1 1 1 42 1 1 1 1 1 1 1 1 1,
           5 50 3 2 1 1 1 1 1 1 10 8 2 8 1 1 1 1 1 1,
           1 1 5 5 1 1 1 1 1 1 1 4 4 43 25 1 1 1 1 1,
           10 15 10 11 1 1 1 1 1 1 14 9 10 9 1 1 1 1 1 1,
           15 20 3 1 1 1 1 1 1 1 25 6 17 1 1 1 1 1 1 1,
           14 1 54 1 1 1 1 1 1 1 10 1 6 1 1 1 1 1 1 1,
           10 10 10 10 1 1 1 1 1 1 14 14 10 10 1 1 1 1 1 1,
           22 12 4 5 1 1 1 1 1 1 28 10 4 3 1 1 1 1 1 1,
           18 6 2 2 1 1 1 1 1 1 52 2 3 3 1 1 1 1 1 1,
           18 6 2 2 1 1 1 1 1 1 52 2 3 3 1 1 1 1 1 1,
           40 1 1 1 1 1 1 1 1 1 42 1 1 1 1 1 1 1 1 1,
           5 50 3 2 1 1 1 1 1 1 10 8 2 8 1 1 1 1 1 1,
           1 1 5 5 1 1 1 1 1 1 1 4 4 43 25 1 1 1 1 1,
           10 15 10 11 1 1 1 1 1 1 14 9 10 9 1 1 1 1 1 1,
           15 20 3 1 1 1 1 1 1 1 25 6 17 1 1 1 1 1 1 1,
           14 1 54 1 1 1 1 1 1 1 10 1 6 1 1 1 1 1 1 1,
           10 10 10 10 1 1 1 1 1 1 14 14 10 10 1 1 1 1 1 1];  
            
ID_serv20 = [22 12 4 5 1 1 1 1 1 1 28 10 4 3 1 1 1 1 1 1,
           18 6 2 2 1 1 1 1 1 1 52 2 3 3 1 1 1 1 1 1,
           18 6 2 2 1 1 1 1 1 1 52 2 3 3 1 1 1 1 1 1,
           40 1 1 1 1 1 1 1 1 1 42 1 1 1 1 1 1 1 1 1,
           5 50 3 2 1 1 1 1 1 1 10 8 2 8 1 1 1 1 1 1,
           1 1 5 5 1 1 1 1 1 1 1 4 4 43 25 1 1 1 1 1,
           10 15 10 11 1 1 1 1 1 1 14 9 10 9 1 1 1 1 1 1,
           15 20 3 1 1 1 1 1 1 1 25 6 17 1 1 1 1 1 1 1,
           14 1 54 1 1 1 1 1 1 1 10 1 6 1 1 1 1 1 1 1,
           10 10 10 10 1 1 1 1 1 1 14 14 10 10 1 1 1 1 1 1,
           22 12 4 5 1 1 1 1 1 1 28 10 4 3 1 1 1 1 1 1,
           18 6 2 2 1 1 1 1 1 1 52 2 3 3 1 1 1 1 1 1,
           18 6 2 2 1 1 1 1 1 1 52 2 3 3 1 1 1 1 1 1,
           40 1 1 1 1 1 1 1 1 1 42 1 1 1 1 1 1 1 1 1,
           5 50 3 2 1 1 1 1 1 1 10 8 2 8 1 1 1 1 1 1,
           1 1 5 5 1 1 1 1 1 1 1 4 4 43 25 1 1 1 1 1,
           10 15 10 11 1 1 1 1 1 1 14 9 10 9 1 1 1 1 1 1,
           15 20 3 1 1 1 1 1 1 1 25 6 17 1 1 1 1 1 1 1,
           14 1 54 1 1 1 1 1 1 1 10 1 6 1 1 1 1 1 1 1,
           10 10 10 10 1 1 1 1 1 1 14 14 10 10 1 1 1 1 1 1];       
                          
ID_os20 = [50 22 8 8 2 2 2 2 2 2,
         70 8 5 5 2 2 2 2 2 2,
         70 8 5 5 2 2 2 2 2 2,
         82 2 2 2 2 2 2 2 2 2,
         15 58 5 10 2 2 2 2 2 2,
         5 5 48 30 2 2 2 2 2 2,
         24 24 20 20 2 2 2 2 2 2,
         40 26 20 2 2 2 2 2 2 2,
         24 2 60 2 2 2 2 2 2 2,
         24 24 20 20 2 2 2 2 2 2,
         50 22 8 8 2 2 2 2 2 2,
         70 8 5 5 2 2 2 2 2 2,
         70 8 5 5 2 2 2 2 2 2,
         82 2 2 2 2 2 2 2 2 2,
         15 58 5 10 2 2 2 2 2 2,
         5 5 48 30 2 2 2 2 2 2,
         24 24 20 20 2 2 2 2 2 2,
         40 26 20 2 2 2 2 2 2 2,
         24 2 60 2 2 2 2 2 2 2,
         24 24 20 20 2 2 2 2 2 2] ;   
     
ID_dr20 = [22 12 4 5 1 1 1 1 1 1 28 10 4 3 1 1 1 1 1 1,
           18 6 2 2 1 1 1 1 1 1 52 2 3 3 1 1 1 1 1 1,
           18 6 2 2 1 1 1 1 1 1 52 2 3 3 1 1 1 1 1 1,
           40 1 1 1 1 1 1 1 1 1 42 1 1 1 1 1 1 1 1 1,
           5 50 3 2 1 1 1 1 1 1 10 8 2 8 1 1 1 1 1 1,
           1 1 5 5 1 1 1 1 1 1 1 4 4 43 25 1 1 1 1 1,
           10 15 10 11 1 1 1 1 1 1 14 9 10 9 1 1 1 1 1 1,
           15 20 3 1 1 1 1 1 1 1 25 6 17 1 1 1 1 1 1 1,
           14 1 54 1 1 1 1 1 1 1 10 1 6 1 1 1 1 1 1 1,
           10 10 10 10 1 1 1 1 1 1 14 14 10 10 1 1 1 1 1 1,
           22 12 4 5 1 1 1 1 1 1 28 10 4 3 1 1 1 1 1 1,
           18 6 2 2 1 1 1 1 1 1 52 2 3 3 1 1 1 1 1 1,
           18 6 2 2 1 1 1 1 1 1 52 2 3 3 1 1 1 1 1 1,
           40 1 1 1 1 1 1 1 1 1 42 1 1 1 1 1 1 1 1 1,
           5 50 3 2 1 1 1 1 1 1 10 8 2 8 1 1 1 1 1 1,
           1 1 5 5 1 1 1 1 1 1 1 4 4 43 25 1 1 1 1 1,
           10 15 10 11 1 1 1 1 1 1 14 9 10 9 1 1 1 1 1 1,
           15 20 3 1 1 1 1 1 1 1 25 6 17 1 1 1 1 1 1 1,
           14 1 54 1 1 1 1 1 1 1 10 1 6 1 1 1 1 1 1 1,
           10 10 10 10 1 1 1 1 1 1 14 14 10 10 1 1 1 1 1 1];
       
ID_apps = zeros(400,20);
ID_apps(1:20,:) = ID_apps20;
ID_apps(21:40,:) = ID_apps20;
ID_apps(41:60,:) = ID_apps20;
ID_apps(61:80,:) = ID_apps20;
ID_apps(81:100,:) = ID_apps20;
ID_apps(101:200,:) = ID_apps(1:100,:);
ID_apps(201:400,:) = ID_apps(1:200,:);
            
ID_serv = zeros(400,20);
ID_serv(1:20,:) = ID_serv20;
ID_serv(21:40,:) = ID_serv20;
ID_serv(41:60,:) = ID_serv20;
ID_serv(61:80,:) = ID_serv20;
ID_serv(81:100,:) = ID_serv20;
ID_serv(101:200,:) = ID_serv(1:100,:);
ID_serv(201:400,:) = ID_serv(1:200,:);
                          
ID_os = zeros(400,10);
ID_os(1:20,:) = ID_os20;
ID_os(21:40,:) = ID_os20;
ID_os(41:60,:) = ID_os20;
ID_os(61:80,:) = ID_os20;
ID_os(81:100,:) = ID_os20;
ID_os(101:200,:) = ID_os(1:100,:);
ID_os(201:400,:) = ID_os(1:200,:);
     
ID_dr = zeros(400,20);
ID_dr(1:20,:) = ID_dr20;
ID_dr(21:40,:) = ID_dr20;
ID_dr(41:60,:) = ID_dr20;
ID_dr(61:80,:) = ID_dr20;
ID_dr(81:100,:) = ID_dr20;
ID_dr(101:200,:) = ID_dr(1:100,:);
ID_dr(201:400,:) = ID_dr(1:200,:);

E_apps2 = E_apps;
E_serv2 = E_serv;
E_os2 = E_os;
E_dr2 = E_dr;     
ID_apps2 = ID_apps;
ID_serv2 = ID_serv;
ID_os2 = ID_os;
ID_dr2 = ID_dr;  

%INDIVIDUAL TIME ARRAY OF CHANGES TO PERSONAL INDIVIDUAL DESIRABILITIES
%needs to be set here because numNodes is different for each case
numNodes = 400;
IDtimeArray1 = zeros(1,numNodes);
IDtimeArray2 = zeros(1,numNodes);

case 13
numNodes = 10
% set up data - Dataset 13 - same as 1 but with orig of 0.5
%%%%%%%%%%%%%
%software strings
%WebBrowser1,6 - commercial products, WebBrowser2,3,4,5 third party
SW_str_apps = ['WebBrowser1v1 ' 'WebBrowser1v2 ' 'WebBrowser2v1 ' 'WebBrowser3v1 ' 'WebBrowser4v1 ' 'WebBrowser5v1 ' 'WebBrowser6v1 ' 'WebBrowser6v4 '];
%All photo viewers about same standard with number 7 slightly better
SW_str_serv = ['PhotoViewer1 ' 'PhotoViewer2 ' 'PhotoViewer3 ' 'PhotoViewer4 ' 'PhotoViewer5 ' 'PhotoViewer6 ' 'PhotoViewer7v1 ' 'PhotoViewer7v2 '];
%OS2 slightly more efficient overall than OS1
SW_str_os = ['OS1 ' 'OS2 '];
%higher versions are better than lower number versions, the commercial
%products are more efficient than the freebies 3rd party
SW_str_dr = ['DataDr1v1 ' 'DataDr1v2 ' 'DataDr2v1 ' 'DataDr3v3 ' 'DataDr4 ' 'DataDr5 ' 'DataDr6 ' 'DataDr7 '];

%software frequency info for running the frequency and nei diversity index
%algorithm
%locusApps - 'a' represents major variants, 'V' represents a minor version
%locusServ - 's' represents major variants, 'V' represents a minor version
%locusOS  - 'o' represents major variants, 'V' represents a minor version
SW_freq_apps = ['a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'];
SW_freq_serv = ['s', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'];
SW_freq_os = ['o', 'V'; 'o', 'V'];
SW_freq_dr = ['d', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'];

%compatability of software
CSW_str_apps = ['a'; 'a'; 'a' ;'a'; 'b'; 'b'; 'b'; 'b'];
CSW_str_serv = ['a'; 'a'; 'a'; 'a'; 'b'; 'b'; 'b'; 'b'];
CSW_str_os = ['a'; 'b'];
CSW_str_dr = ['a'; 'a'; 'a'; 'a'; 'b' ;'b'; 'b'; 'b'];
CSW = [CSW_str_apps; CSW_str_serv; CSW_str_os; CSW_str_dr];
%create two filters
CSW1 = zeros(size(CSW));
CSW2 = zeros(size(CSW));
CSW3 = zeros(size(CSW));
CSW4 = zeros(size(CSW));
CSW5 = zeros(size(CSW));
CSW6 = zeros(size(CSW));
CSW7 = zeros(size(CSW));
CSW8 = zeros(size(CSW));
CSW9 = zeros(size(CSW));
CSW10 = zeros(size(CSW));
for z = 1:size(CSW)
  if CSW(z) ==  'a'
      CSW1(z) = 1;
  end;
  if CSW(z) ==  'b'
      CSW2(z) = 1;
  end;
end; %end for z
CSW1 = CSW1';
CSW2 = CSW2';
CSW3 = CSW3';
CSW4 = CSW4';
CSW5 = CSW5';
CSW6 = CSW6';
CSW7 = CSW7';
CSW8 = CSW8';
CSW9 = CSW9';
CSW10 = CSW10';
CSWGroup(1,:) = CSW1;
CSWGroup(2,:) = CSW2;


% set up genotypes for each of the 10 nodes
%They should correspond roughly to the individuals desirabilities
Genotype_apps = [0 1 0 0 0 0 0 0,
                 0 1 0 0 0 0 0 0,
                 0 1 0 0 0 0 0 0,
                 0 1 0 0 0 0 0 0,
                 0 1 0 0 0 0 0 0,
                 0 0 0 0 0 0 0 1,
                 0 0 0 0 0 0 0 1,
                 0 0 0 0 0 0 0 1,
                 0 0 0 0 0 0 0 1,
                 0 0 0 0 0 0 0 1];
             
Genotype_serv = [1 0 0 0 0 0 0 0,
                 1 0 0 0 0 0 0 0,
                 1 0 0 0 0 0 0 0,
                 1 0 0 0 0 0 0 0,
                 1 0 0 0 0 0 0 0,
                 0 0 0 0 0 0 0 1,
                 0 0 0 0 0 0 0 1,
                 0 0 0 0 0 0 0 1,
                 0 0 0 0 0 0 0 1,
                 0 0 0 0 0 0 0 1];
             
Genotype_os = [1 0,
               1 0,
               1 0,
               1 0,
               1 0,
               0 1,
               0 1,
               0 1,
               0 1,
               0 1];
           
 Genotype_dr = [1 0 0 0 0 0 0 0,
                1 0 0 0 0 0 0 0,
                1 0 0 0 0 0 0 0,
                1 0 0 0 0 0 0 0,
                1 0 0 0 0 0 0 0,
                0 0 0 0 0 0 0 1,
                0 0 0 0 0 0 0 1,
                0 0 0 0 0 0 0 1,
                0 0 0 0 0 0 0 1,
                0 0 0 0 0 0 0 1];

%efficiency/quality ratings of software (1 to 100) 
%(1)inefficient (100)maximum efficiency
E_apps = [65 75 55 50 60 60 60 80];
E_serv = [65 66 67 63 59 62 72 77];
E_os = [70 80];
E_dr = [70 80 60 75 69 68 63 58];


%community desirability ratings (1 to 100) (1)least desirable (100)most
%desirable
CD_apps = [25 40 10 5 10 5 3 2];
sum(CD_apps);
CD_serv = [70 5 3 2 5 5 5 5];
sum(CD_serv);
CD_os = [80 20];
sum(CD_os);
CD_dr = [50 20 5 5 10 5 3 2];
sum(CD_dr);
%for change over
%for change over
CD_apps2 = [25 10 10 5 10 5 30 5];
sum(CD_apps2);
CD_serv2 = [40 5 3 2 15 15 10 10];
sum(CD_serv2);
CD_os2 = [50 50];
sum(CD_os2);
CD_dr2 = [40 1 4 5 10 25 3 12];
sum(CD_dr2);

%individual desirability ratings (1 to 100) (1)least desirable (100)most
%desirable
%MUST NOT HAVE ANY ZERO VALUES!
%do for 10 individuals
ID_apps = [25 40 10 5 10 5 3 2,
           20 68 1 1  5 2 2 1,
           68 20 1 1 5 2 2 1,
           39 48 5 4 1 1 1 1,
           5 10 3 2 50 15 13 2,
           1 1 4 4 48 19 22 1,
           10 15 10 15 10 10 10 20,
           20 35 3 2 10 10 5 15,
           58 10 1 1 5 4 1 20,
           10 15 10 15 10 10 10 20];  
            
ID_serv = [70 5 3 2 5 5 5 5,
           80 5 3 2 2 3 2 3,
           70 15 3 2 2 3 3 2,
           68 17 3 8 1 1 1 1,
           5 8 2 5 13 17 20 30,
           1 2 2 5 13 27 20 30,
           12 13 12 13 12 12 12 14,
           12 23 12 13 12 12 2 14,
           12 33 12 13 12 2 2 14,
           12 13 12 13 12 12 12 14] ;      
                          
ID_os = [80 20,
         90 10,
         90 10,
         96 4,
         20 80,
         10 90,
         50 50,
         60 40,
         70 30,
         50 50] ;   
     
ID_dr = [50 20 5 5 10 5 3 2,
         20 50 10 10 4 3 1 2,
         20 50 10 10 4 3 1 2,
         1 86 5 4 1 1 1 1,
         1 2 1 16 20 20 20 20,
         1 2 1 6 20 20 20 30 ,
         10 15 5 20 10 15 10 15,
         10 25 15 10 10 10 10 10,           
         10 35 15 10 5 10 5 10,
         10 15 5 20 13 13 12 12];
     
          E_apps2 = E_apps;
E_serv2 = E_serv;
E_os2 = E_os;
E_dr2 = E_dr;     
ID_apps2 = ID_apps;
ID_serv2 = ID_serv;
ID_os2 = ID_os;
ID_dr2 = ID_dr;
     
     %INDIVIDUAL TIME ARRAY OF CHANGES TO PERSONAL INDIVIDUAL DESIRABILITIES
%needs to be set here because numNodes is different for each case
IDtimeArray1 = zeros(1,numNodes);
IDtimeArray2 = zeros(1,numNodes);

    case 14
        numNodes = 20
% set up data - Dataset 14 - same as 1 but with orig of 0.5 and 20 nodes
%%%%%%%%%%%%%
%software strings
%WebBrowser1,6 - commercial products, WebBrowser2,3,4,5 third party
SW_str_apps = ['WebBrowser1v1 ' 'WebBrowser1v2 ' 'WebBrowser2v1 ' 'WebBrowser3v1 ' 'WebBrowser4v1 ' 'WebBrowser5v1 ' 'WebBrowser6v1 ' 'WebBrowser6v4 '];
%All photo viewers about same standard with number 7 slightly better
SW_str_serv = ['PhotoViewer1 ' 'PhotoViewer2 ' 'PhotoViewer3 ' 'PhotoViewer4 ' 'PhotoViewer5 ' 'PhotoViewer6 ' 'PhotoViewer7v1 ' 'PhotoViewer7v2 '];
%OS2 slightly more efficient overall than OS1
SW_str_os = ['OS1 ' 'OS2 '];
%higher versions are better than lower number versions, the commercial
%products are more efficient than the freebies 3rd party
SW_str_dr = ['DataDr1v1 ' 'DataDr1v2 ' 'DataDr2v1 ' 'DataDr3v3 ' 'DataDr4 ' 'DataDr5 ' 'DataDr6 ' 'DataDr7 '];

%software frequency info for running the frequency and nei diversity index
%algorithm
%locusApps - 'a' represents major variants, 'V' represents a minor version
%locusServ - 's' represents major variants, 'V' represents a minor version
%locusOS  - 'o' represents major variants, 'V' represents a minor version
SW_freq_apps = ['a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'];
SW_freq_serv = ['s', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'];
SW_freq_os = ['o', 'V'; 'o', 'V'];
SW_freq_dr = ['d', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'];

%compatability of software
CSW_str_apps = ['a'; 'a'; 'a' ;'a'; 'b'; 'b'; 'b'; 'b'];
CSW_str_serv = ['a'; 'a'; 'a'; 'a'; 'b'; 'b'; 'b'; 'b'];
CSW_str_os = ['a'; 'b'];
CSW_str_dr = ['a'; 'a'; 'a'; 'a'; 'b' ;'b'; 'b'; 'b'];
CSW = [CSW_str_apps; CSW_str_serv; CSW_str_os; CSW_str_dr];
%create two filters
CSW1 = zeros(size(CSW));
CSW2 = zeros(size(CSW));
CSW3 = zeros(size(CSW));
CSW4 = zeros(size(CSW));
CSW5 = zeros(size(CSW));
CSW6 = zeros(size(CSW));
CSW7 = zeros(size(CSW));
CSW8 = zeros(size(CSW));
CSW9 = zeros(size(CSW));
CSW10 = zeros(size(CSW));
for z = 1:size(CSW)
  if CSW(z) ==  'a'
      CSW1(z) = 1;
  end;
  if CSW(z) ==  'b'
      CSW2(z) = 1;
  end;
end; %end for z
CSW1 = CSW1';
CSW2 = CSW2';
CSW3 = CSW3';
CSW4 = CSW4';
CSW5 = CSW5';
CSW6 = CSW6';
CSW7 = CSW7';
CSW8 = CSW8';
CSW9 = CSW9';
CSW10 = CSW10';
CSWGroup(1,:) = CSW1;
CSWGroup(2,:) = CSW2;


% set up genotypes for each of the 20 nodes
%They should correspond roughly to the individuals desirabilities
Genotype_apps = [0 1 0 0 0 0 0 0,
                 0 1 0 0 0 0 0 0,
                 0 1 0 0 0 0 0 0,
                 0 1 0 0 0 0 0 0,
                 0 1 0 0 0 0 0 0,
                 0 0 0 0 0 0 0 1,
                 0 0 0 0 0 0 0 1,
                 0 0 0 0 0 0 0 1,
                 0 0 0 0 0 0 0 1,
                 0 0 0 0 0 0 0 1,
                 0 1 0 0 0 0 0 0,
                 0 1 0 0 0 0 0 0,
                 0 1 0 0 0 0 0 0,
                 0 1 0 0 0 0 0 0,
                 0 1 0 0 0 0 0 0,
                 0 0 0 0 0 0 0 1,
                 0 0 0 0 0 0 0 1,
                 0 0 0 0 0 0 0 1,
                 0 0 0 0 0 0 0 1,
                 0 0 0 0 0 0 0 1];
             
Genotype_serv = [1 0 0 0 0 0 0 0,
                 1 0 0 0 0 0 0 0,
                 1 0 0 0 0 0 0 0,
                 1 0 0 0 0 0 0 0,
                 1 0 0 0 0 0 0 0,
                 0 0 0 0 0 0 0 1,
                 0 0 0 0 0 0 0 1,
                 0 0 0 0 0 0 0 1,
                 0 0 0 0 0 0 0 1,
                 0 0 0 0 0 0 0 1,
                 1 0 0 0 0 0 0 0,
                 1 0 0 0 0 0 0 0,
                 1 0 0 0 0 0 0 0,
                 1 0 0 0 0 0 0 0,
                 1 0 0 0 0 0 0 0,
                 0 0 0 0 0 0 0 1,
                 0 0 0 0 0 0 0 1,
                 0 0 0 0 0 0 0 1,
                 0 0 0 0 0 0 0 1,
                 0 0 0 0 0 0 0 1];
             
Genotype_os = [1 0,
               1 0,
               1 0,
               1 0,
               1 0,
               0 1,
               0 1,
               0 1,
               0 1,
               0 1,
               1 0,
               1 0,
               1 0,
               1 0,
               1 0,
               0 1,
               0 1,
               0 1,
               0 1,
               0 1];
           
 Genotype_dr = [1 0 0 0 0 0 0 0,
                1 0 0 0 0 0 0 0,
                1 0 0 0 0 0 0 0,
                1 0 0 0 0 0 0 0,
                1 0 0 0 0 0 0 0,
                0 0 0 0 0 0 0 1,
                0 0 0 0 0 0 0 1,
                0 0 0 0 0 0 0 1,
                0 0 0 0 0 0 0 1,
                0 0 0 0 0 0 0 1,
                1 0 0 0 0 0 0 0,
                1 0 0 0 0 0 0 0,
                1 0 0 0 0 0 0 0,
                1 0 0 0 0 0 0 0,
                1 0 0 0 0 0 0 0,
                0 0 0 0 0 0 0 1,
                0 0 0 0 0 0 0 1,
                0 0 0 0 0 0 0 1,
                0 0 0 0 0 0 0 1,
                0 0 0 0 0 0 0 1];

%efficiency/quality ratings of software (1 to 100) 
%(1)inefficient (100)maximum efficiency
E_apps = [65 75 55 50 60 60 60 80];
E_serv = [65 66 67 63 59 62 72 77];
E_os = [70 80];
E_dr = [70 80 60 75 69 68 63 58];

%for change over
E_apps2 = [1 1 1 50 60 60 60 80];
E_serv2 = [1 1 1 63 59 62 72 77];
E_os2 = [1 85];
E_dr2 = [1 1 1 75 69 68 63 58];


%community desirability ratings (1 to 100) (1)least desirable (100)most
%desirable
CD_apps = [25 40 10 5 10 5 3 2];
sum(CD_apps);
CD_serv = [70 5 3 2 5 5 5 5];
sum(CD_serv);
CD_os = [80 20];
sum(CD_os);
CD_dr = [50 20 5 5 10 5 3 2];
sum(CD_dr);
%for change over
CD_apps2 = [25 10 10 5 10 5 30 5];
sum(CD_apps2);
CD_serv2 = [40 5 3 2 15 15 10 10];
sum(CD_serv2);
CD_os2 = [50 50];
sum(CD_os2);
CD_dr2 = [40 1 4 5 10 25 3 12];
sum(CD_dr2);

%individual desirability ratings (1 to 100) (1)least desirable (100)most
%desirable
%MUST NOT HAVE ANY ZERO VALUES!
%do for 10 individuals
ID_apps = [25 40 10 5 10 5 3 2,
           20 68 1 1  5 2 2 1,
           68 20 1 1 5 2 2 1,
           39 48 5 4 1 1 1 1,
           5 10 3 2 50 15 13 2,
           1 1 4 4 48 19 22 1,
           10 15 10 15 10 10 10 20,
           20 35 3 2 10 10 5 15,
           58 10 1 1 5 4 1 20,
           10 15 10 15 10 10 10 20,
           25 40 10 5 10 5 3 2,
           20 68 1 1  5 2 2 1,
           68 20 1 1 5 2 2 1,
           39 48 5 4 1 1 1 1,
           5 10 3 2 50 15 13 2,
           1 1 4 4 48 19 22 1,
           10 15 10 15 10 10 10 20,
           20 35 3 2 10 10 5 15,
           58 10 1 1 5 4 1 20,
           10 15 10 15 10 10 10 20];  
            
ID_serv = [70 5 3 2 5 5 5 5,
           80 5 3 2 2 3 2 3,
           70 15 3 2 2 3 3 2,
           68 17 3 8 1 1 1 1,
           5 8 2 5 13 17 20 30,
           1 2 2 5 13 27 20 30,
           12 13 12 13 12 12 12 14,
           12 23 12 13 12 12 2 14,
           12 33 12 13 12 2 2 14,
           12 13 12 13 12 12 12 14,
           70 5 3 2 5 5 5 5,
           80 5 3 2 2 3 2 3,
           70 15 3 2 2 3 3 2,
           68 17 3 8 1 1 1 1,
           5 8 2 5 13 17 20 30,
           1 2 2 5 13 27 20 30,
           12 13 12 13 12 12 12 14,
           12 23 12 13 12 12 2 14,
           12 33 12 13 12 2 2 14,
           12 13 12 13 12 12 12 14] ;      
                          
ID_os = [80 20,
         90 10,
         90 10,
         96 4,
         20 80,
         10 90,
         50 50,
         60 40,
         70 30,
         50 50,
         80 20,
         90 10,
         90 10,
         96 4,
         20 80,
         10 90,
         50 50,
         60 40,
         70 30,
         50 50] ;   
     
ID_dr = [50 20 5 5 10 5 3 2,
         20 50 10 10 4 3 1 2,
         20 50 10 10 4 3 1 2,
         1 86 5 4 1 1 1 1,
         1 2 1 16 20 20 20 20,
         1 2 1 6 20 20 20 30 ,
         10 15 5 20 10 15 10 15,
         10 25 15 10 10 10 10 10,           
         10 35 15 10 5 10 5 10,
         10 15 5 20 13 13 12 12,
         50 20 5 5 10 5 3 2,
         20 50 10 10 4 3 1 2,
         20 50 10 10 4 3 1 2,
         1 86 5 4 1 1 1 1,
         1 2 1 16 20 20 20 20,
         1 2 1 6 20 20 20 30 ,
         10 15 5 20 10 15 10 15,
         10 25 15 10 10 10 10 10,           
         10 35 15 10 5 10 5 10,
         10 15 5 20 13 13 12 12];
     ID_apps2 = ID_apps;
     ID_os2 = ID_os;
     ID_dr2 = ID_dr;
ID_serv2 = ID_serv;

    %INDIVIDUAL TIME ARRAY OF CHANGES TO PERSONAL INDIVIDUAL DESIRABILITIES
IDtimeArray1 = zeros(1,numNodes);
IDtimeArray2 = zeros(1,numNodes);
     
    case 15

% set up data - Dataset 15 - same as 1 but with orig of 0.5 and 400 nodes
%%%%%%%%%%%%%
%software strings
%WebBrowser1,6 - commercial products, WebBrowser2,3,4,5 third party
SW_str_apps = ['WebBrowser1v1 ' 'WebBrowser1v2 ' 'WebBrowser2v1 ' 'WebBrowser3v1 ' 'WebBrowser4v1 ' 'WebBrowser5v1 ' 'WebBrowser6v1 ' 'WebBrowser6v4 '];
%All photo viewers about same standard with number 7 slightly better
SW_str_serv = ['PhotoViewer1 ' 'PhotoViewer2 ' 'PhotoViewer3 ' 'PhotoViewer4 ' 'PhotoViewer5 ' 'PhotoViewer6 ' 'PhotoViewer7v1 ' 'PhotoViewer7v2 '];
%OS2 slightly more efficient overall than OS1
SW_str_os = ['OS1 ' 'OS2 '];
%higher versions are better than lower number versions, the commercial
%products are more efficient than the freebies 3rd party
SW_str_dr = ['DataDr1v1 ' 'DataDr1v2 ' 'DataDr2v1 ' 'DataDr3v3 ' 'DataDr4 ' 'DataDr5 ' 'DataDr6 ' 'DataDr7 '];

%software frequency info for running the frequency and nei diversity index
%algorithm
%locusApps - 'a' represents major variants, 'V' represents a minor version
%locusServ - 's' represents major variants, 'V' represents a minor version
%locusOS  - 'o' represents major variants, 'V' represents a minor version
SW_freq_apps = ['a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'];
SW_freq_serv = ['s', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'];
SW_freq_os = ['o', 'V'; 'o', 'V'];
SW_freq_dr = ['d', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'];

%compatability of software
CSW_str_apps = ['a'; 'a'; 'a' ;'a'; 'b'; 'b'; 'b'; 'b'];
CSW_str_serv = ['a'; 'a'; 'a'; 'a'; 'b'; 'b'; 'b'; 'b'];
CSW_str_os = ['a'; 'b'];
CSW_str_dr = ['a'; 'a'; 'a'; 'a'; 'b' ;'b'; 'b'; 'b'];
CSW = [CSW_str_apps; CSW_str_serv; CSW_str_os; CSW_str_dr];
%create two filters
CSW1 = zeros(size(CSW));
CSW2 = zeros(size(CSW));
CSW3 = zeros(size(CSW));
CSW4 = zeros(size(CSW));
CSW5 = zeros(size(CSW));
CSW6 = zeros(size(CSW));
CSW7 = zeros(size(CSW));
CSW8 = zeros(size(CSW));
CSW9 = zeros(size(CSW));
CSW10 = zeros(size(CSW));
for z = 1:size(CSW)
  if CSW(z) ==  'a'
      CSW1(z) = 1;
  end;
  if CSW(z) ==  'b'
      CSW2(z) = 1;
  end;
end; %end for z
CSW1 = CSW1';
CSW2 = CSW2';
CSW3 = CSW3';
CSW4 = CSW4';
CSW5 = CSW5';
CSW6 = CSW6';
CSW7 = CSW7';
CSW8 = CSW8';
CSW9 = CSW9';
CSW10 = CSW10';
CSWGroup(1,:) = CSW1;
CSWGroup(2,:) = CSW2;


% set up genotypes for each of the 400 nodes
Genotype_apps = zeros(400,8);
Genotype_apps(1:200,2)=1;
Genotype_apps(201:400,8)=1;

Genotype_serv = zeros(400,8);
Genotype_serv(1:200,1)=1;
Genotype_serv(201:400,8)=1;
             
Genotype_os = zeros(400,2);
Genotype_os(1:200,1)=1;
Genotype_os(201:400,2)=1;

Genotype_dr = zeros(400,8);
Genotype_dr(1:200,1)=1;
Genotype_dr(201:400,8)=1;           

%efficiency/quality ratings of software (1 to 100) 
%(1)inefficient (100)maximum efficiency
E_apps = [65 75 55 50 60 60 60 80];
E_serv = [65 66 67 63 59 62 72 77];
E_os = [20 80];
E_dr = [70 80 60 75 69 68 63 58];
%for change over
E_apps2 = [1 1 1 50 60 60 60 80];
E_serv2 = [1 1 1 63 59 62 72 77];
E_os2 = [1 85];
E_dr2 = [1 1 1 75 69 68 63 58];

%community desirability ratings (1 to 100) (1)least desirable (100)most
%desirable
CD_apps = [25 40 10 5 10 5 3 2];
sum(CD_apps);
CD_serv = [70 5 3 2 5 5 5 5];
sum(CD_serv);
CD_os = [80 20];
sum(CD_os);
CD_dr = [50 20 5 5 10 5 3 2];
sum(CD_dr);
%for change over
CD_apps2 = [25 10 10 5 10 5 30 5];
sum(CD_apps2);
CD_serv2 = [40 5 3 2 15 15 10 10];
sum(CD_serv2);
CD_os2 = [50 50];
sum(CD_os2);
CD_dr2 = [40 1 4 5 10 25 3 12];
sum(CD_dr2);

CD_apps = zeros(1,8).*10;
CD_serv = zeros(1,8).*10;
CD_os = zeros(1,2).*10;
CD_dr = zeros(1,8).*10;

%individual desirability ratings (1 to 100) (1)least desirable (100)most
%desirable
%MUST NOT HAVE ANY ZERO VALUES!
%do for 10 individuals

ID_apps10 = [25 40 10 5 10 5 3 2,
           20 68 1 1  5 2 2 1,
           68 20 1 1 5 2 2 1,
           39 48 5 4 1 1 1 1,
           5 10 3 2 50 15 13 2,
           1 1 4 4 48 19 22 1,
           10 15 10 15 10 10 10 20,
           20 35 3 2 10 10 5 15,
           58 10 1 1 5 4 1 20,
           10 15 10 15 10 10 10 20];  
            
ID_serv10 = [70 5 3 2 5 5 5 5,
           80 5 3 2 2 3 2 3,
           70 15 3 2 2 3 3 2,
           68 17 3 8 1 1 1 1,
           5 8 2 5 13 17 20 30,
           1 2 2 5 13 27 20 30,
           12 13 12 13 12 12 12 14,
           12 23 12 13 12 12 2 14,
           12 33 12 13 12 2 2 14,
           12 13 12 13 12 12 12 14] ;      
                          
ID_os10 = [80 20,
         90 10,
         90 10,
         96 4,
         20 80,
         10 90,
         50 50,
         60 40,
         70 30,
         50 50] ;   
     
ID_dr10 = [50 20 5 5 10 5 3 2,
         20 50 10 10 4 3 1 2,
         20 50 10 10 4 3 1 2,
         1 86 5 4 1 1 1 1,
         1 2 1 16 20 20 20 20,
         1 2 1 6 20 20 20 30 ,
         10 15 5 20 10 15 10 15,
         10 25 15 10 10 10 10 10,           
         10 35 15 10 5 10 5 10,
         10 15 5 20 13 13 12 12];

ID_apps = zeros(400,8);
ID_apps(1:10,:) = ID_apps10;
ID_apps(11:20,:) = ID_apps10;
ID_apps(21:30,:) = ID_apps10;
ID_apps(31:40,:) = ID_apps10;
ID_apps(41:50,:) = ID_apps10;
ID_apps(51:100,:) = ID_apps(1:50,:);
ID_apps(101:200,:) = ID_apps(1:100,:);
ID_apps(201:400,:) = ID_apps(1:200,:);

ID_serv = zeros(400,8);
ID_serv(1:10,:) = ID_serv10;
ID_serv(11:20,:) = ID_serv10;
ID_serv(21:30,:) = ID_serv10;
ID_serv(31:40,:) = ID_serv10;
ID_serv(41:50,:) = ID_serv10;
ID_serv(51:100,:) = ID_serv(1:50,:);
ID_serv(101:200,:) = ID_serv(1:100,:);
ID_serv(201:400,:) = ID_serv(1:200,:);
                          
ID_os = zeros(400,2);
ID_os(1:10,:) = ID_os10;
ID_os(11:20,:) = ID_os10;
ID_os(21:30,:) = ID_os10;
ID_os(31:40,:) = ID_os10;
ID_os(41:50,:) = ID_os10;
ID_os(51:100,:) = ID_os(1:50,:);
ID_os(101:200,:) = ID_os(1:100,:);
ID_os(201:400,:) = ID_os(1:200,:);
     
ID_dr = zeros(400,8);
ID_dr(1:10,:) = ID_dr10;
ID_dr(11:20,:) = ID_dr10;
ID_dr(21:30,:) = ID_dr10;
ID_dr(31:40,:) = ID_dr10;
ID_dr(41:50,:) = ID_dr10;
ID_dr(51:100,:) = ID_dr(1:50,:);
ID_dr(101:200,:) = ID_dr(1:100,:);
ID_dr(201:400,:) = ID_dr(1:200,:);
    
ID_apps2 = ID_apps;
ID_serv2 = ID_serv;
ID_os2 = ID_os;
ID_dr2 = ID_dr;

%INDIVIDUAL TIME ARRAY OF CHANGES TO PERSONAL INDIVIDUAL DESIRABILITIES
%needs to be set here because numNodes is different for each case
numNodes = 400;
IDtimeArray1 = zeros(1,numNodes);
IDtimeArray2 = zeros(1,numNodes);

    case 16

% set up data - Dataset 16 - same as 1 but with orig of 0.5 and 1000 nodes
%%%%%%%%%%%%%
%software strings
%WebBrowser1,6 - commercial products, WebBrowser2,3,4,5 third party
SW_str_apps = ['WebBrowser1v1 ' 'WebBrowser1v2 ' 'WebBrowser2v1 ' 'WebBrowser3v1 ' 'WebBrowser4v1 ' 'WebBrowser5v1 ' 'WebBrowser6v1 ' 'WebBrowser6v4 '];
%All photo viewers about same standard with number 7 slightly better
SW_str_serv = ['PhotoViewer1 ' 'PhotoViewer2 ' 'PhotoViewer3 ' 'PhotoViewer4 ' 'PhotoViewer5 ' 'PhotoViewer6 ' 'PhotoViewer7v1 ' 'PhotoViewer7v2 '];
%OS2 slightly more efficient overall than OS1
SW_str_os = ['OS1 ' 'OS2 '];
%higher versions are better than lower number versions, the commercial
%products are more efficient than the freebies 3rd party
SW_str_dr = ['DataDr1v1 ' 'DataDr1v2 ' 'DataDr2v1 ' 'DataDr3v3 ' 'DataDr4 ' 'DataDr5 ' 'DataDr6 ' 'DataDr7 '];

%software frequency info for running the frequency and nei diversity index
%algorithm
%locusApps - 'a' represents major variants, 'V' represents a minor version
%locusServ - 's' represents major variants, 'V' represents a minor version
%locusOS  - 'o' represents major variants, 'V' represents a minor version
SW_freq_apps = ['a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'];
SW_freq_serv = ['s', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'];
SW_freq_os = ['o', 'V'; 'o', 'V'];
SW_freq_dr = ['d', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'];

%compatability of software
CSW_str_apps = ['a'; 'a'; 'a' ;'a'; 'b'; 'b'; 'b'; 'b'];
CSW_str_serv = ['a'; 'a'; 'a'; 'a'; 'b'; 'b'; 'b'; 'b'];
CSW_str_os = ['a'; 'b'];
CSW_str_dr = ['a'; 'a'; 'a'; 'a'; 'b' ;'b'; 'b'; 'b'];
CSW = [CSW_str_apps; CSW_str_serv; CSW_str_os; CSW_str_dr];
%create two filters
CSW1 = zeros(size(CSW));
CSW2 = zeros(size(CSW));
CSW3 = zeros(size(CSW));
CSW4 = zeros(size(CSW));
CSW5 = zeros(size(CSW));
CSW6 = zeros(size(CSW));
CSW7 = zeros(size(CSW));
CSW8 = zeros(size(CSW));
CSW9 = zeros(size(CSW));
CSW10 = zeros(size(CSW));
for z = 1:size(CSW)
  if CSW(z) ==  'a'
      CSW1(z) = 1;
  end;
  if CSW(z) ==  'b'
      CSW2(z) = 1;
  end;
end; %end for z
CSW1 = CSW1';
CSW2 = CSW2';
CSW3 = CSW3';
CSW4 = CSW4';
CSW5 = CSW5';
CSW6 = CSW6';
CSW7 = CSW7';
CSW8 = CSW8';
CSW9 = CSW9';
CSW10 = CSW10';
CSWGroup(1,:) = CSW1;
CSWGroup(2,:) = CSW2;


% set up genotypes for each of the 400 nodes
Genotype_apps = zeros(1000,8);
Genotype_apps(1:500,2)=1;
Genotype_apps(501:1000,8)=1;

Genotype_serv = zeros(1000,8);
Genotype_serv(1:500,1)=1;
Genotype_serv(501:1000,8)=1;
             
Genotype_os = zeros(1000,2);
Genotype_os(1:500,1)=1;
Genotype_os(501:1000,2)=1;

Genotype_dr = zeros(1000,8);
Genotype_dr(1:500,1)=1;
Genotype_dr(501:1000,8)=1;           

%efficiency/quality ratings of software (1 to 100) 
%(1)inefficient (100)maximum efficiency
E_apps = [65 75 55 50 60 60 60 80];
E_serv = [65 66 67 63 59 62 72 77];
E_os = [20 80];
E_dr = [70 80 60 75 69 68 63 58];
%for change over
E_apps2 = [1 1 1 50 60 60 60 80];
E_serv2 = [1 1 1 63 59 62 72 77];
E_os2 = [1 85];
E_dr2 = [1 1 1 75 69 68 63 58];

%community desirability ratings (1 to 100) (1)least desirable (100)most
%desirable
CD_apps = [25 40 10 5 10 5 3 2];
sum(CD_apps);
CD_serv = [70 5 3 2 5 5 5 5];
sum(CD_serv);
CD_os = [80 20];
sum(CD_os);
CD_dr = [50 20 5 5 10 5 3 2];
sum(CD_dr);
%for change over
CD_apps2 = [25 10 10 5 10 5 30 5];
sum(CD_apps2);
CD_serv2 = [40 5 3 2 15 15 10 10];
sum(CD_serv2);
CD_os2 = [50 50];
sum(CD_os2);
CD_dr2 = [40 1 4 5 10 25 3 12];
sum(CD_dr2);

%individual desirability ratings (1 to 100) (1)least desirable (100)most
%desirable
%MUST NOT HAVE ANY ZERO VALUES!
%do for 10 individuals
ID_apps10 = [25 40 10 5 10 5 3 2,
           20 68 1 1  5 2 2 1,
           68 20 1 1 5 2 2 1,
           39 48 5 4 1 1 1 1,
           5 10 3 2 50 15 13 2,
           1 1 4 4 48 19 22 1,
           10 15 10 15 10 10 10 20,
           20 35 3 2 10 10 5 15,
           58 10 1 1 5 4 1 20,
           10 15 10 15 10 10 10 20];  
            
ID_serv10 = [70 5 3 2 5 5 5 5,
           80 5 3 2 2 3 2 3,
           70 15 3 2 2 3 3 2,
           68 17 3 8 1 1 1 1,
           5 8 2 5 13 17 20 30,
           1 2 2 5 13 27 20 30,
           12 13 12 13 12 12 12 14,
           12 23 12 13 12 12 2 14,
           12 33 12 13 12 2 2 14,
           12 13 12 13 12 12 12 14] ;      
                          
ID_os10 = [80 20,
         90 10,
         90 10,
         96 4,
         20 80,
         10 90,
         50 50,
         60 40,
         70 30,
         50 50] ;   
     
ID_dr10 = [50 20 5 5 10 5 3 2,
         20 50 10 10 4 3 1 2,
         20 50 10 10 4 3 1 2,
         1 86 5 4 1 1 1 1,
         1 2 1 16 20 20 20 20,
         1 2 1 6 20 20 20 30 ,
         10 15 5 20 10 15 10 15,
         10 25 15 10 10 10 10 10,           
         10 35 15 10 5 10 5 10,
         10 15 5 20 13 13 12 12];
     
ID_apps = zeros(1000,8);
ID_apps(1:10,:) = ID_apps10;
ID_apps(11:20,:) = ID_apps10;
ID_apps(21:30,:) = ID_apps10;
ID_apps(31:40,:) = ID_apps10;
ID_apps(41:50,:) = ID_apps10;
ID_apps(51:100,:) = ID_apps(1:50,:);
ID_apps(101:200,:) = ID_apps(1:100,:);
ID_apps(201:400,:) = ID_apps(1:200,:);
ID_apps(401:800,:) = ID_apps(1:400,:);
ID_apps(801:1000,:) = ID_apps(1:200,:);
             
ID_serv = zeros(1000,8);
ID_serv(1:10,:) = ID_serv10;
ID_serv(11:20,:) = ID_serv10;
ID_serv(21:30,:) = ID_serv10;
ID_serv(31:40,:) = ID_serv10;
ID_serv(41:50,:) = ID_serv10;
ID_serv(51:100,:) = ID_serv(1:50,:);
ID_serv(101:200,:) = ID_serv(1:100,:);
ID_serv(201:400,:) = ID_serv(1:200,:);
ID_serv(401:800,:) = ID_serv(1:400,:);
ID_serv(801:1000,:) = ID_serv(1:200,:);
                            
ID_os = zeros(1000,2);
ID_os(1:10,:) = ID_os10;
ID_os(11:20,:) = ID_os10;
ID_os(21:30,:) = ID_os10;
ID_os(31:40,:) = ID_os10;
ID_os(41:50,:) = ID_os10;
ID_os(51:100,:) = ID_os(1:50,:);
ID_os(101:200,:) = ID_os(1:100,:);
ID_os(201:400,:) = ID_os(1:200,:);
ID_os(401:800,:) = ID_os(1:400,:);
ID_os(801:1000,:) = ID_os(1:200,:);
     
ID_dr = zeros(1000,8);
ID_dr(1:10,:) = ID_dr10;
ID_dr(11:20,:) = ID_dr10;
ID_dr(21:30,:) = ID_dr10;
ID_dr(31:40,:) = ID_dr10;
ID_dr(41:50,:) = ID_dr10;
ID_dr(51:100,:) = ID_dr(1:50,:);
ID_dr(101:200,:) = ID_dr(1:100,:);
ID_dr(201:400,:) = ID_dr(1:200,:);
ID_dr(401:800,:) = ID_dr(1:400,:);
ID_dr(801:1000,:) = ID_dr(1:200,:);
   
ID_apps2 = ID_apps;
ID_serv2 = ID_serv;
ID_os2 = ID_os;
ID_dr2 = ID_dr;

%INDIVIDUAL TIME ARRAY OF CHANGES TO PERSONAL INDIVIDUAL DESIRABILITIES
%needs to be set here because numNodes is different for each case
numNodes = 1000;
IDtimeArray1 = zeros(1,numNodes);
IDtimeArray2 = zeros(1,numNodes);

    case 17
%%%%%%%%%%%%%
% set up data - Dataset 17 - 1000 nodes
%%%%%%%%%%%%%
numNodes = 1000
%software strings
%WebBrowser1,6 - commercial products, WebBrowser2,3,4,5 third party
SW_str_apps = ['WebBrowser1v1 ' 'WebBrowser1v2 ' 'WebBrowser2v1 ' 'WebBrowser3v1 ' 'WebBrowser4v1 ' 'WebBrowser5v1 ' 'WebBrowser6v1 ' 'WebBrowser6v4 ' 'WebBrowser7v1 ' 'WebBrowser7v3 ''WebBrowser8v1 ' 'WebBrowser8v2 ' 'WebBrowser8v3 ' 'WebBrowser9v1 ' 'WebBrowser10v1 ' 'WebBrowser11v1 ' 'WebBrowser12v1 ' 'WebBrowser13v4 ' 'WebBrowser14v1 ' 'WebBrowser15v3 '];
%All photo viewers about same standard with number 7 slightly better
SW_str_serv = ['PhotoViewer1 ' 'PhotoViewer2 ' 'PhotoViewer3 ' 'PhotoViewer4 ' 'PhotoViewer5 ' 'PhotoViewer6 ' 'PhotoViewer7v1 ' 'PhotoViewer7v2 ' 'PhotoViewer8 ' 'Photoviewer9 ' 'PhotoViewer1 ' 'PhotoViewer2 ' 'PhotoViewer3 ' 'PhotoViewer4 ' 'PhotoViewer5 ' 'PhotoViewer6 ' 'PhotoViewer7v1 ' 'PhotoViewer7v2 ' 'PhotoViewer8 ' 'Photoviewer9 '];
%OS2 slightly more efficient overall than OS1
SW_str_os = ['OS1 ' 'OS2 ' 'OS3 ' 'OS4 ' 'OS5' 'OS6' 'OS7' 'OS8' 'OS9' 'OS10'];
%higher versions are better than lower number versions, the commercial
%products are more efficient than the freebies 3rd party
SW_str_dr = ['DataDr1v1 ' 'DataDr1v2 ' 'DataDr2v1 ' 'DataDr3v3 ' 'DataDr4 ' 'DataDr5 ' 'DataDr6 ' 'DataDr7 ' 'DataDr9 ' 'DataDr8 ' 'DataDr1v1 ' 'DataDr1v2 ' 'DataDr2v1 ' 'DataDr3v3 ' 'DataDr4 ' 'DataDr5 ' 'DataDr6 ' 'DataDr7 ' 'DataDr9 ' 'DataDr8 '];

%software frequency info for running the frequency and nei diversity index
%algorithm
%locusApps - 'a' represents major variants, 'V' represents a minor version
%locusServ - 's' represents major variants, 'V' represents a minor version
%locusOS  - 'o' represents major variants, 'V' represents a minor version
SW_freq_apps = ['a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V';'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'];
SW_freq_serv = ['s', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'];
SW_freq_os = ['o', 'V'; 'o', 'V'; 'o', 'V'; 'o', 'V';'o', 'V'; 'o', 'V'; 'o', 'V'; 'o', 'V';'o', 'V'; 'o', 'V'];
SW_freq_dr = ['d', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'];

%compatability of software
CSW_str_apps = ['a'; 'b'; 'c' ;'d'; 'e'; 'f'; 'g'; 'h'; 'i'; 'j'; 'a'; 'b'; 'c' ;'d'; 'e'; 'f'; 'g'; 'h'; 'i'; 'j'];
CSW_str_serv = ['a'; 'b'; 'c'; 'd'; 'e'; 'f'; 'g'; 'h'; 'i'; 'j'; 'a'; 'b'; 'c'; 'd'; 'e'; 'f'; 'g'; 'h'; 'i'; 'j'];
CSW_str_os = ['a'; 'b'; 'c'; 'd'; 'e'; 'f'; 'g'; 'h'; 'i'; 'j'];
CSW_str_dr = ['a'; 'b'; 'c'; 'd'; 'e' ;'f'; 'g'; 'h'; 'i'; 'j'; 'a'; 'b'; 'c'; 'd'; 'e'; 'f'; 'g'; 'h'; 'i'; 'j'];
CSW = [CSW_str_apps; CSW_str_serv; CSW_str_os; CSW_str_dr];
%create filters
CSW1 = zeros(size(CSW));
CSW2 = zeros(size(CSW));
CSW3 = zeros(size(CSW));
CSW4 = zeros(size(CSW));
CSW5 = zeros(size(CSW));
CSW6 = zeros(size(CSW));
CSW7 = zeros(size(CSW));
CSW8 = zeros(size(CSW));
CSW9 = zeros(size(CSW));
CSW10 = zeros(size(CSW));
for z = 1:size(CSW)
  if CSW(z) ==  'a'
      CSW1(z) = 1;
  end;
  if CSW(z) ==  'b'
      CSW2(z) = 1;
  end;
 if CSW(z) ==  'c'
      CSW3(z) = 1;
  end;
 if CSW(z) ==  'd'
      CSW4(z) = 1;
  end;
  if CSW(z) ==  'e'
      CSW5(z) = 1;
  end;
  if CSW(z) ==  'f'
      CSW6(z) = 1;
  end;
 if CSW(z) ==  'g'
      CSW7(z) = 1;
  end;
 if CSW(z) ==  'h'
      CSW8(z) = 1;
  end;  
  if CSW(z) ==  'i'
      CSW9(z) = 1;
  end;
  if CSW(z) ==  'j'
      CSW10(z) = 1;
  end;

end; %end for z
CSW1 = CSW1';
CSW2 = CSW2';
CSW3 = CSW3';
CSW4 = CSW4';
CSW5 = CSW5';
CSW6 = CSW6';
CSW7 = CSW7';
CSW8 = CSW8';
CSW9 = CSW9';
CSW10 = CSW10';
CSWGroup(1,:) = CSW1;
CSWGroup(2,:) = CSW2;
CSWGroup(3,:) = CSW3;
CSWGroup(4,:) = CSW4;
CSWGroup(5,:) = CSW5;
CSWGroup(6,:) = CSW6;
CSWGroup(7,:) = CSW7;
CSWGroup(8,:) = CSW8;
CSWGroup(9,:) = CSW9;
CSWGroup(10,:) = CSW10;

Genotype_apps = zeros(1000,20);
Genotype_apps(1:500,1)=1;
Genotype_apps(501:1000,5)=1;

Genotype_serv = zeros(1000,20);
Genotype_serv(1:500,1)=1;
Genotype_serv(501:1000,5)=1;
             
Genotype_os = zeros(1000,10);
Genotype_os(1:500,1)=1;
Genotype_os(501:1000,5)=1;

Genotype_dr = zeros(1000,20);
Genotype_dr(1:500,1)=1;
Genotype_dr(501:1000,5)=1;          
            
%efficiency/quality ratings of software (1 to 100) 
%(1)inefficient (100)maximum efficiency
%E_apps = [65 75 55 50 60 60 60 80 20 20 65 75 55 50 60 60 60 80 20 20];
%E_serv = [65 66 67 63 59 62 72 77 50 50 65 75 55 50 60 60 60 80 20 20];
%E_os = [50 50 50 50 50 50 50 50 50 50];
%E_dr = [70 80 60 75 69 68 63 58 65 65 65 75 55 50 60 60 60 80 20 20];

E_apps = [1 75 55 5 1 1 5 80 20 20 10 75 10 5 5 5 60 80 5 5];
E_serv = [65 1 67 5 1 62 72 77 50 50 65 75 5 5 5 5 5 80 20 20];
E_os = [70 30 1 10 1 50 2 5 5 5];
E_dr = [70 80 1 75 15 68 20 58 1 1 1 5 5 8 5 1 60 2 20 20];

E_apps2 = [1 1 1 50 60 60 60 80 60 80 1 1 1 50 60 60 60 80 60 80];
E_serv2 = [1 1 1 63 59 62 72 77 77 77 1 1 1 50 60 60 60 80 60 80];
E_os2 = [1 85 1 1 1 1 1 1 1 1];
E_dr2 = [1 1 1 75 69 68 63 58 77 77 1 1 1 50 60 60 60 80 60 80];

%community desirability ratings (1 to 100) (1)least desirable (100)most
%desirable
%desirability 1
CD_apps = [81 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1];
sum(CD_apps);
CD_serv = [81 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1];
sum(CD_serv);
CD_os = [82 2 2 2 2 2 2 2 2 2];
sum(CD_os);
CD_dr = [81 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1];
sum(CD_dr);
%desirability 2 when wish to change
CD_apps2 = [15 8 1 1 1 1 1 1 1 1 55 6 1 1 1 1 1 1 1 1];
sum(CD_apps2)
CD_serv2 = [60 5 1 1 1 1 1 1 1 1 10 9 1 1 1 1 1 1 1 1];
sum(CD_serv2)
CD_os2 = [70 14 2 2 2 2 2 2 2 2];
sum(CD_os2)
CD_dr2 = [40 10 1 1 1 1 1 1 1 1 30 4 1 1 1 1 1 1 1 1];
sum(CD_dr2)
            
%individual desirability ratings (1 to 100) (1)least desirable (100)most
%desirable
%do for 10 individuals

ID_apps20 = [22 12 4 5 1 1 1 1 1 1 28 10 4 3 1 1 1 1 1 1,
           18 6 2 2 1 1 1 1 1 1 52 2 3 3 1 1 1 1 1 1,
           18 6 2 2 1 1 1 1 1 1 52 2 3 3 1 1 1 1 1 1,
           40 1 1 1 1 1 1 1 1 1 42 1 1 1 1 1 1 1 1 1,
           5 50 3 2 1 1 1 1 1 1 10 8 2 8 1 1 1 1 1 1,
           1 1 5 5 1 1 1 1 1 1 1 4 4 43 25 1 1 1 1 1,
           10 15 10 11 1 1 1 1 1 1 14 9 10 9 1 1 1 1 1 1,
           15 20 3 1 1 1 1 1 1 1 25 6 17 1 1 1 1 1 1 1,
           14 1 54 1 1 1 1 1 1 1 10 1 6 1 1 1 1 1 1 1,
           10 10 10 10 1 1 1 1 1 1 14 14 10 10 1 1 1 1 1 1,
           22 12 4 5 1 1 1 1 1 1 28 10 4 3 1 1 1 1 1 1,
           18 6 2 2 1 1 1 1 1 1 52 2 3 3 1 1 1 1 1 1,
           18 6 2 2 1 1 1 1 1 1 52 2 3 3 1 1 1 1 1 1,
           40 1 1 1 1 1 1 1 1 1 42 1 1 1 1 1 1 1 1 1,
           5 50 3 2 1 1 1 1 1 1 10 8 2 8 1 1 1 1 1 1,
           1 1 5 5 1 1 1 1 1 1 1 4 4 43 25 1 1 1 1 1,
           10 15 10 11 1 1 1 1 1 1 14 9 10 9 1 1 1 1 1 1,
           15 20 3 1 1 1 1 1 1 1 25 6 17 1 1 1 1 1 1 1,
           14 1 54 1 1 1 1 1 1 1 10 1 6 1 1 1 1 1 1 1,
           10 10 10 10 1 1 1 1 1 1 14 14 10 10 1 1 1 1 1 1];  
            
ID_serv20 = [22 12 4 5 1 1 1 1 1 1 28 10 4 3 1 1 1 1 1 1,
           18 6 2 2 1 1 1 1 1 1 52 2 3 3 1 1 1 1 1 1,
           18 6 2 2 1 1 1 1 1 1 52 2 3 3 1 1 1 1 1 1,
           40 1 1 1 1 1 1 1 1 1 42 1 1 1 1 1 1 1 1 1,
           5 50 3 2 1 1 1 1 1 1 10 8 2 8 1 1 1 1 1 1,
           1 1 5 5 1 1 1 1 1 1 1 4 4 43 25 1 1 1 1 1,
           10 15 10 11 1 1 1 1 1 1 14 9 10 9 1 1 1 1 1 1,
           15 20 3 1 1 1 1 1 1 1 25 6 17 1 1 1 1 1 1 1,
           14 1 54 1 1 1 1 1 1 1 10 1 6 1 1 1 1 1 1 1,
           10 10 10 10 1 1 1 1 1 1 14 14 10 10 1 1 1 1 1 1,
           22 12 4 5 1 1 1 1 1 1 28 10 4 3 1 1 1 1 1 1,
           18 6 2 2 1 1 1 1 1 1 52 2 3 3 1 1 1 1 1 1,
           18 6 2 2 1 1 1 1 1 1 52 2 3 3 1 1 1 1 1 1,
           40 1 1 1 1 1 1 1 1 1 42 1 1 1 1 1 1 1 1 1,
           5 50 3 2 1 1 1 1 1 1 10 8 2 8 1 1 1 1 1 1,
           1 1 5 5 1 1 1 1 1 1 1 4 4 43 25 1 1 1 1 1,
           10 15 10 11 1 1 1 1 1 1 14 9 10 9 1 1 1 1 1 1,
           15 20 3 1 1 1 1 1 1 1 25 6 17 1 1 1 1 1 1 1,
           14 1 54 1 1 1 1 1 1 1 10 1 6 1 1 1 1 1 1 1,
           10 10 10 10 1 1 1 1 1 1 14 14 10 10 1 1 1 1 1 1];       
                          
ID_os20 = [50 22 8 8 2 2 2 2 2 2,
         70 8 5 5 2 2 2 2 2 2,
         70 8 5 5 2 2 2 2 2 2,
         82 2 2 2 2 2 2 2 2 2,
         15 58 5 10 2 2 2 2 2 2,
         5 5 48 30 2 2 2 2 2 2,
         24 24 20 20 2 2 2 2 2 2,
         40 26 20 2 2 2 2 2 2 2,
         24 2 60 2 2 2 2 2 2 2,
         24 24 20 20 2 2 2 2 2 2,
         50 22 8 8 2 2 2 2 2 2,
         70 8 5 5 2 2 2 2 2 2,
         70 8 5 5 2 2 2 2 2 2,
         82 2 2 2 2 2 2 2 2 2,
         15 58 5 10 2 2 2 2 2 2,
         5 5 48 30 2 2 2 2 2 2,
         24 24 20 20 2 2 2 2 2 2,
         40 26 20 2 2 2 2 2 2 2,
         24 2 60 2 2 2 2 2 2 2,
         24 24 20 20 2 2 2 2 2 2] ;   
     
ID_dr20 = [22 12 4 5 1 1 1 1 1 1 28 10 4 3 1 1 1 1 1 1,
           18 6 2 2 1 1 1 1 1 1 52 2 3 3 1 1 1 1 1 1,
           18 6 2 2 1 1 1 1 1 1 52 2 3 3 1 1 1 1 1 1,
           40 1 1 1 1 1 1 1 1 1 42 1 1 1 1 1 1 1 1 1,
           5 50 3 2 1 1 1 1 1 1 10 8 2 8 1 1 1 1 1 1,
           1 1 5 5 1 1 1 1 1 1 1 4 4 43 25 1 1 1 1 1,
           10 15 10 11 1 1 1 1 1 1 14 9 10 9 1 1 1 1 1 1,
           15 20 3 1 1 1 1 1 1 1 25 6 17 1 1 1 1 1 1 1,
           14 1 54 1 1 1 1 1 1 1 10 1 6 1 1 1 1 1 1 1,
           10 10 10 10 1 1 1 1 1 1 14 14 10 10 1 1 1 1 1 1,
           22 12 4 5 1 1 1 1 1 1 28 10 4 3 1 1 1 1 1 1,
           18 6 2 2 1 1 1 1 1 1 52 2 3 3 1 1 1 1 1 1,
           18 6 2 2 1 1 1 1 1 1 52 2 3 3 1 1 1 1 1 1,
           40 1 1 1 1 1 1 1 1 1 42 1 1 1 1 1 1 1 1 1,
           5 50 3 2 1 1 1 1 1 1 10 8 2 8 1 1 1 1 1 1,
           1 1 5 5 1 1 1 1 1 1 1 4 4 43 25 1 1 1 1 1,
           10 15 10 11 1 1 1 1 1 1 14 9 10 9 1 1 1 1 1 1,
           15 20 3 1 1 1 1 1 1 1 25 6 17 1 1 1 1 1 1 1,
           14 1 54 1 1 1 1 1 1 1 10 1 6 1 1 1 1 1 1 1,
           10 10 10 10 1 1 1 1 1 1 14 14 10 10 1 1 1 1 1 1]; 
       
       
     
ID_apps = zeros(1000,20);
ID_apps(1:20,:) = ID_apps20;
ID_apps(21:40,:) = ID_apps20;
ID_apps(41:60,:) = ID_apps20;
ID_apps(61:80,:) = ID_apps20;
ID_apps(81:100,:) = ID_apps20;
ID_apps(101:200,:) = ID_apps(1:100,:);
ID_apps(201:400,:) = ID_apps(1:200,:);
ID_apps(401:800,:) = ID_apps(1:400,:);
ID_apps(801:1000,:) = ID_apps(1:200,:);
            
ID_serv = zeros(1000,20);
ID_serv(1:20,:) = ID_serv20;
ID_serv(21:40,:) = ID_serv20;
ID_serv(41:60,:) = ID_serv20;
ID_serv(61:80,:) = ID_serv20;
ID_serv(81:100,:) = ID_serv20;
ID_serv(101:200,:) = ID_serv(1:100,:);
ID_serv(201:400,:) = ID_serv(1:200,:);
ID_serv(401:800,:) = ID_serv(1:400,:);
ID_serv(801:1000,:) = ID_serv(1:200,:);
                          
ID_os = zeros(1000,10);
ID_os(1:20,:) = ID_os20;
ID_os(21:40,:) = ID_os20;
ID_os(41:60,:) = ID_os20;
ID_os(61:80,:) = ID_os20;
ID_os(81:100,:) = ID_os20;
ID_os(101:200,:) = ID_os(1:100,:);
ID_os(201:400,:) = ID_os(1:200,:);
ID_os(401:800,:) = ID_os(1:400,:);
ID_os(801:1000,:) = ID_os(1:200,:);
     
ID_dr = zeros(1000,20);
ID_dr(1:20,:) = ID_dr20;
ID_dr(21:40,:) = ID_dr20;
ID_dr(41:60,:) = ID_dr20;
ID_dr(61:80,:) = ID_dr20;
ID_dr(81:100,:) = ID_dr20;
ID_dr(101:200,:) = ID_dr(1:100,:);
ID_dr(201:400,:) = ID_dr(1:200,:);
ID_dr(401:800,:) = ID_dr(1:400,:);
ID_dr(801:1000,:) = ID_dr(1:200,:);


     ID_apps2 = ID_apps;
     ID_os2 = ID_os;
     ID_dr2 = ID_dr;
ID_serv2 = ID_serv;

%INDIVIDUAL TIME ARRAY OF CHANGES TO PERSONAL INDIVIDUAL DESIRABILITIES
%needs to be set here because numNodes is different for each case
numNodes = 1000;
IDtimeArray1 = zeros(1,numNodes);
IDtimeArray2 = zeros(1,numNodes);
    case 18
%%%%%%%%%%%%%
% set up data - Dataset 18 - 10,000 nodes
%%%%%%%%%%%%%
%software strings
%WebBrowser1,6 - commercial products, WebBrowser2,3,4,5 third party
SW_str_apps = ['WebBrowser1v1 ' 'WebBrowser1v2 ' 'WebBrowser2v1 ' 'WebBrowser3v1 ' 'WebBrowser4v1 ' 'WebBrowser5v1 ' 'WebBrowser6v1 ' 'WebBrowser6v4 ' 'WebBrowser7v1 ' 'WebBrowser7v3 ''WebBrowser8v1 ' 'WebBrowser8v2 ' 'WebBrowser8v3 ' 'WebBrowser9v1 ' 'WebBrowser10v1 ' 'WebBrowser11v1 ' 'WebBrowser12v1 ' 'WebBrowser13v4 ' 'WebBrowser14v1 ' 'WebBrowser15v3 '];
%All photo viewers about same standard with number 7 slightly better
SW_str_serv = ['PhotoViewer1 ' 'PhotoViewer2 ' 'PhotoViewer3 ' 'PhotoViewer4 ' 'PhotoViewer5 ' 'PhotoViewer6 ' 'PhotoViewer7v1 ' 'PhotoViewer7v2 ' 'PhotoViewer8 ' 'Photoviewer9 ' 'PhotoViewer1 ' 'PhotoViewer2 ' 'PhotoViewer3 ' 'PhotoViewer4 ' 'PhotoViewer5 ' 'PhotoViewer6 ' 'PhotoViewer7v1 ' 'PhotoViewer7v2 ' 'PhotoViewer8 ' 'Photoviewer9 '];
%OS2 slightly more efficient overall than OS1
SW_str_os = ['OS1 ' 'OS2 ' 'OS3 ' 'OS4 ' 'OS5' 'OS6' 'OS7' 'OS8' 'OS9' 'OS10'];
%higher versions are better than lower number versions, the commercial
%products are more efficient than the freebies 3rd party
SW_str_dr = ['DataDr1v1 ' 'DataDr1v2 ' 'DataDr2v1 ' 'DataDr3v3 ' 'DataDr4 ' 'DataDr5 ' 'DataDr6 ' 'DataDr7 ' 'DataDr9 ' 'DataDr8 ' 'DataDr1v1 ' 'DataDr1v2 ' 'DataDr2v1 ' 'DataDr3v3 ' 'DataDr4 ' 'DataDr5 ' 'DataDr6 ' 'DataDr7 ' 'DataDr9 ' 'DataDr8 '];

%software frequency info for running the frequency and nei diversity index
%algorithm
%locusApps - 'a' represents major variants, 'V' represents a minor version
%locusServ - 's' represents major variants, 'V' represents a minor version
%locusOS  - 'o' represents major variants, 'V' represents a minor version
SW_freq_apps = ['a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V';'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'];
SW_freq_serv = ['s', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'];
SW_freq_os = ['o', 'V'; 'o', 'V'; 'o', 'V'; 'o', 'V';'o', 'V'; 'o', 'V'; 'o', 'V'; 'o', 'V';'o', 'V'; 'o', 'V'];
SW_freq_dr = ['d', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'];

%compatability of software
CSW_str_apps = ['a'; 'b'; 'c' ;'d'; 'e'; 'f'; 'g'; 'h'; 'i'; 'j'; 'a'; 'b'; 'c' ;'d'; 'e'; 'f'; 'g'; 'h'; 'i'; 'j'];
CSW_str_serv = ['a'; 'b'; 'c'; 'd'; 'e'; 'f'; 'g'; 'h'; 'i'; 'j'; 'a'; 'b'; 'c'; 'd'; 'e'; 'f'; 'g'; 'h'; 'i'; 'j'];
CSW_str_os = ['a'; 'b'; 'c'; 'd'; 'e'; 'f'; 'g'; 'h'; 'i'; 'j'];
CSW_str_dr = ['a'; 'b'; 'c'; 'd'; 'e' ;'f'; 'g'; 'h'; 'i'; 'j'; 'a'; 'b'; 'c'; 'd'; 'e'; 'f'; 'g'; 'h'; 'i'; 'j'];
CSW = [CSW_str_apps; CSW_str_serv; CSW_str_os; CSW_str_dr];
%create filters
CSW1 = zeros(size(CSW));
CSW2 = zeros(size(CSW));
CSW3 = zeros(size(CSW));
CSW4 = zeros(size(CSW));
CSW5 = zeros(size(CSW));
CSW6 = zeros(size(CSW));
CSW7 = zeros(size(CSW));
CSW8 = zeros(size(CSW));
CSW9 = zeros(size(CSW));
CSW10 = zeros(size(CSW));
for z = 1:size(CSW)
  if CSW(z) ==  'a'
      CSW1(z) = 1;
  end;
  if CSW(z) ==  'b'
      CSW2(z) = 1;
  end;
 if CSW(z) ==  'c'
      CSW3(z) = 1;
  end;
 if CSW(z) ==  'd'
      CSW4(z) = 1;
  end;
  if CSW(z) ==  'e'
      CSW5(z) = 1;
  end;
  if CSW(z) ==  'f'
      CSW6(z) = 1;
  end;
 if CSW(z) ==  'g'
      CSW7(z) = 1;
  end;
 if CSW(z) ==  'h'
      CSW8(z) = 1;
  end;  
  if CSW(z) ==  'i'
      CSW9(z) = 1;
  end;
  if CSW(z) ==  'j'
      CSW10(z) = 1;
  end;

end; %end for z
CSW1 = CSW1';
CSW2 = CSW2';
CSW3 = CSW3';
CSW4 = CSW4';
CSW5 = CSW5';
CSW6 = CSW6';
CSW7 = CSW7';
CSW8 = CSW8';
CSW9 = CSW9';
CSW10 = CSW10';
CSWGroup(1,:) = CSW1;
CSWGroup(2,:) = CSW2;
CSWGroup(3,:) = CSW3;
CSWGroup(4,:) = CSW4;
CSWGroup(5,:) = CSW5;
CSWGroup(6,:) = CSW6;
CSWGroup(7,:) = CSW7;
CSWGroup(8,:) = CSW8;
CSWGroup(9,:) = CSW9;
CSWGroup(10,:) = CSW10;

Genotype_apps = zeros(10000,20);
Genotype_apps(1:5000,1)=1;
Genotype_apps(5001:10000,5)=1;

Genotype_serv = zeros(10000,20);
Genotype_serv(1:5000,1)=1;
Genotype_serv(5001:10000,5)=1;
             
Genotype_os = zeros(10000,10);
Genotype_os(1:5000,1)=1;
Genotype_os(5001:10000,5)=1;

Genotype_dr = zeros(10000,20);
Genotype_dr(1:5000,1)=1;
Genotype_dr(5001:10000,5)=1;          
            
%efficiency/quality ratings of software (1 to 100) 
%(1)inefficient (100)maximum efficiency
%E_apps = [65 75 55 50 60 60 60 80 20 20 65 75 55 50 60 60 60 80 20 20];
%E_serv = [65 66 67 63 59 62 72 77 50 50 65 75 55 50 60 60 60 80 20 20];
%E_os = [50 50 50 50 50 50 50 50 50 50];
%E_dr = [70 80 60 75 69 68 63 58 65 65 65 75 55 50 60 60 60 80 20 20];

E_apps = [1 75 55 5 1 1 5 80 20 20 10 75 10 5 5 5 60 80 5 5];
E_serv = [65 1 67 5 1 62 72 77 50 50 65 75 5 5 5 5 5 80 20 20];
E_os = [70 30 1 10 1 50 2 5 5 5];
E_dr = [70 80 1 75 15 68 20 58 1 1 1 5 5 8 5 1 60 2 20 20];

%community desirability ratings (1 to 100) (1)least desirable (100)most
%desirable
%desirability 1
CD_apps = [81 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1];
sum(CD_apps);
CD_serv = [81 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1];
sum(CD_serv);
CD_os = [82 2 2 2 2 2 2 2 2 2];
sum(CD_os);
CD_dr = [81 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1];
sum(CD_dr);
%desirability 2 when wish to change
CD_apps2 = [15 8 1 1 1 1 1 1 1 1 55 6 1 1 1 1 1 1 1 1];
sum(CD_apps2)
CD_serv2 = [60 5 1 1 1 1 1 1 1 1 10 9 1 1 1 1 1 1 1 1];
sum(CD_serv2)
CD_os2 = [70 14 2 2 2 2 2 2 2 2];
sum(CD_os2)
CD_dr2 = [40 10 1 1 1 1 1 1 1 1 30 4 1 1 1 1 1 1 1 1];
sum(CD_dr2)
            
%individual desirability ratings (1 to 100) (1)least desirable (100)most
%desirable
%do for 10 individuals

ID_apps20 = [22 12 4 5 1 1 1 1 1 1 28 10 4 3 1 1 1 1 1 1,
           18 6 2 2 1 1 1 1 1 1 52 2 3 3 1 1 1 1 1 1,
           18 6 2 2 1 1 1 1 1 1 52 2 3 3 1 1 1 1 1 1,
           40 1 1 1 1 1 1 1 1 1 42 1 1 1 1 1 1 1 1 1,
           5 50 3 2 1 1 1 1 1 1 10 8 2 8 1 1 1 1 1 1,
           1 1 5 5 1 1 1 1 1 1 1 4 4 43 25 1 1 1 1 1,
           10 15 10 11 1 1 1 1 1 1 14 9 10 9 1 1 1 1 1 1,
           15 20 3 1 1 1 1 1 1 1 25 6 17 1 1 1 1 1 1 1,
           14 1 54 1 1 1 1 1 1 1 10 1 6 1 1 1 1 1 1 1,
           10 10 10 10 1 1 1 1 1 1 14 14 10 10 1 1 1 1 1 1,
           22 12 4 5 1 1 1 1 1 1 28 10 4 3 1 1 1 1 1 1,
           18 6 2 2 1 1 1 1 1 1 52 2 3 3 1 1 1 1 1 1,
           18 6 2 2 1 1 1 1 1 1 52 2 3 3 1 1 1 1 1 1,
           40 1 1 1 1 1 1 1 1 1 42 1 1 1 1 1 1 1 1 1,
           5 50 3 2 1 1 1 1 1 1 10 8 2 8 1 1 1 1 1 1,
           1 1 5 5 1 1 1 1 1 1 1 4 4 43 25 1 1 1 1 1,
           10 15 10 11 1 1 1 1 1 1 14 9 10 9 1 1 1 1 1 1,
           15 20 3 1 1 1 1 1 1 1 25 6 17 1 1 1 1 1 1 1,
           14 1 54 1 1 1 1 1 1 1 10 1 6 1 1 1 1 1 1 1,
           10 10 10 10 1 1 1 1 1 1 14 14 10 10 1 1 1 1 1 1];  
            
ID_serv20 = [22 12 4 5 1 1 1 1 1 1 28 10 4 3 1 1 1 1 1 1,
           18 6 2 2 1 1 1 1 1 1 52 2 3 3 1 1 1 1 1 1,
           18 6 2 2 1 1 1 1 1 1 52 2 3 3 1 1 1 1 1 1,
           40 1 1 1 1 1 1 1 1 1 42 1 1 1 1 1 1 1 1 1,
           5 50 3 2 1 1 1 1 1 1 10 8 2 8 1 1 1 1 1 1,
           1 1 5 5 1 1 1 1 1 1 1 4 4 43 25 1 1 1 1 1,
           10 15 10 11 1 1 1 1 1 1 14 9 10 9 1 1 1 1 1 1,
           15 20 3 1 1 1 1 1 1 1 25 6 17 1 1 1 1 1 1 1,
           14 1 54 1 1 1 1 1 1 1 10 1 6 1 1 1 1 1 1 1,
           10 10 10 10 1 1 1 1 1 1 14 14 10 10 1 1 1 1 1 1,
           22 12 4 5 1 1 1 1 1 1 28 10 4 3 1 1 1 1 1 1,
           18 6 2 2 1 1 1 1 1 1 52 2 3 3 1 1 1 1 1 1,
           18 6 2 2 1 1 1 1 1 1 52 2 3 3 1 1 1 1 1 1,
           40 1 1 1 1 1 1 1 1 1 42 1 1 1 1 1 1 1 1 1,
           5 50 3 2 1 1 1 1 1 1 10 8 2 8 1 1 1 1 1 1,
           1 1 5 5 1 1 1 1 1 1 1 4 4 43 25 1 1 1 1 1,
           10 15 10 11 1 1 1 1 1 1 14 9 10 9 1 1 1 1 1 1,
           15 20 3 1 1 1 1 1 1 1 25 6 17 1 1 1 1 1 1 1,
           14 1 54 1 1 1 1 1 1 1 10 1 6 1 1 1 1 1 1 1,
           10 10 10 10 1 1 1 1 1 1 14 14 10 10 1 1 1 1 1 1];       
                          
ID_os20 = [50 22 8 8 2 2 2 2 2 2,
         70 8 5 5 2 2 2 2 2 2,
         70 8 5 5 2 2 2 2 2 2,
         82 2 2 2 2 2 2 2 2 2,
         15 58 5 10 2 2 2 2 2 2,
         5 5 48 30 2 2 2 2 2 2,
         24 24 20 20 2 2 2 2 2 2,
         40 26 20 2 2 2 2 2 2 2,
         24 2 60 2 2 2 2 2 2 2,
         24 24 20 20 2 2 2 2 2 2,
         50 22 8 8 2 2 2 2 2 2,
         70 8 5 5 2 2 2 2 2 2,
         70 8 5 5 2 2 2 2 2 2,
         82 2 2 2 2 2 2 2 2 2,
         15 58 5 10 2 2 2 2 2 2,
         5 5 48 30 2 2 2 2 2 2,
         24 24 20 20 2 2 2 2 2 2,
         40 26 20 2 2 2 2 2 2 2,
         24 2 60 2 2 2 2 2 2 2,
         24 24 20 20 2 2 2 2 2 2] ;   
     
ID_dr20 = [22 12 4 5 1 1 1 1 1 1 28 10 4 3 1 1 1 1 1 1,
           18 6 2 2 1 1 1 1 1 1 52 2 3 3 1 1 1 1 1 1,
           18 6 2 2 1 1 1 1 1 1 52 2 3 3 1 1 1 1 1 1,
           40 1 1 1 1 1 1 1 1 1 42 1 1 1 1 1 1 1 1 1,
           5 50 3 2 1 1 1 1 1 1 10 8 2 8 1 1 1 1 1 1,
           1 1 5 5 1 1 1 1 1 1 1 4 4 43 25 1 1 1 1 1,
           10 15 10 11 1 1 1 1 1 1 14 9 10 9 1 1 1 1 1 1,
           15 20 3 1 1 1 1 1 1 1 25 6 17 1 1 1 1 1 1 1,
           14 1 54 1 1 1 1 1 1 1 10 1 6 1 1 1 1 1 1 1,
           10 10 10 10 1 1 1 1 1 1 14 14 10 10 1 1 1 1 1 1,
           22 12 4 5 1 1 1 1 1 1 28 10 4 3 1 1 1 1 1 1,
           18 6 2 2 1 1 1 1 1 1 52 2 3 3 1 1 1 1 1 1,
           18 6 2 2 1 1 1 1 1 1 52 2 3 3 1 1 1 1 1 1,
           40 1 1 1 1 1 1 1 1 1 42 1 1 1 1 1 1 1 1 1,
           5 50 3 2 1 1 1 1 1 1 10 8 2 8 1 1 1 1 1 1,
           1 1 5 5 1 1 1 1 1 1 1 4 4 43 25 1 1 1 1 1,
           10 15 10 11 1 1 1 1 1 1 14 9 10 9 1 1 1 1 1 1,
           15 20 3 1 1 1 1 1 1 1 25 6 17 1 1 1 1 1 1 1,
           14 1 54 1 1 1 1 1 1 1 10 1 6 1 1 1 1 1 1 1,
           10 10 10 10 1 1 1 1 1 1 14 14 10 10 1 1 1 1 1 1]; 
       
ID_apps = zeros(10000,20);
ID_apps(1:20,:) = ID_apps20;
ID_apps(21:40,:) = ID_apps20;
ID_apps(41:60,:) = ID_apps20;
ID_apps(61:80,:) = ID_apps20;
ID_apps(81:100,:) = ID_apps20;
ID_apps(101:200,:) = ID_apps(1:100,:);
ID_apps(201:400,:) = ID_apps(1:200,:);
ID_apps(401:800,:) = ID_apps(1:400,:);
ID_apps(801:1000,:) = ID_apps(1:200,:);
ID_apps(1001:2000,:) = ID_apps(1:1000,:);
ID_apps(2001:4000,:) = ID_apps(1:2000,:);
ID_apps(4001:8000,:) = ID_apps(1:4000,:);
ID_apps(8001:10000,:) = ID_apps(1:2000,:);
            
ID_serv = zeros(10000,20);
ID_serv(1:20,:) = ID_serv20;
ID_serv(21:40,:) = ID_serv20;
ID_serv(41:60,:) = ID_serv20;
ID_serv(61:80,:) = ID_serv20;
ID_serv(81:100,:) = ID_serv20;
ID_serv(101:200,:) = ID_serv(1:100,:);
ID_serv(201:400,:) = ID_serv(1:200,:);
ID_serv(401:800,:) = ID_serv(1:400,:);
ID_serv(801:1000,:) = ID_serv(1:200,:);
ID_serv(1001:2000,:) = ID_serv(1:1000,:);
ID_serv(2001:4000,:) = ID_serv(1:2000,:);
ID_serv(4001:8000,:) = ID_serv(1:4000,:);
ID_serv(8001:10000,:) = ID_serv(1:2000,:);
                          
ID_os = zeros(10000,10);
ID_os(1:20,:) = ID_os20;
ID_os(21:40,:) = ID_os20;
ID_os(41:60,:) = ID_os20;
ID_os(61:80,:) = ID_os20;
ID_os(81:100,:) = ID_os20;
ID_os(101:200,:) = ID_os(1:100,:);
ID_os(201:400,:) = ID_os(1:200,:);
ID_os(401:800,:) = ID_os(1:400,:);
ID_os(801:1000,:) = ID_os(1:200,:);
ID_os(1001:2000,:) = ID_os(1:1000,:);
ID_os(2001:4000,:) = ID_os(1:2000,:);
ID_os(4001:8000,:) = ID_os(1:4000,:);
ID_os(8001:10000,:) = ID_os(1:2000,:);   
     
ID_dr = zeros(10000,20);
ID_dr(1:20,:) = ID_dr20;
ID_dr(21:40,:) = ID_dr20;
ID_dr(41:60,:) = ID_dr20;
ID_dr(61:80,:) = ID_dr20;
ID_dr(81:100,:) = ID_dr20;
ID_dr(101:200,:) = ID_dr(1:100,:);
ID_dr(201:400,:) = ID_dr(1:200,:);
ID_dr(401:800,:) = ID_dr(1:400,:);
ID_dr(801:1000,:) = ID_dr(1:200,:);
ID_dr(1001:2000,:) = ID_dr(1:1000,:);
ID_dr(2001:4000,:) = ID_dr(1:2000,:);
ID_dr(4001:8000,:) = ID_dr(1:4000,:);
ID_dr(8001:10000,:) = ID_dr(1:2000,:);

     E_apps2 = E_apps;
E_serv2 = E_serv;
E_os2 = E_os;
E_dr2 = E_dr;     
ID_apps2 = ID_apps;
ID_serv2 = ID_serv;
ID_os2 = ID_os;
ID_dr2 = ID_dr;

%INDIVIDUAL TIME ARRAY OF CHANGES TO PERSONAL INDIVIDUAL DESIRABILITIES
%needs to be set here because numNodes is different for each case
numNodes = 10000;
IDtimeArray1 = zeros(1,numNodes);
IDtimeArray2 = zeros(1,numNodes);

    case 19
% set up data - Dataset 19 - same as 1 but with orig of 0.5 and 10,000 nodes
%%%%%%%%%%%%%
%software strings
%WebBrowser1,6 - commercial products, WebBrowser2,3,4,5 third party
SW_str_apps = ['WebBrowser1v1 ' 'WebBrowser1v2 ' 'WebBrowser2v1 ' 'WebBrowser3v1 ' 'WebBrowser4v1 ' 'WebBrowser5v1 ' 'WebBrowser6v1 ' 'WebBrowser6v4 '];
%All photo viewers about same standard with number 7 slightly better
SW_str_serv = ['PhotoViewer1 ' 'PhotoViewer2 ' 'PhotoViewer3 ' 'PhotoViewer4 ' 'PhotoViewer5 ' 'PhotoViewer6 ' 'PhotoViewer7v1 ' 'PhotoViewer7v2 '];
%OS2 slightly more efficient overall than OS1
SW_str_os = ['OS1 ' 'OS2 '];
%higher versions are better than lower number versions, the commercial
%products are more efficient than the freebies 3rd party
SW_str_dr = ['DataDr1v1 ' 'DataDr1v2 ' 'DataDr2v1 ' 'DataDr3v3 ' 'DataDr4 ' 'DataDr5 ' 'DataDr6 ' 'DataDr7 '];

%software frequency info for running the frequency and nei diversity index
%algorithm
%locusApps - 'a' represents major variants, 'V' represents a minor version
%locusServ - 's' represents major variants, 'V' represents a minor version
%locusOS  - 'o' represents major variants, 'V' represents a minor version
SW_freq_apps = ['a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'];
SW_freq_serv = ['s', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'];
SW_freq_os = ['o', 'V'; 'o', 'V'];
SW_freq_dr = ['d', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'];

%compatability of software
CSW_str_apps = ['a'; 'a'; 'a' ;'a'; 'b'; 'b'; 'b'; 'b'];
CSW_str_serv = ['a'; 'a'; 'a'; 'a'; 'b'; 'b'; 'b'; 'b'];
CSW_str_os = ['a'; 'b'];
CSW_str_dr = ['a'; 'a'; 'a'; 'a'; 'b' ;'b'; 'b'; 'b'];
CSW = [CSW_str_apps; CSW_str_serv; CSW_str_os; CSW_str_dr];
%create two filters
CSW1 = zeros(size(CSW));
CSW2 = zeros(size(CSW));
CSW3 = zeros(size(CSW));
CSW4 = zeros(size(CSW));
CSW5 = zeros(size(CSW));
CSW6 = zeros(size(CSW));
CSW7 = zeros(size(CSW));
CSW8 = zeros(size(CSW));
CSW9 = zeros(size(CSW));
CSW10 = zeros(size(CSW));
for z = 1:size(CSW)
  if CSW(z) ==  'a'
      CSW1(z) = 1;
  end;
  if CSW(z) ==  'b'
      CSW2(z) = 1;
  end;
end; %end for z
CSW1 = CSW1';
CSW2 = CSW2';
CSW3 = CSW3';
CSW4 = CSW4';
CSW5 = CSW5';
CSW6 = CSW6';
CSW7 = CSW7';
CSW8 = CSW8';
CSW9 = CSW9';
CSW10 = CSW10';
CSWGroup(1,:) = CSW1;
CSWGroup(2,:) = CSW2;


% set up genotypes for each of the 400 nodes
Genotype_apps = zeros(10000,8);
Genotype_apps(1:5000,2)=1;
Genotype_apps(5001:10000,8)=1;

Genotype_serv = zeros(10000,8);
Genotype_serv(1:5000,1)=1;
Genotype_serv(5001:10000,8)=1;
             
Genotype_os = zeros(10000,2);
Genotype_os(1:5000,1)=1;
Genotype_os(5001:10000,2)=1;

Genotype_dr = zeros(10000,8);
Genotype_dr(1:5000,1)=1;
Genotype_dr(5001:10000,8)=1;           

%efficiency/quality ratings of software (1 to 100) 
%(1)inefficient (100)maximum efficiency
E_apps = [65 75 55 50 60 60 60 80];
E_serv = [65 66 67 63 59 62 72 77];
E_os = [70 80];
E_dr = [70 80 60 75 69 68 63 58];


%community desirability ratings (1 to 100) (1)least desirable (100)most
%desirable
CD_apps = [25 40 10 5 10 5 3 2];
sum(CD_apps);
CD_serv = [70 5 3 2 5 5 5 5];
sum(CD_serv);
CD_os = [80 20];
sum(CD_os);
CD_dr = [50 20 5 5 10 5 3 2];
sum(CD_dr);
%for change over
CD_apps2 = [5 40 10 5 10 5 23 2];
sum(CD_apps2);
CD_serv2 = [50 5 3 2 5 5 25 5];
sum(CD_serv2);
CD_os2 = [60 40];
sum(CD_os2);
CD_dr2 = [30 20 5 5 30 5 3 2];
sum(CD_dr2);

%individual desirability ratings (1 to 100) (1)least desirable (100)most
%desirable
%MUST NOT HAVE ANY ZERO VALUES!
%do for 10 individuals

ID_apps10 = [25 40 10 5 10 5 3 2,
           20 68 1 1  5 2 2 1,
           68 20 1 1 5 2 2 1,
           39 48 5 4 1 1 1 1,
           5 10 3 2 50 15 13 2,
           1 1 4 4 48 19 22 1,
           10 15 10 15 10 10 10 20,
           20 35 3 2 10 10 5 15,
           58 10 1 1 5 4 1 20,
           10 15 10 15 10 10 10 20];  
            
ID_serv10 = [70 5 3 2 5 5 5 5,
           80 5 3 2 2 3 2 3,
           70 15 3 2 2 3 3 2,
           68 17 3 8 1 1 1 1,
           5 8 2 5 13 17 20 30,
           1 2 2 5 13 27 20 30,
           12 13 12 13 12 12 12 14,
           12 23 12 13 12 12 2 14,
           12 33 12 13 12 2 2 14,
           12 13 12 13 12 12 12 14] ;      
                          
ID_os10 = [80 20,
         90 10,
         90 10,
         96 4,
         20 80,
         10 90,
         50 50,
         60 40,
         70 30,
         50 50] ;   
     
ID_dr10 = [50 20 5 5 10 5 3 2,
         20 50 10 10 4 3 1 2,
         20 50 10 10 4 3 1 2,
         1 86 5 4 1 1 1 1,
         1 2 1 16 20 20 20 20,
         1 2 1 6 20 20 20 30 ,
         10 15 5 20 10 15 10 15,
         10 25 15 10 10 10 10 10,           
         10 35 15 10 5 10 5 10,
         10 15 5 20 13 13 12 12];

ID_apps = zeros(10000,8);
ID_apps(1:10,:) = ID_apps10;
ID_apps(11:20,:) = ID_apps10;
ID_apps(21:30,:) = ID_apps10;
ID_apps(31:40,:) = ID_apps10;
ID_apps(41:50,:) = ID_apps10;
ID_apps(51:100,:) = ID_apps(1:50,:);
ID_apps(101:200,:) = ID_apps(1:100,:);
ID_apps(201:400,:) = ID_apps(1:200,:);
ID_apps(401:800,:) = ID_apps(1:400,:);
ID_apps(801:1000,:) = ID_apps(1:200,:);
ID_apps(1001:2000,:) = ID_apps(1:1000,:);
ID_apps(2001:4000,:) = ID_apps(1:2000,:);
ID_apps(4001:8000,:) = ID_apps(1:4000,:);
ID_apps(8001:10000,:) = ID_apps(1:2000,:);
             
ID_serv = zeros(10000,8);
ID_serv(1:10,:) = ID_serv10;
ID_serv(11:20,:) = ID_serv10;
ID_serv(21:30,:) = ID_serv10;
ID_serv(31:40,:) = ID_serv10;
ID_serv(41:50,:) = ID_serv10;
ID_serv(51:100,:) = ID_serv(1:50,:);
ID_serv(101:200,:) = ID_serv(1:100,:);
ID_serv(201:400,:) = ID_serv(1:200,:);
ID_serv(401:800,:) = ID_serv(1:400,:);
ID_serv(801:1000,:) = ID_serv(1:200,:);
ID_serv(1001:2000,:) = ID_serv(1:1000,:);
ID_serv(2001:4000,:) = ID_serv(1:2000,:);
ID_serv(4001:8000,:) = ID_serv(1:4000,:);
ID_serv(8001:10000,:) = ID_serv(1:2000,:);
                          
ID_os = zeros(10000,2);
ID_os(1:10,:) = ID_os10;
ID_os(11:20,:) = ID_os10;
ID_os(21:30,:) = ID_os10;
ID_os(31:40,:) = ID_os10;
ID_os(41:50,:) = ID_os10;
ID_os(51:100,:) = ID_os(1:50,:);
ID_os(101:200,:) = ID_os(1:100,:);
ID_os(201:400,:) = ID_os(1:200,:);
ID_os(401:800,:) = ID_os(1:400,:);
ID_os(801:1000,:) = ID_os(1:200,:);
ID_os(1001:2000,:) = ID_os(1:1000,:);
ID_os(2001:4000,:) = ID_os(1:2000,:);
ID_os(4001:8000,:) = ID_os(1:4000,:);
ID_os(8001:10000,:) = ID_os(1:2000,:);
     
ID_dr = zeros(10000,8);
ID_dr(1:10,:) = ID_dr10;
ID_dr(11:20,:) = ID_dr10;
ID_dr(21:30,:) = ID_dr10;
ID_dr(31:40,:) = ID_dr10;
ID_dr(41:50,:) = ID_dr10;
ID_dr(51:100,:) = ID_dr(1:50,:);
ID_dr(101:200,:) = ID_dr(1:100,:);
ID_dr(201:400,:) = ID_dr(1:200,:);
ID_dr(401:800,:) = ID_dr(1:400,:);
ID_dr(801:1000,:) = ID_dr(1:200,:);
ID_dr(1001:2000,:) = ID_dr(1:1000,:);
ID_dr(2001:4000,:) = ID_dr(1:2000,:);
ID_dr(4001:8000,:) = ID_dr(1:4000,:);
ID_dr(8001:10000,:) = ID_dr(1:2000,:);

     E_apps2 = E_apps;
E_serv2 = E_serv;
E_os2 = E_os;
E_dr2 = E_dr;     
ID_apps2 = ID_apps;
ID_serv2 = ID_serv;
ID_os2 = ID_os;
ID_dr2 = ID_dr;

%INDIVIDUAL TIME ARRAY OF CHANGES TO PERSONAL INDIVIDUAL DESIRABILITIES
%needs to be set here because numNodes is different for each case
numNodes = 10000;
IDtimeArray1 = zeros(1,numNodes);
IDtimeArray2 = zeros(1,numNodes);

    case 20
% set up data - same as Dataset 14 - but with comm as 0.3
%%%%%%%%%%%%%
%software strings
%WebBrowser1,6 - commercial products, WebBrowser2,3,4,5 third party
SW_str_apps = ['WebBrowser1v1 ' 'WebBrowser1v2 ' 'WebBrowser2v1 ' 'WebBrowser3v1 ' 'WebBrowser4v1 ' 'WebBrowser5v1 ' 'WebBrowser6v1 ' 'WebBrowser6v4 '];
%All photo viewers about same standard with number 7 slightly better
SW_str_serv = ['PhotoViewer1 ' 'PhotoViewer2 ' 'PhotoViewer3 ' 'PhotoViewer4 ' 'PhotoViewer5 ' 'PhotoViewer6 ' 'PhotoViewer7v1 ' 'PhotoViewer7v2 '];
%OS2 slightly more efficient overall than OS1
SW_str_os = ['OS1 ' 'OS2 '];
%higher versions are better than lower number versions, the commercial
%products are more efficient than the freebies 3rd party
SW_str_dr = ['DataDr1v1 ' 'DataDr1v2 ' 'DataDr2v1 ' 'DataDr3v3 ' 'DataDr4 ' 'DataDr5 ' 'DataDr6 ' 'DataDr7 '];

%software frequency info for running the frequency and nei diversity index
%algorithm
%locusApps - 'a' represents major variants, 'V' represents a minor version
%locusServ - 's' represents major variants, 'V' represents a minor version
%locusOS  - 'o' represents major variants, 'V' represents a minor version
SW_freq_apps = ['a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'];
SW_freq_serv = ['s', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'];
SW_freq_os = ['o', 'V'; 'o', 'V'];
SW_freq_dr = ['d', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'];

%compatability of software
CSW_str_apps = ['a'; 'a'; 'a' ;'a'; 'b'; 'b'; 'b'; 'b'];
CSW_str_serv = ['a'; 'a'; 'a'; 'a'; 'b'; 'b'; 'b'; 'b'];
CSW_str_os = ['a'; 'b'];
CSW_str_dr = ['a'; 'a'; 'a'; 'a'; 'b' ;'b'; 'b'; 'b'];
CSW = [CSW_str_apps; CSW_str_serv; CSW_str_os; CSW_str_dr];
%create two filters
CSW1 = zeros(size(CSW));
CSW2 = zeros(size(CSW));
CSW3 = zeros(size(CSW));
CSW4 = zeros(size(CSW));
CSW5 = zeros(size(CSW));
CSW6 = zeros(size(CSW));
CSW7 = zeros(size(CSW));
CSW8 = zeros(size(CSW));
CSW9 = zeros(size(CSW));
CSW10 = zeros(size(CSW));
for z = 1:size(CSW)
  if CSW(z) ==  'a'
      CSW1(z) = 1;
  end;
  if CSW(z) ==  'b'
      CSW2(z) = 1;
  end;
end; %end for z
CSW1 = CSW1';
CSW2 = CSW2';
CSW3 = CSW3';
CSW4 = CSW4';
CSW5 = CSW5';
CSW6 = CSW6';
CSW7 = CSW7';
CSW8 = CSW8';
CSW9 = CSW9';
CSW10 = CSW10';
CSWGroup(1,:) = CSW1;
CSWGroup(2,:) = CSW2;


% set up genotypes for each of the 20 nodes
%They should correspond roughly to the individuals desirabilities
Genotype_apps = [0 1 0 0 0 0 0 0,
                 0 1 0 0 0 0 0 0,
                 0 1 0 0 0 0 0 0,
                 0 1 0 0 0 0 0 0,
                 0 1 0 0 0 0 0 0,
                 0 0 0 0 0 0 0 1,
                 0 0 0 0 0 0 0 1,
                 0 0 0 0 0 0 0 1,
                 0 0 0 0 0 0 0 1,
                 0 0 0 0 0 0 0 1,
                 0 1 0 0 0 0 0 0,
                 0 1 0 0 0 0 0 0,
                 0 1 0 0 0 0 0 0,
                 0 1 0 0 0 0 0 0,
                 0 1 0 0 0 0 0 0,
                 0 0 0 0 0 0 0 1,
                 0 0 0 0 0 0 0 1,
                 0 0 0 0 0 0 0 1,
                 0 0 0 0 0 0 0 1,
                 0 0 0 0 0 0 0 1];
             
Genotype_serv = [1 0 0 0 0 0 0 0,
                 1 0 0 0 0 0 0 0,
                 1 0 0 0 0 0 0 0,
                 1 0 0 0 0 0 0 0,
                 1 0 0 0 0 0 0 0,
                 0 0 0 0 0 0 0 1,
                 0 0 0 0 0 0 0 1,
                 0 0 0 0 0 0 0 1,
                 0 0 0 0 0 0 0 1,
                 0 0 0 0 0 0 0 1,
                 1 0 0 0 0 0 0 0,
                 1 0 0 0 0 0 0 0,
                 1 0 0 0 0 0 0 0,
                 1 0 0 0 0 0 0 0,
                 1 0 0 0 0 0 0 0,
                 0 0 0 0 0 0 0 1,
                 0 0 0 0 0 0 0 1,
                 0 0 0 0 0 0 0 1,
                 0 0 0 0 0 0 0 1,
                 0 0 0 0 0 0 0 1];
             
Genotype_os = [1 0,
               1 0,
               1 0,
               1 0,
               1 0,
               0 1,
               0 1,
               0 1,
               0 1,
               0 1,
               1 0,
               1 0,
               1 0,
               1 0,
               1 0,
               0 1,
               0 1,
               0 1,
               0 1,
               0 1];
           
 Genotype_dr = [1 0 0 0 0 0 0 0,
                1 0 0 0 0 0 0 0,
                1 0 0 0 0 0 0 0,
                1 0 0 0 0 0 0 0,
                1 0 0 0 0 0 0 0,
                0 0 0 0 0 0 0 1,
                0 0 0 0 0 0 0 1,
                0 0 0 0 0 0 0 1,
                0 0 0 0 0 0 0 1,
                0 0 0 0 0 0 0 1,
                1 0 0 0 0 0 0 0,
                1 0 0 0 0 0 0 0,
                1 0 0 0 0 0 0 0,
                1 0 0 0 0 0 0 0,
                1 0 0 0 0 0 0 0,
                0 0 0 0 0 0 0 1,
                0 0 0 0 0 0 0 1,
                0 0 0 0 0 0 0 1,
                0 0 0 0 0 0 0 1,
                0 0 0 0 0 0 0 1];

%efficiency/quality ratings of software (1 to 100) 
%(1)inefficient (100)maximum efficiency
E_apps = [65 75 55 50 60 60 60 80];
E_serv = [65 66 67 63 59 62 72 77];
E_os = [70 80];
E_dr = [70 80 60 75 69 68 63 58];


%community desirability ratings (1 to 100) (1)least desirable (100)most
%desirable
CD_apps = [82 2 2 2 3 3 3 3];
sum(CD_apps);
CD_serv = [82 2 2 2 3 3 3 3];
sum(CD_serv);
CD_os = [88 12];
sum(CD_os);
CD_dr = [82 2 2 2 3 3 3 3];
sum(CD_dr);
%for change over
CD_apps2 = [5 40 10 5 10 5 23 2];
sum(CD_apps2);
CD_serv2 = [50 5 3 2 5 5 25 5];
sum(CD_serv2);
CD_os2 = [60 40];
sum(CD_os2);
CD_dr2 = [30 20 5 5 30 5 3 2];
sum(CD_dr2);

%individual desirability ratings (1 to 100) (1)least desirable (100)most
%desirable
%MUST NOT HAVE ANY ZERO VALUES!
%do for 10 individuals
ID_apps = [25 40 10 5 10 5 3 2,
           20 68 1 1  5 2 2 1,
           68 20 1 1 5 2 2 1,
           39 48 5 4 1 1 1 1,
           5 10 3 2 50 15 13 2,
           1 1 4 4 48 19 22 1,
           10 15 10 15 10 10 10 20,
           20 35 3 2 10 10 5 15,
           58 10 1 1 5 4 1 20,
           10 15 10 15 10 10 10 20,
           25 40 10 5 10 5 3 2,
           20 68 1 1  5 2 2 1,
           68 20 1 1 5 2 2 1,
           39 48 5 4 1 1 1 1,
           5 10 3 2 50 15 13 2,
           1 1 4 4 48 19 22 1,
           10 15 10 15 10 10 10 20,
           20 35 3 2 10 10 5 15,
           58 10 1 1 5 4 1 20,
           10 15 10 15 10 10 10 20];  
            
ID_serv = [70 5 3 2 5 5 5 5,
           80 5 3 2 2 3 2 3,
           70 15 3 2 2 3 3 2,
           68 17 3 8 1 1 1 1,
           5 8 2 5 13 17 20 30,
           1 2 2 5 13 27 20 30,
           12 13 12 13 12 12 12 14,
           12 23 12 13 12 12 2 14,
           12 33 12 13 12 2 2 14,
           12 13 12 13 12 12 12 14,
           70 5 3 2 5 5 5 5,
           80 5 3 2 2 3 2 3,
           70 15 3 2 2 3 3 2,
           68 17 3 8 1 1 1 1,
           5 8 2 5 13 17 20 30,
           1 2 2 5 13 27 20 30,
           12 13 12 13 12 12 12 14,
           12 23 12 13 12 12 2 14,
           12 33 12 13 12 2 2 14,
           12 13 12 13 12 12 12 14] ;      
                          
ID_os = [80 20,
         90 10,
         90 10,
         96 4,
         20 80,
         10 90,
         50 50,
         60 40,
         70 30,
         50 50,
         80 20,
         90 10,
         90 10,
         96 4,
         20 80,
         10 90,
         50 50,
         60 40,
         70 30,
         50 50] ;   
     
ID_dr = [50 20 5 5 10 5 3 2,
         20 50 10 10 4 3 1 2,
         20 50 10 10 4 3 1 2,
         1 86 5 4 1 1 1 1,
         1 2 1 16 20 20 20 20,
         1 2 1 6 20 20 20 30 ,
         10 15 5 20 10 15 10 15,
         10 25 15 10 10 10 10 10,           
         10 35 15 10 5 10 5 10,
         10 15 5 20 13 13 12 12,
         50 20 5 5 10 5 3 2,
         20 50 10 10 4 3 1 2,
         20 50 10 10 4 3 1 2,
         1 86 5 4 1 1 1 1,
         1 2 1 16 20 20 20 20,
         1 2 1 6 20 20 20 30 ,
         10 15 5 20 10 15 10 15,
         10 25 15 10 10 10 10 10,           
         10 35 15 10 5 10 5 10,
         10 15 5 20 13 13 12 12];
     
          E_apps2 = E_apps;
E_serv2 = E_serv;
E_os2 = E_os;
E_dr2 = E_dr;     
ID_apps2 = ID_apps;
ID_serv2 = ID_serv;
ID_os2 = ID_os;
ID_dr2 = ID_dr;
     
     %INDIVIDUAL TIME ARRAY OF CHANGES TO PERSONAL INDIVIDUAL DESIRABILITIES
%needs to be set here because numNodes is different for each case
numNodes = 20;
IDtimeArray1 = zeros(1,numNodes);
IDtimeArray2 = zeros(1,numNodes);
         case 21

% set up data - Dataset 15 - same as 1 but with orig of 0.5 and 400 nodes
%%%%%%%%%%%%%
%software strings
%WebBrowser1,6 - commercial products, WebBrowser2,3,4,5 third party
SW_str_apps = ['WebBrowser1v1 ' 'WebBrowser1v2 ' 'WebBrowser2v1 ' 'WebBrowser3v1 ' 'WebBrowser4v1 ' 'WebBrowser5v1 ' 'WebBrowser6v1 ' 'WebBrowser6v4 '];
%All photo viewers about same standard with number 7 slightly better
SW_str_serv = ['PhotoViewer1 ' 'PhotoViewer2 ' 'PhotoViewer3 ' 'PhotoViewer4 ' 'PhotoViewer5 ' 'PhotoViewer6 ' 'PhotoViewer7v1 ' 'PhotoViewer7v2 '];
%OS2 slightly more efficient overall than OS1
SW_str_os = ['OS1 ' 'OS2 '];
%higher versions are better than lower number versions, the commercial
%products are more efficient than the freebies 3rd party
SW_str_dr = ['DataDr1v1 ' 'DataDr1v2 ' 'DataDr2v1 ' 'DataDr3v3 ' 'DataDr4 ' 'DataDr5 ' 'DataDr6 ' 'DataDr7 '];

%software frequency info for running the frequency and nei diversity index
%algorithm
%locusApps - 'a' represents major variants, 'V' represents a minor version
%locusServ - 's' represents major variants, 'V' represents a minor version
%locusOS  - 'o' represents major variants, 'V' represents a minor version
SW_freq_apps = ['a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'];
SW_freq_serv = ['s', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'];
SW_freq_os = ['o', 'V'; 'o', 'V'];
SW_freq_dr = ['d', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'];

%compatability of software
CSW_str_apps = ['a'; 'a'; 'a' ;'a'; 'b'; 'b'; 'b'; 'b'];
CSW_str_serv = ['a'; 'a'; 'a'; 'a'; 'b'; 'b'; 'b'; 'b'];
CSW_str_os = ['a'; 'b'];
CSW_str_dr = ['a'; 'a'; 'a'; 'a'; 'b' ;'b'; 'b'; 'b'];
CSW = [CSW_str_apps; CSW_str_serv; CSW_str_os; CSW_str_dr];
%create two filters
CSW1 = zeros(size(CSW));
CSW2 = zeros(size(CSW));
CSW3 = zeros(size(CSW));
CSW4 = zeros(size(CSW));
CSW5 = zeros(size(CSW));
CSW6 = zeros(size(CSW));
CSW7 = zeros(size(CSW));
CSW8 = zeros(size(CSW));
CSW9 = zeros(size(CSW));
CSW10 = zeros(size(CSW));
for z = 1:size(CSW)
  if CSW(z) ==  'a'
      CSW1(z) = 1;
  end;
  if CSW(z) ==  'b'
      CSW2(z) = 1;
  end;
end; %end for z
CSW1 = CSW1';
CSW2 = CSW2';
CSW3 = CSW3';
CSW4 = CSW4';
CSW5 = CSW5';
CSW6 = CSW6';
CSW7 = CSW7';
CSW8 = CSW8';
CSW9 = CSW9';
CSW10 = CSW10';
CSWGroup(1,:) = CSW1;
CSWGroup(2,:) = CSW2;


% set up genotypes for each of the 400 nodes
Genotype_apps = zeros(400,8);
Genotype_apps(1:200,2)=1;
Genotype_apps(201:400,8)=1;

Genotype_serv = zeros(400,8);
Genotype_serv(1:200,1)=1;
Genotype_serv(201:400,8)=1;
             
Genotype_os = zeros(400,2);
Genotype_os(1:200,1)=1;
Genotype_os(201:400,2)=1;

Genotype_dr = zeros(400,8);
Genotype_dr(1:200,1)=1;
Genotype_dr(201:400,8)=1;           

%efficiency/quality ratings of software (1 to 100) 
%(1)inefficient (100)maximum efficiency
E_apps = [65 75 55 50 60 60 60 80];
E_serv = [65 66 67 63 59 62 72 77];
E_os = [20 80];
E_dr = [70 80 60 75 69 68 63 58];

%community desirability ratings (1 to 100) (1)least desirable (100)most
%desirable
CD_apps = [82 2 2 2 3 3 3 3];
sum(CD_apps);
CD_serv = [82 2 2 2 3 3 3 3];
sum(CD_serv);
CD_os = [86 14];
sum(CD_os);
CD_dr = [82 2 2 2 3 3 3 3];
sum(CD_dr);
%for change over
CD_apps2 = [5 40 10 5 10 5 23 2];
sum(CD_apps2);
CD_serv2 = [50 5 3 2 5 5 25 5];
sum(CD_serv2);
CD_os2 = [60 40];
sum(CD_os2);
CD_dr2 = [30 20 5 5 30 5 3 2];
sum(CD_dr2);

%individual desirability ratings (1 to 100) (1)least desirable (100)most
%desirable
%MUST NOT HAVE ANY ZERO VALUES!
%do for 10 individuals
ID_apps10 = [25 40 10 5 10 5 3 2,
           20 68 1 1  5 2 2 1,
           68 20 1 1 5 2 2 1,
           39 48 5 4 1 1 1 1,
           5 10 3 2 50 15 13 2,
           1 1 4 4 48 19 22 1,
           10 15 10 15 10 10 10 20,
           20 35 3 2 10 10 5 15,
           58 10 1 1 5 4 1 20,
           10 15 10 15 10 10 10 20];  
            
ID_serv10 = [70 5 3 2 5 5 5 5,
           80 5 3 2 2 3 2 3,
           70 15 3 2 2 3 3 2,
           68 17 3 8 1 1 1 1,
           5 8 2 5 13 17 20 30,
           1 2 2 5 13 27 20 30,
           12 13 12 13 12 12 12 14,
           12 23 12 13 12 12 2 14,
           12 33 12 13 12 2 2 14,
           12 13 12 13 12 12 12 14] ;      
                          
ID_os10 = [80 20,
         90 10,
         90 10,
         96 4,
         20 80,
         10 90,
         50 50,
         60 40,
         70 30,
         50 50] ;   
     
ID_dr10 = [50 20 5 5 10 5 3 2,
         20 50 10 10 4 3 1 2,
         20 50 10 10 4 3 1 2,
         1 86 5 4 1 1 1 1,
         1 2 1 16 20 20 20 20,
         1 2 1 6 20 20 20 30 ,
         10 15 5 20 10 15 10 15,
         10 25 15 10 10 10 10 10,           
         10 35 15 10 5 10 5 10,
         10 15 5 20 13 13 12 12];
     
ID_apps = zeros(400,8);
ID_apps(1:10,:) = ID_apps10;
ID_apps(11:20,:) = ID_apps10;
ID_apps(21:30,:) = ID_apps10;
ID_apps(31:40,:) = ID_apps10;
ID_apps(41:50,:) = ID_apps10;
ID_apps(51:100,:) = ID_apps(1:50,:);
ID_apps(101:200,:) = ID_apps(1:100,:);
ID_apps(201:400,:) = ID_apps(1:200,:);
             
ID_serv = zeros(400,8);
ID_serv(1:10,:) = ID_serv10;
ID_serv(11:20,:) = ID_serv10;
ID_serv(21:30,:) = ID_serv10;
ID_serv(31:40,:) = ID_serv10;
ID_serv(41:50,:) = ID_serv10;
ID_serv(51:100,:) = ID_serv(1:50,:);
ID_serv(101:200,:) = ID_serv(1:100,:);
ID_serv(201:400,:) = ID_serv(1:200,:);
                           
ID_os = zeros(400,2);
ID_os(1:10,:) = ID_os10;
ID_os(11:20,:) = ID_os10;
ID_os(21:30,:) = ID_os10;
ID_os(31:40,:) = ID_os10;
ID_os(41:50,:) = ID_os10;
ID_os(51:100,:) = ID_os(1:50,:);
ID_os(101:200,:) = ID_os(1:100,:);
ID_os(201:400,:) = ID_os(1:200,:);
     
ID_dr = zeros(400,8);
ID_dr(1:10,:) = ID_dr10;
ID_dr(11:20,:) = ID_dr10;
ID_dr(21:30,:) = ID_dr10;
ID_dr(31:40,:) = ID_dr10;
ID_dr(41:50,:) = ID_dr10;
ID_dr(51:100,:) = ID_dr(1:50,:);
ID_dr(101:200,:) = ID_dr(1:100,:);
ID_dr(201:400,:) = ID_dr(1:200,:);

     E_apps2 = E_apps;
E_serv2 = E_serv;
E_os2 = E_os;
E_dr2 = E_dr;     
ID_apps2 = ID_apps;
ID_serv2 = ID_serv;
ID_os2 = ID_os;
ID_dr2 = ID_dr;

%INDIVIDUAL TIME ARRAY OF CHANGES TO PERSONAL INDIVIDUAL DESIRABILITIES
%needs to be set here because numNodes is different for each case
numNodes = 400;
IDtimeArray1 = zeros(1,numNodes);
IDtimeArray2 = zeros(1,numNodes);

    case 22
numNodes = 1000
% set up data - Dataset 16 - same as 1 but with orig of 0.5 and 1000 nodes
%%%%%%%%%%%%%
%software strings
%WebBrowser1,6 - commercial products, WebBrowser2,3,4,5 third party
SW_str_apps = ['WebBrowser1v1 ' 'WebBrowser1v2 ' 'WebBrowser2v1 ' 'WebBrowser3v1 ' 'WebBrowser4v1 ' 'WebBrowser5v1 ' 'WebBrowser6v1 ' 'WebBrowser6v4 '];
%All photo viewers about same standard with number 7 slightly better
SW_str_serv = ['PhotoViewer1 ' 'PhotoViewer2 ' 'PhotoViewer3 ' 'PhotoViewer4 ' 'PhotoViewer5 ' 'PhotoViewer6 ' 'PhotoViewer7v1 ' 'PhotoViewer7v2 '];
%OS2 slightly more efficient overall than OS1
SW_str_os = ['OS1 ' 'OS2 '];
%higher versions are better than lower number versions, the commercial
%products are more efficient than the freebies 3rd party
SW_str_dr = ['DataDr1v1 ' 'DataDr1v2 ' 'DataDr2v1 ' 'DataDr3v3 ' 'DataDr4 ' 'DataDr5 ' 'DataDr6 ' 'DataDr7 '];

%software frequency info for running the frequency and nei diversity index
%algorithm
%locusApps - 'a' represents major variants, 'V' represents a minor version
%locusServ - 's' represents major variants, 'V' represents a minor version
%locusOS  - 'o' represents major variants, 'V' represents a minor version
SW_freq_apps = ['a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'];
SW_freq_serv = ['s', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'];
SW_freq_os = ['o', 'V'; 'o', 'V'];
SW_freq_dr = ['d', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'];

%compatability of software
CSW_str_apps = ['a'; 'a'; 'a' ;'a'; 'b'; 'b'; 'b'; 'b'];
CSW_str_serv = ['a'; 'a'; 'a'; 'a'; 'b'; 'b'; 'b'; 'b'];
CSW_str_os = ['a'; 'b'];
CSW_str_dr = ['a'; 'a'; 'a'; 'a'; 'b' ;'b'; 'b'; 'b'];
CSW = [CSW_str_apps; CSW_str_serv; CSW_str_os; CSW_str_dr];
%create two filters
CSW1 = zeros(size(CSW));
CSW2 = zeros(size(CSW));
CSW3 = zeros(size(CSW));
CSW4 = zeros(size(CSW));
CSW5 = zeros(size(CSW));
CSW6 = zeros(size(CSW));
CSW7 = zeros(size(CSW));
CSW8 = zeros(size(CSW));
CSW9 = zeros(size(CSW));
CSW10 = zeros(size(CSW));
for z = 1:size(CSW)
  if CSW(z) ==  'a'
      CSW1(z) = 1;
  end;
  if CSW(z) ==  'b'
      CSW2(z) = 1;
  end;
end; %end for z
CSW1 = CSW1';
CSW2 = CSW2';
CSW3 = CSW3';
CSW4 = CSW4';
CSW5 = CSW5';
CSW6 = CSW6';
CSW7 = CSW7';
CSW8 = CSW8';
CSW9 = CSW9';
CSW10 = CSW10';
CSWGroup(1,:) = CSW1;
CSWGroup(2,:) = CSW2;


% set up genotypes for each of the 400 nodes
Genotype_apps = zeros(1000,8);
Genotype_apps(1:500,2)=1;
Genotype_apps(501:1000,8)=1;

Genotype_serv = zeros(1000,8);
Genotype_serv(1:500,1)=1;
Genotype_serv(501:1000,8)=1;
             
Genotype_os = zeros(1000,2);
Genotype_os(1:500,1)=1;
Genotype_os(501:1000,2)=1;

Genotype_dr = zeros(1000,8);
Genotype_dr(1:500,1)=1;
Genotype_dr(501:1000,8)=1;           

%efficiency/quality ratings of software (1 to 100) 
%(1)inefficient (100)maximum efficiency
E_apps = [65 75 55 50 60 60 60 80];
E_serv = [65 66 67 63 59 62 72 77];
E_os = [20 80];
E_dr = [70 80 60 75 69 68 63 58];
%for change over
E_apps2 = [1 1 1 50 60 60 60 80];
E_serv2 = [1 1 1 63 59 62 72 77];
E_os2 = [1 85];
E_dr2 = [1 1 1 75 69 68 63 58];

%community desirability ratings (1 to 100) (1)least desirable (100)most
%desirable
CD_apps = [82 2 2 2 3 3 3 3];
sum(CD_apps);
CD_serv = [82 2 2 2 3 3 3 3];
sum(CD_serv);
CD_os = [88 12];
sum(CD_os);
CD_dr = [82 2 2 2 3 3 3 3];
sum(CD_dr);
%for change over
CD_apps2 = [5 40 10 5 10 5 23 2];
sum(CD_apps2);
CD_serv2 = [50 5 3 2 5 5 25 5];
sum(CD_serv2);
CD_os2 = [60 40];
sum(CD_os2);
CD_dr2 = [30 20 5 5 30 5 3 2];
sum(CD_dr2);

%individual desirability ratings (1 to 100) (1)least desirable (100)most
%desirable
%MUST NOT HAVE ANY ZERO VALUES!
%do for 10 individuals
ID_apps10 = [25 40 10 5 10 5 3 2,
           20 68 1 1  5 2 2 1,
           68 20 1 1 5 2 2 1,
           39 48 5 4 1 1 1 1,
           5 10 3 2 50 15 13 2,
           1 1 4 4 48 19 22 1,
           10 15 10 15 10 10 10 20,
           20 35 3 2 10 10 5 15,
           58 10 1 1 5 4 1 20,
           10 15 10 15 10 10 10 20];  
            
ID_serv10 = [70 5 3 2 5 5 5 5,
           80 5 3 2 2 3 2 3,
           70 15 3 2 2 3 3 2,
           68 17 3 8 1 1 1 1,
           5 8 2 5 13 17 20 30,
           1 2 2 5 13 27 20 30,
           12 13 12 13 12 12 12 14,
           12 23 12 13 12 12 2 14,
           12 33 12 13 12 2 2 14,
           12 13 12 13 12 12 12 14] ;      
                          
ID_os10 = [80 20,
         90 10,
         90 10,
         96 4,
         20 80,
         10 90,
         50 50,
         60 40,
         70 30,
         50 50] ;   
     
ID_dr10 = [50 20 5 5 10 5 3 2,
         20 50 10 10 4 3 1 2,
         20 50 10 10 4 3 1 2,
         1 86 5 4 1 1 1 1,
         1 2 1 16 20 20 20 20,
         1 2 1 6 20 20 20 30 ,
         10 15 5 20 10 15 10 15,
         10 25 15 10 10 10 10 10,           
         10 35 15 10 5 10 5 10,
         10 15 5 20 13 13 12 12];
     
ID_apps = zeros(1000,8);
ID_apps(1:10,:) = ID_apps10;
ID_apps(11:20,:) = ID_apps10;
ID_apps(21:30,:) = ID_apps10;
ID_apps(31:40,:) = ID_apps10;
ID_apps(41:50,:) = ID_apps10;
ID_apps(51:100,:) = ID_apps(1:50,:);
ID_apps(101:200,:) = ID_apps(1:100,:);
ID_apps(201:400,:) = ID_apps(1:200,:);
ID_apps(401:800,:) = ID_apps(1:400,:);
ID_apps(801:1000,:) = ID_apps(1:200,:);
            
ID_serv = zeros(1000,8);
ID_serv(1:10,:) = ID_serv10;
ID_serv(11:20,:) = ID_serv10;
ID_serv(21:30,:) = ID_serv10;
ID_serv(31:40,:) = ID_serv10;
ID_serv(41:50,:) = ID_serv10;
ID_serv(51:100,:) = ID_serv(1:50,:);
ID_serv(101:200,:) = ID_serv(1:100,:);
ID_serv(201:400,:) = ID_serv(1:200,:);
ID_serv(401:800,:) = ID_serv(1:400,:);
ID_serv(801:1000,:) = ID_serv(1:200,:);
                          
ID_os = zeros(1000,2);
ID_os(1:10,:) = ID_os10;
ID_os(11:20,:) = ID_os10;
ID_os(21:30,:) = ID_os10;
ID_os(31:40,:) = ID_os10;
ID_os(41:50,:) = ID_os10;
ID_os(51:100,:) = ID_os(1:50,:);
ID_os(101:200,:) = ID_os(1:100,:);
ID_os(201:400,:) = ID_os(1:200,:);
ID_os(401:800,:) = ID_os(1:400,:);
ID_os(801:1000,:) = ID_os(1:200,:);
     
ID_dr = zeros(1000,8);
ID_dr(1:10,:) = ID_dr10;
ID_dr(11:20,:) = ID_dr10;
ID_dr(21:30,:) = ID_dr10;
ID_dr(31:40,:) = ID_dr10;
ID_dr(41:50,:) = ID_dr10;
ID_dr(51:100,:) = ID_dr(1:50,:);
ID_dr(101:200,:) = ID_dr(1:100,:);
ID_dr(201:400,:) = ID_dr(1:200,:);
ID_dr(401:800,:) = ID_dr(1:400,:);
ID_dr(801:1000,:) = ID_dr(1:200,:);

     ID_apps2 = ID_apps;
     ID_os2 = ID_os;
     ID_dr2 = ID_dr;
ID_serv2 = ID_serv;

    %INDIVIDUAL TIME ARRAY OF CHANGES TO PERSONAL INDIVIDUAL DESIRABILITIES
IDtimeArray1 = zeros(1,numNodes);
IDtimeArray2 = zeros(1,numNodes);


    case 23
%%%%%%%%%%%%%
% set up data - Dataset 22 - 100 nodes
%%%%%%%%%%%%%
%software strings
%WebBrowser1,6 - commercial products, WebBrowser2,3,4,5 third party
SW_str_apps = ['WebBrowser1v1 ' 'WebBrowser1v2 ' 'WebBrowser2v1 ' 'WebBrowser3v1 ' 'WebBrowser4v1 ' 'WebBrowser5v1 ' 'WebBrowser6v1 ' 'WebBrowser6v4 ' 'WebBrowser7v1 ' 'WebBrowser7v3 ''WebBrowser8v1 ' 'WebBrowser8v2 ' 'WebBrowser8v3 ' 'WebBrowser9v1 ' 'WebBrowser10v1 ' 'WebBrowser11v1 ' 'WebBrowser12v1 ' 'WebBrowser13v4 ' 'WebBrowser14v1 ' 'WebBrowser15v3 '];
%All photo viewers about same standard with number 7 slightly better
SW_str_serv = ['PhotoViewer1 ' 'PhotoViewer2 ' 'PhotoViewer3 ' 'PhotoViewer4 ' 'PhotoViewer5 ' 'PhotoViewer6 ' 'PhotoViewer7v1 ' 'PhotoViewer7v2 ' 'PhotoViewer8 ' 'Photoviewer9 ' 'PhotoViewer1 ' 'PhotoViewer2 ' 'PhotoViewer3 ' 'PhotoViewer4 ' 'PhotoViewer5 ' 'PhotoViewer6 ' 'PhotoViewer7v1 ' 'PhotoViewer7v2 ' 'PhotoViewer8 ' 'Photoviewer9 '];
%OS2 slightly more efficient overall than OS1
SW_str_os = ['OS1 ' 'OS2 ' 'OS3 ' 'OS4 ' 'OS5' 'OS6' 'OS7' 'OS8' 'OS9' 'OS10'];
%higher versions are better than lower number versions, the commercial
%products are more efficient than the freebies 3rd party
SW_str_dr = ['DataDr1v1 ' 'DataDr1v2 ' 'DataDr2v1 ' 'DataDr3v3 ' 'DataDr4 ' 'DataDr5 ' 'DataDr6 ' 'DataDr7 ' 'DataDr9 ' 'DataDr8 ' 'DataDr1v1 ' 'DataDr1v2 ' 'DataDr2v1 ' 'DataDr3v3 ' 'DataDr4 ' 'DataDr5 ' 'DataDr6 ' 'DataDr7 ' 'DataDr9 ' 'DataDr8 '];

%software frequency info for running the frequency and nei diversity index
%algorithm
%locusApps - 'a' represents major variants, 'V' represents a minor version
%locusServ - 's' represents major variants, 'V' represents a minor version
%locusOS  - 'o' represents major variants, 'V' represents a minor version
SW_freq_apps = ['a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V';'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'];
SW_freq_serv = ['s', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'];
SW_freq_os = ['o', 'V'; 'o', 'V'; 'o', 'V'; 'o', 'V';'o', 'V'; 'o', 'V'; 'o', 'V'; 'o', 'V';'o', 'V'; 'o', 'V'];
SW_freq_dr = ['d', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'];

%compatability of software
CSW_str_apps = ['a'; 'b'; 'c' ;'d'; 'e'; 'f'; 'g'; 'h'; 'i'; 'j'; 'a'; 'b'; 'c' ;'d'; 'e'; 'f'; 'g'; 'h'; 'i'; 'j'];
CSW_str_serv = ['a'; 'b'; 'c'; 'd'; 'e'; 'f'; 'g'; 'h'; 'i'; 'j'; 'a'; 'b'; 'c'; 'd'; 'e'; 'f'; 'g'; 'h'; 'i'; 'j'];
CSW_str_os = ['a'; 'b'; 'c'; 'd'; 'e'; 'f'; 'g'; 'h'; 'i'; 'j'];
CSW_str_dr = ['a'; 'b'; 'c'; 'd'; 'e' ;'f'; 'g'; 'h'; 'i'; 'j'; 'a'; 'b'; 'c'; 'd'; 'e'; 'f'; 'g'; 'h'; 'i'; 'j'];
CSW = [CSW_str_apps; CSW_str_serv; CSW_str_os; CSW_str_dr];
%create filters
CSW1 = zeros(size(CSW));
CSW2 = zeros(size(CSW));
CSW3 = zeros(size(CSW));
CSW4 = zeros(size(CSW));
CSW5 = zeros(size(CSW));
CSW6 = zeros(size(CSW));
CSW7 = zeros(size(CSW));
CSW8 = zeros(size(CSW));
CSW9 = zeros(size(CSW));
CSW10 = zeros(size(CSW));
for z = 1:size(CSW)
  if CSW(z) ==  'a'
      CSW1(z) = 1;
  end;
  if CSW(z) ==  'b'
      CSW2(z) = 1;
  end;
 if CSW(z) ==  'c'
      CSW3(z) = 1;
  end;
 if CSW(z) ==  'd'
      CSW4(z) = 1;
  end;
  if CSW(z) ==  'e'
      CSW5(z) = 1;
  end;
  if CSW(z) ==  'f'
      CSW6(z) = 1;
  end;
 if CSW(z) ==  'g'
      CSW7(z) = 1;
  end;
 if CSW(z) ==  'h'
      CSW8(z) = 1;
  end;  
  if CSW(z) ==  'i'
      CSW9(z) = 1;
  end;
  if CSW(z) ==  'j'
      CSW10(z) = 1;
  end;

end; %end for z
CSW1 = CSW1';
CSW2 = CSW2';
CSW3 = CSW3';
CSW4 = CSW4';
CSW5 = CSW5';
CSW6 = CSW6';
CSW7 = CSW7';
CSW8 = CSW8';
CSW9 = CSW9';
CSW10 = CSW10';
CSWGroup(1,:) = CSW1;
CSWGroup(2,:) = CSW2;
CSWGroup(3,:) = CSW3;
CSWGroup(4,:) = CSW4;
CSWGroup(5,:) = CSW5;
CSWGroup(6,:) = CSW6;
CSWGroup(7,:) = CSW7;
CSWGroup(8,:) = CSW8;
CSWGroup(9,:) = CSW9;
CSWGroup(10,:) = CSW10;

Genotype_apps = zeros(100,20);
Genotype_apps(1:50,1)=1;
Genotype_apps(51:100,5)=1;

Genotype_serv = zeros(100,20);
Genotype_serv(1:50,1)=1;
Genotype_serv(51:100,5)=1;
             
Genotype_os = zeros(100,10);
Genotype_os(1:50,1)=1;
Genotype_os(51:100,5)=1;

Genotype_dr = zeros(100,20);
Genotype_dr(1:50,1)=1;
Genotype_dr(51:100,5)=1;          
            
%efficiency/quality ratings of software (1 to 100) 
%(1)inefficient (100)maximum efficiency
%E_apps = [65 75 55 50 60 60 60 80 20 20 65 75 55 50 60 60 60 80 20 20];
%E_serv = [65 66 67 63 59 62 72 77 50 50 65 75 55 50 60 60 60 80 20 20];
%E_os = [50 50 50 50 50 50 50 50 50 50];
%E_dr = [70 80 60 75 69 68 63 58 65 65 65 75 55 50 60 60 60 80 20 20];

E_apps = [1 75 55 5 1 1 5 80 20 20 10 75 10 5 5 5 60 80 5 5];
E_serv = [65 1 67 5 1 62 72 77 50 50 65 75 5 5 5 5 5 80 20 20];
E_os = [70 30 1 10 1 50 2 5 5 5];
E_dr = [70 80 1 75 15 68 20 58 1 1 1 5 5 8 5 1 60 2 20 20];

%community desirability ratings (1 to 100) (1)least desirable (100)most
%desirable
%desirability 1
CD_apps = [81 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1];
sum(CD_apps);
CD_serv = [81 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1];
sum(CD_serv);
CD_os = [82 2 2 2 2 2 2 2 2 2];
sum(CD_os);
CD_dr = [81 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1];
sum(CD_dr);
%desirability 2 when wish to change CHECK NUMBERS ADD UP CORRECTLY
CD_apps2 = [15 8 1 1 1 1 1 1 1 1 55 6 1 1 1 1 1 1 1 1];
sum(CD_apps2)
CD_serv2 = [60 5 1 1 1 1 1 1 1 1 10 9 1 1 1 1 1 1 1 1];
sum(CD_serv2)
CD_os2 = [70 14 2 2 2 2 2 2 2 2];
sum(CD_os2)
CD_dr2 = [40 10 1 1 1 1 1 1 1 1 30 4 1 1 1 1 1 1 1 1];
sum(CD_dr2)
            
%individual desirability ratings (1 to 100) (1)least desirable (100)most
%desirable
%do for 10 individuals

ID_apps20 = [22 12 4 5 1 1 1 1 1 1 28 10 4 3 1 1 1 1 1 1,
           18 6 2 2 1 1 1 1 1 1 52 2 3 3 1 1 1 1 1 1,
           18 6 2 2 1 1 1 1 1 1 52 2 3 3 1 1 1 1 1 1,
           40 1 1 1 1 1 1 1 1 1 42 1 1 1 1 1 1 1 1 1,
           5 50 3 2 1 1 1 1 1 1 10 8 2 8 1 1 1 1 1 1,
           1 1 5 5 1 1 1 1 1 1 1 4 4 43 25 1 1 1 1 1,
           10 15 10 11 1 1 1 1 1 1 14 9 10 9 1 1 1 1 1 1,
           15 20 3 1 1 1 1 1 1 1 25 6 17 1 1 1 1 1 1 1,
           14 1 54 1 1 1 1 1 1 1 10 1 6 1 1 1 1 1 1 1,
           10 10 10 10 1 1 1 1 1 1 14 14 10 10 1 1 1 1 1 1,
           22 12 4 5 1 1 1 1 1 1 28 10 4 3 1 1 1 1 1 1,
           18 6 2 2 1 1 1 1 1 1 52 2 3 3 1 1 1 1 1 1,
           18 6 2 2 1 1 1 1 1 1 52 2 3 3 1 1 1 1 1 1,
           40 1 1 1 1 1 1 1 1 1 42 1 1 1 1 1 1 1 1 1,
           5 50 3 2 1 1 1 1 1 1 10 8 2 8 1 1 1 1 1 1,
           1 1 5 5 1 1 1 1 1 1 1 4 4 43 25 1 1 1 1 1,
           10 15 10 11 1 1 1 1 1 1 14 9 10 9 1 1 1 1 1 1,
           15 20 3 1 1 1 1 1 1 1 25 6 17 1 1 1 1 1 1 1,
           14 1 54 1 1 1 1 1 1 1 10 1 6 1 1 1 1 1 1 1,
           10 10 10 10 1 1 1 1 1 1 14 14 10 10 1 1 1 1 1 1];  
            
ID_serv20 = [22 12 4 5 1 1 1 1 1 1 28 10 4 3 1 1 1 1 1 1,
           18 6 2 2 1 1 1 1 1 1 52 2 3 3 1 1 1 1 1 1,
           18 6 2 2 1 1 1 1 1 1 52 2 3 3 1 1 1 1 1 1,
           40 1 1 1 1 1 1 1 1 1 42 1 1 1 1 1 1 1 1 1,
           5 50 3 2 1 1 1 1 1 1 10 8 2 8 1 1 1 1 1 1,
           1 1 5 5 1 1 1 1 1 1 1 4 4 43 25 1 1 1 1 1,
           10 15 10 11 1 1 1 1 1 1 14 9 10 9 1 1 1 1 1 1,
           15 20 3 1 1 1 1 1 1 1 25 6 17 1 1 1 1 1 1 1,
           14 1 54 1 1 1 1 1 1 1 10 1 6 1 1 1 1 1 1 1,
           10 10 10 10 1 1 1 1 1 1 14 14 10 10 1 1 1 1 1 1,
           22 12 4 5 1 1 1 1 1 1 28 10 4 3 1 1 1 1 1 1,
           18 6 2 2 1 1 1 1 1 1 52 2 3 3 1 1 1 1 1 1,
           18 6 2 2 1 1 1 1 1 1 52 2 3 3 1 1 1 1 1 1,
           40 1 1 1 1 1 1 1 1 1 42 1 1 1 1 1 1 1 1 1,
           5 50 3 2 1 1 1 1 1 1 10 8 2 8 1 1 1 1 1 1,
           1 1 5 5 1 1 1 1 1 1 1 4 4 43 25 1 1 1 1 1,
           10 15 10 11 1 1 1 1 1 1 14 9 10 9 1 1 1 1 1 1,
           15 20 3 1 1 1 1 1 1 1 25 6 17 1 1 1 1 1 1 1,
           14 1 54 1 1 1 1 1 1 1 10 1 6 1 1 1 1 1 1 1,
           10 10 10 10 1 1 1 1 1 1 14 14 10 10 1 1 1 1 1 1];       
                          
ID_os20 = [50 22 8 8 2 2 2 2 2 2,
         70 8 5 5 2 2 2 2 2 2,
         70 8 5 5 2 2 2 2 2 2,
         82 2 2 2 2 2 2 2 2 2,
         15 58 5 10 2 2 2 2 2 2,
         5 5 48 30 2 2 2 2 2 2,
         24 24 20 20 2 2 2 2 2 2,
         40 26 20 2 2 2 2 2 2 2,
         24 2 60 2 2 2 2 2 2 2,
         24 24 20 20 2 2 2 2 2 2,
         50 22 8 8 2 2 2 2 2 2,
         70 8 5 5 2 2 2 2 2 2,
         70 8 5 5 2 2 2 2 2 2,
         82 2 2 2 2 2 2 2 2 2,
         15 58 5 10 2 2 2 2 2 2,
         5 5 48 30 2 2 2 2 2 2,
         24 24 20 20 2 2 2 2 2 2,
         40 26 20 2 2 2 2 2 2 2,
         24 2 60 2 2 2 2 2 2 2,
         24 24 20 20 2 2 2 2 2 2] ;   
     
ID_dr20 = [22 12 4 5 1 1 1 1 1 1 28 10 4 3 1 1 1 1 1 1,
           18 6 2 2 1 1 1 1 1 1 52 2 3 3 1 1 1 1 1 1,
           18 6 2 2 1 1 1 1 1 1 52 2 3 3 1 1 1 1 1 1,
           40 1 1 1 1 1 1 1 1 1 42 1 1 1 1 1 1 1 1 1,
           5 50 3 2 1 1 1 1 1 1 10 8 2 8 1 1 1 1 1 1,
           1 1 5 5 1 1 1 1 1 1 1 4 4 43 25 1 1 1 1 1,
           10 15 10 11 1 1 1 1 1 1 14 9 10 9 1 1 1 1 1 1,
           15 20 3 1 1 1 1 1 1 1 25 6 17 1 1 1 1 1 1 1,
           14 1 54 1 1 1 1 1 1 1 10 1 6 1 1 1 1 1 1 1,
           10 10 10 10 1 1 1 1 1 1 14 14 10 10 1 1 1 1 1 1,
           22 12 4 5 1 1 1 1 1 1 28 10 4 3 1 1 1 1 1 1,
           18 6 2 2 1 1 1 1 1 1 52 2 3 3 1 1 1 1 1 1,
           18 6 2 2 1 1 1 1 1 1 52 2 3 3 1 1 1 1 1 1,
           40 1 1 1 1 1 1 1 1 1 42 1 1 1 1 1 1 1 1 1,
           5 50 3 2 1 1 1 1 1 1 10 8 2 8 1 1 1 1 1 1,
           1 1 5 5 1 1 1 1 1 1 1 4 4 43 25 1 1 1 1 1,
           10 15 10 11 1 1 1 1 1 1 14 9 10 9 1 1 1 1 1 1,
           15 20 3 1 1 1 1 1 1 1 25 6 17 1 1 1 1 1 1 1,
           14 1 54 1 1 1 1 1 1 1 10 1 6 1 1 1 1 1 1 1,
           10 10 10 10 1 1 1 1 1 1 14 14 10 10 1 1 1 1 1 1]; 
       
ID_apps = zeros(100,20);
ID_apps(1:20,:) = ID_apps20;
ID_apps(21:40,:) = ID_apps20;
ID_apps(41:60,:) = ID_apps20;
ID_apps(61:80,:) = ID_apps20;
ID_apps(81:100,:) = ID_apps20;
            
ID_serv = zeros(100,20);
ID_serv(1:20,:) = ID_serv20;
ID_serv(21:40,:) = ID_serv20;
ID_serv(41:60,:) = ID_serv20;
ID_serv(61:80,:) = ID_serv20;
ID_serv(81:100,:) = ID_serv20;
                          
ID_os = zeros(100,10);
ID_os(1:20,:) = ID_os20;
ID_os(21:40,:) = ID_os20;
ID_os(41:60,:) = ID_os20;
ID_os(61:80,:) = ID_os20;
ID_os(81:100,:) = ID_os20;
     
ID_dr = zeros(100,20);
ID_dr(1:20,:) = ID_dr20;
ID_dr(21:40,:) = ID_dr20;
ID_dr(41:60,:) = ID_dr20;
ID_dr(61:80,:) = ID_dr20;
ID_dr(81:100,:) = ID_dr20;

     E_apps2 = E_apps;
E_serv2 = E_serv;
E_os2 = E_os;
E_dr2 = E_dr;     
ID_apps2 = ID_apps;
ID_serv2 = ID_serv;
ID_os2 = ID_os;
ID_dr2 = ID_dr;

%INDIVIDUAL TIME ARRAY OF CHANGES TO PERSONAL INDIVIDUAL DESIRABILITIES
%needs to be set here because numNodes is different for each case
numNodes = 100;
IDtimeArray1 = zeros(1,numNodes);
IDtimeArray2 = zeros(1,numNodes);

    case 24
%%%%%%%%%%%%%
% set up data - Dataset 12 - 200 nodes
%%%%%%%%%%%%%
%software strings
%WebBrowser1,6 - commercial products, WebBrowser2,3,4,5 third party
SW_str_apps = ['WebBrowser1v1 ' 'WebBrowser1v2 ' 'WebBrowser2v1 ' 'WebBrowser3v1 ' 'WebBrowser4v1 ' 'WebBrowser5v1 ' 'WebBrowser6v1 ' 'WebBrowser6v4 ' 'WebBrowser7v1 ' 'WebBrowser7v3 ''WebBrowser8v1 ' 'WebBrowser8v2 ' 'WebBrowser8v3 ' 'WebBrowser9v1 ' 'WebBrowser10v1 ' 'WebBrowser11v1 ' 'WebBrowser12v1 ' 'WebBrowser13v4 ' 'WebBrowser14v1 ' 'WebBrowser15v3 '];
%All photo viewers about same standard with number 7 slightly better
SW_str_serv = ['PhotoViewer1 ' 'PhotoViewer2 ' 'PhotoViewer3 ' 'PhotoViewer4 ' 'PhotoViewer5 ' 'PhotoViewer6 ' 'PhotoViewer7v1 ' 'PhotoViewer7v2 ' 'PhotoViewer8 ' 'Photoviewer9 ' 'PhotoViewer1 ' 'PhotoViewer2 ' 'PhotoViewer3 ' 'PhotoViewer4 ' 'PhotoViewer5 ' 'PhotoViewer6 ' 'PhotoViewer7v1 ' 'PhotoViewer7v2 ' 'PhotoViewer8 ' 'Photoviewer9 '];
%OS2 slightly more efficient overall than OS1
SW_str_os = ['OS1 ' 'OS2 ' 'OS3 ' 'OS4 ' 'OS5' 'OS6' 'OS7' 'OS8' 'OS9' 'OS10'];
%higher versions are better than lower number versions, the commercial
%products are more efficient than the freebies 3rd party
SW_str_dr = ['DataDr1v1 ' 'DataDr1v2 ' 'DataDr2v1 ' 'DataDr3v3 ' 'DataDr4 ' 'DataDr5 ' 'DataDr6 ' 'DataDr7 ' 'DataDr9 ' 'DataDr8 ' 'DataDr1v1 ' 'DataDr1v2 ' 'DataDr2v1 ' 'DataDr3v3 ' 'DataDr4 ' 'DataDr5 ' 'DataDr6 ' 'DataDr7 ' 'DataDr9 ' 'DataDr8 '];

%software frequency info for running the frequency and nei diversity index
%algorithm
%locusApps - 'a' represents major variants, 'V' represents a minor version
%locusServ - 's' represents major variants, 'V' represents a minor version
%locusOS  - 'o' represents major variants, 'V' represents a minor version
SW_freq_apps = ['a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V';'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'];
SW_freq_serv = ['s', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'];
SW_freq_os = ['o', 'V'; 'o', 'V'; 'o', 'V'; 'o', 'V';'o', 'V'; 'o', 'V'; 'o', 'V'; 'o', 'V';'o', 'V'; 'o', 'V'];
SW_freq_dr = ['d', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'];

%compatability of software
CSW_str_apps = ['a'; 'b'; 'c' ;'d'; 'e'; 'f'; 'g'; 'h'; 'i'; 'j'; 'a'; 'b'; 'c' ;'d'; 'e'; 'f'; 'g'; 'h'; 'i'; 'j'];
CSW_str_serv = ['a'; 'b'; 'c'; 'd'; 'e'; 'f'; 'g'; 'h'; 'i'; 'j'; 'a'; 'b'; 'c'; 'd'; 'e'; 'f'; 'g'; 'h'; 'i'; 'j'];
CSW_str_os = ['a'; 'b'; 'c'; 'd'; 'e'; 'f'; 'g'; 'h'; 'i'; 'j'];
CSW_str_dr = ['a'; 'b'; 'c'; 'd'; 'e' ;'f'; 'g'; 'h'; 'i'; 'j'; 'a'; 'b'; 'c'; 'd'; 'e'; 'f'; 'g'; 'h'; 'i'; 'j'];
CSW = [CSW_str_apps; CSW_str_serv; CSW_str_os; CSW_str_dr];
%create filters
CSW1 = zeros(size(CSW));
CSW2 = zeros(size(CSW));
CSW3 = zeros(size(CSW));
CSW4 = zeros(size(CSW));
CSW5 = zeros(size(CSW));
CSW6 = zeros(size(CSW));
CSW7 = zeros(size(CSW));
CSW8 = zeros(size(CSW));
CSW9 = zeros(size(CSW));
CSW10 = zeros(size(CSW));
for z = 1:size(CSW)
  if CSW(z) ==  'a'
      CSW1(z) = 1;
  end;
  if CSW(z) ==  'b'
      CSW2(z) = 1;
  end;
 if CSW(z) ==  'c'
      CSW3(z) = 1;
  end;
 if CSW(z) ==  'd'
      CSW4(z) = 1;
  end;
  if CSW(z) ==  'e'
      CSW5(z) = 1;
  end;
  if CSW(z) ==  'f'
      CSW6(z) = 1;
  end;
 if CSW(z) ==  'g'
      CSW7(z) = 1;
  end;
 if CSW(z) ==  'h'
      CSW8(z) = 1;
  end;  
  if CSW(z) ==  'i'
      CSW9(z) = 1;
  end;
  if CSW(z) ==  'j'
      CSW10(z) = 1;
  end;

end; %end for z
CSW1 = CSW1';
CSW2 = CSW2';
CSW3 = CSW3';
CSW4 = CSW4';
CSW5 = CSW5';
CSW6 = CSW6';
CSW7 = CSW7';
CSW8 = CSW8';
CSW9 = CSW9';
CSW10 = CSW10';
CSWGroup(1,:) = CSW1;
CSWGroup(2,:) = CSW2;
CSWGroup(3,:) = CSW3;
CSWGroup(4,:) = CSW4;
CSWGroup(5,:) = CSW5;
CSWGroup(6,:) = CSW6;
CSWGroup(7,:) = CSW7;
CSWGroup(8,:) = CSW8;
CSWGroup(9,:) = CSW9;
CSWGroup(10,:) = CSW10;

Genotype_apps = zeros(200,20);
Genotype_apps(1:100,1)=1;
Genotype_apps(101:200,5)=1;

Genotype_serv = zeros(200,20);
Genotype_serv(1:100,1)=1;
Genotype_serv(101:200,5)=1;
             
Genotype_os = zeros(200,10);
Genotype_os(1:100,1)=1;
Genotype_os(101:200,5)=1;

Genotype_dr = zeros(200,20);
Genotype_dr(1:100,1)=1;
Genotype_dr(101:200,5)=1;          
            
%efficiency/quality ratings of software (1 to 100) 
%(1)inefficient (100)maximum efficiency
%E_apps = [65 75 55 50 60 60 60 80 20 20 65 75 55 50 60 60 60 80 20 20];
%E_serv = [65 66 67 63 59 62 72 77 50 50 65 75 55 50 60 60 60 80 20 20];
%E_os = [50 50 50 50 50 50 50 50 50 50];
%E_dr = [70 80 60 75 69 68 63 58 65 65 65 75 55 50 60 60 60 80 20 20];

E_apps = [1 75 55 5 1 1 5 80 20 20 10 75 10 5 5 5 60 80 5 5];
E_serv = [65 1 67 5 1 62 72 77 50 50 65 75 5 5 5 5 5 80 20 20];
E_os = [70 30 1 10 1 50 2 5 5 5];
E_dr = [70 80 1 75 15 68 20 58 1 1 1 5 5 8 5 1 60 2 20 20];


%community desirability ratings (1 to 100) (1)least desirable (100)most
%desirable
%desirability 1
CD_apps = [81 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1];
sum(CD_apps);
CD_serv = [81 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1];
sum(CD_serv);
CD_os = [82 2 2 2 2 2 2 2 2 2];
sum(CD_os);
CD_dr = [81 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1];
sum(CD_dr);
%desirability 2 when wish to change
CD_apps2 = [15 8 1 1 1 1 1 1 1 1 55 6 1 1 1 1 1 1 1 1];
sum(CD_apps2)
CD_serv2 = [60 5 1 1 1 1 1 1 1 1 10 9 1 1 1 1 1 1 1 1];
sum(CD_serv2)
CD_os2 = [70 14 2 2 2 2 2 2 2 2];
sum(CD_os2)
CD_dr2 = [40 10 1 1 1 1 1 1 1 1 30 4 1 1 1 1 1 1 1 1];
sum(CD_dr2)
            
%individual desirability ratings (1 to 100) (1)least desirable (100)most
%desirable
%do for 10 individuals
ID_apps20 = [22 12 4 5 1 1 1 1 1 1 28 10 4 3 1 1 1 1 1 1,
           18 6 2 2 1 1 1 1 1 1 52 2 3 3 1 1 1 1 1 1,
           18 6 2 2 1 1 1 1 1 1 52 2 3 3 1 1 1 1 1 1,
           40 1 1 1 1 1 1 1 1 1 42 1 1 1 1 1 1 1 1 1,
           5 50 3 2 1 1 1 1 1 1 10 8 2 8 1 1 1 1 1 1,
           1 1 5 5 1 1 1 1 1 1 1 4 4 43 25 1 1 1 1 1,
           10 15 10 11 1 1 1 1 1 1 14 9 10 9 1 1 1 1 1 1,
           15 20 3 1 1 1 1 1 1 1 25 6 17 1 1 1 1 1 1 1,
           14 1 54 1 1 1 1 1 1 1 10 1 6 1 1 1 1 1 1 1,
           10 10 10 10 1 1 1 1 1 1 14 14 10 10 1 1 1 1 1 1,
           22 12 4 5 1 1 1 1 1 1 28 10 4 3 1 1 1 1 1 1,
           18 6 2 2 1 1 1 1 1 1 52 2 3 3 1 1 1 1 1 1,
           18 6 2 2 1 1 1 1 1 1 52 2 3 3 1 1 1 1 1 1,
           40 1 1 1 1 1 1 1 1 1 42 1 1 1 1 1 1 1 1 1,
           5 50 3 2 1 1 1 1 1 1 10 8 2 8 1 1 1 1 1 1,
           1 1 5 5 1 1 1 1 1 1 1 4 4 43 25 1 1 1 1 1,
           10 15 10 11 1 1 1 1 1 1 14 9 10 9 1 1 1 1 1 1,
           15 20 3 1 1 1 1 1 1 1 25 6 17 1 1 1 1 1 1 1,
           14 1 54 1 1 1 1 1 1 1 10 1 6 1 1 1 1 1 1 1,
           10 10 10 10 1 1 1 1 1 1 14 14 10 10 1 1 1 1 1 1];  
            
ID_serv20 = [22 12 4 5 1 1 1 1 1 1 28 10 4 3 1 1 1 1 1 1,
           18 6 2 2 1 1 1 1 1 1 52 2 3 3 1 1 1 1 1 1,
           18 6 2 2 1 1 1 1 1 1 52 2 3 3 1 1 1 1 1 1,
           40 1 1 1 1 1 1 1 1 1 42 1 1 1 1 1 1 1 1 1,
           5 50 3 2 1 1 1 1 1 1 10 8 2 8 1 1 1 1 1 1,
           1 1 5 5 1 1 1 1 1 1 1 4 4 43 25 1 1 1 1 1,
           10 15 10 11 1 1 1 1 1 1 14 9 10 9 1 1 1 1 1 1,
           15 20 3 1 1 1 1 1 1 1 25 6 17 1 1 1 1 1 1 1,
           14 1 54 1 1 1 1 1 1 1 10 1 6 1 1 1 1 1 1 1,
           10 10 10 10 1 1 1 1 1 1 14 14 10 10 1 1 1 1 1 1,
           22 12 4 5 1 1 1 1 1 1 28 10 4 3 1 1 1 1 1 1,
           18 6 2 2 1 1 1 1 1 1 52 2 3 3 1 1 1 1 1 1,
           18 6 2 2 1 1 1 1 1 1 52 2 3 3 1 1 1 1 1 1,
           40 1 1 1 1 1 1 1 1 1 42 1 1 1 1 1 1 1 1 1,
           5 50 3 2 1 1 1 1 1 1 10 8 2 8 1 1 1 1 1 1,
           1 1 5 5 1 1 1 1 1 1 1 4 4 43 25 1 1 1 1 1,
           10 15 10 11 1 1 1 1 1 1 14 9 10 9 1 1 1 1 1 1,
           15 20 3 1 1 1 1 1 1 1 25 6 17 1 1 1 1 1 1 1,
           14 1 54 1 1 1 1 1 1 1 10 1 6 1 1 1 1 1 1 1,
           10 10 10 10 1 1 1 1 1 1 14 14 10 10 1 1 1 1 1 1];       
                          
ID_os20 = [50 22 8 8 2 2 2 2 2 2,
         70 8 5 5 2 2 2 2 2 2,
         70 8 5 5 2 2 2 2 2 2,
         82 2 2 2 2 2 2 2 2 2,
         15 58 5 10 2 2 2 2 2 2,
         5 5 48 30 2 2 2 2 2 2,
         24 24 20 20 2 2 2 2 2 2,
         40 26 20 2 2 2 2 2 2 2,
         24 2 60 2 2 2 2 2 2 2,
         24 24 20 20 2 2 2 2 2 2,
         50 22 8 8 2 2 2 2 2 2,
         70 8 5 5 2 2 2 2 2 2,
         70 8 5 5 2 2 2 2 2 2,
         82 2 2 2 2 2 2 2 2 2,
         15 58 5 10 2 2 2 2 2 2,
         5 5 48 30 2 2 2 2 2 2,
         24 24 20 20 2 2 2 2 2 2,
         40 26 20 2 2 2 2 2 2 2,
         24 2 60 2 2 2 2 2 2 2,
         24 24 20 20 2 2 2 2 2 2] ;   
     
ID_dr20 = [22 12 4 5 1 1 1 1 1 1 28 10 4 3 1 1 1 1 1 1,
           18 6 2 2 1 1 1 1 1 1 52 2 3 3 1 1 1 1 1 1,
           18 6 2 2 1 1 1 1 1 1 52 2 3 3 1 1 1 1 1 1,
           40 1 1 1 1 1 1 1 1 1 42 1 1 1 1 1 1 1 1 1,
           5 50 3 2 1 1 1 1 1 1 10 8 2 8 1 1 1 1 1 1,
           1 1 5 5 1 1 1 1 1 1 1 4 4 43 25 1 1 1 1 1,
           10 15 10 11 1 1 1 1 1 1 14 9 10 9 1 1 1 1 1 1,
           15 20 3 1 1 1 1 1 1 1 25 6 17 1 1 1 1 1 1 1,
           14 1 54 1 1 1 1 1 1 1 10 1 6 1 1 1 1 1 1 1,
           10 10 10 10 1 1 1 1 1 1 14 14 10 10 1 1 1 1 1 1,
           22 12 4 5 1 1 1 1 1 1 28 10 4 3 1 1 1 1 1 1,
           18 6 2 2 1 1 1 1 1 1 52 2 3 3 1 1 1 1 1 1,
           18 6 2 2 1 1 1 1 1 1 52 2 3 3 1 1 1 1 1 1,
           40 1 1 1 1 1 1 1 1 1 42 1 1 1 1 1 1 1 1 1,
           5 50 3 2 1 1 1 1 1 1 10 8 2 8 1 1 1 1 1 1,
           1 1 5 5 1 1 1 1 1 1 1 4 4 43 25 1 1 1 1 1,
           10 15 10 11 1 1 1 1 1 1 14 9 10 9 1 1 1 1 1 1,
           15 20 3 1 1 1 1 1 1 1 25 6 17 1 1 1 1 1 1 1,
           14 1 54 1 1 1 1 1 1 1 10 1 6 1 1 1 1 1 1 1,
           10 10 10 10 1 1 1 1 1 1 14 14 10 10 1 1 1 1 1 1]; 
       
ID_apps = zeros(200,20);
ID_apps(1:20,:) = ID_apps20;
ID_apps(21:40,:) = ID_apps20;
ID_apps(41:60,:) = ID_apps20;
ID_apps(61:80,:) = ID_apps20;
ID_apps(81:100,:) = ID_apps20;
ID_apps(101:200,:) = ID_apps(1:100,:);

ID_serv = zeros(200,20);
ID_serv(1:20,:) = ID_serv20;
ID_serv(21:40,:) = ID_serv20;
ID_serv(41:60,:) = ID_serv20;
ID_serv(61:80,:) = ID_serv20;
ID_serv(81:100,:) = ID_serv20;
ID_serv(101:200,:) = ID_serv(1:100,:);
                          
ID_os = zeros(200,10);
ID_os(1:20,:) = ID_os20;
ID_os(21:40,:) = ID_os20;
ID_os(41:60,:) = ID_os20;
ID_os(61:80,:) = ID_os20;
ID_os(81:100,:) = ID_os20;
ID_os(101:200,:) = ID_os(1:100,:);
     
ID_dr = zeros(200,20);
ID_dr(1:20,:) = ID_dr20;
ID_dr(21:40,:) = ID_dr20;
ID_dr(41:60,:) = ID_dr20;
ID_dr(61:80,:) = ID_dr20;
ID_dr(81:100,:) = ID_dr20;
ID_dr(101:200,:) = ID_dr(1:100,:);

     E_apps2 = E_apps;
E_serv2 = E_serv;
E_os2 = E_os;
E_dr2 = E_dr;     
ID_apps2 = ID_apps;
ID_serv2 = ID_serv;
ID_os2 = ID_os;
ID_dr2 = ID_dr;

%INDIVIDUAL TIME ARRAY OF CHANGES TO PERSONAL INDIVIDUAL DESIRABILITIES
%needs to be set here because numNodes is different for each case
numNodes = 200;
IDtimeArray1 = zeros(1,numNodes);
IDtimeArray2 = zeros(1,numNodes);

    case 25
        numNodes=300
%%%%%%%%%%%%%
% set up data - Dataset 24 - 300 nodes
%%%%%%%%%%%%%
%software strings
%WebBrowser1,6 - commercial products, WebBrowser2,3,4,5 third party
SW_str_apps = ['WebBrowser1v1 ' 'WebBrowser1v2 ' 'WebBrowser2v1 ' 'WebBrowser3v1 ' 'WebBrowser4v1 ' 'WebBrowser5v1 ' 'WebBrowser6v1 ' 'WebBrowser6v4 ' 'WebBrowser7v1 ' 'WebBrowser7v3 ''WebBrowser8v1 ' 'WebBrowser8v2 ' 'WebBrowser8v3 ' 'WebBrowser9v1 ' 'WebBrowser10v1 ' 'WebBrowser11v1 ' 'WebBrowser12v1 ' 'WebBrowser13v4 ' 'WebBrowser14v1 ' 'WebBrowser15v3 '];
%All photo viewers about same standard with number 7 slightly better
SW_str_serv = ['PhotoViewer1 ' 'PhotoViewer2 ' 'PhotoViewer3 ' 'PhotoViewer4 ' 'PhotoViewer5 ' 'PhotoViewer6 ' 'PhotoViewer7v1 ' 'PhotoViewer7v2 ' 'PhotoViewer8 ' 'Photoviewer9 ' 'PhotoViewer1 ' 'PhotoViewer2 ' 'PhotoViewer3 ' 'PhotoViewer4 ' 'PhotoViewer5 ' 'PhotoViewer6 ' 'PhotoViewer7v1 ' 'PhotoViewer7v2 ' 'PhotoViewer8 ' 'Photoviewer9 '];
%OS2 slightly more efficient overall than OS1
SW_str_os = ['OS1 ' 'OS2 ' 'OS3 ' 'OS4 ' 'OS5' 'OS6' 'OS7' 'OS8' 'OS9' 'OS10'];
%higher versions are better than lower number versions, the commercial
%products are more efficient than the freebies 3rd party
SW_str_dr = ['DataDr1v1 ' 'DataDr1v2 ' 'DataDr2v1 ' 'DataDr3v3 ' 'DataDr4 ' 'DataDr5 ' 'DataDr6 ' 'DataDr7 ' 'DataDr9 ' 'DataDr8 ' 'DataDr1v1 ' 'DataDr1v2 ' 'DataDr2v1 ' 'DataDr3v3 ' 'DataDr4 ' 'DataDr5 ' 'DataDr6 ' 'DataDr7 ' 'DataDr9 ' 'DataDr8 '];

%software frequency info for running the frequency and nei diversity index
%algorithm
%locusApps - 'a' represents major variants, 'V' represents a minor version
%locusServ - 's' represents major variants, 'V' represents a minor version
%locusOS  - 'o' represents major variants, 'V' represents a minor version
SW_freq_apps = ['a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V';'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'];
SW_freq_serv = ['s', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'];
SW_freq_os = ['o', 'V'; 'o', 'V'; 'o', 'V'; 'o', 'V';'o', 'V'; 'o', 'V'; 'o', 'V'; 'o', 'V';'o', 'V'; 'o', 'V'];
SW_freq_dr = ['d', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'];

%compatability of software
CSW_str_apps = ['a'; 'b'; 'c' ;'d'; 'e'; 'f'; 'g'; 'h'; 'i'; 'j'; 'a'; 'b'; 'c' ;'d'; 'e'; 'f'; 'g'; 'h'; 'i'; 'j'];
CSW_str_serv = ['a'; 'b'; 'c'; 'd'; 'e'; 'f'; 'g'; 'h'; 'i'; 'j'; 'a'; 'b'; 'c'; 'd'; 'e'; 'f'; 'g'; 'h'; 'i'; 'j'];
CSW_str_os = ['a'; 'b'; 'c'; 'd'; 'e'; 'f'; 'g'; 'h'; 'i'; 'j'];
CSW_str_dr = ['a'; 'b'; 'c'; 'd'; 'e' ;'f'; 'g'; 'h'; 'i'; 'j'; 'a'; 'b'; 'c'; 'd'; 'e'; 'f'; 'g'; 'h'; 'i'; 'j'];
CSW = [CSW_str_apps; CSW_str_serv; CSW_str_os; CSW_str_dr];
%create filters
CSW1 = zeros(size(CSW));
CSW2 = zeros(size(CSW));
CSW3 = zeros(size(CSW));
CSW4 = zeros(size(CSW));
CSW5 = zeros(size(CSW));
CSW6 = zeros(size(CSW));
CSW7 = zeros(size(CSW));
CSW8 = zeros(size(CSW));
CSW9 = zeros(size(CSW));
CSW10 = zeros(size(CSW));
for z = 1:size(CSW)
  if CSW(z) ==  'a'
      CSW1(z) = 1;
  end;
  if CSW(z) ==  'b'
      CSW2(z) = 1;
  end;
 if CSW(z) ==  'c'
      CSW3(z) = 1;
  end;
 if CSW(z) ==  'd'
      CSW4(z) = 1;
  end;
  if CSW(z) ==  'e'
      CSW5(z) = 1;
  end;
  if CSW(z) ==  'f'
      CSW6(z) = 1;
  end;
 if CSW(z) ==  'g'
      CSW7(z) = 1;
  end;
 if CSW(z) ==  'h'
      CSW8(z) = 1;
  end;  
  if CSW(z) ==  'i'
      CSW9(z) = 1;
  end;
  if CSW(z) ==  'j'
      CSW10(z) = 1;
  end;

end; %end for z
CSW1 = CSW1';
CSW2 = CSW2';
CSW3 = CSW3';
CSW4 = CSW4';
CSW5 = CSW5';
CSW6 = CSW6';
CSW7 = CSW7';
CSW8 = CSW8';
CSW9 = CSW9';
CSW10 = CSW10';
CSWGroup(1,:) = CSW1;
CSWGroup(2,:) = CSW2;
CSWGroup(3,:) = CSW3;
CSWGroup(4,:) = CSW4;
CSWGroup(5,:) = CSW5;
CSWGroup(6,:) = CSW6;
CSWGroup(7,:) = CSW7;
CSWGroup(8,:) = CSW8;
CSWGroup(9,:) = CSW9;
CSWGroup(10,:) = CSW10;

Genotype_apps = zeros(300,20);
Genotype_apps(1:150,1)=1;
Genotype_apps(151:300,5)=1;

Genotype_serv = zeros(300,20);
Genotype_serv(1:150,1)=1;
Genotype_serv(151:300,5)=1;
             
Genotype_os = zeros(300,10);
Genotype_os(1:150,1)=1;
Genotype_os(151:300,5)=1;

Genotype_dr = zeros(300,20);
Genotype_dr(1:150,1)=1;
Genotype_dr(151:300,5)=1;          
            
%efficiency/quality ratings of software (1 to 100) 
%(1)inefficient (100)maximum efficiency
%E_apps = [65 75 55 50 60 60 60 80 20 20 65 75 55 50 60 60 60 80 20 20];
%E_serv = [65 66 67 63 59 62 72 77 50 50 65 75 55 50 60 60 60 80 20 20];
%E_os = [50 50 50 50 50 50 50 50 50 50];
%E_dr = [70 80 60 75 69 68 63 58 65 65 65 75 55 50 60 60 60 80 20 20];

E_apps = [1 75 55 5 1 1 5 80 20 20 10 75 10 5 5 5 60 80 5 5];
E_serv = [65 1 67 5 1 62 72 77 50 50 65 75 5 5 5 5 5 80 20 20];
E_os = [70 30 1 10 1 50 2 5 5 5];
E_dr = [70 80 1 75 15 68 20 58 1 1 1 5 5 8 5 1 60 2 20 20];

%community desirability ratings (1 to 100) (1)least desirable (100)most
%desirable
%desirability 1
CD_apps = [81 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1];
sum(CD_apps);
CD_serv = [81 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1];
sum(CD_serv);
CD_os = [82 2 2 2 2 2 2 2 2 2];
sum(CD_os);
CD_dr = [81 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1];
sum(CD_dr);
%desirability 2 when wish to change
CD_apps2 = [15 8 1 1 1 1 1 1 1 1 55 6 1 1 1 1 1 1 1 1];
sum(CD_apps2)
CD_serv2 = [60 5 1 1 1 1 1 1 1 1 10 9 1 1 1 1 1 1 1 1];
sum(CD_serv2)
CD_os2 = [70 14 2 2 2 2 2 2 2 2];
sum(CD_os2)
CD_dr2 = [40 10 1 1 1 1 1 1 1 1 30 4 1 1 1 1 1 1 1 1];
sum(CD_dr2)
            
%individual desirability ratings (1 to 100) (1)least desirable (100)most
%desirable
%do for 10 individuals

ID_apps20 = [22 12 4 5 1 1 1 1 1 1 28 10 4 3 1 1 1 1 1 1,
           18 6 2 2 1 1 1 1 1 1 52 2 3 3 1 1 1 1 1 1,
           18 6 2 2 1 1 1 1 1 1 52 2 3 3 1 1 1 1 1 1,
           40 1 1 1 1 1 1 1 1 1 42 1 1 1 1 1 1 1 1 1,
           5 50 3 2 1 1 1 1 1 1 10 8 2 8 1 1 1 1 1 1,
           1 1 5 5 1 1 1 1 1 1 1 4 4 43 25 1 1 1 1 1,
           10 15 10 11 1 1 1 1 1 1 14 9 10 9 1 1 1 1 1 1,
           15 20 3 1 1 1 1 1 1 1 25 6 17 1 1 1 1 1 1 1,
           14 1 54 1 1 1 1 1 1 1 10 1 6 1 1 1 1 1 1 1,
           10 10 10 10 1 1 1 1 1 1 14 14 10 10 1 1 1 1 1 1,
           22 12 4 5 1 1 1 1 1 1 28 10 4 3 1 1 1 1 1 1,
           18 6 2 2 1 1 1 1 1 1 52 2 3 3 1 1 1 1 1 1,
           18 6 2 2 1 1 1 1 1 1 52 2 3 3 1 1 1 1 1 1,
           40 1 1 1 1 1 1 1 1 1 42 1 1 1 1 1 1 1 1 1,
           5 50 3 2 1 1 1 1 1 1 10 8 2 8 1 1 1 1 1 1,
           1 1 5 5 1 1 1 1 1 1 1 4 4 43 25 1 1 1 1 1,
           10 15 10 11 1 1 1 1 1 1 14 9 10 9 1 1 1 1 1 1,
           15 20 3 1 1 1 1 1 1 1 25 6 17 1 1 1 1 1 1 1,
           14 1 54 1 1 1 1 1 1 1 10 1 6 1 1 1 1 1 1 1,
           10 10 10 10 1 1 1 1 1 1 14 14 10 10 1 1 1 1 1 1];  
            
ID_serv20 = [22 12 4 5 1 1 1 1 1 1 28 10 4 3 1 1 1 1 1 1,
           18 6 2 2 1 1 1 1 1 1 52 2 3 3 1 1 1 1 1 1,
           18 6 2 2 1 1 1 1 1 1 52 2 3 3 1 1 1 1 1 1,
           40 1 1 1 1 1 1 1 1 1 42 1 1 1 1 1 1 1 1 1,
           5 50 3 2 1 1 1 1 1 1 10 8 2 8 1 1 1 1 1 1,
           1 1 5 5 1 1 1 1 1 1 1 4 4 43 25 1 1 1 1 1,
           10 15 10 11 1 1 1 1 1 1 14 9 10 9 1 1 1 1 1 1,
           15 20 3 1 1 1 1 1 1 1 25 6 17 1 1 1 1 1 1 1,
           14 1 54 1 1 1 1 1 1 1 10 1 6 1 1 1 1 1 1 1,
           10 10 10 10 1 1 1 1 1 1 14 14 10 10 1 1 1 1 1 1,
           22 12 4 5 1 1 1 1 1 1 28 10 4 3 1 1 1 1 1 1,
           18 6 2 2 1 1 1 1 1 1 52 2 3 3 1 1 1 1 1 1,
           18 6 2 2 1 1 1 1 1 1 52 2 3 3 1 1 1 1 1 1,
           40 1 1 1 1 1 1 1 1 1 42 1 1 1 1 1 1 1 1 1,
           5 50 3 2 1 1 1 1 1 1 10 8 2 8 1 1 1 1 1 1,
           1 1 5 5 1 1 1 1 1 1 1 4 4 43 25 1 1 1 1 1,
           10 15 10 11 1 1 1 1 1 1 14 9 10 9 1 1 1 1 1 1,
           15 20 3 1 1 1 1 1 1 1 25 6 17 1 1 1 1 1 1 1,
           14 1 54 1 1 1 1 1 1 1 10 1 6 1 1 1 1 1 1 1,
           10 10 10 10 1 1 1 1 1 1 14 14 10 10 1 1 1 1 1 1];       
                          
ID_os20 = [50 22 8 8 2 2 2 2 2 2,
         70 8 5 5 2 2 2 2 2 2,
         70 8 5 5 2 2 2 2 2 2,
         82 2 2 2 2 2 2 2 2 2,
         15 58 5 10 2 2 2 2 2 2,
         5 5 48 30 2 2 2 2 2 2,
         24 24 20 20 2 2 2 2 2 2,
         40 26 20 2 2 2 2 2 2 2,
         24 2 60 2 2 2 2 2 2 2,
         24 24 20 20 2 2 2 2 2 2,
         50 22 8 8 2 2 2 2 2 2,
         70 8 5 5 2 2 2 2 2 2,
         70 8 5 5 2 2 2 2 2 2,
         82 2 2 2 2 2 2 2 2 2,
         15 58 5 10 2 2 2 2 2 2,
         5 5 48 30 2 2 2 2 2 2,
         24 24 20 20 2 2 2 2 2 2,
         40 26 20 2 2 2 2 2 2 2,
         24 2 60 2 2 2 2 2 2 2,
         24 24 20 20 2 2 2 2 2 2] ;   
     
ID_dr20 = [22 12 4 5 1 1 1 1 1 1 28 10 4 3 1 1 1 1 1 1,
           18 6 2 2 1 1 1 1 1 1 52 2 3 3 1 1 1 1 1 1,
           18 6 2 2 1 1 1 1 1 1 52 2 3 3 1 1 1 1 1 1,
           40 1 1 1 1 1 1 1 1 1 42 1 1 1 1 1 1 1 1 1,
           5 50 3 2 1 1 1 1 1 1 10 8 2 8 1 1 1 1 1 1,
           1 1 5 5 1 1 1 1 1 1 1 4 4 43 25 1 1 1 1 1,
           10 15 10 11 1 1 1 1 1 1 14 9 10 9 1 1 1 1 1 1,
           15 20 3 1 1 1 1 1 1 1 25 6 17 1 1 1 1 1 1 1,
           14 1 54 1 1 1 1 1 1 1 10 1 6 1 1 1 1 1 1 1,
           10 10 10 10 1 1 1 1 1 1 14 14 10 10 1 1 1 1 1 1,
           22 12 4 5 1 1 1 1 1 1 28 10 4 3 1 1 1 1 1 1,
           18 6 2 2 1 1 1 1 1 1 52 2 3 3 1 1 1 1 1 1,
           18 6 2 2 1 1 1 1 1 1 52 2 3 3 1 1 1 1 1 1,
           40 1 1 1 1 1 1 1 1 1 42 1 1 1 1 1 1 1 1 1,
           5 50 3 2 1 1 1 1 1 1 10 8 2 8 1 1 1 1 1 1,
           1 1 5 5 1 1 1 1 1 1 1 4 4 43 25 1 1 1 1 1,
           10 15 10 11 1 1 1 1 1 1 14 9 10 9 1 1 1 1 1 1,
           15 20 3 1 1 1 1 1 1 1 25 6 17 1 1 1 1 1 1 1,
           14 1 54 1 1 1 1 1 1 1 10 1 6 1 1 1 1 1 1 1,
           10 10 10 10 1 1 1 1 1 1 14 14 10 10 1 1 1 1 1 1]; 
       
ID_apps = zeros(300,20);
ID_apps(1:20,:) = ID_apps20;
ID_apps(21:40,:) = ID_apps20;
ID_apps(41:60,:) = ID_apps20;
ID_apps(61:80,:) = ID_apps20;
ID_apps(81:100,:) = ID_apps20;
ID_apps(101:200,:) = ID_apps(1:100,:);
ID_apps(201:300,:) = ID_apps(1:100,:);
            
ID_serv = zeros(300,20);
ID_serv(1:20,:) = ID_serv20;
ID_serv(21:40,:) = ID_serv20;
ID_serv(41:60,:) = ID_serv20;
ID_serv(61:80,:) = ID_serv20;
ID_serv(81:100,:) = ID_serv20;
ID_serv(101:200,:) = ID_serv(1:100,:);
ID_serv(201:300,:) = ID_serv(1:100,:);
                          
ID_os = zeros(300,10);
ID_os(1:20,:) = ID_os20;
ID_os(21:40,:) = ID_os20;
ID_os(41:60,:) = ID_os20;
ID_os(61:80,:) = ID_os20;
ID_os(81:100,:) = ID_os20;
ID_os(101:200,:) = ID_os(1:100,:);
ID_os(201:300,:) = ID_os(1:100,:);
     
ID_dr = zeros(300,20);
ID_dr(1:20,:) = ID_dr20;
ID_dr(21:40,:) = ID_dr20;
ID_dr(41:60,:) = ID_dr20;
ID_dr(61:80,:) = ID_dr20;
ID_dr(81:100,:) = ID_dr20;
ID_dr(101:200,:) = ID_dr(1:100,:);
ID_dr(201:300,:) = ID_dr(1:100,:);

     E_apps2 = E_apps;
E_serv2 = E_serv;
E_os2 = E_os;
E_dr2 = E_dr;     
ID_apps2 = ID_apps;
ID_serv2 = ID_serv;
ID_os2 = ID_os;
ID_dr2 = ID_dr;

%INDIVIDUAL TIME ARRAY OF CHANGES TO PERSONAL INDIVIDUAL DESIRABILITIES
%needs to be set here because numNodes is different for each case
IDtimeArray1 = zeros(1,numNodes);
IDtimeArray2 = zeros(1,numNodes);

    case 26
%%%%%%%%%%%%%
% set up data - Dataset 25 - 600 nodes
%%%%%%%%%%%%%
%software strings
%WebBrowser1,6 - commercial products, WebBrowser2,3,4,5 third party
SW_str_apps = ['WebBrowser1v1 ' 'WebBrowser1v2 ' 'WebBrowser2v1 ' 'WebBrowser3v1 ' 'WebBrowser4v1 ' 'WebBrowser5v1 ' 'WebBrowser6v1 ' 'WebBrowser6v4 ' 'WebBrowser7v1 ' 'WebBrowser7v3 ''WebBrowser8v1 ' 'WebBrowser8v2 ' 'WebBrowser8v3 ' 'WebBrowser9v1 ' 'WebBrowser10v1 ' 'WebBrowser11v1 ' 'WebBrowser12v1 ' 'WebBrowser13v4 ' 'WebBrowser14v1 ' 'WebBrowser15v3 '];
%All photo viewers about same standard with number 7 slightly better
SW_str_serv = ['PhotoViewer1 ' 'PhotoViewer2 ' 'PhotoViewer3 ' 'PhotoViewer4 ' 'PhotoViewer5 ' 'PhotoViewer6 ' 'PhotoViewer7v1 ' 'PhotoViewer7v2 ' 'PhotoViewer8 ' 'Photoviewer9 ' 'PhotoViewer1 ' 'PhotoViewer2 ' 'PhotoViewer3 ' 'PhotoViewer4 ' 'PhotoViewer5 ' 'PhotoViewer6 ' 'PhotoViewer7v1 ' 'PhotoViewer7v2 ' 'PhotoViewer8 ' 'Photoviewer9 '];
%OS2 slightly more efficient overall than OS1
SW_str_os = ['OS1 ' 'OS2 ' 'OS3 ' 'OS4 ' 'OS5' 'OS6' 'OS7' 'OS8' 'OS9' 'OS10'];
%higher versions are better than lower number versions, the commercial
%products are more efficient than the freebies 3rd party
SW_str_dr = ['DataDr1v1 ' 'DataDr1v2 ' 'DataDr2v1 ' 'DataDr3v3 ' 'DataDr4 ' 'DataDr5 ' 'DataDr6 ' 'DataDr7 ' 'DataDr9 ' 'DataDr8 ' 'DataDr1v1 ' 'DataDr1v2 ' 'DataDr2v1 ' 'DataDr3v3 ' 'DataDr4 ' 'DataDr5 ' 'DataDr6 ' 'DataDr7 ' 'DataDr9 ' 'DataDr8 '];

%software frequency info for running the frequency and nei diversity index
%algorithm
%locusApps - 'a' represents major variants, 'V' represents a minor version
%locusServ - 's' represents major variants, 'V' represents a minor version
%locusOS  - 'o' represents major variants, 'V' represents a minor version
SW_freq_apps = ['a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V';'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'];
SW_freq_serv = ['s', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'];
SW_freq_os = ['o', 'V'; 'o', 'V'; 'o', 'V'; 'o', 'V';'o', 'V'; 'o', 'V'; 'o', 'V'; 'o', 'V';'o', 'V'; 'o', 'V'];
SW_freq_dr = ['d', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'];

%compatability of software
CSW_str_apps = ['a'; 'b'; 'c' ;'d'; 'e'; 'f'; 'g'; 'h'; 'i'; 'j'; 'a'; 'b'; 'c' ;'d'; 'e'; 'f'; 'g'; 'h'; 'i'; 'j'];
CSW_str_serv = ['a'; 'b'; 'c'; 'd'; 'e'; 'f'; 'g'; 'h'; 'i'; 'j'; 'a'; 'b'; 'c'; 'd'; 'e'; 'f'; 'g'; 'h'; 'i'; 'j'];
CSW_str_os = ['a'; 'b'; 'c'; 'd'; 'e'; 'f'; 'g'; 'h'; 'i'; 'j'];
CSW_str_dr = ['a'; 'b'; 'c'; 'd'; 'e' ;'f'; 'g'; 'h'; 'i'; 'j'; 'a'; 'b'; 'c'; 'd'; 'e'; 'f'; 'g'; 'h'; 'i'; 'j'];
CSW = [CSW_str_apps; CSW_str_serv; CSW_str_os; CSW_str_dr];
%create filters
CSW1 = zeros(size(CSW));
CSW2 = zeros(size(CSW));
CSW3 = zeros(size(CSW));
CSW4 = zeros(size(CSW));
CSW5 = zeros(size(CSW));
CSW6 = zeros(size(CSW));
CSW7 = zeros(size(CSW));
CSW8 = zeros(size(CSW));
CSW9 = zeros(size(CSW));
CSW10 = zeros(size(CSW));
for z = 1:size(CSW)
  if CSW(z) ==  'a'
      CSW1(z) = 1;
  end;
  if CSW(z) ==  'b'
      CSW2(z) = 1;
  end;
 if CSW(z) ==  'c'
      CSW3(z) = 1;
  end;
 if CSW(z) ==  'd'
      CSW4(z) = 1;
  end;
  if CSW(z) ==  'e'
      CSW5(z) = 1;
  end;
  if CSW(z) ==  'f'
      CSW6(z) = 1;
  end;
 if CSW(z) ==  'g'
      CSW7(z) = 1;
  end;
 if CSW(z) ==  'h'
      CSW8(z) = 1;
  end;  
  if CSW(z) ==  'i'
      CSW9(z) = 1;
  end;
  if CSW(z) ==  'j'
      CSW10(z) = 1;
  end;

end; %end for z
CSW1 = CSW1';
CSW2 = CSW2';
CSW3 = CSW3';
CSW4 = CSW4';
CSW5 = CSW5';
CSW6 = CSW6';
CSW7 = CSW7';
CSW8 = CSW8';
CSW9 = CSW9';
CSW10 = CSW10';
CSWGroup(1,:) = CSW1;
CSWGroup(2,:) = CSW2;
CSWGroup(3,:) = CSW3;
CSWGroup(4,:) = CSW4;
CSWGroup(5,:) = CSW5;
CSWGroup(6,:) = CSW6;
CSWGroup(7,:) = CSW7;
CSWGroup(8,:) = CSW8;
CSWGroup(9,:) = CSW9;
CSWGroup(10,:) = CSW10;

Genotype_apps = zeros(600,20);
Genotype_apps(1:300,1)=1;
Genotype_apps(301:600,5)=1;

Genotype_serv = zeros(600,20);
Genotype_serv(1:300,1)=1;
Genotype_serv(301:600,5)=1;
             
Genotype_os = zeros(600,10);
Genotype_os(1:300,1)=1;
Genotype_os(301:600,5)=1;

Genotype_dr = zeros(600,20);
Genotype_dr(1:300,1)=1;
Genotype_dr(301:600,5)=1;          
            
%efficiency/quality ratings of software (1 to 100) 
%(1)inefficient (100)maximum efficiency
%E_apps = [65 75 55 50 60 60 60 80 20 20 65 75 55 50 60 60 60 80 20 20];
%E_serv = [65 66 67 63 59 62 72 77 50 50 65 75 55 50 60 60 60 80 20 20];
%E_os = [50 50 50 50 50 50 50 50 50 50];
%E_dr = [70 80 60 75 69 68 63 58 65 65 65 75 55 50 60 60 60 80 20 20];

%case 26
%E_apps = [1 75 55 5 1 1 5 80 20 20 10 75 10 5 5 5 60 80 5 5]
%E_serv = [65 1 67 5 1 62 72 77 50 50 65 75 5 5 5 5 5 80 20 20]
%E_os = [70 30 1 10 1 50 2 5 5 5]
%E_dr = [70 80 1 75 15 68 20 58 1 1 1 5 5 8 5 1 60 2 20 20]

%case 11
%E_apps = [65 75 55 50 60 60 60 80 20 20 65 75 55 50 60 60 60 80 20 20];
%E_serv = [65 66 67 63 59 62 72 77 50 50 65 75 55 50 60 60 60 80 20 20];
%E_os = [50 50 50 50 50 50 50 50 50 50];
%E_dr = [70 80 60 75 69 68 63 58 65 65 65 75 55 50 60 60 60 80 20 20];

%case unaligned
E_apps = [65 75 55 50 60 60 60 80 20 20 90 90 90 90 90 90 90 80 20 20];
E_serv = [65 66 67 63 59 62 72 77 50 50 90 90 90 90 90 90 90 80 20 20];
E_os = [2 5 5 5 5 10 20 90 2 2];
E_dr = [70 80 60 75 69 68 63 58 65 65 90 90 90 90 90 90 90 80 90 20];


%community desirability ratings (1 to 100) (1)least desirable (100)most
%desirable
%desirability 1
CD_apps = [81 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1];
sum(CD_apps);
CD_serv = [81 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1];
sum(CD_serv);
CD_os = [82 2 2 2 2 2 2 2 2 2];
sum(CD_os);
CD_dr = [81 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1];
sum(CD_dr);

%desirability 2 when wish to change
CD_apps2 = [15 8 1 1 1 1 1 1 1 1 55 6 1 1 1 1 1 1 1 1];
sum(CD_apps2)
CD_serv2 = [60 5 1 1 1 1 1 1 1 1 10 9 1 1 1 1 1 1 1 1];
sum(CD_serv2)
CD_os2 = [70 14 2 2 2 2 2 2 2 2];
sum(CD_os2)
CD_dr2 = [40 10 1 1 1 1 1 1 1 1 30 4 1 1 1 1 1 1 1 1];
sum(CD_dr2)

            
%individual desirability ratings (1 to 100) (1)least desirable (100)most
%desirable
%do for 10 individuals

ID_apps20 = [22 12 4 5 1 1 1 1 1 1 28 10 4 3 1 1 1 1 1 1,
           18 6 2 2 1 1 1 1 1 1 52 2 3 3 1 1 1 1 1 1,
           18 6 2 2 1 1 1 1 1 1 52 2 3 3 1 1 1 1 1 1,
           40 1 1 1 1 1 1 1 1 1 42 1 1 1 1 1 1 1 1 1,
           5 50 3 2 1 1 1 1 1 1 10 8 2 8 1 1 1 1 1 1,
           1 1 5 5 1 1 1 1 1 1 1 4 4 43 25 1 1 1 1 1,
           10 15 10 11 1 1 1 1 1 1 14 9 10 9 1 1 1 1 1 1,
           15 20 3 1 1 1 1 1 1 1 25 6 17 1 1 1 1 1 1 1,
           14 1 54 1 1 1 1 1 1 1 10 1 6 1 1 1 1 1 1 1,
           10 10 10 10 1 1 1 1 1 1 14 14 10 10 1 1 1 1 1 1,
           22 12 4 5 1 1 1 1 1 1 28 10 4 3 1 1 1 1 1 1,
           18 6 2 2 1 1 1 1 1 1 52 2 3 3 1 1 1 1 1 1,
           18 6 2 2 1 1 1 1 1 1 52 2 3 3 1 1 1 1 1 1,
           40 1 1 1 1 1 1 1 1 1 42 1 1 1 1 1 1 1 1 1,
           5 50 3 2 1 1 1 1 1 1 10 8 2 8 1 1 1 1 1 1,
           1 1 5 5 1 1 1 1 1 1 1 4 4 43 25 1 1 1 1 1,
           10 15 10 11 1 1 1 1 1 1 14 9 10 9 1 1 1 1 1 1,
           15 20 3 1 1 1 1 1 1 1 25 6 17 1 1 1 1 1 1 1,
           14 1 54 1 1 1 1 1 1 1 10 1 6 1 1 1 1 1 1 1,
           10 10 10 10 1 1 1 1 1 1 14 14 10 10 1 1 1 1 1 1];  
            
ID_serv20 = [22 12 4 5 1 1 1 1 1 1 28 10 4 3 1 1 1 1 1 1,
           18 6 2 2 1 1 1 1 1 1 52 2 3 3 1 1 1 1 1 1,
           18 6 2 2 1 1 1 1 1 1 52 2 3 3 1 1 1 1 1 1,
           40 1 1 1 1 1 1 1 1 1 42 1 1 1 1 1 1 1 1 1,
           5 50 3 2 1 1 1 1 1 1 10 8 2 8 1 1 1 1 1 1,
           1 1 5 5 1 1 1 1 1 1 1 4 4 43 25 1 1 1 1 1,
           10 15 10 11 1 1 1 1 1 1 14 9 10 9 1 1 1 1 1 1,
           15 20 3 1 1 1 1 1 1 1 25 6 17 1 1 1 1 1 1 1,
           14 1 54 1 1 1 1 1 1 1 10 1 6 1 1 1 1 1 1 1,
           10 10 10 10 1 1 1 1 1 1 14 14 10 10 1 1 1 1 1 1,
           22 12 4 5 1 1 1 1 1 1 28 10 4 3 1 1 1 1 1 1,
           18 6 2 2 1 1 1 1 1 1 52 2 3 3 1 1 1 1 1 1,
           18 6 2 2 1 1 1 1 1 1 52 2 3 3 1 1 1 1 1 1,
           40 1 1 1 1 1 1 1 1 1 42 1 1 1 1 1 1 1 1 1,
           5 50 3 2 1 1 1 1 1 1 10 8 2 8 1 1 1 1 1 1,
           1 1 5 5 1 1 1 1 1 1 1 4 4 43 25 1 1 1 1 1,
           10 15 10 11 1 1 1 1 1 1 14 9 10 9 1 1 1 1 1 1,
           15 20 3 1 1 1 1 1 1 1 25 6 17 1 1 1 1 1 1 1,
           14 1 54 1 1 1 1 1 1 1 10 1 6 1 1 1 1 1 1 1,
           10 10 10 10 1 1 1 1 1 1 14 14 10 10 1 1 1 1 1 1];       
                          
ID_os20 = [50 22 8 8 2 2 2 2 2 2,
         70 8 5 5 2 2 2 2 2 2,
         70 8 5 5 2 2 2 2 2 2,
         82 2 2 2 2 2 2 2 2 2,
         15 58 5 10 2 2 2 2 2 2,
         5 5 48 30 2 2 2 2 2 2,
         24 24 20 20 2 2 2 2 2 2,
         40 26 20 2 2 2 2 2 2 2,
         24 2 60 2 2 2 2 2 2 2,
         24 24 20 20 2 2 2 2 2 2,
         50 22 8 8 2 2 2 2 2 2,
         70 8 5 5 2 2 2 2 2 2,
         70 8 5 5 2 2 2 2 2 2,
         82 2 2 2 2 2 2 2 2 2,
         15 58 5 10 2 2 2 2 2 2,
         5 5 48 30 2 2 2 2 2 2,
         24 24 20 20 2 2 2 2 2 2,
         40 26 20 2 2 2 2 2 2 2,
         24 2 60 2 2 2 2 2 2 2,
         24 24 20 20 2 2 2 2 2 2] ;   
     
ID_dr20 = [22 12 4 5 1 1 1 1 1 1 28 10 4 3 1 1 1 1 1 1,
           18 6 2 2 1 1 1 1 1 1 52 2 3 3 1 1 1 1 1 1,
           18 6 2 2 1 1 1 1 1 1 52 2 3 3 1 1 1 1 1 1,
           40 1 1 1 1 1 1 1 1 1 42 1 1 1 1 1 1 1 1 1,
           5 50 3 2 1 1 1 1 1 1 10 8 2 8 1 1 1 1 1 1,
           1 1 5 5 1 1 1 1 1 1 1 4 4 43 25 1 1 1 1 1,
           10 15 10 11 1 1 1 1 1 1 14 9 10 9 1 1 1 1 1 1,
           15 20 3 1 1 1 1 1 1 1 25 6 17 1 1 1 1 1 1 1,
           14 1 54 1 1 1 1 1 1 1 10 1 6 1 1 1 1 1 1 1,
           10 10 10 10 1 1 1 1 1 1 14 14 10 10 1 1 1 1 1 1,
           22 12 4 5 1 1 1 1 1 1 28 10 4 3 1 1 1 1 1 1,
           18 6 2 2 1 1 1 1 1 1 52 2 3 3 1 1 1 1 1 1,
           18 6 2 2 1 1 1 1 1 1 52 2 3 3 1 1 1 1 1 1,
           40 1 1 1 1 1 1 1 1 1 42 1 1 1 1 1 1 1 1 1,
           5 50 3 2 1 1 1 1 1 1 10 8 2 8 1 1 1 1 1 1,
           1 1 5 5 1 1 1 1 1 1 1 4 4 43 25 1 1 1 1 1,
           10 15 10 11 1 1 1 1 1 1 14 9 10 9 1 1 1 1 1 1,
           15 20 3 1 1 1 1 1 1 1 25 6 17 1 1 1 1 1 1 1,
           14 1 54 1 1 1 1 1 1 1 10 1 6 1 1 1 1 1 1 1,
           10 10 10 10 1 1 1 1 1 1 14 14 10 10 1 1 1 1 1 1]; 
       
ID_apps = zeros(600,20);
ID_apps(1:20,:) = ID_apps20;
ID_apps(21:40,:) = ID_apps20;
ID_apps(41:60,:) = ID_apps20;
ID_apps(61:80,:) = ID_apps20;
ID_apps(81:100,:) = ID_apps20;
ID_apps(101:200,:) = ID_apps(1:100,:);
ID_apps(201:400,:) = ID_apps(1:200,:);
ID_apps(401:600,:) = ID_apps(1:200,:);
            
ID_serv = zeros(600,20);
ID_serv(1:20,:) = ID_serv20;
ID_serv(21:40,:) = ID_serv20;
ID_serv(41:60,:) = ID_serv20;
ID_serv(61:80,:) = ID_serv20;
ID_serv(81:100,:) = ID_serv20;
ID_serv(101:200,:) = ID_serv(1:100,:);
ID_serv(201:400,:) = ID_serv(1:200,:);
ID_serv(401:600,:) = ID_serv(1:200,:);
                          
ID_os = zeros(600,10);
ID_os(1:20,:) = ID_os20;
ID_os(21:40,:) = ID_os20;
ID_os(41:60,:) = ID_os20;
ID_os(61:80,:) = ID_os20;
ID_os(81:100,:) = ID_os20;
ID_os(101:200,:) = ID_os(1:100,:);
ID_os(201:400,:) = ID_os(1:200,:);
ID_os(401:600,:) = ID_os(1:200,:);
     
ID_dr = zeros(600,20);
ID_dr(1:20,:) = ID_dr20;
ID_dr(21:40,:) = ID_dr20;
ID_dr(41:60,:) = ID_dr20;
ID_dr(61:80,:) = ID_dr20;
ID_dr(81:100,:) = ID_dr20;
ID_dr(101:200,:) = ID_dr(1:100,:);
ID_dr(201:400,:) = ID_dr(1:200,:);
ID_dr(401:600,:) = ID_dr(1:200,:);

     E_apps2 = E_apps;
E_serv2 = E_serv;
E_os2 = E_os;
E_dr2 = E_dr;     
ID_apps2 = ID_apps;
ID_serv2 = ID_serv;
ID_os2 = ID_os;
ID_dr2 = ID_dr;
%INDIVIDUAL TIME ARRAY OF CHANGES TO PERSONAL INDIVIDUAL DESIRABILITIES
%needs to be set here because numNodes is different for each case
numNodes = 600;
IDtimeArray1 = zeros(1,numNodes);
IDtimeArray2 = zeros(1,numNodes);

    case 27
%%%%%%%%%%%%%
% set up data - Dataset 16 - but with only 1 os
% check to see if filtered and unfiltered are the same
%%%%%%%%%%%%%
% set up data - Dataset 16 - same as 1 but with orig of 0.5 and 1000 nodes
%%%%%%%%%%%%%
%software strings
%WebBrowser1,6 - commercial products, WebBrowser2,3,4,5 third party
SW_str_apps = ['WebBrowser1v1 ' 'WebBrowser1v2 ' 'WebBrowser2v1 ' 'WebBrowser3v1 ' 'WebBrowser4v1 ' 'WebBrowser5v1 ' 'WebBrowser6v1 ' 'WebBrowser6v4 '];
%All photo viewers about same standard with number 7 slightly better
SW_str_serv = ['PhotoViewer1 ' 'PhotoViewer2 ' 'PhotoViewer3 ' 'PhotoViewer4 ' 'PhotoViewer5 ' 'PhotoViewer6 ' 'PhotoViewer7v1 ' 'PhotoViewer7v2 '];
SW_str_os = ['OS1 '];
%higher versions are better than lower number versions, the commercial
%products are more efficient than the freebies 3rd party
SW_str_dr = ['DataDr1v1 ' 'DataDr1v2 ' 'DataDr2v1 ' 'DataDr3v3 ' 'DataDr4 ' 'DataDr5 ' 'DataDr6 ' 'DataDr7 '];

%software frequency info for running the frequency and nei diversity index
%algorithm
%locusApps - 'a' represents major variants, 'V' represents a minor version
%locusServ - 's' represents major variants, 'V' represents a minor version
%locusOS  - 'o' represents major variants, 'V' represents a minor version
SW_freq_apps = ['a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'];
SW_freq_serv = ['s', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'];
SW_freq_os = ['o', 'V'];
SW_freq_dr = ['d', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'];

%compatability of software
CSW_str_apps = ['a'; 'a'; 'a' ;'a'; 'a'; 'a'; 'a'; 'a'];
CSW_str_serv = ['a'; 'a'; 'a'; 'a'; 'a'; 'a'; 'a'; 'a'];
CSW_str_os = ['a'];
CSW_str_dr = ['a'; 'a'; 'a'; 'a'; 'a' ;'a'; 'a'; 'a'];
CSW = [CSW_str_apps; CSW_str_serv; CSW_str_os; CSW_str_dr];
%create two filters
CSW1 = zeros(size(CSW));
CSW2 = zeros(size(CSW));
CSW3 = zeros(size(CSW));
CSW4 = zeros(size(CSW));
CSW5 = zeros(size(CSW));
CSW6 = zeros(size(CSW));
CSW7 = zeros(size(CSW));
CSW8 = zeros(size(CSW));
CSW9 = zeros(size(CSW));
CSW10 = zeros(size(CSW));
for z = 1:size(CSW)
  if CSW(z) ==  'a'
      CSW1(z) = 1;
  end;
  if CSW(z) ==  'b'
      CSW2(z) = 1;
  end;
end; %end for z
CSW1 = CSW1';
CSW2 = CSW2';
CSW3 = CSW3';
CSW4 = CSW4';
CSW5 = CSW5';
CSW6 = CSW6';
CSW7 = CSW7';
CSW8 = CSW8';
CSW9 = CSW9';
CSW10 = CSW10';
CSWGroup(1,:) = CSW1;
CSWGroup(2,:) = CSW2;


% set up genotypes for each of the 400 nodes
Genotype_apps = zeros(1000,8);
Genotype_apps(1:500,2)=1;
Genotype_apps(501:1000,8)=1;

Genotype_serv = zeros(1000,8);
Genotype_serv(1:500,1)=1;
Genotype_serv(501:1000,8)=1;
             
Genotype_os = zeros(1000,1);
Genotype_os(1:500,1)=1;
Genotype_os(501:1000,1)=1;

Genotype_dr = zeros(1000,8);
Genotype_dr(1:500,1)=1;
Genotype_dr(501:1000,8)=1;           

%efficiency/quality ratings of software (1 to 100) 
%(1)inefficient (100)maximum efficiency
E_apps = [65 75 55 50 6 6 6 8];
E_serv = [65 66 67 63 5 6 17 7];
E_os = [70];
E_dr = [70 80 60 75 6 6 6 5];

%community desirability ratings (1 to 100) (1)least desirable (100)most
%desirable
CD_apps = [82 2 2 2 3 3 3 3];
sum(CD_apps);
CD_serv = [82 2 2 2 3 3 3 3];
sum(CD_serv);
CD_os = [100];
sum(CD_os);
CD_dr = [82 2 2 2 3 3 3 3];
sum(CD_dr);
%for change over
CD_apps2 = [25 40 10 5 10 5 3 2];
sum(CD_apps2);
CD_serv2 = [70 5 3 2 5 5 5 5];
sum(CD_serv2);
CD_os2 = [100];
sum(CD_os2);
CD_dr2 = [50 20 5 5 10 5 3 2];
sum(CD_dr2);

%individual desirability ratings (1 to 100) (1)least desirable (100)most
%desirable
%MUST NOT HAVE ANY ZERO VALUES!
%do for 10 individuals
ID_apps10 = [25 40 10 5 10 5 3 2,
           20 70 1 1  5 1 1 1,
           70 20 1 1 5 1 1 1,
           39 48 5 3 2 1 1 1,
           5 10 3 2 50 15 13 2,
           1 1 5 5 48 19 20 1,
           10 15 10 15 10 10 10 20,
           20 35 3 2 10 10 5 15,
           57 10 1 1 5 5 1 20,
           10 15 10 15 10 10 10 20];
ID_apps = zeros(1000,8);
ID_apps(1:10,:) = ID_apps10;
ID_apps(11:20,:) = ID_apps10;
ID_apps(21:30,:) = ID_apps10;
ID_apps(31:40,:) = ID_apps10;
ID_apps(41:50,:) = ID_apps10;
ID_apps(51:100,:) = ID_apps(1:50,:);
ID_apps(101:200,:) = ID_apps(1:100,:);
ID_apps(201:400,:) = ID_apps(1:200,:);
ID_apps(401:800,:) = ID_apps(1:400,:);
ID_apps(801:1000,:) = ID_apps(1:200,:);
            
ID_serv10 = [70 5 3 2 5 5 5 5,
           70 5 3 2 5 5 5 5,
           60 15 3 2 5 5 5 5,
           67 7 3 2 5 1 5 10,
           5 8 7 5 13 17 20 25,
           5 8 7 5 13 17 20 25,
           12 13 12 13 12 12 12 14,
           12 23 12 13 12 12 2 14,
           12 33 12 13 12 12 2 1,
           12 13 12 13 12 12 12 14] ; 
ID_serv = zeros(1000,8);
ID_serv(1:10,:) = ID_serv10;
ID_serv(11:20,:) = ID_serv10;
ID_serv(21:30,:) = ID_serv10;
ID_serv(31:40,:) = ID_serv10;
ID_serv(41:50,:) = ID_serv10;
ID_serv(51:100,:) = ID_serv(1:50,:);
ID_serv(101:200,:) = ID_serv(1:100,:);
ID_serv(201:400,:) = ID_serv(1:200,:);
ID_serv(401:800,:) = ID_serv(1:400,:);
ID_serv(801:1000,:) = ID_serv(1:200,:);
                          
ID_os10 = [100,
         100,
         100,
         100,
         100,
         100,
         100,
         100,
         100,
         100] ;  
ID_os = zeros(1000,1);
ID_os(1:10,:) = ID_os10;
ID_os(11:20,:) = ID_os10;
ID_os(21:30,:) = ID_os10;
ID_os(31:40,:) = ID_os10;
ID_os(41:50,:) = ID_os10;
ID_os(51:100,:) = ID_os(1:50,:);
ID_os(101:200,:) = ID_os(1:100,:);
ID_os(201:400,:) = ID_os(1:200,:);
ID_os(401:800,:) = ID_os(1:400,:);
ID_os(801:1000,:) = ID_os(1:200,:);
     
ID_dr10 = [50 20 5 5 10 5 3 2,
         20 50 10 10 4 3 1 2,
         20 50 10 10 4 3 1 2,
         1 86 5 2 1 1 1 3,
         1 2 1 18 18 20 20 20,
         1 2 1 8 18 20 20 30 ,
         10 15 5 20 10 15 10 15,
         10 25 15 10 10 10 10 10,           
         10 35 15 10 5 10 5 10,
         10 15 5 20 13 13 12 12];
ID_dr = zeros(1000,8);
ID_dr(1:10,:) = ID_dr10;
ID_dr(11:20,:) = ID_dr10;
ID_dr(21:30,:) = ID_dr10;
ID_dr(31:40,:) = ID_dr10;
ID_dr(41:50,:) = ID_dr10;
ID_dr(51:100,:) = ID_dr(1:50,:);
ID_dr(101:200,:) = ID_dr(1:100,:);
ID_dr(201:400,:) = ID_dr(1:200,:);
ID_dr(401:800,:) = ID_dr(1:400,:);
ID_dr(801:1000,:) = ID_dr(1:200,:);
     E_apps2 = E_apps;
E_serv2 = E_serv;
E_os2 = E_os;
E_dr2 = E_dr;     
ID_apps2 = ID_apps;
ID_serv2 = ID_serv;
ID_os2 = ID_os;
ID_dr2 = ID_dr;
%INDIVIDUAL TIME ARRAY OF CHANGES TO PERSONAL INDIVIDUAL DESIRABILITIES
%needs to be set here because numNodes is different for each case
numNodes = 1000;
IDtimeArray1 = zeros(1,numNodes);
IDtimeArray2 = zeros(1,numNodes);

    case 28

% set up data - Dataset 22 - 2 os same but 20 other options
%%%%%%%%%%%%%
numNodes = 1000
%software strings
%WebBrowser1,6 - commercial products, WebBrowser2,3,4,5 third party
SW_str_apps = ['WebBrowser1v1 ' 'WebBrowser1v2 ' 'WebBrowser2v1 ' 'WebBrowser3v1 ' 'WebBrowser4v1 ' 'WebBrowser5v1 ' 'WebBrowser6v1 ' 'WebBrowser6v4 ' 'web9 ' 'web10 ' 'web11 ' 'web12 ' 'web13 ' 'web14 ' 'web15 ' 'web16 ' 'web17 ' 'web18 ' 'web19 ' 'web20 '];
%All photo viewers about same standard with number 7 slightly better
SW_str_serv = ['PhotoViewer1 ' 'PhotoViewer2 ' 'PhotoViewer3 ' 'PhotoViewer4 ' 'PhotoViewer5 ' 'PhotoViewer6 ' 'PhotoViewer7v1 ' 'PhotoViewer7v2 ' 'ph9 ' 'ph10 ' 'ph11 ' 'ph12 ' 'ph13 ' 'ph14 ' 'ph15 ' 'ph16 ' 'ph17 ' 'ph18 ' 'ph19 ' 'ph20 '];
%OS2 slightly more efficient overall than OS1
SW_str_os = ['OS1 ' 'OS2 '];
%higher versions are better than lower number versions, the commercial
%products are more efficient than the freebies 3rd party
SW_str_dr = ['DataDr1v1 ' 'DataDr1v2 ' 'DataDr2v1 ' 'DataDr3v3 ' 'DataDr4 ' 'DataDr5 ' 'DataDr6 ' 'DataDr7 ' 'dr9 ' 'dr10 ' 'dr11 ' 'dr12 ' 'dr13 ' 'dr14 ' 'dr15 ' 'dr16 ' 'dr17 ' 'dr18 ' 'dr19 ' 'dr20 '];

%software frequency info for running the frequency and nei diversity index
%algorithm
%locusApps - 'a' represents major variants, 'V' represents a minor version
%locusServ - 's' represents major variants, 'V' represents a minor version
%locusOS  - 'o' represents major variants, 'V' represents a minor version
SW_freq_apps = ['a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a' 'V';'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a' 'V'];
SW_freq_serv = ['s', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's' 'V'; 's' 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's' 'V'; 's' 'V'];
SW_freq_os = ['o', 'V'; 'o', 'V'];
SW_freq_dr = ['d', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd' 'V'; 'd' 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd' 'V'; 'd' 'V'];

%compatability of software
CSW_str_apps = ['a'; 'a'; 'a'; 'a'; 'a'; 'a'; 'a'; 'a'; 'a'; 'a'; 'b'; 'b'; 'b'; 'b'; 'b'; 'b'; 'b'; 'b'; 'b'; 'b'];
CSW_str_serv = ['a'; 'a'; 'a'; 'a'; 'a'; 'a'; 'a'; 'a'; 'a'; 'a'; 'b'; 'b'; 'b'; 'b'; 'b'; 'b'; 'b'; 'b'; 'b'; 'b'];
CSW_str_os = ['a'; 'b'];
CSW_str_dr = ['a'; 'a'; 'a'; 'a'; 'a'; 'a'; 'a'; 'a'; 'a'; 'a'; 'b'; 'b'; 'b'; 'b'; 'b'; 'b'; 'b'; 'b'; 'b'; 'b'];
CSW = [CSW_str_apps; CSW_str_serv; CSW_str_os; CSW_str_dr];
%create two filters
CSW1 = zeros(size(CSW));
CSW2 = zeros(size(CSW));
CSW3 = zeros(size(CSW));
CSW4 = zeros(size(CSW));
CSW5 = zeros(size(CSW));
CSW6 = zeros(size(CSW));
CSW7 = zeros(size(CSW));
CSW8 = zeros(size(CSW));
CSW9 = zeros(size(CSW));
CSW10 = zeros(size(CSW));
for z = 1:size(CSW)
  if CSW(z) ==  'a'
      CSW1(z) = 1;
  end;
  if CSW(z) ==  'b'
      CSW2(z) = 1;
  end;
end; %end for z
CSW1 = CSW1';
CSW2 = CSW2';
CSW3 = CSW3';
CSW4 = CSW4';
CSW5 = CSW5';
CSW6 = CSW6';
CSW7 = CSW7';
CSW8 = CSW8';
CSW9 = CSW9';
CSW10 = CSW10';
CSWGroup(1,:) = CSW1;
CSWGroup(2,:) = CSW2;


% set up genotypes for each of the 1000 nodes
Genotype_apps = zeros(1000,20);
Genotype_apps(1:500,2)=1;
Genotype_apps(501:1000,20)=1;

Genotype_serv = zeros(1000,20);
Genotype_serv(1:500,1)=1;
Genotype_serv(501:1000,20)=1;
             
Genotype_os = zeros(1000,2);
Genotype_os(1:500,1)=1;
Genotype_os(501:1000,2)=1;

Genotype_dr = zeros(1000,20);
Genotype_dr(1:500,1)=1;
Genotype_dr(501:1000,20)=1;           

%efficiency/quality ratings of software (1 to 100) 
%(1)inefficient (100)maximum efficiency
%case 28
E_apps = [65 75 55 50 60 60 60 80 10 10 65 75 55 50 60 60 60 80 10 10];
E_serv = [65 66 67 63 59 62 72 77 10 10 65 75 55 50 60 60 60 80 10 10];
E_os = [1 80];
E_dr = [70 80 60 75 69 68 63 58 10 10 65 75 55 50 60 60 60 80 10 10];

E_apps2 = [1 1 1 50 60 60 60 80 60 80 1 1 1 50 60 60 60 80 60 80];
E_serv2 = [1 1 1 63 59 62 72 77 77 77 1 1 1 50 60 60 60 80 60 80];
E_os2 = [1 85];
E_dr2 = [1 1 1 75 69 68 63 58 77 77 1 1 1 50 60 60 60 80 60 80];

%community desirability ratings (1 to 100) (1)least desirable (100)most
%desirable
CD_apps = [81 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1];
sum(CD_apps);
CD_serv = [81 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1];
sum(CD_serv);
CD_os = [98 2];
sum(CD_os);
CD_dr = [81 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1];
sum(CD_dr);

%for change over
CD_apps2 = [52 2 2 2 2 2 2 2 2 2 3 3 3 3 3 3 3 3 3 3];
sum(CD_apps2);
CD_serv2 = [52 2 2 2 2 2 2 2 2 2 3 3 3 3 3 3 3 3 3 3];
sum(CD_serv2);
CD_os2 = [30 70];
sum(CD_os2);
CD_dr2 = [52 2 2 2 2 2 2 2 2 2 3 3 3 3 3 3 3 3 3 3];
sum(CD_dr2);

%individual desirability ratings (1 to 100) (1)least desirable (100)most
%desirable
%MUST NOT HAVE ANY ZERO VALUES!
%do for 10 individuals
ID_apps10 = [15 40 10 5 10 3 3 2 1 1 1 1 1 1 1 1 1 1 1 1,
           20 60 1 1  3 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1,
           60 20 1 1 3 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1,
           29 48 3 3 2 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1,
           5 10 3 2 40 13 13 2 1 1 1 1 1 1 1 1 1 1 1 1,
           1 1 5 3 38 19 20 1 1 1 1 1 1 1 1 1 1 1 1 1,
           10 15 10 5 8 10 10 20 1 1 1 1 1 1 1 1 1 1 1 1,
           20 25 3 2 8 10 5 15 1 1 1 1 1 1 1 1 1 1 1 1,
           47 10 1 1 5 3 1 20 1 1 1 1 1 1 1 1 1 1 1 1,
           10 15 10 5 8 10 10 20 1 1 1 1 1 1 1 1 1 1 1 1];
ID_apps = zeros(1000,20);
ID_apps(1:10,:) = ID_apps10;
ID_apps(11:20,:) = ID_apps10;
ID_apps(21:30,:) = ID_apps10;
ID_apps(31:40,:) = ID_apps10;
ID_apps(41:50,:) = ID_apps10;
ID_apps(51:100,:) = ID_apps(1:50,:);
ID_apps(101:200,:) = ID_apps(1:100,:);
ID_apps(201:400,:) = ID_apps(1:200,:);
ID_apps(401:800,:) = ID_apps(1:400,:);
ID_apps(801:1000,:) = ID_apps(1:200,:);
            
ID_serv10 = [60 5 3 2 3 5 5 5 1 1 1 1 1 1 1 1 1 1 1 1,
           60 3 3 2 5 5 5 5 1 1 1 1 1 1 1 1 1 1 1 1,
           50 13 3 2 5 5 5 5 1 1 1 1 1 1 1 1 1 1 1 1,
           57 7 3 2 5 1 5 8 1 1 1 1 1 1 1 1 1 1 1 1,
           5 8 7 5 13 17 10 23 1 1 1 1 1 1 1 1 1 1 1 1,
           5 8 7 5 13 17 18 15 1 1 1 1 1 1 1 1 1 1 1 1,
           12 13 12 3 10 12 12 14 1 1 1 1 1 1 1 1 1 1 1 1,
           12 23 12 13 12 10 2 4 1 1 1 1 1 1 1 1 1 1 1 1,
           12 23 10 13 12 12 2 4 1 1 1 1 1 1 1 1 1 1 1 1,
           12 3 12 13 12 12 10 14 1 1 1 1 1 1 1 1 1 1 1 1] ; 
ID_serv = zeros(1000,20);
ID_serv(1:10,:) = ID_serv10;
ID_serv(11:20,:) = ID_serv10;
ID_serv(21:30,:) = ID_serv10;
ID_serv(31:40,:) = ID_serv10;
ID_serv(41:50,:) = ID_serv10;
ID_serv(51:100,:) = ID_serv(1:50,:);
ID_serv(101:200,:) = ID_serv(1:100,:);
ID_serv(201:400,:) = ID_serv(1:200,:);
ID_serv(401:800,:) = ID_serv(1:400,:);
ID_serv(801:1000,:) = ID_serv(1:200,:);
%filtered more than ideal                          
%ID_os10 = [80 20,
%         90 10,
%         90 10,
%         97 3,
%         20 80,
%         10 90,
%         50 50,
%         60 40,
%         70 30,
%         50 50] ; 

%filtered less than ideal
     ID_os10 = [99 1,
         99 1,
         99 1,
         99 1,
         99 1,
         99 1,
         99 1,
         99 1,
         99 1,
         99 1] ; 
ID_os = zeros(1000,2);
ID_os(1:10,:) = ID_os10;
ID_os(11:20,:) = ID_os10;
ID_os(21:30,:) = ID_os10;
ID_os(31:40,:) = ID_os10;
ID_os(41:50,:) = ID_os10;
ID_os(51:100,:) = ID_os(1:50,:);
ID_os(101:200,:) = ID_os(1:100,:);
ID_os(201:400,:) = ID_os(1:200,:);
ID_os(401:800,:) = ID_os(1:400,:);
ID_os(801:1000,:) = ID_os(1:200,:);
     
ID_dr10 = [40 18 5 5 10 5 3 2 1 1 1 1 1 1 1 1 1 1 1 1,
         20 40 10 10 2 3 1 2 1 1 1 1 1 1 1 1 1 1 1 1,
         20 40 10 8 4 3 1 2 1 1 1 1 1 1 1 1 1 1 1 1,
         1 76 3 2 1 1 1 3 1 1 1 1 1 1 1 1 1 1 1 1,
         1 2 1 8 18 18 20 20 1 1 1 1 1 1 1 1 1 1 1 1,
         1 2 1 8 18 20 20 18 1 1 1 1 1 1 1 1 1 1 1 1,
         10 15 5 8 10 15 10 15 1 1 1 1 1 1 1 1 1 1 1 1,
         10 25 5 8 10 10 10 10 1 1 1 1 1 1 1 1 1 1 1 1,           
         10 25 15 10 5 10 5 8 1 1 1 1 1 1 1 1 1 1 1 1,
         10 15 5 10 11 13 12 12 1 1 1 1 1 1 1 1 1 1 1 1];
ID_dr = zeros(1000,20);
ID_dr(1:10,:) = ID_dr10;
ID_dr(11:20,:) = ID_dr10;
ID_dr(21:30,:) = ID_dr10;
ID_dr(31:40,:) = ID_dr10;
ID_dr(41:50,:) = ID_dr10;
ID_dr(51:100,:) = ID_dr(1:50,:);
ID_dr(101:200,:) = ID_dr(1:100,:);
ID_dr(201:400,:) = ID_dr(1:200,:);
ID_dr(401:800,:) = ID_dr(1:400,:);
ID_dr(801:1000,:) = ID_dr(1:200,:);

     ID_apps2 = ID_apps;
     ID_os2 = ID_os;
     ID_dr2 = ID_dr;
ID_serv2 = ID_serv;
    %INDIVIDUAL TIME ARRAY OF CHANGES TO PERSONAL INDIVIDUAL DESIRABILITIES
    numNodes=1000
IDtimeArray1 = zeros(1,numNodes);
IDtimeArray2 = zeros(1,numNodes);

    case 29

% set up data - Dataset 22 - 2 os same but 20 other options
numNodes=20
%%%%%%%%%%%%%
%software strings
%WebBrowser1,6 - commercial products, WebBrowser2,3,4,5 third party
SW_str_apps = ['WebBrowser1v1 ' 'WebBrowser1v2 ' 'WebBrowser2v1 ' 'WebBrowser3v1 ' 'WebBrowser4v1 ' 'WebBrowser5v1 ' 'WebBrowser6v1 ' 'WebBrowser6v4 ' 'web9 ' 'web10 ' 'web11 ' 'web12 ' 'web13 ' 'web14 ' 'web15 ' 'web16 ' 'web17 ' 'web18 ' 'web19 ' 'web20 '];
%All photo viewers about same standard with number 7 slightly better
SW_str_serv = ['PhotoViewer1 ' 'PhotoViewer2 ' 'PhotoViewer3 ' 'PhotoViewer4 ' 'PhotoViewer5 ' 'PhotoViewer6 ' 'PhotoViewer7v1 ' 'PhotoViewer7v2 ' 'ph9 ' 'ph10 ' 'ph11 ' 'ph12 ' 'ph13 ' 'ph14 ' 'ph15 ' 'ph16 ' 'ph17 ' 'ph18 ' 'ph19 ' 'ph20 '];
%OS2 slightly more efficient overall than OS1
SW_str_os = ['OS1 ' 'OS2 '];
%higher versions are better than lower number versions, the commercial
%products are more efficient than the freebies 3rd party
SW_str_dr = ['DataDr1v1 ' 'DataDr1v2 ' 'DataDr2v1 ' 'DataDr3v3 ' 'DataDr4 ' 'DataDr5 ' 'DataDr6 ' 'DataDr7 ' 'dr9 ' 'dr10 ' 'dr11 ' 'dr12 ' 'dr13 ' 'dr14 ' 'dr15 ' 'dr16 ' 'dr17 ' 'dr18 ' 'dr19 ' 'dr20 '];

%software frequency info for running the frequency and nei diversity index
%algorithm
%locusApps - 'a' represents major variants, 'V' represents a minor version
%locusServ - 's' represents major variants, 'V' represents a minor version
%locusOS  - 'o' represents major variants, 'V' represents a minor version
SW_freq_apps = ['a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a' 'V';'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a' 'V'];
SW_freq_serv = ['s', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's' 'V'; 's' 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's' 'V'; 's' 'V'];
SW_freq_os = ['o', 'V'; 'o', 'V'];
SW_freq_dr = ['d', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd' 'V'; 'd' 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd' 'V'; 'd' 'V'];

%compatability of software
CSW_str_apps = ['a'; 'a'; 'a'; 'a'; 'a'; 'a'; 'a'; 'a'; 'a'; 'a'; 'b'; 'b'; 'b'; 'b'; 'b'; 'b'; 'b'; 'b'; 'b'; 'b'];
CSW_str_serv = ['a'; 'a'; 'a'; 'a'; 'a'; 'a'; 'a'; 'a'; 'a'; 'a'; 'b'; 'b'; 'b'; 'b'; 'b'; 'b'; 'b'; 'b'; 'b'; 'b'];
CSW_str_os = ['a'; 'b'];
CSW_str_dr = ['a'; 'a'; 'a'; 'a'; 'a'; 'a'; 'a'; 'a'; 'a'; 'a'; 'b'; 'b'; 'b'; 'b'; 'b'; 'b'; 'b'; 'b'; 'b'; 'b'];
CSW = [CSW_str_apps; CSW_str_serv; CSW_str_os; CSW_str_dr];
%create two filters
CSW1 = zeros(size(CSW));
CSW2 = zeros(size(CSW));
CSW3 = zeros(size(CSW));
CSW4 = zeros(size(CSW));
CSW5 = zeros(size(CSW));
CSW6 = zeros(size(CSW));
CSW7 = zeros(size(CSW));
CSW8 = zeros(size(CSW));
CSW9 = zeros(size(CSW));
CSW10 = zeros(size(CSW));
for z = 1:size(CSW)
  if CSW(z) ==  'a'
      CSW1(z) = 1;
  end;
  if CSW(z) ==  'b'
      CSW2(z) = 1;
  end;
end; %end for z
CSW1 = CSW1';
CSW2 = CSW2';
CSW3 = CSW3';
CSW4 = CSW4';
CSW5 = CSW5';
CSW6 = CSW6';
CSW7 = CSW7';
CSW8 = CSW8';
CSW9 = CSW9';
CSW10 = CSW10';
CSWGroup(1,:) = CSW1;
CSWGroup(2,:) = CSW2;


% set up genotypes for each of the nodes
stop1 = numNodes/2;
start2 = stop1+1;

Genotype_apps = zeros(numNodes,20);
Genotype_apps(1:stop1,2)=1;
Genotype_apps(start2:numNodes,20)=1;

Genotype_serv = zeros(numNodes,20);
Genotype_serv(1:stop1,1)=1;
Genotype_serv(start2:numNodes,20)=1;
             
Genotype_os = zeros(numNodes,2);
Genotype_os(1:stop1,1)=1;
Genotype_os(start2:numNodes,2)=1;

Genotype_dr = zeros(numNodes,20);
Genotype_dr(1:stop1,1)=1;
Genotype_dr(start2:numNodes,20)=1;           

%efficiency/quality ratings of software (1 to 100) 
%(1)inefficient (100)maximum efficiency
%case 28
E_apps = [65 75 55 50 60 60 60 80 10 10 65 75 55 50 60 60 60 80 10 10];
E_serv = [65 66 67 63 59 62 72 77 10 10 65 75 55 50 60 60 60 80 10 10];
E_os = [1 80];
E_dr = [70 80 60 75 69 68 63 58 10 10 65 75 55 50 60 60 60 80 10 10];

E_apps2 = [1 1 1 50 60 60 60 80 60 80 1 1 1 50 60 60 60 80 60 80];
E_serv2 = [1 1 1 63 59 62 72 77 77 77 1 1 1 50 60 60 60 80 60 80];
E_os2 = [1 85];
E_dr2 = [1 1 1 75 69 68 63 58 77 77 1 1 1 50 60 60 60 80 60 80];

%community desirability ratings (1 to 100) (1)least desirable (100)most
%desirable
CD_apps = [81 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1];
sum(CD_apps);
CD_serv = [81 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1];
sum(CD_serv);
CD_os = [98 2];
sum(CD_os);
CD_dr = [81 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1];
sum(CD_dr);

%for change over
CD_apps2 = [52 2 2 2 2 2 2 2 2 2 3 3 3 3 3 3 3 3 3 3];
sum(CD_apps2);
CD_serv2 = [52 2 2 2 2 2 2 2 2 2 3 3 3 3 3 3 3 3 3 3];
sum(CD_serv2);
CD_os2 = [30 70];
sum(CD_os2);
CD_dr2 = [52 2 2 2 2 2 2 2 2 2 3 3 3 3 3 3 3 3 3 3];
sum(CD_dr2);

%individual desirability ratings (1 to 100) (1)least desirable (100)most
%desirable
%MUST NOT HAVE ANY ZERO VALUES!
%do for 10 individuals
ID_apps10 = [15 40 10 5 10 3 3 2 1 1 1 1 1 1 1 1 1 1 1 1,
           20 60 1 1  3 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1,
           60 20 1 1 3 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1,
           29 48 3 3 2 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1,
           5 10 3 2 40 13 13 2 1 1 1 1 1 1 1 1 1 1 1 1,
           1 1 5 3 38 19 20 1 1 1 1 1 1 1 1 1 1 1 1 1,
           10 15 10 5 8 10 10 20 1 1 1 1 1 1 1 1 1 1 1 1,
           20 25 3 2 8 10 5 15 1 1 1 1 1 1 1 1 1 1 1 1,
           47 10 1 1 5 3 1 20 1 1 1 1 1 1 1 1 1 1 1 1,
           10 15 10 5 8 10 10 20 1 1 1 1 1 1 1 1 1 1 1 1];
ID_apps = zeros(numNodes,20);
ID_apps(1:10,:) = ID_apps10;
ID_apps(11:20,:) = ID_apps10;
            
ID_serv10 = [60 5 3 2 3 5 5 5 1 1 1 1 1 1 1 1 1 1 1 1,
           60 3 3 2 5 5 5 5 1 1 1 1 1 1 1 1 1 1 1 1,
           50 13 3 2 5 5 5 5 1 1 1 1 1 1 1 1 1 1 1 1,
           57 7 3 2 5 1 5 8 1 1 1 1 1 1 1 1 1 1 1 1,
           5 8 7 5 13 17 10 23 1 1 1 1 1 1 1 1 1 1 1 1,
           5 8 7 5 13 17 18 15 1 1 1 1 1 1 1 1 1 1 1 1,
           12 13 12 3 10 12 12 14 1 1 1 1 1 1 1 1 1 1 1 1,
           12 23 12 13 12 10 2 4 1 1 1 1 1 1 1 1 1 1 1 1,
           12 23 10 13 12 12 2 4 1 1 1 1 1 1 1 1 1 1 1 1,
           12 3 12 13 12 12 10 14 1 1 1 1 1 1 1 1 1 1 1 1] ; 
ID_serv = zeros(numNodes,20);
ID_serv(1:10,:) = ID_serv10;
ID_serv(11:20,:) = ID_serv10;

%filtered less than ideal
     ID_os10 = [99 1,
         99 1,
         99 1,
         99 1,
         99 1,
         99 1,
         99 1,
         99 1,
         99 1,
         99 1] ; 
ID_os = zeros(numNodes,2);
ID_os(1:10,:) = ID_os10;
ID_os(11:20,:) = ID_os10;
     
ID_dr10 = [40 18 5 5 10 5 3 2 1 1 1 1 1 1 1 1 1 1 1 1,
         20 40 10 10 2 3 1 2 1 1 1 1 1 1 1 1 1 1 1 1,
         20 40 10 8 4 3 1 2 1 1 1 1 1 1 1 1 1 1 1 1,
         1 76 3 2 1 1 1 3 1 1 1 1 1 1 1 1 1 1 1 1,
         1 2 1 8 18 18 20 20 1 1 1 1 1 1 1 1 1 1 1 1,
         1 2 1 8 18 20 20 18 1 1 1 1 1 1 1 1 1 1 1 1,
         10 15 5 8 10 15 10 15 1 1 1 1 1 1 1 1 1 1 1 1,
         10 25 5 8 10 10 10 10 1 1 1 1 1 1 1 1 1 1 1 1,           
         10 25 15 10 5 10 5 8 1 1 1 1 1 1 1 1 1 1 1 1,
         10 15 5 10 11 13 12 12 1 1 1 1 1 1 1 1 1 1 1 1];
ID_dr = zeros(numNodes,20);
ID_dr(1:10,:) = ID_dr10;
ID_dr(11:20,:) = ID_dr10;

     ID_apps2 = ID_apps;
     ID_os2 = ID_os;
     ID_dr2 = ID_dr;
ID_serv2 = ID_serv;
    %INDIVIDUAL TIME ARRAY OF CHANGES TO PERSONAL INDIVIDUAL DESIRABILITIES
IDtimeArray1 = zeros(1,numNodes);
IDtimeArray2 = zeros(1,numNodes);

    case 30

% set up data - Dataset 22 - 2 os same but 20 other options
%%%%%%%%%%%%%
numNodes = 50
%software strings
%WebBrowser1,6 - commercial products, WebBrowser2,3,4,5 third party
SW_str_apps = ['WebBrowser1v1 ' 'WebBrowser1v2 ' 'WebBrowser2v1 ' 'WebBrowser3v1 ' 'WebBrowser4v1 ' 'WebBrowser5v1 ' 'WebBrowser6v1 ' 'WebBrowser6v4 ' 'web9 ' 'web10 ' 'web11 ' 'web12 ' 'web13 ' 'web14 ' 'web15 ' 'web16 ' 'web17 ' 'web18 ' 'web19 ' 'web20 '];
%All photo viewers about same standard with number 7 slightly better
SW_str_serv = ['PhotoViewer1 ' 'PhotoViewer2 ' 'PhotoViewer3 ' 'PhotoViewer4 ' 'PhotoViewer5 ' 'PhotoViewer6 ' 'PhotoViewer7v1 ' 'PhotoViewer7v2 ' 'ph9 ' 'ph10 ' 'ph11 ' 'ph12 ' 'ph13 ' 'ph14 ' 'ph15 ' 'ph16 ' 'ph17 ' 'ph18 ' 'ph19 ' 'ph20 '];
%OS2 slightly more efficient overall than OS1
SW_str_os = ['OS1 ' 'OS2 '];
%higher versions are better than lower number versions, the commercial
%products are more efficient than the freebies 3rd party
SW_str_dr = ['DataDr1v1 ' 'DataDr1v2 ' 'DataDr2v1 ' 'DataDr3v3 ' 'DataDr4 ' 'DataDr5 ' 'DataDr6 ' 'DataDr7 ' 'dr9 ' 'dr10 ' 'dr11 ' 'dr12 ' 'dr13 ' 'dr14 ' 'dr15 ' 'dr16 ' 'dr17 ' 'dr18 ' 'dr19 ' 'dr20 '];

%software frequency info for running the frequency and nei diversity index
%algorithm
%locusApps - 'a' represents major variants, 'V' represents a minor version
%locusServ - 's' represents major variants, 'V' represents a minor version
%locusOS  - 'o' represents major variants, 'V' represents a minor version
SW_freq_apps = ['a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a' 'V';'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a' 'V'];
SW_freq_serv = ['s', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's' 'V'; 's' 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's' 'V'; 's' 'V'];
SW_freq_os = ['o', 'V'; 'o', 'V'];
SW_freq_dr = ['d', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd' 'V'; 'd' 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd' 'V'; 'd' 'V'];

%compatability of software
CSW_str_apps = ['a'; 'a'; 'a'; 'a'; 'a'; 'a'; 'a'; 'a'; 'a'; 'a'; 'b'; 'b'; 'b'; 'b'; 'b'; 'b'; 'b'; 'b'; 'b'; 'b'];
CSW_str_serv = ['a'; 'a'; 'a'; 'a'; 'a'; 'a'; 'a'; 'a'; 'a'; 'a'; 'b'; 'b'; 'b'; 'b'; 'b'; 'b'; 'b'; 'b'; 'b'; 'b'];
CSW_str_os = ['a'; 'b'];
CSW_str_dr = ['a'; 'a'; 'a'; 'a'; 'a'; 'a'; 'a'; 'a'; 'a'; 'a'; 'b'; 'b'; 'b'; 'b'; 'b'; 'b'; 'b'; 'b'; 'b'; 'b'];
CSW = [CSW_str_apps; CSW_str_serv; CSW_str_os; CSW_str_dr];
%create two filters
CSW1 = zeros(size(CSW));
CSW2 = zeros(size(CSW));
CSW3 = zeros(size(CSW));
CSW4 = zeros(size(CSW));
CSW5 = zeros(size(CSW));
CSW6 = zeros(size(CSW));
CSW7 = zeros(size(CSW));
CSW8 = zeros(size(CSW));
CSW9 = zeros(size(CSW));
CSW10 = zeros(size(CSW));
for z = 1:size(CSW)
  if CSW(z) ==  'a'
      CSW1(z) = 1;
  end;
  if CSW(z) ==  'b'
      CSW2(z) = 1;
  end;
end; %end for z
CSW1 = CSW1';
CSW2 = CSW2';
CSW3 = CSW3';
CSW4 = CSW4';
CSW5 = CSW5';
CSW6 = CSW6';
CSW7 = CSW7';
CSW8 = CSW8';
CSW9 = CSW9';
CSW10 = CSW10';
CSWGroup(1,:) = CSW1;
CSWGroup(2,:) = CSW2;


% set up genotypes for each of the  nodes
stop1 = numNodes/2;
start2 = stop1+1;

Genotype_apps = zeros(numNodes,20);
Genotype_apps(1:stop1,2)=1;
Genotype_apps(start2:numNodes,20)=1;

Genotype_serv = zeros(numNodes,20);
Genotype_serv(1:stop1,1)=1;
Genotype_serv(start2:numNodes,20)=1;
             
Genotype_os = zeros(numNodes,2);
Genotype_os(1:stop1,1)=1;
Genotype_os(start2:numNodes,2)=1;

Genotype_dr = zeros(numNodes,20);
Genotype_dr(1:stop1,1)=1;
Genotype_dr(start2:numNodes,20)=1;           

%efficiency/quality ratings of software (1 to 100) 
%(1)inefficient (100)maximum efficiency
%case 28
E_apps = [65 75 55 50 60 60 60 80 10 10 65 75 55 50 60 60 60 80 10 10];
E_serv = [65 66 67 63 59 62 72 77 10 10 65 75 55 50 60 60 60 80 10 10];
E_os = [1 80];
E_dr = [70 80 60 75 69 68 63 58 10 10 65 75 55 50 60 60 60 80 10 10];

E_apps2 = [1 1 1 50 60 60 60 80 60 80 1 1 1 50 60 60 60 80 60 80];
E_serv2 = [1 1 1 63 59 62 72 77 77 77 1 1 1 50 60 60 60 80 60 80];
E_os2 = [1 85];
E_dr2 = [1 1 1 75 69 68 63 58 77 77 1 1 1 50 60 60 60 80 60 80];

%community desirability ratings (1 to 100) (1)least desirable (100)most
%desirable
CD_apps = [81 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1];
sum(CD_apps);
CD_serv = [81 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1];
sum(CD_serv);
CD_os = [98 2];
sum(CD_os);
CD_dr = [81 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1];
sum(CD_dr);

%for change over
CD_apps2 = [52 2 2 2 2 2 2 2 2 2 3 3 3 3 3 3 3 3 3 3];
sum(CD_apps2);
CD_serv2 = [52 2 2 2 2 2 2 2 2 2 3 3 3 3 3 3 3 3 3 3];
sum(CD_serv2);
CD_os2 = [30 70];
sum(CD_os2);
CD_dr2 = [52 2 2 2 2 2 2 2 2 2 3 3 3 3 3 3 3 3 3 3];
sum(CD_dr2);

%individual desirability ratings (1 to 100) (1)least desirable (100)most
%desirable
%MUST NOT HAVE ANY ZERO VALUES!
%do for 10 individuals
ID_apps10 = [15 40 10 5 10 3 3 2 1 1 1 1 1 1 1 1 1 1 1 1,
           20 60 1 1  3 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1,
           60 20 1 1 3 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1,
           29 48 3 3 2 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1,
           5 10 3 2 40 13 13 2 1 1 1 1 1 1 1 1 1 1 1 1,
           1 1 5 3 38 19 20 1 1 1 1 1 1 1 1 1 1 1 1 1,
           10 15 10 5 8 10 10 20 1 1 1 1 1 1 1 1 1 1 1 1,
           20 25 3 2 8 10 5 15 1 1 1 1 1 1 1 1 1 1 1 1,
           47 10 1 1 5 3 1 20 1 1 1 1 1 1 1 1 1 1 1 1,
           10 15 10 5 8 10 10 20 1 1 1 1 1 1 1 1 1 1 1 1];
ID_apps = zeros(numNodes,20);
ID_apps(1:10,:) = ID_apps10;
ID_apps(11:20,:) = ID_apps10;
ID_apps(21:30,:) = ID_apps10;
ID_apps(31:40,:) = ID_apps10;
ID_apps(41:50,:) = ID_apps10;
            
ID_serv10 = [60 5 3 2 3 5 5 5 1 1 1 1 1 1 1 1 1 1 1 1,
           60 3 3 2 5 5 5 5 1 1 1 1 1 1 1 1 1 1 1 1,
           50 13 3 2 5 5 5 5 1 1 1 1 1 1 1 1 1 1 1 1,
           57 7 3 2 5 1 5 8 1 1 1 1 1 1 1 1 1 1 1 1,
           5 8 7 5 13 17 10 23 1 1 1 1 1 1 1 1 1 1 1 1,
           5 8 7 5 13 17 18 15 1 1 1 1 1 1 1 1 1 1 1 1,
           12 13 12 3 10 12 12 14 1 1 1 1 1 1 1 1 1 1 1 1,
           12 23 12 13 12 10 2 4 1 1 1 1 1 1 1 1 1 1 1 1,
           12 23 10 13 12 12 2 4 1 1 1 1 1 1 1 1 1 1 1 1,
           12 3 12 13 12 12 10 14 1 1 1 1 1 1 1 1 1 1 1 1] ; 
ID_serv = zeros(numNodes,20);
ID_serv(1:10,:) = ID_serv10;
ID_serv(11:20,:) = ID_serv10;
ID_serv(21:30,:) = ID_serv10;
ID_serv(31:40,:) = ID_serv10;
ID_serv(41:50,:) = ID_serv10;

%filtered less than ideal
     ID_os10 = [99 1,
         99 1,
         99 1,
         99 1,
         99 1,
         99 1,
         99 1,
         99 1,
         99 1,
         99 1] ; 
ID_os = zeros(numNodes,2);
ID_os(1:10,:) = ID_os10;
ID_os(11:20,:) = ID_os10;
ID_os(21:30,:) = ID_os10;
ID_os(31:40,:) = ID_os10;
ID_os(41:50,:) = ID_os10;
     
ID_dr10 = [40 18 5 5 10 5 3 2 1 1 1 1 1 1 1 1 1 1 1 1,
         20 40 10 10 2 3 1 2 1 1 1 1 1 1 1 1 1 1 1 1,
         20 40 10 8 4 3 1 2 1 1 1 1 1 1 1 1 1 1 1 1,
         1 76 3 2 1 1 1 3 1 1 1 1 1 1 1 1 1 1 1 1,
         1 2 1 8 18 18 20 20 1 1 1 1 1 1 1 1 1 1 1 1,
         1 2 1 8 18 20 20 18 1 1 1 1 1 1 1 1 1 1 1 1,
         10 15 5 8 10 15 10 15 1 1 1 1 1 1 1 1 1 1 1 1,
         10 25 5 8 10 10 10 10 1 1 1 1 1 1 1 1 1 1 1 1,           
         10 25 15 10 5 10 5 8 1 1 1 1 1 1 1 1 1 1 1 1,
         10 15 5 10 11 13 12 12 1 1 1 1 1 1 1 1 1 1 1 1];
ID_dr = zeros(50,20);
ID_dr(1:10,:) = ID_dr10;
ID_dr(11:20,:) = ID_dr10;
ID_dr(21:30,:) = ID_dr10;
ID_dr(31:40,:) = ID_dr10;
ID_dr(41:50,:) = ID_dr10;

     ID_apps2 = ID_apps;
     ID_os2 = ID_os;
     ID_dr2 = ID_dr;
ID_serv2 = ID_serv;
    %INDIVIDUAL TIME ARRAY OF CHANGES TO PERSONAL INDIVIDUAL DESIRABILITIES
IDtimeArray1 = zeros(1,numNodes);
IDtimeArray2 = zeros(1,numNodes);

    case 31

% set up data - Dataset 22 - 2 os same but 20 other options
%%%%%%%%%%%%%
%software strings
numNodes = 100
%WebBrowser1,6 - commercial products, WebBrowser2,3,4,5 third party
SW_str_apps = ['WebBrowser1v1 ' 'WebBrowser1v2 ' 'WebBrowser2v1 ' 'WebBrowser3v1 ' 'WebBrowser4v1 ' 'WebBrowser5v1 ' 'WebBrowser6v1 ' 'WebBrowser6v4 ' 'web9 ' 'web10 ' 'web11 ' 'web12 ' 'web13 ' 'web14 ' 'web15 ' 'web16 ' 'web17 ' 'web18 ' 'web19 ' 'web20 '];
%All photo viewers about same standard with number 7 slightly better
SW_str_serv = ['PhotoViewer1 ' 'PhotoViewer2 ' 'PhotoViewer3 ' 'PhotoViewer4 ' 'PhotoViewer5 ' 'PhotoViewer6 ' 'PhotoViewer7v1 ' 'PhotoViewer7v2 ' 'ph9 ' 'ph10 ' 'ph11 ' 'ph12 ' 'ph13 ' 'ph14 ' 'ph15 ' 'ph16 ' 'ph17 ' 'ph18 ' 'ph19 ' 'ph20 '];
%OS2 slightly more efficient overall than OS1
SW_str_os = ['OS1 ' 'OS2 '];
%higher versions are better than lower number versions, the commercial
%products are more efficient than the freebies 3rd party
SW_str_dr = ['DataDr1v1 ' 'DataDr1v2 ' 'DataDr2v1 ' 'DataDr3v3 ' 'DataDr4 ' 'DataDr5 ' 'DataDr6 ' 'DataDr7 ' 'dr9 ' 'dr10 ' 'dr11 ' 'dr12 ' 'dr13 ' 'dr14 ' 'dr15 ' 'dr16 ' 'dr17 ' 'dr18 ' 'dr19 ' 'dr20 '];

%software frequency info for running the frequency and nei diversity index
%algorithm
%locusApps - 'a' represents major variants, 'V' represents a minor version
%locusServ - 's' represents major variants, 'V' represents a minor version
%locusOS  - 'o' represents major variants, 'V' represents a minor version
SW_freq_apps = ['a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a' 'V';'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a' 'V'];
SW_freq_serv = ['s', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's' 'V'; 's' 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's' 'V'; 's' 'V'];
SW_freq_os = ['o', 'V'; 'o', 'V'];
SW_freq_dr = ['d', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd' 'V'; 'd' 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd' 'V'; 'd' 'V'];

%compatability of software
CSW_str_apps = ['a'; 'a'; 'a'; 'a'; 'a'; 'a'; 'a'; 'a'; 'a'; 'a'; 'b'; 'b'; 'b'; 'b'; 'b'; 'b'; 'b'; 'b'; 'b'; 'b'];
CSW_str_serv = ['a'; 'a'; 'a'; 'a'; 'a'; 'a'; 'a'; 'a'; 'a'; 'a'; 'b'; 'b'; 'b'; 'b'; 'b'; 'b'; 'b'; 'b'; 'b'; 'b'];
CSW_str_os = ['a'; 'b'];
CSW_str_dr = ['a'; 'a'; 'a'; 'a'; 'a'; 'a'; 'a'; 'a'; 'a'; 'a'; 'b'; 'b'; 'b'; 'b'; 'b'; 'b'; 'b'; 'b'; 'b'; 'b'];
CSW = [CSW_str_apps; CSW_str_serv; CSW_str_os; CSW_str_dr];
%create two filters
CSW1 = zeros(size(CSW));
CSW2 = zeros(size(CSW));
CSW3 = zeros(size(CSW));
CSW4 = zeros(size(CSW));
CSW5 = zeros(size(CSW));
CSW6 = zeros(size(CSW));
CSW7 = zeros(size(CSW));
CSW8 = zeros(size(CSW));
CSW9 = zeros(size(CSW));
CSW10 = zeros(size(CSW));
for z = 1:size(CSW)
  if CSW(z) ==  'a'
      CSW1(z) = 1;
  end;
  if CSW(z) ==  'b'
      CSW2(z) = 1;
  end;
end; %end for z
CSW1 = CSW1';
CSW2 = CSW2';
CSW3 = CSW3';
CSW4 = CSW4';
CSW5 = CSW5';
CSW6 = CSW6';
CSW7 = CSW7';
CSW8 = CSW8';
CSW9 = CSW9';
CSW10 = CSW10';
CSWGroup(1,:) = CSW1;
CSWGroup(2,:) = CSW2;


% set up genotypes for each of the  nodes
stop1 = numNodes/2;
start2 = stop1+1;

Genotype_apps = zeros(numNodes,20);
Genotype_apps(1:stop1,2)=1;
Genotype_apps(start2:numNodes,20)=1;

Genotype_serv = zeros(numNodes,20);
Genotype_serv(1:stop1,1)=1;
Genotype_serv(start2:numNodes,20)=1;
             
Genotype_os = zeros(numNodes,2);
Genotype_os(1:stop1,1)=1;
Genotype_os(start2:numNodes,2)=1;

Genotype_dr = zeros(numNodes,20);
Genotype_dr(1:stop1,1)=1;
Genotype_dr(start2:numNodes,20)=1;           

%efficiency/quality ratings of software (1 to 100) 
%(1)inefficient (100)maximum efficiency
%case 28
E_apps = [65 75 55 50 60 60 60 80 10 10 65 75 55 50 60 60 60 80 10 10];
E_serv = [65 66 67 63 59 62 72 77 10 10 65 75 55 50 60 60 60 80 10 10];
E_os = [1 80];
E_dr = [70 80 60 75 69 68 63 58 10 10 65 75 55 50 60 60 60 80 10 10];

E_apps2 = [1 1 1 50 60 60 60 80 60 80 1 1 1 50 60 60 60 80 60 80];
E_serv2 = [1 1 1 63 59 62 72 77 77 77 1 1 1 50 60 60 60 80 60 80];
E_os2 = [1 85];
E_dr2 = [1 1 1 75 69 68 63 58 77 77 1 1 1 50 60 60 60 80 60 80];

%community desirability ratings (1 to 100) (1)least desirable (100)most
%desirable
CD_apps = [81 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1];
sum(CD_apps);
CD_serv = [81 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1];
sum(CD_serv);
CD_os = [98 2];
sum(CD_os);
CD_dr = [81 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1];
sum(CD_dr);

%for change over
CD_apps2 = [52 2 2 2 2 2 2 2 2 2 3 3 3 3 3 3 3 3 3 3];
sum(CD_apps2);
CD_serv2 = [52 2 2 2 2 2 2 2 2 2 3 3 3 3 3 3 3 3 3 3];
sum(CD_serv2);
CD_os2 = [30 70];
sum(CD_os2);
CD_dr2 = [52 2 2 2 2 2 2 2 2 2 3 3 3 3 3 3 3 3 3 3];
sum(CD_dr2);

%individual desirability ratings (1 to 100) (1)least desirable (100)most
%desirable
%MUST NOT HAVE ANY ZERO VALUES!
%do for 10 individuals
ID_apps10 = [15 40 10 5 10 3 3 2 1 1 1 1 1 1 1 1 1 1 1 1,
           20 60 1 1  3 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1,
           60 20 1 1 3 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1,
           29 48 3 3 2 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1,
           5 10 3 2 40 13 13 2 1 1 1 1 1 1 1 1 1 1 1 1,
           1 1 5 3 38 19 20 1 1 1 1 1 1 1 1 1 1 1 1 1,
           10 15 10 5 8 10 10 20 1 1 1 1 1 1 1 1 1 1 1 1,
           20 25 3 2 8 10 5 15 1 1 1 1 1 1 1 1 1 1 1 1,
           47 10 1 1 5 3 1 20 1 1 1 1 1 1 1 1 1 1 1 1,
           10 15 10 5 8 10 10 20 1 1 1 1 1 1 1 1 1 1 1 1];
ID_apps = zeros(numNodes,20);
ID_apps(1:10,:) = ID_apps10;
ID_apps(11:20,:) = ID_apps10;
ID_apps(21:30,:) = ID_apps10;
ID_apps(31:40,:) = ID_apps10;
ID_apps(41:50,:) = ID_apps10;
ID_apps(51:100,:) = ID_apps(1:50,:);

            
ID_serv10 = [60 5 3 2 3 5 5 5 1 1 1 1 1 1 1 1 1 1 1 1,
           60 3 3 2 5 5 5 5 1 1 1 1 1 1 1 1 1 1 1 1,
           50 13 3 2 5 5 5 5 1 1 1 1 1 1 1 1 1 1 1 1,
           57 7 3 2 5 1 5 8 1 1 1 1 1 1 1 1 1 1 1 1,
           5 8 7 5 13 17 10 23 1 1 1 1 1 1 1 1 1 1 1 1,
           5 8 7 5 13 17 18 15 1 1 1 1 1 1 1 1 1 1 1 1,
           12 13 12 3 10 12 12 14 1 1 1 1 1 1 1 1 1 1 1 1,
           12 23 12 13 12 10 2 4 1 1 1 1 1 1 1 1 1 1 1 1,
           12 23 10 13 12 12 2 4 1 1 1 1 1 1 1 1 1 1 1 1,
           12 3 12 13 12 12 10 14 1 1 1 1 1 1 1 1 1 1 1 1] ; 
ID_serv = zeros(numNodes,20);
ID_serv(1:10,:) = ID_serv10;
ID_serv(11:20,:) = ID_serv10;
ID_serv(21:30,:) = ID_serv10;
ID_serv(31:40,:) = ID_serv10;
ID_serv(41:50,:) = ID_serv10;
ID_serv(51:100,:) = ID_serv(1:50,:);


%filtered less than ideal
     ID_os10 = [99 1,
         99 1,
         99 1,
         99 1,
         99 1,
         99 1,
         99 1,
         99 1,
         99 1,
         99 1] ; 
ID_os = zeros(numNodes,2);
ID_os(1:10,:) = ID_os10;
ID_os(11:20,:) = ID_os10;
ID_os(21:30,:) = ID_os10;
ID_os(31:40,:) = ID_os10;
ID_os(41:50,:) = ID_os10;
ID_os(51:100,:) = ID_os(1:50,:);
     
ID_dr10 = [40 18 5 5 10 5 3 2 1 1 1 1 1 1 1 1 1 1 1 1,
         20 40 10 10 2 3 1 2 1 1 1 1 1 1 1 1 1 1 1 1,
         20 40 10 8 4 3 1 2 1 1 1 1 1 1 1 1 1 1 1 1,
         1 76 3 2 1 1 1 3 1 1 1 1 1 1 1 1 1 1 1 1,
         1 2 1 8 18 18 20 20 1 1 1 1 1 1 1 1 1 1 1 1,
         1 2 1 8 18 20 20 18 1 1 1 1 1 1 1 1 1 1 1 1,
         10 15 5 8 10 15 10 15 1 1 1 1 1 1 1 1 1 1 1 1,
         10 25 5 8 10 10 10 10 1 1 1 1 1 1 1 1 1 1 1 1,           
         10 25 15 10 5 10 5 8 1 1 1 1 1 1 1 1 1 1 1 1,
         10 15 5 10 11 13 12 12 1 1 1 1 1 1 1 1 1 1 1 1];
ID_dr = zeros(numNodes,20);
ID_dr(1:10,:) = ID_dr10;
ID_dr(11:20,:) = ID_dr10;
ID_dr(21:30,:) = ID_dr10;
ID_dr(31:40,:) = ID_dr10;
ID_dr(41:50,:) = ID_dr10;
ID_dr(51:100,:) = ID_dr(1:50,:);

     ID_apps2 = ID_apps;
     ID_os2 = ID_os;
     ID_dr2 = ID_dr;
ID_serv2 = ID_serv;
    %INDIVIDUAL TIME ARRAY OF CHANGES TO PERSONAL INDIVIDUAL DESIRABILITIES
IDtimeArray1 = zeros(1,numNodes);
IDtimeArray2 = zeros(1,numNodes);

    case 32
numNodes = 400
% set up data - Dataset 22 - 2 os same but 20 other options
%%%%%%%%%%%%%
%software strings
%WebBrowser1,6 - commercial products, WebBrowser2,3,4,5 third party
SW_str_apps = ['WebBrowser1v1 ' 'WebBrowser1v2 ' 'WebBrowser2v1 ' 'WebBrowser3v1 ' 'WebBrowser4v1 ' 'WebBrowser5v1 ' 'WebBrowser6v1 ' 'WebBrowser6v4 ' 'web9 ' 'web10 ' 'web11 ' 'web12 ' 'web13 ' 'web14 ' 'web15 ' 'web16 ' 'web17 ' 'web18 ' 'web19 ' 'web20 '];
%All photo viewers about same standard with number 7 slightly better
SW_str_serv = ['PhotoViewer1 ' 'PhotoViewer2 ' 'PhotoViewer3 ' 'PhotoViewer4 ' 'PhotoViewer5 ' 'PhotoViewer6 ' 'PhotoViewer7v1 ' 'PhotoViewer7v2 ' 'ph9 ' 'ph10 ' 'ph11 ' 'ph12 ' 'ph13 ' 'ph14 ' 'ph15 ' 'ph16 ' 'ph17 ' 'ph18 ' 'ph19 ' 'ph20 '];
%OS2 slightly more efficient overall than OS1
SW_str_os = ['OS1 ' 'OS2 '];
%higher versions are better than lower number versions, the commercial
%products are more efficient than the freebies 3rd party
SW_str_dr = ['DataDr1v1 ' 'DataDr1v2 ' 'DataDr2v1 ' 'DataDr3v3 ' 'DataDr4 ' 'DataDr5 ' 'DataDr6 ' 'DataDr7 ' 'dr9 ' 'dr10 ' 'dr11 ' 'dr12 ' 'dr13 ' 'dr14 ' 'dr15 ' 'dr16 ' 'dr17 ' 'dr18 ' 'dr19 ' 'dr20 '];

%software frequency info for running the frequency and nei diversity index
%algorithm
%locusApps - 'a' represents major variants, 'V' represents a minor version
%locusServ - 's' represents major variants, 'V' represents a minor version
%locusOS  - 'o' represents major variants, 'V' represents a minor version
SW_freq_apps = ['a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a' 'V';'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a' 'V'];
SW_freq_serv = ['s', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's' 'V'; 's' 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's' 'V'; 's' 'V'];
SW_freq_os = ['o', 'V'; 'o', 'V'];
SW_freq_dr = ['d', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd' 'V'; 'd' 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd' 'V'; 'd' 'V'];

%compatability of software
CSW_str_apps = ['a'; 'a'; 'a'; 'a'; 'a'; 'a'; 'a'; 'a'; 'a'; 'a'; 'b'; 'b'; 'b'; 'b'; 'b'; 'b'; 'b'; 'b'; 'b'; 'b'];
CSW_str_serv = ['a'; 'a'; 'a'; 'a'; 'a'; 'a'; 'a'; 'a'; 'a'; 'a'; 'b'; 'b'; 'b'; 'b'; 'b'; 'b'; 'b'; 'b'; 'b'; 'b'];
CSW_str_os = ['a'; 'b'];
CSW_str_dr = ['a'; 'a'; 'a'; 'a'; 'a'; 'a'; 'a'; 'a'; 'a'; 'a'; 'b'; 'b'; 'b'; 'b'; 'b'; 'b'; 'b'; 'b'; 'b'; 'b'];
CSW = [CSW_str_apps; CSW_str_serv; CSW_str_os; CSW_str_dr];
%create two filters
CSW1 = zeros(size(CSW));
CSW2 = zeros(size(CSW));
CSW3 = zeros(size(CSW));
CSW4 = zeros(size(CSW));
CSW5 = zeros(size(CSW));
CSW6 = zeros(size(CSW));
CSW7 = zeros(size(CSW));
CSW8 = zeros(size(CSW));
CSW9 = zeros(size(CSW));
CSW10 = zeros(size(CSW));
for z = 1:size(CSW)
  if CSW(z) ==  'a'
      CSW1(z) = 1;
  end;
  if CSW(z) ==  'b'
      CSW2(z) = 1;
  end;
end; %end for z
CSW1 = CSW1';
CSW2 = CSW2';
CSW3 = CSW3';
CSW4 = CSW4';
CSW5 = CSW5';
CSW6 = CSW6';
CSW7 = CSW7';
CSW8 = CSW8';
CSW9 = CSW9';
CSW10 = CSW10';
CSWGroup(1,:) = CSW1;
CSWGroup(2,:) = CSW2;


% set up genotypes for each of the 1000 nodes
stop1 = numNodes/2;
start2 = stop1+1;

Genotype_apps = zeros(numNodes,20);
Genotype_apps(1:stop1,2)=1;
Genotype_apps(start2:numNodes,20)=1;

Genotype_serv = zeros(numNodes,20);
Genotype_serv(1:stop1,1)=1;
Genotype_serv(start2:numNodes,20)=1;
             
Genotype_os = zeros(numNodes,2);
Genotype_os(1:stop1,1)=1;
Genotype_os(start2:numNodes,2)=1;

Genotype_dr = zeros(numNodes,20);
Genotype_dr(1:stop1,1)=1;
Genotype_dr(start2:numNodes,20)=1;           

%efficiency/quality ratings of software (1 to 100) 
%(1)inefficient (100)maximum efficiency
%case 28
E_apps = [65 75 55 50 60 60 60 80 10 10 65 75 55 50 60 60 60 80 10 10];
E_serv = [65 66 67 63 59 62 72 77 10 10 65 75 55 50 60 60 60 80 10 10];
E_os = [1 80];
E_dr = [70 80 60 75 69 68 63 58 10 10 65 75 55 50 60 60 60 80 10 10];

E_apps2 = [1 1 1 50 60 60 60 80 60 80 1 1 1 50 60 60 60 80 60 80];
E_serv2 = [1 1 1 63 59 62 72 77 77 77 1 1 1 50 60 60 60 80 60 80];
E_os2 = [1 85];
E_dr2 = [1 1 1 75 69 68 63 58 77 77 1 1 1 50 60 60 60 80 60 80];

%community desirability ratings (1 to 100) (1)least desirable (100)most
%desirable
CD_apps = [81 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1];
sum(CD_apps);
CD_serv = [81 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1];
sum(CD_serv);
CD_os = [98 2];
sum(CD_os);
CD_dr = [81 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1];
sum(CD_dr);

%for change over
CD_apps2 = [52 2 2 2 2 2 2 2 2 2 3 3 3 3 3 3 3 3 3 3];
sum(CD_apps2);
CD_serv2 = [52 2 2 2 2 2 2 2 2 2 3 3 3 3 3 3 3 3 3 3];
sum(CD_serv2);
CD_os2 = [30 70];
sum(CD_os2);
CD_dr2 = [52 2 2 2 2 2 2 2 2 2 3 3 3 3 3 3 3 3 3 3];
sum(CD_dr2);

%individual desirability ratings (1 to 100) (1)least desirable (100)most
%desirable
%MUST NOT HAVE ANY ZERO VALUES!
%do for 10 individuals
ID_apps10 = [15 40 10 5 10 3 3 2 1 1 1 1 1 1 1 1 1 1 1 1,
           20 60 1 1  3 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1,
           60 20 1 1 3 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1,
           29 48 3 3 2 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1,
           5 10 3 2 40 13 13 2 1 1 1 1 1 1 1 1 1 1 1 1,
           1 1 5 3 38 19 20 1 1 1 1 1 1 1 1 1 1 1 1 1,
           10 15 10 5 8 10 10 20 1 1 1 1 1 1 1 1 1 1 1 1,
           20 25 3 2 8 10 5 15 1 1 1 1 1 1 1 1 1 1 1 1,
           47 10 1 1 5 3 1 20 1 1 1 1 1 1 1 1 1 1 1 1,
           10 15 10 5 8 10 10 20 1 1 1 1 1 1 1 1 1 1 1 1];
ID_apps = zeros(numNodes,20);
ID_apps(1:10,:) = ID_apps10;
ID_apps(11:20,:) = ID_apps10;
ID_apps(21:30,:) = ID_apps10;
ID_apps(31:40,:) = ID_apps10;
ID_apps(41:50,:) = ID_apps10;
ID_apps(51:100,:) = ID_apps(1:50,:);
ID_apps(101:200,:) = ID_apps(1:100,:);
ID_apps(201:400,:) = ID_apps(1:200,:);
            
ID_serv10 = [60 5 3 2 3 5 5 5 1 1 1 1 1 1 1 1 1 1 1 1,
           60 3 3 2 5 5 5 5 1 1 1 1 1 1 1 1 1 1 1 1,
           50 13 3 2 5 5 5 5 1 1 1 1 1 1 1 1 1 1 1 1,
           57 7 3 2 5 1 5 8 1 1 1 1 1 1 1 1 1 1 1 1,
           5 8 7 5 13 17 10 23 1 1 1 1 1 1 1 1 1 1 1 1,
           5 8 7 5 13 17 18 15 1 1 1 1 1 1 1 1 1 1 1 1,
           12 13 12 3 10 12 12 14 1 1 1 1 1 1 1 1 1 1 1 1,
           12 23 12 13 12 10 2 4 1 1 1 1 1 1 1 1 1 1 1 1,
           12 23 10 13 12 12 2 4 1 1 1 1 1 1 1 1 1 1 1 1,
           12 3 12 13 12 12 10 14 1 1 1 1 1 1 1 1 1 1 1 1] ; 
ID_serv = zeros(numNodes,20);
ID_serv(1:10,:) = ID_serv10;
ID_serv(11:20,:) = ID_serv10;
ID_serv(21:30,:) = ID_serv10;
ID_serv(31:40,:) = ID_serv10;
ID_serv(41:50,:) = ID_serv10;
ID_serv(51:100,:) = ID_serv(1:50,:);
ID_serv(101:200,:) = ID_serv(1:100,:);
ID_serv(201:400,:) = ID_serv(1:200,:);

%filtered less than ideal
     ID_os10 = [99 1,
         99 1,
         99 1,
         99 1,
         99 1,
         99 1,
         99 1,
         99 1,
         99 1,
         99 1] ; 
ID_os = zeros(numNodes,2);
ID_os(1:10,:) = ID_os10;
ID_os(11:20,:) = ID_os10;
ID_os(21:30,:) = ID_os10;
ID_os(31:40,:) = ID_os10;
ID_os(41:50,:) = ID_os10;
ID_os(51:100,:) = ID_os(1:50,:);
ID_os(101:200,:) = ID_os(1:100,:);
ID_os(201:400,:) = ID_os(1:200,:);
     
ID_dr10 = [40 18 5 5 10 5 3 2 1 1 1 1 1 1 1 1 1 1 1 1,
         20 40 10 10 2 3 1 2 1 1 1 1 1 1 1 1 1 1 1 1,
         20 40 10 8 4 3 1 2 1 1 1 1 1 1 1 1 1 1 1 1,
         1 76 3 2 1 1 1 3 1 1 1 1 1 1 1 1 1 1 1 1,
         1 2 1 8 18 18 20 20 1 1 1 1 1 1 1 1 1 1 1 1,
         1 2 1 8 18 20 20 18 1 1 1 1 1 1 1 1 1 1 1 1,
         10 15 5 8 10 15 10 15 1 1 1 1 1 1 1 1 1 1 1 1,
         10 25 5 8 10 10 10 10 1 1 1 1 1 1 1 1 1 1 1 1,           
         10 25 15 10 5 10 5 8 1 1 1 1 1 1 1 1 1 1 1 1,
         10 15 5 10 11 13 12 12 1 1 1 1 1 1 1 1 1 1 1 1];
ID_dr = zeros(numNodes,20);
ID_dr(1:10,:) = ID_dr10;
ID_dr(11:20,:) = ID_dr10;
ID_dr(21:30,:) = ID_dr10;
ID_dr(31:40,:) = ID_dr10;
ID_dr(41:50,:) = ID_dr10;
ID_dr(51:100,:) = ID_dr(1:50,:);
ID_dr(101:200,:) = ID_dr(1:100,:);
ID_dr(201:400,:) = ID_dr(1:200,:);

     ID_apps2 = ID_apps;
     ID_os2 = ID_os;
     ID_dr2 = ID_dr;
ID_serv2 = ID_serv;
    %INDIVIDUAL TIME ARRAY OF CHANGES TO PERSONAL INDIVIDUAL DESIRABILITIES
IDtimeArray1 = zeros(1,numNodes);
IDtimeArray2 = zeros(1,numNodes);

    case 33

% set up data - Dataset 30
%%%%%%%%%%%%%
numNodes = 400
%software strings
%WebBrowser1,6 - commercial products, WebBrowser2,3,4,5 third party
SW_str_apps = ['WebBrowser1v1 ' 'WebBrowser1v2 ' 'WebBrowser2v1 ' 'WebBrowser3v1 ' 'WebBrowser4v1 ' 'WebBrowser5v1 ' 'WebBrowser6v1 ' 'WebBrowser6v4 ' 'WebBrowser7v1 ' 'WebBrowser7v3 ''WebBrowser8v1 ' 'WebBrowser8v2 ' 'WebBrowser8v3 ' 'WebBrowser9v1 ' 'WebBrowser10v1 ' 'WebBrowser11v1 ' 'WebBrowser12v1 ' 'WebBrowser13v4 ' 'WebBrowser14v1 ' 'WebBrowser15v3 '];
%All photo viewers about same standard with number 7 slightly better
SW_str_serv = ['PhotoViewer1 ' 'PhotoViewer2 ' 'PhotoViewer3 ' 'PhotoViewer4 ' 'PhotoViewer5 ' 'PhotoViewer6 ' 'PhotoViewer7v1 ' 'PhotoViewer7v2 ' 'PhotoViewer8 ' 'Photoviewer9 ' 'PhotoViewer1 ' 'PhotoViewer2 ' 'PhotoViewer3 ' 'PhotoViewer4 ' 'PhotoViewer5 ' 'PhotoViewer6 ' 'PhotoViewer7v1 ' 'PhotoViewer7v2 ' 'PhotoViewer8 ' 'Photoviewer9 '];
%OS2 slightly more efficient overall than OS1
SW_str_os = ['OS1 ' 'OS2 ' 'OS3 ' 'OS4 ' 'OS5' 'OS6' 'OS7' 'OS8' 'OS9' 'OS10'];
%higher versions are better than lower number versions, the commercial
%products are more efficient than the freebies 3rd party
SW_str_dr = ['DataDr1v1 ' 'DataDr1v2 ' 'DataDr2v1 ' 'DataDr3v3 ' 'DataDr4 ' 'DataDr5 ' 'DataDr6 ' 'DataDr7 ' 'DataDr9 ' 'DataDr8 ' 'DataDr1v1 ' 'DataDr1v2 ' 'DataDr2v1 ' 'DataDr3v3 ' 'DataDr4 ' 'DataDr5 ' 'DataDr6 ' 'DataDr7 ' 'DataDr9 ' 'DataDr8 '];

%software frequency info for running the frequency and nei diversity index
%algorithm
%locusApps - 'a' represents major variants, 'V' represents a minor version
%locusServ - 's' represents major variants, 'V' represents a minor version
%locusOS  - 'o' represents major variants, 'V' represents a minor version
SW_freq_apps = ['a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V';'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'];
SW_freq_serv = ['s', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'];
SW_freq_os = ['o', 'V'; 'o', 'V'; 'o', 'V'; 'o', 'V';'o', 'V'; 'o', 'V'; 'o', 'V'; 'o', 'V';'o', 'V'; 'o', 'V'];
SW_freq_dr = ['d', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'];

%compatability of software
CSW_str_apps = ['a'; 'b'; 'c' ;'d'; 'e'; 'f'; 'g'; 'h'; 'i'; 'j'; 'a'; 'b'; 'c' ;'d'; 'e'; 'f'; 'g'; 'h'; 'i'; 'j'];
CSW_str_serv = ['a'; 'b'; 'c'; 'd'; 'e'; 'f'; 'g'; 'h'; 'i'; 'j'; 'a'; 'b'; 'c'; 'd'; 'e'; 'f'; 'g'; 'h'; 'i'; 'j'];
CSW_str_os = ['a'; 'b'; 'c'; 'd'; 'e'; 'f'; 'g'; 'h'; 'i'; 'j'];
CSW_str_dr = ['a'; 'b'; 'c'; 'd'; 'e' ;'f'; 'g'; 'h'; 'i'; 'j'; 'a'; 'b'; 'c'; 'd'; 'e'; 'f'; 'g'; 'h'; 'i'; 'j'];
CSW = [CSW_str_apps; CSW_str_serv; CSW_str_os; CSW_str_dr];
%create filters
CSW1 = zeros(size(CSW));
CSW2 = zeros(size(CSW));
CSW3 = zeros(size(CSW));
CSW4 = zeros(size(CSW));
CSW5 = zeros(size(CSW));
CSW6 = zeros(size(CSW));
CSW7 = zeros(size(CSW));
CSW8 = zeros(size(CSW));
CSW9 = zeros(size(CSW));
CSW10 = zeros(size(CSW));
for z = 1:size(CSW)
  if CSW(z) ==  'a'
      CSW1(z) = 1;
  end;
  if CSW(z) ==  'b'
      CSW2(z) = 1;
  end;
 if CSW(z) ==  'c'
      CSW3(z) = 1;
  end;
 if CSW(z) ==  'd'
      CSW4(z) = 1;
  end;
  if CSW(z) ==  'e'
      CSW5(z) = 1;
  end;
  if CSW(z) ==  'f'
      CSW6(z) = 1;
  end;
 if CSW(z) ==  'g'
      CSW7(z) = 1;
  end;
 if CSW(z) ==  'h'
      CSW8(z) = 1;
  end;  
  if CSW(z) ==  'i'
      CSW9(z) = 1;
  end;
  if CSW(z) ==  'j'
      CSW10(z) = 1;
  end;

end; %end for z
CSW1 = CSW1';
CSW2 = CSW2';
CSW3 = CSW3';
CSW4 = CSW4';
CSW5 = CSW5';
CSW6 = CSW6';
CSW7 = CSW7';
CSW8 = CSW8';
CSW9 = CSW9';
CSW10 = CSW10';
CSWGroup(1,:) = CSW1;
CSWGroup(2,:) = CSW2;
CSWGroup(3,:) = CSW3;
CSWGroup(4,:) = CSW4;
CSWGroup(5,:) = CSW5;
CSWGroup(6,:) = CSW6;
CSWGroup(7,:) = CSW7;
CSWGroup(8,:) = CSW8;
CSWGroup(9,:) = CSW9;
CSWGroup(10,:) = CSW10;
%Genotype
stop1 = numNodes/2;
start2 = stop1+1;

Genotype_apps = zeros(numNodes,20);
Genotype_apps(1:stop1,1)=1;
Genotype_apps(start2:numNodes,5)=1;

Genotype_serv = zeros(numNodes,20);
Genotype_serv(1:stop1,1)=1;
Genotype_serv(start2:numNodes,5)=1;
             
Genotype_os = zeros(numNodes,10);
Genotype_os(1:stop1,1)=1;
Genotype_os(start2:numNodes,5)=1;

Genotype_dr = zeros(numNodes,20);
Genotype_dr(1:stop1,1)=1;
Genotype_dr(start2:numNodes,5)=1;          
            
%efficiency/quality ratings of software (1 to 100) 
%(1)inefficient (100)maximum efficiency
%E_apps = [65 75 55 50 60 60 60 80 20 20 65 75 55 50 60 60 60 80 20 20];
%E_serv = [65 66 67 63 59 62 72 77 50 50 65 75 55 50 60 60 60 80 20 20];
%E_os = [50 50 50 50 50 50 50 50 50 50];
%E_dr = [70 80 60 75 69 68 63 58 65 65 65 75 55 50 60 60 60 80 20 20];

%E_apps = [1 75 55 5 1 1 5 80 20 20 10 75 10 5 5 5 60 80 5 5];
%E_serv = [65 1 67 5 1 62 72 77 50 50 65 75 5 5 5 5 5 80 20 20];
%E_os = [70 30 1 10 1 50 2 5 5 5];
%E_dr = [70 80 1 75 15 68 20 58 1 1 1 5 5 8 5 1 60 2 20 20];

E_apps = [1 1 1 1 1 1 1 80 10 10 65 75 55 50 60 60 60 80 10 10];
E_serv = [1 1 1 1 1 62 72 77 10 10 65 75 55 50 60 60 60 80 10 10];
E_os = [1 1 1 1 1 1 1 1 1 91];
E_dr = [1 1 1 1 1 1 63 58 10 10 65 75 55 50 60 60 60 80 10 10];

E_apps2 = [1 1 1 50 60 60 60 80 60 80 1 1 1 50 60 60 60 80 60 80];
E_serv2 = [1 1 1 63 59 62 72 77 77 77 1 1 1 50 60 60 60 80 60 80];
E_os2 = [1 85 1 1 1 1 1 1 1 1];
E_dr2 = [1 1 1 75 69 68 63 58 77 77 1 1 1 50 60 60 60 80 60 80];

%community desirability ratings (1 to 100) (1)least desirable (100)most
%desirable
%desirability 1
CD_apps = [81 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1];
sum(CD_apps);
CD_serv = [81 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1];
sum(CD_serv);
%CD_os = [82 2 2 2 2 2 2 2 2 2];
CD_os = [91 1 1 1 1 1 1 1 1 1];
sum(CD_os);
CD_dr = [81 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1];
sum(CD_dr);
%desirability 2 when wish to change
%for change over
CD_apps2 = [15 5 2 4 1 1 1 1 1 1 53 5 3 1 1 1 1 1 1 1];
%CD_apps2 = [12.5 12.5 12.5 12.5 12.5 12.5 12.5 12.5];
sum(CD_apps2);
CD_serv2 = [56 5 3 2 1 1 1 1 1 1 12 5 2 3 1 1 1 1 1 1];
%CD_serv2 = [12.5 12.5 12.5 12.5 12.5 12.5 12.5 12.5];
sum(CD_serv2);
CD_os2 = [68 10 5 5 2 2 2 2 2 2];
%CD_os2 = [12.5 12.5];
sum(CD_os2);
CD_dr2 = [48 5 4 4 1 1 1 1 1 1 20 5 1 1 1 1 1 1 1 1];
%CD_dr2 = [12.5 12.5 12.5 12.5 12.5 12.5 12.5 12.5];
sum(CD_dr2);
            
%individual desirability ratings (1 to 100) (1)least desirable (100)most
%desirable
%do for 10 individuals

ID_apps10 = [22 12 4 5 1 1 1 1 1 1 28 10 4 3 1 1 1 1 1 1,
           18 6 2 2 1 1 1 1 1 1 52 2 3 3 1 1 1 1 1 1,
           18 6 2 2 1 1 1 1 1 1 52 2 3 3 1 1 1 1 1 1,
           40 1 1 1 1 1 1 1 1 1 42 1 1 1 1 1 1 1 1 1,
           5 50 3 2 1 1 1 1 1 1 10 8 2 8 1 1 1 1 1 1,
           1 1 5 5 1 1 1 1 1 1 1 4 4 43 25 1 1 1 1 1,
           10 15 10 11 1 1 1 1 1 1 14 9 10 9 1 1 1 1 1 1,
           15 20 3 1 1 1 1 1 1 1 25 6 17 1 1 1 1 1 1 1,
           14 1 54 1 1 1 1 1 1 1 10 1 6 1 1 1 1 1 1 1,
           10 10 10 10 1 1 1 1 1 1 14 14 10 10 1 1 1 1 1 1];  
            
ID_serv10 = [22 12 4 5 1 1 1 1 1 1 28 10 4 3 1 1 1 1 1 1,
           18 6 2 2 1 1 1 1 1 1 52 2 3 3 1 1 1 1 1 1,
           18 6 2 2 1 1 1 1 1 1 52 2 3 3 1 1 1 1 1 1,
           40 1 1 1 1 1 1 1 1 1 42 1 1 1 1 1 1 1 1 1,
           5 50 3 2 1 1 1 1 1 1 10 8 2 8 1 1 1 1 1 1,
           1 1 5 5 1 1 1 1 1 1 1 4 4 43 25 1 1 1 1 1,
           10 15 10 11 1 1 1 1 1 1 14 9 10 9 1 1 1 1 1 1,
           15 20 3 1 1 1 1 1 1 1 25 6 17 1 1 1 1 1 1 1,
           14 1 54 1 1 1 1 1 1 1 10 1 6 1 1 1 1 1 1 1,
           10 10 10 10 1 1 1 1 1 1 14 14 10 10 1 1 1 1 1 1];       
                          
%ID_os10 = [50 22 8 8 2 2 2 2 2 2,
%         70 8 5 5 2 2 2 2 2 2,
%         70 8 5 5 2 2 2 2 2 2,
%         82 2 2 2 2 2 2 2 2 2,
%         15 58 5 10 2 2 2 2 2 2,
%         5 5 48 30 2 2 2 2 2 2,
%         24 24 20 20 2 2 2 2 2 2,
%         40 26 20 2 2 2 2 2 2 2,
%         24 2 60 2 2 2 2 2 2 2,
%         24 24 20 20 2 2 2 2 2 2] ;   
     
     ID_os10 = [91 1 1 1 1 1 1 1 1 1,
         91 1 1 1 1 1 1 1 1 1,
         91 1 1 1 1 1 1 1 1 1,
         91 1 1 1 1 1 1 1 1 1,
         91 1 1 1 1 1 1 1 1 1,
         91 1 1 1 1 1 1 1 1 1,
         91 1 1 1 1 1 1 1 1 1,
         91 1 1 1 1 1 1 1 1 1,
         91 1 1 1 1 1 1 1 1 1,
         91 1 1 1 1 1 1 1 1 1] ; 
     
ID_dr10 = [81 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1,
           18 6 2 2 1 1 1 1 1 1 52 2 3 3 1 1 1 1 1 1,
           76 1 1 1 1 1 1 1 1 1 1 6 1 1 1 1 1 1 1 1,
           40 1 1 1 1 1 1 1 1 1 42 1 1 1 1 1 1 1 1 1,
           81 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1,
           67 1 1 1 1 1 1 1 1 1 1 6 10 1 1 1 1 1 1 1,
           76 1 1 1 1 1 1 1 1 1 1 6 1 1 1 1 1 1 1 1,
           15 20 3 1 1 1 1 1 1 1 25 6 17 1 1 1 1 1 1 1,
           14 1 54 1 1 1 1 1 1 1 10 1 6 1 1 1 1 1 1 1,
           81 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1];
       
ID_apps = zeros(numNodes,20);
ID_apps(1:10,:) = ID_apps10;
ID_apps(11:20,:) = ID_apps10;
ID_apps(21:30,:) = ID_apps10;
ID_apps(31:40,:) = ID_apps10;
ID_apps(41:50,:) = ID_apps10;
ID_apps(51:100,:) = ID_apps(1:50,:);
ID_apps(101:200,:) = ID_apps(1:100,:);
ID_apps(201:400,:) = ID_apps(1:200,:);

ID_serv = zeros(numNodes,20);
ID_serv(1:10,:) = ID_serv10;
ID_serv(11:20,:) = ID_serv10;
ID_serv(21:30,:) = ID_serv10;
ID_serv(31:40,:) = ID_serv10;
ID_serv(41:50,:) = ID_serv10;
ID_serv(51:100,:) = ID_serv(1:50,:);
ID_serv(101:200,:) = ID_serv(1:100,:);
ID_serv(201:400,:) = ID_serv(1:200,:);
                          
ID_os = zeros(numNodes,10);
ID_os(1:10,:) = ID_os10;
ID_os(11:20,:) = ID_os10;
ID_os(21:30,:) = ID_os10;
ID_os(31:40,:) = ID_os10;
ID_os(41:50,:) = ID_os10;
ID_os(51:100,:) = ID_os(1:50,:);
ID_os(101:200,:) = ID_os(1:100,:);
ID_os(201:400,:) = ID_os(1:200,:);
     
ID_dr = zeros(numNodes,20);
ID_dr(1:10,:) = ID_dr10;
ID_dr(11:20,:) = ID_dr10;
ID_dr(21:30,:) = ID_dr10;
ID_dr(31:40,:) = ID_dr10;
ID_dr(41:50,:) = ID_dr10;
ID_dr(51:100,:) = ID_dr(1:50,:);
ID_dr(101:200,:) = ID_dr(1:100,:);
ID_dr(201:400,:) = ID_dr(1:200,:);

     ID_apps2 = ID_apps;
     ID_os2 = ID_os;
     ID_dr2 = ID_dr;
ID_serv2 = ID_serv;
    %INDIVIDUAL TIME ARRAY OF CHANGES TO PERSONAL INDIVIDUAL DESIRABILITIES
IDtimeArray1 = zeros(1,numNodes);
IDtimeArray2 = zeros(1,numNodes);

    case 34

% set up data - Dataset 30
%%%%%%%%%%%%%
numNodes = 50
%software strings
%WebBrowser1,6 - commercial products, WebBrowser2,3,4,5 third party
SW_str_apps = ['WebBrowser1v1 ' 'WebBrowser1v2 ' 'WebBrowser2v1 ' 'WebBrowser3v1 ' 'WebBrowser4v1 ' 'WebBrowser5v1 ' 'WebBrowser6v1 ' 'WebBrowser6v4 ' 'WebBrowser7v1 ' 'WebBrowser7v3 ''WebBrowser8v1 ' 'WebBrowser8v2 ' 'WebBrowser8v3 ' 'WebBrowser9v1 ' 'WebBrowser10v1 ' 'WebBrowser11v1 ' 'WebBrowser12v1 ' 'WebBrowser13v4 ' 'WebBrowser14v1 ' 'WebBrowser15v3 '];
%All photo viewers about same standard with number 7 slightly better
SW_str_serv = ['PhotoViewer1 ' 'PhotoViewer2 ' 'PhotoViewer3 ' 'PhotoViewer4 ' 'PhotoViewer5 ' 'PhotoViewer6 ' 'PhotoViewer7v1 ' 'PhotoViewer7v2 ' 'PhotoViewer8 ' 'Photoviewer9 ' 'PhotoViewer1 ' 'PhotoViewer2 ' 'PhotoViewer3 ' 'PhotoViewer4 ' 'PhotoViewer5 ' 'PhotoViewer6 ' 'PhotoViewer7v1 ' 'PhotoViewer7v2 ' 'PhotoViewer8 ' 'Photoviewer9 '];
%OS2 slightly more efficient overall than OS1
SW_str_os = ['OS1 ' 'OS2 ' 'OS3 ' 'OS4 ' 'OS5' 'OS6' 'OS7' 'OS8' 'OS9' 'OS10'];
%higher versions are better than lower number versions, the commercial
%products are more efficient than the freebies 3rd party
SW_str_dr = ['DataDr1v1 ' 'DataDr1v2 ' 'DataDr2v1 ' 'DataDr3v3 ' 'DataDr4 ' 'DataDr5 ' 'DataDr6 ' 'DataDr7 ' 'DataDr9 ' 'DataDr8 ' 'DataDr1v1 ' 'DataDr1v2 ' 'DataDr2v1 ' 'DataDr3v3 ' 'DataDr4 ' 'DataDr5 ' 'DataDr6 ' 'DataDr7 ' 'DataDr9 ' 'DataDr8 '];

%software frequency info for running the frequency and nei diversity index
%algorithm
%locusApps - 'a' represents major variants, 'V' represents a minor version
%locusServ - 's' represents major variants, 'V' represents a minor version
%locusOS  - 'o' represents major variants, 'V' represents a minor version
SW_freq_apps = ['a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V';'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'];
SW_freq_serv = ['s', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'];
SW_freq_os = ['o', 'V'; 'o', 'V'; 'o', 'V'; 'o', 'V';'o', 'V'; 'o', 'V'; 'o', 'V'; 'o', 'V';'o', 'V'; 'o', 'V'];
SW_freq_dr = ['d', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'];

%compatability of software
CSW_str_apps = ['a'; 'b'; 'c' ;'d'; 'e'; 'f'; 'g'; 'h'; 'i'; 'j'; 'a'; 'b'; 'c' ;'d'; 'e'; 'f'; 'g'; 'h'; 'i'; 'j'];
CSW_str_serv = ['a'; 'b'; 'c'; 'd'; 'e'; 'f'; 'g'; 'h'; 'i'; 'j'; 'a'; 'b'; 'c'; 'd'; 'e'; 'f'; 'g'; 'h'; 'i'; 'j'];
CSW_str_os = ['a'; 'b'; 'c'; 'd'; 'e'; 'f'; 'g'; 'h'; 'i'; 'j'];
CSW_str_dr = ['a'; 'b'; 'c'; 'd'; 'e' ;'f'; 'g'; 'h'; 'i'; 'j'; 'a'; 'b'; 'c'; 'd'; 'e'; 'f'; 'g'; 'h'; 'i'; 'j'];
CSW = [CSW_str_apps; CSW_str_serv; CSW_str_os; CSW_str_dr];
%create filters
CSW1 = zeros(size(CSW));
CSW2 = zeros(size(CSW));
CSW3 = zeros(size(CSW));
CSW4 = zeros(size(CSW));
CSW5 = zeros(size(CSW));
CSW6 = zeros(size(CSW));
CSW7 = zeros(size(CSW));
CSW8 = zeros(size(CSW));
CSW9 = zeros(size(CSW));
CSW10 = zeros(size(CSW));
for z = 1:size(CSW)
  if CSW(z) ==  'a'
      CSW1(z) = 1;
  end;
  if CSW(z) ==  'b'
      CSW2(z) = 1;
  end;
 if CSW(z) ==  'c'
      CSW3(z) = 1;
  end;
 if CSW(z) ==  'd'
      CSW4(z) = 1;
  end;
  if CSW(z) ==  'e'
      CSW5(z) = 1;
  end;
  if CSW(z) ==  'f'
      CSW6(z) = 1;
  end;
 if CSW(z) ==  'g'
      CSW7(z) = 1;
  end;
 if CSW(z) ==  'h'
      CSW8(z) = 1;
  end;  
  if CSW(z) ==  'i'
      CSW9(z) = 1;
  end;
  if CSW(z) ==  'j'
      CSW10(z) = 1;
  end;

end; %end for z
CSW1 = CSW1';
CSW2 = CSW2';
CSW3 = CSW3';
CSW4 = CSW4';
CSW5 = CSW5';
CSW6 = CSW6';
CSW7 = CSW7';
CSW8 = CSW8';
CSW9 = CSW9';
CSW10 = CSW10';
CSWGroup(1,:) = CSW1;
CSWGroup(2,:) = CSW2;
CSWGroup(3,:) = CSW3;
CSWGroup(4,:) = CSW4;
CSWGroup(5,:) = CSW5;
CSWGroup(6,:) = CSW6;
CSWGroup(7,:) = CSW7;
CSWGroup(8,:) = CSW8;
CSWGroup(9,:) = CSW9;
CSWGroup(10,:) = CSW10;
%Genotype
stop1 = numNodes/2;
start2 = stop1+1;

Genotype_apps = zeros(numNodes,20);
Genotype_apps(1:stop1,1)=1;
Genotype_apps(start2:numNodes,5)=1;

Genotype_serv = zeros(numNodes,20);
Genotype_serv(1:stop1,1)=1;
Genotype_serv(start2:numNodes,5)=1;
             
Genotype_os = zeros(numNodes,10);
Genotype_os(1:stop1,1)=1;
Genotype_os(start2:numNodes,5)=1;

Genotype_dr = zeros(numNodes,20);
Genotype_dr(1:stop1,1)=1;
Genotype_dr(start2:numNodes,5)=1;          
            
%efficiency/quality ratings of software (1 to 100) 
%(1)inefficient (100)maximum efficiency
%E_apps = [65 75 55 50 60 60 60 80 20 20 65 75 55 50 60 60 60 80 20 20];
%E_serv = [65 66 67 63 59 62 72 77 50 50 65 75 55 50 60 60 60 80 20 20];
%E_os = [50 50 50 50 50 50 50 50 50 50];
%E_dr = [70 80 60 75 69 68 63 58 65 65 65 75 55 50 60 60 60 80 20 20];

%E_apps = [1 75 55 5 1 1 5 80 20 20 10 75 10 5 5 5 60 80 5 5];
%E_serv = [65 1 67 5 1 62 72 77 50 50 65 75 5 5 5 5 5 80 20 20];
%E_os = [70 30 1 10 1 50 2 5 5 5];
%E_dr = [70 80 1 75 15 68 20 58 1 1 1 5 5 8 5 1 60 2 20 20];

E_apps = [1 1 1 1 1 1 1 80 10 10 65 75 55 50 60 60 60 80 10 10];
E_serv = [1 1 1 1 1 62 72 77 10 10 65 75 55 50 60 60 60 80 10 10];
E_os = [1 1 1 1 1 1 1 1 1 91];
E_dr = [1 1 1 1 1 1 63 58 10 10 65 75 55 50 60 60 60 80 10 10];

E_apps2 = [1 1 1 50 60 60 60 80 60 80 1 1 1 50 60 60 60 80 60 80];
E_serv2 = [1 1 1 63 59 62 72 77 77 77 1 1 1 50 60 60 60 80 60 80];
E_os2 = [1 85 1 1 1 1 1 1 1 1];
E_dr2 = [1 1 1 75 69 68 63 58 77 77 1 1 1 50 60 60 60 80 60 80];

%community desirability ratings (1 to 100) (1)least desirable (100)most
%desirable
%desirability 1
CD_apps = [81 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1];
sum(CD_apps);
CD_serv = [81 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1];
sum(CD_serv);
%CD_os = [82 2 2 2 2 2 2 2 2 2];
CD_os = [91 1 1 1 1 1 1 1 1 1];
sum(CD_os);
CD_dr = [81 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1];
sum(CD_dr);
%desirability 2 when wish to change
%for change over
CD_apps2 = [15 5 2 4 1 1 1 1 1 1 53 5 3 1 1 1 1 1 1 1];
%CD_apps2 = [12.5 12.5 12.5 12.5 12.5 12.5 12.5 12.5];
sum(CD_apps2);
CD_serv2 = [56 5 3 2 1 1 1 1 1 1 12 5 2 3 1 1 1 1 1 1];
%CD_serv2 = [12.5 12.5 12.5 12.5 12.5 12.5 12.5 12.5];
sum(CD_serv2);
CD_os2 = [68 10 5 5 2 2 2 2 2 2];
%CD_os2 = [12.5 12.5];
sum(CD_os2);
CD_dr2 = [48 5 4 4 1 1 1 1 1 1 20 5 1 1 1 1 1 1 1 1];
%CD_dr2 = [12.5 12.5 12.5 12.5 12.5 12.5 12.5 12.5];
sum(CD_dr2);
            
%individual desirability ratings (1 to 100) (1)least desirable (100)most
%desirable
%do for 10 individuals

ID_apps10 = [22 12 4 5 1 1 1 1 1 1 28 10 4 3 1 1 1 1 1 1,
           18 6 2 2 1 1 1 1 1 1 52 2 3 3 1 1 1 1 1 1,
           18 6 2 2 1 1 1 1 1 1 52 2 3 3 1 1 1 1 1 1,
           40 1 1 1 1 1 1 1 1 1 42 1 1 1 1 1 1 1 1 1,
           5 50 3 2 1 1 1 1 1 1 10 8 2 8 1 1 1 1 1 1,
           1 1 5 5 1 1 1 1 1 1 1 4 4 43 25 1 1 1 1 1,
           10 15 10 11 1 1 1 1 1 1 14 9 10 9 1 1 1 1 1 1,
           15 20 3 1 1 1 1 1 1 1 25 6 17 1 1 1 1 1 1 1,
           14 1 54 1 1 1 1 1 1 1 10 1 6 1 1 1 1 1 1 1,
           10 10 10 10 1 1 1 1 1 1 14 14 10 10 1 1 1 1 1 1];  
            
ID_serv10 = [22 12 4 5 1 1 1 1 1 1 28 10 4 3 1 1 1 1 1 1,
           18 6 2 2 1 1 1 1 1 1 52 2 3 3 1 1 1 1 1 1,
           18 6 2 2 1 1 1 1 1 1 52 2 3 3 1 1 1 1 1 1,
           40 1 1 1 1 1 1 1 1 1 42 1 1 1 1 1 1 1 1 1,
           5 50 3 2 1 1 1 1 1 1 10 8 2 8 1 1 1 1 1 1,
           1 1 5 5 1 1 1 1 1 1 1 4 4 43 25 1 1 1 1 1,
           10 15 10 11 1 1 1 1 1 1 14 9 10 9 1 1 1 1 1 1,
           15 20 3 1 1 1 1 1 1 1 25 6 17 1 1 1 1 1 1 1,
           14 1 54 1 1 1 1 1 1 1 10 1 6 1 1 1 1 1 1 1,
           10 10 10 10 1 1 1 1 1 1 14 14 10 10 1 1 1 1 1 1];       
                          
%ID_os10 = [50 22 8 8 2 2 2 2 2 2,
%         70 8 5 5 2 2 2 2 2 2,
%         70 8 5 5 2 2 2 2 2 2,
%         82 2 2 2 2 2 2 2 2 2,
%         15 58 5 10 2 2 2 2 2 2,
%         5 5 48 30 2 2 2 2 2 2,
%         24 24 20 20 2 2 2 2 2 2,
%         40 26 20 2 2 2 2 2 2 2,
%         24 2 60 2 2 2 2 2 2 2,
%         24 24 20 20 2 2 2 2 2 2] ;   
     
     ID_os10 = [91 1 1 1 1 1 1 1 1 1,
         91 1 1 1 1 1 1 1 1 1,
         91 1 1 1 1 1 1 1 1 1,
         91 1 1 1 1 1 1 1 1 1,
         91 1 1 1 1 1 1 1 1 1,
         91 1 1 1 1 1 1 1 1 1,
         91 1 1 1 1 1 1 1 1 1,
         91 1 1 1 1 1 1 1 1 1,
         91 1 1 1 1 1 1 1 1 1,
         91 1 1 1 1 1 1 1 1 1] ; 
     
ID_dr10 = [81 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1,
           18 6 2 2 1 1 1 1 1 1 52 2 3 3 1 1 1 1 1 1,
           76 1 1 1 1 1 1 1 1 1 1 6 1 1 1 1 1 1 1 1,
           40 1 1 1 1 1 1 1 1 1 42 1 1 1 1 1 1 1 1 1,
           81 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1,
           67 1 1 1 1 1 1 1 1 1 1 6 10 1 1 1 1 1 1 1,
           76 1 1 1 1 1 1 1 1 1 1 6 1 1 1 1 1 1 1 1,
           15 20 3 1 1 1 1 1 1 1 25 6 17 1 1 1 1 1 1 1,
           14 1 54 1 1 1 1 1 1 1 10 1 6 1 1 1 1 1 1 1,
           81 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1];
       
ID_apps = zeros(numNodes,20);
ID_apps(1:10,:) = ID_apps10;
ID_apps(11:20,:) = ID_apps10;
ID_apps(21:30,:) = ID_apps10;
ID_apps(31:40,:) = ID_apps10;
ID_apps(41:50,:) = ID_apps10;
            
ID_serv = zeros(numNodes,20);
ID_serv(1:10,:) = ID_serv10;
ID_serv(11:20,:) = ID_serv10;
ID_serv(21:30,:) = ID_serv10;
ID_serv(31:40,:) = ID_serv10;
ID_serv(41:50,:) = ID_serv10;
                          
ID_os = zeros(numNodes,10);
ID_os(1:10,:) = ID_os10;
ID_os(11:20,:) = ID_os10;
ID_os(21:30,:) = ID_os10;
ID_os(31:40,:) = ID_os10;
ID_os(41:50,:) = ID_os10;
     
ID_dr = zeros(numNodes,20);
ID_dr(1:10,:) = ID_dr10;
ID_dr(11:20,:) = ID_dr10;
ID_dr(21:30,:) = ID_dr10;
ID_dr(31:40,:) = ID_dr10;
ID_dr(41:50,:) = ID_dr10;


     ID_apps2 = ID_apps;
     ID_os2 = ID_os;
     ID_dr2 = ID_dr;
ID_serv2 = ID_serv;
    %INDIVIDUAL TIME ARRAY OF CHANGES TO PERSONAL INDIVIDUAL DESIRABILITIES
IDtimeArray1 = zeros(1,numNodes);
IDtimeArray2 = zeros(1,numNodes);
       
         case 35
numNodes = 400
% set up data - Dataset 15 - same as 1 but with orig of 0.5 and 400 nodes
%%%%%%%%%%%%%
%software strings
%WebBrowser1,6 - commercial products, WebBrowser2,3,4,5 third party
SW_str_apps = ['WebBrowser1v1 ' 'WebBrowser1v2 ' 'WebBrowser2v1 ' 'WebBrowser3v1 ' 'WebBrowser4v1 ' 'WebBrowser5v1 ' 'WebBrowser6v1 ' 'WebBrowser6v4 '];
%All photo viewers about same standard with number 7 slightly better
SW_str_serv = ['PhotoViewer1 ' 'PhotoViewer2 ' 'PhotoViewer3 ' 'PhotoViewer4 ' 'PhotoViewer5 ' 'PhotoViewer6 ' 'PhotoViewer7v1 ' 'PhotoViewer7v2 '];
%OS2 slightly more efficient overall than OS1
SW_str_os = ['OS1 ' 'OS2 '];
%higher versions are better than lower number versions, the commercial
%products are more efficient than the freebies 3rd party
SW_str_dr = ['DataDr1v1 ' 'DataDr1v2 ' 'DataDr2v1 ' 'DataDr3v3 ' 'DataDr4 ' 'DataDr5 ' 'DataDr6 ' 'DataDr7 '];

%software frequency info for running the frequency and nei diversity index
%algorithm
%locusApps - 'a' represents major variants, 'V' represents a minor version
%locusServ - 's' represents major variants, 'V' represents a minor version
%locusOS  - 'o' represents major variants, 'V' represents a minor version
SW_freq_apps = ['a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'];
SW_freq_serv = ['s', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'];
SW_freq_os = ['o', 'V'; 'o', 'V'];
SW_freq_dr = ['d', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'];

%compatability of software
CSW_str_apps = ['a'; 'a'; 'a' ;'a'; 'b'; 'b'; 'b'; 'b'];
CSW_str_serv = ['a'; 'a'; 'a'; 'a'; 'b'; 'b'; 'b'; 'b'];
CSW_str_os = ['a'; 'b'];
CSW_str_dr = ['a'; 'a'; 'a'; 'a'; 'b' ;'b'; 'b'; 'b'];
CSW = [CSW_str_apps; CSW_str_serv; CSW_str_os; CSW_str_dr];
%create two filters
CSW1 = zeros(size(CSW));
CSW2 = zeros(size(CSW));
CSW3 = zeros(size(CSW));
CSW4 = zeros(size(CSW));
CSW5 = zeros(size(CSW));
CSW6 = zeros(size(CSW));
CSW7 = zeros(size(CSW));
CSW8 = zeros(size(CSW));
CSW9 = zeros(size(CSW));
CSW10 = zeros(size(CSW));
for z = 1:size(CSW)
  if CSW(z) ==  'a'
      CSW1(z) = 1;
  end;
  if CSW(z) ==  'b'
      CSW2(z) = 1;
  end;
end; %end for z
CSW1 = CSW1';
CSW2 = CSW2';
CSW3 = CSW3';
CSW4 = CSW4';
CSW5 = CSW5';
CSW6 = CSW6';
CSW7 = CSW7';
CSW8 = CSW8';
CSW9 = CSW9';
CSW10 = CSW10';
CSWGroup(1,:) = CSW1;
CSWGroup(2,:) = CSW2;


% set up genotypes for each of the 400 nodes
stop1 = numNodes/2;
start2 = stop1+1;

Genotype_apps = zeros(numNodes,8);
Genotype_apps(1:stop1,2)=1;
Genotype_apps(start2:numNodes,8)=1;

Genotype_serv = zeros(numNodes,8);
Genotype_serv(1:stop1,1)=1;
Genotype_serv(start2:numNodes,8)=1;
             
Genotype_os = zeros(numNodes,2);
Genotype_os(1:stop1,1)=1;
Genotype_os(start2:numNodes,2)=1;

Genotype_dr = zeros(numNodes,8);
Genotype_dr(1:stop1,1)=1;
Genotype_dr(start2:numNodes,8)=1;           

%efficiency/quality ratings of software (1 to 100) 
%(1)inefficient (100)maximum efficiency
E_apps = [65 75 55 50 60 60 60 80];
E_serv = [65 66 67 63 59 62 72 77];
E_os = [15 85];
E_dr = [70 80 60 75 69 68 63 58];
%for change over
E_apps2 = [1 1 1 50 60 60 60 80];
E_serv2 = [1 1 1 63 59 62 72 77];
E_os2 = [1 85];
E_dr2 = [1 1 1 75 69 68 63 58];

%community desirability ratings (1 to 100) (1)least desirable (100)most
%desirable
CD_apps = [80 2 2 2 1 1 1 11];
sum(CD_apps);
CD_serv = [80 2 2 2 1 1 1 11];
sum(CD_serv);
CD_os = [10 90];
%CD_os = [96 4];
sum(CD_os);
CD_dr = [80 2 2 2 1 1 1 11];
sum(CD_dr);
%for change over
CD_apps2 = [5 40 10 5 10 5 23 2];
sum(CD_apps2);
CD_serv2 = [50 5 3 2 5 5 25 5];
sum(CD_serv2);
CD_os2 = [60 40];
sum(CD_os2);
CD_dr2 = [30 20 5 5 30 5 3 2];
sum(CD_dr2);

%individual desirability ratings (1 to 100) (1)least desirable (100)most
%desirable
%MUST NOT HAVE ANY ZERO VALUES!
%do for 10 individuals
ID_apps10 = [25 40 10 5 10 5 3 2,
           20 68 1 1  5 2 2 1,
           68 20 1 1 5 2 2 1,
           39 48 5 4 1 1 1 1,
           5 10 3 2 50 15 13 2,
           1 1 4 4 48 19 22 1,
           10 15 10 15 10 10 10 20,
           20 35 3 2 10 10 5 15,
           58 10 1 1 5 4 1 20,
           10 15 10 15 10 10 10 20];  
            
ID_serv10 = [70 5 3 2 5 5 5 5,
           80 5 3 2 2 3 2 3,
           70 15 3 2 2 3 3 2,
           68 17 3 8 1 1 1 1,
           5 8 2 5 13 17 20 30,
           1 2 2 5 13 27 20 30,
           12 13 12 13 12 12 12 14,
           12 23 12 13 12 12 2 14,
           12 33 12 13 12 2 2 14,
           12 13 12 13 12 12 12 14] ;      
                          
%ID_os10 = [80 20,
%         90 10,
%         90 10,
%         96 4,
%         20 80,
%         10 90,
%         50 50,
%         60 40,
%         70 30,
%         50 50] ;  
     
     ID_os10 = [90 10,
         99 1,
         99 1,
         99 1,
         99 1,
         90 10,
         90 10,
         90 10,
         90 10,
         90 10] ;
     
ID_dr10 = [50 20 5 5 10 5 3 2,
         20 50 10 10 4 3 1 2,
         20 50 10 10 4 3 1 2,
         1 86 5 4 1 1 1 1,
         1 2 1 16 20 20 20 20,
         1 2 1 6 20 20 20 30 ,
         10 15 5 20 10 15 10 15,
         10 25 15 10 10 10 10 10,           
         10 35 15 10 5 10 5 10,
         10 15 5 20 13 13 12 12];
     
ID_apps = zeros(numNodes,8);
ID_apps(1:10,:) = ID_apps10;
ID_apps(11:20,:) = ID_apps10;
ID_apps(21:30,:) = ID_apps10;
ID_apps(31:40,:) = ID_apps10;
ID_apps(41:50,:) = ID_apps10;
ID_apps(51:100,:) = ID_apps(1:50,:);
ID_apps(101:200,:) = ID_apps(1:100,:);
ID_apps(201:400,:) = ID_apps(1:200,:);
             
ID_serv = zeros(numNodes,8);
ID_serv(1:10,:) = ID_serv10;
ID_serv(11:20,:) = ID_serv10;
ID_serv(21:30,:) = ID_serv10;
ID_serv(31:40,:) = ID_serv10;
ID_serv(41:50,:) = ID_serv10;
ID_serv(51:100,:) = ID_serv(1:50,:);
ID_serv(101:200,:) = ID_serv(1:100,:);
ID_serv(201:400,:) = ID_serv(1:200,:);
                           
ID_os = zeros(numNodes,2);
ID_os(1:10,:) = ID_os10;
ID_os(11:20,:) = ID_os10;
ID_os(21:30,:) = ID_os10;
ID_os(31:40,:) = ID_os10;
ID_os(41:50,:) = ID_os10;
ID_os(51:100,:) = ID_os(1:50,:);
ID_os(101:200,:) = ID_os(1:100,:);
ID_os(201:400,:) = ID_os(1:200,:);
     
ID_dr = zeros(numNodes,8);
ID_dr(1:10,:) = ID_dr10;
ID_dr(11:20,:) = ID_dr10;
ID_dr(21:30,:) = ID_dr10;
ID_dr(31:40,:) = ID_dr10;
ID_dr(41:50,:) = ID_dr10;
ID_dr(51:100,:) = ID_dr(1:50,:);
ID_dr(101:200,:) = ID_dr(1:100,:);
ID_dr(201:400,:) = ID_dr(1:200,:);

%for ID change over - just change the apps
%ID_apps10_2 = [47 4 1 1 1 1 1 1,
%           47 4 1 1 1 1 1 1,
%           47 4 1 1 1 1 1 1,
%           47 4 1 1 1 1 1 1,
%           47 4 1 1 1 1 1 1,
%           47 4 1 1 1 1 1 1,
%           47 4 1 1 1 1 1 1,
%           47 4 1 1 1 1 1 1,
%           47 4 1 1 1 1 1 1,
%           47 4 1 1 1 1 1 1];
%for ID change over - just change the apps
ID_apps10_2 = [90 4 1 1 1 1 1 1,
           90 4 1 1 1 1 1 1,
           90 4 1 1 1 1 1 1,
           90 4 1 1 1 1 1 1,
           90 4 1 1 1 1 1 1,
           90 4 1 1 1 1 1 1,
           90 4 1 1 1 1 1 1,
           90 4 1 1 1 1 1 1,
           90 4 1 1 1 1 1 1,
           90 4 1 1 1 1 1 1];
       
ID_apps2 = zeros(numNodes,8);
ID_apps2(1:10,:) = ID_apps10_2;
ID_apps2(11:20,:) = ID_apps10_2;
ID_apps2(21:30,:) = ID_apps10_2;
ID_apps2(31:40,:) = ID_apps10_2;
ID_apps2(41:50,:) = ID_apps10_2;
ID_apps2(51:100,:) = ID_apps2(1:50,:);
ID_apps2(101:200,:) = ID_apps2(1:100,:);
ID_apps2(201:400,:) = ID_apps2(1:200,:);

     ID_os10_2 = [90 10,
         99 1,
         99 1,
         99 1,
         99 1,
         90 1,
         90 1,
         90 1,
         90 1,
         90 1] ;
     
ID_os2 = zeros(numNodes,2);
ID_os2(1:10,:) = ID_os10_2;
ID_os2(11:20,:) = ID_os10_2;
ID_os2(21:30,:) = ID_os10_2;
ID_os2(31:40,:) = ID_os10_2;
ID_os2(41:50,:) = ID_os10_2;
ID_os2(51:100,:) = ID_os2(1:50,:);
ID_os2(101:200,:) = ID_os2(1:100,:);
ID_os2(201:400,:) = ID_os2(1:200,:);


ID_dr2 = ID_dr;
ID_serv2 = ID_serv;

%INDIVIDUAL TIME ARRAY OF CHANGES TO PERSONAL INDIVIDUAL DESIRABILITIES
IDtimeArray1 = zeros(1,numNodes);
IDtimeArray2 = zeros(1,numNodes);

%%%%%%%%%%%%%%%%%%
%short times
%%%%%%%%%%%%%%%%%%%%%%
%399-400
%IDtimeArray1(1:numNodes)=randi(200,1,numNodes)+400; %time to change desirabilities
%%IDtimeArray2(1:numNodes)=randi(200,1,numNodes)+800; %time to change desirabilities
%IDtimeArray1(1)=0;
%%IDtimeArray2(1)=0;

%200-400
%IDtimeArray1(201:400)=randi(200,1,200)+400; %time to change desirabilities
%IDtimeArray2(201:400)=randi(200,1,200)+800; %time to change desirabilities

%100-400
%IDtimeArray1(201:300)=randi(200,1,100)+400; %time to change desirabilities
%IDtimeArray2(201:300)=randi(200,1,100)+800; %time to change desirabilities

%40-400
%IDtimeArray1(201:240)=randi(200,1,40)+400; %time to change desirabilities
%IDtimeArray2(201:240)=randi(200,1,40)+800; %time to change desirabilities

%%%%%%%%%%%%%%%
%long times
%%%%%%%%%%%%%%%%%%%
%399/400
%IDtimeArray1(1:numNodes)=randi(1000,1,numNodes)+4000; %time to change desirabilities
%IDtimeArray2(1:numNodes)=randi(1000,1,numNodes)+8000; %time to change desirabilities
%IDtimeArray1(1)=0;
%IDtimeArray2(1)=0;

%40/400
%IDtimeArray1(201:240)=randi(1000,1,40)+4000; %time to change desirabilities
%IDtimeArray2(201:240)=randi(1000,1,40)+8000; %time to change desirabilities

%20/400
%IDtimeArray1(201:220)=randi(100,1,20)+1000; %time to change desirabilities
%IDtimeArray2(201:220)=randi(1000,1,20)+8000; %time to change desirabilities

%200/400
IDtimeArray1(201:400)=randi(500,1,200)+2000; %time to change desirabilities
%IDtimeArray2(201:400)=randi(100,1,200)+8000; %time to change desirabilities

%IDtimeArray1(1:numNodes)=randi(200,1,numNodes)+400; %time to change desirabilities
%IDtimeArray2(1:numNodes)=randi(100,1,numNodes)+800; %time to change desirabilities
%IDtimeArray1(1)=0;
%IDtimeArray2(1)=0;

%IDtimeArray1(1:numNodes)=randi(1000,1,numNodes)+400; %time to change desirabilities
%IDtimeArray2(1:numNodes)=randi(1000,1,numNodes)+800; %time to change desirabilities

case 36
numNodes = 50
% set up data - Dataset 15 - same as 1 but with orig of 0.5 and 400 nodes
%%%%%%%%%%%%%
%software strings
%WebBrowser1,6 - commercial products, WebBrowser2,3,4,5 third party
SW_str_apps = ['WebBrowser1v1 ' 'WebBrowser1v2 ' 'WebBrowser2v1 ' 'WebBrowser3v1 ' 'WebBrowser4v1 ' 'WebBrowser5v1 ' 'WebBrowser6v1 ' 'WebBrowser6v4 '];
%All photo viewers about same standard with number 7 slightly better
SW_str_serv = ['PhotoViewer1 ' 'PhotoViewer2 ' 'PhotoViewer3 ' 'PhotoViewer4 ' 'PhotoViewer5 ' 'PhotoViewer6 ' 'PhotoViewer7v1 ' 'PhotoViewer7v2 '];
%OS2 slightly more efficient overall than OS1
SW_str_os = ['OS1 ' 'OS2 '];
%higher versions are better than lower number versions, the commercial
%products are more efficient than the freebies 3rd party
SW_str_dr = ['DataDr1v1 ' 'DataDr1v2 ' 'DataDr2v1 ' 'DataDr3v3 ' 'DataDr4 ' 'DataDr5 ' 'DataDr6 ' 'DataDr7 '];

%software frequency info for running the frequency and nei diversity index
%algorithm
%locusApps - 'a' represents major variants, 'V' represents a minor version
%locusServ - 's' represents major variants, 'V' represents a minor version
%locusOS  - 'o' represents major variants, 'V' represents a minor version
SW_freq_apps = ['a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'];
SW_freq_serv = ['s', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'];
SW_freq_os = ['o', 'V'; 'o', 'V'];
SW_freq_dr = ['d', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'];

%compatability of software
CSW_str_apps = ['a'; 'a'; 'a' ;'a'; 'b'; 'b'; 'b'; 'b'];
CSW_str_serv = ['a'; 'a'; 'a'; 'a'; 'b'; 'b'; 'b'; 'b'];
CSW_str_os = ['a'; 'b'];
CSW_str_dr = ['a'; 'a'; 'a'; 'a'; 'b' ;'b'; 'b'; 'b'];
CSW = [CSW_str_apps; CSW_str_serv; CSW_str_os; CSW_str_dr];
%create two filters
CSW1 = zeros(size(CSW));
CSW2 = zeros(size(CSW));
CSW3 = zeros(size(CSW));
CSW4 = zeros(size(CSW));
CSW5 = zeros(size(CSW));
CSW6 = zeros(size(CSW));
CSW7 = zeros(size(CSW));
CSW8 = zeros(size(CSW));
CSW9 = zeros(size(CSW));
CSW10 = zeros(size(CSW));
for z = 1:size(CSW)
  if CSW(z) ==  'a'
      CSW1(z) = 1;
  end;
  if CSW(z) ==  'b'
      CSW2(z) = 1;
  end;
end; %end for z
CSW1 = CSW1';
CSW2 = CSW2';
CSW3 = CSW3';
CSW4 = CSW4';
CSW5 = CSW5';
CSW6 = CSW6';
CSW7 = CSW7';
CSW8 = CSW8';
CSW9 = CSW9';
CSW10 = CSW10';
CSWGroup(1,:) = CSW1;
CSWGroup(2,:) = CSW2;


% set up genotypes for each of the 400 nodes
stop1 = numNodes/2;
start2 = stop1+1;

Genotype_apps = zeros(numNodes,8);
Genotype_apps(1:stop1,2)=1;
Genotype_apps(start2:numNodes,8)=1;

Genotype_serv = zeros(numNodes,8);
Genotype_serv(1:stop1,1)=1;
Genotype_serv(start2:numNodes,8)=1;
             
Genotype_os = zeros(numNodes,2);
Genotype_os(1:stop1,1)=1;
Genotype_os(start2:numNodes,2)=1;

Genotype_dr = zeros(numNodes,8);
Genotype_dr(1:stop1,1)=1;
Genotype_dr(start2:numNodes,8)=1;           

%efficiency/quality ratings of software (1 to 100) 
%(1)inefficient (100)maximum efficiency
E_apps = [65 75 55 50 60 60 60 80];
E_serv = [65 66 67 63 59 62 72 77];
E_os = [15 85];
E_dr = [70 80 60 75 69 68 63 58];
%for change over
E_apps2 = [1 1 1 50 60 60 60 80];
E_serv2 = [1 1 1 63 59 62 72 77];
E_os2 = [1 85];
E_dr2 = [1 1 1 75 69 68 63 58];

%community desirability ratings (1 to 100) (1)least desirable (100)most
%desirable
CD_apps = [80 2 2 2 1 1 1 11];
sum(CD_apps);
CD_serv = [80 2 2 2 1 1 1 11];
sum(CD_serv);
CD_os = [10 90];
%CD_os = [96 4];
sum(CD_os);
CD_dr = [80 2 2 2 1 1 1 11];
sum(CD_dr);
%for change over
CD_apps2 = [5 40 10 5 10 5 23 2];
sum(CD_apps2);
CD_serv2 = [50 5 3 2 5 5 25 5];
sum(CD_serv2);
CD_os2 = [60 40];
sum(CD_os2);
CD_dr2 = [30 20 5 5 30 5 3 2];
sum(CD_dr2);

%individual desirability ratings (1 to 100) (1)least desirable (100)most
%desirable
%MUST NOT HAVE ANY ZERO VALUES!
%do for 10 individuals
ID_apps10 = [25 40 10 5 10 5 3 2,
           20 68 1 1  5 2 2 1,
           68 20 1 1 5 2 2 1,
           39 48 5 4 1 1 1 1,
           5 10 3 2 50 15 13 2,
           1 1 4 4 48 19 22 1,
           10 15 10 15 10 10 10 20,
           20 35 3 2 10 10 5 15,
           58 10 1 1 5 4 1 20,
           10 15 10 15 10 10 10 20];  
            
ID_serv10 = [70 5 3 2 5 5 5 5,
           80 5 3 2 2 3 2 3,
           70 15 3 2 2 3 3 2,
           68 17 3 8 1 1 1 1,
           5 8 2 5 13 17 20 30,
           1 2 2 5 13 27 20 30,
           12 13 12 13 12 12 12 14,
           12 23 12 13 12 12 2 14,
           12 33 12 13 12 2 2 14,
           12 13 12 13 12 12 12 14] ;      
                          
%ID_os10 = [80 20,
%         90 10,
%         90 10,
%         96 4,
%         20 80,
%         10 90,
%         50 50,
%         60 40,
%         70 30,
%         50 50] ;  
     
     ID_os10 = [90 10,
         99 1,
         99 1,
         99 1,
         99 1,
         90 10,
         90 10,
         90 10,
         90 10,
         90 10] ;
     
ID_dr10 = [50 20 5 5 10 5 3 2,
         20 50 10 10 4 3 1 2,
         20 50 10 10 4 3 1 2,
         1 86 5 4 1 1 1 1,
         1 2 1 16 20 20 20 20,
         1 2 1 6 20 20 20 30 ,
         10 15 5 20 10 15 10 15,
         10 25 15 10 10 10 10 10,           
         10 35 15 10 5 10 5 10,
         10 15 5 20 13 13 12 12];
     
ID_apps = zeros(numNodes,8);
ID_apps(1:10,:) = ID_apps10;
ID_apps(11:20,:) = ID_apps10;
ID_apps(21:30,:) = ID_apps10;
ID_apps(31:40,:) = ID_apps10;
ID_apps(41:50,:) = ID_apps10;
             
ID_serv = zeros(numNodes,8);
ID_serv(1:10,:) = ID_serv10;
ID_serv(11:20,:) = ID_serv10;
ID_serv(21:30,:) = ID_serv10;
ID_serv(31:40,:) = ID_serv10;
ID_serv(41:50,:) = ID_serv10;
                           
ID_os = zeros(numNodes,2);
ID_os(1:10,:) = ID_os10;
ID_os(11:20,:) = ID_os10;
ID_os(21:30,:) = ID_os10;
ID_os(31:40,:) = ID_os10;
ID_os(41:50,:) = ID_os10;
     
ID_dr = zeros(numNodes,8);
ID_dr(1:10,:) = ID_dr10;
ID_dr(11:20,:) = ID_dr10;
ID_dr(21:30,:) = ID_dr10;
ID_dr(31:40,:) = ID_dr10;
ID_dr(41:50,:) = ID_dr10;

     ID_apps2 = ID_apps;
     ID_os2 = ID_os;
     ID_dr2 = ID_dr;
ID_serv2 = ID_serv;

    %INDIVIDUAL TIME ARRAY OF CHANGES TO PERSONAL INDIVIDUAL DESIRABILITIES
IDtimeArray1 = zeros(1,numNodes);
IDtimeArray2 = zeros(1,numNodes);

%case 37 - same as 36 but with 100 instead of 50 nodes
case 37
numNodes = 100
% set up data - Dataset 15 - same as 1 but with orig of 0.5 and 400 nodes
%%%%%%%%%%%%%
%software strings
%WebBrowser1,6 - commercial products, WebBrowser2,3,4,5 third party
SW_str_apps = ['WebBrowser1v1 ' 'WebBrowser1v2 ' 'WebBrowser2v1 ' 'WebBrowser3v1 ' 'WebBrowser4v1 ' 'WebBrowser5v1 ' 'WebBrowser6v1 ' 'WebBrowser6v4 '];
%All photo viewers about same standard with number 7 slightly better
SW_str_serv = ['PhotoViewer1 ' 'PhotoViewer2 ' 'PhotoViewer3 ' 'PhotoViewer4 ' 'PhotoViewer5 ' 'PhotoViewer6 ' 'PhotoViewer7v1 ' 'PhotoViewer7v2 '];
%OS2 slightly more efficient overall than OS1
SW_str_os = ['OS1 ' 'OS2 '];
%higher versions are better than lower number versions, the commercial
%products are more efficient than the freebies 3rd party
SW_str_dr = ['DataDr1v1 ' 'DataDr1v2 ' 'DataDr2v1 ' 'DataDr3v3 ' 'DataDr4 ' 'DataDr5 ' 'DataDr6 ' 'DataDr7 '];

%software frequency info for running the frequency and nei diversity index
%algorithm
%locusApps - 'a' represents major variants, 'V' represents a minor version
%locusServ - 's' represents major variants, 'V' represents a minor version
%locusOS  - 'o' represents major variants, 'V' represents a minor version
SW_freq_apps = ['a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'; 'a', 'V'];
SW_freq_serv = ['s', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'; 's', 'V'];
SW_freq_os = ['o', 'V'; 'o', 'V'];
SW_freq_dr = ['d', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'; 'd', 'V'];

%compatability of software
CSW_str_apps = ['a'; 'a'; 'a' ;'a'; 'b'; 'b'; 'b'; 'b'];
CSW_str_serv = ['a'; 'a'; 'a'; 'a'; 'b'; 'b'; 'b'; 'b'];
CSW_str_os = ['a'; 'b'];
CSW_str_dr = ['a'; 'a'; 'a'; 'a'; 'b' ;'b'; 'b'; 'b'];
CSW = [CSW_str_apps; CSW_str_serv; CSW_str_os; CSW_str_dr];
%create two filters
CSW1 = zeros(size(CSW));
CSW2 = zeros(size(CSW));
CSW3 = zeros(size(CSW));
CSW4 = zeros(size(CSW));
CSW5 = zeros(size(CSW));
CSW6 = zeros(size(CSW));
CSW7 = zeros(size(CSW));
CSW8 = zeros(size(CSW));
CSW9 = zeros(size(CSW));
CSW10 = zeros(size(CSW));
for z = 1:size(CSW)
  if CSW(z) ==  'a'
      CSW1(z) = 1;
  end;
  if CSW(z) ==  'b'
      CSW2(z) = 1;
  end;
end; %end for z
CSW1 = CSW1';
CSW2 = CSW2';
CSW3 = CSW3';
CSW4 = CSW4';
CSW5 = CSW5';
CSW6 = CSW6';
CSW7 = CSW7';
CSW8 = CSW8';
CSW9 = CSW9';
CSW10 = CSW10';
CSWGroup(1,:) = CSW1;
CSWGroup(2,:) = CSW2;


% set up genotypes for each of the 400 nodes
stop1 = numNodes/2;
start2 = stop1+1;

Genotype_apps = zeros(numNodes,8);
Genotype_apps(1:stop1,2)=1;
Genotype_apps(start2:numNodes,8)=1;

Genotype_serv = zeros(numNodes,8);
Genotype_serv(1:stop1,1)=1;
Genotype_serv(start2:numNodes,8)=1;
             
Genotype_os = zeros(numNodes,2);
Genotype_os(1:stop1,1)=1;
Genotype_os(start2:numNodes,2)=1;

Genotype_dr = zeros(numNodes,8);
Genotype_dr(1:stop1,1)=1;
Genotype_dr(start2:numNodes,8)=1;           

%efficiency/quality ratings of software (1 to 100) 
%(1)inefficient (100)maximum efficiency
E_apps = [65 75 55 50 60 60 60 80];
E_serv = [65 66 67 63 59 62 72 77];
E_os = [15 85];
E_dr = [70 80 60 75 69 68 63 58];
%for change over
E_apps2 = [1 1 1 50 60 60 60 80];
E_serv2 = [1 1 1 63 59 62 72 77];
E_os2 = [1 85];
E_dr2 = [1 1 1 75 69 68 63 58];

%community desirability ratings (1 to 100) (1)least desirable (100)most
%desirable
CD_apps = [80 2 2 2 1 1 1 11];
sum(CD_apps);
CD_serv = [80 2 2 2 1 1 1 11];
sum(CD_serv);
CD_os = [10 90];
%CD_os = [96 4];
sum(CD_os);
CD_dr = [80 2 2 2 1 1 1 11];
sum(CD_dr);
%for change over
CD_apps2 = [5 40 10 5 10 5 23 2];
sum(CD_apps2);
CD_serv2 = [50 5 3 2 5 5 25 5];
sum(CD_serv2);
CD_os2 = [60 40];
sum(CD_os2);
CD_dr2 = [30 20 5 5 30 5 3 2];
sum(CD_dr2);

%individual desirability ratings (1 to 100) (1)least desirable (100)most
%desirable
%MUST NOT HAVE ANY ZERO VALUES!
%do for 10 individuals
ID_apps10 = [25 40 10 5 10 5 3 2,
           20 68 1 1  5 2 2 1,
           68 20 1 1 5 2 2 1,
           39 48 5 4 1 1 1 1,
           5 10 3 2 50 15 13 2,
           1 1 4 4 48 19 22 1,
           10 15 10 15 10 10 10 20,
           20 35 3 2 10 10 5 15,
           58 10 1 1 5 4 1 20,
           10 15 10 15 10 10 10 20];  
            
ID_serv10 = [70 5 3 2 5 5 5 5,
           80 5 3 2 2 3 2 3,
           70 15 3 2 2 3 3 2,
           68 17 3 8 1 1 1 1,
           5 8 2 5 13 17 20 30,
           1 2 2 5 13 27 20 30,
           12 13 12 13 12 12 12 14,
           12 23 12 13 12 12 2 14,
           12 33 12 13 12 2 2 14,
           12 13 12 13 12 12 12 14] ;      
                          
%ID_os10 = [80 20,
%         90 10,
%         90 10,
%         96 4,
%         20 80,
%         10 90,
%         50 50,
%         60 40,
%         70 30,
%         50 50] ;  
     
     ID_os10 = [90 10,
         99 1,
         99 1,
         99 1,
         99 1,
         90 10,
         90 10,
         90 10,
         90 10,
         90 10] ;
     
ID_dr10 = [50 20 5 5 10 5 3 2,
         20 50 10 10 4 3 1 2,
         20 50 10 10 4 3 1 2,
         1 86 5 4 1 1 1 1,
         1 2 1 16 20 20 20 20,
         1 2 1 6 20 20 20 30 ,
         10 15 5 20 10 15 10 15,
         10 25 15 10 10 10 10 10,           
         10 35 15 10 5 10 5 10,
         10 15 5 20 13 13 12 12];
     
ID_apps = zeros(numNodes,8);
ID_apps(1:10,:) = ID_apps10;
ID_apps(11:20,:) = ID_apps10;
ID_apps(21:30,:) = ID_apps10;
ID_apps(31:40,:) = ID_apps10;
ID_apps(41:50,:) = ID_apps10;
ID_apps(51:100,:) = ID_apps(1:50,:);
             
ID_serv = zeros(numNodes,8);
ID_serv(1:10,:) = ID_serv10;
ID_serv(11:20,:) = ID_serv10;
ID_serv(21:30,:) = ID_serv10;
ID_serv(31:40,:) = ID_serv10;
ID_serv(41:50,:) = ID_serv10;
ID_serv(51:100,:) = ID_serv(1:50,:);
                           
ID_os = zeros(numNodes,2);
ID_os(1:10,:) = ID_os10;
ID_os(11:20,:) = ID_os10;
ID_os(21:30,:) = ID_os10;
ID_os(31:40,:) = ID_os10;
ID_os(41:50,:) = ID_os10;
ID_os(51:100,:) = ID_os(1:50,:);
     
ID_dr = zeros(numNodes,8);
ID_dr(1:10,:) = ID_dr10;
ID_dr(11:20,:) = ID_dr10;
ID_dr(21:30,:) = ID_dr10;
ID_dr(31:40,:) = ID_dr10;
ID_dr(41:50,:) = ID_dr10;
ID_dr(51:100,:) = ID_dr(1:50,:);

     ID_apps2 = ID_apps;
     ID_os2 = ID_os;
     ID_dr2 = ID_dr;
ID_serv2 = ID_serv;

    %INDIVIDUAL TIME ARRAY OF CHANGES TO PERSONAL INDIVIDUAL DESIRABILITIES
IDtimeArray1 = zeros(1,numNodes);
IDtimeArray2 = zeros(1,numNodes);
    
    otherwise
        disp 'Dataset number not valid'
end; %end switch
%**************************************************************************************************************************8

n= 1
if n == 1
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%NORMALISATION AND ALIGNMENT OF DATA TO THE OPERATING SYSTEMS
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%E
%normalise arrays to sum to 1 for unfiltered version
E_appsUFilt=normArray(E_apps,normValE);
E_servUFilt=normArray(E_serv, normValE);
E_osUFilt=normArray(E_os, normValE);
E_drUFilt=normArray(E_dr, normValE);
%normalise to OS for filtered version
[E_appsFilt,E_servFilt,E_osFilt,E_drFilt] = normToOS( normValE,...
   CSW1,CSW2,CSW3,CSW4,CSW5,CSW6,CSW7,CSW8,CSW9,CSW10, ...
  E_apps,E_serv,E_os,E_dr);
%reassign
if alignData == 1
    %normalise and align to OS
    E_apps = E_appsFilt;
    E_serv = E_servFilt;
    E_os = E_osFilt;
    E_dr = E_drFilt;
else
    %just normalise
    E_apps = E_appsUFilt;
    E_serv = E_servUFilt;
    E_os = E_osUFilt;
    E_dr = E_drUFilt;
end
    E_sumApps = sum(E_apps);
    
%normalise arrays to sum to 1 for unfiltered version
E_appsUFilt2=normArray(E_apps2,normValE);
E_servUFilt2=normArray(E_serv2, normValE);
E_osUFilt2=normArray(E_os2, normValE);
E_drUFilt2=normArray(E_dr2, normValE);
%normalise to OS for filtered version
[E_appsFilt2,E_servFilt2,E_osFilt2,E_drFilt2] = normToOS( normValE,...
   CSW1,CSW2,CSW3,CSW4,CSW5,CSW6,CSW7,CSW8,CSW9,CSW10, ...
  E_apps2,E_serv2,E_os2,E_dr2);
%reassign
if alignData == 1
    %normalise and align to OS
    E_apps2 = E_appsFilt2;
    E_serv2 = E_servFilt2;
    E_os2 = E_osFilt2;
    E_dr2 = E_drFilt2;
else
    %just normalise
    E_apps2 = E_appsUFilt2;
    E_serv2 = E_servUFilt2;
    E_os2 = E_osUFilt2;
    E_dr2 = E_drUFilt2;
end
    E_sumApps2 = sum(E_apps2);

%CD
%normalise arrays to sum to 1 for unfiltered version
CD_appsUFilt=normArray(CD_apps,normValCD);%shouldn't need 100, but doesn't draw line on graph correctly otherwise
CD_servUFilt=normArray(CD_serv,normValCD);
CD_osUFilt=normArray(CD_os,normValCD);
CD_drUFilt=normArray(CD_dr,normValCD);
%normalise to OS for filtered version
[CD_appsFilt,CD_servFilt,CD_osFilt,CD_drFilt] = normToOS(normValCD, ...
   CSW1,CSW2,CSW3,CSW4,CSW5,CSW6,CSW7,CSW8,CSW9,CSW10, ...
  CD_apps,CD_serv,CD_os,CD_dr);
%reassign
if alignData == 1
    %normalise and align to OS
    CD_apps = CD_appsFilt; 
    CD_serv = CD_servFilt;
    CD_os = CD_osFilt;
    CD_dr = CD_drFilt;
else
    %just normalise
    CD_apps = CD_appsUFilt; 
    CD_serv = CD_servUFilt;
    CD_os = CD_osUFilt;
    CD_dr = CD_drUFilt;
end
    CD_sumApps = sum(CD_apps);

%normalise arrays to sum to 100 for unfiltered version
CD_apps2UFilt=normArray(CD_apps2,normValCD);%shouldn't need 100, but doesn't draw line on graph correctly otherwise
CD_serv2UFilt=normArray(CD_serv2,normValCD);
CD_os2UFilt=normArray(CD_os2,normValCD);
CD_dr2UFilt=normArray(CD_dr2,normValCD);
%normalise to OS for filtered version
[CD_apps2Filt,CD_serv2Filt,CD_os2Filt,CD_dr2Filt] = normToOS(normValCD, ...
   CSW1,CSW2,CSW3,CSW4,CSW5,CSW6,CSW7,CSW8,CSW9,CSW10, ...
  CD_apps2,CD_serv2,CD_os2,CD_dr2);
%reassign
if alignData == 1
     %normalise and align to OS
    CD_apps2 = CD_apps2Filt; 
    CD_serv2 = CD_serv2Filt;
    CD_os2 = CD_os2Filt;
    CD_dr2 = CD_dr2Filt;
else
    %just normalise
    CD_apps2 = CD_apps2UFilt; 
    CD_serv2 = CD_serv2UFilt;
    CD_os2 = CD_os2UFilt;
    CD_dr2 = CD_dr2UFilt;
end
    CD_sumApps2 = sum(CD_apps2);

%ID
%normalise arrays to sum to 100 for unfiltered version
ID_appsUFilt=normArray2(ID_apps,normValID);%shouldn't need 100, but doesn't draw line on graph correctly otherwise
ID_servUFilt=normArray2(ID_serv,normValID);
ID_osUFilt=normArray2(ID_os,normValID);
ID_drUFilt=normArray2(ID_dr,normValID);
%normalise to OS for filtered version
[ID_appsFilt,ID_servFilt,ID_osFilt,ID_drFilt] = normToOS2(normValID, ...
    CSW1,CSW2,CSW3,CSW4,CSW5,CSW6,CSW7,CSW8,CSW9,CSW10, ...
    ID_apps,ID_serv,ID_os,ID_dr);
%reassign
if alignData == 1
     %normalise and align to OS
     ID_apps = ID_appsFilt; 
     ID_serv = ID_servFilt;
     ID_os = ID_osFilt;
     ID_dr = ID_drFilt;
else
    %just normalise
    ID_apps = ID_appsUFilt; 
    ID_serv = ID_servUFilt;
    ID_os = ID_osUFilt;
    ID_dr = ID_drUFilt;
end
    ID_sumApps = sum(ID_apps,2);
    ID_sumAppsD5 = ID_sumApps(1:5);
end

%normalise arrays to sum to 100 for unfiltered version
ID_appsUFilt2=normArray2(ID_apps2,normValID);%shouldn't need 100, but doesn't draw line on graph correctly otherwise
ID_servUFilt2=normArray2(ID_serv2,normValID);
ID_osUFilt2=normArray2(ID_os2,normValID);
ID_drUFilt2=normArray2(ID_dr2,normValID);
%normalise to OS for filtered version
[ID_appsFilt2,ID_servFilt2,ID_osFilt2,ID_drFilt2] = normToOS2(normValID, ...
    CSW1,CSW2,CSW3,CSW4,CSW5,CSW6,CSW7,CSW8,CSW9,CSW10, ...
    ID_apps2,ID_serv2,ID_os2,ID_dr2);
%reassign
if alignData == 1
     %normalise and align to OS
     ID_apps2 = ID_appsFilt2; 
     ID_serv2 = ID_servFilt2;
     ID_os2 = ID_osFilt2;
     ID_dr2 = ID_drFilt2;
else
    %just normalise
    ID_apps2 = ID_appsUFilt2; 
    ID_serv2 = ID_servUFilt2;
    ID_os2 = ID_osUFilt2;
    ID_dr2 = ID_drUFilt2;
end
    ID_sumApps2 = sum(ID_apps2,2);
    ID_sumApps2D5 = ID_sumApps2(1:5);
end