%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Jennifer Jackson 2017                                                        %
% A Biodiversity Approach to Cyber Security                                    %
% PhD Complexity Science                                                       %
% University of Warwick                                                        %
% http://wrap.warwick.ac.uk/98458                                              %
% This software is distributed under the  Creative Commons Attribution License %
% https://creativecommons.org/licenses/by/4.0/                                 %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function [ output_args ] = testRandomGenotypesALL( input_args )
%NOTES: when blacklisting one variant VR needs to be at least 3, since FS
%algorithm sets FS score of blacklist to zero but if there is only one left
%to choose from will set this to zero also because considers it used to
%much already and then assigns the blacklisted one as a default measure 
%(as its the first in the list) as it doesn't know which one to pick.
clear all;
%*************************************
% TESTING AGENT BASED MODEL
%*************************************
close all;

modePar.desirabilities = 'no' %include desirability constraints
modePar.filter = 'no' %include sw filtering

numRuns = 20 %100 %200
numNodes = 1000;
SEpidemic=60; %cutoff;
VR = [1 2 3 4 5 6 7 8 9 10];

doSIRNTests = zeros(1,500); %tests with genotypes
%doSIRNTests(400)=1 % 1 locus RE

%do at least 50 runs
%doSIRNTests(411)=1; %stopUpdating and recovery -  1 locus should get same as static case VR 1:10 50 runs
%doSIRNTests(412)=1; %stopUpdating and recovery -  4 loci AND should get same as static case VR 1:5 10 runs
%doSIRNTests(413)=1; %stopUpdating and recovery -  4 loci OR should get same as static case VR 1:30 50 runs
%doSIRNTests(414)=1; %stopUpdating and blacklisting -  1 locus VR 1:10 50 runs
%doSIRNTests(415)=1; %stopUpdating and blacklisting -  4 loci AND VR 1:5 10 runs
%doSIRNTests(416)=1; %stopUpdating and blacklisting -  4 loci OR VR 1:30 50 runs
%doSIRNTests(417)=1; %stopUpdating and blacklisting and vmupdates -  1 locus VR 1:10 10 runs
%doSIRNTests(418)=1; %stopUpdating and blacklisting and vmupdates -  4 loci AND VR 1:5 10 runs
%doSIRNTests(419)=1; %stopUpdating and blacklisting and vmupdates -  4 loci OR VR1:30 50 runs
doSIRNTests(420)=1; %combine data into graphs

%doSIRNTests(421)=1; %stopUpdating and recovery -  1 locus should get same as static case VR 1:10 50 runs
%no constraints
%21 3/4 constraints
%22 1/2 constraints
%23 1/4 constraints
%24 user desirabilities
%filtering
%doSIRNTests(425)=1; %combine data into graphs




%if doSIRNTests(422) == 1
  
%CONSTRAINTS       
data.m = 422 %data file number
%numRuns = 2 %100 %200
%numNodes = 1000;
%SEpidemic=60; %cutoff;
%**********************
%constraints
modePar.numToConstrain = fix(numNodes*1/2); %constrain a number of nodes to 1 variant
modePar.areaConstrainrwp='no'
%**********************
%1 locus model
%outputDirectory = 'Graphs\'
outputDirectory = 'Graphs\'
tic
modePar.netStr = 're'; %'rwp' random waypoint 're' random encounter
%*************************
%UNUSED PAR FOR RE MODE
%rwp par
modePar.genotypeTimeOutPeriod = 10; %rwp
modePar.xmin     = 1;     % Minimum x-axis location (du)
modePar.xmax     = 31;    % Maximum x-axis location (du)
modePar.ymin     = 1;     % Minimum y-axis location (du)
modePar.ymax     = 31;    % Maximum y-axis location (du)
modePar.smin     = 1.4;  % Minimum speed (du / tu)
modePar.smax     = 1.4;  % Maximum speed (du / tu)
modePar.pmin     = 0;     % Minimum time for pause (integer tu)
modePar.pmax     = 0;     % Maximum time for pause (integer tu)
modePar.dinr     = 3; %7    % Radial distance for in-range (du)
modePar.dexceed  = 1000;  % Value larger than any possible distance (du)
modePar.tinrg    = 1;     % Time in-range for genotype transfer (tu)
modePar.tinrv    = 1;     % Time in-range for virus transfer (tu)
% Mode
% rwph.mode = rwph.MODE_RIR;  1    % Select Random in range mode
% rwph.mode = rwph.MODE_NIR;  2    % Select Nearest in range mode
modePar.moderwp = 1; %MODE_AIR;  % 4    % Select (Random) Available in range mode
%rwp constrain
modePar.xboxc=0.5
modePar.yboxc=0.5
modePar.rwpcontrainplotGraph=0 %draw init constraints graph
% Log vector
modePar.logena = [1 2];
% Log directory for rwp
modePar.logDir = sprintf('%s\\log', pwd);
modePar.statnodesrwp = 'dynamic'; %'dynamic' or 'stationary' nodes, if dynamic box constraints applied at point of virus start
%END UNUSED PAR
%*****************
%data logging of output
data.logDir = sprintf('%s\\outputdata', pwd)
s = sprintf('%s\\data%i.txt', data.logDir,data.m)
data.logOutput(data.m) = fopen(s, 'wt');
%****************************************
modePar.numEncountersBetweenUpdates = 1
modePar.bufferlength = 10 %length of genotype buffer for favscore algorithm
modePar.genoInit = 'mindiv'  %initial conditions of genotypes maxdiv (maximum diversity - random variant chosen) mindiv (minimum diversity - all nodes same)
%blacklist mode
modePar.blklist = 'no'; %yes or no
modePar.numToBlklist = 1
modePar.blklistrate = 0.004 %0.001
%vmupdate mode
modePar.vm = 'no' %yes or no

%update mode
modePar.update = 'yes' %stop updating mode
modePar.bufferlengthNei=10 %buffer for buffering local nei diversity,
modePar.stdNeiUpdateThreshold = 0.15
%recovery
recovery = 0.004; 0.0005 %0.001
%*****************************************

%main par
%numRuns = 50 %20 %100 %200
%numNodes = 100;
%SEpidemic=6; %cutoff;
numLoci=1; 
casetype = 'OR';
modePar.virusStartTime = 1200;
numTimestepsVR = [5000]; %7000?
%VR = [1 2 3 4 5 6 7 8 9 10];
%VR = [5 10];
modePar.blklistStartTime = modePar.virusStartTime
numExploits=1;

%init parameters
ResistanceFSSI = zeros(1,size(VR,2)); % resistance SI
PeakTimeFS = zeros(1,size(VR,2)); %peak time
ResTimeFS = zeros(1,size(VR,2));  %resilience time
ResilienceFS = zeros(1,size(VR,2)); %resilience SIR
ResistanceFS = zeros(1,size(VR,2)); %resistance SIR
NumberInSEndFS = zeros(1,size(VR,2));%with vm updates
ResistanceFSVM = zeros(1,size(VR,2)); %vm resistance
ResilienceTimeFSVM = zeros(1,size(VR,2)); %vm resilience time
ResilienceFSVM = zeros(1,size(VR,2)); %vm resilience
ResistanceSI = zeros(1,size(VR,2)); % resistance SI
PeakTime = zeros(1,size(VR,2)); %peak time
ResTime = zeros(1,size(VR,2));  %resilience time
Resilience = zeros(1,size(VR,2)); %resilience SIR
Resistance = zeros(1,size(VR,2)); %resistance SIR
NumberInSEnd = zeros(1,size(VR,2));%with vm updates
ResistanceVM = zeros(1,size(VR,2)); %vm resistance
ResilienceTimeVM = zeros(1,size(VR,2)); %vm resilience time
ResilienceVM = zeros(1,size(VR,2)); %vm resilience

mode = 'Dynamic-favScore' %mode - can be 'static' or 'dynamic' 'Dynamic-random' 'Dynamic-favScore'
%monte carlo random genotype SIR model
%set up diversity mode parameters
modePar.modeStr = mode
modePar.stopUpdatingTime = 200000 %time at which to stop updating the genotypes
for j = 1:size(VR,2)%do for all VR
    variantRichness =  VR(j)
    numTimesteps = numTimestepsVR(1);
   
 betan = 0.02;  plotGraphs = 0; gamma = recovery;  throwAway = 'nonEpidemics', 
 %agent
 [figMeanNei figNeiOneRun fighistSpRun fighistRecovered fighistSusceptible fighistpeakValue fighistpeakTime fighistBeta fighistGamma fighistBetanew fighistGammanew figInfectedRun1 figBetaRun1 figGammaRun1 figRoRun1 figBetaGamma1 figBetaGamma2...
            meanNeiIndexDynamic betastd gammastd betastd2 betastdNew betastdNew2 gammastdNew peakTimemean peakTimestd peakValuemean peakValuestd...
            betameanmean gammameanmean betameanmean2 betameanmeanNew betameanmeanNew2 gammameanmeanNew Smean Imean Rmean Bmean NSmean Smedian Imedian Rmedian S I R NS SmeanN ImeanN1 RmeanN1 BmeanN1 Snewendmean Snewendstd Rnewendmean Rnewendstd Rnew_nonendmean Rnew_nonendstd propSimsNonEp propSimsNonEp_theoretical...
            numRunsMinor measuredProbMinor numRunsMajor measuredProbMajor meanmdist meannumInfectedVM...
            ] = monteCarloSIRN2(numRuns,numNodes, betan, variantRichness, numTimesteps, plotGraphs,gamma,throwAway,SEpidemic,numExploits,modePar, numLoci, casetype);
   close all; 
   
    %peak time SI
    FinalSizeI = max(Imean,[],2); %mean final size SI
    maska = Imean >= FinalSizeI-1; %when within 1 of the final value
    [C Index] = max(maska);
    PeakTimeFS(j) = Index - modePar.virusStartTime; %T1
    if PeakTimeFS(j) < 0; PeakTimeFS(j)=0; end %check to see if picks an index before the virus start time, must be no outbreak and zero
    %Resistance SI
    ResistanceFSSI(j) = (numNodes-FinalSizeI)./numNodes;  
    %Resilience SIR
     FinalSize = max(RmeanN1,[],2); %mean final R of epidemics only
    maska = RmeanN1 >= FinalSize-1; %when within 1 of the final value
    [C Index] = max(maska);
    ResTimeFS(j) = Index -modePar.virusStartTime; %T1 
    if ResTimeFS(j) < 0; ResTimeFS(j)=0; end %check to see if picks an index before the virus start time, must be no outbreak and zero
    ResilienceFS(j) = 1./ResTimeFS(j);
    %resistance SIR
    ResistanceFS(j) = (numNodes-FinalSize)./numNodes;
    
    %VM update Resistance
     ResistanceFSVM(j) =(numNodes - meannumInfectedVM)./numNodes; %number infected at least once
     %[val index] = min(Imean(modePar.virusStartTime:end)) %time for infected to die away
     maska = Imean(modePar.virusStartTime:end) >= 1; %time when within 1 of zero
    [C indvm] = min(maska); %get index of first zero
     ResilienceTimeFSVM(j)= indvm-1; %index 1 means timw zero of malware injection so subtract 1
    ResilienceFSVM(j) = 1./(indvm-1);
     %with vm updates can get rid of those infected to count ended up in S
    %at end
    NumberInSEndFS(j) = Smean(end);
    
  
   
%data logging
 fprintf(data.logOutput(data.m), '%f,', Imean);     % infection
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResistanceFSSI(j)); % resistance SI
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', PeakTimeFS(j)); %peak time
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResTimeFS(j));     %resilience time
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResilienceFS(j)); %resilience
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResistanceFS(j)); %resistance SIR
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', NumberInSEndFS(j));  %with vm updates can get rid of those infected to count ended up in S    %at end
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResistanceFSVM(j));  
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResilienceTimeFSVM(j));  
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResilienceFSVM(j));  
fprintf(data.logOutput(data.m), '\n'); %new line
end %VR


mode = 'Dynamic-random' %mode - can be 'static' or 'dynamic' 'Dynamic-random' 'Dynamic-favScore'
%monte carlo random genotype SIR model
%set up diversity mode parameters
modePar.modeStr = mode
modePar.stopUpdatingTime = modePar.virusStartTime %time at which to stop updating the genotypes
for j = 1:size(VR,2)%do for all VR
    variantRichness =  VR(j)
    numTimesteps = numTimestepsVR(1);
 betan = 0.02;  plotGraphs = 0; gamma = recovery; throwAway = 'nonEpidemics';
 %agent
 [figMeanNei figNeiOneRun fighistSpRun fighistRecovered fighistSusceptible fighistpeakValue fighistpeakTime fighistBeta fighistGamma fighistBetanew fighistGammanew figInfectedRun1 figBetaRun1 figGammaRun1 figRoRun1 figBetaGamma1 figBetaGamma2...
            meanNeiIndexDynamic betastd gammastd betastd2 betastdNew betastdNew2 gammastdNew peakTimemean peakTimestd peakValuemean peakValuestd...
            betameanmean gammameanmean betameanmean2 betameanmeanNew betameanmeanNew2 gammameanmeanNew Smean Imean Rmean Bmean NSmean Smedian Imedian Rmedian S I R NS SmeanN ImeanN1 RmeanN1 BmeanN1 Snewendmean Snewendstd Rnewendmean Rnewendstd Rnew_nonendmean Rnew_nonendstd propSimsNonEp propSimsNonEp_theoretical...
            numRunsMinor measuredProbMinor numRunsMajor measuredProbMajor meanmdist meannumInfectedVM...
            ] = monteCarloSIRN2(numRuns,numNodes, betan, variantRichness, numTimesteps, plotGraphs,gamma,throwAway,SEpidemic,numExploits,modePar, numLoci, casetype);
   close all; 
   
  %peak time SI
    FinalSizeI = max(Imean,[],2); %mean final size SI
   maska = Imean >= FinalSizeI-1; %when within 1 of the final value
   [C Index] = max(maska);
   PeakTime(j) = Index-modePar.virusStartTime; %T1
   if PeakTime(j) < 0; PeakTime(j)=0; end %check to see if picks an index before the virus start time, must be no outbreak and zero
  %Resistance SI
    ResistanceSI(j) = (numNodes-FinalSizeI)./numNodes; 
    %Resilience SIR
     FinalSize = max(RmeanN1,[],2); %mean final R of epidemics only
    maska = RmeanN1 >= FinalSize-1; %when within 1 of the final value
   [C Index] = max(maska);
   ResTime(j) = Index-modePar.virusStartTime; %T1 
   if ResTime(j) < 0; ResTime(j)=0; end %check to see if picks an index before the virus start time, must be no outbreak and zero
   Resilience(j) = 1./ResTime(j);
   %resistance SIR
   Resistance(j) = (numNodes-FinalSize)./numNodes;
    %VM update Resistance
     ResistanceVM(j) =(numNodes - meannumInfectedVM)./numNodes; %number infected at least once
     %[val index] = min(Imean(modePar.virusStartTime:end)) %time for infected to die away
     maska = Imean(modePar.virusStartTime:end) >= 1; %time when within 1 of zero
    [C indvm] = min(maska); %get index of first zero
     ResilienceTimeVM(j)= indvm-1; %index 1 means timw zero of malware injection so subtract 1
    ResilienceVM(j) = 1./(indvm-1);
     %with vm updates can get rid of those infected to count ended up in S
    %at end
    NumberInSEnd(j) = Smean(end);
  
%data logging
 fprintf(data.logOutput(data.m), '%f,', Imean);     % infection
fprintf(data.logOutput(data.m), '\n'); %new line
fprintf(data.logOutput(data.m), '%f,', ResistanceSI(j)); % resistance SI
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', PeakTime(j)); %peak time
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResTime(j));     %resilience time
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', Resilience(j)); %resilience
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', Resistance(j)); %resistance SIR
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', NumberInSEnd(j));  %with vm updates can get rid of those infected to count ended up in S
fprintf(data.logOutput(data.m), '\n'); %new line 
fprintf(data.logOutput(data.m), '%f,', ResistanceVM(j));  
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResilienceTimeVM(j));  
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResilienceVM(j));  
fprintf(data.logOutput(data.m), '\n'); %new line
end %VR

fclose(data.logOutput(data.m));

%last Imean
figImean = figure;
plot(Imean, 'k')
xlabel('Time (seconds)')
ylabel('Number Infected')
%peak time SI
figIPeak = figure;
plot(VR,PeakTimeFS, 'k+-')
hold on
plot(VR,PeakTime, 'ko-')
xlabel('Variant Richness')
ylabel('Peak Time - SI')
%resistance SI
figResistanceSI=figure;
plot(VR,ResistanceFSSI,'k+-')
hold on
plot(VR,ResistanceSI,'ko-')
xlabel('Variant Richness')
ylabel('Peak I ')

%resilience time SIR
figResilienceTimeSI=figure;
plot(VR,ResTimeFS, 'k+-')
hold on
plot(VR,ResTime, 'ko-')
xlabel('Variant Richness')
ylabel('Resilience time - SIR')

%resilience SIR
figResilienceSIR=figure;
plot(VR,ResilienceFS, 'k+-')
hold on
plot(VR,Resilience, 'ko-')
xlabel('Variant Richness')
ylabel('Resilience - SIR')

%Resistance SIR
figResistenceSIR=figure
plot(VR,ResistanceFS, 'k+-')
hold on
plot(VR,Resistance, 'ko-')
xlabel('Variant Richness')
ylabel('Resistance - SIR')

%VM mode
%s
figsuceptEndVM=figure;
plot(VR,NumberInSEndFS,'k+-')
hold on
plot(VR,NumberInSEnd,'ko-')
xlabel('Variant Richness')
ylabel('Susceptible End - SI')

figResistanceVM=figure
plot(VR,ResistanceFSVM,'k+-')
hold on
plot(VR,ResistanceVM,'ko-')
xlabel('Variant Richness')
ylabel('Resistance - VM')

figResilienceTimeVM=figure;
plot(VR,ResilienceTimeFSVM,'k+-')
hold on
plot(VR,ResilienceTimeVM,'ko-')
xlabel('Variant Richness')
ylabel('Resilience time - VM')

figResilienceVM = figure;
plot(VR,ResilienceFSVM,'k+-')
hold on
plot(VR,ResilienceVM,'ko-')
xlabel('Variant Richness')
ylabel('Resilience - VM')

ResistanceFSSI22=ResistanceFSSI % resistance SI
PeakTimeFS22=PeakTimeFS %peak time
ResTimeFS22=ResTimeFS  %resilience time
ResilienceFS22=ResilienceFS %resilience SIR
ResistanceFS22=ResistanceFS %resistance SIR
NumberInSEndFS22=NumberInSEndFS%with vm updates
ResistanceFSVM22=ResistanceFSVM %vm resistance
ResilienceTimeFSVM22=ResilienceTimeFSVM %vm resilience time
ResilienceFSVM22=ResilienceFSVM %vm resilience


ResistanceSI22=ResistanceSI % resistance SI
PeakTime22=PeakTime %peak time
ResTime22=ResTime  %resilience time
Resilience22=Resilience %resilience SIR
Resistance22=Resistance %resistance SIR
NumberInSEnd22=NumberInSEnd%with vm updates
ResistanceVM22=ResistanceVM %vm resistance
ResilienceTimeVM22=ResilienceTimeVM %vm resilience time
ResilienceVM22=ResilienceVM %vm resilience
fileName = [outputDirectory num2str(data.m) 'output.txt']
outFile = fopen(fileName, 'wt');
fprintf(outFile, '%s\n,', 'ResistanceFSSI'); fprintf(outFile, '%f,', ResistanceFSSI); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'PeakTimeFS'); fprintf(outFile, '%f,', PeakTimeFS); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'ResTimeFS'); fprintf(outFile, '%f,', ResTimeFS); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'ResilienceFS'); fprintf(outFile, '%f,', ResilienceFS); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'ResistanceFS'); fprintf(outFile, '%f,', ResistanceFS); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'NumberInSEndFS'); fprintf(outFile, '%f,', NumberInSEndFS); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'ResistanceFSVM'); fprintf(outFile, '%f,', ResistanceFSVM); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'ResilienceTimeFSVM'); fprintf(outFile, '%f,', ResilienceTimeFSVM); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'ResilienceFSVM'); fprintf(outFile, '%f,', ResilienceFSVM); fprintf(outFile, '\n'); %new line

fprintf(outFile, '%s\n,', 'ResistanceSI'); fprintf(outFile, '%f,', ResistanceSI); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'PeakTime'); fprintf(outFile, '%f,', PeakTime); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'ResTime'); fprintf(outFile, '%f,', ResTime); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'Resilience'); fprintf(outFile, '%f,', Resilience); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'Resistance'); fprintf(outFile, '%f,', Resistance); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'NumberInSEnd'); fprintf(outFile, '%f,', NumberInSEnd); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'ResistanceVM'); fprintf(outFile, '%f,', ResistanceVM); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'ResilienceTimeVM'); fprintf(outFile, '%f,', ResilienceTimeVM); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'ResilienceVM'); fprintf(outFile, '%f,', ResilienceVM); fprintf(outFile, '\n'); %new line
fclose(outFile);


saveas(figImean,[outputDirectory 'figImean.fig']);
saveas(figImean,[outputDirectory 'figImean.emf']);
saveas(figIPeak,[outputDirectory 'figIPeak.fig']);
saveas(figIPeak,[outputDirectory 'figIPeak.emf']);
saveas(figResistanceSI,[outputDirectory 'figResistanceSI.fig']);
saveas(figResistanceSI,[outputDirectory 'figResistanceSI.emf']);
saveas(figResilienceTimeSI,[outputDirectory 'figResilienceTimeSI.fig']);
saveas(figResilienceTimeSI,[outputDirectory 'figResilienceTimeSI.emf']);
saveas(figResilienceSIR,[outputDirectory 'figResilienceSIR.fig']);
saveas(figResilienceSIR,[outputDirectory 'figResilienceSIR.emf']);
saveas(figResistenceSIR,[outputDirectory 'figResistenceSIR.fig']);
saveas(figResistenceSIR,[outputDirectory 'figResistenceSIR.emf']);
saveas(figsuceptEndVM,[outputDirectory 'figsuceptEndVM.fig']);
saveas(figsuceptEndVM,[outputDirectory 'figsuceptEndVM.emf']);
saveas(figResistanceVM,[outputDirectory 'figResistanceVM.fig']);
saveas(figResistanceVM,[outputDirectory 'figResistanceVM.emf']);
saveas(figResilienceTimeVM,[outputDirectory 'figResilienceTimeVM.fig']);
saveas(figResilienceTimeVM,[outputDirectory 'figResilienceTimeVM.emf']);
saveas(figResilienceVM,[outputDirectory 'figResilienceVM.fig']);
saveas(figResilienceVM,[outputDirectory 'figResilienceVM.emf']);
close all;
toc
%end

%if doSIRNTests(423) == 1
  
%CONSTRAINTS       
data.m = 423 %data file number
%numRuns = 2 %100 %200
%numNodes = 1000;
%SEpidemic=60; %cutoff;
%**********************
%constraints
modePar.numToConstrain = fix(numNodes*1/4); %constrain a number of nodes to 1 variant
modePar.areaConstrainrwp='no'
%**********************
%1 locus model
%outputDirectory = 'randomGenotypesGraphs\ALL\Test423\' %BUMBLEBEE
outputDirectory = 'randomGenotypesGraphs\ALL\Test423\'
tic
modePar.netStr = 're'; %'rwp' random waypoint 're' random encounter
%*************************
%UNUSED PAR FOR RE MODE
%rwp par
modePar.genotypeTimeOutPeriod = 10; %rwp
modePar.xmin     = 1;     % Minimum x-axis location (du)
modePar.xmax     = 31;    % Maximum x-axis location (du)
modePar.ymin     = 1;     % Minimum y-axis location (du)
modePar.ymax     = 31;    % Maximum y-axis location (du)
modePar.smin     = 1.4;  % Minimum speed (du / tu)
modePar.smax     = 1.4;  % Maximum speed (du / tu)
modePar.pmin     = 0;     % Minimum time for pause (integer tu)
modePar.pmax     = 0;     % Maximum time for pause (integer tu)
modePar.dinr     = 3; %7    % Radial distance for in-range (du)
modePar.dexceed  = 1000;  % Value larger than any possible distance (du)
modePar.tinrg    = 1;     % Time in-range for genotype transfer (tu)
modePar.tinrv    = 1;     % Time in-range for virus transfer (tu)
% Mode
% rwph.mode = rwph.MODE_RIR;  1    % Select Random in range mode
% rwph.mode = rwph.MODE_NIR;  2    % Select Nearest in range mode
modePar.moderwp = 1; %MODE_AIR;  % 4    % Select (Random) Available in range mode
%rwp constrain
modePar.xboxc=0.5
modePar.yboxc=0.5
modePar.rwpcontrainplotGraph=0 %draw init constraints graph
% Log vector
modePar.logena = [1 2];
% Log directory for rwp
modePar.logDir = sprintf('%s\\log', pwd);
modePar.statnodesrwp = 'dynamic'; %'dynamic' or 'stationary' nodes, if dynamic box constraints applied at point of virus start
%END UNUSED PAR
%*****************
%data logging of output
data.logDir = sprintf('%s\\outputdata', pwd)
s = sprintf('%s\\data%i.txt', data.logDir,data.m)
data.logOutput(data.m) = fopen(s, 'wt');
%****************************************
modePar.numEncountersBetweenUpdates = 1
modePar.bufferlength = 10 %length of genotype buffer for favscore algorithm
modePar.genoInit = 'mindiv'  %initial conditions of genotypes maxdiv (maximum diversity - random variant chosen) mindiv (minimum diversity - all nodes same)
%blacklist mode
modePar.blklist = 'no'; %yes or no
modePar.numToBlklist = 1
modePar.blklistrate = 0.004 %0.001
%vmupdate mode
modePar.vm = 'no' %yes or no

%update mode
modePar.update = 'yes' %stop updating mode
modePar.bufferlengthNei=10 %buffer for buffering local nei diversity,
modePar.stdNeiUpdateThreshold = 0.15
%recovery
recovery = 0.004; 0.0005 %0.001
%*****************************************

%main par
%numRuns = 50 %20 %100 %200
%numNodes = 100;
%SEpidemic=6; %cutoff;
numLoci=1; 
casetype = 'OR';
modePar.virusStartTime = 1200;
numTimestepsVR = [5000]; %7000?
%VR = [1 2 3 4 5 6 7 8 9 10];
%VR = [5 10];
modePar.blklistStartTime = modePar.virusStartTime
numExploits=1;

%init parameters
ResistanceFSSI = zeros(1,size(VR,2)); % resistance SI
PeakTimeFS = zeros(1,size(VR,2)); %peak time
ResTimeFS = zeros(1,size(VR,2));  %resilience time
ResilienceFS = zeros(1,size(VR,2)); %resilience SIR
ResistanceFS = zeros(1,size(VR,2)); %resistance SIR
NumberInSEndFS = zeros(1,size(VR,2));%with vm updates
ResistanceFSVM = zeros(1,size(VR,2)); %vm resistance
ResilienceTimeFSVM = zeros(1,size(VR,2)); %vm resilience time
ResilienceFSVM = zeros(1,size(VR,2)); %vm resilience
ResistanceSI = zeros(1,size(VR,2)); % resistance SI
PeakTime = zeros(1,size(VR,2)); %peak time
ResTime = zeros(1,size(VR,2));  %resilience time
Resilience = zeros(1,size(VR,2)); %resilience SIR
Resistance = zeros(1,size(VR,2)); %resistance SIR
NumberInSEnd = zeros(1,size(VR,2));%with vm updates
ResistanceVM = zeros(1,size(VR,2)); %vm resistance
ResilienceTimeVM = zeros(1,size(VR,2)); %vm resilience time
ResilienceVM = zeros(1,size(VR,2)); %vm resilience

mode = 'Dynamic-favScore' %mode - can be 'static' or 'dynamic' 'Dynamic-random' 'Dynamic-favScore'
%monte carlo random genotype SIR model
%set up diversity mode parameters
modePar.modeStr = mode
modePar.stopUpdatingTime = 200000 %time at which to stop updating the genotypes
for j = 1:size(VR,2)%do for all VR
    variantRichness =  VR(j)
    numTimesteps = numTimestepsVR(1);
   
 betan = 0.02;  plotGraphs = 0; gamma = recovery;  throwAway = 'nonEpidemics', 
 %agent
 [figMeanNei figNeiOneRun fighistSpRun fighistRecovered fighistSusceptible fighistpeakValue fighistpeakTime fighistBeta fighistGamma fighistBetanew fighistGammanew figInfectedRun1 figBetaRun1 figGammaRun1 figRoRun1 figBetaGamma1 figBetaGamma2...
            meanNeiIndexDynamic betastd gammastd betastd2 betastdNew betastdNew2 gammastdNew peakTimemean peakTimestd peakValuemean peakValuestd...
            betameanmean gammameanmean betameanmean2 betameanmeanNew betameanmeanNew2 gammameanmeanNew Smean Imean Rmean Bmean NSmean Smedian Imedian Rmedian S I R NS SmeanN ImeanN1 RmeanN1 BmeanN1 Snewendmean Snewendstd Rnewendmean Rnewendstd Rnew_nonendmean Rnew_nonendstd propSimsNonEp propSimsNonEp_theoretical...
            numRunsMinor measuredProbMinor numRunsMajor measuredProbMajor meanmdist meannumInfectedVM...
            ] = monteCarloSIRN2(numRuns,numNodes, betan, variantRichness, numTimesteps, plotGraphs,gamma,throwAway,SEpidemic,numExploits,modePar, numLoci, casetype);
   close all; 
   
    %peak time SI
    FinalSizeI = max(Imean,[],2); %mean final size SI
    maska = Imean >= FinalSizeI-1; %when within 1 of the final value
    [C Index] = max(maska);
    PeakTimeFS(j) = Index - modePar.virusStartTime; %T1
    if PeakTimeFS(j) < 0; PeakTimeFS(j)=0; end %check to see if picks an index before the virus start time, must be no outbreak and zero
    %Resistance SI
    ResistanceFSSI(j) = (numNodes-FinalSizeI)./numNodes;  
    %Resilience SIR
     FinalSize = max(RmeanN1,[],2); %mean final R of epidemics only
    maska = RmeanN1 >= FinalSize-1; %when within 1 of the final value
    [C Index] = max(maska);
    ResTimeFS(j) = Index -modePar.virusStartTime; %T1 
    if ResTimeFS(j) < 0; ResTimeFS(j)=0; end %check to see if picks an index before the virus start time, must be no outbreak and zero
    ResilienceFS(j) = 1./ResTimeFS(j);
    %resistance SIR
    ResistanceFS(j) = (numNodes-FinalSize)./numNodes;
    
    %VM update Resistance
     ResistanceFSVM(j) =(numNodes - meannumInfectedVM)./numNodes; %number infected at least once
     %[val index] = min(Imean(modePar.virusStartTime:end)) %time for infected to die away
     maska = Imean(modePar.virusStartTime:end) >= 1; %time when within 1 of zero
    [C indvm] = min(maska); %get index of first zero
     ResilienceTimeFSVM(j)= indvm-1; %index 1 means timw zero of malware injection so subtract 1
    ResilienceFSVM(j) = 1./(indvm-1);
     %with vm updates can get rid of those infected to count ended up in S
    %at end
    NumberInSEndFS(j) = Smean(end);
    
  
   
%data logging
 fprintf(data.logOutput(data.m), '%f,', Imean);     % infection
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResistanceFSSI(j)); % resistance SI
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', PeakTimeFS(j)); %peak time
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResTimeFS(j));     %resilience time
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResilienceFS(j)); %resilience
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResistanceFS(j)); %resistance SIR
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', NumberInSEndFS(j));  %with vm updates can get rid of those infected to count ended up in S    %at end
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResistanceFSVM(j));  
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResilienceTimeFSVM(j));  
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResilienceFSVM(j));  
fprintf(data.logOutput(data.m), '\n'); %new line
end %VR


mode = 'Dynamic-random' %mode - can be 'static' or 'dynamic' 'Dynamic-random' 'Dynamic-favScore'
%monte carlo random genotype SIR model
%set up diversity mode parameters
modePar.modeStr = mode
modePar.stopUpdatingTime = modePar.virusStartTime %time at which to stop updating the genotypes
for j = 1:size(VR,2)%do for all VR
    variantRichness =  VR(j)
    numTimesteps = numTimestepsVR(1);
 betan = 0.02;  plotGraphs = 0; gamma = recovery; throwAway = 'nonEpidemics';
 %agent
 [figMeanNei figNeiOneRun fighistSpRun fighistRecovered fighistSusceptible fighistpeakValue fighistpeakTime fighistBeta fighistGamma fighistBetanew fighistGammanew figInfectedRun1 figBetaRun1 figGammaRun1 figRoRun1 figBetaGamma1 figBetaGamma2...
            meanNeiIndexDynamic betastd gammastd betastd2 betastdNew betastdNew2 gammastdNew peakTimemean peakTimestd peakValuemean peakValuestd...
            betameanmean gammameanmean betameanmean2 betameanmeanNew betameanmeanNew2 gammameanmeanNew Smean Imean Rmean Bmean NSmean Smedian Imedian Rmedian S I R NS SmeanN ImeanN1 RmeanN1 BmeanN1 Snewendmean Snewendstd Rnewendmean Rnewendstd Rnew_nonendmean Rnew_nonendstd propSimsNonEp propSimsNonEp_theoretical...
            numRunsMinor measuredProbMinor numRunsMajor measuredProbMajor meanmdist meannumInfectedVM...
            ] = monteCarloSIRN2(numRuns,numNodes, betan, variantRichness, numTimesteps, plotGraphs,gamma,throwAway,SEpidemic,numExploits,modePar, numLoci, casetype);
   close all; 
   
  %peak time SI
    FinalSizeI = max(Imean,[],2); %mean final size SI
   maska = Imean >= FinalSizeI-1; %when within 1 of the final value
   [C Index] = max(maska);
   PeakTime(j) = Index-modePar.virusStartTime; %T1
   if PeakTime(j) < 0; PeakTime(j)=0; end %check to see if picks an index before the virus start time, must be no outbreak and zero
  %Resistance SI
    ResistanceSI(j) = (numNodes-FinalSizeI)./numNodes; 
    %Resilience SIR
     FinalSize = max(RmeanN1,[],2); %mean final R of epidemics only
    maska = RmeanN1 >= FinalSize-1; %when within 1 of the final value
   [C Index] = max(maska);
   ResTime(j) = Index-modePar.virusStartTime; %T1 
   if ResTime(j) < 0; ResTime(j)=0; end %check to see if picks an index before the virus start time, must be no outbreak and zero
   Resilience(j) = 1./ResTime(j);
   %resistance SIR
   Resistance(j) = (numNodes-FinalSize)./numNodes;
    %VM update Resistance
     ResistanceVM(j) =(numNodes - meannumInfectedVM)./numNodes; %number infected at least once
     %[val index] = min(Imean(modePar.virusStartTime:end)) %time for infected to die away
     maska = Imean(modePar.virusStartTime:end) >= 1; %time when within 1 of zero
    [C indvm] = min(maska); %get index of first zero
     ResilienceTimeVM(j)= indvm-1; %index 1 means timw zero of malware injection so subtract 1
    ResilienceVM(j) = 1./(indvm-1);
     %with vm updates can get rid of those infected to count ended up in S
    %at end
    NumberInSEnd(j) = Smean(end);
  
%data logging
 fprintf(data.logOutput(data.m), '%f,', Imean);     % infection
fprintf(data.logOutput(data.m), '\n'); %new line
fprintf(data.logOutput(data.m), '%f,', ResistanceSI(j)); % resistance SI
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', PeakTime(j)); %peak time
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResTime(j));     %resilience time
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', Resilience(j)); %resilience
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', Resistance(j)); %resistance SIR
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', NumberInSEnd(j));  %with vm updates can get rid of those infected to count ended up in S
fprintf(data.logOutput(data.m), '\n'); %new line 
fprintf(data.logOutput(data.m), '%f,', ResistanceVM(j));  
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResilienceTimeVM(j));  
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResilienceVM(j));  
fprintf(data.logOutput(data.m), '\n'); %new line
end %VR

fclose(data.logOutput(data.m));

%last Imean
figImean = figure;
plot(Imean, 'k')
xlabel('Time (seconds)')
ylabel('Number Infected')
%peak time SI
figIPeak = figure;
plot(VR,PeakTimeFS, 'k+-')
hold on
plot(VR,PeakTime, 'ko-')
xlabel('Variant Richness')
ylabel('Peak Time - SI')
%resistance SI
figResistanceSI=figure;
plot(VR,ResistanceFSSI,'k+-')
hold on
plot(VR,ResistanceSI,'ko-')
xlabel('Variant Richness')
ylabel('Peak I ')

%resilience time SIR
figResilienceTimeSI=figure;
plot(VR,ResTimeFS, 'k+-')
hold on
plot(VR,ResTime, 'ko-')
xlabel('Variant Richness')
ylabel('Resilience time - SIR')

%resilience SIR
figResilienceSIR=figure;
plot(VR,ResilienceFS, 'k+-')
hold on
plot(VR,Resilience, 'ko-')
xlabel('Variant Richness')
ylabel('Resilience - SIR')

%Resistance SIR
figResistenceSIR=figure
plot(VR,ResistanceFS, 'k+-')
hold on
plot(VR,Resistance, 'ko-')
xlabel('Variant Richness')
ylabel('Resistance - SIR')

%VM mode
%s
figsuceptEndVM=figure;
plot(VR,NumberInSEndFS,'k+-')
hold on
plot(VR,NumberInSEnd,'ko-')
xlabel('Variant Richness')
ylabel('Susceptible End - SI')

figResistanceVM=figure
plot(VR,ResistanceFSVM,'k+-')
hold on
plot(VR,ResistanceVM,'ko-')
xlabel('Variant Richness')
ylabel('Resistance - VM')

figResilienceTimeVM=figure;
plot(VR,ResilienceTimeFSVM,'k+-')
hold on
plot(VR,ResilienceTimeVM,'ko-')
xlabel('Variant Richness')
ylabel('Resilience time - VM')

figResilienceVM = figure;
plot(VR,ResilienceFSVM,'k+-')
hold on
plot(VR,ResilienceVM,'ko-')
xlabel('Variant Richness')
ylabel('Resilience - VM')

ResistanceFSSI23=ResistanceFSSI % resistance SI
PeakTimeFS23=PeakTimeFS %peak time
ResTimeFS23=ResTimeFS  %resilience time
ResilienceFS23=ResilienceFS %resilience SIR
ResistanceFS23=ResistanceFS %resistance SIR
NumberInSEndFS23=NumberInSEndFS%with vm updates
ResistanceFSVM23=ResistanceFSVM %vm resistance
ResilienceTimeFSVM23=ResilienceTimeFSVM %vm resilience time
ResilienceFSVM23=ResilienceFSVM %vm resilience


ResistanceSI23=ResistanceSI % resistance SI
PeakTime23=PeakTime %peak time
ResTime23=ResTime  %resilience time
Resilience23=Resilience %resilience SIR
Resistance23=Resistance %resistance SIR
NumberInSEnd23=NumberInSEnd%with vm updates
ResistanceVM23=ResistanceVM %vm resistance
ResilienceTimeVM23=ResilienceTimeVM %vm resilience time
ResilienceVM23=ResilienceVM %vm resilience
fileName = [outputDirectory num2str(data.m) 'output.txt']
outFile = fopen(fileName, 'wt');
fprintf(outFile, '%s\n,', 'ResistanceFSSI'); fprintf(outFile, '%f,', ResistanceFSSI); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'PeakTimeFS'); fprintf(outFile, '%f,', PeakTimeFS); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'ResTimeFS'); fprintf(outFile, '%f,', ResTimeFS); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'ResilienceFS'); fprintf(outFile, '%f,', ResilienceFS); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'ResistanceFS'); fprintf(outFile, '%f,', ResistanceFS); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'NumberInSEndFS'); fprintf(outFile, '%f,', NumberInSEndFS); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'ResistanceFSVM'); fprintf(outFile, '%f,', ResistanceFSVM); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'ResilienceTimeFSVM'); fprintf(outFile, '%f,', ResilienceTimeFSVM); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'ResilienceFSVM'); fprintf(outFile, '%f,', ResilienceFSVM); fprintf(outFile, '\n'); %new line

fprintf(outFile, '%s\n,', 'ResistanceSI'); fprintf(outFile, '%f,', ResistanceSI); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'PeakTime'); fprintf(outFile, '%f,', PeakTime); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'ResTime'); fprintf(outFile, '%f,', ResTime); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'Resilience'); fprintf(outFile, '%f,', Resilience); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'Resistance'); fprintf(outFile, '%f,', Resistance); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'NumberInSEnd'); fprintf(outFile, '%f,', NumberInSEnd); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'ResistanceVM'); fprintf(outFile, '%f,', ResistanceVM); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'ResilienceTimeVM'); fprintf(outFile, '%f,', ResilienceTimeVM); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'ResilienceVM'); fprintf(outFile, '%f,', ResilienceVM); fprintf(outFile, '\n'); %new line
fclose(outFile);


saveas(figImean,[outputDirectory 'figImean.fig']);
saveas(figImean,[outputDirectory 'figImean.emf']);
saveas(figIPeak,[outputDirectory 'figIPeak.fig']);
saveas(figIPeak,[outputDirectory 'figIPeak.emf']);
saveas(figResistanceSI,[outputDirectory 'figResistanceSI.fig']);
saveas(figResistanceSI,[outputDirectory 'figResistanceSI.emf']);
saveas(figResilienceTimeSI,[outputDirectory 'figResilienceTimeSI.fig']);
saveas(figResilienceTimeSI,[outputDirectory 'figResilienceTimeSI.emf']);
saveas(figResilienceSIR,[outputDirectory 'figResilienceSIR.fig']);
saveas(figResilienceSIR,[outputDirectory 'figResilienceSIR.emf']);
saveas(figResistenceSIR,[outputDirectory 'figResistenceSIR.fig']);
saveas(figResistenceSIR,[outputDirectory 'figResistenceSIR.emf']);
saveas(figsuceptEndVM,[outputDirectory 'figsuceptEndVM.fig']);
saveas(figsuceptEndVM,[outputDirectory 'figsuceptEndVM.emf']);
saveas(figResistanceVM,[outputDirectory 'figResistanceVM.fig']);
saveas(figResistanceVM,[outputDirectory 'figResistanceVM.emf']);
saveas(figResilienceTimeVM,[outputDirectory 'figResilienceTimeVM.fig']);
saveas(figResilienceTimeVM,[outputDirectory 'figResilienceTimeVM.emf']);
saveas(figResilienceVM,[outputDirectory 'figResilienceVM.fig']);
saveas(figResilienceVM,[outputDirectory 'figResilienceVM.emf']);
close all;

%resilience SIR
figResilienceSIR=figure;
plot([1 2 3 4 5 6 7 8 9 10],ResilienceFS11, 'r+-')
hold on
plot([1 2 3 4 5 6 7 8 9 10],Resilience11, 'ro-')
plot(VR,ResilienceFS21, 'k+-')
plot(VR,Resilience21, 'ko-')
plot(VR,ResilienceFS22, 'b+-')
plot(VR,Resilience22, 'bo-')
plot(VR,ResilienceFS23, 'g+-')
plot(VR,Resilience23, 'go-')
xlabel('Variant Richness')
ylabel('Resilience - SIR')
legend('FS with recovery', 'RV with recovery', 'FS 3/4 constraint','RV 3/4 constraint','FS 1/2 constraint','RV 1/2 constraint','FS 1/4 constraint','RV 1/4 constraint');

%Resistance SIR
figResistenceSIR=figure
plot([1 2 3 4 5 6 7 8 9 10],ResistanceFS11, 'r+-')
hold on
plot([1 2 3 4 5 6 7 8 9 10],Resistance11, 'ro-')
plot(VR,ResistanceFS21, 'k+-')
plot(VR,Resistance21, 'ko-')
plot(VR,ResistanceFS22, 'b+-')
plot(VR,Resistance22, 'bo-')
plot(VR,ResistanceFS23, 'g+-')
plot(VR,Resistance23, 'go-')
xlabel('Variant Richness')
ylabel('Resistance - SIR')
legend('FS with recovery', 'RV with recovery', 'FS 3/4 constraint','RV 3/4 constraint','FS 1/2 constraint','RV 1/2 constraint','FS 1/4 constraint','RV 1/4 constraint');

toc 
end;

if doSIRNTests(424) == 1
  
%CONSTRAINTS       
data.m = 424 %data file number
%numRuns = 2 %100 %200
%numNodes = 1000;
%SEpidemic=60; %cutoff;
%**********************
%constraints
modePar.numToConstrain = 0; %fix(numNodes*1/4); %constrain a number of nodes to 1 variant
modePar.areaConstrainrwp='no'
modePar.desirabilities = 'yes' %include desirability constraints
%**********************
%1 locus model
%outputDirectory = 'randomGenotypesGraphs\ALL\Test424\' %BUMBLEBEE
outputDirectory = 'randomGenotypesGraphs\ALL\Test424\'
tic
modePar.netStr = 're'; %'rwp' random waypoint 're' random encounter
%*************************
%UNUSED PAR FOR RE MODE
%rwp par
modePar.genotypeTimeOutPeriod = 10; %rwp
modePar.xmin     = 1;     % Minimum x-axis location (du)
modePar.xmax     = 31;    % Maximum x-axis location (du)
modePar.ymin     = 1;     % Minimum y-axis location (du)
modePar.ymax     = 31;    % Maximum y-axis location (du)
modePar.smin     = 1.4;  % Minimum speed (du / tu)
modePar.smax     = 1.4;  % Maximum speed (du / tu)
modePar.pmin     = 0;     % Minimum time for pause (integer tu)
modePar.pmax     = 0;     % Maximum time for pause (integer tu)
modePar.dinr     = 3; %7    % Radial distance for in-range (du)
modePar.dexceed  = 1000;  % Value larger than any possible distance (du)
modePar.tinrg    = 1;     % Time in-range for genotype transfer (tu)
modePar.tinrv    = 1;     % Time in-range for virus transfer (tu)
% Mode
% rwph.mode = rwph.MODE_RIR;  1    % Select Random in range mode
% rwph.mode = rwph.MODE_NIR;  2    % Select Nearest in range mode
modePar.moderwp = 1; %MODE_AIR;  % 4    % Select (Random) Available in range mode
%rwp constrain
modePar.xboxc=0.5
modePar.yboxc=0.5
modePar.rwpcontrainplotGraph=0 %draw init constraints graph
% Log vector
modePar.logena = [1 2];
% Log directory for rwp
modePar.logDir = sprintf('%s\\log', pwd);
modePar.statnodesrwp = 'dynamic'; %'dynamic' or 'stationary' nodes, if dynamic box constraints applied at point of virus start
%END UNUSED PAR
%*****************
%data logging of output
data.logDir = sprintf('%s\\outputdata', pwd)
s = sprintf('%s\\data%i.txt', data.logDir,data.m)
data.logOutput(data.m) = fopen(s, 'wt');
%****************************************
modePar.numEncountersBetweenUpdates = 1
modePar.bufferlength = 10 %length of genotype buffer for favscore algorithm
modePar.genoInit = 'mindiv'  %initial conditions of genotypes maxdiv (maximum diversity - random variant chosen) mindiv (minimum diversity - all nodes same)
%blacklist mode
modePar.blklist = 'no'; %yes or no
modePar.numToBlklist = 1
modePar.blklistrate = 0.004 %0.001
%vmupdate mode
modePar.vm = 'no' %yes or no

%update mode
modePar.update = 'yes' %stop updating mode
modePar.bufferlengthNei=10 %buffer for buffering local nei diversity,
modePar.stdNeiUpdateThreshold = 0.15
%recovery
recovery = 0.004; 0.0005 %0.001
%*****************************************

%main par
%numRuns = 50 %20 %100 %200
%numNodes = 100;
%SEpidemic=6; %cutoff;
numLoci=1; 
casetype = 'OR';
modePar.virusStartTime = 1200;
numTimestepsVR = [5000]; %7000?
%VR = [1 2 3 4 5 6 7 8 9 10];
%VR = [5 10];
modePar.blklistStartTime = modePar.virusStartTime
numExploits=1;

%init parameters
ResistanceFSSI = zeros(1,size(VR,2)); % resistance SI
PeakTimeFS = zeros(1,size(VR,2)); %peak time
ResTimeFS = zeros(1,size(VR,2));  %resilience time
ResilienceFS = zeros(1,size(VR,2)); %resilience SIR
ResistanceFS = zeros(1,size(VR,2)); %resistance SIR
NumberInSEndFS = zeros(1,size(VR,2));%with vm updates
ResistanceFSVM = zeros(1,size(VR,2)); %vm resistance
ResilienceTimeFSVM = zeros(1,size(VR,2)); %vm resilience time
ResilienceFSVM = zeros(1,size(VR,2)); %vm resilience
ResistanceSI = zeros(1,size(VR,2)); % resistance SI
PeakTime = zeros(1,size(VR,2)); %peak time
ResTime = zeros(1,size(VR,2));  %resilience time
Resilience = zeros(1,size(VR,2)); %resilience SIR
Resistance = zeros(1,size(VR,2)); %resistance SIR
NumberInSEnd = zeros(1,size(VR,2));%with vm updates
ResistanceVM = zeros(1,size(VR,2)); %vm resistance
ResilienceTimeVM = zeros(1,size(VR,2)); %vm resilience time
ResilienceVM = zeros(1,size(VR,2)); %vm resilience

mode = 'Dynamic-favScore' %mode - can be 'static' or 'dynamic' 'Dynamic-random' 'Dynamic-favScore'
%monte carlo random genotype SIR model
%set up diversity mode parameters
modePar.modeStr = mode
modePar.stopUpdatingTime = 200000 %time at which to stop updating the genotypes
for j = 1:size(VR,2)%do for all VR
    variantRichness =  VR(j)
    numTimesteps = numTimestepsVR(1);
   
 betan = 0.02;  plotGraphs = 0; gamma = recovery;  throwAway = 'nonEpidemics', 
 %agent
 [figMeanNei figNeiOneRun fighistSpRun fighistRecovered fighistSusceptible fighistpeakValue fighistpeakTime fighistBeta fighistGamma fighistBetanew fighistGammanew figInfectedRun1 figBetaRun1 figGammaRun1 figRoRun1 figBetaGamma1 figBetaGamma2...
            meanNeiIndexDynamic betastd gammastd betastd2 betastdNew betastdNew2 gammastdNew peakTimemean peakTimestd peakValuemean peakValuestd...
            betameanmean gammameanmean betameanmean2 betameanmeanNew betameanmeanNew2 gammameanmeanNew Smean Imean Rmean Bmean NSmean Smedian Imedian Rmedian S I R NS SmeanN ImeanN1 RmeanN1 BmeanN1 Snewendmean Snewendstd Rnewendmean Rnewendstd Rnew_nonendmean Rnew_nonendstd propSimsNonEp propSimsNonEp_theoretical...
            numRunsMinor measuredProbMinor numRunsMajor measuredProbMajor meanmdist meannumInfectedVM...
            ] = monteCarloSIRN2(numRuns,numNodes, betan, variantRichness, numTimesteps, plotGraphs,gamma,throwAway,SEpidemic,numExploits,modePar, numLoci, casetype);
   close all; 
   
    %peak time SI
    FinalSizeI = max(Imean,[],2); %mean final size SI
    maska = Imean >= FinalSizeI-1; %when within 1 of the final value
    [C Index] = max(maska);
    PeakTimeFS(j) = Index - modePar.virusStartTime; %T1
    if PeakTimeFS(j) < 0; PeakTimeFS(j)=0; end %check to see if picks an index before the virus start time, must be no outbreak and zero
    %Resistance SI
    ResistanceFSSI(j) = (numNodes-FinalSizeI)./numNodes;  
    %Resilience SIR
     FinalSize = max(RmeanN1,[],2); %mean final R of epidemics only
    maska = RmeanN1 >= FinalSize-1; %when within 1 of the final value
    [C Index] = max(maska);
    ResTimeFS(j) = Index -modePar.virusStartTime; %T1 
    if ResTimeFS(j) < 0; ResTimeFS(j)=0; end %check to see if picks an index before the virus start time, must be no outbreak and zero
    ResilienceFS(j) = 1./ResTimeFS(j);
    %resistance SIR
    ResistanceFS(j) = (numNodes-FinalSize)./numNodes;
    
    %VM update Resistance
     ResistanceFSVM(j) =(numNodes - meannumInfectedVM)./numNodes; %number infected at least once
     %[val index] = min(Imean(modePar.virusStartTime:end)) %time for infected to die away
     maska = Imean(modePar.virusStartTime:end) >= 1; %time when within 1 of zero
    [C indvm] = min(maska); %get index of first zero
     ResilienceTimeFSVM(j)= indvm-1; %index 1 means timw zero of malware injection so subtract 1
    ResilienceFSVM(j) = 1./(indvm-1);
     %with vm updates can get rid of those infected to count ended up in S
    %at end
    NumberInSEndFS(j) = Smean(end);
    
  
   
%data logging
 fprintf(data.logOutput(data.m), '%f,', Imean);     % infection
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResistanceFSSI(j)); % resistance SI
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', PeakTimeFS(j)); %peak time
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResTimeFS(j));     %resilience time
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResilienceFS(j)); %resilience
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResistanceFS(j)); %resistance SIR
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', NumberInSEndFS(j));  %with vm updates can get rid of those infected to count ended up in S    %at end
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResistanceFSVM(j));  
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResilienceTimeFSVM(j));  
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResilienceFSVM(j));  
fprintf(data.logOutput(data.m), '\n'); %new line
end %VR


mode = 'Dynamic-random' %mode - can be 'static' or 'dynamic' 'Dynamic-random' 'Dynamic-favScore'
%monte carlo random genotype SIR model
%set up diversity mode parameters
modePar.modeStr = mode
modePar.stopUpdatingTime = modePar.virusStartTime %time at which to stop updating the genotypes
for j = 1:size(VR,2)%do for all VR
    variantRichness =  VR(j)
    numTimesteps = numTimestepsVR(1);
 betan = 0.02;  plotGraphs = 0; gamma = recovery; throwAway = 'nonEpidemics';
 %agent
 [figMeanNei figNeiOneRun fighistSpRun fighistRecovered fighistSusceptible fighistpeakValue fighistpeakTime fighistBeta fighistGamma fighistBetanew fighistGammanew figInfectedRun1 figBetaRun1 figGammaRun1 figRoRun1 figBetaGamma1 figBetaGamma2...
            meanNeiIndexDynamic betastd gammastd betastd2 betastdNew betastdNew2 gammastdNew peakTimemean peakTimestd peakValuemean peakValuestd...
            betameanmean gammameanmean betameanmean2 betameanmeanNew betameanmeanNew2 gammameanmeanNew Smean Imean Rmean Bmean NSmean Smedian Imedian Rmedian S I R NS SmeanN ImeanN1 RmeanN1 BmeanN1 Snewendmean Snewendstd Rnewendmean Rnewendstd Rnew_nonendmean Rnew_nonendstd propSimsNonEp propSimsNonEp_theoretical...
            numRunsMinor measuredProbMinor numRunsMajor measuredProbMajor meanmdist meannumInfectedVM...
            ] = monteCarloSIRN2(numRuns,numNodes, betan, variantRichness, numTimesteps, plotGraphs,gamma,throwAway,SEpidemic,numExploits,modePar, numLoci, casetype);
   close all; 
   
  %peak time SI
    FinalSizeI = max(Imean,[],2); %mean final size SI
   maska = Imean >= FinalSizeI-1; %when within 1 of the final value
   [C Index] = max(maska);
   PeakTime(j) = Index-modePar.virusStartTime; %T1
   if PeakTime(j) < 0; PeakTime(j)=0; end %check to see if picks an index before the virus start time, must be no outbreak and zero
  %Resistance SI
    ResistanceSI(j) = (numNodes-FinalSizeI)./numNodes; 
    %Resilience SIR
     FinalSize = max(RmeanN1,[],2); %mean final R of epidemics only
    maska = RmeanN1 >= FinalSize-1; %when within 1 of the final value
   [C Index] = max(maska);
   ResTime(j) = Index-modePar.virusStartTime; %T1 
   if ResTime(j) < 0; ResTime(j)=0; end %check to see if picks an index before the virus start time, must be no outbreak and zero
   Resilience(j) = 1./ResTime(j);
   %resistance SIR
   Resistance(j) = (numNodes-FinalSize)./numNodes;
    %VM update Resistance
     ResistanceVM(j) =(numNodes - meannumInfectedVM)./numNodes; %number infected at least once
     %[val index] = min(Imean(modePar.virusStartTime:end)) %time for infected to die away
     maska = Imean(modePar.virusStartTime:end) >= 1; %time when within 1 of zero
    [C indvm] = min(maska); %get index of first zero
     ResilienceTimeVM(j)= indvm-1; %index 1 means timw zero of malware injection so subtract 1
    ResilienceVM(j) = 1./(indvm-1);
     %with vm updates can get rid of those infected to count ended up in S
    %at end
    NumberInSEnd(j) = Smean(end);
  
%data logging
 fprintf(data.logOutput(data.m), '%f,', Imean);     % infection
fprintf(data.logOutput(data.m), '\n'); %new line
fprintf(data.logOutput(data.m), '%f,', ResistanceSI(j)); % resistance SI
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', PeakTime(j)); %peak time
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResTime(j));     %resilience time
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', Resilience(j)); %resilience
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', Resistance(j)); %resistance SIR
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', NumberInSEnd(j));  %with vm updates can get rid of those infected to count ended up in S
fprintf(data.logOutput(data.m), '\n'); %new line 
fprintf(data.logOutput(data.m), '%f,', ResistanceVM(j));  
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResilienceTimeVM(j));  
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResilienceVM(j));  
fprintf(data.logOutput(data.m), '\n'); %new line
end %VR

fclose(data.logOutput(data.m));

%last Imean
figImean = figure;
plot(Imean, 'k')
xlabel('Time (seconds)')
ylabel('Number Infected')
%peak time SI
figIPeak = figure;
plot(VR,PeakTimeFS, 'k+-')
hold on
plot(VR,PeakTime, 'ko-')
xlabel('Variant Richness')
ylabel('Peak Time - SI')
%resistance SI
figResistanceSI=figure;
plot(VR,ResistanceFSSI,'k+-')
hold on
plot(VR,ResistanceSI,'ko-')
xlabel('Variant Richness')
ylabel('Peak I ')

%resilience time SIR
figResilienceTimeSI=figure;
plot(VR,ResTimeFS, 'k+-')
hold on
plot(VR,ResTime, 'ko-')
xlabel('Variant Richness')
ylabel('Resilience time - SIR')

%resilience SIR
figResilienceSIR=figure;
plot(VR,ResilienceFS, 'k+-')
hold on
plot(VR,Resilience, 'ko-')
xlabel('Variant Richness')
ylabel('Resilience - SIR')

%Resistance SIR
figResistenceSIR=figure
plot(VR,ResistanceFS, 'k+-')
hold on
plot(VR,Resistance, 'ko-')
xlabel('Variant Richness')
ylabel('Resistance - SIR')

%VM mode
%s
figsuceptEndVM=figure;
plot(VR,NumberInSEndFS,'k+-')
hold on
plot(VR,NumberInSEnd,'ko-')
xlabel('Variant Richness')
ylabel('Susceptible End - SI')

figResistanceVM=figure
plot(VR,ResistanceFSVM,'k+-')
hold on
plot(VR,ResistanceVM,'ko-')
xlabel('Variant Richness')
ylabel('Resistance - VM')

figResilienceTimeVM=figure;
plot(VR,ResilienceTimeFSVM,'k+-')
hold on
plot(VR,ResilienceTimeVM,'ko-')
xlabel('Variant Richness')
ylabel('Resilience time - VM')

figResilienceVM = figure;
plot(VR,ResilienceFSVM,'k+-')
hold on
plot(VR,ResilienceVM,'ko-')
xlabel('Variant Richness')
ylabel('Resilience - VM')

ResistanceFSSI24=ResistanceFSSI % resistance SI
PeakTimeFS24=PeakTimeFS %peak time
ResTimeFS24=ResTimeFS  %resilience time
ResilienceFS24=ResilienceFS %resilience SIR
ResistanceFS24=ResistanceFS %resistance SIR
NumberInSEndFS24=NumberInSEndFS%with vm updates
ResistanceFSVM24=ResistanceFSVM %vm resistance
ResilienceTimeFSVM24=ResilienceTimeFSVM %vm resilience time
ResilienceFSVM24=ResilienceFSVM %vm resilience


ResistanceSI24=ResistanceSI % resistance SI
PeakTime24=PeakTime %peak time
ResTime24=ResTime  %resilience time
Resilience24=Resilience %resilience SIR
Resistance24=Resistance %resistance SIR
NumberInSEnd24=NumberInSEnd%with vm updates
ResistanceVM24=ResistanceVM %vm resistance
ResilienceTimeVM24=ResilienceTimeVM %vm resilience time
ResilienceVM24=ResilienceVM %vm resilience
fileName = [outputDirectory num2str(data.m) 'output.txt']
outFile = fopen(fileName, 'wt');
fprintf(outFile, '%s\n,', 'ResistanceFSSI'); fprintf(outFile, '%f,', ResistanceFSSI); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'PeakTimeFS'); fprintf(outFile, '%f,', PeakTimeFS); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'ResTimeFS'); fprintf(outFile, '%f,', ResTimeFS); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'ResilienceFS'); fprintf(outFile, '%f,', ResilienceFS); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'ResistanceFS'); fprintf(outFile, '%f,', ResistanceFS); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'NumberInSEndFS'); fprintf(outFile, '%f,', NumberInSEndFS); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'ResistanceFSVM'); fprintf(outFile, '%f,', ResistanceFSVM); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'ResilienceTimeFSVM'); fprintf(outFile, '%f,', ResilienceTimeFSVM); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'ResilienceFSVM'); fprintf(outFile, '%f,', ResilienceFSVM); fprintf(outFile, '\n'); %new line

fprintf(outFile, '%s\n,', 'ResistanceSI'); fprintf(outFile, '%f,', ResistanceSI); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'PeakTime'); fprintf(outFile, '%f,', PeakTime); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'ResTime'); fprintf(outFile, '%f,', ResTime); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'Resilience'); fprintf(outFile, '%f,', Resilience); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'Resistance'); fprintf(outFile, '%f,', Resistance); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'NumberInSEnd'); fprintf(outFile, '%f,', NumberInSEnd); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'ResistanceVM'); fprintf(outFile, '%f,', ResistanceVM); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'ResilienceTimeVM'); fprintf(outFile, '%f,', ResilienceTimeVM); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'ResilienceVM'); fprintf(outFile, '%f,', ResilienceVM); fprintf(outFile, '\n'); %new line
fclose(outFile);


saveas(figImean,[outputDirectory 'figImean.fig']);
saveas(figImean,[outputDirectory 'figImean.emf']);
saveas(figIPeak,[outputDirectory 'figIPeak.fig']);
saveas(figIPeak,[outputDirectory 'figIPeak.emf']);
saveas(figResistanceSI,[outputDirectory 'figResistanceSI.fig']);
saveas(figResistanceSI,[outputDirectory 'figResistanceSI.emf']);
saveas(figResilienceTimeSI,[outputDirectory 'figResilienceTimeSI.fig']);
saveas(figResilienceTimeSI,[outputDirectory 'figResilienceTimeSI.emf']);
saveas(figResilienceSIR,[outputDirectory 'figResilienceSIR.fig']);
saveas(figResilienceSIR,[outputDirectory 'figResilienceSIR.emf']);
saveas(figResistenceSIR,[outputDirectory 'figResistenceSIR.fig']);
saveas(figResistenceSIR,[outputDirectory 'figResistenceSIR.emf']);
saveas(figsuceptEndVM,[outputDirectory 'figsuceptEndVM.fig']);
saveas(figsuceptEndVM,[outputDirectory 'figsuceptEndVM.emf']);
saveas(figResistanceVM,[outputDirectory 'figResistanceVM.fig']);
saveas(figResistanceVM,[outputDirectory 'figResistanceVM.emf']);
saveas(figResilienceTimeVM,[outputDirectory 'figResilienceTimeVM.fig']);
saveas(figResilienceTimeVM,[outputDirectory 'figResilienceTimeVM.emf']);
saveas(figResilienceVM,[outputDirectory 'figResilienceVM.fig']);
saveas(figResilienceVM,[outputDirectory 'figResilienceVM.emf']);
close all;

%ALL graphs
ResilienceFS21
Resilience21
ResilienceFS22
Resilience22
ResilienceFS23
Resilience23
ResilienceFS24
Resilience24

ResistanceFS21
Resistance21
ResistanceFS22
Resistance22
ResistanceFS23
Resistance23
ResistanceFS24
Resistance24



toc
end %424




%dynamic nodes -  1 locus
if doSIRNTests(419) == 1
data.m = 419 %data file number
%1 locus model
%outputDirectory = 'randomGenotypesGraphs\ALL\Test419\' %BUMBLEBEE
outputDirectory = 'randomGenotypesGraphs\ALL\Test419\'
tic
modePar.netStr = 're'; %'rwp' random waypoint 're' random encounter
%*************************
%UNUSED PAR FOR RE MODE
%rwp par
modePar.genotypeTimeOutPeriod = 10; %rwp
modePar.xmin     = 1;     % Minimum x-axis location (du)
modePar.xmax     = 31;    % Maximum x-axis location (du)
modePar.ymin     = 1;     % Minimum y-axis location (du)
modePar.ymax     = 31;    % Maximum y-axis location (du)
modePar.smin     = 1.4;  % Minimum speed (du / tu)
modePar.smax     = 1.4;  % Maximum speed (du / tu)
modePar.pmin     = 0;     % Minimum time for pause (integer tu)
modePar.pmax     = 0;     % Maximum time for pause (integer tu)
modePar.dinr     = 3; %7    % Radial distance for in-range (du)
modePar.dexceed  = 1000;  % Value larger than any possible distance (du)
modePar.tinrg    = 1;     % Time in-range for genotype transfer (tu)
modePar.tinrv    = 1;     % Time in-range for virus transfer (tu)
% Mode
% rwph.mode = rwph.MODE_RIR;  1    % Select Random in range mode
% rwph.mode = rwph.MODE_NIR;  2    % Select Nearest in range mode
modePar.moderwp = 1; %MODE_AIR;  % 4    % Select (Random) Available in range mode
%rwp constrain
modePar.xboxc=0.5
modePar.yboxc=0.5
modePar.rwpcontrainplotGraph=0 %draw init constraints graph
% Log vector
modePar.logena = [1 2];
% Log directory for rwp
modePar.logDir = sprintf('%s\\log', pwd);
modePar.statnodesrwp = 'dynamic'; %'dynamic' or 'stationary' nodes, if dynamic box constraints applied at point of virus start
%END UNUSED PAR
%*****************
%data logging of output
data.logDir = sprintf('%s\\outputdata', pwd)
s = sprintf('%s\\data%i.txt', data.logDir,data.m)
data.logOutput(data.m) = fopen(s, 'wt');
%****************************************
modePar.numEncountersBetweenUpdates = 1
modePar.bufferlength = 10 %length of genotype buffer for favscore algorithm
modePar.genoInit = 'mindiv'  %initial conditions of genotypes maxdiv (maximum diversity - random variant chosen) mindiv (minimum diversity - all nodes same)
%blacklist mode
modePar.blklist = 'yes'; %yes or no
modePar.numToBlklist = 1
modePar.blklistrate = 0.004 %0.001
%vmupdate mode
modePar.vm = 'yes' %yes or no

%update mode
modePar.update = 'yes' %stop updating mode
modePar.bufferlengthNei=10 %buffer for buffering local nei diversity,
modePar.stdNeiUpdateThreshold = 0.15
%recovery
recovery = 0; %0.004; 0.0005 %0.001
%*****************************************
%**********************
%constraints
modePar.numToConstrain = 0;%fix(numNodes*1/4); %constain a number of nodes to 1 variant
modePar.areaConstrainrwp='no'
%**********************
%main par
%numRuns = 50 %20 %100 %200
%numNodes = 100;
%SEpidemic=6; %cutoff;
numLoci=4; 
casetype = 'OR';
modePar.virusStartTime = 1200;
numTimestepsVR = [5000]; %7000?
%VR = [1 2 3 4 5];
VR = [1 3 5 7 9 11 13 15 17 18 19 20 21 22 23 25 27 30];
modePar.blklistStartTime = modePar.virusStartTime
numExploits=1;

%init parameters
ResistanceFSSI = zeros(1,size(VR,2)); % resistance SI
PeakTimeFS = zeros(1,size(VR,2)); %peak time
ResTimeFS = zeros(1,size(VR,2));  %resilience time
ResilienceFS = zeros(1,size(VR,2)); %resilience SIR
ResistanceFS = zeros(1,size(VR,2)); %resistance SIR
NumberInSEndFS = zeros(1,size(VR,2));%with vm updates
ResistanceFSVM = zeros(1,size(VR,2)); %vm resistance
ResilienceTimeFSVM = zeros(1,size(VR,2)); %vm resilience time
ResilienceFSVM = zeros(1,size(VR,2)); %vm resilience
ResistanceSI = zeros(1,size(VR,2)); % resistance SI
PeakTime = zeros(1,size(VR,2)); %peak time
ResTime = zeros(1,size(VR,2));  %resilience time
Resilience = zeros(1,size(VR,2)); %resilience SIR
Resistance = zeros(1,size(VR,2)); %resistance SIR
NumberInSEnd = zeros(1,size(VR,2));%with vm updates
ResistanceVM = zeros(1,size(VR,2)); %vm resistance
ResilienceTimeVM = zeros(1,size(VR,2)); %vm resilience time
ResilienceVM = zeros(1,size(VR,2)); %vm resilience


mode = 'Dynamic-favScore' %mode - can be 'static' or 'dynamic' 'Dynamic-random' 'Dynamic-favScore'
%monte carlo random genotype SIR model
%set up diversity mode parameters
modePar.modeStr = mode
modePar.stopUpdatingTime = 200000 %time at which to stop updating the genotypes
for j = 1:size(VR,2)%do for all VR
    variantRichness =  VR(j)
    numTimesteps = numTimestepsVR(1);
   
 betan = 0.02;  plotGraphs = 0; gamma = recovery;  throwAway = 'nonEpidemics', 
 %agent
 [figMeanNei figNeiOneRun fighistSpRun fighistRecovered fighistSusceptible fighistpeakValue fighistpeakTime fighistBeta fighistGamma fighistBetanew fighistGammanew figInfectedRun1 figBetaRun1 figGammaRun1 figRoRun1 figBetaGamma1 figBetaGamma2...
            meanNeiIndexDynamic betastd gammastd betastd2 betastdNew betastdNew2 gammastdNew peakTimemean peakTimestd peakValuemean peakValuestd...
            betameanmean gammameanmean betameanmean2 betameanmeanNew betameanmeanNew2 gammameanmeanNew Smean Imean Rmean Bmean NSmean Smedian Imedian Rmedian S I R NS SmeanN ImeanN1 RmeanN1 BmeanN1 Snewendmean Snewendstd Rnewendmean Rnewendstd Rnew_nonendmean Rnew_nonendstd propSimsNonEp propSimsNonEp_theoretical...
            numRunsMinor measuredProbMinor numRunsMajor measuredProbMajor meanmdist meannumInfectedVM...
            ] = monteCarloSIRN2(numRuns,numNodes, betan, variantRichness, numTimesteps, plotGraphs,gamma,throwAway,SEpidemic,numExploits,modePar, numLoci, casetype);
   close all; 
   
    %peak time SI
    FinalSizeI = max(Imean,[],2); %mean final size SI
    maska = Imean >= FinalSizeI-1; %when within 1 of the final value
    [C Index] = max(maska);
    PeakTimeFS(j) = Index - modePar.virusStartTime; %T1
    if PeakTimeFS(j) < 0; PeakTimeFS(j)=0; end %check to see if picks an index before the virus start time, must be no outbreak and zero
    %Resistance SI
    ResistanceFSSI(j) = (numNodes-FinalSizeI)./numNodes;  
    %Resilience SIR
     FinalSize = max(RmeanN1,[],2); %mean final R of epidemics only
    maska = RmeanN1 >= FinalSize-1; %when within 1 of the final value
    [C Index] = max(maska);
    ResTimeFS(j) = Index -modePar.virusStartTime; %T1 
    if ResTimeFS(j) < 0; ResTimeFS(j)=0; end %check to see if picks an index before the virus start time, must be no outbreak and zero
    ResilienceFS(j) = 1./ResTimeFS(j);
    %resistance SIR
    ResistanceFS(j) = (numNodes-FinalSize)./numNodes;
    
    %VM update Resistance
     ResistanceFSVM(j) =(numNodes - meannumInfectedVM)./numNodes; %number infected at least once
     %[val index] = min(Imean(modePar.virusStartTime:end)) %time for infected to die away
     maska = Imean(modePar.virusStartTime:end) >= 1; %time when within 1 of zero
    [C indvm] = min(maska); %get index of first zero
     ResilienceTimeFSVM(j)= indvm-1; %index 1 means timw zero of malware injection so subtract 1
    ResilienceFSVM(j) = 1./(indvm-1);
     %with vm updates can get rid of those infected to count ended up in S
    %at end
    NumberInSEndFS(j) = Smean(end);
    
  
   
%data logging
 fprintf(data.logOutput(data.m), '%f,', Imean);     % infection
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResistanceFSSI(j)); % resistance SI
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', PeakTimeFS(j)); %peak time
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResTimeFS(j));     %resilience time
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResilienceFS(j)); %resilience
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResistanceFS(j)); %resistance SIR
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', NumberInSEndFS(j));  %with vm updates can get rid of those infected to count ended up in S    %at end
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResistanceFSVM(j));  
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResilienceTimeFSVM(j));  
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResilienceFSVM(j));  
fprintf(data.logOutput(data.m), '\n'); %new line
end %VR


mode = 'Dynamic-random' %mode - can be 'static' or 'dynamic' 'Dynamic-random' 'Dynamic-favScore'
%monte carlo random genotype SIR model
%set up diversity mode parameters
modePar.modeStr = mode
modePar.stopUpdatingTime = modePar.virusStartTime %time at which to stop updating the genotypes
for j = 1:size(VR,2)%do for all VR
    variantRichness =  VR(j)
    numTimesteps = numTimestepsVR(1);
 betan = 0.02;  plotGraphs = 0; gamma = recovery; throwAway = 'nonEpidemics';
 %agent
 [figMeanNei figNeiOneRun fighistSpRun fighistRecovered fighistSusceptible fighistpeakValue fighistpeakTime fighistBeta fighistGamma fighistBetanew fighistGammanew figInfectedRun1 figBetaRun1 figGammaRun1 figRoRun1 figBetaGamma1 figBetaGamma2...
            meanNeiIndexDynamic betastd gammastd betastd2 betastdNew betastdNew2 gammastdNew peakTimemean peakTimestd peakValuemean peakValuestd...
            betameanmean gammameanmean betameanmean2 betameanmeanNew betameanmeanNew2 gammameanmeanNew Smean Imean Rmean Bmean NSmean Smedian Imedian Rmedian S I R NS SmeanN ImeanN1 RmeanN1 BmeanN1 Snewendmean Snewendstd Rnewendmean Rnewendstd Rnew_nonendmean Rnew_nonendstd propSimsNonEp propSimsNonEp_theoretical...
            numRunsMinor measuredProbMinor numRunsMajor measuredProbMajor meanmdist meannumInfectedVM...
            ] = monteCarloSIRN2(numRuns,numNodes, betan, variantRichness, numTimesteps, plotGraphs,gamma,throwAway,SEpidemic,numExploits,modePar, numLoci, casetype);
   close all; 
   
   %peak time SI
    FinalSizeI = max(Imean,[],2); %mean final size SI
   maska = Imean >= FinalSizeI-1; %when within 1 of the final value
   [C Index] = max(maska);
   PeakTime(j) = Index-modePar.virusStartTime; %T1
   if PeakTime(j) < 0; PeakTime(j)=0; end %check to see if picks an index before the virus start time, must be no outbreak and zero
  %Resistance SI
    ResistanceSI(j) = (numNodes-FinalSizeI)./numNodes; 
    %Resilience SIR
     FinalSize = max(RmeanN1,[],2); %mean final R of epidemics only
    maska = RmeanN1 >= FinalSize-1; %when within 1 of the final value
   [C Index] = max(maska);
   ResTime(j) = Index-modePar.virusStartTime; %T1 
   if ResTime(j) < 0; ResTime(j)=0; end %check to see if picks an index before the virus start time, must be no outbreak and zero
   Resilience(j) = 1./ResTime(j);
   %resistance SIR
   Resistance(j) = (numNodes-FinalSize)./numNodes;
    %VM update Resistance
     ResistanceVM(j) =(numNodes - meannumInfectedVM)./numNodes; %number infected at least once
     %[val index] = min(Imean(modePar.virusStartTime:end)) %time for infected to die away
     maska = Imean(modePar.virusStartTime:end) >= 1; %time when within 1 of zero
    [C indvm] = min(maska); %get index of first zero
     ResilienceTimeVM(j)= indvm-1; %index 1 means timw zero of malware injection so subtract 1
    ResilienceVM(j) = 1./(indvm-1);
     %with vm updates can get rid of those infected to count ended up in S
    %at end
    NumberInSEnd(j) = Smean(end);
  
%data logging
 fprintf(data.logOutput(data.m), '%f,', Imean);     % infection
fprintf(data.logOutput(data.m), '\n'); %new line
fprintf(data.logOutput(data.m), '%f,', ResistanceSI(j)); % resistance SI
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', PeakTime(j)); %peak time
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResTime(j));     %resilience time
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', Resilience(j)); %resilience
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', Resistance(j)); %resistance SIR
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', NumberInSEnd(j));  %with vm updates can get rid of those infected to count ended up in S
fprintf(data.logOutput(data.m), '\n'); %new line 
fprintf(data.logOutput(data.m), '%f,', ResistanceVM(j));  
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResilienceTimeVM(j));  
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResilienceVM(j));  
fprintf(data.logOutput(data.m), '\n'); %new line
end %VR

fclose(data.logOutput(data.m));

%last Imean
figImean = figure;
plot(Imean, 'k')
xlabel('Time (seconds)')
ylabel('Number Infected')
%peak time SI
figIPeak = figure;
plot(VR,PeakTimeFS, 'k+-')
hold on
plot(VR,PeakTime, 'ko-')
xlabel('Variant Richness')
ylabel('Peak Time - SI')
%resistance SI
figResistanceSI=figure;
plot(VR,ResistanceFSSI,'k+-')
hold on
plot(VR,ResistanceSI,'ko-')
xlabel('Variant Richness')
ylabel('Peak I ')

%resilience time SIR
figResilienceTimeSI=figure;
plot(VR,ResTimeFS, 'k+-')
hold on
plot(VR,ResTime, 'ko-')
xlabel('Variant Richness')
ylabel('Resilience time - SIR')

%resilience SIR
figResilienceSIR=figure;
plot(VR,ResilienceFS, 'k+-')
hold on
plot(VR,Resilience, 'ko-')
xlabel('Variant Richness')
ylabel('Resilience - SIR')

%Resistance SIR
figResistenceSIR=figure
plot(VR,ResistanceFS, 'k+-')
hold on
plot(VR,Resistance, 'ko-')
xlabel('Variant Richness')
ylabel('Resistance - SIR')

%VM mode
%s
figsuceptEndVM=figure;
plot(VR,NumberInSEndFS,'k+-')
hold on
plot(VR,NumberInSEnd,'ko-')
xlabel('Variant Richness')
ylabel('Susceptible End - SI')

figResistanceVM=figure
plot(VR,ResistanceFSVM,'k+-')
hold on
plot(VR,ResistanceVM,'ko-')
xlabel('Variant Richness')
ylabel('Resistance - VM')

figResilienceTimeVM=figure;
plot(VR,ResilienceTimeFSVM,'k+-')
hold on
plot(VR,ResilienceTimeVM,'ko-')
xlabel('Variant Richness')
ylabel('Resilience time - VM')

figResilienceVM = figure;
plot(VR,ResilienceFSVM,'k+-')
hold on
plot(VR,ResilienceVM,'ko-')
xlabel('Variant Richness')
ylabel('Resilience - VM')

ResistanceFSSI % resistance SI
PeakTimeFS %peak time
ResTimeFS  %resilience time
ResilienceFS %resilience SIR
ResistanceFS %resistance SIR
NumberInSEndFS%with vm updates
ResistanceFSVM %vm resistance
ResilienceTimeFSVM %vm resilience time
ResilienceFSVM %vm resilience


ResistanceSI % resistance SI
PeakTime %peak time
ResTime  %resilience time
Resilience %resilience SIR
Resistance %resistance SIR
NumberInSEnd%with vm updates
ResistanceVM %vm resistance
ResilienceTimeVM %vm resilience time
ResilienceVM %vm resilience
fileName = [outputDirectory num2str(data.m) 'output.txt']
outFile = fopen(fileName, 'wt');
fprintf(outFile, '%s\n,', 'ResistanceFSSI'); fprintf(outFile, '%f,', ResistanceFSSI); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'PeakTimeFS'); fprintf(outFile, '%f,', PeakTimeFS); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'ResTimeFS'); fprintf(outFile, '%f,', ResTimeFS); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'ResilienceFS'); fprintf(outFile, '%f,', ResilienceFS); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'ResistanceFS'); fprintf(outFile, '%f,', ResistanceFS); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'NumberInSEndFS'); fprintf(outFile, '%f,', NumberInSEndFS); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'ResistanceFSVM'); fprintf(outFile, '%f,', ResistanceFSVM); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'ResilienceTimeFSVM'); fprintf(outFile, '%f,', ResilienceTimeFSVM); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'ResilienceFSVM'); fprintf(outFile, '%f,', ResilienceFSVM); fprintf(outFile, '\n'); %new line

fprintf(outFile, '%s\n,', 'ResistanceSI'); fprintf(outFile, '%f,', ResistanceSI); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'PeakTime'); fprintf(outFile, '%f,', PeakTime); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'ResTime'); fprintf(outFile, '%f,', ResTime); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'Resilience'); fprintf(outFile, '%f,', Resilience); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'Resistance'); fprintf(outFile, '%f,', Resistance); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'NumberInSEnd'); fprintf(outFile, '%f,', NumberInSEnd); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'ResistanceVM'); fprintf(outFile, '%f,', ResistanceVM); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'ResilienceTimeVM'); fprintf(outFile, '%f,', ResilienceTimeVM); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'ResilienceVM'); fprintf(outFile, '%f,', ResilienceVM); fprintf(outFile, '\n'); %new line
fclose(outFile);


saveas(figImean,[outputDirectory 'figImean.fig']);
saveas(figImean,[outputDirectory 'figImean.emf']);
saveas(figIPeak,[outputDirectory 'figIPeak.fig']);
saveas(figIPeak,[outputDirectory 'figIPeak.emf']);
saveas(figResistanceSI,[outputDirectory 'figResistanceSI.fig']);
saveas(figResistanceSI,[outputDirectory 'figResistanceSI.emf']);
saveas(figResilienceTimeSI,[outputDirectory 'figResilienceTimeSI.fig']);
saveas(figResilienceTimeSI,[outputDirectory 'figResilienceTimeSI.emf']);
saveas(figResilienceSIR,[outputDirectory 'figResilienceSIR.fig']);
saveas(figResilienceSIR,[outputDirectory 'figResilienceSIR.emf']);
saveas(figResistenceSIR,[outputDirectory 'figResistenceSIR.fig']);
saveas(figResistenceSIR,[outputDirectory 'figResistenceSIR.emf']);
saveas(figsuceptEndVM,[outputDirectory 'figsuceptEndVM.fig']);
saveas(figsuceptEndVM,[outputDirectory 'figsuceptEndVM.emf']);
saveas(figResistanceVM,[outputDirectory 'figResistanceVM.fig']);
saveas(figResistanceVM,[outputDirectory 'figResistanceVM.emf']);
saveas(figResilienceTimeVM,[outputDirectory 'figResilienceTimeVM.fig']);
saveas(figResilienceTimeVM,[outputDirectory 'figResilienceTimeVM.emf']);
saveas(figResilienceVM,[outputDirectory 'figResilienceVM.fig']);
saveas(figResilienceVM,[outputDirectory 'figResilienceVM.emf']);
close all;
toc
%end%419

%dynamic nodes -  1 locus
%if doSIRNTests(418) == 1
data.m = 418 %data file number
%1 locus model
%outputDirectory = 'randomGenotypesGraphs\ALL\Test418\' %BUMBLEBEE
outputDirectory = 'randomGenotypesGraphs\ALL\Test418\'
tic
modePar.netStr = 're'; %'rwp' random waypoint 're' random encounter
%*************************
%UNUSED PAR FOR RE MODE
%rwp par
modePar.genotypeTimeOutPeriod = 10; %rwp
modePar.xmin     = 1;     % Minimum x-axis location (du)
modePar.xmax     = 31;    % Maximum x-axis location (du)
modePar.ymin     = 1;     % Minimum y-axis location (du)
modePar.ymax     = 31;    % Maximum y-axis location (du)
modePar.smin     = 1.4;  % Minimum speed (du / tu)
modePar.smax     = 1.4;  % Maximum speed (du / tu)
modePar.pmin     = 0;     % Minimum time for pause (integer tu)
modePar.pmax     = 0;     % Maximum time for pause (integer tu)
modePar.dinr     = 3; %7    % Radial distance for in-range (du)
modePar.dexceed  = 1000;  % Value larger than any possible distance (du)
modePar.tinrg    = 1;     % Time in-range for genotype transfer (tu)
modePar.tinrv    = 1;     % Time in-range for virus transfer (tu)
% Mode
% rwph.mode = rwph.MODE_RIR;  1    % Select Random in range mode
% rwph.mode = rwph.MODE_NIR;  2    % Select Nearest in range mode
modePar.moderwp = 1; %MODE_AIR;  % 4    % Select (Random) Available in range mode
%rwp constrain
modePar.xboxc=0.5
modePar.yboxc=0.5
modePar.rwpcontrainplotGraph=0 %draw init constraints graph
% Log vector
modePar.logena = [1 2];
% Log directory for rwp
modePar.logDir = sprintf('%s\\log', pwd);
modePar.statnodesrwp = 'dynamic'; %'dynamic' or 'stationary' nodes, if dynamic box constraints applied at point of virus start
%END UNUSED PAR
%*****************
%data logging of output
data.logDir = sprintf('%s\\outputdata', pwd)
s = sprintf('%s\\data%i.txt', data.logDir,data.m)
data.logOutput(data.m) = fopen(s, 'wt');
%****************************************
modePar.numEncountersBetweenUpdates = 1
modePar.bufferlength = 10 %length of genotype buffer for favscore algorithm
modePar.genoInit = 'mindiv'  %initial conditions of genotypes maxdiv (maximum diversity - random variant chosen) mindiv (minimum diversity - all nodes same)
%blacklist mode
modePar.blklist = 'yes'; %yes or no
modePar.numToBlklist = 1
modePar.blklistrate = 0.004 %0.001
%vmupdate mode
modePar.vm = 'yes' %yes or no

%update mode
modePar.update = 'yes' %stop updating mode
modePar.bufferlengthNei=10 %buffer for buffering local nei diversity,
modePar.stdNeiUpdateThreshold = 0.15
%recovery
recovery = 0; %0.004; 0.0005 %0.001
%*****************************************
%**********************
%constraints
modePar.numToConstrain = 0;%fix(numNodes*1/4); %constain a number of nodes to 1 variant
modePar.areaConstrainrwp='no'
%**********************
%main par
%numRuns = 10 %20 %100 %200
%numNodes = 100;
%SEpidemic=6; %cutoff;
numLoci=4; 
casetype = 'AND';
modePar.virusStartTime = 1200;
numTimestepsVR = [5000]; %7000?
VR = [1 2 3 4 5];
modePar.blklistStartTime = modePar.virusStartTime
numExploits=1;

%init parameters
ResistanceFSSI = zeros(1,size(VR,2)); % resistance SI
PeakTimeFS = zeros(1,size(VR,2)); %peak time
ResTimeFS = zeros(1,size(VR,2));  %resilience time
ResilienceFS = zeros(1,size(VR,2)); %resilience SIR
ResistanceFS = zeros(1,size(VR,2)); %resistance SIR
NumberInSEndFS = zeros(1,size(VR,2));%with vm updates
ResistanceFSVM = zeros(1,size(VR,2)); %vm resistance
ResilienceTimeFSVM = zeros(1,size(VR,2)); %vm resilience time
ResilienceFSVM = zeros(1,size(VR,2)); %vm resilience
ResistanceSI = zeros(1,size(VR,2)); % resistance SI
PeakTime = zeros(1,size(VR,2)); %peak time
ResTime = zeros(1,size(VR,2));  %resilience time
Resilience = zeros(1,size(VR,2)); %resilience SIR
Resistance = zeros(1,size(VR,2)); %resistance SIR
NumberInSEnd = zeros(1,size(VR,2));%with vm updates
ResistanceVM = zeros(1,size(VR,2)); %vm resistance
ResilienceTimeVM = zeros(1,size(VR,2)); %vm resilience time
ResilienceVM = zeros(1,size(VR,2)); %vm resilience

mode = 'Dynamic-favScore' %mode - can be 'static' or 'dynamic' 'Dynamic-random' 'Dynamic-favScore'
%monte carlo random genotype SIR model
%set up diversity mode parameters
modePar.modeStr = mode
modePar.stopUpdatingTime = 200000 %time at which to stop updating the genotypes
for j = 1:size(VR,2)%do for all VR
    variantRichness =  VR(j)
    numTimesteps = numTimestepsVR(1);
   
 betan = 0.02;  plotGraphs = 0; gamma = recovery;  throwAway = 'nonEpidemics', 
 %agent
 [figMeanNei figNeiOneRun fighistSpRun fighistRecovered fighistSusceptible fighistpeakValue fighistpeakTime fighistBeta fighistGamma fighistBetanew fighistGammanew figInfectedRun1 figBetaRun1 figGammaRun1 figRoRun1 figBetaGamma1 figBetaGamma2...
            meanNeiIndexDynamic betastd gammastd betastd2 betastdNew betastdNew2 gammastdNew peakTimemean peakTimestd peakValuemean peakValuestd...
            betameanmean gammameanmean betameanmean2 betameanmeanNew betameanmeanNew2 gammameanmeanNew Smean Imean Rmean Bmean NSmean Smedian Imedian Rmedian S I R NS SmeanN ImeanN1 RmeanN1 BmeanN1 Snewendmean Snewendstd Rnewendmean Rnewendstd Rnew_nonendmean Rnew_nonendstd propSimsNonEp propSimsNonEp_theoretical...
            numRunsMinor measuredProbMinor numRunsMajor measuredProbMajor meanmdist meannumInfectedVM...
            ] = monteCarloSIRN2(numRuns,numNodes, betan, variantRichness, numTimesteps, plotGraphs,gamma,throwAway,SEpidemic,numExploits,modePar, numLoci, casetype);
   close all; 
   
    %peak time SI
    FinalSizeI = max(Imean,[],2); %mean final size SI
    maska = Imean >= FinalSizeI-1; %when within 1 of the final value
    [C Index] = max(maska);
    PeakTimeFS(j) = Index - modePar.virusStartTime; %T1
    if PeakTimeFS(j) < 0; PeakTimeFS(j)=0; end %check to see if picks an index before the virus start time, must be no outbreak and zero
    %Resistance SI
    ResistanceFSSI(j) = (numNodes-FinalSizeI)./numNodes;  
    %Resilience SIR
     FinalSize = max(RmeanN1,[],2); %mean final R of epidemics only
    maska = RmeanN1 >= FinalSize-1; %when within 1 of the final value
    [C Index] = max(maska);
    ResTimeFS(j) = Index -modePar.virusStartTime; %T1 
    if ResTimeFS(j) < 0; ResTimeFS(j)=0; end %check to see if picks an index before the virus start time, must be no outbreak and zero
    ResilienceFS(j) = 1./ResTimeFS(j);
    %resistance SIR
    ResistanceFS(j) = (numNodes-FinalSize)./numNodes;
    
    %VM update Resistance
     ResistanceFSVM(j) =(numNodes - meannumInfectedVM)./numNodes; %number infected at least once
     %[val index] = min(Imean(modePar.virusStartTime:end)) %time for infected to die away
     maska = Imean(modePar.virusStartTime:end) >= 1; %time when within 1 of zero
    [C indvm] = min(maska); %get index of first zero
     ResilienceTimeFSVM(j)= indvm-1; %index 1 means timw zero of malware injection so subtract 1
    ResilienceFSVM(j) = 1./(indvm-1);
     %with vm updates can get rid of those infected to count ended up in S
    %at end
    NumberInSEndFS(j) = Smean(end);
    
  
   
%data logging
 fprintf(data.logOutput(data.m), '%f,', Imean);     % infection
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResistanceFSSI(j)); % resistance SI
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', PeakTimeFS(j)); %peak time
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResTimeFS(j));     %resilience time
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResilienceFS(j)); %resilience
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResistanceFS(j)); %resistance SIR
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', NumberInSEndFS(j));  %with vm updates can get rid of those infected to count ended up in S    %at end
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResistanceFSVM(j));  
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResilienceTimeFSVM(j));  
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResilienceFSVM(j));  
fprintf(data.logOutput(data.m), '\n'); %new line
end %VR


mode = 'Dynamic-random' %mode - can be 'static' or 'dynamic' 'Dynamic-random' 'Dynamic-favScore'
%monte carlo random genotype SIR model
%set up diversity mode parameters
modePar.modeStr = mode
modePar.stopUpdatingTime = modePar.virusStartTime %time at which to stop updating the genotypes
for j = 1:size(VR,2)%do for all VR
    variantRichness =  VR(j)
    numTimesteps = numTimestepsVR(1);
 betan = 0.02;  plotGraphs = 0; gamma = recovery; throwAway = 'nonEpidemics';
 %agent
 [figMeanNei figNeiOneRun fighistSpRun fighistRecovered fighistSusceptible fighistpeakValue fighistpeakTime fighistBeta fighistGamma fighistBetanew fighistGammanew figInfectedRun1 figBetaRun1 figGammaRun1 figRoRun1 figBetaGamma1 figBetaGamma2...
            meanNeiIndexDynamic betastd gammastd betastd2 betastdNew betastdNew2 gammastdNew peakTimemean peakTimestd peakValuemean peakValuestd...
            betameanmean gammameanmean betameanmean2 betameanmeanNew betameanmeanNew2 gammameanmeanNew Smean Imean Rmean Bmean NSmean Smedian Imedian Rmedian S I R NS SmeanN ImeanN1 RmeanN1 BmeanN1 Snewendmean Snewendstd Rnewendmean Rnewendstd Rnew_nonendmean Rnew_nonendstd propSimsNonEp propSimsNonEp_theoretical...
            numRunsMinor measuredProbMinor numRunsMajor measuredProbMajor meanmdist meannumInfectedVM...
            ] = monteCarloSIRN2(numRuns,numNodes, betan, variantRichness, numTimesteps, plotGraphs,gamma,throwAway,SEpidemic,numExploits,modePar, numLoci, casetype);
   close all; 
   
   %peak time SI
    FinalSizeI = max(Imean,[],2); %mean final size SI
   maska = Imean >= FinalSizeI-1; %when within 1 of the final value
   [C Index] = max(maska);
   PeakTime(j) = Index-modePar.virusStartTime; %T1
   if PeakTime(j) < 0; PeakTime(j)=0; end %check to see if picks an index before the virus start time, must be no outbreak and zero
  %Resistance SI
    ResistanceSI(j) = (numNodes-FinalSizeI)./numNodes; 
    %Resilience SIR
     FinalSize = max(RmeanN1,[],2); %mean final R of epidemics only
    maska = RmeanN1 >= FinalSize-1; %when within 1 of the final value
   [C Index] = max(maska);
   ResTime(j) = Index-modePar.virusStartTime; %T1 
   if ResTime(j) < 0; ResTime(j)=0; end %check to see if picks an index before the virus start time, must be no outbreak and zero
   Resilience(j) = 1./ResTime(j);
   %resistance SIR
   Resistance(j) = (numNodes-FinalSize)./numNodes;
    %VM update Resistance
     ResistanceVM(j) =(numNodes - meannumInfectedVM)./numNodes; %number infected at least once
     %[val index] = min(Imean(modePar.virusStartTime:end)) %time for infected to die away
     maska = Imean(modePar.virusStartTime:end) >= 1; %time when within 1 of zero
    [C indvm] = min(maska); %get index of first zero
     ResilienceTimeVM(j)= indvm-1; %index 1 means timw zero of malware injection so subtract 1
    ResilienceVM(j) = 1./(indvm-1);
     %with vm updates can get rid of those infected to count ended up in S
    %at end
    NumberInSEnd(j) = Smean(end);
  
%data logging
 fprintf(data.logOutput(data.m), '%f,', Imean);     % infection
fprintf(data.logOutput(data.m), '\n'); %new line
fprintf(data.logOutput(data.m), '%f,', ResistanceSI(j)); % resistance SI
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', PeakTime(j)); %peak time
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResTime(j));     %resilience time
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', Resilience(j)); %resilience
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', Resistance(j)); %resistance SIR
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', NumberInSEnd(j));  %with vm updates can get rid of those infected to count ended up in S
fprintf(data.logOutput(data.m), '\n'); %new line 
fprintf(data.logOutput(data.m), '%f,', ResistanceVM(j));  
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResilienceTimeVM(j));  
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResilienceVM(j));  
fprintf(data.logOutput(data.m), '\n'); %new line
end %VR

fclose(data.logOutput(data.m));

%last Imean
figImean = figure;
plot(Imean, 'k')
xlabel('Time (seconds)')
ylabel('Number Infected')
%peak time SI
figIPeak = figure;
plot(VR,PeakTimeFS, 'k+-')
hold on
plot(VR,PeakTime, 'ko-')
xlabel('Variant Richness')
ylabel('Peak Time - SI')
%resistance SI
figResistanceSI=figure;
plot(VR,ResistanceFSSI,'k+-')
hold on
plot(VR,ResistanceSI,'ko-')
xlabel('Variant Richness')
ylabel('Peak I ')

%resilience time SIR
figResilienceTimeSI=figure;
plot(VR,ResTimeFS, 'k+-')
hold on
plot(VR,ResTime, 'ko-')
xlabel('Variant Richness')
ylabel('Resilience time - SIR')

%resilience SIR
figResilienceSIR=figure;
plot(VR,ResilienceFS, 'k+-')
hold on
plot(VR,Resilience, 'ko-')
xlabel('Variant Richness')
ylabel('Resilience - SIR')

%Resistance SIR
figResistenceSIR=figure
plot(VR,ResistanceFS, 'k+-')
hold on
plot(VR,Resistance, 'ko-')
xlabel('Variant Richness')
ylabel('Resistance - SIR')

%VM mode
%s
figsuceptEndVM=figure;
plot(VR,NumberInSEndFS,'k+-')
hold on
plot(VR,NumberInSEnd,'ko-')
xlabel('Variant Richness')
ylabel('Susceptible End - SI')

figResistanceVM=figure
plot(VR,ResistanceFSVM,'k+-')
hold on
plot(VR,ResistanceVM,'ko-')
xlabel('Variant Richness')
ylabel('Resistance - VM')

figResilienceTimeVM=figure;
plot(VR,ResilienceTimeFSVM,'k+-')
hold on
plot(VR,ResilienceTimeVM,'ko-')
xlabel('Variant Richness')
ylabel('Resilience time - VM')

figResilienceVM = figure;
plot(VR,ResilienceFSVM,'k+-')
hold on
plot(VR,ResilienceVM,'ko-')
xlabel('Variant Richness')
ylabel('Resilience - VM')

ResistanceFSSI % resistance SI
PeakTimeFS %peak time
ResTimeFS  %resilience time
ResilienceFS %resilience SIR
ResistanceFS %resistance SIR
NumberInSEndFS%with vm updates
ResistanceFSVM %vm resistance
ResilienceTimeFSVM %vm resilience time
ResilienceFSVM %vm resilience


ResistanceSI % resistance SI
PeakTime %peak time
ResTime  %resilience time
Resilience %resilience SIR
Resistance %resistance SIR
NumberInSEnd%with vm updates
ResistanceVM %vm resistance
ResilienceTimeVM %vm resilience time
ResilienceVM %vm resilience
fileName = [outputDirectory num2str(data.m) 'output.txt']
outFile = fopen(fileName, 'wt');
fprintf(outFile, '%s\n,', 'ResistanceFSSI'); fprintf(outFile, '%f,', ResistanceFSSI); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'PeakTimeFS'); fprintf(outFile, '%f,', PeakTimeFS); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'ResTimeFS'); fprintf(outFile, '%f,', ResTimeFS); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'ResilienceFS'); fprintf(outFile, '%f,', ResilienceFS); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'ResistanceFS'); fprintf(outFile, '%f,', ResistanceFS); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'NumberInSEndFS'); fprintf(outFile, '%f,', NumberInSEndFS); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'ResistanceFSVM'); fprintf(outFile, '%f,', ResistanceFSVM); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'ResilienceTimeFSVM'); fprintf(outFile, '%f,', ResilienceTimeFSVM); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'ResilienceFSVM'); fprintf(outFile, '%f,', ResilienceFSVM); fprintf(outFile, '\n'); %new line

fprintf(outFile, '%s\n,', 'ResistanceSI'); fprintf(outFile, '%f,', ResistanceSI); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'PeakTime'); fprintf(outFile, '%f,', PeakTime); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'ResTime'); fprintf(outFile, '%f,', ResTime); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'Resilience'); fprintf(outFile, '%f,', Resilience); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'Resistance'); fprintf(outFile, '%f,', Resistance); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'NumberInSEnd'); fprintf(outFile, '%f,', NumberInSEnd); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'ResistanceVM'); fprintf(outFile, '%f,', ResistanceVM); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'ResilienceTimeVM'); fprintf(outFile, '%f,', ResilienceTimeVM); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'ResilienceVM'); fprintf(outFile, '%f,', ResilienceVM); fprintf(outFile, '\n'); %new line
fclose(outFile);


saveas(figImean,[outputDirectory 'figImean.fig']);
saveas(figImean,[outputDirectory 'figImean.emf']);
saveas(figIPeak,[outputDirectory 'figIPeak.fig']);
saveas(figIPeak,[outputDirectory 'figIPeak.emf']);
saveas(figResistanceSI,[outputDirectory 'figResistanceSI.fig']);
saveas(figResistanceSI,[outputDirectory 'figResistanceSI.emf']);
saveas(figResilienceTimeSI,[outputDirectory 'figResilienceTimeSI.fig']);
saveas(figResilienceTimeSI,[outputDirectory 'figResilienceTimeSI.emf']);
saveas(figResilienceSIR,[outputDirectory 'figResilienceSIR.fig']);
saveas(figResilienceSIR,[outputDirectory 'figResilienceSIR.emf']);
saveas(figResistenceSIR,[outputDirectory 'figResistenceSIR.fig']);
saveas(figResistenceSIR,[outputDirectory 'figResistenceSIR.emf']);
saveas(figsuceptEndVM,[outputDirectory 'figsuceptEndVM.fig']);
saveas(figsuceptEndVM,[outputDirectory 'figsuceptEndVM.emf']);
saveas(figResistanceVM,[outputDirectory 'figResistanceVM.fig']);
saveas(figResistanceVM,[outputDirectory 'figResistanceVM.emf']);
saveas(figResilienceTimeVM,[outputDirectory 'figResilienceTimeVM.fig']);
saveas(figResilienceTimeVM,[outputDirectory 'figResilienceTimeVM.emf']);
saveas(figResilienceVM,[outputDirectory 'figResilienceVM.fig']);
saveas(figResilienceVM,[outputDirectory 'figResilienceVM.emf']);
close all;
toc
%end%418


%dynamic nodes -  1 locus
%if doSIRNTests(417) == 1
data.m = 417 %data file number
%1 locus model
%outputDirectory = 'randomGenotypesGraphs\ALL\Test417\' %BUMBLEBEE
outputDirectory = 'randomGenotypesGraphs\ALL\Test417\'
tic
modePar.netStr = 're'; %'rwp' random waypoint 're' random encounter
%*************************
%UNUSED PAR FOR RE MODE
%rwp par
modePar.genotypeTimeOutPeriod = 10; %rwp
modePar.xmin     = 1;     % Minimum x-axis location (du)
modePar.xmax     = 31;    % Maximum x-axis location (du)
modePar.ymin     = 1;     % Minimum y-axis location (du)
modePar.ymax     = 31;    % Maximum y-axis location (du)
modePar.smin     = 1.4;  % Minimum speed (du / tu)
modePar.smax     = 1.4;  % Maximum speed (du / tu)
modePar.pmin     = 0;     % Minimum time for pause (integer tu)
modePar.pmax     = 0;     % Maximum time for pause (integer tu)
modePar.dinr     = 3; %7    % Radial distance for in-range (du)
modePar.dexceed  = 1000;  % Value larger than any possible distance (du)
modePar.tinrg    = 1;     % Time in-range for genotype transfer (tu)
modePar.tinrv    = 1;     % Time in-range for virus transfer (tu)
% Mode
% rwph.mode = rwph.MODE_RIR;  1    % Select Random in range mode
% rwph.mode = rwph.MODE_NIR;  2    % Select Nearest in range mode
modePar.moderwp = 1; %MODE_AIR;  % 4    % Select (Random) Available in range mode
%rwp constrain
modePar.xboxc=0.5
modePar.yboxc=0.5
modePar.rwpcontrainplotGraph=0 %draw init constraints graph
% Log vector
modePar.logena = [1 2];
% Log directory for rwp
modePar.logDir = sprintf('%s\\log', pwd);
modePar.statnodesrwp = 'dynamic'; %'dynamic' or 'stationary' nodes, if dynamic box constraints applied at point of virus start
%END UNUSED PAR
%*****************
%data logging of output
data.logDir = sprintf('%s\\outputdata', pwd)
s = sprintf('%s\\data%i.txt', data.logDir,data.m)
data.logOutput(data.m) = fopen(s, 'wt');
%****************************************
modePar.numEncountersBetweenUpdates = 1
modePar.bufferlength = 10 %length of genotype buffer for favscore algorithm
modePar.genoInit = 'mindiv'  %initial conditions of genotypes maxdiv (maximum diversity - random variant chosen) mindiv (minimum diversity - all nodes same)
%blacklist mode
modePar.blklist = 'yes'; %yes or no
modePar.numToBlklist = 1
modePar.blklistrate = 0.004 %0.001
%vmupdate mode
modePar.vm = 'yes' %yes or no

%update mode
modePar.update = 'yes' %stop updating mode
modePar.bufferlengthNei=10 %buffer for buffering local nei diversity,
modePar.stdNeiUpdateThreshold = 0.15
%recovery
recovery = 0; %0.004; 0.0005 %0.001
%*****************************************
%**********************
%constraints
modePar.numToConstrain = 0;%fix(numNodes*1/4); %constain a number of nodes to 1 variant
modePar.areaConstrainrwp='no'
%**********************
%main par
%numRuns = 50 %20 %100 %200
%numNodes = 100;
%SEpidemic=6; %cutoff;
numLoci=1; 
casetype = 'OR';
modePar.virusStartTime = 1200;
numTimestepsVR = [5000]; %7000?
VR = [1 2 3 4 5 6 7 8 9 10];
modePar.blklistStartTime = modePar.virusStartTime
numExploits=1;

%init parameters
ResistanceFSSI = zeros(1,size(VR,2)); % resistance SI
PeakTimeFS = zeros(1,size(VR,2)); %peak time
ResTimeFS = zeros(1,size(VR,2));  %resilience time
ResilienceFS = zeros(1,size(VR,2)); %resilience SIR
ResistanceFS = zeros(1,size(VR,2)); %resistance SIR
NumberInSEndFS = zeros(1,size(VR,2));%with vm updates
ResistanceFSVM = zeros(1,size(VR,2)); %vm resistance
ResilienceTimeFSVM = zeros(1,size(VR,2)); %vm resilience time
ResilienceFSVM = zeros(1,size(VR,2)); %vm resilience
ResistanceSI = zeros(1,size(VR,2)); % resistance SI
PeakTime = zeros(1,size(VR,2)); %peak time
ResTime = zeros(1,size(VR,2));  %resilience time
Resilience = zeros(1,size(VR,2)); %resilience SIR
Resistance = zeros(1,size(VR,2)); %resistance SIR
NumberInSEnd = zeros(1,size(VR,2));%with vm updates
ResistanceVM = zeros(1,size(VR,2)); %vm resistance
ResilienceTimeVM = zeros(1,size(VR,2)); %vm resilience time
ResilienceVM = zeros(1,size(VR,2)); %vm resilience

mode = 'Dynamic-favScore' %mode - can be 'static' or 'dynamic' 'Dynamic-random' 'Dynamic-favScore'
%monte carlo random genotype SIR model
%set up diversity mode parameters
modePar.modeStr = mode
modePar.stopUpdatingTime = 200000 %time at which to stop updating the genotypes
for j = 1:size(VR,2)%do for all VR
    variantRichness =  VR(j)
    numTimesteps = numTimestepsVR(1);
   
 betan = 0.02;  plotGraphs = 0; gamma = recovery;  throwAway = 'nonEpidemics', 
 %agent
 [figMeanNei figNeiOneRun fighistSpRun fighistRecovered fighistSusceptible fighistpeakValue fighistpeakTime fighistBeta fighistGamma fighistBetanew fighistGammanew figInfectedRun1 figBetaRun1 figGammaRun1 figRoRun1 figBetaGamma1 figBetaGamma2...
            meanNeiIndexDynamic betastd gammastd betastd2 betastdNew betastdNew2 gammastdNew peakTimemean peakTimestd peakValuemean peakValuestd...
            betameanmean gammameanmean betameanmean2 betameanmeanNew betameanmeanNew2 gammameanmeanNew Smean Imean Rmean Bmean NSmean Smedian Imedian Rmedian S I R NS SmeanN ImeanN1 RmeanN1 BmeanN1 Snewendmean Snewendstd Rnewendmean Rnewendstd Rnew_nonendmean Rnew_nonendstd propSimsNonEp propSimsNonEp_theoretical...
            numRunsMinor measuredProbMinor numRunsMajor measuredProbMajor meanmdist meannumInfectedVM ...
            ] = monteCarloSIRN2(numRuns,numNodes, betan, variantRichness, numTimesteps, plotGraphs,gamma,throwAway,SEpidemic,numExploits,modePar, numLoci, casetype);
   close all; 
   
    %peak time SI
    FinalSizeI = max(Imean,[],2); %mean final size SI
    maska = Imean >= FinalSizeI-1; %when within 1 of the final value
    [C Index] = max(maska);
    PeakTimeFS(j) = Index - modePar.virusStartTime; %T1
    if PeakTimeFS(j) < 0; PeakTimeFS(j)=0; end %check to see if picks an index before the virus start time, must be no outbreak and zero
    %Resistance SI
    ResistanceFSSI(j) = (numNodes-FinalSizeI)./numNodes;  
    %Resilience SIR
     FinalSize = max(RmeanN1,[],2); %mean final R of epidemics only
    maska = RmeanN1 >= FinalSize-1; %when within 1 of the final value
    [C Index] = max(maska);
    ResTimeFS(j) = Index -modePar.virusStartTime; %T1 
    if ResTimeFS(j) < 0; ResTimeFS(j)=0; end %check to see if picks an index before the virus start time, must be no outbreak and zero
    ResilienceFS(j) = 1./ResTimeFS(j);
    %resistance SIR
    ResistanceFS(j) = (numNodes-FinalSize)./numNodes;
    
    %VM update Resistance
     ResistanceFSVM(j) =(numNodes - meannumInfectedVM)./numNodes; %number infected at least once
     %[val index] = min(Imean(modePar.virusStartTime:end)) %time for infected to die away
     maska = Imean(modePar.virusStartTime:end) >= 1; %time when within 1 of zero
    [C indvm] = min(maska); %get index of first zero
     ResilienceTimeFSVM(j)= indvm-1; %index 1 means timw zero of malware injection so subtract 1
    ResilienceFSVM(j) = 1./(indvm-1);
     %with vm updates can get rid of those infected to count ended up in S
    %at end
    NumberInSEndFS(j) = Smean(end);
    
  
   
%data logging
 fprintf(data.logOutput(data.m), '%f,', Imean);     % infection
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResistanceFSSI(j)); % resistance SI
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', PeakTimeFS(j)); %peak time
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResTimeFS(j));     %resilience time
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResilienceFS(j)); %resilience
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResistanceFS(j)); %resistance SIR
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', NumberInSEndFS(j));  %with vm updates can get rid of those infected to count ended up in S    %at end
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResistanceFSVM(j));  
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResilienceTimeFSVM(j));  
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResilienceFSVM(j));  
fprintf(data.logOutput(data.m), '\n'); %new line
end %VR


mode = 'Dynamic-random' %mode - can be 'static' or 'dynamic' 'Dynamic-random' 'Dynamic-favScore'
%monte carlo random genotype SIR model
%set up diversity mode parameters
modePar.modeStr = mode
modePar.stopUpdatingTime = modePar.virusStartTime %time at which to stop updating the genotypes
for j = 1:size(VR,2)%do for all VR
    variantRichness =  VR(j)
    numTimesteps = numTimestepsVR(1);
 betan = 0.02;  plotGraphs = 0; gamma = recovery; throwAway = 'nonEpidemics';
 %agent
 [figMeanNei figNeiOneRun fighistSpRun fighistRecovered fighistSusceptible fighistpeakValue fighistpeakTime fighistBeta fighistGamma fighistBetanew fighistGammanew figInfectedRun1 figBetaRun1 figGammaRun1 figRoRun1 figBetaGamma1 figBetaGamma2...
            meanNeiIndexDynamic betastd gammastd betastd2 betastdNew betastdNew2 gammastdNew peakTimemean peakTimestd peakValuemean peakValuestd...
            betameanmean gammameanmean betameanmean2 betameanmeanNew betameanmeanNew2 gammameanmeanNew Smean Imean Rmean Bmean NSmean Smedian Imedian Rmedian S I R NS SmeanN ImeanN1 RmeanN1 BmeanN1 Snewendmean Snewendstd Rnewendmean Rnewendstd Rnew_nonendmean Rnew_nonendstd propSimsNonEp propSimsNonEp_theoretical...
            numRunsMinor measuredProbMinor numRunsMajor measuredProbMajor meanmdist meannumInfectedVM...
            ] = monteCarloSIRN2(numRuns,numNodes, betan, variantRichness, numTimesteps, plotGraphs,gamma,throwAway,SEpidemic,numExploits,modePar, numLoci, casetype);
   close all; 
   
   %peak time SI
    FinalSizeI = max(Imean,[],2); %mean final size SI
   maska = Imean >= FinalSizeI-1; %when within 1 of the final value
   [C Index] = max(maska);
   PeakTime(j) = Index-modePar.virusStartTime; %T1
   if PeakTime(j) < 0; PeakTime(j)=0; end %check to see if picks an index before the virus start time, must be no outbreak and zero
  %Resistance SI
    ResistanceSI(j) = (numNodes-FinalSizeI)./numNodes; 
    %Resilience SIR
     FinalSize = max(RmeanN1,[],2); %mean final R of epidemics only
    maska = RmeanN1 >= FinalSize-1; %when within 1 of the final value
   [C Index] = max(maska);
   ResTime(j) = Index-modePar.virusStartTime; %T1 
   if ResTime(j) < 0; ResTime(j)=0; end %check to see if picks an index before the virus start time, must be no outbreak and zero
   Resilience(j) = 1./ResTime(j);
   %resistance SIR
   Resistance(j) = (numNodes-FinalSize)./numNodes;
    %VM update Resistance
     ResistanceVM(j) =(numNodes - meannumInfectedVM)./numNodes; %number infected at least once
     %[val index] = min(Imean(modePar.virusStartTime:end)) %time for infected to die away
     maska = Imean(modePar.virusStartTime:end) >= 1; %time when within 1 of zero
    [C indvm] = min(maska); %get index of first zero
     ResilienceTimeVM(j)= indvm-1; %index 1 means timw zero of malware injection so subtract 1
    ResilienceVM(j) = 1./(indvm-1);
     %with vm updates can get rid of those infected to count ended up in S
    %at end
    NumberInSEnd(j) = Smean(end);
  
%data logging
 fprintf(data.logOutput(data.m), '%f,', Imean);     % infection
fprintf(data.logOutput(data.m), '\n'); %new line
fprintf(data.logOutput(data.m), '%f,', ResistanceSI(j)); % resistance SI
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', PeakTime(j)); %peak time
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResTime(j));     %resilience time
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', Resilience(j)); %resilience
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', Resistance(j)); %resistance SIR
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', NumberInSEnd(j));  %with vm updates can get rid of those infected to count ended up in S
fprintf(data.logOutput(data.m), '\n'); %new line 
fprintf(data.logOutput(data.m), '%f,', ResistanceVM(j));  
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResilienceTimeVM(j));  
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResilienceVM(j));  
fprintf(data.logOutput(data.m), '\n'); %new line
end %VR

fclose(data.logOutput(data.m));

%last Imean
figImean = figure;
plot(Imean, 'k')
xlabel('Time (seconds)')
ylabel('Number Infected')
%peak time SI
figIPeak = figure;
plot(VR,PeakTimeFS, 'k+-')
hold on
plot(VR,PeakTime, 'ko-')
xlabel('Variant Richness')
ylabel('Peak Time - SI')
%resistance SI
figResistanceSI=figure;
plot(VR,ResistanceFSSI,'k+-')
hold on
plot(VR,ResistanceSI,'ko-')
xlabel('Variant Richness')
ylabel('Peak I ')

%resilience time SIR
figResilienceTimeSI=figure;
plot(VR,ResTimeFS, 'k+-')
hold on
plot(VR,ResTime, 'ko-')
xlabel('Variant Richness')
ylabel('Resilience time - SIR')

%resilience SIR
figResilienceSIR=figure;
plot(VR,ResilienceFS, 'k+-')
hold on
plot(VR,Resilience, 'ko-')
xlabel('Variant Richness')
ylabel('Resilience - SIR')

%Resistance SIR
figResistenceSIR=figure
plot(VR,ResistanceFS, 'k+-')
hold on
plot(VR,Resistance, 'ko-')
xlabel('Variant Richness')
ylabel('Resistance - SIR')

%VM mode
%s
figsuceptEndVM=figure;
plot(VR,NumberInSEndFS,'k+-')
hold on
plot(VR,NumberInSEnd,'ko-')
xlabel('Variant Richness')
ylabel('Susceptible End - SI')

figResistanceVM=figure
plot(VR,ResistanceFSVM,'k+-')
hold on
plot(VR,ResistanceVM,'ko-')
xlabel('Variant Richness')
ylabel('Resistance - VM')

figResilienceTimeVM=figure;
plot(VR,ResilienceTimeFSVM,'k+-')
hold on
plot(VR,ResilienceTimeVM,'ko-')
xlabel('Variant Richness')
ylabel('Resilience time - VM')

figResilienceVM = figure;
plot(VR,ResilienceFSVM,'k+-')
hold on
plot(VR,ResilienceVM,'ko-')
xlabel('Variant Richness')
ylabel('Resilience - VM')

ResistanceFSSI % resistance SI
PeakTimeFS %peak time
ResTimeFS  %resilience time
ResilienceFS %resilience SIR
ResistanceFS %resistance SIR
NumberInSEndFS%with vm updates
ResistanceFSVM %vm resistance
ResilienceTimeFSVM %vm resilience time
ResilienceFSVM %vm resilience


ResistanceSI % resistance SI
PeakTime %peak time
ResTime  %resilience time
Resilience %resilience SIR
Resistance %resistance SIR
NumberInSEnd%with vm updates
ResistanceVM %vm resistance
ResilienceTimeVM %vm resilience time
ResilienceVM %vm resilience
fileName = [outputDirectory num2str(data.m) 'output.txt']
outFile = fopen(fileName, 'wt');
fprintf(outFile, '%s\n,', 'ResistanceFSSI'); fprintf(outFile, '%f,', ResistanceFSSI); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'PeakTimeFS'); fprintf(outFile, '%f,', PeakTimeFS); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'ResTimeFS'); fprintf(outFile, '%f,', ResTimeFS); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'ResilienceFS'); fprintf(outFile, '%f,', ResilienceFS); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'ResistanceFS'); fprintf(outFile, '%f,', ResistanceFS); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'NumberInSEndFS'); fprintf(outFile, '%f,', NumberInSEndFS); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'ResistanceFSVM'); fprintf(outFile, '%f,', ResistanceFSVM); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'ResilienceTimeFSVM'); fprintf(outFile, '%f,', ResilienceTimeFSVM); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'ResilienceFSVM'); fprintf(outFile, '%f,', ResilienceFSVM); fprintf(outFile, '\n'); %new line

fprintf(outFile, '%s\n,', 'ResistanceSI'); fprintf(outFile, '%f,', ResistanceSI); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'PeakTime'); fprintf(outFile, '%f,', PeakTime); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'ResTime'); fprintf(outFile, '%f,', ResTime); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'Resilience'); fprintf(outFile, '%f,', Resilience); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'Resistance'); fprintf(outFile, '%f,', Resistance); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'NumberInSEnd'); fprintf(outFile, '%f,', NumberInSEnd); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'ResistanceVM'); fprintf(outFile, '%f,', ResistanceVM); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'ResilienceTimeVM'); fprintf(outFile, '%f,', ResilienceTimeVM); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'ResilienceVM'); fprintf(outFile, '%f,', ResilienceVM); fprintf(outFile, '\n'); %new line
fclose(outFile);


saveas(figImean,[outputDirectory 'figImean.fig']);
saveas(figImean,[outputDirectory 'figImean.emf']);
saveas(figIPeak,[outputDirectory 'figIPeak.fig']);
saveas(figIPeak,[outputDirectory 'figIPeak.emf']);
saveas(figResistanceSI,[outputDirectory 'figResistanceSI.fig']);
saveas(figResistanceSI,[outputDirectory 'figResistanceSI.emf']);
saveas(figResilienceTimeSI,[outputDirectory 'figResilienceTimeSI.fig']);
saveas(figResilienceTimeSI,[outputDirectory 'figResilienceTimeSI.emf']);
saveas(figResilienceSIR,[outputDirectory 'figResilienceSIR.fig']);
saveas(figResilienceSIR,[outputDirectory 'figResilienceSIR.emf']);
saveas(figResistenceSIR,[outputDirectory 'figResistenceSIR.fig']);
saveas(figResistenceSIR,[outputDirectory 'figResistenceSIR.emf']);
saveas(figsuceptEndVM,[outputDirectory 'figsuceptEndVM.fig']);
saveas(figsuceptEndVM,[outputDirectory 'figsuceptEndVM.emf']);
saveas(figResistanceVM,[outputDirectory 'figResistanceVM.fig']);
saveas(figResistanceVM,[outputDirectory 'figResistanceVM.emf']);
saveas(figResilienceTimeVM,[outputDirectory 'figResilienceTimeVM.fig']);
saveas(figResilienceTimeVM,[outputDirectory 'figResilienceTimeVM.emf']);
saveas(figResilienceVM,[outputDirectory 'figResilienceVM.fig']);
saveas(figResilienceVM,[outputDirectory 'figResilienceVM.emf']);
close all;
toc
%end%417

%dynamic nodes -  1 locus
%if doSIRNTests(416) == 1
data.m = 416 %data file number
%1 locus model
%outputDirectory = 'randomGenotypesGraphs\ALL\Test416\' %BUMBLEBEE
outputDirectory = 'randomGenotypesGraphs\ALL\Test416\'
tic
modePar.netStr = 're'; %'rwp' random waypoint 're' random encounter
%*************************
%UNUSED PAR FOR RE MODE
%rwp par
modePar.genotypeTimeOutPeriod = 10; %rwp
modePar.xmin     = 1;     % Minimum x-axis location (du)
modePar.xmax     = 31;    % Maximum x-axis location (du)
modePar.ymin     = 1;     % Minimum y-axis location (du)
modePar.ymax     = 31;    % Maximum y-axis location (du)
modePar.smin     = 1.4;  % Minimum speed (du / tu)
modePar.smax     = 1.4;  % Maximum speed (du / tu)
modePar.pmin     = 0;     % Minimum time for pause (integer tu)
modePar.pmax     = 0;     % Maximum time for pause (integer tu)
modePar.dinr     = 3; %7    % Radial distance for in-range (du)
modePar.dexceed  = 1000;  % Value larger than any possible distance (du)
modePar.tinrg    = 1;     % Time in-range for genotype transfer (tu)
modePar.tinrv    = 1;     % Time in-range for virus transfer (tu)
% Mode
% rwph.mode = rwph.MODE_RIR;  1    % Select Random in range mode
% rwph.mode = rwph.MODE_NIR;  2    % Select Nearest in range mode
modePar.moderwp = 1; %MODE_AIR;  % 4    % Select (Random) Available in range mode
%rwp constrain
modePar.xboxc=0.5
modePar.yboxc=0.5
modePar.rwpcontrainplotGraph=0 %draw init constraints graph
% Log vector
modePar.logena = [1 2];
% Log directory for rwp
modePar.logDir = sprintf('%s\\log', pwd);
modePar.statnodesrwp = 'dynamic'; %'dynamic' or 'stationary' nodes, if dynamic box constraints applied at point of virus start
%END UNUSED PAR
%*****************
%data logging of output
data.logDir = sprintf('%s\\outputdata', pwd)
s = sprintf('%s\\data%i.txt', data.logDir,data.m)
data.logOutput(data.m) = fopen(s, 'wt');
%****************************************
modePar.numEncountersBetweenUpdates = 1
modePar.bufferlength = 10 %length of genotype buffer for favscore algorithm
modePar.genoInit = 'mindiv'  %initial conditions of genotypes maxdiv (maximum diversity - random variant chosen) mindiv (minimum diversity - all nodes same)
%blacklist mode
modePar.blklist = 'yes'; %yes or no
modePar.numToBlklist = 1
modePar.blklistrate = 0.004 %0.001
%vmupdate mode
modePar.vm = 'no' %yes or no

%update mode
modePar.update = 'yes' %stop updating mode
modePar.bufferlengthNei=10 %buffer for buffering local nei diversity,
modePar.stdNeiUpdateThreshold = 0.15
%recovery
recovery = 0; %0.004; 0.0005 %0.001
%*****************************************
%**********************
%constraints
modePar.numToConstrain = 0;%fix(numNodes*1/4); %constain a number of nodes to 1 variant
modePar.areaConstrainrwp='no'
%**********************
%main par
%numRuns = 50 %20 %100 %200
%numNodes = 100;
%SEpidemic=6; %cutoff;
numLoci=4; 
casetype = 'OR';
modePar.virusStartTime = 1200;
numTimestepsVR = [5000]; %7000?
%VR = [1 2 3 4 5];
VR = [1 3 5 7 9 11 13 15 17 18 19 20 21 22 23 25 27 30];
modePar.blklistStartTime = modePar.virusStartTime
numExploits=1;

%init parameters
ResistanceFSSI = zeros(1,size(VR,2)); % resistance SI
PeakTimeFS = zeros(1,size(VR,2)); %peak time
ResTimeFS = zeros(1,size(VR,2));  %resilience time
ResilienceFS = zeros(1,size(VR,2)); %resilience SIR
ResistanceFS = zeros(1,size(VR,2)); %resistance SIR
NumberInSEndFS = zeros(1,size(VR,2));%with vm updates
ResistanceFSVM = zeros(1,size(VR,2)); %vm resistance
ResilienceTimeFSVM = zeros(1,size(VR,2)); %vm resilience time
ResilienceFSVM = zeros(1,size(VR,2)); %vm resilience
ResistanceSI = zeros(1,size(VR,2)); % resistance SI
PeakTime = zeros(1,size(VR,2)); %peak time
ResTime = zeros(1,size(VR,2));  %resilience time
Resilience = zeros(1,size(VR,2)); %resilience SIR
Resistance = zeros(1,size(VR,2)); %resistance SIR
NumberInSEnd = zeros(1,size(VR,2));%with vm updates
ResistanceVM = zeros(1,size(VR,2)); %vm resistance
ResilienceTimeVM = zeros(1,size(VR,2)); %vm resilience time
ResilienceVM = zeros(1,size(VR,2)); %vm resilience

mode = 'Dynamic-favScore' %mode - can be 'static' or 'dynamic' 'Dynamic-random' 'Dynamic-favScore'
%monte carlo random genotype SIR model
%set up diversity mode parameters
modePar.modeStr = mode
modePar.stopUpdatingTime = 200000 %time at which to stop updating the genotypes
for j = 1:size(VR,2)%do for all VR
    variantRichness =  VR(j)
    numTimesteps = numTimestepsVR(1);
   
 betan = 0.02;  plotGraphs = 0; gamma = recovery;  throwAway = 'nonEpidemics', 
 %agent
 [figMeanNei figNeiOneRun fighistSpRun fighistRecovered fighistSusceptible fighistpeakValue fighistpeakTime fighistBeta fighistGamma fighistBetanew fighistGammanew figInfectedRun1 figBetaRun1 figGammaRun1 figRoRun1 figBetaGamma1 figBetaGamma2...
            meanNeiIndexDynamic betastd gammastd betastd2 betastdNew betastdNew2 gammastdNew peakTimemean peakTimestd peakValuemean peakValuestd...
            betameanmean gammameanmean betameanmean2 betameanmeanNew betameanmeanNew2 gammameanmeanNew Smean Imean Rmean Bmean NSmean Smedian Imedian Rmedian S I R NS SmeanN ImeanN1 RmeanN1 BmeanN1 Snewendmean Snewendstd Rnewendmean Rnewendstd Rnew_nonendmean Rnew_nonendstd propSimsNonEp propSimsNonEp_theoretical...
            numRunsMinor measuredProbMinor numRunsMajor measuredProbMajor meanmdist meannumInfectedVM...
            ] = monteCarloSIRN2(numRuns,numNodes, betan, variantRichness, numTimesteps, plotGraphs,gamma,throwAway,SEpidemic,numExploits,modePar, numLoci, casetype);
   close all; 
   
     %peak time SI
    FinalSizeI = max(Imean,[],2); %mean final size SI
    maska = Imean >= FinalSizeI-1; %when within 1 of the final value
    [C Index] = max(maska);
    PeakTimeFS(j) = Index - modePar.virusStartTime; %T1
    if PeakTimeFS(j) < 0; PeakTimeFS(j)=0; end %check to see if picks an index before the virus start time, must be no outbreak and zero
    %Resistance SI
    ResistanceFSSI(j) = (numNodes-FinalSizeI)./numNodes;  
    %Resilience SIR
     FinalSize = max(RmeanN1,[],2); %mean final R of epidemics only
    maska = RmeanN1 >= FinalSize-1; %when within 1 of the final value
    [C Index] = max(maska);
    ResTimeFS(j) = Index -modePar.virusStartTime; %T1 
    if ResTimeFS(j) < 0; ResTimeFS(j)=0; end %check to see if picks an index before the virus start time, must be no outbreak and zero
    ResilienceFS(j) = 1./ResTimeFS(j);
    %resistance SIR
    ResistanceFS(j) = (numNodes-FinalSize)./numNodes;
    
    %VM update Resistance
     ResistanceFSVM(j) =(numNodes - meannumInfectedVM)./numNodes; %number infected at least once
     %[val index] = min(Imean(modePar.virusStartTime:end)) %time for infected to die away
     maska = Imean(modePar.virusStartTime:end) >= 1; %time when within 1 of zero
    [C indvm] = min(maska); %get index of first zero
     ResilienceTimeFSVM(j)= indvm-1; %index 1 means timw zero of malware injection so subtract 1
    ResilienceFSVM(j) = 1./(indvm-1);
     %with vm updates can get rid of those infected to count ended up in S
    %at end
    NumberInSEndFS(j) = Smean(end);
    
  
   
%data logging
 fprintf(data.logOutput(data.m), '%f,', Imean);     % infection
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResistanceFSSI(j)); % resistance SI
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', PeakTimeFS(j)); %peak time
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResTimeFS(j));     %resilience time
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResilienceFS(j)); %resilience
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResistanceFS(j)); %resistance SIR
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', NumberInSEndFS(j));  %with vm updates can get rid of those infected to count ended up in S    %at end
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResistanceFSVM(j));  
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResilienceTimeFSVM(j));  
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResilienceFSVM(j));  
fprintf(data.logOutput(data.m), '\n'); %new line
end %VR


mode = 'Dynamic-random' %mode - can be 'static' or 'dynamic' 'Dynamic-random' 'Dynamic-favScore'
%monte carlo random genotype SIR model
%set up diversity mode parameters
modePar.modeStr = mode
modePar.stopUpdatingTime = modePar.virusStartTime %time at which to stop updating the genotypes
for j = 1:size(VR,2)%do for all VR
    variantRichness =  VR(j)
    numTimesteps = numTimestepsVR(1);
 betan = 0.02;  plotGraphs = 0; gamma = recovery; throwAway = 'nonEpidemics';
 %agent
 [figMeanNei figNeiOneRun fighistSpRun fighistRecovered fighistSusceptible fighistpeakValue fighistpeakTime fighistBeta fighistGamma fighistBetanew fighistGammanew figInfectedRun1 figBetaRun1 figGammaRun1 figRoRun1 figBetaGamma1 figBetaGamma2...
            meanNeiIndexDynamic betastd gammastd betastd2 betastdNew betastdNew2 gammastdNew peakTimemean peakTimestd peakValuemean peakValuestd...
            betameanmean gammameanmean betameanmean2 betameanmeanNew betameanmeanNew2 gammameanmeanNew Smean Imean Rmean Bmean NSmean Smedian Imedian Rmedian S I R NS SmeanN ImeanN1 RmeanN1 BmeanN1 Snewendmean Snewendstd Rnewendmean Rnewendstd Rnew_nonendmean Rnew_nonendstd propSimsNonEp propSimsNonEp_theoretical...
            numRunsMinor measuredProbMinor numRunsMajor measuredProbMajor meanmdist meannumInfectedVM...
            ] = monteCarloSIRN2(numRuns,numNodes, betan, variantRichness, numTimesteps, plotGraphs,gamma,throwAway,SEpidemic,numExploits,modePar, numLoci, casetype);
   close all; 
   
  %peak time SI
    FinalSizeI = max(Imean,[],2); %mean final size SI
   maska = Imean >= FinalSizeI-1; %when within 1 of the final value
   [C Index] = max(maska);
   PeakTime(j) = Index-modePar.virusStartTime; %T1
   if PeakTime(j) < 0; PeakTime(j)=0; end %check to see if picks an index before the virus start time, must be no outbreak and zero
  %Resistance SI
    ResistanceSI(j) = (numNodes-FinalSizeI)./numNodes; 
    %Resilience SIR
     FinalSize = max(RmeanN1,[],2); %mean final R of epidemics only
    maska = RmeanN1 >= FinalSize-1; %when within 1 of the final value
   [C Index] = max(maska);
   ResTime(j) = Index-modePar.virusStartTime; %T1 
   if ResTime(j) < 0; ResTime(j)=0; end %check to see if picks an index before the virus start time, must be no outbreak and zero
   Resilience(j) = 1./ResTime(j);
   %resistance SIR
   Resistance(j) = (numNodes-FinalSize)./numNodes;
    %VM update Resistance
     ResistanceVM(j) =(numNodes - meannumInfectedVM)./numNodes; %number infected at least once
     %[val index] = min(Imean(modePar.virusStartTime:end)) %time for infected to die away
     maska = Imean(modePar.virusStartTime:end) >= 1; %time when within 1 of zero
    [C indvm] = min(maska); %get index of first zero
     ResilienceTimeVM(j)= indvm-1; %index 1 means timw zero of malware injection so subtract 1
    ResilienceVM(j) = 1./(indvm-1);
     %with vm updates can get rid of those infected to count ended up in S
    %at end
    NumberInSEnd(j) = Smean(end);
  
%data logging
 fprintf(data.logOutput(data.m), '%f,', Imean);     % infection
fprintf(data.logOutput(data.m), '\n'); %new line
fprintf(data.logOutput(data.m), '%f,', ResistanceSI(j)); % resistance SI
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', PeakTime(j)); %peak time
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResTime(j));     %resilience time
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', Resilience(j)); %resilience
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', Resistance(j)); %resistance SIR
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', NumberInSEnd(j));  %with vm updates can get rid of those infected to count ended up in S
fprintf(data.logOutput(data.m), '\n'); %new line 
fprintf(data.logOutput(data.m), '%f,', ResistanceVM(j));  
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResilienceTimeVM(j));  
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResilienceVM(j));  
fprintf(data.logOutput(data.m), '\n'); %new line
end %VR

fclose(data.logOutput(data.m));

%last Imean
figImean = figure;
plot(Imean, 'k')
xlabel('Time (seconds)')
ylabel('Number Infected')
%peak time SI
figIPeak = figure;
plot(VR,PeakTimeFS, 'k+-')
hold on
plot(VR,PeakTime, 'ko-')
xlabel('Variant Richness')
ylabel('Peak Time - SI')
%resistance SI
figResistanceSI=figure;
plot(VR,ResistanceFSSI,'k+-')
hold on
plot(VR,ResistanceSI,'ko-')
xlabel('Variant Richness')
ylabel('Peak I ')

%resilience time SIR
figResilienceTimeSI=figure;
plot(VR,ResTimeFS, 'k+-')
hold on
plot(VR,ResTime, 'ko-')
xlabel('Variant Richness')
ylabel('Resilience time - SIR')

%resilience SIR
figResilienceSIR=figure;
plot(VR,ResilienceFS, 'k+-')
hold on
plot(VR,Resilience, 'ko-')
xlabel('Variant Richness')
ylabel('Resilience - SIR')

%Resistance SIR
figResistenceSIR=figure
plot(VR,ResistanceFS, 'k+-')
hold on
plot(VR,Resistance, 'ko-')
xlabel('Variant Richness')
ylabel('Resistance - SIR')

%VM mode
%s
figsuceptEndVM=figure;
plot(VR,NumberInSEndFS,'k+-')
hold on
plot(VR,NumberInSEnd,'ko-')
xlabel('Variant Richness')
ylabel('Susceptible End - SI')

figResistanceVM=figure
plot(VR,ResistanceFSVM,'k+-')
hold on
plot(VR,ResistanceVM,'ko-')
xlabel('Variant Richness')
ylabel('Resistance - VM')

figResilienceTimeVM=figure;
plot(VR,ResilienceTimeFSVM,'k+-')
hold on
plot(VR,ResilienceTimeVM,'ko-')
xlabel('Variant Richness')
ylabel('Resilience time - VM')

figResilienceVM = figure;
plot(VR,ResilienceFSVM,'k+-')
hold on
plot(VR,ResilienceVM,'ko-')
xlabel('Variant Richness')
ylabel('Resilience - VM')

ResistanceFSSI % resistance SI
PeakTimeFS %peak time
ResTimeFS  %resilience time
ResilienceFS %resilience SIR
ResistanceFS %resistance SIR
NumberInSEndFS%with vm updates
ResistanceFSVM %vm resistance
ResilienceTimeFSVM %vm resilience time
ResilienceFSVM %vm resilience


ResistanceSI % resistance SI
PeakTime %peak time
ResTime  %resilience time
Resilience %resilience SIR
Resistance %resistance SIR
NumberInSEnd%with vm updates
ResistanceVM %vm resistance
ResilienceTimeVM %vm resilience time
ResilienceVM %vm resilience
fileName = [outputDirectory num2str(data.m) 'output.txt']
outFile = fopen(fileName, 'wt');
fprintf(outFile, '%s\n,', 'ResistanceFSSI'); fprintf(outFile, '%f,', ResistanceFSSI); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'PeakTimeFS'); fprintf(outFile, '%f,', PeakTimeFS); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'ResTimeFS'); fprintf(outFile, '%f,', ResTimeFS); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'ResilienceFS'); fprintf(outFile, '%f,', ResilienceFS); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'ResistanceFS'); fprintf(outFile, '%f,', ResistanceFS); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'NumberInSEndFS'); fprintf(outFile, '%f,', NumberInSEndFS); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'ResistanceFSVM'); fprintf(outFile, '%f,', ResistanceFSVM); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'ResilienceTimeFSVM'); fprintf(outFile, '%f,', ResilienceTimeFSVM); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'ResilienceFSVM'); fprintf(outFile, '%f,', ResilienceFSVM); fprintf(outFile, '\n'); %new line

fprintf(outFile, '%s\n,', 'ResistanceSI'); fprintf(outFile, '%f,', ResistanceSI); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'PeakTime'); fprintf(outFile, '%f,', PeakTime); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'ResTime'); fprintf(outFile, '%f,', ResTime); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'Resilience'); fprintf(outFile, '%f,', Resilience); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'Resistance'); fprintf(outFile, '%f,', Resistance); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'NumberInSEnd'); fprintf(outFile, '%f,', NumberInSEnd); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'ResistanceVM'); fprintf(outFile, '%f,', ResistanceVM); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'ResilienceTimeVM'); fprintf(outFile, '%f,', ResilienceTimeVM); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'ResilienceVM'); fprintf(outFile, '%f,', ResilienceVM); fprintf(outFile, '\n'); %new line
fclose(outFile);


saveas(figImean,[outputDirectory 'figImean.fig']);
saveas(figImean,[outputDirectory 'figImean.emf']);
saveas(figIPeak,[outputDirectory 'figIPeak.fig']);
saveas(figIPeak,[outputDirectory 'figIPeak.emf']);
saveas(figResistanceSI,[outputDirectory 'figResistanceSI.fig']);
saveas(figResistanceSI,[outputDirectory 'figResistanceSI.emf']);
saveas(figResilienceTimeSI,[outputDirectory 'figResilienceTimeSI.fig']);
saveas(figResilienceTimeSI,[outputDirectory 'figResilienceTimeSI.emf']);
saveas(figResilienceSIR,[outputDirectory 'figResilienceSIR.fig']);
saveas(figResilienceSIR,[outputDirectory 'figResilienceSIR.emf']);
saveas(figResistenceSIR,[outputDirectory 'figResistenceSIR.fig']);
saveas(figResistenceSIR,[outputDirectory 'figResistenceSIR.emf']);
saveas(figsuceptEndVM,[outputDirectory 'figsuceptEndVM.fig']);
saveas(figsuceptEndVM,[outputDirectory 'figsuceptEndVM.emf']);
saveas(figResistanceVM,[outputDirectory 'figResistanceVM.fig']);
saveas(figResistanceVM,[outputDirectory 'figResistanceVM.emf']);
saveas(figResilienceTimeVM,[outputDirectory 'figResilienceTimeVM.fig']);
saveas(figResilienceTimeVM,[outputDirectory 'figResilienceTimeVM.emf']);
saveas(figResilienceVM,[outputDirectory 'figResilienceVM.fig']);
saveas(figResilienceVM,[outputDirectory 'figResilienceVM.emf']);

toc
close all;

%end%416



%dynamic nodes -  4 LOCI AND
%if doSIRNTests(415) == 1
data.m = 415 %data file number
%1 locus model
%outputDirectory = 'randomGenotypesGraphs\ALL\Test415\' %BUMBLEBEE
outputDirectory = 'randomGenotypesGraphs\ALL\Test415\'
tic
modePar.netStr = 're'; %'rwp' random waypoint 're' random encounter
%*************************
%UNUSED PAR FOR RE MODE
%rwp par
modePar.genotypeTimeOutPeriod = 10; %rwp
modePar.xmin     = 1;     % Minimum x-axis location (du)
modePar.xmax     = 31;    % Maximum x-axis location (du)
modePar.ymin     = 1;     % Minimum y-axis location (du)
modePar.ymax     = 31;    % Maximum y-axis location (du)
modePar.smin     = 1.4;  % Minimum speed (du / tu)
modePar.smax     = 1.4;  % Maximum speed (du / tu)
modePar.pmin     = 0;     % Minimum time for pause (integer tu)
modePar.pmax     = 0;     % Maximum time for pause (integer tu)
modePar.dinr     = 3; %7    % Radial distance for in-range (du)
modePar.dexceed  = 1000;  % Value larger than any possible distance (du)
modePar.tinrg    = 1;     % Time in-range for genotype transfer (tu)
modePar.tinrv    = 1;     % Time in-range for virus transfer (tu)
% Mode
% rwph.mode = rwph.MODE_RIR;  1    % Select Random in range mode
% rwph.mode = rwph.MODE_NIR;  2    % Select Nearest in range mode
modePar.moderwp = 1; %MODE_AIR;  % 4    % Select (Random) Available in range mode
%rwp constrain
modePar.xboxc=0.5
modePar.yboxc=0.5
modePar.rwpcontrainplotGraph=0 %draw init constraints graph
% Log vector
modePar.logena = [1 2];
% Log directory for rwp
modePar.logDir = sprintf('%s\\log', pwd);
modePar.statnodesrwp = 'dynamic'; %'dynamic' or 'stationary' nodes, if dynamic box constraints applied at point of virus start
%END UNUSED PAR
%*****************
%data logging of output
data.logDir = sprintf('%s\\outputdata', pwd)
s = sprintf('%s\\data%i.txt', data.logDir,data.m)
data.logOutput(data.m) = fopen(s, 'wt');
%****************************************
modePar.numEncountersBetweenUpdates = 1
modePar.bufferlength = 10 %length of genotype buffer for favscore algorithm
modePar.genoInit = 'mindiv'  %initial conditions of genotypes maxdiv (maximum diversity - random variant chosen) mindiv (minimum diversity - all nodes same)
%blacklist mode
modePar.blklist = 'yes'; %yes or no
modePar.numToBlklist = 1
modePar.blklistrate = 0.004 %0.001
%vmupdate mode
modePar.vm = 'no' %yes or no

%update mode
modePar.update = 'yes' %stop updating mode
modePar.bufferlengthNei=10 %buffer for buffering local nei diversity,
modePar.stdNeiUpdateThreshold = 0.15
%recovery
recovery = 0; %0.004; 0.0005 %0.001
%*****************************************
%**********************
%constraints
modePar.numToConstrain = 0;%fix(numNodes*1/4); %constain a number of nodes to 1 variant
modePar.areaConstrainrwp='no'
%**********************
%main par
%numRuns = 10 %20 %100 %200
%numNodes = 100;
%SEpidemic=6; %cutoff;
numLoci=4; 
casetype = 'AND';
modePar.virusStartTime = 1200;
numTimestepsVR = [5000]; %7000?
VR = [1 2 3 4 5];
modePar.blklistStartTime = modePar.virusStartTime
numExploits=1;

%init parameters
ResistanceFSSI = zeros(1,size(VR,2)); % resistance SI
PeakTimeFS = zeros(1,size(VR,2)); %peak time
ResTimeFS = zeros(1,size(VR,2));  %resilience time
ResilienceFS = zeros(1,size(VR,2)); %resilience SIR
ResistanceFS = zeros(1,size(VR,2)); %resistance SIR
NumberInSEndFS = zeros(1,size(VR,2));%with vm updates
ResistanceFSVM = zeros(1,size(VR,2)); %vm resistance
ResilienceTimeFSVM = zeros(1,size(VR,2)); %vm resilience time
ResilienceFSVM = zeros(1,size(VR,2)); %vm resilience
ResistanceSI = zeros(1,size(VR,2)); % resistance SI
PeakTime = zeros(1,size(VR,2)); %peak time
ResTime = zeros(1,size(VR,2));  %resilience time
Resilience = zeros(1,size(VR,2)); %resilience SIR
Resistance = zeros(1,size(VR,2)); %resistance SIR
NumberInSEnd = zeros(1,size(VR,2));%with vm updates
ResistanceVM = zeros(1,size(VR,2)); %vm resistance
ResilienceTimeVM = zeros(1,size(VR,2)); %vm resilience time
ResilienceVM = zeros(1,size(VR,2)); %vm resilience

mode = 'Dynamic-favScore' %mode - can be 'static' or 'dynamic' 'Dynamic-random' 'Dynamic-favScore'
%monte carlo random genotype SIR model
%set up diversity mode parameters
modePar.modeStr = mode
modePar.stopUpdatingTime = 200000 %time at which to stop updating the genotypes
for j = 1:size(VR,2)%do for all VR
    variantRichness =  VR(j)
    numTimesteps = numTimestepsVR(1);
   
 betan = 0.02;  plotGraphs = 0; gamma = recovery;  throwAway = 'nonEpidemics', 
 %agent
 [figMeanNei figNeiOneRun fighistSpRun fighistRecovered fighistSusceptible fighistpeakValue fighistpeakTime fighistBeta fighistGamma fighistBetanew fighistGammanew figInfectedRun1 figBetaRun1 figGammaRun1 figRoRun1 figBetaGamma1 figBetaGamma2...
            meanNeiIndexDynamic betastd gammastd betastd2 betastdNew betastdNew2 gammastdNew peakTimemean peakTimestd peakValuemean peakValuestd...
            betameanmean gammameanmean betameanmean2 betameanmeanNew betameanmeanNew2 gammameanmeanNew Smean Imean Rmean Bmean NSmean Smedian Imedian Rmedian S I R NS SmeanN ImeanN1 RmeanN1 BmeanN1 Snewendmean Snewendstd Rnewendmean Rnewendstd Rnew_nonendmean Rnew_nonendstd propSimsNonEp propSimsNonEp_theoretical...
            numRunsMinor measuredProbMinor numRunsMajor measuredProbMajor meanmdist meannumInfectedVM...
            ] = monteCarloSIRN2(numRuns,numNodes, betan, variantRichness, numTimesteps, plotGraphs,gamma,throwAway,SEpidemic,numExploits,modePar, numLoci, casetype);
   close all; 
   
      %peak time SI
    FinalSizeI = max(Imean,[],2); %mean final size SI
    maska = Imean >= FinalSizeI-1; %when within 1 of the final value
    [C Index] = max(maska);
    PeakTimeFS(j) = Index - modePar.virusStartTime; %T1
    if PeakTimeFS(j) < 0; PeakTimeFS(j)=0; end %check to see if picks an index before the virus start time, must be no outbreak and zero
    %Resistance SI
    ResistanceFSSI(j) = (numNodes-FinalSizeI)./numNodes;  
    %Resilience SIR
     FinalSize = max(RmeanN1,[],2); %mean final R of epidemics only
    maska = RmeanN1 >= FinalSize-1; %when within 1 of the final value
    [C Index] = max(maska);
    ResTimeFS(j) = Index -modePar.virusStartTime; %T1 
    if ResTimeFS(j) < 0; ResTimeFS(j)=0; end %check to see if picks an index before the virus start time, must be no outbreak and zero
    ResilienceFS(j) = 1./ResTimeFS(j);
    %resistance SIR
    ResistanceFS(j) = (numNodes-FinalSize)./numNodes;
    
    %VM update Resistance
     ResistanceFSVM(j) =(numNodes - meannumInfectedVM)./numNodes; %number infected at least once
     %[val index] = min(Imean(modePar.virusStartTime:end)) %time for infected to die away
     maska = Imean(modePar.virusStartTime:end) >= 1; %time when within 1 of zero
    [C indvm] = min(maska); %get index of first zero
     ResilienceTimeFSVM(j)= indvm-1; %index 1 means timw zero of malware injection so subtract 1
    ResilienceFSVM(j) = 1./(indvm-1);
     %with vm updates can get rid of those infected to count ended up in S
    %at end
    NumberInSEndFS(j) = Smean(end);
    
  
   
%data logging
 fprintf(data.logOutput(data.m), '%f,', Imean);     % infection
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResistanceFSSI(j)); % resistance SI
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', PeakTimeFS(j)); %peak time
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResTimeFS(j));     %resilience time
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResilienceFS(j)); %resilience
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResistanceFS(j)); %resistance SIR
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', NumberInSEndFS(j));  %with vm updates can get rid of those infected to count ended up in S    %at end
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResistanceFSVM(j));  
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResilienceTimeFSVM(j));  
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResilienceFSVM(j));  
fprintf(data.logOutput(data.m), '\n'); %new line
end %VR


mode = 'Dynamic-random' %mode - can be 'static' or 'dynamic' 'Dynamic-random' 'Dynamic-favScore'
%monte carlo random genotype SIR model
%set up diversity mode parameters
modePar.modeStr = mode
modePar.stopUpdatingTime = modePar.virusStartTime %time at which to stop updating the genotypes
for j = 1:size(VR,2)%do for all VR
    variantRichness =  VR(j)
    numTimesteps = numTimestepsVR(1);
 betan = 0.02;  plotGraphs = 0; gamma = recovery; throwAway = 'nonEpidemics';
 %agent
 [figMeanNei figNeiOneRun fighistSpRun fighistRecovered fighistSusceptible fighistpeakValue fighistpeakTime fighistBeta fighistGamma fighistBetanew fighistGammanew figInfectedRun1 figBetaRun1 figGammaRun1 figRoRun1 figBetaGamma1 figBetaGamma2...
            meanNeiIndexDynamic betastd gammastd betastd2 betastdNew betastdNew2 gammastdNew peakTimemean peakTimestd peakValuemean peakValuestd...
            betameanmean gammameanmean betameanmean2 betameanmeanNew betameanmeanNew2 gammameanmeanNew Smean Imean Rmean Bmean NSmean Smedian Imedian Rmedian S I R NS SmeanN ImeanN1 RmeanN1 BmeanN1 Snewendmean Snewendstd Rnewendmean Rnewendstd Rnew_nonendmean Rnew_nonendstd propSimsNonEp propSimsNonEp_theoretical...
            numRunsMinor measuredProbMinor numRunsMajor measuredProbMajor meanmdist meannumInfectedVM...
            ] = monteCarloSIRN2(numRuns,numNodes, betan, variantRichness, numTimesteps, plotGraphs,gamma,throwAway,SEpidemic,numExploits,modePar, numLoci, casetype);
   close all; 
   
   %peak time SI
    FinalSizeI = max(Imean,[],2); %mean final size SI
   maska = Imean >= FinalSizeI-1; %when within 1 of the final value
   [C Index] = max(maska);
   PeakTime(j) = Index-modePar.virusStartTime; %T1
   if PeakTime(j) < 0; PeakTime(j)=0; end %check to see if picks an index before the virus start time, must be no outbreak and zero
  %Resistance SI
    ResistanceSI(j) = (numNodes-FinalSizeI)./numNodes; 
    %Resilience SIR
     FinalSize = max(RmeanN1,[],2); %mean final R of epidemics only
    maska = RmeanN1 >= FinalSize-1; %when within 1 of the final value
   [C Index] = max(maska);
   ResTime(j) = Index-modePar.virusStartTime; %T1 
   if ResTime(j) < 0; ResTime(j)=0; end %check to see if picks an index before the virus start time, must be no outbreak and zero
   Resilience(j) = 1./ResTime(j);
   %resistance SIR
   Resistance(j) = (numNodes-FinalSize)./numNodes;
    %VM update Resistance
     ResistanceVM(j) =(numNodes - meannumInfectedVM)./numNodes; %number infected at least once
     %[val index] = min(Imean(modePar.virusStartTime:end)) %time for infected to die away
     maska = Imean(modePar.virusStartTime:end) >= 1; %time when within 1 of zero
    [C indvm] = min(maska); %get index of first zero
     ResilienceTimeVM(j)= indvm-1; %index 1 means timw zero of malware injection so subtract 1
    ResilienceVM(j) = 1./(indvm-1);
     %with vm updates can get rid of those infected to count ended up in S
    %at end
    NumberInSEnd(j) = Smean(end);
  
%data logging
 fprintf(data.logOutput(data.m), '%f,', Imean);     % infection
fprintf(data.logOutput(data.m), '\n'); %new line
fprintf(data.logOutput(data.m), '%f,', ResistanceSI(j)); % resistance SI
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', PeakTime(j)); %peak time
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResTime(j));     %resilience time
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', Resilience(j)); %resilience
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', Resistance(j)); %resistance SIR
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', NumberInSEnd(j));  %with vm updates can get rid of those infected to count ended up in S
fprintf(data.logOutput(data.m), '\n'); %new line 
fprintf(data.logOutput(data.m), '%f,', ResistanceVM(j));  
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResilienceTimeVM(j));  
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResilienceVM(j));  
fprintf(data.logOutput(data.m), '\n'); %new line
end %VR

fclose(data.logOutput(data.m));

%last Imean
figImean = figure;
plot(Imean, 'k')
xlabel('Time (seconds)')
ylabel('Number Infected')
%peak time SI
figIPeak = figure;
plot(VR,PeakTimeFS, 'k+-')
hold on
plot(VR,PeakTime, 'ko-')
xlabel('Variant Richness')
ylabel('Peak Time - SI')
%resistance SI
figResistanceSI=figure;
plot(VR,ResistanceFSSI,'k+-')
hold on
plot(VR,ResistanceSI,'ko-')
xlabel('Variant Richness')
ylabel('Peak I ')

%resilience time SIR
figResilienceTimeSI=figure;
plot(VR,ResTimeFS, 'k+-')
hold on
plot(VR,ResTime, 'ko-')
xlabel('Variant Richness')
ylabel('Resilience time - SIR')

%resilience SIR
figResilienceSIR=figure;
plot(VR,ResilienceFS, 'k+-')
hold on
plot(VR,Resilience, 'ko-')
xlabel('Variant Richness')
ylabel('Resilience - SIR')

%Resistance SIR
figResistenceSIR=figure
plot(VR,ResistanceFS, 'k+-')
hold on
plot(VR,Resistance, 'ko-')
xlabel('Variant Richness')
ylabel('Resistance - SIR')

%VM mode
%s
figsuceptEndVM=figure;
plot(VR,NumberInSEndFS,'k+-')
hold on
plot(VR,NumberInSEnd,'ko-')
xlabel('Variant Richness')
ylabel('Susceptible End - SI')

figResistanceVM=figure
plot(VR,ResistanceFSVM,'k+-')
hold on
plot(VR,ResistanceVM,'ko-')
xlabel('Variant Richness')
ylabel('Resistance - VM')

figResilienceTimeVM=figure;
plot(VR,ResilienceTimeFSVM,'k+-')
hold on
plot(VR,ResilienceTimeVM,'ko-')
xlabel('Variant Richness')
ylabel('Resilience time - VM')

figResilienceVM = figure;
plot(VR,ResilienceFSVM,'k+-')
hold on
plot(VR,ResilienceVM,'ko-')
xlabel('Variant Richness')
ylabel('Resilience - VM')

ResistanceFSSI % resistance SI
PeakTimeFS %peak time
ResTimeFS  %resilience time
ResilienceFS %resilience SIR
ResistanceFS %resistance SIR
NumberInSEndFS%with vm updates
ResistanceFSVM %vm resistance
ResilienceTimeFSVM %vm resilience time
ResilienceFSVM %vm resilience


ResistanceSI % resistance SI
PeakTime %peak time
ResTime  %resilience time
Resilience %resilience SIR
Resistance %resistance SIR
NumberInSEnd%with vm updates
ResistanceVM %vm resistance
ResilienceTimeVM %vm resilience time
ResilienceVM %vm resilience
fileName = [outputDirectory num2str(data.m) 'output.txt']
outFile = fopen(fileName, 'wt');
fprintf(outFile, '%s\n,', 'ResistanceFSSI'); fprintf(outFile, '%f,', ResistanceFSSI); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'PeakTimeFS'); fprintf(outFile, '%f,', PeakTimeFS); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'ResTimeFS'); fprintf(outFile, '%f,', ResTimeFS); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'ResilienceFS'); fprintf(outFile, '%f,', ResilienceFS); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'ResistanceFS'); fprintf(outFile, '%f,', ResistanceFS); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'NumberInSEndFS'); fprintf(outFile, '%f,', NumberInSEndFS); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'ResistanceFSVM'); fprintf(outFile, '%f,', ResistanceFSVM); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'ResilienceTimeFSVM'); fprintf(outFile, '%f,', ResilienceTimeFSVM); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'ResilienceFSVM'); fprintf(outFile, '%f,', ResilienceFSVM); fprintf(outFile, '\n'); %new line

fprintf(outFile, '%s\n,', 'ResistanceSI'); fprintf(outFile, '%f,', ResistanceSI); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'PeakTime'); fprintf(outFile, '%f,', PeakTime); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'ResTime'); fprintf(outFile, '%f,', ResTime); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'Resilience'); fprintf(outFile, '%f,', Resilience); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'Resistance'); fprintf(outFile, '%f,', Resistance); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'NumberInSEnd'); fprintf(outFile, '%f,', NumberInSEnd); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'ResistanceVM'); fprintf(outFile, '%f,', ResistanceVM); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'ResilienceTimeVM'); fprintf(outFile, '%f,', ResilienceTimeVM); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'ResilienceVM'); fprintf(outFile, '%f,', ResilienceVM); fprintf(outFile, '\n'); %new line
fclose(outFile);


saveas(figImean,[outputDirectory 'figImean.fig']);
saveas(figImean,[outputDirectory 'figImean.emf']);
saveas(figIPeak,[outputDirectory 'figIPeak.fig']);
saveas(figIPeak,[outputDirectory 'figIPeak.emf']);
saveas(figResistanceSI,[outputDirectory 'figResistanceSI.fig']);
saveas(figResistanceSI,[outputDirectory 'figResistanceSI.emf']);
saveas(figResilienceTimeSI,[outputDirectory 'figResilienceTimeSI.fig']);
saveas(figResilienceTimeSI,[outputDirectory 'figResilienceTimeSI.emf']);
saveas(figResilienceSIR,[outputDirectory 'figResilienceSIR.fig']);
saveas(figResilienceSIR,[outputDirectory 'figResilienceSIR.emf']);
saveas(figResistenceSIR,[outputDirectory 'figResistenceSIR.fig']);
saveas(figResistenceSIR,[outputDirectory 'figResistenceSIR.emf']);
saveas(figsuceptEndVM,[outputDirectory 'figsuceptEndVM.fig']);
saveas(figsuceptEndVM,[outputDirectory 'figsuceptEndVM.emf']);
saveas(figResistanceVM,[outputDirectory 'figResistanceVM.fig']);
saveas(figResistanceVM,[outputDirectory 'figResistanceVM.emf']);
saveas(figResilienceTimeVM,[outputDirectory 'figResilienceTimeVM.fig']);
saveas(figResilienceTimeVM,[outputDirectory 'figResilienceTimeVM.emf']);
saveas(figResilienceVM,[outputDirectory 'figResilienceVM.fig']);
saveas(figResilienceVM,[outputDirectory 'figResilienceVM.emf']);
close all;
toc


%end%415

%dynamic nodes -  1 locus
%if doSIRNTests(414) == 1
data.m = 414 %data file number
%1 locus model
%outputDirectory = 'randomGenotypesGraphs\ALL\Test414\' %BUMBLEBEE
outputDirectory = 'randomGenotypesGraphs\ALL\Test414\'
tic
modePar.netStr = 're'; %'rwp' random waypoint 're' random encounter
%*************************
%UNUSED PAR FOR RE MODE
%rwp par
modePar.genotypeTimeOutPeriod = 10; %rwp
modePar.xmin     = 1;     % Minimum x-axis location (du)
modePar.xmax     = 31;    % Maximum x-axis location (du)
modePar.ymin     = 1;     % Minimum y-axis location (du)
modePar.ymax     = 31;    % Maximum y-axis location (du)
modePar.smin     = 1.4;  % Minimum speed (du / tu)
modePar.smax     = 1.4;  % Maximum speed (du / tu)
modePar.pmin     = 0;     % Minimum time for pause (integer tu)
modePar.pmax     = 0;     % Maximum time for pause (integer tu)
modePar.dinr     = 3; %7    % Radial distance for in-range (du)
modePar.dexceed  = 1000;  % Value larger than any possible distance (du)
modePar.tinrg    = 1;     % Time in-range for genotype transfer (tu)
modePar.tinrv    = 1;     % Time in-range for virus transfer (tu)
% Mode
% rwph.mode = rwph.MODE_RIR;  1    % Select Random in range mode
% rwph.mode = rwph.MODE_NIR;  2    % Select Nearest in range mode
modePar.moderwp = 1; %MODE_AIR;  % 4    % Select (Random) Available in range mode
%rwp constrain
modePar.xboxc=0.5
modePar.yboxc=0.5
modePar.rwpcontrainplotGraph=0 %draw init constraints graph
% Log vector
modePar.logena = [1 2];
% Log directory for rwp
modePar.logDir = sprintf('%s\\log', pwd);
modePar.statnodesrwp = 'dynamic'; %'dynamic' or 'stationary' nodes, if dynamic box constraints applied at point of virus start
%END UNUSED PAR
%*****************
%data logging of output
data.logDir = sprintf('%s\\outputdata', pwd)
s = sprintf('%s\\data%i.txt', data.logDir,data.m)
data.logOutput(data.m) = fopen(s, 'wt');
%****************************************
modePar.numEncountersBetweenUpdates = 1
modePar.bufferlength = 10 %length of genotype buffer for favscore algorithm
modePar.genoInit = 'mindiv'  %initial conditions of genotypes maxdiv (maximum diversity - random variant chosen) mindiv (minimum diversity - all nodes same)
%blacklist mode
modePar.blklist = 'yes'; %yes or no
modePar.numToBlklist = 1
modePar.blklistrate = 0.004; %0.004 %0.001
%vmupdate mode
modePar.vm = 'no' %yes or no

%update mode
modePar.update = 'yes' %stop updating mode
modePar.bufferlengthNei=10 %buffer for buffering local nei diversity,
modePar.stdNeiUpdateThreshold = 0.15
%recovery
recovery = 0; %0.004; 0.0005 %0.001
%*****************************************
%**********************
%constraints
modePar.numToConstrain = 0;%fix(numNodes*1/4); %constain a number of nodes to 1 variant
modePar.areaConstrainrwp='no'
%**********************
%main par
%numRuns = 50 %20 %100 %200
%numNodes = 100;
%SEpidemic=6; %cutoff;
numLoci=1; 
casetype = 'OR';
modePar.virusStartTime = 1200;
numTimestepsVR = [5000]; %7000?
%VR = [2];
%VR = [1 2 3 4 5 6 7 8 9 10];
VR = [1 2 3 4 5 6 7 8 9 10];
modePar.blklistStartTime = modePar.virusStartTime
numExploits=1;

%init parameters
ResistanceFSSI = zeros(1,size(VR,2)); % resistance SI
PeakTimeFS = zeros(1,size(VR,2)); %peak time
ResTimeFS = zeros(1,size(VR,2));  %resilience time
ResilienceFS = zeros(1,size(VR,2)); %resilience SIR
ResistanceFS = zeros(1,size(VR,2)); %resistance SIR
NumberInSEndFS = zeros(1,size(VR,2));%with vm updates
ResistanceFSVM = zeros(1,size(VR,2)); %vm resistance
ResilienceTimeFSVM = zeros(1,size(VR,2)); %vm resilience time
ResilienceFSVM = zeros(1,size(VR,2)); %vm resilience
ResistanceSI = zeros(1,size(VR,2)); % resistance SI
PeakTime = zeros(1,size(VR,2)); %peak time
ResTime = zeros(1,size(VR,2));  %resilience time
Resilience = zeros(1,size(VR,2)); %resilience SIR
Resistance = zeros(1,size(VR,2)); %resistance SIR
NumberInSEnd = zeros(1,size(VR,2));%with vm updates
ResistanceVM = zeros(1,size(VR,2)); %vm resistance
ResilienceTimeVM = zeros(1,size(VR,2)); %vm resilience time
ResilienceVM = zeros(1,size(VR,2)); %vm resilience

%figImeanFS = figure 

mode = 'Dynamic-favScore' %mode - can be 'static' or 'dynamic' 'Dynamic-random' 'Dynamic-favScore'
%monte carlo random genotype SIR model
%set up diversity mode parameters
modePar.modeStr = mode
modePar.stopUpdatingTime = 200000 %time at which to stop updating the genotypes
for j = 1:size(VR,2)%do for all VR
    variantRichness =  VR(j)
    numTimesteps = numTimestepsVR(1);
   
 betan = 0.02;  plotGraphs = 0; gamma = recovery;  throwAway = 'nonEpidemics', 
 %agent
 [figMeanNei figNeiOneRun fighistSpRun fighistRecovered fighistSusceptible fighistpeakValue fighistpeakTime fighistBeta fighistGamma fighistBetanew fighistGammanew figInfectedRun1 figBetaRun1 figGammaRun1 figRoRun1 figBetaGamma1 figBetaGamma2...
            meanNeiIndexDynamic betastd gammastd betastd2 betastdNew betastdNew2 gammastdNew peakTimemean peakTimestd peakValuemean peakValuestd...
            betameanmean gammameanmean betameanmean2 betameanmeanNew betameanmeanNew2 gammameanmeanNew Smean Imean Rmean Bmean NSmean Smedian Imedian Rmedian S I R NS SmeanN ImeanN1 RmeanN1 BmeanN1 Snewendmean Snewendstd Rnewendmean Rnewendstd Rnew_nonendmean Rnew_nonendstd propSimsNonEp propSimsNonEp_theoretical...
            numRunsMinor measuredProbMinor numRunsMajor measuredProbMajor meanmdist meannumInfectedVM...
            ] = monteCarloSIRN2(numRuns,numNodes, betan, variantRichness, numTimesteps, plotGraphs,gamma,throwAway,SEpidemic,numExploits,modePar, numLoci, casetype);
   close all; 
   
     %peak time SI
    FinalSizeI = max(Imean,[],2); %mean final size SI
    maska = Imean >= FinalSizeI-1; %when within 1 of the final value
    [C Index] = max(maska);
    PeakTimeFS(j) = Index - modePar.virusStartTime; %T1
    if PeakTimeFS(j) < 0; PeakTimeFS(j)=0; end %check to see if picks an index before the virus start time, must be no outbreak and zero
    %Resistance SI
    ResistanceFSSI(j) = (numNodes-FinalSizeI)./numNodes;  
    %Resilience SIR
     FinalSize = max(RmeanN1,[],2); %mean final R of epidemics only
    maska = RmeanN1 >= FinalSize-1; %when within 1 of the final value
    [C Index] = max(maska);
    ResTimeFS(j) = Index -modePar.virusStartTime; %T1 
    if ResTimeFS(j) < 0; ResTimeFS(j)=0; end %check to see if picks an index before the virus start time, must be no outbreak and zero
    ResilienceFS(j) = 1./ResTimeFS(j);
    %resistance SIR
    ResistanceFS(j) = (numNodes-FinalSize)./numNodes;
    
    %VM update Resistance
     ResistanceFSVM(j) =(numNodes - meannumInfectedVM)./numNodes; %number infected at least once
     %[val index] = min(Imean(modePar.virusStartTime:end)) %time for infected to die away
     maska = Imean(modePar.virusStartTime:end) >= 1; %time when within 1 of zero
    [C indvm] = min(maska); %get index of first zero
     ResilienceTimeFSVM(j)= indvm-1; %index 1 means timw zero of malware injection so subtract 1
    ResilienceFSVM(j) = 1./(indvm-1);
     %with vm updates can get rid of those infected to count ended up in S
    %at end
    NumberInSEndFS(j) = Smean(end);
    
  
   
%data logging
 fprintf(data.logOutput(data.m), '%f,', Imean);     % infection
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResistanceFSSI(j)); % resistance SI
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', PeakTimeFS(j)); %peak time
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResTimeFS(j));     %resilience time
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResilienceFS(j)); %resilience
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResistanceFS(j)); %resistance SIR
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', NumberInSEndFS(j));  %with vm updates can get rid of those infected to count ended up in S    %at end
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResistanceFSVM(j));  
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResilienceTimeFSVM(j));  
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResilienceFSVM(j));  
fprintf(data.logOutput(data.m), '\n'); %new line
end %VR


%figImean=figure
mode = 'Dynamic-random' %mode - can be 'static' or 'dynamic' 'Dynamic-random' 'Dynamic-favScore'
%monte carlo random genotype SIR model
%set up diversity mode parameters
modePar.modeStr = mode
modePar.stopUpdatingTime = modePar.virusStartTime %time at which to stop updating the genotypes
for j = 1:size(VR,2)%do for all VR
    variantRichness =  VR(j)
    numTimesteps = numTimestepsVR(1);
 betan = 0.02;  plotGraphs = 0; gamma = recovery; throwAway = 'nonEpidemics';
 %agent
 [figMeanNei figNeiOneRun fighistSpRun fighistRecovered fighistSusceptible fighistpeakValue fighistpeakTime fighistBeta fighistGamma fighistBetanew fighistGammanew figInfectedRun1 figBetaRun1 figGammaRun1 figRoRun1 figBetaGamma1 figBetaGamma2...
            meanNeiIndexDynamic betastd gammastd betastd2 betastdNew betastdNew2 gammastdNew peakTimemean peakTimestd peakValuemean peakValuestd...
            betameanmean gammameanmean betameanmean2 betameanmeanNew betameanmeanNew2 gammameanmeanNew Smean Imean Rmean Bmean NSmean Smedian Imedian Rmedian S I R NS SmeanN ImeanN1 RmeanN1 BmeanN1 Snewendmean Snewendstd Rnewendmean Rnewendstd Rnew_nonendmean Rnew_nonendstd propSimsNonEp propSimsNonEp_theoretical...
            numRunsMinor measuredProbMinor numRunsMajor measuredProbMajor meanmdist meannumInfectedVM...
            ] = monteCarloSIRN2(numRuns,numNodes, betan, variantRichness, numTimesteps, plotGraphs,gamma,throwAway,SEpidemic,numExploits,modePar, numLoci, casetype);
   close all; 
   
   %peak time SI
    FinalSizeI = max(Imean,[],2); %mean final size SI
   maska = Imean >= FinalSizeI-1; %when within 1 of the final value
   [C Index] = max(maska);
   PeakTime(j) = Index-modePar.virusStartTime; %T1
   if PeakTime(j) < 0; PeakTime(j)=0; end %check to see if picks an index before the virus start time, must be no outbreak and zero
  %Resistance SI
    ResistanceSI(j) = (numNodes-FinalSizeI)./numNodes; 
    %Resilience SIR
     FinalSize = max(RmeanN1,[],2); %mean final R of epidemics only
    maska = RmeanN1 >= FinalSize-1; %when within 1 of the final value
   [C Index] = max(maska);
   ResTime(j) = Index-modePar.virusStartTime; %T1 
   if ResTime(j) < 0; ResTime(j)=0; end %check to see if picks an index before the virus start time, must be no outbreak and zero
   Resilience(j) = 1./ResTime(j);
   %resistance SIR
   Resistance(j) = (numNodes-FinalSize)./numNodes;
    %VM update Resistance
     ResistanceVM(j) =(numNodes - meannumInfectedVM)./numNodes; %number infected at least once
     %[val index] = min(Imean(modePar.virusStartTime:end)) %time for infected to die away
     maska = Imean(modePar.virusStartTime:end) >= 1; %time when within 1 of zero
    [C indvm] = min(maska); %get index of first zero
     ResilienceTimeVM(j)= indvm-1; %index 1 means timw zero of malware injection so subtract 1
    ResilienceVM(j) = 1./(indvm-1);
     %with vm updates can get rid of those infected to count ended up in S
    %at end
    NumberInSEnd(j) = Smean(end);
  
%data logging
 fprintf(data.logOutput(data.m), '%f,', Imean);     % infection
fprintf(data.logOutput(data.m), '\n'); %new line
fprintf(data.logOutput(data.m), '%f,', ResistanceSI(j)); % resistance SI
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', PeakTime(j)); %peak time
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResTime(j));     %resilience time
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', Resilience(j)); %resilience
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', Resistance(j)); %resistance SIR
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', NumberInSEnd(j));  %with vm updates can get rid of those infected to count ended up in S
fprintf(data.logOutput(data.m), '\n'); %new line 
fprintf(data.logOutput(data.m), '%f,', ResistanceVM(j));  
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResilienceTimeVM(j));  
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResilienceVM(j));  
fprintf(data.logOutput(data.m), '\n'); %new line
end %VR

fclose(data.logOutput(data.m));

%last Imean
figImean = figure;
plot(Imean, 'k')
xlabel('Time (seconds)')
ylabel('Number Infected')
%peak time SI
figIPeak = figure;
plot(VR,PeakTimeFS, 'k+-')
hold on
plot(VR,PeakTime, 'ko-')
xlabel('Variant Richness')
ylabel('Peak Time - SI')
%resistance SI
figResistanceSI=figure;
plot(VR,ResistanceFSSI,'k+-')
hold on
plot(VR,ResistanceSI,'ko-')
xlabel('Variant Richness')
ylabel('Peak I ')

%resilience time SIR
figResilienceTimeSI=figure;
plot(VR,ResTimeFS, 'k+-')
hold on
plot(VR,ResTime, 'ko-')
xlabel('Variant Richness')
ylabel('Resilience time - SIR')

%resilience SIR
figResilienceSIR=figure;
plot(VR,ResilienceFS, 'k+-')
hold on
plot(VR,Resilience, 'ko-')
xlabel('Variant Richness')
ylabel('Resilience - SIR')

%Resistance SIR
figResistenceSIR=figure
plot(VR,ResistanceFS, 'k+-')
hold on
plot(VR,Resistance, 'ko-')
xlabel('Variant Richness')
ylabel('Resistance - SIR')

%VM mode
%s
figsuceptEndVM=figure;
plot(VR,NumberInSEndFS,'k+-')
hold on
plot(VR,NumberInSEnd,'ko-')
xlabel('Variant Richness')
ylabel('Susceptible End - SI')

figResistanceVM=figure
plot(VR,ResistanceFSVM,'k+-')
hold on
plot(VR,ResistanceVM,'ko-')
xlabel('Variant Richness')
ylabel('Resistance - VM')

figResilienceTimeVM=figure;
plot(VR,ResilienceTimeFSVM,'k+-')
hold on
plot(VR,ResilienceTimeVM,'ko-')
xlabel('Variant Richness')
ylabel('Resilience time - VM')

figResilienceVM = figure;
plot(VR,ResilienceFSVM,'k+-')
hold on
plot(VR,ResilienceVM,'ko-')
xlabel('Variant Richness')
ylabel('Resilience - VM')

ResistanceFSSI % resistance SI
PeakTimeFS %peak time
ResTimeFS  %resilience time
ResilienceFS %resilience SIR
ResistanceFS %resistance SIR
NumberInSEndFS%with vm updates
ResistanceFSVM %vm resistance
ResilienceTimeFSVM %vm resilience time
ResilienceFSVM %vm resilience


ResistanceSI % resistance SI
PeakTime %peak time
ResTime  %resilience time
Resilience %resilience SIR
Resistance %resistance SIR
NumberInSEnd%with vm updates
ResistanceVM %vm resistance
ResilienceTimeVM %vm resilience time
ResilienceVM %vm resilience
fileName = [outputDirectory num2str(data.m) 'output.txt']
outFile = fopen(fileName, 'wt');
fprintf(outFile, '%s\n,', 'ResistanceFSSI'); fprintf(outFile, '%f,', ResistanceFSSI); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'PeakTimeFS'); fprintf(outFile, '%f,', PeakTimeFS); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'ResTimeFS'); fprintf(outFile, '%f,', ResTimeFS); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'ResilienceFS'); fprintf(outFile, '%f,', ResilienceFS); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'ResistanceFS'); fprintf(outFile, '%f,', ResistanceFS); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'NumberInSEndFS'); fprintf(outFile, '%f,', NumberInSEndFS); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'ResistanceFSVM'); fprintf(outFile, '%f,', ResistanceFSVM); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'ResilienceTimeFSVM'); fprintf(outFile, '%f,', ResilienceTimeFSVM); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'ResilienceFSVM'); fprintf(outFile, '%f,', ResilienceFSVM); fprintf(outFile, '\n'); %new line

fprintf(outFile, '%s\n,', 'ResistanceSI'); fprintf(outFile, '%f,', ResistanceSI); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'PeakTime'); fprintf(outFile, '%f,', PeakTime); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'ResTime'); fprintf(outFile, '%f,', ResTime); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'Resilience'); fprintf(outFile, '%f,', Resilience); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'Resistance'); fprintf(outFile, '%f,', Resistance); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'NumberInSEnd'); fprintf(outFile, '%f,', NumberInSEnd); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'ResistanceVM'); fprintf(outFile, '%f,', ResistanceVM); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'ResilienceTimeVM'); fprintf(outFile, '%f,', ResilienceTimeVM); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'ResilienceVM'); fprintf(outFile, '%f,', ResilienceVM); fprintf(outFile, '\n'); %new line
fclose(outFile);


saveas(figImean,[outputDirectory 'figImean.fig']);
saveas(figImean,[outputDirectory 'figImean.emf']);
saveas(figIPeak,[outputDirectory 'figIPeak.fig']);
saveas(figIPeak,[outputDirectory 'figIPeak.emf']);
saveas(figResistanceSI,[outputDirectory 'figResistanceSI.fig']);
saveas(figResistanceSI,[outputDirectory 'figResistanceSI.emf']);
saveas(figResilienceTimeSI,[outputDirectory 'figResilienceTimeSI.fig']);
saveas(figResilienceTimeSI,[outputDirectory 'figResilienceTimeSI.emf']);
saveas(figResilienceSIR,[outputDirectory 'figResilienceSIR.fig']);
saveas(figResilienceSIR,[outputDirectory 'figResilienceSIR.emf']);
saveas(figResistenceSIR,[outputDirectory 'figResistenceSIR.fig']);
saveas(figResistenceSIR,[outputDirectory 'figResistenceSIR.emf']);
saveas(figsuceptEndVM,[outputDirectory 'figsuceptEndVM.fig']);
saveas(figsuceptEndVM,[outputDirectory 'figsuceptEndVM.emf']);
saveas(figResistanceVM,[outputDirectory 'figResistanceVM.fig']);
saveas(figResistanceVM,[outputDirectory 'figResistanceVM.emf']);
saveas(figResilienceTimeVM,[outputDirectory 'figResilienceTimeVM.fig']);
saveas(figResilienceTimeVM,[outputDirectory 'figResilienceTimeVM.emf']);
saveas(figResilienceVM,[outputDirectory 'figResilienceVM.fig']);
saveas(figResilienceVM,[outputDirectory 'figResilienceVM.emf']);
close all;
toc
%end%414

%dynamic nodes -  1 locus
%if doSIRNTests(413) == 1
data.m = 413 %data file number
%1 locus model
%outputDirectory = 'randomGenotypesGraphs\ALL\Test413\' %BUMBLEBEE
outputDirectory = 'randomGenotypesGraphs\ALL\Test413\'
tic
modePar.netStr = 're'; %'rwp' random waypoint 're' random encounter
%*************************
%UNUSED PAR FOR RE MODE
%rwp par
modePar.genotypeTimeOutPeriod = 10; %rwp
modePar.xmin     = 1;     % Minimum x-axis location (du)
modePar.xmax     = 31;    % Maximum x-axis location (du)
modePar.ymin     = 1;     % Minimum y-axis location (du)
modePar.ymax     = 31;    % Maximum y-axis location (du)
modePar.smin     = 1.4;  % Minimum speed (du / tu)
modePar.smax     = 1.4;  % Maximum speed (du / tu)
modePar.pmin     = 0;     % Minimum time for pause (integer tu)
modePar.pmax     = 0;     % Maximum time for pause (integer tu)
modePar.dinr     = 3; %7    % Radial distance for in-range (du)
modePar.dexceed  = 1000;  % Value larger than any possible distance (du)
modePar.tinrg    = 1;     % Time in-range for genotype transfer (tu)
modePar.tinrv    = 1;     % Time in-range for virus transfer (tu)
% Mode
% rwph.mode = rwph.MODE_RIR;  1    % Select Random in range mode
% rwph.mode = rwph.MODE_NIR;  2    % Select Nearest in range mode
modePar.moderwp = 1; %MODE_AIR;  % 4    % Select (Random) Available in range mode
%rwp constrain
modePar.xboxc=0.5
modePar.yboxc=0.5
modePar.rwpcontrainplotGraph=0 %draw init constraints graph
% Log vector
modePar.logena = [1 2];
% Log directory for rwp
modePar.logDir = sprintf('%s\\log', pwd);
modePar.statnodesrwp = 'dynamic'; %'dynamic' or 'stationary' nodes, if dynamic box constraints applied at point of virus start
%END UNUSED PAR
%*****************
%data logging of output
data.logDir = sprintf('%s\\outputdata', pwd)
s = sprintf('%s\\data%i.txt', data.logDir,data.m)
data.logOutput(data.m) = fopen(s, 'wt');
%****************************************
modePar.numEncountersBetweenUpdates = 1
modePar.bufferlength = 10 %length of genotype buffer for favscore algorithm
modePar.genoInit = 'mindiv'  %initial conditions of genotypes maxdiv (maximum diversity - random variant chosen) mindiv (minimum diversity - all nodes same)
%blacklist mode
modePar.blklist = 'no'; %yes or no
modePar.numToBlklist = 1
modePar.blklistrate = 0.004 %0.001
%vmupdate mode
modePar.vm = 'no' %yes or no

%update mode
modePar.update = 'yes' %stop updating mode
modePar.bufferlengthNei=10 %buffer for buffering local nei diversity,
modePar.stdNeiUpdateThreshold = 0.15
%recovery
recovery = 0.004; 0.0005 %0.001
%*****************************************
%**********************
%constraints
modePar.numToConstrain = 0;%fix(numNodes*1/4); %constain a number of nodes to 1 variant
modePar.areaConstrainrwp='no'
%**********************
%main par
%numRuns = 50 %20 %100 %200
%numNodes = 100;
%SEpidemic=6; %cutoff;
numLoci=4; 
casetype = 'OR';
modePar.virusStartTime = 1200;
numTimestepsVR = [5000]; %7000?
VR = [1 3 5 7 9 11 13 15 17 18 19 20 21 22 23 25 27 30];
modePar.blklistStartTime = modePar.virusStartTime
numExploits=1;
%init parameters
ResistanceFSSI = zeros(1,size(VR,2)); % resistance SI
PeakTimeFS = zeros(1,size(VR,2)); %peak time
ResTimeFS = zeros(1,size(VR,2));  %resilience time
ResilienceFS = zeros(1,size(VR,2)); %resilience SIR
ResistanceFS = zeros(1,size(VR,2)); %resistance SIR
NumberInSEndFS = zeros(1,size(VR,2));%with vm updates
ResistanceFSVM = zeros(1,size(VR,2)); %vm resistance
ResilienceTimeFSVM = zeros(1,size(VR,2)); %vm resilience time
ResilienceFSVM = zeros(1,size(VR,2)); %vm resilience
ResistanceSI = zeros(1,size(VR,2)); % resistance SI
PeakTime = zeros(1,size(VR,2)); %peak time
ResTime = zeros(1,size(VR,2));  %resilience time
Resilience = zeros(1,size(VR,2)); %resilience SIR
Resistance = zeros(1,size(VR,2)); %resistance SIR
NumberInSEnd = zeros(1,size(VR,2));%with vm updates
ResistanceVM = zeros(1,size(VR,2)); %vm resistance
ResilienceTimeVM = zeros(1,size(VR,2)); %vm resilience time
ResilienceVM = zeros(1,size(VR,2)); %vm resilience

mode = 'Dynamic-favScore' %mode - can be 'static' or 'dynamic' 'Dynamic-random' 'Dynamic-favScore'
%monte carlo random genotype SIR model
%set up diversity mode parameters
modePar.modeStr = mode
modePar.stopUpdatingTime = 200000 %time at which to stop updating the genotypes
for j = 1:size(VR,2)%do for all VR
    variantRichness =  VR(j)
    numTimesteps = numTimestepsVR(1);
   
 betan = 0.02;  plotGraphs = 0; gamma = recovery;  throwAway = 'nonEpidemics', 
 %agent
 [figMeanNei figNeiOneRun fighistSpRun fighistRecovered fighistSusceptible fighistpeakValue fighistpeakTime fighistBeta fighistGamma fighistBetanew fighistGammanew figInfectedRun1 figBetaRun1 figGammaRun1 figRoRun1 figBetaGamma1 figBetaGamma2...
            meanNeiIndexDynamic betastd gammastd betastd2 betastdNew betastdNew2 gammastdNew peakTimemean peakTimestd peakValuemean peakValuestd...
            betameanmean gammameanmean betameanmean2 betameanmeanNew betameanmeanNew2 gammameanmeanNew Smean Imean Rmean Bmean NSmean Smedian Imedian Rmedian S I R NS SmeanN ImeanN1 RmeanN1 BmeanN1 Snewendmean Snewendstd Rnewendmean Rnewendstd Rnew_nonendmean Rnew_nonendstd propSimsNonEp propSimsNonEp_theoretical...
            numRunsMinor measuredProbMinor numRunsMajor measuredProbMajor meanmdist meannumInfectedVM...
            ] = monteCarloSIRN2(numRuns,numNodes, betan, variantRichness, numTimesteps, plotGraphs,gamma,throwAway,SEpidemic,numExploits,modePar, numLoci, casetype);
   close all; 
   
    %peak time SI
    FinalSizeI = max(Imean,[],2); %mean final size SI
    maska = Imean >= FinalSizeI-1; %when within 1 of the final value
    [C Index] = max(maska);
    PeakTimeFS(j) = Index - modePar.virusStartTime; %T1
    if PeakTimeFS(j) < 0; PeakTimeFS(j)=0; end %check to see if picks an index before the virus start time, must be no outbreak and zero
    %Resistance SI
    ResistanceFSSI(j) = (numNodes-FinalSizeI)./numNodes;  
    %Resilience SIR
     FinalSize = max(RmeanN1,[],2); %mean final R of epidemics only
    maska = RmeanN1 >= FinalSize-1; %when within 1 of the final value
    [C Index] = max(maska);
    ResTimeFS(j) = Index -modePar.virusStartTime; %T1 
    if ResTimeFS(j) < 0; ResTimeFS(j)=0; end %check to see if picks an index before the virus start time, must be no outbreak and zero
    ResilienceFS(j) = 1./ResTimeFS(j);
    %resistance SIR
    ResistanceFS(j) = (numNodes-FinalSize)./numNodes;
    
    %VM update Resistance
     ResistanceFSVM(j) =(numNodes - meannumInfectedVM)./numNodes; %number infected at least once
     %[val index] = min(Imean(modePar.virusStartTime:end)) %time for infected to die away
     maska = Imean(modePar.virusStartTime:end) >= 1; %time when within 1 of zero
    [C indvm] = min(maska); %get index of first zero
     ResilienceTimeFSVM(j)= indvm-1; %index 1 means timw zero of malware injection so subtract 1
    ResilienceFSVM(j) = 1./(indvm-1);
     %with vm updates can get rid of those infected to count ended up in S
    %at end
    NumberInSEndFS(j) = Smean(end);
    
  
   
%data logging
 fprintf(data.logOutput(data.m), '%f,', Imean);     % infection
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResistanceFSSI(j)); % resistance SI
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', PeakTimeFS(j)); %peak time
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResTimeFS(j));     %resilience time
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResilienceFS(j)); %resilience
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResistanceFS(j)); %resistance SIR
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', NumberInSEndFS(j));  %with vm updates can get rid of those infected to count ended up in S    %at end
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResistanceFSVM(j));  
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResilienceTimeFSVM(j));  
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResilienceFSVM(j));  
fprintf(data.logOutput(data.m), '\n'); %new line
end %VR


mode = 'Dynamic-random' %mode - can be 'static' or 'dynamic' 'Dynamic-random' 'Dynamic-favScore'
%monte carlo random genotype SIR model
%set up diversity mode parameters
modePar.modeStr = mode
modePar.stopUpdatingTime = modePar.virusStartTime %time at which to stop updating the genotypes
for j = 1:size(VR,2)%do for all VR
    variantRichness =  VR(j)
    numTimesteps = numTimestepsVR(1);
 betan = 0.02;  plotGraphs = 0; gamma = recovery; throwAway = 'nonEpidemics';
 %agent
 [figMeanNei figNeiOneRun fighistSpRun fighistRecovered fighistSusceptible fighistpeakValue fighistpeakTime fighistBeta fighistGamma fighistBetanew fighistGammanew figInfectedRun1 figBetaRun1 figGammaRun1 figRoRun1 figBetaGamma1 figBetaGamma2...
            meanNeiIndexDynamic betastd gammastd betastd2 betastdNew betastdNew2 gammastdNew peakTimemean peakTimestd peakValuemean peakValuestd...
            betameanmean gammameanmean betameanmean2 betameanmeanNew betameanmeanNew2 gammameanmeanNew Smean Imean Rmean Bmean NSmean Smedian Imedian Rmedian S I R NS SmeanN ImeanN1 RmeanN1 BmeanN1 Snewendmean Snewendstd Rnewendmean Rnewendstd Rnew_nonendmean Rnew_nonendstd propSimsNonEp propSimsNonEp_theoretical...
            numRunsMinor measuredProbMinor numRunsMajor measuredProbMajor meanmdist meannumInfectedVM...
            ] = monteCarloSIRN2(numRuns,numNodes, betan, variantRichness, numTimesteps, plotGraphs,gamma,throwAway,SEpidemic,numExploits,modePar, numLoci, casetype);
   close all; 
   
  %peak time SI
    FinalSizeI = max(Imean,[],2); %mean final size SI
   maska = Imean >= FinalSizeI-1; %when within 1 of the final value
   [C Index] = max(maska);
   PeakTime(j) = Index-modePar.virusStartTime; %T1
   if PeakTime(j) < 0; PeakTime(j)=0; end %check to see if picks an index before the virus start time, must be no outbreak and zero
  %Resistance SI
    ResistanceSI(j) = (numNodes-FinalSizeI)./numNodes; 
    %Resilience SIR
     FinalSize = max(RmeanN1,[],2); %mean final R of epidemics only
    maska = RmeanN1 >= FinalSize-1; %when within 1 of the final value
   [C Index] = max(maska);
   ResTime(j) = Index-modePar.virusStartTime; %T1 
   if ResTime(j) < 0; ResTime(j)=0; end %check to see if picks an index before the virus start time, must be no outbreak and zero
   Resilience(j) = 1./ResTime(j);
   %resistance SIR
   Resistance(j) = (numNodes-FinalSize)./numNodes;
    %VM update Resistance
     ResistanceVM(j) =(numNodes - meannumInfectedVM)./numNodes; %number infected at least once
     %[val index] = min(Imean(modePar.virusStartTime:end)) %time for infected to die away
     maska = Imean(modePar.virusStartTime:end) >= 1; %time when within 1 of zero
    [C indvm] = min(maska); %get index of first zero
     ResilienceTimeVM(j)= indvm-1; %index 1 means timw zero of malware injection so subtract 1
    ResilienceVM(j) = 1./(indvm-1);
     %with vm updates can get rid of those infected to count ended up in S
    %at end
    NumberInSEnd(j) = Smean(end);
  
%data logging
 fprintf(data.logOutput(data.m), '%f,', Imean);     % infection
fprintf(data.logOutput(data.m), '\n'); %new line
fprintf(data.logOutput(data.m), '%f,', ResistanceSI(j)); % resistance SI
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', PeakTime(j)); %peak time
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResTime(j));     %resilience time
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', Resilience(j)); %resilience
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', Resistance(j)); %resistance SIR
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', NumberInSEnd(j));  %with vm updates can get rid of those infected to count ended up in S
fprintf(data.logOutput(data.m), '\n'); %new line 
fprintf(data.logOutput(data.m), '%f,', ResistanceVM(j));  
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResilienceTimeVM(j));  
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResilienceVM(j));  
fprintf(data.logOutput(data.m), '\n'); %new line
end %VR

fclose(data.logOutput(data.m));

%last Imean
figImean = figure;
plot(Imean, 'k')
xlabel('Time (seconds)')
ylabel('Number Infected')
%peak time SI
figIPeak = figure;
plot(VR,PeakTimeFS, 'k+-')
hold on
plot(VR,PeakTime, 'ko-')
xlabel('Variant Richness')
ylabel('Peak Time - SI')
%resistance SI
figResistanceSI=figure;
plot(VR,ResistanceFSSI,'k+-')
hold on
plot(VR,ResistanceSI,'ko-')
xlabel('Variant Richness')
ylabel('Peak I ')

%resilience time SIR
figResilienceTimeSI=figure;
plot(VR,ResTimeFS, 'k+-')
hold on
plot(VR,ResTime, 'ko-')
xlabel('Variant Richness')
ylabel('Resilience time - SIR')

%resilience SIR
figResilienceSIR=figure;
plot(VR,ResilienceFS, 'k+-')
hold on
plot(VR,Resilience, 'ko-')
xlabel('Variant Richness')
ylabel('Resilience - SIR')

%Resistance SIR
figResistenceSIR=figure
plot(VR,ResistanceFS, 'k+-')
hold on
plot(VR,Resistance, 'ko-')
xlabel('Variant Richness')
ylabel('Resistance - SIR')

%VM mode
%s
figsuceptEndVM=figure;
plot(VR,NumberInSEndFS,'k+-')
hold on
plot(VR,NumberInSEnd,'ko-')
xlabel('Variant Richness')
ylabel('Susceptible End - SI')

figResistanceVM=figure
plot(VR,ResistanceFSVM,'k+-')
hold on
plot(VR,ResistanceVM,'ko-')
xlabel('Variant Richness')
ylabel('Resistance - VM')

figResilienceTimeVM=figure;
plot(VR,ResilienceTimeFSVM,'k+-')
hold on
plot(VR,ResilienceTimeVM,'ko-')
xlabel('Variant Richness')
ylabel('Resilience time - VM')

figResilienceVM = figure;
plot(VR,ResilienceFSVM,'k+-')
hold on
plot(VR,ResilienceVM,'ko-')
xlabel('Variant Richness')
ylabel('Resilience - VM')

ResistanceFSSI % resistance SI
PeakTimeFS %peak time
ResTimeFS  %resilience time
ResilienceFS %resilience SIR
ResistanceFS %resistance SIR
NumberInSEndFS%with vm updates
ResistanceFSVM %vm resistance
ResilienceTimeFSVM %vm resilience time
ResilienceFSVM %vm resilience


ResistanceSI % resistance SI
PeakTime %peak time
ResTime  %resilience time
Resilience %resilience SIR
Resistance %resistance SIR
NumberInSEnd%with vm updates
ResistanceVM %vm resistance
ResilienceTimeVM %vm resilience time
ResilienceVM %vm resilience
fileName = [outputDirectory num2str(data.m) 'output.txt']
outFile = fopen(fileName, 'wt');
fprintf(outFile, '%s\n,', 'ResistanceFSSI'); fprintf(outFile, '%f,', ResistanceFSSI); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'PeakTimeFS'); fprintf(outFile, '%f,', PeakTimeFS); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'ResTimeFS'); fprintf(outFile, '%f,', ResTimeFS); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'ResilienceFS'); fprintf(outFile, '%f,', ResilienceFS); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'ResistanceFS'); fprintf(outFile, '%f,', ResistanceFS); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'NumberInSEndFS'); fprintf(outFile, '%f,', NumberInSEndFS); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'ResistanceFSVM'); fprintf(outFile, '%f,', ResistanceFSVM); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'ResilienceTimeFSVM'); fprintf(outFile, '%f,', ResilienceTimeFSVM); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'ResilienceFSVM'); fprintf(outFile, '%f,', ResilienceFSVM); fprintf(outFile, '\n'); %new line

fprintf(outFile, '%s\n,', 'ResistanceSI'); fprintf(outFile, '%f,', ResistanceSI); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'PeakTime'); fprintf(outFile, '%f,', PeakTime); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'ResTime'); fprintf(outFile, '%f,', ResTime); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'Resilience'); fprintf(outFile, '%f,', Resilience); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'Resistance'); fprintf(outFile, '%f,', Resistance); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'NumberInSEnd'); fprintf(outFile, '%f,', NumberInSEnd); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'ResistanceVM'); fprintf(outFile, '%f,', ResistanceVM); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'ResilienceTimeVM'); fprintf(outFile, '%f,', ResilienceTimeVM); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'ResilienceVM'); fprintf(outFile, '%f,', ResilienceVM); fprintf(outFile, '\n'); %new line
fclose(outFile);


saveas(figImean,[outputDirectory 'figImean.fig']);
saveas(figImean,[outputDirectory 'figImean.emf']);
saveas(figIPeak,[outputDirectory 'figIPeak.fig']);
saveas(figIPeak,[outputDirectory 'figIPeak.emf']);
saveas(figResistanceSI,[outputDirectory 'figResistanceSI.fig']);
saveas(figResistanceSI,[outputDirectory 'figResistanceSI.emf']);
saveas(figResilienceTimeSI,[outputDirectory 'figResilienceTimeSI.fig']);
saveas(figResilienceTimeSI,[outputDirectory 'figResilienceTimeSI.emf']);
saveas(figResilienceSIR,[outputDirectory 'figResilienceSIR.fig']);
saveas(figResilienceSIR,[outputDirectory 'figResilienceSIR.emf']);
saveas(figResistenceSIR,[outputDirectory 'figResistenceSIR.fig']);
saveas(figResistenceSIR,[outputDirectory 'figResistenceSIR.emf']);
saveas(figsuceptEndVM,[outputDirectory 'figsuceptEndVM.fig']);
saveas(figsuceptEndVM,[outputDirectory 'figsuceptEndVM.emf']);
saveas(figResistanceVM,[outputDirectory 'figResistanceVM.fig']);
saveas(figResistanceVM,[outputDirectory 'figResistanceVM.emf']);
saveas(figResilienceTimeVM,[outputDirectory 'figResilienceTimeVM.fig']);
saveas(figResilienceTimeVM,[outputDirectory 'figResilienceTimeVM.emf']);
saveas(figResilienceVM,[outputDirectory 'figResilienceVM.fig']);
saveas(figResilienceVM,[outputDirectory 'figResilienceVM.emf']);
close all;
toc
%end%413


%dynamic nodes -  1 locus
%if doSIRNTests(412) == 1
data.m = 412 %data file number
%1 locus model
%outputDirectory = 'randomGenotypesGraphs\ALL\Test412\' %BUMBLEBEE
outputDirectory = 'randomGenotypesGraphs\ALL\Test412\'
tic
modePar.netStr = 're'; %'rwp' random waypoint 're' random encounter
%*************************
%UNUSED PAR FOR RE MODE
%rwp par
modePar.genotypeTimeOutPeriod = 10; %rwp
modePar.xmin     = 1;     % Minimum x-axis location (du)
modePar.xmax     = 31;    % Maximum x-axis location (du)
modePar.ymin     = 1;     % Minimum y-axis location (du)
modePar.ymax     = 31;    % Maximum y-axis location (du)
modePar.smin     = 1.4;  % Minimum speed (du / tu)
modePar.smax     = 1.4;  % Maximum speed (du / tu)
modePar.pmin     = 0;     % Minimum time for pause (integer tu)
modePar.pmax     = 0;     % Maximum time for pause (integer tu)
modePar.dinr     = 3; %7    % Radial distance for in-range (du)
modePar.dexceed  = 1000;  % Value larger than any possible distance (du)
modePar.tinrg    = 1;     % Time in-range for genotype transfer (tu)
modePar.tinrv    = 1;     % Time in-range for virus transfer (tu)
% Mode
% rwph.mode = rwph.MODE_RIR;  1    % Select Random in range mode
% rwph.mode = rwph.MODE_NIR;  2    % Select Nearest in range mode
modePar.moderwp = 1; %MODE_AIR;  % 4    % Select (Random) Available in range mode
%rwp constrain
modePar.xboxc=0.5
modePar.yboxc=0.5
modePar.rwpcontrainplotGraph=0 %draw init constraints graph
% Log vector
modePar.logena = [1 2];
% Log directory for rwp
modePar.logDir = sprintf('%s\\log', pwd);
modePar.statnodesrwp = 'dynamic'; %'dynamic' or 'stationary' nodes, if dynamic box constraints applied at point of virus start
%END UNUSED PAR
%*****************
%data logging of output
data.logDir = sprintf('%s\\outputdata', pwd)
s = sprintf('%s\\data%i.txt', data.logDir,data.m)
data.logOutput(data.m) = fopen(s, 'wt');
%****************************************
modePar.numEncountersBetweenUpdates = 1
modePar.bufferlength = 10 %length of genotype buffer for favscore algorithm
modePar.genoInit = 'mindiv'  %initial conditions of genotypes maxdiv (maximum diversity - random variant chosen) mindiv (minimum diversity - all nodes same)
%blacklist mode
modePar.blklist = 'no'; %yes or no
modePar.numToBlklist = 1
modePar.blklistrate = 0.004 %0.001
%vmupdate mode
modePar.vm = 'no' %yes or no

%update mode
modePar.update = 'yes' %stop updating mode
modePar.bufferlengthNei=10 %buffer for buffering local nei diversity,
modePar.stdNeiUpdateThreshold = 0.15
%recovery
recovery = 0.004; 0.0005 %0.001
%*****************************************
%**********************
%constraints
modePar.numToConstrain = 0;%fix(numNodes*1/4); %constain a number of nodes to 1 variant
modePar.areaConstrainrwp='no'
%**********************
%main par
%numRuns = 10 %20 %100 %200
%numNodes = 100;
%SEpidemic=6; %cutoff;
numLoci=4; 
casetype = 'AND';
modePar.virusStartTime = 1200;
numTimestepsVR = [5000]; %7000?
VR = [1 2 3 4 5];
modePar.blklistStartTime = modePar.virusStartTime
numExploits=1;

%init parameters
ResistanceFSSI = zeros(1,size(VR,2)); % resistance SI
PeakTimeFS = zeros(1,size(VR,2)); %peak time
ResTimeFS = zeros(1,size(VR,2));  %resilience time
ResilienceFS = zeros(1,size(VR,2)); %resilience SIR
ResistanceFS = zeros(1,size(VR,2)); %resistance SIR
NumberInSEndFS = zeros(1,size(VR,2));%with vm updates
ResistanceFSVM = zeros(1,size(VR,2)); %vm resistance
ResilienceTimeFSVM = zeros(1,size(VR,2)); %vm resilience time
ResilienceFSVM = zeros(1,size(VR,2)); %vm resilience
ResistanceSI = zeros(1,size(VR,2)); % resistance SI
PeakTime = zeros(1,size(VR,2)); %peak time
ResTime = zeros(1,size(VR,2));  %resilience time
Resilience = zeros(1,size(VR,2)); %resilience SIR
Resistance = zeros(1,size(VR,2)); %resistance SIR
NumberInSEnd = zeros(1,size(VR,2));%with vm updates
ResistanceVM = zeros(1,size(VR,2)); %vm resistance
ResilienceTimeVM = zeros(1,size(VR,2)); %vm resilience time
ResilienceVM = zeros(1,size(VR,2)); %vm resilience

mode = 'Dynamic-favScore' %mode - can be 'static' or 'dynamic' 'Dynamic-random' 'Dynamic-favScore'
%monte carlo random genotype SIR model
%set up diversity mode parameters
modePar.modeStr = mode
modePar.stopUpdatingTime = 200000 %time at which to stop updating the genotypes
for j = 1:size(VR,2)%do for all VR
    variantRichness =  VR(j)
    numTimesteps = numTimestepsVR(1);
   
 betan = 0.02;  plotGraphs = 0; gamma = recovery;  throwAway = 'nonEpidemics', 
 %agent
 [figMeanNei figNeiOneRun fighistSpRun fighistRecovered fighistSusceptible fighistpeakValue fighistpeakTime fighistBeta fighistGamma fighistBetanew fighistGammanew figInfectedRun1 figBetaRun1 figGammaRun1 figRoRun1 figBetaGamma1 figBetaGamma2...
            meanNeiIndexDynamic betastd gammastd betastd2 betastdNew betastdNew2 gammastdNew peakTimemean peakTimestd peakValuemean peakValuestd...
            betameanmean gammameanmean betameanmean2 betameanmeanNew betameanmeanNew2 gammameanmeanNew Smean Imean Rmean Bmean NSmean Smedian Imedian Rmedian S I R NS SmeanN ImeanN1 RmeanN1 BmeanN1 Snewendmean Snewendstd Rnewendmean Rnewendstd Rnew_nonendmean Rnew_nonendstd propSimsNonEp propSimsNonEp_theoretical...
            numRunsMinor measuredProbMinor numRunsMajor measuredProbMajor meanmdist meannumInfectedVM...
            ] = monteCarloSIRN2(numRuns,numNodes, betan, variantRichness, numTimesteps, plotGraphs,gamma,throwAway,SEpidemic,numExploits,modePar, numLoci, casetype);
   close all; 
   
    %peak time SI
    FinalSizeI = max(Imean,[],2); %mean final size SI
    maska = Imean >= FinalSizeI-1; %when within 1 of the final value
    [C Index] = max(maska);
    PeakTimeFS(j) = Index - modePar.virusStartTime; %T1
    if PeakTimeFS(j) < 0; PeakTimeFS(j)=0; end %check to see if picks an index before the virus start time, must be no outbreak and zero
    %Resistance SI
    ResistanceFSSI(j) = (numNodes-FinalSizeI)./numNodes;  
    %Resilience SIR
     FinalSize = max(RmeanN1,[],2); %mean final R of epidemics only
    maska = RmeanN1 >= FinalSize-1; %when within 1 of the final value
    [C Index] = max(maska);
    ResTimeFS(j) = Index -modePar.virusStartTime; %T1 
    if ResTimeFS(j) < 0; ResTimeFS(j)=0; end %check to see if picks an index before the virus start time, must be no outbreak and zero
    ResilienceFS(j) = 1./ResTimeFS(j);
    %resistance SIR
    ResistanceFS(j) = (numNodes-FinalSize)./numNodes;
    
    %VM update Resistance
     ResistanceFSVM(j) =(numNodes - meannumInfectedVM)./numNodes; %number infected at least once
     %[val index] = min(Imean(modePar.virusStartTime:end)) %time for infected to die away
     maska = Imean(modePar.virusStartTime:end) >= 1; %time when within 1 of zero
    [C indvm] = min(maska); %get index of first zero
     ResilienceTimeFSVM(j)= indvm-1; %index 1 means timw zero of malware injection so subtract 1
    ResilienceFSVM(j) = 1./(indvm-1);
     %with vm updates can get rid of those infected to count ended up in S
    %at end
    NumberInSEndFS(j) = Smean(end);
    
  
   
%data logging
 fprintf(data.logOutput(data.m), '%f,', Imean);     % infection
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResistanceFSSI(j)); % resistance SI
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', PeakTimeFS(j)); %peak time
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResTimeFS(j));     %resilience time
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResilienceFS(j)); %resilience
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResistanceFS(j)); %resistance SIR
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', NumberInSEndFS(j));  %with vm updates can get rid of those infected to count ended up in S    %at end
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResistanceFSVM(j));  
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResilienceTimeFSVM(j));  
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResilienceFSVM(j));  
fprintf(data.logOutput(data.m), '\n'); %new line
end %VR


mode = 'Dynamic-random' %mode - can be 'static' or 'dynamic' 'Dynamic-random' 'Dynamic-favScore'
%monte carlo random genotype SIR model
%set up diversity mode parameters
modePar.modeStr = mode
modePar.stopUpdatingTime = modePar.virusStartTime %time at which to stop updating the genotypes
for j = 1:size(VR,2)%do for all VR
    variantRichness =  VR(j)
    numTimesteps = numTimestepsVR(1);
 betan = 0.02;  plotGraphs = 0; gamma = recovery; throwAway = 'nonEpidemics';
 %agent
 [figMeanNei figNeiOneRun fighistSpRun fighistRecovered fighistSusceptible fighistpeakValue fighistpeakTime fighistBeta fighistGamma fighistBetanew fighistGammanew figInfectedRun1 figBetaRun1 figGammaRun1 figRoRun1 figBetaGamma1 figBetaGamma2...
            meanNeiIndexDynamic betastd gammastd betastd2 betastdNew betastdNew2 gammastdNew peakTimemean peakTimestd peakValuemean peakValuestd...
            betameanmean gammameanmean betameanmean2 betameanmeanNew betameanmeanNew2 gammameanmeanNew Smean Imean Rmean Bmean NSmean Smedian Imedian Rmedian S I R NS SmeanN ImeanN1 RmeanN1 BmeanN1 Snewendmean Snewendstd Rnewendmean Rnewendstd Rnew_nonendmean Rnew_nonendstd propSimsNonEp propSimsNonEp_theoretical...
            numRunsMinor measuredProbMinor numRunsMajor measuredProbMajor meanmdist meannumInfectedVM...
            ] = monteCarloSIRN2(numRuns,numNodes, betan, variantRichness, numTimesteps, plotGraphs,gamma,throwAway,SEpidemic,numExploits,modePar, numLoci, casetype);
   close all; 
   
   %peak time SI
    FinalSizeI = max(Imean,[],2); %mean final size SI
   maska = Imean >= FinalSizeI-1; %when within 1 of the final value
   [C Index] = max(maska);
   PeakTime(j) = Index-modePar.virusStartTime; %T1
   if PeakTime(j) < 0; PeakTime(j)=0; end %check to see if picks an index before the virus start time, must be no outbreak and zero
  %Resistance SI
    ResistanceSI(j) = (numNodes-FinalSizeI)./numNodes; 
    %Resilience SIR
     FinalSize = max(RmeanN1,[],2); %mean final R of epidemics only
    maska = RmeanN1 >= FinalSize-1; %when within 1 of the final value
   [C Index] = max(maska);
   ResTime(j) = Index-modePar.virusStartTime; %T1 
   if ResTime(j) < 0; ResTime(j)=0; end %check to see if picks an index before the virus start time, must be no outbreak and zero
   Resilience(j) = 1./ResTime(j);
   %resistance SIR
   Resistance(j) = (numNodes-FinalSize)./numNodes;
    %VM update Resistance
     ResistanceVM(j) =(numNodes - meannumInfectedVM)./numNodes; %number infected at least once
     %[val index] = min(Imean(modePar.virusStartTime:end)) %time for infected to die away
     maska = Imean(modePar.virusStartTime:end) >= 1; %time when within 1 of zero
    [C indvm] = min(maska); %get index of first zero
     ResilienceTimeVM(j)= indvm-1; %index 1 means timw zero of malware injection so subtract 1
    ResilienceVM(j) = 1./(indvm-1);
     %with vm updates can get rid of those infected to count ended up in S
    %at end
    NumberInSEnd(j) = Smean(end);
  
%data logging
 fprintf(data.logOutput(data.m), '%f,', Imean);     % infection
fprintf(data.logOutput(data.m), '\n'); %new line
fprintf(data.logOutput(data.m), '%f,', ResistanceSI(j)); % resistance SI
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', PeakTime(j)); %peak time
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResTime(j));     %resilience time
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', Resilience(j)); %resilience
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', Resistance(j)); %resistance SIR
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', NumberInSEnd(j));  %with vm updates can get rid of those infected to count ended up in S
fprintf(data.logOutput(data.m), '\n'); %new line 
fprintf(data.logOutput(data.m), '%f,', ResistanceVM(j));  
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResilienceTimeVM(j));  
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResilienceVM(j));  
fprintf(data.logOutput(data.m), '\n'); %new line
end %VR

fclose(data.logOutput(data.m));

%last Imean
figImean = figure;
plot(Imean, 'k')
xlabel('Time (seconds)')
ylabel('Number Infected')
%peak time SI
figIPeak = figure;
plot(VR,PeakTimeFS, 'k+-')
hold on
plot(VR,PeakTime, 'ko-')
xlabel('Variant Richness')
ylabel('Peak Time - SI')
%resistance SI
figResistanceSI=figure;
plot(VR,ResistanceFSSI,'k+-')
hold on
plot(VR,ResistanceSI,'ko-')
xlabel('Variant Richness')
ylabel('Peak I ')

%resilience time SIR
figResilienceTimeSI=figure;
plot(VR,ResTimeFS, 'k+-')
hold on
plot(VR,ResTime, 'ko-')
xlabel('Variant Richness')
ylabel('Resilience time - SIR')

%resilience SIR
figResilienceSIR=figure;
plot(VR,ResilienceFS, 'k+-')
hold on
plot(VR,Resilience, 'ko-')
xlabel('Variant Richness')
ylabel('Resilience - SIR')

%Resistance SIR
figResistenceSIR=figure
plot(VR,ResistanceFS, 'k+-')
hold on
plot(VR,Resistance, 'ko-')
xlabel('Variant Richness')
ylabel('Resistance - SIR')

%VM mode
%s
figsuceptEndVM=figure;
plot(VR,NumberInSEndFS,'k+-')
hold on
plot(VR,NumberInSEnd,'ko-')
xlabel('Variant Richness')
ylabel('Susceptible End - SI')

figResistanceVM=figure
plot(VR,ResistanceFSVM,'k+-')
hold on
plot(VR,ResistanceVM,'ko-')
xlabel('Variant Richness')
ylabel('Resistance - VM')

figResilienceTimeVM=figure;
plot(VR,ResilienceTimeFSVM,'k+-')
hold on
plot(VR,ResilienceTimeVM,'ko-')
xlabel('Variant Richness')
ylabel('Resilience time - VM')

figResilienceVM = figure;
plot(VR,ResilienceFSVM,'k+-')
hold on
plot(VR,ResilienceVM,'ko-')
xlabel('Variant Richness')
ylabel('Resilience - VM')

ResistanceFSSI % resistance SI
PeakTimeFS %peak time
ResTimeFS  %resilience time
ResilienceFS %resilience SIR
ResistanceFS %resistance SIR
NumberInSEndFS%with vm updates
ResistanceFSVM %vm resistance
ResilienceTimeFSVM %vm resilience time
ResilienceFSVM %vm resilience


ResistanceSI % resistance SI
PeakTime %peak time
ResTime  %resilience time
Resilience %resilience SIR
Resistance %resistance SIR
NumberInSEnd%with vm updates
ResistanceVM %vm resistance
ResilienceTimeVM %vm resilience time
ResilienceVM %vm resilience
fileName = [outputDirectory num2str(data.m) 'output.txt']
outFile = fopen(fileName, 'wt');
fprintf(outFile, '%s\n,', 'ResistanceFSSI'); fprintf(outFile, '%f,', ResistanceFSSI); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'PeakTimeFS'); fprintf(outFile, '%f,', PeakTimeFS); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'ResTimeFS'); fprintf(outFile, '%f,', ResTimeFS); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'ResilienceFS'); fprintf(outFile, '%f,', ResilienceFS); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'ResistanceFS'); fprintf(outFile, '%f,', ResistanceFS); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'NumberInSEndFS'); fprintf(outFile, '%f,', NumberInSEndFS); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'ResistanceFSVM'); fprintf(outFile, '%f,', ResistanceFSVM); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'ResilienceTimeFSVM'); fprintf(outFile, '%f,', ResilienceTimeFSVM); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'ResilienceFSVM'); fprintf(outFile, '%f,', ResilienceFSVM); fprintf(outFile, '\n'); %new line

fprintf(outFile, '%s\n,', 'ResistanceSI'); fprintf(outFile, '%f,', ResistanceSI); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'PeakTime'); fprintf(outFile, '%f,', PeakTime); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'ResTime'); fprintf(outFile, '%f,', ResTime); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'Resilience'); fprintf(outFile, '%f,', Resilience); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'Resistance'); fprintf(outFile, '%f,', Resistance); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'NumberInSEnd'); fprintf(outFile, '%f,', NumberInSEnd); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'ResistanceVM'); fprintf(outFile, '%f,', ResistanceVM); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'ResilienceTimeVM'); fprintf(outFile, '%f,', ResilienceTimeVM); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'ResilienceVM'); fprintf(outFile, '%f,', ResilienceVM); fprintf(outFile, '\n'); %new line
fclose(outFile);


saveas(figImean,[outputDirectory 'figImean.fig']);
saveas(figImean,[outputDirectory 'figImean.emf']);
saveas(figIPeak,[outputDirectory 'figIPeak.fig']);
saveas(figIPeak,[outputDirectory 'figIPeak.emf']);
saveas(figResistanceSI,[outputDirectory 'figResistanceSI.fig']);
saveas(figResistanceSI,[outputDirectory 'figResistanceSI.emf']);
saveas(figResilienceTimeSI,[outputDirectory 'figResilienceTimeSI.fig']);
saveas(figResilienceTimeSI,[outputDirectory 'figResilienceTimeSI.emf']);
saveas(figResilienceSIR,[outputDirectory 'figResilienceSIR.fig']);
saveas(figResilienceSIR,[outputDirectory 'figResilienceSIR.emf']);
saveas(figResistenceSIR,[outputDirectory 'figResistenceSIR.fig']);
saveas(figResistenceSIR,[outputDirectory 'figResistenceSIR.emf']);
saveas(figsuceptEndVM,[outputDirectory 'figsuceptEndVM.fig']);
saveas(figsuceptEndVM,[outputDirectory 'figsuceptEndVM.emf']);
saveas(figResistanceVM,[outputDirectory 'figResistanceVM.fig']);
saveas(figResistanceVM,[outputDirectory 'figResistanceVM.emf']);
saveas(figResilienceTimeVM,[outputDirectory 'figResilienceTimeVM.fig']);
saveas(figResilienceTimeVM,[outputDirectory 'figResilienceTimeVM.emf']);
saveas(figResilienceVM,[outputDirectory 'figResilienceVM.fig']);
saveas(figResilienceVM,[outputDirectory 'figResilienceVM.emf']);
close all;
toc
%end%412

%dynamic nodes -  1 locus
%if doSIRNTests(411) == 1
data.m = 411 %data file number
%1 locus model
%outputDirectory = 'randomGenotypesGraphs\ALL\Test411\' %BUMBLEBEE
outputDirectory = 'randomGenotypesGraphs\ALL\Test411\'
tic
modePar.netStr = 're'; %'rwp' random waypoint 're' random encounter
%*************************
%UNUSED PAR FOR RE MODE
%rwp par
modePar.genotypeTimeOutPeriod = 10; %rwp
modePar.xmin     = 1;     % Minimum x-axis location (du)
modePar.xmax     = 31;    % Maximum x-axis location (du)
modePar.ymin     = 1;     % Minimum y-axis location (du)
modePar.ymax     = 31;    % Maximum y-axis location (du)
modePar.smin     = 1.4;  % Minimum speed (du / tu)
modePar.smax     = 1.4;  % Maximum speed (du / tu)
modePar.pmin     = 0;     % Minimum time for pause (integer tu)
modePar.pmax     = 0;     % Maximum time for pause (integer tu)
modePar.dinr     = 3; %7    % Radial distance for in-range (du)
modePar.dexceed  = 1000;  % Value larger than any possible distance (du)
modePar.tinrg    = 1;     % Time in-range for genotype transfer (tu)
modePar.tinrv    = 1;     % Time in-range for virus transfer (tu)
% Mode
% rwph.mode = rwph.MODE_RIR;  1    % Select Random in range mode
% rwph.mode = rwph.MODE_NIR;  2    % Select Nearest in range mode
modePar.moderwp = 1; %MODE_AIR;  % 4    % Select (Random) Available in range mode
%rwp constrain
modePar.xboxc=0.5
modePar.yboxc=0.5
modePar.rwpcontrainplotGraph=0 %draw init constraints graph
% Log vector
modePar.logena = [1 2];
% Log directory for rwp
modePar.logDir = sprintf('%s\\log', pwd);
modePar.statnodesrwp = 'dynamic'; %'dynamic' or 'stationary' nodes, if dynamic box constraints applied at point of virus start
%END UNUSED PAR
%*****************
%data logging of output
data.logDir = sprintf('%s\\outputdata', pwd)
s = sprintf('%s\\data%i.txt', data.logDir,data.m)
data.logOutput(data.m) = fopen(s, 'wt');
%****************************************
modePar.numEncountersBetweenUpdates = 1
modePar.bufferlength = 10 %length of genotype buffer for favscore algorithm
modePar.genoInit = 'mindiv'  %initial conditions of genotypes maxdiv (maximum diversity - random variant chosen) mindiv (minimum diversity - all nodes same)
%blacklist mode
modePar.blklist = 'no'; %yes or no
modePar.numToBlklist = 1
modePar.blklistrate = 0.004 %0.001
%vmupdate mode
modePar.vm = 'no' %yes or no

%update mode
modePar.update = 'yes' %stop updating mode
modePar.bufferlengthNei=10 %buffer for buffering local nei diversity,
modePar.stdNeiUpdateThreshold = 0.15
%recovery
recovery = 0.004; 0.0005 %0.001
%*****************************************
%**********************
%constraints
modePar.numToConstrain = 0;%fix(numNodes*1/4); %constain a number of nodes to 1 variant
modePar.areaConstrainrwp='no'
%**********************
%main par
%numRuns = 50 %20 %100 %200
%numNodes = 100;
%SEpidemic=6; %cutoff;
numLoci=1; 
casetype = 'OR';
modePar.virusStartTime = 1200;
numTimestepsVR = [5000]; %7000?
VR = [1 2 3 4 5 6 7 8 9 10];
modePar.blklistStartTime = modePar.virusStartTime
numExploits=1;

%init parameters
ResistanceFSSI = zeros(1,size(VR,2)); % resistance SI
PeakTimeFS = zeros(1,size(VR,2)); %peak time
ResTimeFS = zeros(1,size(VR,2));  %resilience time
ResilienceFS = zeros(1,size(VR,2)); %resilience SIR
ResistanceFS = zeros(1,size(VR,2)); %resistance SIR
NumberInSEndFS = zeros(1,size(VR,2));%with vm updates
ResistanceFSVM = zeros(1,size(VR,2)); %vm resistance
ResilienceTimeFSVM = zeros(1,size(VR,2)); %vm resilience time
ResilienceFSVM = zeros(1,size(VR,2)); %vm resilience
ResistanceSI = zeros(1,size(VR,2)); % resistance SI
PeakTime = zeros(1,size(VR,2)); %peak time
ResTime = zeros(1,size(VR,2));  %resilience time
Resilience = zeros(1,size(VR,2)); %resilience SIR
Resistance = zeros(1,size(VR,2)); %resistance SIR
NumberInSEnd = zeros(1,size(VR,2));%with vm updates
ResistanceVM = zeros(1,size(VR,2)); %vm resistance
ResilienceTimeVM = zeros(1,size(VR,2)); %vm resilience time
ResilienceVM = zeros(1,size(VR,2)); %vm resilience

mode = 'Dynamic-favScore' %mode - can be 'static' or 'dynamic' 'Dynamic-random' 'Dynamic-favScore'
%monte carlo random genotype SIR model
%set up diversity mode parameters
modePar.modeStr = mode
modePar.stopUpdatingTime = 200000 %time at which to stop updating the genotypes
for j = 1:size(VR,2)%do for all VR
    variantRichness =  VR(j)
    numTimesteps = numTimestepsVR(1);
   
 betan = 0.02;  plotGraphs = 0; gamma = recovery;  throwAway = 'nonEpidemics', 
 %agent
 [figMeanNei figNeiOneRun fighistSpRun fighistRecovered fighistSusceptible fighistpeakValue fighistpeakTime fighistBeta fighistGamma fighistBetanew fighistGammanew figInfectedRun1 figBetaRun1 figGammaRun1 figRoRun1 figBetaGamma1 figBetaGamma2...
            meanNeiIndexDynamic betastd gammastd betastd2 betastdNew betastdNew2 gammastdNew peakTimemean peakTimestd peakValuemean peakValuestd...
            betameanmean gammameanmean betameanmean2 betameanmeanNew betameanmeanNew2 gammameanmeanNew Smean Imean Rmean Bmean NSmean Smedian Imedian Rmedian S I R NS SmeanN ImeanN1 RmeanN1 BmeanN1 Snewendmean Snewendstd Rnewendmean Rnewendstd Rnew_nonendmean Rnew_nonendstd propSimsNonEp propSimsNonEp_theoretical...
            numRunsMinor measuredProbMinor numRunsMajor measuredProbMajor meanmdist meannumInfectedVM...
            ] = monteCarloSIRN2(numRuns,numNodes, betan, variantRichness, numTimesteps, plotGraphs,gamma,throwAway,SEpidemic,numExploits,modePar, numLoci, casetype);
   close all; 
   
    %peak time SI
    FinalSizeI = max(Imean,[],2); %mean final size SI
    maska = Imean >= FinalSizeI-1; %when within 1 of the final value
    [C Index] = max(maska);
    PeakTimeFS(j) = Index - modePar.virusStartTime; %T1
    if PeakTimeFS(j) < 0; PeakTimeFS(j)=0; end %check to see if picks an index before the virus start time, must be no outbreak and zero
    %Resistance SI
    ResistanceFSSI(j) = (numNodes-FinalSizeI)./numNodes;  
    %Resilience SIR
     FinalSize = max(RmeanN1,[],2); %mean final R of epidemics only
    maska = RmeanN1 >= FinalSize-1; %when within 1 of the final value
    [C Index] = max(maska);
    ResTimeFS(j) = Index -modePar.virusStartTime; %T1 
    if ResTimeFS(j) < 0; ResTimeFS(j)=0; end %check to see if picks an index before the virus start time, must be no outbreak and zero
    ResilienceFS(j) = 1./ResTimeFS(j);
    %resistance SIR
    ResistanceFS(j) = (numNodes-FinalSize)./numNodes;
    
    %VM update Resistance
     ResistanceFSVM(j) =(numNodes - meannumInfectedVM)./numNodes; %number infected at least once
     %[val index] = min(Imean(modePar.virusStartTime:end)) %time for infected to die away
     maska = Imean(modePar.virusStartTime:end) >= 1; %time when within 1 of zero
    [C indvm] = min(maska); %get index of first zero
     ResilienceTimeFSVM(j)= indvm-1; %index 1 means timw zero of malware injection so subtract 1
    ResilienceFSVM(j) = 1./(indvm-1);
     %with vm updates can get rid of those infected to count ended up in S
    %at end
    NumberInSEndFS(j) = Smean(end);
    
  
   
%data logging
 fprintf(data.logOutput(data.m), '%f,', Imean);     % infection
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResistanceFSSI(j)); % resistance SI
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', PeakTimeFS(j)); %peak time
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResTimeFS(j));     %resilience time
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResilienceFS(j)); %resilience
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResistanceFS(j)); %resistance SIR
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', NumberInSEndFS(j));  %with vm updates can get rid of those infected to count ended up in S    %at end
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResistanceFSVM(j));  
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResilienceTimeFSVM(j));  
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResilienceFSVM(j));  
fprintf(data.logOutput(data.m), '\n'); %new line
end %VR


mode = 'Dynamic-random' %mode - can be 'static' or 'dynamic' 'Dynamic-random' 'Dynamic-favScore'
%monte carlo random genotype SIR model
%set up diversity mode parameters
modePar.modeStr = mode
modePar.stopUpdatingTime = modePar.virusStartTime %time at which to stop updating the genotypes
for j = 1:size(VR,2)%do for all VR
    variantRichness =  VR(j)
    numTimesteps = numTimestepsVR(1);
 betan = 0.02;  plotGraphs = 0; gamma = recovery; throwAway = 'nonEpidemics';
 %agent
 [figMeanNei figNeiOneRun fighistSpRun fighistRecovered fighistSusceptible fighistpeakValue fighistpeakTime fighistBeta fighistGamma fighistBetanew fighistGammanew figInfectedRun1 figBetaRun1 figGammaRun1 figRoRun1 figBetaGamma1 figBetaGamma2...
            meanNeiIndexDynamic betastd gammastd betastd2 betastdNew betastdNew2 gammastdNew peakTimemean peakTimestd peakValuemean peakValuestd...
            betameanmean gammameanmean betameanmean2 betameanmeanNew betameanmeanNew2 gammameanmeanNew Smean Imean Rmean Bmean NSmean Smedian Imedian Rmedian S I R NS SmeanN ImeanN1 RmeanN1 BmeanN1 Snewendmean Snewendstd Rnewendmean Rnewendstd Rnew_nonendmean Rnew_nonendstd propSimsNonEp propSimsNonEp_theoretical...
            numRunsMinor measuredProbMinor numRunsMajor measuredProbMajor meanmdist meannumInfectedVM...
            ] = monteCarloSIRN2(numRuns,numNodes, betan, variantRichness, numTimesteps, plotGraphs,gamma,throwAway,SEpidemic,numExploits,modePar, numLoci, casetype);
   close all; 
   
  %peak time SI
    FinalSizeI = max(Imean,[],2); %mean final size SI
   maska = Imean >= FinalSizeI-1; %when within 1 of the final value
   [C Index] = max(maska);
   PeakTime(j) = Index-modePar.virusStartTime; %T1
   if PeakTime(j) < 0; PeakTime(j)=0; end %check to see if picks an index before the virus start time, must be no outbreak and zero
  %Resistance SI
    ResistanceSI(j) = (numNodes-FinalSizeI)./numNodes; 
    %Resilience SIR
     FinalSize = max(RmeanN1,[],2); %mean final R of epidemics only
    maska = RmeanN1 >= FinalSize-1; %when within 1 of the final value
   [C Index] = max(maska);
   ResTime(j) = Index-modePar.virusStartTime; %T1 
   if ResTime(j) < 0; ResTime(j)=0; end %check to see if picks an index before the virus start time, must be no outbreak and zero
   Resilience(j) = 1./ResTime(j);
   %resistance SIR
   Resistance(j) = (numNodes-FinalSize)./numNodes;
    %VM update Resistance
     ResistanceVM(j) =(numNodes - meannumInfectedVM)./numNodes; %number infected at least once
     %[val index] = min(Imean(modePar.virusStartTime:end)) %time for infected to die away
     maska = Imean(modePar.virusStartTime:end) >= 1; %time when within 1 of zero
    [C indvm] = min(maska); %get index of first zero
     ResilienceTimeVM(j)= indvm-1; %index 1 means timw zero of malware injection so subtract 1
    ResilienceVM(j) = 1./(indvm-1);
     %with vm updates can get rid of those infected to count ended up in S
    %at end
    NumberInSEnd(j) = Smean(end);
  
%data logging
 fprintf(data.logOutput(data.m), '%f,', Imean);     % infection
fprintf(data.logOutput(data.m), '\n'); %new line
fprintf(data.logOutput(data.m), '%f,', ResistanceSI(j)); % resistance SI
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', PeakTime(j)); %peak time
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResTime(j));     %resilience time
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', Resilience(j)); %resilience
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', Resistance(j)); %resistance SIR
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', NumberInSEnd(j));  %with vm updates can get rid of those infected to count ended up in S
fprintf(data.logOutput(data.m), '\n'); %new line 
fprintf(data.logOutput(data.m), '%f,', ResistanceVM(j));  
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResilienceTimeVM(j));  
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResilienceVM(j));  
fprintf(data.logOutput(data.m), '\n'); %new line
end %VR

fclose(data.logOutput(data.m));

%last Imean
figImean = figure;
plot(Imean, 'k')
xlabel('Time (seconds)')
ylabel('Number Infected')
%peak time SI
figIPeak = figure;
plot(VR,PeakTimeFS, 'k+-')
hold on
plot(VR,PeakTime, 'ko-')
xlabel('Variant Richness')
ylabel('Peak Time - SI')
%resistance SI
figResistanceSI=figure;
plot(VR,ResistanceFSSI,'k+-')
hold on
plot(VR,ResistanceSI,'ko-')
xlabel('Variant Richness')
ylabel('Peak I ')

%resilience time SIR
figResilienceTimeSI=figure;
plot(VR,ResTimeFS, 'k+-')
hold on
plot(VR,ResTime, 'ko-')
xlabel('Variant Richness')
ylabel('Resilience time - SIR')

%resilience SIR
figResilienceSIR=figure;
plot(VR,ResilienceFS, 'k+-')
hold on
plot(VR,Resilience, 'ko-')
xlabel('Variant Richness')
ylabel('Resilience - SIR')

%Resistance SIR
figResistenceSIR=figure
plot(VR,ResistanceFS, 'k+-')
hold on
plot(VR,Resistance, 'ko-')
xlabel('Variant Richness')
ylabel('Resistance - SIR')

%VM mode
%s
figsuceptEndVM=figure;
plot(VR,NumberInSEndFS,'k+-')
hold on
plot(VR,NumberInSEnd,'ko-')
xlabel('Variant Richness')
ylabel('Susceptible End - SI')

figResistanceVM=figure
plot(VR,ResistanceFSVM,'k+-')
hold on
plot(VR,ResistanceVM,'ko-')
xlabel('Variant Richness')
ylabel('Resistance - VM')

figResilienceTimeVM=figure;
plot(VR,ResilienceTimeFSVM,'k+-')
hold on
plot(VR,ResilienceTimeVM,'ko-')
xlabel('Variant Richness')
ylabel('Resilience time - VM')

figResilienceVM = figure;
plot(VR,ResilienceFSVM,'k+-')
hold on
plot(VR,ResilienceVM,'ko-')
xlabel('Variant Richness')
ylabel('Resilience - VM')

ResistanceFSSI % resistance SI
PeakTimeFS %peak time
ResTimeFS  %resilience time
ResilienceFS %resilience SIR
ResistanceFS %resistance SIR
NumberInSEndFS%with vm updates
ResistanceFSVM %vm resistance
ResilienceTimeFSVM %vm resilience time
ResilienceFSVM %vm resilience


ResistanceSI % resistance SI
PeakTime %peak time
ResTime  %resilience time
Resilience %resilience SIR
Resistance %resistance SIR
NumberInSEnd%with vm updates
ResistanceVM %vm resistance
ResilienceTimeVM %vm resilience time
ResilienceVM %vm resilience
fileName = [outputDirectory num2str(data.m) 'output.txt']
outFile = fopen(fileName, 'wt');
fprintf(outFile, '%s\n,', 'ResistanceFSSI'); fprintf(outFile, '%f,', ResistanceFSSI); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'PeakTimeFS'); fprintf(outFile, '%f,', PeakTimeFS); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'ResTimeFS'); fprintf(outFile, '%f,', ResTimeFS); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'ResilienceFS'); fprintf(outFile, '%f,', ResilienceFS); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'ResistanceFS'); fprintf(outFile, '%f,', ResistanceFS); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'NumberInSEndFS'); fprintf(outFile, '%f,', NumberInSEndFS); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'ResistanceFSVM'); fprintf(outFile, '%f,', ResistanceFSVM); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'ResilienceTimeFSVM'); fprintf(outFile, '%f,', ResilienceTimeFSVM); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'ResilienceFSVM'); fprintf(outFile, '%f,', ResilienceFSVM); fprintf(outFile, '\n'); %new line

fprintf(outFile, '%s\n,', 'ResistanceSI'); fprintf(outFile, '%f,', ResistanceSI); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'PeakTime'); fprintf(outFile, '%f,', PeakTime); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'ResTime'); fprintf(outFile, '%f,', ResTime); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'Resilience'); fprintf(outFile, '%f,', Resilience); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'Resistance'); fprintf(outFile, '%f,', Resistance); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'NumberInSEnd'); fprintf(outFile, '%f,', NumberInSEnd); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'ResistanceVM'); fprintf(outFile, '%f,', ResistanceVM); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'ResilienceTimeVM'); fprintf(outFile, '%f,', ResilienceTimeVM); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'ResilienceVM'); fprintf(outFile, '%f,', ResilienceVM); fprintf(outFile, '\n'); %new line
fclose(outFile);


saveas(figImean,[outputDirectory 'figImean.fig']);
saveas(figImean,[outputDirectory 'figImean.emf']);
saveas(figIPeak,[outputDirectory 'figIPeak.fig']);
saveas(figIPeak,[outputDirectory 'figIPeak.emf']);
saveas(figResistanceSI,[outputDirectory 'figResistanceSI.fig']);
saveas(figResistanceSI,[outputDirectory 'figResistanceSI.emf']);
saveas(figResilienceTimeSI,[outputDirectory 'figResilienceTimeSI.fig']);
saveas(figResilienceTimeSI,[outputDirectory 'figResilienceTimeSI.emf']);
saveas(figResilienceSIR,[outputDirectory 'figResilienceSIR.fig']);
saveas(figResilienceSIR,[outputDirectory 'figResilienceSIR.emf']);
saveas(figResistenceSIR,[outputDirectory 'figResistenceSIR.fig']);
saveas(figResistenceSIR,[outputDirectory 'figResistenceSIR.emf']);
saveas(figsuceptEndVM,[outputDirectory 'figsuceptEndVM.fig']);
saveas(figsuceptEndVM,[outputDirectory 'figsuceptEndVM.emf']);
saveas(figResistanceVM,[outputDirectory 'figResistanceVM.fig']);
saveas(figResistanceVM,[outputDirectory 'figResistanceVM.emf']);
saveas(figResilienceTimeVM,[outputDirectory 'figResilienceTimeVM.fig']);
saveas(figResilienceTimeVM,[outputDirectory 'figResilienceTimeVM.emf']);
saveas(figResilienceVM,[outputDirectory 'figResilienceVM.fig']);
saveas(figResilienceVM,[outputDirectory 'figResilienceVM.emf']);
close all;
toc
end%411









%dynamic nodes -  1 locus
if doSIRNTests(400) == 1
data.m = 400 %data file number
%1 locus model
%outputDirectory = 'randomGenotypesGraphs\' %BUMBLEBEE
outputDirectory = 'randomGenotypesGraphs\'
tic
modePar.netStr = 're'; %'rwp' random waypoint 're' random encounter
%*************************
%UNUSED PAR FOR RE MODE
%rwp par
modePar.genotypeTimeOutPeriod = 10; %rwp
modePar.xmin     = 1;     % Minimum x-axis location (du)
modePar.xmax     = 31;    % Maximum x-axis location (du)
modePar.ymin     = 1;     % Minimum y-axis location (du)
modePar.ymax     = 31;    % Maximum y-axis location (du)
modePar.smin     = 1.4;  % Minimum speed (du / tu)
modePar.smax     = 1.4;  % Maximum speed (du / tu)
modePar.pmin     = 0;     % Minimum time for pause (integer tu)
modePar.pmax     = 0;     % Maximum time for pause (integer tu)
modePar.dinr     = 3; %7    % Radial distance for in-range (du)
modePar.dexceed  = 1000;  % Value larger than any possible distance (du)
modePar.tinrg    = 1;     % Time in-range for genotype transfer (tu)
modePar.tinrv    = 1;     % Time in-range for virus transfer (tu)
% Mode
% rwph.mode = rwph.MODE_RIR;  1    % Select Random in range mode
% rwph.mode = rwph.MODE_NIR;  2    % Select Nearest in range mode
modePar.moderwp = 1; %MODE_AIR;  % 4    % Select (Random) Available in range mode
%rwp constrain
modePar.xboxc=0.5
modePar.yboxc=0.5
modePar.rwpcontrainplotGraph=0 %draw init constraints graph
% Log vector
modePar.logena = [1 2];
% Log directory for rwp
modePar.logDir = sprintf('%s\\log', pwd);
modePar.statnodesrwp = 'dynamic'; %'dynamic' or 'stationary' nodes, if dynamic box constraints applied at point of virus start
%END UNUSED PAR
%*****************
%data logging of output
data.logDir = sprintf('%s\\outputdata', pwd)
s = sprintf('%s\\data%i.txt', data.logDir,data.m)
data.logOutput(data.m) = fopen(s, 'wt');
%****************************************
modePar.numEncountersBetweenUpdates = 1
modePar.bufferlength = 10 %length of genotype buffer for favscore algorithm
modePar.genoInit = 'mindiv'  %initial conditions of genotypes maxdiv (maximum diversity - random variant chosen) mindiv (minimum diversity - all nodes same)
%blacklist mode
modePar.blklist = 'no'; %yes or no
modePar.numToBlklist = 1
modePar.blklistrate = 0.004; %0.004 %0.001
%vmupdate mode
modePar.vm = 'no' %yes or no

%update mode
modePar.update = 'yes' %stop updating mode
modePar.bufferlengthNei=10 %buffer for buffering local nei diversity,
modePar.stdNeiUpdateThreshold = 0.15
%recovery
recovery = 0; %0.004; 0.0005 %0.001
%*****************************************
%**********************
%constraints
modePar.numToConstrain = 0;%fix(numNodes*1/4); %constain a number of nodes to 1 variant
modePar.areaConstrainrwp='no'
modePar.desirabilities = 'no' %include desirability constraints
modePar.filter = 'yes' %include sw filtering
%**********************
%main par
numRuns = 2 %5 %20 %100 %200
numNodes = 10;

numLoci=4; 
casetype = 'OR';
modePar.virusStartTime = 1200;
numTimestepsVR = [3000]; %[5000]; %7000?
VR = [1];
modePar.blklistStartTime = modePar.virusStartTime
numExploits=1;

mode = 'Dynamic-favScore' %mode - can be 'static' or 'dynamic' 'Dynamic-random' 'Dynamic-favScore'
%monte carlo random genotype SIR model
%set up diversity mode parameters
modePar.modeStr = mode
modePar.stopUpdatingTime = 200000 %time at which to stop updating the genotypes
for j = 1:size(VR,2)%do for all VR
    variantRichness =  VR(j)
    numTimesteps = numTimestepsVR(1);
   
 betan = 0.02;  plotGraphs = 0; gamma = recovery;  throwAway = 'nonEpidemics', SEpidemic=6; %cutoff;
 %agent
 [figMeanNei figNeiOneRun fighistSpRun fighistRecovered fighistSusceptible fighistpeakValue fighistpeakTime fighistBeta fighistGamma fighistBetanew fighistGammanew figInfectedRun1 figBetaRun1 figGammaRun1 figRoRun1 figBetaGamma1 figBetaGamma2...
            meanNeiIndexDynamic betastd gammastd betastd2 betastdNew betastdNew2 gammastdNew peakTimemean peakTimestd peakValuemean peakValuestd...
            betameanmean gammameanmean betameanmean2 betameanmeanNew betameanmeanNew2 gammameanmeanNew Smean Imean Rmean Bmean NSmean Smedian Imedian Rmedian S I R NS SmeanN ImeanN1 RmeanN1 BmeanN1 Snewendmean Snewendstd Rnewendmean Rnewendstd Rnew_nonendmean Rnew_nonendstd propSimsNonEp propSimsNonEp_theoretical...
            numRunsMinor measuredProbMinor numRunsMajor measuredProbMajor meanmdist meannumInfectedVM...
            ] = monteCarloSIRN2(numRuns,numNodes, betan, variantRichness, numTimesteps, plotGraphs,gamma,throwAway,SEpidemic,numExploits,modePar, numLoci, casetype);
   %close all; 
   
    %peak time
    FinalSize = max(Imean,[],2); %mean final size SI
    maska = Imean >= FinalSize-1; %when within 1 of the final value
    [C Index] = max(maska);
    MLa(j) = Index; %T1
    %resistance
    Resistance = (numNodes-FinalSize)./numNodes;
    
        %VM update Resistance
     ResistanceFSVM(j) =(numNodes - meannumInfectedVM)./numNodes; %number infected at least once
     %[val index] = min(Imean(modePar.virusStartTime:end)) %time for infected to die away
     maska = Imean(modePar.virusStartTime:end) >= 1; %time when within 1 of zero
    [C indvm] = min(maska); %get index of first zero
     ResilienceTimeFSVM(j)= indvm-1; %index 1 means timw zero of malware injection so subtract 1
    ResilienceFSVM(j) = 1./(indvm-1);
     
    %with vm updates can get rid of those infected to count ended up in S
    %at end
    NumberInSEndFS(j) = Smean(end);
    %check choose correct location
    figure
    plot(Imean,'r')
    hold on
    plot(indvm,0.5,'k+-')
    plot((indvm-1+modePar.virusStartTime),0.5,'ko-')
   
   
%data logging
 fprintf(data.logOutput(data.m), '%f,', Imean);     % infection
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', meanmdist); %distance spread
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', Index);     %T1
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', Resistance); %resistance
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', FinalSize); %final size
fprintf(data.logOutput(data.m), '\n'); %new line
end %VR
figure
plot(VR,meannumInfectedVM,'ko-')
title('vm update mode number infected')

mode = 'Dynamic-random' %mode - can be 'static' or 'dynamic' 'Dynamic-random' 'Dynamic-favScore'
%monte carlo random genotype SIR model
%set up diversity mode parameters
modePar.modeStr = mode
modePar.stopUpdatingTime = modePar.virusStartTime %time at which to stop updating the genotypes
for j = 1:size(VR,2)%do for all VR
    variantRichness =  VR(j)
    numTimesteps = numTimestepsVR(1);
 betan = 0.02;  plotGraphs = 0; gamma = recovery; throwAway = 'nonEpidemics', SEpidemic=60; %cutoff;
 %agent
 [figMeanNei figNeiOneRun fighistSpRun fighistRecovered fighistSusceptible fighistpeakValue fighistpeakTime fighistBeta fighistGamma fighistBetanew fighistGammanew figInfectedRun1 figBetaRun1 figGammaRun1 figRoRun1 figBetaGamma1 figBetaGamma2...
            meanNeiIndexDynamic betastd gammastd betastd2 betastdNew betastdNew2 gammastdNew peakTimemean peakTimestd peakValuemean peakValuestd...
            betameanmean gammameanmean betameanmean2 betameanmeanNew betameanmeanNew2 gammameanmeanNew Smean Imean Rmean Bmean NSmean Smedian Imedian Rmedian S I R NS SmeanN ImeanN1 RmeanN1 BmeanN1 Snewendmean Snewendstd Rnewendmean Rnewendstd Rnew_nonendmean Rnew_nonendstd propSimsNonEp propSimsNonEp_theoretical...
            numRunsMinor measuredProbMinor numRunsMajor measuredProbMajor meanmdist...
            ] = monteCarloSIRN2(numRuns,numNodes, betan, variantRichness, numTimesteps, plotGraphs,gamma,throwAway,SEpidemic,numExploits,modePar, numLoci, casetype);
   %close all; 
   
    %peak time
    FinalSize = max(Imean,[],2); %mean final size SI
    maska = Imean >= FinalSize-1; %when within 1 of the final value
    [C Index] = max(maska);
    MLa(j) = Index; %T1
    %resistance
    Resistance = (numNodes-FinalSize)./numNodes;
   
%data logging
 fprintf(data.logOutput(data.m), '%f,', Imean);     % infection
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', meanmdist); %distance spread
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', Index);     %T1
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', Resistance); %resistance
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', FinalSize); %final size
fprintf(data.logOutput(data.m), '\n'); %new line
end %VR


end

