%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Jennifer Jackson 2017                                                        %
% A Biodiversity Approach to Cyber Security                                    %
% PhD Complexity Science                                                       %
% University of Warwick                                                        %
% http://wrap.warwick.ac.uk/98458                                              %
% This software is distributed under the  Creative Commons Attribution License %
% https://creativecommons.org/licenses/by/4.0/                                 %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function filetest()
clear all;
close all;


 numNodes = 10;
 
endTimeTxGenotype = [5 1 0 0 5 0 0 0 0 0]
endTimeTxExploit = [15 1 0 0 15 0 0 0 0 0]
timeOutTxGenotype = zeros(numNodes,numNodes);
timeOutPeriod = 50;
TxGenotypeTime = 5;
TxExploitTime = 10;



 endTimeTimeOutTxGenotype =[...
     100     0     0     0     0     0     0     0     0     100;
     0     0     100     0     0     0     0    100     0     0;
     0     0     88     0     0     0     0     100     0     0;
     0     0     0     0     88    88     0     88    88     0;
     0     0     0     0     0     0     0     0     0     0;
     0     88     88     0     0     0     0     0     90     90;
     90     0     0     0     0     90     0     0     0     0;
     0     0     0     0     90     0     0     0     0     90;
    90     90     0     0     0     0     0     0     0     0;
     0     0     0     0     0     0     0     0     0     0]
 
 nodesInRange =[...
     1     0     0     0     0     0     0     0     0     1;
     0     0     1     0     0     0     0    1     0     0;
     0     0     1     0     0     0     0     1     0     0;
     0     0     0     0     0    1     0     1     1     0;
     0     0     0     0     0     0     0     0     0     0;
     0     1     1     0     0     0     0     0     1     1;
     1     0     0     0     0     1     0     0     0     0;
     0     0     0     0     0     0     0     0     0     1;
    1     1     0     0     0     0     0     0     0     0;
     0     0     0     0     0     0     0     0     0     0];

nodesInRangeNumberMMod =[...
     2     0     0     0     0     0     0     0     0     1;
     0     0     5     0     0     0     0    10     0     0;
     0     0     6     0     0     0     0     1     0     0;
     0     0     0     0     0    10     0     2     3     0;
     0     0     0     0     0     0     0     0     0     0;
     0     8     9     0     0     0     0     0     5     6;
     8     0     0     0     0     3     0     0     0     0;
     0     0     0     0     0     0     0     0     0     8;
    10     1     0     0     0     0     0     0     0     0;
     0     0     0     0     0     0     0     0     0     0];


nodesInRangeFlag =[...
     1     1     1     0     0     1     0     1     1     1];

numNodesInRange =[...
     3     2     3     0     0     2     0     3     2     3];
 


sqrDistance =...
  1.0e+003 * [...
    0.0483    0.4854    0.2377    0.1231    0.1636    0.2198 0.7875    0.3937    0.2595    0.0717;
    0.2325    0.3487    0.0258    0.3905    0.4518    0.1825 0.3407    0.0544    0.2514    0.1361;
    0.1797    0.4832    0.0776    1.0014    0.3796    0.1249 0.4329    0.0259    0.5189    0.2035;
    0.2264    0.3109    0.2669    0.3392    0.0079    0.0466 0.7375    0.0184    0.0067    0.4027;
    0.1530    1.0430    0.3517    0.1901    0.2818    0.1530 1.0430    0.3517    0.1901    0.2818;
    0.7375    0.0184    0.0067    0.4027    0.2264    0.3109 0.2669    0.3392    0.0079    0.0466;
    0.0259    0.5189    0.2035    0.1797    0.4832    0.0776 1.0014    0.3796    0.1249    0.4329;
    0.2514    0.1361    0.2325    0.3487    0.0258    0.3905 0.4518    0.1825    0.3407    0.0544;
    0.0717    0.0483    0.4854    0.2377    0.1231    0.1636 0.2198    0.7875    0.3937    0.2595;
         0         0         0         0         0         0 0         0         0         0]

%tag = [0 1 0 0 0 0 0 1 0 0];
%identNewNode = [1 0 1 1 1 1 1 0 1 1]
%taggedNodes = [1 8 3 4 5 6 7 10 9 2];
%maskedTagged = taggedNodes.*tag;

tagState = ones(1,numNodes);
tagState(1) = 3; %3 - tagged & tx genotype
tagState(2) = 2; %4; %4 - tagged & tx exploit
tagState(5) = 2 %2 - tagged
% 1 - not tagged
     
nodesInRangeShift = zeros(numNodes,numNodes);
nodesInRangeNumber = zeros(numNodes,numNodes);
nodesTagged = zeros(numNodes,numNodes); %stored in rhandles
nodesTagged(5,1) = 1;
nodesTagged(8,2) = 1;
nodesTagged(2,5) = 1
t=1
%**********stuff in getNodesInRange function*******************
nodeNumbers = 1:numNodes;
for i = 1: numNodes
nodesInRangeShift(:,i) = circshift(nodesInRange(:,i), [i, 0]); %shift so node number flags are aligned in rows
nodesInRangeNumber(:,i) = nodesInRangeShift(:,i) .* nodeNumbers'; %get the node numbers
end
nodesInRange
nodesInRangeShift
nodesInRangeNumber
sortNodesInRangeNumber = sort(nodesInRangeNumber, 1, 'ascend') %sort nodes in order
%***************************************************************
nodesTagged

%***************key pre-statemachine checks********************************
[newNodeIdentified chosenNodes] = getAvailableNodesInRange(numNodes,nodesTagged,sortNodesInRangeNumber)
%check if tagged still in range
[taggedNodeStillInRange] = checkTaggedInRange(nodesTagged,nodesInRangeShift)
%check if tagged out of range
[taggedNodeOutOfRange] = checkTaggedOutOfRange(nodesTagged,nodesInRangeShift)
%check if taggedNode - endTimeTimeOutTxGenotype is in reset
[taggedNodeTimeOutReset] = checkTimeOutTxGenotype(nodesTagged,endTimeTimeOutTxGenotype)
%check  tagged node has not reached end time of endTimeTimeOutTxGenotype
activeEndTimeTimeOutTxGenotype = checkTimeOutTxGenotypeNotReached(nodesTagged,endTimeTimeOutTxGenotype)

%tagState statemachine
%********************************************************************************
%state 1 not tagged
%**********************************************************************************
%decide who can identify a new node in range
%identNewNode = tagState < 1 %i.e those in state 0
%[newNodeIdentified chosenNodes] = getAvailableNodesInRange(numNodes,nodesTagged,sortNodesInRangeNumber)
%1.check if in state '1 - not tagged' AND new nodes to tag -> change to state '2 - tagged'
%set endtxgenotype and endtxexploit
changeState_NotTaggedToTagged = and((tagState==1),(newNodeIdentified))%mask of nodes to change
nextState_NotTaggedToTagged = changeState_NotTaggedToTagged*2 %2 means state 2
%********************************************************************************
%state 2 tagged
%**********************************************************************************
%check if tagged still in range
%[taggedNodeStillInRange] = checkTaggedInRange(nodesTagged,nodesInRangeShift)
%check if taggedNode - endTimeTimeOutTxGenotype is in reset
%[taggedNodeTimeOutReset] = checkTimeOutTxGenotype(nodesTagged,endTimeTimeOutTxGenotype)
%1. still in range and endTimeTimeOutTxGenotype ==0 and reached endTimeTxgenotype-> change to state 3 - tx genotype
changeState_TaggedToTxGenotype = and(and(and((tagState==2),(taggedNodeStillInRange)),taggedNodeTimeOutReset),endTimeTxGenotype<=t)
nextState_TaggedToTxGenotype = changeState_TaggedToTxGenotype.*3 %3 means state 3
%2.  still in range and NOT reached endTimeTimeOutTxGenotype, but reached endTimeTxexploit-> change to state 4 - tx exploit
%check  if not reached end time
%activeEndTimeTimeOutTxGenotype = checkTimeOutTxGenotypeNotReached(nodesTagged,endTimeTimeOutTxGenotype)
changeState_TaggedToTxExploit = and(and(and((tagState==2),(taggedNodeStillInRange)),activeEndTimeTimeOutTxGenotype),endTimeTxExploit<=t)
nextState_TaggedToTxExploit = changeState_TaggedToTxExploit.*4 %4 means state 4
%3.  -> change to state 1 - tagged node out of range
%[taggedNodeOutOfRange] = checkTaggedOutOfRange(nodesTagged,nodesInRangeShift)
changeState_TaggedToNotTagged = and((tagState==2),(taggedNodeOutOfRange))%mask of nodes to change
releaseTags__TaggedToNotTagged = repmat((changeState_TaggedToNotTagged),[numNodes,1])
nextState_TaggedToNotTagged = changeState_TaggedToNotTagged.*1 %1 means state 1
%********************************************************************************
%state 3 tagged & tx genotype
%**********************************************************************************
%1. still in range and reached endTimeTxExploit-> change to state 4 - txExploit
changeState_TxGenotypeToTxExploit = and(and((tagState==3),(taggedNodeStillInRange)),endTimeTxExploit<=t)
nextState_TxGenotypeToTxExploit = changeState_TxGenotypeToTxExploit.*4 %4 means state 4
%2.  -> change to state 1 - tagged node out of range
changeState_TxGenotypeToNotTagged = and((tagState==3),(taggedNodeOutOfRange))%mask of nodes to change
releaseTags__TxGenotypeToNotTagged = repmat((changeState_TxGenotypeToNotTagged),[numNodes,1])
nextState_TxGenotypeToNotTagged = changeState_TxGenotypeToNotTagged.*1 %1 means state 1
%********************************************************************************
%state 4 tagged & tx exploit
%**********************************************************************************
%1.-> change to state 1 - All change after tx exploit tagged out of range
changeState_TxExploitToNotTagged = (tagState==4)%mask of nodes to change
releaseTags__TxExploitToNotTagged = repmat((changeState_TxExploitToNotTagged),[numNodes,1])
nextState_TxExploitToNotTagged = changeState_TxExploitToNotTagged.*1 %1 means state 1
%*********************************************************************************
%unchanged - rest stay as they are
%*********************************************************************************
NOTchangeState = (changeState_NotTaggedToTagged + changeState_TaggedToTxGenotype + changeState_TaggedToTxExploit + ...
                   changeState_TaggedToNotTagged + changeState_TxGenotypeToTxExploit + changeState_TxGenotypeToNotTagged + ...
                   changeState_TxExploitToNotTagged -1).*(-1);%inv of change state
nextState_NoChange = NOTchangeState.*tagState;
nextStateNumber = nextState_NotTaggedToTagged + nextState_TaggedToTxGenotype + nextState_TaggedToTxExploit + ...
                  + nextState_TaggedToNotTagged + nextState_TxGenotypeToTxExploit + nextState_TxGenotypeToNotTagged + ...
                  nextState_TxExploitToNotTagged + nextState_NoChange
%*********************************************************************************
%Post statemachine set new variables 
%*********************************************************************************
%Add tagging
endTimeTimeOutTxGenotype = setTimeOut(numNodes,t,timeOutPeriod,changeState_TaggedToTxGenotype,nodesTagged,endTimeTimeOutTxGenotype)%NEED TO SET AS RHANDLES
nodesTagged
releaseTags = releaseTags__TaggedToNotTagged + releaseTags__TxGenotypeToNotTagged + releaseTags__TxExploitToNotTagged
tagsToAdd = addTags(numNodes,chosenNodes)%add these ones
tagsToStayTheSame = nodesTagged.*((releaseTags + tagsToAdd )<1) %keep these ones
nodesTagged = tagsToAdd + tagsToStayTheSame
%set endtxgenotype and endtxexploit
endTimeTxGenotype
keepEndTimeTxGenotype = (releaseTags(1,:)<1).*endTimeTxGenotype %keep these ones
addEndTimeTxGenotype = newNodeIdentified.*(t+TxGenotypeTime)%add these ones
endTimeTxGenotype = keepEndTimeTxGenotype + addEndTimeTxGenotype

%set endExploitTime assuming genotype not going to be sent first
endTimeTxExploit
keepEndTimeTxExploit = (releaseTags(1,:)<1).*endTimeTxExploit %keep these ones
AddEndTimeTxExploit = newNodeIdentified.*(t+TxExploitTime)%add these ones
endTimeTxExploit = keepEndTimeTxExploit + AddEndTimeTxExploit
%update endExploitTime if sent genotype first
keepEndTimeTxExploit2 = (changeState_TaggedToTxGenotype < 1).*endTimeTxExploit
AddEndTimeTxExploit2 = changeState_TaggedToTxGenotype.*(t+TxExploitTime)
endTimeTxExploit = keepEndTimeTxExploit2 + AddEndTimeTxExploit2
%check endTimeTimeOutTxGenotype against t and reset if reached
endTimeTimeOutTxGenotype
keepEndTimeTimeOutTxGenotype = endTimeTimeOutTxGenotype>t
endTimeTimeOutTxGenotype = endTimeTimeOutTxGenotype.*keepEndTimeTimeOutTxGenotype
%next state
tagState = nextStateNumber
%*************************************
%Assign outputs
%*************************************
txGenotypeEncounterYes = changeState_TaggedToTxGenotype
encounterNodes = nodesTagged
txExploitEncounterYes = or(changeState_TaggedToTxExploit,changeState_TxGenotypeToTxExploit)
end

function tagsToAdd = addTags(numNodes,chosenNodes)
tagsToAdd = zeros(numNodes,numNodes);
for i = 1:numNodes
    if chosenNodes(i)>0
    tagsToAdd(chosenNodes(i),i)=1;
    end
end
end
function activeEndTimeTimeOutTxGenotype = checkTimeOutTxGenotypeNotReached(nodesTagged,endTimeTimeOutTxGenotype)
%check if not reached end time
match = and(nodesTagged,endTimeTimeOutTxGenotype>0)
activeEndTimeTimeOutTxGenotype = sum(match,1)%sum down columns
end
function timeOutTxGenotype = setTimeOut(numNodes,t,timeOutPeriod,changeState_TaggedToTxGenotype,nodesTagged,timeOutTxGenotypeOld)
changeState_TaggedToTxGenotypeRep = repmat(changeState_TaggedToTxGenotype,[numNodes,1]);
timeOutTxGenotype_temp = changeState_TaggedToTxGenotypeRep .* nodesTagged .* (t+timeOutPeriod);
timeOutTxGenotype = timeOutTxGenotype_temp + timeOutTxGenotypeOld; %put this under rhandles
end
function [taggedNodeStillInRange] = checkTaggedInRange(nodesTagged,nodesInRangeShift)
match = and(nodesTagged,nodesInRangeShift);
taggedNodeStillInRange=sum(match,1);
end
function [taggedNodeOutOfRange] = checkTaggedOutOfRange(nodesTagged,nodesInRangeShift)
match = and(nodesTagged,nodesInRangeShift<1);
taggedNodeOutOfRange=sum(match,1);
end
function[taggedNodeTimeOutReset] = checkTimeOutTxGenotype(nodesTagged,endTimeTimeOutTxGenotype)
match = and(nodesTagged,endTimeTimeOutTxGenotype==0)
taggedNodeTimeOutReset=sum(match,1)
end
function [chosenFlag chosenNodes] = getAvailableNodesInRange(numNodes,nodesTagged,sortNodesInRangeNumber)
%taggedNodesOrdered = zeros(1,numNodes);
chosenNodes = zeros(1,numNodes); %node number chosen to be encountered - nodeEncounter
chosenFlag = zeros(1,numNodes); %flag indicating a node has been chosen - encounterYes
%nodesTagged - numNodes by numNodes matrix, each column is the node, each row
%is what the node sees about other nodes, i.e which node is tagged for
%communicating with
taggedNodesOrdered = sum((nodesTagged >=1),2) %sum across rows to determine which node has been tagged already
%nodesAvailableOrdered = nodesTaggedOrdered <1 %invert to find out which nodes are available
identNewNode = sum((nodesTagged >=1),1) <1 %sum across columns and invert to find out which nodes are trying to identify a node to tag 
            %3.scroll through the nodes in range and select one that is not
            %already tagged, if a node is selected, tag it, to stop others
            %from selecting it at the same time
            for i = 1:numNodes
                if identNewNode(i) ==1 %only do if need to encounter another node
                    num = numNodes;
                    while and(and(sortNodesInRangeNumber(num,i) > 0 ,num > 0),chosenFlag(1,i)==0) %scroll through the nodes in range only
                        if taggedNodesOrdered(sortNodesInRangeNumber(num,i)) == 0;  %select only if not already tagged
                            chosenNodes(1,i) = sortNodesInRangeNumber(num,i);
                            taggedNodesOrdered(sortNodesInRangeNumber(num,i)) = 1;
                            chosenFlag(1,i)=1;
                        end
                        num = num-1;
                    end
                end
            end
            taggedNodesOrderedD=taggedNodesOrdered %testing
end









function notuse()
%*******************************************************************
 taggedNodesOrdered = zeros(1,numNodes); %indicates which nodes are already tx
 for i = 1: numNodes
 if maskedTagged(i) > 0    
 taggedNodesOrdered(maskedTagged(i)) = 1;
 end
 end
 
 taggedNodesOrdered

 
 %and(tag,taggedNodes)
 %taggedNodesOrdered(taggedNodes) = 1
 
  %[sortTaggedV sorttaggedi] = sort(maskedTagged)
  sortMMod = sort(nodesInRangeNumberMMod)
 

   chosenNodes = zeros(1,numNodes);
   chosenFlag = zeros(1,numNodes);
   
   for i = 1:numNodes
       if identNewNode(i) ==1 %only do if need to encounter another node
            num = numNodes
            while and(and(sortMMod(num,i) > 0 ,num > 0),chosenFlag(1,i)==0) %scroll through the nodes in range only
                numD = num
                if taggedNodesOrdered(sortMMod(num,i)) == 0  %select only if not already tagged
                    chosenNodes(1,i) = sortMMod(num,i)
                    taggedNodesOrdered(sortMMod(num,i)) = 1
                    chosenFlag(1,i)=1
                end
                num = num-1;
            end
       end
   end
    
    AllNodesNumber = maskedNodes + chosenNodes
    AllNodesTagged = tag + chosenFlag
    
 %***************************************************************************************************   
       



%node tagging for tx virus over a set time period
%data set up
nodesInRange = ...
    [ 0     0     0     1     0     0     0     1 0 1;
     1     1     0     0     0     1     0     0 0 0;
     0     1     0     0     0     1     0     0 0 0;
     0     0     0     0     0     0     0     0 0 0;
     0     0     0     0     0     0     0     0 0 0;
     0     0     0     0     0     0     0     0 0 0;
     0     0     0     0     1     0     0     0 1 0;
     0     0     1     1     0     0     0     1 0 0;
     1     0     0     0     1     0     0     0 1 0;
     0     0     0     0     0     0     0     0 0 0];
numNodes = 10
txTime = 5 %secs
endTime = 1;
tag = 2;
nodeNumberTagged = 3;
virusTransmitted = 4;

%initialise tagged matrix
nodeTagged = zeros(4,numNodes);
nodeTagged(endTime,1) = 33;
nodeTagged(tag,1) = 1;
for nodeNumber = 1: numNodes
    nodeTagged(nodeNumberTagged,nodeNumber) = nodeNumber;
end
%set pretend tag
nodeTagged(nodeNumberTagged,1) = 3;
nodeTagged(tag,2) = 1;
nodeTagged

for t = 1:1

%************************************
%code
%***********************************
%1.check if node tagged
nodeIsTagged = nodeTagged(tag,:) == 1


%reset tx virus flag
nodeTagged(virusTransmitted,:) = 0;

%convert nodes in range matrix of 1's and 0's into to a matrix containing the actual node(s) number in range 
for nodeNumber = 1: numNodes
for nodeIndex= 1:numNodes
index(nodeIndex,nodeNumber) = (nodesInRange(nodeIndex,nodeNumber)+nodeIndex+nodeNumber-1).*nodesInRange(nodeIndex,nodeNumber);
                if index(nodeIndex,nodeNumber) > numNodes
                    index(nodeIndex,nodeNumber) = rem(index(nodeIndex,nodeNumber),numNodes);
                end
end
end
nodesInRangeNumberM = index %matrix  - column represents the current node, numbers listed in the rows are the node number of the nodes in range

%compare node numbers in matrix against tagged numbers(node tagged to be in range previously)
for nodeNumber = 1: numNodes
    %need and in here somewhere to check if tagged and check end time
match(:,nodeNumber) = (nodesInRangeNumberM(:,nodeNumber) == nodeTagged(nodeNumberTagged,nodeNumber)); %number matches , need and here to and the tag
matchSum(nodeNumber) = sum(match(:,nodeNumber)); %match against number
%if tagged and same node still in range and >= end time, release tag and send virus
option1 = and(nodeTagged(tag,nodeNumber),and(matchSum(nodeNumber),t >= nodeTagged(endTime,nodeNumber)))
if and(nodeTagged(tag,nodeNumber),and(matchSum(nodeNumber),t >= nodeTagged(endTime,nodeNumber)))
    disp('release tag and send virus')
    nodeNumber
    nodeTagged(tag,nodeNumber)
    nodeTagged(tag,nodeNumber) = 0
%elseif tagged and same node NOT still in range, release tag but don't send virus,identify new node in range and tag
option2 = and(nodeTagged(tag,nodeNumber),matchSum(nodeNumber)==0)
elseif and(nodeTagged(tag,nodeNumber),matchSum(nodeNumber)==0)
    disp('release tag, identify a new node in range and tag')
    nodeNumber
    nodeTagged(tag,nodeNumber)
    nodeTagged(tag,nodeNumber) = 0
%elseif not tagged identify new node in range and tag
option3 = nodeTagged(tag,nodeNumber)==0
elseif (nodeTagged(tag,nodeNumber)==0)
    disp('identify a new node in range and tag')
    nodeNumber
else
    disp('keep tag and do nothing')
    nodeNumber
end

end

match
matchSum
%check if already tagged and same node
keepNodeTaggedFlag = and(matchSum(1,:),nodeTagged(tag,:)) %if already tagged and number matched flag to keep node tagged
[num indexmax] = max(match) %get the index of the match
nodeNumberToKeepTaggedIndex = indexmax.*matchSum %get the index of the node number to be tagged
nodeNumberToKeepTagged = zeros(numNodes,1); %get the actual node number to be tagged
for nodeNumber = 1: numNodes
    if nodeNumberToKeepTaggedIndex(nodeNumber)> 0
        nodeNumberToKeepTagged(nodeNumber) = nodesInRangeNumberM(nodeNumberToKeepTaggedIndex(nodeNumber),nodeNumber);
    end
end

nodeNumberToKeepTagged




end % t loop






return





directorynameSettings = GUIClass.getDirectoryNameSettings();
settingsTempFileNames = GUIClass.genSettingsTempFileNames(directorynameSettings,1);
%names of outputs temp files
directorynameOut = 'outputs\test\filetest.bin';

nodesDiversityBefore = ones(2,5,8)
%outputs.nodesDiversity4 = zeros(2,10,201);
sizenodesDiversity4 = size(nodesDiversityBefore)

fidtemp = fopen(directorynameOut, 'w')
fwrite(fidtemp,nodesDiversityBefore,'double');
fclose(fidtemp);  


fidtemp = fopen(directorynameOut, 'r')
%fread only works on a 2 dimensional array
c = fread(fidtemp, 2*5*8, '*double');
nodesDiversityAfter = reshape(c,[2 5 8])



%outputs.nodesDiversity4 = fread(fidtemp,[10,201],'double');
%outputs.nodesDiversity4 = fread(fidtemp,[2,10,201],'double');
fclose(fidtemp);


sizenodesDiversity4 = size(nodesDiversityAfter)
end