%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Jennifer Jackson 2017                                                        %
% A Biodiversity Approach to Cyber Security                                    %
% PhD Complexity Science                                                       %
% University of Warwick                                                        %
% http://wrap.warwick.ac.uk/98458                                              %
% This software is distributed under the  Creative Commons Attribution License %
% https://creativecommons.org/licenses/by/4.0/                                 %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
classdef inputHandles < handle
    %Handles for inputs so can modify call by reference
    properties
        %main handle properties
        numNodes = '';
        editSaveParameters = ''; %22 run file parameters that can be saved, look at GUIClass.getTempRunFileNames for parameter names added 3rd May 2016
        %*******************
        %Dataset properties
        %*******************
        numLoci = 4; %added 30th March 2016
        dataSet = '';
        alignData = '';
        SW_str_apps = '';
        SW_str_serv = '';
        SW_str_os = '';
        SW_str_dr = '';
        SW_freq_apps = '';
        SW_freq_serv = '';
        SW_freq_os  = '';
        SW_freq_dr = '';
        CSW1 = '';
        CSW2 = '';
        CSW3 = '';
        CSW4 = '';
        CSW5 = '';
        CSW6 = '';
        CSW7 = '';
        CSW8 = '';
        CSW9 = '';
        CSW10 = '';
        CSWGroup = '';
        Genotype_apps = '';
        Genotype_serv = '';
        Genotype_os = '';
        Genotype_dr = '';
        E_apps  = '';
        E_serv = '';
        E_os  = '';
        E_dr = '';
        E_apps2 = '';
        E_serv2 = '';
        E_os2 = '';
        E_dr2 = '';
        CD_apps = '';
        CD_serv = '';
        CD_os = '';
        CD_dr = '';
        CD_apps2 = '';
        CD_serv2 = '';
        CD_os2 = '';
        CD_dr2 = '';
        ID_apps = '';
        ID_serv = '';
        ID_os = '';
        ID_dr = '';
        ID_apps2 = '';
        ID_serv2 = '';
        ID_os2 = '';
        ID_dr2 = '';
        IDtimeArray1 = '';
        IDtimeArray2 = '';
        textdata = '';
        Genotype = '';
        E = '';
        E2 = '';
        CD = '';
        CD2 = '';
        ID = '';
        ID2 = '';
        len_apps = '';
        len_serv = '';
        len_os  = '';
        len_dr  = '';
        len_sw = '';
        SizeCD_apps = '';
        SizeCD_serv = '';
        SizeCD_os = '';
        SizeCD_dr = '';
        tallyLength = '';
        numOS = '';
        CDSize = '';
        divWeights = '';
        divWeightsE ='';
        comWeights = '';
        comWeightsE = '';
        indWeights = '';
        indWeightsE = '';
        qualWeights = '';
        qualWeightsE = '';
        comDes = '';
        comDesE = '';
        indDes = '';
        indDesE ='';
        qualDes ='';
        qualDesE ='';
        CSWGrouprep = '';
        probabilityDistr = ''; %either fixed or called from wireless bluetooth model
        %************************************
        %enable properties from main window
        %***********************************
        datasetEnable ='';
        datasetNumber ='';
        datasetStaticEnable =''; %added 31st March 2016
        datasetStaticNumber =''; %added 31st March 2016
        networkModelEnable =''; 
        networkModelS ='';
        networkModelV ='';
        attackModelEnable ='';
        attackModelS ='';
        attackModelV ='';
        exploitEnable='';
        exploitTypeS='';
        exploitTypeV='';
        algModelEnable ='';
        algModelS ='';
        algModelV ='';
        networkPerfEnable ='';
        perfModelS ='';
        perfModelV ='';
        %****************************
        %wirelessBluetoothParameters
        %*****************************
        density = '';
        avVelocity = '';
        TxRadius = '';
        Tvirus = '';
        %*****************************************
        %Random waypoint model inputs
        %*****************************************
        s_input = struct('V_POSITION_X_INTERVAL',... %[10 300],...%(m)
                 'V_POSITION_Y_INTERVAL',... %[10 300],...%(m)
                 'V_SPEED_INTERVAL',... %[0.2 2.2],...%(m/s)
                 'V_PAUSE_INTERVAL',... %[0 1],...%pause time (s)
                 'V_WALK_INTERVAL',... %[2.00 6.00],...%walk time (s)
                 'V_DIRECTION_INTERVAL',... %[-180 180],...%(degrees)
                 'SIMULATION_TIME',...%(s)
                 'NB_NODES');
        %precomputed x and y positions
        PlotWayPoints = '';
        vs_node = struct('v_x','v_y');
        RWPrange = ''; %4; %range of node in metres
        RWPmode = ''; %string %2; %1.nearest in range %2.random chosen in range %3.Available in range %4.Available in range with a virus tx time
        %*****************************
        % Attack Model SI parameters
        %*****************************
        %no parameters
        %*****************************
        % Attack Model SIR parameters
        %*****************************
        SIRrecovProb = '';
        SIRrecovTime = ''; %start time of recovery
        %*****************************
        % Attack Model SEIR parameters
        %*****************************
        SEIRrecovProb = '';
        %*****************************
        % Attack Model SEPTICOX parameters
        %*****************************
        DevicesOffline = '';
        Pos1 = '';
        Pos2 = '';
        Pso1 = '';
        Pso2 = '';
        Pex = '';
        Pxe = '';
        Pto1 = '';
        Pto2 = '';
        Psp = '';
        Pet = '';
        Pit = '';
        Pts = '';
        Ptp = '';
        Pic = '';
        Pci = '';
        UsePeriodic = '';
        PlotPeriod = '';
        FreqOn = '';
        PeakOn = '';
        SpreadOn = '';
        AmpOn = '';
        FreqOff = '';
        PeakOff = '';
        SpreadOff = '';
        AmpOff = '';
        %*****************************
        % Edit Exploit
        %*****************************
        exploitApp ='';
        exploitServ ='';
        exploitOS ='';
        exploitDr ='';
        exploitRoute = '';
        malwareType=''; %added 5th Jan 2017 1 AND or 0 OR
        virusType ='';
        Pei1 =''; %prob of user download
        Pei2 =''; %virus latency time
        latUnits ='';
        infectionTime ='';
        infectTimeUnits ='';
        timeToTxVirus = '';
        timeToTxVirusUnits = '';
        timeToTxGenotype = '';
        timeToTxGenotypeUnits = '';
        timeOutPeriodTxGenotype = '';
        timeOutPeriodTxGenotypeUnits = '';
        numInitialInfected ='';
        %********************
        %Fav Score algorithm
        %********************
        %Fixed
        singleStopMode = 4;
        restartMode = 5;
        maxStdTolerance = 0.1; %for single stop mode only
        stdMargin = 0.01 %for mode 6 multiple restart
        ChangeOwnIndDesirabilitiesFlag = 0 %to enable
        wdivUpdateTime1=0;
        wdivUpdateValue1=0;
        wdivUpdateTime2=0;
        wdivUpdateValue2=0;
        wdivUpdateTime3=0;
        wdivUpdateValue3=0;
        %flag for ownInd to turn on and off
        WidUpdateTime1=0; %1
        WidUpdateValue1=0; %0
        WidUpdateTime2=0; %1000
        WidUpdateValue2=0; %1
        tolerance = 0.2; %tolerance for choosing random maximum out of a possible many choices for solution 1 and 2
        %Variable
        turnOnSol1 = '';
        turnOnSol2 = '';
        turnOnSol3 = '';
        turnOnSol4 = '';
        turnOnSol5 = '';
        numSims = '';
        numRunsPerSim = '';
        numTimeSteps = '';
        minEncounters = '';
        maxEncounters = '';
        distStr = '';
        minstd4Tolerance = '';
        maxstd4Tolerance  = '';
        minstd5Tolerance  = '';
        maxstd5Tolerance  = '';
        sampleSize = '';
        restartUpdateTest = '';
        stopUpdate4  = '';
        restartUpdate4 = '';
        stopUpdate5  = '';
        restartUpdate5 = '';
        ChangeDesirabilitiesFlag = '';
        tChange1Enable = '';
        tChange1  = '';
        tChange2Enable = '';
        tChange2 = '';
        ChangeIndDesirabilitiesFlag = '';
        tChangeInd1Enable = '';
        tChangeInd1 = '';
        tChangeInd2Enable = '';
        tChangeInd2 = '';
        ChangeEffFlag = '';
        tChangeEff1Enable = '';
        tChangeEff1 = '';
        tChangeEff2Enable = '';
        tChangeEff2 = '';
        We = '';
        Wcd = '';
        Wid = '';
        wdiv = '';

    end
    
    methods
        function iH = inputHandles()
            %initialise / constructor function
        end     
     
    end
    
end

