%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Jennifer Jackson 2017                                                        %
% A Biodiversity Approach to Cyber Security                                    %
% PhD Complexity Science                                                       %
% University of Warwick                                                        %
% http://wrap.warwick.ac.uk/98458                                              %
% This software is distributed under the  Creative Commons Attribution License %
% https://creativecommons.org/licenses/by/4.0/                                 %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function [ output_args ] = testRandomGenotypesMore( )
clear all;
%*************************************
% TESTING AGENT BASED STOCHASIC MODELS
%*************************************
outputDirectory = 'Graphs\'
close all;

%new parameters
modePar.blklistStartTime = 1
%vmupdate mode
modePar.vm = 'no' %yes or no
modePar.desirabilities = 'no' %include desirability constraints
modePar.filter = 'no' %include sw filtering

doSIRNTests = zeros(1,30) %tests with genotypes
%mode - can be 'static' or 'dynamic' 'Dynamic-random' 'Dynamic-favScore'

%***************
% SIRN TESTS - with genotypes
%**************
%doSIRNTests(1) = 1 %combine results into single graph
%doSIRNTests(14) = 1 %SIR OR CASE Increase variants upto 30, fix exploit 1 - 4 loci
%doSIRNTests(15) = 1 %SIR AND CASE Increase variants upto 8, fix exploit 1 to 3 - 4 loci
%not used - code needs updating%doSIRNTests(16) = 1 %SIR OR CASE Increase variants upto 50, fix exploit 2 - 4 loci
%not used - code needs updating%doSIRNTests(17) = 1 %SIR OR CASE Increase variants upto 70, fix exploit 3 - 4 loci
%not used - code needs updating%doSIRNTests(18) = 1 %SIR OR CASE Increase variants 18 to 20, fix exploit 1 - 4 loci, network size match to needed number of genotypes for each change in the number of variants, look at resistance output only, dont compare resilience
%doSIRNTests(19) = 1 %SIR 1 locus model Increase variants upto 10, fix exploit 1
%dynamic tests
%doSIRNTests(20) = 1 %SIR AND CASE dynamic
%doSIRNTests(21) = 1 %SIR 1 locus dynamic
%doSIRNTests(22) = 1 %SIR OR CASE dynamic
%doSIRNTests(23) = 1 %Diversity time test - 1 locus VR 5 time of reaching maximum diversity for dynamic diversity algorithms
%doSIRNTests(24) = 1%Dynamic Diversity reaching highest diversity level
%doSIRNTests(25) = 1%Dynamic Diversity reaching highest diversity level under constraints
%doSIRNTests(26) = 1%Dynamic Diversity reaching highest diversity level-vary the number of devices

doSIRNTests(27) = 1 %SIR 1 locus dynamic - light version using monteCarloSIRN3
% SIRN TEST 1
% SIR - combine data from tests below onto single graphs
%***************
if doSIRNTests(1) == 1
%outputDirectory = 'Graphs\' 
outputDirectory = 'Graphs\'
end

% SIRN TEST 14
% SIR - 4 loci OR fix exploit at 1 and increase variants - takes 8 hours
%***************
if doSIRNTests(14) == 1
%outputDirectory = 'Graphs\' 
outputDirectory = 'Graphs\'
%Increase variants upto 25, fix exploit
%***************************************
%SIRN testing
%***************************************
%Deterministic - 4 loci OR
tic
numNodes = 1000;
VRmin = 1 %1
VRmax = 30 %30
N=numNodes; Vmax = 1:VRmax;  G = Vmax.^2; %number genotypes
%for OR case
Sprop = SPExact4LociOR( 1, Vmax )
mode = 'static'
%monte carlo random genotype SIR model
numRuns = 100 %100 %200

%set up diversity mode parameters
modePar.modeStr = mode
modePar.numToConstrain = 0 %constain a number of nodes to 1 variant
modePar.stopUpdatingTime = 20000 %time at which to stop updating the genotypes
%modePar.numEncountersBetweenUpdates = 1 % number of encounters between updates for random and favscore algorithms
modePar.bufferlength = 10 %length of genotype buffer for favscore algorithm
modePar.genoInit = 'maxdiv'  %initial conditions of genotypes maxdiv (maximum diversity - random variant chosen) mindiv (minimum diversity - all nodes same)


for z= VRmin:VRmax
 betan = 0.02; variantRichness =  z;  numTimesteps = 7000; plotGraphs = 0; gamma = 0.004; numExploits=1; numLoci=4; casetype = 'OR'; throwAway = 'nonEpidemics', cutoff = gamma.*numNodes./(betan.*Sprop); SEpidemic=50; %cutoff;
%agent
 [figMeanNei(z) figNeiOneRun(z) fighistSpRun(z) fighistRecovered(z) fighistSusceptible(z) fighistpeakValue(z) fighistpeakTime(z) fighistBeta(z) fighistGamma(z) fighistBetanew(z) fighistGammanew(z) figInfectedRun1 figBetaRun1 figGammaRun1 figRoRun1 figBetaGamma1 figBetaGamma2...
            meanNeiIndexDynamicF  betastd gammastd betastd2 betastdNew betastdNew2 gammastdNew peakTimemean peakTimestd peakValuemean peakValuestd...
            betameanmean(z) gammameanmean betameanmean2(z) betameanmeanNew(z) betameanmeanNew2 gammameanmeanNew(z) Smean(z,:) Imean(z,:) Rmean(z,:) Bmean(z,:) NSmean(z,:) Smedian Imedian Rmedian S I R NS SmeanN ImeanN1(z,:) RmeanN1 Snewendmean Snewendstd Rnewendmean(z) Rnewendstd(z) Rnew_nonendmean Rnew_nonendstd propSimsNonEp(z) propSimsNonEp_theoretical(z)...
            numRunsMinor(z) measuredProbMinor(z) numRunsMajor(z) measuredProbMajor(z) ...
            ] = monteCarloSIRN2(numRuns,numNodes, betan, variantRichness, numTimesteps, plotGraphs,gamma,throwAway,SEpidemic,numExploits,modePar, numLoci, casetype);
   size(ImeanN1)
FinalSize(z) = max(RmeanN1,[],2) %mean final size
    %resilience of major only
     maska = RmeanN1 >= FinalSize(z)-1; %when within 1 of the final value
    [C Index] = max(maska);
    MLa(z) = Index; %T1
    RmeanN1;
    size(RmeanN1)
    size(Index)
        %resilience of all
     maska = Rmean(z,:) >= FinalSize(z)-1; %when within 1 of the final value
    [C Index] = max(maska);
        size(Rmean(z,:))
    size(Index)
    MLa_all(z) = Index; %T1
         saveas(fighistSpRun(z),[outputDirectory 'Test14fighistSpRun' num2str(z) '.fig']);
    saveas(fighistSpRun(z),[outputDirectory 'Test14fighistSpRun' num2str(z) '.emf']);
        saveas(fighistRecovered(z),[outputDirectory 'Test14fighistRecovered' num2str(z) '.fig']);
    saveas(fighistRecovered(z),[outputDirectory 'Test14fighistRecovered' num2str(z) '.emf']);
    saveas(fighistSusceptible(z),[outputDirectory 'Test14fighistSusceptible' num2str(z) '.fig']);
    saveas(fighistSusceptible(z),[outputDirectory 'Test14fighistSusceptible' num2str(z) '.emf']);
    saveas(fighistpeakValue(z),[outputDirectory 'Test14fighistpeakValue' num2str(z) '.fig']);
    saveas(fighistpeakValue(z),[outputDirectory 'Test14fighistpeakValue' num2str(z) '.emf']);
    saveas(fighistpeakTime(z),[outputDirectory 'Test14fighistpeakTime' num2str(z) '.fig']);
    saveas(fighistpeakTime(z),[outputDirectory 'Test14fighistpeakTime' num2str(z) '.emf']);
    saveas(fighistBeta(z),[outputDirectory 'Test14histBeta' num2str(z) '.fig']);
    saveas(fighistBeta(z),[outputDirectory 'Test14histBeta' num2str(z) '.emf']);
    saveas(fighistGamma(z),[outputDirectory 'Test14histGamma' num2str(z) '.fig']);
    saveas(fighistGamma(z),[outputDirectory 'Test14histGamma' num2str(z) '.emf']);
    saveas(fighistBetanew(z),[outputDirectory 'Test14histBetaNew' num2str(z) '.fig']);
    saveas(fighistBetanew(z),[outputDirectory 'Test14histBetaNew' num2str(z) '.emf']);
    saveas(fighistGammanew(z),[outputDirectory 'Test14histGammaNew' num2str(z) '.fig']);
    saveas(fighistGammanew(z),[outputDirectory 'Test14histGammaNew' num2str(z) '.emf']);
    close(fighistRecovered(z));
    close(fighistSusceptible(z));
    close(fighistpeakValue(z));
    close(fighistpeakTime(z));
    close(fighistBeta(z));
    close(fighistGamma(z));
    close(fighistBetanew(z));
    close(fighistGammanew(z));
    
    %stochastic
        dtt=0.1 %stochastic dtt = used in graph and set in function
    timeS = dtt:dtt:numTimesteps;%stochastic time for graphs
    [SfighistRecovered(z) SfighistSusceptible(z) SfighistpeakValue(z) SfighistpeakTime(z) SfighistBeta(z) SfighistGamma(z) SfighistBetanew(z) SfighistGammanew(z) SfigInfectedRun1 SfigBetaRun1 SfigGammaRun1 SfigRoRun1 SfigBetaGamma1 SfigBetaGamma2...
            Sbetastd Sgammastd Sbetastd2 SbetastdNew SbetastdNew2 SgammastdNew SpeakTimemean SpeakTimestd SpeakValuemean SpeakValuestd...
            Sbetameanmean(z) Sgammameanmean Sbetameanmean2(z) SbetameanmeanNew(z) SbetameanmeanNew2 SgammameanmeanNew(z) SSmean(z,:) SImean(z,:) SRmean(z,:) SNSmean(z,:) SSmedian SImedian SRmedian SS SI SR SNS SSmeanN SImeanN1(z,:) SRmeanN1 SSnewendmean SSnewendstd SRnewendmean(z) SRnewendstd(z) SRnew_nonendmean SRnew_nonendstd SpropSimsNonEp(z) SpropSimsNonEp_theoretical(z)...
            SnumRunsMinor(z) SmeasuredProbMinor(z) SnumRunsMajor(z) SmeasuredProbMajor(z) ...
            ] = monteCarloStochastic(numRuns,numNodes, betan, variantRichness, numTimesteps, plotGraphs,gamma,throwAway,SEpidemic,numExploits,mode, numLoci, casetype);
     size(SImeanN1)
SFinalSize(z) = max(SRmeanN1,[],2) %mean final size
    %resilience of major only
     Smaska = SRmeanN1 >= SFinalSize(z)-1; %when within 1 of the final value
    [SC SIndex] = max(Smaska);
    SMLa(z) = ceil(SIndex.*dtt); %T1
        %resilience of all
     Smaska = SRmean(z,:) >= SFinalSize(z)-1; %when within 1 of the final value
    [SC SIndex] = max(Smaska);
    SMLa_all(z) = ceil(SIndex.*dtt); %T1
        saveas(SfighistRecovered(z),[outputDirectory 'Test14StochfighistRecovered' num2str(z) '.fig']);
    saveas(SfighistRecovered(z),[outputDirectory 'Test14StochfighistRecovered' num2str(z) '.emf']);
    saveas(SfighistSusceptible(z),[outputDirectory 'Test14StochfighistSusceptible' num2str(z) '.fig']);
    saveas(SfighistSusceptible(z),[outputDirectory 'Test14StochfighistSusceptible' num2str(z) '.emf']);
    saveas(SfighistpeakValue(z),[outputDirectory 'Test14StochfighistpeakValue' num2str(z) '.fig']);
    saveas(SfighistpeakValue(z),[outputDirectory 'Test14StochfighistpeakValue' num2str(z) '.emf']);
    saveas(SfighistpeakTime(z),[outputDirectory 'Test14StochfighistpeakTime' num2str(z) '.fig']);
    saveas(SfighistpeakTime(z),[outputDirectory 'Test14StochfighistpeakTime' num2str(z) '.emf']);
    saveas(SfighistBeta(z),[outputDirectory 'Test14StochhistBeta' num2str(z) '.fig']);
    saveas(SfighistBeta(z),[outputDirectory 'Test14StochhistBeta' num2str(z) '.emf']);
    saveas(SfighistGamma(z),[outputDirectory 'Test14StochhistGamma' num2str(z) '.fig']);
    saveas(SfighistGamma(z),[outputDirectory 'Test14StochhistGamma' num2str(z) '.emf']);
    saveas(SfighistBetanew(z),[outputDirectory 'Test14StochhistBetaNew' num2str(z) '.fig']);
    saveas(SfighistBetanew(z),[outputDirectory 'Test14StochhistBetaNew' num2str(z) '.emf']);
    saveas(SfighistGammanew(z),[outputDirectory 'Test14StochhistGammaNew' num2str(z) '.fig']);
    saveas(SfighistGammanew(z),[outputDirectory 'Test14StochhistGammaNew' num2str(z) '.emf']);
    close(SfighistRecovered(z));
    close(SfighistSusceptible(z));
    close(SfighistpeakValue(z));
    close(SfighistpeakTime(z));
    close(SfighistBeta(z));
    close(SfighistGamma(z));
    close(SfighistBetanew(z));
    close(SfighistGammanew(z));
    text = ['done ' num2str(z) ' out of ' num2str(VRmax)];
    disp(text)
end    
    
%Deterministic - 4 loci OR
N=numNodes; Vmax = 1:VRmax;  G = Vmax.^2; %number genotypes
%for OR case
Sprop = SPExact4LociOR( 1, Vmax )
%Sprop = 2./Vmax - 1./G %both loci have the same number of variants and both have 1 exploit
S = N.*Sprop; B = 0.02; beta = B.*Sprop; gamma = 0.004; %1/48*60*60 %2 days
for i = VRmin:VRmax
    [Ro(i) St(i,:) It(i,:) Rt(i,:)] = SIRDeterministic(beta(i), gamma, S(i), 1, 0, numTimesteps, 0); 
    FinalSized(i) = Rt(i,end);
     
    %resilience
     maskd = Rt(i,:) >= Rt(i,end)-1; %when within 1 of the final value
    [C Index] = max(maskd);
    MLd(i) = Index; %T1
end

dec = 50; t2 = 1:dec:numTimesteps;

%stochastic final size approximation
[ FinalSizeS stdS ] = finalSizeApprox( Sprop, betan, gamma, VRmin, VRmax, numNodes)

 
 figTest9inf0_02 = figure
 for i = VRmin:VRmax
     plot(Imean(i,:),'k')
     hold on
     plot(t2,It(i,1:dec:end),'k.-')
      plot(timeS,SImean(i,:),'k--')
 end
 ylabel('Number of nodes infected - It')
 xlabel('Timesteps')
 title('a) SI-Increasing variants: Nodes infected')
 legend('Agent', 'Deterministic', 'Stochastic')
 %axis([0 1000 0 400])
 
  figmajor = figure
 for i = VRmin:VRmax
     plot(ImeanN1(1,:),'k')
     hold on
     plot(t2,It(i,1:dec:end),'k.-')
     plot(timeS,SImeanN1(i,:),'k--')
     plot(ImeanN1(i,:),'k')
 end
xlabel('Timesteps')
ylabel('Number of individuals infected I(t)')
title('Mean of major outbreaks')
 legend('Agent', 'Deterministic', 'Stochastic')
%axis([0 100 0 90])
 
 
  %number of nodes infected
 figTest2FinalInfected = figure
 %agentImax = max(Imean,[],2);
 %plot(agentImax,'k')
 for j = VRmin:VRmax
 if isnan(FinalSizeS(j)); h(j) = 0; else h(j) = FinalSizeS(j); end;
 if isnan(FinalSize(j)); q(j) = 0; else q(j) = FinalSize(j); end;
  if isnan(SFinalSize(j)); v(j) = 0; else v(j) = SFinalSize(j); end;
 end
 FinalSize=q
 FinalSizeS=h
 SFinalSize=v
 plot(FinalSize,'ko-')
 hold on
 %plot(S,'k.-')
 plot(FinalSized,'k.-')
  plot(SFinalSize,'k+-')
 plot(FinalSizeS,'ks-')
plot([18.615 18.615],[0 1],'k--')
 ylabel('Final number infected')
 xlabel('Number of variants')
 title('c) SI-Increasing variants: Final size')
 legend('Agent', 'Deterministic', 'Stochastic measured','Stochastic Approximation')
 
  %number of nodes infected
 figTest2Finalstd = figure
 %agentImax = max(Imean,[],2);
 %plot(agentImax,'k')
 for j = VRmin:VRmax
 if isnan(Rnewendstd(j)); a(j) = 0; else a(j) = Rnewendstd(j); end;
 if isnan(SRnewendstd(j)); b(j) = 0; else b(j) = SRnewendstd(j); end;
  if isnan(stdS(j)); c(j) = 0; else c(j) = stdS(j); end;
 end
 SRnewendstd=a
 Rnewendstd=b
 stdS = c
 plot(Rnewendstd,'ko-') %agent measured
 hold on
 %plot(S,'k.-')
 plot(SRnewendstd,'ks-') %stochastic measured
 plot(stdS,'k+-') % calc approx
plot([18.615 18.615],[0 1],'k--')
 ylabel('Standard deviation')
 xlabel('Number of variants')
 title('c) SI-Increasing variants: Final size std')
 legend('Agent measured', 'Stochastic measured', 'Stochastic Approximation')
 
  %RESISTANCE
 figTest2Resistance = figure
 plot(1-FinalSize./N,'ko-')
 hold on
 %plot(S,'k.-')
 plot(1-FinalSized./N,'k.-')
 plot(1-SFinalSize./N,'ks-')
  plot(1-FinalSizeS./N,'k+-')
plot([18.615 18.615],[0 1],'k--')
 ylabel('Resistance M_R')
 xlabel('Variant Richness')
 title('c) SI-Increasing variants: Resistance')
 legend('Agent (measured)', ' Deterministic (measured) ', 'Stochastic (measured) ','Stochastic (approximated)')
 
 %RESILIENCE major outbreaks only
 figTest2Resilience = figure
  plot(1./MLa,'ko-') %agent measured
 hold on
 plot(1./MLd,'k.-') %deterministic
  plot(1./SMLa,'ks-') %stochastic measured
 hold on
  ylabel('Resilience M_L')
 xlabel('Variant Richness')
 title('c) SI-Increasing variants: Resilience major')
 legend('Agent (measured)', 'Deterministic (measured)', 'Stochastic (measured)')
 plot([18.615 18.615],[0 1],'k--')
 
  %RESILIENCE TIME of major outbreaks only
 figTest2ResilienceTime = figure
  plot(MLa,'ko-') %agent measured
 hold on
 plot(MLd,'k.-') %deterministic
  plot(SMLa,'ks-') %stochastic measured
 hold on
  ylabel('Resilience Time')
 xlabel('Variant Richness')
 title('c) SI-Increasing variants: Resilience Time major')
 legend('Agent (measured)', 'Deterministic (measured)', 'Stochastic (measured)')
  plot([1.8533 1.8533],[0 1],'k--')
   %axis([1 8 0 1.1])

 
saveas(figTest9inf0_02,[outputDirectory 'Test14meanall.fig']);
saveas(figTest9inf0_02,[outputDirectory 'Test14meanall.emf']); 
saveas(figmajor,[outputDirectory 'Test14meanmajor.fig']);
saveas(figmajor,[outputDirectory 'Test14meanmajor.emf']);
saveas(figTest2FinalInfected,[outputDirectory 'Test14FinalInfected.fig']);
saveas(figTest2FinalInfected,[outputDirectory 'Test14FinalInfected.emf']);
saveas(figTest2Finalstd,[outputDirectory 'Test14Finalstd.fig']);
saveas(figTest2Finalstd,[outputDirectory 'Test14Finalstd.emf']);
saveas(figTest2Resistance,[outputDirectory 'Test14Resistance.fig']);
saveas(figTest2Resistance,[outputDirectory 'Test14Resistance.emf']);
saveas(figTest2Resilience,[outputDirectory 'Test14Resilience.fig']);
saveas(figTest2Resilience,[outputDirectory 'Test14Resilience.emf']);
saveas(figTest2ResilienceTime,[outputDirectory 'Test14ResilienceTime.fig']);
saveas(figTest2ResilienceTime,[outputDirectory 'Test14ResilienceTime.emf']);
%close all


betameanmean
gammameanmean

betameanmean2
betameanmeanNew 
betameanmeanNew2
gammameanmeanNew

Rnewendmean%epidemics only
Rnewendstd

 propSimsNonEp % proportion of sims with non-epidemics
 propSimsNonEp_theoretical %theoretical value
    
R = betameanmean./gammameanmean
RN = betameanmeanNew./gammameanmeanNew
SRN = SbetameanmeanNew./SgammameanmeanNew
RTheoretical = beta./gamma

figro = figure
%plot(beta,R,'k')
hold on
plot(RN,'ko-')
plot(RTheoretical,'k.-')
plot(RN,'ks-') %stochastic measured
plot([1 1 1 1 1 1 1 1],'k--')
plot([18.615 18.615],[0 1],'k--')
xlabel('Number of variants')
ylabel('ro')
%legend('R','RNew','Rtheoretical') 
legend('Ro Agent(measured)','Ro Deterministic','Ro Stochastic(measured)') 
%axis([0.1 0.5 0 2])
saveas(figro,[outputDirectory 'Test14figro.fig']);
saveas(figro,[outputDirectory 'Test14figro.emf']);
%close all
%close all;

%calculate proportion of minor and major outbreaks
[ minorCalc majorCalc ] = propCalcOutbreaks( Sprop, B, gamma )
%measure proportion of minor and major outbreaks
%agent
%numRunsMinor measuredProbMinor numRunsMajor measuredProbMajor
numRunsMinor
numRunsMajor
measuredProbMinor
measuredProbMajor
%stochastic
%SnumRunsMinor SmeasuredProbMinor SnumRunsMajor SmeasuredProbMajor
SnumRunsMinor
SnumRunsMajor
SmeasuredProbMinor
SmeasuredProbMajor

figMinorProb = figure;
plot(measuredProbMinor,'ko-') %agent
hold on
plot(SmeasuredProbMinor,'ks-') %stochastic
plot(minorCalc,'k+-') %stoch approx
xlabel('Variant Richness')
ylabel('Proportion of minor outbreaks')
%legend('R','RNew','Rtheoretical') 
plot([18.615 18.615],[0 0.9],'k--')
legend('Agent (measured)','Stochastic (measured)', 'Stochastic (approximated)')
title('probability of minor outbreak')

figMajorProb = figure;
plot(measuredProbMajor,'ko-') %agent
hold on
plot(SmeasuredProbMajor,'ks-') %stochastic
plot(majorCalc,'k+-') %stoch approx
xlabel('Variant Richness')
ylabel('Proportion of major outbreaks')
%legend('R','RNew','Rtheoretical') 
legend('Agent (measured)','Stochastic (measured)', 'Stochastic (approximated)')
plot([18.615 18.615],[0 0.9],'k--')
title('probability of major outbreak')

saveas(figMinorProb,[outputDirectory 'Test14_1EXPfigMinorProb.fig']);
saveas(figMinorProb,[outputDirectory 'Test14_1EXPfigMinorProb.emf']);
saveas(figMajorProb,[outputDirectory 'Test14_1EXPfigMajorProb.fig']);
saveas(figMajorProb,[outputDirectory 'Test14_1EXPfigMajorProb.emf']);


toc
   %SAVE FOR LATER
   N %number of nodes
   FinalSize %measured agent
   FinalSized %deterministic
   FinalSizeS %stoch approx
   SFinalSize %stoch measured
Resistancea_1EXP=1-FinalSize./N
Resistanced_1EXP=1-FinalSized./N
Resistancesapp_1EXP=1-FinalSizeS./N
Resistances_1EXP=1-SFinalSize./N
Resiliencea_1EXP=1./MLa
Resilienced_1EXP=1./MLd
Resiliences_1EXP=1./SMLa
Rnewendstd_1EXP=Rnewendstd
SRnewendstd_1EXP=SRnewendstd
stdS_1EXP=stdS

end %SIRN Test14


% SIRN TEST 15
% SIR - 4 loci AND fix exploit at 1 and increase variants - takes ?? mins
%***************
if doSIRNTests(15) == 1
    %outputDirectory = 'Graphs\'
outputDirectory = 'Graphs\'
%Increase variants upto 5, fix exploit
%***************************************
%SIRN testing
%***************************************
%   1 EXPLOIT
%   *******************************************************************************************************
%Deterministic - 4 loci AND
tic
numNodes = 1000;
VRmin = 1 %25
VRmax = 8 %25
N=numNodes; Vmax = 1:VRmax;  G = Vmax.^2; %number genotypes
%for AND case
Sprop = sp4LociAND( 1, Vmax )
mode = 'static' %mode - can be 'static' or 'dynamic' 'Dynamic-random' 'Dynamic-favScore'
%monte carlo random genotype SIR model
numRuns = 100 %100 %200

%set up diversity mode parameters
modePar.modeStr = mode
modePar.numToConstrain = 0 %constain a number of nodes to 1 variant
modePar.stopUpdatingTime = 20000 %time at which to stop updating the genotypes
%modePar.numEncountersBetweenUpdates = 1 % number of encounters between updates for random and favscore algorithms
modePar.bufferlength = 10 %length of genotype buffer for favscore algorithm
modePar.genoInit = 'maxdiv'  %initial conditions of genotypes maxdiv (maximum diversity - random variant chosen) mindiv (minimum diversity - all nodes same)


for z= VRmin:VRmax
 betan = 0.02; variantRichness =  z;  numTimesteps = 7000; plotGraphs = 0; gamma = 0.004; numExploits=1; numLoci=4; casetype = 'AND'; throwAway = 'nonEpidemics', cutoff = gamma.*numNodes./(betan.*Sprop); SEpidemic=60; %cutoff;
%agent
 [figMeanNei(z) figNeiOneRun(z) fighistSpRun(z) fighistRecovered(z) fighistSusceptible(z) fighistpeakValue(z) fighistpeakTime(z) fighistBeta(z) fighistGamma(z) fighistBetanew(z) fighistGammanew(z) figInfectedRun1 figBetaRun1 figGammaRun1 figRoRun1 figBetaGamma1 figBetaGamma2...
            meanNeiIndexDynamicF  betastd gammastd betastd2 betastdNew betastdNew2 gammastdNew peakTimemean peakTimestd peakValuemean peakValuestd...
            betameanmean(z) gammameanmean betameanmean2(z) betameanmeanNew(z) betameanmeanNew2 gammameanmeanNew(z) Smean(z,:) Imean(z,:) Rmean(z,:) Bmean NSmean(z,:) Smedian Imedian Rmedian S I R NS SmeanN ImeanN1(z,:) RmeanN1 BmeanN1 Snewendmean Snewendstd Rnewendmean(z) Rnewendstd(z) Rnew_nonendmean Rnew_nonendstd propSimsNonEp(z) propSimsNonEp_theoretical(z)...
            numRunsMinor(z) measuredProbMinor(z) numRunsMajor(z) measuredProbMajor(z) ...
            ] = monteCarloSIRN2(numRuns,numNodes, betan, variantRichness, numTimesteps, plotGraphs,gamma,throwAway,SEpidemic,numExploits,modePar, numLoci, casetype);
   size(ImeanN1)
FinalSize(z) = max(RmeanN1,[],2) %mean final size
    %resilience of major only
     maska = RmeanN1 >= FinalSize(z)-1; %when within 1 of the final value
    [C Index] = max(maska);
    MLa(z) = Index; %T1
    RmeanN1;
    size(RmeanN1)
    size(Index)
        %resilience of all
     maska = Rmean(z,:) >= FinalSize(z)-1; %when within 1 of the final value
    [C Index] = max(maska);
        size(Rmean(z,:))
    size(Index)
    MLa_all(z) = Index; %T1
         saveas(fighistSpRun(z),[outputDirectory 'Test15_1EXPfighistSpRun' num2str(z) '.fig']);
    saveas(fighistSpRun(z),[outputDirectory 'Test15_1EXPfighistSpRun' num2str(z) '.emf']);
        saveas(fighistRecovered(z),[outputDirectory 'Test15_1EXPfighistRecovered' num2str(z) '.fig']);
    saveas(fighistRecovered(z),[outputDirectory 'Test15_1EXPfighistRecovered' num2str(z) '.emf']);
    saveas(fighistSusceptible(z),[outputDirectory 'Test15_1EXPfighistSusceptible' num2str(z) '.fig']);
    saveas(fighistSusceptible(z),[outputDirectory 'Test15_1EXPfighistSusceptible' num2str(z) '.emf']);
    saveas(fighistpeakValue(z),[outputDirectory 'Test15_1EXPfighistpeakValue' num2str(z) '.fig']);
    saveas(fighistpeakValue(z),[outputDirectory 'Test15_1EXPfighistpeakValue' num2str(z) '.emf']);
    saveas(fighistpeakTime(z),[outputDirectory 'Test15_1EXPfighistpeakTime' num2str(z) '.fig']);
    saveas(fighistpeakTime(z),[outputDirectory 'Test15_1EXPfighistpeakTime' num2str(z) '.emf']);
    saveas(fighistBeta(z),[outputDirectory 'Test15_1EXPhistBeta' num2str(z) '.fig']);
    saveas(fighistBeta(z),[outputDirectory 'Test15_1EXPhistBeta' num2str(z) '.emf']);
    saveas(fighistGamma(z),[outputDirectory 'Test15_1EXPhistGamma' num2str(z) '.fig']);
    saveas(fighistGamma(z),[outputDirectory 'Test15_1EXPhistGamma' num2str(z) '.emf']);
    saveas(fighistBetanew(z),[outputDirectory 'Test15_1EXPhistBetaNew' num2str(z) '.fig']);
    saveas(fighistBetanew(z),[outputDirectory 'Test15_1EXPhistBetaNew' num2str(z) '.emf']);
    saveas(fighistGammanew(z),[outputDirectory 'Test15_1EXPhistGammaNew' num2str(z) '.fig']);
    saveas(fighistGammanew(z),[outputDirectory 'Test15_1EXPhistGammaNew' num2str(z) '.emf']);
    close(fighistRecovered(z));
    close(fighistSusceptible(z));
    close(fighistpeakValue(z));
    close(fighistpeakTime(z));
    close(fighistBeta(z));
    close(fighistGamma(z));
    close(fighistBetanew(z));
    close(fighistGammanew(z));
    
    %stochastic
        dtt=0.1 %stochastic dtt = used in graph and set in function
    timeS = dtt:dtt:numTimesteps;%stochastic time for graphs
    [SfighistRecovered(z) SfighistSusceptible(z) SfighistpeakValue(z) SfighistpeakTime(z) SfighistBeta(z) SfighistGamma(z) SfighistBetanew(z) SfighistGammanew(z) SfigInfectedRun1 SfigBetaRun1 SfigGammaRun1 SfigRoRun1 SfigBetaGamma1 SfigBetaGamma2...
            Sbetastd Sgammastd Sbetastd2 SbetastdNew SbetastdNew2 SgammastdNew SpeakTimemean SpeakTimestd SpeakValuemean SpeakValuestd...
            Sbetameanmean(z) Sgammameanmean Sbetameanmean2(z) SbetameanmeanNew(z) SbetameanmeanNew2 SgammameanmeanNew(z) SSmean(z,:) SImean(z,:) SRmean(z,:) SNSmean(z,:) SSmedian SImedian SRmedian SS SI SR SNS SSmeanN SImeanN1(z,:) SRmeanN1 SSnewendmean SSnewendstd SRnewendmean(z) SRnewendstd(z) SRnew_nonendmean SRnew_nonendstd SpropSimsNonEp(z) SpropSimsNonEp_theoretical(z)...
            SnumRunsMinor(z) SmeasuredProbMinor(z) SnumRunsMajor(z) SmeasuredProbMajor(z) ...
            ] = monteCarloStochastic(numRuns,numNodes, betan, variantRichness, numTimesteps, plotGraphs,gamma,throwAway,SEpidemic,numExploits,mode, numLoci, casetype);
     size(SImeanN1)
SFinalSize(z) = max(SRmeanN1,[],2) %mean final size
    %resilience of major only
     Smaska = SRmeanN1 >= SFinalSize(z)-1; %when within 1 of the final value
    [SC SIndex] = max(Smaska)
    SMLa(z) = ceil(SIndex.*dtt); %T1 %round up to nearest whole second
        %resilience of all
     Smaska = SRmean(z,:) >= SFinalSize(z)-1; %when within 1 of the final value
    [SC SIndex] = max(Smaska);
    SMLa_all(z) = ceil(SIndex.*dtt); %T1
        saveas(SfighistRecovered(z),[outputDirectory 'Test15_1EXPStochfighistRecovered' num2str(z) '.fig']);
    saveas(SfighistRecovered(z),[outputDirectory 'Test15_1EXPStochfighistRecovered' num2str(z) '.emf']);
    saveas(SfighistSusceptible(z),[outputDirectory 'Test15_1EXPStochfighistSusceptible' num2str(z) '.fig']);
    saveas(SfighistSusceptible(z),[outputDirectory 'Test15_1EXPStochfighistSusceptible' num2str(z) '.emf']);
    saveas(SfighistpeakValue(z),[outputDirectory 'Test15_1EXPStochfighistpeakValue' num2str(z) '.fig']);
    saveas(SfighistpeakValue(z),[outputDirectory 'Test15_1EXPStochfighistpeakValue' num2str(z) '.emf']);
    saveas(SfighistpeakTime(z),[outputDirectory 'Test15_1EXPStochfighistpeakTime' num2str(z) '.fig']);
    saveas(SfighistpeakTime(z),[outputDirectory 'Test15_1EXPStochfighistpeakTime' num2str(z) '.emf']);
    saveas(SfighistBeta(z),[outputDirectory 'Test15_1EXPStochhistBeta' num2str(z) '.fig']);
    saveas(SfighistBeta(z),[outputDirectory 'Test15_1EXPStochhistBeta' num2str(z) '.emf']);
    saveas(SfighistGamma(z),[outputDirectory 'Test15_1EXPStochhistGamma' num2str(z) '.fig']);
    saveas(SfighistGamma(z),[outputDirectory 'Test15_1EXPStochhistGamma' num2str(z) '.emf']);
    saveas(SfighistBetanew(z),[outputDirectory 'Test15_1EXPStochhistBetaNew' num2str(z) '.fig']);
    saveas(SfighistBetanew(z),[outputDirectory 'Test15_1EXPStochhistBetaNew' num2str(z) '.emf']);
    saveas(SfighistGammanew(z),[outputDirectory 'Test15_1EXPStochhistGammaNew' num2str(z) '.fig']);
    saveas(SfighistGammanew(z),[outputDirectory 'Test15_1EXPStochhistGammaNew' num2str(z) '.emf']);
    close(SfighistRecovered(z));
    close(SfighistSusceptible(z));
    close(SfighistpeakValue(z));
    close(SfighistpeakTime(z));
    close(SfighistBeta(z));
    close(SfighistGamma(z));
    close(SfighistBetanew(z));
    close(SfighistGammanew(z));
    text = ['done ' num2str(z) ' out of ' num2str(VRmax)];
    disp(text)
end    
    
   
%Deterministic - 4 loci AND
N=numNodes; Vmax = 1:VRmax;  G = Vmax.^2; %number genotypes
%for AND case
Sprop = sp4LociAND( 1, Vmax )
%Sprop = 2./Vmax - 1./G %both loci have the same number of variants and both have 1 exploit
S = N.*Sprop; B = 0.02; beta = B.*Sprop; gamma = 0.004; %1/48*60*60 %2 days
for i = VRmin:VRmax
    [Ro(i) St(i,:) It(i,:) Rt(i,:)] = SIRDeterministic(beta(i), gamma, S(i), 1, 0, numTimesteps, 0); 
    FinalSized(i) = Rt(i,end);
     
    %resilience
     maskd = Rt(i,:) >= Rt(i,end)-1; %when within 1 of the final value
    [C Index] = max(maskd);
    MLd(i) = Index; %T1
end

dec = 50; t2 = 1:dec:numTimesteps;

%stochastic final size approximation
[ FinalSizeS stdS ] = finalSizeApprox( Sprop, betan, gamma, VRmin, VRmax, numNodes)
%for h = VRmin:VRmax
%  text = ['1-x = exp(-1.0*(' num2str(Sprop(h)*betan/gamma) ')*x)'] 
%meanRTheory =  (solve(text, 'Real', true))*Sprop(h)*numNodes
%FinalSizeS(h) = max(double(meanRTheory))
%end

 
 figTest9inf0_02 = figure
 for i = VRmin:VRmax
     plot(Imean(i,:),'k')
     hold on
     plot(t2,It(i,1:dec:end),'k.-')
      plot(timeS,SImean(i,:),'k--')
 end
 ylabel('Number of nodes infected - It')
 xlabel('Timesteps')
 title('a) SI-Increasing variants: Nodes infected')
 legend('Agent', 'Deterministic', 'Stochastic')
 %axis([0 1000 0 400])
 
  figmajor = figure
 for i = VRmin:VRmax
     plot(ImeanN1(1,:),'k')
     hold on
     plot(t2,It(i,1:dec:end),'k.-')
     plot(timeS,SImeanN1(i,:),'k--')
     plot(ImeanN1(i,:),'k')
 end
xlabel('Timesteps')
ylabel('Number of individuals infected I(t)')
title('Mean of major outbreaks')
 legend('Agent', 'Deterministic', 'Stochastic')
%axis([0 100 0 90])
 
 
  %number of nodes infected
 figTest2FinalInfected = figure
 %agentImax = max(Imean,[],2);
 %plot(agentImax,'k')
 for j = VRmin:VRmax
 if isnan(FinalSizeS(j)); h(j) = 0; else h(j) = FinalSizeS(j); end;
 if isnan(FinalSize(j)); q(j) = 0; else q(j) = FinalSize(j); end;
  if isnan(SFinalSize(j)); v(j) = 0; else v(j) = SFinalSize(j); end;
 end
 FinalSize=q
 FinalSizeS=h
 SFinalSize=v
 plot(FinalSize,'ko-')
 hold on
 %plot(S,'k.-')
 plot(FinalSized,'k.-')
  plot(SFinalSize,'k+-')
 plot(FinalSizeS,'ks-')
%plot([1.8533 1.8533],[0 1],'k--')
 ylabel('Final number infected')
 xlabel('Number of variants')
 title('c) SI-Increasing variants: Final size')
 legend('Agent', 'Deterministic', 'Stochastic measured','Stochastic Approximation')
 
  %number of nodes infected
 figTest2Finalstd = figure
 %agentImax = max(Imean,[],2);
 %plot(agentImax,'k')
 for j = VRmin:VRmax
 if isnan(Rnewendstd(j)); h(j) = 0; else h(j) = Rnewendstd(j); end;
 if isnan(SRnewendstd(j)); q(j) = 0; else q(j) = SRnewendstd(j); end;
  if isnan(stdS(j)); v(j) = 0; else v(j) = stdS(j); end;
 end
 SRnewendstd=q
 Rnewendstd=h
 plot(Rnewendstd,'ko-') %agent measured
 hold on
 %plot(S,'k.-')
 plot(SRnewendstd,'ks-') %stochastic measured
 plot(stdS,'k+-') % calc approx
%plot([1.8533 1.8533],[0 1],'k--')
 ylabel('Standard deviation')
 xlabel('Number of variants')
 title('c) SI-Increasing variants: Final size std')
 legend('Agent measured', 'Stochastic measured', 'Stochastic Approximation')
 
  %RESISTANCE
 figTest2Resistance = figure
 plot(1-FinalSize./N,'ko-') %agent
 hold on
 %plot(S,'k.-')
 plot(1-FinalSized./N,'k.-') %deterministic
  plot(1-SFinalSize./N,'ks-') %stoch
  plot(1-FinalSizeS./N,'k+-') %stoch approximated 
 plot([1.8533 1.8533],[0 1],'k--')
 ylabel('Resistance M_R')
 xlabel('Variant Richness')
 title('c) SI-Increasing variants: Resistance')
 legend('Agent (measured)', ' Deterministic (measured)', 'Stochastic (measured)','Stochastic (approximated)')
 axis([1 8 0 1.1])
 %RESILIENCE major outbreaks only
 figTest2Resilience = figure
  plot(1./MLa,'ko-') %agent measured
 hold on
 plot(1./MLd,'k.-') %deterministic
  plot(1./SMLa,'ks-') %stochastic measured
 hold on
  ylabel('Resilience M_L')
 xlabel('Variant Richness')
 title('c) SI-Increasing variants: Resilience major')
 legend('Agent (measured)', ' Deterministic (measured)', 'Stochastic (measured)')
  plot([1.8533 1.8533],[0 1],'k--')
   axis([1 8 0 1.1])
  
  %RESILIENCE TIME of major outbreaks only
 figTest2ResilienceTime = figure
  plot(MLa,'ko-') %agent measured
 hold on
 plot(MLd,'k.-') %deterministic
  plot(SMLa,'ks-') %stochastic measured
 hold on
  ylabel('Resilience Time (seconds)')
 xlabel('Variant Richness')
 title('c) SI-Increasing variants: Resilience Time major')
 legend('Agent (measured)', ' Deterministic (measured)', 'Stochastic (measured)')
  plot([1.8533 1.8533],[0 1],'k--')
   %axis([1 8 0 1.1])
   
   %SAVE FOR LATER
Resistancea_1EXP=1-FinalSize./N
Resistanced_1EXP=1-FinalSized./N
Resistancesapp_1EXP=1-FinalSizeS./N
Resistances_1EXP=1-SFinalSize./N
Rnewendstd_1EXP=Rnewendstd
SRnewendstd_1EXP=SRnewendstd
stdS_1EXP=stdS
MLa
MLd
SMLa
Resiliencea_1EXP=1./MLa
Resilienced_1EXP=1./MLd
Resiliences_1EXP=1./SMLa


saveas(figTest9inf0_02,[outputDirectory 'Test15_1EXPmeanall.fig']);
saveas(figTest9inf0_02,[outputDirectory 'Test15_1EXPmeanall.emf']); 
saveas(figmajor,[outputDirectory 'Test15_1EXPmeanmajor.fig']);
saveas(figmajor,[outputDirectory 'Test15_1EXPmeanmajor.emf']);
saveas(figTest2FinalInfected,[outputDirectory 'Test15_1EXPFinalInfected.fig']);
saveas(figTest2FinalInfected,[outputDirectory 'Test15_1EXPFinalInfected.emf']);
saveas(figTest2Finalstd,[outputDirectory 'Test15_1EXPFinalstd.fig']);
saveas(figTest2Finalstd,[outputDirectory 'Test15_1EXPFinalstd.emf']);
saveas(figTest2Resistance,[outputDirectory 'Test15_1EXPResistance.fig']);
saveas(figTest2Resistance,[outputDirectory 'Test15_1EXPResistance.emf']);
saveas(figTest2Resilience,[outputDirectory 'Test15_1EXPResilience.fig']);
saveas(figTest2Resilience,[outputDirectory 'Test15_1EXPResilience.emf']);
saveas(figTest2ResilienceTime,[outputDirectory 'Test15_1EXPResilienceTime.fig']);
saveas(figTest2ResilienceTime,[outputDirectory 'Test15_1EXPResilienceTime.emf']);
%close all


betameanmean
gammameanmean

betameanmean2
betameanmeanNew 
betameanmeanNew2
gammameanmeanNew

Rnewendmean%epidemics only
Rnewendstd

 propSimsNonEp % proportion of sims with non-epidemics
 propSimsNonEp_theoretical %theoretical value
    
R = betameanmean./gammameanmean
RN = betameanmeanNew./gammameanmeanNew
SRN = SbetameanmeanNew./SgammameanmeanNew
RTheoretical = beta./gamma

figro = figure
%plot(beta,R,'k')
hold on
plot(RN,'ko-')
plot(RTheoretical,'k.-')
plot(RN,'ks-') %stochastic measured
plot([1 1 1 1 1 1 1 1],'k--')
%plot([19 19],[0 2],'k--')
xlabel('Number of variants')
ylabel('ro')
%legend('R','RNew','Rtheoretical') 
legend('Ro Agent(measured)','Ro Deterministic','Ro Stochastic(measured)') 
%axis([0.1 0.5 0 2])
saveas(figro,[outputDirectory 'Test15_1EXPfigro.fig']);
saveas(figro,[outputDirectory 'Test15_1EXPfigro.emf']);
%close all
%close all;

%calculate proportion of minor and major outbreaks
[ minorCalc majorCalc ] = propCalcOutbreaks( Sprop, B, gamma )
%R0 = Sprop.*B./gamma;
%for i = 1:size(R0,2)
%if R0(i) >= 1
%minorCalc(i) = 1./R0(i);
%majorCalc(i) = 1-minorCalc(i);
%else
%minorCalc(i) = 1;
%majorCalc(i) = 0;
%end
%end
%minorCalc
%majorCalc

%measure proportion of minor and major outbreaks
%agent
%numRunsMinor measuredProbMinor numRunsMajor measuredProbMajor
numRunsMinor
numRunsMajor
measuredProbMinor
measuredProbMajor
%stochastic
%SnumRunsMinor SmeasuredProbMinor SnumRunsMajor SmeasuredProbMajor
SnumRunsMinor
SnumRunsMajor
SmeasuredProbMinor
SmeasuredProbMajor

figMinorProb = figure;
plot(measuredProbMinor,'ko-') %agent
hold on
plot(SmeasuredProbMinor,'ks-') %stochastic
plot(minorCalc,'k+-') %calc
xlabel('Variant Richness')
ylabel('Proportion of minor outbreaks')
%legend('R','RNew','Rtheoretical') 
 plot([1.8533 1.8533],[0 1],'k--')
legend('Agent (measured)','Stochastic (measured)', 'Stochastic (approximated)')
title('probability of minor outbreak')

figMajorProb = figure;
plot(measuredProbMajor,'ko-') %agent
hold on
plot(SmeasuredProbMajor,'ks-') %stochastic
plot(majorCalc,'k+-') %calc
xlabel('Variant Richness')
ylabel('Proportion of major outbreaks')
%legend('R','RNew','Rtheoretical') 
 plot([1.8533 1.8533],[0 1],'k--')
legend('Agent (measured)','Stochastic (measured)', 'Stochastic (approximated)')
title('probability of major outbreak')

saveas(figMinorProb,[outputDirectory 'Test15_1EXPfigMinorProb.fig']);
saveas(figMinorProb,[outputDirectory 'Test15_1EXPfigMinorProb.emf']);
saveas(figMajorProb,[outputDirectory 'Test15_1EXPfigMajorProb.fig']);
saveas(figMajorProb,[outputDirectory 'Test15_1EXPfigMajorProb.emf']);

%Final size distribution
Rnewendmean
Rnewendstd

return

% 2 EXPLOITS
% *************************************************************************************************
%Deterministic - 4 loci AND
tic
numNodes = 1000;
VRmin = 1 %25
VRmax = 8 %25
N=numNodes; Vmax = 1:VRmax;  G = Vmax.^2; %number genotypes
%for AND case
Sprop = sp4LociAND( 2, Vmax )
mode = 'static'
%monte carlo random genotype SIR model
numRuns = 100 %100 %200

for z= VRmin:VRmax
 betan = 0.02; variantRichness =  z;  numTimesteps = 7000; plotGraphs = 0; gamma = 0.004; numExploits=2; numLoci=4; casetype = 'AND'; throwAway = 'nonEpidemics', cutoff = gamma.*numNodes./(betan.*Sprop); SEpidemic=60; %cutoff;
%agent
 [figMeanNei(z) figNeiOneRun(z) fighistSpRun(z) fighistRecovered(z) fighistSusceptible(z) fighistpeakValue(z) fighistpeakTime(z) fighistBeta(z) fighistGamma(z) fighistBetanew(z) fighistGammanew(z) figInfectedRun1 figBetaRun1 figGammaRun1 figRoRun1 figBetaGamma1 figBetaGamma2...
            meanNeiIndexDynamicF  betastd gammastd betastd2 betastdNew betastdNew2 gammastdNew peakTimemean peakTimestd peakValuemean peakValuestd...
            betameanmean(z) gammameanmean betameanmean2(z) betameanmeanNew(z) betameanmeanNew2 gammameanmeanNew(z) Smean(z,:) Imean(z,:) Rmean(z,:) Bmean NSmean(z,:) Smedian Imedian Rmedian S I R NS SmeanN ImeanN1(z,:) RmeanN1 BmeanN1 Snewendmean Snewendstd Rnewendmean(z) Rnewendstd(z) Rnew_nonendmean Rnew_nonendstd propSimsNonEp(z) propSimsNonEp_theoretical(z)...
            numRunsMinor(z) measuredProbMinor(z) numRunsMajor(z) measuredProbMajor(z) ...
            ] = monteCarloSIRN2(numRuns,numNodes, betan, variantRichness, numTimesteps, plotGraphs,gamma,throwAway,SEpidemic,numExploits,modePar, numLoci, casetype);     
            
        size(ImeanN1)
FinalSize(z) = max(RmeanN1,[],2) %mean final size
    %resilience of major only
     maska = RmeanN1 >= FinalSize(z)-1; %when within 1 of the final value
    [C Index] = max(maska);
    MLa(z) = Index; %T1
    RmeanN1;
    size(RmeanN1)
    size(Index)
        %resilience of all
     maska = Rmean(z,:) >= FinalSize(z)-1; %when within 1 of the final value
    [C Index] = max(maska);
        size(Rmean(z,:))
    size(Index)
    MLa_all(z) = Index; %T1
         saveas(fighistSpRun(z),[outputDirectory 'Test15_2EXPfighistSpRun' num2str(z) '.fig']);
    saveas(fighistSpRun(z),[outputDirectory 'Test15_2EXPfighistSpRun' num2str(z) '.emf']);
        saveas(fighistRecovered(z),[outputDirectory 'Test15_2EXPfighistRecovered' num2str(z) '.fig']);
    saveas(fighistRecovered(z),[outputDirectory 'Test15_2EXPfighistRecovered' num2str(z) '.emf']);
    saveas(fighistSusceptible(z),[outputDirectory 'Test15_2EXPfighistSusceptible' num2str(z) '.fig']);
    saveas(fighistSusceptible(z),[outputDirectory 'Test15_2EXPfighistSusceptible' num2str(z) '.emf']);
    saveas(fighistpeakValue(z),[outputDirectory 'Test15_2EXPfighistpeakValue' num2str(z) '.fig']);
    saveas(fighistpeakValue(z),[outputDirectory 'Test15_2EXPfighistpeakValue' num2str(z) '.emf']);
    saveas(fighistpeakTime(z),[outputDirectory 'Test15_2EXPfighistpeakTime' num2str(z) '.fig']);
    saveas(fighistpeakTime(z),[outputDirectory 'Test15_2EXPfighistpeakTime' num2str(z) '.emf']);
    saveas(fighistBeta(z),[outputDirectory 'Test15_2EXPhistBeta' num2str(z) '.fig']);
    saveas(fighistBeta(z),[outputDirectory 'Test15_2EXPhistBeta' num2str(z) '.emf']);
    saveas(fighistGamma(z),[outputDirectory 'Test15_2EXPhistGamma' num2str(z) '.fig']);
    saveas(fighistGamma(z),[outputDirectory 'Test15_2EXPhistGamma' num2str(z) '.emf']);
    saveas(fighistBetanew(z),[outputDirectory 'Test15_2EXPhistBetaNew' num2str(z) '.fig']);
    saveas(fighistBetanew(z),[outputDirectory 'Test15_2EXPhistBetaNew' num2str(z) '.emf']);
    saveas(fighistGammanew(z),[outputDirectory 'Test15_2EXPhistGammaNew' num2str(z) '.fig']);
    saveas(fighistGammanew(z),[outputDirectory 'Test15_2EXPhistGammaNew' num2str(z) '.emf']);
    close(fighistRecovered(z));
    close(fighistSusceptible(z));
    close(fighistpeakValue(z));
    close(fighistpeakTime(z));
    close(fighistBeta(z));
    close(fighistGamma(z));
    close(fighistBetanew(z));
    close(fighistGammanew(z));
    
    %stochastic
        dtt=0.1 %stochastic dtt = used in graph and set in function
    timeS = dtt:dtt:numTimesteps;%stochastic time for graphs
      plotGraphs = 1;
    [SfighistRecovered(z) SfighistSusceptible(z) SfighistpeakValue(z) SfighistpeakTime(z) SfighistBeta(z) SfighistGamma(z) SfighistBetanew(z) SfighistGammanew(z) SfigInfectedRun1 SfigBetaRun1 SfigGammaRun1 SfigRoRun1 SfigBetaGamma1 SfigBetaGamma2...
            Sbetastd Sgammastd Sbetastd2 SbetastdNew SbetastdNew2 SgammastdNew SpeakTimemean SpeakTimestd SpeakValuemean SpeakValuestd...
            Sbetameanmean(z) Sgammameanmean Sbetameanmean2(z) SbetameanmeanNew(z) SbetameanmeanNew2 SgammameanmeanNew(z) SSmean(z,:) SImean(z,:) SRmean(z,:) SNSmean(z,:) SSmedian SImedian SRmedian SS SI SR SNS SSmeanN SImeanN1(z,:) SRmeanN1 SSnewendmean SSnewendstd SRnewendmean(z) SRnewendstd(z) SRnew_nonendmean SRnew_nonendstd SpropSimsNonEp(z) SpropSimsNonEp_theoretical(z)...
            SnumRunsMinor(z) SmeasuredProbMinor(z) SnumRunsMajor(z) SmeasuredProbMajor(z) ...
            ] = monteCarloStochastic(numRuns,numNodes, betan, variantRichness, numTimesteps, plotGraphs,gamma,throwAway,SEpidemic,numExploits,mode, numLoci, casetype);
     size(SImeanN1)
SFinalSize(z) = max(SRmeanN1,[],2) %mean final size
    %resilience of major only
     Smaska = SRmeanN1 >= SFinalSize(z)-1; %when within 1 of the final value
    [SC SIndex] = max(Smaska);
    SMLa(z) = ceil(SIndex.*dtt); %T1
        %resilience of all
     Smaska = SRmean(z,:) >= SFinalSize(z)-1; %when within 1 of the final value
    [SC SIndex] = max(Smaska);
    SMLa_all(z) = ceil(SIndex.*dtt); %T1
        saveas(SfighistRecovered(z),[outputDirectory 'Test15_2EXPStochfighistRecovered' num2str(z) '.fig']);
    saveas(SfighistRecovered(z),[outputDirectory 'Test15_2EXPStochfighistRecovered' num2str(z) '.emf']);
    saveas(SfighistSusceptible(z),[outputDirectory 'Test15_2EXPStochfighistSusceptible' num2str(z) '.fig']);
    saveas(SfighistSusceptible(z),[outputDirectory 'Test15_2EXPStochfighistSusceptible' num2str(z) '.emf']);
    saveas(SfighistpeakValue(z),[outputDirectory 'Test15_2EXPStochfighistpeakValue' num2str(z) '.fig']);
    saveas(SfighistpeakValue(z),[outputDirectory 'Test15_2EXPStochfighistpeakValue' num2str(z) '.emf']);
    saveas(SfighistpeakTime(z),[outputDirectory 'Test15_2EXPStochfighistpeakTime' num2str(z) '.fig']);
    saveas(SfighistpeakTime(z),[outputDirectory 'Test15_2EXPStochfighistpeakTime' num2str(z) '.emf']);
    saveas(SfighistBeta(z),[outputDirectory 'Test15_2EXPStochhistBeta' num2str(z) '.fig']);
    saveas(SfighistBeta(z),[outputDirectory 'Test15_2EXPStochhistBeta' num2str(z) '.emf']);
    saveas(SfighistGamma(z),[outputDirectory 'Test15_2EXPStochhistGamma' num2str(z) '.fig']);
    saveas(SfighistGamma(z),[outputDirectory 'Test15_2EXPStochhistGamma' num2str(z) '.emf']);
    saveas(SfighistBetanew(z),[outputDirectory 'Test15_2EXPStochhistBetaNew' num2str(z) '.fig']);
    saveas(SfighistBetanew(z),[outputDirectory 'Test15_2EXPStochhistBetaNew' num2str(z) '.emf']);
    saveas(SfighistGammanew(z),[outputDirectory 'Test15_2EXPStochhistGammaNew' num2str(z) '.fig']);
    saveas(SfighistGammanew(z),[outputDirectory 'Test15_2EXPStochhistGammaNew' num2str(z) '.emf']);
    close(SfighistRecovered(z));
    close(SfighistSusceptible(z));
    close(SfighistpeakValue(z));
    close(SfighistpeakTime(z));
    close(SfighistBeta(z));
    close(SfighistGamma(z));
    close(SfighistBetanew(z));
    close(SfighistGammanew(z));
    text = ['done ' num2str(z) ' out of ' num2str(VRmax)];
    disp(text)
end    
    
   
%Deterministic - 4 loci AND
N=numNodes; Vmax = 1:VRmax;  G = Vmax.^2; %number genotypes
%for AND case
Sprop = sp4LociAND( 2, Vmax )
%Sprop = 2./Vmax - 1./G %both loci have the same number of variants and both have 1 exploit
S = N.*Sprop; B = 0.02; beta = B.*Sprop; gamma = 0.004; %1/48*60*60 %2 days
for i = VRmin:VRmax
    [Ro(i) St(i,:) It(i,:) Rt(i,:)] = SIRDeterministic(beta(i), gamma, S(i), 1, 0, numTimesteps, 0); 
    FinalSized(i) = Rt(i,end);
     
    %resilience
     maskd = Rt(i,:) >= Rt(i,end)-1; %when within 1 of the final value
    [C Index] = max(maskd);
    MLd(i) = Index; %T1
end

dec = 50; t2 = 1:dec:numTimesteps;

%stochastic final size approximation
[ FinalSizeS stdS ] = finalSizeApprox( Sprop, betan, gamma, VRmin, VRmax, numNodes)
%for h = VRmin:VRmax
%  text = ['1-x = exp(-1.0*(' num2str(Sprop(h)*betan/gamma) ')*x)'] 
%meanRTheory =  (solve(text, 'Real', true))*Sprop(h)*numNodes
%FinalSizeS(h) = max(double(meanRTheory))
%end

 
 figTest9inf0_02 = figure
 for i = VRmin:VRmax
     plot(Imean(i,:),'k')
     hold on
     plot(t2,It(i,1:dec:end),'k.-')
      plot(timeS,SImean(i,:),'k--')
 end
 ylabel('Number of nodes infected - It')
 xlabel('Timesteps')
 title('a) SI-Increasing variants: Nodes infected')
 legend('Agent', 'Deterministic', 'Stochastic')
 %axis([0 1000 0 400])
 
  figmajor = figure
 for i = VRmin:VRmax
     plot(ImeanN1(1,:),'k')
     hold on
     plot(t2,It(i,1:dec:end),'k.-')
     plot(timeS,SImeanN1(i,:),'k--')
     plot(ImeanN1(i,:),'k')
 end
xlabel('Timesteps')
ylabel('Number of individuals infected I(t)')
title('Mean of major outbreaks')
 legend('Agent', 'Deterministic', 'Stochastic')
%axis([0 100 0 90])
 
 
   %number of nodes infected
 figTest2FinalInfected = figure
 %agentImax = max(Imean,[],2);
 %plot(agentImax,'k')
 for j = VRmin:VRmax
 if isnan(FinalSizeS(j)); h(j) = 0; else h(j) = FinalSizeS(j); end;
 if isnan(FinalSize(j)); q(j) = 0; else q(j) = FinalSize(j); end;
  if isnan(SFinalSize(j)); v(j) = 0; else v(j) = SFinalSize(j); end;
 end
 FinalSize=q
 FinalSizeS=h
 SFinalSize=v
 plot(FinalSize,'ko-')
 hold on
 %plot(S,'k.-')
 plot(FinalSized,'k.-')
  plot(SFinalSize,'k+-')
 plot(FinalSizeS,'ks-')
%plot([1.8533 1.8533],[0 1],'k--')
 ylabel('Final number infected')
 xlabel('Number of variants')
 title('c) SI-Increasing variants: Final size')
 legend('Agent', 'Deterministic', 'Stochastic measured','Stochastic Approximation')
 
  %number of nodes infected
 figTest2Finalstd = figure
 %agentImax = max(Imean,[],2);
 %plot(agentImax,'k')
 for j = VRmin:VRmax
 if isnan(Rnewendstd(j)); h(j) = 0; else h(j) = Rnewendstd(j); end;
 if isnan(SRnewendstd(j)); q(j) = 0; else q(j) = SRnewendstd(j); end;
  if isnan(stdS(j)); v(j) = 0; else v(j) = stdS(j); end;
 end
 SRnewendstd=q
 Rnewendstd=h
 plot(Rnewendstd,'ko-') %agent measured
 hold on
 %plot(S,'k.-')
 plot(SRnewendstd,'ks-') %stochastic measured
 plot(stdS,'k+-') % calc approx
%plot([1.8533 1.8533],[0 1],'k--')
 ylabel('Standard deviation')
 xlabel('Number of variants')
 title('c) SI-Increasing variants: Final size std')
 legend('Agent measured', 'Stochastic measured', 'Stochastic Approximation')
 
  %RESISTANCE
 figTest2Resistance = figure
 
      %SAVE FOR LATER
Resistancea_2EXP=1-FinalSize./N;
Resistanced_2EXP=1-FinalSized./N;
Resistancesapp_2EXP=1-FinalSizeS./N;
Resistances_2EXP=1-SFinalSize./N;
Resiliencea_2EXP=1./MLa;
Resilienced_2EXP=1./MLd;
Resiliences_2EXP=1./SMLa;
Rnewendstd_2EXP=Rnewendstd
SRnewendstd_2EXP=SRnewendstd
stdS_2EXP=stdS


 plot(2:VRmax,Resistancea_2EXP(2:end),'ko-')
 hold on
 %plot(S,'k.-')
 plot(2:VRmax,Resistanced_2EXP(2:end),'k.-')
   plot(2:VRmax,Resistances_2EXP(2:end),'ks-')
 plot(2:VRmax,Resistancesapp_2EXP(2:end),'k+-')
 %plot([1.8533 1.8533],[0 1],'k--')
 ylabel('Resistance M_R')
 xlabel('Variant Richness')
 title('c) SI-Increasing variants: Resistance')
 legend('Agent (measured)', ' Deterministic (measured)', 'Stochastic (measured)','Stochastic (approximated)')
  axis([1 8 0 1.1])
 
 %RESILIENCE major outbreaks only
 figTest2Resilience = figure
  plot(2:VRmax,Resiliencea_2EXP(2:end),'ko-') %agent measured
 hold on
 plot(2:VRmax,Resilienced_2EXP(2:end),'k.-') %deterministic
  plot(2:VRmax,Resiliences_2EXP(2:end),'ks-') %stochastic measured
 hold on
  ylabel('Resilience M_L')
 xlabel('Variant Richness')
 title('c) SI-Increasing variants: Resilience major')
 legend('Agent (measured)', ' Deterministic (measured)', 'Stochastic (measured)')
  %plot([1.8533 1.8533],[0 1],'k--')
 axis([1 8 0 1.1])

 
%RESILIENCE TIME of major outbreaks only
 figTest2ResilienceTime = figure
  plot(MLa,'ko-') %agent measured
 hold on
 plot(MLd,'k.-') %deterministic
  plot(SMLa,'ks-') %stochastic measured
 hold on
  ylabel('Resilience Time')
 xlabel('Variant Richness')
 title('c) SI-Increasing variants: Resilience Time major')
 legend('Agent (measured)', ' Deterministic (measured)', 'Stochastic (measured)')
  plot([1.8533 1.8533],[0 1],'k--')
   %axis([1 8 0 1.1])
 
saveas(figTest9inf0_02,[outputDirectory 'Test15_2EXPmeanall.fig']);
saveas(figTest9inf0_02,[outputDirectory 'Test15_2EXPmeanall.emf']); 
saveas(figmajor,[outputDirectory 'Test15_2EXPmeanmajor.fig']);
saveas(figmajor,[outputDirectory 'Test15_2EXPmeanmajor.emf']);
saveas(figTest2FinalInfected,[outputDirectory 'Test15_2EXPFinalInfected.fig']);
saveas(figTest2FinalInfected,[outputDirectory 'Test15_2EXPFinalInfected.emf']);
saveas(figTest2Finalstd,[outputDirectory 'Test15_2EXPFinalstd.fig']);
saveas(figTest2Finalstd,[outputDirectory 'Test15_2EXPFinalstd.emf']);
saveas(figTest2Resistance,[outputDirectory 'Test15_2EXPResistance.fig']);
saveas(figTest2Resistance,[outputDirectory 'Test15_2EXPResistance.emf']);
saveas(figTest2Resilience,[outputDirectory 'Test15_2EXPResilience.fig']);
saveas(figTest2Resilience,[outputDirectory 'Test15_2EXPResilience.emf']);
saveas(figTest2ResilienceTime,[outputDirectory 'Test15_2EXPResilienceTime.fig']);
saveas(figTest2ResilienceTime,[outputDirectory 'Test15_2EXPResilienceTime.emf']);
%close all


betameanmean
gammameanmean

betameanmean2
betameanmeanNew 
betameanmeanNew2
gammameanmeanNew

Rnewendmean%epidemics only
Rnewendstd

 propSimsNonEp % proportion of sims with non-epidemics
 propSimsNonEp_theoretical %theoretical value
    
R = betameanmean./gammameanmean
RN = betameanmeanNew./gammameanmeanNew
SRN = SbetameanmeanNew./SgammameanmeanNew
RTheoretical = beta./gamma

figro = figure
%plot(beta,R,'k')
hold on
plot(RN,'ko-')
plot(RTheoretical,'k.-')
plot(RN,'ks-') %stochastic measured
plot([1 1 1 1 1 1 1 1],'k--')
%plot([19 19],[0 2],'k--')
xlabel('Number of variants')
ylabel('ro')
%legend('R','RNew','Rtheoretical') 
legend('Ro Agent(measured)','Ro Deterministic','Ro Stochastic(measured)') 
%axis([0.1 0.5 0 2])
saveas(figro,[outputDirectory 'Test15_2EXPfigro.fig']);
saveas(figro,[outputDirectory 'Test15_2EXPfigro.emf']);
%close all
%close all;

%calculate proportion of minor and major outbreaks
[ minorCalc majorCalc ] = propCalcOutbreaks( Sprop, B, gamma )

%measure proportion of minor and major outbreaks
%agent
%numRunsMinor measuredProbMinor numRunsMajor measuredProbMajor
numRunsMinor
numRunsMajor
measuredProbMinor
measuredProbMajor
%stochastic
%SnumRunsMinor SmeasuredProbMinor SnumRunsMajor SmeasuredProbMajor
SnumRunsMinor
SnumRunsMajor
SmeasuredProbMinor
SmeasuredProbMajor

figMinorProb = figure;
plot(measuredProbMinor,'ko-') %agent
hold on
plot(SmeasuredProbMinor,'ks-') %stochastic
plot(minorCalc,'k+-') %calc
xlabel('Variant Richness')
ylabel('proportion of minor outbreaks')
%legend('R','RNew','Rtheoretical') 
legend('Agent (measured)','Stochastic (measured)', 'Stochastic (approximated)')
title('probability of minor outbreak 2 exploits')

figMajorProb = figure;
plot(measuredProbMajor,'ko-') %agent
hold on
plot(SmeasuredProbMajor,'ks-') %stochastic
plot(majorCalc,'k+-') %calc
xlabel('Variant Richness')
ylabel('proportion of major outbreaks')
%legend('R','RNew','Rtheoretical') 
legend('Agent (measured)','Stochastic (measured)', 'Stochastic (approximated)')
title('probability of major outbreak 2 exploits')

saveas(figMinorProb,[outputDirectory 'Test15_2EXPfigMinorProb.fig']);
saveas(figMinorProb,[outputDirectory 'Test15_2EXPfigMinorProb.emf']);
saveas(figMajorProb,[outputDirectory 'Test15_2EXPfigMajorProb.fig']);
saveas(figMajorProb,[outputDirectory 'Test15_2EXPfigMajorProb.emf']);

% 3 EXPLOITS *************************************************************
%Deterministic - 4 loci AND
tic
numNodes = 1000;
VRmin = 1 %25
VRmax = 8 %25
N=numNodes; Vmax = 1:VRmax;  G = Vmax.^2; %number genotypes
%for AND case
Sprop = sp4LociAND( 3, Vmax )
mode = 'static'
%monte carlo random genotype SIR model
numRuns = 100 %100 %200

for z= VRmin:VRmax
 betan = 0.02; variantRichness =  z;  numTimesteps = 7000; plotGraphs = 0; gamma = 0.004; numExploits=3; numLoci=4; casetype = 'AND'; throwAway = 'nonEpidemics', cutoff = gamma.*numNodes./(betan.*Sprop); SEpidemic=60; %cutoff;
%agent
 [figMeanNei(z) figNeiOneRun(z) fighistSpRun(z) fighistRecovered(z) fighistSusceptible(z) fighistpeakValue(z) fighistpeakTime(z) fighistBeta(z) fighistGamma(z) fighistBetanew(z) fighistGammanew(z) figInfectedRun1 figBetaRun1 figGammaRun1 figRoRun1 figBetaGamma1 figBetaGamma2...
            meanNeiIndexDynamicF  betastd gammastd betastd2 betastdNew betastdNew2 gammastdNew peakTimemean peakTimestd peakValuemean peakValuestd...
            betameanmean(z) gammameanmean betameanmean2(z) betameanmeanNew(z) betameanmeanNew2 gammameanmeanNew(z) Smean(z,:) Imean(z,:) Rmean(z,:) Bmean NSmean(z,:) Smedian Imedian Rmedian S I R NS SmeanN ImeanN1(z,:) RmeanN1 BmeanN1 Snewendmean Snewendstd Rnewendmean(z) Rnewendstd(z) Rnew_nonendmean Rnew_nonendstd propSimsNonEp(z) propSimsNonEp_theoretical(z)...
            numRunsMinor(z) measuredProbMinor(z) numRunsMajor(z) measuredProbMajor(z) ...
            ] = monteCarloSIRN2(numRuns,numNodes, betan, variantRichness, numTimesteps, plotGraphs,gamma,throwAway,SEpidemic,numExploits,modePar, numLoci, casetype);
   size(ImeanN1)
FinalSize(z) = max(RmeanN1,[],2) %mean final size
    %resilience of major only
     maska = RmeanN1 >= FinalSize(z)-1; %when within 1 of the final value
    [C Index] = max(maska);
    MLa(z) = Index; %T1
    RmeanN1;
    size(RmeanN1)
    size(Index)
        %resilience of all
     maska = Rmean(z,:) >= FinalSize(z)-1; %when within 1 of the final value
    [C Index] = max(maska);
        size(Rmean(z,:))
    size(Index)
    MLa_all(z) = Index; %T1
         saveas(fighistSpRun(z),[outputDirectory 'Test15_3EXPfighistSpRun' num2str(z) '.fig']);
    saveas(fighistSpRun(z),[outputDirectory 'Test15_3EXPfighistSpRun' num2str(z) '.emf']);
        saveas(fighistRecovered(z),[outputDirectory 'Test15_3EXPfighistRecovered' num2str(z) '.fig']);
    saveas(fighistRecovered(z),[outputDirectory 'Test15_3EXPfighistRecovered' num2str(z) '.emf']);
    saveas(fighistSusceptible(z),[outputDirectory 'Test15_3EXPfighistSusceptible' num2str(z) '.fig']);
    saveas(fighistSusceptible(z),[outputDirectory 'Test15_3EXPfighistSusceptible' num2str(z) '.emf']);
    saveas(fighistpeakValue(z),[outputDirectory 'Test15_3EXPfighistpeakValue' num2str(z) '.fig']);
    saveas(fighistpeakValue(z),[outputDirectory 'Test15_3EXPfighistpeakValue' num2str(z) '.emf']);
    saveas(fighistpeakTime(z),[outputDirectory 'Test15_3EXPfighistpeakTime' num2str(z) '.fig']);
    saveas(fighistpeakTime(z),[outputDirectory 'Test15_3EXPfighistpeakTime' num2str(z) '.emf']);
    saveas(fighistBeta(z),[outputDirectory 'Test15_3EXPhistBeta' num2str(z) '.fig']);
    saveas(fighistBeta(z),[outputDirectory 'Test15_3EXPhistBeta' num2str(z) '.emf']);
    saveas(fighistGamma(z),[outputDirectory 'Test15_3EXPhistGamma' num2str(z) '.fig']);
    saveas(fighistGamma(z),[outputDirectory 'Test15_3EXPhistGamma' num2str(z) '.emf']);
    saveas(fighistBetanew(z),[outputDirectory 'Test15_3EXPhistBetaNew' num2str(z) '.fig']);
    saveas(fighistBetanew(z),[outputDirectory 'Test15_3EXPhistBetaNew' num2str(z) '.emf']);
    saveas(fighistGammanew(z),[outputDirectory 'Test15_3EXPhistGammaNew' num2str(z) '.fig']);
    saveas(fighistGammanew(z),[outputDirectory 'Test15_3EXPhistGammaNew' num2str(z) '.emf']);
    close(fighistRecovered(z));
    close(fighistSusceptible(z));
    close(fighistpeakValue(z));
    close(fighistpeakTime(z));
    close(fighistBeta(z));
    close(fighistGamma(z));
    close(fighistBetanew(z));
    close(fighistGammanew(z));
    
    %stochastic
        dtt=0.1 %stochastic dtt = used in graph and set in function
    timeS = dtt:dtt:numTimesteps;%stochastic time for graphs
    [SfighistRecovered(z) SfighistSusceptible(z) SfighistpeakValue(z) SfighistpeakTime(z) SfighistBeta(z) SfighistGamma(z) SfighistBetanew(z) SfighistGammanew(z) SfigInfectedRun1 SfigBetaRun1 SfigGammaRun1 SfigRoRun1 SfigBetaGamma1 SfigBetaGamma2...
            Sbetastd Sgammastd Sbetastd2 SbetastdNew SbetastdNew2 SgammastdNew SpeakTimemean SpeakTimestd SpeakValuemean SpeakValuestd...
            Sbetameanmean(z) Sgammameanmean Sbetameanmean2(z) SbetameanmeanNew(z) SbetameanmeanNew2 SgammameanmeanNew(z) SSmean(z,:) SImean(z,:) SRmean(z,:) SNSmean(z,:) SSmedian SImedian SRmedian SS SI SR SNS SSmeanN SImeanN1(z,:) SRmeanN1 SSnewendmean SSnewendstd SRnewendmean(z) SRnewendstd(z) SRnew_nonendmean SRnew_nonendstd SpropSimsNonEp(z) SpropSimsNonEp_theoretical(z)...
            SnumRunsMinor(z) SmeasuredProbMinor(z) SnumRunsMajor(z) SmeasuredProbMajor(z) ...
            ] = monteCarloStochastic(numRuns,numNodes, betan, variantRichness, numTimesteps, plotGraphs,gamma,throwAway,SEpidemic,numExploits,mode, numLoci, casetype);
     size(SImeanN1)
SFinalSize(z) = max(SRmeanN1,[],2) %mean final size
    %resilience of major only
     Smaska = SRmeanN1 >= SFinalSize(z)-1; %when within 1 of the final value
    [SC SIndex] = max(Smaska);
    SMLa(z) = ceil(SIndex.*dtt); %T1
        %resilience of all
     Smaska = SRmean(z,:) >= SFinalSize(z)-1; %when within 1 of the final value
    [SC SIndex] = max(Smaska);
    SMLa_all(z) = ceil(SIndex.*dtt); %T1
        saveas(SfighistRecovered(z),[outputDirectory 'Test15_3EXPStochfighistRecovered' num2str(z) '.fig']);
    saveas(SfighistRecovered(z),[outputDirectory 'Test15_3EXPStochfighistRecovered' num2str(z) '.emf']);
    saveas(SfighistSusceptible(z),[outputDirectory 'Test15_3EXPStochfighistSusceptible' num2str(z) '.fig']);
    saveas(SfighistSusceptible(z),[outputDirectory 'Test15_3EXPStochfighistSusceptible' num2str(z) '.emf']);
    saveas(SfighistpeakValue(z),[outputDirectory 'Test15_3EXPStochfighistpeakValue' num2str(z) '.fig']);
    saveas(SfighistpeakValue(z),[outputDirectory 'Test15_3EXPStochfighistpeakValue' num2str(z) '.emf']);
    saveas(SfighistpeakTime(z),[outputDirectory 'Test15_3EXPStochfighistpeakTime' num2str(z) '.fig']);
    saveas(SfighistpeakTime(z),[outputDirectory 'Test15_3EXPStochfighistpeakTime' num2str(z) '.emf']);
    saveas(SfighistBeta(z),[outputDirectory 'Test15_3EXPStochhistBeta' num2str(z) '.fig']);
    saveas(SfighistBeta(z),[outputDirectory 'Test15_3EXPStochhistBeta' num2str(z) '.emf']);
    saveas(SfighistGamma(z),[outputDirectory 'Test15_3EXPStochhistGamma' num2str(z) '.fig']);
    saveas(SfighistGamma(z),[outputDirectory 'Test15_3EXPStochhistGamma' num2str(z) '.emf']);
    saveas(SfighistBetanew(z),[outputDirectory 'Test15_3EXPStochhistBetaNew' num2str(z) '.fig']);
    saveas(SfighistBetanew(z),[outputDirectory 'Test15_3EXPStochhistBetaNew' num2str(z) '.emf']);
    saveas(SfighistGammanew(z),[outputDirectory 'Test15_3EXPStochhistGammaNew' num2str(z) '.fig']);
    saveas(SfighistGammanew(z),[outputDirectory 'Test15_3EXPStochhistGammaNew' num2str(z) '.emf']);
    close(SfighistRecovered(z));
    close(SfighistSusceptible(z));
    close(SfighistpeakValue(z));
    close(SfighistpeakTime(z));
    close(SfighistBeta(z));
    close(SfighistGamma(z));
    close(SfighistBetanew(z));
    close(SfighistGammanew(z));
    text = ['done ' num2str(z) ' out of ' num2str(VRmax)];
    disp(text)
end    
    
   
%Deterministic - 4 loci AND
N=numNodes; Vmax = 1:VRmax;  G = Vmax.^2; %number genotypes
%for AND case
Sprop = sp4LociAND( 3, Vmax )
%Sprop = 2./Vmax - 1./G %both loci have the same number of variants and both have 1 exploit
S = N.*Sprop; B = 0.02; beta = B.*Sprop; gamma = 0.004; %1/48*60*60 %2 days
for i = VRmin:VRmax
    [Ro(i) St(i,:) It(i,:) Rt(i,:)] = SIRDeterministic(beta(i), gamma, S(i), 1, 0, numTimesteps, 0); 
    FinalSized(i) = Rt(i,end);
     
    %resilience
     maskd = Rt(i,:) >= Rt(i,end)-1; %when within 1 of the final value
    [C Index] = max(maskd);
    MLd(i) = Index; %T1
end

dec = 50; t2 = 1:dec:numTimesteps;

%stochastic final size approximation

for h = VRmin:VRmax
  text = ['1-x = exp(-1.0*(' num2str(Sprop(h)*betan/gamma) ')*x)'] 
meanRTheory =  (solve(text, 'Real', true))*Sprop(h)*numNodes
FinalSizeS(h) = max(double(meanRTheory))
end

 
 figTest9inf0_02 = figure
 for i = VRmin:VRmax
     plot(Imean(i,:),'k')
     hold on
     plot(t2,It(i,1:dec:end),'k.-')
      plot(timeS,SImean(i,:),'k--')
 end
 ylabel('Number of nodes infected - It')
 xlabel('Timesteps')
 title('a) SI-Increasing variants: Nodes infected')
 legend('Agent', 'Deterministic', 'Stochastic')
 %axis([0 1000 0 400])
 
  figmajor = figure
 for i = VRmin:VRmax
     plot(ImeanN1(1,:),'k')
     hold on
     plot(t2,It(i,1:dec:end),'k.-')
     plot(timeS,SImeanN1(i,:),'k--')
     plot(ImeanN1(i,:),'k')
 end
xlabel('Timesteps')
ylabel('Number of individuals infected I(t)')
title('Mean of major outbreaks')
 legend('Agent', 'Deterministic', 'Stochastic')
%axis([0 100 0 90])
 
 
   %number of nodes infected
 figTest2FinalInfected = figure
 %agentImax = max(Imean,[],2);
 %plot(agentImax,'k')
 for j = VRmin:VRmax
 if isnan(FinalSizeS(j)); h(j) = 0; else h(j) = FinalSizeS(j); end;
 if isnan(FinalSize(j)); q(j) = 0; else q(j) = FinalSize(j); end;
  if isnan(SFinalSize(j)); v(j) = 0; else v(j) = SFinalSize(j); end;
 end
 FinalSize=q
 FinalSizeS=h
 SFinalSize=v
 plot(FinalSize,'ko-')
 hold on
 %plot(S,'k.-')
 plot(FinalSized,'k.-')
  plot(SFinalSize,'k+-')
 plot(FinalSizeS,'ks-')
%plot([1.8533 1.8533],[0 1],'k--')
 ylabel('Final number infected')
 xlabel('Number of variants')
 title('c) SI-Increasing variants: Final size')
 legend('Agent', 'Deterministic', 'Stochastic measured','Stochastic Approximation')
 
  %number of nodes infected
 figTest2Finalstd = figure
 %agentImax = max(Imean,[],2);
 %plot(agentImax,'k')
 for j = VRmin:VRmax
 if isnan(Rnewendstd(j)); h(j) = 0; else h(j) = Rnewendstd(j); end;
 if isnan(SRnewendstd(j)); q(j) = 0; else q(j) = SRnewendstd(j); end;
  if isnan(stdS(j)); v(j) = 0; else v(j) = stdS(j); end;
 end
 SRnewendstd=q
 Rnewendstd=h
 plot(Rnewendstd,'ko-') %agent measured
 hold on
 %plot(S,'k.-')
 plot(SRnewendstd,'ks-') %stochastic measured
 plot(stdS,'k+-') % calc approx
%plot([1.8533 1.8533],[0 1],'k--')
 ylabel('Standard deviation')
 xlabel('Number of variants')
 title('c) SI-Increasing variants: Final size std')
 legend('Agent measured', 'Stochastic measured', 'Stochastic Approximation')
 
  %RESISTANCE
 figTest2Resistance = figure
 
      %SAVE FOR LATER
Resistancea_3EXP=1-FinalSize./N;
Resistanced_3EXP=1-FinalSized./N;
Resistancesapp_3EXP=1-FinalSizeS./N;
Resistances_3EXP=1-SFinalSize./N;
Resiliencea_3EXP=1./MLa;
Resilienced_3EXP=1./MLd;
Resiliences_3EXP=1./SMLa;
Rnewendstd_3EXP=Rnewendstd
SRnewendstd_3EXP=SRnewendstd
stdS_3EXP=stdS
 
 plot(3:VRmax,Resistancea_3EXP(3:end),'ko-')
 hold on
 %plot(S,'k.-')
 plot(3:VRmax,Resistanced_3EXP(3:end),'k.-')
   plot(3:VRmax,Resistances_3EXP(3:end),'ks-')
 plot(3:VRmax,Resistancesapp_3EXP(3:end),'k+-')
 plot([1.8533 1.8533],[0 1],'k--')
 ylabel('Resistance M_R')
 xlabel('Variant Richness')
 title('c) SI-Increasing variants: Resistance')
  legend('Agent (measured)', ' Deterministic (measured)', 'Stochastic (measured)','Stochastic (approximated)')
  axis([1 8 0 1.1])
  
 %RESILIENCE major outbreaks only
 figTest2Resilience = figure
  plot(3:VRmax,Resiliencea_3EXP(3:end),'ko-') %agent measured
 hold on
 plot(3:VRmax,Resilienced_3EXP(3:end),'k.-') %deterministic
  plot(3:VRmax,Resiliences_3EXP(3:end),'ks-') %stochastic measured
 hold on
  ylabel('Resilience M_L')
 xlabel('Variant Richness')
 title('c) SI-Increasing variants: Resilience major')
  legend('Agent (measured)', ' Deterministic (measured)', 'Stochastic (measured)')
  %plot([1.8533 1.8533],[0 1],'k--')
   axis([1 8 0 1.1])


%RESILIENCE TIME of major outbreaks only
 figTest2ResilienceTime = figure
  plot(MLa,'ko-') %agent measured
 hold on
 plot(MLd,'k.-') %deterministic
  plot(SMLa,'ks-') %stochastic measured
 hold on
  ylabel('Resilience Time')
 xlabel('Variant Richness')
 title('c) SI-Increasing variants: Resilience Time major')
 legend('measured Agent', ' measured Deterministic', 'measured Stochastic')
  plot([1.8533 1.8533],[0 1],'k--')
   %axis([1 8 0 1.1])
  
saveas(figTest9inf0_02,[outputDirectory 'Test15_3EXPmeanall.fig']);
saveas(figTest9inf0_02,[outputDirectory 'Test15_3EXPmeanall.emf']); 
saveas(figmajor,[outputDirectory 'Test15_3EXPmeanmajor.fig']);
saveas(figmajor,[outputDirectory 'Test15_3EXPmeanmajor.emf']);
saveas(figTest2FinalInfected,[outputDirectory 'Test15_3EXPFinalInfected.fig']);
saveas(figTest2FinalInfected,[outputDirectory 'Test15_3EXPFinalInfected.emf']);
saveas(figTest2Resistance,[outputDirectory 'Test15_3EXPResistance.fig']);
saveas(figTest2Resistance,[outputDirectory 'Test15_3EXPResistance.emf']);
saveas(figTest2Resilience,[outputDirectory 'Test15_3EXPResilience.fig']);
saveas(figTest2Resilience,[outputDirectory 'Test15_3EXPResilience.emf']);
saveas(figTest2ResilienceTime,[outputDirectory 'Test15_3EXPResilienceTime.fig']);
saveas(figTest2ResilienceTime,[outputDirectory 'Test15_3EXPResilienceTime.emf']);
%close all


betameanmean
gammameanmean

betameanmean2
betameanmeanNew 
betameanmeanNew2
gammameanmeanNew

Rnewendmean%epidemics only
Rnewendstd

 propSimsNonEp % proportion of sims with non-epidemics
 propSimsNonEp_theoretical %theoretical value
    
R = betameanmean./gammameanmean
RN = betameanmeanNew./gammameanmeanNew
SRN = SbetameanmeanNew./SgammameanmeanNew
RTheoretical = beta./gamma

figro = figure
%plot(beta,R,'k')
hold on
plot(RN,'ko-')
plot(RTheoretical,'k.-')
plot(RN,'ks-') %stochastic measured
plot([1 1 1 1 1 1 1 1],'k--')
%plot([19 19],[0 2],'k--')
xlabel('Number of variants')
ylabel('ro')
%legend('R','RNew','Rtheoretical') 
legend('Ro Agent(measured)','Ro Deterministic','Ro Stochastic(measured)') 
%axis([0.1 0.5 0 2])
saveas(figro,[outputDirectory 'Test15_3EXPfigro.fig']);
saveas(figro,[outputDirectory 'Test15_3EXPfigro.emf']);
%close all
%close all;

%calculate proportion of minor and major outbreaks
[ minorCalc majorCalc ] = propCalcOutbreaks( Sprop, B, gamma )

%measure proportion of minor and major outbreaks
%agent
%numRunsMinor measuredProbMinor numRunsMajor measuredProbMajor
numRunsMinor
numRunsMajor
measuredProbMinor
measuredProbMajor
%stochastic
%SnumRunsMinor SmeasuredProbMinor SnumRunsMajor SmeasuredProbMajor
SnumRunsMinor
SnumRunsMajor
SmeasuredProbMinor
SmeasuredProbMajor

figMinorProb = figure;
plot(measuredProbMinor,'ko-') %agent
hold on
plot(SmeasuredProbMinor,'ks-') %stochastic
plot(minorCalc,'k+-') %calc
xlabel('Variant Richness')
ylabel('proportion of minor outbreaks')
%legend('R','RNew','Rtheoretical') 
legend('Agent (measured)','Stochastic (measured)', 'Stochastic (approximated)')
title('probability of minor outbreak 2 exploits')

figMajorProb = figure;
plot(measuredProbMajor,'ko-') %agent
hold on
plot(SmeasuredProbMajor,'ks-') %stochastic
plot(majorCalc,'k+-') %calc
xlabel('Variant Richness')
ylabel('proportion of major outbreaks')
%legend('R','RNew','Rtheoretical') 
legend('Agent (measured)','Stochastic (measured)', 'Stochastic (approximated)')
title('probability of major outbreak 2 exploits')

saveas(figMinorProb,[outputDirectory 'Test15_3EXPfigMinorProb.fig']);
saveas(figMinorProb,[outputDirectory 'Test15_3EXPfigMinorProb.emf']);
saveas(figMajorProb,[outputDirectory 'Test15_3EXPfigMajorProb.fig']);
saveas(figMajorProb,[outputDirectory 'Test15_3EXPfigMajorProb.emf']);
%COMBINED EXPLOIT GRAPHS

%std
Rnewendstd_1EXP=Rnewendstd
SRnewendstd_1EXP=SRnewendstd
stdS_EXP=stdS

 figTest2StdAllExploits = figure
 plot(Rnewendstd_1EXP,'ko-','linewidth',2) %agent
 hold on
 plot(stdS_1EXP,'k+-','linewidth',2)  %stochastic approx
plot(SRnewendstd_1EXP,'ks-','linewidth',2)%stochastic

plot(Rnewendstd_2EXP,'ko-') %agent
 plot(stdS_2EXP,'k+-')  %stochastic approx
plot(SRnewendstd_2EXP,'ks-')%stochastic

plot(Rnewendstd_3EXP,'ko-') %agent
 plot(stdS_3EXP,'k+-')  %stochastic approx
plot(SRnewendstd_3EXP,'ks-')%stochastic

 ylabel('Standard deviation of final size distribution')
 xlabel('Variant Richness')
 title('c) SI-Increasing variants: std')
 legend('measured Agent', 'approximated Stochastic','measured Stochastic')
  plot([1.8533 1.8533],[0 1],'k--')
% axis([1 8 0 1.1])

  %RESISTANCE
 figTest2ResistanceAllExploits = figure

  plot(Resistancea_1EXP,'ko-','linewidth',2)
 hold on
 plot(Resistanced_1EXP,'k.-','linewidth',2)
 plot(Resistancesapp_1EXP,'k+-','linewidth',2)
plot(Resistances_1EXP,'ks-','linewidth',2)

  plot(2:VRmax,Resistancea_2EXP(2:end),'ko-')
 plot(2:VRmax,Resistanced_2EXP(2:end),'k.-')
 plot(2:VRmax,Resistancesapp_2EXP(2:end),'k+-')
plot(2:VRmax,Resistances_2EXP(2:end),'ks-')

 plot(3:VRmax,Resistancea_3EXP(3:end),'ko-')
 plot(3:VRmax,Resistanced_3EXP(3:end),'k.-')
 plot(3:VRmax,Resistancesapp_3EXP(3:end),'k+-')
plot(3:VRmax,Resistances_3EXP(3:end),'ks-')

 plot([1.8533 1.8533],[0 1],'k--')
 ylabel('Resistance M_R')
 xlabel('Variant Richness')
 title('c) SI-Increasing variants: Resistance')
 legend('measured Agent', ' measured Deterministic', 'approximated Stochastic','measured Stochastic')
 axis([1 8 0 1.1])
 
 %RESILIENCE major outbreaks only
 figTest2ResilienceAllExploits = figure
 plot(Resiliencea_1EXP,'ko-','linewidth',2) %agent
 hold on
 plot(Resilienced_1EXP,'k.-','linewidth',2) %deterministic
plot(Resiliences_1EXP,'ks-','linewidth',2) %stochastic measured

 plot(2:VRmax,Resiliencea_2EXP(2:end),'ko-') %agent
 plot(2:VRmax,Resilienced_2EXP(2:end),'k.-') %deterministic
plot(2:VRmax,Resiliences_2EXP(2:end),'ks-') %stochastic measured

 plot(3:VRmax,Resiliencea_3EXP(3:end),'ko-') %agent
 plot(3:VRmax,Resilienced_3EXP(3:end),'k.-') %deterministic
plot(3:VRmax,Resiliences_3EXP(3:end),'ks-') %stochastic measured
  ylabel('Resilience M_L')
 xlabel('Variant Richness')
 title('c) SI-Increasing variants: Resilience major')
 legend('measured Agent', ' measured Deterministic', 'measured Stochastic')
  plot([1.8533 1.8533],[0 1],'k--')
 axis([1 8 0 1.1])
  
  saveas(figTest2ResistanceAllExploits,[outputDirectory 'Test15_ALLEXPResistenceAll.fig']);
saveas(figTest2ResistanceAllExploits,[outputDirectory 'Test15_ALLEXPResistenceAll.emf']);
saveas(figTest2ResilienceAllExploits,[outputDirectory 'Test15_ALLEXPResilienceAll.fig']);
saveas(figTest2ResilienceAllExploits,[outputDirectory 'Test15_ALLEXPResilienceAll.emf']);

toc

%saved data
Resistancea_1EXP
Resistanced_1EXP
Resistancesapp_1EXP
Resistances_1EXP

Resistancea_2EXP
Resistanced_2EXP
Resistancesapp_2EXP
Resistances_2EXP

Resistancea_3EXP
Resistanced_3EXP
Resistancesapp_3EXP
Resistances_3EXP

Resiliencea_1EXP
Resilienced_1EXP
Resiliences_1EXP

Resiliencea_2EXP
Resilienced_2EXP
Resiliences_2EXP

Resiliencea_3EXP
Resilienced_3EXP
Resiliences_3EXP

end %SIRN Test15

% SIRN TEST 16
% SIR - 4 loci OR fix exploit at 2 and increase variants - takes 14 hours
%***************
if doSIRNTests(16) == 1
    %outputDirectory = 'Graphs\'
outputDirectory = 'Graphs\'
%Increase variants upto 50, fix exploit
%***************************************
%SIRN testing
%***************************************
%Deterministic - 4 loci OR
tic
numNodes = 1000;
VRmin = 1 %25
VRmax = 50 %25
N=numNodes; Vmax = 1:VRmax;  G = Vmax.^2; %number genotypes
%for OR case
Sprop = SPExact4LociOR( 2, Vmax )
mode = 'static'
%monte carlo random genotype SIR model
numRuns = 100 %100 %200

%set up diversity mode parameters
modePar.modeStr = mode
modePar.numToConstrain = 0 %constain a number of nodes to 1 variant
modePar.stopUpdatingTime = 20000 %time at which to stop updating the genotypes
%modePar.numEncountersBetweenUpdates = 1 % number of encounters between updates for random and favscore algorithms
modePar.bufferlength = 10 %length of genotype buffer for favscore algorithm
modePar.genoInit = 'maxdiv'  %initial conditions of genotypes maxdiv (maximum diversity - random variant chosen) mindiv (minimum diversity - all nodes same)


for z= VRmin:VRmax
 betan = 0.02; variantRichness =  z;  numTimesteps = 7000; plotGraphs = 0; gamma = 0.004; numExploits=2; numLoci=4; casetype = 'OR'; throwAway = 'nonEpidemics', cutoff = gamma.*numNodes./(betan.*Sprop); SEpidemic=60; %cutoff;
%agent
 [figMeanNei(z) figNeiOneRun(z) fighistSpRun(z) fighistRecovered(z) fighistSusceptible(z) fighistpeakValue(z) fighistpeakTime(z) fighistBeta(z) fighistGamma(z) fighistBetanew(z) fighistGammanew(z) figInfectedRun1 figBetaRun1 figGammaRun1 figRoRun1 figBetaGamma1 figBetaGamma2...
            meanNeiIndexDynamicF  betastd gammastd betastd2 betastdNew betastdNew2 gammastdNew peakTimemean peakTimestd peakValuemean peakValuestd...
            betameanmean(z) gammameanmean betameanmean2(z) betameanmeanNew(z) betameanmeanNew2 gammameanmeanNew(z) Smean(z,:) Imean(z,:) Rmean(z,:) Bmean NSmean(z,:) Smedian Imedian Rmedian S I R NS SmeanN ImeanN1(z,:) RmeanN1 BmeanN1 Snewendmean Snewendstd Rnewendmean(z) Rnewendstd(z) Rnew_nonendmean Rnew_nonendstd propSimsNonEp(z) propSimsNonEp_theoretical(z)...
            numRunsMinor(z) measuredProbMinor(z) numRunsMajor(z) measuredProbMajor(z) ...
            ] = monteCarloSIRN2(numRuns,numNodes, betan, variantRichness, numTimesteps, plotGraphs,gamma,throwAway,SEpidemic,numExploits,modePar, numLoci, casetype);
   size(ImeanN1)
FinalSize(z) = max(RmeanN1,[],2) %mean final size
    %resilience of major only
     maska = RmeanN1 >= FinalSize(z)-1; %when within 1 of the final value
    [C Index] = max(maska);
    MLa(z) = Index; %T1
    RmeanN1;
    size(RmeanN1)
    size(Index)
        %resilience of all
     maska = Rmean(z,:) >= FinalSize(z)-1; %when within 1 of the final value
    [C Index] = max(maska);
        size(Rmean(z,:))
    size(Index)
    MLa_all(z) = Index; %T1
         saveas(fighistSpRun(z),[outputDirectory 'Test16fighistSpRun' num2str(z) '.fig']);
    saveas(fighistSpRun(z),[outputDirectory 'Test16fighistSpRun' num2str(z) '.emf']);
        saveas(fighistRecovered(z),[outputDirectory 'Test16fighistRecovered' num2str(z) '.fig']);
    saveas(fighistRecovered(z),[outputDirectory 'Test16fighistRecovered' num2str(z) '.emf']);
    saveas(fighistSusceptible(z),[outputDirectory 'Test16fighistSusceptible' num2str(z) '.fig']);
    saveas(fighistSusceptible(z),[outputDirectory 'Test16fighistSusceptible' num2str(z) '.emf']);
    saveas(fighistpeakValue(z),[outputDirectory 'Test16fighistpeakValue' num2str(z) '.fig']);
    saveas(fighistpeakValue(z),[outputDirectory 'Test16fighistpeakValue' num2str(z) '.emf']);
    saveas(fighistpeakTime(z),[outputDirectory 'Test16fighistpeakTime' num2str(z) '.fig']);
    saveas(fighistpeakTime(z),[outputDirectory 'Test16fighistpeakTime' num2str(z) '.emf']);
    saveas(fighistBeta(z),[outputDirectory 'Test16histBeta' num2str(z) '.fig']);
    saveas(fighistBeta(z),[outputDirectory 'Test16histBeta' num2str(z) '.emf']);
    saveas(fighistGamma(z),[outputDirectory 'Test16histGamma' num2str(z) '.fig']);
    saveas(fighistGamma(z),[outputDirectory 'Test16histGamma' num2str(z) '.emf']);
    saveas(fighistBetanew(z),[outputDirectory 'Test16histBetaNew' num2str(z) '.fig']);
    saveas(fighistBetanew(z),[outputDirectory 'Test16histBetaNew' num2str(z) '.emf']);
    saveas(fighistGammanew(z),[outputDirectory 'Test16histGammaNew' num2str(z) '.fig']);
    saveas(fighistGammanew(z),[outputDirectory 'Test16histGammaNew' num2str(z) '.emf']);
    close(fighistRecovered(z));
    close(fighistSusceptible(z));
    close(fighistpeakValue(z));
    close(fighistpeakTime(z));
    close(fighistBeta(z));
    close(fighistGamma(z));
    close(fighistBetanew(z));
    close(fighistGammanew(z));
    
    %stochastic
        dtt=0.1 %stochastic dtt = used in graph and set in function
    timeS = dtt:dtt:numTimesteps;%stochastic time for graphs
    [SfighistRecovered(z) SfighistSusceptible(z) SfighistpeakValue(z) SfighistpeakTime(z) SfighistBeta(z) SfighistGamma(z) SfighistBetanew(z) SfighistGammanew(z) SfigInfectedRun1 SfigBetaRun1 SfigGammaRun1 SfigRoRun1 SfigBetaGamma1 SfigBetaGamma2...
            Sbetastd Sgammastd Sbetastd2 SbetastdNew SbetastdNew2 SgammastdNew SpeakTimemean SpeakTimestd SpeakValuemean SpeakValuestd...
            Sbetameanmean(z) Sgammameanmean Sbetameanmean2(z) SbetameanmeanNew(z) SbetameanmeanNew2 SgammameanmeanNew(z) SSmean(z,:) SImean(z,:) SRmean(z,:) SNSmean(z,:) SSmedian SImedian SRmedian SS SI SR SNS SSmeanN SImeanN1(z,:) SRmeanN1 SSnewendmean SSnewendstd SRnewendmean(z) SRnewendstd(z) SRnew_nonendmean SRnew_nonendstd SpropSimsNonEp(z) SpropSimsNonEp_theoretical(z)...
            SnumRunsMinor(z) SmeasuredProbMinor(z) SnumRunsMajor(z) SmeasuredProbMajor(z) ...
            ] = monteCarloStochastic(numRuns,numNodes, betan, variantRichness, numTimesteps, plotGraphs,gamma,throwAway,SEpidemic,numExploits,mode, numLoci, casetype);
     size(SImeanN1)
SFinalSize(z) = max(SRmeanN1,[],2) %mean final size
    %resilience of major only
     Smaska = SRmeanN1 >= SFinalSize(z)-1; %when within 1 of the final value
    [SC SIndex] = max(Smaska);
    SMLa(z) = ceil(SIndex.*dtt); %T1
        %resilience of all
     Smaska = SRmean(z,:) >= SFinalSize(z)-1; %when within 1 of the final value
    [SC SIndex] = max(Smaska);
    SMLa_all(z) = ceil(SIndex.*dtt); %T1
        saveas(SfighistRecovered(z),[outputDirectory 'Test16StochfighistRecovered' num2str(z) '.fig']);
    saveas(SfighistRecovered(z),[outputDirectory 'Test16StochfighistRecovered' num2str(z) '.emf']);
    saveas(SfighistSusceptible(z),[outputDirectory 'Test16StochfighistSusceptible' num2str(z) '.fig']);
    saveas(SfighistSusceptible(z),[outputDirectory 'Test16StochfighistSusceptible' num2str(z) '.emf']);
    saveas(SfighistpeakValue(z),[outputDirectory 'Test16StochfighistpeakValue' num2str(z) '.fig']);
    saveas(SfighistpeakValue(z),[outputDirectory 'Test16StochfighistpeakValue' num2str(z) '.emf']);
    saveas(SfighistpeakTime(z),[outputDirectory 'Test16StochfighistpeakTime' num2str(z) '.fig']);
    saveas(SfighistpeakTime(z),[outputDirectory 'Test16StochfighistpeakTime' num2str(z) '.emf']);
    saveas(SfighistBeta(z),[outputDirectory 'Test16StochhistBeta' num2str(z) '.fig']);
    saveas(SfighistBeta(z),[outputDirectory 'Test16StochhistBeta' num2str(z) '.emf']);
    saveas(SfighistGamma(z),[outputDirectory 'Test16StochhistGamma' num2str(z) '.fig']);
    saveas(SfighistGamma(z),[outputDirectory 'Test16StochhistGamma' num2str(z) '.emf']);
    saveas(SfighistBetanew(z),[outputDirectory 'Test16StochhistBetaNew' num2str(z) '.fig']);
    saveas(SfighistBetanew(z),[outputDirectory 'Test16StochhistBetaNew' num2str(z) '.emf']);
    saveas(SfighistGammanew(z),[outputDirectory 'Test16StochhistGammaNew' num2str(z) '.fig']);
    saveas(SfighistGammanew(z),[outputDirectory 'Test16StochhistGammaNew' num2str(z) '.emf']);
    close(SfighistRecovered(z));
    close(SfighistSusceptible(z));
    close(SfighistpeakValue(z));
    close(SfighistpeakTime(z));
    close(SfighistBeta(z));
    close(SfighistGamma(z));
    close(SfighistBetanew(z));
    close(SfighistGammanew(z));
    text = ['done ' num2str(z) ' out of ' num2str(VRmax)];
    disp(text)
end    
    
    
    %Histograms
% for i = 1:VRmax
%    saveas(fighistRecovered(i),[outputDirectory 'Test14fighistRecovered' num2str(i) '.fig']);
%    saveas(fighistRecovered(i),[outputDirectory 'Test14fighistRecovered' num2str(i) '.emf']);
%    saveas(fighistSusceptible(i),[outputDirectory 'Test14fighistSusceptible' num2str(i) '.fig']);
%    saveas(fighistSusceptible(i),[outputDirectory 'Test14fighistSusceptible' num2str(i) '.emf']);
%    saveas(fighistpeakValue(i),[outputDirectory 'Test14fighistpeakValue' num2str(i) '.fig']);
%    saveas(fighistpeakValue(i),[outputDirectory 'Test14fighistpeakValue' num2str(i) '.emf']);
%    saveas(fighistpeakTime(i),[outputDirectory 'Test14fighistpeakTime' num2str(i) '.fig']);
%    saveas(fighistpeakTime(i),[outputDirectory 'Test14fighistpeakTime' num2str(i) '.emf']);
%    saveas(fighistBeta(i),[outputDirectory 'Test14histBeta' num2str(i) '.fig']);
%    saveas(fighistBeta(i),[outputDirectory 'Test14histBeta' num2str(i) '.emf']);
%    saveas(fighistGamma(i),[outputDirectory 'Test14histGamma' num2str(i) '.fig']);
%    saveas(fighistGamma(i),[outputDirectory 'Test14histGamma' num2str(i) '.emf']);
%    saveas(fighistBetanew(i),[outputDirectory 'Test14histBetaNew' num2str(i) '.fig']);
%    saveas(fighistBetanew(i),[outputDirectory 'Test14histBetaNew' num2str(i) '.emf']);
%    saveas(fighistGammanew(i),[outputDirectory 'Test14histGammaNew' num2str(i) '.fig']);
%    saveas(fighistGammanew(i),[outputDirectory 'Test14histGammaNew' num2str(i) '.emf']);
% end
% close all;
%Deterministic - 4 loci OR
N=numNodes; Vmax = 1:VRmax;  G = Vmax.^2; %number genotypes
%for OR case
Sprop = SPExact4LociOR( 2, Vmax )
%Sprop = 2./Vmax - 1./G %both loci have the same number of variants and both have 1 exploit
S = N.*Sprop; B = 0.02; beta = B.*Sprop; gamma = 0.004; %1/48*60*60 %2 days
for i = VRmin:VRmax
    [Ro(i) St(i,:) It(i,:) Rt(i,:)] = SIRDeterministic(beta(i), gamma, S(i), 1, 0, numTimesteps, 0); 
    FinalSized(i) = Rt(i,end);
     
    %resilience
     maskd = Rt(i,:) >= Rt(i,end)-1; %when within 1 of the final value
    [C Index] = max(maskd);
    MLd(i) = Index; %T1
end

dec = 50; t2 = 1:dec:numTimesteps;

%stochastic final size approximation

for h = VRmin:VRmax
  text = ['1-x = exp(-1.0*(' num2str(Sprop(h)*betan/gamma) ')*x)'] 
meanRTheory =  (solve(text, 'Real', true))*Sprop(h)*numNodes
FinalSizeS(h) = max(double(meanRTheory))
end

 
 figTest9inf0_02 = figure
 for i = VRmin:VRmax
     plot(Imean(i,:),'k')
     hold on
     plot(t2,It(i,1:dec:end),'k.-')
      plot(timeS,SImean(i,:),'k--')
 end
 ylabel('Number of nodes infected - It')
 xlabel('Timesteps')
 title('a) SI-Increasing variants: Nodes infected')
 legend('Agent', 'Deterministic', 'Stochastic')
 %axis([0 1000 0 400])
 
  figmajor = figure
 for i = VRmin:VRmax
     plot(ImeanN1(1,:),'k')
     hold on
     plot(t2,It(i,1:dec:end),'k.-')
     plot(timeS,SImeanN1(i,:),'k--')
     plot(ImeanN1(i,:),'k')
 end
xlabel('Timesteps')
ylabel('Number of individuals infected I(t)')
title('Mean of major outbreaks')
 legend('Agent', 'Deterministic', 'Stochastic')
%axis([0 100 0 90])
 
 
 %number of nodes infected
 figTest2FinalInfected = figure
 %agentImax = max(Imean,[],2);
 %plot(agentImax,'k')
 for j = VRmin:VRmax
 if isnan(FinalSizeS(j)); h(j) = 0; else h(j) = FinalSizeS(j); end;
 if isnan(FinalSize(j)); q(j) = 0; else q(j) = FinalSize(j); end;
 end
 FinalSize=q
 FinalSizeS=h
 plot(FinalSize,'ko-')
 hold on
 %plot(S,'k.-')
 plot(FinalSized,'k.-')
 plot(FinalSizeS,'k+-')
%plot([18.615 18.615],[0 1],'k--')
 ylabel('Final number infected')
 xlabel('Number of variants')
 title('c) SI-Increasing variants: Final size')
 legend('Agent', 'Deterministic', 'Stochastic Approximation')
 
  %RESISTANCE
 figTest2Resistance = figure
 %agentImax = max(Imean,[],2);
 %plot(agentImax,'k')
 for j = VRmin:VRmax
 %if isnan(FinalSizeS(j)); h(j) = 0; else h(j) = FinalSizeS(j); end; %STOCHASTIC APPROX
 %if isnan(FinalSize(j)); q(j) = 0; else q(j) = FinalSize(j); end; %AGENT
 if isnan(SFinalSize(j)); w(j) = 0; else w(j) = SFinalSize(j); end; %STOCHASTIC MEASURED
 end
 FinalSize=q
 FinalSizeS=h
 SFinalSize=w
 plot(1-FinalSize./N,'ko-')
 hold on
 %plot(S,'k.-')
 plot(1-FinalSized./N,'k.-')
 plot(1-FinalSizeS./N,'k+-')
  plot(1-SFinalSize./N,'ks-')
%plot([18.615 18.615],[0 1],'k--')
 ylabel('Resistance M_R')
 xlabel('Variant Richness')
 title('c) SI-Increasing variants: Resistance')
 legend('measured Agent', ' measured Deterministic', 'approximated Stochastic','measured Stochastic')
 
 %RESILIENCE major outbreaks only
 figTest2Resilience = figure
  plot(1./MLa,'ko-') %agent measured
 hold on
 plot(1./MLd,'k.-') %deterministic
  plot(1./SMLa,'ks-') %stochastic measured
 hold on
  ylabel('Resilience M_L')
 xlabel('Variant Richness')
 title('c) SI-Increasing variants: Resilience major')
 legend('measured Agent', ' measured Deterministic', 'measured Stochastic')
 %plot([18.615 18.615],[0 1],'k--')

%RESILIENCE TIME of major outbreaks only
 figTest2ResilienceTime = figure
  plot(MLa,'ko-') %agent measured
 hold on
 plot(MLd,'k.-') %deterministic
  plot(SMLa,'ks-') %stochastic measured
 hold on
  ylabel('Resilience Time')
 xlabel('Variant Richness')
 title('c) SI-Increasing variants: Resilience Time major')
 legend('measured Agent', ' measured Deterministic', 'measured Stochastic')
 % plot([1.8533 1.8533],[0 1],'k--')
   %axis([1 8 0 1.1])
 
saveas(figTest9inf0_02,[outputDirectory 'Test16meanall.fig']);
saveas(figTest9inf0_02,[outputDirectory 'Test16meanall.emf']); 
saveas(figmajor,[outputDirectory 'Test16meanmajor.fig']);
saveas(figmajor,[outputDirectory 'Test16meanmajor.emf']);
saveas(figTest2FinalInfected,[outputDirectory 'Test16FinalInfected.fig']);
saveas(figTest2FinalInfected,[outputDirectory 'Test16FinalInfected.emf']);
saveas(figTest2Resistance,[outputDirectory 'Test16Resistance.fig']);
saveas(figTest2Resistance,[outputDirectory 'Test16Resistance.emf']);
saveas(figTest2Resilience,[outputDirectory 'Test16Resilience.fig']);
saveas(figTest2Resilience,[outputDirectory 'Test16Resilience.emf']);
saveas(figTest2ResilienceTime,[outputDirectory 'Test16ResilienceTime.fig']);
saveas(figTest2ResilienceTime,[outputDirectory 'Test16ResilienceTime.emf']);
%close all


betameanmean
gammameanmean

betameanmean2
betameanmeanNew 
betameanmeanNew2
gammameanmeanNew

Rnewendmean%epidemics only
Rnewendstd

 propSimsNonEp % proportion of sims with non-epidemics
 propSimsNonEp_theoretical %theoretical value
    
R = betameanmean./gammameanmean
RN = betameanmeanNew./gammameanmeanNew
SRN = SbetameanmeanNew./SgammameanmeanNew
RTheoretical = beta./gamma

figro = figure
%plot(beta,R,'k')
hold on
plot(RN,'ko-')
plot(RTheoretical,'k.-')
plot(RN,'ks-') %stochastic measured
plot([1 1 1 1 1 1 1 1],'k--')
%plot([18.615 18.615],[0 1],'k--')
xlabel('Number of variants')
ylabel('ro')
%legend('R','RNew','Rtheoretical') 
legend('Ro Agent(measured)','Ro Deterministic','Ro Stochastic(measured)') 
%axis([0.1 0.5 0 2])
saveas(figro,[outputDirectory 'Test16figro.fig']);
saveas(figro,[outputDirectory 'Test16figro.emf']);
%close all
%close all;
toc
   %SAVE FOR LATER
Resistancea_2EXP=1-FinalSize./N
Resistanced_2EXP=1-FinalSized./N
Resistancesapp_2EXP=1-FinalSizeS./N
Resistances_2EXP=1-SFinalSize./N
Resiliencea_2EXP=1./MLa
Resilienced_2EXP=1./MLd
Resiliences_2EXP=1./SMLa


%saved data


end %SIRN Test16

% SIRN TEST 17
% SIR - 4 loci OR fix exploit at 3 and increase variants - takes 18hrs ??
%***************
if doSIRNTests(17) == 1
    %outputDirectory = 'Graphs\' 
outputDirectory = 'Graphs\'
%Increase variants upto 70, fix exploit
%***************************************
%SIRN testing
%***************************************
%Deterministic - 4 loci OR
tic
numNodes = 1000;
VRmin = 1 %25
VRmax = 70 %25
N=numNodes; Vmax = 1:VRmax;  G = Vmax.^2; %number genotypes
%for OR case
Sprop = SPExact4LociOR( 3, Vmax )
mode = 'static'
%monte carlo random genotype SIR model
numRuns = 100 %100 %200

%set up diversity mode parameters
modePar.modeStr = mode
modePar.numToConstrain = 0 %constain a number of nodes to 1 variant
modePar.stopUpdatingTime = 20000 %time at which to stop updating the genotypes
%modePar.numEncountersBetweenUpdates = 1 % number of encounters between updates for random and favscore algorithms
modePar.bufferlength = 10 %length of genotype buffer for favscore algorithm
modePar.genoInit = 'maxdiv'  %initial conditions of genotypes maxdiv (maximum diversity - random variant chosen) mindiv (minimum diversity - all nodes same)


for z= VRmin:VRmax
 betan = 0.02; variantRichness =  z;  numTimesteps = 7000; plotGraphs = 0; gamma = 0.004; numExploits=3; numLoci=4; casetype = 'OR'; throwAway = 'nonEpidemics', cutoff = gamma.*numNodes./(betan.*Sprop); SEpidemic=60; %cutoff;
%agent
 [figMeanNei(z) figNeiOneRun(z) fighistSpRun(z) fighistRecovered(z) fighistSusceptible(z) fighistpeakValue(z) fighistpeakTime(z) fighistBeta(z) fighistGamma(z) fighistBetanew(z) fighistGammanew(z) figInfectedRun1 figBetaRun1 figGammaRun1 figRoRun1 figBetaGamma1 figBetaGamma2...
            meanNeiIndexDynamicF  betastd gammastd betastd2 betastdNew betastdNew2 gammastdNew peakTimemean peakTimestd peakValuemean peakValuestd...
            betameanmean(z) gammameanmean betameanmean2(z) betameanmeanNew(z) betameanmeanNew2 gammameanmeanNew(z) Smean(z,:) Imean(z,:) Rmean(z,:) Bmean NSmean(z,:) Smedian Imedian Rmedian S I R NS SmeanN ImeanN1(z,:) RmeanN1 BmeanN1 Snewendmean Snewendstd Rnewendmean(z) Rnewendstd(z) Rnew_nonendmean Rnew_nonendstd propSimsNonEp(z) propSimsNonEp_theoretical(z)...
            numRunsMinor(z) measuredProbMinor(z) numRunsMajor(z) measuredProbMajor(z) ...
            ] = monteCarloSIRN2(numRuns,numNodes, betan, variantRichness, numTimesteps, plotGraphs,gamma,throwAway,SEpidemic,numExploits,modePar, numLoci, casetype);
   size(ImeanN1)
FinalSize(z) = max(RmeanN1,[],2) %mean final size
    %resilience of major only
     maska = RmeanN1 >= FinalSize(z)-1; %when within 1 of the final value
    [C Index] = max(maska);
    MLa(z) = Index; %T1
    RmeanN1;
    size(RmeanN1)
    size(Index)
        %resilience of all
     maska = Rmean(z,:) >= FinalSize(z)-1; %when within 1 of the final value
    [C Index] = max(maska);
        size(Rmean(z,:))
    size(Index)
    MLa_all(z) = Index; %T1
         saveas(fighistSpRun(z),[outputDirectory 'Test17fighistSpRun' num2str(z) '.fig']);
    saveas(fighistSpRun(z),[outputDirectory 'Test17fighistSpRun' num2str(z) '.emf']);
        saveas(fighistRecovered(z),[outputDirectory 'Test17fighistRecovered' num2str(z) '.fig']);
    saveas(fighistRecovered(z),[outputDirectory 'Test17fighistRecovered' num2str(z) '.emf']);
    saveas(fighistSusceptible(z),[outputDirectory 'Test17fighistSusceptible' num2str(z) '.fig']);
    saveas(fighistSusceptible(z),[outputDirectory 'Test17fighistSusceptible' num2str(z) '.emf']);
    saveas(fighistpeakValue(z),[outputDirectory 'Test17fighistpeakValue' num2str(z) '.fig']);
    saveas(fighistpeakValue(z),[outputDirectory 'Test17fighistpeakValue' num2str(z) '.emf']);
    saveas(fighistpeakTime(z),[outputDirectory 'Test17fighistpeakTime' num2str(z) '.fig']);
    saveas(fighistpeakTime(z),[outputDirectory 'Test17fighistpeakTime' num2str(z) '.emf']);
    saveas(fighistBeta(z),[outputDirectory 'Test17histBeta' num2str(z) '.fig']);
    saveas(fighistBeta(z),[outputDirectory 'Test17histBeta' num2str(z) '.emf']);
    saveas(fighistGamma(z),[outputDirectory 'Test17histGamma' num2str(z) '.fig']);
    saveas(fighistGamma(z),[outputDirectory 'Test17histGamma' num2str(z) '.emf']);
    saveas(fighistBetanew(z),[outputDirectory 'Test17histBetaNew' num2str(z) '.fig']);
    saveas(fighistBetanew(z),[outputDirectory 'Test17histBetaNew' num2str(z) '.emf']);
    saveas(fighistGammanew(z),[outputDirectory 'Test17histGammaNew' num2str(z) '.fig']);
    saveas(fighistGammanew(z),[outputDirectory 'Test17histGammaNew' num2str(z) '.emf']);
    close(fighistRecovered(z));
    close(fighistSusceptible(z));
    close(fighistpeakValue(z));
    close(fighistpeakTime(z));
    close(fighistBeta(z));
    close(fighistGamma(z));
    close(fighistBetanew(z));
    close(fighistGammanew(z));
    
    %stochastic
        dtt=0.1 %stochastic dtt = used in graph and set in function
    timeS = dtt:dtt:numTimesteps;%stochastic time for graphs
    [SfighistRecovered(z) SfighistSusceptible(z) SfighistpeakValue(z) SfighistpeakTime(z) SfighistBeta(z) SfighistGamma(z) SfighistBetanew(z) SfighistGammanew(z) SfigInfectedRun1 SfigBetaRun1 SfigGammaRun1 SfigRoRun1 SfigBetaGamma1 SfigBetaGamma2...
            Sbetastd Sgammastd Sbetastd2 SbetastdNew SbetastdNew2 SgammastdNew SpeakTimemean SpeakTimestd SpeakValuemean SpeakValuestd...
            Sbetameanmean(z) Sgammameanmean Sbetameanmean2(z) SbetameanmeanNew(z) SbetameanmeanNew2 SgammameanmeanNew(z) SSmean(z,:) SImean(z,:) SRmean(z,:) SNSmean(z,:) SSmedian SImedian SRmedian SS SI SR SNS SSmeanN SImeanN1(z,:) SRmeanN1 SSnewendmean SSnewendstd SRnewendmean(z) SRnewendstd(z) SRnew_nonendmean SRnew_nonendstd SpropSimsNonEp(z) SpropSimsNonEp_theoretical(z)...
            SnumRunsMinor(z) SmeasuredProbMinor(z) SnumRunsMajor(z) SmeasuredProbMajor(z) ...
            ] = monteCarloStochastic(numRuns,numNodes, betan, variantRichness, numTimesteps, plotGraphs,gamma,throwAway,SEpidemic,numExploits,mode, numLoci, casetype);
     size(SImeanN1)
SFinalSize(z) = max(SRmeanN1,[],2) %mean final size
    %resilience of major only
     Smaska = SRmeanN1 >= SFinalSize(z)-1; %when within 1 of the final value
    [SC SIndex] = max(Smaska);
    SMLa(z) = ceil(SIndex.*dtt); %T1
        %resilience of all
     Smaska = SRmean(z,:) >= SFinalSize(z)-1; %when within 1 of the final value
    [SC SIndex] = max(Smaska);
    SMLa_all(z) = ceil(SIndex.*dtt); %T1
        saveas(SfighistRecovered(z),[outputDirectory 'Test17StochfighistRecovered' num2str(z) '.fig']);
    saveas(SfighistRecovered(z),[outputDirectory 'Test17StochfighistRecovered' num2str(z) '.emf']);
    saveas(SfighistSusceptible(z),[outputDirectory 'Test17StochfighistSusceptible' num2str(z) '.fig']);
    saveas(SfighistSusceptible(z),[outputDirectory 'Test17StochfighistSusceptible' num2str(z) '.emf']);
    saveas(SfighistpeakValue(z),[outputDirectory 'Test17StochfighistpeakValue' num2str(z) '.fig']);
    saveas(SfighistpeakValue(z),[outputDirectory 'Test17StochfighistpeakValue' num2str(z) '.emf']);
    saveas(SfighistpeakTime(z),[outputDirectory 'Test17StochfighistpeakTime' num2str(z) '.fig']);
    saveas(SfighistpeakTime(z),[outputDirectory 'Test17StochfighistpeakTime' num2str(z) '.emf']);
    saveas(SfighistBeta(z),[outputDirectory 'Test17StochhistBeta' num2str(z) '.fig']);
    saveas(SfighistBeta(z),[outputDirectory 'Test17StochhistBeta' num2str(z) '.emf']);
    saveas(SfighistGamma(z),[outputDirectory 'Test17StochhistGamma' num2str(z) '.fig']);
    saveas(SfighistGamma(z),[outputDirectory 'Test17StochhistGamma' num2str(z) '.emf']);
    saveas(SfighistBetanew(z),[outputDirectory 'Test17StochhistBetaNew' num2str(z) '.fig']);
    saveas(SfighistBetanew(z),[outputDirectory 'Test17StochhistBetaNew' num2str(z) '.emf']);
    saveas(SfighistGammanew(z),[outputDirectory 'Test17StochhistGammaNew' num2str(z) '.fig']);
    saveas(SfighistGammanew(z),[outputDirectory 'Test17StochhistGammaNew' num2str(z) '.emf']);
    close(SfighistRecovered(z));
    close(SfighistSusceptible(z));
    close(SfighistpeakValue(z));
    close(SfighistpeakTime(z));
    close(SfighistBeta(z));
    close(SfighistGamma(z));
    close(SfighistBetanew(z));
    close(SfighistGammanew(z));
    text = ['done ' num2str(z) ' out of ' num2str(VRmax)];
    disp(text)
end    
    
  
%Deterministic - 4 loci OR
N=numNodes; Vmax = 1:VRmax;  G = Vmax.^2; %number genotypes
%for OR case
Sprop = SPExact4LociOR( 3, Vmax )
%Sprop = 2./Vmax - 1./G %both loci have the same number of variants and both have 1 exploit
S = N.*Sprop; B = 0.02; beta = B.*Sprop; gamma = 0.004; %1/48*60*60 %2 days
for i = VRmin:VRmax
    [Ro(i) St(i,:) It(i,:) Rt(i,:)] = SIRDeterministic(beta(i), gamma, S(i), 1, 0, numTimesteps, 0); 
    FinalSized(i) = Rt(i,end);
     
    %resilience
     maskd = Rt(i,:) >= Rt(i,end)-1; %when within 1 of the final value
    [C Index] = max(maskd);
    MLd(i) = Index; %T1
end

dec = 50; t2 = 1:dec:numTimesteps;

%stochastic final size approximation

for h = VRmin:VRmax
  text = ['1-x = exp(-1.0*(' num2str(Sprop(h)*betan/gamma) ')*x)'] 
meanRTheory =  (solve(text, 'Real', true))*Sprop(h)*numNodes
FinalSizeS(h) = max(double(meanRTheory))
end

 
 figTest9inf0_02 = figure
 for i = VRmin:VRmax
     plot(Imean(i,:),'k')
     hold on
     plot(t2,It(i,1:dec:end),'k.-')
      plot(timeS,SImean(i,:),'k--')
 end
 ylabel('Number of nodes infected - It')
 xlabel('Timesteps')
 title('a) SI-Increasing variants: Nodes infected')
 legend('Agent', 'Deterministic', 'Stochastic')
 %axis([0 1000 0 400])
 
  figmajor = figure
 for i = VRmin:VRmax
     plot(ImeanN1(1,:),'k')
     hold on
     plot(t2,It(i,1:dec:end),'k.-')
     plot(timeS,SImeanN1(i,:),'k--')
     plot(ImeanN1(i,:),'k')
 end
xlabel('Timesteps')
ylabel('Number of individuals infected I(t)')
title('Mean of major outbreaks')
 legend('Agent', 'Deterministic', 'Stochastic')
%axis([0 100 0 90])
 
 
 %number of nodes infected
 figTest2FinalInfected = figure
 %agentImax = max(Imean,[],2);
 %plot(agentImax,'k')
 for j = VRmin:VRmax
 if isnan(FinalSizeS(j)); h(j) = 0; else h(j) = FinalSizeS(j); end;
 if isnan(FinalSize(j)); q(j) = 0; else q(j) = FinalSize(j); end;
 end
 FinalSize=q
 FinalSizeS=h
 plot(FinalSize,'ko-')
 hold on
 %plot(S,'k.-')
 plot(FinalSized,'k.-')
 plot(FinalSizeS,'k+-')
%plot([18.615 18.615],[0 1],'k--')
 ylabel('Final number infected')
 xlabel('Number of variants')
 title('c) SI-Increasing variants: Final size')
 legend('Agent', 'Deterministic', 'Stochastic Approximation')
 
  %RESISTANCE
 figTest2Resistance = figure
 %agentImax = max(Imean,[],2);
 %plot(agentImax,'k')
 for j = VRmin:VRmax
 %if isnan(FinalSizeS(j)); h(j) = 0; else h(j) = FinalSizeS(j); end; %STOCHASTIC APPROX
 %if isnan(FinalSize(j)); q(j) = 0; else q(j) = FinalSize(j); end; %AGENT
 if isnan(SFinalSize(j)); w(j) = 0; else w(j) = SFinalSize(j); end; %STOCHASTIC MEASURED
 end
 FinalSize=q
 FinalSizeS=h
 SFinalSize=w
 plot(1-FinalSize./N,'ko-')
 hold on
 %plot(S,'k.-')
 plot(1-FinalSized./N,'k.-')
 plot(1-FinalSizeS./N,'k+-')
  plot(1-SFinalSize./N,'ks-')
%plot([18.615 18.615],[0 1],'k--')
 ylabel('Resistance M_R')
 xlabel('Variant Richness')
 title('c) SI-Increasing variants: Resistance')
 legend('measured Agent', ' measured Deterministic', 'approximated Stochastic','measured Stochastic')
 
 %RESILIENCE major outbreaks only
 figTest2Resilience = figure
  plot(1./MLa,'ko-') %agent measured
 hold on
 plot(1./MLd,'k.-') %deterministic
  plot(1./SMLa,'ks-') %stochastic measured
 hold on
  ylabel('Resilience M_L')
 xlabel('Variant Richness')
 title('c) SI-Increasing variants: Resilience major')
 legend('measured Agent', ' measured Deterministic', 'measured Stochastic')
 %plot([18.615 18.615],[0 1],'k--')

%RESILIENCE TIME of major outbreaks only
 figTest2ResilienceTime = figure
  plot(MLa,'ko-') %agent measured
 hold on
 plot(MLd,'k.-') %deterministic
  plot(SMLa,'ks-') %stochastic measured
 hold on
  ylabel('Resilience Time')
 xlabel('Variant Richness')
 title('c) SI-Increasing variants: Resilience Time major')
 legend('measured Agent', ' measured Deterministic', 'measured Stochastic')
 % plot([1.8533 1.8533],[0 1],'k--')
   %axis([1 8 0 1.1])
 
saveas(figTest9inf0_02,[outputDirectory 'Test17meanall.fig']);
saveas(figTest9inf0_02,[outputDirectory 'Test17meanall.emf']); 
saveas(figmajor,[outputDirectory 'Test17meanmajor.fig']);
saveas(figmajor,[outputDirectory 'Test17meanmajor.emf']);
saveas(figTest2FinalInfected,[outputDirectory 'Test17FinalInfected.fig']);
saveas(figTest2FinalInfected,[outputDirectory 'Test17FinalInfected.emf']);
saveas(figTest2Resistance,[outputDirectory 'Test17Resistance.fig']);
saveas(figTest2Resistance,[outputDirectory 'Test17Resistance.emf']);
saveas(figTest2Resilience,[outputDirectory 'Test17Resilience.fig']);
saveas(figTest2Resilience,[outputDirectory 'Test17Resilience.emf']);
saveas(figTest2Resilience2,[outputDirectory 'Test17ResilienceAll.fig']);
saveas(figTest2Resilience2,[outputDirectory 'Test17ResilienceAll.emf']);
%close all


betameanmean
gammameanmean

betameanmean2
betameanmeanNew 
betameanmeanNew2
gammameanmeanNew

Rnewendmean%epidemics only
Rnewendstd

 propSimsNonEp % proportion of sims with non-epidemics
 propSimsNonEp_theoretical %theoretical value
    
R = betameanmean./gammameanmean
RN = betameanmeanNew./gammameanmeanNew
SRN = SbetameanmeanNew./SgammameanmeanNew
RTheoretical = beta./gamma

figro = figure
%plot(beta,R,'k')
hold on
plot(RN,'ko-')
plot(RTheoretical,'k.-')
plot(RN,'ks-') %stochastic measured
plot([1 1 1 1 1 1 1 1],'k--')
plot([18.615 18.615],[0 1],'k--')
xlabel('Number of variants')
ylabel('ro')
%legend('R','RNew','Rtheoretical') 
legend('Ro Agent(measured)','Ro Deterministic','Ro Stochastic(measured)') 
%axis([0.1 0.5 0 2])
saveas(figro,[outputDirectory 'Test14figro.fig']);
saveas(figro,[outputDirectory 'Test14figro.emf']);
%close all
%close all;
toc
   %SAVE FOR LATER
Resistancea_3EXP=1-FinalSize./N
Resistanced_3EXP=1-FinalSized./N
Resistancesapp_3EXP=1-FinalSizeS./N
Resistances_3EXP=1-SFinalSize./N
Resiliencea_3EXP=1./MLa
Resilienced_3EXP=1./MLd
Resiliences_3EXP=1./SMLa


%saved data


end %SIRN Test17

% SIRN TEST 18
%SIR OR CASE Increase variants 18 to 20, fix exploit 1 - 4 loci, network size match to needed number of genotypes for each change in the number of variants, look at resistance output only, dont compare resilience
%takes xxx hours
%***************
if doSIRNTests(18) == 1
    %outputDirectory = 'Graphs\'
outputDirectory = 'Graphs\'
%***************************************
%SIRN testing
%***************************************
%Deterministic - 4 loci OR
tic
numLoci=4
VRmin = 12; %25
VRmax = 22; %25
VR=VRmin:VRmax
numNodes([VRmin:VRmax]) = 2000; %2.*VR.^numLoci; %network size match to needed number of genotypes
N=numNodes; Vmax = 1:VRmax;  G = Vmax.^2; %number genotypes
%for OR case
Sprop = SPExact4LociOR( 1, Vmax )
mode = 'static'
%monte carlo random genotype SIR model
numRuns = 100 %100 %200
numTimesteps = 10000; %7000;

%set up diversity mode parameters
modePar.modeStr = mode
modePar.numToConstrain = 0 %constain a number of nodes to 1 variant
modePar.stopUpdatingTime = 20000 %time at which to stop updating the genotypes
%modePar.numEncountersBetweenUpdates = 1 % number of encounters between updates for random and favscore algorithms
modePar.bufferlength = 10 %length of genotype buffer for favscore algorithm
modePar.genoInit = 'maxdiv'  %initial conditions of genotypes maxdiv (maximum diversity - random variant chosen) mindiv (minimum diversity - all nodes same)


for z= VRmin:VRmax
 betan = 0.02; variantRichness =  z;   plotGraphs = 0; gamma = 0.004; numExploits=1; numLoci=4; casetype = 'OR'; throwAway = 'nonEpidemics', cutoff = gamma.*numNodes./(betan.*Sprop); SEpidemic=60; %SEpidemic=numNodes - 60; %cutoff;
%agent
 [figMeanNei(z) figNeiOneRun(z) fighistSpRun(z) fighistRecovered(z) fighistSusceptible(z) fighistpeakValue(z) fighistpeakTime(z) fighistBeta(z) fighistGamma(z) fighistBetanew(z) fighistGammanew(z) figInfectedRun1 figBetaRun1 figGammaRun1 figRoRun1 figBetaGamma1 figBetaGamma2...
            meanNeiIndexDynamicF  betastd gammastd betastd2 betastdNew betastdNew2 gammastdNew peakTimemean peakTimestd peakValuemean peakValuestd...
            betameanmean(z) gammameanmean betameanmean2(z) betameanmeanNew(z) betameanmeanNew2 gammameanmeanNew(z) Smean(z,:) Imean(z,:) Rmean(z,:) Bmean NSmean(z,:) Smedian Imedian Rmedian S I R NS SmeanN ImeanN1(z,:) RmeanN1 BmeanN1 Snewendmean Snewendstd Rnewendmean(z) Rnewendstd(z) Rnew_nonendmean Rnew_nonendstd propSimsNonEp(z) propSimsNonEp_theoretical(z)...
           numRunsMinor(z) measuredProbMinor(z) numRunsMajor(z) measuredProbMajor(z) ...
            ] = monteCarloSIRN2(numRuns,numNodes(z), betan, variantRichness, numTimesteps, plotGraphs,gamma,throwAway,SEpidemic,numExploits,modePar, numLoci, casetype);
   size(ImeanN1)
FinalSize(z) = max(RmeanN1,[],2) %mean final size
    %resilience of major only
     maska = RmeanN1 >= FinalSize(z)-1; %when within 1 of the final value
    [C Index] = max(maska);
    MLa(z) = Index; %T1

    size(RmeanN1)
    size(Index)
        %resilience of all
     maska = Rmean(z,:) >= FinalSize(z)-1; %when within 1 of the final value
    [C Index] = max(maska);
        size(Rmean(z,:))
    size(Index)
    MLa_all(z) = Index; %T1
         saveas(fighistSpRun(z),[outputDirectory 'Test18fighistSpRun' num2str(z) '.fig']);
    saveas(fighistSpRun(z),[outputDirectory 'Test18fighistSpRun' num2str(z) '.emf']);
        saveas(fighistRecovered(z),[outputDirectory 'Test18fighistRecovered' num2str(z) '.fig']);
    saveas(fighistRecovered(z),[outputDirectory 'Test18fighistRecovered' num2str(z) '.emf']);
    saveas(fighistSusceptible(z),[outputDirectory 'Test18fighistSusceptible' num2str(z) '.fig']);
    saveas(fighistSusceptible(z),[outputDirectory 'Test18fighistSusceptible' num2str(z) '.emf']);
    saveas(fighistpeakValue(z),[outputDirectory 'Test18fighistpeakValue' num2str(z) '.fig']);
    saveas(fighistpeakValue(z),[outputDirectory 'Test18fighistpeakValue' num2str(z) '.emf']);
    saveas(fighistpeakTime(z),[outputDirectory 'Test18fighistpeakTime' num2str(z) '.fig']);
    saveas(fighistpeakTime(z),[outputDirectory 'Test18fighistpeakTime' num2str(z) '.emf']);
    saveas(fighistBeta(z),[outputDirectory 'Test18histBeta' num2str(z) '.fig']);
    saveas(fighistBeta(z),[outputDirectory 'Test18histBeta' num2str(z) '.emf']);
    saveas(fighistGamma(z),[outputDirectory 'Test18histGamma' num2str(z) '.fig']);
    saveas(fighistGamma(z),[outputDirectory 'Test18histGamma' num2str(z) '.emf']);
    saveas(fighistBetanew(z),[outputDirectory 'Test18histBetaNew' num2str(z) '.fig']);
    saveas(fighistBetanew(z),[outputDirectory 'Test18histBetaNew' num2str(z) '.emf']);
    saveas(fighistGammanew(z),[outputDirectory 'Test18histGammaNew' num2str(z) '.fig']);
    saveas(fighistGammanew(z),[outputDirectory 'Test18histGammaNew' num2str(z) '.emf']);
    close(fighistRecovered(z));
    close(fighistSusceptible(z));
    close(fighistpeakValue(z));
    close(fighistpeakTime(z));
    close(fighistBeta(z));
    close(fighistGamma(z));
    close(fighistBetanew(z));
    close(fighistGammanew(z));
    
    %stochastic
    dtt=0.1 %stochastic dtt = used in graph and set in function
    timeS = dtt:dtt:numTimesteps;%stochastic time for graphs
    [SfighistRecovered(z) SfighistSusceptible(z) SfighistpeakValue(z) SfighistpeakTime(z) SfighistBeta(z) SfighistGamma(z) SfighistBetanew(z) SfighistGammanew(z) SfigInfectedRun1 SfigBetaRun1 SfigGammaRun1 SfigRoRun1 SfigBetaGamma1 SfigBetaGamma2...
            Sbetastd Sgammastd Sbetastd2 SbetastdNew SbetastdNew2 SgammastdNew SpeakTimemean SpeakTimestd SpeakValuemean SpeakValuestd...
            Sbetameanmean(z) Sgammameanmean Sbetameanmean2(z) SbetameanmeanNew(z) SbetameanmeanNew2 SgammameanmeanNew(z) SSmean(z,:) SImean(z,:) SRmean(z,:) SNSmean(z,:) SSmedian SImedian SRmedian SS SI SR SNS SSmeanN SImeanN1(z,:) SRmeanN1 SSnewendmean SSnewendstd SRnewendmean(z) SRnewendstd(z) SRnew_nonendmean SRnew_nonendstd SpropSimsNonEp(z) SpropSimsNonEp_theoretical(z)...
            SnumRunsMinor(z) SmeasuredProbMinor(z) SnumRunsMajor(z) SmeasuredProbMajor(z) ...
            ] = monteCarloStochastic(numRuns,numNodes(z), betan, variantRichness, numTimesteps, plotGraphs,gamma,throwAway,SEpidemic,numExploits,mode, numLoci, casetype);
     size(SImeanN1)
SFinalSize(z) = max(SRmeanN1,[],2) %mean final size
    %resilience of major only
     Smaska = SRmeanN1 >= SFinalSize(z)-1; %when within 1 of the final value
    [SC SIndex] = max(Smaska);
    SMLa(z) = ceil(SIndex.*dtt); %T1 %divide by dtt to get back to true time in seconds
        %resilience of all
     Smaska = SRmean(z,:) >= SFinalSize(z)-1; %when within 1 of the final value
    [SC SIndex] = max(Smaska);
    SMLa_all(z) = ceil(SIndex.*dtt); %T1 %divide by dtt to get back to true time in seconds
        saveas(SfighistRecovered(z),[outputDirectory 'Test18StochfighistRecovered' num2str(z) '.fig']);
    saveas(SfighistRecovered(z),[outputDirectory 'Test18StochfighistRecovered' num2str(z) '.emf']);
    saveas(SfighistSusceptible(z),[outputDirectory 'Test18StochfighistSusceptible' num2str(z) '.fig']);
    saveas(SfighistSusceptible(z),[outputDirectory 'Test18StochfighistSusceptible' num2str(z) '.emf']);
    saveas(SfighistpeakValue(z),[outputDirectory 'Test18StochfighistpeakValue' num2str(z) '.fig']);
    saveas(SfighistpeakValue(z),[outputDirectory 'Test18StochfighistpeakValue' num2str(z) '.emf']);
    saveas(SfighistpeakTime(z),[outputDirectory 'Test18StochfighistpeakTime' num2str(z) '.fig']);
    saveas(SfighistpeakTime(z),[outputDirectory 'Test18StochfighistpeakTime' num2str(z) '.emf']);
    saveas(SfighistBeta(z),[outputDirectory 'Test18StochhistBeta' num2str(z) '.fig']);
    saveas(SfighistBeta(z),[outputDirectory 'Test18StochhistBeta' num2str(z) '.emf']);
    saveas(SfighistGamma(z),[outputDirectory 'Test18StochhistGamma' num2str(z) '.fig']);
    saveas(SfighistGamma(z),[outputDirectory 'Test18StochhistGamma' num2str(z) '.emf']);
    saveas(SfighistBetanew(z),[outputDirectory 'Test18StochhistBetaNew' num2str(z) '.fig']);
    saveas(SfighistBetanew(z),[outputDirectory 'Test18StochhistBetaNew' num2str(z) '.emf']);
    saveas(SfighistGammanew(z),[outputDirectory 'Test18StochhistGammaNew' num2str(z) '.fig']);
    saveas(SfighistGammanew(z),[outputDirectory 'Test18StochhistGammaNew' num2str(z) '.emf']);
    close(SfighistRecovered(z));
    close(SfighistSusceptible(z));
    close(SfighistpeakValue(z));
    close(SfighistpeakTime(z));
    close(SfighistBeta(z));
    close(SfighistGamma(z));
    close(SfighistBetanew(z));
    close(SfighistGammanew(z));
    text = ['done ' num2str(z) ' out of ' num2str(VRmax)];
    disp(text)
end    

%Deterministic - 4 loci OR
N=numNodes; Vmax = 1:VRmax;  G = Vmax.^2; %number genotypes
%for OR case
Sprop = SPExact4LociOR( 1, Vmax )
%Sprop = 2./Vmax - 1./G %both loci have the same number of variants and both have 1 exploit
S = N.*Sprop; B = 0.02; beta = B.*Sprop; gamma = 0.004; %1/48*60*60 %2 days
for i = VRmin:VRmax
    [Ro(i) St(i,:) It(i,:) Rt(i,:)] = SIRDeterministic(beta(i), gamma, S(i), 1, 0, numTimesteps, 0); 
    FinalSized(i) = Rt(i,end);
     
    %resilience
     maskd = Rt(i,:) >= Rt(i,end)-1; %when within 1 of the final value
    [C Index] = max(maskd);
    MLd(i) = Index; %T1
end

dec = 50; t2 = 1:dec:numTimesteps;

%stochastic final size approximation

for h = VRmin:VRmax
  text = ['1-x = exp(-1.0*(' num2str(Sprop(h).*betan./gamma) ')*x)'] 
meanRTheory =  (solve(text, 'Real', true)).*Sprop(h).*numNodes(h)
FinalSizeS(h) = max(double(meanRTheory))
end

 
 figTest9inf0_02 = figure
 for i = VRmin:VRmax
     plot(Imean(i,:),'k')
     hold on
     plot(t2,It(i,1:dec:end),'k.-')
      plot(timeS,SImean(i,:),'k--')
 end
 ylabel('Number of nodes infected - It')
 xlabel('Timesteps')
 title('a) SI-Increasing variants: Nodes infected')
 legend('Agent', 'Deterministic', 'Stochastic')
 %axis([0 1000 0 400])
 
  figmajor = figure
 for i = VRmin:VRmax
     plot(ImeanN1(1,:),'k')
     hold on
     plot(t2,It(i,1:dec:end),'k.-')
     size(timeS)
     size(SImeanN1(i,:))
     plot(timeS,SImeanN1(i,:),'k--')%stochastic time has more data points
     plot(ImeanN1(i,:),'k')
 end
xlabel('Timesteps')
ylabel('Number of individuals infected I(t)')
title('Mean of major outbreaks')
 legend('Agent', 'Deterministic', 'Stochastic')
%axis([0 100 0 90])
 
 
 %number of nodes infected
 figTest2FinalInfected = figure
 %agentImax = max(Imean,[],2);
 %plot(agentImax,'k')
 for j = VRmin:VRmax
 if isnan(FinalSizeS(j)); h(j) = 0; else h(j) = FinalSizeS(j); end;%STOCHASTIC APPROX
 if isnan(FinalSize(j)); q(j) = 0; else q(j) = FinalSize(j); end;%AGENT
 if isnan(SFinalSize(j)); w(j) = 0; else w(j) = SFinalSize(j); end; %STOCHASTIC MEASURED
 end
 FinalSize=q
 FinalSizeS=h
 plot(FinalSize,'ko-')
 hold on
 %plot(S,'k.-')
 plot(FinalSized,'k.-')
 plot(FinalSizeS,'k+-')
  plot(SFinalSize,'ks-')
plot([18.615 18.615],[0 1],'k--')
 ylabel('Final number infected')
 xlabel('Number of variants')
 title('c) SI-Increasing variants: Final size')
 legend('Agent', 'Deterministic', 'Stochastic Approximation', 'Stochastic measured')
 
  %RESISTANCE
  Resistanced_1EXP =[...
    0.0069    0.0714    0.2131    0.3417    0.4465    0.5319    0.6027 ...
    0.6625    0.7139    0.7587    0.7982    0.8336    0.8656    0.8952 ...
    0.9228    0.9475    0.9668    0.9793    0.9864    0.9904    0.9927 ...
    0.9941    0.9950    0.9957    0.9961    0.9965    0.9968    0.9970 ...
    0.9972    0.9973];
 figTest2Resistance = figure
 %agentImax = max(Imean,[],2);
 %plot(agentImax,'k')
% for j = VRmin:VRmax
 %if isnan(FinalSizeS(j)); h(j) = 0; else h(j) = FinalSizeS(j); end; 
 %if isnan(FinalSize(j)); q(j) = 0; else q(j) = FinalSize(j); end; 
% if isnan(SFinalSize(j)); w(j) = 0; else w(j) = SFinalSize(j); end; %STOCHASTIC MEASURED
% end
 FinalSize=q
 FinalSizeS=h
 SFinalSize=w
 Resistancea_1EXP=1-FinalSize./N
Resistanced_1EXP=1-FinalSized./N
Resistancesapp_1EXP=1-FinalSizeS./N
Resistances_1EXP=1-SFinalSize./N
size(Resistancea_1EXP)
size([1:VRmax])
 plot([1:VRmax],Resistancea_1EXP,'ko-')
 hold on
 %plot(S,'k.-')
 plot([1:VRmax],Resistanced_1EXP,'k.-')
 plot([1:VRmax],Resistancesapp_1EXP,'k+-')
  plot([1:VRmax],Resistances_1EXP,'ks-')
  plot(Resistanced_1EXP,'r--')
plot([18.615 18.615],[0 1],'k--')
 ylabel('Resistance M_R')
 xlabel('Variant Richness')
 title('c) SI-Increasing variants: Resistance')
 legend('measured Agent', ' measured Deterministic', 'approximated Stochastic','measured Stochastic', ' measured Deterministic')
 
 %RESILIENCE major outbreaks only
 figTest2Resilience = figure
  plot([1:VRmax],1./MLa,'ko-') %agent measured
 hold on
 plot([1:VRmax],1./MLd,'k.-') %deterministic
  plot([1:VRmax],1./SMLa,'ks-') %stochastic measured
 hold on
  ylabel('Resilience M_L')
 xlabel('Variant Richness')
 title('c) SI-Increasing variants: Resilience major')
 legend('measured Agent', ' measured Deterministic', 'measured Stochastic')
 plot([18.615 18.615],[0 1],'k--')

%RESILIENCE TIME of major outbreaks only
 figTest2ResilienceTime = figure
  plot(MLa,'ko-') %agent measured
 hold on
 plot(MLd,'k.-') %deterministic
  plot(SMLa,'ks-') %stochastic measured
 hold on
  ylabel('Resilience Time')
 xlabel('Variant Richness')
 title('c) SI-Increasing variants: Resilience Time major')
 legend('measured Agent', ' measured Deterministic', 'measured Stochastic')
 plot([18.615 18.615],[0 1],'k--')
   %axis([1 8 0 1.1])
 
saveas(figTest9inf0_02,[outputDirectory 'Test18meanall.fig']);
saveas(figTest9inf0_02,[outputDirectory 'Test18meanall.emf']); 
saveas(figmajor,[outputDirectory 'Test18meanmajor.fig']);
saveas(figmajor,[outputDirectory 'Test18meanmajor.emf']);
saveas(figTest2FinalInfected,[outputDirectory 'Test18FinalInfected.fig']);
saveas(figTest2FinalInfected,[outputDirectory 'Test18FinalInfected.emf']);
saveas(figTest2Resistance,[outputDirectory 'Test18Resistance.fig']);
saveas(figTest2Resistance,[outputDirectory 'Test18Resistance.emf']);
saveas(figTest2Resilience,[outputDirectory 'Test18Resilience.fig']);
saveas(figTest2Resilience,[outputDirectory 'Test18Resilience.emf']);
saveas(figTest2ResilienceTime,[outputDirectory 'Test18ResilienceTime.fig']);
saveas(figTest2ResilienceTime,[outputDirectory 'Test18ResilienceTime.emf']);
%close all


betameanmean
gammameanmean

betameanmean2
betameanmeanNew 
betameanmeanNew2
gammameanmeanNew

Rnewendmean%epidemics only
Rnewendstd

 propSimsNonEp % proportion of sims with non-epidemics
 propSimsNonEp_theoretical %theoretical value
    
R = betameanmean./gammameanmean
RN = betameanmeanNew./gammameanmeanNew
SRN = SbetameanmeanNew./SgammameanmeanNew
RTheoretical = beta./gamma

figro = figure
%plot(beta,R,'k')
hold on
plot([1:VRmax],RN,'ko-')
plot(RTheoretical,'k.-')
plot([1:VRmax],RN,'ks-') %stochastic measured
plot([1 1 1 1 1 1 1 1],'k--')
plot([18.615 18.615],[0 1],'k--')
xlabel('Number of variants')
ylabel('ro')
%legend('R','RNew','Rtheoretical') 
legend('Ro Agent(measured)','Ro Deterministic','Ro Stochastic(measured)') 
%axis([0.1 0.5 0 2])
saveas(figro,[outputDirectory 'Test18figro.fig']);
saveas(figro,[outputDirectory 'Test18figro.emf']);
%close all
%close all;
toc
   %SAVE FOR LATER
Resistancea_1EXP=1-FinalSize./N
Resistanced_1EXP=1-FinalSized./N
Resistancesapp_1EXP=1-FinalSizeS./N
Resistances_1EXP=1-SFinalSize./N
Resiliencea_1EXP=1./MLa
Resilienced_1EXP=1./MLd
Resiliences_1EXP=1./SMLa

%saved data
%numNodes = number of required genotypes; VRmin = 18 VRmax = 22; numRuns = 100
%SEpidemic=numNodes - 60; (cut off) 1 exploit only

end %SIRN Test18

% SIRN TEST 19
% SIR - 1 locus model fix exploit at 1 and increase variants - 
%***************
if doSIRNTests(19) == 1
%outputDirectory = 'Graphs\'
outputDirectory = 'Graphs\'
%Increase variants upto 10, fix exploit
%***************************************
%SIRN testing
%***************************************
tic
numNodes = 1000;
VRmin = 1 %1
VRmax = 9 %10
N=numNodes; Vmax = 1:VRmax;  G = Vmax.^2; %number genotypes
%for OR case
Sprop = SPExact1LociOR( 1, Vmax )
mode = 'static'
%monte carlo random genotype SIR model
numRuns = 100 %100 %200

%set up diversity mode parameters
modePar.modeStr = mode
modePar.numToConstrain = 0 %constain a number of nodes to 1 variant
modePar.stopUpdatingTime = 20000 %time at which to stop updating the genotypes
%modePar.numEncountersBetweenUpdates = 1 % number of encounters between updates for random and favscore algorithms
modePar.bufferlength = 10 %length of genotype buffer for favscore algorithm
modePar.genoInit = 'maxdiv'  %initial conditions of genotypes maxdiv (maximum diversity - random variant chosen) mindiv (minimum diversity - all nodes same)


for z= VRmin:VRmax
 betan = 0.02; variantRichness =  z;  numTimesteps = 7000; plotGraphs = 0; gamma = 0.004; numExploits=1; numLoci=1; casetype = 'OR'; throwAway = 'nonEpidemics', cutoff = gamma.*numNodes./(betan.*Sprop); SEpidemic=60; %cutoff;
%agent
 [figMeanNei(z) figNeiOneRun(z) fighistSpRun(z) fighistRecovered(z) fighistSusceptible(z) fighistpeakValue(z) fighistpeakTime(z) fighistBeta(z) fighistGamma(z) fighistBetanew(z) fighistGammanew(z) figInfectedRun1 figBetaRun1 figGammaRun1 figRoRun1 figBetaGamma1 figBetaGamma2...
            meanNeiIndexDynamicF  betastd gammastd betastd2 betastdNew betastdNew2 gammastdNew peakTimemean peakTimestd peakValuemean peakValuestd...
            betameanmean(z) gammameanmean betameanmean2(z) betameanmeanNew(z) betameanmeanNew2 gammameanmeanNew(z) Smean(z,:) Imean(z,:) Rmean(z,:) Bmean NSmean(z,:) Smedian Imedian Rmedian S I R NS SmeanN ImeanN1(z,:) RmeanN1 BmeanN1 Snewendmean Snewendstd Rnewendmean(z) Rnewendstd(z) Rnew_nonendmean Rnew_nonendstd propSimsNonEp(z) propSimsNonEp_theoretical(z)...
            numRunsMinor(z) measuredProbMinor(z) numRunsMajor(z) measuredProbMajor(z) ...
            ] = monteCarloSIRN2(numRuns,numNodes, betan, variantRichness, numTimesteps, plotGraphs,gamma,throwAway,SEpidemic,numExploits,modePar, numLoci, casetype);
   sizeRmeanN1 = size(RmeanN1)
   numRunsMajorD=numRunsMajor
FinalSize(z) = max(RmeanN1,[],2) %mean final size

    %resilience of major only
     maska = RmeanN1 >= FinalSize(z)-1; %when within 1 of the final value
    [C Index] = max(maska);
    MLa(z) = Index %T1
    
        %resilience of all
     maska = Rmean(z,:) >= FinalSize(z)-1; %when within 1 of the final value
    [C Index] = max(maska);
        size(Rmean(z,:))
    size(Index)
    MLa_all(z) = Index; %T1
    
     saveas(fighistSpRun(z),[outputDirectory 'Test19fighistSpRun' num2str(z) '.fig']);
    saveas(fighistSpRun(z),[outputDirectory 'Test19fighistSpRun' num2str(z) '.emf']);    
        saveas(fighistRecovered(z),[outputDirectory 'Test19fighistRecovered' num2str(z) '.fig']);
    saveas(fighistRecovered(z),[outputDirectory 'Test19fighistRecovered' num2str(z) '.emf']);
    saveas(fighistSusceptible(z),[outputDirectory 'Test19fighistSusceptible' num2str(z) '.fig']);
    saveas(fighistSusceptible(z),[outputDirectory 'Test19fighistSusceptible' num2str(z) '.emf']);
    saveas(fighistpeakValue(z),[outputDirectory 'Test19fighistpeakValue' num2str(z) '.fig']);
    saveas(fighistpeakValue(z),[outputDirectory 'Test19fighistpeakValue' num2str(z) '.emf']);
    saveas(fighistpeakTime(z),[outputDirectory 'Test19fighistpeakTime' num2str(z) '.fig']);
    saveas(fighistpeakTime(z),[outputDirectory 'Test19fighistpeakTime' num2str(z) '.emf']);
    saveas(fighistBeta(z),[outputDirectory 'Test19histBeta' num2str(z) '.fig']);
    saveas(fighistBeta(z),[outputDirectory 'Test19histBeta' num2str(z) '.emf']);
    saveas(fighistGamma(z),[outputDirectory 'Test19histGamma' num2str(z) '.fig']);
    saveas(fighistGamma(z),[outputDirectory 'Test19histGamma' num2str(z) '.emf']);
    saveas(fighistBetanew(z),[outputDirectory 'Test19histBetaNew' num2str(z) '.fig']);
    saveas(fighistBetanew(z),[outputDirectory 'Test19histBetaNew' num2str(z) '.emf']);
    saveas(fighistGammanew(z),[outputDirectory 'Test19histGammaNew' num2str(z) '.fig']);
    saveas(fighistGammanew(z),[outputDirectory 'Test19histGammaNew' num2str(z) '.emf']);
    close(fighistRecovered(z));
    close(fighistSusceptible(z));
    close(fighistpeakValue(z));
    close(fighistpeakTime(z));
    close(fighistBeta(z));
    close(fighistGamma(z));
    close(fighistBetanew(z));
    close(fighistGammanew(z));
    
    %stochastic
        dtt=0.1 %stochastic dtt = used in graph and set in function
    timeS = dtt:dtt:numTimesteps;%stochastic time for graphs
    [SfighistRecovered(z) SfighistSusceptible(z) SfighistpeakValue(z) SfighistpeakTime(z) SfighistBeta(z) SfighistGamma(z) SfighistBetanew(z) SfighistGammanew(z) SfigInfectedRun1 SfigBetaRun1 SfigGammaRun1 SfigRoRun1 SfigBetaGamma1 SfigBetaGamma2...
            Sbetastd Sgammastd Sbetastd2 SbetastdNew SbetastdNew2 SgammastdNew SpeakTimemean SpeakTimestd SpeakValuemean SpeakValuestd...
            Sbetameanmean(z) Sgammameanmean Sbetameanmean2(z) SbetameanmeanNew(z) SbetameanmeanNew2 SgammameanmeanNew(z) SSmean(z,:) SImean(z,:) SRmean(z,:) SNSmean(z,:) SSmedian SImedian SRmedian SS SI SR SNS SSmeanN SImeanN1(z,:) SRmeanN1 SSnewendmean SSnewendstd SRnewendmean(z) SRnewendstd(z) SRnew_nonendmean SRnew_nonendstd SpropSimsNonEp(z) SpropSimsNonEp_theoretical(z)...
            SnumRunsMinor(z) SmeasuredProbMinor(z) SnumRunsMajor(z) SmeasuredProbMajor(z) ...
            ] = monteCarloStochastic(numRuns,numNodes, betan, variantRichness, numTimesteps, plotGraphs,gamma,throwAway,SEpidemic,numExploits,mode, numLoci, casetype);
     size(SImeanN1)
SFinalSize(z) = max(SRmeanN1,[],2) %mean final size
    %resilience of major only
     Smaska = SRmeanN1 >= SFinalSize(z)-1; %when within 1 of the final value
    [SC SIndex] = max(Smaska);
    SMLa(z) = ceil(SIndex.*dtt); %T1
    
    
        %resilience of all
     Smaska = SRmean(z,:) >= SFinalSize(z)-1; %when within 1 of the final value
    [SC SIndex] = max(Smaska);
    SMLa_all(z) = ceil(SIndex.*dtt); %T1
        saveas(SfighistRecovered(z),[outputDirectory 'Test19StochfighistRecovered' num2str(z) '.fig']);
    saveas(SfighistRecovered(z),[outputDirectory 'Test19StochfighistRecovered' num2str(z) '.emf']);
    saveas(SfighistSusceptible(z),[outputDirectory 'Test19StochfighistSusceptible' num2str(z) '.fig']);
    saveas(SfighistSusceptible(z),[outputDirectory 'Test19StochfighistSusceptible' num2str(z) '.emf']);
    saveas(SfighistpeakValue(z),[outputDirectory 'Test19StochfighistpeakValue' num2str(z) '.fig']);
    saveas(SfighistpeakValue(z),[outputDirectory 'Test19StochfighistpeakValue' num2str(z) '.emf']);
    saveas(SfighistpeakTime(z),[outputDirectory 'Test19StochfighistpeakTime' num2str(z) '.fig']);
    saveas(SfighistpeakTime(z),[outputDirectory 'Test19StochfighistpeakTime' num2str(z) '.emf']);
    saveas(SfighistBeta(z),[outputDirectory 'Test19StochhistBeta' num2str(z) '.fig']);
    saveas(SfighistBeta(z),[outputDirectory 'Test19StochhistBeta' num2str(z) '.emf']);
    saveas(SfighistGamma(z),[outputDirectory 'Test19StochhistGamma' num2str(z) '.fig']);
    saveas(SfighistGamma(z),[outputDirectory 'Test19StochhistGamma' num2str(z) '.emf']);
    saveas(SfighistBetanew(z),[outputDirectory 'Test19StochhistBetaNew' num2str(z) '.fig']);
    saveas(SfighistBetanew(z),[outputDirectory 'Test19StochhistBetaNew' num2str(z) '.emf']);
    saveas(SfighistGammanew(z),[outputDirectory 'Test19StochhistGammaNew' num2str(z) '.fig']);
    saveas(SfighistGammanew(z),[outputDirectory 'Test19StochhistGammaNew' num2str(z) '.emf']);
    close(SfighistRecovered(z));
    close(SfighistSusceptible(z));
    close(SfighistpeakValue(z));
    close(SfighistpeakTime(z));
    close(SfighistBeta(z));
    close(SfighistGamma(z));
    close(SfighistBetanew(z));
    close(SfighistGammanew(z));
    text = ['done ' num2str(z) ' out of ' num2str(VRmax)];
    disp(text)
end    
    
%Deterministic - 4 loci OR
N=numNodes; Vmax = 1:VRmax;  G = Vmax.^2; %number genotypes
%for OR case
Sprop = SPExact1LociOR( 1, Vmax )
%Sprop = 2./Vmax - 1./G %both loci have the same number of variants and both have 1 exploit
S = N.*Sprop; B = 0.02; beta = B.*Sprop; gamma = 0.004; %1/48*60*60 %2 days
for i = VRmin:VRmax
    [Ro(i) St(i,:) It(i,:) Rt(i,:)] = SIRDeterministic(beta(i), gamma, S(i), 1, 0, numTimesteps, 0); 
    FinalSized(i) = Rt(i,end);
     
    %resilience
     maskd = Rt(i,:) >= Rt(i,end)-1; %when within 1 of the final value
    [C Index] = max(maskd);
    MLd(i) = Index; %T1
end

dec = 50; t2 = 1:dec:numTimesteps;

%stochastic final size approximation
[ FinalSizeS stdS ] = finalSizeApprox( Sprop, betan, gamma, VRmin, VRmax, numNodes)

 
 figTest9inf0_02 = figure
 for i = VRmin:VRmax
     plot(Imean(i,:),'k')
     hold on
     plot(t2,It(i,1:dec:end),'k.-')
      plot(timeS,SImean(i,:),'k--')
 end
 ylabel('Number of nodes infected - It')
 xlabel('Timesteps')
 title('a) SI-Increasing variants: Nodes infected')
 legend('Agent', 'Deterministic', 'Stochastic')
 %axis([0 1000 0 400])
 
  figmajor = figure
 for i = VRmin:VRmax
     plot(ImeanN1(1,:),'k')
     hold on
     plot(t2,It(i,1:dec:end),'k.-')
     plot(timeS,SImeanN1(i,:),'k--')
     plot(ImeanN1(i,:),'k')
 end
xlabel('Time (seconds)')
ylabel('Number of individuals infected I(t)')
title('Mean of major outbreaks')
 legend('Agent (measured)', 'Deterministic', 'Stochastic (measured)')
%axis([0 100 0 90])
 
 
  %number of nodes infected
 figTest2FinalInfected = figure
 %agentImax = max(Imean,[],2);
 %plot(agentImax,'k')
 for j = VRmin:VRmax
 if isnan(FinalSizeS(j)); h(j) = 0; else h(j) = FinalSizeS(j); end;
 if isnan(FinalSize(j)); q(j) = 0; else q(j) = FinalSize(j); end;
  if isnan(SFinalSize(j)); v(j) = 0; else v(j) = SFinalSize(j); end;
 end
 FinalSize=q
 FinalSizeS=h
 SFinalSize=v
 plot(FinalSize,'ko-')
 hold on
 %plot(S,'k.-')
 plot(FinalSized,'k.-')
  plot(SFinalSize,'ks-')
 plot(FinalSizeS,'k+-')
plot([5 5],[0 1],'k--')
 ylabel('Final number infected')
 xlabel('Variant Richness')
 title('c) SI-Increasing variants: Final size')
 legend('Agent', 'Deterministic', 'Stochastic measured','Stochastic Approximation')
 
  %number of nodes infected
 figTest2Finalstd = figure
 %agentImax = max(Imean,[],2);
 %plot(agentImax,'k')
 for j = VRmin:VRmax
 if isnan(Rnewendstd(j)); a(j) = 0; else a(j) = Rnewendstd(j); end;
 if isnan(SRnewendstd(j)); b(j) = 0; else b(j) = SRnewendstd(j); end;
  if isnan(stdS(j)); c(j) = 0; else c(j) = stdS(j); end;
 end
 SRnewendstd=a
 Rnewendstd=b
 stdS = c
 plot(Rnewendstd,'ko-') %agent measured
 hold on
 %plot(S,'k.-')
 plot(SRnewendstd,'ks-') %stochastic measured
 plot(stdS,'k+-') % calc approx
plot([5 5],[0 1],'k--')
 ylabel('Standard deviation')
 xlabel('Variant Richness')
 title('c) SI-Increasing variants: Final size std')
 legend('Agent measured', 'Stochastic measured', 'Stochastic Approximation')
 
  %RESISTANCE
 figTest2Resistance = figure
 plot(1-FinalSize./N,'ko-')
 hold on
 %plot(S,'k.-')
 plot(1-FinalSized./N,'k.-')
 plot(1-SFinalSize./N,'ks-')
  plot(1-FinalSizeS./N,'k+-')
plot([5 5],[0 1],'k--')
 ylabel('Resistance M_R')
 xlabel('Variant Richness')
 title('c) SI-Increasing variants: Resistance')
 legend('Agent (measured)', ' Deterministic (measured) ', 'Stochastic (measured) ','Stochastic (approximated)')
 
 %RESILIENCE major outbreaks only
 figTest2Resilience = figure
  plot(1./MLa,'ko-') %agent measured
 hold on
 plot(1./MLd,'k.-') %deterministic
  plot(1./SMLa,'ks-') %stochastic measured
 hold on
  ylabel('Resilience M_L')
 xlabel('Variant Richness')
 title('c) SI-Increasing variants: Resilience major')
 legend('Agent (measured)', 'Deterministic (measured)', 'Stochastic (measured)')
plot([5 5],[0 1],'k--')
 
  %RESILIENCE TIME of major outbreaks only
 figTest2ResilienceTime = figure
  plot(MLa,'ko-') %agent measured
 hold on
 plot(MLd,'k.-') %deterministic
  plot(SMLa,'ks-') %stochastic measured
 hold on
  ylabel('Resilience Time')
 xlabel('Variant Richness')
 title('c) SI-Increasing variants: Resilience Time major')
 legend('Agent (measured)', 'Deterministic (measured)', 'Stochastic (measured)')
plot([5 5],[0 1],'k--')
   %axis([1 8 0 1.1])

 
saveas(figTest9inf0_02,[outputDirectory 'Test19meanall.fig']);
saveas(figTest9inf0_02,[outputDirectory 'Test19meanall.emf']); 
saveas(figmajor,[outputDirectory 'Test19meanmajor.fig']);
saveas(figmajor,[outputDirectory 'Test19meanmajor.emf']);
saveas(figTest2FinalInfected,[outputDirectory 'Test19FinalInfected.fig']);
saveas(figTest2FinalInfected,[outputDirectory 'Test19FinalInfected.emf']);
saveas(figTest2Finalstd,[outputDirectory 'Test19Finalstd.fig']);
saveas(figTest2Finalstd,[outputDirectory 'Test19Finalstd.emf']);
saveas(figTest2Resistance,[outputDirectory 'Test19Resistance.fig']);
saveas(figTest2Resistance,[outputDirectory 'Test19Resistance.emf']);
saveas(figTest2Resilience,[outputDirectory 'Test19Resilience.fig']);
saveas(figTest2Resilience,[outputDirectory 'Test19Resilience.emf']);
saveas(figTest2ResilienceTime,[outputDirectory 'Test19ResilienceTime.fig']);
saveas(figTest2ResilienceTime,[outputDirectory 'Test19ResilienceTime.emf']);
%close all


betameanmean
gammameanmean

betameanmean2
betameanmeanNew 
betameanmeanNew2
gammameanmeanNew

Rnewendmean%epidemics only
Rnewendstd

 propSimsNonEp % proportion of sims with non-epidemics
 propSimsNonEp_theoretical %theoretical value
    
R = betameanmean./gammameanmean
RN = betameanmeanNew./gammameanmeanNew
SRN = SbetameanmeanNew./SgammameanmeanNew
RTheoretical = beta./gamma

figro = figure
%plot(beta,R,'k')
hold on
plot(RN,'ko-')
plot(RTheoretical,'k.-')
plot(RN,'ks-') %stochastic measured
plot([1 1 1 1 1 1 1 1],'k--')
plot([5 5],[0 1],'k--')
xlabel('Number of variants')
ylabel('ro')
%legend('R','RNew','Rtheoretical') 
legend('Ro Agent(measured)','Ro Deterministic','Ro Stochastic(measured)') 
%axis([0.1 0.5 0 2])
saveas(figro,[outputDirectory 'Test19figro.fig']);
saveas(figro,[outputDirectory 'Test19figro.emf']);
%close all
%close all;

%calculate proportion of minor and major outbreaks
[ minorCalc majorCalc ] = propCalcOutbreaks( Sprop, B, gamma )
%measure proportion of minor and major outbreaks
%agent
%numRunsMinor measuredProbMinor numRunsMajor measuredProbMajor
numRunsMinor
numRunsMajor
measuredProbMinor
measuredProbMajor
%stochastic
%SnumRunsMinor SmeasuredProbMinor SnumRunsMajor SmeasuredProbMajor
SnumRunsMinor
SnumRunsMajor
SmeasuredProbMinor
SmeasuredProbMajor

figMinorProb = figure;
plot(measuredProbMinor,'ko-') %agent
hold on
plot(SmeasuredProbMinor,'ks-') %stochastic
plot(minorCalc,'k+-') %stoch approx
xlabel('Variant Richness')
ylabel('Proportion of minor outbreaks')
%legend('R','RNew','Rtheoretical') 
plot([5 5],[0 0.9],'k--')
legend('Agent (measured)','Stochastic (measured)', 'Stochastic (approximated)')
title('probability of minor outbreak')

figMajorProb = figure;
plot(measuredProbMajor,'ko-') %agent
hold on
plot(SmeasuredProbMajor,'ks-') %stochastic
plot(majorCalc,'k+-') %stoch approx
xlabel('Variant Richness')
ylabel('Proportion of major outbreaks')
%legend('R','RNew','Rtheoretical') 
legend('Agent (measured)','Stochastic (measured)', 'Stochastic (approximated)')
plot([5 5],[0 0.9],'k--')
title('probability of major outbreak')

saveas(figMinorProb,[outputDirectory 'Test19_1EXPfigMinorProb.fig']);
saveas(figMinorProb,[outputDirectory 'Test19_1EXPfigMinorProb.emf']);
saveas(figMajorProb,[outputDirectory 'Test19_1EXPfigMajorProb.fig']);
saveas(figMajorProb,[outputDirectory 'Test19_1EXPfigMajorProb.emf']);


toc
   %SAVE FOR LATER
   N %number of nodes
   FinalSize %measured agent
   FinalSized %deterministic
   FinalSizeS %stoch approx
   SFinalSize %stoch measured
Resistancea_1EXP=1-FinalSize./N
Resistanced_1EXP=1-FinalSized./N
Resistancesapp_1EXP=1-FinalSizeS./N
Resistances_1EXP=1-SFinalSize./N
Resiliencea_1EXP=1./MLa
Resilienced_1EXP=1./MLd
Resiliences_1EXP=1./SMLa
Rnewendstd_1EXP=Rnewendstd
SRnewendstd_1EXP=SRnewendstd
stdS_1EXP=stdS

end %SIRN Test19



% SIRN TEST 20
% SIR - 4 loci AND fix exploit at 1 and increase variants - takes ?? mins
%***************
if doSIRNTests(20) == 1
    %outputDirectory = 'Graphs\'
outputDirectory = 'Graphs\'
%Increase variants upto 5, fix exploit
%***************************************
%SIRN testing
%***************************************
%   1 EXPLOIT
%   *******************************************************************************************************
%Deterministic - 4 loci AND
tic
numNodes = 1000;
VRmin = 1 %25
VRmax = 1 %25
N=numNodes; Vmax = 1:VRmax;  G = Vmax.^2; %number genotypes
%for AND case
Sprop = sp4LociAND( 1, Vmax )
mode = 'static' %mode - can be 'static' or 'dynamic' 'Dynamic-random' 'Dynamic-favScore'
%monte carlo random genotype SIR model
numRuns = 20 %100 %200

%set up diversity mode parameters
modePar.modeStr = mode
modePar.numToConstrain = 0 %constain a number of nodes to 1 variant
modePar.stopUpdatingTime = 20000 %time at which to stop updating the genotypes
%modePar.numEncountersBetweenUpdates = 1 % number of encounters between updates for random and favscore algorithms
modePar.bufferlength = 10 %length of genotype buffer for favscore algorithm
modePar.genoInit = 'maxdiv'  %initial conditions of genotypes maxdiv (maximum diversity - random variant chosen) mindiv (minimum diversity - all nodes same)

for z= VRmin:VRmax
 betan = 0.02; variantRichness =  z;  numTimesteps = 7000; plotGraphs = 1; gamma = 0.004; numExploits=1; numLoci=4; casetype = 'AND'; throwAway = 'nonEpidemics', cutoff = gamma.*numNodes./(betan.*Sprop); SEpidemic=60; %cutoff;
%agent
 [figMeanNei(z) figNeiOneRun(z) fighistSpRun(z) fighistRecovered(z) fighistSusceptible(z) fighistpeakValue(z) fighistpeakTime(z) fighistBeta(z) fighistGamma(z) fighistBetanew(z) fighistGammanew(z) figInfectedRun1 figBetaRun1 figGammaRun1 figRoRun1 figBetaGamma1 figBetaGamma2...
            meanNeiIndexDynamicF  betastd gammastd betastd2 betastdNew betastdNew2 gammastdNew peakTimemean peakTimestd peakValuemean peakValuestd...
            betameanmean(z) gammameanmean betameanmean2(z) betameanmeanNew(z) betameanmeanNew2 gammameanmeanNew(z) Smean(z,:) Imean(z,:) Rmean(z,:) Bmean NSmean(z,:) Smedian Imedian Rmedian S I R NS SmeanN ImeanN1(z,:) RmeanN1 BmeanN1 Snewendmean Snewendstd Rnewendmean(z) Rnewendstd(z) Rnew_nonendmean Rnew_nonendstd propSimsNonEp(z) propSimsNonEp_theoretical(z)...
            numRunsMinor(z) measuredProbMinor(z) numRunsMajor(z) measuredProbMajor(z) ...
            ] = monteCarloSIRN2(numRuns,numNodes, betan, variantRichness, numTimesteps, plotGraphs,gamma,throwAway,SEpidemic,numExploits,modePar, numLoci, casetype);
   size(ImeanN1)
FinalSize(z) = max(RmeanN1,[],2) %mean final size
    %resilience of major only
     maska = RmeanN1 >= FinalSize(z)-1; %when within 1 of the final value
    [C Index] = max(maska);
    MLa(z) = Index; %T1
    RmeanN1;
    size(RmeanN1)
    size(Index)
        %resilience of all
     maska = Rmean(z,:) >= FinalSize(z)-1; %when within 1 of the final value
    [C Index] = max(maska);
        size(Rmean(z,:))
    size(Index)
    MLa_all(z) = Index; %T1
    
             saveas(figMeanNei(z),[outputDirectory 'Test20_1EXPfigMeanNei' num2str(z) '.fig']);
    saveas(figMeanNei(z),[outputDirectory 'Test20_1EXPfigMeanNei' num2str(z) '.emf']); 
         saveas(figNeiOneRun(z),[outputDirectory 'Test20_1EXPfigNeiOneRun' num2str(z) '.fig']);
    saveas(figNeiOneRun(z),[outputDirectory 'Test20_1EXPfigNeiOneRun' num2str(z) '.emf']); 
         saveas(fighistSpRun(z),[outputDirectory 'Test20_1EXPfighistSpRun' num2str(z) '.fig']);
    saveas(fighistSpRun(z),[outputDirectory 'Test20_1EXPfighistSpRun' num2str(z) '.emf']);
        saveas(fighistRecovered(z),[outputDirectory 'Test20_1EXPfighistRecovered' num2str(z) '.fig']);
    saveas(fighistRecovered(z),[outputDirectory 'Test20_1EXPfighistRecovered' num2str(z) '.emf']);
    saveas(fighistSusceptible(z),[outputDirectory 'Test20_1EXPfighistSusceptible' num2str(z) '.fig']);
    saveas(fighistSusceptible(z),[outputDirectory 'Test20_1EXPfighistSusceptible' num2str(z) '.emf']);
    saveas(fighistpeakValue(z),[outputDirectory 'Test20_1EXPfighistpeakValue' num2str(z) '.fig']);
    saveas(fighistpeakValue(z),[outputDirectory 'Test20_1EXPfighistpeakValue' num2str(z) '.emf']);
    saveas(fighistpeakTime(z),[outputDirectory 'Test20_1EXPfighistpeakTime' num2str(z) '.fig']);
    saveas(fighistpeakTime(z),[outputDirectory 'Test20_1EXPfighistpeakTime' num2str(z) '.emf']);
    saveas(fighistBeta(z),[outputDirectory 'Test20_1EXPhistBeta' num2str(z) '.fig']);
    saveas(fighistBeta(z),[outputDirectory 'Test20_1EXPhistBeta' num2str(z) '.emf']);
    saveas(fighistGamma(z),[outputDirectory 'Test20_1EXPhistGamma' num2str(z) '.fig']);
    saveas(fighistGamma(z),[outputDirectory 'Test20_1EXPhistGamma' num2str(z) '.emf']);
    saveas(fighistBetanew(z),[outputDirectory 'Test20_1EXPhistBetaNew' num2str(z) '.fig']);
    saveas(fighistBetanew(z),[outputDirectory 'Test20_1EXPhistBetaNew' num2str(z) '.emf']);
    saveas(fighistGammanew(z),[outputDirectory 'Test20_1EXPhistGammaNew' num2str(z) '.fig']);
    saveas(fighistGammanew(z),[outputDirectory 'Test20_1EXPhistGammaNew' num2str(z) '.emf']);
    close(fighistRecovered(z));
    close(fighistSusceptible(z));
    close(fighistpeakValue(z));
    close(fighistpeakTime(z));
    close(fighistBeta(z));
    close(fighistGamma(z));
    close(fighistBetanew(z));
    close(fighistGammanew(z));
    
    %stochastic
        dtt=0.1 %stochastic dtt = used in graph and set in function
    timeS = dtt:dtt:numTimesteps;%stochastic time for graphs
    [SfighistRecovered(z) SfighistSusceptible(z) SfighistpeakValue(z) SfighistpeakTime(z) SfighistBeta(z) SfighistGamma(z) SfighistBetanew(z) SfighistGammanew(z) SfigInfectedRun1 SfigBetaRun1 SfigGammaRun1 SfigRoRun1 SfigBetaGamma1 SfigBetaGamma2...
            Sbetastd Sgammastd Sbetastd2 SbetastdNew SbetastdNew2 SgammastdNew SpeakTimemean SpeakTimestd SpeakValuemean SpeakValuestd...
            Sbetameanmean(z) Sgammameanmean Sbetameanmean2(z) SbetameanmeanNew(z) SbetameanmeanNew2 SgammameanmeanNew(z) SSmean(z,:) SImean(z,:) SRmean(z,:) SNSmean(z,:) SSmedian SImedian SRmedian SS SI SR SNS SSmeanN SImeanN1(z,:) SRmeanN1 SSnewendmean SSnewendstd SRnewendmean(z) SRnewendstd(z) SRnew_nonendmean SRnew_nonendstd SpropSimsNonEp(z) SpropSimsNonEp_theoretical(z)...
            SnumRunsMinor(z) SmeasuredProbMinor(z) SnumRunsMajor(z) SmeasuredProbMajor(z) ...
            ] = monteCarloStochastic(numRuns,numNodes, betan, variantRichness, numTimesteps, plotGraphs,gamma,throwAway,SEpidemic,numExploits,mode, numLoci, casetype);
     size(SImeanN1)
SFinalSize(z) = max(SRmeanN1,[],2) %mean final size
    %resilience of major only
     Smaska = SRmeanN1 >= SFinalSize(z)-1; %when within 1 of the final value
    [SC SIndex] = max(Smaska)
    SMLa(z) = ceil(SIndex.*dtt); %T1 %round up to nearest whole second
        %resilience of all
     Smaska = SRmean(z,:) >= SFinalSize(z)-1; %when within 1 of the final value
    [SC SIndex] = max(Smaska);
    SMLa_all(z) = ceil(SIndex.*dtt); %T1
        saveas(SfighistRecovered(z),[outputDirectory 'Test20_1EXPStochfighistRecovered' num2str(z) '.fig']);
    saveas(SfighistRecovered(z),[outputDirectory 'Test20_1EXPStochfighistRecovered' num2str(z) '.emf']);
    saveas(SfighistSusceptible(z),[outputDirectory 'Test20_1EXPStochfighistSusceptible' num2str(z) '.fig']);
    saveas(SfighistSusceptible(z),[outputDirectory 'Test20_1EXPStochfighistSusceptible' num2str(z) '.emf']);
    saveas(SfighistpeakValue(z),[outputDirectory 'Test20_1EXPStochfighistpeakValue' num2str(z) '.fig']);
    saveas(SfighistpeakValue(z),[outputDirectory 'Test20_1EXPStochfighistpeakValue' num2str(z) '.emf']);
    saveas(SfighistpeakTime(z),[outputDirectory 'Test20_1EXPStochfighistpeakTime' num2str(z) '.fig']);
    saveas(SfighistpeakTime(z),[outputDirectory 'Test20_1EXPStochfighistpeakTime' num2str(z) '.emf']);
    saveas(SfighistBeta(z),[outputDirectory 'Test20_1EXPStochhistBeta' num2str(z) '.fig']);
    saveas(SfighistBeta(z),[outputDirectory 'Test20_1EXPStochhistBeta' num2str(z) '.emf']);
    saveas(SfighistGamma(z),[outputDirectory 'Test20_1EXPStochhistGamma' num2str(z) '.fig']);
    saveas(SfighistGamma(z),[outputDirectory 'Test20_1EXPStochhistGamma' num2str(z) '.emf']);
    saveas(SfighistBetanew(z),[outputDirectory 'Test20_1EXPStochhistBetaNew' num2str(z) '.fig']);
    saveas(SfighistBetanew(z),[outputDirectory 'Test20_1EXPStochhistBetaNew' num2str(z) '.emf']);
    saveas(SfighistGammanew(z),[outputDirectory 'Test20_1EXPStochhistGammaNew' num2str(z) '.fig']);
    saveas(SfighistGammanew(z),[outputDirectory 'Test20_1EXPStochhistGammaNew' num2str(z) '.emf']);
    close(SfighistRecovered(z));
    close(SfighistSusceptible(z));
    close(SfighistpeakValue(z));
    close(SfighistpeakTime(z));
    close(SfighistBeta(z));
    close(SfighistGamma(z));
    close(SfighistBetanew(z));
    close(SfighistGammanew(z));
    text = ['done ' num2str(z) ' out of ' num2str(VRmax)];
    disp(text)
end    
    
   
%Deterministic - 4 loci AND
N=numNodes; Vmax = 1:VRmax;  G = Vmax.^2; %number genotypes
%for AND case
Sprop = sp4LociAND( 1, Vmax )
%Sprop = 2./Vmax - 1./G %both loci have the same number of variants and both have 1 exploit
S = N.*Sprop; B = 0.02; beta = B.*Sprop; gamma = 0.004; %1/48*60*60 %2 days
for i = VRmin:VRmax
    [Ro(i) St(i,:) It(i,:) Rt(i,:)] = SIRDeterministic(beta(i), gamma, S(i), 1, 0, numTimesteps, 0); 
    FinalSized(i) = Rt(i,end);
     
    %resilience
     maskd = Rt(i,:) >= Rt(i,end)-1; %when within 1 of the final value
    [C Index] = max(maskd);
    MLd(i) = Index; %T1
end

dec = 50; t2 = 1:dec:numTimesteps;

%stochastic final size approximation
[ FinalSizeS stdS ] = finalSizeApprox( Sprop, betan, gamma, VRmin, VRmax, numNodes)
%for h = VRmin:VRmax
%  text = ['1-x = exp(-1.0*(' num2str(Sprop(h)*betan/gamma) ')*x)'] 
%meanRTheory =  (solve(text, 'Real', true))*Sprop(h)*numNodes
%FinalSizeS(h) = max(double(meanRTheory))
%end

 
 figTest9inf0_02 = figure
 for i = VRmin:VRmax
     plot(Imean(i,:),'k')
     hold on
     plot(t2,It(i,1:dec:end),'k.-')
      plot(timeS,SImean(i,:),'k--')
 end
 ylabel('Number of nodes infected - It')
 xlabel('Timesteps')
 title('a) SI-Increasing variants: Nodes infected')
 legend('Agent', 'Deterministic', 'Stochastic')
 %axis([0 1000 0 400])
 
  figmajor = figure
 for i = VRmin:VRmax
     plot(ImeanN1(1,:),'k')
     hold on
     plot(t2,It(i,1:dec:end),'k.-')
     plot(timeS,SImeanN1(i,:),'k--')
     plot(ImeanN1(i,:),'k')
 end
xlabel('Timesteps')
ylabel('Number of individuals infected I(t)')
title('Mean of major outbreaks')
 legend('Agent', 'Deterministic', 'Stochastic')
%axis([0 100 0 90])
 
 
  %number of nodes infected
 figTest2FinalInfected = figure
 %agentImax = max(Imean,[],2);
 %plot(agentImax,'k')
 for j = VRmin:VRmax
 if isnan(FinalSizeS(j)); h(j) = 0; else h(j) = FinalSizeS(j); end;
 if isnan(FinalSize(j)); q(j) = 0; else q(j) = FinalSize(j); end;
  if isnan(SFinalSize(j)); v(j) = 0; else v(j) = SFinalSize(j); end;
 end
 FinalSize=q
 FinalSizeS=h
 SFinalSize=v
 plot(FinalSize,'ko-')
 hold on
 %plot(S,'k.-')
 plot(FinalSized,'k.-')
  plot(SFinalSize,'k+-')
 plot(FinalSizeS,'ks-')
%plot([1.8533 1.8533],[0 1],'k--')
 ylabel('Final number infected')
 xlabel('Number of variants')
 title('c) SI-Increasing variants: Final size')
 legend('Agent', 'Deterministic', 'Stochastic measured','Stochastic Approximation')
 
  %number of nodes infected
 figTest2Finalstd = figure
 %agentImax = max(Imean,[],2);
 %plot(agentImax,'k')
 for j = VRmin:VRmax
 if isnan(Rnewendstd(j)); h(j) = 0; else h(j) = Rnewendstd(j); end;
 if isnan(SRnewendstd(j)); q(j) = 0; else q(j) = SRnewendstd(j); end;
  if isnan(stdS(j)); v(j) = 0; else v(j) = stdS(j); end;
 end
 SRnewendstd=q
 Rnewendstd=h
 plot(Rnewendstd,'ko-') %agent measured
 hold on
 %plot(S,'k.-')
 plot(SRnewendstd,'ks-') %stochastic measured
 plot(stdS,'k+-') % calc approx
%plot([1.8533 1.8533],[0 1],'k--')
 ylabel('Standard deviation')
 xlabel('Number of variants')
 title('c) SI-Increasing variants: Final size std')
 legend('Agent measured', 'Stochastic measured', 'Stochastic Approximation')
 
  %RESISTANCE
 figTest2Resistance = figure
 plot(1-FinalSize./N,'ko-') %agent
 hold on
 %plot(S,'k.-')
 plot(1-FinalSized./N,'k.-') %deterministic
  plot(1-SFinalSize./N,'ks-') %stoch
  plot(1-FinalSizeS./N,'k+-') %stoch approximated 
 plot([1.8533 1.8533],[0 1],'k--')
 ylabel('Resistance M_R')
 xlabel('Variant Richness')
 title('c) SI-Increasing variants: Resistance')
 legend('Agent (measured)', ' Deterministic (measured)', 'Stochastic (measured)','Stochastic (approximated)')
 axis([1 8 0 1.1])
 %RESILIENCE major outbreaks only
 figTest2Resilience = figure
  plot(1./MLa,'ko-') %agent measured
 hold on
 plot(1./MLd,'k.-') %deterministic
  plot(1./SMLa,'ks-') %stochastic measured
 hold on
  ylabel('Resilience M_L')
 xlabel('Variant Richness')
 title('c) SI-Increasing variants: Resilience major')
 legend('Agent (measured)', ' Deterministic (measured)', 'Stochastic (measured)')
  plot([1.8533 1.8533],[0 1],'k--')
   axis([1 8 0 1.1])
  
  %RESILIENCE TIME of major outbreaks only
 figTest2ResilienceTime = figure
  plot(MLa,'ko-') %agent measured
 hold on
 plot(MLd,'k.-') %deterministic
  plot(SMLa,'ks-') %stochastic measured
 hold on
  ylabel('Resilience Time (seconds)')
 xlabel('Variant Richness')
 title('c) SI-Increasing variants: Resilience Time major')
 legend('Agent (measured)', ' Deterministic (measured)', 'Stochastic (measured)')
  plot([1.8533 1.8533],[0 1],'k--')
   %axis([1 8 0 1.1])
   
   %SAVE FOR LATER
Resistancea_1EXP=1-FinalSize./N
Resistanced_1EXP=1-FinalSized./N
Resistancesapp_1EXP=1-FinalSizeS./N
Resistances_1EXP=1-SFinalSize./N
Rnewendstd_1EXP=Rnewendstd
SRnewendstd_1EXP=SRnewendstd
stdS_1EXP=stdS
MLa
MLd
SMLa
Resiliencea_1EXP=1./MLa
Resilienced_1EXP=1./MLd
Resiliences_1EXP=1./SMLa


saveas(figTest9inf0_02,[outputDirectory 'Test20_1EXPmeanall.fig']);
saveas(figTest9inf0_02,[outputDirectory 'Test20_1EXPmeanall.emf']); 
saveas(figmajor,[outputDirectory 'Test20_1EXPmeanmajor.fig']);
saveas(figmajor,[outputDirectory 'Test20_1EXPmeanmajor.emf']);
saveas(figTest2FinalInfected,[outputDirectory 'Test20_1EXPFinalInfected.fig']);
saveas(figTest2FinalInfected,[outputDirectory 'Test20_1EXPFinalInfected.emf']);
saveas(figTest2Finalstd,[outputDirectory 'Test20_1EXPFinalstd.fig']);
saveas(figTest2Finalstd,[outputDirectory 'Test20_1EXPFinalstd.emf']);
saveas(figTest2Resistance,[outputDirectory 'Test20_1EXPResistance.fig']);
saveas(figTest2Resistance,[outputDirectory 'Test20_1EXPResistance.emf']);
saveas(figTest2Resilience,[outputDirectory 'Test20_1EXPResilience.fig']);
saveas(figTest2Resilience,[outputDirectory 'Test20_1EXPResilience.emf']);
saveas(figTest2ResilienceTime,[outputDirectory 'Test20_1EXPResilienceTime.fig']);
saveas(figTest2ResilienceTime,[outputDirectory 'Test20_1EXPResilienceTime.emf']);
%close all


betameanmean
gammameanmean

betameanmean2
betameanmeanNew 
betameanmeanNew2
gammameanmeanNew

Rnewendmean%epidemics only
Rnewendstd

 propSimsNonEp % proportion of sims with non-epidemics
 propSimsNonEp_theoretical %theoretical value
    
R = betameanmean./gammameanmean
RN = betameanmeanNew./gammameanmeanNew
SRN = SbetameanmeanNew./SgammameanmeanNew
RTheoretical = beta./gamma

figro = figure
%plot(beta,R,'k')
hold on
plot(RN,'ko-')
plot(RTheoretical,'k.-')
plot(RN,'ks-') %stochastic measured
plot([1 1 1 1 1 1 1 1],'k--')
%plot([19 19],[0 2],'k--')
xlabel('Number of variants')
ylabel('ro')
%legend('R','RNew','Rtheoretical') 
legend('Ro Agent(measured)','Ro Deterministic','Ro Stochastic(measured)') 
%axis([0.1 0.5 0 2])
saveas(figro,[outputDirectory 'Test20_1EXPfigro.fig']);
saveas(figro,[outputDirectory 'Test20_1EXPfigro.emf']);
%close all
%close all;

%calculate proportion of minor and major outbreaks
[ minorCalc majorCalc ] = propCalcOutbreaks( Sprop, B, gamma )
%R0 = Sprop.*B./gamma;
%for i = 1:size(R0,2)
%if R0(i) >= 1
%minorCalc(i) = 1./R0(i);
%majorCalc(i) = 1-minorCalc(i);
%else
%minorCalc(i) = 1;
%majorCalc(i) = 0;
%end
%end
%minorCalc
%majorCalc

%measure proportion of minor and major outbreaks
%agent
%numRunsMinor measuredProbMinor numRunsMajor measuredProbMajor
numRunsMinor
numRunsMajor
measuredProbMinor
measuredProbMajor
%stochastic
%SnumRunsMinor SmeasuredProbMinor SnumRunsMajor SmeasuredProbMajor
SnumRunsMinor
SnumRunsMajor
SmeasuredProbMinor
SmeasuredProbMajor

figMinorProb = figure;
plot(measuredProbMinor,'ko-') %agent
hold on
plot(SmeasuredProbMinor,'ks-') %stochastic
plot(minorCalc,'k+-') %calc
xlabel('Variant Richness')
ylabel('Proportion of minor outbreaks')
%legend('R','RNew','Rtheoretical') 
 plot([1.8533 1.8533],[0 1],'k--')
legend('Agent (measured)','Stochastic (measured)', 'Stochastic (approximated)')
title('probability of minor outbreak')

figMajorProb = figure;
plot(measuredProbMajor,'ko-') %agent
hold on
plot(SmeasuredProbMajor,'ks-') %stochastic
plot(majorCalc,'k+-') %calc
xlabel('Variant Richness')
ylabel('Proportion of major outbreaks')
%legend('R','RNew','Rtheoretical') 
 plot([1.8533 1.8533],[0 1],'k--')
legend('Agent (measured)','Stochastic (measured)', 'Stochastic (approximated)')
title('probability of major outbreak')

saveas(figMinorProb,[outputDirectory 'Test20_1EXPfigMinorProb.fig']);
saveas(figMinorProb,[outputDirectory 'Test20_1EXPfigMinorProb.emf']);
saveas(figMajorProb,[outputDirectory 'Test20_1EXPfigMajorProb.fig']);
saveas(figMajorProb,[outputDirectory 'Test20_1EXPfigMajorProb.emf']);

%Final size distribution
Rnewendmean
Rnewendstd

end %test20

if doSIRNTests(21) == 1
%1 locus model
%outputDirectory = 'Graphs\'
outputDirectory = 'Graphs\'
%Increase variants upto 10, fix exploit
%***************************************
%SIRN testing
%***************************************
tic
numNodes = 1000;
VRmin = 1 %1
VRmax = 10 %10
N=numNodes; Vmax = 1:VRmax;  G = Vmax.^2; %number genotypes
%for OR case
Sprop = SPExact1LociOR( 1, Vmax )
mode = 'Dynamic-random' %mode - can be 'static' or 'dynamic' 'Dynamic-random' 'Dynamic-favScore'
%monte carlo random genotype SIR model
numRuns = 1 %100 %200
%set up diversity mode parameters
modePar.modeStr = mode
modePar.numToConstrain = 0 %constain a number of nodes to 1 variant
modePar.stopUpdatingTime = 2000 %time at which to stop updating the genotypes
modePar.numEncountersBetweenUpdates = 1 % number of encounters between updates for random and favscore algorithms
modePar.bufferlength = 10 %length of genotype buffer for favscore algorithm
modePar.genoInit = 'maxdiv'  %initial conditions of genotypes maxdiv (maximum diversity - random variant chosen) mindiv (minimum diversity - all nodes same)

for z= VRmin:VRmax
 betan = 0.02; variantRichness =  z;  numTimesteps = 200; plotGraphs = 1; gamma = 0.004; numExploits=1; numLoci=1; casetype = 'OR'; throwAway = 'nonEpidemics', cutoff = gamma.*numNodes./(betan.*Sprop); SEpidemic=60; %cutoff;
%agent
 [figMeanNei(z) figNeiOneRun(z) fighistSpRun(z) fighistRecovered(z) fighistSusceptible(z) fighistpeakValue(z) fighistpeakTime(z) fighistBeta(z) fighistGamma(z) fighistBetanew(z) fighistGammanew(z) figInfectedRun1 figBetaRun1 figGammaRun1 figRoRun1 figBetaGamma1 figBetaGamma2...
            meanNeiIndexDynamicF  betastd gammastd betastd2 betastdNew betastdNew2 gammastdNew peakTimemean peakTimestd peakValuemean peakValuestd...
            betameanmean(z) gammameanmean betameanmean2(z) betameanmeanNew(z) betameanmeanNew2 gammameanmeanNew(z) Smean(z,:) Imean(z,:) Rmean(z,:) Bmean NSmean(z,:) Smedian Imedian Rmedian S I R NS SmeanN ImeanN1(z,:) RmeanN1 BmeanN1 Snewendmean Snewendstd Rnewendmean(z) Rnewendstd(z) Rnew_nonendmean Rnew_nonendstd propSimsNonEp(z) propSimsNonEp_theoretical(z)...
            numRunsMinor(z) measuredProbMinor(z) numRunsMajor(z) measuredProbMajor(z) ...
            ] = monteCarloSIRN2(numRuns,numNodes, betan, variantRichness, numTimesteps, plotGraphs,gamma,throwAway,SEpidemic,numExploits,modePar, numLoci, casetype);
   sizeRmeanN1 = size(RmeanN1)
   numRunsMajorD=numRunsMajor
FinalSize(z) = max(RmeanN1,[],2) %mean final size

    %resilience of major only
     maska = RmeanN1 >= FinalSize(z)-1; %when within 1 of the final value
    [C Index] = max(maska);
    MLa(z) = Index %T1
    
        %resilience of all
     maska = Rmean(z,:) >= FinalSize(z)-1; %when within 1 of the final value
    [C Index] = max(maska);
        size(Rmean(z,:))
    size(Index)
    MLa_all(z) = Index; %T1
    
         saveas(figMeanNei(z),[outputDirectory 'Test21figMeanNei' num2str(z) '.fig']);
    saveas(figMeanNei(z),[outputDirectory 'Test21figMeanNei' num2str(z) '.emf']); 
         saveas(figNeiOneRun(z),[outputDirectory 'Test21figNeiOneRun' num2str(z) '.fig']);
    saveas(figNeiOneRun(z),[outputDirectory 'Test21figNeiOneRun' num2str(z) '.emf']); 
    
     saveas(fighistSpRun(z),[outputDirectory 'Test21fighistSpRun' num2str(z) '.fig']);
    saveas(fighistSpRun(z),[outputDirectory 'Test21fighistSpRun' num2str(z) '.emf']);    
        saveas(fighistRecovered(z),[outputDirectory 'Test21fighistRecovered' num2str(z) '.fig']);
    saveas(fighistRecovered(z),[outputDirectory 'Test21fighistRecovered' num2str(z) '.emf']);
    saveas(fighistSusceptible(z),[outputDirectory 'Test21fighistSusceptible' num2str(z) '.fig']);
    saveas(fighistSusceptible(z),[outputDirectory 'Test21fighistSusceptible' num2str(z) '.emf']);
    saveas(fighistpeakValue(z),[outputDirectory 'Test21fighistpeakValue' num2str(z) '.fig']);
    saveas(fighistpeakValue(z),[outputDirectory 'Test21fighistpeakValue' num2str(z) '.emf']);
    saveas(fighistpeakTime(z),[outputDirectory 'Test21fighistpeakTime' num2str(z) '.fig']);
    saveas(fighistpeakTime(z),[outputDirectory 'Test21fighistpeakTime' num2str(z) '.emf']);
    saveas(fighistBeta(z),[outputDirectory 'Test21histBeta' num2str(z) '.fig']);
    saveas(fighistBeta(z),[outputDirectory 'Test21histBeta' num2str(z) '.emf']);
    saveas(fighistGamma(z),[outputDirectory 'Test21histGamma' num2str(z) '.fig']);
    saveas(fighistGamma(z),[outputDirectory 'Test21histGamma' num2str(z) '.emf']);
    saveas(fighistBetanew(z),[outputDirectory 'Test21histBetaNew' num2str(z) '.fig']);
    saveas(fighistBetanew(z),[outputDirectory 'Test21histBetaNew' num2str(z) '.emf']);
    saveas(fighistGammanew(z),[outputDirectory 'Test21histGammaNew' num2str(z) '.fig']);
    saveas(fighistGammanew(z),[outputDirectory 'Test21histGammaNew' num2str(z) '.emf']);
    close(fighistRecovered(z));
    close(fighistSusceptible(z));
    close(fighistpeakValue(z));
    close(fighistpeakTime(z));
    close(fighistBeta(z));
    close(fighistGamma(z));
    close(fighistBetanew(z));
    close(fighistGammanew(z));
    
    %stochastic
        dtt=0.1 %stochastic dtt = used in graph and set in function
    timeS = dtt:dtt:numTimesteps;%stochastic time for graphs
    plotGraphs=0
    [SfighistRecovered(z) SfighistSusceptible(z) SfighistpeakValue(z) SfighistpeakTime(z) SfighistBeta(z) SfighistGamma(z) SfighistBetanew(z) SfighistGammanew(z) SfigInfectedRun1 SfigBetaRun1 SfigGammaRun1 SfigRoRun1 SfigBetaGamma1 SfigBetaGamma2...
            Sbetastd Sgammastd Sbetastd2 SbetastdNew SbetastdNew2 SgammastdNew SpeakTimemean SpeakTimestd SpeakValuemean SpeakValuestd...
            Sbetameanmean(z) Sgammameanmean Sbetameanmean2(z) SbetameanmeanNew(z) SbetameanmeanNew2 SgammameanmeanNew(z) SSmean(z,:) SImean(z,:) SRmean(z,:) SNSmean(z,:) SSmedian SImedian SRmedian SS SI SR SNS SSmeanN SImeanN1(z,:) SRmeanN1 SSnewendmean SSnewendstd SRnewendmean(z) SRnewendstd(z) SRnew_nonendmean SRnew_nonendstd SpropSimsNonEp(z) SpropSimsNonEp_theoretical(z)...
            SnumRunsMinor(z) SmeasuredProbMinor(z) SnumRunsMajor(z) SmeasuredProbMajor(z) ...
            ] = monteCarloStochastic(numRuns,numNodes, betan, variantRichness, numTimesteps, plotGraphs,gamma,throwAway,SEpidemic,numExploits,mode, numLoci, casetype);
     size(SImeanN1)
SFinalSize(z) = max(SRmeanN1,[],2) %mean final size
    %resilience of major only
     Smaska = SRmeanN1 >= SFinalSize(z)-1; %when within 1 of the final value
    [SC SIndex] = max(Smaska);
    SMLa(z) = ceil(SIndex.*dtt); %T1
    
    
        %resilience of all
     Smaska = SRmean(z,:) >= SFinalSize(z)-1; %when within 1 of the final value
    [SC SIndex] = max(Smaska);
    SMLa_all(z) = ceil(SIndex.*dtt); %T1
        saveas(SfighistRecovered(z),[outputDirectory 'Test21StochfighistRecovered' num2str(z) '.fig']);
    saveas(SfighistRecovered(z),[outputDirectory 'Test21StochfighistRecovered' num2str(z) '.emf']);
    saveas(SfighistSusceptible(z),[outputDirectory 'Test21StochfighistSusceptible' num2str(z) '.fig']);
    saveas(SfighistSusceptible(z),[outputDirectory 'Test21StochfighistSusceptible' num2str(z) '.emf']);
    saveas(SfighistpeakValue(z),[outputDirectory 'Test21StochfighistpeakValue' num2str(z) '.fig']);
    saveas(SfighistpeakValue(z),[outputDirectory 'Test21StochfighistpeakValue' num2str(z) '.emf']);
    saveas(SfighistpeakTime(z),[outputDirectory 'Test21StochfighistpeakTime' num2str(z) '.fig']);
    saveas(SfighistpeakTime(z),[outputDirectory 'Test21StochfighistpeakTime' num2str(z) '.emf']);
    saveas(SfighistBeta(z),[outputDirectory 'Test21StochhistBeta' num2str(z) '.fig']);
    saveas(SfighistBeta(z),[outputDirectory 'Test21StochhistBeta' num2str(z) '.emf']);
    saveas(SfighistGamma(z),[outputDirectory 'Test21StochhistGamma' num2str(z) '.fig']);
    saveas(SfighistGamma(z),[outputDirectory 'Test21StochhistGamma' num2str(z) '.emf']);
    saveas(SfighistBetanew(z),[outputDirectory 'Test21StochhistBetaNew' num2str(z) '.fig']);
    saveas(SfighistBetanew(z),[outputDirectory 'Test21StochhistBetaNew' num2str(z) '.emf']);
    saveas(SfighistGammanew(z),[outputDirectory 'Test21StochhistGammaNew' num2str(z) '.fig']);
    saveas(SfighistGammanew(z),[outputDirectory 'Test21StochhistGammaNew' num2str(z) '.emf']);
    close(SfighistRecovered(z));
    close(SfighistSusceptible(z));
    close(SfighistpeakValue(z));
    close(SfighistpeakTime(z));
    close(SfighistBeta(z));
    close(SfighistGamma(z));
    close(SfighistBetanew(z));
    close(SfighistGammanew(z));
    text = ['done ' num2str(z) ' out of ' num2str(VRmax)];
    disp(text)
end    
    
%Deterministic - 4 loci OR
N=numNodes; Vmax = 1:VRmax;  G = Vmax.^2; %number genotypes
%for OR case
Sprop = SPExact1LociOR( 1, Vmax )
%Sprop = 2./Vmax - 1./G %both loci have the same number of variants and both have 1 exploit
S = N.*Sprop; B = 0.02; beta = B.*Sprop; gamma = 0.004; %1/48*60*60 %2 days
for i = VRmin:VRmax
    [Ro(i) St(i,:) It(i,:) Rt(i,:)] = SIRDeterministic(beta(i), gamma, S(i), 1, 0, numTimesteps, 0); 
    FinalSized(i) = Rt(i,end);
     
    %resilience
     maskd = Rt(i,:) >= Rt(i,end)-1; %when within 1 of the final value
    [C Index] = max(maskd);
    MLd(i) = Index; %T1
end

dec = 50; t2 = 1:dec:numTimesteps;

%stochastic final size approximation
[ FinalSizeS stdS ] = finalSizeApprox( Sprop, betan, gamma, VRmin, VRmax, numNodes)

 
 figTest9inf0_02 = figure
 for i = VRmin:VRmax
     plot(Imean(i,:),'k')
     hold on
     plot(t2,It(i,1:dec:end),'k.-')
      plot(timeS,SImean(i,:),'k--')
 end
 ylabel('Number of nodes infected - It')
 xlabel('Timesteps')
 title('a) SI-Increasing variants: Nodes infected')
 legend('Agent', 'Deterministic', 'Stochastic')
 %axis([0 1000 0 400])
 
  figmajor = figure
 for i = VRmin:VRmax
     plot(ImeanN1(1,:),'k')
     hold on
     plot(t2,It(i,1:dec:end),'k.-')
     plot(timeS,SImeanN1(i,:),'k--')
     plot(ImeanN1(i,:),'k')
 end
xlabel('Time (seconds)')
ylabel('Number of individuals infected I(t)')
title('Mean of major outbreaks')
 legend('Agent (measured)', 'Deterministic', 'Stochastic (measured)')
%axis([0 100 0 90])
 
 
  %number of nodes infected
 figTest2FinalInfected = figure
 %agentImax = max(Imean,[],2);
 %plot(agentImax,'k')
 for j = VRmin:VRmax
 if isnan(FinalSizeS(j)); h(j) = 0; else h(j) = FinalSizeS(j); end;
 if isnan(FinalSize(j)); q(j) = 0; else q(j) = FinalSize(j); end;
  if isnan(SFinalSize(j)); v(j) = 0; else v(j) = SFinalSize(j); end;
 end
 FinalSize=q
 FinalSizeS=h
 SFinalSize=v
 plot(FinalSize,'ko-')
 hold on
 %plot(S,'k.-')
 plot(FinalSized,'k.-')
  plot(SFinalSize,'ks-')
 plot(FinalSizeS,'k+-')
plot([5 5],[0 1],'k--')
 ylabel('Final number infected')
 xlabel('Variant Richness')
 title('c) SI-Increasing variants: Final size')
 legend('Agent', 'Deterministic', 'Stochastic measured','Stochastic Approximation')
 
  %number of nodes infected
 figTest2Finalstd = figure
 %agentImax = max(Imean,[],2);
 %plot(agentImax,'k')
 for j = VRmin:VRmax
 if isnan(Rnewendstd(j)); a(j) = 0; else a(j) = Rnewendstd(j); end;
 if isnan(SRnewendstd(j)); b(j) = 0; else b(j) = SRnewendstd(j); end;
  if isnan(stdS(j)); c(j) = 0; else c(j) = stdS(j); end;
 end
 SRnewendstd=a
 Rnewendstd=b
 stdS = c
 plot(Rnewendstd,'ko-') %agent measured
 hold on
 %plot(S,'k.-')
 plot(SRnewendstd,'ks-') %stochastic measured
 plot(stdS,'k+-') % calc approx
plot([5 5],[0 1],'k--')
 ylabel('Standard deviation')
 xlabel('Variant Richness')
 title('c) SI-Increasing variants: Final size std')
 legend('Agent measured', 'Stochastic measured', 'Stochastic Approximation')
 
  %RESISTANCE
 figTest2Resistance = figure
 plot(1-FinalSize./N,'ko-')
 hold on
 %plot(S,'k.-')
 plot(1-FinalSized./N,'k.-')
 plot(1-SFinalSize./N,'ks-')
  plot(1-FinalSizeS./N,'k+-')
plot([5 5],[0 1],'k--')
 ylabel('Resistance M_R')
 xlabel('Variant Richness')
 title('c) SI-Increasing variants: Resistance')
 legend('Agent (measured)', ' Deterministic (measured) ', 'Stochastic (measured) ','Stochastic (approximated)')
 
 %RESILIENCE major outbreaks only
 figTest2Resilience = figure
  plot(1./MLa,'ko-') %agent measured
 hold on
 plot(1./MLd,'k.-') %deterministic
  plot(1./SMLa,'ks-') %stochastic measured
 hold on
  ylabel('Resilience M_L')
 xlabel('Variant Richness')
 title('c) SI-Increasing variants: Resilience major')
 legend('Agent (measured)', 'Deterministic (measured)', 'Stochastic (measured)')
plot([5 5],[0 1],'k--')
 
  %RESILIENCE TIME of major outbreaks only
 figTest2ResilienceTime = figure
  plot(MLa,'ko-') %agent measured
 hold on
 plot(MLd,'k.-') %deterministic
  plot(SMLa,'ks-') %stochastic measured
 hold on
  ylabel('Resilience Time')
 xlabel('Variant Richness')
 title('c) SI-Increasing variants: Resilience Time major')
 legend('Agent (measured)', 'Deterministic (measured)', 'Stochastic (measured)')
plot([5 5],[0 1],'k--')
   %axis([1 8 0 1.1])

 
saveas(figTest9inf0_02,[outputDirectory 'Test21meanall.fig']);
saveas(figTest9inf0_02,[outputDirectory 'Test21meanall.emf']); 
saveas(figmajor,[outputDirectory 'Test21meanmajor.fig']);
saveas(figmajor,[outputDirectory 'Test21meanmajor.emf']);
saveas(figTest2FinalInfected,[outputDirectory 'Test21FinalInfected.fig']);
saveas(figTest2FinalInfected,[outputDirectory 'Test21FinalInfected.emf']);
saveas(figTest2Finalstd,[outputDirectory 'Test21Finalstd.fig']);
saveas(figTest2Finalstd,[outputDirectory 'Test21Finalstd.emf']);
saveas(figTest2Resistance,[outputDirectory 'Test21Resistance.fig']);
saveas(figTest2Resistance,[outputDirectory 'Test21Resistance.emf']);
saveas(figTest2Resilience,[outputDirectory 'Test21Resilience.fig']);
saveas(figTest2Resilience,[outputDirectory 'Test21Resilience.emf']);
saveas(figTest2ResilienceTime,[outputDirectory 'Test21ResilienceTime.fig']);
saveas(figTest2ResilienceTime,[outputDirectory 'Test21ResilienceTime.emf']);
%close all


betameanmean
gammameanmean

betameanmean2
betameanmeanNew 
betameanmeanNew2
gammameanmeanNew

Rnewendmean%epidemics only
Rnewendstd

 propSimsNonEp % proportion of sims with non-epidemics
 propSimsNonEp_theoretical %theoretical value
    
R = betameanmean./gammameanmean
RN = betameanmeanNew./gammameanmeanNew
SRN = SbetameanmeanNew./SgammameanmeanNew
RTheoretical = beta./gamma

figro = figure
%plot(beta,R,'k')
hold on
plot(RN,'ko-')
plot(RTheoretical,'k.-')
plot(RN,'ks-') %stochastic measured
plot([1 1 1 1 1 1 1 1],'k--')
plot([5 5],[0 1],'k--')
xlabel('Number of variants')
ylabel('ro')
%legend('R','RNew','Rtheoretical') 
legend('Ro Agent(measured)','Ro Deterministic','Ro Stochastic(measured)') 
%axis([0.1 0.5 0 2])
saveas(figro,[outputDirectory 'Test21figro.fig']);
saveas(figro,[outputDirectory 'Test21figro.emf']);
%close all
%close all;

%calculate proportion of minor and major outbreaks
[ minorCalc majorCalc ] = propCalcOutbreaks( Sprop, B, gamma )
%measure proportion of minor and major outbreaks
%agent
%numRunsMinor measuredProbMinor numRunsMajor measuredProbMajor
numRunsMinor
numRunsMajor
measuredProbMinor
measuredProbMajor
%stochastic
%SnumRunsMinor SmeasuredProbMinor SnumRunsMajor SmeasuredProbMajor
SnumRunsMinor
SnumRunsMajor
SmeasuredProbMinor
SmeasuredProbMajor

figMinorProb = figure;
plot(measuredProbMinor,'ko-') %agent
hold on
plot(SmeasuredProbMinor,'ks-') %stochastic
plot(minorCalc,'k+-') %stoch approx
xlabel('Variant Richness')
ylabel('Proportion of minor outbreaks')
%legend('R','RNew','Rtheoretical') 
plot([5 5],[0 0.9],'k--')
legend('Agent (measured)','Stochastic (measured)', 'Stochastic (approximated)')
title('probability of minor outbreak')

figMajorProb = figure;
plot(measuredProbMajor,'ko-') %agent
hold on
plot(SmeasuredProbMajor,'ks-') %stochastic
plot(majorCalc,'k+-') %stoch approx
xlabel('Variant Richness')
ylabel('Proportion of major outbreaks')
%legend('R','RNew','Rtheoretical') 
legend('Agent (measured)','Stochastic (measured)', 'Stochastic (approximated)')
plot([5 5],[0 0.9],'k--')
title('probability of major outbreak')

saveas(figMinorProb,[outputDirectory 'Test21_1EXPfigMinorProb.fig']);
saveas(figMinorProb,[outputDirectory 'Test21_1EXPfigMinorProb.emf']);
saveas(figMajorProb,[outputDirectory 'Test21_1EXPfigMajorProb.fig']);
saveas(figMajorProb,[outputDirectory 'Test21_1EXPfigMajorProb.emf']);


toc
   %SAVE FOR LATER
   N %number of nodes
   FinalSize %measured agent
   FinalSized %deterministic
   FinalSizeS %stoch approx
   SFinalSize %stoch measured
Resistancea_1EXP=1-FinalSize./N
Resistanced_1EXP=1-FinalSized./N
Resistancesapp_1EXP=1-FinalSizeS./N
Resistances_1EXP=1-SFinalSize./N
Resiliencea_1EXP=1./MLa
Resilienced_1EXP=1./MLd
Resiliences_1EXP=1./SMLa
Rnewendstd_1EXP=Rnewendstd
SRnewendstd_1EXP=SRnewendstd
stdS_1EXP=stdS

end %SIRN Test21

% SIRN TEST 22 DYNAMIC
% SIR - 4 loci OR fix exploit at 1 and increase variants - takes 8 hours
%***************
if doSIRNTests(22) == 1
%outputDirectory = 'Graphs\'
outputDirectory = 'Graphs\'
%Increase variants upto 25, fix exploit
%***************************************
%SIRN testing
%***************************************
%Deterministic - 4 loci OR
tic
numNodes = 1000;
VRmin = 1 %1
VRmax = 30 %30
N=numNodes; Vmax = 1:VRmax;  G = Vmax.^2; %number genotypes
%for OR case
Sprop = SPExact4LociOR( 1, Vmax )
mode = 'dynamic' %mode - can be 'static' or 'dynamic' 'Dynamic-random' 'Dynamic-favScore'
%monte carlo random genotype SIR model
numRuns = 20 %100 %200

%set up diversity mode parameters
modePar.modeStr = mode
modePar.numToConstrain = 0 %constain a number of nodes to 1 variant
modePar.stopUpdatingTime = 20000 %time at which to stop updating the genotypes
%modePar.numEncountersBetweenUpdates = 1 % number of encounters between updates for random and favscore algorithms
modePar.bufferlength = 10 %length of genotype buffer for favscore algorithm
modePar.genoInit = 'maxdiv'  %initial conditions of genotypes maxdiv (maximum diversity - random variant chosen) mindiv (minimum diversity - all nodes same)

for z= VRmin:VRmax
 betan = 0.02; variantRichness =  z;  numTimesteps = 7000; plotGraphs = 0; gamma = 0.004; numExploits=1; numLoci=4; casetype = 'OR'; throwAway = 'nonEpidemics', cutoff = gamma.*numNodes./(betan.*Sprop); SEpidemic=50; %cutoff;
%agent
 [figMeanNei(z) figNeiOneRun(z) fighistSpRun(z) fighistRecovered(z) fighistSusceptible(z) fighistpeakValue(z) fighistpeakTime(z) fighistBeta(z) fighistGamma(z) fighistBetanew(z) fighistGammanew(z) figInfectedRun1 figBetaRun1 figGammaRun1 figRoRun1 figBetaGamma1 figBetaGamma2...
            meanNeiIndexDynamicF  betastd gammastd betastd2 betastdNew betastdNew2 gammastdNew peakTimemean peakTimestd peakValuemean peakValuestd...
            betameanmean(z) gammameanmean betameanmean2(z) betameanmeanNew(z) betameanmeanNew2 gammameanmeanNew(z) Smean(z,:) Imean(z,:) Rmean(z,:) Bmean NSmean(z,:) Smedian Imedian Rmedian S I R NS SmeanN ImeanN1(z,:) RmeanN1 BmeanN1 Snewendmean Snewendstd Rnewendmean(z) Rnewendstd(z) Rnew_nonendmean Rnew_nonendstd propSimsNonEp(z) propSimsNonEp_theoretical(z)...
            numRunsMinor(z) measuredProbMinor(z) numRunsMajor(z) measuredProbMajor(z) ...
            ] = monteCarloSIRN2(numRuns,numNodes, betan, variantRichness, numTimesteps, plotGraphs,gamma,throwAway,SEpidemic,numExploits,modePar, numLoci, casetype);
   size(ImeanN1)
FinalSize(z) = max(RmeanN1,[],2) %mean final size
    %resilience of major only
     maska = RmeanN1 >= FinalSize(z)-1; %when within 1 of the final value
    [C Index] = max(maska);
    MLa(z) = Index; %T1
    RmeanN1;
    size(RmeanN1)
    size(Index)
        %resilience of all
     maska = Rmean(z,:) >= FinalSize(z)-1; %when within 1 of the final value
    [C Index] = max(maska);
        size(Rmean(z,:))
    size(Index)
    MLa_all(z) = Index; %T1
    
             saveas(figMeanNei(z),[outputDirectory 'Test22figMeanNei' num2str(z) '.fig']);
    saveas(figMeanNei(z),[outputDirectory 'Test22figMeanNei' num2str(z) '.emf']); 
         saveas(figNeiOneRun(z),[outputDirectory 'Test22figNeiOneRun' num2str(z) '.fig']);
    saveas(figNeiOneRun(z),[outputDirectory 'Test22figNeiOneRun' num2str(z) '.emf']); 
    
         saveas(fighistSpRun(z),[outputDirectory 'Test22fighistSpRun' num2str(z) '.fig']);
    saveas(fighistSpRun(z),[outputDirectory 'Test22fighistSpRun' num2str(z) '.emf']);
        saveas(fighistRecovered(z),[outputDirectory 'Test22fighistRecovered' num2str(z) '.fig']);
    saveas(fighistRecovered(z),[outputDirectory 'Test22fighistRecovered' num2str(z) '.emf']);
    saveas(fighistSusceptible(z),[outputDirectory 'Test22fighistSusceptible' num2str(z) '.fig']);
    saveas(fighistSusceptible(z),[outputDirectory 'Test22fighistSusceptible' num2str(z) '.emf']);
    saveas(fighistpeakValue(z),[outputDirectory 'Test22fighistpeakValue' num2str(z) '.fig']);
    saveas(fighistpeakValue(z),[outputDirectory 'Test22fighistpeakValue' num2str(z) '.emf']);
    saveas(fighistpeakTime(z),[outputDirectory 'Test22fighistpeakTime' num2str(z) '.fig']);
    saveas(fighistpeakTime(z),[outputDirectory 'Test22fighistpeakTime' num2str(z) '.emf']);
    saveas(fighistBeta(z),[outputDirectory 'Test22histBeta' num2str(z) '.fig']);
    saveas(fighistBeta(z),[outputDirectory 'Test22histBeta' num2str(z) '.emf']);
    saveas(fighistGamma(z),[outputDirectory 'Test22histGamma' num2str(z) '.fig']);
    saveas(fighistGamma(z),[outputDirectory 'Test22histGamma' num2str(z) '.emf']);
    saveas(fighistBetanew(z),[outputDirectory 'Test22histBetaNew' num2str(z) '.fig']);
    saveas(fighistBetanew(z),[outputDirectory 'Test22histBetaNew' num2str(z) '.emf']);
    saveas(fighistGammanew(z),[outputDirectory 'Test22histGammaNew' num2str(z) '.fig']);
    saveas(fighistGammanew(z),[outputDirectory 'Test22histGammaNew' num2str(z) '.emf']);
    close(fighistRecovered(z));
    close(fighistSusceptible(z));
    close(fighistpeakValue(z));
    close(fighistpeakTime(z));
    close(fighistBeta(z));
    close(fighistGamma(z));
    close(fighistBetanew(z));
    close(fighistGammanew(z));
    
    %stochastic
        dtt=0.1 %stochastic dtt = used in graph and set in function
    timeS = dtt:dtt:numTimesteps;%stochastic time for graphs
    [SfighistRecovered(z) SfighistSusceptible(z) SfighistpeakValue(z) SfighistpeakTime(z) SfighistBeta(z) SfighistGamma(z) SfighistBetanew(z) SfighistGammanew(z) SfigInfectedRun1 SfigBetaRun1 SfigGammaRun1 SfigRoRun1 SfigBetaGamma1 SfigBetaGamma2...
            Sbetastd Sgammastd Sbetastd2 SbetastdNew SbetastdNew2 SgammastdNew SpeakTimemean SpeakTimestd SpeakValuemean SpeakValuestd...
            Sbetameanmean(z) Sgammameanmean Sbetameanmean2(z) SbetameanmeanNew(z) SbetameanmeanNew2 SgammameanmeanNew(z) SSmean(z,:) SImean(z,:) SRmean(z,:) SNSmean(z,:) SSmedian SImedian SRmedian SS SI SR SNS SSmeanN SImeanN1(z,:) SRmeanN1 SSnewendmean SSnewendstd SRnewendmean(z) SRnewendstd(z) SRnew_nonendmean SRnew_nonendstd SpropSimsNonEp(z) SpropSimsNonEp_theoretical(z)...
            SnumRunsMinor(z) SmeasuredProbMinor(z) SnumRunsMajor(z) SmeasuredProbMajor(z) ...
            ] = monteCarloStochastic(numRuns,numNodes, betan, variantRichness, numTimesteps, plotGraphs,gamma,throwAway,SEpidemic,numExploits,mode, numLoci, casetype);
     size(SImeanN1)
SFinalSize(z) = max(SRmeanN1,[],2) %mean final size
    %resilience of major only
     Smaska = SRmeanN1 >= SFinalSize(z)-1; %when within 1 of the final value
    [SC SIndex] = max(Smaska);
    SMLa(z) = ceil(SIndex.*dtt); %T1
        %resilience of all
     Smaska = SRmean(z,:) >= SFinalSize(z)-1; %when within 1 of the final value
    [SC SIndex] = max(Smaska);
    SMLa_all(z) = ceil(SIndex.*dtt); %T1
        saveas(SfighistRecovered(z),[outputDirectory 'Test22StochfighistRecovered' num2str(z) '.fig']);
    saveas(SfighistRecovered(z),[outputDirectory 'Test22StochfighistRecovered' num2str(z) '.emf']);
    saveas(SfighistSusceptible(z),[outputDirectory 'Test22StochfighistSusceptible' num2str(z) '.fig']);
    saveas(SfighistSusceptible(z),[outputDirectory 'Test22StochfighistSusceptible' num2str(z) '.emf']);
    saveas(SfighistpeakValue(z),[outputDirectory 'Test22StochfighistpeakValue' num2str(z) '.fig']);
    saveas(SfighistpeakValue(z),[outputDirectory 'Test22StochfighistpeakValue' num2str(z) '.emf']);
    saveas(SfighistpeakTime(z),[outputDirectory 'Test22StochfighistpeakTime' num2str(z) '.fig']);
    saveas(SfighistpeakTime(z),[outputDirectory 'Test22StochfighistpeakTime' num2str(z) '.emf']);
    saveas(SfighistBeta(z),[outputDirectory 'Test22StochhistBeta' num2str(z) '.fig']);
    saveas(SfighistBeta(z),[outputDirectory 'Test22StochhistBeta' num2str(z) '.emf']);
    saveas(SfighistGamma(z),[outputDirectory 'Test22StochhistGamma' num2str(z) '.fig']);
    saveas(SfighistGamma(z),[outputDirectory 'Test22StochhistGamma' num2str(z) '.emf']);
    saveas(SfighistBetanew(z),[outputDirectory 'Test22StochhistBetaNew' num2str(z) '.fig']);
    saveas(SfighistBetanew(z),[outputDirectory 'Test22StochhistBetaNew' num2str(z) '.emf']);
    saveas(SfighistGammanew(z),[outputDirectory 'Test22StochhistGammaNew' num2str(z) '.fig']);
    saveas(SfighistGammanew(z),[outputDirectory 'Test22StochhistGammaNew' num2str(z) '.emf']);
    close(SfighistRecovered(z));
    close(SfighistSusceptible(z));
    close(SfighistpeakValue(z));
    close(SfighistpeakTime(z));
    close(SfighistBeta(z));
    close(SfighistGamma(z));
    close(SfighistBetanew(z));
    close(SfighistGammanew(z));
    text = ['done ' num2str(z) ' out of ' num2str(VRmax)];
    disp(text)
end    
    
%Deterministic - 4 loci OR
N=numNodes; Vmax = 1:VRmax;  G = Vmax.^2; %number genotypes
%for OR case
Sprop = SPExact4LociOR( 1, Vmax )
%Sprop = 2./Vmax - 1./G %both loci have the same number of variants and both have 1 exploit
S = N.*Sprop; B = 0.02; beta = B.*Sprop; gamma = 0.004; %1/48*60*60 %2 days
for i = VRmin:VRmax
    [Ro(i) St(i,:) It(i,:) Rt(i,:)] = SIRDeterministic(beta(i), gamma, S(i), 1, 0, numTimesteps, 0); 
    FinalSized(i) = Rt(i,end);
     
    %resilience
     maskd = Rt(i,:) >= Rt(i,end)-1; %when within 1 of the final value
    [C Index] = max(maskd);
    MLd(i) = Index; %T1
end

dec = 50; t2 = 1:dec:numTimesteps;

%stochastic final size approximation
[ FinalSizeS stdS ] = finalSizeApprox( Sprop, betan, gamma, VRmin, VRmax, numNodes)

 
 figTest9inf0_02 = figure
 for i = VRmin:VRmax
     plot(Imean(i,:),'k')
     hold on
     plot(t2,It(i,1:dec:end),'k.-')
      plot(timeS,SImean(i,:),'k--')
 end
 ylabel('Number of nodes infected - It')
 xlabel('Timesteps')
 title('a) SI-Increasing variants: Nodes infected')
 legend('Agent', 'Deterministic', 'Stochastic')
 %axis([0 1000 0 400])
 
  figmajor = figure
 for i = VRmin:VRmax
     plot(ImeanN1(1,:),'k')
     hold on
     plot(t2,It(i,1:dec:end),'k.-')
     plot(timeS,SImeanN1(i,:),'k--')
     plot(ImeanN1(i,:),'k')
 end
xlabel('Timesteps')
ylabel('Number of individuals infected I(t)')
title('Mean of major outbreaks')
 legend('Agent', 'Deterministic', 'Stochastic')
%axis([0 100 0 90])
 
 
  %number of nodes infected
 figTest2FinalInfected = figure
 %agentImax = max(Imean,[],2);
 %plot(agentImax,'k')
 for j = VRmin:VRmax
 if isnan(FinalSizeS(j)); h(j) = 0; else h(j) = FinalSizeS(j); end;
 if isnan(FinalSize(j)); q(j) = 0; else q(j) = FinalSize(j); end;
  if isnan(SFinalSize(j)); v(j) = 0; else v(j) = SFinalSize(j); end;
 end
 FinalSize=q
 FinalSizeS=h
 SFinalSize=v
 plot(FinalSize,'ko-')
 hold on
 %plot(S,'k.-')
 plot(FinalSized,'k.-')
  plot(SFinalSize,'k+-')
 plot(FinalSizeS,'ks-')
plot([18.615 18.615],[0 1],'k--')
 ylabel('Final number infected')
 xlabel('Number of variants')
 title('c) SI-Increasing variants: Final size')
 legend('Agent', 'Deterministic', 'Stochastic measured','Stochastic Approximation')
 
  %number of nodes infected
 figTest2Finalstd = figure
 %agentImax = max(Imean,[],2);
 %plot(agentImax,'k')
 for j = VRmin:VRmax
 if isnan(Rnewendstd(j)); a(j) = 0; else a(j) = Rnewendstd(j); end;
 if isnan(SRnewendstd(j)); b(j) = 0; else b(j) = SRnewendstd(j); end;
  if isnan(stdS(j)); c(j) = 0; else c(j) = stdS(j); end;
 end
 SRnewendstd=a
 Rnewendstd=b
 stdS = c
 plot(Rnewendstd,'ko-') %agent measured
 hold on
 %plot(S,'k.-')
 plot(SRnewendstd,'ks-') %stochastic measured
 plot(stdS,'k+-') % calc approx
plot([18.615 18.615],[0 1],'k--')
 ylabel('Standard deviation')
 xlabel('Number of variants')
 title('c) SI-Increasing variants: Final size std')
 legend('Agent measured', 'Stochastic measured', 'Stochastic Approximation')
 
  %RESISTANCE
 figTest2Resistance = figure
 plot(1-FinalSize./N,'ko-')
 hold on
 %plot(S,'k.-')
 plot(1-FinalSized./N,'k.-')
 plot(1-SFinalSize./N,'ks-')
  plot(1-FinalSizeS./N,'k+-')
plot([18.615 18.615],[0 1],'k--')
 ylabel('Resistance M_R')
 xlabel('Variant Richness')
 title('c) SI-Increasing variants: Resistance')
 legend('Agent (measured)', ' Deterministic (measured) ', 'Stochastic (measured) ','Stochastic (approximated)')
 
 %RESILIENCE major outbreaks only
 figTest2Resilience = figure
  plot(1./MLa,'ko-') %agent measured
 hold on
 plot(1./MLd,'k.-') %deterministic
  plot(1./SMLa,'ks-') %stochastic measured
 hold on
  ylabel('Resilience M_L')
 xlabel('Variant Richness')
 title('c) SI-Increasing variants: Resilience major')
 legend('Agent (measured)', 'Deterministic (measured)', 'Stochastic (measured)')
 plot([18.615 18.615],[0 1],'k--')
 
  %RESILIENCE TIME of major outbreaks only
 figTest2ResilienceTime = figure
  plot(MLa,'ko-') %agent measured
 hold on
 plot(MLd,'k.-') %deterministic
  plot(SMLa,'ks-') %stochastic measured
 hold on
  ylabel('Resilience Time')
 xlabel('Variant Richness')
 title('c) SI-Increasing variants: Resilience Time major')
 legend('Agent (measured)', 'Deterministic (measured)', 'Stochastic (measured)')
  plot([1.8533 1.8533],[0 1],'k--')
   %axis([1 8 0 1.1])

 
saveas(figTest9inf0_02,[outputDirectory 'Test22meanall.fig']);
saveas(figTest9inf0_02,[outputDirectory 'Test22meanall.emf']); 
saveas(figmajor,[outputDirectory 'Test22meanmajor.fig']);
saveas(figmajor,[outputDirectory 'Test22meanmajor.emf']);
saveas(figTest2FinalInfected,[outputDirectory 'Test22FinalInfected.fig']);
saveas(figTest2FinalInfected,[outputDirectory 'Test22FinalInfected.emf']);
saveas(figTest2Finalstd,[outputDirectory 'Test22Finalstd.fig']);
saveas(figTest2Finalstd,[outputDirectory 'Test22Finalstd.emf']);
saveas(figTest2Resistance,[outputDirectory 'Test22Resistance.fig']);
saveas(figTest2Resistance,[outputDirectory 'Test22Resistance.emf']);
saveas(figTest2Resilience,[outputDirectory 'Test22Resilience.fig']);
saveas(figTest2Resilience,[outputDirectory 'Test22Resilience.emf']);
saveas(figTest2ResilienceTime,[outputDirectory 'Test22ResilienceTime.fig']);
saveas(figTest2ResilienceTime,[outputDirectory 'Test22ResilienceTime.emf']);
%close all


betameanmean
gammameanmean

betameanmean2
betameanmeanNew 
betameanmeanNew2
gammameanmeanNew

Rnewendmean%epidemics only
Rnewendstd

 propSimsNonEp % proportion of sims with non-epidemics
 propSimsNonEp_theoretical %theoretical value
    
R = betameanmean./gammameanmean
RN = betameanmeanNew./gammameanmeanNew
SRN = SbetameanmeanNew./SgammameanmeanNew
RTheoretical = beta./gamma

figro = figure
%plot(beta,R,'k')
hold on
plot(RN,'ko-')
plot(RTheoretical,'k.-')
plot(RN,'ks-') %stochastic measured
plot([1 1 1 1 1 1 1 1],'k--')
plot([18.615 18.615],[0 1],'k--')
xlabel('Number of variants')
ylabel('ro')
%legend('R','RNew','Rtheoretical') 
legend('Ro Agent(measured)','Ro Deterministic','Ro Stochastic(measured)') 
%axis([0.1 0.5 0 2])
saveas(figro,[outputDirectory 'Test22figro.fig']);
saveas(figro,[outputDirectory 'Test22figro.emf']);
%close all
%close all;

%calculate proportion of minor and major outbreaks
[ minorCalc majorCalc ] = propCalcOutbreaks( Sprop, B, gamma )
%measure proportion of minor and major outbreaks
%agent
%numRunsMinor measuredProbMinor numRunsMajor measuredProbMajor
numRunsMinor
numRunsMajor
measuredProbMinor
measuredProbMajor
%stochastic
%SnumRunsMinor SmeasuredProbMinor SnumRunsMajor SmeasuredProbMajor
SnumRunsMinor
SnumRunsMajor
SmeasuredProbMinor
SmeasuredProbMajor

figMinorProb = figure;
plot(measuredProbMinor,'ko-') %agent
hold on
plot(SmeasuredProbMinor,'ks-') %stochastic
plot(minorCalc,'k+-') %stoch approx
xlabel('Variant Richness')
ylabel('Proportion of minor outbreaks')
%legend('R','RNew','Rtheoretical') 
plot([18.615 18.615],[0 0.9],'k--')
legend('Agent (measured)','Stochastic (measured)', 'Stochastic (approximated)')
title('probability of minor outbreak')

figMajorProb = figure;
plot(measuredProbMajor,'ko-') %agent
hold on
plot(SmeasuredProbMajor,'ks-') %stochastic
plot(majorCalc,'k+-') %stoch approx
xlabel('Variant Richness')
ylabel('Proportion of major outbreaks')
%legend('R','RNew','Rtheoretical') 
legend('Agent (measured)','Stochastic (measured)', 'Stochastic (approximated)')
plot([18.615 18.615],[0 0.9],'k--')
title('probability of major outbreak')

saveas(figMinorProb,[outputDirectory 'Test22_1EXPfigMinorProb.fig']);
saveas(figMinorProb,[outputDirectory 'Test22_1EXPfigMinorProb.emf']);
saveas(figMajorProb,[outputDirectory 'Test22_1EXPfigMajorProb.fig']);
saveas(figMajorProb,[outputDirectory 'Test22_1EXPfigMajorProb.emf']);


toc
   %SAVE FOR LATER
   N %number of nodes
   FinalSize %measured agent
   FinalSized %deterministic
   FinalSizeS %stoch approx
   SFinalSize %stoch measured
Resistancea_1EXP=1-FinalSize./N
Resistanced_1EXP=1-FinalSized./N
Resistancesapp_1EXP=1-FinalSizeS./N
Resistances_1EXP=1-SFinalSize./N
Resiliencea_1EXP=1./MLa
Resilienced_1EXP=1./MLd
Resiliences_1EXP=1./SMLa
Rnewendstd_1EXP=Rnewendstd
SRnewendstd_1EXP=SRnewendstd
stdS_1EXP=stdS

end %SIRN Test22

%*********************************
%Diversity method times to maximum diversity
%***********************************
if doSIRNTests(23) == 1
%NEED TO COMMENT OUT THE FOLLOWING FOR TEST: genotypeNode(:,1:numNotConstrain) = randi(variantRichness,[numLoci,numNotConstrain]); %number not to constrain
%1 locus model
%outputDirectory = 'Graphs\'
outputDirectory = 'Graphs\'
%VR 5
%time of reaching maximum diversity for dynamic diversity algorithms
%***************************************
%SIRN testing
%***************************************
tic
numNodes = 1000;
VRmin = 5 %1
VRmax = 5 %10
N=numNodes; Vmax = 1:VRmax;  G = Vmax.^2; %number genotypes
%for OR case
Sprop = SPExact1LociOR( 1, Vmax )
mode = 'Dynamic-random' %mode - can be 'static' or 'dynamic' 'Dynamic-random' 'Dynamic-favScore'
%monte carlo random genotype SIR model
numRuns = 1 %100 %200
numEncountersBetweenUpdates = [1 10 20 50]
%set up diversity mode parameters
modePar.modeStr = mode
modePar.numToConstrain = 0 %constain a number of nodes to 1 variant
modePar.stopUpdatingTime = 20000 %time at which to stop updating the genotypes
%modePar.numEncountersBetweenUpdates = 1 % number of encounters between updates for random and favscore algorithms
modePar.bufferlength = 10 %length of genotype buffer for favscore algorithm
modePar.genoInit = 'mindiv'  %initial conditions of genotypes maxdiv (maximum diversity - random variant chosen) mindiv (minimum diversity - all nodes same)


for z= 1:4
    modePar.numEncountersBetweenUpdates = numEncountersBetweenUpdates(z);
 betan = 0.02; variantRichness =  VRmin;  numTimesteps = 3500; plotGraphs = 0; gamma = 0.004; numExploits=1; numLoci=1; casetype = 'OR'; throwAway = 'nonEpidemics', cutoff = gamma.*numNodes./(betan.*Sprop); SEpidemic=60; %cutoff;

 %agent
 [figMeanNei figNeiOneRun fighistSpRun fighistRecovered fighistSusceptible fighistpeakValue fighistpeakTime fighistBeta fighistGamma fighistBetanew fighistGammanew figInfectedRun1 figBetaRun1 figGammaRun1 figRoRun1 figBetaGamma1 figBetaGamma2...
            meanNeiIndexDynamic(z,:) betastd gammastd betastd2 betastdNew betastdNew2 gammastdNew peakTimemean peakTimestd peakValuemean peakValuestd...
            betameanmean(z) gammameanmean betameanmean2(z) betameanmeanNew(z) betameanmeanNew2 gammameanmeanNew(z) Smean Imean Rmean Bmean NSmean Smedian Imedian Rmedian S I R NS SmeanN ImeanN1 RmeanN1 BmeanN1 Snewendmean Snewendstd Rnewendmean(z) Rnewendstd(z) Rnew_nonendmean Rnew_nonendstd propSimsNonEp(z) propSimsNonEp_theoretical(z)...
            numRunsMinor(z) measuredProbMinor(z) numRunsMajor(z) measuredProbMajor(z) ...
            ] = monteCarloSIRN2(numRuns,numNodes, betan, variantRichness, numTimesteps, plotGraphs,gamma,throwAway,SEpidemic,numExploits,modePar, numLoci, casetype);


sizemeanNeiIndexDynamic = size(meanNeiIndexDynamic)
end
close all;

mode = 'Dynamic-favScore' %mode - can be 'static' or 'dynamic' 'Dynamic-random' 'Dynamic-favScore'
%monte carlo random genotype SIR model
numRuns = 1 %100 %200
numEncountersBetweenUpdates = [1 10 20 50]
%set up diversity mode parameters
modePar.modeStr = mode
modePar.numToConstrain = 0 %constain a number of nodes to 1 variant
modePar.stopUpdatingTime = 20000 %time at which to stop updating the genotypes
%modePar.numEncountersBetweenUpdates = 1 % number of encounters between updates for random and favscore algorithms
modePar.bufferlength = 10 %length of genotype buffer for favscore algorithm
modePar.genoInit = 'mindiv'  %initial conditions of genotypes maxdiv (maximum diversity - random variant chosen) mindiv (minimum diversity - all nodes same)


for z= 1:4
    modePar.numEncountersBetweenUpdates = numEncountersBetweenUpdates(z);
 betan = 0.02; variantRichness =  VRmin;  numTimesteps = 3500; plotGraphs = 0; gamma = 0.004; numExploits=1; numLoci=1; casetype = 'OR'; throwAway = 'nonEpidemics', cutoff = gamma.*numNodes./(betan.*Sprop); SEpidemic=60; %cutoff;

 %agent
 [figMeanNei figNeiOneRun fighistSpRun fighistRecovered fighistSusceptible fighistpeakValue fighistpeakTime fighistBeta fighistGamma fighistBetanew fighistGammanew figInfectedRun1 figBetaRun1 figGammaRun1 figRoRun1 figBetaGamma1 figBetaGamma2...
            meanNeiIndexDynamicF(z,:) betastd gammastd betastd2 betastdNew betastdNew2 gammastdNew peakTimemean peakTimestd peakValuemean peakValuestd...
            betameanmean(z) gammameanmean betameanmean2(z) betameanmeanNew(z) betameanmeanNew2 gammameanmeanNew(z) Smean Imean Rmean Bmean NSmean Smedian Imedian Rmedian S I R NS SmeanN ImeanN1 RmeanN1 BmeanN1 Snewendmean Snewendstd Rnewendmean(z) Rnewendstd(z) Rnew_nonendmean Rnew_nonendstd propSimsNonEp(z) propSimsNonEp_theoretical(z)...
            numRunsMinor(z) measuredProbMinor(z) numRunsMajor(z) measuredProbMajor(z) ...
            ] = monteCarloSIRN2(numRuns,numNodes, betan, variantRichness, numTimesteps, plotGraphs,gamma,throwAway,SEpidemic,numExploits,modePar, numLoci, casetype);


sizemeanNeiIndexDynamic = size(meanNeiIndexDynamic)
end
close all;

            %diversity mean
            figMeanNei=figure
            for s= 1:4
            plot(meanNeiIndexDynamic(s,:),'k')
            hold on
            end
            numAlleles = repmat(variantRichness,[1,numLoci]);
            [ Dmax DmaxLocus ] = getMaxNeiCalc( numNodes, numAlleles );
            DmaxLine = repmat(Dmax,[1 numTimesteps]);
            plot(DmaxLine,'k','Linewidth',2)
            xlabel('Time (second)')
            ylabel('Diversity')
            axis([0 numTimesteps 0 1])
            legend('update: every 1 encounter','update: every 10 encounters','update: every 20 encounters','update: every 50 encounters')
            title('Dynamic-random, VR=5')
            
            %diversity mean
            figMeanNei=figure
            for s= 1:4
            plot(meanNeiIndexDynamicF(s,:),'k')
            hold on
            end
            numAlleles = repmat(variantRichness,[1,numLoci]);
            [ Dmax DmaxLocus ] = getMaxNeiCalc( numNodes, numAlleles );
            DmaxLine = repmat(Dmax,[1 numTimesteps]);
            plot(DmaxLine,'k','Linewidth',2)
            xlabel('Time (second)')
            ylabel('Diversity')
            axis([0 numTimesteps 0 1])
            legend('update: every 1 encounter','update: every 10 encounters','update: every 20 encounters','update: every 50 encounters')
            title('Dynamic-favScore, VR=5')
            
                        %diversity mean
            figMeanNei=figure
            for s= 1:4
            plot(meanNeiIndexDynamic(s,:),'k','Linewidth',2)
            hold on
            plot(meanNeiIndexDynamicF(s,:),'k--','Linewidth',2)
            end
            numAlleles = repmat(variantRichness,[1,numLoci]);
            [ Dmax DmaxLocus ] = getMaxNeiCalc( numNodes, numAlleles );
            DmaxLine = repmat(Dmax,[1 numTimesteps]);
            plot(DmaxLine,'k','Linewidth',2)
            xlabel('Time (second)')
            ylabel('Diversity')
            axis([0 numTimesteps 0 1])
            %legend('update: every 1 encounter','update: every 10 encounters','update: every 20 encounters','update: every 50 encounters')
            legend('Diversity: random','Diversity: favscore')
            title('Dynamic, VR=5')

end

%*********************************
%Dynamic Diversity reaching highest diversity level-
%time graphs
%***********************************
if doSIRNTests(24) == 1
%1 locus model
%outputDirectory = 'Graphs\'
outputDirectory = 'Graphs\'
%VR 5
numRuns = 20 %100 %200
tic
numNodes = 1000;
%VRmin = 5 %1
%VRmax = 5 %10
VR = [2 5 10 20 50]
numTimestepsVR = [5000 5000 5000 5000 5000];
numEncountersBetweenUpdates = [2 5 10 20 50]
modePar.numToBlklist = 1
modePar.blklistrate = 0.004 %0.001
modePar.blklist = 'no'; %yes or no
%N=numNodes; Vmax = 1:VRmax;  G = Vmax.^2; %number genotypes
%for OR case
Sprop = SPExact1LociOR( 1, 5 )
mode = 'Dynamic-random' %mode - can be 'static' or 'dynamic' 'Dynamic-random' 'Dynamic-favScore'
%monte carlo random genotype SIR model


%set up diversity mode parameters
modePar.modeStr = mode
modePar.numToConstrain = 0;%fix(numNodes/2) %constain a number of nodes to 1 variant
modePar.stopUpdatingTime = 200000 %time at which to stop updating the genotypes
%modePar.numEncountersBetweenUpdates = 1 % number of encounters between updates for random and favscore algorithms
modePar.bufferlength = 10 %length of genotype buffer for favscore algorithm
modePar.genoInit = 'mindiv'  %initial conditions of genotypes maxdiv (maximum diversity - random variant chosen) mindiv (minimum diversity - all nodes same)

meanNeiIndexDynamic = zeros(1,5000);
meanNeiIndexDynamicF = zeros(1,5000);

for j = 1:size(VR,2)%do for all VRs
    variantRichness =  VR(j);
    numTimesteps = numTimestepsVR(j)
for z= 1:size(numEncountersBetweenUpdates,2)
    modePar.numEncountersBetweenUpdates = numEncountersBetweenUpdates(z);
 betan = 0.02;  plotGraphs = 0; gamma = 0.004; numExploits=1; numLoci=1; casetype = 'OR'; throwAway = 'nonEpidemics', cutoff = gamma.*numNodes./(betan.*Sprop); SEpidemic=60; %cutoff;
j
z
 %agent
 [figMeanNei figNeiOneRun fighistSpRun fighistRecovered fighistSusceptible fighistpeakValue fighistpeakTime fighistBeta fighistGamma fighistBetanew fighistGammanew figInfectedRun1 figBetaRun1 figGammaRun1 figRoRun1 figBetaGamma1 figBetaGamma2...
            meanNeiIndexDynamic(z,1:numTimesteps) betastd gammastd betastd2 betastdNew betastdNew2 gammastdNew peakTimemean peakTimestd peakValuemean peakValuestd...
            betameanmean gammameanmean betameanmean2 betameanmeanNew betameanmeanNew2 gammameanmeanNew Smean Imean Rmean Bmean NSmean Smedian Imedian Rmedian S I R NS SmeanN ImeanN1 RmeanN1 BmeanN1 Snewendmean Snewendstd Rnewendmean Rnewendstd Rnew_nonendmean Rnew_nonendstd propSimsNonEp propSimsNonEp_theoretical...
            numRunsMinor measuredProbMinor numRunsMajor measuredProbMajor ...
            ] = monteCarloSIRN2(numRuns,numNodes, betan, variantRichness, numTimesteps, plotGraphs,gamma,throwAway,SEpidemic,numExploits,modePar, numLoci, casetype);
maxNei = max(meanNeiIndexDynamic(z,1:numTimesteps),[],2); %mean final size SI
    %time
    size(maxNei)
     maska = meanNeiIndexDynamic(z,1:numTimesteps) >= maxNei-0.001; %when first reaches max with small tolerance
    [C Index] = max(maska);
    MLaRE(j,z) = Index %T1
end

end
close all;


numNodes = 1000;
%VRmin = 5 %1
%VRmax = 5 %10
%N=numNodes; Vmax = 1:VRmax;  G = Vmax.^2; %number genotypes
%for OR case
Sprop = SPExact1LociOR( 1, 5 )
mode = 'Dynamic-favScore' %mode - can be 'static' or 'dynamic' 'Dynamic-random' 'Dynamic-favScore'
%monte carlo random genotype SIR model
%numRuns = 1 %100 %200
%numEncountersBetweenUpdates = [1 10 20 50]
%set up diversity mode parameters
modePar.modeStr = mode
modePar.numToConstrain = 0;%fix(numNodes/2) %constain a number of nodes to 1 variant
modePar.stopUpdatingTime = 200000 %time at which to stop updating the genotypes
%modePar.numEncountersBetweenUpdates = 1 % number of encounters between updates for random and favscore algorithms
modePar.bufferlength = 10 %length of genotype buffer for favscore algorithm
modePar.genoInit = 'mindiv'  %initial conditions of genotypes maxdiv (maximum diversity - random variant chosen) mindiv (minimum diversity - all nodes same)

for j = 1:size(VR,2)%do for all VRs
    variantRichness =  VR(j);
    numTimesteps = numTimestepsVR(j)
for z= 1:size(numEncountersBetweenUpdates,2) %do for all update rates
    modePar.numEncountersBetweenUpdates = numEncountersBetweenUpdates(z);
 betan = 0.02;  plotGraphs = 0; gamma = 0.004; numExploits=1; numLoci=1; casetype = 'OR'; throwAway = 'nonEpidemics', cutoff = gamma.*numNodes./(betan.*Sprop); SEpidemic=60; %cutoff;

 %agent
 [figMeanNei figNeiOneRun fighistSpRun fighistRecovered fighistSusceptible fighistpeakValue fighistpeakTime fighistBeta fighistGamma fighistBetanew fighistGammanew figInfectedRun1 figBetaRun1 figGammaRun1 figRoRun1 figBetaGamma1 figBetaGamma2...
            meanNeiIndexDynamicF(z,1:numTimesteps) betastd gammastd betastd2 betastdNew betastdNew2 gammastdNew peakTimemean peakTimestd peakValuemean peakValuestd...
            betameanmean gammameanmean betameanmean2 betameanmeanNew betameanmeanNew2 gammameanmeanNew Smean Imean Rmean NSmean Bmean Smedian Imedian Rmedian S I R NS SmeanN ImeanN1 RmeanN1 BmeanN1 Snewendmean Snewendstd Rnewendmean Rnewendstd Rnew_nonendmean Rnew_nonendstd propSimsNonEp propSimsNonEp_theoretical...
            numRunsMinor measuredProbMinor numRunsMajor measuredProbMajor ...
            ] = monteCarloSIRN2(numRuns,numNodes, betan, variantRichness, numTimesteps, plotGraphs,gamma,throwAway,SEpidemic,numExploits,modePar, numLoci, casetype);
maxNei = max(meanNeiIndexDynamicF(z,1:numTimesteps),[],2); %mean final size SI
    %time
     maska = meanNeiIndexDynamicF(z,1:numTimesteps) >= maxNei-0.001; %when first reaches max with small tolerance
    [C Index] = max(maska);
    MLaFS(j,z) = Index %T1
end
end
close all;
%vary buffer size same as number of encounters
numNodes = 1000;
%VRmin = 5 %1
%VRmax = 5 %10
%N=numNodes; Vmax = 1:VRmax;  G = Vmax.^2; %number genotypes
%for OR case
Sprop = SPExact1LociOR( 1, 5 )
mode = 'Dynamic-favScore' %mode - can be 'static' or 'dynamic' 'Dynamic-random' 'Dynamic-favScore'
%monte carlo random genotype SIR model
%numRuns = 1 %100 %200
%numEncountersBetweenUpdates = [1 10 20 50]
%set up diversity mode parameters
modePar.modeStr = mode
modePar.numToConstrain = 0;%fix(numNodes/2) %constain a number of nodes to 1 variant
modePar.stopUpdatingTime = 200000 %time at which to stop updating the genotypes
%modePar.numEncountersBetweenUpdates = 1 % number of encounters between updates for random and favscore algorithms
%modePar.bufferlength = 10 %length of genotype buffer for favscore algorithm
modePar.genoInit = 'mindiv'  %initial conditions of genotypes maxdiv (maximum diversity - random variant chosen) mindiv (minimum diversity - all nodes same)

for j = 1:size(VR,2)%do for all VRs
    variantRichness =  VR(j);
    numTimesteps = numTimestepsVR(j)
for z= 1:size(numEncountersBetweenUpdates,2) %do for all update rates
    modePar.numEncountersBetweenUpdates = numEncountersBetweenUpdates(z);
    modePar.bufferlength=numEncountersBetweenUpdates(z);
 betan = 0.02;  plotGraphs = 0; gamma = 0.004; numExploits=1; numLoci=1; casetype = 'OR'; throwAway = 'nonEpidemics', cutoff = gamma.*numNodes./(betan.*Sprop); SEpidemic=60; %cutoff;

 %agent
 [figMeanNei figNeiOneRun fighistSpRun fighistRecovered fighistSusceptible fighistpeakValue fighistpeakTime fighistBeta fighistGamma fighistBetanew fighistGammanew figInfectedRun1 figBetaRun1 figGammaRun1 figRoRun1 figBetaGamma1 figBetaGamma2...
            meanNeiIndexDynamicF(z,1:numTimesteps) betastd gammastd betastd2 betastdNew betastdNew2 gammastdNew peakTimemean peakTimestd peakValuemean peakValuestd...
            betameanmean gammameanmean betameanmean2 betameanmeanNew betameanmeanNew2 gammameanmeanNew Smean Imean Rmean NSmean Bmean Smedian Imedian Rmedian S I R NS SmeanN ImeanN1 RmeanN1 BmeanN1 Snewendmean Snewendstd Rnewendmean Rnewendstd Rnew_nonendmean Rnew_nonendstd propSimsNonEp propSimsNonEp_theoretical...
            numRunsMinor measuredProbMinor numRunsMajor measuredProbMajor ...
            ] = monteCarloSIRN2(numRuns,numNodes, betan, variantRichness, numTimesteps, plotGraphs,gamma,throwAway,SEpidemic,numExploits,modePar, numLoci, casetype);
maxNei = max(meanNeiIndexDynamicF(z,1:numTimesteps),[],2); %mean final size SI
    %time
     maska = meanNeiIndexDynamicF(z,1:numTimesteps) >= maxNei-0.001; %when first reaches max with small tolerance
    [C Index] = max(maska);
    MLaFS2(j,z) = Index %T1 %buffer length same as update rate
end
end

MLaFS

 MLaRE
close all;
              %Time relationships
              figure
              plot(numEncountersBetweenUpdates,MLaRE(1,:),'k') %all update rates RE
              hold on
              plot(numEncountersBetweenUpdates,MLaFS(1,:),'k--') %all update rates FS
              for j = 1:size(VR,2)%do for all VRs
              plot(numEncountersBetweenUpdates,MLaRE(j,:),'k') %all update rates RE
              hold on
              plot(numEncountersBetweenUpdates,MLaFS(j,:),'k--') %all update rates FS
              end
             legend('Diversity: random','Diversity: favscore')
            xlabel('Number of encounters before an update')
            ylabel('Time to reach maximum')
             title('numUpdates vs Time')
             
                           %Time relationships
              figure
              plot(numEncountersBetweenUpdates,MLaRE(1,:),'k') %all update rates RE
              hold on
              plot(numEncountersBetweenUpdates,MLaFS(1,:),'k--') %all update rates FS
               plot(numEncountersBetweenUpdates,MLaFS2(1,:),'k+-') %all update rates FS
              for j = 1:size(VR,2)%do for all VRs
              plot(numEncountersBetweenUpdates,MLaRE(j,:),'k') %all update rates RE
              hold on
              plot(numEncountersBetweenUpdates,MLaFS(j,:),'k--') %all update rates FS
              plot(numEncountersBetweenUpdates,MLaFS2(j,:),'k+-') %all update rates FS
              end
             legend('RV-E','FS (10)', 'FS (buffer same as update rate)')
            xlabel('Number of encounters before an update')
            ylabel('Time to reach maximum')
             title('numUpdates vs Time')
             
                                        %Time relationships
              figure
              plot(numEncountersBetweenUpdates,MLaRE(1,:),'k') %all update rates RE
              hold on
              %plot(numEncountersBetweenUpdates,MLaFS(1,:),'k--') %all update rates FS
               plot(numEncountersBetweenUpdates,MLaFS2(1,:),'k+-') %all update rates FS
              for j = 1:size(VR,2)%do for all VRs
              plot(numEncountersBetweenUpdates,MLaRE(j,:),'k') %all update rates RE
              hold on
              %plot(numEncountersBetweenUpdates,MLaFS(j,:),'k--') %all update rates FS
              plot(numEncountersBetweenUpdates,MLaFS2(j,:),'k+-') %all update rates FS
              end
             legend('RV-E', 'FS (buffer same as update rate)')
            xlabel('Number of encounters before an update')
            ylabel('Time to reach maximum')
             title('numUpdates vs Time')
             

              figure
              plot(VR,MLaRE(:,1),'k') %all update rates RE
              hold on
              plot(VR,MLaFS(:,1),'k--') %all update rates FS
              for z = 1:size(numEncountersBetweenUpdates,2)%do for all VRs
              plot(VR,MLaRE(:,z),'k') %all update rates RE
              hold on
              plot(VR,MLaFS(:,z),'k--') %all update rates FS
              end
             legend('Diversity: random','Diversity: favscore')
            xlabel('Number of Variants')
            ylabel('Time to reach maximum')
             title('numUpdates vs Time')
 

                       %diversity mean DISPLAYS LAST VR value (50)
            figMeanNei=figure
            for s= 1:size(numEncountersBetweenUpdates,2)
            plot(meanNeiIndexDynamic(s,:),'k','Linewidth',2)
            hold on
            plot(meanNeiIndexDynamicF(s,:),'k--','Linewidth',2)
            end
            numAlleles = repmat(variantRichness,[1,numLoci]);
            [ Dmax DmaxLocus ] = getMaxNeiCalc( numNodes, numAlleles );
            DmaxLine = repmat(Dmax,[1 numTimesteps]);
            plot(DmaxLine,'k','Linewidth',2)
            xlabel('Time (second)')
            ylabel('Diversity')
            axis([0 numTimesteps 0 1])
            %legend('update: every 1 encounter','update: every 10 encounters','update: every 20 encounters','update: every 50 encounters')
            legend('Diversity: random','Diversity: favscore')
            title('constrained Dynamic, VR=5')


                       %diversity mean
            figMeanNei=figure
            for s= 1:1
            plot(meanNeiIndexDynamic(s,:),'k','Linewidth',2)
            hold on
            plot(meanNeiIndexDynamicF(s,:),'k--','Linewidth',2)
            end
            numAlleles = repmat(variantRichness,[1,numLoci]);
            [ Dmax DmaxLocus ] = getMaxNeiCalc( numNodes, numAlleles );
            DmaxLine = repmat(Dmax,[1 numTimesteps]);
            plot(DmaxLine,'k','Linewidth',2)
            xlabel('Time (second)')
            ylabel('Diversity')
            axis([0 numTimesteps 0 1])
            %legend('update: every 1 encounter','update: every 10 encounters','update: every 20 encounters','update: every 50 encounters')
            legend('Diversity: random','Diversity: favscore')
            title('constrained Dynamic, VR=5')


                                   %diversity mean
            figMeanNei=figure
            for s= 2:2
            plot(meanNeiIndexDynamic(s,:),'k','Linewidth',2)
            hold on
            plot(meanNeiIndexDynamicF(s,:),'k--','Linewidth',2)
            end
            numAlleles = repmat(variantRichness,[1,numLoci]);
            [ Dmax DmaxLocus ] = getMaxNeiCalc( numNodes, numAlleles );
            DmaxLine = repmat(Dmax,[1 numTimesteps]);
            plot(DmaxLine,'k','Linewidth',2)
            xlabel('Time (second)')
            ylabel('Diversity')
            axis([0 numTimesteps 0 1])
            %legend('update: every 1 encounter','update: every 10 encounters','update: every 20 encounters','update: every 50 encounters')
            legend('Diversity: random','Diversity: favscore')
            title('constrained Dynamic, VR=5')
            
                                   %diversity mean
            figMeanNei=figure
            for s= 3:3
            plot(meanNeiIndexDynamic(s,:),'k','Linewidth',2)
            hold on
            plot(meanNeiIndexDynamicF(s,:),'k--','Linewidth',2)
            end
            numAlleles = repmat(variantRichness,[1,numLoci]);
            [ Dmax DmaxLocus ] = getMaxNeiCalc( numNodes, numAlleles );
            DmaxLine = repmat(Dmax,[1 numTimesteps]);
            plot(DmaxLine,'k','Linewidth',2)
            xlabel('Time (second)')
            ylabel('Diversity')
            axis([0 numTimesteps 0 1])
            %legend('update: every 1 encounter','update: every 10 encounters','update: every 20 encounters','update: every 50 encounters')
            legend('Diversity: random','Diversity: favscore')
            title('constrained Dynamic, VR=5')
            
                                   %diversity mean
            figMeanNei=figure
            for s= 4:4
            plot(meanNeiIndexDynamic(s,:),'k','Linewidth',2)
            hold on
            plot(meanNeiIndexDynamicF(s,:),'k--','Linewidth',2)
            end
            numAlleles = repmat(variantRichness,[1,numLoci]);
            [ Dmax DmaxLocus ] = getMaxNeiCalc( numNodes, numAlleles );
            DmaxLine = repmat(Dmax,[1 numTimesteps]);
            plot(DmaxLine,'k','Linewidth',2)
            xlabel('Time (second)')
            ylabel('Diversity')
            axis([0 numTimesteps 0 1])
            %legend('update: every 1 encounter','update: every 10 encounters','update: every 20 encounters','update: every 50 encounters')
            legend('Diversity: random','Diversity: favscore')
            title('constrained Dynamic, VR=5')
end


%*********************************
%Dynamic Diversity reaching highest diversity level-vary the number of
%devices
%time graphs
%***********************************
if doSIRNTests(26) == 1
%1 locus model
%outputDirectory = 'Graphs\' 
outputDirectory = 'Graphs\'
%VR 5
numRuns = 20 %100 %200
tic
numNodesS = [10 20 50 100 500 1000];
%VRmin = 5 %1
%VRmax = 5 %10
VR = [50 50 50 50 50 50]
numTimestepsVR = [5000 5000 5000 5000 5000 5000];
modePar.numToBlklist = 1
modePar.blklistrate = 0.004 %0.001
modePar.blklist = 'no'; %yes or no
%N=numNodes; Vmax = 1:VRmax;  G = Vmax.^2; %number genotypes
%for OR case
Sprop = SPExact1LociOR( 1, 5 )
mode = 'Dynamic-random' %mode - can be 'static' or 'dynamic' 'Dynamic-random' 'Dynamic-favScore'
%monte carlo random genotype SIR model

numEncountersBetweenUpdates = [1 10 20 50]
%set up diversity mode parameters
modePar.modeStr = mode
modePar.numToConstrain = 0;%fix(numNodes/2) %constain a number of nodes to 1 variant
modePar.stopUpdatingTime = 200000 %time at which to stop updating the genotypes
%modePar.numEncountersBetweenUpdates = 1 % number of encounters between updates for random and favscore algorithms
modePar.bufferlength = 10 %length of genotype buffer for favscore algorithm
modePar.genoInit = 'mindiv'  %initial conditions of genotypes maxdiv (maximum diversity - random variant chosen) mindiv (minimum diversity - all nodes same)

meanNeiIndexDynamic = zeros(1,5000);
meanNeiIndexDynamicF = zeros(1,5000);

for j = 1:size(VR,2)%do for all node sizes
    variantRichness =  VR(j);
    numTimesteps = numTimestepsVR(j);
    numNodes = numNodesS(j);
for z= 1:4 %do for all number of encounters
    modePar.numEncountersBetweenUpdates = numEncountersBetweenUpdates(z);
 betan = 0.02;  plotGraphs = 0; gamma = 0.004; numExploits=1; numLoci=1; casetype = 'OR'; throwAway = 'nonEpidemics', cutoff = gamma.*numNodes./(betan.*Sprop); SEpidemic=60; %cutoff;
j
z
 %agent
 [figMeanNei figNeiOneRun fighistSpRun fighistRecovered fighistSusceptible fighistpeakValue fighistpeakTime fighistBeta fighistGamma fighistBetanew fighistGammanew figInfectedRun1 figBetaRun1 figGammaRun1 figRoRun1 figBetaGamma1 figBetaGamma2...
            meanNeiIndexDynamic(z,1:numTimesteps) betastd gammastd betastd2 betastdNew betastdNew2 gammastdNew peakTimemean peakTimestd peakValuemean peakValuestd...
            betameanmean gammameanmean betameanmean2 betameanmeanNew betameanmeanNew2 gammameanmeanNew Smean Imean Rmean Bmean NSmean Smedian Imedian Rmedian S I R NS SmeanN ImeanN1 RmeanN1 BmeanN1 Snewendmean Snewendstd Rnewendmean Rnewendstd Rnew_nonendmean Rnew_nonendstd propSimsNonEp propSimsNonEp_theoretical...
            numRunsMinor measuredProbMinor numRunsMajor measuredProbMajor ...
            ] = monteCarloSIRN2(numRuns,numNodes, betan, variantRichness, numTimesteps, plotGraphs,gamma,throwAway,SEpidemic,numExploits,modePar, numLoci, casetype);
maxNei = max(meanNeiIndexDynamic(z,:),[],2); %mean final size SI
    %time
    size(maxNei)
     maska = meanNeiIndexDynamic(z,:) >= maxNei-0.01; %when first reaches max with small tolerance
    [C Index] = max(maska);
    MLaRE(j,z) = Index %T1
end

end
close all;


numNodes = 1000;
%VRmin = 5 %1
%VRmax = 5 %10
%N=numNodes; Vmax = 1:VRmax;  G = Vmax.^2; %number genotypes
%for OR case
Sprop = SPExact1LociOR( 1, 5 )
mode = 'Dynamic-favScore' %mode - can be 'static' or 'dynamic' 'Dynamic-random' 'Dynamic-favScore'
%monte carlo random genotype SIR model
%numRuns = 1 %100 %200
numEncountersBetweenUpdates = [1 10 20 50]
%set up diversity mode parameters
modePar.modeStr = mode
modePar.numToConstrain = 0;%fix(numNodes/2) %constain a number of nodes to 1 variant
modePar.stopUpdatingTime = 200000 %time at which to stop updating the genotypes
%modePar.numEncountersBetweenUpdates = 1 % number of encounters between updates for random and favscore algorithms
modePar.bufferlength = 10 %length of genotype buffer for favscore algorithm
modePar.genoInit = 'mindiv'  %initial conditions of genotypes maxdiv (maximum diversity - random variant chosen) mindiv (minimum diversity - all nodes same)

for j = 1:size(VR,2)%do for all VRs
     variantRichness =  VR(j);
    numTimesteps = numTimestepsVR(j);
    numNodes = numNodesS(j);
for z= 1:4 %do for all update rates
    modePar.numEncountersBetweenUpdates = numEncountersBetweenUpdates(z);
 betan = 0.02;  plotGraphs = 0; gamma = 0.004; numExploits=1; numLoci=1; casetype = 'OR'; throwAway = 'nonEpidemics', cutoff = gamma.*numNodes./(betan.*Sprop); SEpidemic=60; %cutoff;

 %agent
 [figMeanNei figNeiOneRun fighistSpRun fighistRecovered fighistSusceptible fighistpeakValue fighistpeakTime fighistBeta fighistGamma fighistBetanew fighistGammanew figInfectedRun1 figBetaRun1 figGammaRun1 figRoRun1 figBetaGamma1 figBetaGamma2...
            meanNeiIndexDynamicF(z,1:numTimesteps) betastd gammastd betastd2 betastdNew betastdNew2 gammastdNew peakTimemean peakTimestd peakValuemean peakValuestd...
            betameanmean gammameanmean betameanmean2 betameanmeanNew betameanmeanNew2 gammameanmeanNew Smean Imean Rmean NSmean Bmean Smedian Imedian Rmedian S I R NS SmeanN ImeanN1 RmeanN1 BmeanN1 Snewendmean Snewendstd Rnewendmean Rnewendstd Rnew_nonendmean Rnew_nonendstd propSimsNonEp propSimsNonEp_theoretical...
            numRunsMinor measuredProbMinor numRunsMajor measuredProbMajor ...
            ] = monteCarloSIRN2(numRuns,numNodes, betan, variantRichness, numTimesteps, plotGraphs,gamma,throwAway,SEpidemic,numExploits,modePar, numLoci, casetype);
maxNei = max(meanNeiIndexDynamicF(z,:),[],2); %mean final size SI
    %time
     maska = meanNeiIndexDynamicF(z,:) >= maxNei-0.01; %when first reaches max with small tolerance
    [C Index] = max(maska);
    MLaFS(j,z) = Index %T1
end
end
 MLaRE
close all;
              %Time relationships
              figure
              plot(numEncountersBetweenUpdates,MLaRE(1,:),'k') %all update rates RE
              hold on
              plot(numEncountersBetweenUpdates,MLaFS(1,:),'k--') %all update rates FS
              for j = 1:size(VR,2)%do for all nodes
              plot(numEncountersBetweenUpdates,MLaRE(j,:),'k') %all update rates RE
              hold on
              plot(numEncountersBetweenUpdates,MLaFS(j,:),'k--') %all update rates FS
              end
             legend('Diversity: random','Diversity: favscore')
            xlabel('Number of encounters before an update')
            ylabel('Time to reach maximum')
             title('numUpdates vs Time')
             

              figure
              plot(VR,MLaRE(:,1),'k') %all update rates RE
              hold on
              plot(VR,MLaFS(:,1),'k--') %all update rates FS
              for z = 1:4%do for all nodes
              plot(VR,MLaRE(:,z),'k') %all update rates RE
              hold on
              plot(VR,MLaFS(:,z),'k--') %all update rates FS
              end
             legend('Diversity: random','Diversity: favscore')
            xlabel('Number of Devices')
            ylabel('Time to reach maximum')
             title('numDevices vs Time')
 

                       %diversity mean DISPLAYS LAST VR value (50)
            figMeanNei=figure
            for s= 1:4
            plot(meanNeiIndexDynamic(s,:),'k','Linewidth',2)
            hold on
            plot(meanNeiIndexDynamicF(s,:),'k--','Linewidth',2)
            end
            numAlleles = repmat(variantRichness,[1,numLoci]);
            [ Dmax DmaxLocus ] = getMaxNeiCalc( numNodes, numAlleles );
            DmaxLine = repmat(Dmax,[1 numTimesteps]);
            plot(DmaxLine,'k','Linewidth',2)
            xlabel('Time (second)')
            ylabel('Diversity')
            axis([0 numTimesteps 0 1])
            %legend('update: every 1 encounter','update: every 10 encounters','update: every 20 encounters','update: every 50 encounters')
            legend('Diversity: random','Diversity: favscore')
            title('constrained Dynamic, VR=5')


                       %diversity mean
            figMeanNei=figure
            for s= 1:1
            plot(meanNeiIndexDynamic(s,:),'k','Linewidth',2)
            hold on
            plot(meanNeiIndexDynamicF(s,:),'k--','Linewidth',2)
            end
            numAlleles = repmat(variantRichness,[1,numLoci]);
            [ Dmax DmaxLocus ] = getMaxNeiCalc( numNodes, numAlleles );
            DmaxLine = repmat(Dmax,[1 numTimesteps]);
            plot(DmaxLine,'k','Linewidth',2)
            xlabel('Time (second)')
            ylabel('Diversity')
            axis([0 numTimesteps 0 1])
            %legend('update: every 1 encounter','update: every 10 encounters','update: every 20 encounters','update: every 50 encounters')
            legend('Diversity: random','Diversity: favscore')
            title('constrained Dynamic, VR=5')


                                   %diversity mean
            figMeanNei=figure
            for s= 2:2
            plot(meanNeiIndexDynamic(s,:),'k','Linewidth',2)
            hold on
            plot(meanNeiIndexDynamicF(s,:),'k--','Linewidth',2)
            end
            numAlleles = repmat(variantRichness,[1,numLoci]);
            [ Dmax DmaxLocus ] = getMaxNeiCalc( numNodes, numAlleles );
            DmaxLine = repmat(Dmax,[1 numTimesteps]);
            plot(DmaxLine,'k','Linewidth',2)
            xlabel('Time (second)')
            ylabel('Diversity')
            axis([0 numTimesteps 0 1])
            %legend('update: every 1 encounter','update: every 10 encounters','update: every 20 encounters','update: every 50 encounters')
            legend('Diversity: random','Diversity: favscore')
            title('constrained Dynamic, VR=5')
            
                                   %diversity mean
            figMeanNei=figure
            for s= 3:3
            plot(meanNeiIndexDynamic(s,:),'k','Linewidth',2)
            hold on
            plot(meanNeiIndexDynamicF(s,:),'k--','Linewidth',2)
            end
            numAlleles = repmat(variantRichness,[1,numLoci]);
            [ Dmax DmaxLocus ] = getMaxNeiCalc( numNodes, numAlleles );
            DmaxLine = repmat(Dmax,[1 numTimesteps]);
            plot(DmaxLine,'k','Linewidth',2)
            xlabel('Time (second)')
            ylabel('Diversity')
            axis([0 numTimesteps 0 1])
            %legend('update: every 1 encounter','update: every 10 encounters','update: every 20 encounters','update: every 50 encounters')
            legend('Diversity: random','Diversity: favscore')
            title('constrained Dynamic, VR=5')
            
                                   %diversity mean
            figMeanNei=figure
            for s= 4:4
            plot(meanNeiIndexDynamic(s,:),'k','Linewidth',2)
            hold on
            plot(meanNeiIndexDynamicF(s,:),'k--','Linewidth',2)
            end
            numAlleles = repmat(variantRichness,[1,numLoci]);
            [ Dmax DmaxLocus ] = getMaxNeiCalc( numNodes, numAlleles );
            DmaxLine = repmat(Dmax,[1 numTimesteps]);
            plot(DmaxLine,'k','Linewidth',2)
            xlabel('Time (second)')
            ylabel('Diversity')
            axis([0 numTimesteps 0 1])
            %legend('update: every 1 encounter','update: every 10 encounters','update: every 20 encounters','update: every 50 encounters')
            legend('Diversity: random','Diversity: favscore')
            title('constrained Dynamic, VR=5')
end%26

%light version using monteCarloSIRN3
if doSIRNTests(27) == 1
%1 locus model
%outputDirectory = 'Graphs\' 
outputDirectory = 'Graphs\'
%Increase variants upto 10, fix exploit
%***************************************
%SIRN testing
%***************************************
tic
numNodes = 1000;
VRmin = 1 %1
VRmax = 10 %10
N=numNodes; Vmax = 1:VRmax;  G = Vmax.^2; %number genotypes
%for OR case - 1 loci
Sprop = SPExact1LociOR( 1, Vmax )
mode = 'Dynamic-random' %mode - can be 'static' or 'dynamic' 'Dynamic-random' 'Dynamic-favScore'
%monte carlo random genotype SIR model
numRuns = 1 %100 %200
%set up diversity mode parameters
modePar.modeStr = mode
modePar.numToConstrain = 0 %constain a number of nodes to 1 variant
modePar.stopUpdatingTime = 2000 %time at which to stop updating the genotypes
modePar.numEncountersBetweenUpdates = 1 % number of encounters between updates for random and favscore algorithms
modePar.bufferlength = 10 %length of genotype buffer for favscore algorithm
modePar.genoInit = 'maxdiv'  %initial conditions of genotypes maxdiv (maximum diversity - random variant chosen) mindiv (minimum diversity - all nodes same)

for z= VRmin:VRmax
 betan = 0.02; variantRichness =  z;  numTimesteps = 200; plotGraphs = 1; gamma = 0.004; numExploits=1; numLoci=1; casetype = 'OR'; throwAway = 'nonEpidemics', cutoff = gamma.*numNodes./(betan.*Sprop); SEpidemic=60; %cutoff;
%agent

           [numRunsMinor(z) measuredProbMinor(z) numRunsMajor(z) measuredProbMajor(z)...
           ] = monteCarloSIRN3(numRuns,numNodes, betan, variantRichness, numTimesteps, plotGraphs,gamma,throwAway,SEpidemic,numExploits,modePar, numLoci, casetype);
 
end    
end %SIRN Test27

if doSIRNTests(28) == 1
%1 locus model plot 1 result
%outputDirectory = 'Graphs\' 
outputDirectory = 'Graphs\'

numNodes = 1000;
VRmin = 1 %1
VRmax = 10 %10
N=numNodes; Vmax = 1:VRmax;  G = Vmax.^2; %number genotypes
%for OR case - 1 loci
Sprop = SPExact1LociOR( 1, Vmax )
dec = 50; t2 = 1:dec:numTimesteps;

%stochastic final size approximation
betan = 0.02; gamma = 0.004;
[ FinalSizeS stdS ] = finalSizeApprox( Sprop, betan, gamma, VRmin, VRmax, numNodes)

%read final size data from file and plot 


  %number of nodes infected
 figTest2FinalInfected = figure
 %agentImax = max(Imean,[],2);
 %plot(agentImax,'k')
 for j = VRmin:VRmax
 if isnan(FinalSizeS(j)); h(j) = 0; else h(j) = FinalSizeS(j); end;
 if isnan(FinalSize(j)); q(j) = 0; else q(j) = FinalSize(j); end;
 end
 FinalSize=q
 FinalSizeS=h
 plot(FinalSize,'ko-')
 hold on
 plot(FinalSizeS,'k+-')
plot([5 5],[0 1],'k--')
 ylabel('Final number infected')
 xlabel('Variant Richness')
 title('c) SI-Increasing variants: Final size')
 legend('Agent', 'Deterministic', 'Stochastic measured','Stochastic Approximation')
 
  %number of nodes infected
 figTest2Finalstd = figure
 %agentImax = max(Imean,[],2);
 %plot(agentImax,'k')
 for j = VRmin:VRmax
 if isnan(Rnewendstd(j)); a(j) = 0; else a(j) = Rnewendstd(j); end;
 if isnan(SRnewendstd(j)); b(j) = 0; else b(j) = SRnewendstd(j); end;
  if isnan(stdS(j)); c(j) = 0; else c(j) = stdS(j); end;
 end
 SRnewendstd=a
 Rnewendstd=b
 stdS = c
 plot(Rnewendstd,'ko-') %agent measured
 hold on
 %plot(S,'k.-')
 plot(SRnewendstd,'ks-') %stochastic measured
 plot(stdS,'k+-') % calc approx
plot([5 5],[0 1],'k--')
 ylabel('Standard deviation')
 xlabel('Variant Richness')
 title('c) SI-Increasing variants: Final size std')
 legend('Agent measured', 'Stochastic measured', 'Stochastic Approximation')
 
  %RESISTANCE
 figTest2Resistance = figure
 plot(1-FinalSize./N,'ko-')
 hold on
 %plot(S,'k.-')
 plot(1-FinalSized./N,'k.-')
 plot(1-SFinalSize./N,'ks-')
  plot(1-FinalSizeS./N,'k+-')
plot([5 5],[0 1],'k--')
 ylabel('Resistance M_R')
 xlabel('Variant Richness')
 title('c) SI-Increasing variants: Resistance')
 legend('Agent (measured)', ' Deterministic (measured) ', 'Stochastic (measured) ','Stochastic (approximated)')
 
 
 
saveas(figTest9inf0_02,[outputDirectory 'Test21meanall.fig']);
saveas(figTest9inf0_02,[outputDirectory 'Test21meanall.emf']); 
saveas(figmajor,[outputDirectory 'Test21meanmajor.fig']);
saveas(figmajor,[outputDirectory 'Test21meanmajor.emf']);
saveas(figTest2FinalInfected,[outputDirectory 'Test21FinalInfected.fig']);
saveas(figTest2FinalInfected,[outputDirectory 'Test21FinalInfected.emf']);
saveas(figTest2Finalstd,[outputDirectory 'Test21Finalstd.fig']);
saveas(figTest2Finalstd,[outputDirectory 'Test21Finalstd.emf']);
saveas(figTest2Resistance,[outputDirectory 'Test21Resistance.fig']);
saveas(figTest2Resistance,[outputDirectory 'Test21Resistance.emf']);
saveas(figTest2Resilience,[outputDirectory 'Test21Resilience.fig']);
saveas(figTest2Resilience,[outputDirectory 'Test21Resilience.emf']);
saveas(figTest2ResilienceTime,[outputDirectory 'Test21ResilienceTime.fig']);
saveas(figTest2ResilienceTime,[outputDirectory 'Test21ResilienceTime.emf']);
%close all


betameanmean
gammameanmean

betameanmean2
betameanmeanNew 
betameanmeanNew2
gammameanmeanNew

Rnewendmean%epidemics only
Rnewendstd

 propSimsNonEp % proportion of sims with non-epidemics
 propSimsNonEp_theoretical %theoretical value
    
R = betameanmean./gammameanmean
RN = betameanmeanNew./gammameanmeanNew
SRN = SbetameanmeanNew./SgammameanmeanNew
RTheoretical = beta./gamma


%close all
%close all;

%calculate proportion of minor and major outbreaks
[ minorCalc majorCalc ] = propCalcOutbreaks( Sprop, B, gamma )
%measure proportion of minor and major outbreaks
%agent
%numRunsMinor measuredProbMinor numRunsMajor measuredProbMajor
numRunsMinor
numRunsMajor
measuredProbMinor
measuredProbMajor
%stochastic
%SnumRunsMinor SmeasuredProbMinor SnumRunsMajor SmeasuredProbMajor
SnumRunsMinor
SnumRunsMajor
SmeasuredProbMinor
SmeasuredProbMajor

figMinorProb = figure;
plot(measuredProbMinor,'ko-') %agent
hold on
plot(SmeasuredProbMinor,'ks-') %stochastic
plot(minorCalc,'k+-') %stoch approx
xlabel('Variant Richness')
ylabel('Proportion of minor outbreaks')
%legend('R','RNew','Rtheoretical') 
plot([5 5],[0 0.9],'k--')
legend('Agent (measured)','Stochastic (measured)', 'Stochastic (approximated)')
title('probability of minor outbreak')

figMajorProb = figure;
plot(measuredProbMajor,'ko-') %agent
hold on
plot(SmeasuredProbMajor,'ks-') %stochastic
plot(majorCalc,'k+-') %stoch approx
xlabel('Variant Richness')
ylabel('Proportion of major outbreaks')
%legend('R','RNew','Rtheoretical') 
legend('Agent (measured)','Stochastic (measured)', 'Stochastic (approximated)')
plot([5 5],[0 0.9],'k--')
title('probability of major outbreak')

saveas(figMinorProb,[outputDirectory 'Test21_1EXPfigMinorProb.fig']);
saveas(figMinorProb,[outputDirectory 'Test21_1EXPfigMinorProb.emf']);
saveas(figMajorProb,[outputDirectory 'Test21_1EXPfigMajorProb.fig']);
saveas(figMajorProb,[outputDirectory 'Test21_1EXPfigMajorProb.emf']);


toc
   %SAVE FOR LATER
   N %number of nodes
   FinalSize %measured agent
   FinalSized %deterministic
   FinalSizeS %stoch approx
   SFinalSize %stoch measured
Resistancea_1EXP=1-FinalSize./N
Resistanced_1EXP=1-FinalSized./N
Resistancesapp_1EXP=1-FinalSizeS./N
Resistances_1EXP=1-SFinalSize./N
Resiliencea_1EXP=1./MLa
Resilienced_1EXP=1./MLd
Resiliences_1EXP=1./SMLa
Rnewendstd_1EXP=Rnewendstd
SRnewendstd_1EXP=SRnewendstd
stdS_1EXP=stdS

end %SIRN Test28
