%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Jennifer Jackson 2017                                                        %
% A Biodiversity Approach to Cyber Security                                    %
% PhD Complexity Science                                                       %
% University of Warwick                                                        %
% http://wrap.warwick.ac.uk/98458                                              %
% This software is distributed under the  Creative Commons Attribution License %
% https://creativecommons.org/licenses/by/4.0/                                 %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
classdef outputHandles < handle
    %Handles for outputs so can modify call by reference
    properties
        %************************************
        %enable properties from main window
        %***********************************
        datasetEnable ='';
        datasetNumber ='';
        datasetStaticEnable = ''; %added 31st March 2016
        datasetStaticNumber = ''; %added 31st March 2016
        networkModelEnable =''; 
        networkModelS ='';
        networkModelV ='';
        attackModelEnable ='';
        attackModelS ='';
        attackModelV ='';
        exploitEnable='';
        exploitTypeS='';
        exploitTypeV='';
        algModelEnable ='';
        algModelS ='';
        algModelV ='';
        networkPerfEnable ='';
        perfModelS ='';
        perfModelV ='';
        %input data saved as outputs
        numNodes = '';
        numSims = '';
        numRunsPerSim = '';
        numTimeSteps = '';
        len_apps = '';
        len_serv = '';
        len_os = '';
        len_dr = '';
        CD_apps = '';
        CD_serv = '';
        CD_os = '';
        CD_dr = '';
        ChangeDesirabilitiesFlag = '';
        tChange1 = '';
        tChange2 = '';
        CD_apps2 = '';
        CD_serv2 = '';
        CD_os2 = '';
        CD_dr2 = '';
        ChangeIndDesirabilitiesFlag = '';
        tChangeInd1 = '';
        tChangeInd2 = '';
        ID2 = '';
        ID_apps2 = '';
        ID_serv2 = '';
        ID_os2 = '';
        ID_dr2 = '';
        E_apps = '';
        E_serv = '';
        E_os = '';
        E_dr = '';
        ChangeEffFlag = '';
        tChangeEff1 = '';
        tChangeEff2 = '';
        E_apps2 = '';
        E_serv2 = '';
        E_os2 = '';
        E_dr2 = '';
        Genotype = '';
        Genotype_apps = '';
        Genotype_serv = '';
        Genotype_os = '';
        Genotype_dr = '';
        textdata = '';
        ID = '';
        ID_apps = '';
        ID_serv = '';
        ID_os = '';
        ID_dr = '';
        minstd4Tolerance = '';
        maxstd4Tolerance = '';
        minstd5Tolerance = '';
        maxstd5Tolerance = '';
        turnOnSol1 = '';
        turnOnSol2 = '';
        turnOnSol3 = '';
        turnOnSol4 = '';
        turnOnSol5 = '';           
        singleStopMode = '';
        restartMode = '';
        ChangeOwnIndDesirabilitiesFlag = '';
        %randowm waypoints
        vs_node = struct('v_x','v_y');
        %true outputs that change every run
        Nei_sol1 = '';
        Nei_sol2 = '';
        Nei_sol3 = '';
        Nei_sol4 = '';
        Nei_sol5 = '';
        nodesDiversity4 = '';
        nodesMean4 = '';
        nodesStd4 = '';
        updateStopDisplay4 = '';
        minStd4Curve = '';
        nodesDiversity5 = '';
        nodesMean5 = '';       
        updateStopDisplay5 = '';
        nodesStd5 = '';
        minStd5Curve = '';
        lastStoppedStdMatrix = '';
        lastStoppedStdMatrix2 = '';
        stdMargin = '';
        Nei_indDynamic = '';
        %added outputs from static diversity 30th March 2016
        neiIndexSingleLocus_sol1 = '';
        neiIndexSingleLocus_sol2 = '';
        neiIndexSingleLocus_sol3 = '';
        neiIndexSingleLocus_sol4 = '';
        neiIndexSingleLocus_sol5 = '';
        %genotype outputs from all simulation added 31st March 2016
        %initialised in MeasureDiversityClass
        %GenoSim_sol1 = '';
        %GenoSim_sol2 = '';
        %GenoSim_sol3 = '';
        GenoSim_sol4 = '';
        GenoSim_sol5 = '';
        %outputs from attack model
        sumOfStates = '';
        numStates = '';
        %nodeStateAtTime = ''; %state of the node at time t
        allRunsNodeStateAtTime = struct('nodeStateAtTimeStr','nodeStateAtTimeNumber'); %need to define struct as combining string arrays and number arrays
        beta = ''; %measured infection rate of every run
        gammaSIR = ''; %measured SIR recovery rate of every run
    end
    
    methods
        function oH = outputHandles()
            %initialise / constructor function

        end     
     
    end
    
end

