%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Jennifer Jackson 2017                                                        %
% A Biodiversity Approach to Cyber Security                                    %
% PhD Complexity Science                                                       %
% University of Warwick                                                        %
% http://wrap.warwick.ac.uk/98458                                              %
% This software is distributed under the  Creative Commons Attribution License %
% https://creativecommons.org/licenses/by/4.0/                                 %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
classdef runHandles < handle
    %%Handles for a single run input so can modify call by reference
    
    properties
        %***************************
        % Node encounter variables
        %****************************
        randomEncounter = '';
        encounterYes = '';
        sumEncounterYesM = ''; %zeros(200,10); %full time matrix need to set this properly
        sumEncounterYes = ''; %running sum of encounters
        %*****************************
        %Random waypoint variables
        %******************************
        RWPencounterYes = '';
        RWPSumEncounterYesM = ''; %zeros(200,10); %full time matrix need to set this properly
        RWPSumEncounterYes = ''; %running sum of encounters
        RWPnodesEncountered ='';
        %RWPNodeTagged = struct('endTime',0,'tag',0,'nodeNumberTagged',0);
        RWPendTime = 1;
        RWPtag = 2;
        RWPnodeNumberTagged = 3;
        RWPvirusTransmitted = 4;
        RWPNodeTagged = '';
        %'Independent geno-exploit' option
        endTimeTxGenotype = '';
        endTimeTxExploit = '';
        endTimeTimeOutTxGenotype = '';
        tagState = '';
        nodesTagged = '';
        txGenotypeEncounterYes = '';
        txExploitEncounterYes = '';
        %****************************
        %Fav Score alg
        %***************************
        updateGenotypeYes = '';
        S = '';
        %for calcS changing during simulation
        S_CD = '';
        S_ID = '';
        S_ID_apps = '';
        S_ID_os = '';
        S_ID_serv = '';
        S_ID_dr =  '';
        S_E = '';
        Nei_indDynamic = '';
        counterEncounters = ''; 
        updateYes = '';
        %******************
        %fOLLOWING NOT USED
        updateStop1 = '';
        updateStop2 = '';
        updateStop3 = '';
        GenotypeSol1 = '';
        GenotypeSol1_apps = '';
        GenotypeSol1_serv = '';
        GenotypeSol1_os = '';
        GenotypeSol1_dr = '';
        GenotypeSol2 = '';
        GenotypeSol2_apps = '';
        GenotypeSol2_serv = '';
        GenotypeSol2_os = '';
        GenotypeSol2_dr = '';
        GenotypeSol3 = '';
        GenotypeSol3_apps = '';
        GenotypeSol3_serv = '';
        GenotypeSol3_os  = '';
        GenotypeSol3_dr = '';
        %**********************
        updateStop4 = '';
        reachTolFlag4 = '';
        minStd4 = '';
        maxStd4 = '';
        minStd4Curve = '' ;
        nodesDiversity4 = '';
        nodesDiversity4_buffer = ''; %for buffering diversity values to measure std and mean added 24th April 2016
        updateStopDisplay4 = '';
        nodesMean4 = '';
        nodesMean4Filt ='';
        nodesStd4 = '';
        nodesStd4Filt = '';
        displayStopVal = '';
        displayStartVal = '';
        updateStopDisplayFlagOld4 = '';
        lastStoppedStd = '';
        lastStoppedStdMatrix = '';
        lastStoppedStdMatrix2 = '';
        GenotypeSol4 = '';
        GenotypeSol4_apps = '';
        GenotypeSol4_serv = '';
        GenotypeSol4_os = '';
        GenotypeSol4_dr ='';
        updateStop5 ='';
        reachTolFlag5='';
        minStd5='';
        maxStd5='';
        minStd5Curve='';
        nodesDiversity5='';
        nodesDiversity5_buffer = ''; %for buffering diversity values to measure std and mean added 24th April 2016
        updateStopDisplay5='';
        nodesMean5 ='';
        nodesStd5='';
        displayStopVal5='';
        displayStartVal5='';
        updateStopDisplayFlagOld5='';
        lastStoppedStd5 ='';
        GenotypeSol5 ='';
        GenotypeSol5_apps='';
        GenotypeSol5_serv='';
        GenotypeSol5_os='';
        GenotypeSol5_dr='';
        tallyUpdates ='';
        tallySol1 ='';
        tallySol2 ='';
        tallySol3 ='';
        tallySol4 ='';
        tallySol5='';
        divWeightsValueOld='';
        comWeightsValueOld='';
        indWeightsValueOld='';
        qualWeightsValueOld='';
        calcSE_Divw='';
        calcSE_Comw='';
        calcSE_Indw='';
        calcSE_Qualw='';
        comDesValueOld='';
        indDesValueOld='';
        qualDesValueOld='';
        calcSE_Comd ='';
        calcSE_Indd = '';
        calcSE_Quald = '';
        numEncounters= '';
        %**************
        %NO LONGER USED
        Genotype_1New ='';
        Genotype_apps1New ='';
        Genotype_serv1New ='';
        Genotype_os1New ='';
        Genotype_dr1New ='';
        Genotype_2New ='';
        Genotype_apps2New ='';
        Genotype_serv2New ='';
        Genotype_os2New ='';
        Genotype_dr2New ='';
        Genotype_3New ='';
        Genotype_apps3New ='';
        Genotype_serv3New ='';
        Genotype_os3New ='';
        Genotype_dr3New ='';
        %******************
        Genotype_4New ='';
        Genotype_apps4New ='';
        Genotype_serv4New ='';
        Genotype_os4New ='';
        Genotype_dr4New ='';
        Genotype_5New ='';
        Genotype_apps5New ='';
        Genotype_serv5New ='';
        Genotype_os5New ='';
        Genotype_dr5New ='';
        %**************************
        %State Machine variables
        %*************************
        StateMachine = '';
        numStates = '';
        sumOfStates = '';
        nodeStateAtTimeStr = '';
        nodeStateAtTimeNumber = '';
        S_buffer = ''; %saving two values of S for beta calc
        I_buffer = ''; %saving two values of I for beta calc
        beta = ''; %measured infection rate
        gammaSIR = ''; %measured SIR recovery rate
        %outs
        nextStateNumber = '';
        saveInfectionExploitDataEnable = '';
        updateOwnExploitDataEnable = '';
        resetOwnExploitDataEnable = '';
        deviceOffline = '';
        NewNextState_Eentry = '';
        NewNextState_Eprob = '';
        NewNext_LatencyCounter = '';
        %ins
        deltaT = '';
        latCountOption = '';
        currentE_entryState = '';
        currentE_entryProb = '';
        current_LatencyCounter = '';
        %***************************
        %Exploit variables
        %***************************
        exploitData = '';
        savedExploitData = '';
    end
    
    methods
       function rH = runHandles()
       %initialise / constructor function

        end
    end
    
end

