%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Jennifer Jackson 2017                                                        %
% A Biodiversity Approach to Cyber Security                                    %
% PhD Complexity Science                                                       %
% University of Warwick                                                        %
% http://wrap.warwick.ac.uk/98458                                              %
% This software is distributed under the  Creative Commons Attribution License %
% https://creativecommons.org/licenses/by/4.0/                                 %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function [figMeanNei figNeiOneRun fighistSpRun fighistRecovered fighistSusceptible fighistpeakValue fighistpeakTime fighistBeta fighistGamma fighistBetanew fighistGammanew figInfectedRun1 figBetaRun1 figGammaRun1 figRoRun1 figBetaGamma1 figAllRuns ...
            meanNeiIndexDynamic betastd gammastd betastd2 betastdNew betastdNew2 gammastdNew peakTimemean peakTimestd peakValuemean peakValuestd...
            betameanmean gammameanmean betameanmean2 betameanmeanNew betameanmeanNew2 gammameanmeanNew Smean Imean Rmean Bmean NSmean Smedian Imedian Rmedian S I R NS SmeanN ImeanN RmeanN BmeanN Snewendmean Snewendstd Rnewendmean Rnewendstd Rnew_nonendmean Rnew_nonendstd propSimsNonEp propSimsNonEp_theoretical...
           numRunsMinor measuredProbMinor numRunsMajor measuredProbMajor meanmdist meannumInfectedVM...
            ] = monteCarloSIRN2(numRuns,numNodes, beta, variantRichness, numTimesteps, plotGraphs,gamma,throwAway,SEpidemic,numExploits,modePar, numLoci, casetype)
        mode=modePar.modeStr;
        %[betameanmean betameanmean2 Smean Imean Rmean NSmean] = monteCarloSIRN(numRuns, numNodes, betas, variantRichness, numTimesteps, plotGraphs, gamma,numExploits,mode, numLoci,casetype)
        %plotGraphsSIRN=0
        %for i = 1:numRuns          
        %     [numSusceptibles numInfected numRecovered numNotSusceptibles] = randomGenotypesSIRN(numNodes, betan, variantRichness, numTimesteps, plotGraphsSIRN, gamma, numExploits, mode, numLoci,casetype);

        %choice to add extra 'NotSusceptible state'
        extraState = 0; %0 - dont include, 1- include
        sumNeiIndexDynamic = zeros(1,numTimesteps);
        
        deltat=1 ; plotGraphsSIRN=0;
             
        %plotGraphsSIRN = 1
            %figure
            as=1; ai=1; ar=1; sm=0; rm=0;
            for i = 1:numRuns 
                runNumber = i
                    %[numSusceptibles numInfected numRecovered] = agentSIR(numNodes, beta, numTimesteps, 0, gamma);
                     [sp numSusceptibles numInfected numRecovered numNotSusceptibles numBlacklisting neiIndexDynamic mdist(i) numInfectedVM(i)] = randomGenotypesSIRN(numNodes, beta, variantRichness, numTimesteps, plotGraphsSIRN, gamma, numExploits, modePar, numLoci,casetype);
                spRun(i) = sp; %initial susceptibility of each run
                for j = 1 : (numTimesteps/deltat) -1
                    if and(strcmp(mode,'static'),extraState == 1)
                    Ns = numSusceptibles(j+1)+numInfected(j+1)+numRecovered(j+1); %only count those actually in susceptible part of network at time t
                    %measure beta
                    B(j)=(-(numSusceptibles(j+1) - numSusceptibles(j))/(numInfected(j)*numSusceptibles(j)/Ns))./deltat; %measured beta
                    %B2(j) = (Ns.*(numInfected(j+1)+(gamma-1).*numInfected(j)))/(numInfected(j)*numSusceptibles(j)); %measured beta
                    %measure gamma
                    Y(j) = ((numRecovered(j+1)-numRecovered(j))/numInfected(j))./deltat;
                    B2(j) = ((Ns.*(numInfected(j+1)+(Y(j)-1).*numInfected(j)))/(numInfected(j)*numSusceptibles(j)))./deltat; %measured beta
                    %measure Ro
                    Ro(j) = (B(j)*numSusceptibles(j))/(Ns*Y(j));
                    else
                        %dynamic - assume 1 S state to calculate beta as
                        %all are susceptible
                         Ns = numSusceptibles(j+1)+numInfected(j+1)+numRecovered(j+1)+numNotSusceptibles(j+1); %only count those actually in susceptible part of network at time t
                         %measure beta 
                         B(j)=(-(numSusceptibles(j+1)+numNotSusceptibles(j+1) - numSusceptibles(j)-numNotSusceptibles(j))/(numInfected(j)*numSusceptibles(j)/Ns))./deltat; %measured beta
                         %B2(j) = (Ns.*(numInfected(j+1)+(gamma-1).*numInfected(j)))/(numInfected(j)*numSusceptibles(j)); %measured beta
                         %measure gamma
                         Y(j) = ((numRecovered(j+1)-numRecovered(j))/numInfected(j))./deltat;
                         B2(j) = ((Ns.*(numInfected(j+1)+(Y(j)-1).*numInfected(j)))/(numInfected(j)*(numSusceptibles(j)+numNotSusceptibles(j))))./deltat; %measured beta
                         %measure Ro
                         Ro(j) = (B(j)*(numSusceptibles(j)+numNotSusceptibles(j)))/(Ns*Y(j));
                    end
                end
                Bsave(i,:) = B;
                Ysave(i,:) = Y;
                %sort beta to get rid of nan values
                sortedbeta = sort(B);
                nanMask = isnan(sortedbeta);
                infMask = isinf(sortedbeta);
                [startv starti] = min(infMask);
                [c indexNan] = max(nanMask);
                if indexNan == 1; indexNan = (numTimesteps/deltat)-1; end;
                %BD = B %test only
                %sortedbetaDisplayPre = sortedbeta %test only
                %sortedbetaDisplay = sortedbeta(starti:indexNan-1)%test only
                %sortedbeta(indexNan)=0;
                %betamean(i) = mean(sortedbeta(starti:indexNan));
                betamean(i) = mean(sortedbeta(starti:indexNan-1));
                %sort beta2 to get rid of nan values
                sortedbeta2 = sort(B2);
                nanMask2= isnan(sortedbeta2);
                infMask2 = isinf(sortedbeta2);
                [startv2 starti2] = min(infMask2);
                [c2 indexNan2] = max(nanMask2);
                if indexNan2 == 1; indexNan2 = (numTimesteps/deltat)-1; end;
                betamean2(i) = mean(sortedbeta2(starti2:indexNan2-1));
                
                 %sort gamma to get rid of nan and inf values
                sortedgamma = sort(Y);
                nanMaskg= isnan(sortedgamma);
                infMaskg = isinf(sortedgamma);
                [startvg startig] = min(infMaskg);
                [cg indexNang] = max(nanMaskg);
                if indexNang == 1; indexNang = (numTimesteps/deltat)-1; end;
                gammamean(i) = mean(sortedgamma(startig:indexNang-1));

               % plot(numSusceptibles,'b')
               % hold on
               % plot(numInfected,'r')
               % hold on
               % plot(numRecovered,'g')
               % hold on
                
                S(i,:) = numSusceptibles;
                I(i,:) = numInfected;
                R(i,:) = numRecovered;
                Blk(i,:) = numBlacklisting;
                  NS(i,:) = numNotSusceptibles;
                                   if strcmp(throwAway,'nonEpidemics') %updated 20th July 2016 to include +numNotSusceptibles               
                 %if min(numSusceptibles+numNotSusceptibles)>= SEpidemic; sm(as) = i; as = as+ 1; end %case of non epidemics to throw away
                    %if  numRecovered(end) < SEpidemic; sm(as) = i; as = as+ 1; end %case of non epidemics to throw away
                     if  numRecovered(end) > SEpidemic; sm(as) = i; as = as+ 1; end %major epidemics to keep
                                   end
                 
                 if strcmp(throwAway,'Epidemics')
                 %if min(numSusceptibles+numNotSusceptibles) < SEpidemic; sm(as) = i; as = as+ 1; end %case of epidemics to throw away
                    if numRecovered(end)< SEpidemic; sm(as) = i; as = as+ 1; end %case of epidemics to throw away
                  
                 end
                 %if max(numInfected)<= 1; im(ai) = i; ai = ai+ 1;end
                 %if max(numRecovered)<= 1; rm(ar) = i; ar = ar+ 1;end
                  %if min(numSusceptibles+numNotSusceptibles) < SEpidemic; rm(ar) = i; ar = ar+ 1; end %case of epidemics to throw away
                 if numRecovered(end)> SEpidemic; rm(ar) = i; ar = ar+ 1; end %case of epidemics to throw away

                 
                % if strcmp(throwAway,'nonEpidemics') %updated 20th July 2016 to include +numNotSusceptibles
                % if min(numSusceptibles+numNotSusceptibles)>= SEpidemic; sm(as) = i; as = as+ 1; end %case of non epidemics to throw away
                % end
                 %if strcmp(throwAway,'Epidemics')
                 %if min(numSusceptibles+numNotSusceptibles) < SEpidemic; sm(as) = i; as = as+ 1; end %case of epidemics to throw away
                 %end
                 %if max(numInfected)<= 1; im(ai) = i; ai = ai+ 1;end
                 %if max(numRecovered)<= 1; rm(ar) = i; ar = ar+ 1;end
                 
                 %if min(numSusceptibles+numNotSusceptibles) < SEpidemic; rm(ar) = i; ar = ar+ 1; end %case of epidemics to throw away

                 figBetaRun1=0;
                 figInfectedRun1=0;
                 figGammaRun1=0;
                 figBetaGamma1=0;
                 figBetaGamma2=0;
                 figRoRun1=0;
                 
                 
            %title('S I R new - without non epidemics')
                %if plotGraphsSIRN ==1
              %  if i == 1
              %      figBetaRun1 = figure
              %      plot(B,'k')
              %      BoneRun = B;
              %      title('beta 1 run')
              %      xlabel('Timesteps')
              %      ylabel('Measured beta')
              %      figInfectedRun1 = figure
              %      plot(numInfected,'k')
              %      title('infected 1 run')
              %      xlabel('Timesteps')
              %      ylabel('I(t)')
              %      %figure
              %      %plot(B2,'k')
              %      %title('beta2 1 run')
              %      figGammaRun1 = figure
              %      plot(Y,'k')
              %      YoneRun = Y;
              %      xlabel('Timesteps')
              %      ylabel('Measured gamma')
              %      title('gamma 1 run')
              %      figRoRun1 = figure
              %      plot(Ro,'k', 'Linewidth', 2)
              %      hold on
              %      r1 = 1;
              %      r1rep = repmat(r1,size(Ro,2));
              %      plot(numInfected./5,'k')
              %      plot(r1rep,'k--')
              %      xlabel('Timesteps')
              %      ylabel('Measured Re')
              %      title('Re 1 run')
              %      legend('Re','infected/5','Re=1')
              %      figBetaGamma1 = figure
              %      plot(B./Y,'k')
              %      title('beta/gamma')
              %      figBetaGamma2 = figure
              %      plot(B>Y,'k')
              %      title('beta>gamma')
              %  end
              
              sumNeiIndexDynamic = neiIndexDynamic + sumNeiIndexDynamic;
              
            end
            
            %mean max distance virus spread in rwp mode
            meanmdist = mean(mdist)
            
            meanNeiIndexDynamic = sumNeiIndexDynamic./numRuns; %mean dynamic diversity
            
            %diversity one run
            numAlleles = repmat(variantRichness,[1,numLoci]);
            [ Dmax DmaxLocus ] = getMaxNeiCalc( numNodes, numAlleles );
            DmaxLine = repmat(Dmax,[1 numTimesteps]);
            figNeiOneRun = figure
            plot(neiIndexDynamic,'k')
            hold on
            plot(DmaxLine,'k','Linewidth',2)
            xlabel('Time')
            ylabel('Diversity')
            axis([0 numTimesteps 0 1])
            title('Dynamic diversity 1 run')
            
            %diversity mean
            figMeanNei=figure
            plot(meanNeiIndexDynamic,'k')
            hold on
            plot(DmaxLine,'k','Linewidth',2)
            xlabel('Time')
            ylabel('Diversity')
            axis([0 numTimesteps 0 1])
            title('Dynamic diversity mean all runs')
            
            
            %betamean = mean(beta(:,2:23),2) %needs doing better
            Smean = mean(S,1);
            Imean = mean(I,1);
            Rmean = mean(R,1);
            Bmean = mean(Blk,1);
            NSmean = mean(NS,1);
            Smedian = median(S,1);
            Imedian = median(I,1);
            Rmedian = median(R,1);
            
            
            %get rid of non epidemic runs in data
            sm
            len = size(sm,2)
            lenS = size(S,1)
            if and(len>=1,sm>0) 
              for i = 1:len %only keep the major outbreaks, throw the rest away
                 Snew(i,:) = S(sm(i),:);
                 Inew(i,:) = I(sm(i),:);
                 Rnew(i,:) = R(sm(i),:);
                 Bnew(i,:) = Blk(sm(i),:);
                 betameannew(i) = betamean(sm(i));
                 gammameannew(i) = gammamean(sm(i));
                 betameannew2(i) = betamean2(sm(i));
                 BOnly(i,:) = Bsave((i),:);
                 Yonly(i,:) = Ysave((i),:);
              end
             numRunsMajor = size(Snew,1);    
                
                
            else
                Snew = 0.0;
                Inew = 0.0;
                Rnew = 0.0;
                Bnew = 0.0;
                numRunsMajor = 0
                %betameannew=betamean;
                %gammameannew=gammamean;
                %betameannew2=betamean2;
                betameannew=betamean.*0.0;
                gammameannew=gammamean.*0.0;
                betameannew2=betamean2.*0.0;
                disp('assigned betameannew to zero')
            end 
            
           
            
            
            %Measure Final value size info - non epidemics
            lenr = size(rm,2);
            lenS = size(S,1);
            if and(lenr>=1,rm>0)           
            Rnew_non((1:rm(1)-1),:) = R(1:rm(1)-1,:);
            for j = 2:lenr
            Rnew_non(rm(j-1)-(j-2):rm(j)-j,:) = R(rm(j-1)+1:rm(j)-1,:);
            end
            Rnew_non(rm(j)-(j-1):lenS-j,:) = R(rm(j)+1:lenS,:);
            else
                Rnew_non = R;
            end          
            Rnew_nonMean = mean(Rnew_non,1);
            
            if plotGraphs==1
            figure
            for i =1:size(Snew,1)
                plot(Snew(i,:),'b')
                hold on
                plot(Inew(i,:),'r')
                plot(Rnew(i,:),'g')
                plot(Bnew(i,:),'c')%blacklisting
            end
            title('S I R new - without non epidemics')
            
          %  figure
          %  if len>0
          %  for j =1:len
          %      sm(j);
          %      plot(S(sm(j),:),'b')
          %      hold on
          %      plot(I(sm(j),:),'r')
          %      plot(R(sm(j),:),'g')
          %  end
          %  end
          %  title('sm only')
          end %plot graphs  
            figAllRuns = figure
            for j =1:numRuns
                plot(S(j,:),'b')
                hold on
                plot(I(j,:),'r')
                plot(R(j,:),'g')
                plot(Blk(j,:),'c')%blacklisting
            end
            title('All runs')
            
            SmeanN = mean(Snew,1);
            ImeanN = mean(Inew,1);
            RmeanN = mean(Rnew,1);
             BmeanN = mean(Bnew,1);

            %sizeImean = size(Imean)
           % if plotGraphs==1
            figure
            plot(Smean,'b')
            hold on
            plot(Imean,'r')
            plot(Rmean,'g')
            plot(Bmean,'c') %blacklisting
            title('SIR -mean of all')
           % end
            
           %  if plotGraphs==1
            figure
            plot(SmeanN,'b')
            hold on
            plot(ImeanN,'r')
            plot(RmeanN,'g')
            title('SIR -mean of epidemics')
          %  end
            
            %sortedbetamean = sort(betamean)
            %nanMask = isnan(sortedbetamean)
            %[c indexNan] = max(nanMask)
            %betameanmean = mean(sortedbetamean(1:indexNan-1))
            betameanmean = mean(betamean)
            betastd = std(betamean); %std of beta, not std of beta exponential!
            gammameanmean = mean(gammamean);
            gammastd = std(gammamean);
             betameanmean2 = mean(betamean2);  
             betastd2 = std(betamean2); 
             sizebetameannew=size(betameannew)
             betameanmeanNew = mean(betameannew);%without non epidemics
             betastdNew = std(betameannew);
             betameanmeanNew2 = mean(betameannew2);%without non epidemics
             betastdNew2 = std(betameannew2);
             gammameanmeanNew = mean(gammameannew);%without non epidemics
             gammastdNew = std(gammameannew);
             %Snewend = Snew(:,numTimesteps);
             if size(Snew) < 1; Snewend = nan; else Snewend = Snew(:,end); end;
             Snewendmean = mean(Snewend); %mean of final value of S with epidemics
             Snewendstd = std(Snewend);
             %Rnewend = Rnew(:,numTimesteps);
             if size(Rnew) < 1; Rnewend = nan; else Rnewend = Rnew(:,end); end;
             Rnewendmean = mean(Rnewend);%mean of final value of R with epidemics
             Rnewendstd = std(Rnewend);
             if size(Rnew_non,2) > 0; Rnew_nonend = Rnew_non(:,numTimesteps); else Rnew_nonend = 0; end
             Rnew_nonendmean = mean(Rnew_nonend);%mean of final value of R with no epidemics
             Rnew_nonendstd = std(Rnew_nonend);
             %proportion of simulations resulting in minor outbreak(non-epidemics)
             numberNonEp= size(Rnew_nonend,1)
             propSimsNonEp = numberNonEp/numRuns
             %theoretical gamma/beta = 1/R0
             propSimsNonEp_theoretical = gamma/beta;
             %theoretical value of mean of final value of R with epidemics
             %numNodes *z, where z is +ve solution of 1-z = e(-Roz)
             

             
             
    %**********************
    %DISTRIBUTION GRAPHS
    %**********************
    
       %peak value and time of peak infection
    [peakValue peakTime] = max(I,[],2);
    
    histscale = [0 numNodes 0 numRuns]
    histscale2 = [0 1 0 numRuns]
    histSize = 100;
    
    %VM update
    keepvmInfec = numInfectedVM >= SEpidemic; %keep all values above threshold
    numTokeep = sum(keepvmInfec);%number of runs 
    valTokeep=numInfectedVM.*keepvmInfec; %values to keep 
    if numTokeep > 0 %can't divide by zero
    meannumInfectedVM = sum(valTokeep)./numTokeep; %mean value
    else
        meannumInfectedVM=0; %if no major outbreaks then the number infected must be zero
    end
    %remove zero values
     b=sort(valTokeep,'descend');
     [val ind] = min(b);
    majorvm=b(1:ind-1);%remove zero values
    
    %keepvmInfecrep=repmat(keepvmInfec',[1,numTimesteps]);
    %Ikeep = I.*keepvmInfecrep; %I values to keep
    %if numTokeep > 0 %can't divide by zero
    %    meanIVM = sum(Ikeep,1)./numTokeep; %mean value for measuring VM resilience
    %else
    %    meanIVM = zeros(1,numTimesteps);
    %end

       %distribution of vm infection         
    fighistVM=figure;
    hist(numInfectedVM,histSize)
    xlabel('Number infected for one run')
    ylabel('Number of runs')
    title('Histogram of vm infection')
    h = findobj(gca,'Type','patch');
    set(h,'FaceColor','k')
     axis(histscale)
    
    fighistVM2=figure;
    hist(majorvm,histSize)
    xlabel('Number infected for one run')
    ylabel('Number of runs')
    title('Histogram of vm infection - major only')
    h = findobj(gca,'Type','patch');
    set(h,'FaceColor','k')
     axis(histscale)
    
   %distribution of beta         
    fighistBeta=figure;
    hist(betamean,histSize)
    xlabel('Average value of beta for one run')
    ylabel('Number of runs')
    title('Histogram of Beta')
    h = findobj(gca,'Type','patch');
    set(h,'FaceColor','k')
     axis(histscale2)
   %distribution of gamma
    fighistGamma=figure;
    hist(gammamean,histSize)
    xlabel('Average value of gamma for one run')
    ylabel('Number of runs')
    title('Histogram of Gamma')
    h = findobj(gca,'Type','patch');
    set(h,'FaceColor','k')
     axis(histscale2)
   %distribution of beta with runs removed
    fighistBetanew=figure;
    hist(betameannew,histSize)
    xlabel('Average value of beta for one run')
    ylabel('Number of runs')
    title('Histogram of Beta')
    h = findobj(gca,'Type','patch');
    set(h,'FaceColor','k')
     axis(histscale2)
   %distribution of gamma with runs removed
    fighistGammanew=figure;
    hist(gammameannew,histSize)
    xlabel('Average value of gamma for one run')
    ylabel('Number of runs')
    title('Histogram of Gamma')
    h = findobj(gca,'Type','patch');
    set(h,'FaceColor','k')
    axis(histscale2)
   %distribution of R at end of simulation
    rend = R(:,numTimesteps);
    fighistRecovered = figure
    hist(rend,histSize)
    xlabel('Final size (Recovered)')
    ylabel('Number of runs')
    title('Histogram of Final recovered size')
    h = findobj(gca,'Type','patch');
    set(h,'FaceColor','k')
    axis(histscale)
   %get distribution of S at end of simulation
   %include S and NS
   nodesLeft = S+NS;
    %send = S(:,numTimesteps);
     send = nodesLeft(:,numTimesteps);
    fighistSusceptible = figure;
    hist(send,histSize)
    xlabel('Final value of S')
    ylabel('Number of runs')
    title('Histogram of S(t=end)')
    h = findobj(gca,'Type','patch');
    set(h,'FaceColor','k')
    axis(histscale)
   %distribution of peak value infection 
    fighistpeakValue = figure
    hist(peakValue,histSize)
    xlabel('peak value of infectives')
    ylabel('Number of runs')
    title('Histogram of peak value of infectives')
    h = findobj(gca,'Type','patch');
    set(h,'FaceColor','k')
  %distribution of peak time infection
    fighistpeakTime = figure
    hist(peakTime,histSize)
    xlabel('peak time of infectives')
    ylabel('Number of runs')
    title('Histogram of peak time of infectives')
    h = findobj(gca,'Type','patch');
    set(h,'FaceColor','k')
  %distribution of sp at initiation
    fighistSpRun = figure
    hist(spRun,histSize)
    xlabel('sp at outset')
    ylabel('Number of runs')
    title('Histogram of generated sp')
    h = findobj(gca,'Type','patch');
    set(h,'FaceColor','k')
     axis(histscale)
    peakTimemean = mean(peakTime);
    peakTimestd = std(peakTime);
    peakValuemean = mean(peakValue);
    peakValuestd = std(peakValue);
    
    
     mask = gammamean<1; %elliminate all those with a gamma value of 1
     sumMask = sum(mask,2);%number to average over
     sumMaskRep = repmat(sumMask,1,size(gammamean,2));
      avGamma = sum(gammamean.*mask./sumMaskRep)
             
%             BOnlyD=BOnly(1,1:10)
%             YOnlyD=YOnly(1,1:10)
%             BOnlyD=BOnly(2,1:10)
%             YOnlyD=YOnly(2,1:10)
%             BOnlyD=BOnly(3,1:10)
%             YOnlyD=YOnly(3,1:10)
sizeInew = size(Inew)
sizeImean = size(Imean)
sizeImeanN = size(ImeanN)
%measure probability of minor and major runs
size(sm);
size(Snew);
numRunsMajorD=numRunsMajor;
measuredProbMajor = numRunsMajor/numRuns;
numRunsMinor = numRuns - numRunsMajor;
measuredProbMinor = numRunsMinor/numRuns;
        end

