%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Jennifer Jackson 2017                                                        %
% A Biodiversity Approach to Cyber Security                                    %
% PhD Complexity Science                                                       %
% University of Warwick                                                        %
% http://wrap.warwick.ac.uk/98458                                              %
% This software is distributed under the  Creative Commons Attribution License %
% https://creativecommons.org/licenses/by/4.0/                                 %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function [ output_args ] = testRandomGenotypesAND( input_args )
%practical example for 4 loci AND from epidemic model with additional
%mechanisms

clear all;
%*************************************
% TESTING AGENT BASED MODEL
%*************************************
close all;

modePar.desirabilities = 'no' %include desirability constraints
modePar.filter = 'no' %include sw filtering


doSIRNTests = zeros(1,600); %tests with genotypes
doSIRNTests(600) = 1 %4 loci OR
%doSIRNTests(601) = 1 %4 loci AND

%FS user desirabilities and filtering 4 loci AND, 4 loci OR
if doSIRNTests(600) == 1
      tic
data.m = 600 %data file number
  
numRuns = 3 %20
numNodes = 10000;
SEpidemic=60; %cutoff;
%main par
numLoci=4; 
casetype = 'AND';
modePar.virusStartTime = 1; %[1400 1400 1400 14000];
numTimestepsVR = [10000]; %7000? [60000 60000 60000 70000]
%VR = [1 2 3 4 5 6 7 8 9 10 11 12];
%bn = [1 (1/10) (1/60) (1/(10*60))]; 

bn = [1/10];
VR = [3];

%VR = [1 3];
%bn = [1];

modePar.blklistStartTime = modePar.virusStartTime
numExploits=1;

%1 locus model
%outputDirectory = 'Graphs\'
outputDirectory = 'Graphs\'
tic
modePar.netStr = 're'; %'rwp' random waypoint 're' random encounter
%*************************
%UNUSED PAR FOR RE MODE
%rwp par
modePar.genotypeTimeOutPeriod = 10; %rwp
modePar.xmin     = 1;     % Minimum x-axis location (du)
modePar.xmax     = 31;    % Maximum x-axis location (du)
modePar.ymin     = 1;     % Minimum y-axis location (du)
modePar.ymax     = 31;    % Maximum y-axis location (du)
modePar.smin     = 1.4;  % Minimum speed (du / tu)
modePar.smax     = 1.4;  % Maximum speed (du / tu)
modePar.pmin     = 0;     % Minimum time for pause (integer tu)
modePar.pmax     = 0;     % Maximum time for pause (integer tu)
modePar.dinr     = 3; %7    % Radial distance for in-range (du)
modePar.dexceed  = 1000;  % Value larger than any possible distance (du)
modePar.tinrg    = 1;     % Time in-range for genotype transfer (tu)
modePar.tinrv    = 1;     % Time in-range for virus transfer (tu)
% Mode
% rwph.mode = rwph.MODE_RIR;  1    % Select Random in range mode
% rwph.mode = rwph.MODE_NIR;  2    % Select Nearest in range mode
modePar.moderwp = 1; %MODE_AIR;  % 4    % Select (Random) Available in range mode
%rwp constrain
modePar.xboxc=0.5
modePar.yboxc=0.5
modePar.rwpcontrainplotGraph=0 %draw init constraints graph
% Log vector
modePar.logena = [1 2];
% Log directory for rwp
modePar.logDir = sprintf('%s\\log', pwd);
modePar.statnodesrwp = 'dynamic'; %'dynamic' or 'stationary' nodes, if dynamic box constraints applied at point of virus start
%END UNUSED PAR
%*****************
%data logging of output
data.logDir = sprintf('%s\\outputdata', pwd)
s = sprintf('%s\\data%i.txt', data.logDir,data.m)
data.logOutput(data.m) = fopen(s, 'wt');
%****************************************
modePar.numEncountersBetweenUpdates = 1
modePar.bufferlength = 10 %length of genotype buffer for favscore algorithm
modePar.genoInit = 'maxdiv'  %initial conditions of genotypes maxdiv (maximum diversity - random variant chosen) mindiv (minimum diversity - all nodes same)
%no constraints
modePar.numToConstrain = 0; %fix(numNodes*1/4); %constrain a number of nodes to 1 variant
modePar.areaConstrainrwp='no'
modePar.desirabilities = 'no' %include desirability constraints
modePar.filter='no'
%update mode
modePar.update = 'yes' %stop updating mode
modePar.bufferlengthNei=10 %buffer for buffering local nei diversity,
modePar.stdNeiUpdateThreshold = 0.15
%*****************************************
%init parameters
%1.recovery only
ResistanceSI_noc = zeros(size(bn,2),size(VR,2)); % resistance SI
PeakTime_noc = zeros(size(bn,2),size(VR,2)); %peak time
ResTime_noc = zeros(size(bn,2),size(VR,2));  %resilience time
Resilience_noc = zeros(size(bn,2),size(VR,2)); %resilience SIR
Resistance_noc = zeros(size(bn,2),size(VR,2)); %resistance SIR
NumberInSEnd_noc = zeros(size(bn,2),size(VR,2));%with vm updates
ResistanceVM_noc = zeros(size(bn,2),size(VR,2)); %vm resistance
ResilienceTimeVM_noc = zeros(size(bn,2),size(VR,2)); %vm resilience time
ResilienceVM_noc = zeros(size(bn,2),size(VR,2)); %vm resilience
%2.recovery and blacklisting
ResistanceSI_ud = zeros(size(bn,2),size(VR,2)); % resistance SI
PeakTime_ud = zeros(size(bn,2),size(VR,2)); %peak time
ResTime_ud = zeros(size(bn,2),size(VR,2));  %resilience time
Resilience_ud = zeros(size(bn,2),size(VR,2)); %resilience SIR
Resistance_ud = zeros(size(bn,2),size(VR,2)); %resistance SIR
NumberInSEnd_ud = zeros(size(bn,2),size(VR,2));%with vm updates
ResistanceVM_ud = zeros(size(bn,2),size(VR,2)); %vm resistance
ResilienceTimeVM_ud = zeros(size(bn,2),size(VR,2)); %vm resilience time
ResilienceVM_ud = zeros(size(bn,2),size(VR,2)); %vm resilience
%3.recovery blacklisting and vm updates
ResistanceSI_f = zeros(size(bn,2),size(VR,2)); % resistance SI
PeakTime_f = zeros(size(bn,2),size(VR,2)); %peak time
ResTime_f = zeros(size(bn,2),size(VR,2));  %resilience time
Resilience_f = zeros(size(bn,2),size(VR,2)); %resilience SIR
Resistance_f = zeros(size(bn,2),size(VR,2)); %resistance SIR
NumberInSEnd_f = zeros(size(bn,2),size(VR,2));%with vm updates
ResistanceVM_f = zeros(size(bn,2),size(VR,2)); %vm resistance
ResilienceTimeVM_f = zeros(size(bn,2),size(VR,2)); %vm resilience time
ResilienceVM_f = zeros(size(bn,2),size(VR,2)); %vm resilience


%**********************
%1. recovery only
%blacklist mode
modePar.blklist = 'no'; %yes or no
modePar.numToBlklist = 1
modePar.blklistrate = 1/(2*60*60); %2 hours
%vmupdate mode
modePar.vm = 'no' %yes or no
%recovery
recovery = 1/(2*60*60); %2 hours%0.004; 0.0005 %0.001
%**********************

mode = 'static' %mode - can be 'static' or 'dynamic' 'Dynamic-random' 'Dynamic-favScore'
%monte carlo random genotype SIR model
%set up diversity mode parameters
modePar.modeStr = mode
modePar.stopUpdatingTime = 2000000 %time at which to stop updating the genotypes

for z = 1:size(bn,2)%do for all contact rates
    betan = bn(z)
for j = 1:size(VR,2)%do for all VR
    variantRichness =  VR(j)
    numTimesteps = numTimestepsVR(1);
   
 plotGraphs = 0; gamma = recovery;  throwAway = 'nonEpidemics', 
 %agent
 [figMeanNei figNeiOneRun fighistSpRun fighistRecovered fighistSusceptible fighistpeakValue fighistpeakTime fighistBeta fighistGamma fighistBetanew fighistGammanew figInfectedRun1 figBetaRun1 figGammaRun1 figRoRun1 figBetaGamma1 figBetaGamma2...
            meanNeiIndexDynamic betastd gammastd betastd2 betastdNew betastdNew2 gammastdNew peakTimemean peakTimestd peakValuemean peakValuestd...
            betameanmean gammameanmean betameanmean2 betameanmeanNew betameanmeanNew2 gammameanmeanNew Smean Imean Rmean Bmean NSmean Smedian Imedian Rmedian S I R NS SmeanN ImeanN1 RmeanN1 BmeanN1 Snewendmean Snewendstd Rnewendmean Rnewendstd Rnew_nonendmean Rnew_nonendstd propSimsNonEp propSimsNonEp_theoretical...
            numRunsMinor measuredProbMinor numRunsMajor measuredProbMajor meanmdist meannumInfectedVM...
            ] = monteCarloSIRN2(numRuns,numNodes, betan, variantRichness, numTimesteps, plotGraphs,gamma,throwAway,SEpidemic,numExploits,modePar, numLoci, casetype);
   %close all; 
   
    %peak time SI
    FinalSizeI = max(Imean,[],2); %mean final size SI
    maska = Imean >= FinalSizeI-1; %when within 1 of the final value
    [C Index] = max(maska);
    PeakTime_noc(z,j) = Index - modePar.virusStartTime; %T1
    if PeakTime_noc(z,j) < 0; PeakTime_noc(z,j)=0; end %check to see if picks an index before the virus start time, must be no outbreak and zero
    %Resistance SI
    ResistanceSI_noc(z,j) = (numNodes-FinalSizeI)./numNodes;  
    %Resilience SIR
     FinalSize = max(RmeanN1,[],2) %mean final R of epidemics only
    maska = RmeanN1 >= FinalSize-1; %when within 1 of the final value
    [C Index] = max(maska);
    ResTime_noc(z,j) = Index -modePar.virusStartTime; %T1 
    if ResTime_noc(z,j) < 0; ResTime_noc(z,j)=0; end %check to see if picks an index before the virus start time, must be no outbreak and zero
    Resilience_noc(z,j) = 1./ResTime_noc(z,j)
    %resistance SIR
    Resistance_noc(z,j) = (numNodes-FinalSize)./numNodes
    
    %VM update Resistance
     ResistanceVM_noc(z,j) =(numNodes - meannumInfectedVM)./numNodes; %number infected at least once
     %[val index] = min(Imean(modePar.virusStartTime:end)) %time for infected to die away
     maska = Imean(modePar.virusStartTime:end) >= 1; %time when within 1 of zero
    [C indvm] = min(maska); %get index of first zero
     ResilienceTimeVM_noc(z,j)= indvm-1; %index 1 means timw zero of malware injection so subtract 1
    ResilienceVM_noc(z,j) = 1./(indvm-1);
     %with vm updates can get rid of those infected to count ended up in S
    %at end
    NumberInSEnd_noc(z,j) = Smean(end);
    
  %figure
  %plot(RmeanN1,'g')
  %title('RmeanN1')
   
%data logging
 fprintf(data.logOutput(data.m), '%f,', Imean);     % infection
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResistanceSI_noc(z,j)); % resistance SI
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', PeakTime_noc(z,j)); %peak time
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResTime_noc(z,j));     %resilience time
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', Resilience_noc(z,j)); %resilience
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', Resistance_noc(z,j)); %resistance SIR
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', NumberInSEnd_noc(z,j));  %with vm updates can get rid of those infected to count ended up in S    %at end
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResistanceVM_noc(z,j));  
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResilienceTimeVM_noc(z,j));  
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResilienceVM_noc(z,j));  
fprintf(data.logOutput(data.m), '\n'); %new line
end %VR
end %bn

fileName = [outputDirectory num2str(data.m) 'outputRecovery.txt']
outFile = fopen(fileName, 'wt');
%1.recovery
fprintf(outFile, '%s\n,', 'ResistanceSI_noc'); fprintf(outFile, '%f,', ResistanceSI_noc); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'PeakTime_noc'); fprintf(outFile, '%f,', PeakTime_noc); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'ResTime_noc'); fprintf(outFile, '%f,', ResTime_noc); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'Resilience_noc'); fprintf(outFile, '%f,', Resilience_noc); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'Resistance_noc'); fprintf(outFile, '%f,', Resistance_noc); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'NumberInSEnd_noc'); fprintf(outFile, '%f,', NumberInSEnd_noc); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'ResistanceVM_noc'); fprintf(outFile, '%f,', ResistanceVM_noc); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'ResilienceTimeVM_noc'); fprintf(outFile, '%f,', ResilienceTimeVM_noc); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'ResilienceVM_noc'); fprintf(outFile, '%f,', ResilienceVM_noc); fprintf(outFile, '\n'); %new line
fclose(outFile);


%peak time SI
figResilienceSIR = figure;
plot(VR,Resilience_noc(1,:), 'k+-','linewidth',2) %1 sec
hold on
%plot(VR,Resilience_noc(2,:), 'ko-','linewidth',2) %10 sec
%plot(VR,Resilience_noc(3,:), 'ks-','linewidth',2) %1 min
%plot(VR,Resilience_noc(4,:), 'k*-','linewidth',2) %10 min
xlabel('Variant Richness')
ylabel('Resilience')
legend('1 sec','10 sec','1 min','10 min')
title('4 loci AND')

%resistance SI
figResistanceSIR=figure;
plot(VR,Resistance_noc(1,:), 'k+-','linewidth',2) %1 sec
hold on
%plot(VR,Resistance_noc(2,:), 'ko-','linewidth',2) %10 sec
%plot(VR,Resistance_noc(3,:), 'ks-','linewidth',2) %1 min
%plot(VR,Resistance_noc(4,:), 'k*-','linewidth',2) %10 min
xlabel('Variant Richness')
ylabel('Resistance ')
legend('1 sec','10 sec','1 min','10 min')
title('4 loci AND')

saveas(figResilienceSIR,[outputDirectory 'figResilienceSIR.fig']);
saveas(figResilienceSIR,[outputDirectory 'figResilienceSIR.emf']);
saveas(figResistanceSIR,[outputDirectory 'figResistanceSIR.fig']);
saveas(figResistanceSIR,[outputDirectory 'figResistanceSIR.emf']);



toc
clock

end

