%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Jennifer Jackson 2017                                                        %
% A Biodiversity Approach to Cyber Security                                    %
% PhD Complexity Science                                                       %
% University of Warwick                                                        %
% http://wrap.warwick.ac.uk/98458                                              %
% This software is distributed under the  Creative Commons Attribution License %
% https://creativecommons.org/licenses/by/4.0/                                 %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function [ output_args ] = testRandomGenotypesDes( input_args )


clear all;
%*************************************
% TESTING AGENT BASED MODEL
%*************************************
close all;

modePar.desirabilities = 'no' %include desirability constraints
modePar.filter = 'no' %include sw filtering


doSIRNTests = zeros(1,500); %tests with genotypes
doSIRNTests(427) = 1 %4 loci OR
%doSIRNTests(428) = 1 %4 loci AND

%FS user desirabilities and filtering 4 loci AND, 4 loci OR
if doSIRNTests(427) == 1
    %OR 427
     %1.no constraints 
    %2.user desirabilities 84% one variant on each locus, rest spread evenly 
    %3.filtering 
    %4.user desirability and filtering 
    %AND 428
     %1.no constraints 
    %2.user desirabilities 84% one variant on each locus, rest spread evenly 
    %3.filtering 
    %4.user desirability and filtering       
data.m = 427 %data file number
  
numRuns = 1 %20 %100 %200
numNodes = 1000;
SEpidemic=60; %cutoff;
%main par
numLoci=4; 
casetype = 'OR';
modePar.virusStartTime = 1200;
numTimestepsVR = [1200];%[5000]; %7000?
%VR = [1 3 5 7 9 11 13 15 17 19 21 23 25 27 30 33 35];
VR = [5];
modePar.blklistStartTime = modePar.virusStartTime
numExploits=1;

%1 locus model
%outputDirectory = 'Graphs\'
outputDirectory = 'Graphs\'
tic
modePar.netStr = 're'; %'rwp' random waypoint 're' random encounter
%*************************
%UNUSED PAR FOR RE MODE
%rwp par
modePar.genotypeTimeOutPeriod = 10; %rwp
modePar.xmin     = 1;     % Minimum x-axis location (du)
modePar.xmax     = 31;    % Maximum x-axis location (du)
modePar.ymin     = 1;     % Minimum y-axis location (du)
modePar.ymax     = 31;    % Maximum y-axis location (du)
modePar.smin     = 1.4;  % Minimum speed (du / tu)
modePar.smax     = 1.4;  % Maximum speed (du / tu)
modePar.pmin     = 0;     % Minimum time for pause (integer tu)
modePar.pmax     = 0;     % Maximum time for pause (integer tu)
modePar.dinr     = 3; %7    % Radial distance for in-range (du)
modePar.dexceed  = 1000;  % Value larger than any possible distance (du)
modePar.tinrg    = 1;     % Time in-range for genotype transfer (tu)
modePar.tinrv    = 1;     % Time in-range for virus transfer (tu)
% Mode
% rwph.mode = rwph.MODE_RIR;  1    % Select Random in range mode
% rwph.mode = rwph.MODE_NIR;  2    % Select Nearest in range mode
modePar.moderwp = 1; %MODE_AIR;  % 4    % Select (Random) Available in range mode
%rwp constrain
modePar.xboxc=0.5
modePar.yboxc=0.5
modePar.rwpcontrainplotGraph=0 %draw init constraints graph
% Log vector
modePar.logena = [1 2];
% Log directory for rwp
modePar.logDir = sprintf('%s\\log', pwd);
modePar.statnodesrwp = 'dynamic'; %'dynamic' or 'stationary' nodes, if dynamic box constraints applied at point of virus start
%END UNUSED PAR
%*****************
%data logging of output
data.logDir = sprintf('%s\\outputdata', pwd)
s = sprintf('%s\\data%i.txt', data.logDir,data.m)
data.logOutput(data.m) = fopen(s, 'wt');
%****************************************
modePar.numEncountersBetweenUpdates = 1
modePar.bufferlength = 10 %length of genotype buffer for favscore algorithm
modePar.genoInit = 'mindiv'  %initial conditions of genotypes maxdiv (maximum diversity - random variant chosen) mindiv (minimum diversity - all nodes same)
%blacklist mode
modePar.blklist = 'no'; %yes or no
modePar.numToBlklist = 1
modePar.blklistrate = 0.004 %0.001
%vmupdate mode
modePar.vm = 'no' %yes or no
%update mode
modePar.update = 'yes' %stop updating mode
modePar.bufferlengthNei=10 %buffer for buffering local nei diversity,
modePar.stdNeiUpdateThreshold = 0.15
%recovery
recovery = 0; %0.004; 0.0005 %0.001
%*****************************************


%init parameters
%1.no constraints
ResistanceSI_noc = zeros(1,size(VR,2)); % resistance SI
PeakTime_noc = zeros(1,size(VR,2)); %peak time
ResTime_noc = zeros(1,size(VR,2));  %resilience time
Resilience_noc = zeros(1,size(VR,2)); %resilience SIR
Resistance_noc = zeros(1,size(VR,2)); %resistance SIR
NumberInSEnd_noc = zeros(1,size(VR,2));%with vm updates
ResistanceVM_noc = zeros(1,size(VR,2)); %vm resistance
ResilienceTimeVM_noc = zeros(1,size(VR,2)); %vm resilience time
ResilienceVM_noc = zeros(1,size(VR,2)); %vm resilience
%2.User desirabilities
ResistanceSI_ud = zeros(1,size(VR,2)); % resistance SI
PeakTime_ud = zeros(1,size(VR,2)); %peak time
ResTime_ud = zeros(1,size(VR,2));  %resilience time
Resilience_ud = zeros(1,size(VR,2)); %resilience SIR
Resistance_ud = zeros(1,size(VR,2)); %resistance SIR
NumberInSEnd_ud = zeros(1,size(VR,2));%with vm updates
ResistanceVM_ud = zeros(1,size(VR,2)); %vm resistance
ResilienceTimeVM_ud = zeros(1,size(VR,2)); %vm resilience time
ResilienceVM_ud = zeros(1,size(VR,2)); %vm resilience
%filtering
ResistanceSI_f = zeros(1,size(VR,2)); % resistance SI
PeakTime_f = zeros(1,size(VR,2)); %peak time
ResTime_f = zeros(1,size(VR,2));  %resilience time
Resilience_f = zeros(1,size(VR,2)); %resilience SIR
Resistance_f = zeros(1,size(VR,2)); %resistance SIR
NumberInSEnd_f = zeros(1,size(VR,2));%with vm updates
ResistanceVM_f = zeros(1,size(VR,2)); %vm resistance
ResilienceTimeVM_f = zeros(1,size(VR,2)); %vm resilience time
ResilienceVM_f = zeros(1,size(VR,2)); %vm resilience
%user desirability and filtering
ResistanceSI_udf = zeros(1,size(VR,2)); % resistance SI
PeakTime_udf = zeros(1,size(VR,2)); %peak time
ResTime_udf = zeros(1,size(VR,2));  %resilience time
Resilience_udf = zeros(1,size(VR,2)); %resilience SIR
Resistance_udf = zeros(1,size(VR,2)); %resistance SIR
NumberInSEnd_udf = zeros(1,size(VR,2));%with vm updates
ResistanceVM_udf = zeros(1,size(VR,2)); %vm resistance
ResilienceTimeVM_udf = zeros(1,size(VR,2)); %vm resilience time
ResilienceVM_udf = zeros(1,size(VR,2)); %vm resilience

%**********************
%1. no constraints
modePar.numToConstrain = 0; %fix(numNodes*1/4); %constrain a number of nodes to 1 variant
modePar.areaConstrainrwp='no'
modePar.desirabilities = 'no' %include desirability constraints
modePar.filter='no'
%**********************
mode = 'Dynamic-favScore' %mode - can be 'static' or 'dynamic' 'Dynamic-random' 'Dynamic-favScore'
%monte carlo random genotype SIR model
%set up diversity mode parameters
modePar.modeStr = mode
modePar.stopUpdatingTime = 200000 %time at which to stop updating the genotypes
for j = 1:size(VR,2)%do for all VR
    variantRichness =  VR(j)
    numTimesteps = numTimestepsVR(1);
   
 betan = 0.02;  plotGraphs = 0; gamma = recovery;  throwAway = 'nonEpidemics', 
 %agent
 [figMeanNei figNeiOneRun fighistSpRun fighistRecovered fighistSusceptible fighistpeakValue fighistpeakTime fighistBeta fighistGamma fighistBetanew fighistGammanew figInfectedRun1 figBetaRun1 figGammaRun1 figRoRun1 figBetaGamma1 figBetaGamma2...
            meanNeiIndexDynamic1 betastd gammastd betastd2 betastdNew betastdNew2 gammastdNew peakTimemean peakTimestd peakValuemean peakValuestd...
            betameanmean gammameanmean betameanmean2 betameanmeanNew betameanmeanNew2 gammameanmeanNew Smean Imean Rmean Bmean NSmean Smedian Imedian Rmedian S I R NS SmeanN ImeanN1 RmeanN1 BmeanN1 Snewendmean Snewendstd Rnewendmean Rnewendstd Rnew_nonendmean Rnew_nonendstd propSimsNonEp propSimsNonEp_theoretical...
            numRunsMinor measuredProbMinor numRunsMajor measuredProbMajor meanmdist meannumInfectedVM...
            ] = monteCarloSIRN2(numRuns,numNodes, betan, variantRichness, numTimesteps, plotGraphs,gamma,throwAway,SEpidemic,numExploits,modePar, numLoci, casetype);
  % close all; 
   
    %peak time SI
    FinalSizeI = max(Imean,[],2); %mean final size SI
    maska = Imean >= FinalSizeI-1; %when within 1 of the final value
    [C Index] = max(maska);
    PeakTime_noc(j) = Index - modePar.virusStartTime; %T1
    if PeakTime_noc(j) < 0; PeakTime_noc(j)=0; end %check to see if picks an index before the virus start time, must be no outbreak and zero
    %Resistance SI
    ResistanceSI_noc(j) = (numNodes-FinalSizeI)./numNodes;  
    %Resilience SIR
     FinalSize = max(RmeanN1,[],2); %mean final R of epidemics only
    maska = RmeanN1 >= FinalSize-1; %when within 1 of the final value
    [C Index] = max(maska);
    ResTime_noc(j) = Index -modePar.virusStartTime; %T1 
    if ResTime_noc(j) < 0; ResTime_noc(j)=0; end %check to see if picks an index before the virus start time, must be no outbreak and zero
    Resilience_noc(j) = 1./ResTime_noc(j);
    %resistance SIR
    Resistance_noc(j) = (numNodes-FinalSize)./numNodes;
    
    %VM update Resistance
     ResistanceVM_noc(j) =(numNodes - meannumInfectedVM)./numNodes; %number infected at least once
     %[val index] = min(Imean(modePar.virusStartTime:end)) %time for infected to die away
     maska = Imean(modePar.virusStartTime:end) >= 1; %time when within 1 of zero
    [C indvm] = min(maska); %get index of first zero
     ResilienceTimeVM_noc(j)= indvm-1; %index 1 means timw zero of malware injection so subtract 1
    ResilienceVM_noc(j) = 1./(indvm-1);
     %with vm updates can get rid of those infected to count ended up in S
    %at end
    NumberInSEnd_noc(j) = Smean(end);
    
  
   
%data logging
 fprintf(data.logOutput(data.m), '%f,', Imean);     % infection
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResistanceSI_noc(j)); % resistance SI
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', PeakTime_noc(j)); %peak time
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResTime_noc(j));     %resilience time
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', Resilience_noc(j)); %resilience
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', Resistance_noc(j)); %resistance SIR
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', NumberInSEnd_noc(j));  %with vm updates can get rid of those infected to count ended up in S    %at end
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResistanceVM_noc(j));  
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResilienceTimeVM_noc(j));  
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResilienceVM_noc(j));  
fprintf(data.logOutput(data.m), '\n'); %new line
end %VR


%**********************
%2. user desirabilities
modePar.numToConstrain = 0; %fix(numNodes*1/4); %constrain a number of nodes to 1 variant
modePar.areaConstrainrwp='no'
modePar.desirabilities = 'yes' %include desirability constraints
modePar.filter='no'
%**********************
mode = 'Dynamic-favScore' %mode - can be 'static' or 'dynamic' 'Dynamic-random' 'Dynamic-favScore'
%monte carlo random genotype SIR model
%set up diversity mode parameters
modePar.modeStr = mode
modePar.stopUpdatingTime = 200000 %time at which to stop updating the genotypes
for j = 1:size(VR,2)%do for all VR
    variantRichness =  VR(j)
    numTimesteps = numTimestepsVR(1);
 betan = 0.02;  plotGraphs = 0; gamma = recovery; throwAway = 'nonEpidemics';
 %agent
 [figMeanNei figNeiOneRun fighistSpRun fighistRecovered fighistSusceptible fighistpeakValue fighistpeakTime fighistBeta fighistGamma fighistBetanew fighistGammanew figInfectedRun1 figBetaRun1 figGammaRun1 figRoRun1 figBetaGamma1 figBetaGamma2...
            meanNeiIndexDynamic2 betastd gammastd betastd2 betastdNew betastdNew2 gammastdNew peakTimemean peakTimestd peakValuemean peakValuestd...
            betameanmean gammameanmean betameanmean2 betameanmeanNew betameanmeanNew2 gammameanmeanNew Smean Imean Rmean Bmean NSmean Smedian Imedian Rmedian S I R NS SmeanN ImeanN1 RmeanN1 BmeanN1 Snewendmean Snewendstd Rnewendmean Rnewendstd Rnew_nonendmean Rnew_nonendstd propSimsNonEp propSimsNonEp_theoretical...
            numRunsMinor measuredProbMinor numRunsMajor measuredProbMajor meanmdist meannumInfectedVM...
            ] = monteCarloSIRN2(numRuns,numNodes, betan, variantRichness, numTimesteps, plotGraphs,gamma,throwAway,SEpidemic,numExploits,modePar, numLoci, casetype);
   %close all; 
   
  %peak time SI
    FinalSizeI = max(Imean,[],2); %mean final size SI
   maska = Imean >= FinalSizeI-1; %when within 1 of the final value
   [C Index] = max(maska);
   PeakTime_ud(j) = Index-modePar.virusStartTime; %T1
   if PeakTime_ud(j) < 0; PeakTime_ud(j)=0; end %check to see if picks an index before the virus start time, must be no outbreak and zero
  %Resistance SI
    ResistanceSI_ud(j) = (numNodes-FinalSizeI)./numNodes; 
    %Resilience SIR
     FinalSize = max(RmeanN1,[],2); %mean final R of epidemics only
    maska = RmeanN1 >= FinalSize-1; %when within 1 of the final value
   [C Index] = max(maska);
   ResTime_ud(j) = Index-modePar.virusStartTime; %T1 
   if ResTime_ud(j) < 0; ResTime_ud(j)=0; end %check to see if picks an index before the virus start time, must be no outbreak and zero
   Resilience_ud(j) = 1./ResTime_ud(j);
   %resistance SIR
   Resistance_ud(j) = (numNodes-FinalSize)./numNodes;
    %VM update Resistance
     ResistanceVM_ud(j) =(numNodes - meannumInfectedVM)./numNodes; %number infected at least once
     %[val index] = min(Imean(modePar.virusStartTime:end)) %time for infected to die away
     maska = Imean(modePar.virusStartTime:end) >= 1; %time when within 1 of zero
    [C indvm] = min(maska); %get index of first zero
     ResilienceTimeVM_ud(j)= indvm-1; %index 1 means timw zero of malware injection so subtract 1
    ResilienceVM_ud(j) = 1./(indvm-1);
     %with vm updates can get rid of those infected to count ended up in S
    %at end
    NumberInSEnd_ud(j) = Smean(end);
  
%data logging
 fprintf(data.logOutput(data.m), '%f,', Imean);     % infection
fprintf(data.logOutput(data.m), '\n'); %new line
fprintf(data.logOutput(data.m), '%f,', ResistanceSI_ud(j)); % resistance SI
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', PeakTime_ud(j)); %peak time
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResTime_ud(j));     %resilience time
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', Resilience_ud(j)); %resilience
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', Resistance_ud(j)); %resistance SIR
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', NumberInSEnd_ud(j));  %with vm updates can get rid of those infected to count ended up in S
fprintf(data.logOutput(data.m), '\n'); %new line 
fprintf(data.logOutput(data.m), '%f,', ResistanceVM_ud(j));  
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResilienceTimeVM_ud(j));  
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResilienceVM_ud(j));  
fprintf(data.logOutput(data.m), '\n'); %new line
end %VR


%**********************
%3. filtering
modePar.numToConstrain = 0; %fix(numNodes*1/4); %constrain a number of nodes to 1 variant
modePar.areaConstrainrwp='no'
modePar.desirabilities = 'no' %include desirability constraints
modePar.filter='yes'
%**********************
mode = 'Dynamic-favScore' %mode - can be 'static' or 'dynamic' 'Dynamic-random' 'Dynamic-favScore'
%monte carlo random genotype SIR model
%set up diversity mode parameters
modePar.modeStr = mode
modePar.stopUpdatingTime = 200000 %time at which to stop updating the genotypes
for j = 1:size(VR,2)%do for all VR
    variantRichness =  VR(j)
    numTimesteps = numTimestepsVR(1);
 betan = 0.02;  plotGraphs = 0; gamma = recovery; throwAway = 'nonEpidemics';
 %agent
 [figMeanNei figNeiOneRun fighistSpRun fighistRecovered fighistSusceptible fighistpeakValue fighistpeakTime fighistBeta fighistGamma fighistBetanew fighistGammanew figInfectedRun1 figBetaRun1 figGammaRun1 figRoRun1 figBetaGamma1 figBetaGamma2...
            meanNeiIndexDynamic3 betastd gammastd betastd2 betastdNew betastdNew2 gammastdNew peakTimemean peakTimestd peakValuemean peakValuestd...
            betameanmean gammameanmean betameanmean2 betameanmeanNew betameanmeanNew2 gammameanmeanNew Smean Imean Rmean Bmean NSmean Smedian Imedian Rmedian S I R NS SmeanN ImeanN1 RmeanN1 BmeanN1 Snewendmean Snewendstd Rnewendmean Rnewendstd Rnew_nonendmean Rnew_nonendstd propSimsNonEp propSimsNonEp_theoretical...
            numRunsMinor measuredProbMinor numRunsMajor measuredProbMajor meanmdist meannumInfectedVM...
            ] = monteCarloSIRN2(numRuns,numNodes, betan, variantRichness, numTimesteps, plotGraphs,gamma,throwAway,SEpidemic,numExploits,modePar, numLoci, casetype);
   %close all; 
   
  %peak time SI
    FinalSizeI = max(Imean,[],2); %mean final size SI
   maska = Imean >= FinalSizeI-1; %when within 1 of the final value
   [C Index] = max(maska);
   PeakTime_f(j) = Index-modePar.virusStartTime; %T1
   if PeakTime_f(j) < 0; PeakTime_f(j)=0; end %check to see if picks an index before the virus start time, must be no outbreak and zero
  %Resistance SI
    ResistanceSI_f(j) = (numNodes-FinalSizeI)./numNodes; 
    %Resilience SIR
     FinalSize = max(RmeanN1,[],2); %mean final R of epidemics only
    maska = RmeanN1 >= FinalSize-1; %when within 1 of the final value
   [C Index] = max(maska);
   ResTime_f(j) = Index-modePar.virusStartTime; %T1 
   if ResTime_f(j) < 0; ResTime_f(j)=0; end %check to see if picks an index before the virus start time, must be no outbreak and zero
   Resilience_f(j) = 1./ResTime_f(j);
   %resistance SIR
   Resistance_f(j) = (numNodes-FinalSize)./numNodes;
    %VM update Resistance
     ResistanceVM_f(j) =(numNodes - meannumInfectedVM)./numNodes; %number infected at least once
     %[val index] = min(Imean(modePar.virusStartTime:end)) %time for infected to die away
     maska = Imean(modePar.virusStartTime:end) >= 1; %time when within 1 of zero
    [C indvm] = min(maska); %get index of first zero
     ResilienceTimeVM_f(j)= indvm-1; %index 1 means timw zero of malware injection so subtract 1
    ResilienceVM_f(j) = 1./(indvm-1);
     %with vm updates can get rid of those infected to count ended up in S
    %at end
    NumberInSEnd_f(j) = Smean(end);
  
%data logging
 fprintf(data.logOutput(data.m), '%f,', Imean);     % infection
fprintf(data.logOutput(data.m), '\n'); %new line
fprintf(data.logOutput(data.m), '%f,', ResistanceSI_f(j)); % resistance SI
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', PeakTime_f(j)); %peak time
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResTime_f(j));     %resilience time
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', Resilience_f(j)); %resilience
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', Resistance_f(j)); %resistance SIR
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', NumberInSEnd_f(j));  %with vm updates can get rid of those infected to count ended up in S
fprintf(data.logOutput(data.m), '\n'); %new line 
fprintf(data.logOutput(data.m), '%f,', ResistanceVM_f(j));  
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResilienceTimeVM_f(j));  
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResilienceVM_f(j));  
fprintf(data.logOutput(data.m), '\n'); %new line
end %VR

%**********************
%4. user desirability and filtering
modePar.numToConstrain = 0; %fix(numNodes*1/4); %constrain a number of nodes to 1 variant
modePar.areaConstrainrwp='no'
modePar.desirabilities = 'yes' %include desirability constraints
modePar.filter='yes'
%**********************
mode = 'Dynamic-favScore' %mode - can be 'static' or 'dynamic' 'Dynamic-random' 'Dynamic-favScore'
%monte carlo random genotype SIR model
%set up diversity mode parameters
modePar.modeStr = mode
modePar.stopUpdatingTime = 200000 %time at which to stop updating the genotypes
for j = 1:size(VR,2)%do for all VR
    variantRichness =  VR(j)
    numTimesteps = numTimestepsVR(1);
 betan = 0.02;  plotGraphs = 0; gamma = recovery; throwAway = 'nonEpidemics';
 %agent
 [figMeanNei figNeiOneRun fighistSpRun fighistRecovered fighistSusceptible fighistpeakValue fighistpeakTime fighistBeta fighistGamma fighistBetanew fighistGammanew figInfectedRun1 figBetaRun1 figGammaRun1 figRoRun1 figBetaGamma1 figBetaGamma2...
            meanNeiIndexDynamic4 betastd gammastd betastd2 betastdNew betastdNew2 gammastdNew peakTimemean peakTimestd peakValuemean peakValuestd...
            betameanmean gammameanmean betameanmean2 betameanmeanNew betameanmeanNew2 gammameanmeanNew Smean Imean Rmean Bmean NSmean Smedian Imedian Rmedian S I R NS SmeanN ImeanN1 RmeanN1 BmeanN1 Snewendmean Snewendstd Rnewendmean Rnewendstd Rnew_nonendmean Rnew_nonendstd propSimsNonEp propSimsNonEp_theoretical...
            numRunsMinor measuredProbMinor numRunsMajor measuredProbMajor meanmdist meannumInfectedVM...
            ] = monteCarloSIRN2(numRuns,numNodes, betan, variantRichness, numTimesteps, plotGraphs,gamma,throwAway,SEpidemic,numExploits,modePar, numLoci, casetype);
   %close all; 
   
  %peak time SI
    FinalSizeI = max(Imean,[],2); %mean final size SI
   maska = Imean >= FinalSizeI-1; %when within 1 of the final value
   [C Index] = max(maska);
   PeakTime_udf(j) = Index-modePar.virusStartTime; %T1
   if PeakTime_udf(j) < 0; PeakTime_udf(j)=0; end %check to see if picks an index before the virus start time, must be no outbreak and zero
  %Resistance SI
    ResistanceSI_udf(j) = (numNodes-FinalSizeI)./numNodes; 
    %Resilience SIR
     FinalSize = max(RmeanN1,[],2); %mean final R of epidemics only
    maska = RmeanN1 >= FinalSize-1; %when within 1 of the final value
   [C Index] = max(maska);
   ResTime_udf(j) = Index-modePar.virusStartTime; %T1 
   if ResTime_udf(j) < 0; ResTime_udf(j)=0; end %check to see if picks an index before the virus start time, must be no outbreak and zero
   Resilience_udf(j) = 1./ResTime_udf(j);
   %resistance SIR
   Resistance_udf(j) = (numNodes-FinalSize)./numNodes;
    %VM update Resistance
     ResistanceVM_udf(j) =(numNodes - meannumInfectedVM)./numNodes; %number infected at least once
     %[val index] = min(Imean(modePar.virusStartTime:end)) %time for infected to die away
     maska = Imean(modePar.virusStartTime:end) >= 1; %time when within 1 of zero
    [C indvm] = min(maska); %get index of first zero
     ResilienceTimeVM_udf(j)= indvm-1; %index 1 means timw zero of malware injection so subtract 1
    ResilienceVM_udf(j) = 1./(indvm-1);
     %with vm updates can get rid of those infected to count ended up in S
    %at end
    NumberInSEnd_udf(j) = Smean(end);
  
%data logging
 fprintf(data.logOutput(data.m), '%f,', Imean);     % infection
fprintf(data.logOutput(data.m), '\n'); %new line
fprintf(data.logOutput(data.m), '%f,', ResistanceSI_udf(j)); % resistance SI
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', PeakTime_udf(j)); %peak time
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResTime_udf(j));     %resilience time
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', Resilience_udf(j)); %resilience
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', Resistance_udf(j)); %resistance SIR
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', NumberInSEnd_udf(j));  %with vm updates can get rid of those infected to count ended up in S
fprintf(data.logOutput(data.m), '\n'); %new line 
fprintf(data.logOutput(data.m), '%f,', ResistanceVM_udf(j));  
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResilienceTimeVM_udf(j));  
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResilienceVM_udf(j));  
fprintf(data.logOutput(data.m), '\n'); %new line
end %VR
fclose(data.logOutput(data.m));


fileName = [outputDirectory num2str(data.m) 'output.txt']
outFile = fopen(fileName, 'wt');
%1.no constraints 
fprintf(outFile, '%s\n,', 'ResistanceSI'); fprintf(outFile, '%f,', ResistanceSI_noc); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'PeakTime'); fprintf(outFile, '%f,', PeakTime_noc); fprintf(outFile, '\n'); %new line
%2.user desirabilities 84% one variant on each locus, rest spread evenly 
fprintf(outFile, '%s\n,', 'ResistanceSI'); fprintf(outFile, '%f,', ResistanceSI_ud); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'PeakTime'); fprintf(outFile, '%f,', PeakTime_ud); fprintf(outFile, '\n'); %new line
%3.filtering 
fprintf(outFile, '%s\n,', 'ResistanceSI'); fprintf(outFile, '%f,', ResistanceSI_f); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'PeakTime'); fprintf(outFile, '%f,', PeakTime_f); fprintf(outFile, '\n'); %new line
%4.user desirability and filtering
fprintf(outFile, '%s\n,', 'ResistanceSI'); fprintf(outFile, '%f,', ResistanceSI_udf); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'PeakTime'); fprintf(outFile, '%f,', PeakTime_udf); fprintf(outFile, '\n'); %new line
fclose(outFile);


%peak time SI
figIPeak = figure;
plot(VR,PeakTime_noc, 'k+-','linewidth',2)
hold on
plot(VR,PeakTime_ud, 'ko-','linewidth',2)
plot(VR,PeakTime_f, 'ks-','linewidth',2)
plot(VR,PeakTime_udf, 'k*--','linewidth',2)
xlabel('Variant Richness')
ylabel('Peak Time - SI')
legend('No constraints','User desirability 84%','Filtering','User desirability & filtering')
title('4 loci OR')

%resistance SI
figResistanceSI=figure;
plot(VR,ResistanceSI_noc,'k+-','linewidth',2)
hold on
plot(VR,ResistanceSI_ud,'ko-','linewidth',2)
plot(VR,ResistanceSI_f,'ks-','linewidth',2)
plot(VR,ResistanceSI_udf,'k*--','linewidth',2)
xlabel('Variant Richness')
ylabel('Resistance ')
legend('No constraints','User desirability 84%','Filtering','User desirability & filtering')
title('4 loci OR')

saveas(figResistanceSI,[outputDirectory 'figResistanceSI.fig']);
saveas(figResistanceSI,[outputDirectory 'figResistanceSI.emf']);
saveas(figIPeak,[outputDirectory 'figIPeak.fig']);
saveas(figIPeak,[outputDirectory 'figIPeak.emf']);

%ALL graphs
ResistanceSI_noc
PeakTime_noc
ResistanceSI_ud
PeakTime_ud
ResistanceSI_f
PeakTime_f
ResistanceSI_udf
PeakTime_udf
toc


figure
plot(meanNeiIndexDynamic1,'k','linewidth',2)
hold on
plot(meanNeiIndexDynamic2,'r','linewidth',2)
plot(meanNeiIndexDynamic3,'k--','linewidth',2)
plot(meanNeiIndexDynamic4,'r--','linewidth',2)
xlabel('Time (seconds)')
ylabel('Variant Diversity')
legend('No constraints', 'User desirabilities 84%', 'Filtering', 'User desirabilities & filtering')

end %427

if doSIRNTests(428) == 1
    %OR 427
     %1.no constraints 
    %2.user desirabilities 84% one variant on each locus, rest spread evenly 
    %3.filtering 
    %4.user desirability and filtering 
    %AND 428
     %1.no constraints 
    %2.user desirabilities 84% one variant on each locus, rest spread evenly 
    %3.filtering 
    %4.user desirability and filtering       
data.m = 428 %data file number
  
numRuns = 20 %100 %200
numNodes = 1000;
SEpidemic=60; %cutoff;
%main par
numLoci=4; 
casetype = 'AND';
modePar.virusStartTime = 1200;
numTimestepsVR = [5000]; %7000?
VR = [1 2 3 4 5 6 7 8 9 10];
modePar.blklistStartTime = modePar.virusStartTime
numExploits=1;

%1 locus model
%outputDirectory = 'randomGenotypesGraphs\Des\Test428\' %BUMBLEBEE
outputDirectory = 'randomGenotypesGraphs\Des\Test428\'
tic
modePar.netStr = 're'; %'rwp' random waypoint 're' random encounter
%*************************
%UNUSED PAR FOR RE MODE
%rwp par
modePar.genotypeTimeOutPeriod = 10; %rwp
modePar.xmin     = 1;     % Minimum x-axis location (du)
modePar.xmax     = 31;    % Maximum x-axis location (du)
modePar.ymin     = 1;     % Minimum y-axis location (du)
modePar.ymax     = 31;    % Maximum y-axis location (du)
modePar.smin     = 1.4;  % Minimum speed (du / tu)
modePar.smax     = 1.4;  % Maximum speed (du / tu)
modePar.pmin     = 0;     % Minimum time for pause (integer tu)
modePar.pmax     = 0;     % Maximum time for pause (integer tu)
modePar.dinr     = 3; %7    % Radial distance for in-range (du)
modePar.dexceed  = 1000;  % Value larger than any possible distance (du)
modePar.tinrg    = 1;     % Time in-range for genotype transfer (tu)
modePar.tinrv    = 1;     % Time in-range for virus transfer (tu)
% Mode
% rwph.mode = rwph.MODE_RIR;  1    % Select Random in range mode
% rwph.mode = rwph.MODE_NIR;  2    % Select Nearest in range mode
modePar.moderwp = 1; %MODE_AIR;  % 4    % Select (Random) Available in range mode
%rwp constrain
modePar.xboxc=0.5
modePar.yboxc=0.5
modePar.rwpcontrainplotGraph=0 %draw init constraints graph
% Log vector
modePar.logena = [1 2];
% Log directory for rwp
modePar.logDir = sprintf('%s\\log', pwd);
modePar.statnodesrwp = 'dynamic'; %'dynamic' or 'stationary' nodes, if dynamic box constraints applied at point of virus start
%END UNUSED PAR
%*****************
%data logging of output
data.logDir = sprintf('%s\\outputdata', pwd)
s = sprintf('%s\\data%i.txt', data.logDir,data.m)
data.logOutput(data.m) = fopen(s, 'wt');
%****************************************
modePar.numEncountersBetweenUpdates = 1
modePar.bufferlength = 10 %length of genotype buffer for favscore algorithm
modePar.genoInit = 'mindiv'  %initial conditions of genotypes maxdiv (maximum diversity - random variant chosen) mindiv (minimum diversity - all nodes same)
%blacklist mode
modePar.blklist = 'no'; %yes or no
modePar.numToBlklist = 1
modePar.blklistrate = 0.004 %0.001
%vmupdate mode
modePar.vm = 'no' %yes or no
%update mode
modePar.update = 'yes' %stop updating mode
modePar.bufferlengthNei=10 %buffer for buffering local nei diversity,
modePar.stdNeiUpdateThreshold = 0.15
%recovery
recovery = 0; %0.004; 0.0005 %0.001
%*****************************************


%init parameters
%1.no constraints
ResistanceSI_noc = zeros(1,size(VR,2)); % resistance SI
PeakTime_noc = zeros(1,size(VR,2)); %peak time
ResTime_noc = zeros(1,size(VR,2));  %resilience time
Resilience_noc = zeros(1,size(VR,2)); %resilience SIR
Resistance_noc = zeros(1,size(VR,2)); %resistance SIR
NumberInSEnd_noc = zeros(1,size(VR,2));%with vm updates
ResistanceVM_noc = zeros(1,size(VR,2)); %vm resistance
ResilienceTimeVM_noc = zeros(1,size(VR,2)); %vm resilience time
ResilienceVM_noc = zeros(1,size(VR,2)); %vm resilience
%2.User desirabilities
ResistanceSI_ud = zeros(1,size(VR,2)); % resistance SI
PeakTime_ud = zeros(1,size(VR,2)); %peak time
ResTime_ud = zeros(1,size(VR,2));  %resilience time
Resilience_ud = zeros(1,size(VR,2)); %resilience SIR
Resistance_ud = zeros(1,size(VR,2)); %resistance SIR
NumberInSEnd_ud = zeros(1,size(VR,2));%with vm updates
ResistanceVM_ud = zeros(1,size(VR,2)); %vm resistance
ResilienceTimeVM_ud = zeros(1,size(VR,2)); %vm resilience time
ResilienceVM_ud = zeros(1,size(VR,2)); %vm resilience
%filtering
ResistanceSI_f = zeros(1,size(VR,2)); % resistance SI
PeakTime_f = zeros(1,size(VR,2)); %peak time
ResTime_f = zeros(1,size(VR,2));  %resilience time
Resilience_f = zeros(1,size(VR,2)); %resilience SIR
Resistance_f = zeros(1,size(VR,2)); %resistance SIR
NumberInSEnd_f = zeros(1,size(VR,2));%with vm updates
ResistanceVM_f = zeros(1,size(VR,2)); %vm resistance
ResilienceTimeVM_f = zeros(1,size(VR,2)); %vm resilience time
ResilienceVM_f = zeros(1,size(VR,2)); %vm resilience
%user desirability and filtering
ResistanceSI_udf = zeros(1,size(VR,2)); % resistance SI
PeakTime_udf = zeros(1,size(VR,2)); %peak time
ResTime_udf = zeros(1,size(VR,2));  %resilience time
Resilience_udf = zeros(1,size(VR,2)); %resilience SIR
Resistance_udf = zeros(1,size(VR,2)); %resistance SIR
NumberInSEnd_udf = zeros(1,size(VR,2));%with vm updates
ResistanceVM_udf = zeros(1,size(VR,2)); %vm resistance
ResilienceTimeVM_udf = zeros(1,size(VR,2)); %vm resilience time
ResilienceVM_udf = zeros(1,size(VR,2)); %vm resilience

%**********************
%1. no constraints
modePar.numToConstrain = 0; %fix(numNodes*1/4); %constrain a number of nodes to 1 variant
modePar.areaConstrainrwp='no'
modePar.desirabilities = 'no' %include desirability constraints
modePar.filter='no'
%**********************
mode = 'Dynamic-favScore' %mode - can be 'static' or 'dynamic' 'Dynamic-random' 'Dynamic-favScore'
%monte carlo random genotype SIR model
%set up diversity mode parameters
modePar.modeStr = mode
modePar.stopUpdatingTime = 200000 %time at which to stop updating the genotypes
for j = 1:size(VR,2)%do for all VR
    variantRichness =  VR(j)
    numTimesteps = numTimestepsVR(1);
   
 betan = 0.02;  plotGraphs = 0; gamma = recovery;  throwAway = 'nonEpidemics', 
 %agent
 [figMeanNei figNeiOneRun fighistSpRun fighistRecovered fighistSusceptible fighistpeakValue fighistpeakTime fighistBeta fighistGamma fighistBetanew fighistGammanew figInfectedRun1 figBetaRun1 figGammaRun1 figRoRun1 figBetaGamma1 figBetaGamma2...
            meanNeiIndexDynamic betastd gammastd betastd2 betastdNew betastdNew2 gammastdNew peakTimemean peakTimestd peakValuemean peakValuestd...
            betameanmean gammameanmean betameanmean2 betameanmeanNew betameanmeanNew2 gammameanmeanNew Smean Imean Rmean Bmean NSmean Smedian Imedian Rmedian S I R NS SmeanN ImeanN1 RmeanN1 BmeanN1 Snewendmean Snewendstd Rnewendmean Rnewendstd Rnew_nonendmean Rnew_nonendstd propSimsNonEp propSimsNonEp_theoretical...
            numRunsMinor measuredProbMinor numRunsMajor measuredProbMajor meanmdist meannumInfectedVM...
            ] = monteCarloSIRN2(numRuns,numNodes, betan, variantRichness, numTimesteps, plotGraphs,gamma,throwAway,SEpidemic,numExploits,modePar, numLoci, casetype);
   close all; 
   
    %peak time SI
    FinalSizeI = max(Imean,[],2); %mean final size SI
    maska = Imean >= FinalSizeI-1; %when within 1 of the final value
    [C Index] = max(maska);
    PeakTime_noc(j) = Index - modePar.virusStartTime; %T1
    if PeakTime_noc(j) < 0; PeakTime_noc(j)=0; end %check to see if picks an index before the virus start time, must be no outbreak and zero
    %Resistance SI
    ResistanceSI_noc(j) = (numNodes-FinalSizeI)./numNodes;  
    %Resilience SIR
     FinalSize = max(RmeanN1,[],2); %mean final R of epidemics only
    maska = RmeanN1 >= FinalSize-1; %when within 1 of the final value
    [C Index] = max(maska);
    ResTime_noc(j) = Index -modePar.virusStartTime; %T1 
    if ResTime_noc(j) < 0; ResTime_noc(j)=0; end %check to see if picks an index before the virus start time, must be no outbreak and zero
    Resilience_noc(j) = 1./ResTime_noc(j);
    %resistance SIR
    Resistance_noc(j) = (numNodes-FinalSize)./numNodes;
    
    %VM update Resistance
     ResistanceVM_noc(j) =(numNodes - meannumInfectedVM)./numNodes; %number infected at least once
     %[val index] = min(Imean(modePar.virusStartTime:end)) %time for infected to die away
     maska = Imean(modePar.virusStartTime:end) >= 1; %time when within 1 of zero
    [C indvm] = min(maska); %get index of first zero
     ResilienceTimeVM_noc(j)= indvm-1; %index 1 means timw zero of malware injection so subtract 1
    ResilienceVM_noc(j) = 1./(indvm-1);
     %with vm updates can get rid of those infected to count ended up in S
    %at end
    NumberInSEnd_noc(j) = Smean(end);
    
  
   
%data logging
 fprintf(data.logOutput(data.m), '%f,', Imean);     % infection
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResistanceSI_noc(j)); % resistance SI
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', PeakTime_noc(j)); %peak time
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResTime_noc(j));     %resilience time
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', Resilience_noc(j)); %resilience
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', Resistance_noc(j)); %resistance SIR
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', NumberInSEnd_noc(j));  %with vm updates can get rid of those infected to count ended up in S    %at end
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResistanceVM_noc(j));  
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResilienceTimeVM_noc(j));  
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResilienceVM_noc(j));  
fprintf(data.logOutput(data.m), '\n'); %new line
end %VR


%**********************
%2. user desirabilities
modePar.numToConstrain = 0; %fix(numNodes*1/4); %constrain a number of nodes to 1 variant
modePar.areaConstrainrwp='no'
modePar.desirabilities = 'yes' %include desirability constraints
modePar.filter='no'
%**********************
mode = 'Dynamic-favScore' %mode - can be 'static' or 'dynamic' 'Dynamic-random' 'Dynamic-favScore'
%monte carlo random genotype SIR model
%set up diversity mode parameters
modePar.modeStr = mode
modePar.stopUpdatingTime = 200000 %time at which to stop updating the genotypes
for j = 1:size(VR,2)%do for all VR
    variantRichness =  VR(j)
    numTimesteps = numTimestepsVR(1);
 betan = 0.02;  plotGraphs = 0; gamma = recovery; throwAway = 'nonEpidemics';
 %agent
 [figMeanNei figNeiOneRun fighistSpRun fighistRecovered fighistSusceptible fighistpeakValue fighistpeakTime fighistBeta fighistGamma fighistBetanew fighistGammanew figInfectedRun1 figBetaRun1 figGammaRun1 figRoRun1 figBetaGamma1 figBetaGamma2...
            meanNeiIndexDynamic betastd gammastd betastd2 betastdNew betastdNew2 gammastdNew peakTimemean peakTimestd peakValuemean peakValuestd...
            betameanmean gammameanmean betameanmean2 betameanmeanNew betameanmeanNew2 gammameanmeanNew Smean Imean Rmean Bmean NSmean Smedian Imedian Rmedian S I R NS SmeanN ImeanN1 RmeanN1 BmeanN1 Snewendmean Snewendstd Rnewendmean Rnewendstd Rnew_nonendmean Rnew_nonendstd propSimsNonEp propSimsNonEp_theoretical...
            numRunsMinor measuredProbMinor numRunsMajor measuredProbMajor meanmdist meannumInfectedVM...
            ] = monteCarloSIRN2(numRuns,numNodes, betan, variantRichness, numTimesteps, plotGraphs,gamma,throwAway,SEpidemic,numExploits,modePar, numLoci, casetype);
   close all; 
   
  %peak time SI
    FinalSizeI = max(Imean,[],2); %mean final size SI
   maska = Imean >= FinalSizeI-1; %when within 1 of the final value
   [C Index] = max(maska);
   PeakTime_ud(j) = Index-modePar.virusStartTime; %T1
   if PeakTime_ud(j) < 0; PeakTime_ud(j)=0; end %check to see if picks an index before the virus start time, must be no outbreak and zero
  %Resistance SI
    ResistanceSI_ud(j) = (numNodes-FinalSizeI)./numNodes; 
    %Resilience SIR
     FinalSize = max(RmeanN1,[],2); %mean final R of epidemics only
    maska = RmeanN1 >= FinalSize-1; %when within 1 of the final value
   [C Index] = max(maska);
   ResTime_ud(j) = Index-modePar.virusStartTime; %T1 
   if ResTime_ud(j) < 0; ResTime_ud(j)=0; end %check to see if picks an index before the virus start time, must be no outbreak and zero
   Resilience_ud(j) = 1./ResTime_ud(j);
   %resistance SIR
   Resistance_ud(j) = (numNodes-FinalSize)./numNodes;
    %VM update Resistance
     ResistanceVM_ud(j) =(numNodes - meannumInfectedVM)./numNodes; %number infected at least once
     %[val index] = min(Imean(modePar.virusStartTime:end)) %time for infected to die away
     maska = Imean(modePar.virusStartTime:end) >= 1; %time when within 1 of zero
    [C indvm] = min(maska); %get index of first zero
     ResilienceTimeVM_ud(j)= indvm-1; %index 1 means timw zero of malware injection so subtract 1
    ResilienceVM_ud(j) = 1./(indvm-1);
     %with vm updates can get rid of those infected to count ended up in S
    %at end
    NumberInSEnd_ud(j) = Smean(end);
  
%data logging
 fprintf(data.logOutput(data.m), '%f,', Imean);     % infection
fprintf(data.logOutput(data.m), '\n'); %new line
fprintf(data.logOutput(data.m), '%f,', ResistanceSI_ud(j)); % resistance SI
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', PeakTime_ud(j)); %peak time
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResTime_ud(j));     %resilience time
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', Resilience_ud(j)); %resilience
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', Resistance_ud(j)); %resistance SIR
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', NumberInSEnd_ud(j));  %with vm updates can get rid of those infected to count ended up in S
fprintf(data.logOutput(data.m), '\n'); %new line 
fprintf(data.logOutput(data.m), '%f,', ResistanceVM_ud(j));  
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResilienceTimeVM_ud(j));  
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResilienceVM_ud(j));  
fprintf(data.logOutput(data.m), '\n'); %new line
end %VR


%**********************
%3. filtering
modePar.numToConstrain = 0; %fix(numNodes*1/4); %constrain a number of nodes to 1 variant
modePar.areaConstrainrwp='no'
modePar.desirabilities = 'no' %include desirability constraints
modePar.filter='yes'
%**********************
mode = 'Dynamic-favScore' %mode - can be 'static' or 'dynamic' 'Dynamic-random' 'Dynamic-favScore'
%monte carlo random genotype SIR model
%set up diversity mode parameters
modePar.modeStr = mode
modePar.stopUpdatingTime = 200000 %time at which to stop updating the genotypes
for j = 1:size(VR,2)%do for all VR
    variantRichness =  VR(j)
    numTimesteps = numTimestepsVR(1);
 betan = 0.02;  plotGraphs = 0; gamma = recovery; throwAway = 'nonEpidemics';
 %agent
 [figMeanNei figNeiOneRun fighistSpRun fighistRecovered fighistSusceptible fighistpeakValue fighistpeakTime fighistBeta fighistGamma fighistBetanew fighistGammanew figInfectedRun1 figBetaRun1 figGammaRun1 figRoRun1 figBetaGamma1 figBetaGamma2...
            meanNeiIndexDynamic betastd gammastd betastd2 betastdNew betastdNew2 gammastdNew peakTimemean peakTimestd peakValuemean peakValuestd...
            betameanmean gammameanmean betameanmean2 betameanmeanNew betameanmeanNew2 gammameanmeanNew Smean Imean Rmean Bmean NSmean Smedian Imedian Rmedian S I R NS SmeanN ImeanN1 RmeanN1 BmeanN1 Snewendmean Snewendstd Rnewendmean Rnewendstd Rnew_nonendmean Rnew_nonendstd propSimsNonEp propSimsNonEp_theoretical...
            numRunsMinor measuredProbMinor numRunsMajor measuredProbMajor meanmdist meannumInfectedVM...
            ] = monteCarloSIRN2(numRuns,numNodes, betan, variantRichness, numTimesteps, plotGraphs,gamma,throwAway,SEpidemic,numExploits,modePar, numLoci, casetype);
   close all; 
   
  %peak time SI
    FinalSizeI = max(Imean,[],2); %mean final size SI
   maska = Imean >= FinalSizeI-1; %when within 1 of the final value
   [C Index] = max(maska);
   PeakTime_f(j) = Index-modePar.virusStartTime; %T1
   if PeakTime_f(j) < 0; PeakTime_f(j)=0; end %check to see if picks an index before the virus start time, must be no outbreak and zero
  %Resistance SI
    ResistanceSI_f(j) = (numNodes-FinalSizeI)./numNodes; 
    %Resilience SIR
     FinalSize = max(RmeanN1,[],2); %mean final R of epidemics only
    maska = RmeanN1 >= FinalSize-1; %when within 1 of the final value
   [C Index] = max(maska);
   ResTime_f(j) = Index-modePar.virusStartTime; %T1 
   if ResTime_f(j) < 0; ResTime_f(j)=0; end %check to see if picks an index before the virus start time, must be no outbreak and zero
   Resilience_f(j) = 1./ResTime_f(j);
   %resistance SIR
   Resistance_f(j) = (numNodes-FinalSize)./numNodes;
    %VM update Resistance
     ResistanceVM_f(j) =(numNodes - meannumInfectedVM)./numNodes; %number infected at least once
     %[val index] = min(Imean(modePar.virusStartTime:end)) %time for infected to die away
     maska = Imean(modePar.virusStartTime:end) >= 1; %time when within 1 of zero
    [C indvm] = min(maska); %get index of first zero
     ResilienceTimeVM_f(j)= indvm-1; %index 1 means timw zero of malware injection so subtract 1
    ResilienceVM_f(j) = 1./(indvm-1);
     %with vm updates can get rid of those infected to count ended up in S
    %at end
    NumberInSEnd_f(j) = Smean(end);
  
%data logging
 fprintf(data.logOutput(data.m), '%f,', Imean);     % infection
fprintf(data.logOutput(data.m), '\n'); %new line
fprintf(data.logOutput(data.m), '%f,', ResistanceSI_f(j)); % resistance SI
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', PeakTime_f(j)); %peak time
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResTime_f(j));     %resilience time
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', Resilience_f(j)); %resilience
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', Resistance_f(j)); %resistance SIR
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', NumberInSEnd_f(j));  %with vm updates can get rid of those infected to count ended up in S
fprintf(data.logOutput(data.m), '\n'); %new line 
fprintf(data.logOutput(data.m), '%f,', ResistanceVM_f(j));  
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResilienceTimeVM_f(j));  
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResilienceVM_f(j));  
fprintf(data.logOutput(data.m), '\n'); %new line
end %VR

%**********************
%4. user desirability and filtering
modePar.numToConstrain = 0; %fix(numNodes*1/4); %constrain a number of nodes to 1 variant
modePar.areaConstrainrwp='no'
modePar.desirabilities = 'yes' %include desirability constraints
modePar.filter='yes'
%**********************
mode = 'Dynamic-favScore' %mode - can be 'static' or 'dynamic' 'Dynamic-random' 'Dynamic-favScore'
%monte carlo random genotype SIR model
%set up diversity mode parameters
modePar.modeStr = mode
modePar.stopUpdatingTime = 200000 %time at which to stop updating the genotypes
for j = 1:size(VR,2)%do for all VR
    variantRichness =  VR(j)
    numTimesteps = numTimestepsVR(1);
 betan = 0.02;  plotGraphs = 0; gamma = recovery; throwAway = 'nonEpidemics';
 %agent
 [figMeanNei figNeiOneRun fighistSpRun fighistRecovered fighistSusceptible fighistpeakValue fighistpeakTime fighistBeta fighistGamma fighistBetanew fighistGammanew figInfectedRun1 figBetaRun1 figGammaRun1 figRoRun1 figBetaGamma1 figBetaGamma2...
            meanNeiIndexDynamic betastd gammastd betastd2 betastdNew betastdNew2 gammastdNew peakTimemean peakTimestd peakValuemean peakValuestd...
            betameanmean gammameanmean betameanmean2 betameanmeanNew betameanmeanNew2 gammameanmeanNew Smean Imean Rmean Bmean NSmean Smedian Imedian Rmedian S I R NS SmeanN ImeanN1 RmeanN1 BmeanN1 Snewendmean Snewendstd Rnewendmean Rnewendstd Rnew_nonendmean Rnew_nonendstd propSimsNonEp propSimsNonEp_theoretical...
            numRunsMinor measuredProbMinor numRunsMajor measuredProbMajor meanmdist meannumInfectedVM...
            ] = monteCarloSIRN2(numRuns,numNodes, betan, variantRichness, numTimesteps, plotGraphs,gamma,throwAway,SEpidemic,numExploits,modePar, numLoci, casetype);
   close all; 
   
  %peak time SI
    FinalSizeI = max(Imean,[],2); %mean final size SI
   maska = Imean >= FinalSizeI-1; %when within 1 of the final value
   [C Index] = max(maska);
   PeakTime_udf(j) = Index-modePar.virusStartTime; %T1
   if PeakTime_udf(j) < 0; PeakTime_udf(j)=0; end %check to see if picks an index before the virus start time, must be no outbreak and zero
  %Resistance SI
    ResistanceSI_udf(j) = (numNodes-FinalSizeI)./numNodes; 
    %Resilience SIR
     FinalSize = max(RmeanN1,[],2); %mean final R of epidemics only
    maska = RmeanN1 >= FinalSize-1; %when within 1 of the final value
   [C Index] = max(maska);
   ResTime_udf(j) = Index-modePar.virusStartTime; %T1 
   if ResTime_udf(j) < 0; ResTime_udf(j)=0; end %check to see if picks an index before the virus start time, must be no outbreak and zero
   Resilience_udf(j) = 1./ResTime_udf(j);
   %resistance SIR
   Resistance_udf(j) = (numNodes-FinalSize)./numNodes;
    %VM update Resistance
     ResistanceVM_udf(j) =(numNodes - meannumInfectedVM)./numNodes; %number infected at least once
     %[val index] = min(Imean(modePar.virusStartTime:end)) %time for infected to die away
     maska = Imean(modePar.virusStartTime:end) >= 1; %time when within 1 of zero
    [C indvm] = min(maska); %get index of first zero
     ResilienceTimeVM_udf(j)= indvm-1; %index 1 means timw zero of malware injection so subtract 1
    ResilienceVM_udf(j) = 1./(indvm-1);
     %with vm updates can get rid of those infected to count ended up in S
    %at end
    NumberInSEnd_udf(j) = Smean(end);
  
%data logging
 fprintf(data.logOutput(data.m), '%f,', Imean);     % infection
fprintf(data.logOutput(data.m), '\n'); %new line
fprintf(data.logOutput(data.m), '%f,', ResistanceSI_udf(j)); % resistance SI
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', PeakTime_udf(j)); %peak time
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResTime_udf(j));     %resilience time
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', Resilience_udf(j)); %resilience
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', Resistance_udf(j)); %resistance SIR
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', NumberInSEnd_udf(j));  %with vm updates can get rid of those infected to count ended up in S
fprintf(data.logOutput(data.m), '\n'); %new line 
fprintf(data.logOutput(data.m), '%f,', ResistanceVM_udf(j));  
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResilienceTimeVM_udf(j));  
fprintf(data.logOutput(data.m), '\n'); %new line
 fprintf(data.logOutput(data.m), '%f,', ResilienceVM_udf(j));  
fprintf(data.logOutput(data.m), '\n'); %new line
end %VR
fclose(data.logOutput(data.m));


fileName = [outputDirectory num2str(data.m) 'output.txt']
outFile = fopen(fileName, 'wt');
%1.no constraints 
fprintf(outFile, '%s\n,', 'ResistanceSI'); fprintf(outFile, '%f,', ResistanceSI_noc); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'PeakTime'); fprintf(outFile, '%f,', PeakTime_noc); fprintf(outFile, '\n'); %new line
%2.user desirabilities 84% one variant on each locus, rest spread evenly 
fprintf(outFile, '%s\n,', 'ResistanceSI'); fprintf(outFile, '%f,', ResistanceSI_ud); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'PeakTime'); fprintf(outFile, '%f,', PeakTime_ud); fprintf(outFile, '\n'); %new line
%3.filtering 
fprintf(outFile, '%s\n,', 'ResistanceSI'); fprintf(outFile, '%f,', ResistanceSI_f); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'PeakTime'); fprintf(outFile, '%f,', PeakTime_f); fprintf(outFile, '\n'); %new line
%4.user desirability and filtering
fprintf(outFile, '%s\n,', 'ResistanceSI'); fprintf(outFile, '%f,', ResistanceSI_udf); fprintf(outFile, '\n'); %new line
fprintf(outFile, '%s\n,', 'PeakTime'); fprintf(outFile, '%f,', PeakTime_udf); fprintf(outFile, '\n'); %new line
fclose(outFile);


%peak time SI
figIPeak = figure;
plot(VR,PeakTime_noc, 'k+-','linewidth',2)
hold on
plot(VR,PeakTime_ud, 'ko-','linewidth',2)
plot(VR,PeakTime_f, 'ks-','linewidth',2)
plot(VR,PeakTime_udf, 'k*--','linewidth',2)
xlabel('Variant Richness')
ylabel('Peak Time - SI')
legend('No constraints','User desirability 84%','Filtering','User desirability & filtering')
title('4 loci AND')

%resistance SI
figResistanceSI=figure;
plot(VR,ResistanceSI_noc,'k+-','linewidth',2)
hold on
plot(VR,ResistanceSI_ud,'ko-','linewidth',2)
plot(VR,ResistanceSI_f,'ks-','linewidth',2)
plot(VR,ResistanceSI_udf,'k*--','linewidth',2)
xlabel('Variant Richness')
ylabel('Resistance ')
legend('No constraints','User desirability 84%','Filtering','User desirability & filtering')
title('4 loci AND')

saveas(figResistanceSI,[outputDirectory 'figResistanceSI.fig']);
saveas(figResistanceSI,[outputDirectory 'figResistanceSI.emf']);
saveas(figIPeak,[outputDirectory 'figIPeak.fig']);
saveas(figIPeak,[outputDirectory 'figIPeak.emf']);

%ALL graphs
ResistanceSI_noc
PeakTime_noc
ResistanceSI_ud
PeakTime_ud
ResistanceSI_f
PeakTime_f
ResistanceSI_udf
PeakTime_udf
toc
end %428
end

