%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Jennifer Jackson 2017                                                        %
% A Biodiversity Approach to Cyber Security                                    %
% PhD Complexity Science                                                       %
% University of Warwick                                                        %
% http://wrap.warwick.ac.uk/98458                                              %
% This software is distributed under the  Creative Commons Attribution License %
% https://creativecommons.org/licenses/by/4.0/                                 %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function [ output_args ] = testRandomGenotypesDynamic( input_args )
clear all;
%*************************************
% TESTING AGENT BASED STOCHASIC MODEL -DYNAMIC 
%*************************************
outputDirectory = 'Graphs\'
close all;

doSIRNTests = zeros(1,40) %tests with genotypes

%***************
% SIRN TESTS - with genotypes
%**************
%uses monteCarloSIRN2   - SIR model with dynamic and static genotypes
doSIRNTests(22) = 1 %SI Increase variants upto 8, fix exploit - single locus
%doSIRNTests(23) = 1 %SI fix variants at 8 and increase number of exploits - single locus
%doSIRNTests(24) = 1 %SI AND CASE Increase variants upto 8, fix exploit - 2 loci
%doSIRNTests(25) = 1 %SI AND CASE fix variants at 8 and increase number of exploits - 2 loci
%doSIRNTests(26) = 1 %SI OR CASE Increase variants upto 8, fix exploit - 2 loci
%doSIRNTests(27) = 1 %SI OR CASE fix variants at 8 and increase number of exploits - 2 loci
%doSIRNTests(28) = 1 %SIR Increase variants upto 8, fix exploit - single locus
%doSIRNTests(29) = 1 %SIR fix variants at 8 and increase number of exploits - single locus
%doSIRNTests(30) = 1 %SIR AND CASE Increase variants upto 8, fix exploit - 2 loci
%doSIRNTests(31) = 1 %SIR AND CASE fix variants at 8 and increase number of exploits - 2 loci
%doSIRNTests(32) = 1 %SIR OR CASE Increase variants upto 8, fix exploit - 2 loci
%doSIRNTests(33) = 1 %SIR OR CASE fix variants at 8 and increase number of exploits - 2 loci




%************************
%SIRN TEST 22
%***********************
if doSIRNTests(22) == 1
%Increase variants upto 8, fix exploit
  outputDirectory = 'Graphs\'
%Increase variants upto 8, fix exploit

mode = 'dynamic'
%monte carlo random genotype SIR model
numRuns = 200
%1 genotype
numNodes = 400; betas = 0.02; numGenotypes =  1;  numTimesteps = 10000; plotGraphs = 0; gamma = 0; numExploits=1; numLoci=1; casetype = 'AND'; throwAway = 'nonEpidemics', SEpidemic=400-60;
[fighistRecovered(1) fighistSusceptible(1) fighistpeakValue(1) fighistpeakTime(1) fighistBeta(1) fighistGamma(1) fighistBetanew(1) fighistGammanew(1) figInfectedRun1 figBetaRun1 figGammaRun1 figRoRun1 figBetaGamma1 figBetaGamma2...
            betastd gammastd betastd2 betastdNew betastdNew2 gammastdNew peakTimemean peakTimestd peakValuemean peakValuestd...
            betameanmean(1) gammameanmean betameanmean2(1) betameanmeanNew(1) betameanmeanNew2 gammameanmeanNew(1) Smean(1,:) Imean(1,:) Rmean(1,:) NSmean(1,:) Smedian Imedian Rmedian S I R NS SmeanN ImeanN1 RmeanN1 Snewendmean Snewendstd Rnewendmean(1) Rnewendstd(1) Rnew_nonendmean Rnew_nonendstd propSimsNonEp(1) propSimsNonEp_theoretical(1)...
            ] = monteCarloSIRN2(numRuns,numNodes, betas, numGenotypes, numTimesteps, plotGraphs,gamma,throwAway,SEpidemic,numExploits,mode, numLoci, casetype);
size(ImeanN1)

%2 genotype
numNodes = 400; betas = 0.02; numGenotypes =  2;  numTimesteps = 10000; plotGraphs = 0; gamma = 0; numExploits=2; numLoci=1; casetype = 'AND';
[fighistRecovered(2) fighistSusceptible(2) fighistpeakValue(2) fighistpeakTime(2) fighistBeta(2) fighistGamma(2) fighistBetanew(2) fighistGammanew(2) figInfectedRun1 figBetaRun1 figGammaRun1 figRoRun1 figBetaGamma1 figBetaGamma2...
            betastd gammastd betastd2 betastdNew betastdNew2 gammastdNew peakTimemean peakTimestd peakValuemean peakValuestd...
            betameanmean(2) gammameanmean betameanmean2(2) betameanmeanNew(2) betameanmeanNew2 gammameanmeanNew(2) Smean(2,:) Imean(2,:) Rmean(2,:) NSmean(2,:) Smedian Imedian Rmedian S I R NS SmeanN ImeanN2 RmeanN2 Snewendmean Snewendstd Rnewendmean(2) Rnewendstd(2) Rnew_nonendmean Rnew_nonendstd propSimsNonEp(2) propSimsNonEp_theoretical(2)...
            ] = monteCarloSIRN2(numRuns,numNodes, betas, numGenotypes, numTimesteps, plotGraphs,gamma,throwAway,SEpidemic,numExploits,mode, numLoci, casetype);
size(ImeanN2)

%3 genotype
numNodes = 400; betas = 0.02; numGenotypes =  3;  numTimesteps = 10000; plotGraphs = 0; gamma = 0; numExploits=3; numLoci=1; casetype = 'AND';
[fighistRecovered(3) fighistSusceptible(3) fighistpeakValue(3) fighistpeakTime(3) fighistBeta(3) fighistGamma(3) fighistBetanew(3) fighistGammanew(3) figInfectedRun1 figBetaRun1 figGammaRun1 figRoRun1 figBetaGamma1 figBetaGamma2...
            betastd gammastd betastd2 betastdNew betastdNew2 gammastdNew peakTimemean peakTimestd peakValuemean peakValuestd...
            betameanmean(3) gammameanmean betameanmean2(3) betameanmeanNew(3) betameanmeanNew2 gammameanmeanNew(3) Smean(3,:) Imean(3,:) Rmean(3,:) NSmean(3,:) Smedian Imedian Rmedian S I R NS SmeanN ImeanN3 RmeanN3 Snewendmean Snewendstd Rnewendmean(3) Rnewendstd(3) Rnew_nonendmean Rnew_nonendstd propSimsNonEp(3) propSimsNonEp_theoretical(3)...
            ] = monteCarloSIRN2(numRuns,numNodes, betas, numGenotypes, numTimesteps, plotGraphs,gamma,throwAway,SEpidemic,numExploits,mode, numLoci, casetype);
size(ImeanN3)

%4 genotype
numNodes = 400; betas = 0.02; numGenotypes =  4;  numTimesteps = 10000; plotGraphs = 0; gamma = 0; numExploits=3; numLoci=1; casetype = 'AND';
[fighistRecovered(4) fighistSusceptible(4) fighistpeakValue(4) fighistpeakTime(4) fighistBeta(4) fighistGamma(4) fighistBetanew(4) fighistGammanew(4) figInfectedRun1 figBetaRun1 figGammaRun1 figRoRun1 figBetaGamma1 figBetaGamma2...
            betastd gammastd betastd2 betastdNew betastdNew2 gammastdNew peakTimemean peakTimestd peakValuemean peakValuestd...
            betameanmean(4) gammameanmean betameanmean2(4) betameanmeanNew(4) betameanmeanNew2 gammameanmeanNew(4) Smean(4,:) Imean(4,:) Rmean(4,:) NSmean(4,:) Smedian Imedian Rmedian S I R NS SmeanN ImeanN4 RmeanN4 Snewendmean Snewendstd Rnewendmean(4) Rnewendstd(4) Rnew_nonendmean Rnew_nonendstd propSimsNonEp(4) propSimsNonEp_theoretical(4)...
            ] = monteCarloSIRN2(numRuns,numNodes, betas, numGenotypes, numTimesteps, plotGraphs,gamma,throwAway,SEpidemic,numExploits,mode, numLoci, casetype);
size(ImeanN4)
%5 genotype
numNodes = 400; betas = 0.02; numGenotypes =  5;  numTimesteps = 10000; plotGraphs = 0; gamma = 0; numExploits=3; numLoci=1; casetype = 'AND';
[fighistRecovered(5) fighistSusceptible(5) fighistpeakValue(5) fighistpeakTime(5) fighistBeta(5) fighistGamma(5) fighistBetanew(5) fighistGammanew(5) figInfectedRun1 figBetaRun1 figGammaRun1 figRoRun1 figBetaGamma1 figBetaGamma2...
            betastd gammastd betastd2 betastdNew betastdNew2 gammastdNew peakTimemean peakTimestd peakValuemean peakValuestd...
            betameanmean(5) gammameanmean betameanmean2(5) betameanmeanNew(5) betameanmeanNew2 gammameanmeanNew(5) Smean(5,:) Imean(5,:) Rmean(5,:) NSmean(5,:) Smedian Imedian Rmedian S I R NS SmeanN ImeanN5 RmeanN5 Snewendmean Snewendstd Rnewendmean(5) Rnewendstd(5) Rnew_nonendmean Rnew_nonendstd propSimsNonEp(5) propSimsNonEp_theoretical(5)...
            ] = monteCarloSIRN2(numRuns,numNodes, betas, numGenotypes, numTimesteps, plotGraphs,gamma,throwAway,SEpidemic,numExploits,mode, numLoci, casetype);
size(ImeanN5)
%6 genotype
numNodes = 400; betas = 0.02; numGenotypes =  6;  numTimesteps = 10000; plotGraphs = 0; gamma = 0; numExploits=3; numLoci=1; casetype = 'AND';
[fighistRecovered(6) fighistSusceptible(6) fighistpeakValue(6) fighistpeakTime(6) fighistBeta(6) fighistGamma(6) fighistBetanew(6) fighistGammanew(6) figInfectedRun1 figBetaRun1 figGammaRun1 figRoRun1 figBetaGamma1 figBetaGamma2...
            betastd gammastd betastd2 betastdNew betastdNew2 gammastdNew peakTimemean peakTimestd peakValuemean peakValuestd...
            betameanmean(6) gammameanmean betameanmean2(6) betameanmeanNew(6) betameanmeanNew2 gammameanmeanNew(6) Smean(6,:) Imean(6,:) Rmean(6,:) NSmean(6,:) Smedian Imedian Rmedian S I R NS SmeanN ImeanN6 RmeanN6 Snewendmean Snewendstd Rnewendmean(6) Rnewendstd(6) Rnew_nonendmean Rnew_nonendstd propSimsNonEp(6) propSimsNonEp_theoretical(6)...
            ] = monteCarloSIRN2(numRuns,numNodes, betas, numGenotypes, numTimesteps, plotGraphs,gamma,throwAway,SEpidemic,numExploits,mode, numLoci, casetype);
size(ImeanN6)
%7 genotype
numNodes = 400; betas = 0.02; numGenotypes =  7;  numTimesteps = 10000; plotGraphs = 0; gamma = 0; numExploits=3; numLoci=1; casetype = 'AND';
[fighistRecovered(7) fighistSusceptible(7) fighistpeakValue(7) fighistpeakTime(7) fighistBeta(7) fighistGamma(7) fighistBetanew(7) fighistGammanew(7) figInfectedRun1 figBetaRun1 figGammaRun1 figRoRun1 figBetaGamma1 figBetaGamma2...
            betastd gammastd betastd2 betastdNew betastdNew2 gammastdNew peakTimemean peakTimestd peakValuemean peakValuestd...
            betameanmean(7) gammameanmean betameanmean2(7) betameanmeanNew(7) betameanmeanNew2 gammameanmeanNew(7) Smean(7,:) Imean(7,:) Rmean(7,:) NSmean(7,:) Smedian Imedian Rmedian S I R NS SmeanN ImeanN7 RmeanN7 Snewendmean Snewendstd Rnewendmean(7) Rnewendstd(7) Rnew_nonendmean Rnew_nonendstd propSimsNonEp(7) propSimsNonEp_theoretical(7)...
            ] = monteCarloSIRN2(numRuns,numNodes, betas, numGenotypes, numTimesteps, plotGraphs,gamma,throwAway,SEpidemic,numExploits,mode, numLoci, casetype);
size(ImeanN7)
%8 genotype
numNodes = 400; betas = 0.02; numGenotypes =  8;  numTimesteps = 10000; plotGraphs = 0; gamma = 0; numExploits=3; numLoci=1; casetype = 'AND';
[fighistRecovered(8) fighistSusceptible(8) fighistpeakValue(8) fighistpeakTime(8) fighistBeta(8) fighistGamma(8) fighistBetanew(8) fighistGammanew(8) figInfectedRun1 figBetaRun1 figGammaRun1 figRoRun1 figBetaGamma1 figBetaGamma2...
            betastd gammastd betastd2 betastdNew betastdNew2 gammastdNew peakTimemean peakTimestd peakValuemean peakValuestd...
            betameanmean(8) gammameanmean betameanmean2(8) betameanmeanNew(8) betameanmeanNew2 gammameanmeanNew(8) Smean(8,:) Imean(8,:) Rmean(8,:) NSmean(8,:) Smedian Imedian Rmedian S I R NS SmeanN ImeanN8 RmeanN8 Snewendmean Snewendstd Rnewendmean(8) Rnewendstd(8) Rnew_nonendmean Rnew_nonendstd propSimsNonEp(8) propSimsNonEp_theoretical(8)...
            ] = monteCarloSIRN2(numRuns,numNodes, betas, numGenotypes, numTimesteps, plotGraphs,gamma,throwAway,SEpidemic,numExploits,mode, numLoci, casetype);
size(ImeanN8)
%Deterministic STATIC SI model
%N=400; Vmax = 1:8; V=[1 1 1 1 1 1 1 1];%fixed exploited 
N=400; Vmax = 1:8; V=[1 2 3 3 3 3 3 3];%fixed exploited - can't have more exploits than genotypes for 1st case
Sprop = V./Vmax; S = N.*Sprop; B = 0.02; beta = B.*Sprop; gamma = 0;
for i = 1:8
    [Ro(i) St(i,:) It(i,:) Rt(i,:)] = SIRDeterministic(beta(i), gamma, S(i), 1, 0, numTimesteps, 0); 
end
dec = 50; t2 = 1:dec:numTimesteps; 


%Deterministic DYNAMIC SI model
%N=400; Vmax = 1:8; V=[1 1 1 1 1 1 1 1]%fixed exploited - can't have more exploits than genotypes for 1st case
N=400; Vmax = 1:8; V=[1 2 3 3 3 3 3 3]%fixed exploited - can't have more exploits than genotypes for 1st case
Sprop = V./Vmax; S = N; B = 0.02; beta = B.*Sprop.*Sprop; gamma = 0;
for i = 1:8
    [RoD(i) StD(i,:) ItD(i,:) RtD(i,:)] = SIRDeterministic(beta(i), gamma, S, 1, 0, numTimesteps, 0); 
end
dec = 50; t2 = 1:dec:numTimesteps; 


betameanmeanD=betameanmean
 figTest9beta0_02 = figure
 plot(betameanmean,'k')
 hold on
 plot(beta,'k.-')
 ylabel('beta')
 xlabel('Number of variants')
 %title('b) SI-Increasing variants on 1 locus - ')
 title('b) SI-Increasing variants: Infection rate')
 legend('Agent(measured)', 'Deterministic')
 
 betameanmean2D=betameanmean2
 figTest9beta20_02 = figure
 plot(betameanmean2,'k')
 hold on
 plot(beta,'k.-')
 ylabel('beta')
 xlabel('Number of variants')
 %title('b) SI-Increasing variants on 1 locus - ')
 title('b) SI-Increasing variants: Infection rate - 2')
 legend('Agent(measured)', 'Deterministic')
 
 c = ['r', 'm', 'g', 'y','c', 'g', 'r', 'm']
 figTest9inf0_02 = figure
 for i = 1:8
     plot(Imean(i,:),'k')
     hold on
     plot(t2,It(i,1:dec:end),'k.-')
 %    plot(t2,ItD(i,1:dec:end),'k+-')
      plot(t2,ItD(i,1:dec:end),c(i))
      % plot(t2,ItD2(i,1:dec:end),'b+-') %V only at top of equ. not V^2
 end
 ylabel('Number of nodes infected - It')
 xlabel('Timesteps')
 title('a) SI-Increasing variants: Nodes infected')
 legend('Agent DYNAMIC', 'Deterministic STATIC', 'Deterministic DYNAMIC')
 %axis([0 1000 0 100])
 
 %number of nodes infected
 figTest2FinalInfected = figure
 agentImax = max(Imean,[],2);
 plot(agentImax,'k')
 hold on
 plot(S,'k.-')
 ylabel('Final number infected')
 xlabel('Number of variants')
 title('c) SI-Increasing variants: Final size')
 legend('Agent', 'Deterministic')
 
saveas(figTest9beta0_02,[outputDirectory 'Test22beta0_02.fig']);
saveas(figTest9beta0_02,[outputDirectory 'Test22beta0_02.emf']);
saveas(figTest9beta20_02,[outputDirectory 'Test22beta0_02.fig']);
saveas(figTest9beta20_02,[outputDirectory 'Test22beta0_02.emf']);
saveas(figTest9inf0_02,[outputDirectory 'Test22inf0_02.fig']);
saveas(figTest9inf0_02,[outputDirectory 'Test22inf0_02.emf']); 
saveas(figTest2FinalInfected,[outputDirectory 'Test22FinalInfected.fig']);
saveas(figTest2FinalInfected,[outputDirectory 'Test22FinalInfected.emf']); 

 %close all;
end %SIRN test 22
end

