%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Jennifer Jackson 2017                                                        %
% A Biodiversity Approach to Cyber Security                                    %
% PhD Complexity Science                                                       %
% University of Warwick                                                        %
% http://wrap.warwick.ac.uk/98458                                              %
% This software is distributed under the  Creative Commons Attribution License %
% https://creativecommons.org/licenses/by/4.0/                                 %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function [ output_args ] = testRandomGenotypesSI( input_args )

clear all;
%*************************************
% TESTING AGENT BASED MODEL - SI TESTS ONLY
%*************************************
close all;

%new parameters
modePar.blklistStartTime = 1
%vmupdate mode
modePar.vm = 'no' %yes or no
modePar.desirabilities = 'no' %include desirability constraints
modePar.filter = 'no' %include sw filtering
modePar.netStr = 're'; %'rwp' random waypoint 're' random encounter
modePar.areaConstrainrwp='no'
modePar.virusStartTime=1;

doSIRNTests = zeros(1,30) %tests with genotypes
%mode - can be 'static' or 'dynamic' 'Dynamic-random' 'Dynamic-favScore'
%doSIRNTests(21) = 1 %SIR 1 locus dynamic
%doSIRNTests(22) = 1 %SIR 1 locus dynamic with blacklisting
%doSIRNTests(23) = 1 %blacklisting varied for VR=5, 1 locus
%doSIRNTests(30)=1 %testing stop update process
%doSIRNTests(31)=1 %vary VR and measure peak infection time and do Infected graph

%doSIRNTests(32) = 1 %blacklisting relationship at static diversity
%doSIRNTests(33) = 1 %blacklisting and vm update relationship at static diversity
%doSIRNTests(34) = 1 %recovery
doSIRNTests(35) = 1 %combine data and graph


%**********************************************************
if doSIRNTests(34) == 1
    data.m=34
%1 locus model
%outputDirectory = 'Graphs\'
outputDirectory = 'Graphs\'
%***************************************
%recovery only - 1 locus model
%7.dynamic diversity with blacklisting - different blacklisting rates
%***************************************
numRuns = 20 %10 %100 %200
numTimesteps= 10000 %10000
numNodes = 1000 %1000;
%variantRichness = 5 ;%1
variantRichnessX = [2 3 4 5] ;%1
%variantRichnessX = [2 5] ;%1
blklistrate=[0.0001 0.0002 0.0005 0.0007 0.001 0.002 0.003 0.004 0.005 0.006 0.007 0.008 0.0100 0.0200]
recoveryX=[0.0001 0.0002 0.0005 0.0007 0.001 0.002 0.003 0.004 0.005 0.006 0.007 0.008 0.0100 0.0200]
%recoveryX=[0.001]
modePar.numToBlklist = 1
dec = 10%100 %decimation of output data
modePar.numToConstrain = 0; %constain a number of nodes to 1 variant
modePar.stopUpdatingTime = 2 %200000; %time at which to stop updating the genotypes
modePar.numEncountersBetweenUpdates = 1; % number of encounters between updates for random and favscore algorithms
modePar.bufferlength = 10; %length of genotype buffer for favscore algorithm
modePar.genoInit = 'maxdiv';  %initial conditions of genotypes maxdiv (maximum diversity - random variant chosen) mindiv (minimum diversity - all nodes same)
modePar.blklist = 'no'; %yes or no
modePar.vm = 'no' %yes or no
mode = 'dynamic'; %mode - can be 'static' or 'dynamic' 'Dynamic-random' 'Dynamic-favScore'
modePar.modeStr = mode;
betan = 0.02;
tic
%*****************************************************
%7.dynamic diversity with blacklisting
runSim=1;
if runSim==1
    %data logging of output
data.logDir = sprintf('%s\\outputdata', pwd)
s = sprintf('%s\\dataSI%i.txt', data.logDir,data.m)
data.logOutput(data.m) = fopen(s, 'wt');
for j= 1:size(variantRichnessX,2)
    variantRichness=variantRichnessX(j);
 %ifig=   figure %VR=5 Imean
 %divfig = figure
for z= 1:size(recoveryX,2)
 modePar.blklistrate = blklistrate(z) 
 gamma = recoveryX(z);
   plotGraphs = 1;  numExploits=1; numLoci=1; casetype = 'OR'; throwAway = 'nonEpidemics'; SEpidemic=60; %cutoff;
%agent
 [figMeanNei figNeiOneRun fighistSpRun fighistRecovered fighistSusceptible fighistpeakValue fighistpeakTime fighistBeta fighistGamma fighistBetanew fighistGammanew figInfectedRun1 figBetaRun1 figGammaRun1 figRoRun1 figBetaGamma1 figAllRuns...
            meanNeiIndexDynamicF  betastd gammastd betastd2 betastdNew betastdNew2 gammastdNew peakTimemean peakTimestd peakValuemean peakValuestd...
            betameanmean gammameanmean betameanmean2 betameanmeanNew betameanmeanNew2 gammameanmeanNew Smean Imean Rmean Bmean NSmean Smedian Imedian Rmedian S I R NS SmeanN1 ImeanN1 RmeanN1 BmeanN1 Snewendmean Snewendstd Rnewendmean Rnewendstd Rnew_nonendmean Rnew_nonendstd propSimsNonEp propSimsNonEp_theoretical...
            numRunsMinor measuredProbMinor numRunsMajor measuredProbMajor meanmdist meannumInfectedVM...
            ] = monteCarloSIRN2(numRuns,numNodes, betan, variantRichness, numTimesteps, plotGraphs,gamma,throwAway,SEpidemic,numExploits,modePar, numLoci, casetype);

        outputDi = [outputDirectory 'test' num2str(j) num2str(z)];
           saveas(figAllRuns,[outputDi 'figAllRuns.fig']);
        
%FinalSize(j,z) = max(Imean,[],2); %blacklisting
%FinalSize(j,z) = meannumInfectedVM %blacklisting with vm
FinalSize(j,z) = min(SmeanN1,[],2); %recovery major outbreak - number left at end
    %time
%     maska = Imean >= FinalSize(z)-1; %when within 1 of the final value
%    [C Index] = max(maska);
%    TimeDynamic(z) = Index; %T1
%    ImeanDynamic(z,:)=Imean(1:dec:end);
%    SmeanDynamic(z,:)=Smean(1:dec:end);
%    RmeanDynamic(z,:)=Rmean(1:dec:end);
%    BmeanDynamic(z,:)=Bmean(1:dec:end);
%close(fighistSpRun); close(fighistRecovered); close(fighistSusceptible); close(fighistpeakValue); close(fighistpeakTime);
%close(fighistBeta); close(fighistGamma); close(fighistBetanew); close(fighistGammanew); 
%close(figInfectedRun1);%close(figBetaRun1); %close(figGammaRun1); %close(figRoRun1); %close(figBetaGamma1); %close(figBetaGamma2); 
close all;
    text = ['done blklistrate ' num2str(z) ' out of ' num2str(size(blklistrate,2))];
    disp(text) 
    text = ['done vr ' num2str(j) ' out of ' num2str(size(variantRichnessX,2))];
    disp(text)   
disp('done dynamic and blacklisting')
toc

time = 1:dec:numTimesteps;

%GRAPHS
%All
%figure(ifig) %VR=5 Imean
%plot(time,Imean(1:dec:end),'k', 'Linewidth', 2) %dynamic diversity and blacklisting
%hold on
%plot(time,ImeanDynamic(2,:),'k', 'Linewidth', 2) %dynamic diversity and blacklisting
%plot(time,ImeanDynamic(3,:),'k--', 'Linewidth', 2) %dynamic diversity and blacklisting
%plot(time,ImeanDynamic(4,:),'k', 'Linewidth', 2) %dynamic diversity and blacklisting
%plot(time,ImeanDynamic(5,:),'k.-', 'Linewidth', 2) 
%plot(time,ImeanDynamic(6,:),'k.-', 'Linewidth', 2) 
%plot(time,ImeanDynamic(7,:),'k.-', 'Linewidth', 2) 
%plot(time,ImeanDynamic(8,:),'r') 
%plot(time,ImeanDynamic(9,:),'r--') 
%plot(time,ImeanDynamic(10,:),'r--') 
%plot(time,ImeanDynamic(11,:),'r--') 
%plot(time,ImeanDynamic(12,:),'r--') 
%plot(time,ImeanDynamic(13,:),'r--') 
%plot(time,ImeanDynamic(14,:),'r--') 
%legend('0.0001','0.0002','0.0005','0.0007','0.001','0.002','0.003','0.004','0.005','0.006','0.007','0.008','0.0100','0.0200') 
%xlabel('Time (seconds)')
%ylabel('Size of Epidemic - All')

%figure (divfig)
%plot(time,meanNeiIndexDynamicF(1:dec:end),'k', 'Linewidth', 2)
%hold on
%xlabel('Time (seconds)')
%ylabel('Variant diversity')
end
fprintf(data.logOutput(data.m), '%f,', FinalSize(j,:));     % infection
fprintf(data.logOutput(data.m), '\n'); %new line
end
end %runSim

%close data logger
fclose(data.logOutput(data.m));

bs = SPExact1LociOR( 1, [1:5] ).*betan %100% resistance   0.0200    0.0100    0.0067    0.0050    0.0040

%ResSim = (numNodes-FinalSize)/numNodes %resistance of sim
ResSim = (FinalSize)/numNodes %resistance of sim

figure
%continuous update
plot(recoveryX,FinalSVR5(1:size(recoveryX,2)),'ko-')
hold on
plot(recoveryX,FinalSVR4(1:size(recoveryX,2)),'k+-')
plot(recoveryX,FinalSVR3(1:size(recoveryX,2)),'ks-')
plot(recoveryX,FinalSVR2(1:size(recoveryX,2)),'k--')
%blacklisting
plot(recoveryX,ResSim_blk5(1,1:size(recoveryX,2)),'ro-', 'Linewidth', 2) %VR=5 simulated
plot(recoveryX,ResSim_blk4(1,1:size(recoveryX,2)),'r+-', 'Linewidth', 2) %VR=4 simulated
plot(recoveryX,ResSim_blk3(1,1:size(recoveryX,2)),'rs-', 'Linewidth', 2) %VR=3 simulated
plot(recoveryX,ResSim_blk2(1,1:size(recoveryX,2)),'r--', 'Linewidth', 2) %VR=2 simulated
%blacklisting and vm update
plot(recoveryX,ResSim_blkvm5(1,1:size(recoveryX,2)),'bo-', 'Linewidth', 2) %VR=5 simulated
plot(recoveryX,ResSim_blkvm4(1,1:size(recoveryX,2)),'b+-', 'Linewidth', 2) %VR=4 simulated
plot(recoveryX,ResSim_blkvm3(1,1:size(recoveryX,2)),'bs-', 'Linewidth', 2) %VR=3 simulated
plot(recoveryX,ResSim_blkvm2(1,1:size(recoveryX,2)),'b--', 'Linewidth', 2) %VR=2 simulated
%recovery only
plot(recoveryX,ResSim(4,1:size(recoveryX,2)),'go-', 'Linewidth', 2) %VR=5 simulated
plot(recoveryX,ResSim(3,1:size(recoveryX,2)),'g+-', 'Linewidth', 2) %VR=4 simulated
plot(recoveryX,ResSim(2,1:size(recoveryX,2)),'gs-', 'Linewidth', 2) %VR=3 simulated
plot(recoveryX,ResSim(1,1:size(recoveryX,2)),'g--', 'Linewidth', 2) %VR=2 simulated

for f = 1:5
plot([bs(f) bs(f)],[0 1],'k--')
end
xlabel('blacklisting rate')
ylabel('Resistance')
legend('VR=5','VR=4','VR=3','VR=2')



toc
clock
end %test34

%**********************************************************
if doSIRNTests(33) == 1
    data.m=33
%1 locus model
%outputDirectory = 'randomGenotypesGraphs\' %BUMBLEBEE
outputDirectory = 'Graphs\'
%***************************************
%blacklisting - 1 locus model
%7.dynamic diversity with blacklisting - different blacklisting rates
%***************************************
numRuns = 20 %10 %100 %200
numTimesteps= 25000 %10000
numNodes = 1000 %1000;
%variantRichness = 5 ;%1
variantRichnessX = [2 3 4 5] ;%1
blklistrate=[0.0001 0.0002 0.0005 0.0007 0.001 0.002 0.003 0.004 0.005 0.006 0.007 0.008 0.0100 0.0200]
%blklistrate=[0.0001 0.0002 0.0005 0.0007 0.001 0.002 0.003 0.004 0.005]
modePar.numToBlklist = 1
dec = 10%100 %decimation of output data
modePar.numToConstrain = 0; %constain a number of nodes to 1 variant
modePar.stopUpdatingTime = 2 %200000; %time at which to stop updating the genotypes
modePar.numEncountersBetweenUpdates = 1; % number of encounters between updates for random and favscore algorithms
modePar.bufferlength = 10; %length of genotype buffer for favscore algorithm
modePar.genoInit = 'maxdiv';  %initial conditions of genotypes maxdiv (maximum diversity - random variant chosen) mindiv (minimum diversity - all nodes same)
modePar.blklist = 'yes'; %yes or no
modePar.vm = 'yes' %yes or no
mode = 'dynamic'; %mode - can be 'static' or 'dynamic' 'Dynamic-random' 'Dynamic-favScore'
modePar.modeStr = mode;
betan = 0.02;
tic
%*****************************************************
%7.dynamic diversity with blacklisting
runSim=1;
if runSim==1
    %data logging of output
data.logDir = sprintf('%s\\outputdata', pwd)
s = sprintf('%s\\dataSI%i.txt', data.logDir,data.m)
data.logOutput(data.m) = fopen(s, 'wt');
for j= 1:size(variantRichnessX,2)
    variantRichness=variantRichnessX(j);
 %ifig=   figure %VR=5 Imean
 %divfig = figure
for z= 1:size(blklistrate,2)
 modePar.blklistrate = blklistrate(z)  
   plotGraphs = 1; gamma = 0; numExploits=1; numLoci=1; casetype = 'OR'; throwAway = 'nonEpidemics'; SEpidemic=60; %cutoff;
%agent
 [figMeanNei figNeiOneRun fighistSpRun fighistRecovered fighistSusceptible fighistpeakValue fighistpeakTime fighistBeta fighistGamma fighistBetanew fighistGammanew figInfectedRun1 figBetaRun1 figGammaRun1 figRoRun1 figBetaGamma1 figBetaGamma2...
            meanNeiIndexDynamicF  betastd gammastd betastd2 betastdNew betastdNew2 gammastdNew peakTimemean peakTimestd peakValuemean peakValuestd...
            betameanmean gammameanmean betameanmean2 betameanmeanNew betameanmeanNew2 gammameanmeanNew Smean Imean Rmean Bmean NSmean Smedian Imedian Rmedian S I R NS SmeanN1 ImeanN1 RmeanN1 BmeanN1 Snewendmean Snewendstd Rnewendmean Rnewendstd Rnew_nonendmean Rnew_nonendstd propSimsNonEp propSimsNonEp_theoretical...
            numRunsMinor measuredProbMinor numRunsMajor measuredProbMajor meanmdist meannumInfectedVM...
            ] = monteCarloSIRN2(numRuns,numNodes, betan, variantRichness, numTimesteps, plotGraphs,gamma,throwAway,SEpidemic,numExploits,modePar, numLoci, casetype);
%FinalSize(j,z) = max(Imean,[],2); %blacklisting
FinalSize(j,z) = meannumInfectedVM %blacklisting with vm

    %time
%     maska = Imean >= FinalSize(z)-1; %when within 1 of the final value
%    [C Index] = max(maska);
%    TimeDynamic(z) = Index; %T1
%    ImeanDynamic(z,:)=Imean(1:dec:end);
%    SmeanDynamic(z,:)=Smean(1:dec:end);
%    RmeanDynamic(z,:)=Rmean(1:dec:end);
%    BmeanDynamic(z,:)=Bmean(1:dec:end);
%close(fighistSpRun); close(fighistRecovered); close(fighistSusceptible); close(fighistpeakValue); close(fighistpeakTime);
%close(fighistBeta); close(fighistGamma); close(fighistBetanew); close(fighistGammanew); 
%close(figInfectedRun1);%close(figBetaRun1); %close(figGammaRun1); %close(figRoRun1); %close(figBetaGamma1); %close(figBetaGamma2); 
close all;
    text = ['done blklistrate ' num2str(z) ' out of ' num2str(size(blklistrate,2))];
    disp(text) 
    text = ['done vr ' num2str(j) ' out of ' num2str(size(variantRichnessX,2))];
    disp(text)   
disp('done dynamic and blacklisting')
toc

time = 1:dec:numTimesteps;

%GRAPHS
%All
%figure(ifig) %VR=5 Imean
%plot(time,Imean(1:dec:end),'k', 'Linewidth', 2) %dynamic diversity and blacklisting
%hold on
%plot(time,ImeanDynamic(2,:),'k', 'Linewidth', 2) %dynamic diversity and blacklisting
%plot(time,ImeanDynamic(3,:),'k--', 'Linewidth', 2) %dynamic diversity and blacklisting
%plot(time,ImeanDynamic(4,:),'k', 'Linewidth', 2) %dynamic diversity and blacklisting
%plot(time,ImeanDynamic(5,:),'k.-', 'Linewidth', 2) 
%plot(time,ImeanDynamic(6,:),'k.-', 'Linewidth', 2) 
%plot(time,ImeanDynamic(7,:),'k.-', 'Linewidth', 2) 
%plot(time,ImeanDynamic(8,:),'r') 
%plot(time,ImeanDynamic(9,:),'r--') 
%plot(time,ImeanDynamic(10,:),'r--') 
%plot(time,ImeanDynamic(11,:),'r--') 
%plot(time,ImeanDynamic(12,:),'r--') 
%plot(time,ImeanDynamic(13,:),'r--') 
%plot(time,ImeanDynamic(14,:),'r--') 
%legend('0.0001','0.0002','0.0005','0.0007','0.001','0.002','0.003','0.004','0.005','0.006','0.007','0.008','0.0100','0.0200') 
%xlabel('Time (seconds)')
%ylabel('Size of Epidemic - All')

%figure (divfig)
%plot(time,meanNeiIndexDynamicF(1:dec:end),'k', 'Linewidth', 2)
%hold on
%xlabel('Time (seconds)')
%ylabel('Variant diversity')
end
fprintf(data.logOutput(data.m), '%f,', FinalSize(j,:));     % infection
fprintf(data.logOutput(data.m), '\n'); %new line
end
end %runSim

%close data logger
fclose(data.logOutput(data.m));

bs = SPExact1LociOR( 1, [1:5] ).*betan %100% resistance   0.0200    0.0100    0.0067    0.0050    0.0040

ResSim = (numNodes-FinalSize)/numNodes %resistance of sim

figure
%continuous update
plot(blklistrate,FinalSVR5(1:size(blklistrate,2)),'ko-')
hold on
plot(blklistrate,FinalSVR4(1:size(blklistrate,2)),'k+-')
plot(blklistrate,FinalSVR3(1:size(blklistrate,2)),'ks-')
plot(blklistrate,FinalSVR2(1:size(blklistrate,2)),'k--')
%blacklisting
plot(blklistrate,ResSim_blk5(1,1:size(blklistrate,2)),'ro-', 'Linewidth', 2) %VR=5 simulated
plot(blklistrate,ResSim_blk4(1,1:size(blklistrate,2)),'r+-', 'Linewidth', 2) %VR=4 simulated
plot(blklistrate,ResSim_blk3(1,1:size(blklistrate,2)),'rs-', 'Linewidth', 2) %VR=3 simulated
plot(blklistrate,ResSim_blk2(1,1:size(blklistrate,2)),'r--', 'Linewidth', 2) %VR=2 simulated
%blacklisting and vm update
plot(blklistrate,ResSim_blkvm5(1,1:size(blklistrate,2)),'bo-', 'Linewidth', 2) %VR=5 simulated
plot(blklistrate,ResSim_blkvm4(1,1:size(blklistrate,2)),'b+-', 'Linewidth', 2) %VR=4 simulated
plot(blklistrate,ResSim_blkvm3(1,1:size(blklistrate,2)),'bs-', 'Linewidth', 2) %VR=3 simulated
plot(blklistrate,ResSim_blkvm2(1,1:size(blklistrate,2)),'b--', 'Linewidth', 2) %VR=2 simulated
%recovery only
plot(blklistrate,ResSim(4,1:size(blklistrate,2)),'go-', 'Linewidth', 2) %VR=5 simulated
plot(blklistrate,ResSim(3,1:size(blklistrate,2)),'g+-', 'Linewidth', 2) %VR=4 simulated
plot(blklistrate,ResSim(2,1:size(blklistrate,2)),'gs-', 'Linewidth', 2) %VR=3 simulated
plot(blklistrate,ResSim(1,1:size(blklistrate,2)),'g--', 'Linewidth', 2) %VR=2 simulated

for f = 1:5
plot([bs(f) bs(f)],[0 1],'k--')
end
xlabel('blacklisting rate')
ylabel('Resistance')
legend('VR=5','VR=4','VR=3','VR=2')



toc
clock
end %test33


%**********************************************************
if doSIRNTests(32) == 1
%1 locus model
%outputDirectory = 'randomGenotypesGraphs\' %
outputDirectory = 'Graphs\'
%***************************************
%blacklisting - 1 locus model
%7.dynamic diversity with blacklisting - different blacklisting rates
%***************************************
numRuns = 20 %10 %100 %200
numTimesteps= 4000 %10000
numNodes = 1000 %1000;
%variantRichness = 5 ;%1
variantRichnessX = [2 3 4 5] ;%1
blklistrate=[0.0001 0.0002 0.0005 0.0007 0.001 0.002 0.003 0.004 0.005 0.006 0.007 0.008 0.0100 0.0200]
%blklistrate=[0.0001 0.0002 0.0005 0.0007 0.001 0.002 0.003 0.004 0.005]
modePar.numToBlklist = 1
dec = 10%100 %decimation of output data
modePar.numToConstrain = 0; %constain a number of nodes to 1 variant
modePar.stopUpdatingTime = 2 %200000; %time at which to stop updating the genotypes
modePar.numEncountersBetweenUpdates = 1; % number of encounters between updates for random and favscore algorithms
modePar.bufferlength = 10; %length of genotype buffer for favscore algorithm
modePar.genoInit = 'maxdiv';  %initial conditions of genotypes maxdiv (maximum diversity - random variant chosen) mindiv (minimum diversity - all nodes same)
modePar.blklist = 'yes'; %yes or no
modePar.vm = 'no' %yes or no
mode = 'dynamic'; %mode - can be 'static' or 'dynamic' 'Dynamic-random' 'Dynamic-favScore'
modePar.modeStr = mode;
betan = 0.02;
tic
%*****************************************************
%7.dynamic diversity with blacklisting
runSim=1;
if runSim==1
for j= 1:size(variantRichnessX,2)
    variantRichness=variantRichnessX(j);
 %ifig=   figure %VR=5 Imean
 %divfig = figure
for z= 1:size(blklistrate,2)
 modePar.blklistrate = blklistrate(z)  
   plotGraphs = 1; gamma = 0; numExploits=1; numLoci=1; casetype = 'OR'; throwAway = 'nonEpidemics'; SEpidemic=60; %cutoff;
%agent
 [figMeanNei figNeiOneRun fighistSpRun fighistRecovered fighistSusceptible fighistpeakValue fighistpeakTime fighistBeta fighistGamma fighistBetanew fighistGammanew figInfectedRun1 figBetaRun1 figGammaRun1 figRoRun1 figBetaGamma1 figBetaGamma2...
            meanNeiIndexDynamicF  betastd gammastd betastd2 betastdNew betastdNew2 gammastdNew peakTimemean peakTimestd peakValuemean peakValuestd...
            betameanmean gammameanmean betameanmean2 betameanmeanNew betameanmeanNew2 gammameanmeanNew Smean Imean Rmean Bmean NSmean Smedian Imedian Rmedian S I R NS SmeanN1 ImeanN1 RmeanN1 BmeanN1 Snewendmean Snewendstd Rnewendmean Rnewendstd Rnew_nonendmean Rnew_nonendstd propSimsNonEp propSimsNonEp_theoretical...
            numRunsMinor measuredProbMinor numRunsMajor measuredProbMajor meanmdist meannumInfectedVM...
            ] = monteCarloSIRN2(numRuns,numNodes, betan, variantRichness, numTimesteps, plotGraphs,gamma,throwAway,SEpidemic,numExploits,modePar, numLoci, casetype);
FinalSize(j,z) = max(Imean,[],2); %mean final size SI
    %time
%     maska = Imean >= FinalSize(z)-1; %when within 1 of the final value
%    [C Index] = max(maska);
%    TimeDynamic(z) = Index; %T1
%    ImeanDynamic(z,:)=Imean(1:dec:end);
%    SmeanDynamic(z,:)=Smean(1:dec:end);
%    RmeanDynamic(z,:)=Rmean(1:dec:end);
%    BmeanDynamic(z,:)=Bmean(1:dec:end);
%close(fighistSpRun); close(fighistRecovered); close(fighistSusceptible); close(fighistpeakValue); close(fighistpeakTime);
%close(fighistBeta); close(fighistGamma); close(fighistBetanew); close(fighistGammanew); 
%close(figInfectedRun1);%close(figBetaRun1); %close(figGammaRun1); %close(figRoRun1); %close(figBetaGamma1); %close(figBetaGamma2); 
close all;
    text = ['done ' num2str(z) ' out of ' num2str(9)];
    disp(text)   
disp('done dynamic and blacklisting')
toc

time = 1:dec:numTimesteps;

%GRAPHS
%All
%figure(ifig) %VR=5 Imean
%plot(time,Imean(1:dec:end),'k', 'Linewidth', 2) %dynamic diversity and blacklisting
%hold on
%plot(time,ImeanDynamic(2,:),'k', 'Linewidth', 2) %dynamic diversity and blacklisting
%plot(time,ImeanDynamic(3,:),'k--', 'Linewidth', 2) %dynamic diversity and blacklisting
%plot(time,ImeanDynamic(4,:),'k', 'Linewidth', 2) %dynamic diversity and blacklisting
%plot(time,ImeanDynamic(5,:),'k.-', 'Linewidth', 2) 
%plot(time,ImeanDynamic(6,:),'k.-', 'Linewidth', 2) 
%plot(time,ImeanDynamic(7,:),'k.-', 'Linewidth', 2) 
%plot(time,ImeanDynamic(8,:),'r') 
%plot(time,ImeanDynamic(9,:),'r--') 
%plot(time,ImeanDynamic(10,:),'r--') 
%plot(time,ImeanDynamic(11,:),'r--') 
%plot(time,ImeanDynamic(12,:),'r--') 
%plot(time,ImeanDynamic(13,:),'r--') 
%plot(time,ImeanDynamic(14,:),'r--') 
%legend('0.0001','0.0002','0.0005','0.0007','0.001','0.002','0.003','0.004','0.005','0.006','0.007','0.008','0.0100','0.0200') 
%xlabel('Time (seconds)')
%ylabel('Size of Epidemic - All')

%figure (divfig)
%plot(time,meanNeiIndexDynamicF(1:dec:end),'k', 'Linewidth', 2)
%hold on
%xlabel('Time (seconds)')
%ylabel('Variant diversity')
end
end
end %runSim

bs = SPExact1LociOR( 1, [1:5] ).*betan %100% resistance   0.0200    0.0100    0.0067    0.0050    0.0040

ResSim = (numNodes-FinalSize)/numNodes %resistance of sim

figure
plot(blklistrate,FinalSVR5(1:size(blklistrate,2)),'ko-')
hold on
plot(blklistrate,FinalSVR4(1:size(blklistrate,2)),'k+-')
plot(blklistrate,FinalSVR3(1:size(blklistrate,2)),'ks-')
plot(blklistrate,FinalSVR2(1:size(blklistrate,2)),'k--')
plot(blklistrate,ResSim(4,1:size(blklistrate,2)),'ro-', 'Linewidth', 2) %VR=5 simulated
plot(blklistrate,ResSim(3,1:size(blklistrate,2)),'r+-', 'Linewidth', 2) %VR=4 simulated
plot(blklistrate,ResSim(2,1:size(blklistrate,2)),'rs-', 'Linewidth', 2) %VR=3 simulated
plot(blklistrate,ResSim(1,1:size(blklistrate,2)),'r--', 'Linewidth', 2) %VR=2 simulated

for f = 1:5
plot([bs(f) bs(f)],[0 1],'k--')
end
xlabel('blacklisting rate')
ylabel('Resistance')
legend('VR=5','VR=4','VR=3','VR=2')



toc
clock
end %test32


if doSIRNTests(31) == 1
%1 locus model
%outputDirectory = 'randomGenotypesGraphs\' %
%outputDirectory = 'Graphs\'
%Increase variants upto 10, fix exploit
%***************************************
%SIRN testing
%All need to start with maximum diverse  - set genotypes to max
%I mean output at VR = 5, and compare to no diversity VR=1
%VR=5 static, dynamic
%VR=5 dynamic-random (1,10,20,50,100 encounter), dynamic-favscore (1,10,20,50,100 encounter)
%VR=1 static or dynamic as same
%***************************************
tic
numRuns = 20 %100 %200
numTimesteps=8000
numNodes = 100;
modePar.virusStartTime = 1;
modePar.blklist = 'no'; %yes or no
modePar.numToBlklist = 2
modePar.blklistrate = 0.01
data.m = 31

VR = [1 2 4 6 8 10];
modePar.netStr = 're'; %'rwp' random waypoint 're' random encounter

%rwp par
modePar.genotypeTimeOutPeriod = 10; %rwp
modePar.xmin     = 1;     % Minimum x-axis location (du)
modePar.xmax     = 31;    % Maximum x-axis location (du)
modePar.ymin     = 1;     % Minimum y-axis location (du)
modePar.ymax     = 31;    % Maximum y-axis location (du)
modePar.smin     = 1.4;  % Minimum speed (du / tu)
modePar.smax     = 1.4;  % Maximum speed (du / tu)
modePar.pmin     = 0;     % Minimum time for pause (integer tu)
modePar.pmax     = 0;     % Maximum time for pause (integer tu)
%modePar.dinr     = 3; %7    % Radial distance for in-range (du)
modePar.dexceed  = 1000;  % Value larger than any possible distance (du)
modePar.tinrg    = 1;     % Time in-range for genotype transfer (tu)
modePar.tinrv    = 1;     % Time in-range for virus transfer (tu)
% Mode
% rwph.mode = rwph.MODE_RIR;  1    % Select Random in range mode
% rwph.mode = rwph.MODE_NIR;  2    % Select Nearest in range mode
modePar.moderwp = 1; %MODE_AIR;  % 4    % Select (Random) Available in range mode
%rwp constrain
modePar.xboxc=0.5
modePar.yboxc=0.5
modePar.rwpcontrainplotGraph=0 %draw init constraints graph
% Log vector
modePar.logena = [1 2];
% Log directory for rwp
modePar.logDir = sprintf('%s\\log', pwd);
%data logging of output
data.logDir = sprintf('%s\\outputdata', pwd)
s = sprintf('%s\\data%i.txt', data.logDir,data.m)
data.logOutput(data.m) = fopen(s, 'wt');
%set up diversity mode parameters
modePar.areaConstrainrwp='no'
modePar.numToConstrain = 0; %constain a number of nodes to 1 variant
modePar.stopUpdatingTime = 200000; %time at which to stop updating the genotypes
modePar.numEncountersBetweenUpdates = 1; % number of encounters between updates for random and favscore algorithms
modePar.bufferlength = 10; %length of genotype buffer for favscore algorithm
modePar.genoInit = 'maxdiv';  %initial conditions of genotypes maxdiv (maximum diversity - random variant chosen) mindiv (minimum diversity - all nodes same)
%update mode
modePar.update = 'no' %stop updating mode
modePar.bufferlengthNei=10 %buffer for buffering local nei diversity,
modePar.stdNeiUpdateThreshold = 0.15


figImean = figure
figImean2 = figure
%for OR case
modePar.modeStr = 'Dynamic-favScore'; %mode - can be 'static' or 'dynamic' 'Dynamic-random' 'Dynamic-favScore'
%monte carlo random genotype SIR model
for z = 1:size(VR,2)%do for all VR
    variantRichness =  VR(z)
 betan = 0.02;   plotGraphs = 1; gamma = 0; numExploits=1; numLoci=1; casetype = 'OR'; throwAway = 'nonEpidemics'; SEpidemic=60; %cutoff;
%agent
 [figMeanNei figNeiOneRun fighistSpRun fighistRecovered fighistSusceptible fighistpeakValue fighistpeakTime fighistBeta fighistGamma fighistBetanew fighistGammanew figInfectedRun1 figBetaRun1 figGammaRun1 figRoRun1 figBetaGamma1 figBetaGamma2...
            meanNeiIndexDynamicF  betastd gammastd betastd2 betastdNew betastdNew2 gammastdNew peakTimemean peakTimestd peakValuemean peakValuestd...
            betameanmean gammameanmean betameanmean2 betameanmeanNew betameanmeanNew2 gammameanmeanNew Smean Imean Rmean NSmean Smedian Imedian Rmedian S I R NS SmeanN ImeanN1 RmeanN1 Snewendmean Snewendstd Rnewendmean Rnewendstd Rnew_nonendmean Rnew_nonendstd propSimsNonEp propSimsNonEp_theoretical...
            numRunsMinor measuredProbMinor numRunsMajor measuredProbMajor meanmdist meannumInfectedVM...
            ] = monteCarloSIRN2(numRuns,numNodes, betan, variantRichness, numTimesteps, plotGraphs,gamma,throwAway,SEpidemic,numExploits,modePar, numLoci, casetype);
FinalSize(z) = max(Imean,[],2); %mean final size SI

 fprintf(data.logOutput(data.m), '%f,', Imean);     % infection
fprintf(data.logOutput(data.m), '\n'); %new line

    %time
     maska = Imean >= FinalSize(z)-1; %when within 1 of the final value
    [C Index] = max(maska);
    MLa(z) = Index; %T1
    
    figure(figImean)
    plot(Imean, 'k', 'linewidth',2)
    hold on
    xlabel('Time (seconds)')
    ylabel ('Number of devices infected')
    
        figure(figImean2)
    plot(Imean./numNodes, 'k', 'linewidth',2)
    hold on
    xlabel('Time (seconds)')
    ylabel ('Percentage of devices infected')

%close all;
    
    text = ['done ' num2str(z) ' out of ' num2str(VR(end))];
    disp(text)
end    
%save outputs
FinalSizeInfected = FinalSize
TimeReachPeak=MLa

figure
plot(VR,MLa,'k', 'linewidth',2)
xlabel('Variant Richness')
ylabel('Time to reach peak infection')

disp('done static')
fclose(data.logOutput(data.m));
end%31


%*****************************
%%testing stop update process
%*****************************
if doSIRNTests(30) == 1
%****************************************
%***************************************
numRuns = 1 %100 %200
numTimesteps=1500
numNodes = 100;
VRmin = 3 ;%1
VRmax = 3; %10
modePar.update = 'yes' %stop updating mode
modePar.bufferlengthNei=10 %buffer for buffering local nei diversity,
modePar.stdNeiUpdateThreshold = 0.05
modePar.numToBlklist = 1
modePar.blklistrate = 0.002 %0.001
recovery = 0.0005 %0.001
dec = 100 %decimation of output data
modePar.numToConstrain = 0; %constain a number of nodes to 1 variant
modePar.stopUpdatingTime = 200000; %time at which to stop updating the genotypes
modePar.numEncountersBetweenUpdates = 1; % number of encounters between updates for random and favscore algorithms
modePar.bufferlength = 10; %length of genotype buffer for favscore algorithm
modePar.genoInit = 'mindiv';  %initial conditions of genotypes maxdiv (maximum diversity - random variant chosen) mindiv (minimum diversity - all nodes same)
tic
%5.dynamic diversity
modePar.blklist = 'yes'; %yes or no
mode = 'Dynamic-favScore'; %mode - can be 'static' or 'dynamic' 'Dynamic-random' 'Dynamic-favScore'
%monte carlo random genotype SIR model
%set up diversity mode parameters
modePar.modeStr = mode;
for z= VRmin:VRmax
 betan = 0.2; variantRichness =  z;   plotGraphs = 1; gamma = recovery; numExploits=1; numLoci=1; casetype = 'OR'; throwAway = 'nonEpidemics'; SEpidemic=60; %cutoff;
%agent
 [figMeanNei(z) figNeiOneRun(z) fighistSpRun(z) fighistRecovered(z) fighistSusceptible(z) fighistpeakValue(z) fighistpeakTime(z) fighistBeta(z) fighistGamma(z) fighistBetanew(z) fighistGammanew(z) figInfectedRun1 figBetaRun1 figGammaRun1 figRoRun1 figBetaGamma1 figBetaGamma2...
            meanNeiIndexDynamicF  betastd gammastd betastd2 betastdNew betastdNew2 gammastdNew peakTimemean peakTimestd peakValuemean peakValuestd...
            betameanmean(z) gammameanmean betameanmean2(z) betameanmeanNew(z) betameanmeanNew2 gammameanmeanNew(z) Smean Imean Rmean Bmean NSmean(z,:) Smedian Imedian Rmedian S I R NS SmeanN1 ImeanN1 RmeanN1 BmeanN1 Snewendmean Snewendstd Rnewendmean(z) Rnewendstd(z) Rnew_nonendmean Rnew_nonendstd propSimsNonEp(z) propSimsNonEp_theoretical(z)...
            numRunsMinor(z) measuredProbMinor(z) numRunsMajor(z) measuredProbMajor(z) meanmdist meannumInfectedVM...
            ] = monteCarloSIRN2(numRuns,numNodes, betan, variantRichness, numTimesteps, plotGraphs,gamma,throwAway,SEpidemic,numExploits,modePar, numLoci, casetype);
FinalSize(z) = max(Imean,[],2); %mean final size SI

    %time
     maska = Imean >= FinalSize(z)-1; %when within 1 of the final value
    [C Index] = max(maska);
    MLa(z) = Index; %T1
%close(fighistSpRun); close(fighistRecovered); close(fighistSusceptible); close(fighistpeakValue); close(fighistpeakTime);
%close(fighistBeta); close(fighistGamma); close(fighistBetanew); close(fighistGammanew); 
%close(figInfectedRun1);%close(figBetaRun1); %close(figGammaRun1); %close(figRoRun1); %close(figBetaGamma1); %close(figBetaGamma2); 
%close all;
    text = ['done ' num2str(z) ' out of ' num2str(VRmax)];
    disp(text)
end    
%save outputs
FinalSizeDynamic = FinalSize(z);
TimeDynamic=MLa(z);
ImeanDynamic=Imean(1:dec:end);
RmeanDynamic=Rmean(1:dec:end);
SmeanDynamic=Smean(1:dec:end);
BmeanDynamic=Bmean(1:dec:end);
disp('done dynamic')


figure
plot(meanNeiIndexDynamicF,'k')
xlabel('Time (seconds)')
ylabel('Variant Diversity')

%*****************************************************
toc
end %30




%**********************************************************
if doSIRNTests(23) == 1
%1 locus model
%outputDirectory = 'randomGenotypesGraphs\' %
outputDirectory = 'Graphs\'
%***************************************
%blacklisting - 1 locus model
%7.dynamic diversity with blacklisting - different blacklisting rates
%***************************************
numRuns = 10 %100 %200
numTimesteps=10000
numNodes = 1000;
variantRichness = 5 ;%1
blklistrate=[0.0001 0.0002 0.0005 0.0007 0.001 0.002 0.003 0.004 0.005 0.006 0.007 0.008 0.0100 0.0200]
modePar.numToBlklist = 1
dec = 100 %decimation of output data
modePar.numToConstrain = 0; %constain a number of nodes to 1 variant
modePar.stopUpdatingTime = 200000; %time at which to stop updating the genotypes
modePar.numEncountersBetweenUpdates = 1; % number of encounters between updates for random and favscore algorithms
modePar.bufferlength = 10; %length of genotype buffer for favscore algorithm
modePar.genoInit = 'maxdiv';  %initial conditions of genotypes maxdiv (maximum diversity - random variant chosen) mindiv (minimum diversity - all nodes same)
modePar.blklist = 'yes'; %yes or no
mode = 'dynamic'; %mode - can be 'static' or 'dynamic' 'Dynamic-random' 'Dynamic-favScore'
modePar.modeStr = mode;
betan = 0.03;
tic
%*****************************************************
%7.dynamic diversity with blacklisting
runSim=0;
if runSim==1
for z= 1:14
 modePar.blklistrate = blklistrate(z)  
   plotGraphs = 1; gamma = 0; numExploits=1; numLoci=1; casetype = 'OR'; throwAway = 'nonEpidemics'; SEpidemic=60; %cutoff;
%agent
 [figMeanNei(z) figNeiOneRun(z) fighistSpRun(z) fighistRecovered(z) fighistSusceptible(z) fighistpeakValue(z) fighistpeakTime(z) fighistBeta(z) fighistGamma(z) fighistBetanew(z) fighistGammanew(z) figInfectedRun1 figBetaRun1 figGammaRun1 figRoRun1 figBetaGamma1 figBetaGamma2...
            meanNeiIndexDynamicF  betastd gammastd betastd2 betastdNew betastdNew2 gammastdNew peakTimemean peakTimestd peakValuemean peakValuestd...
            betameanmean(z) gammameanmean betameanmean2(z) betameanmeanNew(z) betameanmeanNew2 gammameanmeanNew(z) Smean Imean Rmean Bmean NSmean(z,:) Smedian Imedian Rmedian S I R NS SmeanN1 ImeanN1 RmeanN1 BmeanN1 Snewendmean Snewendstd Rnewendmean(z) Rnewendstd(z) Rnew_nonendmean Rnew_nonendstd propSimsNonEp(z) propSimsNonEp_theoretical(z)...
            numRunsMinor(z) measuredProbMinor(z) numRunsMajor(z) measuredProbMajor(z) meanmdist meannumInfectedVM...
            ] = monteCarloSIRN2(numRuns,numNodes, betan, variantRichness, numTimesteps, plotGraphs,gamma,throwAway,SEpidemic,numExploits,modePar, numLoci, casetype);
FinalSize(z) = max(Imean,[],2); %mean final size SI
    %time
     maska = Imean >= FinalSize(z)-1; %when within 1 of the final value
    [C Index] = max(maska);
    TimeDynamic(z) = Index; %T1
    ImeanDynamic(z,:)=Imean(1:dec:end);
    SmeanDynamic(z,:)=Smean(1:dec:end);
    RmeanDynamic(z,:)=Rmean(1:dec:end);
    BmeanDynamic(z,:)=Bmean(1:dec:end);
%close(fighistSpRun); close(fighistRecovered); close(fighistSusceptible); close(fighistpeakValue); close(fighistpeakTime);
%close(fighistBeta); close(fighistGamma); close(fighistBetanew); close(fighistGammanew); 
%close(figInfectedRun1);%close(figBetaRun1); %close(figGammaRun1); %close(figRoRun1); %close(figBetaGamma1); %close(figBetaGamma2); 
close all;
    text = ['done ' num2str(z) ' out of ' num2str(9)];
    disp(text)
end    
disp('done dynamic and blacklisting')
toc

time = 1:dec:numTimesteps;

%GRAPHS
%All
figure %VR=5 Imean
plot(time,ImeanDynamic(1,:),'k', 'Linewidth', 2) %dynamic diversity and blacklisting
hold on
plot(time,ImeanDynamic(2,:),'k', 'Linewidth', 2) %dynamic diversity and blacklisting
plot(time,ImeanDynamic(3,:),'k--', 'Linewidth', 2) %dynamic diversity and blacklisting
plot(time,ImeanDynamic(4,:),'k', 'Linewidth', 2) %dynamic diversity and blacklisting
plot(time,ImeanDynamic(5,:),'k.-', 'Linewidth', 2) 
plot(time,ImeanDynamic(6,:),'k.-', 'Linewidth', 2) 
plot(time,ImeanDynamic(7,:),'k.-', 'Linewidth', 2) 
plot(time,ImeanDynamic(8,:),'r') 
plot(time,ImeanDynamic(9,:),'r--') 
plot(time,ImeanDynamic(10,:),'r--') 
plot(time,ImeanDynamic(11,:),'r--') 
plot(time,ImeanDynamic(12,:),'r--') 
plot(time,ImeanDynamic(13,:),'r--') 
plot(time,ImeanDynamic(14,:),'r--') 
legend('0.0001','0.0002','0.0005','0.0007','0.001','0.002','0.003','0.004','0.005','0.006','0.007','0.008','0.0100','0.0200') 
xlabel('Time (seconds)')
ylabel('Size of Epidemic - All')
end %runSim

bs = SPExact1LociOR( 1, [1:5] ).*betan %100% resistance   0.0200    0.0100    0.0067    0.0050    0.0040

figure
plot(blklistrate,FinalSVR5,'ko-')
hold on
plot(blklistrate,FinalSVR4,'k+-')
plot(blklistrate,FinalSVR3,'ks-')
plot(blklistrate,FinalSVR2,'k--')
for f = 1:5
plot([bs(f) bs(f)],[0 1],'k--')
end
xlabel('blacklisting rate')
ylabel('Resistance')
legend('VR=5','VR=4','VR=3','VR=2')



toc
end %test23






    
    
%1 locus model
%outputDirectory = 'Graphs\'
outputDirectory = 'Graphs\'
%***************************************
%blacklisting - 1 locus model
%1.no diversity
%2.no diversity and recovery
%3.static diversity
%4.static diversity with recovery
%5.dynamic diversity
%6.dynamic diversity with recovery
%7.dynamic diversity with blacklisting
%8.dynamic diversity with blacklisting and recovery
%ADDED
%9.FS with blacklisting 10 encounter update
%10.FS with blacklisting 10 encounter update and recovery
%11.FV-E with blacklisting 10 encounter update
%12.FV-E with blacklisting 10 encounter update and recovery
%***************************************
numRuns = 20 %100 %200
numTimesteps=7000
numNodes = 1000;
VRmin = 1 ;%1
VRmax = 1; %10
modePar.numToBlklist = 1
modePar.blklistrate = 0.004 %0.001
recovery = 0.004 %0.001
dec = 100 %decimation of output data
modePar.numToConstrain = 0; %constain a number of nodes to 1 variant
modePar.stopUpdatingTime = 200000; %time at which to stop updating the genotypes
modePar.numEncountersBetweenUpdates = 10; % number of encounters between updates for random and favscore algorithms
modePar.bufferlength = 10; %length of genotype buffer for favscore algorithm
modePar.genoInit = 'maxdiv';  %initial conditions of genotypes maxdiv (maximum diversity - random variant chosen) mindiv (minimum diversity - all nodes same)
tic
%***********************
%1.no diversity
modePar.blklist = 'no'; %yes or no
mode = 'static' %mode - can be 'static' or 'dynamic' 'Dynamic-random' 'Dynamic-favScore'
%monte carlo random genotype SIR model
%numRuns = 20 %100 %200
%set up diversity mode parameters
modePar.modeStr = mode;

for z= 1:1
 betan = 0.02; variantRichness =  z;   plotGraphs = 1; gamma = 0; numExploits=1; numLoci=1; casetype = 'OR'; throwAway = 'nonEpidemics', SEpidemic=60; %cutoff;
%agent
 [figMeanNei(z) figNeiOneRun(z) fighistSpRun(z) fighistRecovered(z) fighistSusceptible(z) fighistpeakValue(z) fighistpeakTime(z) fighistBeta(z) fighistGamma(z) fighistBetanew(z) fighistGammanew(z) figInfectedRun1 figBetaRun1 figGammaRun1 figRoRun1 figBetaGamma1 figBetaGamma2...
            meanNeiIndexDynamicF  betastd gammastd betastd2 betastdNew betastdNew2 gammastdNew peakTimemean peakTimestd peakValuemean peakValuestd...
            betameanmean(z) gammameanmean betameanmean2(z) betameanmeanNew(z) betameanmeanNew2 gammameanmeanNew(z) Smean Imean Rmean Bmean NSmean(z,:) Smedian Imedian Rmedian S I R NS SmeanN ImeanN1 RmeanN1 BmeanN1 Snewendmean Snewendstd Rnewendmean(z) Rnewendstd(z) Rnew_nonendmean Rnew_nonendstd propSimsNonEp(z) propSimsNonEp_theoretical(z)...
            numRunsMinor(z) measuredProbMinor(z) numRunsMajor(z) measuredProbMajor(z) meanmdist meannumInfectedVM...
            ] = monteCarloSIRN2(numRuns,numNodes, betan, variantRichness, numTimesteps, plotGraphs,gamma,throwAway,SEpidemic,numExploits,modePar, numLoci, casetype);
FinalSize(z) = max(Imean,[],2); %mean final size SI
    %time
     maska = Imean >= FinalSize(z)-1; %when within 1 of the final value
    [C Index] = max(maska);
    MLa(z) = Index %T1
close(fighistSpRun); close(fighistRecovered); close(fighistSusceptible); close(fighistpeakValue); close(fighistpeakTime);
close(fighistBeta); close(fighistGamma); close(fighistBetanew); close(fighistGammanew); 
%close(figInfectedRun1);%close(figBetaRun1); %close(figGammaRun1); %close(figRoRun1); %close(figBetaGamma1); %close(figBetaGamma2); 
close all;
    text = ['done ' num2str(z) ' out of ' num2str(1)];
    disp(text)
end    
%save outputs
FinalSizeVR1 = FinalSize(z);
TimeVR1=MLa(z);
ImeanVR1=Imean(1:dec:end);
SmeanVR1=Smean(1:dec:end);
RmeanVR1=Rmean(1:dec:end);
BmeanVR1=Bmean(1:dec:end);
disp('done VR1')
%*********************************
%2.no diversity and recovery
modePar.blklist = 'no'; %yes or no
mode = 'static' %mode - can be 'static' or 'dynamic' 'Dynamic-random' 'Dynamic-favScore'
modePar.modeStr = mode;
for z= 1:1
 betan = 0.02; variantRichness =  z;   plotGraphs = 1; gamma = recovery; numExploits=1; numLoci=1; casetype = 'OR'; throwAway = 'nonEpidemics'; SEpidemic=60; %cutoff;
%agent
 [figMeanNei(z) figNeiOneRun(z) fighistSpRun(z) fighistRecovered(z) fighistSusceptible(z) fighistpeakValue(z) fighistpeakTime(z) fighistBeta(z) fighistGamma(z) fighistBetanew(z) fighistGammanew(z) figInfectedRun1 figBetaRun1 figGammaRun1 figRoRun1 figBetaGamma1 figBetaGamma2...
            meanNeiIndexDynamicF  betastd gammastd betastd2 betastdNew betastdNew2 gammastdNew peakTimemean peakTimestd peakValuemean peakValuestd...
            betameanmean(z) gammameanmean betameanmean2(z) betameanmeanNew(z) betameanmeanNew2 gammameanmeanNew(z) Smean Imean Rmean Bmean NSmean(z,:) Smedian Imedian Rmedian S I R NS SmeanN1 ImeanN1 RmeanN1 BmeanN1 Snewendmean Snewendstd Rnewendmean(z) Rnewendstd(z) Rnew_nonendmean Rnew_nonendstd propSimsNonEp(z) propSimsNonEp_theoretical(z)...
            numRunsMinor(z) measuredProbMinor(z) numRunsMajor(z) measuredProbMajor(z) meanmdist meannumInfectedVM...
            ] = monteCarloSIRN2(numRuns,numNodes, betan, variantRichness, numTimesteps, plotGraphs,gamma,throwAway,SEpidemic,numExploits,modePar, numLoci, casetype);
FinalSize(z) = max(Imean,[],2); %mean final size SI
    %time
     maska = Imean >= FinalSize(z)-1; %when within 1 of the final value
    [C Index] = max(maska);
    MLa(z) = Index %T1
close(fighistSpRun); close(fighistRecovered); close(fighistSusceptible); close(fighistpeakValue); close(fighistpeakTime);
close(fighistBeta); close(fighistGamma); close(fighistBetanew); close(fighistGammanew); 
%close(figInfectedRun1);%close(figBetaRun1); %close(figGammaRun1); %close(figRoRun1); %close(figBetaGamma1); %close(figBetaGamma2); 
close all;
    text = ['done ' num2str(z) ' out of ' num2str(1)];
    disp(text)
end    
%save outputs
FinalSizeVR1R = FinalSize(z);
TimeVR1R=MLa(z);
ImeanVR1R=ImeanN1(1:dec:end);
SmeanVR1R=SmeanN1(1:dec:end);
RmeanVR1R=RmeanN1(1:dec:end);
BmeanVR1R=BmeanN1(1:dec:end);
disp('done VR1R')

%**********************
%3.static diversity
modePar.blklist = 'no'; %yes or no
mode = 'static'; %mode - can be 'static' or 'dynamic' 'Dynamic-random' 'Dynamic-favScore'
%monte carlo random genotype SIR model
%set up diversity mode parameters
modePar.modeStr = mode;
for z= VRmin:VRmax
 betan = 0.02; variantRichness =  z;   plotGraphs = 1; gamma = 0; numExploits=1; numLoci=1; casetype = 'OR'; throwAway = 'nonEpidemics'; SEpidemic=60; %cutoff;
%agent
 [figMeanNei(z) figNeiOneRun(z) fighistSpRun(z) fighistRecovered(z) fighistSusceptible(z) fighistpeakValue(z) fighistpeakTime(z) fighistBeta(z) fighistGamma(z) fighistBetanew(z) fighistGammanew(z) figInfectedRun1 figBetaRun1 figGammaRun1 figRoRun1 figBetaGamma1 figBetaGamma2...
            meanNeiIndexDynamicF  betastd gammastd betastd2 betastdNew betastdNew2 gammastdNew peakTimemean peakTimestd peakValuemean peakValuestd...
            betameanmean(z) gammameanmean betameanmean2(z) betameanmeanNew(z) betameanmeanNew2 gammameanmeanNew(z) Smean Imean Rmean Bmean NSmean(z,:) Smedian Imedian Rmedian S I R NS SmeanN1 ImeanN1 RmeanN1 BmeanN1 Snewendmean Snewendstd Rnewendmean(z) Rnewendstd(z) Rnew_nonendmean Rnew_nonendstd propSimsNonEp(z) propSimsNonEp_theoretical(z)...
            numRunsMinor(z) measuredProbMinor(z) numRunsMajor(z) measuredProbMajor(z) meanmdist meannumInfectedVM...
            ] = monteCarloSIRN2(numRuns,numNodes, betan, variantRichness, numTimesteps, plotGraphs,gamma,throwAway,SEpidemic,numExploits,modePar, numLoci, casetype);
FinalSize(z) = max(Imean,[],2); %mean final size SI
%time
maska = Imean >= FinalSize(z)-1; %when within 1 of the final value
[C Index] = max(maska);
MLa(z) = Index; %T1
%close(fighistSpRun); 
%close(fighistRecovered); 
%close(fighistSusceptible); 
%close(fighistpeakValue); 
%close(fighistpeakTime);
%close(fighistBeta); close(fighistGamma); close(fighistBetanew); close(fighistGammanew); 
%close(figInfectedRun1);%close(figBetaRun1); %close(figGammaRun1); %close(figRoRun1); %close(figBetaGamma1); %close(figBetaGamma2); 
close all;
end    
%save outputs
FinalSizeStatic = FinalSize(z);
TimeStatic=MLa(z);
ImeanStatic=Imean(1:dec:end);
SmeanStatic=Smean(1:dec:end);
RmeanStatic=Rmean(1:dec:end);
BmeanStatic=Bmean(1:dec:end);

disp('done static')
%**************************
%4.static diversity and recovery
modePar.blklist = 'no'; %yes or no
mode = 'static'; %mode - can be 'static' or 'dynamic' 'Dynamic-random' 'Dynamic-favScore'
%monte carlo random genotype SIR model
%set up diversity mode parameters
modePar.modeStr = mode;
for z= VRmin:VRmax
 betan = 0.02; variantRichness =  z;   plotGraphs = 1; gamma = recovery; numExploits=1; numLoci=1; casetype = 'OR'; throwAway = 'nonEpidemics'; SEpidemic=60; %cutoff;
%agent
 [figMeanNei(z) figNeiOneRun(z) fighistSpRun(z) fighistRecovered(z) fighistSusceptible(z) fighistpeakValue(z) fighistpeakTime(z) fighistBeta(z) fighistGamma(z) fighistBetanew(z) fighistGammanew(z) figInfectedRun1 figBetaRun1 figGammaRun1 figRoRun1 figBetaGamma1 figBetaGamma2...
            meanNeiIndexDynamicF  betastd gammastd betastd2 betastdNew betastdNew2 gammastdNew peakTimemean peakTimestd peakValuemean peakValuestd...
            betameanmean(z) gammameanmean betameanmean2(z) betameanmeanNew(z) betameanmeanNew2 gammameanmeanNew(z) Smean Imean Rmean Bmean NSmean(z,:) Smedian Imedian Rmedian S I R NS SmeanN1 ImeanN1 RmeanN1 BmeanN1 Snewendmean Snewendstd Rnewendmean(z) Rnewendstd(z) Rnew_nonendmean Rnew_nonendstd propSimsNonEp(z) propSimsNonEp_theoretical(z)...
            numRunsMinor(z) measuredProbMinor(z) numRunsMajor(z) measuredProbMajor(z) meanmdist meannumInfectedVM...
            ] = monteCarloSIRN2(numRuns,numNodes, betan, variantRichness, numTimesteps, plotGraphs,gamma,throwAway,SEpidemic,numExploits,modePar, numLoci, casetype);
FinalSize(z) = max(RmeanN1,[],2); %mean final size SIR
%time
maska = Imean >= FinalSize(z)-1; %when within 1 of the final value
[C Index] = max(maska);
MLa(z) = Index; %T1
%close(fighistSpRun); close(fighistRecovered); close(fighistSusceptible); close(fighistpeakValue); close(fighistpeakTime);
%close(fighistBeta); close(fighistGamma); close(fighistBetanew); close(fighistGammanew); 
%close(figInfectedRun1);%close(figBetaRun1); %close(figGammaRun1); %close(figRoRun1); %close(figBetaGamma1); %close(figBetaGamma2); 
close all;
end    
%save outputs
FinalSizeStaticR = FinalSize(z);
TimeStaticR=MLa(z);
ImeanStaticR=ImeanN1(1:dec:end);
SmeanStaticR=SmeanN1(1:dec:end);
RmeanStaticR=RmeanN1(1:dec:end);
BmeanStaticR=BmeanN1(1:dec:end);

disp('done static with recovery')
%****************************************
%5.dynamic diversity
modePar.blklist = 'no'; %yes or no
mode = 'dynamic'; %mode - can be 'static' or 'dynamic' 'Dynamic-random' 'Dynamic-favScore'
%monte carlo random genotype SIR model
%set up diversity mode parameters
modePar.modeStr = mode;
for z= VRmin:VRmax
 betan = 0.02; variantRichness =  z;   plotGraphs = 1; gamma = 0; numExploits=1; numLoci=1; casetype = 'OR'; throwAway = 'nonEpidemics'; SEpidemic=60; %cutoff;
%agent
 [figMeanNei(z) figNeiOneRun(z) fighistSpRun(z) fighistRecovered(z) fighistSusceptible(z) fighistpeakValue(z) fighistpeakTime(z) fighistBeta(z) fighistGamma(z) fighistBetanew(z) fighistGammanew(z) figInfectedRun1 figBetaRun1 figGammaRun1 figRoRun1 figBetaGamma1 figBetaGamma2...
            meanNeiIndexDynamicF  betastd gammastd betastd2 betastdNew betastdNew2 gammastdNew peakTimemean peakTimestd peakValuemean peakValuestd...
            betameanmean(z) gammameanmean betameanmean2(z) betameanmeanNew(z) betameanmeanNew2 gammameanmeanNew(z) Smean Imean Rmean Bmean NSmean(z,:) Smedian Imedian Rmedian S I R NS SmeanN1 ImeanN1 RmeanN1 BmeanN1 Snewendmean Snewendstd Rnewendmean(z) Rnewendstd(z) Rnew_nonendmean Rnew_nonendstd propSimsNonEp(z) propSimsNonEp_theoretical(z)...
            numRunsMinor(z) measuredProbMinor(z) numRunsMajor(z) measuredProbMajor(z) meanmdist meannumInfectedVM...
            ] = monteCarloSIRN2(numRuns,numNodes, betan, variantRichness, numTimesteps, plotGraphs,gamma,throwAway,SEpidemic,numExploits,modePar, numLoci, casetype);
FinalSize(z) = max(Imean,[],2); %mean final size SI

    %time
     maska = Imean >= FinalSize(z)-1; %when within 1 of the final value
    [C Index] = max(maska);
    MLa(z) = Index; %T1
%close(fighistSpRun); close(fighistRecovered); close(fighistSusceptible); close(fighistpeakValue); close(fighistpeakTime);
%close(fighistBeta); close(fighistGamma); close(fighistBetanew); close(fighistGammanew); 
%close(figInfectedRun1);%close(figBetaRun1); %close(figGammaRun1); %close(figRoRun1); %close(figBetaGamma1); %close(figBetaGamma2); 
close all;
    text = ['done ' num2str(z) ' out of ' num2str(VRmax)];
    disp(text)
end    
%save outputs
FinalSizeDynamic = FinalSize(z);
TimeDynamic=MLa(z);
ImeanDynamic=Imean(1:dec:end);
RmeanDynamic=Rmean(1:dec:end);
SmeanDynamic=Smean(1:dec:end);
BmeanDynamic=Bmean(1:dec:end);
disp('done dynamic')
%*****************************************************

%*********************************
%6.dynamic diversity with recovery
modePar.blklist = 'no'; %yes or no
mode = 'dynamic'; %mode - can be 'static' or 'dynamic' 'Dynamic-random' 'Dynamic-favScore'
%set up diversity mode parameters
modePar.modeStr = mode;
for z= VRmin:VRmax
 betan = 0.02; variantRichness =  z;   plotGraphs = 1; gamma = recovery; numExploits=1; numLoci=1; casetype = 'OR'; throwAway = 'nonEpidemics'; SEpidemic=60; %cutoff;
%agent
 [figMeanNei(z) figNeiOneRun(z) fighistSpRun(z) fighistRecovered(z) fighistSusceptible(z) fighistpeakValue(z) fighistpeakTime(z) fighistBeta(z) fighistGamma(z) fighistBetanew(z) fighistGammanew(z) figInfectedRun1 figBetaRun1 figGammaRun1 figRoRun1 figBetaGamma1 figBetaGamma2...
            meanNeiIndexDynamicF  betastd gammastd betastd2 betastdNew betastdNew2 gammastdNew peakTimemean peakTimestd peakValuemean peakValuestd...
            betameanmean(z) gammameanmean betameanmean2(z) betameanmeanNew(z) betameanmeanNew2 gammameanmeanNew(z) Smean Imean Rmean Bmean NSmean(z,:) Smedian Imedian Rmedian S I R NS SmeanN1 ImeanN1 RmeanN1 BmeanN1 Snewendmean Snewendstd Rnewendmean(z) Rnewendstd(z) Rnew_nonendmean Rnew_nonendstd propSimsNonEp(z) propSimsNonEp_theoretical(z)...
            numRunsMinor(z) measuredProbMinor(z) numRunsMajor(z) measuredProbMajor(z) meanmdist meannumInfectedVM...
            ] = monteCarloSIRN2(numRuns,numNodes, betan, variantRichness, numTimesteps, plotGraphs,gamma,throwAway,SEpidemic,numExploits,modePar, numLoci, casetype);
FinalSize(z) = max(RmeanN1,[],2); %mean final size SI
    %time
     maska = Imean >= FinalSize(z)-1; %when within 1 of the final value
    [C Index] = max(maska);
    MLa(z) = Index; %T1
%close(fighistSpRun); close(fighistRecovered); close(fighistSusceptible); close(fighistpeakValue); close(fighistpeakTime);
%close(fighistBeta); close(fighistGamma); close(fighistBetanew); close(fighistGammanew); 
%close(figInfectedRun1);%close(figBetaRun1); %close(figGammaRun1); %close(figRoRun1); %close(figBetaGamma1); %close(figBetaGamma2); 
close all;
     text = ['done ' num2str(z) ' out of ' num2str(VRmax)];
    disp(text)
end    
%save outputs
FinalSizeDynamicR = FinalSize(z);
TimeDynamicR=MLa(z);
ImeanDynamicR=ImeanN1(1:dec:end);
SmeanDynamicR=SmeanN1(1:dec:end);
RmeanDynamicR=RmeanN1(1:dec:end);
BmeanDynamicR=BmeanN1(1:dec:end);
disp('done dynamic and recovery')

%*****************************************************
%7.dynamic diversity with blacklisting
modePar.blklist = 'yes'; %yes or no
mode = 'dynamic'; %mode - can be 'static' or 'dynamic' 'Dynamic-random' 'Dynamic-favScore'
modePar.modeStr = mode;
for z= VRmin:VRmax
 betan = 0.02; variantRichness =  z;   plotGraphs = 1; gamma = 0; numExploits=1; numLoci=1; casetype = 'OR'; throwAway = 'nonEpidemics'; SEpidemic=60; %cutoff;
%agent
 [figMeanNei(z) figNeiOneRun(z) fighistSpRun(z) fighistRecovered(z) fighistSusceptible(z) fighistpeakValue(z) fighistpeakTime(z) fighistBeta(z) fighistGamma(z) fighistBetanew(z) fighistGammanew(z) figInfectedRun1 figBetaRun1 figGammaRun1 figRoRun1 figBetaGamma1 figBetaGamma2...
            meanNeiIndexDynamicF  betastd gammastd betastd2 betastdNew betastdNew2 gammastdNew peakTimemean peakTimestd peakValuemean peakValuestd...
            betameanmean(z) gammameanmean betameanmean2(z) betameanmeanNew(z) betameanmeanNew2 gammameanmeanNew(z) Smean Imean Rmean Bmean NSmean(z,:) Smedian Imedian Rmedian S I R NS SmeanN1 ImeanN1 RmeanN1 BmeanN1 Snewendmean Snewendstd Rnewendmean(z) Rnewendstd(z) Rnew_nonendmean Rnew_nonendstd propSimsNonEp(z) propSimsNonEp_theoretical(z)...
            numRunsMinor(z) measuredProbMinor(z) numRunsMajor(z) measuredProbMajor(z) meanmdist meannumInfectedVM...
            ] = monteCarloSIRN2(numRuns,numNodes, betan, variantRichness, numTimesteps, plotGraphs,gamma,throwAway,SEpidemic,numExploits,modePar, numLoci, casetype);
FinalSize(z) = max(Imean,[],2); %mean final size SI
    %time
     maska = Imean >= FinalSize(z)-1; %when within 1 of the final value
    [C Index] = max(maska);
    MLa(z) = Index; %T1
%close(fighistSpRun); close(fighistRecovered); close(fighistSusceptible); close(fighistpeakValue); close(fighistpeakTime);
%close(fighistBeta); close(fighistGamma); close(fighistBetanew); close(fighistGammanew); 
%close(figInfectedRun1);%close(figBetaRun1); %close(figGammaRun1); %close(figRoRun1); %close(figBetaGamma1); %close(figBetaGamma2); 
close all;
    text = ['done ' num2str(z) ' out of ' num2str(VRmax)];
    disp(text)
end    
%save outputs
FinalSizeDynamicYes1 = FinalSize(z);
TimeDynamicYes1=MLa(z);
ImeanDynamicYes1=Imean(1:dec:end);
SmeanDynamicYes1=Smean(1:dec:end);
RmeanDynamicYes1=Rmean(1:dec:end);
BmeanDynamicYes1=Bmean(1:dec:end);
disp('done dynamic and blacklisting')

%*****************************************************
%8.dynamic diversity with blacklisting and recovery
modePar.blklist = 'yes'; %yes or no
mode = 'dynamic'; %mode - can be 'static' or 'dynamic' 'Dynamic-random' 'Dynamic-favScore'
modePar.modeStr = mode;
for z= VRmin:VRmax
 betan = 0.02; variantRichness =  z;   plotGraphs = 1; gamma = recovery; numExploits=1; numLoci=1; casetype = 'OR'; throwAway = 'nonEpidemics'; SEpidemic=60; %cutoff;
%agent
 [figMeanNei(z) figNeiOneRun(z) fighistSpRun(z) fighistRecovered(z) fighistSusceptible(z) fighistpeakValue(z) fighistpeakTime(z) fighistBeta(z) fighistGamma(z) fighistBetanew(z) fighistGammanew(z) figInfectedRun1 figBetaRun1 figGammaRun1 figRoRun1 figBetaGamma1 figBetaGamma2...
            meanNeiIndexDynamicF  betastd gammastd betastd2 betastdNew betastdNew2 gammastdNew peakTimemean peakTimestd peakValuemean peakValuestd...
            betameanmean(z) gammameanmean betameanmean2(z) betameanmeanNew(z) betameanmeanNew2 gammameanmeanNew(z) Smean Imean Rmean Bmean NSmean Smedian Imedian Rmedian S I R NS SmeanN1 ImeanN1 RmeanN1 BmeanN1 Snewendmean Snewendstd Rnewendmean(z) Rnewendstd(z) Rnew_nonendmean Rnew_nonendstd propSimsNonEp(z) propSimsNonEp_theoretical(z)...
            numRunsMinor(z) measuredProbMinor(z) numRunsMajor(z) measuredProbMajor(z) meanmdist meannumInfectedVM...
            ] = monteCarloSIRN2(numRuns,numNodes, betan, variantRichness, numTimesteps, plotGraphs,gamma,throwAway,SEpidemic,numExploits,modePar, numLoci, casetype);
FinalSize(z) = max(RmeanN1,[],2); %mean final size SI
    %time
     maska = Imean >= FinalSize(z)-1; %when within 1 of the final value
    [C Index] = max(maska);
    MLa(z) = Index; %T1
%close(fighistSpRun); close(fighistRecovered); close(fighistSusceptible); close(fighistpeakValue); close(fighistpeakTime);
%close(fighistBeta); close(fighistGamma); close(fighistBetanew); close(fighistGammanew); 
%close(figInfectedRun1);%close(figBetaRun1); %close(figGammaRun1); %close(figRoRun1); %close(figBetaGamma1); %close(figBetaGamma2); 
close all;
    text = ['done ' num2str(z) ' out of ' num2str(VRmax)];
    disp(text)
end    
%save outputs
FinalSizeDynamicYes1Gamma1 = FinalSize(z);
TimeDynamicYes1Gamma1=MLa(z);
ImeanDynamicYes1Gamma1=ImeanN1(1:dec:end); %major outbreaks only
SmeanDynamicYes1Gamma1=SmeanN1(1:dec:end);
RmeanDynamicYes1Gamma1=RmeanN1(1:dec:end);
BmeanDynamicYes1Gamma1=BmeanN1(1:dec:end);
disp('done dynamic and blacklisting and recovery')

%*****************************************************
%*****************************************************
%9.FS with blacklisting 10 encounter update
modePar.blklist = 'yes'; %yes or no
mode = 'Dynamic-favScore'; %mode - can be 'static' or 'dynamic' 'Dynamic-random' 'Dynamic-favScore'
modePar.modeStr = mode;
for z= VRmin:VRmax
 betan = 0.02; variantRichness =  z;   plotGraphs = 1; gamma = 0; numExploits=1; numLoci=1; casetype = 'OR'; throwAway = 'nonEpidemics'; SEpidemic=60; %cutoff;
%agent
 [figMeanNei(z) figNeiOneRun(z) fighistSpRun(z) fighistRecovered(z) fighistSusceptible(z) fighistpeakValue(z) fighistpeakTime(z) fighistBeta(z) fighistGamma(z) fighistBetanew(z) fighistGammanew(z) figInfectedRun1 figBetaRun1 figGammaRun1 figRoRun1 figBetaGamma1 figBetaGamma2...
            meanNeiIndexDynamicF  betastd gammastd betastd2 betastdNew betastdNew2 gammastdNew peakTimemean peakTimestd peakValuemean peakValuestd...
            betameanmean(z) gammameanmean betameanmean2(z) betameanmeanNew(z) betameanmeanNew2 gammameanmeanNew(z) Smean Imean Rmean Bmean NSmean(z,:) Smedian Imedian Rmedian S I R NS SmeanN1 ImeanN1 RmeanN1 BmeanN1 Snewendmean Snewendstd Rnewendmean(z) Rnewendstd(z) Rnew_nonendmean Rnew_nonendstd propSimsNonEp(z) propSimsNonEp_theoretical(z)...
            numRunsMinor(z) measuredProbMinor(z) numRunsMajor(z) measuredProbMajor(z) meanmdist meannumInfectedVM...
            ] = monteCarloSIRN2(numRuns,numNodes, betan, variantRichness, numTimesteps, plotGraphs,gamma,throwAway,SEpidemic,numExploits,modePar, numLoci, casetype);
FinalSize(z) = max(Imean,[],2); %mean final size SI
    %time
     maska = Imean >= FinalSize(z)-1; %when within 1 of the final value
    [C Index] = max(maska);
    MLa(z) = Index; %T1
%close(fighistSpRun); close(fighistRecovered); close(fighistSusceptible); close(fighistpeakValue); close(fighistpeakTime);
%close(fighistBeta); close(fighistGamma); close(fighistBetanew); close(fighistGammanew); 
%close(figInfectedRun1);%close(figBetaRun1); %close(figGammaRun1); %close(figRoRun1); %close(figBetaGamma1); %close(figBetaGamma2); 
close all;
    text = ['done ' num2str(z) ' out of ' num2str(VRmax)];
    disp(text)
end    
%save outputs
FinalSizeDynamicYes1_FS = FinalSize(z);
TimeDynamicYes1_FS=MLa(z);
ImeanDynamicYes1_FS=Imean(1:dec:end);
SmeanDynamicYes1_FS=Smean(1:dec:end);
RmeanDynamicYes1_FS=Rmean(1:dec:end);
BmeanDynamicYes1_FS=Bmean(1:dec:end);
disp('done FS and blacklisting')

%*****************************************************
%10.FS with blacklisting 10 encounter update and recovery
modePar.blklist = 'yes'; %yes or no
mode = 'Dynamic-favScore'; %mode - can be 'static' or 'dynamic' 'Dynamic-random' 'Dynamic-favScore'
modePar.modeStr = mode;
for z= VRmin:VRmax
 betan = 0.02; variantRichness =  z;   plotGraphs = 1; gamma = recovery; numExploits=1; numLoci=1; casetype = 'OR'; throwAway = 'nonEpidemics'; SEpidemic=60; %cutoff;
%agent
 [figMeanNei(z) figNeiOneRun(z) fighistSpRun(z) fighistRecovered(z) fighistSusceptible(z) fighistpeakValue(z) fighistpeakTime(z) fighistBeta(z) fighistGamma(z) fighistBetanew(z) fighistGammanew(z) figInfectedRun1 figBetaRun1 figGammaRun1 figRoRun1 figBetaGamma1 figBetaGamma2...
            meanNeiIndexDynamicF  betastd gammastd betastd2 betastdNew betastdNew2 gammastdNew peakTimemean peakTimestd peakValuemean peakValuestd...
            betameanmean(z) gammameanmean betameanmean2(z) betameanmeanNew(z) betameanmeanNew2 gammameanmeanNew(z) Smean Imean Rmean Bmean NSmean Smedian Imedian Rmedian S I R NS SmeanN1 ImeanN1 RmeanN1 BmeanN1 Snewendmean Snewendstd Rnewendmean(z) Rnewendstd(z) Rnew_nonendmean Rnew_nonendstd propSimsNonEp(z) propSimsNonEp_theoretical(z)...
            numRunsMinor(z) measuredProbMinor(z) numRunsMajor(z) measuredProbMajor(z) meanmdist meannumInfectedVM...
            ] = monteCarloSIRN2(numRuns,numNodes, betan, variantRichness, numTimesteps, plotGraphs,gamma,throwAway,SEpidemic,numExploits,modePar, numLoci, casetype);
FinalSize(z) = max(RmeanN1,[],2); %mean final size SI
    %time
     maska = Imean >= FinalSize(z)-1; %when within 1 of the final value
    [C Index] = max(maska);
    MLa(z) = Index; %T1
%close(fighistSpRun); close(fighistRecovered); close(fighistSusceptible); close(fighistpeakValue); close(fighistpeakTime);
%close(fighistBeta); close(fighistGamma); close(fighistBetanew); close(fighistGammanew); 
%close(figInfectedRun1);%close(figBetaRun1); %close(figGammaRun1); %close(figRoRun1); %close(figBetaGamma1); %close(figBetaGamma2); 
close all;
    text = ['done ' num2str(z) ' out of ' num2str(VRmax)];
    disp(text)
end    
%save outputs
FinalSizeDynamicYes1Gamma1_FS = FinalSize(z);
TimeDynamicYes1Gamma1_FS=MLa(z);
ImeanDynamicYes1Gamma1_FS=ImeanN1(1:dec:end); %major outbreaks only
SmeanDynamicYes1Gamma1_FS=SmeanN1(1:dec:end);
RmeanDynamicYes1Gamma1_FS=RmeanN1(1:dec:end);
BmeanDynamicYes1Gamma1_FS=BmeanN1(1:dec:end);
disp('done FS and blacklisting and recovery')

%*****************************************************
%11.FV-E with blacklisting 10 encounter update
modePar.blklist = 'yes'; %yes or no
mode = 'Dynamic-random'; %mode - can be 'static' or 'dynamic' 'Dynamic-random' 'Dynamic-favScore'
modePar.modeStr = mode;
for z= VRmin:VRmax
 betan = 0.02; variantRichness =  z;   plotGraphs = 1; gamma = 0; numExploits=1; numLoci=1; casetype = 'OR'; throwAway = 'nonEpidemics'; SEpidemic=60; %cutoff;
%agent
 [figMeanNei(z) figNeiOneRun(z) fighistSpRun(z) fighistRecovered(z) fighistSusceptible(z) fighistpeakValue(z) fighistpeakTime(z) fighistBeta(z) fighistGamma(z) fighistBetanew(z) fighistGammanew(z) figInfectedRun1 figBetaRun1 figGammaRun1 figRoRun1 figBetaGamma1 figBetaGamma2...
            meanNeiIndexDynamicF  betastd gammastd betastd2 betastdNew betastdNew2 gammastdNew peakTimemean peakTimestd peakValuemean peakValuestd...
            betameanmean(z) gammameanmean betameanmean2(z) betameanmeanNew(z) betameanmeanNew2 gammameanmeanNew(z) Smean Imean Rmean Bmean NSmean(z,:) Smedian Imedian Rmedian S I R NS SmeanN1 ImeanN1 RmeanN1 BmeanN1 Snewendmean Snewendstd Rnewendmean(z) Rnewendstd(z) Rnew_nonendmean Rnew_nonendstd propSimsNonEp(z) propSimsNonEp_theoretical(z)...
            numRunsMinor(z) measuredProbMinor(z) numRunsMajor(z) measuredProbMajor(z) meanmdist meannumInfectedVM...
            ] = monteCarloSIRN2(numRuns,numNodes, betan, variantRichness, numTimesteps, plotGraphs,gamma,throwAway,SEpidemic,numExploits,modePar, numLoci, casetype);
FinalSize(z) = max(Imean,[],2); %mean final size SI
    %time
     maska = Imean >= FinalSize(z)-1; %when within 1 of the final value
    [C Index] = max(maska);
    MLa(z) = Index; %T1
%close(fighistSpRun); close(fighistRecovered); close(fighistSusceptible); close(fighistpeakValue); close(fighistpeakTime);
%close(fighistBeta); close(fighistGamma); close(fighistBetanew); close(fighistGammanew); 
%close(figInfectedRun1);%close(figBetaRun1); %close(figGammaRun1); %close(figRoRun1); %close(figBetaGamma1); %close(figBetaGamma2); 
close all;
    text = ['done ' num2str(z) ' out of ' num2str(VRmax)];
    disp(text)
end    
%save outputs
FinalSizeDynamicYes1_FVE = FinalSize(z);
TimeDynamicYes1_FVE=MLa(z);
ImeanDynamicYes1_FVE=Imean(1:dec:end);
SmeanDynamicYes1_FVE=Smean(1:dec:end);
RmeanDynamicYes1_FVE=Rmean(1:dec:end);
BmeanDynamicYes1_FVE=Bmean(1:dec:end);
disp('done FV-E and blacklisting')

%*****************************************************
%12.FV-E with blacklisting 10 encounter update and recovery
modePar.blklist = 'yes'; %yes or no
mode = 'Dynamic-random'; %mode - can be 'static' or 'dynamic' 'Dynamic-random' 'Dynamic-favScore'
modePar.modeStr = mode;
for z= VRmin:VRmax
 betan = 0.02; variantRichness =  z;   plotGraphs = 1; gamma = recovery; numExploits=1; numLoci=1; casetype = 'OR'; throwAway = 'nonEpidemics'; SEpidemic=60; %cutoff;
%agent
 [figMeanNei(z) figNeiOneRun(z) fighistSpRun(z) fighistRecovered(z) fighistSusceptible(z) fighistpeakValue(z) fighistpeakTime(z) fighistBeta(z) fighistGamma(z) fighistBetanew(z) fighistGammanew(z) figInfectedRun1 figBetaRun1 figGammaRun1 figRoRun1 figBetaGamma1 figBetaGamma2...
            meanNeiIndexDynamicF  betastd gammastd betastd2 betastdNew betastdNew2 gammastdNew peakTimemean peakTimestd peakValuemean peakValuestd...
            betameanmean(z) gammameanmean betameanmean2(z) betameanmeanNew(z) betameanmeanNew2 gammameanmeanNew(z) Smean Imean Rmean Bmean NSmean Smedian Imedian Rmedian S I R NS SmeanN1 ImeanN1 RmeanN1 BmeanN1 Snewendmean Snewendstd Rnewendmean(z) Rnewendstd(z) Rnew_nonendmean Rnew_nonendstd propSimsNonEp(z) propSimsNonEp_theoretical(z)...
            numRunsMinor(z) measuredProbMinor(z) numRunsMajor(z) measuredProbMajor(z) meanmdist meannumInfectedVM...
            ] = monteCarloSIRN2(numRuns,numNodes, betan, variantRichness, numTimesteps, plotGraphs,gamma,throwAway,SEpidemic,numExploits,modePar, numLoci, casetype);
FinalSize(z) = max(RmeanN1,[],2); %mean final size SI
    %time
     maska = Imean >= FinalSize(z)-1; %when within 1 of the final value
    [C Index] = max(maska);
    MLa(z) = Index; %T1
%close(fighistSpRun); close(fighistRecovered); close(fighistSusceptible); close(fighistpeakValue); close(fighistpeakTime);
%close(fighistBeta); close(fighistGamma); close(fighistBetanew); close(fighistGammanew); 
%close(figInfectedRun1);%close(figBetaRun1); %close(figGammaRun1); %close(figRoRun1); %close(figBetaGamma1); %close(figBetaGamma2); 
close all;
    text = ['done ' num2str(z) ' out of ' num2str(VRmax)];
    disp(text)
end    
%save outputs
FinalSizeDynamicYes1Gamma1_FVE = FinalSize(z);
TimeDynamicYes1Gamma1_FVE=MLa(z);
ImeanDynamicYes1Gamma1_FVE=ImeanN1(1:dec:end); %major outbreaks only
SmeanDynamicYes1Gamma1_FVE=SmeanN1(1:dec:end);
RmeanDynamicYes1Gamma1_FVE=RmeanN1(1:dec:end);
BmeanDynamicYes1Gamma1_FVE=BmeanN1(1:dec:end);
disp('done FV-E and blacklisting and recovery')

%*****************************************************
%**************************************************************
%GRAPHS
%blacklisting - 1 locus model
%1.no diversity
%2.no diversity and recovery
%3.static diversity
%4.static diversity with recovery
%5.dynamic diversity FV-T
%6.dynamic diversity with recovery FV-T
%7.dynamic diversity with blacklisting FV-T
%8.dynamic diversity with blacklisting and recovery FV-T
%9.FS with blacklisting 10 encounter update
%10.FS with blacklisting 10 encounter update and recovery
%11.FV-E with blacklisting 10 encounter update
%12.FV-E with blacklisting 10 encounter update and recovery
time = 1:dec:numTimesteps;

%All
figure %VR=5 Imean
plot(time,ImeanVR1,'k', 'Linewidth', 2) %no diversity
hold on
plot(time,ImeanVR1R,'k--', 'Linewidth', 2) %no diversity with recovery
plot(time,ImeanStatic,'r') %static
plot(time,ImeanStaticR,'r--') %static and recovery
plot(time,ImeanDynamic,'b') %dynamic diversity
plot(time,ImeanDynamicR,'b--') %dynamic diversity and recovery
plot(time,ImeanDynamicYes1,'g') %dynamic diversity and blacklisting
plot(time,ImeanDynamicYes1Gamma1,'g--') %dynamic diversity and blacklisting and recovery
plot(time,ImeanDynamicYes1_FS,'c') %dynamic diversity and blacklisting
plot(time,ImeanDynamicYes1Gamma1_FS,'c--') %dynamic diversity and blacklisting and recovery
plot(time,ImeanDynamicYes1_FVE,'m') %dynamic diversity and blacklisting
plot(time,ImeanDynamicYes1Gamma1_FVE,'m--') %dynamic diversity and blacklisting and recovery
legend('no diversity','no diversity and recovery','static','static with recovery',...
    'Random (Time)', 'Random (Time) with recovery','Random (Time) - blklist0.001', 'Random (Time) - blklist0.001 recovery0.001') 
xlabel('Time (seconds)')
ylabel('Size of Epidemic - All')

%1.no diversity
figure 
plot(time,SmeanVR1,'b')
hold on
plot(time,ImeanVR1,'r')
plot(time,RmeanVR1,'g')
plot(time,BmeanVR1,'b--')
legend('Susceptible', 'Infected','Recovered', 'Blacklisting') 
xlabel('Time (seconds)')
ylabel('Size of Epidemic -no diversity')

%2.no diversity and recovery
figure
plot(time,SmeanVR1R,'b')
hold on
plot(time,ImeanVR1R,'r')
plot(time,RmeanVR1R,'g')
plot(time,BmeanVR1R,'b--')
legend('Susceptible', 'Infected','Recovered', 'Blacklisting') 
xlabel('Time (seconds)')
ylabel('Size of Epidemic -no diversity with recovery')

%3.static diversity
figure
plot(time,SmeanStatic,'b')
hold on
plot(time,ImeanStatic,'r')
plot(time,RmeanStatic,'g')
plot(time,BmeanStatic,'b--')
legend('Susceptible', 'Infected','Recovered', 'Blacklisting') 
xlabel('Time (seconds)')
ylabel('Size of Epidemic -static')

%4.static diversity with recovery
figure
plot(time,SmeanStaticR,'b')
hold on
plot(time,ImeanStaticR,'r')
plot(time,RmeanStaticR,'g')
plot(time,BmeanStaticR,'b--')
legend('Susceptible', 'Infected','Recovered', 'Blacklisting') 
xlabel('Time (seconds)')
ylabel('Size of Epidemic -static with recovery')

%5.dynamic diversity
figure %VR=5 Imean
plot(time,SmeanDynamic,'b')
hold on
plot(time,ImeanDynamic,'r')
plot(time,RmeanDynamic,'g')
plot(time,BmeanDynamic,'b--')
legend('Susceptible', 'Infected','Recovered', 'Blacklisting') 
xlabel('Time (seconds)')
ylabel('Size of Epidemic dynamic')

%6.dynamic diversity with recovery
figure %VR=5 Imean
plot(time,SmeanDynamicR,'b')
hold on
plot(time,ImeanDynamicR,'r')
plot(time,RmeanDynamicR,'g')
plot(time,BmeanDynamicR,'b--')
legend('Susceptible', 'Infected','Recovered', 'Blacklisting') 
xlabel('Time (seconds)')
ylabel('Size of Epidemic dynamic and recovery')


%7.dynamic diversity with blacklisting
figure %VR=5 Imean
plot(time,SmeanDynamicYes1,'b')
hold on
plot(time,ImeanDynamicYes1,'r')
plot(time,RmeanDynamicYes1,'g')
plot(time,BmeanDynamicYes1,'b--')
legend('Susceptible', 'Infected','Recovered', 'Blacklisting') 
xlabel('Time (seconds)')
ylabel('Size of Epidemic dynamic blklist')

%8.dynamic diversity with blacklisting and recovery
figure %VR=5 Imean
plot(time,SmeanDynamicYes1Gamma1,'b')
hold on
plot(time,ImeanDynamicYes1Gamma1,'r')
plot(time,RmeanDynamicYes1Gamma1,'g')
plot(time,BmeanDynamicYes1Gamma1,'b--')
legend('Susceptible', 'Infected','Recovered', 'Blacklisting') 
xlabel('Time (seconds)')
ylabel('Size of Epidemic dynamic and blklist and recovery')

%using data generated from test22
%blacklisting - 1 locus model
%1.no diversity
%2.no diversity and recovery
%3.static diversity
%4.static diversity with recovery
%5.dynamic diversity (RV-T)
%6.dynamic diversity with recovery (RV-T)
%7.dynamic diversity with blacklisting (RV-T)
%8.dynamic diversity with blacklisting and recovery (RV-T)

%VR=5
FinalSizeVR1
TimeVR1

FinalSizeVR1R
TimeVR1R

FinalSizeStatic
TimeStatic

FinalSizeStaticR
TimeStaticR

FinalSizeDynamic
TimeDynamic

FinalSizeDynamicR
TimeDynamicR

FinalSizeDynamicYes1
TimeDynamicYes1

FinalSizeDynamicYes1Gamma1
TimeDynamicYes1Gamma1

FinalSizeDynamicYes1_FS
TimeDynamicYes1_FS

FinalSizeDynamicYes1Gamma1_FS
TimeDynamicYes1Gamma1_FS

FinalSizeDynamicYes1_FVE
TimeDynamicYes1_FVE

FinalSizeDynamicYes1Gamma1_FVE
TimeDynamicYes1Gamma1_FVE

%from test 21 - 20 runs (testRandomGenotypesMore - test1)
%static stochastic approximation
Resistancesappr_1locus =[0.0070    0.5537    0.7747    0.9072    1.0000    1.0000    1.0000    1.0000    1.0000    1.0000];
%static agent
Resistance_static_1locus = [7.345679e-003 5.401014e-001 7.836053e-001 8.937895e-001 9.332500e-001 1 1 1 1 1];
%dynamic - every timestep
Resistancea_dynamic_1locus = [0.006977 0.09773 0.3118 0.6174 0.8184 1 1 1 1 1];
%Dynamic-random - every encounter
Resistancea_01_1locus = [0.006977 0.1172 0.3297 0.6725 0.936 1 1 1 1 1];
%Dynamic-random - every 10th encounter
Resistancea_10_1locus =[0.0071    0.2024    0.4396    0.6510    0.7565   1.0000    1.0000    1.0000    1.0000    1.0000];
%Dynamic-random - every 20th encounter
Resistancea_20_1locus =[0.0074    0.2844    0.5202    0.7510    1.0000   1.0000    1.0000    1.0000    1.0000    1.0000];
%Dynamic-random - every 30th encounter
Resistancea_30_1locus =[0.0079    0.3201    0.5748    0.7403    0.9300    1.0000    1.0000    1.0000    1.0000    1.0000];
%Dynamic-random - every 50th encounter
Resistancea_50_1locus = [0.0079    0.4073    0.6683    0.8165    0.8530    1.0000    1.0000    1.0000    1.0000    1.0000];
%Dynamic-favscore - every 1 encounter
FavResistancea_01_1locus = [0.0072    0.1192    0.3433    0.7180    0.8710   1.0000    1.0000    1.0000    1.0000    1.0000];
%Dynamic-favscore - every 10 encounter
FavResistancea_10_1locus =[0.0065    0.2083    0.4111    0.7734    0.8220    1.0000    1.0000    1.0000    1.0000    1.0000];
%Dynamic-favscore - every 20 encounter
FavResistancea_20_1locus =[0.0075    0.2970    0.5262    0.7980    0.9140   1.0000    1.0000    1.0000    1.0000    1.0000];
%Dynamic-favscore - every 50 encounter
FavResistancea_50_1locus =[0.0071    0.4285    0.6300    0.8187    0.8900   1.0000    1.0000    1.0000    1.0000    1.0000];
%WITH BLACKLISTING DATA
%VR1
%FinalSizeVR1 =        1000
%TimeVR1 =   770
%FinalSizeVR1R =  389.9500
%TimeVR1R =   566
%FinalSizeStatic =        1000
%TimeStatic =   786
%FinalSizeStaticR =  993.3333
%TimeStaticR =     1
%FinalSizeDynamic =        1000
%TimeDynamic =   793
%FinalSizeDynamicR =  991.8667
%TimeDynamicR =     1
%FinalSizeDynamicYes1 =        1000
%TimeDynamicYes1 =   741
%FinalSizeDynamicYes1Gamma1 =  993.6111
%TimeDynamicYes1Gamma1 =     1
%FinalSizeDynamicYes1_FS =        1000
%TimeDynamicYes1_FS =   787
%FinalSizeDynamicYes1Gamma1_FS =  992.8571
%TimeDynamicYes1Gamma1_FS =     1
%FinalSizeDynamicYes1_FVE =        1000
%TimeDynamicYes1_FVE =   911
%FinalSizeDynamicYes1Gamma1_FVE =  992.1250
%TimeDynamicYes1Gamma1_FVE =     1
%VR2
%FinalSizeVR1 =        1000
%TimeVR1 =   811
%FinalSizeVR1R =  369.8500
%TimeVR1R =   570
%FinalSizeStatic =  499.7000
%TimeStatic =        1499
%FinalSizeStaticR =  442.5000
%TimeStaticR =     1
%FinalSizeDynamic =        1000
%TimeDynamic =        1519
%FinalSizeDynamicR =  892.5556
%TimeDynamicR =     1
%FinalSizeDynamicYes1 =     7
%TimeDynamicYes1 =   637
%FinalSizeDynamicYes1Gamma1 =     0
%TimeDynamicYes1Gamma1 =     1
%FinalSizeDynamicYes1_FS =  993.4500
%TimeDynamicYes1_FS =        6868
%FinalSizeDynamicYes1Gamma1_FS =   79.6667
%TimeDynamicYes1Gamma1_FS =     1
%FinalSizeDynamicYes1_FVE =   10.5500
%TimeDynamicYes1_FVE =   686
%FinalSizeDynamicYes1Gamma1_FVE =     0
%TimeDynamicYes1Gamma1_FVE =     1
%VR3
%FinalSizeVR1 =   1000
%TimeVR1 =   806
%FinalSizeVR1R =  356.7500
%TimeVR1R =   514
%FinalSizeStatic =  334.4000
%TimeStatic =        2005
%FinalSizeStaticR =  234.4444
%TimeStaticR =     1
%FinalSizeDynamic =        1000
%TimeDynamic =        2574
%FinalSizeDynamicR =  684.1000
%TimeDynamicR =     1
%FinalSizeDynamicYes1 =    5.0500
%TimeDynamicYes1 =   496
%FinalSizeDynamicYes1Gamma1 =     0
%TimeDynamicYes1Gamma1 =     1
%FinalSizeDynamicYes1_FS =    5.6500
%TimeDynamicYes1_FS =   566
%FinalSizeDynamicYes1Gamma1_FS =     0
%TimeDynamicYes1Gamma1_FS =     1
%FinalSizeDynamicYes1_FVE =    4.7500
%TimeDynamicYes1_FVE =   511
%FinalSizeDynamicYes1Gamma1_FVE =     0
%TimeDynamicYes1Gamma1_FVE =     1
%VR4
%FinalSizeVR1 =        1000
%TimeVR1 =   756
%FinalSizeVR1R =  319.6000
%TimeVR1R =   601
%FinalSizeStatic =  250.4000
%TimeStatic =        2963
%FinalSizeStaticR =  129.5000
%TimeStaticR =     1
%FinalSizeDynamic =        1000
%TimeDynamic =        3051
%FinalSizeDynamicR =  442.7500
%TimeDynamicR =     1
%FinalSizeDynamicYes1 =    3.2000
%TimeDynamicYes1 =   314
%FinalSizeDynamicYes1Gamma1 =     0
%TimeDynamicYes1Gamma1 =     1
%FinalSizeDynamicYes1_FS =    4.9500
%TimeDynamicYes1_FS =   349
%FinalSizeDynamicYes1Gamma1_FS =     0
%TimeDynamicYes1Gamma1_FS =     1
%FinalSizeDynamicYes1_FVE =    3.9000
%TimeDynamicYes1_FVE =   337
%FinalSizeDynamicYes1Gamma1_FVE =     0
%TimeDynamicYes1Gamma1_FVE =     1
%VR5
%FinalSizeVR1 =        1000
%TimeVR1 =   748
%FinalSizeVR1R =  316.3500
%TimeVR1R =   559
%FinalSizeStatic =  198.2500
%TimeStatic =        3538
%FinalSizeStaticR =     0
%TimeStaticR =     1
%FinalSizeDynamic =        1000
%TimeDynamic =        3550
%FinalSizeDynamicR =  128.6667
%TimeDynamicR =     1
%FinalSizeDynamicYes1 =    2.7500
%TimeDynamicYes1 =   163
%FinalSizeDynamicYes1Gamma1 =     0
%TimeDynamicYes1Gamma1 =     1
%FinalSizeDynamicYes1_FS =    2.7000
%TimeDynamicYes1_FS =   251
%FinalSizeDynamicYes1Gamma1_FS =     0
%TimeDynamicYes1Gamma1_FS =     1
%FinalSizeDynamicYes1_FVE =    3.2500
%TimeDynamicYes1_FVE =   300
%FinalSizeDynamicYes1Gamma1_FVE =     0
%TimeDynamicYes1Gamma1_FVE =     1
%Resistance
%dynamic both

FinalSizeVR1 =  (numNodes-[  1000    1000 1000 1000 1000])./numNodes;%1.no diversity
TimeVR1 =   [770 811 806 756 748];
FinalSizeVR1R =  (numNodes-[389.9500 369.8500 356.7500 319.6000 316.3500])./numNodes;%2.no diversity and recovery
TimeVR1R =   [566 570 514 601 559];
FinalSizeStatic = (numNodes-[ 1000 499.7000 334.4000 250.4000 198.2500])./numNodes;%3.static diversity
TimeStatic =   [ 786 1499 2005 2963 3538];
FinalSizeStaticR = (numNodes-[ 993.3333 442.5000 234.4444 129.5000 0 ])./numNodes;%4.static diversity with recovery
TimeStaticR =  [ 1 1 1 1 1];
FinalSizeDynamic =  (numNodes-[ 1000 1000 1000 1000 1000])./numNodes;%5.dynamic diversity FV-T
TimeDynamic =    [ 793  1519 2574 3051 3550];
FinalSizeDynamicR = (numNodes-[ 991.8667 892.5556 684.1000 442.7500 128.6667])./numNodes;%6.dynamic diversity with recovery FV-T
TimeDynamicR =    [1 1 1 1 1];
FinalSizeDynamicYes1 =    (numNodes-[ 1000 7 5.0500 3.2000 2.75])./numNodes;%7.dynamic diversity with blacklisting FV-T
TimeDynamicYes1 =   [741 637 496 314 163];
FinalSizeDynamicYes1Gamma1 =    (numNodes-[ 993.6111 0 0 0 0])./numNodes;%8.dynamic diversity with blacklisting and recovery FV-T
TimeDynamicYes1Gamma1 =    [1 1 1 1 1];
FinalSizeDynamicYes1_FS =  (numNodes-[1000 993.4500 5.6500 4.9500 2.7])./numNodes;%9.FS with blacklisting 10 encounter update
TimeDynamicYes1_FS =       [787 6868 566 349 251];
FinalSizeDynamicYes1Gamma1_FS =   (numNodes-[992.8571 79.6667 0 0 0])./numNodes;%10.FS with blacklisting 10 encounter update and recovery
TimeDynamicYes1Gamma1_FS =     [1 1 1 1 1];
FinalSizeDynamicYes1_FVE =   (numNodes-[1000 10.5500 4.7500 3.9 3.25])./numNodes;%11.FV-E with blacklisting 10 encounter update
TimeDynamicYes1_FVE =   [911 686 511 337 300];
FinalSizeDynamicYes1Gamma1_FVE =     (numNodes-[992.1250 0 0 0 0])./numNodes;%12.FV-E with blacklisting 10 encounter update and recovery
TimeDynamicYes1Gamma1_FVE =     [1 1 1 1 1];

figure
plot(Resistancesappr_1locus(1:8),'k+-')
hold on
plot(Resistance_static_1locus(1:8),'ko-')
plot(Resistancea_dynamic_1locus(1:8),'ks-')
plot(FinalSizeVR1,'r')%1.no diversity
plot(FinalSizeVR1R,'g')%2.no diversity and recovery
plot(FinalSizeStatic,'b')%3.static diversity
plot(FinalSizeStaticR,'r--')%4.static diversity with recovery
plot(FinalSizeDynamic,'g--')%5.dynamic diversity FV-T
plot(FinalSizeDynamicR,'b--') %6.dynamic diversity with recovery FV-T
plot(FinalSizeDynamicYes1,'r.-') %7.dynamic diversity with blacklisting FV-T
plot(FinalSizeDynamicYes1Gamma1,'g.-')%8.dynamic diversity with blacklisting and recovery FV-T
plot(FinalSizeDynamicYes1_FS,'b.-') %9.FS with blacklisting 10 encounter update
plot(FinalSizeDynamicYes1Gamma1_FS,'c')%10.FS with blacklisting 10 encounter update and recovery
plot(FinalSizeDynamicYes1_FVE,'m') %11.FV-E with blacklisting 10 encounter update
plot(FinalSizeDynamicYes1Gamma1_FVE,'c--') %12.FV-E with blacklisting 10 encounter update and recovery
plot([5 5],[0 1],'k--')
xlabel('Variant Richness')
ylabel('Resistance')
legend('Stochastic approx - static', 'Agent static', 'Agent dynamic')
title('Resistance - 1 loci All')


figure
plot(Resistancesappr_1locus(1:8),'k+-')
hold on
plot(Resistance_static_1locus(1:8),'ko-')
plot(Resistancea_dynamic_1locus(1:8),'ks-')
plot(FinalSizeVR1,'r')%1.no diversity
plot(FinalSizeStatic,'g')%3.static diversity
plot(FinalSizeDynamic,'b')%5.dynamic diversity FV-T
plot(FinalSizeDynamicYes1,'r--') %7.dynamic diversity with blacklisting FV-T
plot(FinalSizeDynamicYes1_FS,'g--') %9.FS with blacklisting 10 encounter update
plot(FinalSizeDynamicYes1_FVE,'b--') %11.FV-E with blacklisting 10 encounter update
plot([5 5],[0 1],'k--')
xlabel('Variant Richness')
ylabel('Resistance')
legend('Stochastic approx - static', 'Agent static', 'Agent dynamic')
title('Resistance - blacklisting')


toc
end






















if doSIRNTests(21) == 1
%1 locus model
%outputDirectory = 'randomGenotypesGraphs\' %
%outputDirectory = 'Graphs\'
%Increase variants upto 10, fix exploit
%***************************************
%SIRN testing
%All need to start with maximum diverse  - set genotypes to max
%I mean output at VR = 5, and compare to no diversity VR=1
%VR=5 static, dynamic
%VR=5 dynamic-random (1,10,20,50,100 encounter), dynamic-favscore (1,10,20,50,100 encounter)
%VR=1 static or dynamic as same
%***************************************
numRuns = 20 %100 %200
numTimesteps=7000
staticResistance = 200; %VR=5

modePar.blklist = 'no'; %yes or no
modePar.numToBlklist = 2
modePar.blklistrate = 0.01
dec = 100 %decimation of output data
tic
numNodes = 1000;
VRmin = 5 ;%1
VRmax = 5; %10
N=numNodes; Vmax = 1:VRmax;  G = Vmax.^2; %number genotypes
%for OR case
Sprop = SPExact1LociOR( 1, Vmax );
mode = 'static'; %mode - can be 'static' or 'dynamic' 'Dynamic-random' 'Dynamic-favScore'
%monte carlo random genotype SIR model

%set up diversity mode parameters
modePar.modeStr = mode;
modePar.numToConstrain = 0; %constain a number of nodes to 1 variant
modePar.stopUpdatingTime = 200000; %time at which to stop updating the genotypes
modePar.numEncountersBetweenUpdates = 1; % number of encounters between updates for random and favscore algorithms
modePar.bufferlength = 10; %length of genotype buffer for favscore algorithm
modePar.genoInit = 'maxdiv';  %initial conditions of genotypes maxdiv (maximum diversity - random variant chosen) mindiv (minimum diversity - all nodes same)

for z= VRmin:VRmax
 betan = 0.02; variantRichness =  z;   plotGraphs = 1; gamma = 0; numExploits=1; numLoci=1; casetype = 'OR'; throwAway = 'nonEpidemics', cutoff = gamma.*numNodes./(betan.*Sprop); SEpidemic=60; %cutoff;
%agent
 [figMeanNei(z) figNeiOneRun(z) fighistSpRun(z) fighistRecovered(z) fighistSusceptible(z) fighistpeakValue(z) fighistpeakTime(z) fighistBeta(z) fighistGamma(z) fighistBetanew(z) fighistGammanew(z) figInfectedRun1 figBetaRun1 figGammaRun1 figRoRun1 figBetaGamma1 figBetaGamma2...
            meanNeiIndexDynamicF  betastd gammastd betastd2 betastdNew betastdNew2 gammastdNew peakTimemean peakTimestd peakValuemean peakValuestd...
            betameanmean(z) gammameanmean betameanmean2(z) betameanmeanNew(z) betameanmeanNew2 gammameanmeanNew(z) Smean(z,:) Imean Rmean(z,:) NSmean(z,:) Smedian Imedian Rmedian S I R NS SmeanN ImeanN1(z,:) RmeanN1 Snewendmean Snewendstd Rnewendmean(z) Rnewendstd(z) Rnew_nonendmean Rnew_nonendstd propSimsNonEp(z) propSimsNonEp_theoretical(z)...
            numRunsMinor(z) measuredProbMinor(z) numRunsMajor(z) measuredProbMajor(z) meanmdist meannumInfectedVM...
            ] = monteCarloSIRN2(numRuns,numNodes, betan, variantRichness, numTimesteps, plotGraphs,gamma,throwAway,SEpidemic,numExploits,modePar, numLoci, casetype);
FinalSize(z) = max(Imean,[],2); %mean final size SI

    %time
     maska = Imean >= FinalSize(z)-1; %when within 1 of the final value
    [C Index] = max(maska);
    MLa(z) = Index; %T1
    %staticResistance time
     maska = Imean >= staticResistance-1; %when within 1 of the final value
    [C Index] = max(maska);
    MLb(z) = Index; %T1
close all;
    
    text = ['done ' num2str(z) ' out of ' num2str(VRmax)];
    disp(text)
end    
%save outputs
FinalSizeStatic = FinalSize(z)
TimeStatic=MLa(z)
TimeStaticStatic=MLb(z)
ImeanStatic=Imean(1:dec:end)

disp('done static')

numNodes = 1000;
VRmin = 1; %1
VRmax = 1; %10
N=numNodes; Vmax = 1:VRmax;  G = Vmax.^2; %number genotypes
%for OR case
Sprop = SPExact1LociOR( 1, Vmax );
mode = 'static' %mode - can be 'static' or 'dynamic' 'Dynamic-random' 'Dynamic-favScore'
%monte carlo random genotype SIR model
%numRuns = 20 %100 %200
%set up diversity mode parameters
modePar.modeStr = mode;
modePar.numToConstrain = 0; %constain a number of nodes to 1 variant
modePar.stopUpdatingTime = 200000; %time at which to stop updating the genotypes
modePar.numEncountersBetweenUpdates = 1; % number of encounters between updates for random and favscore algorithms
modePar.bufferlength = 10; %length of genotype buffer for favscore algorithm
modePar.genoInit = 'maxdiv';  %initial conditions of genotypes maxdiv (maximum diversity - random variant chosen) mindiv (minimum diversity - all nodes same)

for z= VRmin:VRmax
 betan = 0.02; variantRichness =  z;   plotGraphs = 1; gamma = 0; numExploits=1; numLoci=1; casetype = 'OR'; throwAway = 'nonEpidemics', cutoff = gamma.*numNodes./(betan.*Sprop); SEpidemic=60; %cutoff;
%agent
 [figMeanNei(z) figNeiOneRun(z) fighistSpRun(z) fighistRecovered(z) fighistSusceptible(z) fighistpeakValue(z) fighistpeakTime(z) fighistBeta(z) fighistGamma(z) fighistBetanew(z) fighistGammanew(z) figInfectedRun1 figBetaRun1 figGammaRun1 figRoRun1 figBetaGamma1 figBetaGamma2...
            meanNeiIndexDynamicF  betastd gammastd betastd2 betastdNew betastdNew2 gammastdNew peakTimemean peakTimestd peakValuemean peakValuestd...
            betameanmean(z) gammameanmean betameanmean2(z) betameanmeanNew(z) betameanmeanNew2 gammameanmeanNew(z) Smean(z,:) Imean Rmean(z,:) NSmean(z,:) Smedian Imedian Rmedian S I R NS SmeanN ImeanN1(z,:) RmeanN1 Snewendmean Snewendstd Rnewendmean(z) Rnewendstd(z) Rnew_nonendmean Rnew_nonendstd propSimsNonEp(z) propSimsNonEp_theoretical(z)...
            numRunsMinor(z) measuredProbMinor(z) numRunsMajor(z) measuredProbMajor(z) meanmdist meannumInfectedVM...
            ] = monteCarloSIRN2(numRuns,numNodes, betan, variantRichness, numTimesteps, plotGraphs,gamma,throwAway,SEpidemic,numExploits,modePar, numLoci, casetype);
FinalSize(z) = max(Imean,[],2); %mean final size SI

    %time
     maska = Imean >= FinalSize(z)-1; %when within 1 of the final value
    [C Index] = max(maska);
    MLa(z) = Index %T1
        %staticResistance time
     maska = Imean >= staticResistance-1; %when within 1 of the final value
    [C Index] = max(maska);
    MLb(z) = Index; %T1

close all;
    
    text = ['done ' num2str(z) ' out of ' num2str(VRmax)];
    disp(text)
end    
%save outputs
FinalSizeVR1 = FinalSize(z)
TimeVR1=MLa(z)
TimeVR1Static=MLb(z)
ImeanVR1=Imean(1:dec:end)
disp('done VR1')

numNodes = 1000;
VRmin = 5; %1
VRmax = 5 ;%10
N=numNodes; Vmax = 1:VRmax;  G = Vmax.^2; %number genotypes
%for OR case
Sprop = SPExact1LociOR( 1, Vmax );
mode = 'dynamic'; %mode - can be 'static' or 'dynamic' 'Dynamic-random' 'Dynamic-favScore'
%monte carlo random genotype SIR model
%numRuns = 20; %100 %200
%set up diversity mode parameters
modePar.modeStr = mode;
modePar.numToConstrain = 0; %constain a number of nodes to 1 variant
modePar.stopUpdatingTime = 200000; %time at which to stop updating the genotypes
modePar.numEncountersBetweenUpdates = 1; % number of encounters between updates for random and favscore algorithms
modePar.bufferlength = 10; %length of genotype buffer for favscore algorithm
modePar.genoInit = 'maxdiv';  %initial conditions of genotypes maxdiv (maximum diversity - random variant chosen) mindiv (minimum diversity - all nodes same)


for z= VRmin:VRmax
 betan = 0.02; variantRichness =  z;   plotGraphs = 1; gamma = 0; numExploits=1; numLoci=1; casetype = 'OR'; throwAway = 'nonEpidemics', cutoff = gamma.*numNodes./(betan.*Sprop); SEpidemic=60; %cutoff;
%agent
 [figMeanNei(z) figNeiOneRun(z) fighistSpRun(z) fighistRecovered(z) fighistSusceptible(z) fighistpeakValue(z) fighistpeakTime(z) fighistBeta(z) fighistGamma(z) fighistBetanew(z) fighistGammanew(z) figInfectedRun1 figBetaRun1 figGammaRun1 figRoRun1 figBetaGamma1 figBetaGamma2...
            meanNeiIndexDynamicF  betastd gammastd betastd2 betastdNew betastdNew2 gammastdNew peakTimemean peakTimestd peakValuemean peakValuestd...
            betameanmean(z) gammameanmean betameanmean2(z) betameanmeanNew(z) betameanmeanNew2 gammameanmeanNew(z) Smean(z,:) Imean Rmean(z,:) NSmean(z,:) Smedian Imedian Rmedian S I R NS SmeanN ImeanN1(z,:) RmeanN1 Snewendmean Snewendstd Rnewendmean(z) Rnewendstd(z) Rnew_nonendmean Rnew_nonendstd propSimsNonEp(z) propSimsNonEp_theoretical(z)...
            numRunsMinor(z) measuredProbMinor(z) numRunsMajor(z) measuredProbMajor(z) meanmdist meannumInfectedVM...
            ] = monteCarloSIRN2(numRuns,numNodes, betan, variantRichness, numTimesteps, plotGraphs,gamma,throwAway,SEpidemic,numExploits,modePar, numLoci, casetype);
FinalSize(z) = max(Imean,[],2); %mean final size SI

    %time
     maska = Imean >= FinalSize(z)-1; %when within 1 of the final value
    [C Index] = max(maska);
    MLa(z) = Index %T1
            %staticResistance time
     maska = Imean >= staticResistance-1; %when within 1 of the final value
    [C Index] = max(maska);
    MLb(z) = Index; %T1

close all;
    
    text = ['done ' num2str(z) ' out of ' num2str(VRmax)];
    disp(text)
end    
%save outputs
FinalSizeDynamic = FinalSize(z)
TimeDynamic=MLa(z)
TimeDynamicStatic=MLb(z)
ImeanDynamic=Imean(1:dec:end)
disp('done dynamic')

numNodes = 1000;
VRmin = 5; %1
VRmax = 5; %10
N=numNodes; Vmax = 1:VRmax;  G = Vmax.^2; %number genotypes
%for OR case
Sprop = SPExact1LociOR( 1, Vmax );
mode = 'Dynamic-random'; %mode - can be 'static' or 'dynamic' 'Dynamic-random' 'Dynamic-favScore'
%monte carlo random genotype SIR model
%numRuns = 20; %100 %200
%set up diversity mode parameters
modePar.modeStr = mode;
modePar.numToConstrain = 0; %constain a number of nodes to 1 variant
modePar.stopUpdatingTime = 200000; %time at which to stop updating the genotypes
modePar.numEncountersBetweenUpdates = 1; % number of encounters between updates for random and favscore algorithms
modePar.bufferlength = 10; %length of genotype buffer for favscore algorithm
modePar.genoInit = 'maxdiv';  %initial conditions of genotypes maxdiv (maximum diversity - random variant chosen) mindiv (minimum diversity - all nodes same)


for z= VRmin:VRmax
 betan = 0.02; variantRichness =  z;   plotGraphs = 1; gamma = 0; numExploits=1; numLoci=1; casetype = 'OR'; throwAway = 'nonEpidemics', cutoff = gamma.*numNodes./(betan.*Sprop); SEpidemic=60; %cutoff;
%agent
 [figMeanNei(z) figNeiOneRun(z) fighistSpRun(z) fighistRecovered(z) fighistSusceptible(z) fighistpeakValue(z) fighistpeakTime(z) fighistBeta(z) fighistGamma(z) fighistBetanew(z) fighistGammanew(z) figInfectedRun1 figBetaRun1 figGammaRun1 figRoRun1 figBetaGamma1 figBetaGamma2...
            meanNeiIndexDynamicF  betastd gammastd betastd2 betastdNew betastdNew2 gammastdNew peakTimemean peakTimestd peakValuemean peakValuestd...
            betameanmean(z) gammameanmean betameanmean2(z) betameanmeanNew(z) betameanmeanNew2 gammameanmeanNew(z) Smean(z,:) Imean Rmean(z,:) NSmean(z,:) Smedian Imedian Rmedian S I R NS SmeanN ImeanN1(z,:) RmeanN1 Snewendmean Snewendstd Rnewendmean(z) Rnewendstd(z) Rnew_nonendmean Rnew_nonendstd propSimsNonEp(z) propSimsNonEp_theoretical(z)...
            numRunsMinor(z) measuredProbMinor(z) numRunsMajor(z) measuredProbMajor(z) meanmdist meannumInfectedVM...
            ] = monteCarloSIRN2(numRuns,numNodes, betan, variantRichness, numTimesteps, plotGraphs,gamma,throwAway,SEpidemic,numExploits,modePar, numLoci, casetype);
FinalSize(z) = max(Imean,[],2); %mean final size SI

    %time
     maska = Imean >= FinalSize(z)-1; %when within 1 of the final value
    [C Index] = max(maska);
    MLa(z) = Index %T1
                %staticResistance time
     maska = Imean >= staticResistance-1; %when within 1 of the final value
    [C Index] = max(maska);
    MLb(z) = Index; %T1
close all;
    
    text = ['done ' num2str(z) ' out of ' num2str(VRmax)];
    disp(text)
end    
%save outputs
FinalSizeDynamicRandom1 = FinalSize(z)
TimeDynamicRandom1=MLa(z)
TimeDynamicRandom1Static=MLb(z)
ImeanDynamicRandom1=Imean(1:dec:end)
disp('done Dynamic-random-1')

%**********************
numNodes = 1000;
VRmin = 5; %1
VRmax = 5; %10
N=numNodes; Vmax = 1:VRmax;  G = Vmax.^2; %number genotypes
%for OR case
Sprop = SPExact1LociOR( 1, Vmax );
mode = 'Dynamic-random' %mode - can be 'static' or 'dynamic' 'Dynamic-random' 'Dynamic-favScore'
%monte carlo random genotype SIR model
%numRuns = 20 %100 %200
%set up diversity mode parameters
modePar.modeStr = mode;
modePar.numToConstrain = 0; %constain a number of nodes to 1 variant
modePar.stopUpdatingTime = 200000; %time at which to stop updating the genotypes
modePar.numEncountersBetweenUpdates = 10; % number of encounters between updates for random and favscore algorithms
modePar.bufferlength = 10; %length of genotype buffer for favscore algorithm
modePar.genoInit = 'maxdiv';  %initial conditions of genotypes maxdiv (maximum diversity - random variant chosen) mindiv (minimum diversity - all nodes same)


for z= VRmin:VRmax
 betan = 0.02; variantRichness =  z;   plotGraphs = 1; gamma = 0; numExploits=1; numLoci=1; casetype = 'OR'; throwAway = 'nonEpidemics', cutoff = gamma.*numNodes./(betan.*Sprop); SEpidemic=60; %cutoff;
%agent
 [figMeanNei(z) figNeiOneRun(z) fighistSpRun(z) fighistRecovered(z) fighistSusceptible(z) fighistpeakValue(z) fighistpeakTime(z) fighistBeta(z) fighistGamma(z) fighistBetanew(z) fighistGammanew(z) figInfectedRun1 figBetaRun1 figGammaRun1 figRoRun1 figBetaGamma1 figBetaGamma2...
            meanNeiIndexDynamicF  betastd gammastd betastd2 betastdNew betastdNew2 gammastdNew peakTimemean peakTimestd peakValuemean peakValuestd...
            betameanmean(z) gammameanmean betameanmean2(z) betameanmeanNew(z) betameanmeanNew2 gammameanmeanNew(z) Smean(z,:) Imean Rmean(z,:) NSmean(z,:) Smedian Imedian Rmedian S I R NS SmeanN ImeanN1(z,:) RmeanN1 Snewendmean Snewendstd Rnewendmean(z) Rnewendstd(z) Rnew_nonendmean Rnew_nonendstd propSimsNonEp(z) propSimsNonEp_theoretical(z)...
            numRunsMinor(z) measuredProbMinor(z) numRunsMajor(z) measuredProbMajor(z) meanmdist meannumInfectedVM...
            ] = monteCarloSIRN2(numRuns,numNodes, betan, variantRichness, numTimesteps, plotGraphs,gamma,throwAway,SEpidemic,numExploits,modePar, numLoci, casetype);
FinalSize(z) = max(Imean,[],2) %mean final size SI

    %time
     maska = Imean >= FinalSize(z)-1; %when within 1 of the final value
    [C Index] = max(maska);
    MLa(z) = Index %T1
     %staticResistance time
     maska = Imean >= staticResistance-1; %when within 1 of the final value
    [C Index] = max(maska);
    MLb(z) = Index; %T1
close all;
    
    text = ['done ' num2str(z) ' out of ' num2str(VRmax)];
    disp(text)
end    
%save outputs
FinalSizeDynamicRandom10 = FinalSize(z)
TimeDynamicRandom10=MLa(z)
TimeDynamicRandom10Static=MLb(z)
ImeanDynamicRandom10=Imean(1:dec:end)
disp('done Dynamic-random-10')

%**********************
numNodes = 1000;
VRmin = 5; %1
VRmax = 5; %10
N=numNodes; Vmax = 1:VRmax;  G = Vmax.^2; %number genotypes
%for OR case
Sprop = SPExact1LociOR( 1, Vmax );
mode = 'Dynamic-random' %mode - can be 'static' or 'dynamic' 'Dynamic-random' 'Dynamic-favScore'
%monte carlo random genotype SIR model
%numRuns = 20 %100 %200
%set up diversity mode parameters
modePar.modeStr = mode;
modePar.numToConstrain = 0; %constain a number of nodes to 1 variant
modePar.stopUpdatingTime = 200000; %time at which to stop updating the genotypes
modePar.numEncountersBetweenUpdates = 20; % number of encounters between updates for random and favscore algorithms
modePar.bufferlength = 10; %length of genotype buffer for favscore algorithm
modePar.genoInit = 'maxdiv';  %initial conditions of genotypes maxdiv (maximum diversity - random variant chosen) mindiv (minimum diversity - all nodes same)


for z= VRmin:VRmax
 betan = 0.02; variantRichness =  z;   plotGraphs = 1; gamma = 0; numExploits=1; numLoci=1; casetype = 'OR'; throwAway = 'nonEpidemics', cutoff = gamma.*numNodes./(betan.*Sprop); SEpidemic=60; %cutoff;
%agent
 [figMeanNei(z) figNeiOneRun(z) fighistSpRun(z) fighistRecovered(z) fighistSusceptible(z) fighistpeakValue(z) fighistpeakTime(z) fighistBeta(z) fighistGamma(z) fighistBetanew(z) fighistGammanew(z) figInfectedRun1 figBetaRun1 figGammaRun1 figRoRun1 figBetaGamma1 figBetaGamma2...
            meanNeiIndexDynamicF  betastd gammastd betastd2 betastdNew betastdNew2 gammastdNew peakTimemean peakTimestd peakValuemean peakValuestd...
            betameanmean(z) gammameanmean betameanmean2(z) betameanmeanNew(z) betameanmeanNew2 gammameanmeanNew(z) Smean(z,:) Imean Rmean(z,:) NSmean(z,:) Smedian Imedian Rmedian S I R NS SmeanN ImeanN1(z,:) RmeanN1 Snewendmean Snewendstd Rnewendmean(z) Rnewendstd(z) Rnew_nonendmean Rnew_nonendstd propSimsNonEp(z) propSimsNonEp_theoretical(z)...
            numRunsMinor(z) measuredProbMinor(z) numRunsMajor(z) measuredProbMajor(z) meanmdist meannumInfectedVM...
            ] = monteCarloSIRN2(numRuns,numNodes, betan, variantRichness, numTimesteps, plotGraphs,gamma,throwAway,SEpidemic,numExploits,modePar, numLoci, casetype);
FinalSize(z) = max(Imean,[],2) %mean final size SI

    %time
     maska = Imean >= FinalSize(z)-1; %when within 1 of the final value
    [C Index] = max(maska);
    MLa(z) = Index %T1
     %staticResistance time
     maska = Imean >= staticResistance-1; %when within 1 of the final value
    [C Index] = max(maska);
    MLb(z) = Index; %T1
close all;
    
    text = ['done ' num2str(z) ' out of ' num2str(VRmax)];
    disp(text)
end    
%save outputs
FinalSizeDynamicRandom20 = FinalSize(z)
TimeDynamicRandom20=MLa(z)
TimeDynamicRandom20Static=MLb(z)
ImeanDynamicRandom20=Imean(1:dec:end)
disp('done Dynamic-random-20')
%**********************
numNodes = 1000;
VRmin = 5; %1
VRmax = 5; %10
N=numNodes; Vmax = 1:VRmax;  G = Vmax.^2; %number genotypes
%for OR case
Sprop = SPExact1LociOR( 1, Vmax );
mode = 'Dynamic-random' %mode - can be 'static' or 'dynamic' 'Dynamic-random' 'Dynamic-favScore'
%monte carlo random genotype SIR model
%numRuns = 20 %100 %200
%set up diversity mode parameters
modePar.modeStr = mode;
modePar.numToConstrain = 0; %constain a number of nodes to 1 variant
modePar.stopUpdatingTime = 200000; %time at which to stop updating the genotypes
modePar.numEncountersBetweenUpdates = 50; % number of encounters between updates for random and favscore algorithms
modePar.bufferlength = 10; %length of genotype buffer for favscore algorithm
modePar.genoInit = 'maxdiv';  %initial conditions of genotypes maxdiv (maximum diversity - random variant chosen) mindiv (minimum diversity - all nodes same)


for z= VRmin:VRmax
 betan = 0.02; variantRichness =  z;   plotGraphs = 1; gamma = 0; numExploits=1; numLoci=1; casetype = 'OR'; throwAway = 'nonEpidemics', cutoff = gamma.*numNodes./(betan.*Sprop); SEpidemic=60; %cutoff;
%agent
 [figMeanNei(z) figNeiOneRun(z) fighistSpRun(z) fighistRecovered(z) fighistSusceptible(z) fighistpeakValue(z) fighistpeakTime(z) fighistBeta(z) fighistGamma(z) fighistBetanew(z) fighistGammanew(z) figInfectedRun1 figBetaRun1 figGammaRun1 figRoRun1 figBetaGamma1 figBetaGamma2...
            meanNeiIndexDynamicF  betastd gammastd betastd2 betastdNew betastdNew2 gammastdNew peakTimemean peakTimestd peakValuemean peakValuestd...
            betameanmean(z) gammameanmean betameanmean2(z) betameanmeanNew(z) betameanmeanNew2 gammameanmeanNew(z) Smean(z,:) Imean Rmean(z,:) NSmean(z,:) Smedian Imedian Rmedian S I R NS SmeanN ImeanN1(z,:) RmeanN1 Snewendmean Snewendstd Rnewendmean(z) Rnewendstd(z) Rnew_nonendmean Rnew_nonendstd propSimsNonEp(z) propSimsNonEp_theoretical(z)...
            numRunsMinor(z) measuredProbMinor(z) numRunsMajor(z) measuredProbMajor(z) meanmdist meannumInfectedVM...
            ] = monteCarloSIRN2(numRuns,numNodes, betan, variantRichness, numTimesteps, plotGraphs,gamma,throwAway,SEpidemic,numExploits,modePar, numLoci, casetype);
FinalSize(z) = max(Imean,[],2) %mean final size SI

    %time
     maska = Imean >= FinalSize(z)-1; %when within 1 of the final value
    [C Index] = max(maska);
    MLa(z) = Index %T1
         %staticResistance time
     maska = Imean >= staticResistance-1; %when within 1 of the final value
    [C Index] = max(maska);
    MLb(z) = Index; %T1
close all;
    
    text = ['done ' num2str(z) ' out of ' num2str(VRmax)];
    disp(text)
end    
%save outputs
FinalSizeDynamicRandom50 = FinalSize(z)
TimeDynamicRandom50=MLa(z)
TimeDynamicRandom50Static=MLb(z)
ImeanDynamicRandom50=Imean(1:dec:end)
disp('done Dynamic-random-50')

%**********************
%**********************
numNodes = 1000;
VRmin = 5; %1
VRmax = 5; %10
N=numNodes; Vmax = 1:VRmax;  G = Vmax.^2; %number genotypes
%for OR case
Sprop = SPExact1LociOR( 1, Vmax );
mode = 'Dynamic-random' %mode - can be 'static' or 'dynamic' 'Dynamic-random' 'Dynamic-favScore'
%monte carlo random genotype SIR model
%numRuns = 20 %100 %200
%set up diversity mode parameters
modePar.modeStr = mode;
modePar.numToConstrain = 0; %constain a number of nodes to 1 variant
modePar.stopUpdatingTime = 200000; %time at which to stop updating the genotypes
modePar.numEncountersBetweenUpdates = 100; % number of encounters between updates for random and favscore algorithms
modePar.bufferlength = 10; %length of genotype buffer for favscore algorithm
modePar.genoInit = 'maxdiv';  %initial conditions of genotypes maxdiv (maximum diversity - random variant chosen) mindiv (minimum diversity - all nodes same)


for z= VRmin:VRmax
 betan = 0.02; variantRichness =  z;   plotGraphs = 1; gamma = 0; numExploits=1; numLoci=1; casetype = 'OR'; throwAway = 'nonEpidemics', cutoff = gamma.*numNodes./(betan.*Sprop); SEpidemic=60; %cutoff;
%agent
 [figMeanNei(z) figNeiOneRun(z) fighistSpRun(z) fighistRecovered(z) fighistSusceptible(z) fighistpeakValue(z) fighistpeakTime(z) fighistBeta(z) fighistGamma(z) fighistBetanew(z) fighistGammanew(z) figInfectedRun1 figBetaRun1 figGammaRun1 figRoRun1 figBetaGamma1 figBetaGamma2...
            meanNeiIndexDynamicF  betastd gammastd betastd2 betastdNew betastdNew2 gammastdNew peakTimemean peakTimestd peakValuemean peakValuestd...
            betameanmean(z) gammameanmean betameanmean2(z) betameanmeanNew(z) betameanmeanNew2 gammameanmeanNew(z) Smean(z,:) Imean Rmean(z,:) NSmean(z,:) Smedian Imedian Rmedian S I R NS SmeanN ImeanN1(z,:) RmeanN1 Snewendmean Snewendstd Rnewendmean(z) Rnewendstd(z) Rnew_nonendmean Rnew_nonendstd propSimsNonEp(z) propSimsNonEp_theoretical(z)...
            numRunsMinor(z) measuredProbMinor(z) numRunsMajor(z) measuredProbMajor(z) meanmdist meannumInfectedVM...
            ] = monteCarloSIRN2(numRuns,numNodes, betan, variantRichness, numTimesteps, plotGraphs,gamma,throwAway,SEpidemic,numExploits,modePar, numLoci, casetype);
FinalSize(z) = max(Imean,[],2) %mean final size SI

    %time
     maska = Imean >= FinalSize(z)-1; %when within 1 of the final value
    [C Index] = max(maska);
    MLa(z) = Index %T1
         %staticResistance time
     maska = Imean >= staticResistance-1; %when within 1 of the final value
    [C Index] = max(maska);
    MLb(z) = Index; %T1
close all;
    
    text = ['done ' num2str(z) ' out of ' num2str(VRmax)];
    disp(text)
end    
%save outputs
FinalSizeDynamicRandom100 = FinalSize(z)
TimeDynamicRandom100=MLa(z)
TimeDynamicRandom100Static=MLb(z)
ImeanDynamicRandom100=Imean(1:dec:end)
disp('done Dynamic-random-100')

%**********
numNodes = 1000;
VRmin = 5; %1
VRmax = 5; %10
N=numNodes; Vmax = 1:VRmax;  G = Vmax.^2; %number genotypes
%for OR case
Sprop = SPExact1LociOR( 1, Vmax );
mode = 'Dynamic-favScore'; %mode - can be 'static' or 'dynamic' 'Dynamic-random' 'Dynamic-favScore'
%monte carlo random genotype SIR model
%numRuns = 20 %100 %200
%set up diversity mode parameters
modePar.modeStr = mode;
modePar.numToConstrain = 0; %constain a number of nodes to 1 variant
modePar.stopUpdatingTime = 200000; %time at which to stop updating the genotypes
modePar.numEncountersBetweenUpdates = 1; % number of encounters between updates for random and favscore algorithms
modePar.bufferlength = 10; %length of genotype buffer for favscore algorithm
modePar.genoInit = 'maxdiv';  %initial conditions of genotypes maxdiv (maximum diversity - random variant chosen) mindiv (minimum diversity - all nodes same)


for z= VRmin:VRmax
 betan = 0.02; variantRichness =  z;   plotGraphs = 1; gamma = 0; numExploits=1; numLoci=1; casetype = 'OR'; throwAway = 'nonEpidemics', cutoff = gamma.*numNodes./(betan.*Sprop); SEpidemic=60; %cutoff;
%agent
 [figMeanNei(z) figNeiOneRun(z) fighistSpRun(z) fighistRecovered(z) fighistSusceptible(z) fighistpeakValue(z) fighistpeakTime(z) fighistBeta(z) fighistGamma(z) fighistBetanew(z) fighistGammanew(z) figInfectedRun1 figBetaRun1 figGammaRun1 figRoRun1 figBetaGamma1 figBetaGamma2...
            meanNeiIndexDynamicF  betastd gammastd betastd2 betastdNew betastdNew2 gammastdNew peakTimemean peakTimestd peakValuemean peakValuestd...
            betameanmean(z) gammameanmean betameanmean2(z) betameanmeanNew(z) betameanmeanNew2 gammameanmeanNew(z) Smean(z,:) Imean Rmean(z,:) NSmean(z,:) Smedian Imedian Rmedian S I R NS SmeanN ImeanN1(z,:) RmeanN1 Snewendmean Snewendstd Rnewendmean(z) Rnewendstd(z) Rnew_nonendmean Rnew_nonendstd propSimsNonEp(z) propSimsNonEp_theoretical(z)...
            numRunsMinor(z) measuredProbMinor(z) numRunsMajor(z) measuredProbMajor(z) meanmdist meannumInfectedVM...
            ] = monteCarloSIRN2(numRuns,numNodes, betan, variantRichness, numTimesteps, plotGraphs,gamma,throwAway,SEpidemic,numExploits,modePar, numLoci, casetype);
FinalSize(z) = max(Imean,[],2); %mean final size SI

    %time
     maska = Imean >= FinalSize(z)-1; %when within 1 of the final value
    [C Index] = max(maska);
    MLa(z) = Index; %T1
         %staticResistance time
     maska = Imean >= staticResistance-1; %when within 1 of the final value
    [C Index] = max(maska);
    MLb(z) = Index; %T1
 
close all;
    
    text = ['done ' num2str(z) ' out of ' num2str(VRmax)];
    disp(text)
end    
%save outputs
FinalSizeDynamicFavScore1 = FinalSize(z)
TimeDynamicFavScore1=MLa(z)
TimeDynamicFavScore1Static=MLb(z)
ImeanDynamicFavScore1=Imean(1:dec:end)
disp('done Dynamic-favscore-1')
%****************************
numNodes = 1000;
VRmin = 5; %1
VRmax = 5; %10
N=numNodes; Vmax = 1:VRmax;  G = Vmax.^2; %number genotypes
%for OR case
Sprop = SPExact1LociOR( 1, Vmax );
mode = 'Dynamic-favScore'; %mode - can be 'static' or 'dynamic' 'Dynamic-random' 'Dynamic-favScore'
%monte carlo random genotype SIR model
%numRuns = 20 %100 %200
%set up diversity mode parameters
modePar.modeStr = mode;
modePar.numToConstrain = 0; %constain a number of nodes to 1 variant
modePar.stopUpdatingTime = 200000; %time at which to stop updating the genotypes
modePar.numEncountersBetweenUpdates = 10; % number of encounters between updates for random and favscore algorithms
modePar.bufferlength = 10; %length of genotype buffer for favscore algorithm
modePar.genoInit = 'maxdiv';  %initial conditions of genotypes maxdiv (maximum diversity - random variant chosen) mindiv (minimum diversity - all nodes same)

for z= VRmin:VRmax
 betan = 0.02; variantRichness =  z;   plotGraphs = 1; gamma = 0; numExploits=1; numLoci=1; casetype = 'OR'; throwAway = 'nonEpidemics', cutoff = gamma.*numNodes./(betan.*Sprop); SEpidemic=60; %cutoff;
%agent
 [figMeanNei(z) figNeiOneRun(z) fighistSpRun(z) fighistRecovered(z) fighistSusceptible(z) fighistpeakValue(z) fighistpeakTime(z) fighistBeta(z) fighistGamma(z) fighistBetanew(z) fighistGammanew(z) figInfectedRun1 figBetaRun1 figGammaRun1 figRoRun1 figBetaGamma1 figBetaGamma2...
            meanNeiIndexDynamicF  betastd gammastd betastd2 betastdNew betastdNew2 gammastdNew peakTimemean peakTimestd peakValuemean peakValuestd...
            betameanmean(z) gammameanmean betameanmean2(z) betameanmeanNew(z) betameanmeanNew2 gammameanmeanNew(z) Smean(z,:) Imean Rmean(z,:) NSmean(z,:) Smedian Imedian Rmedian S I R NS SmeanN ImeanN1(z,:) RmeanN1 Snewendmean Snewendstd Rnewendmean(z) Rnewendstd(z) Rnew_nonendmean Rnew_nonendstd propSimsNonEp(z) propSimsNonEp_theoretical(z)...
            numRunsMinor(z) measuredProbMinor(z) numRunsMajor(z) measuredProbMajor(z) meanmdist meannumInfectedVM...
            ] = monteCarloSIRN2(numRuns,numNodes, betan, variantRichness, numTimesteps, plotGraphs,gamma,throwAway,SEpidemic,numExploits,modePar, numLoci, casetype);
FinalSize(z) = max(Imean,[],2) %mean final size SI

    %time
     maska = Imean >= FinalSize(z)-1; %when within 1 of the final value
    [C Index] = max(maska);
         %staticResistance time
     maska = Imean >= staticResistance-1; %when within 1 of the final value
    [C Index] = max(maska);
    MLb(z) = Index; %T1
close all;
    
    text = ['done ' num2str(z) ' out of ' num2str(VRmax)];
    disp(text)
end    
%save outputs
FinalSizeDynamicFavScore10 = FinalSize(z)
TimeDynamicFavScore10=MLa(z)
TimeDynamicFavScore10Static=MLb(z)
ImeanDynamicFavScore10=Imean(1:dec:end)
disp('done Dynamic-favscore-10')

%****************************
numNodes = 1000;
VRmin = 5; %1
VRmax = 5; %10
N=numNodes; Vmax = 1:VRmax;  G = Vmax.^2; %number genotypes
%for OR case
Sprop = SPExact1LociOR( 1, Vmax );
mode = 'Dynamic-favScore'; %mode - can be 'static' or 'dynamic' 'Dynamic-random' 'Dynamic-favScore'
%monte carlo random genotype SIR model
%numRuns = 20 %100 %200
%set up diversity mode parameters
modePar.modeStr = mode;
modePar.numToConstrain = 0; %constain a number of nodes to 1 variant
modePar.stopUpdatingTime = 200000; %time at which to stop updating the genotypes
modePar.numEncountersBetweenUpdates = 20; % number of encounters between updates for random and favscore algorithms
modePar.bufferlength = 10; %length of genotype buffer for favscore algorithm
modePar.genoInit = 'maxdiv';  %initial conditions of genotypes maxdiv (maximum diversity - random variant chosen) mindiv (minimum diversity - all nodes same)

for z= VRmin:VRmax
 betan = 0.02; variantRichness =  z;   plotGraphs = 1; gamma = 0; numExploits=1; numLoci=1; casetype = 'OR'; throwAway = 'nonEpidemics', cutoff = gamma.*numNodes./(betan.*Sprop); SEpidemic=60; %cutoff;
%agent
 [figMeanNei(z) figNeiOneRun(z) fighistSpRun(z) fighistRecovered(z) fighistSusceptible(z) fighistpeakValue(z) fighistpeakTime(z) fighistBeta(z) fighistGamma(z) fighistBetanew(z) fighistGammanew(z) figInfectedRun1 figBetaRun1 figGammaRun1 figRoRun1 figBetaGamma1 figBetaGamma2...
            meanNeiIndexDynamicF  betastd gammastd betastd2 betastdNew betastdNew2 gammastdNew peakTimemean peakTimestd peakValuemean peakValuestd...
            betameanmean(z) gammameanmean betameanmean2(z) betameanmeanNew(z) betameanmeanNew2 gammameanmeanNew(z) Smean(z,:) Imean Rmean(z,:) NSmean(z,:) Smedian Imedian Rmedian S I R NS SmeanN ImeanN1(z,:) RmeanN1 Snewendmean Snewendstd Rnewendmean(z) Rnewendstd(z) Rnew_nonendmean Rnew_nonendstd propSimsNonEp(z) propSimsNonEp_theoretical(z)...
            numRunsMinor(z) measuredProbMinor(z) numRunsMajor(z) measuredProbMajor(z) meanmdist meannumInfectedVM...
            ] = monteCarloSIRN2(numRuns,numNodes, betan, variantRichness, numTimesteps, plotGraphs,gamma,throwAway,SEpidemic,numExploits,modePar, numLoci, casetype);
FinalSize(z) = max(Imean,[],2) %mean final size SI

    %time
     maska = Imean >= FinalSize(z)-1; %when within 1 of the final value
    [C Index] = max(maska);
    MLa(z) = Index %T1
             %staticResistance time
     maska = Imean >= staticResistance-1; %when within 1 of the final value
    [C Index] = max(maska);
    MLb(z) = Index; %T1
close all;
    
    text = ['done ' num2str(z) ' out of ' num2str(VRmax)];
    disp(text)
end    
%save outputs
FinalSizeDynamicFavScore20 = FinalSize(z)
TimeDynamicFavScore20=MLa(z)
TimeDynamicFavScore20Static=MLb(z)
ImeanDynamicFavScore20=Imean(1:dec:end)
disp('done Dynamic-favscore-20')

%****************************
numNodes = 1000;
VRmin = 5; %1
VRmax = 5; %10
N=numNodes; Vmax = 1:VRmax;  G = Vmax.^2; %number genotypes
%for OR case
Sprop = SPExact1LociOR( 1, Vmax );
mode = 'Dynamic-favScore'; %mode - can be 'static' or 'dynamic' 'Dynamic-random' 'Dynamic-favScore'
%monte carlo random genotype SIR model
%numRuns = 20 %100 %200
%set up diversity mode parameters
modePar.modeStr = mode;
modePar.numToConstrain = 0; %constain a number of nodes to 1 variant
modePar.stopUpdatingTime = 200000; %time at which to stop updating the genotypes
modePar.numEncountersBetweenUpdates = 50; % number of encounters between updates for random and favscore algorithms
modePar.bufferlength = 10; %length of genotype buffer for favscore algorithm
modePar.genoInit = 'maxdiv';  %initial conditions of genotypes maxdiv (maximum diversity - random variant chosen) mindiv (minimum diversity - all nodes same)

for z= VRmin:VRmax
 betan = 0.02; variantRichness =  z;   plotGraphs = 1; gamma = 0; numExploits=1; numLoci=1; casetype = 'OR'; throwAway = 'nonEpidemics', cutoff = gamma.*numNodes./(betan.*Sprop); SEpidemic=60; %cutoff;
%agent
 [figMeanNei(z) figNeiOneRun(z) fighistSpRun(z) fighistRecovered(z) fighistSusceptible(z) fighistpeakValue(z) fighistpeakTime(z) fighistBeta(z) fighistGamma(z) fighistBetanew(z) fighistGammanew(z) figInfectedRun1 figBetaRun1 figGammaRun1 figRoRun1 figBetaGamma1 figBetaGamma2...
            meanNeiIndexDynamicF  betastd gammastd betastd2 betastdNew betastdNew2 gammastdNew peakTimemean peakTimestd peakValuemean peakValuestd...
            betameanmean(z) gammameanmean betameanmean2(z) betameanmeanNew(z) betameanmeanNew2 gammameanmeanNew(z) Smean(z,:) Imean Rmean(z,:) NSmean(z,:) Smedian Imedian Rmedian S I R NS SmeanN ImeanN1(z,:) RmeanN1 Snewendmean Snewendstd Rnewendmean(z) Rnewendstd(z) Rnew_nonendmean Rnew_nonendstd propSimsNonEp(z) propSimsNonEp_theoretical(z)...
            numRunsMinor(z) measuredProbMinor(z) numRunsMajor(z) measuredProbMajor(z) meanmdist meannumInfectedVM...
            ] = monteCarloSIRN2(numRuns,numNodes, betan, variantRichness, numTimesteps, plotGraphs,gamma,throwAway,SEpidemic,numExploits,modePar, numLoci, casetype);
FinalSize(z) = max(Imean,[],2) %mean final size SI

    %time
     maska = Imean >= FinalSize(z)-1; %when within 1 of the final value
    [C Index] = max(maska);
    MLa(z) = Index %T1
                 %staticResistance time
     maska = Imean >= staticResistance-1; %when within 1 of the final value
    [C Index] = max(maska);
    MLb(z) = Index; %T1
close all;
    
    text = ['done ' num2str(z) ' out of ' num2str(VRmax)];
    disp(text)
end    
%save outputs
FinalSizeDynamicFavScore50 = FinalSize(z)
TimeDynamicFavScore50=MLa(z)
TimeDynamicFavScore50Static=MLb(z)
ImeanDynamicFavScore50=Imean(1:dec:end)
disp('done Dynamic-favscore-50')

%****************************
numNodes = 1000;
VRmin = 5; %1
VRmax = 5; %10
N=numNodes; Vmax = 1:VRmax;  G = Vmax.^2; %number genotypes
%for OR case
Sprop = SPExact1LociOR( 1, Vmax );
mode = 'Dynamic-favScore'; %mode - can be 'static' or 'dynamic' 'Dynamic-random' 'Dynamic-favScore'
%monte carlo random genotype SIR model
%numRuns = 20 %100 %200
%set up diversity mode parameters
modePar.modeStr = mode;
modePar.numToConstrain = 0; %constain a number of nodes to 1 variant
modePar.stopUpdatingTime = 200000; %time at which to stop updating the genotypes
modePar.numEncountersBetweenUpdates = 100; % number of encounters between updates for random and favscore algorithms
modePar.bufferlength = 10; %length of genotype buffer for favscore algorithm
modePar.genoInit = 'maxdiv';  %initial conditions of genotypes maxdiv (maximum diversity - random variant chosen) mindiv (minimum diversity - all nodes same)

for z= VRmin:VRmax
 betan = 0.02; variantRichness =  z;   plotGraphs = 1; gamma = 0; numExploits=1; numLoci=1; casetype = 'OR'; throwAway = 'nonEpidemics', cutoff = gamma.*numNodes./(betan.*Sprop); SEpidemic=60; %cutoff;
%agent
 [figMeanNei(z) figNeiOneRun(z) fighistSpRun(z) fighistRecovered(z) fighistSusceptible(z) fighistpeakValue(z) fighistpeakTime(z) fighistBeta(z) fighistGamma(z) fighistBetanew(z) fighistGammanew(z) figInfectedRun1 figBetaRun1 figGammaRun1 figRoRun1 figBetaGamma1 figBetaGamma2...
            meanNeiIndexDynamicF  betastd gammastd betastd2 betastdNew betastdNew2 gammastdNew peakTimemean peakTimestd peakValuemean peakValuestd...
            betameanmean(z) gammameanmean betameanmean2(z) betameanmeanNew(z) betameanmeanNew2 gammameanmeanNew(z) Smean(z,:) Imean Rmean(z,:) NSmean(z,:) Smedian Imedian Rmedian S I R NS SmeanN ImeanN1(z,:) RmeanN1 Snewendmean Snewendstd Rnewendmean(z) Rnewendstd(z) Rnew_nonendmean Rnew_nonendstd propSimsNonEp(z) propSimsNonEp_theoretical(z)...
            numRunsMinor(z) measuredProbMinor(z) numRunsMajor(z) measuredProbMajor(z) meanmdist meannumInfectedVM...
            ] = monteCarloSIRN2(numRuns,numNodes, betan, variantRichness, numTimesteps, plotGraphs,gamma,throwAway,SEpidemic,numExploits,modePar, numLoci, casetype);
FinalSize(z) = max(Imean,[],2) %mean final size SI

    %time
     maska = Imean >= FinalSize(z)-1; %when within 1 of the final value
    [C Index] = max(maska);
    MLa(z) = Index %T1
     %staticResistance time
     maska = Imean >= staticResistance-1; %when within 1 of the final value
    [C Index] = max(maska);
    MLb(z) = Index; %T1
close all;
    
    text = ['done ' num2str(z) ' out of ' num2str(VRmax)];
    disp(text)
end    
%save outputs
FinalSizeDynamicFavScore100 = FinalSize(z)
TimeDynamicFavScore100=MLa(z)
TimeDynamicFavScore100Static=MLb(z)
ImeanDynamicFavScore100=Imean(1:dec:end)
disp('done Dynamic-favscore-100')

%**************************************************************
%UPTO HERE - FINISH WRITING GRAPHS
time = 1:dec:numTimesteps;
figure %VR=5 Imean
plot(time,ImeanVR1,'k', 'Linewidth', 2) %no diversity
hold on
plot(time,ImeanStatic,'k--', 'Linewidth', 2)
plot(time,ImeanDynamic,'k.-')
plot(time,ImeanDynamicRandom1,'k')
plot(time,ImeanDynamicFavScore1,'k--')
plot(time,ImeanDynamicRandom10,'k')
plot(time,ImeanDynamicFavScore10,'k--')
plot(time,ImeanDynamicRandom20,'k')
plot(time,ImeanDynamicFavScore20,'k--')
plot(time,ImeanDynamicRandom50,'k')
plot(time,ImeanDynamicFavScore50,'k--')
plot(time,ImeanDynamicRandom100,'k')
plot(time,ImeanDynamicFavScore100,'k--')
legend('No diversity', 'Static', 'Random (Time)', 'Random (Encounter)', 'Favscore (Encounter)') 
xlabel('Time (seconds)')
ylabel('Size of Epidemic')

figure %time
plot([1 10 20 50 100],[TimeVR1 TimeVR1 TimeVR1 TimeVR1 TimeVR1],'k', 'Linewidth', 2)
hold on
plot([1 10 20 50 100],[TimeStatic TimeStatic TimeStatic TimeStatic TimeStatic],'ko-')
plot([1 10 20 50 100],[TimeDynamic TimeDynamic TimeDynamic TimeDynamic TimeDynamic],'ks-')
plot([1 10 20 50 100],[TimeDynamicRandom1 TimeDynamicRandom10 TimeDynamicRandom20 TimeDynamicRandom50 TimeDynamicRandom100],'k.-')
plot([1 10 20 50 100],[TimeDynamicFavScore1 TimeDynamicFavScore10 TimeDynamicFavScore20 TimeDynamicFavScore50 TimeDynamicFavScore100],'k--')
legend('No diversity', 'Static', 'Random (Time)', 'Random (Encounter)', 'Favscore (Encounter)') 
xlabel('Number of encounters')
ylabel('Time to reach final size')

figure %static time
plot([1 10 20 50 100],[TimeVR1 TimeVR1 TimeVR1 TimeVR1 TimeVR1],'k', 'Linewidth', 2)
hold on
plot([1 10 20 50 100],[TimeStatic TimeStatic TimeStatic TimeStatic TimeStatic],'ko-')
plot([1 10 20 50 100],[TimeDynamicStatic TimeDynamicStatic TimeDynamicStatic TimeDynamicStatic TimeDynamicStatic],'ks-')
plot([1 10 20 50 100],[TimeDynamicRandom1Static TimeDynamicRandom10Static TimeDynamicRandom20Static TimeDynamicRandom50Static TimeDynamicRandom100Static],'k.-')
plot([1 10 20 50 100],[TimeDynamicFavScore1Static TimeDynamicFavScore10Static TimeDynamicFavScore20Static TimeDynamicFavScore50Static TimeDynamicFavScore100Static],'k--')
legend('No diversity', 'Static', 'Random (Time)', 'Random (Encounter)', 'Favscore (Encounter)') 
xlabel('Number of encounters')
ylabel('Time to reach static size')

figure %final size
plot([1 10 20 50 100],[FinalSizeVR1 FinalSizeVR1 FinalSizeVR1 FinalSizeVR1 FinalSizeVR1],'k', 'Linewidth', 2)
hold on
plot([1 10 20 50 100],[FinalSizeStatic FinalSizeStatic FinalSizeStatic FinalSizeStatic FinalSizeStatic],'ko-')
plot([1 10 20 50 100],[FinalSizeDynamic FinalSizeDynamic FinalSizeDynamic FinalSizeDynamic FinalSizeDynamic],'ks-')
plot([1 10 20 50 100],[FinalSizeDynamicRandom1 FinalSizeDynamicRandom10 FinalSizeDynamicRandom20 FinalSizeDynamicRandom50 FinalSizeDynamicRandom100],'k.-')
plot([1 10 20 50 100],[FinalSizeDynamicFavScore1 FinalSizeDynamicFavScore10 FinalSizeDynamicFavScore20 FinalSizeDynamicFavScore50 FinalSizeDynamicFavScore100],'k--')
legend('No diversity', 'Static', 'Random (Time)', 'Random (Encounter)', 'Favscore (Encounter)') 
xlabel('Number of encounters')
ylabel('Final size')


figure %final size
plot([1 10 20 50 100],(numNodes-[FinalSizeVR1 FinalSizeVR1 FinalSizeVR1 FinalSizeVR1 FinalSizeVR1])./numNodes,'k', 'Linewidth', 2)
hold on
plot([1 10 20 50 100],(numNodes-[FinalSizeStatic FinalSizeStatic FinalSizeStatic FinalSizeStatic FinalSizeStatic])./numNodes,'ko-')
plot([1 10 20 50 100],(numNodes-[FinalSizeDynamic FinalSizeDynamic FinalSizeDynamic FinalSizeDynamic FinalSizeDynamic])./numNodes,'ks-')
plot([1 10 20 50 100],(numNodes-[FinalSizeDynamicRandom1 FinalSizeDynamicRandom10 FinalSizeDynamicRandom20 FinalSizeDynamicRandom50 FinalSizeDynamicRandom100])./numNodes,'k.-')
plot([1 10 20 50 100],(numNodes-[FinalSizeDynamicFavScore1 FinalSizeDynamicFavScore10 FinalSizeDynamicFavScore20 FinalSizeDynamicFavScore50 FinalSizeDynamicFavScore100])./numNodes,'k--')
legend('No diversity', 'Static', 'Random (Time)', 'Random (Encounter)', 'Favscore (Encounter)') 
xlabel('Number of encounters')
ylabel('Resistance')

%outputs
noDiv=[TimeVR1 TimeVR1 TimeVR1 TimeVR1 TimeVR1]
stat=[TimeStatic TimeStatic TimeStatic TimeStatic TimeStatic]
T1FVT=[TimeDynamic TimeDynamic TimeDynamic TimeDynamic TimeDynamic]
T1FVE=[TimeDynamicRandom1 TimeDynamicRandom10 TimeDynamicRandom20 TimeDynamicRandom50 TimeDynamicRandom100]
T1FS=[TimeDynamicFavScore1 TimeDynamicFavScore10 TimeDynamicFavScore20 TimeDynamicFavScore50 TimeDynamicFavScore100]

(numNodes-[FinalSizeVR1 FinalSizeVR1 FinalSizeVR1 FinalSizeVR1 FinalSizeVR1])./numNodes
(numNodes-[FinalSizeStatic FinalSizeStatic FinalSizeStatic FinalSizeStatic FinalSizeStatic])./numNodes
(numNodes-[FinalSizeDynamic FinalSizeDynamic FinalSizeDynamic FinalSizeDynamic FinalSizeDynamic])./numNodes
(numNodes-[FinalSizeDynamicRandom1 FinalSizeDynamicRandom10 FinalSizeDynamicRandom20 FinalSizeDynamicRandom50 FinalSizeDynamicRandom100])./numNodes
(numNodes-[FinalSizeDynamicFavScore1 FinalSizeDynamicFavScore10 FinalSizeDynamicFavScore20 FinalSizeDynamicFavScore50 FinalSizeDynamicFavScore100])./numNodes

%captured data
%VR=5, for 1, 10, 20, 50 100 encounters (100 encounter not run for long
%enough, so invalid result for time to reach final size.)
TimeVR1 =[   745   745   745   745   745]
TimeStatic=[2844        2844        2844        2844        2844]
TimeDynamic=[3690        3690        3690        3690        3690]
TimeDynamicRandom1=[ 3810       16034       31181       72302       98219]
TimeDynamicFavScore1=[3857       16726       33723       73450       98618]

ResVR1=[     0     0     0     0     0]
ResStatic=[0.8020    0.8020    0.8020    0.8020    0.8020]
ResDynamic=[     0     0     0     0     0]
FinalSizeDynamicRandom1=[0         0         0    0.0001    0.0096]
FinalSizeDynamicFavScore1=[0         0         0    0.0001    0.0104]


toc


end %SIRN Test21

end

