%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Jennifer Jackson 2017                                                        %
% A Biodiversity Approach to Cyber Security                                    %
% PhD Complexity Science                                                       %
% University of Warwick                                                        %
% http://wrap.warwick.ac.uk/98458                                              %
% This software is distributed under the  Creative Commons Attribution License %
% https://creativecommons.org/licenses/by/4.0/                                 %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function [ output_args ] = SIRTolerance( input_args )
%   calculates the number of variants in each locus needed to tolerate the
%   specified number of exploits for the SIR model
close all;
clear all;

%results chapter
%*******************
%Sp relationship graph with QT
%*******************
% Ro balance equation
%solve('1-x = exp(-1.0*R0*x)', 'Real', true)
Ro = [0.0 0.5 1.0 1.1 1.2 1.3 1.4 1.5 1.6 1.7 1.8 1.9 2.0 2.1 2.2 2.3 2.4 2.5 2.6 2.7 2.8 2.9 3.0 3.1 3.2 3.5 3.7 4.0 5.0 6.0 7.0]
answer(1) = solve('1-x = exp(-1.0*0.0*x)', 'Real', true)
answer(2) = solve('1-x = exp(-1.0*0.5*x)', 'Real', true)
answer(3) = solve('1-x = exp(-1.0*1.0*x)', 'Real', true)
answer(4) = solve('1-x = exp(-1.0*1.1*x)', 'Real', true)
answer(5) = solve('1-x = exp(-1.0*1.2*x)', 'Real', true)
answer(6) = solve('1-x = exp(-1.0*1.3*x)', 'Real', true)
answer(7) = solve('1-x = exp(-1.0*1.4*x)', 'Real', true)
answer(8) = solve('1-x = exp(-1.0*1.5*x)', 'Real', true)
answer(9) = solve('1-x = exp(-1.0*1.6*x)', 'Real', true)
answer(10) = solve('1-x = exp(-1.0*1.7*x)', 'Real', true)
answer(11) = solve('1-x = exp(-1.0*1.8*x)', 'Real', true)
answer(12) = solve('1-x = exp(-1.0*1.9*x)', 'Real', true)
answer(13) = solve('1-x = exp(-1.0*2.0*x)', 'Real', true)
answer(14) = solve('1-x = exp(-1.0*2.1*x)', 'Real', true)
answer(15) = solve('1-x = exp(-1.0*2.2*x)', 'Real', true)
answer(16) = solve('1-x = exp(-1.0*2.3*x)', 'Real', true)
answer(17) = solve('1-x = exp(-1.0*2.4*x)', 'Real', true)
answer(18) = solve('1-x = exp(-1.0*2.5*x)', 'Real', true)
answer(19) = solve('1-x = exp(-1.0*2.6*x)', 'Real', true)
answer(20) = solve('1-x = exp(-1.0*2.7*x)', 'Real', true)
answer(21) = solve('1-x = exp(-1.0*2.8*x)', 'Real', true)
answer(22) = solve('1-x = exp(-1.0*2.9*x)', 'Real', true)
answer(23) = solve('1-x = exp(-1.0*3.0*x)', 'Real', true)
answer(24) = solve('1-x = exp(-1.0*3.1*x)', 'Real', true)
answer(25) = solve('1-x = exp(-1.0*3.2*x)', 'Real', true)
answer(26) = solve('1-x = exp(-1.0*3.5*x)', 'Real', true)
answer(27) = solve('1-x = exp(-1.0*3.7*x)', 'Real', true)
answer(28) = solve('1-x = exp(-1.0*4.0*x)', 'Real', true)
answer(29) = solve('1-x = exp(-1.0*5.0*x)', 'Real', true)
answer(30) = solve('1-x = exp(-1.0*6.0*x)', 'Real', true)
answer(31) = solve('1-x = exp(-1.0*7.0*x)', 'Real', true)
%by = Ro./answer %=beta/gamma
trueRo = answer.*Ro
figure
plot(Ro,answer,'k','Linewidth',2)
xlabel('Ro')
ylabel('Final Size')
axis([0 7 0 2])

QT=0.8
sus = (1-QT)./answer
by = Ro./sus %=beta/gamma


figure
plot(Ro,sus,'k','Linewidth',2)
xlabel('Ro')
ylabel('Sp')

figure
plot(Ro,by,'k','Linewidth',2)
xlabel('Ro')
ylabel('bn/y')
%*******************
%Sp relationship graph with bn/y
%*******************
QT3 = [0.8 0.9 0.95 0.5 0.2] %QoS tolerance values
a = log(QT3)
Rc = (-1.*a)./(1-QT3) %critical values of Rc

%by = 1.1157:0.1:7
by1 = Rc(1):0.1:100;
top = 1-QT3(1);%80%
e = (-1.*by1.*(1-QT3(1)));
bottom = 1-(exp(e));
Sp1 = top./bottom %sp equation (final size)
%**
by2 = Rc(2):0.1:100;
top = 1-QT3(2);%90%
e = (-1.*by2.*(1-QT3(2)));
bottom = 1-(exp(e));
Sp2 = top./bottom;
%**
by3 = Rc(3):0.1:100;
top = 1-QT3(3);%95%
e = (-1.*by3.*(1-QT3(3)));
bottom = 1-(exp(e));
Sp3 = top./bottom
%if 0 on top answer should be zero, rather than NaN
%Sp(end) = 0; %top is zero when QT=1.0
%**
by4 = Rc(4):0.1:100;
top = 1-QT3(4);%50%
e = (-1.*by4.*(1-QT3(4)));
bottom = 1-(exp(e));
Sp4 = top./bottom;
%if 0 on top answer should be zero, rather than NaN
%Sp(end) = 0; %top is zero when QT=1.0
%**
by5 = Rc(5):0.1:100;
top = 1-QT3(5);%20%
e = (-1.*by5.*(1-QT3(5)));
bottom = 1-(exp(e));
Sp5 = top./bottom;
%if 0 on top answer should be zero, rather than NaN
%Sp(end) = 0; %top is zero when QT=1.0

figure
plot(by5,Sp5,'k','linewidth',2)
hold on
plot(by4,Sp4,'k','linewidth',2)
plot(by1,Sp1,'k','linewidth',2)
plot(by2,Sp2,'k--','linewidth',2)
plot(by3,Sp3,'k.','linewidth',2)
xlabel('beta_n/gamma')
ylabel('Proportion susceptible Sp')
title('QT = 0.8, 0.9, 0.95, start bn/y at critical R')
%legend('80% Tolerance','90% Tolerance','95% Tolerance')
legend('20% Tolerance','50% Tolerance','80% Tolerance','90% Tolerance','95% Tolerance')

QT = 0 : 0.01 :1.0;
Rcrit = (-log(QT))./(1-QT)
figure
plot(QT,Rcrit,'k')
xlabel('QT')
ylabel('R critical')

Rc = (-1.*a)./(1-QT3) %critical values of Rc

clear all;

%QT = [0.8 0.9 0.95];
QT = 0 : 0.01 :1.0;
bn = 0.02; %betan b/y >5
y = 0.004;%0.004;
I0 = 0 ; %assume negligable so zero

top = 1-QT
e = (-1.*bn.*(1-QT))./y
bottom = 1-((1-I0).*exp(e))
Sp = top./bottom
%if 0 on top answer should be zero, rather than NaN
Sp(end) = 0; %top is zero when QT=1.0
r0 = Sp.*bn./y

spr1=y./bn; %sp when r0=1

finalSize = (1-QT)./Sp

figure
plot(QT,r0,'k')
hold on
plot([0 1],[1 1],'k--')
%plot(1,spr1,'k*', 'linewidth',4)
%xlabel('R0')
xlabel('Quality of Service Tolerance QT')
%ylabel('Proportion Susceptible Sp')
ylabel('Reproduction Number R0')
title('Value of R0 (above 1) for a fixed QT, beta and gamma')
axis([0 1 0 5.5])


bn = 0.02; %betan b/y >5
y = 0.004;%0.004;
top = 1-QT
e = (-1.*bn.*(1-QT))./y
bottom = 1-((1-I0).*exp(e))
Sp(1,:) = top./bottom

bn = 3; %betan b/y >5
y = 1;%0.004;
top = 1-QT
e = (-1.*bn.*(1-QT))./y
bottom = 1-((1-I0).*exp(e))
Sp(2,:) = top./bottom

bn = 2; %betan b/y >5
y = 1;%0.004;
top = 1-QT
e = (-1.*bn.*(1-QT))./y
bottom = 1-((1-I0).*exp(e))
Sp(3,:) = top./bottom

figure
plot(QT,Sp(1,:),'k')%5
hold on
plot(QT,Sp(2,:),'k')%3
plot(QT,Sp(3,:),'k')%2
plot([0 1],[spr1 spr1],'k--')
xlabel('Quality of Service Tolerance QT')
%xlabel('Quality of Service Tolerance QT')
ylabel('Proportion Susceptible Sp')
title('Proportion Susceptible with Recovery for a fixed QT')
axis([0 1 0 1])

figure
plot(QT,finalSize,'k')
xlabel('Quality of Service Tolerance QT')
%xlabel('Quality of Service Tolerance QT')
ylabel('Final Size')
title('Final Size with Recovery for a fixed QT')

%***********************************











%*********************************************************************************************************************
%***********************************************
%EPIDEMIC MODEL CHAPTER
%***********************************************
%***********************************************
%OUTPUTS - WITH RECOVERY
%optimum Diversity for Quality of Service Tolerance

%************************
% optimum diversity with r0 = 1
%exploit richness vs variant richness
%*******************************
 %r0 = 1
 %sp < y/bn
%sp = [0.08 0.1 0.2 0.4 0.8 1.0] %y/bn points when R0=1
sp = [1.0 0.8 0.4 0.2 0.1 0.08] %y/bn points when R0=1
%sp = [0.083 0.0083 0.0014 0.00013889 0.00013889 0.00013889] %y/bn points when R0=1
numsp=6
Nn = 1000
 %define exploits
 x = 1:8

for j = 1:numsp %SP values
for x = 1:8
%average AND - 4 loci
va(x,j) = V4LociANDMin( x, sp(j) );
 %average OR - 4 loci using approximation - cant use for high sp values
vo(x,j) = V4LociORMin( x, sp(j) );
 %average OR - 4 loci using exact 
voexact(x,j) = VRExact4LociOR( x, sp(j));
%one locus model
vOne(x,j) = V1Loci( x, sp(j) )
end
end
 
%One locus case
figure
plot(1:8,vOne(:,1),'k','linewidth',2) %Rc
hold on
plot(1:8,vOne(:,2),'ko-') %bny
plot(1:8,vOne(:,3),'k+-') %bny
plot(1:8,vOne(:,4),'k.-') %bny
plot(1:8,vOne(:,5),'k*-') %bny
plot(1:8,vOne(:,6),'ks-') %bny
xlabel('Exploit Richness')
ylabel('Variant Richness')
  legend('y/bn=1.0', 'y/bn=0.8', 'y/bn=0.4', 'y/bn=0.2', 'y/bn=0.1', 'y/bn=0.08')
 title('one locus model r0=1')
%AND case
figure
plot(1:8,va(:,1),'k','linewidth',2) %Rc
hold on
plot(1:8,va(:,2),'ko-') %bny
plot(1:8,va(:,3),'k+-') %bny
plot(1:8,va(:,4),'k.-') %bny
plot(1:8,va(:,5),'k*-') %bny
plot(1:8,va(:,6),'ks-') %bny
xlabel('Exploit Richness')
ylabel('Variant Richness')
  legend('y/bn=1.0', 'y/bn=0.8', 'y/bn=0.4', 'y/bn=0.2', 'y/bn=0.1', 'y/bn=0.08')
 title('r0=1, 4 loci AND')

 
 %OR case exact and approx
figure
plot(1:8,voexact(:,1),'k','linewidth',2) %Rc
hold on
plot(1:8,voexact(:,2),'ko-') %bny
plot(1:8,voexact(:,3),'k+-') %bny
plot(1:8,voexact(:,4),'k.-') %bny
plot(1:8,voexact(:,5),'k*-') %bny
plot(1:8,voexact(:,6),'ks-') %bny

plot(1:8,vo(:,1),'k--') %Rc
hold on
plot(1:8,vo(:,2),'k--') %bny
plot(1:8,vo(:,3),'k--') %bny
plot(1:8,vo(:,4),'k--') %bny
plot(1:8,vo(:,5),'k--') %bny
plot(1:8,vo(:,6),'k--') %bny
xlabel('Exploit Richness')
ylabel('Variant Richness')
  legend('y/bn=1.0', 'y/bn=0.8', 'y/bn=0.4', 'y/bn=0.2', 'y/bn=0.1', 'y/bn=0.08')
 title('r0=1, 4 loci OR')  
 
 
 
 %************************
% optimum diversity with r0 = 1
%time between contacts vs variant richness
%realistic time data
%*******************************
clear all;
recoveryTime = 2*60*60 %2hours
contactTime = [1 10 60 10*60] %1 sec, 10sec, 1min, 10min
sp = contactTime./recoveryTime
numsp=4
Nn = 1000
 %define exploits
 x = 1:8

for j = 1:numsp %SP values
for x = 1:8
%average AND - 4 loci
va(x,j) = V4LociANDMin( x, sp(j) );
 %average OR - 4 loci using approximation - cant use for high sp values
vo(x,j) = V4LociORMin( x, sp(j) );
 %average OR - 4 loci using exact 
voexact(x,j) = VRExact4LociOR( x, sp(j));
%one locus model
vOne(x,j) = V1Loci( x, sp(j) );
end
end
 

vOne
va
voexact

%1 exploit richness
figure
plot(contactTime,vOne(1,:),'k*-','linewidth',2) %one locus
hold on
plot(contactTime,va(1,:),'ko-','linewidth',2) %AND
plot(contactTime,voexact(1,:),'k+-','linewidth',2) %OR
xlabel('Time between contacts (seconds)')
ylabel('Variant Richness')
  legend('one locus model', '4 loci AND', '4 loci OR')
 title(' for a 2 hour recovery time with one exploit')
return



%One locus case
figure
plot(1:8,vOne(:,1),'k','linewidth',2) %Rc
hold on
plot(1:8,vOne(:,2),'ko-') %bny
plot(1:8,vOne(:,3),'k+-') %bny
plot(1:8,vOne(:,4),'k.-') %bny
plot(1:8,vOne(:,5),'k*-') %bny
plot(1:8,vOne(:,6),'ks-') %bny
xlabel('Exploit Richness')
ylabel('Variant Richness')
  legend('y/bn=1.0', 'y/bn=0.8', 'y/bn=0.4', 'y/bn=0.2', 'y/bn=0.1', 'y/bn=0.08')
 title('one locus model r0=1')
%AND case
figure
plot(1:8,va(:,1),'k','linewidth',2) %Rc
hold on
plot(1:8,va(:,2),'ko-') %bny
plot(1:8,va(:,3),'k+-') %bny
plot(1:8,va(:,4),'k.-') %bny
plot(1:8,va(:,5),'k*-') %bny
plot(1:8,va(:,6),'ks-') %bny
xlabel('Exploit Richness')
ylabel('Variant Richness')
  legend('y/bn=1.0', 'y/bn=0.8', 'y/bn=0.4', 'y/bn=0.2', 'y/bn=0.1', 'y/bn=0.08')
 title('r0=1, 4 loci AND')

 
 %OR case exact and approx
figure
plot(1:8,voexact(:,1),'k','linewidth',2) %Rc
hold on
plot(1:8,voexact(:,2),'ko-') %bny
plot(1:8,voexact(:,3),'k+-') %bny
plot(1:8,voexact(:,4),'k.-') %bny
plot(1:8,voexact(:,5),'k*-') %bny
plot(1:8,voexact(:,6),'ks-') %bny

plot(1:8,vo(:,1),'k--') %Rc
hold on
plot(1:8,vo(:,2),'k--') %bny
plot(1:8,vo(:,3),'k--') %bny
plot(1:8,vo(:,4),'k--') %bny
plot(1:8,vo(:,5),'k--') %bny
plot(1:8,vo(:,6),'k--') %bny
xlabel('Exploit Richness')
ylabel('Variant Richness')
  legend('y/bn=1.0', 'y/bn=0.8', 'y/bn=0.4', 'y/bn=0.2', 'y/bn=0.1', 'y/bn=0.08')
 title('r0=1, 4 loci OR')  

 
 

return

%************************
% optimum diversity with r0 = 1
% Resistance and Resilience measurements for the deterministic malware
% model
%************************
 %r0 = 1
 %sp < y/bn
  clear all;
  close all;
 
 bn = 0.02; y = 0.004 %Rc = 0.2
 sp = [0.1 0.15 0.18 0.2 0.3 0.4 0.5 0.7 0.9 1.0]
 Nn = 1000
 %define exploits
 x = 1:8
 numsp=10
 
 %optimise v for 4 loci and
 %************ Average cases
for j = 1:numsp %SP values
for x = 1:8
%average AND - 4 loci
va(x,j) = V4LociANDMin( x, sp(j) );
 %average OR - 4 loci using approximation - cant use for high sp values
vo(x,j) = V4LociORMin( x, sp(j) );
 %average OR - 4 loci using exact 
voexact(x,j) = VRExact4LociOR( x, sp(j));

%voexact(x,j) = VRExact4LociOR( x, sp(j) );
%recalculate sp
spo(x,j)= sp4LociOR( x, vo(x,j) );
spoexact(x,j) = SPExact4LociOR( x, voexact(x,j) );
spa(x,j)= sp4LociAND( x, va(x,j) );
end
end

voexact
va

spoexact;
vo;
spo;


%  figure
% plot(vo(1,:),spo(1,:),'k', 'linewidth',2) %x1
% hold on
% plot(vo(2,:),spo(2,:),'k') %x2
% plot(vo(3,:),spo(3,:),'k') %x3
% plot(vo(4,:),spo(4,:),'k') %x4
% plot(vo(5,:),spo(5,:),'k') %x5
% plot(vo(6,:),spo(6,:),'k') %x6
% plot(vo(7,:),spo(7,:),'k') %x7
% plot(vo(8,:),spo(8,:),'k') %x8 
%  plot([0 60],[0.2 0.2], 'k--') %r0=1
%  xlabel('Variant Richness (diversity)')
% ylabel('Recalculated S_p')
% legend('x=1', 'x=2to8')
% title('4 loci OR - APROX')
% axis([0 60 0.1 1])
 
   figure
 plot(voexact(1,:),spoexact(1,:),'k', 'linewidth',2) %x1
 hold on
 plot(voexact(2,:),spoexact(2,:),'k') %x2
 plot(voexact(3,:),spoexact(3,:),'k') %x3
 plot(voexact(4,:),spoexact(4,:),'k') %x4
 plot(voexact(5,:),spoexact(5,:),'k') %x5
 plot(voexact(6,:),spoexact(6,:),'k') %x6
 plot(voexact(7,:),spoexact(7,:),'k') %x7
 plot(voexact(8,:),spoexact(8,:),'k') %x8 
  plot([0 60],[0.2 0.2], 'k--') %r0=1
plot([18.615 18.615],[0 0.2],'k--')
  xlabel('Variant Richness (diversity)')
 ylabel('Recalculated Susceptibility S_p')
 legend('x=1', 'x=2to8')
 title('4 loci OR - EXACT')
 axis([0 60 0.1 1])

  figure
 plot(va(1,:),spa(1,:),'k', 'linewidth',2) %x1
 hold on
 plot(va(2,:),spa(2,:),'k') %x2
 plot(va(3,:),spa(3,:),'k') %x3
 plot(va(4,:),spa(4,:),'k') %x4
 plot(va(5,:),spa(5,:),'k') %x5
 plot(va(6,:),spa(6,:),'k') %x6
 plot(va(7,:),spa(7,:),'k') %x7
 plot(va(8,:),spa(8,:),'k') %x8 
 plot([0 10],[0.2 0.2], 'k--') %r0=1
plot([1.8533 1.8533],[0 0.2],'k--')
  xlabel('Variant Richness (diversity)')
 ylabel('Recalculated Susceptibility S_p')
 legend('x=1', 'x=2to8')
 title('4 loci AND')
 axis([0 10 0.06 1])


 %input to SIR model
 bsa = spa.*bn %AND
 Nsa = spa.*Nn %AND
 R0a = bsa./y
 
 bso = spo.*bn %OR
 Nso = spo.*Nn %OR
 R0o = bso./y
 
  bsoexact = spoexact.*bn %OR
 Nsoexact = spoexact.*Nn %OR
 R0oexact = bsoexact./y

 
 %figure
 %plot([1:8],R0a(1,:),'k') %x1
 %hold on
 %plot([1:8],R0a(2,:),'k--') %x2
 %plot([1:8],R0a(3,:),'k--') %x3
 %plot([1:8],R0a(4,:),'k--') %x4
 %plot([1:8],R0a(5,:),'k--') %x5
 %plot([1:8],R0a(6,:),'k--') %x6
 %plot([1:8],R0a(7,:),'k--') %x7
 %plot([1:8],R0a(8,:),'k--') %x8
 %xlabel('S_p number 1:8')
 %ylabel('R_0')
 %legend('x=1', 'x=2to8')
 %title('4 loci AND')

 % figure
 %plot([1:8],R0o(1,:),'k') %x1
 %hold on
 %plot([1:8],R0o(2,:),'k--') %x2
 %plot([1:8],R0o(3,:),'k--') %x3
 %%plot([1:8],R0o(4,:),'k--') %x4
 %plot([1:8],R0o(5,:),'k--') %x5
 %plot([1:8],R0o(6,:),'k--') %x6
 %plot([1:8],R0o(7,:),'k--') %x7
 %plot([1:8],R0o(8,:),'k--') %x8    
 % xlabel('S_p number 1:8')
 %ylabel('R_0')
 %legend('x=1', 'x=2to8')
 %title('4 loci OR')
 
%  figure
% plot(va(1,:),R0a(1,:),'k', 'linewidth',2) %x1
% hold on
% plot(va(2,:),R0a(2,:),'k') %x2
% plot(va(3,:),R0a(3,:),'k') %x3
% plot(va(4,:),R0a(4,:),'k') %x4
% plot(va(5,:),R0a(5,:),'k') %x5
% plot(va(6,:),R0a(6,:),'k') %x6
% plot(va(7,:),R0a(7,:),'k') %x7
% plot(va(8,:),R0a(8,:),'k') %x8
%  xlabel('Variant Richness (diversity)')
% ylabel('R_0')
% legend('x=1', 'x=2to8')
% title('4 loci AND')
%  axis([0 10 0.3 5])
  
%  figure
% plot(vo(1,:),R0o(1,:),'k', 'linewidth',2) %x1
% hold on
% plot(vo(2,:),R0o(2,:),'k') %x2
% plot(vo(3,:),R0o(3,:),'k') %x3
% plot(vo(4,:),R0o(4,:),'k') %x4
% plot(vo(5,:),R0o(5,:),'k') %x5
% plot(vo(6,:),R0o(6,:),'k') %x6
% plot(vo(7,:),R0o(7,:),'k') %x7
% plot(vo(8,:),R0o(8,:),'k') %x8    
%  xlabel('Variant Richness (diversity)')
% ylabel('R_0')
% legend('x=1', 'x=2to8')
% title('4 loci OR')
%  axis([0 60 0.5 5])
 
I=1 %number infected
R=0 %initial recovered
timeMax = 10000 %5000
ts = 1:timeMax

drawPlots = 0
 %run deterministic model
 for j = 1:numsp %8 %SP values
for x = 1:8 %8
    [Ra, Sta, Ita, Rta] = SIRDeterministic(bsa(x,j), y, Nsa(x,j), I, R, timeMax, 0);
  %  disp('done AND SIR')
    [Ro, Sto, Ito, Rto] = SIRDeterministic(bso(x,j), y, Nso(x,j), I, R, timeMax, drawPlots);
  %    disp('done OR APPROX SIR')
    [Roe, Stoe, Itoe, Rtoe] = SIRDeterministic(bsoexact(x,j), y, Nsoexact(x,j), I, R, timeMax, drawPlots);
  %    disp('done OR EXACT SIR')
    R_OR(x,j,:)= Rto;
    R_ORe(x,j,:)= Rtoe;
    R_AND(x,j,:)= Rta;
     I_OR(x,j,:)= Ito;
      I_ORe(x,j,:)= Itoe;
    I_AND(x,j,:)= Ita;
     MRo(x,j) = 1-(Rto(end))./Nn;%resistance OR
     MRoe(x,j) = 1-(Rtoe(end))./Nn;%resistance ORe
     MRa(x,j) = 1-(Rta(end))./Nn;%resistance AND
     
     
     %resilience OR
     masko = Rto >= Rto(end)-1; %when within 1 of the final value
    [Co Indexo] = max(masko);
    T1o(x,j) = Indexo; %T1
    
         %resilience ORe
     maskoe = Rtoe >= Rtoe(end)-1; %when within 1 of the final value
    [Coe Indexoe] = max(maskoe);
    T1oe(x,j) = Indexoe; %T1
    
         %resilience AND
     maska = Rta >= Rta(end)-1; %when within 1 of the final value
    [Ca Indexa] = max(maska);
    T1a(x,j) = Indexa; %T1
     
end
 end
 

   %OR Infected - exact
 figure
 R1(:,:) = I_ORe(1,:,:)
 plot(ts./60./60,R1(1,:),'k--','linewidth',2)
 hold on
 % plot(R1(2,:),'k','linewidth',2)
   plot(ts./60./60,R1(3,:),'k')
     plot(ts./60./60,R1(4,:),'k','linewidth',2)
       plot(ts./60./60,R1(5,:),'k-.')
  %       plot(R1(6,:),'k')
  %         plot(R1(7,:),'k')
  %           plot(R1(8,:),'k')
 xlabel('Time (Hours)')
 ylabel('Number Infected It')
% legend('sp=0.1', 'sp=0.18', 'sp=0.2', 'sp=0.3')
 legend('VR=39', 'VR=21', 'VR=19', 'VR=12 (major outbreak)')
 title('Infected - OR exact')
  axis([0 2 0 20]) 

 %AND Infected
 figure
 R1(:,:) = I_AND(1,:,:)
% plot(ts./60./60,R1(1,:),'k--','linewidth',2)
 hold on
% plot(ts./60./60,R1(2,:),'k','linewidth',2)
  % plot(ts./60./60,R1(3,:),'k')
  %   plot(ts./60./60,R1(4,:),'r')
  %     plot(ts./60./60,R1(5,:),'g')
  %       plot(ts./60./60,R1(6,:),'c')
  %         plot(ts./60./60,R1(7,:),'y')
  %           plot(ts./60./60,R1(8,:),'r')
   plot(ts./60./60,R1(9,:),'k','linewidth',2)
 plot(ts./60./60,R1(10,:),'k-.')
  
 xlabel('Time (Hours)')
 ylabel('Number Infected It')
 legend('VR=2', 'VR=1 (major outbreak)')
 title('Infected - AND')
   axis([0 1 0 500])
 
 
 
%OR RESISTANCE
figure 
plot(voexact(1,:),MRoe(1,:),'k', 'linewidth',2)%all sp values for one exploit
hold on
plot(voexact(2,:),MRoe(2,:),'k')
plot(voexact(3,:),MRoe(3,:),'k')
plot(voexact(4,:),MRoe(4,:),'k')
plot(voexact(5,:),MRoe(5,:),'k')
plot(voexact(6,:),MRoe(6,:),'k')
plot(voexact(7,:),MRoe(7,:),'k')
plot(voexact(8,:),MRoe(8,:),'k')
plot([18.615 18.615],[0 1000],'k--')
  xlabel('Variant Richness (diversity)')
 ylabel('Measured Resistance M_R')
 legend('x=1', 'x=2to8')
 title('4 loci OR - Exact')
  axis([0 60 0 1.1])
%AND RESISTANCE
figure 
plot(va(1,:) ,MRa(1,:),'k', 'linewidth',2)%all sp values for one exploit
hold on
plot(va(2,:) ,MRa(2,:),'k')
plot(va(3,:) ,MRa(3,:),'k')
plot(va(4,:) ,MRa(4,:),'k')
plot(va(5,:) ,MRa(5,:),'k')
plot(va(6,:) ,MRa(6,:),'k')
plot(va(7,:) ,MRa(7,:),'k')
plot(va(8,:) ,MRa(8,:),'k')
plot([1.8533 1.8533],[0 1000],'k--')
  xlabel('Variant Richness (diversity)')
 ylabel('Measured Resistance M_R')
 legend('x=1', 'x=2to8')
 title('4 loci AND')
  axis([0 10 0 1.1])

 %OR RESILIENCE
figure 
plot(voexact(1,:),1./T1oe(1,:),'k', 'linewidth',2)%all sp values for one exploit
hold on
plot(voexact(2,:),1./T1oe(2,:),'k')
plot(voexact(3,:),1./T1oe(3,:),'k')
plot(voexact(4,:),1./T1oe(4,:),'k')
plot(voexact(5,:),1./T1oe(5,:),'k')
plot(voexact(6,:),1./T1oe(6,:),'k')
plot(voexact(7,:),1./T1oe(7,:),'k')
plot(voexact(8,:),1./T1oe(8,:),'k')
plot([18.615 18.615],[0 1],'k--')
  xlabel('Variant Richness (diversity)')
 ylabel('Measured Resilience M_L')
 legend('x=1', 'x=2to8')
 title('4 loci OR - exact')
  axis([0 60 0 0.004])
 
  %AND RESILIENCE
figure 
plot(va(1,:),1./T1a(1,:),'k', 'linewidth',2)%all sp values for one exploit
hold on
plot(va(2,:),1./T1a(2,:),'k')
plot(va(3,:),1./T1a(3,:),'k')
plot(va(4,:),1./T1a(4,:),'k')
plot(va(5,:),1./T1a(5,:),'k')
plot(va(6,:),1./T1a(6,:),'k')
plot(va(7,:),1./T1a(7,:),'k')
plot(va(8,:),1./T1a(8,:),'k')
plot([1.8533 1.8533],[0 1],'k--')
  xlabel('Variant Richness (diversity)')
 ylabel('Measured Resilience M_L')
 legend('x=1', 'x=2to8')
 title('4 loci AND')
  axis([0 10 0 0.008])

 %OR RESILIENCE
figure 
plot(voexact(1,:),1./T1oe(1,:),'k', 'linewidth',2)%all sp values for one exploit
hold on
plot(voexact(2,:),1./T1oe(2,:),'k')
plot(voexact(3,:),1./T1oe(3,:),'k')
plot(voexact(4,:),1./T1oe(4,:),'k')
plot(voexact(5,:),1./T1oe(5,:),'k')
plot(voexact(6,:),1./T1oe(6,:),'k')
plot(voexact(7,:),1./T1oe(7,:),'k')
plot(voexact(8,:),1./T1oe(8,:),'k')
plot([18.615 18.615],[0 1],'k--')
  xlabel('Variant Richness (diversity)')
 ylabel('Measured Resilience M_L')
 legend('x=1', 'x=2to8')
 title('4 loci OR - exact')
  axis([0 60 0 0.004])
 
  %AND RESILIENCE
figure 
plot(va(1,:),1./T1a(1,:),'k', 'linewidth',2)%all sp values for one exploit
hold on
plot(va(2,:),1./T1a(2,:),'k')
plot(va(3,:),1./T1a(3,:),'k')
plot(va(4,:),1./T1a(4,:),'k')
plot(va(5,:),1./T1a(5,:),'k')
plot(va(6,:),1./T1a(6,:),'k')
plot(va(7,:),1./T1a(7,:),'k')
plot(va(8,:),1./T1a(8,:),'k')
plot([1.8533 1.8533],[0 1],'k--')
  xlabel('Variant Richness (diversity)')
 ylabel('Measured Resilience M_L')
 legend('x=1', 'x=2to8')
 title('4 loci AND rESILIENCE INVERTED')
 axis([0 10 0 0.008])
  
  return


 %************************
 % optimum diversity to tolerate an attack using QT
% minimise diversity with recovery
%************************
%80% QT, Vary bn/y
I0=0
QT = 0.8
Rc = -1*log(QT)/(1-QT)%critical values
bny = [Rc 2 3 4 5 6 7 100]
%calculate sp
top = 1-QT
e = (-1.*bny.*(1-QT))
bottom = 1-((1-I0).*exp(e))
sp = top./bottom

%************ Average cases
for j = 1:8 %SP values
for x = 1:8
%average AND - 4 loci
va(x,j) = V4LociANDMin( x, sp(j) );
 %average OR - 4 loci using approximation - CANT USE APPROXIMATION FOR THIS
 %SINCE bny VALUES GENERATE HIGH Sp VALUES
vo(x,j) = V4LociORMin( x, sp(j) );
voexact(x,j) = VRExact4LociOR( x, sp(j) ); %OR exact
%one locus model
vOne(x,j) = V1Loci( x, sp(j) )
end
end
va
vo
voexact
%One locus case
figure
plot(1:8,vOne(:,1),'k','linewidth',2) %Rc
hold on
plot(1:8,vOne(:,2),'k--') %bny
%plot(1:8,va(:,3),'k.-') %bny
plot(1:8,vOne(:,4),'k+-') %bny
%plot(1:8,va(:,5),'k') %bny
%plot(1:8,va(:,6),'k') %bny
%plot(1:8,va(:,7),'k') %bny
plot(1:8,vOne(:,8),'k.-') %bny
xlabel('Exploit Richness')
ylabel('Variant Richness')
 legend('bn/y=Rc  (Sp=1)', 'bn/y=2', 'bn/y=4', 'bn/y=100 (Sp=0.2)')
 title('80% Tolerance, one locus')
%AND case
figure
plot(1:8,va(:,1),'k','linewidth',2) %Rc
hold on
plot(1:8,va(:,2),'k--') %bny
%plot(1:8,va(:,3),'k.-') %bny
plot(1:8,va(:,4),'k+-') %bny
%plot(1:8,va(:,5),'k') %bny
%plot(1:8,va(:,6),'k') %bny
%plot(1:8,va(:,7),'k') %bny
plot(1:8,va(:,8),'k.-') %bny
xlabel('Exploit Richness')
ylabel('Variant Richness')
 legend('bn/y=Rc  (Sp=1)', 'bn/y=2', 'bn/y=4', 'bn/y=100 (Sp=0.2)')
 title('80% Tolerance, 4 loci AND')
%OR case approx
figure
plot(1:8,vo(:,1),'k','linewidth',2) %Rc
hold on
plot(1:8,vo(:,2),'ko-') %bny
%plot(1:8,va(:,3),'k.-') %bny
plot(1:8,vo(:,4),'k+-') %bny
%plot(1:8,va(:,5),'k') %bny
%plot(1:8,va(:,6),'k') %bny
%plot(1:8,va(:,7),'k') %bny
plot(1:8,vo(:,8),'k.-') %bny
xlabel('Exploit Richness')
ylabel('Variant Richness')
 legend('bn/y=Rc  (Sp=1)', 'bn/y=2', 'bn/y=4', 'bn/y=100 (Sp=0.2)')
 title('80% Tolerance, 4 loci OR')

%OR case exact
figure
plot(1:8,voexact(:,1),'k','linewidth',2) %Rc
hold on
plot(1:8,voexact(:,2),'k--') %bny
%plot(1:8,va(:,3),'k.-') %bny
plot(1:8,voexact(:,4),'k+-') %bny
%plot(1:8,va(:,5),'k') %bny
%plot(1:8,va(:,6),'k') %bny
%plot(1:8,va(:,7),'k') %bny
plot(1:8,voexact(:,8),'k.-') %bny
xlabel('Exploit Richness')
ylabel('Variant Richness')
 legend('bn/y=Rc (Sp=1)', 'bn/y=2', 'bn/y=4', 'bn/y=100 (Sp=0.2)')
 title('80% Tolerance, 4 loci OR')
 
 
 %OR case exact and approx
figure
plot(1:8,voexact(:,1),'k','linewidth',2) %Rc
hold on
plot(1:8,voexact(:,2),'ko-') %bny
%plot(1:8,va(:,3),'k.-') %bny
plot(1:8,voexact(:,4),'k+-') %bny
%plot(1:8,va(:,5),'k') %bny
%plot(1:8,va(:,6),'k') %bny
%plot(1:8,va(:,7),'k') %bny
plot(1:8,voexact(:,8),'k.-') %bny

plot(1:8,vo(:,1),'k') %Rc
hold on
plot(1:8,vo(:,2),'k') %bny
%plot(1:8,va(:,3),'k.-') %bny
plot(1:8,vo(:,4),'k') %bny
%plot(1:8,va(:,5),'k') %bny
%plot(1:8,va(:,6),'k') %bny
%plot(1:8,va(:,7),'k') %bny
plot(1:8,vo(:,8),'k') %bny
xlabel('Exploit Richness')
ylabel('Variant Richness')
 legend('bn/y=Rc (Sp=1)', 'bn/y=2', 'bn/y=4', 'bn/y=100 (Sp=0.2)')
 title('80% Tolerance, 4 loci OR') 
return







%*******************
%2 loci AND example - general case, exact solution
%*******************
%minimum solution for specified exploits in each locus
x1 = 2; x2 = 4; tol = 0.2;
mw1 = 2; mw2 = 4;
numGenotypes = x1*x2/tol
w1=1:12
w2 = ceil(numGenotypes./w1)
minw1 = ones(1,12)*mw1
minw2 = ones(1,12)*mw2
figure
plot(w1,w2,'k')
hold on
plot(minw2,'k--')
plot(mw1,w2,'k+-')
xlabel('v1')
ylabel('v2')
title('Number of variants - different solutions')
figure
sumVariants = w1+w2
plot(w1,sumVariants,'k')
hold on
xlabel('v1')
ylabel('sum of Variants')
title('Sum of variants - optimum solutions')
%*******************
%2 loci OR example - general case, exact solution
%*******************
s=0.2;x1=2;x2=4;
for v1 = 1:40
v2(v1)=ceil(((x1*x2/v1)-x2)/((x1/v1)-s)); %exact solution
v2Approx(v1) =ceil(x2./(s-(x1/v1)));%approx solution when only use first term
sumV(v1) = v1+v2(v1);
multV(v1) = v1*v2(v1);
end
figure
plot(v2,'k')
hold on
%plot(v2Approx,'b')
xlabel('v1')
ylabel('v2')
title('OR 2 loci - Number of variants')

figure
plot(sumV,'k')
xlabel('v1')
ylabel('Total number of variants across all loci')
title('OR 2 loci - Number of variants')

figure
plot(multV,'k')
xlabel('v1')
ylabel('Total number of genotypes')
title('OR 2 loci - Number of genotypes')
%*************************************************************
%OUTPUTS - NO RECOVERY
%************************************************************
%APPROXIMATION GRAPHS - OR type
%*************************************************************
%********************************
%Approximate solution example for two loci, comparing the exact solution to
%the approximate solution
%2 loci OR plot equation - maximum diversity when x1 = x2 and v1 = v2
%2x/v - x^2/v^2
%x=1;
maxV=500;
for x=1:20
v=1:maxV;
a(x,:)=(2.*x./v);
b(x,:)=(x.^2./v.^2);
size(a);
size(b);
sp = a - b;
end
sp2=sp;
a2=a;
figure
plot(sp(1,:),'k', 'LineWidth',2)
hold on
plot(a(1,:),'k--', 'LineWidth',2)
%plot(b(1,:),'ko-', 'LineWidth',2)

%plot(2:maxV,sp(2,2:end),'b') %only valide for v=>x
%plot(2:maxV,a(2,2:end),'b--')
%plot(2:maxV,b(2,2:end),'b.-')

plot(3:maxV,sp(3,3:end),'k')
plot(3:maxV,a(3,3:end),'k--')
%plot(3:maxV,b(3,3:end),'c.-')

%plot(4:maxV,sp(4,4:end),'g')
%plot(4:maxV,a(4,4:end),'g--')
%plot(4:maxV,b(4,4:end),'g.-')

plot(5:maxV,sp(5,5:end),'k')
plot(5:maxV,a(5,5:end),'k--')
%plot(5:maxV,b(5,5:end),'ko-')

plot(7:maxV,sp(7,7:end),'k')
plot(7:maxV,a(7,7:end),'k--')
%plot(5:maxV,b(5,5:end),'ko-')

title('OR 2 loci - Equation 2x/v - x^2/v^2')
xlabel('v1 and v2')
ylabel('Sp')
%legend ('Susceptibility', '2x/v', 'x^2/v^2')
%legend ('Exact (x1/v1 + x2/v2 - x1x2/v1v2)', 'Term 1 (x1/v1 + x2/v2)', 'Term 2 (x1x2/v1v2)')
legend ('Exact (x1/v1 + x2/v2 - x1x2/v1v2)', 'Approx (x1/v1 + x2/v2)')
axis([0 70 0 1.2])
%********************************
%2 loci OR plot equation - NOT maximum diversity
%x1/v1 +x2/v2 - x1x2/v1v2
%x=1;
maxV1=500;
x2=1;
v2=6;
for x1=1:5
v1=1:maxV1;
a(x1,:)=(x1./v1)+(x2./v2);
b(x1,:)=((x1.*x2)./(v1.*v2));
size(a);
size(b);
sp = a - b;
end
%figure
%plot(sp(1,:),'k')
%hold on
%plot(a(1,:),'k--')
%plot(b(1,:),'k.-')
%plot(5:maxV1,sp(5,5:end),'b')
%hold on
%plot(5:maxV1,a(5,5:end),'b--')
%plot(5:maxV1,b(5,5:end),'b.-')
%title('OR 2 loci - Equation x1/v1 + x2/v2 - x1x2/v1v2')
%xlabel('v')
%ylabel('sp')
%legend ('susceptibility', 'x1/v1 + x2/v2', 'x1x2/v1v2')
%********************************
%3 loci OR plot equation - maximum diversity when x1 = x2 = x3 and v1 = v2
%= v3
%3x/v - 3x^2/v^2 + x^3/v^3
%x=1;
maxV=500;
%c=zeros(20,maxV)
for x=1:20
v=1:maxV;
a(x,:)=((3.*x)./v);
b(x,:)=((3.*(x.^2))./(v.^2));
c(x,:)=(x.^3)./(v.^3);
size(a);
size(b);
size(c);
end
sp = a - b + c;
sp3=sp;
a3=a;
figure
plot(sp(1,:),'k', 'LineWidth',2)
hold on
plot(a(1,:),'k--', 'LineWidth',2)
%plot(b(1,:),'ko-', 'LineWidth',2)
%plot(c(1,:),'k.-', 'LineWidth',2)

%plot(2:maxV,sp(2,2:end),'b') %only valide for v=>x
%plot(2:maxV,a(2,2:end),'b--')
%plot(2:maxV,b(2,2:end),'b.-')

plot(3:maxV,sp(3,3:end),'k')
plot(3:maxV,a(3,3:end),'k--')
%plot(3:maxV,b(3,3:end),'ko-')
%plot(3:maxV,c(3,3:end),'k.-')

%plot(4:maxV,sp(4,4:end),'g')
%plot(4:maxV,a(4,4:end),'g--')
%plot(4:maxV,b(4,4:end),'g.-')

plot(5:maxV,sp(5,5:end),'k')
plot(5:maxV,a(5,5:end),'k--')
%plot(5:maxV,b(5,5:end),'ko-')
%plot(5:maxV,c(5,5:end),'k.-')

plot(7:maxV,sp(7,7:end),'k')
plot(7:maxV,a(7,7:end),'k--')
%plot(7:maxV,b(7,7:end),'ko-')
%plot(7:maxV,c(7,7:end),'k.-')

title('OR 3 loci - Equation 3x/v - 3x^2/v^2 + x^3/v^3')
xlabel('v1,v2,v3')
ylabel('Sp')
%legend ('Susceptibility', '2x/v', 'x^2/v^2')
%legend ('Exact (x1/v1 + x2/v2 - x1x2/v1v2)', 'Term 1 (x1/v1 + x2/v2)', 'Term 2 (x1x2/v1v2)')
legend ('Exact ', 'Approx')
axis([0 80 0 1.2])
%********************************
%4 loci OR plot equation - maximum diversity when x1 = x2 = x3=x4 and v1 = v2
%= v3=v4
%4x/v - 6x^2/v^2 + 4x^3/v^3 - x^4/v^4
%x=1;
maxV=500;
%c=zeros(20,maxV)
for x=1:20
v=1:maxV;
a(x,:)=((4.*x)./v);
b(x,:)=((6.*(x.^2))./(v.^2));
c(x,:)=(4.*x.^3)./(v.^3);
d(x,:)=(x.^4)./(v.^4);
size(a);
size(b);
size(c);
end
sp = a - b + c - d;
sp4=sp;
a4=a;
figure
plot(sp(1,:),'k', 'LineWidth',2)
hold on
plot(a(1,:),'k--', 'LineWidth',2)
%plot(b(1,:),'ko-', 'LineWidth',2)
%plot(c(1,:),'k.-', 'LineWidth',2)

%plot(2:maxV,sp(2,2:end),'b') %only valide for v=>x
%plot(2:maxV,a(2,2:end),'b--')
%plot(2:maxV,b(2,2:end),'b.-')

plot(3:maxV,sp(3,3:end),'k')
plot(3:maxV,a(3,3:end),'k--')
%plot(3:maxV,b(3,3:end),'ko-')
%plot(3:maxV,c(3,3:end),'k.-')

%plot(4:maxV,sp(4,4:end),'g')
%plot(4:maxV,a(4,4:end),'g--')
%plot(4:maxV,b(4,4:end),'g.-')

plot(5:maxV,sp(5,5:end),'k')
plot(5:maxV,a(5,5:end),'k--')
%plot(5:maxV,b(5,5:end),'ko-')
%plot(5:maxV,c(5,5:end),'k.-')

plot(7:maxV,sp(7,7:end),'k')
plot(7:maxV,a(7,7:end),'k--')
%plot(7:maxV,b(7,7:end),'ko-')
%plot(7:maxV,c(7,7:end),'k.-')

title('OR 4 loci - Equation 4x/v - 6x^2/v^2 + 4x^3/v^3 - x^4/v^4')
xlabel('v1,v2,v3,v4')
ylabel('Sp')
%legend ('Susceptibility', '2x/v', 'x^2/v^2')
%legend ('Exact (x1/v1 + x2/v2 - x1x2/v1v2)', 'Term 1 (x1/v1 + x2/v2)', 'Term 2 (x1x2/v1v2)')
legend ('Exact ', 'Approx')
axis([0 80 0 1.2])

%Compare loci between exact and approximate solutions*******************
maxV=500; for x=1:20 v=1:maxV; a1(x,:)=((x)./v); sp1=a1; end; %1 loci
figure %x=1
plot(sp1(1,:),'k', 'LineWidth',1)
hold on
plot(a1(1,:),'k--', 'LineWidth',1)
plot(sp2(1,:),'k', 'LineWidth',1)
plot(a2(1,:),'k--', 'LineWidth',1)
plot(sp3(1,:),'k', 'LineWidth',1)
plot(a3(1,:),'k--', 'LineWidth',1)
plot(sp4(1,:),'k', 'LineWidth',1)
plot(a4(1,:),'k--', 'LineWidth',1)

title('OR All loci x=1')
xlabel('v1,v2,v3,v4')
ylabel('Sp')
%legend ('Susceptibility', '2x/v', 'x^2/v^2')
%legend ('Exact (x1/v1 + x2/v2 - x1x2/v1v2)', 'Term 1 (x1/v1 + x2/v2)', 'Term 2 (x1x2/v1v2)')
legend ('Exact ', 'Approx')
axis([0 40 0 1.1])


figure %x=20
plot(sp1(20,:),'k', 'LineWidth',1)
hold on
plot(a1(20,:),'k--', 'LineWidth',1)
plot(sp2(20,:),'k', 'LineWidth',1)
plot(a2(20,:),'k--', 'LineWidth',1)
plot(sp3(20,:),'k', 'LineWidth',1)
plot(a3(20,:),'k--', 'LineWidth',1)
plot(sp4(20,:),'k', 'LineWidth',1)
plot(a4(20,:),'k--', 'LineWidth',1)

title('OR All loci x=20')
xlabel('v1,v2,v3,v4')
ylabel('Sp')
%legend ('Susceptibility', '2x/v', 'x^2/v^2')
%legend ('Exact (x1/v1 + x2/v2 - x1x2/v1v2)', 'Term 1 (x1/v1 + x2/v2)', 'Term 2 (x1x2/v1v2)')
legend ('Exact ', 'Approx')
axis([0 500 0 1.1])
%***************************************************
%END OF APPROXIMATION OR GRAPHS
%***************************************************

%*************************************************************************************************************************************

%********************************************************************************************************************************
clear all;
%************************************************
%EPIDEMIC RESULTS
%************************************************
%************************************************
%4 loci AND example - general case exact solution
%Determine optimum number of variants at each locus using the GENERAL
%EQUATION
%************************************************
x = [2 3 2 4;...
     4 3 5 4;...
     5 4 6 5;...
     6 4 6 7;...
     6 5 8 7;...
     8 5 8 8;...
     8 8 7 8;...
     8 8 8 8] % exploits
 
 Sp = [0.2 0.1 0.05]
 maxV = 20; %max number of variants
 for j = 1:3 %tolerance
 for i = 1:8 %exploits
[ v1(j,i) v2(j,i) v3(j,i) v4(j,i) ] = Loci4Min( x(i,1),x(i,2),x(i,3),x(i,4),Sp(j), maxV)
xM(i) = x(i,1).*x(i,2).*x(i,3).*x(i,4); %graph values
 end
 end
 
  %80%
 figure
 plot(xM,v1(1,:),'k+')
 hold on
 plot(xM,v2(1,:),'ko')
 plot(xM,v3(1,:),'ks')
 plot(xM,v4(1,:),'k.')
 xlabel('x1x2x3x4')
 ylabel('Number of variants')
 legend('v1', 'v2', 'v3', 'v4')
 title('80% Tolerance, 4 loci AND')
  axis([0 4500 0 20])
    %90%
 figure
 plot(xM,v1(2,:),'k+')
 hold on
 plot(xM,v2(2,:),'ko')
 plot(xM,v3(2,:),'ks')
 plot(xM,v4(2,:),'k.')
 xlabel('x1x2x3x4')
 ylabel('Number of variants')
 legend('v1', 'v2', 'v3', 'v4')
 title('90% Tolerance, 4 loci AND')
  axis([0 4500 0 20])
 %95%
 figure
 plot(xM,v1(3,:),'k+')
 hold on
 plot(xM,v2(3,:),'ko')
 plot(xM,v3(3,:),'ks')
 plot(xM,v4(3,:),'k.')
 xlabel('x1x2x3x4')
 ylabel('Number of variants')
 legend('v1', 'v2', 'v3', 'v4')
 title('95% Tolerance, 4 loci AND')
  axis([0 4500 0 20])
  
%************************************************
%4 loci OR example - general case APPROXIMATION solution
%Determine optimum number of variants at each locus using the GENERAL
%APPROXIMATION
%************************************************
clear all;
x = [2 3 2 4;...
     4 3 5 4;...
     5 4 6 5;...
     6 4 6 7;...
     6 5 8 7;...
     8 5 8 8;...
     8 8 7 8;...
     8 8 8 8] % exploits
 Sp = [0.2 0.1 0.05]
 
 %calc max V values
 xsum = sum(x,2) %sumrows
 %minSp = Sp(3)
 %maxV = ceil(xsum./Sp) + 20 %180; %max number of variants, AT LEAST 4*8/0.05 = 640 for 4 loci, 8 exploits
 for j = 1:3 %tolerance
     j
 for i = 1:8 %exploits
     i
     maxV(i,j) = ceil(xsum(i)./Sp(j)) + 20
[ v1(j,i) v2(j,i) v3(j,i) v4(j,i) ] = Loci4MinOR( x(i,1),x(i,2),x(i,3),x(i,4),Sp(j), maxV(i,j))
xM(i) = x(i,1).*x(i,2).*x(i,3).*x(i,4); %graph values
 end
 end
 
  %80%
 figure
 plot(xM,v1(1,:),'k+')
 hold on
 plot(xM,v2(1,:),'ko')
 plot(xM,v3(1,:),'ks')
 plot(xM,v4(1,:),'k.')
 xlabel('x1x2x3x4')
 ylabel('Number of variants')
 legend('v1', 'v2', 'v3', 'v4')
 title('80% Tolerance, 4 loci OR')
  axis([0 4500 0 180])
    %90%
 figure
 plot(xM,v1(2,:),'k+')
 hold on
 plot(xM,v2(2,:),'ko')
 plot(xM,v3(2,:),'ks')
 plot(xM,v4(2,:),'k.')
 xlabel('x1x2x3x4')
 ylabel('Number of variants')
 legend('v1', 'v2', 'v3', 'v4')
 title('90% Tolerance, 4 loci OR')
  axis([0 4500 0 350])
 %95%
 figure
 plot(xM,v1(3,:),'k+')
 hold on
 plot(xM,v2(3,:),'ko')
 plot(xM,v3(3,:),'ks')
 plot(xM,v4(3,:),'k.')
 xlabel('x1x2x3x4')
 ylabel('Number of variants')
 legend('v1', 'v2', 'v3', 'v4')
 title('95% Tolerance, 4 loci OR')
  axis([0 4500 0 670])
 
%******************************************************
%OUTPUTS - NO RECOVERY
%******************************************************
%Quality of service tolerance graphs AVERAGE - AND and OR TYPEs
%Average variant richness for a given tolerance 
%And peak infection time
%******************************************************

Tolerance = [0.8 0.9 0.95]
Susceptibility = [0.2 0.1 0.05]
numExploits = 1:8; %number of exploits at each locus

%**************
%single locus 
%**************
for T = 1:3 %tolerance loop
    for E = 1:8%exploit loop     
   v1(E,T) = ceil(E/(Susceptibility(T)));      %use ceil as needs to be rounded UP to a whole number   
   Sp1(E,T)=(E)./((v1(E,T)))%1loci - true SP for peak time
    end
end
%1 y label
figure %NOT USED - Average variant richness for a given tolerance
plot(v1(:,1),'k*-')
hold on
plot(v1(:,2),'k+-')
plot(v1(:,3),'ko-')
legend('80% Tolerance','90% Tolerance','95% Tolerance')
xlabel('Number of exploits per locus')
ylabel('Average Variant Richness')
title('Resistance Tolerance - 1 locus')
%2 y labels - trying to plot genotypic richness as well
%figure
%%X = [1:8];
%A=plotyy(X,v1(:,1),X,v1(:,1));
%hold on
%plotyy(X,v1(:,2),X,v1(:,2));
%plotyy(X,v1(:,3),X,v1(:,3));
%legend('80% Tolerance','90% Tolerance','95% Tolerance')
%xlabel('Number of exploits per locus')
%title('Resistance Tolerance - 1 locus')
%set(A(2),'ytick',[],'yticklabel',[20 40 60 80 100 120 140 160]);
% ylabel(A(1),'Average Variant Richness','color','k')
% ylabel(A(2),'Genotypic Richness','color','k')
%set(A(1), 'YColor', 'black');
%set(A(2), 'YColor', 'black');

%Peak infection time With diversity - 1 locus model
Bn=0.02;
Nn = 20000;
I0 = 1
term1 = 1./(Sp1.*Bn);
term2 = log((((Sp1.*Nn)-1).*((Sp1.*Nn)-I0))./(I0));
T1 = term1.*term2;
figure
plot(T1(:,1)./60./60,'k*-','Linewidth',2)
hold on
plot(T1(:,2)./60./60,'k+-','Linewidth',2)
plot(T1(:,3)./60./60,'ko-','Linewidth',2)
legend('80% Tolerance','90% Tolerance','95% Tolerance')
xlabel('Number of exploits per locus')
ylabel('Peak Infection Time (Hours)')
title('Peak Infection Time - 1 locus AND')

%**************
%AND two loci 
%**************
J=2 %2 loci
for T = 1:3 %tolerance loop
    for E = 1:8%exploit loop     
     va2(E,T) =ceil(nthroot((E^J)/(Susceptibility(T)),J)); %use ceil as needs to be rounded UP to a whole number 
     Sp2(E,T)=(E.^2)./((va2(E,T)).^2)%4loci - true SP for peak time
    end
end

figure
plot(va2(:,1),'k*-','Linewidth',2)
hold on
plot(va2(:,2),'k+-','Linewidth',2)
plot(va2(:,3),'ko-','Linewidth',2)
legend('80% Tolerance','90% Tolerance','95% Tolerance')
xlabel('Number of exploits per locus')
ylabel('Average Variant Richness')
title('Resistance Tolerance - 2 loci AND')

%Peak time With diversity
Bn=0.02;
Nn = 20000;
I0 = 1
term1 = 1./(Sp2.*Bn);
term2 = log((((Sp2.*Nn)-1).*((Sp2.*Nn)-I0))./(I0));
T2 = term1.*term2;
figure
plot(T2(:,1)./60./60,'k*-','Linewidth',2)
hold on
plot(T2(:,2)./60./60,'k+-','Linewidth',2)
plot(T2(:,3)./60./60,'ko-','Linewidth',2)
legend('80% Tolerance','90% Tolerance','95% Tolerance')
xlabel('Number of exploits per locus')
ylabel('Peak Infection Time (Hours)')
title('Peak Infection Time - 2 loci AND')

%**************
%OR two loci  - using average approximation
%**************
J=2 %2 loci
for T = 1:3 %tolerance loop
    for E = 1:8%exploit loop     
     vo2(E,T) =ceil((E.*J)./(Susceptibility(T))); %use ceil as needs to be rounded UP to a whole number 
     Spo2(E,T)=(E.*J)./((vo2(E,T)));%4loci - true SP for peak time
    end
end
vo2;
Spo2;
figure
plot(vo2(:,1),'k*-','Linewidth',2)
hold on
plot(vo2(:,2),'k+-','Linewidth',2)
plot(vo2(:,3),'ko-','Linewidth',2)
legend('80% Tolerance','90% Tolerance','95% Tolerance')
xlabel('Number of exploits per locus')
ylabel('Average Variant Richness')
title('Resistance Tolerance - 2 loci OR  - using average approximation')

%Peak time With diversity
Bn=0.02;
Nn = 20000;
I0 = 1
term1 = 1./(Spo2.*Bn);
term2 = log((((Spo2.*Nn)-1).*((Spo2.*Nn)-I0))./(I0));
T2 = term1.*term2;
figure
plot(T2(:,1)./60./60,'k*-','Linewidth',2)
hold on
plot(T2(:,2)./60./60,'k+-','Linewidth',2)
plot(T2(:,3)./60./60,'ko-','Linewidth',2)
legend('80% Tolerance','90% Tolerance','95% Tolerance')
xlabel('Number of exploits per locus')
ylabel('Peak Infection Time (Hours)')
title('Peak Infection Time - 2 loci OR  - using average approximation')


%**************
%AND three loci 
%**************
J=3 %2 loci
for T = 1:3 %tolerance loop
    for E = 1:8%exploit loop     
     va3(E,T) =ceil(nthroot((E^J)/(Susceptibility(T)),J)); %use ceil as needs to be rounded UP to a whole number 
     Sp3(E,T)=(E.^3)./((va3(E,T)).^3)%3loci - true SP for peak time
    end
end

figure
plot(va3(:,1),'k*-','Linewidth',2)
hold on
plot(va3(:,2),'k+-','Linewidth',2)
plot(va3(:,3),'ko-','Linewidth',2)
legend('80% Tolerance','90% Tolerance','95% Tolerance')
xlabel('Number of exploits per locus')
ylabel('Average Variant Richness')
title('Resistance Tolerance - 3 loci AND')

%Peak time With diversity
Bn=0.02;
Nn = 20000;
I0 = 1
term1 = 1./(Sp3.*Bn);
term2 = log((((Sp3.*Nn)-1).*((Sp3.*Nn)-I0))./(I0));
T3 = term1.*term2;
figure
plot(T3(:,1)./60./60,'k*-','Linewidth',2)
hold on
plot(T3(:,2)./60./60,'k+-','Linewidth',2)
plot(T3(:,3)./60./60,'ko-','Linewidth',2)
legend('80% Tolerance','90% Tolerance','95% Tolerance')
xlabel('Number of exploits per locus')
ylabel('Peak Infection Time (Hours)')
title('Peak Infection Time - 3 loci AND')

%**************
%OR three loci  - using average approximation
%**************
J=3 %2 loci
for T = 1:3 %tolerance loop
    for E = 1:8%exploit loop     
     vo3(E,T) =ceil((E.*J)/(Susceptibility(T))); %use ceil as needs to be rounded UP to a whole number 
     Spo3(E,T)=(E.*J)./((vo3(E,T)));%3loci - true SP for peak time
    end
end

figure
plot(vo3(:,1),'k*-','Linewidth',2)
hold on
plot(vo3(:,2),'k+-','Linewidth',2)
plot(vo3(:,3),'ko-','Linewidth',2)
legend('80% Tolerance','90% Tolerance','95% Tolerance')
xlabel('Number of exploits per locus')
ylabel('Average Variant Richness')
title('Resistance Tolerance - 3 loci OR - using average approximation')

%Peak time With diversity
Bn=0.02;
Nn = 20000;
I0 = 1
term1 = 1./(Spo3.*Bn);
term2 = log((((Spo3.*Nn)-1).*((Spo3.*Nn)-I0))./(I0));
T3 = term1.*term2;
figure
plot(T3(:,1)./60./60,'k*-','Linewidth',2)
hold on
plot(T3(:,2)./60./60,'k+-','Linewidth',2)
plot(T3(:,3)./60./60,'ko-','Linewidth',2)
legend('80% Tolerance','90% Tolerance','95% Tolerance')
xlabel('Number of exploits per locus')
ylabel('Peak Infection Time (Hours)')
title('Peak Infection Time - 3 loci OR - using average approximation')

%**************
%AND four loci 
%**************
J=4 %2 loci
for T = 1:3 %tolerance loop
    for E = 1:8%exploit loop     
     va4(E,T) =ceil(nthroot((E^J)/(Susceptibility(T)),J)); %use ceil as needs to be rounded UP to a whole number 
     Sp4(E,T)=(E.^4)./((va4(E,T)).^4)%4loci - true SP for peak time
    end
end
%Average variant Richness
figure
plot(va4(:,1),'k*-','Linewidth',2)
hold on
plot(va4(:,2),'k+-','Linewidth',2)
plot(va4(:,3),'ko-','Linewidth',2)
legend('80% Tolerance','90% Tolerance','95% Tolerance')
xlabel('Number of exploits per locus')
ylabel('Average Variant Richness')
title('Resistance Tolerance - 4 loci AND')

%Peak time With diversity
Bn=0.02;
Nn = 20000;
I0 = 1
term1 = 1./(Sp4.*Bn);
term2 = log((((Sp4.*Nn)-1).*((Sp4.*Nn)-I0))./(I0));
T4 = term1.*term2;
figure
plot(T4(:,1)./60./60,'k*-','Linewidth',2)
hold on
plot(T4(:,2)./60./60,'k+-','Linewidth',2)
plot(T4(:,3)./60./60,'ko-','Linewidth',2)
legend('80% Tolerance','90% Tolerance','95% Tolerance')
xlabel('Number of exploits per locus')
ylabel('Peak Infection Time (Hours)')
title('Peak Infection Time - 4 loci AND')

%**************
%OR four loci - using average approximation
%**************
J=4 %4 loci
for T = 1:3 %tolerance loop
    for E = 1:8%exploit loop     
     vo4(E,T) =ceil((E.*J)/(Susceptibility(T))); %use ceil as needs to be rounded UP to a whole number 
     Spo4(E,T)=(E.*J)./((vo4(E,T)));%4loci - true SP for peak time
    end
end
%Average variant Richness
figure
plot(vo4(:,1),'k*-','Linewidth',2)
hold on
plot(vo4(:,2),'k+-','Linewidth',2)
plot(vo4(:,3),'ko-','Linewidth',2)
legend('80% Tolerance','90% Tolerance','95% Tolerance')
xlabel('Number of exploits per locus')
ylabel('Average Variant Richness')
title('Resistance Tolerance - 4 loci OR - using average approximation')

%Peak time With diversity
Bn=0.02;
Nn = 20000;
I0 = 1
term1 = 1./(Spo4.*Bn);
term2 = log((((Spo4.*Nn)-1).*((Spo4.*Nn)-I0))./(I0));
T4 = term1.*term2;
figure
plot(T4(:,1)./60./60,'k*-','Linewidth',2)
hold on
plot(T4(:,2)./60./60,'k+-','Linewidth',2)
plot(T4(:,3)./60./60,'ko-','Linewidth',2)
legend('80% Tolerance','90% Tolerance','95% Tolerance')
xlabel('Number of exploits per locus')
ylabel('Peak Infection Time (Hours)')
title('Peak Infection Time - 4 loci OR - using average approximation')







%***********************************************************
%combined loci graphs of average variant richness - AND TYPE
figure
plot(v1(:,1),'k*-','Linewidth',2)
hold on
plot(v1(:,2),'k+-','Linewidth',2)
plot(v1(:,3),'ko-','Linewidth',2)
plot(va2(:,1),'k*-')
plot(va2(:,2),'k+-')
plot(va2(:,3),'ko-')
legend('80% Tolerance 1 locus','90% Tolerance 1 locus','95% Tolerance 1 locus','80% Tolerance 2 loci','90% Tolerance 2 loci','95% Tolerance 2 loci')
%legend('80% Tolerance 1 locus','80% Tolerance 2 loci','80% Tolerance 3 loci','80% Tolerance 4 loci')

xlabel('Number of exploits per locus')
ylabel('Average Variant Richness')
title('Resistance Tolerance - 1 locus and 2 loci AND')
axis([1 8 0 160])

figure
plot(v1(:,1),'k*-','Linewidth',2)
hold on
plot(v1(:,2),'k+-','Linewidth',2)
plot(v1(:,3),'ko-','Linewidth',2)
plot(va3(:,1),'k*-')
plot(va3(:,2),'k+-')
plot(va3(:,3),'ko-')
legend('80% Tolerance 1 locus','90% Tolerance 1 locus','95% Tolerance 1 locus','80% Tolerance 3 loci','90% Tolerance 3 loci','95% Tolerance 3 loci')
%legend('90% Tolerance 1 locus','90% Tolerance 2 loci','90% Tolerance 3 loci','90% Tolerance 4 loci')
xlabel('Number of exploits per locus')
ylabel('Average Variant Richness')
title('Resistance Tolerance - 1 locus and 3 loci AND')
axis([1 8 0 160])

figure
plot(v1(:,1),'k*-','Linewidth',2)
hold on
plot(v1(:,2),'k+-','Linewidth',2)
plot(v1(:,3),'ko-','Linewidth',2)
plot(va4(:,1),'k*-')
plot(va4(:,2),'k+-')
plot(va4(:,3),'ko-')
legend('80% Tolerance 1 locus','90% Tolerance 1 locus','95% Tolerance 1 locus','80% Tolerance 4 loci','90% Tolerance 4 loci','95% Tolerance 4 loci')
%legend('95% Tolerance 1 locus','95% Tolerance 2 loci','95% Tolerance 3 loci','95% Tolerance 4 loci')
xlabel('Number of exploits per locus')
ylabel('Average Variant Richness')
title('Resistance Tolerance - 1 locus and 4 loci AND')
axis([1 8 0 160])

%***********************************************************
%combined loci graphs of average variant richness - OR TYPE
figure
plot(v1(:,1),'k*-','Linewidth',2)
hold on
plot(v1(:,2),'k+-','Linewidth',2)
plot(v1(:,3),'ko-','Linewidth',2)
plot(vo2(:,1),'k*-')
plot(vo2(:,2),'k+-')
plot(vo2(:,3),'ko-')
legend('80% Tolerance 1 locus','90% Tolerance 1 locus','95% Tolerance 1 locus','80% Tolerance 2 loci','90% Tolerance 2 loci','95% Tolerance 2 loci')
%legend('80% Tolerance 1 locus','80% Tolerance 2 loci','80% Tolerance 3 loci','80% Tolerance 4 loci')

xlabel('Number of exploits per locus')
ylabel('Average Variant Richness')
title('Resistance Tolerance - 1 locus and 2 loci OR')
axis([1 8 0 700])

figure
plot(v1(:,1),'k*-','Linewidth',2)
hold on
plot(v1(:,2),'k+-','Linewidth',2)
plot(v1(:,3),'ko-','Linewidth',2)
plot(vo3(:,1),'k*-')
plot(vo3(:,2),'k+-')
plot(vo3(:,3),'ko-')
legend('80% Tolerance 1 locus','90% Tolerance 1 locus','95% Tolerance 1 locus','80% Tolerance 3 loci','90% Tolerance 3 loci','95% Tolerance 3 loci')
%legend('90% Tolerance 1 locus','90% Tolerance 2 loci','90% Tolerance 3 loci','90% Tolerance 4 loci')
xlabel('Number of exploits per locus')
ylabel('Average Variant Richness')
title('Resistance Tolerance - 1 locus and 3 loci OR')
axis([1 8 0 700])

figure
plot(v1(:,1),'k*-','Linewidth',2)
hold on
plot(v1(:,2),'k+-','Linewidth',2)
plot(v1(:,3),'ko-','Linewidth',2)
plot(vo4(:,1),'k*-')
plot(vo4(:,2),'k+-')
plot(vo4(:,3),'ko-')
legend('80% Tolerance 1 locus','90% Tolerance 1 locus','95% Tolerance 1 locus','80% Tolerance 4 loci','90% Tolerance 4 loci','95% Tolerance 4 loci')
%legend('95% Tolerance 1 locus','95% Tolerance 2 loci','95% Tolerance 3 loci','95% Tolerance 4 loci')
xlabel('Number of exploits per locus')
ylabel('Average Variant Richness')
title('Resistance Tolerance - 1 locus and 4 loci OR')
axis([1 8 0 700])


%*****************************
% AND total number of variants
%*****************************
v1Sum = v1.*1 %1 locus
va2Sum = va2.*2 %2 loci
va3Sum = va3.*3 %3 loci
va4Sum = va4.*4 %4 loci

figure
plot(v1Sum(:,1),'k*-','Linewidth',2)
hold on
plot(v1Sum(:,2),'k+-','Linewidth',2)
plot(v1Sum(:,3),'ko-','Linewidth',2)
plot(va4Sum(:,1),'k*-')
plot(va4Sum(:,2),'k+-')
plot(va4Sum(:,3),'ko-')
legend('80% Tolerance 1 locus','90% Tolerance 1 locus','95% Tolerance 1 locus','80% Tolerance 4 loci','90% Tolerance 4 loci','95% Tolerance 4 loci')
xlabel('Number of exploits per locus')
ylabel('Total number of variants (V)')
title('Resistance Tolerance - 1 locus and 4 loci - AND')

figure
plot(v1Sum(:,1),'k*-','Linewidth',2)
hold on
plot(v1Sum(:,2),'k+-','Linewidth',2)
plot(v1Sum(:,3),'ko-','Linewidth',2)
plot(va2Sum(:,1),'k*-')
plot(va2Sum(:,2),'k+-')
plot(va2Sum(:,3),'ko-')
legend('80% Tolerance 1 locus','90% Tolerance 1 locus','95% Tolerance 1 locus','80% Tolerance 2 loci','90% Tolerance 2 loci','95% Tolerance 2 loci')
xlabel('Number of exploits per locus')
ylabel('Total number of variants (V)')
title('Resistance Tolerance - 1 locus and 2 loci - AND')

figure
plot(v1Sum(:,1),'k*-','Linewidth',2)
hold on
plot(v1Sum(:,2),'k+-','Linewidth',2)
plot(v1Sum(:,3),'ko-','Linewidth',2)
plot(va3Sum(:,1),'k*-')
plot(va3Sum(:,2),'k+-')
plot(va3Sum(:,3),'ko-')
legend('80% Tolerance 1 locus','90% Tolerance 1 locus','95% Tolerance 1 locus','80% Tolerance 3 loci','90% Tolerance 3 loci','95% Tolerance 3 loci')
xlabel('Number of exploits per locus')
ylabel('Total number of variants (V)')
title('Resistance Tolerance - 1 locus and 3 loci - AND')

%*****************************
% OR total number of variants
%*****************************
v1Sum = v1.*1 %1 locus
vo2Sum = vo2.*2 %2 loci
vo3Sum = vo3.*3 %3 loci
vo4Sum = vo4.*4 %4 loci

figure
plot(v1Sum(:,1),'k*-','Linewidth',2)
hold on
plot(v1Sum(:,2),'k+-','Linewidth',2)
plot(v1Sum(:,3),'ko-','Linewidth',2)
plot(vo4Sum(:,1),'k*-')
plot(vo4Sum(:,2),'k+-')
plot(vo4Sum(:,3),'ko-')
legend('80% Tolerance 1 locus','90% Tolerance 1 locus','95% Tolerance 1 locus','80% Tolerance 4 loci','90% Tolerance 4 loci','95% Tolerance 4 loci')
xlabel('Number of exploits per locus')
ylabel('Total number of variants (V)')
title('Resistance Tolerance - 1 locus and 4 loci - OR')
axis([1 8 0 2600])

figure
plot(v1Sum(:,1),'k*-','Linewidth',2)
hold on
plot(v1Sum(:,2),'k+-','Linewidth',2)
plot(v1Sum(:,3),'ko-','Linewidth',2)
plot(vo2Sum(:,1),'k*-')
plot(vo2Sum(:,2),'k+-')
plot(vo2Sum(:,3),'ko-')
legend('80% Tolerance 1 locus','90% Tolerance 1 locus','95% Tolerance 1 locus','80% Tolerance 2 loci','90% Tolerance 2 loci','95% Tolerance 2 loci')
xlabel('Number of exploits per locus')
ylabel('Total number of variants (V)')
title('Resistance Tolerance - 1 locus and 2 loci - OR')
axis([1 8 0 2600])

figure
plot(v1Sum(:,1),'k*-','Linewidth',2)
hold on
plot(v1Sum(:,2),'k+-','Linewidth',2)
plot(v1Sum(:,3),'ko-','Linewidth',2)
plot(vo3Sum(:,1),'k*-')
plot(vo3Sum(:,2),'k+-')
plot(vo3Sum(:,3),'ko-')
legend('80% Tolerance 1 locus','90% Tolerance 1 locus','95% Tolerance 1 locus','80% Tolerance 3 loci','90% Tolerance 3 loci','95% Tolerance 3 loci')
xlabel('Number of exploits per locus')
ylabel('Total number of variants (V)')
title('Resistance Tolerance - 1 locus and 3 loci - OR')
axis([1 8 0 2600])


%*****************************
% And total number of genotypes
%*****************************
v1G = v1.*1 %1 locus
va2G = va2.^2 %2 loci
va3G= va3.^3 %3 loci
va4G = va4.^4 %4 loci
figure
plot(v1G(:,1),'k*-','Linewidth',2)
hold on
plot(v1G(:,2),'k+-','Linewidth',2)
plot(v1G(:,3),'ko-','Linewidth',2)
plot(va2G(:,1),'k*-')
hold on
plot(va2G(:,2),'k+-')
plot(va2G(:,3),'ko-')
legend('80% Tolerance 1 locus','90% Tolerance 1 locus','95% Tolerance 1 locus','80% Tolerance 2 loci','90% Tolerance 2 loci','95% Tolerance 2 loci')
xlabel('Number of exploits per locus')
ylabel('Total number of genotypes (G)')
title('Resistance Tolerance - 1 locus and 2 loci AND')

figure
plot(va3G(:,1),'k*-','Linewidth',2)
hold on
plot(va3G(:,2),'k+-','Linewidth',2)
plot(va3G(:,3),'ko-','Linewidth',2)
plot(va4G(:,1),'k*-')
hold on
plot(va4G(:,2),'k+-')
plot(va4G(:,3),'ko-')
legend('80% Tolerance 3 loci','90% Tolerance 3 loci','95% Tolerance 3 loci','80% Tolerance 4 loci','90% Tolerance 4 loci','95% Tolerance 4 loci')
xlabel('Number of exploits per locus')
ylabel('Total number of genotypes (G)')
title('Resistance Tolerance - 3 locus and 4 loci AND')

%*****************************
% And total number of genotypes
%*****************************
v1G = v1.*1 %1 locus
vo2G = vo2.^2 %2 loci
vo3G= vo3.^3 %3 loci
vo4G = vo4.^4 %4 loci
figure
plot(v1G(:,1),'k*-','Linewidth',2)
hold on
plot(v1G(:,2),'k+-','Linewidth',2)
plot(v1G(:,3),'ko-','Linewidth',2)
plot(vo2G(:,1),'k*-')
hold on
plot(vo2G(:,2),'k+-')
plot(vo2G(:,3),'ko-')
legend('80% Tolerance 1 locus','90% Tolerance 1 locus','95% Tolerance 1 locus','80% Tolerance 2 loci','90% Tolerance 2 loci','95% Tolerance 2 loci')
xlabel('Number of exploits per locus')
ylabel('Total number of genotypes (G)')
title('Resistance Tolerance - 1 locus and 2 loci OR')

figure
plot(vo3G(:,1),'k*-','Linewidth',2)
hold on
plot(vo3G(:,2),'k+-','Linewidth',2)
plot(vo3G(:,3),'ko-','Linewidth',2)
plot(vo4G(:,1),'k*-')
hold on
plot(vo4G(:,2),'k+-')
plot(vo4G(:,3),'ko-')
legend('80% Tolerance 3 loci','90% Tolerance 3 loci','95% Tolerance 3 loci','80% Tolerance 4 loci','90% Tolerance 4 loci','95% Tolerance 4 loci')
xlabel('Number of exploits per locus')
ylabel('Total number of genotypes (G)')
title('Resistance Tolerance - 3 locus and 4 loci OR')





%**************
%OR two loci 
%**************
J=2 %2 loci
for T = 1:3 %tolerance loop
    for E = 1:8%exploit loop 
        %solve('((2*x/v)-(x^2/v^2)=s)','v')
        vo2_1 = E/(sqrt(1-Susceptibility(T))+1);
        vo2_2 = E/(sqrt(1-Susceptibility(T))-1);
     vo2(E,T) =ceil(vo2_1-vo2_2); %use ceil as needs to be rounded UP to a whole number 
    end
end
        %solve('((2*x/v)-(x^2/v^2)=s)','v')
        %T = 80%
        result = solve('((2*1/v)-(1^2/v^2)=0.2)','v'); vo2_2(1,1) = result(1); %S=0.2,E=1
        result = solve('((2*2/v)-(2^2/v^2)=0.2)','v'); vo2_2(2,1) = result(1); %S=0.2,E=1
        result = solve('((2*3/v)-(3^2/v^2)=0.2)','v'); vo2_2(3,1) = result(1); %S=0.2,E=1
        result = solve('((2*4/v)-(4^2/v^2)=0.2)','v'); vo2_2(4,1) = result(1); %S=0.2,E=1
        result = solve('((2*5/v)-(5^2/v^2)=0.2)','v'); vo2_2(5,1) = result(1); %S=0.2,E=1
        result = solve('((2*6/v)-(6^2/v^2)=0.2)','v'); vo2_2(6,1) = result(1); %S=0.2,E=1
        result = solve('((2*7/v)-(7^2/v^2)=0.2)','v'); vo2_2(7,1) = result(1); %S=0.2,E=1
        result = solve('((2*8/v)-(8^2/v^2)=0.2)','v'); vo2_2(8,1) = result(1); %S=0.2,E=1
        %T = 90%
        result = solve('((2*1/v)-(1^2/v^2)=0.1)','v'); vo2_2(1,2) = result(1); %S=0.1,E=1
        result = solve('((2*2/v)-(2^2/v^2)=0.1)','v'); vo2_2(2,2) = result(1); %S=0.1,E=1
        result = solve('((2*3/v)-(3^2/v^2)=0.1)','v'); vo2_2(3,2) = result(1); %S=0.1,E=1
        result = solve('((2*4/v)-(4^2/v^2)=0.1)','v'); vo2_2(4,2) = result(1); %S=0.1,E=1
        result = solve('((2*5/v)-(5^2/v^2)=0.1)','v'); vo2_2(5,2) = result(1); %S=0.1,E=1
        result = solve('((2*6/v)-(6^2/v^2)=0.1)','v'); vo2_2(6,2) = result(1); %S=0.1,E=1
        result = solve('((2*7/v)-(7^2/v^2)=0.1)','v'); vo2_2(7,2) = result(1); %S=0.1,E=1
        result = solve('((2*8/v)-(8^2/v^2)=0.1)','v'); vo2_2(8,2) = result(1); %S=0.1,E=1
        %T = 95%
        result = solve('((2*1/v)-(1^2/v^2)=0.05)','v'); vo2_2(1,3) = result(1); %S=0.05,E=1
        result = solve('((2*2/v)-(2^2/v^2)=0.05)','v'); vo2_2(2,3) = result(1); %S=0.05,E=1
        result = solve('((2*3/v)-(3^2/v^2)=0.05)','v'); vo2_2(3,3) = result(1); %S=0.05,E=1
        result = solve('((2*4/v)-(4^2/v^2)=0.05)','v'); vo2_2(4,3) = result(1); %S=0.05,E=1
        result = solve('((2*5/v)-(5^2/v^2)=0.05)','v'); vo2_2(5,3) = result(1); %S=0.05,E=1
        result = solve('((2*6/v)-(6^2/v^2)=0.05)','v'); vo2_2(6,3) = result(1); %S=0.05,E=1
        result = solve('((2*7/v)-(7^2/v^2)=0.05)','v'); vo2_2(7,3) = result(1); %S=0.05,E=1
        result = solve('((2*8/v)-(8^2/v^2)=0.05)','v'); vo2_2(8,3) = result(1); %S=0.05,E=1

figure
plot(vo2(:,1),'k*-')
hold on
plot(vo2(:,2),'k+-')
plot(vo2(:,3),'ko-')

plot(vo2_2(:,1),'b*-')
plot(vo2_2(:,2),'b+-')
plot(vo2_2(:,3),'bo-')
legend('80% Tolerance','90% Tolerance','95% Tolerance')
xlabel('Number of exploits per locus')
ylabel('Average Variant Richness')
title('Resistance Tolerance - 2 loci OR')

solve('((x1/v1)+(x2/v2)-(x1*x2/v1*v2)=s)','v1') %with different x and v values

%**************
%OR three loci 
%**************
        %solve('((3*x/v)-(3*x^2/v^2)+(x^3/v^3)=s)','v')
        %T = 80%
        result = solve('((3*1/v)-(3*1^2/v^2)+(1^3/v^3)=0.2)','v'); vo3(1,1) = result(1); %S=0.2,E=1
        result = solve('((3*2/v)-(3*2^2/v^2)+(2^3/v^3)=0.2)','v'); vo3(2,1) = result(1); %S=0.2,E=2
        result = solve('((3*3/v)-(3*3^2/v^2)+(3^3/v^3)=0.2)','v'); vo3(3,1) = result(1); %S=0.2,E=3
        result = solve('((3*4/v)-(3*4^2/v^2)+(4^3/v^3)=0.2)','v'); vo3(4,1) = result(1); %S=0.2,E=4
        result = solve('((3*5/v)-(3*5^2/v^2)+(5^3/v^3)=0.2)','v'); vo3(5,1) = result(1); %S=0.2,E=5
        result = solve('((3*6/v)-(3*6^2/v^2)+(6^3/v^3)=0.2)','v'); vo3(6,1) = result(1); %S=0.2,E=6
        result = solve('((3*7/v)-(3*7^2/v^2)+(7^3/v^3)=0.2)','v'); vo3(7,1) = result(1); %S=0.2,E=7
        result = solve('((3*8/v)-(3*8^2/v^2)+(8^3/v^3)=0.2)','v'); vo3(8,1) = result(1); %S=0.2,E=8
        %T = 90%
        result = solve('((3*1/v)-(3*1^2/v^2)+(1^3/v^3)=0.1)','v'); vo3(1,2) = result(1); %S=0.1,E=1
        result = solve('((3*2/v)-(3*2^2/v^2)+(2^3/v^3)=0.1)','v'); vo3(2,2) = result(1); %S=0.1,E=2
        result = solve('((3*3/v)-(3*3^2/v^2)+(3^3/v^3)=0.1)','v'); vo3(3,2) = result(1); %S=0.1,E=3
        result = solve('((3*4/v)-(3*4^2/v^2)+(4^3/v^3)=0.1)','v'); vo3(4,2) = result(1); %S=0.1,E=4
        result = solve('((3*5/v)-(3*5^2/v^2)+(5^3/v^3)=0.1)','v'); vo3(5,2) = result(1); %S=0.1,E=5
        result = solve('((3*6/v)-(3*6^2/v^2)+(6^3/v^3)=0.1)','v'); vo3(6,2) = result(1); %S=0.1,E=6
        result = solve('((3*7/v)-(3*7^2/v^2)+(7^3/v^3)=0.1)','v'); vo3(7,2) = result(1); %S=0.1,E=7
        result = solve('((3*8/v)-(3*8^2/v^2)+(8^3/v^3)=0.1)','v'); vo3(8,2) = result(1); %S=0.1,E=8
        %T = 95%
        result = solve('((3*1/v)-(3*1^2/v^2)+(1^3/v^3)=0.05)','v'); vo3(1,3) = result(1); %S=0.05,E=1
        result = solve('((3*2/v)-(3*2^2/v^2)+(2^3/v^3)=0.05)','v'); vo3(2,3) = result(1); %S=0.05,E=2
        result = solve('((3*3/v)-(3*3^2/v^2)+(3^3/v^3)=0.05)','v'); vo3(3,3) = result(1); %S=0.05,E=3
        result = solve('((3*4/v)-(3*4^2/v^2)+(4^3/v^3)=0.05)','v'); vo3(4,3) = result(1); %S=0.05,E=4
        result = solve('((3*5/v)-(3*5^2/v^2)+(5^3/v^3)=0.05)','v'); vo3(5,3) = result(1); %S=0.05,E=5
        result = solve('((3*6/v)-(3*6^2/v^2)+(6^3/v^3)=0.05)','v'); vo3(6,3) = result(1); %S=0.05,E=6
        result = solve('((3*7/v)-(3*7^2/v^2)+(7^3/v^3)=0.05)','v'); vo3(7,3) = result(1); %S=0.05,E=7
        result = solve('((3*8/v)-(3*8^2/v^2)+(8^3/v^3)=0.05)','v'); vo3(8,3) = result(1); %S=0.05,E=8

figure
plot(vo3(:,1),'k*-')
hold on
plot(vo3(:,2),'k+-')
plot(vo3(:,3),'ko-')
legend('80% Tolerance','90% Tolerance','95% Tolerance')
xlabel('Number of exploits per locus')
ylabel('Average Variant Richness')
title('Resistance Tolerance - 3 loci OR')

solve('((x1/v1)+(x2/v2)+(x3/v3)-(x1*x2/v1*v2)-(x1*x3/v1*v3)-(x2*x3/v2*v3)+(x1*x2*x3/v1*v2*v3)=s)','v1') %with different x and v values
 

%**************
%OR four loci 
%**************
        %solve('((4*x/v)-(6*x^2/v^2)+(4*x^3/v^3)-(x^4/v^4)=s)','v')
        %get result(1) to ensure largest v solution which needs to be
        %greater than x and not imaginary as the solve function returns
        %range of possible solutions
        %T = 80%
        result = solve('((4*1/v)-(6*1^2/v^2)+(4*1^3/v^3)-(1^4/v^4)=0.2)','v'); vo4(1,1) = result(1); %S=0.2,E=1
        result = solve('((4*2/v)-(6*2^2/v^2)+(4*2^3/v^3)-(2^4/v^4)=0.2)','v'); vo4(2,1) = result(1); %S=0.2,E=2
        result = solve('((4*3/v)-(6*3^2/v^2)+(4*3^3/v^3)-(3^4/v^4)=0.2)','v'); vo4(3,1) = result(1); %S=0.2,E=3
        result = solve('((4*4/v)-(6*4^2/v^2)+(4*4^3/v^3)-(4^4/v^4)=0.2)','v'); vo4(4,1) = result(1); %S=0.2,E=4
        result = solve('((4*5/v)-(6*5^2/v^2)+(4*5^3/v^3)-(5^4/v^4)=0.2)','v'); vo4(5,1) = result(1); %S=0.2,E=5
        result = solve('((4*6/v)-(6*6^2/v^2)+(4*6^3/v^3)-(6^4/v^4)=0.2)','v'); vo4(6,1) = result(1); %S=0.2,E=6
        result = solve('((4*7/v)-(6*7^2/v^2)+(4*7^3/v^3)-(7^4/v^4)=0.2)','v'); vo4(7,1) = result(1); %S=0.2,E=7
        result = solve('((4*8/v)-(6*8^2/v^2)+(4*8^3/v^3)-(8^4/v^4)=0.2)','v'); vo4(8,1) = result(1); %S=0.2,E=8
        %T = 90%
        result = solve('((4*1/v)-(6*1^2/v^2)+(4*1^3/v^3)-(1^4/v^4)=0.1)','v'); vo4(1,2) = result(1); %S=0.1,E=1
        result = solve('((4*2/v)-(6*2^2/v^2)+(4*2^3/v^3)-(2^4/v^4)=0.1)','v'); vo4(2,2) = result(1); %S=0.1,E=2
        result = solve('((4*3/v)-(6*3^2/v^2)+(4*3^3/v^3)-(3^4/v^4)=0.1)','v'); vo4(3,2) = result(1); %S=0.1,E=3
        result = solve('((4*4/v)-(6*4^2/v^2)+(4*4^3/v^3)-(4^4/v^4)=0.1)','v'); vo4(4,2) = result(1); %S=0.1,E=4
        result = solve('((4*5/v)-(6*5^2/v^2)+(4*5^3/v^3)-(5^4/v^4)=0.1)','v'); vo4(5,2) = result(1); %S=0.1,E=5
        result = solve('((4*6/v)-(6*6^2/v^2)+(4*6^3/v^3)-(6^4/v^4)=0.1)','v'); vo4(6,2) = result(1); %S=0.1,E=6
        result = solve('((4*7/v)-(6*7^2/v^2)+(4*7^3/v^3)-(7^4/v^4)=0.1)','v'); vo4(7,2) = result(1); %S=0.1,E=7
        result = solve('((4*8/v)-(6*8^2/v^2)+(4*8^3/v^3)-(8^4/v^4)=0.1)','v'); vo4(8,2) = result(1); %S=0.1,E=8
        %T = 95%
        result = solve('((4*1/v)-(6*1^2/v^2)+(4*1^3/v^3)-(1^4/v^4)=0.05)','v'); vo4(1,3) = result(1); %S=0.05,E=1
        result = solve('((4*2/v)-(6*2^2/v^2)+(4*2^3/v^3)-(2^4/v^4)=0.05)','v'); vo4(2,3) = result(1); %S=0.05,E=2
        result = solve('((4*3/v)-(6*3^2/v^2)+(4*3^3/v^3)-(3^4/v^4)=0.05)','v'); vo4(3,3) = result(1); %S=0.05,E=3
        result = solve('((4*4/v)-(6*4^2/v^2)+(4*4^3/v^3)-(4^4/v^4)=0.05)','v'); vo4(4,3) = result(1); %S=0.05,E=4
        result = solve('((4*5/v)-(6*5^2/v^2)+(4*5^3/v^3)-(5^4/v^4)=0.05)','v'); vo4(5,3) = result(1); %S=0.05,E=5
        result = solve('((4*6/v)-(6*6^2/v^2)+(4*6^3/v^3)-(6^4/v^4)=0.05)','v'); vo4(6,3) = result(1); %S=0.05,E=6
        result = solve('((4*7/v)-(6*7^2/v^2)+(4*7^3/v^3)-(7^4/v^4)=0.05)','v'); vo4(7,3) = result(1); %S=0.05,E=7
        result = solve('((4*8/v)-(6*8^2/v^2)+(4*8^3/v^3)-(8^4/v^4)=0.05)','v'); vo4(8,3) = result(1); %S=0.05,E=8
figure
plot(vo4(:,1),'k*-')
hold on
plot(vo4(:,2),'k+-')
plot(vo4(:,3),'ko-')
legend('80% Tolerance','90% Tolerance','95% Tolerance')
xlabel('Number of exploits per locus')
ylabel('Average Variant Richness')
title('Resistance Tolerance - 4 loci OR')
        

%*************
% AND only - 80%
%*************
figure
plot(v1(:,1),'k*-')
hold on
plot(va2(:,1),'k+-')
plot(va3(:,1),'ko-')
plot(va4(:,1),'ks-')
legend('1 locus','2 loci','3 loci', '4 loci')
xlabel('Number of exploits per locus')
ylabel('Average Variant Richness')
title('Resistance Tolerance - 80% - AND type')
%*************
% AND only - 90%
%*************
figure
plot(v1(:,2),'k*-')
hold on
plot(va2(:,2),'k+-')
plot(va3(:,2),'ko-')
plot(va4(:,2),'ks-')
legend('1 locus','2 loci','3 loci', '4 loci')
xlabel('Number of exploits per locus')
ylabel('Average Variant Richness')
title('Resistance Tolerance - 90% - AND type')
%*************
% AND only - 95%
%*************
figure
plot(v1(:,3),'k*-')
hold on
plot(va2(:,3),'k+-')
plot(va3(:,3),'ko-')
plot(va4(:,3),'ks-')
legend('1 locus','2 loci','3 loci', '4 loci')
xlabel('Number of exploits per locus')
ylabel('Average Variant Richness')
title('Resistance Tolerance - 95% - AND type')

%*************
%AND all
%*************
figure
plot(v1(:,1),'k*-')
hold on
plot(va2(:,1),'k+-')
plot(va3(:,1),'ko-')
plot(va4(:,1),'ks-')

plot(v1(:,2),'r*-')
hold on
plot(va2(:,2),'r+-')
plot(va3(:,2),'ro-')
plot(va4(:,2),'rs-')

plot(v1(:,3),'b*-')
hold on
plot(va2(:,3),'b+-')
plot(va3(:,3),'bo-')
plot(va4(:,3),'bs-')
legend('1 locus','2 loci','3 loci', '4 loci')
xlabel('Number of exploits per locus')
ylabel('Average Variant Richness')
title('Resistance Tolerance - All - AND type')

%*************
% OR only - 80%
%*************
figure
plot(v1(:,1),'k*-')
hold on
plot(vo2(:,1),'k+-')
plot(vo3(:,1),'ko-')
plot(vo4(:,1),'ks-')
legend('1 locus','2 loci','3 loci', '4 loci')
xlabel('Number of exploits per locus')
ylabel('Average Variant Richness')
title('Resistance Tolerance - 80% - OR type')
%*************
% OR only - 90%
%*************
figure
plot(v1(:,2),'k*-')
hold on
plot(vo2(:,2),'k+-')
plot(vo3(:,2),'ko-')
plot(vo4(:,2),'ks-')
legend('1 locus','2 loci','3 loci', '4 loci')
xlabel('Number of exploits per locus')
ylabel('Average Variant Richness')
title('Resistance Tolerance - 90% - OR type')
%*************
% OR only - 95%
%*************
figure
plot(v1(:,3),'k*-')
hold on
plot(vo2(:,3),'k+-')
plot(vo3(:,3),'ko-')
plot(vo4(:,3),'ks-')
legend('1 locus','2 loci','3 loci', '4 loci')
xlabel('Number of exploits per locus')
ylabel('Average Variant Richness')
title('Resistance Tolerance - 95% - OR type')

%*************
%OR all
%*************
figure
plot(v1(:,1),'k*-')
hold on
plot(vo2(:,1),'k+-')
plot(vo3(:,1),'ko-')
plot(vo4(:,1),'ks-')

plot(v1(:,2),'r*-')
hold on
plot(vo2(:,2),'r+-')
plot(vo3(:,2),'ro-')
plot(vo4(:,2),'rs-')

plot(v1(:,3),'b*-')
hold on
plot(vo2(:,3),'b+-')
plot(vo3(:,3),'bo-')
plot(vo4(:,3),'bs-')
legend('1 locus','2 loci','3 loci', '4 loci')
xlabel('Number of exploits per locus')
ylabel('Average Variant Richness')
title('Resistance Tolerance - All - OR type')

%solve('(4/v) - (6/v^2) + (4/v^3) - (1/v^4) =0.2','v')
  
 

















end

