%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Jennifer Jackson 2017                                                        %
% A Biodiversity Approach to Cyber Security                                    %
% PhD Complexity Science                                                       %
% University of Warwick                                                        %
% http://wrap.warwick.ac.uk/98458                                              %
% This software is distributed under the  Creative Commons Attribution License %
% https://creativecommons.org/licenses/by/4.0/                                 %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function [ output_args ] = StaticSIRDeterministicTests( )
clear all;
close all;
doTests = zeros(1,10)
%doTests(1) = 1 % do test 1 only
%doTests(2) = 1 % do test 2 only
%doTests(3) = 1
doTests0 = 1
%***********************************************
%basic SIR tests for background chapter of thesis
%************************************************
if doTests0 ==1
clear all;
outputDirectory = 'graphs\'

% Ro balance equation
%solve('1-x = exp(-1.0*R0*x)', 'Real', true)
Ro = [0.0 0.5 1.0 1.1 1.2 1.3 1.4 1.5 1.6 1.7 1.8 1.9 2.0 2.1 2.2 2.3 2.4 2.5 2.6 2.7 2.8 2.9 3.0 3.1 3.2 3.5 3.7 4.0]

answer(1) = solve('1-x = exp(-1.0*0.0*x)', 'Real', true)
answer(2) = solve('1-x = exp(-1.0*0.5*x)', 'Real', true)
answer(3) = solve('1-x = exp(-1.0*1.0*x)', 'Real', true)
answer(4) = solve('1-x = exp(-1.0*1.1*x)', 'Real', true)
answer(5) = solve('1-x = exp(-1.0*1.2*x)', 'Real', true)
answer(6) = solve('1-x = exp(-1.0*1.3*x)', 'Real', true)
answer(7) = solve('1-x = exp(-1.0*1.4*x)', 'Real', true)
answer(8) = solve('1-x = exp(-1.0*1.5*x)', 'Real', true)
answer(9) = solve('1-x = exp(-1.0*1.6*x)', 'Real', true)
answer(10) = solve('1-x = exp(-1.0*1.7*x)', 'Real', true)
answer(11) = solve('1-x = exp(-1.0*1.8*x)', 'Real', true)
answer(12) = solve('1-x = exp(-1.0*1.9*x)', 'Real', true)
answer(13) = solve('1-x = exp(-1.0*2.0*x)', 'Real', true)
answer(14) = solve('1-x = exp(-1.0*2.1*x)', 'Real', true)
answer(15) = solve('1-x = exp(-1.0*2.2*x)', 'Real', true)
answer(16) = solve('1-x = exp(-1.0*2.3*x)', 'Real', true)
answer(17) = solve('1-x = exp(-1.0*2.4*x)', 'Real', true)
answer(18) = solve('1-x = exp(-1.0*2.5*x)', 'Real', true)
answer(19) = solve('1-x = exp(-1.0*2.6*x)', 'Real', true)
answer(20) = solve('1-x = exp(-1.0*2.7*x)', 'Real', true)
answer(21) = solve('1-x = exp(-1.0*2.8*x)', 'Real', true)
answer(22) = solve('1-x = exp(-1.0*2.9*x)', 'Real', true)
answer(23) = solve('1-x = exp(-1.0*3.0*x)', 'Real', true)
answer(24) = solve('1-x = exp(-1.0*3.1*x)', 'Real', true)
answer(25) = solve('1-x = exp(-1.0*3.2*x)', 'Real', true)
answer(26) = solve('1-x = exp(-1.0*3.5*x)', 'Real', true)
answer(27) = solve('1-x = exp(-1.0*3.7*x)', 'Real', true)
answer(28) = solve('1-x = exp(-1.0*4.0*x)', 'Real', true)

figbalance = figure
plot(Ro,answer,'k','Linewidth',2)
xlabel('Ro')
ylabel('Final Size')
saveas(figbalance,[outputDirectory 'Test0figbalance.fig']);
saveas(figbalance,[outputDirectory 'Test0figbalance.emf']);


%SI
N=1000 %100
S = N %total number of susceptible nodes in network
beta = 0.3 %0.05 %0.5
gamma = 0; %1/48*60*60 %2 days
R=0
I=1
drawPlots=0
timeMax=200 %1000
j=1;
figSIBackground = figure
c = ['r', 'm', 'c', 'k','b', 'g', 'r', 'm']
for i = 1:1
    [Ro(i) St(i,:) It(i,:) Rt(i,:)] = SIRDeterministic(beta(i), gamma, S(i), I, R, timeMax, drawPlots);
    %plot(St(i,:),'b')
    %if i == 1 || i == 10 || i == 20 || i == 50 || i == 70 || i ==100 || i==200 || i==300 || i==400
    hold on
    %plot(It(i,:),c(j))
    plot(St(i,:),'k--')
    hold on
     plot(It(i,:),'k', 'Linewidth', 2)
    %plot(Rt(i,:),'g')
    j = j+1;
    %end   
end
    xlabel('Timesteps')
    ylabel('Number of individuals')
    %title('SI Test 1 - increasing variants exploited on 1 locus with 8 variants')
    title('b) SI - beta = 0.3, gamma = 0')
    legend('S(t)', 'I(t)')
saveas(figSIBackground,[outputDirectory 'Test0figSIBackground.fig']);
saveas(figSIBackground,[outputDirectory 'Test0figSIBackground.emf']);

%SIR
N=1000
S = N %total number of susceptible nodes in network
beta = 0.3 ; %0.05
gamma = 0.15;%0.015; %1/48*60*60 %2 days
R=0
I=1
drawPlots=0
timeMax=200 %1000
j=1;
figSIRBackground = figure
c = ['r', 'm', 'c', 'k','b', 'g', 'r', 'm']
for i = 1:1
    [Ro(i) St(i,:) It(i,:) Rt(i,:)] = SIRDeterministic(beta(i), gamma, S(i), I, R, timeMax, drawPlots);
    %plot(St(i,:),'b')
    %if i == 1 || i == 10 || i == 20 || i == 50 || i == 70 || i ==100 || i==200 || i==300 || i==400
    hold on
    %plot(It(i,:),c(j))
    plot(St(i,:),'k--')
     hold on
     plot(It(i,:),'k', 'Linewidth', 2)  
     plot(Rt(i,:),'k')
    j = j+1;
    %end   
end
    xlabel('Timesteps')
    ylabel('Number of individuals')
    %title('SI Test 1 - increasing variants exploited on 1 locus with 8 variants')
    title('a) SIR - beta = 0.3, gamma = 0.15')
    legend('S(t)', 'I(t)', 'R(t)')
saveas(figSIRBackground,[outputDirectory 'Test0figSIRBackground.fig']);
saveas(figSIRBackground,[outputDirectory 'Test0figSIRBackground.emf']);

%SIR - R0
clear all;
outputDirectory = 'graphs\'
N=1000
S = N %total number of susceptible nodes in network
%beta = [0.045 0.05 0.055]
%beta = [0.045 0.05 0.055]
%beta = [0.1 0.15 0.10 0.15 0.30 0.35 0.40 0.45 0.50]
beta = [0.5 0.45 0.40 0.35 0.30 0.25 0.20 0.15 0.10]
gamma = 0.3; %0.05; %1/48*60*60 %2 days
R=0
I=1
drawPlots=0
timeMax=200
j=1;
figSIRR0Background1 = figure
c = ['r', 'm', 'c', 'k','b', 'g', 'r', 'm']
for i = 1:9
    [Ro(i) St(i,:) It(i,:) Rt(i,:)] = SIRDeterministic(beta(i), gamma, S, I, R, timeMax, drawPlots);
    %plot(St(i,:),'b')
    %if i == 1 || i == 10 || i == 20 || i == 50 || i == 70 || i ==100 || i==200 || i==300 || i==400
    hold on
    %plot(It(i,:),c(j))
    %plot(St(i,:),'k--')
     hold on
     %plot(It(i,:),'k')  
     %plot(Rt(i,:),'k.-')
    j = j+1;
    %end   
end
%decimate
decBy = 5;
timeScale = 1:decBy:timeMax
plot(It(1,:),'k--') ;%plot(It(1,:),'k--')
plot(It(2,:),'k','Linewidth',2)
plot(timeScale,It(3,1:decBy:end),'k+-','Markersize',4)
plot(timeScale,It(4,1:decBy:end),'ko-','Markersize',4)
plot(timeScale,It(5,1:decBy:end),'k')
plot(timeScale,It(6,1:decBy:end),'k.-','Markersize',8)
plot(timeScale,It(7,1:decBy:end),'k')
plot(timeScale,It(8,1:decBy:end),'k')
plot(timeScale,It(9,1:decBy:end),'k')
    xlabel('Timesteps')
    ylabel('Number of individuals infected I(t)')
    %title('SI Test 1 - increasing variants exploited on 1 locus with 8 variants')
    title('c) SIR - gamma = 0.3')
    %legend('beta=0.45', 'beta=0.5', 'beta=0.55')
    legend('0.5', '0.45', '0.40', '0.35', '0.30', '0.25', '0.20', '0.15', '0.10')
    axis([0 200 0 120])
    
    figSIRR0Background2 = figure
    plot(beta,Ro,'k')
    hold on
    plot(beta,[1 1 1 1 1 1 1 1 1],'k--')
    plot([0.3 0.3],[0.2 1.4],'k--')
    xlabel('beta')
    ylabel('Ro')
    %title('SI Test 1 - increasing variants exploited on 1 locus with 8 variants')
    title('d) SIR - R0, gamma = 0.3')
    
    %axis([0.45 0.55 0.85 1.15])
    %legend('S(t)', 'I(t)', 'R(t)')
 
    figSIRR0Background3 = figure
    plot(timeScale,It(4,1:decBy:end),'ko-','Markersize',4) ;%plot(It(4,:),'ko-','Markersize',3)
    hold on
    plot(timeScale,It(5,1:decBy:end),'k', 'Linewidth',1)
    plot(timeScale,It(6,1:decBy:end),'k.-','Markersize',8)
    xlabel('Timesteps')
    ylabel('Number of individuals infected I(t)')
    %title('SI Test 1 - increasing variants exploited on 1 locus with 8 variants')
    %title('c) SIR - gamma = 0.3')
    %legend('beta=0.45', 'beta=0.5', 'beta=0.55')
    legend('0.35, Ro>1', '0.30, Ro = 1', '0.25, Ro<1')
    
saveas(figSIRR0Background1,[outputDirectory 'Test0figSIRR0Background1.fig']);
saveas(figSIRR0Background1,[outputDirectory 'Test0figSIRR0Background1.emf']);
saveas(figSIRR0Background2,[outputDirectory 'Test0figSIRR0Background2.fig']);
saveas(figSIRR0Background2,[outputDirectory 'Test0figSIRR0Background2.emf']);
saveas(figSIRR0Background3,[outputDirectory 'Test0figSIRR0Background3.fig']);
saveas(figSIRR0Background3,[outputDirectory 'Test0figSIRR0Background3.emf']);

return
%fix beta, vary gamma

%SIR - R0
clear all;
outputDirectory = 'graphs\'
N=1000
S = N %total number of susceptible nodes in network
beta = 0.3
gamma = [0.05 0.07 0.1 0.2 0.3 0.4 0.5 0.6 0.7]; %1/48*60*60 %2 days
R=0
I=1
drawPlots=0
timeMax=150
j=1;
figSIRR0Background1 = figure
c = ['r', 'm', 'c', 'k','b', 'g', 'r', 'm']
for i = 1:9
    [Ro(i) St(i,:) It(i,:) Rt(i,:)] = SIRDeterministic(beta, gamma(i), S, I, R, timeMax, drawPlots);
    %plot(St(i,:),'b')
    %if i == 1 || i == 10 || i == 20 || i == 50 || i == 70 || i ==100 || i==200 || i==300 || i==400
    hold on
    %plot(It(i,:),c(j))
    %plot(St(i,:),'k--')
     hold on
     %plot(It(i,:),'k')  
     %plot(Rt(i,:),'k.-')
    j = j+1;
    %end   
end
plot(It(1,:),'k--')
plot(It(2,:),'k','Linewidth',2)
plot(It(3,:),'k+-','Markersize',3)
plot(It(4,:),'ko-','Markersize',3)
plot(It(5,:),'k')
plot(It(6,:),'k')
plot(It(7,:),'k')
plot(It(8,:),'k')
plot(It(9,:),'k')
    xlabel('Timesteps')
    ylabel('Number of individuals infected I(t)')
    %title('SI Test 1 - increasing variants exploited on 1 locus with 8 variants')
    title(' SIR - beta = 0.3')
    legend('0.05', '0.07', '0.1', '0.2', '0.3', '0.4', '0.5', '0.6', '0.7')
    axis([0 200 0 600])
    
    figSIRR0Background2 = figure
    plot(gamma,Ro,'k')
    hold on
    plot(gamma,[1 1 1 1 1 1 1 1 1],'k--')
    plot([0.3 0.3],[0.2 1.4],'k--')
    xlabel('gamma')
    ylabel('Ro')
    %title('SI Test 1 - increasing variants exploited on 1 locus with 8 variants')
    title('d) SIR - R0, beta = 0.3')
    %axis([0.45 0.55 0.85 1.15])
    %legend('S(t)', 'I(t)', 'R(t)')
    
saveas(figSIRR0Background1,[outputDirectory 'Test0figSIRgammaBackground1.fig']);
saveas(figSIRR0Background1,[outputDirectory 'Test0figSIRgammaBackground1.emf']);
saveas(figSIRR0Background2,[outputDirectory 'Test0figSIRgammaBackground2.fig']);
saveas(figSIRR0Background2,[outputDirectory 'Test0figSIRgammaBackground2.emf']);




end
return
%*************************************************************
%Testing of static diversity using the deterministic model
%***************************************************************
%********************************
% SI testing - set gamma to zero
%********************************
%The only way to stop the virus is when V(number of variants on 1 loci) = N(number of nodes)

%*********
%SI test 1
%*********
clear all;
outputDirectory = 'graphs\'
%1 loci test
%Vmax - assume a fixed number of variants on 1 loci
%increase the number exploited upto Vmax
%note change in beta
N=100
Vmax = 8
V=1:Vmax %number variants exploited
Sprop = V./Vmax
S = N.*Sprop
B = 0.02
beta = B.*Sprop
gamma = 0; %1/48*60*60 %2 days
R=0
I=1
drawPlots=0
timeMax=4000
j=1;
figSI1 = figure
c = ['r', 'm', 'c', 'k','b', 'g', 'r', 'm']
for i = 1:Vmax
    [Ro(i) St(i,:) It(i,:) Rt(i,:)] = SIRDeterministic(beta(i), gamma, S(i), I, R, timeMax, drawPlots);
    %plot(St(i,:),'b')
    %if i == 1 || i == 10 || i == 20 || i == 50 || i == 70 || i ==100 || i==200 || i==300 || i==400
    hold on
    %plot(It(i,:),c(j))
     plot(It(i,:),'k')
    %plot(Rt(i,:),'g')
    j = j+1;
    %end   
end
    xlabel('Timesteps')
    ylabel('Number of nodes infected - It')
    %title('SI Test 1 - increasing variants exploited on 1 locus with 8 variants')
    title('a) SI - increasing exploits on 1 locus with 8 variants')
    %legend('1 variant exploited', '2 variant exploited','3 variant exploited','4 variant exploited','5 variant exploited','6 variant exploited','7 variant exploited','8 variant exploited')
saveas(figSI1,[outputDirectory 'figSI1.fig']);
saveas(figSI1,[outputDirectory 'figSI1.emf']);
%*********
%SI test 2
%*********
clear all;
outputDirectory = 'graphs\'
%1 loci test
%Vmax - assume a fixed number of variants on 1 loci
%increase the number exploited upto Vmax
%note change in beta
N=100
Vmax = 100
V=1:Vmax %number variants exploited
Sprop = V./Vmax
S = N.*Sprop
B = 0.02
beta = B.*Sprop
gamma = 0; %1/48*60*60 %2 days
R=0
I=1
drawPlots=0
timeMax=4000
j=1;
figSI2=figure
c = ['r', 'm', 'c', 'k','b', 'g', 'r', 'm']
for i = 1:Vmax
    [Ro(i) St(i,:) It(i,:) Rt(i,:)] = SIRDeterministic(beta(i), gamma, S(i), I, R, timeMax, drawPlots);
    %plot(St(i,:),'b')
    if i == 1 || i == 10 || i == 20 || i == 50 || i == 70 || i ==100 || i==200 || i==300 || i==400
    hold on
    %plot(It(i,:),c(j))
    plot(It(i,:),'k')
    %plot(Rt(i,:),'g')
    j = j+1;
    end   
end
    xlabel('Timesteps')
    ylabel('Number of nodes infected - It')
    %title('SI Test 2 - increasing variants exploited on 1 locus with N variants')
    title('b) SI - increasing exploits on 1 locus with N variants')
    legend('1 variant exploited', '10 variant exploited','20 variant exploited','50 variant exploited','70 variant exploited','100 variant exploited')
saveas(figSI2,[outputDirectory 'figSI2.fig']);
saveas(figSI2,[outputDirectory 'figSI2.emf']);
%*********
%SI test 3
%*********
clear all;
outputDirectory = 'graphs\'
%1 loci test
%assume a fixed number exploited V
%increase the number of variants on 1 loci up to 8
%note change in beta
N=100
Vmax = 1:8 %number variants on loci
V=1%fixed exploited
Sprop = V./Vmax
S = N.*Sprop
B = 0.02
beta = B.*Sprop
gamma = 0; %1/48*60*60 %2 days
R=0
I=1
drawPlots=0
timeMax=4000
j=1;
figSI3 = figure
c = ['r', 'm', 'c', 'k','b', 'g', 'r', 'm']
for i = 1:8
    [Ro(i) St(i,:) It(i,:) Rt(i,:)] = SIRDeterministic(beta(i), gamma, S(i), I, R, timeMax, drawPlots);
    %plot(St(i,:),'b')
    %if i == 1 || i == 10 || i == 20 || i == 50 || i == 70 || i ==100 || i==200 || i==300 || i==400
    hold on
    plot(It(i,:),'k')
    %plot(It(i,:),c(j))
    %plot(Rt(i,:),'g')
    j = j+1;
    %end   
end
    xlabel('Timesteps')
    ylabel('Number of nodes infected - It')
    %title('SI Test 3 - increasing variants on 1 locus up to 8 with fixed variants exploited to 1')
    title('c) SI - increasing variants on 1 locus up to 8 with 1 exploit')
    legend('1 variant', '2 variant','3 variant','4 variant','5 variant','6 variant','7 variant','8 variant')
    saveas(figSI3,[outputDirectory 'figSI3.fig']);
saveas(figSI3,[outputDirectory 'figSI3.emf']);
%*********
%SI test 4
%*********
clear all;
outputDirectory = 'graphs\'
%1 loci test
%assume a fixed number exploited variants V
%increase the number of variants on 1 loci up to N
%note change in beta
N=100
Vmax = 1:N %number variants on loci
V=1%fixed exploited
Sprop = V./Vmax
S = N.*Sprop
B = 0.02
beta = B.*Sprop

gamma = 0; %1/48*60*60 %2 days
R=0
I=1
drawPlots=0
timeMax=4000
j=1;
figSI4 = figure
c = ['r', 'm', 'c', 'k','b', 'g', 'r', 'm']
for i = 1:N
    [Ro(i) St(i,:) It(i,:) Rt(i,:)] = SIRDeterministic(beta(i), gamma, S(i), I, R, timeMax, drawPlots);
    %plot(St(i,:),'b')
    if i == 1 || i == 10 || i == 20 || i == 50 || i == 70 || i ==100 || i==200 || i==300 || i==400
    hold on
    %plot(It(i,:),c(j))
    plot(It(i,:),'k')
    %plot(Rt(i,:),'g')
    j = j+1;
    end   
end
    xlabel('Timesteps')
    ylabel('Number of nodes infected - It')
    %title('SI Test 4 - increasing variants on 1 locus up to N with fixed variants exploited to 1')
     title('d) SI - increasing variants on 1 locus up to N with 1 exploit')
    legend('1 variant', '10 variant', '20 variant', '50 variant', '70 variant','100 variant')
saveas(figSI4,[outputDirectory 'figSI4.fig']);
saveas(figSI4,[outputDirectory 'figSI4.emf']);

%*********
%SI test 5 - 2 loci OR case
%*********
outputDirectory = 'graphs\'
%1 loci test
%Vmax - assume a fixed number of variants on both loci
%increase the number exploited upto Vmax
%note change in beta
%OR case for 8 variants on each calculated from susceptibility matlab code
%susceptibilityTests.m
susProp2loci = [0.2344,0.4375,0.6094,0.7500,0.8594,0.9375,0.9844,1.0000]

N=100
Vmax = 8
S = N.*susProp2loci
B = 0.02
beta = B.*susProp2loci
gamma = 0; %1/48*60*60 %2 days
R=0
I=1
drawPlots=0
timeMax=4000
j=1;
figSI5 = figure
c = ['r', 'm', 'c', 'k','b', 'g', 'r', 'm']
for i = 1:Vmax
    [Ro(i) St(i,:) It(i,:) Rt(i,:)] = SIRDeterministic(beta(i), gamma, S(i), I, R, timeMax, drawPlots);
    %plot(St(i,:),'b')
    %if i == 1 || i == 10 || i == 20 || i == 50 || i == 70 || i ==100 || i==200 || i==300 || i==400
    hold on
    %plot(It(i,:),c(j))
    plot(It(i,:),'k')
    %plot(Rt(i,:),'g')
    j = j+1;
    %end   
end
    xlabel('Timesteps')
    ylabel('Number of nodes infected - It')
    %title('SI Test 1 - increasing variants exploited on 1 locus with 8 variants')
    title('a) SI OR case - increasing exploits on 2 loci with 8 variants on each')
    legend('1 variant exploited', '2 variant exploited','3 variant exploited','4 variant exploited','5 variant exploited','6 variant exploited','7 variant exploited','8 variant exploited')
saveas(figSI5,[outputDirectory 'figSI5.fig']);
saveas(figSI5,[outputDirectory 'figSI5.emf']);

%*********
%SI test 6 - 2 loci AND case
%*********
outputDirectory = 'graphs\'
%2 loci test
%Vmax - assume a fixed number of variants on both loci
%increase the number exploited upto Vmax
%note change in beta
%AND case for 8 variants on each calculated from susceptibility matlab code
susProp2lociAND =[0.0156,0.0625,0.1406,0.2500,0.3906,0.5625,0.7656,1.0000]

N=100
Vmax = 8
S = N.*susProp2lociAND
B = 0.02
beta = B.*susProp2lociAND
gamma = 0; %1/48*60*60 %2 days
R=0
I=1
drawPlots=0
timeMax=4000
j=1;
figSI6 = figure
c = ['r', 'm', 'c', 'k','b', 'g', 'r', 'm']
for i = 1:Vmax
    [Ro(i) St(i,:) It(i,:) Rt(i,:)] = SIRDeterministic(beta(i), gamma, S(i), I, R, timeMax, drawPlots);
    %plot(St(i,:),'b')
    %if i == 1 || i == 10 || i == 20 || i == 50 || i == 70 || i ==100 || i==200 || i==300 || i==400
    hold on
    %plot(It(i,:),c(j))
    plot(It(i,:),'k')
    %plot(Rt(i,:),'g')
    j = j+1;
    %end   
end
    xlabel('Timesteps')
    ylabel('Number of nodes infected - It')
    %title('SI Test 1 - increasing variants exploited on 1 locus with 8 variants')
    title('b) SI AND case, increasing exploits on 2 loci with 8 variants on each')
    legend('1 variant exploited', '2 variant exploited','3 variant exploited','4 variant exploited','5 variant exploited','6 variant exploited','7 variant exploited','8 variant exploited')
saveas(figSI6,[outputDirectory 'figSI6.fig']);
saveas(figSI6,[outputDirectory 'figSI6.emf']);

%*********
%SI test 7 - 2 loci AND increase variants
%*********
clear all;
outputDirectory = 'graphs\'
%2 loci test - proportional susceptible equation can be simplified
%assume a fixed number exploited variants V
%increase the number of variants on both loci at the same rate upto 8
%note change in beta
N=100
Vmax = 1:8 %number variants on loci
G = Vmax.^2; %number genotypes
%for AND case
Sprop = 1./G %both loci have the same number of variants and both have 1 exploit

S = N.*Sprop
B = 0.02
beta = B.*Sprop

gamma = 0; %1/48*60*60 %2 days
R=0
I=1
drawPlots=0
timeMax=4000
j=1;
figSI7 = figure
c = ['r', 'm', 'c', 'k','b', 'g', 'r', 'm']
for i = 1:8
    [Ro(i) St(i,:) It(i,:) Rt(i,:)] = SIRDeterministic(beta(i), gamma, S(i), I, R, timeMax, drawPlots);
    %plot(St(i,:),'b')
    %if i == 1 || i == 10 || i == 20 || i == 50 || i == 70 || i ==100 || i==200 || i==300 || i==400
    hold on
    %plot(It(i,:),c(j))
    plot(It(i,:),'k')
    %plot(Rt(i,:),'g')
    j = j+1;
    %end   
end
    xlabel('Timesteps')
    ylabel('Number of nodes infected - It')
    %title('SI Test 4 - increasing variants on 1 locus up to N with fixed variants exploited to 1')
     title('d) SI AND case - increasing variants on 2 loci up to 8 with 1 exploit on each')
    %legend('1 variant', '10 variant', '20 variant', '50 variant', '70 variant','100 variant')
saveas(figSI7,[outputDirectory 'figSI7.fig']);
saveas(figSI7,[outputDirectory 'figSI7.emf']);


%*********
%SI test 8 - 2 loci OR increase variants
%*********
clear all;
outputDirectory = 'graphs\'
%2 loci test - proportional susceptible equation can be simplified
%assume a fixed number exploited variants V
%increase the number of variants on both loci at the same rate upto 8
%note change in beta
N=100
Vmax = 1:8 %number variants on loci
G = Vmax.^2; %number genotypes
%for OR case
Sprop = 2./Vmax - 1./G %both loci have the same number of variants and both have 1 exploit

S = N.*Sprop
B = 0.02
beta = B.*Sprop

gamma = 0; %1/48*60*60 %2 days
R=0
I=1
drawPlots=0
timeMax=4000
j=1;
figSI8 = figure
c = ['r', 'm', 'c', 'k','b', 'g', 'r', 'm']
for i = 1:8
    [Ro(i) St(i,:) It(i,:) Rt(i,:)] = SIRDeterministic(beta(i), gamma, S(i), I, R, timeMax, drawPlots);
    %plot(St(i,:),'b')
    %if i == 1 || i == 10 || i == 20 || i == 50 || i == 70 || i ==100 || i==200 || i==300 || i==400
    hold on
    %plot(It(i,:),c(j))
    plot(It(i,:),'k')
    %plot(Rt(i,:),'g')
    j = j+1;
    %end   
end
    xlabel('Timesteps')
    ylabel('Number of nodes infected - It')
    %title('SI Test 4 - increasing variants on 1 locus up to N with fixed variants exploited to 1')
     title('c) SI OR case - increasing variants on 2 loci up to 8 with 1 exploit on each')
    %legend('1 variant', '10 variant', '20 variant', '50 variant', '70 variant','100 variant')
saveas(figSI8,[outputDirectory 'figSI8.fig']);
saveas(figSI8,[outputDirectory 'figSI8.emf']);

%********************************
% SIR testing - set gamma
%********************************
%The only way to stop the virus is when V(number of variants on 1 loci) = N(number of nodes)

%*********
%SIR test 1
%*********
clear all;
outputDirectory = 'graphs\'
%1 loci test
%Vmax - assume a fixed number of variants on 1 loci
%increase the number exploited upto Vmax
%note change in beta
N=100
Vmax = 8
V=1:Vmax %number variants exploited
Sprop = V./Vmax
S = N.*Sprop
B = 0.02
beta = B.*Sprop
gamma = 0.01; %1/48*60*60 %2 days
R=0
I=1
drawPlots=0
timeMax=4000
j=1;
figSIR1a = figure
c = ['r', 'm', 'c', 'k','b', 'g', 'r', 'm']
for i = 1:Vmax
    [Ro(i) St(i,:) It(i,:) Rt(i,:)] = SIRDeterministic(beta(i), gamma, S(i), I, R, timeMax, drawPlots);
    %plot(St(i,:),'b')
    %if i == 1 || i == 10 || i == 20 || i == 50 || i == 70 || i ==100 || i==200 || i==300 || i==400
    hold on
    plot(It(i,:),c(j))
    %plot(Rt(i,:),'g')
    j = j+1;
    %end   
end
    xlabel('Timesteps')
    ylabel('Number of nodes infected - It')
    title('SIR Test 1 - increasing variants exploited on 1 locus with 8 variants, gamma 0.01')
legend('1 variant exploited', '2 variant exploited','3 variant exploited','4 variant exploited','5 variant exploited','6 variant exploited','7 variant exploited','8 variant exploited')

r1 = 1
    e1 = [5 5 5]
    e2 = [0 1 2]
r1rep = repmat(r1,size(Ro));
figSIR1b = figure

plot(Ro, 'k')
hold on
plot(r1rep, 'k--')
plot(e1,e2, 'k--')
xlabel('Number of exploits')
ylabel('Ro')
set(figSIR1b, 'Position', [100 100 350 300])
axis([1 8 0 2])
%title('SIR Test 1 - increasing exploits on 1 locus with 8 variants, gamma 0.01')
title('a) SIR - increasing exploits on 1 locus with 8 variants')

saveas(figSIR1a,[outputDirectory 'figSIR1a.fig']);
saveas(figSIR1a,[outputDirectory 'figSIR1a.emf']);
saveas(figSIR1b,[outputDirectory 'figSIR1b.fig']);
saveas(figSIR1b,[outputDirectory 'figSIR1b.emf']);

%*********
%SIR test 2
%*********
clear all;
outputDirectory = 'graphs\'
%1 loci test
%Vmax - assume a fixed number of variants on 1 loci
%increase the number exploited upto Vmax
%note change in beta
N=100
Vmax = 100
V=1:Vmax %number variants exploited
Sprop = V./Vmax
S = N.*Sprop
B = 0.02
disp('here')
beta = B.*Sprop
gamma = 0.01; %1/48*60*60 %2 days
R=0
I=1
drawPlots=0
timeMax=4000
j=1;
figSIR2a = figure
c = ['r', 'm', 'c', 'k','b', 'g', 'r', 'm']
for i = 1:Vmax
    [Ro(i) St(i,:) It(i,:) Rt(i,:)] = SIRDeterministic(beta(i), gamma, S(i), I, R, timeMax, drawPlots);
    %plot(St(i,:),'b')
    if i == 1 || i == 10 || i == 20 || i == 50 || i == 70 || i ==100 || i==200 || i==300 || i==400
    hold on
    plot(It(i,:),c(j))
    %plot(Rt(i,:),'g')
    j = j+1;
    end   
end
    xlabel('Timesteps')
    ylabel('Number of nodes infected - It')
    title('SIR Test 2 - increasing variants exploited on 1 locus with N variants')
    legend('1 variant exploited', '10 variant exploited','20 variant exploited','50 variant exploited','70 variant exploited','100 variant exploited')

r1 = 1
    e1 = [51 51 51]
    e2 = [0 1 2]
r1rep = repmat(r1,size(Ro));
figSIR2b = figure

plot(Ro, 'k')
hold on
plot(r1rep, 'k--')
plot(e1,e2, 'k--')
xlabel('Number of exploits')
ylabel('Ro')
set(figSIR2b, 'Position', [100 100 350 300])
axis([1 100 0 2])
%title('SIR Test 2 - increasing variants exploited on 1 locus with N variants, gamma 0.01')
title('b) SIR - increasing exploits on 1 locus with N variants')
saveas(figSIR2a,[outputDirectory 'figSIR2a.fig']);
saveas(figSIR2a,[outputDirectory 'figSIR2a.emf']);
saveas(figSIR2b,[outputDirectory 'figSIR2b.fig']);
saveas(figSIR2b,[outputDirectory 'figSIR2b.emf']);
%*********
%SIR test 3
%*********
clear all;
outputDirectory = 'graphs\'
%1 loci test
%assume a fixed number exploited variants V
%increase the number of variants on 1 loci up to N
%note change in beta
N=100
Vmax = 1:8 %number variants on loci
V=1%fixed exploited
Sprop = V./Vmax
S = N.*Sprop
B = 0.02
beta = B.*Sprop
gamma = 0.01; %1/48*60*60 %2 days
R=0
I=1
drawPlots=0
timeMax=4000
j=1;
figSIR3a = figure
c = ['r', 'm', 'c', 'k','b', 'g', 'r', 'm']
for i = 1:8
    [Ro(i) St(i,:) It(i,:) Rt(i,:)] = SIRDeterministic(beta(i), gamma, S(i), I, R, timeMax, drawPlots);
    %plot(St(i,:),'b')
    %if i == 1 || i == 10 || i == 20 || i == 50 || i == 70 || i ==100 || i==200 || i==300 || i==400
    hold on
    plot(It(i,:),c(j))
    %plot(Rt(i,:),'g')
    j = j+1;
    %end   
end
    xlabel('Timesteps')
    ylabel('Number of nodes infected - It')
    title('SIR Test 3 - increasing variants on 1 locus up to 8 with fixed variants exploited to 1')
    legend('1 variant', '2 variant','3 variant','4 variant','5 variant','6 variant','7 variant','8 variant')

r1 = 1
  e1 = [2 2 2]
    e2 = [0 1 2]
r1rep = repmat(r1,size(Ro));
figSIR3b = figure

plot(Ro, 'k')
hold on
plot(r1rep, 'k--')
plot(e1,e2, 'k--')
xlabel('Number of variants')
ylabel('Ro')
set(figSIR3b, 'Position', [100 100 350 300])
axis([1 8 0 2])
%title('SIR Test 3 - increasing variants on 1 locus up to 8 with fixed variants exploited to 1, gamma 0.01')
title('c) SIR - increasing variants to 8 on 1 locus with 1 exploit')
saveas(figSIR3a,[outputDirectory 'figSIR3a.fig']);
saveas(figSIR3a,[outputDirectory 'figSIR3a.emf']);
saveas(figSIR3b,[outputDirectory 'figSIR3b.fig']);
saveas(figSIR3b,[outputDirectory 'figSIR3b.emf']);

%*********
%SIR test 4
%*********
clear all;
outputDirectory = 'graphs\'
%1 loci test
%assume a fixed number exploited variants V
%increase the number of variants on 1 loci up to N
%note change in beta
N=100
Vmax = 1:N %number variants on loci
V=1%fixed exploited
Sprop = V./Vmax
S = N.*Sprop
B = 0.02
beta = B.*Sprop
gamma = 0.01; %1/48*60*60 %2 days
R=0
I=1
drawPlots=0
timeMax=4000
j=1;
figSIR4a = figure
c = ['r', 'm', 'c', 'k','b', 'g', 'r', 'm']
for i = 1:N
    [Ro(i) St(i,:) It(i,:) Rt(i,:)] = SIRDeterministic(beta(i), gamma, S(i), I, R, timeMax, drawPlots);
    %plot(St(i,:),'b')
    if i == 1 || i == 10 || i == 20 || i == 50 || i == 70 || i ==100 || i==200 || i==300 || i==400
    hold on
    plot(It(i,:),c(j))
    %plot(Rt(i,:),'g')
    j = j+1;
    end   
end
    xlabel('Timesteps')
    ylabel('Number of nodes infected - It')
    title('SI Test 4 - increasing variants on 1 locus up to N with fixed variants exploited to 1')
    legend('1 variant', '10 variant','20 variant','50 variant','70 variant','100 variant')
r1 = 1
r1rep = repmat(r1,size(Ro));
figSIR4b = figure
plot(Ro, 'k')
hold on
plot(r1rep, 'k--')
xlabel('Number of variants')
ylabel('Ro')
set(figSIR4b, 'Position', [100 100 350 300])
axis([1 100 0 2])
%title('SIR Test 4 - increasing variants on 1 locus up to N with fixed variants exploited to 1, gamma 0.01')
title('d) SIR - increasing variants to N on 1 locus with 1 exploit')
saveas(figSIR4a,[outputDirectory 'figSIR4a.fig']);
saveas(figSIR4a,[outputDirectory 'figSIR4a.emf']);
saveas(figSIR4b,[outputDirectory 'figSIR4b.fig']);
saveas(figSIR4b,[outputDirectory 'figSIR4b.emf']);

%*********
%SIR test 5 - 2 loci OR case
%*********
clear all;
outputDirectory = 'graphs\'
%2 loci test
%Vmax - assume a fixed number of variants on both loci
%increase the number exploited upto Vmax
%note change in beta
%OR case for 8 variants on each calculated from susceptibility matlab code
%susceptibilityTests.m
susProp2loci = [0.2344,0.4375,0.6094,0.7500,0.8594,0.9375,0.9844,1.0000]

N=100
Vmax = 8 %number of exploits
S = N.*susProp2loci
B = 0.02
beta = B.*susProp2loci
gamma = 0.01; %1/48*60*60 %2 days
R=0
I=1
drawPlots=0
timeMax=4000
j=1;
figSIR5a = figure
c = ['r', 'm', 'c', 'k','b', 'g', 'r', 'm']
for i = 1:Vmax
    [Ro(i) St(i,:) It(i,:) Rt(i,:)] = SIRDeterministic(beta(i), gamma, S(i), I, R, timeMax, drawPlots);
    %plot(St(i,:),'b')
    %if i == 1 || i == 10 || i == 20 || i == 50 || i == 70 || i ==100 || i==200 || i==300 || i==400
    hold on
    %plot(It(i,:),c(j))
    plot(It(i,:),'k')
    %plot(Rt(i,:),'g')
    j = j+1;
    %end   
end
    xlabel('Timesteps')
    ylabel('Number of nodes infected - It')
    %title('SIR Test 1 - increasing variants exploited on 1 locus with 8 variants')
    title('a) SIR OR case - increasing exploits on 2 loci with 8 variants on each')
    legend('1 variant exploited', '2 variant exploited','3 variant exploited','4 variant exploited','5 variant exploited','6 variant exploited','7 variant exploited','8 variant exploited')

    r1 = 1
    e1 = [3 3 3]
    e2 = [0 1 2]
r1rep = repmat(r1,size(Ro));
figSIR5b = figure
plot(Ro, 'k')
Ro5 = Ro
hold on
plot(r1rep, 'k--')
plot(e1,e2, 'k--')
xlabel('Number of exploits')
ylabel('Ro')
set(figSIR5b, 'Position', [100 100 350 300])
axis([1 8 0 2])
title('a) SIR OR case - increasing exploits, 2 loci')    
saveas(figSIR5a,[outputDirectory 'figSIR5a.fig']);
saveas(figSIR5a,[outputDirectory 'figSIR5a.emf']);
saveas(figSIR5b,[outputDirectory 'figSIR5b.fig']);
saveas(figSIR5b,[outputDirectory 'figSIR5b.emf']);

%*********
%SIR test 6 - 2 loci AND case
%*********
clear all;
outputDirectory = 'graphs\'
%2 loci test
%Vmax - assume a fixed number of variants on both loci
%increase the number exploited upto Vmax
%note change in beta
%AND case for 8 variants on each calculated from susceptibility matlab code
susProp2lociAND =[0.0156,0.0625,0.1406,0.2500,0.3906,0.5625,0.7656,1.0000]

N=100
Vmax = 8
S = N.*susProp2lociAND
B = 0.02
beta = B.*susProp2lociAND
gamma = 0.01; %1/48*60*60 %2 days
R=0
I=1
drawPlots=0
timeMax=4000
j=1;
figSIR6a = figure
c = ['r', 'm', 'c', 'k','b', 'g', 'r', 'm']
for i = 1:Vmax
    [Ro(i) St(i,:) It(i,:) Rt(i,:)] = SIRDeterministic(beta(i), gamma, S(i), I, R, timeMax, drawPlots);
    %plot(St(i,:),'b')
    %if i == 1 || i == 10 || i == 20 || i == 50 || i == 70 || i ==100 || i==200 || i==300 || i==400
    hold on
    %plot(It(i,:),c(j))
    plot(It(i,:),'k')
    %plot(Rt(i,:),'g')
    j = j+1;
    %end   
end
    xlabel('Timesteps')
    ylabel('Number of nodes infected - It')
    %title('SI Test 1 - increasing variants exploited on 1 locus with 8 variants')
    title('b) SI AND case, increasing exploits on 2 loci with 8 variants on each')
    legend('1 variant exploited', '2 variant exploited','3 variant exploited','4 variant exploited','5 variant exploited','6 variant exploited','7 variant exploited','8 variant exploited')
    r1 = 1
        e1 = [6 6 6]
    e2 = [0 1 2]
r1rep = repmat(r1,size(Ro));
figSIR6b = figure
plot(Ro, 'k')
Ro6 = Ro
hold on
plot(r1rep, 'k--')
plot(e1,e2, 'k--')
xlabel('Number of exploits')
ylabel('Ro')
set(figSIR6b, 'Position', [100 100 350 300])
axis([1 8 0 2])
title('b) SIR AND case - increasing exploits, 2 loci')    
saveas(figSIR6a,[outputDirectory 'figSIR6a.fig']);
saveas(figSIR6a,[outputDirectory 'figSIR6a.emf']);
saveas(figSIR6b,[outputDirectory 'figSIR6b.fig']);
saveas(figSIR6b,[outputDirectory 'figSIR6b.emf']);

%*********
%SIR test 7 - 2 loci AND increase variants
%*********
clear all;
outputDirectory = 'graphs\'
%2 loci test - proportional susceptible equation can be simplified
%assume a fixed number exploited variants V
%increase the number of variants on both loci at the same rate upto 8
%note change in beta
N=100
Vmax = 1:8 %number variants on loci
G = Vmax.^2; %number genotypes
%for AND case
Sprop = 1./G %both loci have the same number of variants and both have 1 exploit

S = N.*Sprop
B = 0.02
beta = B.*Sprop

gamma = 0.01; %1/48*60*60 %2 days
R=0
I=1
drawPlots=0
timeMax=4000
j=1;
figSIR7a = figure
c = ['r', 'm', 'c', 'k','b', 'g', 'r', 'm']
for i = 1:8
    [Ro(i) St(i,:) It(i,:) Rt(i,:)] = SIRDeterministic(beta(i), gamma, S(i), I, R, timeMax, drawPlots);
    %plot(St(i,:),'b')
    %if i == 1 || i == 10 || i == 20 || i == 50 || i == 70 || i ==100 || i==200 || i==300 || i==400
    hold on
    %plot(It(i,:),c(j))
    plot(It(i,:),'k')
    %plot(Rt(i,:),'g')
    j = j+1;
    %end   
end
    xlabel('Timesteps')
    ylabel('Number of nodes infected - It')
    %title('SI Test 4 - increasing variants on 1 locus up to N with fixed variants exploited to 1')
     title('d) SIR AND case - increasing variants, 2 loci, 1 exploit')
    %legend('1 variant', '10 variant', '20 variant', '50 variant', '70 variant','100 variant')
    r1 = 1
    e1 = [2 2 2]
    e2 = [0 1 2]
r1rep = repmat(r1,size(Ro));
figSIR7b = figure
plot(Ro, 'k')
Ro7 = Ro
hold on
plot(r1rep, 'k--')
plot(e1,e2, 'k--')
xlabel('Number of variants')
ylabel('Ro')
set(figSIR7b, 'Position', [100 100 350 300])
axis([1 8 0 2])
title('d) SIR AND case - increasing variants, 2 loci')    
saveas(figSIR7a,[outputDirectory 'figSIR7a.fig']);
saveas(figSIR7a,[outputDirectory 'figSIR7a.emf']);
saveas(figSIR7b,[outputDirectory 'figSIR7b.fig']);
saveas(figSIR7b,[outputDirectory 'figSIR7b.emf']);


%*********
%SIR test 8 - 2 loci OR increase variants
%*********
clear all;
outputDirectory = 'graphs\'
%2 loci test - proportional susceptible equation can be simplified
%assume a fixed number exploited variants V
%increase the number of variants on both loci at the same rate upto 8
%note change in beta
N=100
Vmax = 1:8 %number variants on loci
G = Vmax.^2; %number genotypes
%for OR case
Sprop = 2./Vmax - 1./G %both loci have the same number of variants and both have 1 exploit

S = N.*Sprop
B = 0.02
beta = B.*Sprop

gamma = 0.01; %1/48*60*60 %2 days
R=0
I=1
drawPlots=0
timeMax=4000
j=1;
figSIR8a = figure
c = ['r', 'm', 'c', 'k','b', 'g', 'r', 'm']
for i = 1:8
    [Ro(i) St(i,:) It(i,:) Rt(i,:)] = SIRDeterministic(beta(i), gamma, S(i), I, R, timeMax, drawPlots);
    %plot(St(i,:),'b')
    %if i == 1 || i == 10 || i == 20 || i == 50 || i == 70 || i ==100 || i==200 || i==300 || i==400
    hold on
    %plot(It(i,:),c(j))
    plot(It(i,:),'k')
    %plot(Rt(i,:),'g')
    j = j+1;
    %end   
end
    xlabel('Timesteps')
    ylabel('Number of nodes infected - It')
    %title('SI Test 4 - increasing variants on 1 locus up to N with fixed variants exploited to 1')
     title('c) SIR OR case - increasing variants, 2 loci')
    %legend('1 variant', '10 variant', '20 variant', '50 variant', '70 variant','100 variant')
    r1 = 1
    e1 = [4 4 4]
    e2 = [0 1 2]
r1rep = repmat(r1,size(Ro));
figSIR8b = figure
plot(Ro, 'k')
Ro8 = Ro
hold on
plot(r1rep, 'k--')
plot(e1,e2, 'k--')
xlabel('Number of variants')
ylabel('Ro')
set(figSIR8b, 'Position', [100 100 350 300])
axis([1 8 0 2])
title('c) SIR OR case - increasing variants, 2 loci')    
saveas(figSIR8a,[outputDirectory 'figSIR8a.fig']);
saveas(figSIR8a,[outputDirectory 'figSIR8a.emf']);
saveas(figSIR8b,[outputDirectory 'figSIR8b.fig']);
saveas(figSIR8b,[outputDirectory 'figSIR8b.emf']);








return


%*********
%SIR test 10 - Dynamic test at 0.02 beta
%*********
clear all;
outputDirectory = 'graphs\'
%1 loci test
%Vmax - assume a fixed number of variants on 1 loci
%increase the number exploited upto Vmax
%note change in beta
N=400
Vmax = 8
V=1:Vmax %number variants exploited
Sprop = V./Vmax
S(1:8) = N %all susceptible for dynamic
%B = 0.02
%beta = B.*Sprop
%MeasuredValuesBeta
%beta = [0.001062 0.001247 0.00182 0.002747 0.003718 0.005272 0.008215 0.01853] %0.02
beta = [7.166011e-04 1.144123e-03 1.716730e-03 2.659677e-03 3.721712e-03 5.175498e-03 8.317695e-03 1.853410e-02]%0.02
gamma = 0.01; %1/48*60*60 %2 days
R=0
I=1
drawPlots=0
timeMax=4000
j=1;
figSIR10a = figure
c = ['r', 'm', 'c', 'k','b', 'g', 'r', 'm']
for i = 1:Vmax
    [Ro(i) St(i,:) It(i,:) Rt(i,:)] = SIRDeterministic(beta(i), gamma, S(i), I, R, timeMax, drawPlots);
    %plot(St(i,:),'b')
    %if i == 1 || i == 10 || i == 20 || i == 50 || i == 70 || i ==100 || i==200 || i==300 || i==400
    hold on
    plot(It(i,:),c(j))
    %plot(Rt(i,:),'g')
    j = j+1;
   % end   
end
    xlabel('Timesteps')
    ylabel('Number of nodes infected - It')
    title('SIR Test 10 DYNAMIC 0.02 - increasing variants exploited on 1 locus with 8 variants, beta dynamic 0.02')
    legend('1 variant exploited', '2 variant exploited','3 variant exploited','4 variant exploited','5 variant exploited','6 variant exploited','7 variant exploited','8 variant exploited')

r1 = 1
r1rep = repmat(r1,size(Ro));
figSIR10b = figure
plot(Ro, 'k')
hold on
plot(r1rep, 'k--')
xlabel('Number of exploits')
ylabel('Ro')
%title('SIR Test 6 DYNAMIC 0.02 - increasing variants exploited on 1 locus with 8 variants, gamma 0.01')
title('b) SIR Dynamic 0.02')
set(figSIR10b, 'Position', [100 100 350 300])
saveas(figSIR10a,[outputDirectory 'figSIR10a.fig']);
saveas(figSIR10a,[outputDirectory 'figSIR10a.emf']);
saveas(figSIR10b,[outputDirectory 'figSIR10b.fig']);
saveas(figSIR10b,[outputDirectory 'figSIR10b.emf']);
r0d02=Ro

%UPTO HERE
%*********
%SIR test 11 - Dynamic test at 0.04 beta
%*********
clear all;
outputDirectory = 'graphs\'
%1 loci test
%Vmax - assume a fixed number of variants on 1 loci
%increase the number exploited upto Vmax
%note change in beta
N=400
Vmax = 8
V=1:Vmax %number variants exploited
Sprop = V./Vmax
S(1:8) = N %all susceptible for dynamic
%B = 0.02
%beta = B.*Sprop
%MeasuredValuesBeta
beta = [9.785504e-04 2.100734e-03 3.593512e-03 5.061025e-03 7.093914e-03 1.035281e-02 1.508611e-02 3.587649e-02]%0.04
gamma = 0.01; %1/48*60*60 %2 days
R=0
I=1
drawPlots=0
timeMax=4000
j=1;
figSIR11a = figure
c = ['r', 'm', 'c', 'k','b', 'g', 'r', 'm']
for i = 1:Vmax
    [Ro(i) St(i,:) It(i,:) Rt(i,:)] = SIRDeterministic(beta(i), gamma, S(i), I, R, timeMax, drawPlots);
    %plot(St(i,:),'b')
    %if i == 1 || i == 10 || i == 20 || i == 50 || i == 70 || i ==100 || i==200 || i==300 || i==400
    hold on
    plot(It(i,:),c(j))
    %plot(Rt(i,:),'g')
    j = j+1;
   % end   
end
    xlabel('Timesteps')
    ylabel('Number of nodes infected - It')
    title('SIR Test 11 DYNAMIC 0.04 - increasing variants exploited on 1 locus with 8 variants, beta dynamic 0.02')
    legend('1 variant exploited', '2 variant exploited','3 variant exploited','4 variant exploited','5 variant exploited','6 variant exploited','7 variant exploited','8 variant exploited')

r1 = 1
r1rep = repmat(r1,size(Ro));
figSIR11b = figure
plot(Ro, 'k')
hold on
plot(r1rep, 'k--')
xlabel('Number of exploits')
ylabel('Ro')
%title('SIR Test 7 DYNAMIC 0.04 - increasing variants exploited on 1 locus with 8 variants, gamma 0.01')
title('b) SIR Dynamic 0.04')
set(figSIR11b, 'Position', [100 100 350 300])
saveas(figSIR11a,[outputDirectory 'figSIR11a.fig']);
saveas(figSIR11a,[outputDirectory 'figSIR11a.emf']);
saveas(figSIR11b,[outputDirectory 'figSIR11b.fig']);
saveas(figSIR11b,[outputDirectory 'figSIR11b.emf']);
r0d04=Ro

%*********
%SIR test 12 - Dynamic test at 0.06 beta
%*********
clear all;
outputDirectory = 'graphs\'
%1 loci test
%Vmax - assume a fixed number of variants on 1 loci
%increase the number exploited upto Vmax
%note change in beta
N=400
Vmax = 8
V=1:Vmax %number variants exploited
Sprop = V./Vmax
S(1:8) = N %all susceptible for dynamic
%B = 0.02
%beta = B.*Sprop
%MeasuredValuesBeta
beta = [1.618527e-03 3.342095e-03 5.497526e-03 7.490677e-03 1.096435e-02 1.529307e-02 2.129338e-02 5.511940e-02]%0.06
gamma = 0.01; %1/48*60*60 %2 days
R=0
I=1
drawPlots=0
timeMax=4000
j=1;
figSIR12a = figure
c = ['r', 'm', 'c', 'k','b', 'g', 'r', 'm']
for i = 1:Vmax
    [Ro(i) St(i,:) It(i,:) Rt(i,:)] = SIRDeterministic(beta(i), gamma, S(i), I, R, timeMax, drawPlots);
    %plot(St(i,:),'b')
    %if i == 1 || i == 10 || i == 20 || i == 50 || i == 70 || i ==100 || i==200 || i==300 || i==400
    hold on
    plot(It(i,:),c(j))
    %plot(Rt(i,:),'g')
    j = j+1;
   % end   
end
    xlabel('Timesteps')
    ylabel('Number of nodes infected - It')
    title('SIR Test 12 DYNAMIC 0.06 - increasing variants exploited on 1 locus with 8 variants, beta dynamic 0.02')
    legend('1 variant exploited', '2 variant exploited','3 variant exploited','4 variant exploited','5 variant exploited','6 variant exploited','7 variant exploited','8 variant exploited')

r1 = 1
r1rep = repmat(r1,size(Ro));
figSIR12b = figure
plot(Ro, 'k')
hold on
plot(r1rep, 'k--')
xlabel('Number of exploits')
ylabel('Ro')
%title('SIR Test 6 DYNAMIC 0.04 - increasing variants exploited on 1 locus with 8 variants, gamma 0.01')
title('b) SIR Dynamic 0.06')
set(figSIR12b, 'Position', [100 100 350 300])
saveas(figSIR12a,[outputDirectory 'figSIR12a.fig']);
saveas(figSIR12a,[outputDirectory 'figSIR12a.emf']);
saveas(figSIR12b,[outputDirectory 'figSIR12b.fig']);
saveas(figSIR12b,[outputDirectory 'figSIR12b.emf']);
r0d06=Ro


%*********
%SIR test 13 - Dynamic test at 0.08 beta
%*********
clear all;
outputDirectory = 'graphs\'
%1 loci test
%Vmax - assume a fixed number of variants on 1 loci
%increase the number exploited upto Vmax
%note change in beta
N=400
Vmax = 8
V=1:Vmax %number variants exploited
Sprop = V./Vmax
S(1:8) = N %all susceptible for dynamic
%B = 0.02
%beta = B.*Sprop
%MeasuredValuesBeta
beta = [2.016251e-03 3.935990e-03 6.519993e-03 9.454633e-03 1.395282e-02 1.977906e-02 2.898642e-02 6.741746e-02] %0.08
gamma = 0.01; %1/48*60*60 %2 days
R=0
I=1
drawPlots=0
timeMax=4000
j=1;
figSIR13a = figure
c = ['r', 'm', 'c', 'k','b', 'g', 'r', 'm']
for i = 1:Vmax
    [Ro(i) St(i,:) It(i,:) Rt(i,:)] = SIRDeterministic(beta(i), gamma, S(i), I, R, timeMax, drawPlots);
    %plot(St(i,:),'b')
    %if i == 1 || i == 10 || i == 20 || i == 50 || i == 70 || i ==100 || i==200 || i==300 || i==400
    hold on
    plot(It(i,:),c(j))
    %plot(Rt(i,:),'g')
    j = j+1;
   % end   
end
    xlabel('Timesteps')
    ylabel('Number of nodes infected - It')
    title('SIR Test 13 DYNAMIC 0.08 - increasing variants exploited on 1 locus with 8 variants, beta dynamic 0.08')
    legend('1 variant exploited', '2 variant exploited','3 variant exploited','4 variant exploited','5 variant exploited','6 variant exploited','7 variant exploited','8 variant exploited')

r1 = 1
r1rep = repmat(r1,size(Ro));
figSIR13b = figure
plot(Ro, 'k')
hold on
plot(r1rep, 'k--')
xlabel('Number of exploits')
ylabel('Ro')
title('SIR Test 13 DYNAMIC 0.08 - increasing variants exploited on 1 locus with 8 variants, gamma 0.01')
title('b) SIR Dynamic 0.06')
set(figSIR13b, 'Position', [100 100 350 300])
saveas(figSIR13a,[outputDirectory 'figSIR13a.fig']);
saveas(figSIR13a,[outputDirectory 'figSIR13a.emf']);
saveas(figSIR13b,[outputDirectory 'figSIR13b.fig']);
saveas(figSIR13b,[outputDirectory 'figSIR13b.emf']);
r0d08=Ro
%*********
%SIR test 14 STATIC 0.02 
%*********
clear all;
outputDirectory = 'graphs\'
%1 loci test
%Vmax - assume a fixed number of variants on 1 loci
%increase the number exploited upto Vmax
%note change in beta
N=400 ;%100
Vmax = 8 ;%100
V=1:Vmax %number variants exploited
Sprop = V./Vmax
S = N.*Sprop
B = 0.02
disp('here')
beta = B.*Sprop
gamma = 0.01; %1/48*60*60 %2 days
R=0
I=1
drawPlots=0
timeMax=4000
j=1;
figSIR14a = figure
c = ['r', 'm', 'c', 'k','b', 'g', 'r', 'm']
for i = 1:Vmax
    [Ro(i) St(i,:) It(i,:) Rt(i,:)] = SIRDeterministic(beta(i), gamma, S(i), I, R, timeMax, drawPlots);
    %plot(St(i,:),'b')
   % if i == 1 || i == 10 || i == 20 || i == 50 || i == 70 || i ==100 || i==200 || i==300 || i==400
    hold on
    plot(It(i,:),c(j))
    %plot(Rt(i,:),'g')
    j = j+1;
   % end   
end
    xlabel('Timesteps')
    ylabel('Number of nodes infected - It')
    title('SIR Test 14 STATIC 0.02 - increasing variants exploited on 1 locus with 8 variants')
    legend('1 variant exploited', '2 variant exploited','3 variant exploited','4 variant exploited','5 variant exploited','6 variant exploited','7 variant exploited','8 variant exploited')

r1 = 1
r1rep = repmat(r1,size(Ro));
figSIR14b = figure
plot(Ro, 'k')
hold on
plot(r1rep, 'k--')
xlabel('Number of exploits')
ylabel('Ro')
title('SIR Test 14 STATIC 0.02 - increasing variants exploited on 1 locus with 8 variants, gamma 0.01')

saveas(figSIR14a,[outputDirectory 'figSIR14a.fig']);
saveas(figSIR14a,[outputDirectory 'figSIR14a.emf']);
saveas(figSIR14b,[outputDirectory 'figSIR14b.fig']);
saveas(figSIR14b,[outputDirectory 'figSIR14b.emf']);
r0s02=Ro
%*********
%SIR test 15 STATIC 0.04 
%*********
clear all;
outputDirectory = 'graphs\'
%1 loci test
%Vmax - assume a fixed number of variants on 1 loci
%increase the number exploited upto Vmax
%note change in beta
N=400 ;%100
Vmax = 8 ;%100
V=1:Vmax %number variants exploited
Sprop = V./Vmax
S = N.*Sprop
B = 0.04
disp('here')
beta = B.*Sprop
gamma = 0.01; %1/48*60*60 %2 days
R=0
I=1
drawPlots=0
timeMax=4000
j=1;
figSIR15a = figure
c = ['r', 'm', 'c', 'k','b', 'g', 'r', 'm']
for i = 1:Vmax
    [Ro(i) St(i,:) It(i,:) Rt(i,:)] = SIRDeterministic(beta(i), gamma, S(i), I, R, timeMax, drawPlots);
    %plot(St(i,:),'b')
   % if i == 1 || i == 10 || i == 20 || i == 50 || i == 70 || i ==100 || i==200 || i==300 || i==400
    hold on
    plot(It(i,:),c(j))
    %plot(Rt(i,:),'g')
    j = j+1;
   % end   
end
    xlabel('Timesteps')
    ylabel('Number of nodes infected - It')
    title('SIR Test 15 STATIC 0.04 - increasing variants exploited on 1 locus with 8 variants')
    legend('1 variant exploited', '2 variant exploited','3 variant exploited','4 variant exploited','5 variant exploited','6 variant exploited','7 variant exploited','8 variant exploited')

r1 = 1
r1rep = repmat(r1,size(Ro));
figSIR15b = figure
plot(Ro, 'k')
hold on
plot(r1rep, 'k--')
xlabel('Number of exploits')
ylabel('Ro')
title('SIR Test 15 STATIC 0.04 - increasing variants exploited on 1 locus with 8 variants, gamma 0.01')

saveas(figSIR15a,[outputDirectory 'figSIR15a.fig']);
saveas(figSIR15a,[outputDirectory 'figSIR15a.emf']);
saveas(figSIR15b,[outputDirectory 'figSIR15b.fig']);
saveas(figSIR15b,[outputDirectory 'figSIR15b.emf']);
r0s04=Ro
%*********
%SIR test 16 STATIC 0.06 
%*********
clear all;
outputDirectory = 'graphs\'
%1 loci test
%Vmax - assume a fixed number of variants on 1 loci
%increase the number exploited upto Vmax
%note change in beta
N=400 ;%100
Vmax = 8 ;%100
V=1:Vmax %number variants exploited
Sprop = V./Vmax
S = N.*Sprop
B = 0.06
disp('here')
beta = B.*Sprop
gamma = 0.01; %1/48*60*60 %2 days
R=0
I=1
drawPlots=0
timeMax=4000
j=1;
figSIR16a = figure
c = ['r', 'm', 'c', 'k','b', 'g', 'r', 'm']
for i = 1:Vmax
    [Ro(i) St(i,:) It(i,:) Rt(i,:)] = SIRDeterministic(beta(i), gamma, S(i), I, R, timeMax, drawPlots);
    %plot(St(i,:),'b')
   % if i == 1 || i == 10 || i == 20 || i == 50 || i == 70 || i ==100 || i==200 || i==300 || i==400
    hold on
    plot(It(i,:),c(j))
    %plot(Rt(i,:),'g')
    j = j+1;
   % end   
end
    xlabel('Timesteps')
    ylabel('Number of nodes infected - It')
    title('SIR Test 16 STATIC 0.06 - increasing variants exploited on 1 locus with 8 variants')
    legend('1 variant exploited', '2 variant exploited','3 variant exploited','4 variant exploited','5 variant exploited','6 variant exploited','7 variant exploited','8 variant exploited')

r1 = 1
r1rep = repmat(r1,size(Ro));
figSIR16b = figure
plot(Ro, 'k')
hold on
plot(r1rep, 'k--')
xlabel('Number of exploits')
ylabel('Ro')
title('SIR Test 16 STATIC 0.06 - increasing variants exploited on 1 locus with 8 variants, gamma 0.01')

saveas(figSIR16a,[outputDirectory 'figSIR16a.fig']);
saveas(figSIR16a,[outputDirectory 'figSIR16a.emf']);
saveas(figSIR16b,[outputDirectory 'figSIR16b.fig']);
saveas(figSIR16b,[outputDirectory 'figSIR16b.emf']);
r0s06=Ro
%*********
%SIR test 17 STATIC 0.08
%*********
clear all;
outputDirectory = 'graphs\'
%1 loci test
%Vmax - assume a fixed number of variants on 1 loci
%increase the number exploited upto Vmax
%note change in beta
N=400 ;%100
Vmax = 8 ;%100
V=1:Vmax %number variants exploited
Sprop = V./Vmax
S = N.*Sprop
B = 0.08
disp('here')
beta = B.*Sprop
gamma = 0.01; %1/48*60*60 %2 days
R=0
I=1
drawPlots=0
timeMax=4000
j=1;
figSIR17a = figure
c = ['r', 'm', 'c', 'k','b', 'g', 'r', 'm']
for i = 1:Vmax
    [Ro(i) St(i,:) It(i,:) Rt(i,:)] = SIRDeterministic(beta(i), gamma, S(i), I, R, timeMax, drawPlots);
    %plot(St(i,:),'b')
   % if i == 1 || i == 10 || i == 20 || i == 50 || i == 70 || i ==100 || i==200 || i==300 || i==400
    hold on
    plot(It(i,:),c(j))
    %plot(Rt(i,:),'g')
    j = j+1;
   % end   
end
    xlabel('Timesteps')
    ylabel('Number of nodes infected - It')
    title('SIR Test 17 STATIC 0.08 - increasing variants exploited on 1 locus with 8 variants')
    legend('1 variant exploited', '2 variant exploited','3 variant exploited','4 variant exploited','5 variant exploited','6 variant exploited','7 variant exploited','8 variant exploited')

r1 = 1
r1rep = repmat(r1,size(Ro));
figSIR17b = figure
plot(Ro, 'k')
hold on
plot(r1rep, 'k--')
xlabel('Number of exploits')
ylabel('Ro')
title('SIR Test 17 STATIC 0.08 - increasing variants exploited on 1 locus with 8 variants, gamma 0.01')
saveas(figSIR17a,[outputDirectory 'figSIR17a.fig']);
saveas(figSIR17a,[outputDirectory 'figSIR17a.emf']);
saveas(figSIR17b,[outputDirectory 'figSIR17b.fig']);
saveas(figSIR17b,[outputDirectory 'figSIR17b.emf']);
r0s08=Ro

%output for tests 10 to 17
%10 runs
r0d02 =[0.0717    0.1144    0.1717    0.2660    0.3722    0.5175    0.8318 1.8534] ; 
r0d04 =[0.0979    0.2101    0.3594    0.5061    0.7094    1.0353    1.5086 3.5876];
r0d06 =[0.1619    0.3342    0.5498    0.7491    1.0964    1.5293    2.1293 5.5119];
r0d08 =[0.2016    0.3936    0.6520    0.9455    1.3953    1.9779    2.8986 6.7417];
r0s02 =[0.2500    0.5000    0.7500    1.0000    1.2500    1.5000    1.7500 2.0000] ;   
r0s04 =[0.5000    1.0000    1.5000    2.0000    2.5000    3.0000    3.5000 4.0000];
r0s06 =[0.7500    1.5000    2.2500    3.0000    3.7500    4.5000    5.2500 6.0000];
r0s08 =[1.0000    2.0000    3.0000    4.0000    5.0000    6.0000    7.0000 8.0000];

figStaticR0 = figure
r1 = 1;
r1rep = repmat(r1,size(r0s02));
plot(r0s02,'k')
hold on
plot(r0s04,'k')
plot(r0s06,'k')
plot(r0s08,'k')
plot(r1rep, 'k--')
xlabel('Number of exploits')
ylabel('Ro')
legend('0.02','0.04','0.06','0.08')
title('a) SIR -STATIC')
set(figStaticR0, 'Position', [100 100 350 300])
axis([1 8 0 8])

figDynamicR0 = figure
r1 = 1;
r1rep = repmat(r1,size(r0d02));
plot(r0d02,'k')
hold on
plot(r0d04,'k')
plot(r0d06,'k')
plot(r0d08,'k')
plot(r1rep, 'k--')
xlabel('Number of exploits')
ylabel('Ro')
legend('0.02','0.04','0.06','0.08')
title('b) SIR -DYNAMIC')
set(figDynamicR0, 'Position', [100 100 350 300])
axis([1 8 0 8])

saveas(figStaticR0,[outputDirectory 'figStaticR0.fig']);
saveas(figStaticR0,[outputDirectory 'figStaticR0.emf']);
saveas(figDynamicR0,[outputDirectory 'figDynamicR0.fig']);
saveas(figDynamicR0,[outputDirectory 'figDynamicR0.emf']);

close all;
end

