%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Jennifer Jackson 2017                                                        %
% A Biodiversity Approach to Cyber Security                                    %
% PhD Complexity Science                                                       %
% University of Warwick                                                        %
% http://wrap.warwick.ac.uk/98458                                              %
% This software is distributed under the  Creative Commons Attribution License %
% https://creativecommons.org/licenses/by/4.0/                                 %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function [ v1 v2 v3 v4 ] = Loci4Min( x1,x2,x3,x4,Sp, maxV)
%AND MALWARE TYPE
%Determine optimum number of variants at each locus
%x - product of exploits at each locus
%Sp - susceptibility
%maxV - maximum number of variants
v4 = ones(maxV,maxV,maxV).*4100;
vsum = ones(maxV,maxV,maxV).*4100;
x = x1*x2*x3*x4;
for k = x3: maxV %v3
    for j = x2: maxV %v2
        for i = x1 : maxV %v1
        v4(i,j,k) = ceil(x./(Sp.*i.*j.*k)); %v4
        vsum(i,j,k)=v4(i,j,k)+ i + j + k;
        end
    end
end
[a aI] = min(vsum,[],1); %min of colums, get i values
%index gives values of v1 v2 v3, v4 = vsum - v1 - v2 - v3
b(:,:) = a(1,:,:);
bI(:,:) = aI(1,:,:);
[c cI] = min(b,[],2); %min of rows, get k values
[d dI] = min(c,[],1); %min of columns, get j value
indexJ = dI;
indexK = cI(dI);
indexI = bI(indexJ,indexK);
value = d;

v1 = indexI;
v2 = indexJ;
v3 = indexK;
v4 = value-v1-v2-v3;

end

