%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Jennifer Jackson 2017                                                        %
% A Biodiversity Approach to Cyber Security                                    %
% PhD Complexity Science                                                       %
% University of Warwick                                                        %
% http://wrap.warwick.ac.uk/98458                                              %
% This software is distributed under the  Creative Commons Attribution License %
% https://creativecommons.org/licenses/by/4.0/                                 %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function [ v ] = VRExact4LociOR( x, sp )
%   diversity minimisation of average 4 loci OR case using exact
%max diversity case
%x number exploits per locus
%v number variants per locus

%solve('((4*x/v)-(6*x^2/v^2)+(4*x^3/v^3)-(x^4/v^4)=s)','v')
        %get result(1) to ensure largest v solution which needs to be
        %greater than x and not imaginary as the solve function returns
        %range of possible solutions
        %T = 80%
        text = ['((4*' num2str(x) '/v)-(6*' num2str(x) '^2/v^2)+(4*' num2str(x) '^3/v^3)-(' num2str(x) '^4/v^4)=' num2str(sp) ')'];
        
        result = solve(text,'v'); 
        
       v_temp = ceil(result(1));
        v = double(v_temp);

end

