%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Jennifer Jackson 2017                                                        %
% A Biodiversity Approach to Cyber Security                                    %
% PhD Complexity Science                                                       %
% University of Warwick                                                        %
% http://wrap.warwick.ac.uk/98458                                              %
% This software is distributed under the  Creative Commons Attribution License %
% https://creativecommons.org/licenses/by/4.0/                                 %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function [ sp] = spAverageMaxDiv( variantRichness, numExploits, numLoci, casetype )
%work out sp for specified malware type for max diversity average values
%for any number of loci upto 4
if numLoci == 1; sp  = SPExact1LociOR(numExploits, variantRichness); end;
if and(numLoci == 2, strcmp(casetype, 'AND'));sp  = sp2LociAND(numExploits, variantRichness); end;
if and(numLoci == 2, strcmp(casetype, 'OR')); sp  = SPExact2LociOR(numExploits, variantRichness);end;
if and(numLoci == 3, strcmp(casetype, 'AND'));sp  = sp3LociAND(numExploits, variantRichness); end;
if and(numLoci == 3, strcmp(casetype, 'OR')); sp  = SPExact3LociOR(numExploits, variantRichness);end;
if and(numLoci == 4, strcmp(casetype, 'AND'));sp  = sp4LociAND(numExploits, variantRichness); end;
if and(numLoci == 4, strcmp(casetype, 'OR')); sp  = SPExact4LociOR(numExploits, variantRichness); end;
end

